/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/base/common/path","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/common/extpath","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/platform/contextkey/common/contextkey","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/base/common/themables","vs/editor/common/core/position","vs/base/common/process","fs","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(he){for(var e=[],h=0,N=he.length;h<N;h++)e[h]=Se[he[h]];return e};define(Se[163],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class h{static get(){const O=new Map,R=new Map,M=new Map,b=new Map;function $(y,v){y.has(v.detail)||y.set(v.detail,-v.timestamp)}function k(y,v){const l=y.get(v.detail);l&&(l>=0||y.set(v.detail,l+v.timestamp))}let A=[];typeof he=="function"&&typeof he.getStats=="function"&&(A=he.getStats().slice(0).sort((y,v)=>y.timestamp-v.timestamp));for(const y of A)switch(y.type){case 10:$(O,y);break;case 11:case 12:k(O,y);break;case 21:$(R,y);break;case 22:k(R,y);break;case 33:$(M,y);break;case 34:k(M,y);break;case 31:$(b,y);break;case 32:k(b,y);break}let I=0;M.forEach(y=>I+=y);function p(y){const v=[];return y.forEach((l,d)=>v.push([d,l])),v}return{amdLoad:p(O),amdInvoke:p(R),nodeRequire:p(M),nodeEval:p(b),nodeRequireTotal:I}}static toMarkdownTable(O,R){let M="";const b=[];return O.forEach(($,k)=>{b[k]=$.length}),R.forEach($=>{$.forEach((k,A)=>{typeof k>"u"&&(k=$[A]="-");const I=k.toString().length;b[A]=Math.max(I,b[A])})}),O.forEach(($,k)=>{M+=`| ${$+" ".repeat(b[k]-$.toString().length)} `}),M+=`|
`,O.forEach(($,k)=>{M+=`| ${"-".repeat(b[k])} `}),M+=`|
`,R.forEach($=>{$.forEach((k,A)=>{typeof k<"u"&&(M+=`| ${k+" ".repeat(b[A]-k.toString().length)} `)}),M+=`|
`}),M}}e.$U=h}),define(Se[164],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=h,e.$gb=N,e.$hb=O,e.$ib=R,e.$jb=M,e.$kb=b,e.$lb=$,e.$nb=A,e.$ob=I,e.$pb=p,e.$qb=y,e.$rb=v;function h(l,d){const o=N(l,d);if(o!==-1)return l[o]}function N(l,d,o=l.length-1){for(let n=o;n>=0;n--){const i=l[n];if(d(i))return n}return-1}function O(l,d){const o=R(l,d);return o===-1?void 0:l[o]}function R(l,d,o=0,n=l.length){let i=o,u=n;for(;i<u;){const s=Math.floor((i+u)/2);d(l[s])?i=s+1:u=s}return i-1}function M(l,d){const o=b(l,d);return o===l.length?void 0:l[o]}function b(l,d,o=0,n=l.length){let i=o,u=n;for(;i<u;){const s=Math.floor((i+u)/2);d(l[s])?u=s:i=s+1}return i}function $(l,d,o=0,n=l.length){const i=b(l,d,o,n);return i===l.length?-1:i}class k{static{this.assertInvariants=!1}constructor(d){this.e=d,this.c=0}findLastMonotonous(d){if(k.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!d(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=d}const o=R(this.e,d,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$mb=k;function A(l,d){if(l.length===0)return;let o=l[0];for(let n=1;n<l.length;n++){const i=l[n];d(i,o)>0&&(o=i)}return o}function I(l,d){if(l.length===0)return;let o=l[0];for(let n=1;n<l.length;n++){const i=l[n];d(i,o)>=0&&(o=i)}return o}function p(l,d){return A(l,(o,n)=>-d(o,n))}function y(l,d){if(l.length===0)return-1;let o=0;for(let n=1;n<l.length;n++){const i=l[n];d(i,l[o])>0&&(o=n)}return o}function v(l,d){for(const o of l){const n=d(o);if(n!==void 0)return n}}}),define(Se[74],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=h,e.$L=N,e.$M=O,e.$N=R;function h(M,b){const $=Object.create(null);for(const k of M){const A=b(k);let I=$[A];I||(I=$[A]=[]),I.push(k)}return $}function N(M,b){const $=[],k=[];for(const A of M)b.has(A)||$.push(A);for(const A of b)M.has(A)||k.push(A);return{removed:$,added:k}}function O(M,b){const $=[],k=[];for(const[A,I]of M)b.has(A)||$.push(I);for(const[A,I]of b)M.has(A)||k.push(I);return{removed:$,added:k}}function R(M,b){const $=new Set;for(const k of b)M.has(k)&&$.add(k);return $}}),define(Se[56],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=N,e.$2h=O,e.$3h=R;function h(M){return(b,$,k)=>{let A=null,I=null;if(typeof k.value=="function"?(A="value",I=k.value):typeof k.get=="function"&&(A="get",I=k.get),!I)throw new Error("not supported");k[A]=M(I,$)}}function N(M,b,$){let k=null,A=null;if(typeof $.value=="function"?(k="value",A=$.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(k="get",A=$.get),!A)throw new Error("not supported");const I=`$memoize$${b}`;$[k]=function(...p){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,p)}),this[I]}}function O(M,b,$){return h((k,A)=>{const I=`$debounce$${A}`,p=`$debounce$result$${A}`;return function(...y){this[p]||(this[p]=$?$():void 0),clearTimeout(this[I]),b&&(this[p]=b(this[p],...y),y=[this[p]]),this[I]=setTimeout(()=>{k.apply(this,y),this[p]=$?$():void 0},M)}})}function R(M,b,$){return h((k,A)=>{const I=`$throttle$timer$${A}`,p=`$throttle$result$${A}`,y=`$throttle$lastRun$${A}`,v=`$throttle$pending$${A}`;return function(...l){if(this[p]||(this[p]=$?$():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),b&&(this[p]=b(this[p],...l)),this[v])return;const d=this[y]+M;d<=Date.now()?(this[y]=Date.now(),k.apply(this,[this[p]]),this[p]=$?$():void 0):(this[v]=!0,this[I]=setTimeout(()=>{this[v]=!1,this[y]=Date.now(),k.apply(this,[this[p]]),this[p]=$?$():void 0},d-Date.now()))}})}}),define(Se[13],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=N,e.$Z=O,e.$1=R,e.$2=M,e.$3=b,e.$4=k,e.$6=I,e.$7=p,e.$8=y,e.$0=l;class h{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?i.isErrorNoTelemetry(t)?new i(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(c=>{c(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=h,e.$X=new h;function N(s){e.$X.setUnexpectedErrorHandler(s)}function O(s){if(!s||typeof s!="object")return!1;const t=s;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function R(s){k(s)||e.$X.onUnexpectedError(s)}function M(s){k(s)||e.$X.onUnexpectedExternalError(s)}function b(s){if(s instanceof Error){const{name:t,message:c}=s,r=s.stacktrace||s.stack;return{$isError:!0,name:t,message:c,stack:r,noTelemetry:i.isErrorNoTelemetry(s)}}return s}const $="Canceled";function k(s){return s instanceof A?!0:s instanceof Error&&s.name===$&&s.message===$}class A extends Error{constructor(){super($),this.name=this.message}}e.$5=A;function I(){const s=new Error($);return s.name=s.message,s}function p(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}function y(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}class v extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=v;function l(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}class d extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=d;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=o;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class i extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof i)return t;const c=new i;return c.message=t.message,c.stack=t.stack,c}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=i;class u extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}e.$cb=u}),define(Se[19],De([1,0,13,164]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=O,e.$tb=R,e.$ub=M,e.$vb=b,e.$wb=$,e.$xb=k,e.$yb=A,e.$zb=I,e.$Ab=p,e.$Bb=y,e.$Cb=v,e.$Db=l,e.$Eb=d,e.top=o,e.$Gb=n,e.$Hb=u,e.$Ib=s,e.$Jb=t,e.$Kb=c,e.$Lb=r,e.$Mb=a,e.$Nb=f,e.$Ob=g,e.$Pb=w,e.$Qb=S,e.$Rb=m,e.$Sb=E,e.$Tb=D,e.$Ub=C,e.$Vb=P,e.$Wb=F,e.$Xb=T,e.$Yb=z,e.$Zb=L,e.$1b=j,e.$2b=U,e.$3b=X,e.$4b=ie,e.$5b=q,e.$6b=ne,e.$7b=be,e.$0b=ee;function O(ue,ce=0){return ue[ue.length-(1+ce)]}function R(ue){if(ue.length===0)throw new Error("Invalid tail call");return[ue.slice(0,ue.length-1),ue[ue.length-1]]}function M(ue,ce,oe=(le,K)=>le===K){if(ue===ce)return!0;if(!ue||!ce||ue.length!==ce.length)return!1;for(let le=0,K=ue.length;le<K;le++)if(!oe(ue[le],ce[le]))return!1;return!0}function b(ue,ce){const oe=ue.length-1;ce<oe&&(ue[ce]=ue[oe]),ue.pop()}function $(ue,ce,oe){return k(ue.length,le=>oe(ue[le],ce))}function k(ue,ce){let oe=0,le=ue-1;for(;oe<=le;){const K=(oe+le)/2|0,se=ce(K);if(se<0)oe=K+1;else if(se>0)le=K-1;else return K}return-(oe+1)}function A(ue,ce,oe){if(ue=ue|0,ue>=ce.length)throw new TypeError("invalid index");const le=ce[Math.floor(ce.length*Math.random())],K=[],se=[],$e=[];for(const ve of ce){const Me=oe(ve,le);Me<0?K.push(ve):Me>0?se.push(ve):$e.push(ve)}return ue<K.length?A(ue,K,oe):ue<K.length+$e.length?$e[0]:A(ue-(K.length+$e.length),se,oe)}function I(ue,ce){const oe=[];let le;for(const K of ue.slice(0).sort(ce))!le||ce(le[0],K)!==0?(le=[K],oe.push(le)):le.push(K);return oe}function*p(ue,ce){let oe,le;for(const K of ue)le!==void 0&&ce(le,K)?oe.push(K):(oe&&(yield oe),oe=[K]),le=K;oe&&(yield oe)}function y(ue,ce){for(let oe=0;oe<=ue.length;oe++)ce(oe===0?void 0:ue[oe-1],oe===ue.length?void 0:ue[oe])}function v(ue,ce){for(let oe=0;oe<ue.length;oe++)ce(oe===0?void 0:ue[oe-1],ue[oe],oe+1===ue.length?void 0:ue[oe+1])}function l(ue,ce,oe){const le=[];function K(ve,Me,ge){if(Me===0&&ge.length===0)return;const Ae=le[le.length-1];Ae&&Ae.start+Ae.deleteCount===ve?(Ae.deleteCount+=Me,Ae.toInsert.push(...ge)):le.push({start:ve,deleteCount:Me,toInsert:ge})}let se=0,$e=0;for(;;){if(se===ue.length){K(se,0,ce.slice($e));break}if($e===ce.length){K(se,ue.length-se,[]);break}const ve=ue[se],Me=ce[$e],ge=oe(ve,Me);ge===0?(se+=1,$e+=1):ge<0?(K(se,1,[]),se+=1):ge>0&&(K(se,0,[Me]),$e+=1)}return le}function d(ue,ce,oe){const le=l(ue,ce,oe),K=[],se=[];for(const $e of le)K.push(...ue.slice($e.start,$e.start+$e.deleteCount)),se.push(...$e.toInsert);return{removed:K,added:se}}function o(ue,ce,oe){if(oe===0)return[];const le=ue.slice(0,oe).sort(ce);return i(ue,ce,le,oe,ue.length),le}function n(ue,ce,oe,le,K){return oe===0?Promise.resolve([]):new Promise((se,$e)=>{(async()=>{const ve=ue.length,Me=ue.slice(0,oe).sort(ce);for(let ge=oe,Ae=Math.min(oe+le,ve);ge<ve;ge=Ae,Ae=Math.min(Ae+le,ve)){if(ge>oe&&await new Promise(Re=>setTimeout(Re)),K&&K.isCancellationRequested)throw new h.$5;i(ue,ce,Me,ge,Ae)}return Me})().then(se,$e)})}function i(ue,ce,oe,le,K){for(const se=oe.length;le<K;le++){const $e=ue[le];if(ce($e,oe[se-1])<0){oe.pop();const ve=(0,N.$kb)(oe,Me=>ce($e,Me)<0);oe.splice(ve,0,$e)}}}function u(ue){return ue.filter(ce=>!!ce)}function s(ue){let ce=0;for(let oe=0;oe<ue.length;oe++)ue[oe]&&(ue[ce]=ue[oe],ce+=1);ue.length=ce}function t(ue,ce,oe){ue.splice(oe,0,ue.splice(ce,1)[0])}function c(ue){return!Array.isArray(ue)||ue.length===0}function r(ue){return Array.isArray(ue)&&ue.length>0}function a(ue,ce=oe=>oe){const oe=new Set;return ue.filter(le=>{const K=ce(le);return oe.has(K)?!1:(oe.add(K),!0)})}function f(ue){const ce=new Set;return oe=>{const le=ue(oe);return ce.has(le)?!1:(ce.add(le),!0)}}function g(ue,ce){return ue.length>0?ue[0]:ce}function w(ue,ce){return ue.length>0?ue[ue.length-1]:ce}function S(ue,ce,oe=(le,K)=>le===K){let le=0;for(let K=0,se=Math.min(ue.length,ce.length);K<se&&oe(ue[K],ce[K]);K++)le++;return le}function m(ue,ce){let oe=typeof ce=="number"?ue:0;typeof ce=="number"?oe=ue:(oe=0,ce=ue);const le=[];if(oe<=ce)for(let K=oe;K<ce;K++)le.push(K);else for(let K=oe;K>ce;K--)le.push(K);return le}function E(ue,ce,oe){return ue.reduce((le,K)=>(le[ce(K)]=oe?oe(K):K,le),Object.create(null))}function D(ue,ce){return ue.push(ce),()=>C(ue,ce)}function C(ue,ce){const oe=ue.indexOf(ce);if(oe>-1)return ue.splice(oe,1),ce}function P(ue,ce,oe){const le=ue.slice(0,ce),K=ue.slice(ce);return le.concat(oe,K)}function F(ue,ce){let oe;if(typeof ce=="number"){let le=ce;oe=()=>{const K=Math.sin(le++)*179426549;return K-Math.floor(K)}}else oe=Math.random;for(let le=ue.length-1;le>0;le-=1){const K=Math.floor(oe()*(le+1)),se=ue[le];ue[le]=ue[K],ue[K]=se}}function T(ue,ce){const oe=ue.indexOf(ce);oe>-1&&(ue.splice(oe,1),ue.unshift(ce))}function z(ue,ce){const oe=ue.indexOf(ce);oe>-1&&(ue.splice(oe,1),ue.push(ce))}function L(ue,ce){for(const oe of ce)ue.push(oe)}function j(ue,ce){return Array.isArray(ue)?ue.map(ce):ce(ue)}function U(ue){return Array.isArray(ue)?ue:[ue]}function X(ue){return ue[Math.floor(Math.random()*ue.length)]}function ie(ue,ce,oe){const le=G(ue,ce),K=ue.length,se=oe.length;ue.length=K+se;for(let $e=K-1;$e>=le;$e--)ue[$e+se]=ue[$e];for(let $e=0;$e<se;$e++)ue[$e+le]=oe[$e]}function q(ue,ce,oe,le){const K=G(ue,ce);let se=ue.splice(K,oe);return se===void 0&&(se=[]),ie(ue,K,le),se}function G(ue,ce){return ce<0?Math.max(ce+ue.length,0):Math.min(ce,ue.length)}var x;(function(ue){function ce(se){return se<0}ue.isLessThan=ce;function oe(se){return se<=0}ue.isLessThanOrEqual=oe;function le(se){return se>0}ue.isGreaterThan=le;function K(se){return se===0}ue.isNeitherLessOrGreaterThan=K,ue.greaterThan=1,ue.lessThan=-1,ue.neitherLessOrGreaterThan=0})(x||(e.CompareResult=x={}));function ne(ue,ce){return(oe,le)=>ce(ue(oe),ue(le))}function be(...ue){return(ce,oe)=>{for(const le of ue){const K=le(ce,oe);if(!x.isNeitherLessOrGreaterThan(K))return K}return x.neitherLessOrGreaterThan}}const ae=(ue,ce)=>ue-ce;e.$8b=ae;const Ie=(ue,ce)=>(0,e.$8b)(ue?1:0,ce?1:0);e.$9b=Ie;function ee(ue){return(ce,oe)=>-ue(ce,oe)}class B{constructor(ce){this.g=ce,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ce){let oe=this.c;for(;oe<this.g.length&&ce(this.g[oe]);)oe++;const le=oe===this.c?null:this.g.slice(this.c,oe);return this.c=oe,le}takeFromEndWhile(ce){let oe=this.d;for(;oe>=0&&ce(this.g[oe]);)oe--;const le=oe===this.d?null:this.g.slice(oe+1,this.d+1);return this.d=oe,le}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ce=this.g[this.c];return this.c++,ce}removeLast(){const ce=this.g[this.d];return this.d--,ce}takeCount(ce){const oe=this.g.slice(this.c,this.c+ce);return this.c+=ce,oe}}e.$$b=B;class _{static{this.empty=new _(ce=>{})}constructor(ce){this.iterate=ce}forEach(ce){this.iterate(oe=>(ce(oe),!0))}toArray(){const ce=[];return this.iterate(oe=>(ce.push(oe),!0)),ce}filter(ce){return new _(oe=>this.iterate(le=>ce(le)?oe(le):!0))}map(ce){return new _(oe=>this.iterate(le=>oe(ce(le))))}some(ce){let oe=!1;return this.iterate(le=>(oe=ce(le),!oe)),oe}findFirst(ce){let oe;return this.iterate(le=>ce(le)?(oe=le,!1):!0),oe}findLast(ce){let oe;return this.iterate(le=>(ce(le)&&(oe=le),!0)),oe}findLastMaxBy(ce){let oe,le=!0;return this.iterate(K=>((le||x.isGreaterThan(ce(K,oe)))&&(le=!1,oe=K),!0)),oe}}e.$_b=_;class pe{constructor(ce){this.c=ce}static createSortPermutation(ce,oe){const le=Array.from(ce.keys()).sort((K,se)=>oe(ce[K],ce[se]));return new pe(le)}apply(ce){return ce.map((oe,le)=>ce[this.c[le]])}inverse(){const ce=this.c.slice();for(let oe=0;oe<this.c.length;oe++)ce[this.c[oe]]=oe;return new pe(ce)}}e.$ac=pe}),define(Se[62],De([1,0,13]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=N,e.$ed=O,e.$fd=R,e.$gd=M,e.$hd=b,e.$id=$;function N(k,A){if(!k)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}function O(k,A="Unreachable"){throw new Error(A)}function R(k){if(!k)throw new h.$cb("Assertion Failed")}function M(k){k||(0,h.$1)(new h.$cb("Soft Assertion Failed"))}function b(k){if(!k()){debugger;k(),(0,h.$1)(new h.$cb("Assertion Failed"))}}function $(k,A){let I=0;for(;I<k.length-1;){const p=k[I],y=k[I+1];if(!A(p,y))return!1;I++}return!0}}),define(Se[165],De([1,0,19]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=O,e.$8c=R,e.$9c=M,e.$0c=b,e.$$c=$,e.$_c=k;const N=(y,v)=>y===v;e.$6c=N;function O(y=e.$6c){return(v,l)=>h.$ub(v,l,y)}function R(){return(y,v)=>JSON.stringify(y)===JSON.stringify(v)}function M(){return(y,v)=>y.equals(v)}function b(y,v,l){return!y||!v?y===v:l(y,v)}function $(y,v){if(y===v)return!0;if(Array.isArray(y)&&Array.isArray(v)){if(y.length!==v.length)return!1;for(let l=0;l<y.length;l++)if(!$(y[l],v[l]))return!1;return!0}if(y&&typeof y=="object"&&v&&typeof v=="object"&&Object.getPrototypeOf(y)===Object.prototype&&Object.getPrototypeOf(v)===Object.prototype){const l=y,d=v,o=Object.keys(l),n=Object.keys(d),i=new Set(n);if(o.length!==n.length)return!1;for(const u of o)if(!i.has(u)||!$(l[u],d[u]))return!1;return!0}return!1}function k(y){return JSON.stringify(p(y))}let A=0;const I=new WeakMap;function p(y){if(Array.isArray(y))return y.map(p);if(y&&typeof y=="object")if(Object.getPrototypeOf(y)===Object.prototype){const v=y,l=Object.create(null);for(const d of Object.keys(v).sort())l[d]=p(v[d]);return l}else{let v=I.get(y);return v===void 0&&(v=A++,I.set(y,v)),v+"----2b76a038c20c4bcc"}return y}}),define(Se[75],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=h;function h(N,O){const R=this;let M=!1,b;return function(){if(M)return b;if(M=!0,O)try{b=N.apply(R,arguments)}finally{O()}else b=N.apply(R,arguments);return b}}}),define(Se[125],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KO=e.$JO=void 0;class h{constructor(O){this.a=O,this.b=0}nextId(){return this.a+ ++this.b}}e.$JO=h,e.$KO=new h("id#")}),define(Se[39],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var h;(function(N){function O(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}N.is=O;const R=Object.freeze([]);function M(){return R}N.empty=M;function*b(t){yield t}N.single=b;function $(t){return O(t)?t:b(t)}N.wrap=$;function k(t){return t||R}N.from=k;function*A(t){for(let c=t.length-1;c>=0;c--)yield t[c]}N.reverse=A;function I(t){return!t||t[Symbol.iterator]().next().done===!0}N.isEmpty=I;function p(t){return t[Symbol.iterator]().next().value}N.first=p;function y(t,c){for(const r of t)if(c(r))return!0;return!1}N.some=y;function v(t,c){for(const r of t)if(c(r))return r}N.find=v;function*l(t,c){for(const r of t)c(r)&&(yield r)}N.filter=l;function*d(t,c){let r=0;for(const a of t)yield c(a,r++)}N.map=d;function*o(...t){for(const c of t)yield*c}N.concat=o;function n(t,c,r){let a=r;for(const f of t)a=c(a,f);return a}N.reduce=n;function*i(t,c,r=t.length){for(c<0&&(c+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);c<r;c++)yield t[c]}N.slice=i;function u(t,c=Number.POSITIVE_INFINITY){const r=[];if(c===0)return[r,t];const a=t[Symbol.iterator]();for(let f=0;f<c;f++){const g=a.next();if(g.done)return[r,N.empty()];r.push(g.value)}return[r,{[Symbol.iterator](){return a}}]}N.consume=u;async function s(t){const c=[];for await(const r of t)c.push(r);return Promise.resolve(c)}N.asyncToArray=s})(h||(e.Iterable=h={}))}),define(Se[166],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Hn=M,e.$In=I,e.$Jn=p,e.$Kn=y,e.$Ln=v,e.$Mn=l,e.$Nn=d,e.$On=o,e.$Pn=n,e.$Qn=i,e.$Rn=u,e.$Sn=s;var h;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(h||(e.ScanError=h={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var O;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(O||(e.ParseErrorCode=O={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function M(t,c=!1){let r=0;const a=t.length;let f="",g=0,w=16,S=0;function m(z){let L=0,j=0;for(;L<z;){const U=t.charCodeAt(r);if(U>=48&&U<=57)j=j*16+U-48;else if(U>=65&&U<=70)j=j*16+U-65+10;else if(U>=97&&U<=102)j=j*16+U-97+10;else break;r++,L++}return L<z&&(j=-1),j}function E(z){r=z,f="",g=0,w=16,S=0}function D(){const z=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&k(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&k(t.charCodeAt(r)))for(r++;r<t.length&&k(t.charCodeAt(r));)r++;else return S=3,t.substring(z,r);let L=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&k(t.charCodeAt(r))){for(r++;r<t.length&&k(t.charCodeAt(r));)r++;L=r}else S=3;return t.substring(z,L)}function C(){let z="",L=r;for(;;){if(r>=a){z+=t.substring(L,r),S=2;break}const j=t.charCodeAt(r);if(j===34){z+=t.substring(L,r),r++;break}if(j===92){if(z+=t.substring(L,r),r++,r>=a){S=2;break}switch(t.charCodeAt(r++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const X=m(4);X>=0?z+=String.fromCharCode(X):S=4;break}default:S=5}L=r;continue}if(j>=0&&j<=31)if($(j)){z+=t.substring(L,r),S=2;break}else S=6;r++}return z}function P(){if(f="",S=0,g=r,r>=a)return g=a,w=17;let z=t.charCodeAt(r);if(b(z)){do r++,f+=String.fromCharCode(z),z=t.charCodeAt(r);while(b(z));return w=15}if($(z))return r++,f+=String.fromCharCode(z),z===13&&t.charCodeAt(r)===10&&(r++,f+=`
`),w=14;switch(z){case 123:return r++,w=1;case 125:return r++,w=2;case 91:return r++,w=3;case 93:return r++,w=4;case 58:return r++,w=6;case 44:return r++,w=5;case 34:return r++,f=C(),w=10;case 47:{const L=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<a&&!$(t.charCodeAt(r));)r++;return f=t.substring(L,r),w=12}if(t.charCodeAt(r+1)===42){r+=2;const j=a-1;let U=!1;for(;r<j;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,U=!0;break}r++}return U||(r++,S=1),f=t.substring(L,r),w=13}return f+=String.fromCharCode(z),r++,w=16}case 45:if(f+=String.fromCharCode(z),r++,r===a||!k(t.charCodeAt(r)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return f+=D(),w=11;default:for(;r<a&&F(z);)r++,z=t.charCodeAt(r);if(g!==r){switch(f=t.substring(g,r),f){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return f+=String.fromCharCode(z),r++,w=16}}function F(z){if(b(z)||$(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let z;do z=P();while(z>=12&&z<=15);return z}return{setPosition:E,getPosition:()=>r,scan:c?T:P,getToken:()=>w,getTokenValue:()=>f,getTokenOffset:()=>g,getTokenLength:()=>r-g,getTokenError:()=>S}}function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function I(t,c){const r=[],a=new Object;let f;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function S(m,E,D,C){g.value=m,g.offset=E,g.length=D,g.type=C,g.colonOffset=void 0,f=g}try{i(t,{onObjectBegin:(m,E)=>{if(c<=m)throw a;f=void 0,w=c>m,r.push("")},onObjectProperty:(m,E,D)=>{if(c<E||(S(m,E,D,"property"),r[r.length-1]=m,c<=E+D))throw a},onObjectEnd:(m,E)=>{if(c<=m)throw a;f=void 0,r.pop()},onArrayBegin:(m,E)=>{if(c<=m)throw a;f=void 0,r.push(0)},onArrayEnd:(m,E)=>{if(c<=m)throw a;f=void 0,r.pop()},onLiteralValue:(m,E,D)=>{if(c<E||(S(m,E,D,s(m)),c<=E+D))throw a},onSeparator:(m,E,D)=>{if(c<=E)throw a;if(m===":"&&f&&f.type==="property")f.colonOffset=E,w=!1,f=void 0;else if(m===","){const C=r[r.length-1];typeof C=="number"?r[r.length-1]=C+1:(w=!0,r[r.length-1]=""),f=void 0}}})}catch(m){if(m!==a)throw m}return{path:r,previousNode:f,isAtPropertyKey:w,matches:m=>{let E=0;for(let D=0;E<m.length&&D<r.length;D++)if(m[E]===r[D]||m[E]==="*")E++;else if(m[E]!=="**")return!1;return E===m.length}}}function p(t,c=[],r=R.DEFAULT){let a=null,f=[];const g=[];function w(m){Array.isArray(f)?f.push(m):a!==null&&(f[a]=m)}return i(t,{onObjectBegin:()=>{const m={};w(m),g.push(f),f=m,a=null},onObjectProperty:m=>{a=m},onObjectEnd:()=>{f=g.pop()},onArrayBegin:()=>{const m=[];w(m),g.push(f),f=m,a=null},onArrayEnd:()=>{f=g.pop()},onLiteralValue:w,onError:(m,E,D)=>{c.push({error:m,offset:E,length:D})}},r),f[0]}function y(t,c=[],r=R.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function f(m){a.type==="property"&&(a.length=m-a.offset,a=a.parent)}function g(m){return a.children.push(m),m}i(t,{onObjectBegin:m=>{a=g({type:"object",offset:m,length:-1,parent:a,children:[]})},onObjectProperty:(m,E,D)=>{a=g({type:"property",offset:E,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:m,offset:E,length:D,parent:a})},onObjectEnd:(m,E)=>{a.length=m+E-a.offset,a=a.parent,f(m+E)},onArrayBegin:(m,E)=>{a=g({type:"array",offset:m,length:-1,parent:a,children:[]})},onArrayEnd:(m,E)=>{a.length=m+E-a.offset,a=a.parent,f(m+E)},onLiteralValue:(m,E,D)=>{g({type:s(m),offset:E,length:D,parent:a,value:m}),f(E+D)},onSeparator:(m,E,D)=>{a.type==="property"&&(m===":"?a.colonOffset=E:m===","&&f(E))},onError:(m,E,D)=>{c.push({error:m,offset:E,length:D})}},r);const S=a.children[0];return S&&delete S.parent,S}function v(t,c){if(!t)return;let r=t;for(const a of c)if(typeof a=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let f=!1;for(const g of r.children)if(Array.isArray(g.children)&&g.children[0].value===a){r=g.children[1],f=!0;break}if(!f)return}else{const f=a;if(r.type!=="array"||f<0||!Array.isArray(r.children)||f>=r.children.length)return;r=r.children[f]}return r}function l(t){if(!t.parent||!t.parent.children)return[];const c=l(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;c.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&c.push(r)}return c}function d(t){switch(t.type){case"array":return t.children.map(d);case"object":{const c=Object.create(null);for(const r of t.children){const a=r.children[1];a&&(c[r.children[0].value]=d(a))}return c}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function o(t,c,r=!1){return c>=t.offset&&c<t.offset+t.length||r&&c===t.offset+t.length}function n(t,c,r=!1){if(o(t,c,r)){const a=t.children;if(Array.isArray(a))for(let f=0;f<a.length&&a[f].offset<=c;f++){const g=n(a[f],c,r);if(g)return g}return t}}function i(t,c,r=R.DEFAULT){const a=M(t,!1);function f(be){return be?()=>be(a.getTokenOffset(),a.getTokenLength()):()=>!0}function g(be){return be?ae=>be(ae,a.getTokenOffset(),a.getTokenLength()):()=>!0}const w=f(c.onObjectBegin),S=g(c.onObjectProperty),m=f(c.onObjectEnd),E=f(c.onArrayBegin),D=f(c.onArrayEnd),C=g(c.onLiteralValue),P=g(c.onSeparator),F=f(c.onComment),T=g(c.onError),z=r&&r.disallowComments,L=r&&r.allowTrailingComma;function j(){for(;;){const be=a.scan();switch(a.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:z||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(be){case 12:case 13:z?U(10):F();break;case 16:U(1);break;case 15:case 14:break;default:return be}}}function U(be,ae=[],Ie=[]){if(T(be),ae.length+Ie.length>0){let ee=a.getToken();for(;ee!==17;){if(ae.indexOf(ee)!==-1){j();break}else if(Ie.indexOf(ee)!==-1)break;ee=j()}}}function X(be){const ae=a.getTokenValue();return be?C(ae):S(ae),j(),!0}function ie(){switch(a.getToken()){case 11:{let be=0;try{be=JSON.parse(a.getTokenValue()),typeof be!="number"&&(U(2),be=0)}catch{U(2)}C(be);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return j(),!0}function q(){return a.getToken()!==10?(U(3,[],[2,5]),!1):(X(!1),a.getToken()===6?(P(":"),j(),ne()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function G(){w(),j();let be=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(be||U(4,[],[]),P(","),j(),a.getToken()===2&&L)break}else be&&U(6,[],[]);q()||U(4,[],[2,5]),be=!0}return m(),a.getToken()!==2?U(7,[2],[]):j(),!0}function x(){E(),j();let be=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(be||U(4,[],[]),P(","),j(),a.getToken()===4&&L)break}else be&&U(6,[],[]);ne()||U(4,[],[4,5]),be=!0}return D(),a.getToken()!==4?U(8,[4],[]):j(),!0}function ne(){switch(a.getToken()){case 3:return x();case 1:return G();case 10:return X(!0);default:return ie()}}return j(),a.getToken()===17?r.allowEmptyContent?!0:(U(4,[],[]),!1):ne()?(a.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}function u(t,c){const r=M(t),a=[];let f,g=0,w;do switch(w=r.getPosition(),f=r.scan(),f){case 12:case 13:case 17:g!==w&&a.push(t.substring(g,w)),c!==void 0&&a.push(r.getTokenValue().replace(/[^\r\n]/g,c)),g=r.getPosition();break}while(f!==17);return a.join("")}function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Se[46],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class h{constructor(O){this.d=O,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(O){this.c=O}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=h}),define(Se[76],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class h{static{this.Undefined=new h(void 0)}constructor(R){this.element=R,this.next=h.Undefined,this.prev=h.Undefined}}class N{constructor(){this.a=h.Undefined,this.b=h.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===h.Undefined}clear(){let R=this.a;for(;R!==h.Undefined;){const M=R.next;R.prev=h.Undefined,R.next=h.Undefined,R=M}this.a=h.Undefined,this.b=h.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,M){const b=new h(R);if(this.a===h.Undefined)this.a=b,this.b=b;else if(M){const k=this.b;this.b=b,b.prev=k,k.next=b}else{const k=this.a;this.a=b,b.next=k,k.prev=b}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(b))}}shift(){if(this.a!==h.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==h.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==h.Undefined&&R.next!==h.Undefined){const M=R.prev;M.next=R.next,R.next.prev=M}else R.prev===h.Undefined&&R.next===h.Undefined?(this.a=h.Undefined,this.b=h.Undefined):R.next===h.Undefined?(this.b=this.b.prev,this.b.next=h.Undefined):R.prev===h.Undefined&&(this.a=this.a.next,this.a.prev=h.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==h.Undefined;)yield R.element,R=R.next}}e.$5c=N}),define(Se[27],De([1,0]),function(he,e){"use strict";var h,N,O;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=R,e.$yc=M,e.$zc=b,e.$Ic=u;function R(s,t,c){let r=s.get(t);return r===void 0&&(r=c,s.set(t,r)),r}function M(s){const t=[];return s.forEach((c,r)=>{t.push(`${r} => ${c}`)}),`Map(${s.size}) {${t.join(", ")}}`}function b(s){const t=[];return s.forEach(c=>{t.push(c)}),`Set(${s.size}) {${t.join(", ")}}`}class ${constructor(t,c){this.uri=t,this.value=c}}function k(s){return Array.isArray(s)}class A{static{this.c=t=>t.toString()}constructor(t,c){if(this[h]="ResourceMap",t instanceof A)this.d=new Map(t.d),this.e=c??A.c;else if(k(t)){this.d=new Map,this.e=c??A.c;for(const[r,a]of t)this.set(r,a)}else this.d=new Map,this.e=t??A.c}set(t,c){return this.d.set(this.e(t),new $(t,c)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,c){typeof c<"u"&&(t=t.bind(c));for(const[r,a]of this.d)t(a.value,a.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(h=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Ac=A;class I{constructor(t,c){this[N]="ResourceSet",!t||typeof t=="function"?this.c=new A(t):(this.c=new A(c),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,c){this.c.forEach((r,a)=>t.call(c,a,a,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=I;var p;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class y{constructor(){this[O]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,c=0){const r=this.c.get(t);if(r)return c!==0&&this.m(r,c),r.value}set(t,c,r=0){let a=this.c.get(t);if(a)a.value=c,r!==0&&this.m(a,r);else{switch(a={key:t,value:c,next:void 0,previous:void 0},r){case 0:this.k(a);break;case 1:this.j(a);break;case 2:this.k(a);break;default:this.k(a);break}this.c.set(t,a),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const c=this.c.get(t);if(c)return this.c.delete(t),this.l(c),this.f--,c.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,c){const r=this.g;let a=this.d;for(;a;){if(c?t.bind(c)(a.value,a.key,this):t(a.value,a.key,this),this.g!==r)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const t=this,c=this.g;let r=this.d;const a={[Symbol.iterator](){return a},next(){if(t.g!==c)throw new Error("LinkedMap got modified during iteration.");if(r){const f={value:r.key,done:!1};return r=r.next,f}else return{value:void 0,done:!0}}};return a}values(){const t=this,c=this.g;let r=this.d;const a={[Symbol.iterator](){return a},next(){if(t.g!==c)throw new Error("LinkedMap got modified during iteration.");if(r){const f={value:r.value,done:!1};return r=r.next,f}else return{value:void 0,done:!0}}};return a}entries(){const t=this,c=this.g;let r=this.d;const a={[Symbol.iterator](){return a},next(){if(t.g!==c)throw new Error("LinkedMap got modified during iteration.");if(r){const f={value:[r.key,r.value],done:!1};return r=r.next,f}else return{value:void 0,done:!0}}};return a}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let c=this.d,r=this.size;for(;c&&r>t;)this.c.delete(c.key),c=c.next,r--;this.d=c,this.f=r,c&&(c.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let c=this.e,r=this.size;for(;c&&r>t;)this.c.delete(c.key),c=c.previous,r--;this.e=c,this.f=r,c&&(c.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const c=t.next,r=t.previous;if(!c||!r)throw new Error("Invalid list");c.previous=r,r.next=c}t.next=void 0,t.previous=void 0,this.g++}m(t,c){if(!this.d||!this.e)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(t===this.d)return;const r=t.next,a=t.previous;t===this.e?(a.next=void 0,this.e=a):(r.previous=a,a.next=r),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(c===2){if(t===this.e)return;const r=t.next,a=t.previous;t===this.d?(r.previous=void 0,this.d=r):(r.previous=a,a.next=r),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((c,r)=>{t.push([r,c])}),t}fromJSON(t){this.clear();for(const[c,r]of t)this.set(c,r)}}e.$Cc=y;class v extends y{constructor(t,c=1){super(),this.n=t,this.o=Math.min(Math.max(0,c),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,c=2){return super.get(t,c)}peek(t){return super.get(t,0)}set(t,c){return super.set(t,c,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class l extends v{constructor(t,c=1){super(t,c)}q(t){this.h(t)}set(t,c){return super.set(t,c),this.p(),this}}e.$Dc=l;class d extends v{constructor(t,c=1){super(t,c)}q(t){this.i(t)}set(t,c){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,c),this}}e.$Ec=d;class o{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let c=this.c.get(t)||0;return c===0?!1:(c--,c===0?this.c.delete(t):this.c.set(t,c),!0)}has(t){return this.c.has(t)}}e.$Fc=o;class n{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[c,r]of t)this.set(c,r)}clear(){this.c.clear(),this.d.clear()}set(t,c){this.c.set(t,c),this.d.set(c,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const c=this.c.get(t);return c===void 0?!1:(this.c.delete(t),this.d.delete(c),!0)}forEach(t,c){this.c.forEach((r,a)=>{t.call(c,r,a,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=n;class i{constructor(){this.c=new Map}add(t,c){let r=this.c.get(t);r||(r=new Set,this.c.set(t,r)),r.add(c)}delete(t,c){const r=this.c.get(t);r&&(r.delete(c),r.size===0&&this.c.delete(t))}forEach(t,c){const r=this.c.get(t);r&&r.forEach(c)}get(t){const c=this.c.get(t);return c||new Set}}e.$Hc=i;function u(s,t){if(s===t)return!0;if(s.size!==t.size)return!1;for(const[c,r]of s)if(!t.has(c)||t.get(c)!==r)return!1;for(const[c]of t)if(!s.has(c))return!1;return!0}}),define(Se[3],De([1,0,19,74,27,75,39]),function(he,e,h,N,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=A,e.$Lc=I,e.$Mc=p,e.$Nc=l,e.$Oc=d,e.$Pc=o,e.$Qc=n,e.$Rc=i,e.$Sc=u,e.$3c=m;const b=!1;let $=null;class k{constructor(){this.b=new Map}static{this.a=0}c(C){let P=this.b.get(C);return P||(P={parent:null,source:null,isSingleton:!1,value:C,idx:k.a++},this.b.set(C,P)),P}trackDisposable(C){const P=this.c(C);P.source||(P.source=new Error().stack)}setParent(C,P){const F=this.c(C);F.parent=P}markAsDisposed(C){this.b.delete(C)}markAsSingleton(C){this.c(C).isSingleton=!0}f(C,P){const F=P.get(C);if(F)return F;const T=C.parent?this.f(this.c(C.parent),P):C;return P.set(C,T),T}getTrackedDisposables(){const C=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,C).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(C=10,P){let F;if(P)F=P;else{const U=new Map,X=[...this.b.values()].filter(q=>q.source!==null&&!this.f(q,U).isSingleton);if(X.length===0)return;const ie=new Set(X.map(q=>q.value));if(F=X.filter(q=>!(q.parent&&ie.has(q.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function T(U){function X(q,G){for(;q.length>0&&G.some(x=>typeof x=="string"?x===q[0]:q[0].match(x));)q.shift()}const ie=U.source.split(`
`).map(q=>q.trim().replace("at ","")).filter(q=>q!=="");return X(ie,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ie.reverse()}const z=new O.$Hc;for(const U of F){const X=T(U);for(let ie=0;ie<=X.length;ie++)z.add(X.slice(0,ie).join(`
`),U)}F.sort((0,h.$6b)(U=>U.idx,h.$8b));let L="",j=0;for(const U of F.slice(0,C)){j++;const X=T(U),ie=[];for(let q=0;q<X.length;q++){let G=X[q];G=`(shared with ${z.get(X.slice(0,q+1).join(`
`)).size}/${F.length} leaks) at ${G}`;const ne=z.get(X.slice(0,q).join(`
`)),be=(0,N.$K)([...ne].map(ae=>T(ae)[q]),ae=>ae);delete be[X[q]];for(const[ae,Ie]of Object.entries(be))ie.unshift(`    - stacktraces of ${Ie.length} other leaks continue with ${ae}`);ie.unshift(G)}L+=`


==================== Leaking disposable ${j}/${F.length}: ${U.value.constructor.name} ====================
${ie.join(`
`)}
============================================================

`}return F.length>C&&(L+=`


... and ${F.length-C} more leaking disposables

`),{leaks:F,details:L}}}e.$Jc=k;function A(D){$=D}if(b){const D="__is_disposable_tracked__";A(new class{trackDisposable(C){const P=new Error("Potentially leaked disposable").stack;setTimeout(()=>{C[D]||console.log(P)},3e3)}setParent(C,P){if(C&&C!==t.None)try{C[D]=!0}catch{}}markAsDisposed(C){if(C&&C!==t.None)try{C[D]=!0}catch{}}markAsSingleton(C){}})}function I(D){return $?.trackDisposable(D),D}function p(D){$?.markAsDisposed(D)}function y(D,C){$?.setParent(D,C)}function v(D,C){if($)for(const P of D)$.setParent(P,C)}function l(D){return $?.markAsSingleton(D),D}function d(D){return typeof D=="object"&&D!==null&&typeof D.dispose=="function"&&D.dispose.length===0}function o(D){if(M.Iterable.is(D)){const C=[];for(const P of D)if(P)try{P.dispose()}catch(F){C.push(F)}if(C.length===1)throw C[0];if(C.length>1)throw new AggregateError(C,"Encountered errors while disposing of store");return Array.isArray(D)?[]:D}else if(D)return D.dispose(),D}function n(D){for(const C of D)d(C)&&C.dispose();return[]}function i(...D){const C=u(()=>o(D));return v(D,C),C}function u(D){const C=I({dispose:(0,R.$db)(()=>{p(C),D()})});return C}class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,I(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(C){if(!C)return C;if(C===this)throw new Error("Cannot register a disposable on itself!");return y(C,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(C),C}delete(C){if(C){if(C===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(C),C.dispose()}}deleteAndLeak(C){C&&this.f.has(C)&&(this.f.delete(C),y(C,null))}}e.$Tc=s;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new s,I(this),y(this.q,this)}dispose(){p(this),this.q.dispose()}B(C){if(C===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(C)}}e.$Uc=t;class c{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(C){this.b||C===this.a||(this.a?.dispose(),C&&y(C,this),this.a=C)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const C=this.a;return this.a=void 0,C&&y(C,null),C}}e.$Vc=c;class r{constructor(C){this.a=new c,this.b=!1,this.a.value=C}get value(){return this.a.value}set value(C){this.b||C===this.a.value||(this.a.value=C)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=r;class a{constructor(C){this.b=C,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=a;class f{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(C){let P=C;return this.unset=()=>P=void 0,this.isset=()=>P!==void 0,this.dispose=()=>{P&&(P(),P=void 0,p(this))},this}}e.$Yc=f;class g{constructor(){this.a=new Map}acquire(C,...P){let F=this.a.get(C);F||(F={counter:0,object:this.b(C,...P)},this.a.set(C,F));const{object:T}=F,z=(0,R.$db)(()=>{--F.counter===0&&(this.c(C,F.object),this.a.delete(C))});return F.counter++,{object:T,dispose:z}}}e.$Zc=g;class w{constructor(C){this.a=C}async acquire(C,...P){const F=this.a.acquire(C,...P);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(T){throw F.dispose(),T}}}e.$1c=w;class S{constructor(C){this.object=C}dispose(){}}e.$2c=S;function m(D){const C=new s;try{D(C)}finally{C.dispose()}}class E{constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(C){return this.a.has(C)}get size(){return this.a.size}get(C){return this.a.get(C)}set(C,P,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(C)?.dispose(),this.a.set(C,P)}deleteAndDispose(C){this.a.get(C)?.dispose(),this.a.delete(C)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=E}),function(he,e){typeof define=="function"&&define.amd?define(Se[167],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(he=typeof globalThis<"u"?globalThis:he||self,e(he.marked={}))}(this,function(he){"use strict";function e(ce,oe){for(var le=0;le<oe.length;le++){var K=oe[le];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(ce,K.key,K)}}function h(ce,oe,le){return oe&&e(ce.prototype,oe),le&&e(ce,le),Object.defineProperty(ce,"prototype",{writable:!1}),ce}function N(ce,oe){if(ce){if(typeof ce=="string")return O(ce,oe);var le=Object.prototype.toString.call(ce).slice(8,-1);if(le==="Object"&&ce.constructor&&(le=ce.constructor.name),le==="Map"||le==="Set")return Array.from(ce);if(le==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(le))return O(ce,oe)}}function O(ce,oe){(oe==null||oe>ce.length)&&(oe=ce.length);for(var le=0,K=new Array(oe);le<oe;le++)K[le]=ce[le];return K}function R(ce,oe){var le=typeof Symbol<"u"&&ce[Symbol.iterator]||ce["@@iterator"];if(le)return(le=le.call(ce)).next.bind(le);if(Array.isArray(ce)||(le=N(ce))||oe&&ce&&typeof ce.length=="number"){le&&(ce=le);var K=0;return function(){return K>=ce.length?{done:!0}:{done:!1,value:ce[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}he.defaults=M();function b(ce){he.defaults=ce}var $=/[&<>"']/,k=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(oe){return p[oe]};function v(ce,oe){if(oe){if($.test(ce))return ce.replace(k,y)}else if(A.test(ce))return ce.replace(I,y);return ce}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(ce){return ce.replace(l,function(oe,le){return le=le.toLowerCase(),le==="colon"?":":le.charAt(0)==="#"?le.charAt(1)==="x"?String.fromCharCode(parseInt(le.substring(2),16)):String.fromCharCode(+le.substring(1)):""})}var o=/(^|[^\[])\^/g;function n(ce,oe){ce=typeof ce=="string"?ce:ce.source,oe=oe||"";var le={replace:function(se,$e){return $e=$e.source||$e,$e=$e.replace(o,"$1"),ce=ce.replace(se,$e),le},getRegex:function(){return new RegExp(ce,oe)}};return le}var i=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function s(ce,oe,le){if(ce){var K;try{K=decodeURIComponent(d(le)).replace(i,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}oe&&!u.test(le)&&(le=f(oe,le));try{le=encodeURI(le).replace(/%25/g,"%")}catch{return null}return le}var t={},c=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function f(ce,oe){t[" "+ce]||(c.test(ce)?t[" "+ce]=ce+"/":t[" "+ce]=m(ce,"/",!0)),ce=t[" "+ce];var le=ce.indexOf(":")===-1;return oe.substring(0,2)==="//"?le?oe:ce.replace(r,"$1")+oe:oe.charAt(0)==="/"?le?oe:ce.replace(a,"$1")+oe:ce+oe}var g={exec:function(){}};function w(ce){for(var oe=1,le,K;oe<arguments.length;oe++){le=arguments[oe];for(K in le)Object.prototype.hasOwnProperty.call(le,K)&&(ce[K]=le[K])}return ce}function S(ce,oe){var le=ce.replace(/\|/g,function($e,ve,Me){for(var ge=!1,Ae=ve;--Ae>=0&&Me[Ae]==="\\";)ge=!ge;return ge?"|":" |"}),K=le.split(/ \|/),se=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>oe)K.splice(oe);else for(;K.length<oe;)K.push("");for(;se<K.length;se++)K[se]=K[se].trim().replace(/\\\|/g,"|");return K}function m(ce,oe,le){var K=ce.length;if(K===0)return"";for(var se=0;se<K;){var $e=ce.charAt(K-se-1);if($e===oe&&!le)se++;else if($e!==oe&&le)se++;else break}return ce.slice(0,K-se)}function E(ce,oe){if(ce.indexOf(oe[1])===-1)return-1;for(var le=ce.length,K=0,se=0;se<le;se++)if(ce[se]==="\\")se++;else if(ce[se]===oe[0])K++;else if(ce[se]===oe[1]&&(K--,K<0))return se;return-1}function D(ce){ce&&ce.sanitize&&!ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(ce,oe){if(oe<1)return"";for(var le="";oe>1;)oe&1&&(le+=ce),oe>>=1,ce+=ce;return le+ce}function P(ce,oe,le,K){var se=oe.href,$e=oe.title?v(oe.title):null,ve=ce[1].replace(/\\([\[\]])/g,"$1");if(ce[0].charAt(0)!=="!"){K.state.inLink=!0;var Me={type:"link",raw:le,href:se,title:$e,text:ve,tokens:K.inlineTokens(ve)};return K.state.inLink=!1,Me}return{type:"image",raw:le,href:se,title:$e,text:v(ve)}}function F(ce,oe){var le=ce.match(/^(\s+)(?:```)/);if(le===null)return oe;var K=le[1];return oe.split(`
`).map(function(se){var $e=se.match(/^\s+/);if($e===null)return se;var ve=$e[0];return ve.length>=K.length?se.slice(K.length):se}).join(`
`)}var T=function(){function ce(le){this.options=le||he.defaults}var oe=ce.prototype;return oe.space=function(K){var se=this.rules.block.newline.exec(K);if(se&&se[0].length>0)return{type:"space",raw:se[0]}},oe.code=function(K){var se=this.rules.block.code.exec(K);if(se){var $e=se[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:se[0],codeBlockStyle:"indented",text:this.options.pedantic?$e:m($e,`
`)}}},oe.fences=function(K){var se=this.rules.block.fences.exec(K);if(se){var $e=se[0],ve=F($e,se[3]||"");return{type:"code",raw:$e,lang:se[2]?se[2].trim():se[2],text:ve}}},oe.heading=function(K){var se=this.rules.block.heading.exec(K);if(se){var $e=se[2].trim();if(/#$/.test($e)){var ve=m($e,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&($e=ve.trim())}return{type:"heading",raw:se[0],depth:se[1].length,text:$e,tokens:this.lexer.inline($e)}}},oe.hr=function(K){var se=this.rules.block.hr.exec(K);if(se)return{type:"hr",raw:se[0]}},oe.blockquote=function(K){var se=this.rules.block.blockquote.exec(K);if(se){var $e=se[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:se[0],tokens:this.lexer.blockTokens($e,[]),text:$e}}},oe.list=function(K){var se=this.rules.block.list.exec(K);if(se){var $e,ve,Me,ge,Ae,Re,je,V,W,J,Z,de,we=se[1].trim(),Fe=we.length>1,Ve={type:"list",raw:"",ordered:Fe,start:Fe?+we.slice(0,-1):"",loose:!1,items:[]};we=Fe?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=Fe?we:"[*+-]");for(var Ge=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(de=!1,!(!(se=Ge.exec(K))||this.rules.block.hr.test(K)));){if($e=se[0],K=K.substring($e.length),V=se[2].split(`
`,1)[0],W=K.split(`
`,1)[0],this.options.pedantic?(ge=2,Z=V.trimLeft()):(ge=se[2].search(/[^ ]/),ge=ge>4?1:ge,Z=V.slice(ge),ge+=se[1].length),Re=!1,!V&&/^ *$/.test(W)&&($e+=W+`
`,K=K.substring(W.length+1),de=!0),!de)for(var tt=new RegExp("^ {0,"+Math.min(3,ge-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),_e=new RegExp("^ {0,"+Math.min(3,ge-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,ge-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,ge-1)+"}#");K&&(J=K.split(`
`,1)[0],V=J,this.options.pedantic&&(V=V.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(V)||rt.test(V)||tt.test(V)||_e.test(K)));){if(V.search(/[^ ]/)>=ge||!V.trim())Z+=`
`+V.slice(ge);else if(!Re)Z+=`
`+V;else break;!Re&&!V.trim()&&(Re=!0),$e+=J+`
`,K=K.substring(J.length+1)}Ve.loose||(je?Ve.loose=!0:/\n *\n *$/.test($e)&&(je=!0)),this.options.gfm&&(ve=/^\[[ xX]\] /.exec(Z),ve&&(Me=ve[0]!=="[ ] ",Z=Z.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:$e,task:!!ve,checked:Me,loose:!1,text:Z}),Ve.raw+=$e}Ve.items[Ve.items.length-1].raw=$e.trimRight(),Ve.items[Ve.items.length-1].text=Z.trimRight(),Ve.raw=Ve.raw.trimRight();var it=Ve.items.length;for(Ae=0;Ae<it;Ae++){this.lexer.state.top=!1,Ve.items[Ae].tokens=this.lexer.blockTokens(Ve.items[Ae].text,[]);var ct=Ve.items[Ae].tokens.filter(function(Ee){return Ee.type==="space"}),Oe=ct.every(function(Ee){for(var qe=Ee.raw.split(""),te=0,re=R(qe),Ce;!(Ce=re()).done;){var Pe=Ce.value;if(Pe===`
`&&(te+=1),te>1)return!0}return!1});!Ve.loose&&ct.length&&Oe&&(Ve.loose=!0,Ve.items[Ae].loose=!0)}return Ve}},oe.html=function(K){var se=this.rules.block.html.exec(K);if(se){var $e={type:"html",raw:se[0],pre:!this.options.sanitizer&&(se[1]==="pre"||se[1]==="script"||se[1]==="style"),text:se[0]};if(this.options.sanitize){var ve=this.options.sanitizer?this.options.sanitizer(se[0]):v(se[0]);$e.type="paragraph",$e.text=ve,$e.tokens=this.lexer.inline(ve)}return $e}},oe.def=function(K){var se=this.rules.block.def.exec(K);if(se){se[3]&&(se[3]=se[3].substring(1,se[3].length-1));var $e=se[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:$e,raw:se[0],href:se[2],title:se[3]}}},oe.table=function(K){var se=this.rules.block.table.exec(K);if(se){var $e={type:"table",header:S(se[1]).map(function(je){return{text:je}}),align:se[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:se[3]&&se[3].trim()?se[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if($e.header.length===$e.align.length){$e.raw=se[0];var ve=$e.align.length,Me,ge,Ae,Re;for(Me=0;Me<ve;Me++)/^ *-+: *$/.test($e.align[Me])?$e.align[Me]="right":/^ *:-+: *$/.test($e.align[Me])?$e.align[Me]="center":/^ *:-+ *$/.test($e.align[Me])?$e.align[Me]="left":$e.align[Me]=null;for(ve=$e.rows.length,Me=0;Me<ve;Me++)$e.rows[Me]=S($e.rows[Me],$e.header.length).map(function(je){return{text:je}});for(ve=$e.header.length,ge=0;ge<ve;ge++)$e.header[ge].tokens=this.lexer.inline($e.header[ge].text);for(ve=$e.rows.length,ge=0;ge<ve;ge++)for(Re=$e.rows[ge],Ae=0;Ae<Re.length;Ae++)Re[Ae].tokens=this.lexer.inline(Re[Ae].text);return $e}}},oe.lheading=function(K){var se=this.rules.block.lheading.exec(K);if(se)return{type:"heading",raw:se[0],depth:se[2].charAt(0)==="="?1:2,text:se[1],tokens:this.lexer.inline(se[1])}},oe.paragraph=function(K){var se=this.rules.block.paragraph.exec(K);if(se){var $e=se[1].charAt(se[1].length-1)===`
`?se[1].slice(0,-1):se[1];return{type:"paragraph",raw:se[0],text:$e,tokens:this.lexer.inline($e)}}},oe.text=function(K){var se=this.rules.block.text.exec(K);if(se)return{type:"text",raw:se[0],text:se[0],tokens:this.lexer.inline(se[0])}},oe.escape=function(K){var se=this.rules.inline.escape.exec(K);if(se)return{type:"escape",raw:se[0],text:v(se[1])}},oe.tag=function(K){var se=this.rules.inline.tag.exec(K);if(se)return!this.lexer.state.inLink&&/^<a /i.test(se[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(se[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(se[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(se[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:se[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):v(se[0]):se[0]}},oe.link=function(K){var se=this.rules.inline.link.exec(K);if(se){var $e=se[2].trim();if(!this.options.pedantic&&/^</.test($e)){if(!/>$/.test($e))return;var ve=m($e.slice(0,-1),"\\");if(($e.length-ve.length)%2===0)return}else{var Me=E(se[2],"()");if(Me>-1){var ge=se[0].indexOf("!")===0?5:4,Ae=ge+se[1].length+Me;se[2]=se[2].substring(0,Me),se[0]=se[0].substring(0,Ae).trim(),se[3]=""}}var Re=se[2],je="";if(this.options.pedantic){var V=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);V&&(Re=V[1],je=V[3])}else je=se[3]?se[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test($e)?Re=Re.slice(1):Re=Re.slice(1,-1)),P(se,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:je&&je.replace(this.rules.inline._escapes,"$1")},se[0],this.lexer)}},oe.reflink=function(K,se){var $e;if(($e=this.rules.inline.reflink.exec(K))||($e=this.rules.inline.nolink.exec(K))){var ve=($e[2]||$e[1]).replace(/\s+/g," ");if(ve=se[ve.toLowerCase()],!ve||!ve.href){var Me=$e[0].charAt(0);return{type:"text",raw:Me,text:Me}}return P($e,ve,$e[0],this.lexer)}},oe.emStrong=function(K,se,$e){$e===void 0&&($e="");var ve=this.rules.inline.emStrong.lDelim.exec(K);if(ve&&!(ve[3]&&$e.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Me=ve[1]||ve[2]||"";if(!Me||Me&&($e===""||this.rules.inline.punctuation.exec($e))){var ge=ve[0].length-1,Ae,Re,je=ge,V=0,W=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(W.lastIndex=0,se=se.slice(-1*K.length+ge);(ve=W.exec(se))!=null;)if(Ae=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!Ae){if(Re=Ae.length,ve[3]||ve[4]){je+=Re;continue}else if((ve[5]||ve[6])&&ge%3&&!((ge+Re)%3)){V+=Re;continue}if(je-=Re,!(je>0)){if(Re=Math.min(Re,Re+je+V),Math.min(ge,Re)%2){var J=K.slice(1,ge+ve.index+Re);return{type:"em",raw:K.slice(0,ge+ve.index+Re+1),text:J,tokens:this.lexer.inlineTokens(J)}}var Z=K.slice(2,ge+ve.index+Re-1);return{type:"strong",raw:K.slice(0,ge+ve.index+Re+1),text:Z,tokens:this.lexer.inlineTokens(Z)}}}}}},oe.codespan=function(K){var se=this.rules.inline.code.exec(K);if(se){var $e=se[2].replace(/\n/g," "),ve=/[^ ]/.test($e),Me=/^ /.test($e)&&/ $/.test($e);return ve&&Me&&($e=$e.substring(1,$e.length-1)),$e=v($e,!0),{type:"codespan",raw:se[0],text:$e}}},oe.br=function(K){var se=this.rules.inline.br.exec(K);if(se)return{type:"br",raw:se[0]}},oe.del=function(K){var se=this.rules.inline.del.exec(K);if(se)return{type:"del",raw:se[0],text:se[2],tokens:this.lexer.inlineTokens(se[2])}},oe.autolink=function(K,se){var $e=this.rules.inline.autolink.exec(K);if($e){var ve,Me;return $e[2]==="@"?(ve=v(this.options.mangle?se($e[1]):$e[1]),Me="mailto:"+ve):(ve=v($e[1]),Me=ve),{type:"link",raw:$e[0],text:ve,href:Me,tokens:[{type:"text",raw:ve,text:ve}]}}},oe.url=function(K,se){var $e;if($e=this.rules.inline.url.exec(K)){var ve,Me;if($e[2]==="@")ve=v(this.options.mangle?se($e[0]):$e[0]),Me="mailto:"+ve;else{var ge;do ge=$e[0],$e[0]=this.rules.inline._backpedal.exec($e[0])[0];while(ge!==$e[0]);ve=v($e[0]),$e[1]==="www."?Me="http://"+ve:Me=ve}return{type:"link",raw:$e[0],text:ve,href:Me,tokens:[{type:"text",raw:ve,text:ve}]}}},oe.inlineText=function(K,se){var $e=this.rules.inline.text.exec(K);if($e){var ve;return this.lexer.state.inRawBlock?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer($e[0]):v($e[0]):$e[0]:ve=v(this.options.smartypants?se($e[0]):$e[0]),{type:"text",raw:$e[0],text:ve}}},ce}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:g,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=n(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=n(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=n(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=n(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=n(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=w({},z),z.gfm=w({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=n(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=w({},z.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:g,paragraph:n(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var L={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:g,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:g,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};L._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",L.punctuation=n(L.punctuation).replace(/punctuation/g,L._punctuation).getRegex(),L.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,L.escapedEmSt=/\\\*|\\_/g,L._comment=n(z._comment).replace("(?:-->|$)","-->").getRegex(),L.emStrong.lDelim=n(L.emStrong.lDelim).replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimAst=n(L.emStrong.rDelimAst,"g").replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimUnd=n(L.emStrong.rDelimUnd,"g").replace(/punct/g,L._punctuation).getRegex(),L._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,L._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,L._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,L.autolink=n(L.autolink).replace("scheme",L._scheme).replace("email",L._email).getRegex(),L._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,L.tag=n(L.tag).replace("comment",L._comment).replace("attribute",L._attribute).getRegex(),L._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,L._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,L._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,L.link=n(L.link).replace("label",L._label).replace("href",L._href).replace("title",L._title).getRegex(),L.reflink=n(L.reflink).replace("label",L._label).replace("ref",z._label).getRegex(),L.nolink=n(L.nolink).replace("ref",z._label).getRegex(),L.reflinkSearch=n(L.reflinkSearch,"g").replace("reflink",L.reflink).replace("nolink",L.nolink).getRegex(),L.normal=w({},L),L.pedantic=w({},L.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",L._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",L._label).getRegex()}),L.gfm=w({},L.normal,{escape:n(L.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),L.gfm.url=n(L.gfm.url,"i").replace("email",L.gfm._extended_email).getRegex(),L.breaks=w({},L.gfm,{br:n(L.br).replace("{2,}","*").getRegex(),text:n(L.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function j(ce){return ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(ce){var oe="",le,K,se=ce.length;for(le=0;le<se;le++)K=ce.charCodeAt(le),Math.random()>.5&&(K="x"+K.toString(16)),oe+="&#"+K+";";return oe}var X=function(){function ce(le){this.tokens=[],this.tokens.links=Object.create(null),this.options=le||he.defaults,this.options.tokenizer=this.options.tokenizer||new T,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:z.normal,inline:L.normal};this.options.pedantic?(K.block=z.pedantic,K.inline=L.pedantic):this.options.gfm&&(K.block=z.gfm,this.options.breaks?K.inline=L.breaks:K.inline=L.gfm),this.tokenizer.rules=K}ce.lex=function(K,se){var $e=new ce(se);return $e.lex(K)},ce.lexInline=function(K,se){var $e=new ce(se);return $e.inlineTokens(K)};var oe=ce.prototype;return oe.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var se;se=this.inlineQueue.shift();)this.inlineTokens(se.src,se.tokens);return this.tokens},oe.blockTokens=function(K,se){var $e=this;se===void 0&&(se=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(je,V,W){return V+"    ".repeat(W.length)});for(var ve,Me,ge,Ae;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(je){return(ve=je.call({lexer:$e},K,se))?(K=K.substring(ve.raw.length),se.push(ve),!0):!1}))){if(ve=this.tokenizer.space(K)){K=K.substring(ve.raw.length),ve.raw.length===1&&se.length>0?se[se.length-1].raw+=`
`:se.push(ve);continue}if(ve=this.tokenizer.code(K)){K=K.substring(ve.raw.length),Me=se[se.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+ve.raw,Me.text+=`
`+ve.text,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):se.push(ve);continue}if(ve=this.tokenizer.fences(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.heading(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.hr(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.blockquote(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.list(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.html(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.def(K)){K=K.substring(ve.raw.length),Me=se[se.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+ve.raw,Me.text+=`
`+ve.raw,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.lheading(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ge=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var je=1/0,V=K.slice(1),W=void 0;$e.options.extensions.startBlock.forEach(function(J){W=J.call({lexer:this},V),typeof W=="number"&&W>=0&&(je=Math.min(je,W))}),je<1/0&&je>=0&&(ge=K.substring(0,je+1))}(),this.state.top&&(ve=this.tokenizer.paragraph(ge))){Me=se[se.length-1],Ae&&Me.type==="paragraph"?(Me.raw+=`
`+ve.raw,Me.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):se.push(ve),Ae=ge.length!==K.length,K=K.substring(ve.raw.length);continue}if(ve=this.tokenizer.text(K)){K=K.substring(ve.raw.length),Me=se[se.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+ve.raw,Me.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):se.push(ve);continue}if(K){var Re="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return this.state.top=!0,se},oe.inline=function(K,se){return se===void 0&&(se=[]),this.inlineQueue.push({src:K,tokens:se}),se},oe.inlineTokens=function(K,se){var $e=this;se===void 0&&(se=[]);var ve,Me,ge,Ae=K,Re,je,V;if(this.tokens.links){var W=Object.keys(this.tokens.links);if(W.length>0)for(;(Re=this.tokenizer.rules.inline.reflinkSearch.exec(Ae))!=null;)W.includes(Re[0].slice(Re[0].lastIndexOf("[")+1,-1))&&(Ae=Ae.slice(0,Re.index)+"["+C("a",Re[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Re=this.tokenizer.rules.inline.blockSkip.exec(Ae))!=null;)Ae=Ae.slice(0,Re.index)+"["+C("a",Re[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Re=this.tokenizer.rules.inline.escapedEmSt.exec(Ae))!=null;)Ae=Ae.slice(0,Re.index)+"++"+Ae.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(je||(V=""),je=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Z){return(ve=Z.call({lexer:$e},K,se))?(K=K.substring(ve.raw.length),se.push(ve),!0):!1}))){if(ve=this.tokenizer.escape(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.tag(K)){K=K.substring(ve.raw.length),Me=se[se.length-1],Me&&ve.type==="text"&&Me.type==="text"?(Me.raw+=ve.raw,Me.text+=ve.text):se.push(ve);continue}if(ve=this.tokenizer.link(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(ve.raw.length),Me=se[se.length-1],Me&&ve.type==="text"&&Me.type==="text"?(Me.raw+=ve.raw,Me.text+=ve.text):se.push(ve);continue}if(ve=this.tokenizer.emStrong(K,Ae,V)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.codespan(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.br(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.del(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.autolink(K,U)){K=K.substring(ve.raw.length),se.push(ve);continue}if(!this.state.inLink&&(ve=this.tokenizer.url(K,U))){K=K.substring(ve.raw.length),se.push(ve);continue}if(ge=K,this.options.extensions&&this.options.extensions.startInline&&function(){var Z=1/0,de=K.slice(1),we=void 0;$e.options.extensions.startInline.forEach(function(Fe){we=Fe.call({lexer:this},de),typeof we=="number"&&we>=0&&(Z=Math.min(Z,we))}),Z<1/0&&Z>=0&&(ge=K.substring(0,Z+1))}(),ve=this.tokenizer.inlineText(ge,j)){K=K.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(V=ve.raw.slice(-1)),je=!0,Me=se[se.length-1],Me&&Me.type==="text"?(Me.raw+=ve.raw,Me.text+=ve.text):se.push(ve);continue}if(K){var J="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return se},h(ce,null,[{key:"rules",get:function(){return{block:z,inline:L}}}]),ce}(),ie=function(){function ce(le){this.options=le||he.defaults}var oe=ce.prototype;return oe.code=function(K,se,$e){var ve=(se||"").match(/\S*/)[0];if(this.options.highlight){var Me=this.options.highlight(K,ve);Me!=null&&Me!==K&&($e=!0,K=Me)}return K=K.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+v(ve,!0)+'">'+($e?K:v(K,!0))+`</code></pre>
`:"<pre><code>"+($e?K:v(K,!0))+`</code></pre>
`},oe.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},oe.html=function(K){return K},oe.heading=function(K,se,$e,ve){if(this.options.headerIds){var Me=this.options.headerPrefix+ve.slug($e);return"<h"+se+' id="'+Me+'">'+K+"</h"+se+`>
`}return"<h"+se+">"+K+"</h"+se+`>
`},oe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},oe.list=function(K,se,$e){var ve=se?"ol":"ul",Me=se&&$e!==1?' start="'+$e+'"':"";return"<"+ve+Me+`>
`+K+"</"+ve+`>
`},oe.listitem=function(K){return"<li>"+K+`</li>
`},oe.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},oe.paragraph=function(K){return"<p>"+K+`</p>
`},oe.table=function(K,se){return se&&(se="<tbody>"+se+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+se+`</table>
`},oe.tablerow=function(K){return`<tr>
`+K+`</tr>
`},oe.tablecell=function(K,se){var $e=se.header?"th":"td",ve=se.align?"<"+$e+' align="'+se.align+'">':"<"+$e+">";return ve+K+("</"+$e+`>
`)},oe.strong=function(K){return"<strong>"+K+"</strong>"},oe.em=function(K){return"<em>"+K+"</em>"},oe.codespan=function(K){return"<code>"+K+"</code>"},oe.br=function(){return this.options.xhtml?"<br/>":"<br>"},oe.del=function(K){return"<del>"+K+"</del>"},oe.link=function(K,se,$e){if(K=s(this.options.sanitize,this.options.baseUrl,K),K===null)return $e;var ve='<a href="'+v(K)+'"';return se&&(ve+=' title="'+se+'"'),ve+=">"+$e+"</a>",ve},oe.image=function(K,se,$e){if(K=s(this.options.sanitize,this.options.baseUrl,K),K===null)return $e;var ve='<img src="'+K+'" alt="'+$e+'"';return se&&(ve+=' title="'+se+'"'),ve+=this.options.xhtml?"/>":">",ve},oe.text=function(K){return K},ce}(),q=function(){function ce(){}var oe=ce.prototype;return oe.strong=function(K){return K},oe.em=function(K){return K},oe.codespan=function(K){return K},oe.del=function(K){return K},oe.html=function(K){return K},oe.text=function(K){return K},oe.link=function(K,se,$e){return""+$e},oe.image=function(K,se,$e){return""+$e},oe.br=function(){return""},ce}(),G=function(){function ce(){this.seen={}}var oe=ce.prototype;return oe.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},oe.getNextSafeSlug=function(K,se){var $e=K,ve=0;if(this.seen.hasOwnProperty($e)){ve=this.seen[K];do ve++,$e=K+"-"+ve;while(this.seen.hasOwnProperty($e))}return se||(this.seen[K]=ve,this.seen[$e]=0),$e},oe.slug=function(K,se){se===void 0&&(se={});var $e=this.serialize(K);return this.getNextSafeSlug($e,se.dryrun)},ce}(),x=function(){function ce(le){this.options=le||he.defaults,this.options.renderer=this.options.renderer||new ie,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new q,this.slugger=new G}ce.parse=function(K,se){var $e=new ce(se);return $e.parse(K)},ce.parseInline=function(K,se){var $e=new ce(se);return $e.parseInline(K)};var oe=ce.prototype;return oe.parse=function(K,se){se===void 0&&(se=!0);var $e="",ve,Me,ge,Ae,Re,je,V,W,J,Z,de,we,Fe,Ve,Ge,tt,_e,nt,rt,it=K.length;for(ve=0;ve<it;ve++){if(Z=K[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Z.type]&&(rt=this.options.extensions.renderers[Z.type].call({parser:this},Z),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Z.type))){$e+=rt||"";continue}switch(Z.type){case"space":continue;case"hr":{$e+=this.renderer.hr();continue}case"heading":{$e+=this.renderer.heading(this.parseInline(Z.tokens),Z.depth,d(this.parseInline(Z.tokens,this.textRenderer)),this.slugger);continue}case"code":{$e+=this.renderer.code(Z.text,Z.lang,Z.escaped);continue}case"table":{for(W="",V="",Ae=Z.header.length,Me=0;Me<Ae;Me++)V+=this.renderer.tablecell(this.parseInline(Z.header[Me].tokens),{header:!0,align:Z.align[Me]});for(W+=this.renderer.tablerow(V),J="",Ae=Z.rows.length,Me=0;Me<Ae;Me++){for(je=Z.rows[Me],V="",Re=je.length,ge=0;ge<Re;ge++)V+=this.renderer.tablecell(this.parseInline(je[ge].tokens),{header:!1,align:Z.align[ge]});J+=this.renderer.tablerow(V)}$e+=this.renderer.table(W,J);continue}case"blockquote":{J=this.parse(Z.tokens),$e+=this.renderer.blockquote(J);continue}case"list":{for(de=Z.ordered,we=Z.start,Fe=Z.loose,Ae=Z.items.length,J="",Me=0;Me<Ae;Me++)Ge=Z.items[Me],tt=Ge.checked,_e=Ge.task,Ve="",Ge.task&&(nt=this.renderer.checkbox(tt),Fe?Ge.tokens.length>0&&Ge.tokens[0].type==="paragraph"?(Ge.tokens[0].text=nt+" "+Ge.tokens[0].text,Ge.tokens[0].tokens&&Ge.tokens[0].tokens.length>0&&Ge.tokens[0].tokens[0].type==="text"&&(Ge.tokens[0].tokens[0].text=nt+" "+Ge.tokens[0].tokens[0].text)):Ge.tokens.unshift({type:"text",text:nt}):Ve+=nt),Ve+=this.parse(Ge.tokens,Fe),J+=this.renderer.listitem(Ve,_e,tt);$e+=this.renderer.list(J,de,we);continue}case"html":{$e+=this.renderer.html(Z.text);continue}case"paragraph":{$e+=this.renderer.paragraph(this.parseInline(Z.tokens));continue}case"text":{for(J=Z.tokens?this.parseInline(Z.tokens):Z.text;ve+1<it&&K[ve+1].type==="text";)Z=K[++ve],J+=`
`+(Z.tokens?this.parseInline(Z.tokens):Z.text);$e+=se?this.renderer.paragraph(J):J;continue}default:{var ct='Token with "'+Z.type+'" type was not found.';if(this.options.silent){console.error(ct);return}else throw new Error(ct)}}}return $e},oe.parseInline=function(K,se){se=se||this.renderer;var $e="",ve,Me,ge,Ae=K.length;for(ve=0;ve<Ae;ve++){if(Me=K[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Me.type]&&(ge=this.options.extensions.renderers[Me.type].call({parser:this},Me),ge!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Me.type))){$e+=ge||"";continue}switch(Me.type){case"escape":{$e+=se.text(Me.text);break}case"html":{$e+=se.html(Me.text);break}case"link":{$e+=se.link(Me.href,Me.title,this.parseInline(Me.tokens,se));break}case"image":{$e+=se.image(Me.href,Me.title,Me.text);break}case"strong":{$e+=se.strong(this.parseInline(Me.tokens,se));break}case"em":{$e+=se.em(this.parseInline(Me.tokens,se));break}case"codespan":{$e+=se.codespan(Me.text);break}case"br":{$e+=se.br();break}case"del":{$e+=se.del(this.parseInline(Me.tokens,se));break}case"text":{$e+=se.text(Me.text);break}default:{var Re='Token with "'+Me.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return $e},ce}();function ne(ce,oe,le){if(typeof ce>"u"||ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ce)+", string expected");if(typeof oe=="function"&&(le=oe,oe=null),oe=w({},ne.defaults,oe||{}),D(oe),le){var K=oe.highlight,se;try{se=X.lex(ce,oe)}catch(Ae){return le(Ae)}var $e=function(Re){var je;if(!Re)try{oe.walkTokens&&ne.walkTokens(se,oe.walkTokens),je=x.parse(se,oe)}catch(V){Re=V}return oe.highlight=K,Re?le(Re):le(null,je)};if(!K||K.length<3||(delete oe.highlight,!se.length))return $e();var ve=0;ne.walkTokens(se,function(Ae){Ae.type==="code"&&(ve++,setTimeout(function(){K(Ae.text,Ae.lang,function(Re,je){if(Re)return $e(Re);je!=null&&je!==Ae.text&&(Ae.text=je,Ae.escaped=!0),ve--,ve===0&&$e()})},0))}),ve===0&&$e();return}function Me(Ae){if(Ae.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+v(Ae.message+"",!0)+"</pre>";throw Ae}try{var ge=X.lex(ce,oe);if(oe.walkTokens){if(oe.async)return Promise.all(ne.walkTokens(ge,oe.walkTokens)).then(function(){return x.parse(ge,oe)}).catch(Me);ne.walkTokens(ge,oe.walkTokens)}return x.parse(ge,oe)}catch(Ae){Me(Ae)}}ne.options=ne.setOptions=function(ce){return w(ne.defaults,ce),b(ne.defaults),ne},ne.getDefaults=M,ne.defaults=he.defaults,ne.use=function(){for(var ce=arguments.length,oe=new Array(ce),le=0;le<ce;le++)oe[le]=arguments[le];var K=w.apply(void 0,[{}].concat(oe)),se=ne.defaults.extensions||{renderers:{},childTokens:{}},$e;oe.forEach(function(ve){if(ve.extensions&&($e=!0,ve.extensions.forEach(function(ge){if(!ge.name)throw new Error("extension name required");if(ge.renderer){var Ae=se.renderers?se.renderers[ge.name]:null;Ae?se.renderers[ge.name]=function(){for(var Re=arguments.length,je=new Array(Re),V=0;V<Re;V++)je[V]=arguments[V];var W=ge.renderer.apply(this,je);return W===!1&&(W=Ae.apply(this,je)),W}:se.renderers[ge.name]=ge.renderer}if(ge.tokenizer){if(!ge.level||ge.level!=="block"&&ge.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");se[ge.level]?se[ge.level].unshift(ge.tokenizer):se[ge.level]=[ge.tokenizer],ge.start&&(ge.level==="block"?se.startBlock?se.startBlock.push(ge.start):se.startBlock=[ge.start]:ge.level==="inline"&&(se.startInline?se.startInline.push(ge.start):se.startInline=[ge.start]))}ge.childTokens&&(se.childTokens[ge.name]=ge.childTokens)})),ve.renderer&&function(){var ge=ne.defaults.renderer||new ie,Ae=function(V){var W=ge[V];ge[V]=function(){for(var J=arguments.length,Z=new Array(J),de=0;de<J;de++)Z[de]=arguments[de];var we=ve.renderer[V].apply(ge,Z);return we===!1&&(we=W.apply(ge,Z)),we}};for(var Re in ve.renderer)Ae(Re);K.renderer=ge}(),ve.tokenizer&&function(){var ge=ne.defaults.tokenizer||new T,Ae=function(V){var W=ge[V];ge[V]=function(){for(var J=arguments.length,Z=new Array(J),de=0;de<J;de++)Z[de]=arguments[de];var we=ve.tokenizer[V].apply(ge,Z);return we===!1&&(we=W.apply(ge,Z)),we}};for(var Re in ve.tokenizer)Ae(Re);K.tokenizer=ge}(),ve.walkTokens){var Me=ne.defaults.walkTokens;K.walkTokens=function(ge){var Ae=[];return Ae.push(ve.walkTokens.call(this,ge)),Me&&(Ae=Ae.concat(Me.call(this,ge))),Ae}}$e&&(K.extensions=se),ne.setOptions(K)})},ne.walkTokens=function(ce,oe){for(var le=[],K=function(){var Me=$e.value;switch(le=le.concat(oe.call(ne,Me)),Me.type){case"table":{for(var ge=R(Me.header),Ae;!(Ae=ge()).done;){var Re=Ae.value;le=le.concat(ne.walkTokens(Re.tokens,oe))}for(var je=R(Me.rows),V;!(V=je()).done;)for(var W=V.value,J=R(W),Z;!(Z=J()).done;){var de=Z.value;le=le.concat(ne.walkTokens(de.tokens,oe))}break}case"list":{le=le.concat(ne.walkTokens(Me.items,oe));break}default:ne.defaults.extensions&&ne.defaults.extensions.childTokens&&ne.defaults.extensions.childTokens[Me.type]?ne.defaults.extensions.childTokens[Me.type].forEach(function(we){le=le.concat(ne.walkTokens(Me[we],oe))}):Me.tokens&&(le=le.concat(ne.walkTokens(Me.tokens,oe)))}},se=R(ce),$e;!($e=se()).done;)K();return le},ne.parseInline=function(ce,oe){if(typeof ce>"u"||ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ce)+", string expected");oe=w({},ne.defaults,oe||{}),D(oe);try{var le=X.lexInline(ce,oe);return oe.walkTokens&&ne.walkTokens(le,oe.walkTokens),x.parseInline(le,oe)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+v(K.message+"",!0)+"</pre>";throw K}},ne.Parser=x,ne.parser=x.parse,ne.Renderer=ie,ne.TextRenderer=q,ne.Lexer=X,ne.lexer=X.lex,ne.Tokenizer=T,ne.Slugger=G,ne.parse=ne;var be=ne.options,ae=ne.setOptions,Ie=ne.use,ee=ne.walkTokens,B=ne.parseInline,_=ne,pe=x.parse,ue=X.lex;he.Lexer=X,he.Parser=x,he.Renderer=ie,he.Slugger=G,he.TextRenderer=q,he.Tokenizer=T,he.getDefaults=M,he.lexer=ue,he.marked=ne,he.options=be,he.parse=_,he.parseInline=B,he.parser=pe,he.setOptions=ae,he.use=Ie,he.walkTokens=ee,Object.defineProperty(he,"__esModule",{value:!0})}),define(Se[168],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=h;function h(l){const d=R(l);if(d&&d.length>0)return new Uint32Array(d)}let N=0;const O=new Uint32Array(10);function R(l){if(N=0,M(l,I,4352),N>0||(M(l,p,4449),N>0)||(M(l,y,4520),N>0)||(M(l,v,12593),N))return O.subarray(0,N);if(l>=44032&&l<=55203){const d=l-44032,o=d%588,n=Math.floor(d/588),i=Math.floor(o/28),u=o%28-1;if(n<I.length?M(n,I,0):4352+n-12593<v.length&&M(4352+n,v,12593),i<p.length?M(i,p,0):4449+i-12593<v.length&&M(4449+i-12593,v,12593),u>=0&&(u<y.length?M(u,y,0):4520+u-12593<v.length&&M(4520+u-12593,v,12593)),N>0)return O.subarray(0,N)}}function M(l,d,o){l>=o&&l<o+d.length&&b(d[l-o])}function b(l){l!==0&&(O[N++]=l&255,l>>8&&(O[N++]=l>>8&255),l>>16&&(O[N++]=l>>16&255))}var $;(function(l){l[l.InitialConsonant=4352]="InitialConsonant",l[l.Vowel=4449]="Vowel",l[l.FinalConsonant=4520]="FinalConsonant",l[l.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var k;(function(l){l[l.NUL=0]="NUL",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z"})(k||(k={}));var A;(function(l){l[l.fa=24934]="fa",l[l.fg=26470]="fg",l[l.fq=29030]="fq",l[l.fr=29286]="fr",l[l.ft=29798]="ft",l[l.fv=30310]="fv",l[l.fx=30822]="fx",l[l.hk=27496]="hk",l[l.hl=27752]="hl",l[l.ho=28520]="ho",l[l.ml=27757]="ml",l[l.nj=27246]="nj",l[l.nl=27758]="nl",l[l.np=28782]="np",l[l.qt=29809]="qt",l[l.rt=29810]="rt",l[l.sg=26483]="sg",l[l.sw=30579]="sw"})(A||(A={}));const I=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),p=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),y=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),v=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Se[77],De([1,0,27]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=void 0,e.$bm=O,e.$cm=M;const N=new h.$Dc(1e4);function O(k){return $(k,"NFC",N)}const R=new h.$Dc(1e4);function M(k){return $(k,"NFD",R)}const b=/[^\u0000-\u0080]/;function $(k,A,I){if(!k)return k;const p=I.get(k);if(p)return p;let y;return b.test(k)?y=k.normalize(A):y=k,I.set(k,y),y}e.$dm=function(){const k=/[\u0300-\u036f]/g;return function(A){return M(A).replace(k,"")}}()}),define(Se[126],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=e.$Dm=void 0,e.$Bm=h,e.rot=N;function h(b,$,k){return Math.min(Math.max(b,$),k)}function N(b,$){return($+b%$)%$}class O{constructor(){this.a=0}getNext(){return this.a++}}e.$Dm=O;class R{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Em=R;class M{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const k=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Fm=M}),define(Se[169],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=R,e.$cd=p;class h{constructor(v,l,d){this.owner=v,this.debugNameSource=l,this.referenceFn=d}getDebugName(v){return R(v,this)}}e.$ad=h;const N=new Map,O=new WeakMap;function R(y,v){const l=O.get(y);if(l)return l;const d=M(y,v);if(d){let o=N.get(d)??0;o++,N.set(d,o);const n=o===1?d:`${d}#${o}`;return O.set(y,n),n}}function M(y,v){const l=O.get(y);if(l)return l;const d=v.owner?A(v.owner)+".":"";let o;const n=v.debugNameSource;if(n!==void 0)if(typeof n=="function"){if(o=n(),o!==void 0)return d+o}else return d+n;const i=v.referenceFn;if(i!==void 0&&(o=p(i),o!==void 0))return d+o;if(v.owner!==void 0){const u=b(v.owner,y);if(u!==void 0)return d+u}}function b(y,v){for(const l in y)if(y[l]===v)return l}const $=new Map,k=new WeakMap;function A(y){const v=k.get(y);if(v)return v;const l=I(y);let d=$.get(l)??0;d++,$.set(l,d);const o=d===1?l:`${l}#${d}`;return k.set(y,o),o}function I(y){const v=y.constructor;return v?v.name:"Object"}function p(y){const v=y.toString(),d=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(v);return(d?d[1]:void 0)?.trim()}}),define(Se[170],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Hd=N,e.$Id=O;let h;function N(l){h=l}function O(){return h}class R{constructor(){this.a=0,this.d=new WeakMap}b(d){return M([b(y("|  ",this.a)),d])}c(d){return d.hadValue?d.didChange?[b(" "),k(A(d.oldValue,70),{color:"red",strikeThrough:!0}),b(" "),k(A(d.newValue,60),{color:"green"})]:[b(" (unchanged)")]:[b(" "),k(A(d.newValue,60),{color:"green"}),b(" (initial)")]}handleObservableChanged(d,o){console.log(...this.b([$("observable value changed"),k(d.debugName,{color:"BlueViolet"}),...this.c(o)]))}formatChanges(d){if(d.size!==0)return k(" (changed deps: "+[...d].map(o=>o.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(d){const o=d.handleChange;this.d.set(d,new Set),d.handleChange=(n,i)=>(this.d.get(d).add(n),o.apply(d,[n,i]))}handleDerivedRecomputed(d,o){const n=this.d.get(d);console.log(...this.b([$("derived recomputed"),k(d.debugName,{color:"BlueViolet"}),...this.c(o),this.formatChanges(n),{data:[{fn:d._computeFn}]}])),n.clear()}handleFromEventObservableTriggered(d,o){console.log(...this.b([$("observable from event triggered"),k(d.debugName,{color:"BlueViolet"}),...this.c(o),{data:[{fn:d._getValue}]}]))}handleAutorunCreated(d){const o=d.handleChange;this.d.set(d,new Set),d.handleChange=(n,i)=>(this.d.get(d).add(n),o.apply(d,[n,i]))}handleAutorunTriggered(d){const o=this.d.get(d);console.log(...this.b([$("autorun"),k(d.debugName,{color:"BlueViolet"}),this.formatChanges(o),{data:[{fn:d._runFn}]}])),o.clear(),this.a++}handleAutorunFinished(d){this.a--}handleBeginTransaction(d){let o=d.getDebugName();o===void 0&&(o=""),console.log(...this.b([$("transaction"),k(o,{color:"BlueViolet"}),{data:[{fn:d._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Jd=R;function M(l){const d=new Array,o=[];let n="";function i(s){if("length"in s)for(const t of s)t&&i(t);else"text"in s?(n+=`%c${s.text}`,d.push(s.style),s.data&&o.push(...s.data)):"data"in s&&o.push(...s.data)}i(l);const u=[n,...d];return u.push(...o),u}function b(l){return k(l,{color:"black"})}function $(l){return k(v(`${l}: `,10),{color:"black",bold:!0})}function k(l,d={color:"black"}){function o(i){return Object.entries(i).reduce((u,[s,t])=>`${u}${s}:${t};`,"")}const n={color:d.color};return d.strikeThrough&&(n["text-decoration"]="line-through"),d.bold&&(n["font-weight"]="bold"),{text:l,style:o(n)}}function A(l,d){switch(typeof l){case"number":return""+l;case"string":return l.length+2<=d?`"${l}"`:`"${l.substr(0,d-7)}"+...`;case"boolean":return l?"true":"false";case"undefined":return"undefined";case"object":return l===null?"null":Array.isArray(l)?I(l,d):p(l,d);case"symbol":return l.toString();case"function":return`[[Function${l.name?" "+l.name:""}]]`;default:return""+l}}function I(l,d){let o="[ ",n=!0;for(const i of l){if(n||(o+=", "),o.length-5>d){o+="...";break}n=!1,o+=`${A(i,d-o.length)}`}return o+=" ]",o}function p(l,d){let o="{ ",n=!0;for(const[i,u]of Object.entries(l)){if(n||(o+=", "),o.length-5>d){o+="...";break}n=!1,o+=`${i}: ${A(u,d-o.length)}`}return o+=" }",o}function y(l,d){let o="";for(let n=1;n<=d;n++)o+=l;return o}function v(l,d){for(;l.length<d;)l+=" ";return l}}),define(Se[171],De([1,0,165,169,170]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5d=e.$3d=e.$Zd=e.$Ud=e.$Td=void 0,e.$Qd=M,e.$Rd=$,e.$Sd=A,e.$Vd=y,e.$Wd=l,e.$Xd=d,e.$Yd=o,e.$1d=i,e.$2d=u,e.$4d=t;let R;function M(r){R=r}let b;function $(r){b=r}let k;function A(r){k=r}class I{get TChange(){return null}reportChanges(){this.get()}read(a){return a?a.readObservable(this):this.get()}map(a,f){const g=f===void 0?void 0:a,w=f===void 0?a:f;return k({owner:g,debugName:()=>{const S=(0,N.$cd)(w);if(S!==void 0)return S;const E=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(w.toString());if(E)return`${this.debugName}.${E[2]}`;if(!g)return`${this.debugName} (mapped)`},debugReferenceFn:w},S=>w(this.read(S),S))}recomputeInitiallyAndOnChange(a,f){return a.add(R(this,f)),this}keepObserved(a){return a.add(b(this)),this}get a(){return this.get()}}e.$Td=I;class p extends I{constructor(){super(...arguments),this.b=new Set}addObserver(a){const f=this.b.size;this.b.add(a),f===0&&this.c()}removeObserver(a){this.b.delete(a)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Ud=p;function y(r,a){const f=new n(r,a);try{r(f)}finally{f.finish()}}let v;function l(r){if(v)r(v);else{const a=new n(r,void 0);v=a;try{r(a)}finally{a.finish(),v=void 0}}}async function d(r,a){const f=new n(r,a);try{await r(f)}finally{f.finish()}}function o(r,a,f){r?a(r):y(a,f)}class n{constructor(a,f){this._fn=a,this.b=f,this.a=[],(0,O.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,N.$cd)(this._fn)}updateObserver(a,f){this.a.push({observer:a,observable:f}),a.beginUpdate(f)}finish(){const a=this.a;for(let f=0;f<a.length;f++){const{observer:g,observable:w}=a[f];g.endUpdate(w)}this.a=null,(0,O.$Id)()?.handleEndTransaction()}}e.$Zd=n;function i(r,a){let f;return typeof r=="string"?f=new N.$ad(void 0,r,void 0):f=new N.$ad(r,void 0,void 0),new s(f,a,h.$6c)}function u(r,a){return new s(new N.$ad(r.owner,r.debugName,void 0),a,r.equalsFn??h.$6c)}class s extends p{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(a,f,g){super(),this.e=a,this.g=g,this.d=f}get(){return this.d}set(a,f,g){if(this.g(this.d,a))return;let w;f||(f=w=new n(()=>{},()=>`Setting ${this.debugName}`));try{const S=this.d;this.h(a),(0,O.$Id)()?.handleObservableChanged(this,{oldValue:S,newValue:a,change:g,didChange:!0,hadValue:!0});for(const m of this.b)f.updateObserver(m,this),m.handleChange(this,g)}finally{w&&w.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(a){this.d=a}}e.$3d=s;function t(r,a){let f;return typeof r=="string"?f=new N.$ad(void 0,r,void 0):f=new N.$ad(r,void 0,void 0),new c(f,a,h.$6c)}class c extends s{h(a){this.d!==a&&(this.d&&this.d.dispose(),this.d=a)}dispose(){this.d?.dispose()}}e.$5d=c}),function(){function he(O){const R=[];typeof O=="number"&&R.push("code/timeOrigin",O);function M($){R.push($,Date.now())}function b(){const $=[];for(let k=0;k<R.length;k+=2)$.push({name:R[k],startTime:R[k+1]});return $}return{mark:M,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?he():{mark(O){performance.mark(O)},getMarks(){let O=performance.timeOrigin;typeof O!="number"&&(O=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(O)}];for(const M of performance.getEntriesByType("mark"))R.push({name:M.name,startTime:Math.round(O+M.startTime)});return R}};if(typeof process=="object"){const O=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return he(O)}else return console.trace("perf-util loaded in UNKNOWN environment"),he()}function h(O){return O.MonacoPerformanceMarks||(O.MonacoPerformanceMarks=e()),O.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return h(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=h(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=h(N))}(),define(Se[172],De([1,0,39]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tO=void 0;const N=Symbol("unset");class O{constructor(){this.a=new M,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||h.Iterable.empty()}insert($,k,A){this.d($,I=>I._value=k,A)}mutate($,k){this.d($,A=>A._value=k(A._value===N?void 0:A._value))}delete($){const k=this.c($);if(!k)return;let A=k.length-1;const I=k[A].node._value;if(I!==N){for(this.b--,k[A].node._value=N;A>0;A--){const{node:p,part:y}=k[A];if(p.children?.size||p._value!==N)break;k[A-1].node.children.delete(y)}return I}}*deleteRecursive($){const k=this.c($);if(!k)return;const A=k[k.length-1].node;for(let I=k.length-1;I>0;I--){const p=k[I-1];if(p.node.children.delete(k[I].part),p.node.children.size>0||p.node._value!==N)break}for(const I of R(A))I._value!==N&&(this.b--,yield I._value)}find($){let k=this.a;for(const A of $){const I=k.children?.get(A);if(!I)return;k=I}return k._value===N?void 0:k._value}hasKeyOrParent($){let k=this.a;for(const A of $){const I=k.children?.get(A);if(!I)return!1;if(I._value!==N)return!0;k=I}return!1}hasKeyOrChildren($){let k=this.a;for(const A of $){const I=k.children?.get(A);if(!I)return!1;k=I}return!0}hasKey($){let k=this.a;for(const A of $){const I=k.children?.get(A);if(!I)return!1;k=I}return k._value!==N}c($){const k=[{part:"",node:this.a}];let A=0;for(const I of $){const p=k[A].node.children?.get(I);if(!p)return;k.push({part:I,node:p}),A++}return k}d($,k,A){let I=this.a;for(const v of $){if(I.children)if(I.children.has(v))I=I.children.get(v);else{const l=new M;I.children.set(v,l),I=l}else{const l=new M;I.children=new Map([[v,l]]),I=l}A?.(I)}const p=I._value===N?0:1;k(I);const y=I._value===N?0:1;this.b+=y-p}*values(){for(const{_value:$}of R(this.a))$!==N&&(yield $)}}e.$tO=O;function*R(b){const $=[b];for(;$.length>0;){const k=$.pop();if(yield k,k.children)for(const A of k.children.values())$.push(A)}}class M{constructor(){this._value=N}get value(){return this._value===N?void 0:this._value}set value($){this._value=$===void 0?N:$}}}),function(he,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var h=e();for(var N in h)(typeof exports=="object"?exports:he)[N]=h[N]}}(typeof self<"u"?self:this,function(){return function(he){var e={};function h(N){if(e[N])return e[N].exports;var O=e[N]={i:N,l:!1,exports:{}};return he[N].call(O.exports,O,O.exports,h),O.l=!0,O.exports}return h.m=he,h.c=e,h.d=function(N,O,R){h.o(N,O)||Object.defineProperty(N,O,{enumerable:!0,get:R})},h.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},h.t=function(N,O){if(1&O&&(N=h(N)),8&O||4&O&&typeof N=="object"&&N&&N.__esModule)return N;var R=Object.create(null);if(h.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:N}),2&O&&typeof N!="string")for(var M in N)h.d(R,M,function(b){return N[b]}.bind(null,M));return R},h.n=function(N){var O=N&&N.__esModule?function(){return N.default}:function(){return N};return h.d(O,"a",O),O},h.o=function(N,O){return Object.prototype.hasOwnProperty.call(N,O)},h.p="",h(h.s=0)}([function(he,e,h){(function(N){var O;e=he.exports=Ie,O=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var W=Array.prototype.slice.call(arguments,0);W.unshift("SEMVER"),console.log.apply(console,W)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],$=e.src=[],k=0,A=k++;$[A]="0|[1-9]\\d*";var I=k++;$[I]="[0-9]+";var p=k++;$[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=k++;$[y]="("+$[A]+")\\.("+$[A]+")\\.("+$[A]+")";var v=k++;$[v]="("+$[I]+")\\.("+$[I]+")\\.("+$[I]+")";var l=k++;$[l]="(?:"+$[A]+"|"+$[p]+")";var d=k++;$[d]="(?:"+$[I]+"|"+$[p]+")";var o=k++;$[o]="(?:-("+$[l]+"(?:\\."+$[l]+")*))";var n=k++;$[n]="(?:-?("+$[d]+"(?:\\."+$[d]+")*))";var i=k++;$[i]="[0-9A-Za-z-]+";var u=k++;$[u]="(?:\\+("+$[i]+"(?:\\."+$[i]+")*))";var s=k++,t="v?"+$[y]+$[o]+"?"+$[u]+"?";$[s]="^"+t+"$";var c="[v=\\s]*"+$[v]+$[n]+"?"+$[u]+"?",r=k++;$[r]="^"+c+"$";var a=k++;$[a]="((?:<|>)?=?)";var f=k++;$[f]=$[I]+"|x|X|\\*";var g=k++;$[g]=$[A]+"|x|X|\\*";var w=k++;$[w]="[v=\\s]*("+$[g]+")(?:\\.("+$[g]+")(?:\\.("+$[g]+")(?:"+$[o]+")?"+$[u]+"?)?)?";var S=k++;$[S]="[v=\\s]*("+$[f]+")(?:\\.("+$[f]+")(?:\\.("+$[f]+")(?:"+$[n]+")?"+$[u]+"?)?)?";var m=k++;$[m]="^"+$[a]+"\\s*"+$[w]+"$";var E=k++;$[E]="^"+$[a]+"\\s*"+$[S]+"$";var D=k++;$[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=k++;$[C]="(?:~>?)";var P=k++;$[P]="(\\s*)"+$[C]+"\\s+",b[P]=new RegExp($[P],"g");var F=k++;$[F]="^"+$[C]+$[w]+"$";var T=k++;$[T]="^"+$[C]+$[S]+"$";var z=k++;$[z]="(?:\\^)";var L=k++;$[L]="(\\s*)"+$[z]+"\\s+",b[L]=new RegExp($[L],"g");var j=k++;$[j]="^"+$[z]+$[w]+"$";var U=k++;$[U]="^"+$[z]+$[S]+"$";var X=k++;$[X]="^"+$[a]+"\\s*("+c+")$|^$";var ie=k++;$[ie]="^"+$[a]+"\\s*("+t+")$|^$";var q=k++;$[q]="(\\s*)"+$[a]+"\\s*("+c+"|"+$[w]+")",b[q]=new RegExp($[q],"g");var G=k++;$[G]="^\\s*("+$[w]+")\\s+-\\s+("+$[w]+")\\s*$";var x=k++;$[x]="^\\s*("+$[S]+")\\s+-\\s+("+$[S]+")\\s*$";var ne=k++;$[ne]="(<|>)?=?\\s*\\*";for(var be=0;be<35;be++)O(be,$[be]),b[be]||(b[be]=new RegExp($[be]));function ae(W,J){if(W instanceof Ie)return W;if(typeof W!="string"||W.length>R||!(J?b[r]:b[s]).test(W))return null;try{return new Ie(W,J)}catch{return null}}function Ie(W,J){if(W instanceof Ie){if(W.loose===J)return W;W=W.version}else if(typeof W!="string")throw new TypeError("Invalid Version: "+W);if(W.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof Ie))return new Ie(W,J);O("SemVer",W,J),this.loose=J;var Z=W.trim().match(J?b[r]:b[s]);if(!Z)throw new TypeError("Invalid Version: "+W);if(this.raw=W,this.major=+Z[1],this.minor=+Z[2],this.patch=+Z[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");Z[4]?this.prerelease=Z[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var we=+de;if(we>=0&&we<M)return we}return de}):this.prerelease=[],this.build=Z[5]?Z[5].split("."):[],this.format()}e.parse=ae,e.valid=function(W,J){var Z=ae(W,J);return Z?Z.version:null},e.clean=function(W,J){var Z=ae(W.trim().replace(/^[=v]+/,""),J);return Z?Z.version:null},e.SemVer=Ie,Ie.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ie.prototype.toString=function(){return this.version},Ie.prototype.compare=function(W){return O("SemVer.compare",this.version,this.loose,W),W instanceof Ie||(W=new Ie(W,this.loose)),this.compareMain(W)||this.comparePre(W)},Ie.prototype.compareMain=function(W){return W instanceof Ie||(W=new Ie(W,this.loose)),B(this.major,W.major)||B(this.minor,W.minor)||B(this.patch,W.patch)},Ie.prototype.comparePre=function(W){if(W instanceof Ie||(W=new Ie(W,this.loose)),this.prerelease.length&&!W.prerelease.length)return-1;if(!this.prerelease.length&&W.prerelease.length)return 1;if(!this.prerelease.length&&!W.prerelease.length)return 0;var J=0;do{var Z=this.prerelease[J],de=W.prerelease[J];if(O("prerelease compare",J,Z,de),Z===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(Z===void 0)return-1;if(Z!==de)return B(Z,de)}while(++J)},Ie.prototype.inc=function(W,J){switch(W){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",J);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",J);break;case"prepatch":this.prerelease.length=0,this.inc("patch",J),this.inc("pre",J);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",J),this.inc("pre",J);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Z=this.prerelease.length;--Z>=0;)typeof this.prerelease[Z]=="number"&&(this.prerelease[Z]++,Z=-2);Z===-1&&this.prerelease.push(0)}J&&(this.prerelease[0]===J?isNaN(this.prerelease[1])&&(this.prerelease=[J,0]):this.prerelease=[J,0]);break;default:throw new Error("invalid increment argument: "+W)}return this.format(),this.raw=this.version,this},e.inc=function(W,J,Z,de){typeof Z=="string"&&(de=Z,Z=void 0);try{return new Ie(W,Z).inc(J,de).version}catch{return null}},e.diff=function(W,J){if(ce(W,J))return null;var Z=ae(W),de=ae(J);if(Z.prerelease.length||de.prerelease.length){for(var we in Z)if((we==="major"||we==="minor"||we==="patch")&&Z[we]!==de[we])return"pre"+we;return"prerelease"}for(var we in Z)if((we==="major"||we==="minor"||we==="patch")&&Z[we]!==de[we])return we},e.compareIdentifiers=B;var ee=/^[0-9]+$/;function B(W,J){var Z=ee.test(W),de=ee.test(J);return Z&&de&&(W=+W,J=+J),Z&&!de?-1:de&&!Z?1:W<J?-1:W>J?1:0}function _(W,J,Z){return new Ie(W,Z).compare(new Ie(J,Z))}function pe(W,J,Z){return _(W,J,Z)>0}function ue(W,J,Z){return _(W,J,Z)<0}function ce(W,J,Z){return _(W,J,Z)===0}function oe(W,J,Z){return _(W,J,Z)!==0}function le(W,J,Z){return _(W,J,Z)>=0}function K(W,J,Z){return _(W,J,Z)<=0}function se(W,J,Z,de){var we;switch(J){case"===":typeof W=="object"&&(W=W.version),typeof Z=="object"&&(Z=Z.version),we=W===Z;break;case"!==":typeof W=="object"&&(W=W.version),typeof Z=="object"&&(Z=Z.version),we=W!==Z;break;case"":case"=":case"==":we=ce(W,Z,de);break;case"!=":we=oe(W,Z,de);break;case">":we=pe(W,Z,de);break;case">=":we=le(W,Z,de);break;case"<":we=ue(W,Z,de);break;case"<=":we=K(W,Z,de);break;default:throw new TypeError("Invalid operator: "+J)}return we}function $e(W,J){if(W instanceof $e){if(W.loose===J)return W;W=W.value}if(!(this instanceof $e))return new $e(W,J);O("comparator",W,J),this.loose=J,this.parse(W),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,O("comp",this)}e.rcompareIdentifiers=function(W,J){return B(J,W)},e.major=function(W,J){return new Ie(W,J).major},e.minor=function(W,J){return new Ie(W,J).minor},e.patch=function(W,J){return new Ie(W,J).patch},e.compare=_,e.compareLoose=function(W,J){return _(W,J,!0)},e.rcompare=function(W,J,Z){return _(J,W,Z)},e.sort=function(W,J){return W.sort(function(Z,de){return e.compare(Z,de,J)})},e.rsort=function(W,J){return W.sort(function(Z,de){return e.rcompare(Z,de,J)})},e.gt=pe,e.lt=ue,e.eq=ce,e.neq=oe,e.gte=le,e.lte=K,e.cmp=se,e.Comparator=$e;var ve={};function Me(W,J){if(W instanceof Me)return W.loose===J?W:new Me(W.raw,J);if(W instanceof $e)return new Me(W.value,J);if(!(this instanceof Me))return new Me(W,J);if(this.loose=J,this.raw=W,this.set=W.split(/\s*\|\|\s*/).map(function(Z){return this.parseRange(Z.trim())},this).filter(function(Z){return Z.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+W);this.format()}function ge(W){return!W||W.toLowerCase()==="x"||W==="*"}function Ae(W,J,Z,de,we,Fe,Ve,Ge,tt,_e,nt,rt,it){return((J=ge(Z)?"":ge(de)?">="+Z+".0.0":ge(we)?">="+Z+"."+de+".0":">="+J)+" "+(Ge=ge(tt)?"":ge(_e)?"<"+(+tt+1)+".0.0":ge(nt)?"<"+tt+"."+(+_e+1)+".0":rt?"<="+tt+"."+_e+"."+nt+"-"+rt:"<="+Ge)).trim()}function Re(W,J){for(var Z=0;Z<W.length;Z++)if(!W[Z].test(J))return!1;if(J.prerelease.length){for(Z=0;Z<W.length;Z++)if(O(W[Z].semver),W[Z].semver!==ve&&W[Z].semver.prerelease.length>0){var de=W[Z].semver;if(de.major===J.major&&de.minor===J.minor&&de.patch===J.patch)return!0}return!1}return!0}function je(W,J,Z){try{J=new Me(J,Z)}catch{return!1}return J.test(W)}function V(W,J,Z,de){var we,Fe,Ve,Ge,tt;switch(W=new Ie(W,de),J=new Me(J,de),Z){case">":we=pe,Fe=K,Ve=ue,Ge=">",tt=">=";break;case"<":we=ue,Fe=le,Ve=pe,Ge="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(W,J,de))return!1;for(var _e=0;_e<J.set.length;++_e){var nt=J.set[_e],rt=null,it=null;if(nt.forEach(function(ct){ct.semver===ve&&(ct=new $e(">=0.0.0")),rt=rt||ct,it=it||ct,we(ct.semver,rt.semver,de)?rt=ct:Ve(ct.semver,it.semver,de)&&(it=ct)}),rt.operator===Ge||rt.operator===tt||(!it.operator||it.operator===Ge)&&Fe(W,it.semver)||it.operator===tt&&Ve(W,it.semver))return!1}return!0}$e.prototype.parse=function(W){var J=this.loose?b[X]:b[ie],Z=W.match(J);if(!Z)throw new TypeError("Invalid comparator: "+W);this.operator=Z[1],this.operator==="="&&(this.operator=""),Z[2]?this.semver=new Ie(Z[2],this.loose):this.semver=ve},$e.prototype.toString=function(){return this.value},$e.prototype.test=function(W){return O("Comparator.test",W,this.loose),this.semver===ve||(typeof W=="string"&&(W=new Ie(W,this.loose)),se(W,this.operator,this.semver,this.loose))},$e.prototype.intersects=function(W,J){if(!(W instanceof $e))throw new TypeError("a Comparator is required");var Z;if(this.operator==="")return Z=new Me(W.value,J),je(this.value,Z,J);if(W.operator==="")return Z=new Me(this.value,J),je(W.semver,Z,J);var de=!(this.operator!==">="&&this.operator!==">"||W.operator!==">="&&W.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||W.operator!=="<="&&W.operator!=="<"),Fe=this.semver.version===W.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||W.operator!==">="&&W.operator!=="<="),Ge=se(this.semver,"<",W.semver,J)&&(this.operator===">="||this.operator===">")&&(W.operator==="<="||W.operator==="<"),tt=se(this.semver,">",W.semver,J)&&(this.operator==="<="||this.operator==="<")&&(W.operator===">="||W.operator===">");return de||we||Fe&&Ve||Ge||tt},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(W){return W.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(W){var J=this.loose;W=W.trim(),O("range",W,J);var Z=J?b[x]:b[G];W=W.replace(Z,Ae),O("hyphen replace",W),W=W.replace(b[q],"$1$2$3"),O("comparator trim",W,b[q]),W=(W=(W=W.replace(b[P],"$1~")).replace(b[L],"$1^")).split(/\s+/).join(" ");var de=J?b[X]:b[ie],we=W.split(" ").map(function(Fe){return function(Ve,Ge){return O("comp",Ve),Ve=function(tt,_e){return tt.trim().split(/\s+/).map(function(nt){return function(rt,it){O("caret",rt,it);var ct=it?b[U]:b[j];return rt.replace(ct,function(Oe,Ee,qe,te,re){var Ce;return O("caret",rt,Oe,Ee,qe,te,re),ge(Ee)?Ce="":ge(qe)?Ce=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ge(te)?Ce=Ee==="0"?">="+Ee+"."+qe+".0 <"+Ee+"."+(+qe+1)+".0":">="+Ee+"."+qe+".0 <"+(+Ee+1)+".0.0":re?(O("replaceCaret pr",re),re.charAt(0)!=="-"&&(re="-"+re),Ce=Ee==="0"?qe==="0"?">="+Ee+"."+qe+"."+te+re+" <"+Ee+"."+qe+"."+(+te+1):">="+Ee+"."+qe+"."+te+re+" <"+Ee+"."+(+qe+1)+".0":">="+Ee+"."+qe+"."+te+re+" <"+(+Ee+1)+".0.0"):(O("no pr"),Ce=Ee==="0"?qe==="0"?">="+Ee+"."+qe+"."+te+" <"+Ee+"."+qe+"."+(+te+1):">="+Ee+"."+qe+"."+te+" <"+Ee+"."+(+qe+1)+".0":">="+Ee+"."+qe+"."+te+" <"+(+Ee+1)+".0.0"),O("caret return",Ce),Ce})}(nt,_e)}).join(" ")}(Ve,Ge),O("caret",Ve),Ve=function(tt,_e){return tt.trim().split(/\s+/).map(function(nt){return function(rt,it){var ct=it?b[T]:b[F];return rt.replace(ct,function(Oe,Ee,qe,te,re){var Ce;return O("tilde",rt,Oe,Ee,qe,te,re),ge(Ee)?Ce="":ge(qe)?Ce=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ge(te)?Ce=">="+Ee+"."+qe+".0 <"+Ee+"."+(+qe+1)+".0":re?(O("replaceTilde pr",re),re.charAt(0)!=="-"&&(re="-"+re),Ce=">="+Ee+"."+qe+"."+te+re+" <"+Ee+"."+(+qe+1)+".0"):Ce=">="+Ee+"."+qe+"."+te+" <"+Ee+"."+(+qe+1)+".0",O("tilde return",Ce),Ce})}(nt,_e)}).join(" ")}(Ve,Ge),O("tildes",Ve),Ve=function(tt,_e){return O("replaceXRanges",tt,_e),tt.split(/\s+/).map(function(nt){return function(rt,it){rt=rt.trim();var ct=it?b[E]:b[m];return rt.replace(ct,function(Oe,Ee,qe,te,re,Ce){O("xRange",rt,Oe,Ee,qe,te,re,Ce);var Pe=ge(qe),Xe=Pe||ge(te),st=Xe||ge(re);return Ee==="="&&st&&(Ee=""),Pe?Oe=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&st?(Xe&&(te=0),st&&(re=0),Ee===">"?(Ee=">=",Xe?(qe=+qe+1,te=0,re=0):st&&(te=+te+1,re=0)):Ee==="<="&&(Ee="<",Xe?qe=+qe+1:te=+te+1),Oe=Ee+qe+"."+te+"."+re):Xe?Oe=">="+qe+".0.0 <"+(+qe+1)+".0.0":st&&(Oe=">="+qe+"."+te+".0 <"+qe+"."+(+te+1)+".0"),O("xRange return",Oe),Oe})}(nt,_e)}).join(" ")}(Ve,Ge),O("xrange",Ve),Ve=function(tt,_e){return O("replaceStars",tt,_e),tt.trim().replace(b[ne],"")}(Ve,Ge),O("stars",Ve),Ve}(Fe,J)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Fe){return!!Fe.match(de)})),we=we.map(function(Fe){return new $e(Fe,J)})},Me.prototype.intersects=function(W,J){if(!(W instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(Z){return Z.every(function(de){return W.set.some(function(we){return we.every(function(Fe){return de.intersects(Fe,J)})})})})},e.toComparators=function(W,J){return new Me(W,J).set.map(function(Z){return Z.map(function(de){return de.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(W){if(!W)return!1;typeof W=="string"&&(W=new Ie(W,this.loose));for(var J=0;J<this.set.length;J++)if(Re(this.set[J],W))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(W,J,Z){var de=null,we=null;try{var Fe=new Me(J,Z)}catch{return null}return W.forEach(function(Ve){Fe.test(Ve)&&(de&&we.compare(Ve)!==-1||(we=new Ie(de=Ve,Z)))}),de},e.minSatisfying=function(W,J,Z){var de=null,we=null;try{var Fe=new Me(J,Z)}catch{return null}return W.forEach(function(Ve){Fe.test(Ve)&&(de&&we.compare(Ve)!==1||(we=new Ie(de=Ve,Z)))}),de},e.validRange=function(W,J){try{return new Me(W,J).range||"*"}catch{return null}},e.ltr=function(W,J,Z){return V(W,J,"<",Z)},e.gtr=function(W,J,Z){return V(W,J,">",Z)},e.outside=V,e.prerelease=function(W,J){var Z=ae(W,J);return Z&&Z.prerelease.length?Z.prerelease:null},e.intersects=function(W,J,Z){return W=new Me(W,Z),J=new Me(J,Z),W.intersects(J)},e.coerce=function(W){if(W instanceof Ie)return W;if(typeof W!="string")return null;var J=W.match(b[D]);return J==null?null:ae((J[1]||"0")+"."+(J[2]||"0")+"."+(J[3]||"0"))}}).call(this,h(1))},function(he,e){var h,N,O=he.exports={};function R(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function b(d){if(h===setTimeout)return setTimeout(d,0);if((h===R||!h)&&setTimeout)return h=setTimeout,setTimeout(d,0);try{return h(d,0)}catch{try{return h.call(null,d,0)}catch{return h.call(this,d,0)}}}(function(){try{h=typeof setTimeout=="function"?setTimeout:R}catch{h=R}try{N=typeof clearTimeout=="function"?clearTimeout:M}catch{N=M}})();var $,k=[],A=!1,I=-1;function p(){A&&$&&(A=!1,$.length?k=$.concat(k):I=-1,k.length&&y())}function y(){if(!A){var d=b(p);A=!0;for(var o=k.length;o;){for($=k,k=[];++I<o;)$&&$[I].run();I=-1,o=k.length}$=null,A=!1,function(n){if(N===clearTimeout)return clearTimeout(n);if((N===M||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(n);try{N(n)}catch{try{return N.call(null,n)}catch{return N.call(this,n)}}}(d)}}function v(d,o){this.fun=d,this.array=o}function l(){}O.nextTick=function(d){var o=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)o[n-1]=arguments[n];k.push(new v(d,o)),k.length!==1||A||b(y)},v.prototype.run=function(){this.fun.apply(null,this.array)},O.title="browser",O.browser=!0,O.env={},O.argv=[],O.version="",O.versions={},O.on=l,O.addListener=l,O.once=l,O.off=l,O.removeListener=l,O.removeAllListeners=l,O.emit=l,O.prependListener=l,O.prependOnceListener=l,O.listeners=function(d){return[]},O.binding=function(d){throw new Error("process.binding is not supported")},O.cwd=function(){return"/"},O.chdir=function(d){throw new Error("process.chdir is not supported")},O.umask=function(){return 0}}])}),define(Se[40],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=void 0;const h=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(R){return new N(R)}constructor(R){this.c=h&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$_d=N}),define(Se[4],De([1,0,13,75,3,76,40]),function(he,e,h,N,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$be=e.Event=void 0,e.$ce=y;const b=!1,$=!1,k=!1;var A;(function(P){P.None=()=>O.$Uc.None;function F(Me){if(k){const{onDidAddListener:ge}=Me,Ae=l.create();let Re=0;Me.onDidAddListener=()=>{++Re===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ae.print()),ge?.()}}}function T(Me,ge){return ne(Me,()=>{},0,void 0,!0,void 0,ge)}P.defer=T;function z(Me){return(ge,Ae=null,Re)=>{let je=!1,V;return V=Me(W=>{if(!je)return V?V.dispose():je=!0,ge.call(Ae,W)},null,Re),je&&V.dispose(),V}}P.once=z;function L(Me,ge,Ae){return G((Re,je=null,V)=>Me(W=>Re.call(je,ge(W)),null,V),Ae)}P.map=L;function j(Me,ge,Ae){return G((Re,je=null,V)=>Me(W=>{ge(W),Re.call(je,W)},null,V),Ae)}P.forEach=j;function U(Me,ge,Ae){return G((Re,je=null,V)=>Me(W=>ge(W)&&Re.call(je,W),null,V),Ae)}P.filter=U;function X(Me){return Me}P.signal=X;function ie(...Me){return(ge,Ae=null,Re)=>{const je=(0,O.$Rc)(...Me.map(V=>V(W=>ge.call(Ae,W))));return x(je,Re)}}P.any=ie;function q(Me,ge,Ae,Re){let je=Ae;return L(Me,V=>(je=ge(je,V),je),Re)}P.reduce=q;function G(Me,ge){let Ae;const Re={onWillAddFirstListener(){Ae=Me(je.fire,je)},onDidRemoveLastListener(){Ae?.dispose()}};ge||F(Re);const je=new s(Re);return ge?.add(je),je.event}function x(Me,ge){return ge instanceof Array?ge.push(Me):ge&&ge.add(Me),Me}function ne(Me,ge,Ae=100,Re=!1,je=!1,V,W){let J,Z,de,we=0,Fe;const Ve={leakWarningThreshold:V,onWillAddFirstListener(){J=Me(tt=>{we++,Z=ge(Z,tt),Re&&!de&&(Ge.fire(Z),Z=void 0),Fe=()=>{const _e=Z;Z=void 0,de=void 0,(!Re||we>1)&&Ge.fire(_e),we=0},typeof Ae=="number"?(clearTimeout(de),de=setTimeout(Fe,Ae)):de===void 0&&(de=0,queueMicrotask(Fe))})},onWillRemoveListener(){je&&we>0&&Fe?.()},onDidRemoveLastListener(){Fe=void 0,J.dispose()}};W||F(Ve);const Ge=new s(Ve);return W?.add(Ge),Ge.event}P.debounce=ne;function be(Me,ge=0,Ae){return P.debounce(Me,(Re,je)=>Re?(Re.push(je),Re):[je],ge,void 0,!0,void 0,Ae)}P.accumulate=be;function ae(Me,ge=(Re,je)=>Re===je,Ae){let Re=!0,je;return U(Me,V=>{const W=Re||!ge(V,je);return Re=!1,je=V,W},Ae)}P.latch=ae;function Ie(Me,ge,Ae){return[P.filter(Me,ge,Ae),P.filter(Me,Re=>!ge(Re),Ae)]}P.split=Ie;function ee(Me,ge=!1,Ae=[],Re){let je=Ae.slice(),V=Me(Z=>{je?je.push(Z):J.fire(Z)});Re&&Re.add(V);const W=()=>{je?.forEach(Z=>J.fire(Z)),je=null},J=new s({onWillAddFirstListener(){V||(V=Me(Z=>J.fire(Z)),Re&&Re.add(V))},onDidAddFirstListener(){je&&(ge?setTimeout(W):W())},onDidRemoveLastListener(){V&&V.dispose(),V=null}});return Re&&Re.add(J),J.event}P.buffer=ee;function B(Me,ge){return(Re,je,V)=>{const W=ge(new pe);return Me(function(J){const Z=W.evaluate(J);Z!==_&&Re.call(je,Z)},void 0,V)}}P.chain=B;const _=Symbol("HaltChainable");class pe{constructor(){this.f=[]}map(ge){return this.f.push(ge),this}forEach(ge){return this.f.push(Ae=>(ge(Ae),Ae)),this}filter(ge){return this.f.push(Ae=>ge(Ae)?Ae:_),this}reduce(ge,Ae){let Re=Ae;return this.f.push(je=>(Re=ge(Re,je),Re)),this}latch(ge=(Ae,Re)=>Ae===Re){let Ae=!0,Re;return this.f.push(je=>{const V=Ae||!ge(je,Re);return Ae=!1,Re=je,V?je:_}),this}evaluate(ge){for(const Ae of this.f)if(ge=Ae(ge),ge===_)break;return ge}}function ue(Me,ge,Ae=Re=>Re){const Re=(...J)=>W.fire(Ae(...J)),je=()=>Me.on(ge,Re),V=()=>Me.removeListener(ge,Re),W=new s({onWillAddFirstListener:je,onDidRemoveLastListener:V});return W.event}P.fromNodeEventEmitter=ue;function ce(Me,ge,Ae=Re=>Re){const Re=(...J)=>W.fire(Ae(...J)),je=()=>Me.addEventListener(ge,Re),V=()=>Me.removeEventListener(ge,Re),W=new s({onWillAddFirstListener:je,onDidRemoveLastListener:V});return W.event}P.fromDOMEventEmitter=ce;function oe(Me){return new Promise(ge=>z(Me)(ge))}P.toPromise=oe;function le(Me){const ge=new s;return Me.then(Ae=>{ge.fire(Ae)},()=>{ge.fire(void 0)}).finally(()=>{ge.dispose()}),ge.event}P.fromPromise=le;function K(Me,ge,Ae){return ge(Ae),Me(Re=>ge(Re))}P.runAndSubscribe=K;class se{constructor(ge,Ae){this._observable=ge,this.f=0,this.g=!1;const Re={onWillAddFirstListener:()=>{ge.addObserver(this)},onDidRemoveLastListener:()=>{ge.removeObserver(this)}};Ae||F(Re),this.emitter=new s(Re),Ae&&Ae.add(this.emitter)}beginUpdate(ge){this.f++}handlePossibleChange(ge){}handleChange(ge,Ae){this.g=!0}endUpdate(ge){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function $e(Me,ge){return new se(Me,ge).emitter.event}P.fromObservable=$e;function ve(Me){return(ge,Ae,Re)=>{let je=0,V=!1;const W={beginUpdate(){je++},endUpdate(){je--,je===0&&(Me.reportChanges(),V&&(V=!1,ge.call(Ae)))},handlePossibleChange(){},handleChange(){V=!0}};Me.addObserver(W),Me.reportChanges();const J={dispose(){Me.removeObserver(W)}};return Re instanceof O.$Tc?Re.add(J):Array.isArray(Re)&&Re.push(J),J}}P.fromObservableLight=ve})(A||(e.Event=A={}));class I{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${I.f++}`,I.all.add(this)}start(F){this.g=new M.$_d,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$be=I;let p=-1;function y(P){const F=p;return p=P,{dispose(){p=F}}}class v{constructor(F,T=Math.random().toString(18).slice(2,5)){this.threshold=F,this.name=T,this.g=0}dispose(){this.f?.clear()}check(F,T){const z=this.threshold;if(z<=0||T<z)return;this.f||(this.f=new Map);const L=this.f.get(F.value)||0;if(this.f.set(F.value,L+1),this.g-=1,this.g<=0){this.g=z*.5;let j,U=0;for(const[X,ie]of this.f)(!j||U<ie)&&(j=X,U=ie);console.warn(`[${this.name}] potential listener LEAK detected, having ${T} listeners already. MOST frequent listener (${U}):`),console.warn(j)}return()=>{const j=this.f.get(F.value)||0;this.f.set(F.value,j-1)}}}class l{static create(){return new l(new Error().stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let d=0;class o{constructor(F){this.value=F,this.id=d++}}const n=2,i=(P,F)=>{if(P instanceof o)F(P);else for(let T=0;T<P.length;T++){const z=P[T];z&&F(z)}},u=b?new FinalizationRegistry(P=>{typeof P=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(P))}):void 0;class s{constructor(F){this.w=0,this.f=F,this.g=p>0||this.f?.leakWarningThreshold?new v(this.f?.leakWarningThreshold??p):void 0,this.j=this.f?._profName?new I(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if($){const F=this.t;queueMicrotask(()=>{i(F,T=>T.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,T,z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),O.$Uc.None;if(this.m)return O.$Uc.None;T&&(F=F.bind(T));const L=new o(F);let j,U;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(L.stack=l.create(),j=this.g.check(L.stack,this.w+1)),$&&(L.stack=U??l.create()),this.t?this.t instanceof o?(this.u??=new c,this.t=[this.t,L]):this.t.push(L):(this.f?.onWillAddFirstListener?.(this),this.t=L,this.f?.onDidAddFirstListener?.(this)),this.w++;const X=(0,O.$Sc)(()=>{u?.unregister(X),j?.(),this.x(L)});if(z instanceof O.$Tc?z.add(X):Array.isArray(z)&&z.push(X),u){const ie=new Error().stack.split(`
`).slice(2).join(`
`).trim();u.register(X,ie,X)}return X},this.q}x(F){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const T=this.t,z=T.indexOf(F);if(z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,T[z]=void 0;const L=this.u.current===this;if(this.w*n<=T.length){let j=0;for(let U=0;U<T.length;U++)T[U]?T[j++]=T[U]:L&&(this.u.end--,j<this.u.i&&this.u.i--);T.length=j}}y(F,T){if(!F)return;const z=this.f?.onListenerError||h.$1;if(!z){F.value(T);return}try{F.value(T)}catch(L){z(L)}}z(F){const T=F.current.t;for(;F.i<F.end;)this.y(T[F.i++],F.value);F.reset()}fire(F){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof o)this.y(this.t,F);else{const T=this.u;T.enqueue(this,F,this.t.length),this.z(T)}this.j?.stop()}hasListeners(){return this.w>0}}e.$de=s;const t=()=>new c;e.$ee=t;class c{constructor(){this.i=-1,this.end=0}enqueue(F,T,z){this.i=0,this.end=z,this.current=F,this.value=T}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends s{async fireAsync(F,T,z){if(this.t)for(this.h||(this.h=new R.$5c),i(this.t,L=>this.h.push([L.value,F]));this.h.size>0&&!T.isCancellationRequested;){const[L,j]=this.h.shift(),U=[],X={...j,token:T,waitUntil:ie=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");z&&(ie=z(ie,L)),U.push(ie)}};try{L(X)}catch(ie){(0,h.$1)(ie);continue}Object.freeze(U),await Promise.allSettled(U).then(ie=>{for(const q of ie)q.status==="rejected"&&(0,h.$1)(q.reason)})}}}e.$fe=r;class a extends s{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new R.$5c,this.A=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.A(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.w&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$ge=a;class f extends a{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$he=f;class g extends s{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(T=>super.fire(T)),this.h=[]}))}}e.$ie=g;class w{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const T={event:F,listener:null};this.h.push(T),this.g&&this.m(T);const z=()=>{this.g&&this.o(T);const L=this.h.indexOf(T);this.h.splice(L,1)};return(0,O.$Sc)((0,N.$db)(z))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(T=>this.f.fire(T))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$je=w;class S{constructor(F,T,z,L){this.f=new O.$Tc;const j=this.f.add(new w),U=this.f.add(new O.$4c);function X(ie){U.set(ie,j.add(L(ie)))}for(const ie of F)X(ie);this.f.add(T(ie=>{X(ie)})),this.f.add(z(ie=>{U.deleteAndDispose(ie)})),this.event=j.event}dispose(){this.f.dispose()}}e.$ke=S;class m{constructor(){this.f=[]}wrapEvent(F,T,z){return(L,j,U)=>F(X=>{const ie=this.f[this.f.length-1];if(!T){ie?ie.buffers.push(()=>L.call(j,X)):L.call(j,X);return}const q=ie;if(!q){L.call(j,T(z,X));return}q.items??=[],q.items.push(X),q.buffers.length===0&&ie.buffers.push(()=>{q.reducedResult??=z?q.items.reduce(T,z):q.items.reduce(T),L.call(j,q.reducedResult)})},void 0,U)}bufferEvents(F){const T={buffers:new Array};this.f.push(T);const z=F();return this.f.pop(),T.buffers.forEach(L=>L()),z}}e.$le=m;class E{constructor(){this.f=!1,this.g=A.None,this.h=O.$Uc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$me=E;class D{static const(F){return new C(F)}constructor(F){this.g=F,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$ne=D;class C{constructor(F){this.value=F,this.onDidChange=A.None}}}),define(Se[22],De([1,0,4]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oe=e.CancellationToken=void 0,e.$pe=b;const N=Object.freeze(function($,k){const A=setTimeout($.bind(k),0);return{dispose(){clearTimeout(A)}}});var O;(function($){function k(A){return A===$.None||A===$.Cancelled||A instanceof R?!0:!A||typeof A!="object"?!1:typeof A.isCancellationRequested=="boolean"&&typeof A.onCancellationRequested=="function"}$.isCancellationToken=k,$.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:h.Event.None}),$.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(O||(e.CancellationToken=O={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new h.$de),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class M{constructor(k){this.f=void 0,this.g=void 0,this.g=k&&k.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=O.Cancelled}dispose(k=!1){k&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=O.None}}e.$oe=M;function b($){const k=new M;return $.add({dispose(){k.cancel()}}),k.token}}),define(Se[173],De([1,0,22]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4e=e.$3e=e.$1e=void 0,e.$2e=O;class N{constructor($){this.b=$,this.a=null}get(){if(this.a)return this.a;const $=new h.$oe,k=this.b($.token);return this.a={promise:k,dispose:()=>{this.a=null,$.cancel(),$.dispose()}},this.a}}e.$1e=N;function O(b){return b}class R{constructor($,k){this.a=void 0,this.b=void 0,typeof $=="function"?(this.c=$,this.d=O):(this.c=k,this.d=$.getCacheKey)}get($){const k=this.d($);return this.b!==k&&(this.b=k,this.a=this.c($)),this.a}}e.$3e=R;class M{get cachedValues(){return this.a}constructor($,k){this.a=new Map,this.b=new Map,typeof $=="function"?(this.c=$,this.d=O):(this.c=k,this.d=$.getCacheKey)}get($){const k=this.d($);if(this.b.has(k))return this.b.get(k);const A=this.c($);return this.a.set($,A),this.b.set(k,A),A}}e.$4e=M}),define(Se[98],De([1,0,13,3]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qe=O,e.$re=R,e.$se=M,e.$te=b,e.$ue=k,e.$ve=A,e.$we=I,e.$xe=p,e.$ye=y,e.$ze=v,e.$Ae=l,e.$Be=d,e.$Ce=o,e.$De=n,e.$Ee=i;function O(u){const s=u;return s?typeof s.read=="function":!1}function R(u){const s=u;return s?[s.on,s.pause,s.resume,s.destroy].every(t=>typeof t=="function"):!1}function M(u){const s=u;return s?R(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}function b(u,s){return new $(u,s)}class ${constructor(s,t){this.e=s,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(t=>t(s))}h(s){this.c.error.length===0?(0,h.$1)(s):this.c.error.slice(0).forEach(t=>t(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,t){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(s,t){if(this.a.destroyed)return;let c;switch(s){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const r=c.indexOf(t);r>=0&&c.splice(r,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(u,s){const t=[];let c;for(;(c=u.read())!==null;)t.push(c);return s(t)}function A(u,s,t){const c=[];let r;for(;(r=u.read())!==null&&c.length<t;)c.push(r);return r===null&&c.length>0?s(c):{read:()=>{if(c.length>0)return c.shift();if(typeof r<"u"){const a=r;return r=void 0,a}return u.read()}}}function I(u,s){return new Promise((t,c)=>{const r=[];p(u,{onData:a=>{s&&r.push(a)},onError:a=>{s?c(a):t(void 0)},onEnd:()=>{t(s?s(r):void 0)}})})}function p(u,s,t){u.on("error",c=>{t?.isCancellationRequested||s.onError(c)}),u.on("end",()=>{t?.isCancellationRequested||s.onEnd()}),u.on("data",c=>{t?.isCancellationRequested||s.onData(c)})}function y(u,s){return new Promise((t,c)=>{const r=new N.$Tc,a=[],f=S=>{if(a.push(S),a.length>s)return r.dispose(),u.pause(),t({stream:u,buffer:a,ended:!1})},g=S=>(r.dispose(),c(S)),w=()=>(r.dispose(),t({stream:u,buffer:a,ended:!0}));r.add((0,N.$Sc)(()=>u.removeListener("error",g))),u.on("error",g),r.add((0,N.$Sc)(()=>u.removeListener("end",w))),u.on("end",w),r.add((0,N.$Sc)(()=>u.removeListener("data",f))),u.on("data",f)})}function v(u,s){const t=b(s);return t.end(u),t}function l(){const u=b(()=>{throw new Error("not supported")});return u.end(),u}function d(u){let s=!1;return{read:()=>s?null:(s=!0,u)}}function o(u,s,t){const c=b(t);return p(u,{onData:r=>c.write(s.data(r)),onError:r=>c.error(s.error?s.error(r):r),onEnd:()=>c.end()}),c}function n(u,s,t){let c=!1;return{read:()=>{const r=s.read();return c?r:(c=!0,r!==null?t([u,r]):u)}}}function i(u,s,t){let c=!1;const r=b(t);return p(s,{onData:a=>c?r.write(a):(c=!0,r.write(t([u,a]))),onError:a=>r.error(a),onEnd:()=>{c||(c=!0,r.write(u)),r.end()}}),r}}),define(Se[21],De([1,0,46,98]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fe=void 0,e.$Ge=k,e.$He=A,e.$Ie=I,e.$Je=p,e.$Ke=y,e.$Le=v,e.$Me=l,e.$Ne=d,e.$Oe=o,e.$Pe=n,e.$Qe=i,e.$Re=u,e.$Se=s,e.$Te=t,e.$Ue=c,e.$Ve=r,e.$We=a,e.$Xe=f,e.$Ye=g,e.$Ze=m;const O=typeof Buffer<"u",R=new h.$V(()=>new Uint8Array(256));let M,b;class ${static alloc(D){return O?new $(Buffer.allocUnsafe(D)):new $(new Uint8Array(D))}static wrap(D){return O&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new $(D)}static fromString(D,C){return!(C?.dontUseNodeBuffer||!1)&&O?new $(Buffer.from(D)):(M||(M=new TextEncoder),new $(M.encode(D)))}static fromByteArray(D){const C=$.alloc(D.length);for(let P=0,F=D.length;P<F;P++)C.buffer[P]=D[P];return C}static concat(D,C){if(typeof C>"u"){C=0;for(let T=0,z=D.length;T<z;T++)C+=D[T].byteLength}const P=$.alloc(C);let F=0;for(let T=0,z=D.length;T<z;T++){const L=D[T];P.set(L,F),F+=L.byteLength}return P}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=$.alloc(this.byteLength);return D.set(this),D}toString(){return O?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(D,C){return new $(this.buffer.subarray(D,C))}set(D,C){if(D instanceof $)this.buffer.set(D.buffer,C);else if(D instanceof Uint8Array)this.buffer.set(D,C);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),C);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return p(this.buffer,D)}writeUInt32BE(D,C){y(this.buffer,D,C)}readUInt32LE(D){return v(this.buffer,D)}writeUInt32LE(D,C){l(this.buffer,D,C)}readUInt8(D){return d(this.buffer,D)}writeUInt8(D,C){o(this.buffer,D,C)}indexOf(D,C=0){return k(this.buffer,D instanceof $?D.buffer:D,C)}}e.$Fe=$;function k(E,D,C=0){const P=D.byteLength,F=E.byteLength;if(P===0)return 0;if(P===1)return E.indexOf(D[0]);if(P>F-C)return-1;const T=R.value;T.fill(D.length);for(let U=0;U<D.length;U++)T[D[U]]=D.length-U-1;let z=C+D.length-1,L=z,j=-1;for(;z<F;)if(E[z]===D[L]){if(L===0){j=z;break}z--,L--}else z+=Math.max(D.length-L,T[E[z]]),L=D.length-1;return j}function A(E,D){return E[D+0]<<0>>>0|E[D+1]<<8>>>0}function I(E,D,C){E[C+0]=D&255,D=D>>>8,E[C+1]=D&255}function p(E,D){return E[D]*2**24+E[D+1]*2**16+E[D+2]*2**8+E[D+3]}function y(E,D,C){E[C+3]=D,D=D>>>8,E[C+2]=D,D=D>>>8,E[C+1]=D,D=D>>>8,E[C]=D}function v(E,D){return E[D+0]<<0>>>0|E[D+1]<<8>>>0|E[D+2]<<16>>>0|E[D+3]<<24>>>0}function l(E,D,C){E[C+0]=D&255,D=D>>>8,E[C+1]=D&255,D=D>>>8,E[C+2]=D&255,D=D>>>8,E[C+3]=D&255}function d(E,D){return E[D]}function o(E,D,C){E[C]=D}function n(E){return N.$ue(E,D=>$.concat(D))}function i(E){return N.$Be(E)}function u(E){return N.$we(E,D=>$.concat(D))}async function s(E){return E.ended?$.concat(E.buffer):$.concat([...E.buffer,await u(E.stream)])}function t(E){return N.$ze(E,D=>$.concat(D))}function c(E){return N.$Ce(E,{data:D=>typeof D=="string"?$.fromString(D):$.wrap(D)},D=>$.concat(D))}function r(E){return N.$te(D=>$.concat(D),E)}function a(E,D){return N.$De(E,D,C=>$.concat(C))}function f(E,D){return N.$Ee(E,D,C=>$.concat(C))}function g(E){let D=0,C=0,P=0;const F=new Uint8Array(Math.floor(E.length/4*3)),T=L=>{switch(C){case 3:F[P++]=D|L,C=0;break;case 2:F[P++]=D|L>>>2,D=L<<6,C=3;break;case 1:F[P++]=D|L>>>4,D=L<<4,C=2;break;default:D=L<<2,C=1}};for(let L=0;L<E.length;L++){const j=E.charCodeAt(L);if(j>=65&&j<=90)T(j-65);else if(j>=97&&j<=122)T(j-97+26);else if(j>=48&&j<=57)T(j-48+52);else if(j===43||j===45)T(62);else if(j===47||j===95)T(63);else{if(j===61)break;throw new SyntaxError(`Unexpected base64 character ${E[L]}`)}}const z=P;for(;C>0;)T(0);return $.wrap(F).slice(0,z)}const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:E},D=!0,C=!1){const P=C?S:w;let F="";const T=E.byteLength%3;let z=0;for(;z<E.byteLength-T;z+=3){const L=E[z+0],j=E[z+1],U=E[z+2];F+=P[L>>>2],F+=P[(L<<4|j>>>4)&63],F+=P[(j<<2|U>>>6)&63],F+=P[U&63]}if(T===1){const L=E[z+0];F+=P[L>>>2],F+=P[L<<4&63],D&&(F+="==")}else if(T===2){const L=E[z+0],j=E[z+1];F+=P[L>>>2],F+=P[(L<<4|j>>>4)&63],F+=P[j<<2&63],D&&(F+="=")}return F}}),define(Se[14],De([1,0,173,46]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=e.$7f=e.$6f=e.GraphemeBreakType=e.$Vf=e.$Nf=e.$Gf=e.$Ff=void 0,e.$7e=O,e.$8e=M,e.$9e=$,e.$0e=k,e.$$e=A,e.$_e=I,e.$af=p,e.$bf=y,e.$cf=v,e.$df=l,e.$ef=d,e.$ff=o,e.$gf=n,e.$hf=i,e.$if=u,e.$jf=s,e.$kf=t,e.$lf=c,e.$mf=r,e.$nf=a,e.$of=f,e.$pf=g,e.$qf=w,e.$rf=S,e.$sf=m,e.$tf=E,e.$uf=D,e.$vf=C,e.$wf=P,e.$xf=F,e.$yf=T,e.$zf=z,e.$Af=L,e.$Bf=j,e.$Cf=U,e.$Df=X,e.$Ef=ie,e.$Hf=ne,e.$If=be,e.$Jf=ae,e.$Kf=Ie,e.$Lf=_,e.$Mf=ue,e.$Of=ce,e.$Pf=oe,e.$Qf=le,e.$Rf=K,e.$Sf=$e,e.$Tf=ve,e.$Uf=ge,e.$Wf=Ae,e.$Xf=Re,e.$Yf=je,e.$Zf=V,e.$1f=W,e.$2f=J,e.$3f=Z,e.$4f=de,e.$5f=tt;function O(Oe){return!Oe||typeof Oe!="string"?!0:Oe.trim().length===0}const R=/{(\d+)}/g;function M(Oe,...Ee){return Ee.length===0?Oe:Oe.replace(R,function(qe,te){const re=parseInt(te,10);return isNaN(re)||re<0||re>=Ee.length?qe:Ee[re]})}const b=/{([^}]+)}/g;function $(Oe,Ee){return Object.keys(Ee).length===0?Oe:Oe.replace(b,(qe,te)=>Ee[te]??qe)}function k(Oe){return Oe.replace(/[<>"'&]/g,Ee=>{switch(Ee){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Ee})}function A(Oe){return Oe.replace(/[<>&]/g,function(Ee){switch(Ee){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ee}})}function I(Oe){return Oe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function p(Oe,Ee){let qe=0,te=Oe.indexOf(Ee);for(;te!==-1;)qe++,te=Oe.indexOf(Ee,te+Ee.length);return qe}function y(Oe,Ee,qe="\u2026"){return Oe.length<=Ee?Oe:`${Oe.substr(0,Ee)}${qe}`}function v(Oe,Ee,qe="\u2026"){if(Oe.length<=Ee)return Oe;const te=Math.ceil(Ee/2)-qe.length/2,re=Math.floor(Ee/2)-qe.length/2;return`${Oe.substr(0,te)}${qe}${Oe.substr(Oe.length-re)}`}function l(Oe,Ee=" "){const qe=d(Oe,Ee);return o(qe,Ee)}function d(Oe,Ee){if(!Oe||!Ee)return Oe;const qe=Ee.length;if(qe===0||Oe.length===0)return Oe;let te=0;for(;Oe.indexOf(Ee,te)===te;)te=te+qe;return Oe.substring(te)}function o(Oe,Ee){if(!Oe||!Ee)return Oe;const qe=Ee.length,te=Oe.length;if(qe===0||te===0)return Oe;let re=te,Ce=-1;for(;Ce=Oe.lastIndexOf(Ee,re-1),!(Ce===-1||Ce+qe!==re);){if(Ce===0)return"";re=Ce}return Oe.substring(0,re)}function n(Oe){return Oe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(Oe){return Oe.replace(/\*/g,"")}function u(Oe,Ee,qe={}){if(!Oe)throw new Error("Cannot create regex from empty string");Ee||(Oe=I(Oe)),qe.wholeWord&&(/\B/.test(Oe.charAt(0))||(Oe="\\b"+Oe),/\B/.test(Oe.charAt(Oe.length-1))||(Oe=Oe+"\\b"));let te="";return qe.global&&(te+="g"),qe.matchCase||(te+="i"),qe.multiline&&(te+="m"),qe.unicode&&(te+="u"),new RegExp(Oe,te)}function s(Oe){return Oe.source==="^"||Oe.source==="^$"||Oe.source==="$"||Oe.source==="^\\s*$"?!1:!!(Oe.exec("")&&Oe.lastIndex===0)}function t(Oe){return Oe.split(/\r\n|\r|\n/)}function c(Oe){const Ee=[],qe=Oe.split(/(\r\n|\r|\n)/);for(let te=0;te<Math.ceil(qe.length/2);te++)Ee.push(qe[2*te]+(qe[2*te+1]??""));return Ee}function r(Oe){for(let Ee=0,qe=Oe.length;Ee<qe;Ee++){const te=Oe.charCodeAt(Ee);if(te!==32&&te!==9)return Ee}return-1}function a(Oe,Ee=0,qe=Oe.length){for(let te=Ee;te<qe;te++){const re=Oe.charCodeAt(te);if(re!==32&&re!==9)return Oe.substring(Ee,te)}return Oe.substring(Ee,qe)}function f(Oe,Ee=Oe.length-1){for(let qe=Ee;qe>=0;qe--){const te=Oe.charCodeAt(qe);if(te!==32&&te!==9)return qe}return-1}function g(Oe,Ee,qe){const te=[];let re=0;for(const Ce of Oe.matchAll(Ee)){if(te.push(Oe.slice(re,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");re=Ce.index+Ce[0].length,te.push(qe(Ce[0],...Ce.slice(1),Ce.index,Oe,Ce.groups))}return te.push(Oe.slice(re)),Promise.all(te).then(Ce=>Ce.join(""))}function w(Oe,Ee){return Oe<Ee?-1:Oe>Ee?1:0}function S(Oe,Ee,qe=0,te=Oe.length,re=0,Ce=Ee.length){for(;qe<te&&re<Ce;qe++,re++){const st=Oe.charCodeAt(qe),lt=Ee.charCodeAt(re);if(st<lt)return-1;if(st>lt)return 1}const Pe=te-qe,Xe=Ce-re;return Pe<Xe?-1:Pe>Xe?1:0}function m(Oe,Ee){return E(Oe,Ee,0,Oe.length,0,Ee.length)}function E(Oe,Ee,qe=0,te=Oe.length,re=0,Ce=Ee.length){for(;qe<te&&re<Ce;qe++,re++){let st=Oe.charCodeAt(qe),lt=Ee.charCodeAt(re);if(st===lt)continue;if(st>=128||lt>=128)return S(Oe.toLowerCase(),Ee.toLowerCase(),qe,te,re,Ce);C(st)&&(st-=32),C(lt)&&(lt-=32);const gt=st-lt;if(gt!==0)return gt}const Pe=te-qe,Xe=Ce-re;return Pe<Xe?-1:Pe>Xe?1:0}function D(Oe){return Oe>=48&&Oe<=57}function C(Oe){return Oe>=97&&Oe<=122}function P(Oe){return Oe>=65&&Oe<=90}function F(Oe,Ee){return Oe.length===Ee.length&&E(Oe,Ee)===0}function T(Oe,Ee){const qe=Ee.length;return Ee.length>Oe.length?!1:E(Oe,Ee,0,qe)===0}function z(Oe,Ee){const qe=Math.min(Oe.length,Ee.length);let te;for(te=0;te<qe;te++)if(Oe.charCodeAt(te)!==Ee.charCodeAt(te))return te;return qe}function L(Oe,Ee){const qe=Math.min(Oe.length,Ee.length);let te;const re=Oe.length-1,Ce=Ee.length-1;for(te=0;te<qe;te++)if(Oe.charCodeAt(re-te)!==Ee.charCodeAt(Ce-te))return te;return qe}function j(Oe){return 55296<=Oe&&Oe<=56319}function U(Oe){return 56320<=Oe&&Oe<=57343}function X(Oe,Ee){return(Oe-55296<<10)+(Ee-56320)+65536}function ie(Oe,Ee,qe){const te=Oe.charCodeAt(qe);if(j(te)&&qe+1<Ee){const re=Oe.charCodeAt(qe+1);if(U(re))return X(te,re)}return te}function q(Oe,Ee){const qe=Oe.charCodeAt(Ee-1);if(U(qe)&&Ee>1){const te=Oe.charCodeAt(Ee-2);if(j(te))return X(te,qe)}return qe}class G{get offset(){return this.e}constructor(Ee,qe=0){this.c=Ee,this.d=Ee.length,this.e=qe}setOffset(Ee){this.e=Ee}prevCodePoint(){const Ee=q(this.c,this.e);return this.e-=Ee>=65536?2:1,Ee}nextCodePoint(){const Ee=ie(this.c,this.d,this.e);return this.e+=Ee>=65536?2:1,Ee}eol(){return this.e>=this.d}}e.$Ff=G;class x{get offset(){return this.c.offset}constructor(Ee,qe=0){this.c=new G(Ee,qe)}nextGraphemeLength(){const Ee=Ve.getInstance(),qe=this.c,te=qe.offset;let re=Ee.getGraphemeBreakType(qe.nextCodePoint());for(;!qe.eol();){const Ce=qe.offset,Pe=Ee.getGraphemeBreakType(qe.nextCodePoint());if(we(re,Pe)){qe.setOffset(Ce);break}re=Pe}return qe.offset-te}prevGraphemeLength(){const Ee=Ve.getInstance(),qe=this.c,te=qe.offset;let re=Ee.getGraphemeBreakType(qe.prevCodePoint());for(;qe.offset>0;){const Ce=qe.offset,Pe=Ee.getGraphemeBreakType(qe.prevCodePoint());if(we(Pe,re)){qe.setOffset(Ce);break}re=Pe}return te-qe.offset}eol(){return this.c.eol()}}e.$Gf=x;function ne(Oe,Ee){return new x(Oe,Ee).nextGraphemeLength()}function be(Oe,Ee){return new x(Oe,Ee).prevGraphemeLength()}function ae(Oe,Ee){Ee>0&&U(Oe.charCodeAt(Ee))&&Ee--;const qe=Ee+ne(Oe,Ee);return[qe-be(Oe,qe),qe]}function Ie(Oe){const Ee=new x(Oe);let qe=0;for(;!Ee.eol();)qe++,Ee.nextGraphemeLength();return qe}let ee;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _(Oe){return ee||(ee=B()),ee.test(Oe)}const pe=/^[\t\n\r\x20-\x7E]*$/;function ue(Oe){return pe.test(Oe)}e.$Nf=/[\u2028\u2029]/;function ce(Oe){return e.$Nf.test(Oe)}function oe(Oe){return Oe>=11904&&Oe<=55215||Oe>=63744&&Oe<=64255||Oe>=65281&&Oe<=65374}function le(Oe){return Oe>=127462&&Oe<=127487||Oe===8986||Oe===8987||Oe===9200||Oe===9203||Oe>=9728&&Oe<=10175||Oe===11088||Oe===11093||Oe>=127744&&Oe<=128591||Oe>=128640&&Oe<=128764||Oe>=128992&&Oe<=129008||Oe>=129280&&Oe<=129535||Oe>=129648&&Oe<=129782}function K(Oe,Ee,qe=""){const te=Oe.trimStart();if(te.length<Ee)return te;const re=/\b/g;let Ce=0;for(;re.test(te)&&!(te.length-re.lastIndex<Ee);)Ce=re.lastIndex,re.lastIndex+=1;return Ce===0?te:qe+te.substring(Ce).trimStart()}const se=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*$e(Oe){let Ee=0;for(const qe of Oe.matchAll(se))Ee!==qe.index&&(yield{isCode:!1,str:Oe.substring(Ee,qe.index)}),yield{isCode:!0,str:qe[0]},Ee=qe.index+qe[0].length;Ee!==Oe.length&&(yield{isCode:!1,str:Oe.substring(Ee)})}function ve(Oe){return Oe&&(Oe=Oe.replace(se,"")),Oe}const Me=/\\\[.*?\\\]/g;function ge(Oe){return ve(Oe).replace(Me,"")}e.$Vf="\uFEFF";function Ae(Oe){return!!(Oe&&Oe.length>0&&Oe.charCodeAt(0)===65279)}function Re(Oe){return Ae(Oe)?Oe.substr(1):Oe}function je(Oe,Ee){if(!Oe||!Ee||Oe.length<Ee.length)return!1;const qe=Ee.length,te=Oe.toLowerCase();let re=0,Ce=-1;for(;re<qe;){const Pe=te.indexOf(Ee[re],Ce+1);if(Pe<0)return!1;Ce=Pe,re++}return!0}function V(Oe,Ee=!1){return Oe?(Ee&&(Oe=Oe.replace(/\\./g,"")),Oe.toLowerCase()!==Oe):!1}function W(Oe){return Oe.charAt(0).toUpperCase()+Oe.slice(1)}function J(Oe,Ee=1){if(Ee===0)return"";let qe=-1;do qe=Oe.indexOf(`
`,qe+1),Ee--;while(Ee>0&&qe>=0);return qe===-1?Oe:(Oe[qe-1]==="\r"&&qe--,Oe.substr(0,qe))}function Z(Oe){return Oe=Oe%(2*26),Oe<26?String.fromCharCode(97+Oe):String.fromCharCode(65+Oe-26)}function de(Oe){return Ve.getInstance().getGraphemeBreakType(Oe)}function we(Oe,Ee){return Oe===0?Ee!==5&&Ee!==7:Oe===2&&Ee===3?!1:Oe===4||Oe===2||Oe===3||Ee===4||Ee===2||Ee===3?!0:!(Oe===8&&(Ee===8||Ee===9||Ee===11||Ee===12)||(Oe===11||Oe===9)&&(Ee===9||Ee===10)||(Oe===12||Oe===10)&&Ee===10||Ee===5||Ee===13||Ee===7||Oe===1||Oe===13&&Ee===14||Oe===6&&Ee===6)}var Fe;(function(Oe){Oe[Oe.Other=0]="Other",Oe[Oe.Prepend=1]="Prepend",Oe[Oe.CR=2]="CR",Oe[Oe.LF=3]="LF",Oe[Oe.Control=4]="Control",Oe[Oe.Extend=5]="Extend",Oe[Oe.Regional_Indicator=6]="Regional_Indicator",Oe[Oe.SpacingMark=7]="SpacingMark",Oe[Oe.L=8]="L",Oe[Oe.V=9]="V",Oe[Oe.T=10]="T",Oe[Oe.LV=11]="LV",Oe[Oe.LVT=12]="LVT",Oe[Oe.ZWJ=13]="ZWJ",Oe[Oe.Extended_Pictographic=14]="Extended_Pictographic"})(Fe||(e.GraphemeBreakType=Fe={}));class Ve{static{this.c=null}static getInstance(){return Ve.c||(Ve.c=new Ve),Ve.c}constructor(){this.d=Ge()}getGraphemeBreakType(Ee){if(Ee<32)return Ee===10?3:Ee===13?2:4;if(Ee<127)return 0;const qe=this.d,te=qe.length/3;let re=1;for(;re<=te;)if(Ee<qe[3*re])re=2*re;else if(Ee>qe[3*re+1])re=2*re+1;else return qe[3*re+2];return 0}}function Ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function tt(Oe,Ee){if(Oe===0)return 0;const qe=_e(Oe,Ee);if(qe!==void 0)return qe;const te=new G(Ee,Oe);return te.prevCodePoint(),te.offset}function _e(Oe,Ee){const qe=new G(Ee,Oe);let te=qe.prevCodePoint();for(;nt(te)||te===65039||te===8419;){if(qe.offset===0)return;te=qe.prevCodePoint()}if(!le(te))return;let re=qe.offset;return re>0&&qe.prevCodePoint()===8205&&(re=qe.offset),re}function nt(Oe){return 127995<=Oe&&Oe<=127999}var rt;(function(Oe){Oe[Oe.zwj=8205]="zwj",Oe[Oe.emojiVariantSelector=65039]="emojiVariantSelector",Oe[Oe.enclosingKeyCap=8419]="enclosingKeyCap"})(rt||(rt={})),e.$6f="\xA0";class it{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new h.$3e({getCacheKey:JSON.stringify},Ee=>{function qe(gt){const It=new Map;for(let Pt=0;Pt<gt.length;Pt+=2)It.set(gt[Pt],gt[Pt+1]);return It}function te(gt,It){const Pt=new Map(gt);for(const[zt,Bt]of It)Pt.set(zt,Bt);return Pt}function re(gt,It){if(!gt)return It;const Pt=new Map;for(const[zt,Bt]of gt)It.has(zt)&&Pt.set(zt,Bt);return Pt}const Ce=this.c.value;let Pe=Ee.filter(gt=>!gt.startsWith("_")&&gt in Ce);Pe.length===0&&(Pe=["_default"]);let Xe;for(const gt of Pe){const It=qe(Ce[gt]);Xe=re(Xe,It)}const st=qe(Ce._common),lt=te(st,Xe);return new it(lt)})}static getInstance(Ee){return it.d.get(Array.from(Ee))}static{this.e=new N.$V(()=>Object.keys(it.c.value).filter(Ee=>!Ee.startsWith("_")))}static getLocales(){return it.e.value}constructor(Ee){this.f=Ee}isAmbiguous(Ee){return this.f.has(Ee)}getPrimaryConfusable(Ee){return this.f.get(Ee)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$7f=it;class ct{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ct.c())),this.d}static isInvisibleCharacter(Ee){return ct.e().has(Ee)}static get codePoints(){return ct.e()}}e.$8f=ct}),define(Se[127],De([1,0,27,168,14]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=e.FuzzyScore=e.$yk=e.$xk=void 0,e.or=R,e.$zk=b,e.$Ak=$,e.$Bk=I,e.$Ck=g,e.$Dk=w,e.$Ek=P,e.$Fk=F,e.$Gk=T,e.$Hk=z,e.$Ik=_,e.$Kk=oe,e.$Lk=se,e.$Mk=$e;function R(...ge){return function(Ae,Re){for(let je=0,V=ge.length;je<V;je++){const W=ge[je](Ae,Re);if(W)return W}return null}}e.$xk=M.bind(void 0,!1),e.$yk=M.bind(void 0,!0);function M(ge,Ae,Re){if(!Re||Re.length<Ae.length)return null;let je;return ge?je=O.$yf(Re,Ae):je=Re.indexOf(Ae)===0,je?Ae.length>0?[{start:0,end:Ae.length}]:[]:null}function b(ge,Ae){const Re=Ae.toLowerCase().indexOf(ge.toLowerCase());return Re===-1?null:[{start:Re,end:Re+ge.length}]}function $(ge,Ae){return k(ge.toLowerCase(),Ae.toLowerCase(),0,0)}function k(ge,Ae,Re,je){if(Re===ge.length)return[];if(je===Ae.length)return null;if(ge[Re]===Ae[je]){let V=null;return(V=k(ge,Ae,Re+1,je+1))?u({start:je,end:je+1},V):null}return k(ge,Ae,Re,je+1)}function A(ge){return 97<=ge&&ge<=122}function I(ge){return 65<=ge&&ge<=90}function p(ge){return 48<=ge&&ge<=57}function y(ge){return ge===32||ge===9||ge===10||ge===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ge=>v.add(ge.charCodeAt(0)));function l(ge){return y(ge)||v.has(ge)}function d(ge,Ae){return ge===Ae||l(ge)&&l(Ae)}const o=new Map;function n(ge){if(o.has(ge))return o.get(ge);let Ae;const Re=(0,N.$vk)(ge);return Re&&(Ae=Re),o.set(ge,Ae),Ae}function i(ge){return A(ge)||I(ge)||p(ge)}function u(ge,Ae){return Ae.length===0?Ae=[ge]:ge.end===Ae[0].start?Ae[0].start=ge.start:Ae.unshift(ge),Ae}function s(ge,Ae){for(let Re=Ae;Re<ge.length;Re++){const je=ge.charCodeAt(Re);if(I(je)||p(je)||Re>0&&!i(ge.charCodeAt(Re-1)))return Re}return ge.length}function t(ge,Ae,Re,je){if(Re===ge.length)return[];if(je===Ae.length)return null;if(ge[Re]!==Ae[je].toLowerCase())return null;{let V=null,W=je+1;for(V=t(ge,Ae,Re+1,je+1);!V&&(W=s(Ae,W))<Ae.length;)V=t(ge,Ae,Re+1,W),W++;return V===null?null:u({start:je,end:je+1},V)}}function c(ge){let Ae=0,Re=0,je=0,V=0,W=0;for(let Fe=0;Fe<ge.length;Fe++)W=ge.charCodeAt(Fe),I(W)&&Ae++,A(W)&&Re++,i(W)&&je++,p(W)&&V++;const J=Ae/ge.length,Z=Re/ge.length,de=je/ge.length,we=V/ge.length;return{upperPercent:J,lowerPercent:Z,alphaPercent:de,numericPercent:we}}function r(ge){const{upperPercent:Ae,lowerPercent:Re}=ge;return Re===0&&Ae>.6}function a(ge){const{upperPercent:Ae,lowerPercent:Re,alphaPercent:je,numericPercent:V}=ge;return Re>.2&&Ae<.8&&je>.6&&V<.2}function f(ge){let Ae=0,Re=0,je=0,V=0;for(let W=0;W<ge.length;W++)je=ge.charCodeAt(W),I(je)&&Ae++,A(je)&&Re++,y(je)&&V++;return(Ae===0||Re===0)&&V===0?ge.length<=30:Ae<=5}function g(ge,Ae){if(!Ae||(Ae=Ae.trim(),Ae.length===0)||!f(ge))return null;Ae.length>60&&(Ae=Ae.substring(0,60));const Re=c(Ae);if(!a(Re)){if(!r(Re))return null;Ae=Ae.toLowerCase()}let je=null,V=0;for(ge=ge.toLowerCase();V<Ae.length&&(je=t(ge,Ae,0,V))===null;)V=s(Ae,V+1);return je}function w(ge,Ae,Re=!1){if(!Ae||Ae.length===0)return null;let je=null,V=0;for(ge=ge.toLowerCase(),Ae=Ae.toLowerCase();V<Ae.length&&(je=S(ge,Ae,0,V,Re),je===null);)V=m(Ae,V+1);return je}function S(ge,Ae,Re,je,V){let W=0;if(Re===ge.length)return[];if(je===Ae.length)return null;if(!d(ge.charCodeAt(Re),Ae.charCodeAt(je))){const de=n(ge.charCodeAt(Re));if(!de)return null;for(let we=0;we<de.length;we++)if(!d(de[we],Ae.charCodeAt(je+we)))return null;W+=de.length-1}let J=null,Z=je+W+1;if(J=S(ge,Ae,Re+1,Z,V),!V)for(;!J&&(Z=m(Ae,Z))<Ae.length;)J=S(ge,Ae,Re+1,Z,V),Z++;if(!J)return null;if(ge.charCodeAt(Re)!==Ae.charCodeAt(je)){const de=n(ge.charCodeAt(Re));if(!de)return J;for(let we=0;we<de.length;we++)if(de[we]!==Ae.charCodeAt(je+we))return J}return u({start:je,end:je+W+1},J)}function m(ge,Ae){for(let Re=Ae;Re<ge.length;Re++)if(l(ge.charCodeAt(Re))||Re>0&&l(ge.charCodeAt(Re-1)))return Re;return ge.length}const E=R(e.$yk,g,b),D=R(e.$yk,g,$),C=new h.$Dc(1e4);function P(ge,Ae,Re=!1){if(typeof ge!="string"||typeof Ae!="string")return null;let je=C.get(ge);je||(je=new RegExp(O.$gf(ge),"i"),C.set(ge,je));const V=je.exec(Ae);return V?[{start:V.index,end:V.index+V[0].length}]:Re?D(ge,Ae):E(ge,Ae)}function F(ge,Ae){const Re=oe(ge,ge.toLowerCase(),0,Ae,Ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Re?z(Re):null}function T(ge,Ae,Re,je,V,W){const J=Math.min(13,ge.length);for(;Re<J;Re++){const Z=oe(ge,Ae,Re,je,V,W,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Z)return Z}return[0,W]}function z(ge){if(typeof ge>"u")return[];const Ae=[],Re=ge[1];for(let je=ge.length-1;je>1;je--){const V=ge[je]+Re,W=Ae[Ae.length-1];W&&W.end===V?W.end=V+1:Ae.push({start:V,end:V+1})}return Ae}const L=128;function j(){const ge=[],Ae=[];for(let Re=0;Re<=L;Re++)Ae[Re]=0;for(let Re=0;Re<=L;Re++)ge.push(Ae.slice(0));return ge}function U(ge){const Ae=[];for(let Re=0;Re<=ge;Re++)Ae[Re]=0;return Ae}const X=U(2*L),ie=U(2*L),q=j(),G=j(),x=j(),ne=!1;function be(ge,Ae,Re,je,V){function W(Z,de,we=" "){for(;Z.length<de;)Z=we+Z;return Z}let J=` |   |${je.split("").map(Z=>W(Z,3)).join("|")}
`;for(let Z=0;Z<=Re;Z++)Z===0?J+=" |":J+=`${Ae[Z-1]}|`,J+=ge[Z].slice(0,V+1).map(de=>W(de.toString(),3)).join("|")+`
`;return J}function ae(ge,Ae,Re,je){ge=ge.substr(Ae),Re=Re.substr(je),console.log(be(G,ge,ge.length,Re,Re.length)),console.log(be(x,ge,ge.length,Re,Re.length)),console.log(be(q,ge,ge.length,Re,Re.length))}function Ie(ge,Ae){if(Ae<0||Ae>=ge.length)return!1;const Re=ge.codePointAt(Ae);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!O.$Qf(Re)}}function ee(ge,Ae){if(Ae<0||Ae>=ge.length)return!1;switch(ge.charCodeAt(Ae)){case 32:case 9:return!0;default:return!1}}function B(ge,Ae,Re){return Ae[ge]!==Re[ge]}function _(ge,Ae,Re,je,V,W,J=!1){for(;Ae<Re&&V<W;)ge[Ae]===je[V]&&(J&&(X[Ae]=V),Ae+=1),V+=1;return Ae===Re}var pe;(function(ge){ge[ge.Diag=1]="Diag",ge[ge.Left=2]="Left",ge[ge.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var ue;(function(ge){ge.Default=[-100,0];function Ae(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}ge.isDefault=Ae})(ue||(e.FuzzyScore=ue={}));class ce{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ae,Re){this.firstMatchCanBeWeak=Ae,this.boostFullMatch=Re}}e.$Jk=ce;function oe(ge,Ae,Re,je,V,W,J=ce.default){const Z=ge.length>L?L:ge.length,de=je.length>L?L:je.length;if(Re>=Z||W>=de||Z-Re>de-W||!_(Ae,Re,Z,V,W,de,!0))return;le(Z,de,Re,W,Ae,V);let we=1,Fe=1,Ve=Re,Ge=W;const tt=[!1];for(we=1,Ve=Re;Ve<Z;we++,Ve++){const ct=X[Ve],Oe=ie[Ve],Ee=Ve+1<Z?ie[Ve+1]:de;for(Fe=ct-W+1,Ge=ct;Ge<Ee;Fe++,Ge++){let qe=Number.MIN_SAFE_INTEGER,te=!1;Ge<=Oe&&(qe=K(ge,Ae,Ve,Re,je,V,Ge,de,W,q[we-1][Fe-1]===0,tt));let re=0;qe!==Number.MAX_SAFE_INTEGER&&(te=!0,re=qe+G[we-1][Fe-1]);const Ce=Ge>ct,Pe=Ce?G[we][Fe-1]+(q[we][Fe-1]>0?-5:0):0,Xe=Ge>ct+1&&q[we][Fe-1]>0,st=Xe?G[we][Fe-2]+(q[we][Fe-2]>0?-5:0):0;if(Xe&&(!Ce||st>=Pe)&&(!te||st>=re))G[we][Fe]=st,x[we][Fe]=3,q[we][Fe]=0;else if(Ce&&(!te||Pe>=re))G[we][Fe]=Pe,x[we][Fe]=2,q[we][Fe]=0;else if(te)G[we][Fe]=re,x[we][Fe]=1,q[we][Fe]=q[we-1][Fe-1]+1;else throw new Error("not possible")}}if(ne&&ae(ge,Re,je,W),!tt[0]&&!J.firstMatchCanBeWeak)return;we--,Fe--;const _e=[G[we][Fe],W];let nt=0,rt=0;for(;we>=1;){let ct=Fe;do{const Oe=x[we][ct];if(Oe===3)ct=ct-2;else if(Oe===2)ct=ct-1;else break}while(ct>=1);nt>1&&Ae[Re+we-1]===V[W+Fe-1]&&!B(ct+W-1,je,V)&&nt+1>q[we][ct]&&(ct=Fe),ct===Fe?nt++:nt=1,rt||(rt=ct),we--,Fe=ct-1,_e.push(Fe)}de-W===Z&&J.boostFullMatch&&(_e[0]+=2);const it=rt-Z;return _e[0]-=it,_e}function le(ge,Ae,Re,je,V,W){let J=ge-1,Z=Ae-1;for(;J>=Re&&Z>=je;)V[J]===W[Z]&&(ie[J]=Z,J--),Z--}function K(ge,Ae,Re,je,V,W,J,Z,de,we,Fe){if(Ae[Re]!==W[J])return Number.MIN_SAFE_INTEGER;let Ve=1,Ge=!1;return J===Re-je?Ve=ge[Re]===V[J]?7:5:B(J,V,W)&&(J===0||!B(J-1,V,W))?(Ve=ge[Re]===V[J]?7:5,Ge=!0):Ie(W,J)&&(J===0||!Ie(W,J-1))?Ve=5:(Ie(W,J-1)||ee(W,J-1))&&(Ve=5,Ge=!0),Ve>1&&Re===je&&(Fe[0]=!0),Ge||(Ge=B(J,V,W)||Ie(W,J-1)||ee(W,J-1)),Re===je?J>de&&(Ve-=Ge?3:5):we?Ve+=Ge?2:0:Ve+=Ge?0:1,J+1===Z&&(Ve-=Ge?3:5),Ve}function se(ge,Ae,Re,je,V,W,J){return ve(ge,Ae,Re,je,V,W,!0,J)}function $e(ge,Ae,Re,je,V,W,J){return ve(ge,Ae,Re,je,V,W,!1,J)}function ve(ge,Ae,Re,je,V,W,J,Z){let de=oe(ge,Ae,Re,je,V,W,Z);if(de&&!J)return de;if(ge.length>=3){const we=Math.min(7,ge.length-1);for(let Fe=Re+1;Fe<we;Fe++){const Ve=Me(ge,Fe);if(Ve){const Ge=oe(Ve,Ve.toLowerCase(),Re,je,V,W,Z);Ge&&(Ge[0]-=3,(!de||Ge[0]>de[0])&&(de=Ge))}}}return de}function Me(ge,Ae){if(Ae+1>=ge.length)return;const Re=ge[Ae],je=ge[Ae+1];if(Re!==je)return ge.slice(0,Ae)+je+Re+ge.slice(Ae+2)}}),define(Se[57],De([1,0,14]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$oj=void 0,e.$kj=N,e.$lj=O,e.$mj=R,e.$nj=b,e.$pj=l;function N(o){return O(o,0)}function O(o,n){switch(typeof o){case"object":return o===null?R(349,n):Array.isArray(o)?$(o,n):k(o,n);case"string":return b(o,n);case"boolean":return M(o,n);case"number":return R(o,n);case"undefined":return R(937,n);default:return R(617,n)}}function R(o,n){return(n<<5)-n+o|0}function M(o,n){return R(o?433:863,n)}function b(o,n){n=R(149417,n);for(let i=0,u=o.length;i<u;i++)n=R(o.charCodeAt(i),n);return n}function $(o,n){return n=R(104579,n),o.reduce((i,u)=>O(u,i),n)}function k(o,n){return n=R(181387,n),Object.keys(o).sort().reduce((i,u)=>(i=b(u,i),O(o[u],i)),n)}class A{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=O(n,this.g),this.g}}e.$oj=A;var I;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function p(o,n,i=32){const u=i-n,s=~((1<<u)-1);return(o<<n|(s&o)>>>u)>>>0}function y(o,n=0,i=o.byteLength,u=0){for(let s=0;s<i;s++)o[n+s]=u}function v(o,n,i="0"){for(;o.length<n;)o=i+o;return o}function l(o,n=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(i=>i.toString(16).padStart(2,"0")).join(""):v((o>>>0).toString(16),n/4)}class d{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const i=n.length;if(i===0)return;const u=this.p;let s=this.r,t=this.u,c,r;for(t!==0?(c=t,r=-1,t=0):(c=n.charCodeAt(0),r=0);;){let a=c;if(h.$Bf(c))if(r+1<i){const f=n.charCodeAt(r+1);h.$Cf(f)?(r++,a=h.$Df(c,f)):a=65533}else{t=c;break}else h.$Cf(c)&&(a=65533);if(s=this.w(u,s,a),r++,r<i)c=n.charCodeAt(r);else break}this.r=s,this.u=t}w(n,i,u){return u<128?n[i++]=u:u<2048?(n[i++]=192|(u&1984)>>>6,n[i++]=128|(u&63)>>>0):u<65536?(n[i++]=224|(u&61440)>>>12,n[i++]=128|(u&4032)>>>6,n[i++]=128|(u&63)>>>0):(n[i++]=240|(u&1835008)>>>18,n[i++]=128|(u&258048)>>>12,n[i++]=128|(u&4032)>>>6,n[i++]=128|(u&63)>>>0),i>=64&&(this.y(),i-=64,this.t+=64,n[0]=n[64],n[1]=n[65],n[2]=n[66]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),l(this.h)+l(this.l)+l(this.m)+l(this.n)+l(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=d.g,i=this.q;for(let w=0;w<64;w+=4)n.setUint32(w,i.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)n.setUint32(w,p(n.getUint32(w-12,!1)^n.getUint32(w-32,!1)^n.getUint32(w-56,!1)^n.getUint32(w-64,!1),1),!1);let u=this.h,s=this.l,t=this.m,c=this.n,r=this.o,a,f,g;for(let w=0;w<80;w++)w<20?(a=s&t|~s&c,f=1518500249):w<40?(a=s^t^c,f=1859775393):w<60?(a=s&t|s&c|t&c,f=2400959708):(a=s^t^c,f=3395469782),g=p(u,5)+a+r+f+n.getUint32(w*4,!1)&4294967295,r=c,c=t,t=p(s,30),s=u,u=g;this.h=this.h+u&4294967295,this.l=this.l+s&4294967295,this.m=this.m+t&4294967295,this.n=this.n+c&4294967295,this.o=this.o+r&4294967295}}e.$qj=d}),define(Se[41],De([1,0,14]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(O){O[O.Ignore=0]="Ignore",O[O.Info=1]="Info",O[O.Warning=2]="Warning",O[O.Error=3]="Error"})(N||(N={})),function(O){const R="error",M="warning",b="warn",$="info",k="ignore";function A(p){return p?h.$xf(R,p)?O.Error:h.$xf(M,p)||h.$xf(b,p)?O.Warning:h.$xf($,p)?O.Info:O.Ignore:O.Ignore}O.fromValue=A;function I(p){switch(p){case O.Error:return R;case O.Warning:return M;case O.Info:return $;default:return k}}O.toString=I}(N||(N={})),e.default=N}),define(Se[174],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=void 0,e.$ae=Symbol("MicrotaskDelay")}),define(Se[78],De([1,0,19,14]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=void 0;class O{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const v=y.charCodeAt(0),l=this.b.charCodeAt(this.c);return v-l}value(){return this.b[this.c]}}e.$yi=O;class R{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,N.$rf)(y,this.b,0,y.length,this.c,this.d):(0,N.$tf)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$zi=R;class M{constructor(y=!0,v=!0){this.f=y,this.g=v}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let v=y.length-1;v>=0;v--,this.c--){const l=this.b.charCodeAt(v);if(!(l===47||this.f&&l===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,N.$rf)(y,this.b,0,y.length,this.d,this.e):(0,N.$tf)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ai=M;var b;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(b||(b={}));class ${constructor(y,v){this.f=y,this.g=v,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,N.$sf)(y,this.c.scheme);if(this.d[this.e]===2)return(0,N.$sf)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,N.$qf)(y,this.c.query);if(this.d[this.e]===5)return(0,N.$qf)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Bi=$;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(A||(A={}));class I{static forUris(y=()=>!1,v=()=>!1){return new I(new $(y,v))}static forPaths(y=!1){return new I(new M(void 0,!y))}static forStrings(){return new I(new O)}static forConfigKeys(){return new I(new R)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,v){if(v){const l=v.slice(0);(0,h.$Wb)(l);for(const d of l)this.set(d,y)}else{const l=y.slice(0);(0,h.$Wb)(l);for(const d of l)this.set(d[0],d[1])}}set(y,v){const l=this.b.reset(y);let d;this.c||(this.c=new k,this.c.segment=l.value());const o=[];for(d=this.c;;){const i=l.cmp(d.segment);if(i>0)d.left||(d.left=new k,d.left.segment=l.value()),o.push([-1,d]),d=d.left;else if(i<0)d.right||(d.right=new k,d.right.segment=l.value()),o.push([1,d]),d=d.right;else if(l.hasNext())l.next(),d.mid||(d.mid=new k,d.mid.segment=l.value()),o.push([0,d]),d=d.mid;else break}const n=d.value;d.value=v,d.key=y;for(let i=o.length-1;i>=0;i--){const u=o[i][1];u.updateHeight();const s=u.balanceFactor();if(s<-1||s>1){const t=o[i][0],c=o[i+1][0];if(t===1&&c===1)o[i][1]=u.rotateLeft();else if(t===-1&&c===-1)o[i][1]=u.rotateRight();else if(t===1&&c===-1)u.right=o[i+1][1]=o[i+1][1].rotateRight(),o[i][1]=u.rotateLeft();else if(t===-1&&c===1)u.left=o[i+1][1]=o[i+1][1].rotateLeft(),o[i][1]=u.rotateRight();else throw new Error;if(i>0)switch(o[i-1][0]){case-1:o[i-1][1].left=o[i][1];break;case 1:o[i-1][1].right=o[i][1];break;case 0:o[i-1][1].mid=o[i][1];break}else this.c=o[0][1]}}return n}get(y){return this.d(y)?.value}d(y){const v=this.b.reset(y);let l=this.c;for(;l;){const d=v.cmp(l.segment);if(d>0)l=l.left;else if(d<0)l=l.right;else if(v.hasNext())v.next(),l=l.mid;else break}return l}has(y){const v=this.d(y);return!(v?.value===void 0&&v?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,v){const l=this.b.reset(y),d=[];let o=this.c;for(;o;){const n=l.cmp(o.segment);if(n>0)d.push([-1,o]),o=o.left;else if(n<0)d.push([1,o]),o=o.right;else if(l.hasNext())l.next(),d.push([0,o]),o=o.mid;else break}if(o){if(v?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const n=this.f(o.right);if(n.key){const{key:i,value:u,segment:s}=n;this.e(n.key,!1),o.key=i,o.value=u,o.segment=s}}else{const n=o.left??o.right;if(d.length>0){const[i,u]=d[d.length-1];switch(i){case-1:u.left=n;break;case 0:u.mid=n;break;case 1:u.right=n;break}}else this.c=n}for(let n=d.length-1;n>=0;n--){const i=d[n][1];i.updateHeight();const u=i.balanceFactor();if(u>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),d[n][1]=i.rotateLeft()):u<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),d[n][1]=i.rotateRight()),n>0)switch(d[n-1][0]){case-1:d[n-1][1].left=d[n][1];break;case 1:d[n-1][1].right=d[n][1];break;case 0:d[n-1][1].mid=d[n][1];break}else this.c=d[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const v=this.b.reset(y);let l=this.c,d;for(;l;){const o=v.cmp(l.segment);if(o>0)l=l.left;else if(o<0)l=l.right;else if(v.hasNext())v.next(),d=l.value||d,l=l.mid;else break}return l&&l.value||d}findSuperstr(y){return this.g(y,!1)}g(y,v){const l=this.b.reset(y);let d=this.c;for(;d;){const o=l.cmp(d.segment);if(o>0)d=d.left;else if(o<0)d=d.right;else if(l.hasNext())l.next(),d=d.mid;else return d.mid?this.h(d.mid):v?d.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[v,l]of this)y(l,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const v=[];return this.j(y,v),v[Symbol.iterator]()}j(y,v){y&&(y.left&&this.j(y.left,v),y.value&&v.push([y.key,y.value]),y.mid&&this.j(y.mid,v),y.right&&this.j(y.right,v))}_isBalanced(){const y=v=>{if(!v)return!0;const l=v.balanceFactor();return l<-1||l>1?!1:y(v.left)&&y(v.right)};return y(this.c)}}e.$Ci=I}),define(Se[18],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9f=h,e.$0f=N,e.$$f=O,e.$_f=R,e.$ag=M,e.$bg=b,e.$cg=$,e.$dg=k,e.$eg=A,e.$fg=I,e.$gg=p,e.$hg=y,e.$ig=v,e.$jg=d,e.$kg=o,e.$lg=n,e.$mg=i,e.$ng=u;function h(s){return typeof s=="string"}function N(s){return Array.isArray(s)&&s.every(t=>h(t))}function O(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function R(s){const t=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof t}function M(s){return typeof s=="number"&&!isNaN(s)}function b(s){return!!s&&typeof s[Symbol.iterator]=="function"}function $(s){return s===!0||s===!1}function k(s){return typeof s>"u"}function A(s){return!I(s)}function I(s){return k(s)||s===null}function p(s,t){if(!s)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function y(s){if(I(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function v(...s){const t=[];for(let c=0;c<s.length;c++){const r=s[c];if(I(r))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);t.push(r)}return t}const l=Object.prototype.hasOwnProperty;function d(s){if(!O(s))return!1;for(const t in s)if(l.call(s,t))return!1;return!0}function o(s){return typeof s=="function"}function n(...s){return s.length>0&&s.every(o)}function i(s,t){const c=Math.min(s.length,t.length);for(let r=0;r<c;r++)u(s[r],t[r])}function u(s,t){if(h(t)){if(typeof s!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(s instanceof t)return}catch{}if(!I(s)&&s.constructor===t||t.length===1&&t.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(Se[99],De([1,0,18]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=O,e.$Rj=R;const N=Object.create(null);function O(M,b){if((0,h.$9f)(b)){const $=N[b];if($===void 0)throw new Error(`${M} references an unknown codicon: ${b}`);b=$}return N[M]=b,{id:M}}function R(){return N}}),define(Se[175],De([1,0,99]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=void 0,e.$Sj={add:(0,h.$Qj)("add",6e4),plus:(0,h.$Qj)("plus",6e4),gistNew:(0,h.$Qj)("gist-new",6e4),repoCreate:(0,h.$Qj)("repo-create",6e4),lightbulb:(0,h.$Qj)("lightbulb",60001),lightBulb:(0,h.$Qj)("light-bulb",60001),repo:(0,h.$Qj)("repo",60002),repoDelete:(0,h.$Qj)("repo-delete",60002),gistFork:(0,h.$Qj)("gist-fork",60003),repoForked:(0,h.$Qj)("repo-forked",60003),gitPullRequest:(0,h.$Qj)("git-pull-request",60004),gitPullRequestAbandoned:(0,h.$Qj)("git-pull-request-abandoned",60004),recordKeys:(0,h.$Qj)("record-keys",60005),keyboard:(0,h.$Qj)("keyboard",60005),tag:(0,h.$Qj)("tag",60006),gitPullRequestLabel:(0,h.$Qj)("git-pull-request-label",60006),tagAdd:(0,h.$Qj)("tag-add",60006),tagRemove:(0,h.$Qj)("tag-remove",60006),person:(0,h.$Qj)("person",60007),personFollow:(0,h.$Qj)("person-follow",60007),personOutline:(0,h.$Qj)("person-outline",60007),personFilled:(0,h.$Qj)("person-filled",60007),gitBranch:(0,h.$Qj)("git-branch",60008),gitBranchCreate:(0,h.$Qj)("git-branch-create",60008),gitBranchDelete:(0,h.$Qj)("git-branch-delete",60008),sourceControl:(0,h.$Qj)("source-control",60008),mirror:(0,h.$Qj)("mirror",60009),mirrorPublic:(0,h.$Qj)("mirror-public",60009),star:(0,h.$Qj)("star",60010),starAdd:(0,h.$Qj)("star-add",60010),starDelete:(0,h.$Qj)("star-delete",60010),starEmpty:(0,h.$Qj)("star-empty",60010),comment:(0,h.$Qj)("comment",60011),commentAdd:(0,h.$Qj)("comment-add",60011),alert:(0,h.$Qj)("alert",60012),warning:(0,h.$Qj)("warning",60012),search:(0,h.$Qj)("search",60013),searchSave:(0,h.$Qj)("search-save",60013),logOut:(0,h.$Qj)("log-out",60014),signOut:(0,h.$Qj)("sign-out",60014),logIn:(0,h.$Qj)("log-in",60015),signIn:(0,h.$Qj)("sign-in",60015),eye:(0,h.$Qj)("eye",60016),eyeUnwatch:(0,h.$Qj)("eye-unwatch",60016),eyeWatch:(0,h.$Qj)("eye-watch",60016),circleFilled:(0,h.$Qj)("circle-filled",60017),primitiveDot:(0,h.$Qj)("primitive-dot",60017),closeDirty:(0,h.$Qj)("close-dirty",60017),debugBreakpoint:(0,h.$Qj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,h.$Qj)("debug-breakpoint-disabled",60017),debugHint:(0,h.$Qj)("debug-hint",60017),terminalDecorationSuccess:(0,h.$Qj)("terminal-decoration-success",60017),primitiveSquare:(0,h.$Qj)("primitive-square",60018),edit:(0,h.$Qj)("edit",60019),pencil:(0,h.$Qj)("pencil",60019),info:(0,h.$Qj)("info",60020),issueOpened:(0,h.$Qj)("issue-opened",60020),gistPrivate:(0,h.$Qj)("gist-private",60021),gitForkPrivate:(0,h.$Qj)("git-fork-private",60021),lock:(0,h.$Qj)("lock",60021),mirrorPrivate:(0,h.$Qj)("mirror-private",60021),close:(0,h.$Qj)("close",60022),removeClose:(0,h.$Qj)("remove-close",60022),x:(0,h.$Qj)("x",60022),repoSync:(0,h.$Qj)("repo-sync",60023),sync:(0,h.$Qj)("sync",60023),clone:(0,h.$Qj)("clone",60024),desktopDownload:(0,h.$Qj)("desktop-download",60024),beaker:(0,h.$Qj)("beaker",60025),microscope:(0,h.$Qj)("microscope",60025),vm:(0,h.$Qj)("vm",60026),deviceDesktop:(0,h.$Qj)("device-desktop",60026),file:(0,h.$Qj)("file",60027),fileText:(0,h.$Qj)("file-text",60027),more:(0,h.$Qj)("more",60028),ellipsis:(0,h.$Qj)("ellipsis",60028),kebabHorizontal:(0,h.$Qj)("kebab-horizontal",60028),mailReply:(0,h.$Qj)("mail-reply",60029),reply:(0,h.$Qj)("reply",60029),organization:(0,h.$Qj)("organization",60030),organizationFilled:(0,h.$Qj)("organization-filled",60030),organizationOutline:(0,h.$Qj)("organization-outline",60030),newFile:(0,h.$Qj)("new-file",60031),fileAdd:(0,h.$Qj)("file-add",60031),newFolder:(0,h.$Qj)("new-folder",60032),fileDirectoryCreate:(0,h.$Qj)("file-directory-create",60032),trash:(0,h.$Qj)("trash",60033),trashcan:(0,h.$Qj)("trashcan",60033),history:(0,h.$Qj)("history",60034),clock:(0,h.$Qj)("clock",60034),folder:(0,h.$Qj)("folder",60035),fileDirectory:(0,h.$Qj)("file-directory",60035),symbolFolder:(0,h.$Qj)("symbol-folder",60035),logoGithub:(0,h.$Qj)("logo-github",60036),markGithub:(0,h.$Qj)("mark-github",60036),github:(0,h.$Qj)("github",60036),terminal:(0,h.$Qj)("terminal",60037),console:(0,h.$Qj)("console",60037),repl:(0,h.$Qj)("repl",60037),zap:(0,h.$Qj)("zap",60038),symbolEvent:(0,h.$Qj)("symbol-event",60038),error:(0,h.$Qj)("error",60039),stop:(0,h.$Qj)("stop",60039),variable:(0,h.$Qj)("variable",60040),symbolVariable:(0,h.$Qj)("symbol-variable",60040),array:(0,h.$Qj)("array",60042),symbolArray:(0,h.$Qj)("symbol-array",60042),symbolModule:(0,h.$Qj)("symbol-module",60043),symbolPackage:(0,h.$Qj)("symbol-package",60043),symbolNamespace:(0,h.$Qj)("symbol-namespace",60043),symbolObject:(0,h.$Qj)("symbol-object",60043),symbolMethod:(0,h.$Qj)("symbol-method",60044),symbolFunction:(0,h.$Qj)("symbol-function",60044),symbolConstructor:(0,h.$Qj)("symbol-constructor",60044),symbolBoolean:(0,h.$Qj)("symbol-boolean",60047),symbolNull:(0,h.$Qj)("symbol-null",60047),symbolNumeric:(0,h.$Qj)("symbol-numeric",60048),symbolNumber:(0,h.$Qj)("symbol-number",60048),symbolStructure:(0,h.$Qj)("symbol-structure",60049),symbolStruct:(0,h.$Qj)("symbol-struct",60049),symbolParameter:(0,h.$Qj)("symbol-parameter",60050),symbolTypeParameter:(0,h.$Qj)("symbol-type-parameter",60050),symbolKey:(0,h.$Qj)("symbol-key",60051),symbolText:(0,h.$Qj)("symbol-text",60051),symbolReference:(0,h.$Qj)("symbol-reference",60052),goToFile:(0,h.$Qj)("go-to-file",60052),symbolEnum:(0,h.$Qj)("symbol-enum",60053),symbolValue:(0,h.$Qj)("symbol-value",60053),symbolRuler:(0,h.$Qj)("symbol-ruler",60054),symbolUnit:(0,h.$Qj)("symbol-unit",60054),activateBreakpoints:(0,h.$Qj)("activate-breakpoints",60055),archive:(0,h.$Qj)("archive",60056),arrowBoth:(0,h.$Qj)("arrow-both",60057),arrowDown:(0,h.$Qj)("arrow-down",60058),arrowLeft:(0,h.$Qj)("arrow-left",60059),arrowRight:(0,h.$Qj)("arrow-right",60060),arrowSmallDown:(0,h.$Qj)("arrow-small-down",60061),arrowSmallLeft:(0,h.$Qj)("arrow-small-left",60062),arrowSmallRight:(0,h.$Qj)("arrow-small-right",60063),arrowSmallUp:(0,h.$Qj)("arrow-small-up",60064),arrowUp:(0,h.$Qj)("arrow-up",60065),bell:(0,h.$Qj)("bell",60066),bold:(0,h.$Qj)("bold",60067),book:(0,h.$Qj)("book",60068),bookmark:(0,h.$Qj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,h.$Qj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,h.$Qj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,h.$Qj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,h.$Qj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,h.$Qj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,h.$Qj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,h.$Qj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,h.$Qj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,h.$Qj)("debug-breakpoint-log-disabled",60075),briefcase:(0,h.$Qj)("briefcase",60076),broadcast:(0,h.$Qj)("broadcast",60077),browser:(0,h.$Qj)("browser",60078),bug:(0,h.$Qj)("bug",60079),calendar:(0,h.$Qj)("calendar",60080),caseSensitive:(0,h.$Qj)("case-sensitive",60081),check:(0,h.$Qj)("check",60082),checklist:(0,h.$Qj)("checklist",60083),chevronDown:(0,h.$Qj)("chevron-down",60084),chevronLeft:(0,h.$Qj)("chevron-left",60085),chevronRight:(0,h.$Qj)("chevron-right",60086),chevronUp:(0,h.$Qj)("chevron-up",60087),chromeClose:(0,h.$Qj)("chrome-close",60088),chromeMaximize:(0,h.$Qj)("chrome-maximize",60089),chromeMinimize:(0,h.$Qj)("chrome-minimize",60090),chromeRestore:(0,h.$Qj)("chrome-restore",60091),circleOutline:(0,h.$Qj)("circle-outline",60092),circle:(0,h.$Qj)("circle",60092),debugBreakpointUnverified:(0,h.$Qj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,h.$Qj)("terminal-decoration-incomplete",60092),circleSlash:(0,h.$Qj)("circle-slash",60093),circuitBoard:(0,h.$Qj)("circuit-board",60094),clearAll:(0,h.$Qj)("clear-all",60095),clippy:(0,h.$Qj)("clippy",60096),closeAll:(0,h.$Qj)("close-all",60097),cloudDownload:(0,h.$Qj)("cloud-download",60098),cloudUpload:(0,h.$Qj)("cloud-upload",60099),code:(0,h.$Qj)("code",60100),collapseAll:(0,h.$Qj)("collapse-all",60101),colorMode:(0,h.$Qj)("color-mode",60102),commentDiscussion:(0,h.$Qj)("comment-discussion",60103),creditCard:(0,h.$Qj)("credit-card",60105),dash:(0,h.$Qj)("dash",60108),dashboard:(0,h.$Qj)("dashboard",60109),database:(0,h.$Qj)("database",60110),debugContinue:(0,h.$Qj)("debug-continue",60111),debugDisconnect:(0,h.$Qj)("debug-disconnect",60112),debugPause:(0,h.$Qj)("debug-pause",60113),debugRestart:(0,h.$Qj)("debug-restart",60114),debugStart:(0,h.$Qj)("debug-start",60115),debugStepInto:(0,h.$Qj)("debug-step-into",60116),debugStepOut:(0,h.$Qj)("debug-step-out",60117),debugStepOver:(0,h.$Qj)("debug-step-over",60118),debugStop:(0,h.$Qj)("debug-stop",60119),debug:(0,h.$Qj)("debug",60120),deviceCameraVideo:(0,h.$Qj)("device-camera-video",60121),deviceCamera:(0,h.$Qj)("device-camera",60122),deviceMobile:(0,h.$Qj)("device-mobile",60123),diffAdded:(0,h.$Qj)("diff-added",60124),diffIgnored:(0,h.$Qj)("diff-ignored",60125),diffModified:(0,h.$Qj)("diff-modified",60126),diffRemoved:(0,h.$Qj)("diff-removed",60127),diffRenamed:(0,h.$Qj)("diff-renamed",60128),diff:(0,h.$Qj)("diff",60129),diffSidebyside:(0,h.$Qj)("diff-sidebyside",60129),discard:(0,h.$Qj)("discard",60130),editorLayout:(0,h.$Qj)("editor-layout",60131),emptyWindow:(0,h.$Qj)("empty-window",60132),exclude:(0,h.$Qj)("exclude",60133),extensions:(0,h.$Qj)("extensions",60134),eyeClosed:(0,h.$Qj)("eye-closed",60135),fileBinary:(0,h.$Qj)("file-binary",60136),fileCode:(0,h.$Qj)("file-code",60137),fileMedia:(0,h.$Qj)("file-media",60138),filePdf:(0,h.$Qj)("file-pdf",60139),fileSubmodule:(0,h.$Qj)("file-submodule",60140),fileSymlinkDirectory:(0,h.$Qj)("file-symlink-directory",60141),fileSymlinkFile:(0,h.$Qj)("file-symlink-file",60142),fileZip:(0,h.$Qj)("file-zip",60143),files:(0,h.$Qj)("files",60144),filter:(0,h.$Qj)("filter",60145),flame:(0,h.$Qj)("flame",60146),foldDown:(0,h.$Qj)("fold-down",60147),foldUp:(0,h.$Qj)("fold-up",60148),fold:(0,h.$Qj)("fold",60149),folderActive:(0,h.$Qj)("folder-active",60150),folderOpened:(0,h.$Qj)("folder-opened",60151),gear:(0,h.$Qj)("gear",60152),gift:(0,h.$Qj)("gift",60153),gistSecret:(0,h.$Qj)("gist-secret",60154),gist:(0,h.$Qj)("gist",60155),gitCommit:(0,h.$Qj)("git-commit",60156),gitCompare:(0,h.$Qj)("git-compare",60157),compareChanges:(0,h.$Qj)("compare-changes",60157),gitMerge:(0,h.$Qj)("git-merge",60158),githubAction:(0,h.$Qj)("github-action",60159),githubAlt:(0,h.$Qj)("github-alt",60160),globe:(0,h.$Qj)("globe",60161),grabber:(0,h.$Qj)("grabber",60162),graph:(0,h.$Qj)("graph",60163),gripper:(0,h.$Qj)("gripper",60164),heart:(0,h.$Qj)("heart",60165),home:(0,h.$Qj)("home",60166),horizontalRule:(0,h.$Qj)("horizontal-rule",60167),hubot:(0,h.$Qj)("hubot",60168),inbox:(0,h.$Qj)("inbox",60169),issueReopened:(0,h.$Qj)("issue-reopened",60171),issues:(0,h.$Qj)("issues",60172),italic:(0,h.$Qj)("italic",60173),jersey:(0,h.$Qj)("jersey",60174),json:(0,h.$Qj)("json",60175),kebabVertical:(0,h.$Qj)("kebab-vertical",60176),key:(0,h.$Qj)("key",60177),law:(0,h.$Qj)("law",60178),lightbulbAutofix:(0,h.$Qj)("lightbulb-autofix",60179),linkExternal:(0,h.$Qj)("link-external",60180),link:(0,h.$Qj)("link",60181),listOrdered:(0,h.$Qj)("list-ordered",60182),listUnordered:(0,h.$Qj)("list-unordered",60183),liveShare:(0,h.$Qj)("live-share",60184),loading:(0,h.$Qj)("loading",60185),location:(0,h.$Qj)("location",60186),mailRead:(0,h.$Qj)("mail-read",60187),mail:(0,h.$Qj)("mail",60188),markdown:(0,h.$Qj)("markdown",60189),megaphone:(0,h.$Qj)("megaphone",60190),mention:(0,h.$Qj)("mention",60191),milestone:(0,h.$Qj)("milestone",60192),gitPullRequestMilestone:(0,h.$Qj)("git-pull-request-milestone",60192),mortarBoard:(0,h.$Qj)("mortar-board",60193),move:(0,h.$Qj)("move",60194),multipleWindows:(0,h.$Qj)("multiple-windows",60195),mute:(0,h.$Qj)("mute",60196),noNewline:(0,h.$Qj)("no-newline",60197),note:(0,h.$Qj)("note",60198),octoface:(0,h.$Qj)("octoface",60199),openPreview:(0,h.$Qj)("open-preview",60200),package:(0,h.$Qj)("package",60201),paintcan:(0,h.$Qj)("paintcan",60202),pin:(0,h.$Qj)("pin",60203),play:(0,h.$Qj)("play",60204),run:(0,h.$Qj)("run",60204),plug:(0,h.$Qj)("plug",60205),preserveCase:(0,h.$Qj)("preserve-case",60206),preview:(0,h.$Qj)("preview",60207),project:(0,h.$Qj)("project",60208),pulse:(0,h.$Qj)("pulse",60209),question:(0,h.$Qj)("question",60210),quote:(0,h.$Qj)("quote",60211),radioTower:(0,h.$Qj)("radio-tower",60212),reactions:(0,h.$Qj)("reactions",60213),references:(0,h.$Qj)("references",60214),refresh:(0,h.$Qj)("refresh",60215),regex:(0,h.$Qj)("regex",60216),remoteExplorer:(0,h.$Qj)("remote-explorer",60217),remote:(0,h.$Qj)("remote",60218),remove:(0,h.$Qj)("remove",60219),replaceAll:(0,h.$Qj)("replace-all",60220),replace:(0,h.$Qj)("replace",60221),repoClone:(0,h.$Qj)("repo-clone",60222),repoForcePush:(0,h.$Qj)("repo-force-push",60223),repoPull:(0,h.$Qj)("repo-pull",60224),repoPush:(0,h.$Qj)("repo-push",60225),report:(0,h.$Qj)("report",60226),requestChanges:(0,h.$Qj)("request-changes",60227),rocket:(0,h.$Qj)("rocket",60228),rootFolderOpened:(0,h.$Qj)("root-folder-opened",60229),rootFolder:(0,h.$Qj)("root-folder",60230),rss:(0,h.$Qj)("rss",60231),ruby:(0,h.$Qj)("ruby",60232),saveAll:(0,h.$Qj)("save-all",60233),saveAs:(0,h.$Qj)("save-as",60234),save:(0,h.$Qj)("save",60235),screenFull:(0,h.$Qj)("screen-full",60236),screenNormal:(0,h.$Qj)("screen-normal",60237),searchStop:(0,h.$Qj)("search-stop",60238),server:(0,h.$Qj)("server",60240),settingsGear:(0,h.$Qj)("settings-gear",60241),settings:(0,h.$Qj)("settings",60242),shield:(0,h.$Qj)("shield",60243),smiley:(0,h.$Qj)("smiley",60244),sortPrecedence:(0,h.$Qj)("sort-precedence",60245),splitHorizontal:(0,h.$Qj)("split-horizontal",60246),splitVertical:(0,h.$Qj)("split-vertical",60247),squirrel:(0,h.$Qj)("squirrel",60248),starFull:(0,h.$Qj)("star-full",60249),starHalf:(0,h.$Qj)("star-half",60250),symbolClass:(0,h.$Qj)("symbol-class",60251),symbolColor:(0,h.$Qj)("symbol-color",60252),symbolConstant:(0,h.$Qj)("symbol-constant",60253),symbolEnumMember:(0,h.$Qj)("symbol-enum-member",60254),symbolField:(0,h.$Qj)("symbol-field",60255),symbolFile:(0,h.$Qj)("symbol-file",60256),symbolInterface:(0,h.$Qj)("symbol-interface",60257),symbolKeyword:(0,h.$Qj)("symbol-keyword",60258),symbolMisc:(0,h.$Qj)("symbol-misc",60259),symbolOperator:(0,h.$Qj)("symbol-operator",60260),symbolProperty:(0,h.$Qj)("symbol-property",60261),wrench:(0,h.$Qj)("wrench",60261),wrenchSubaction:(0,h.$Qj)("wrench-subaction",60261),symbolSnippet:(0,h.$Qj)("symbol-snippet",60262),tasklist:(0,h.$Qj)("tasklist",60263),telescope:(0,h.$Qj)("telescope",60264),textSize:(0,h.$Qj)("text-size",60265),threeBars:(0,h.$Qj)("three-bars",60266),thumbsdown:(0,h.$Qj)("thumbsdown",60267),thumbsup:(0,h.$Qj)("thumbsup",60268),tools:(0,h.$Qj)("tools",60269),triangleDown:(0,h.$Qj)("triangle-down",60270),triangleLeft:(0,h.$Qj)("triangle-left",60271),triangleRight:(0,h.$Qj)("triangle-right",60272),triangleUp:(0,h.$Qj)("triangle-up",60273),twitter:(0,h.$Qj)("twitter",60274),unfold:(0,h.$Qj)("unfold",60275),unlock:(0,h.$Qj)("unlock",60276),unmute:(0,h.$Qj)("unmute",60277),unverified:(0,h.$Qj)("unverified",60278),verified:(0,h.$Qj)("verified",60279),versions:(0,h.$Qj)("versions",60280),vmActive:(0,h.$Qj)("vm-active",60281),vmOutline:(0,h.$Qj)("vm-outline",60282),vmRunning:(0,h.$Qj)("vm-running",60283),watch:(0,h.$Qj)("watch",60284),whitespace:(0,h.$Qj)("whitespace",60285),wholeWord:(0,h.$Qj)("whole-word",60286),window:(0,h.$Qj)("window",60287),wordWrap:(0,h.$Qj)("word-wrap",60288),zoomIn:(0,h.$Qj)("zoom-in",60289),zoomOut:(0,h.$Qj)("zoom-out",60290),listFilter:(0,h.$Qj)("list-filter",60291),listFlat:(0,h.$Qj)("list-flat",60292),listSelection:(0,h.$Qj)("list-selection",60293),selection:(0,h.$Qj)("selection",60293),listTree:(0,h.$Qj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,h.$Qj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,h.$Qj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,h.$Qj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,h.$Qj)("debug-stackframe-active",60297),circleSmallFilled:(0,h.$Qj)("circle-small-filled",60298),debugStackframeDot:(0,h.$Qj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,h.$Qj)("terminal-decoration-mark",60298),debugStackframe:(0,h.$Qj)("debug-stackframe",60299),debugStackframeFocused:(0,h.$Qj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,h.$Qj)("debug-breakpoint-unsupported",60300),symbolString:(0,h.$Qj)("symbol-string",60301),debugReverseContinue:(0,h.$Qj)("debug-reverse-continue",60302),debugStepBack:(0,h.$Qj)("debug-step-back",60303),debugRestartFrame:(0,h.$Qj)("debug-restart-frame",60304),debugAlt:(0,h.$Qj)("debug-alt",60305),callIncoming:(0,h.$Qj)("call-incoming",60306),callOutgoing:(0,h.$Qj)("call-outgoing",60307),menu:(0,h.$Qj)("menu",60308),expandAll:(0,h.$Qj)("expand-all",60309),feedback:(0,h.$Qj)("feedback",60310),gitPullRequestReviewer:(0,h.$Qj)("git-pull-request-reviewer",60310),groupByRefType:(0,h.$Qj)("group-by-ref-type",60311),ungroupByRefType:(0,h.$Qj)("ungroup-by-ref-type",60312),account:(0,h.$Qj)("account",60313),gitPullRequestAssignee:(0,h.$Qj)("git-pull-request-assignee",60313),bellDot:(0,h.$Qj)("bell-dot",60314),debugConsole:(0,h.$Qj)("debug-console",60315),library:(0,h.$Qj)("library",60316),output:(0,h.$Qj)("output",60317),runAll:(0,h.$Qj)("run-all",60318),syncIgnored:(0,h.$Qj)("sync-ignored",60319),pinned:(0,h.$Qj)("pinned",60320),githubInverted:(0,h.$Qj)("github-inverted",60321),serverProcess:(0,h.$Qj)("server-process",60322),serverEnvironment:(0,h.$Qj)("server-environment",60323),pass:(0,h.$Qj)("pass",60324),issueClosed:(0,h.$Qj)("issue-closed",60324),stopCircle:(0,h.$Qj)("stop-circle",60325),playCircle:(0,h.$Qj)("play-circle",60326),record:(0,h.$Qj)("record",60327),debugAltSmall:(0,h.$Qj)("debug-alt-small",60328),vmConnect:(0,h.$Qj)("vm-connect",60329),cloud:(0,h.$Qj)("cloud",60330),merge:(0,h.$Qj)("merge",60331),export:(0,h.$Qj)("export",60332),graphLeft:(0,h.$Qj)("graph-left",60333),magnet:(0,h.$Qj)("magnet",60334),notebook:(0,h.$Qj)("notebook",60335),redo:(0,h.$Qj)("redo",60336),checkAll:(0,h.$Qj)("check-all",60337),pinnedDirty:(0,h.$Qj)("pinned-dirty",60338),passFilled:(0,h.$Qj)("pass-filled",60339),circleLargeFilled:(0,h.$Qj)("circle-large-filled",60340),circleLarge:(0,h.$Qj)("circle-large",60341),circleLargeOutline:(0,h.$Qj)("circle-large-outline",60341),combine:(0,h.$Qj)("combine",60342),gather:(0,h.$Qj)("gather",60342),table:(0,h.$Qj)("table",60343),variableGroup:(0,h.$Qj)("variable-group",60344),typeHierarchy:(0,h.$Qj)("type-hierarchy",60345),typeHierarchySub:(0,h.$Qj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,h.$Qj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,h.$Qj)("git-pull-request-create",60348),runAbove:(0,h.$Qj)("run-above",60349),runBelow:(0,h.$Qj)("run-below",60350),notebookTemplate:(0,h.$Qj)("notebook-template",60351),debugRerun:(0,h.$Qj)("debug-rerun",60352),workspaceTrusted:(0,h.$Qj)("workspace-trusted",60353),workspaceUntrusted:(0,h.$Qj)("workspace-untrusted",60354),workspaceUnknown:(0,h.$Qj)("workspace-unknown",60355),terminalCmd:(0,h.$Qj)("terminal-cmd",60356),terminalDebian:(0,h.$Qj)("terminal-debian",60357),terminalLinux:(0,h.$Qj)("terminal-linux",60358),terminalPowershell:(0,h.$Qj)("terminal-powershell",60359),terminalTmux:(0,h.$Qj)("terminal-tmux",60360),terminalUbuntu:(0,h.$Qj)("terminal-ubuntu",60361),terminalBash:(0,h.$Qj)("terminal-bash",60362),arrowSwap:(0,h.$Qj)("arrow-swap",60363),copy:(0,h.$Qj)("copy",60364),personAdd:(0,h.$Qj)("person-add",60365),filterFilled:(0,h.$Qj)("filter-filled",60366),wand:(0,h.$Qj)("wand",60367),debugLineByLine:(0,h.$Qj)("debug-line-by-line",60368),inspect:(0,h.$Qj)("inspect",60369),layers:(0,h.$Qj)("layers",60370),layersDot:(0,h.$Qj)("layers-dot",60371),layersActive:(0,h.$Qj)("layers-active",60372),compass:(0,h.$Qj)("compass",60373),compassDot:(0,h.$Qj)("compass-dot",60374),compassActive:(0,h.$Qj)("compass-active",60375),azure:(0,h.$Qj)("azure",60376),issueDraft:(0,h.$Qj)("issue-draft",60377),gitPullRequestClosed:(0,h.$Qj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,h.$Qj)("git-pull-request-draft",60379),debugAll:(0,h.$Qj)("debug-all",60380),debugCoverage:(0,h.$Qj)("debug-coverage",60381),runErrors:(0,h.$Qj)("run-errors",60382),folderLibrary:(0,h.$Qj)("folder-library",60383),debugContinueSmall:(0,h.$Qj)("debug-continue-small",60384),beakerStop:(0,h.$Qj)("beaker-stop",60385),graphLine:(0,h.$Qj)("graph-line",60386),graphScatter:(0,h.$Qj)("graph-scatter",60387),pieChart:(0,h.$Qj)("pie-chart",60388),bracket:(0,h.$Qj)("bracket",60175),bracketDot:(0,h.$Qj)("bracket-dot",60389),bracketError:(0,h.$Qj)("bracket-error",60390),lockSmall:(0,h.$Qj)("lock-small",60391),azureDevops:(0,h.$Qj)("azure-devops",60392),verifiedFilled:(0,h.$Qj)("verified-filled",60393),newline:(0,h.$Qj)("newline",60394),layout:(0,h.$Qj)("layout",60395),layoutActivitybarLeft:(0,h.$Qj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,h.$Qj)("layout-activitybar-right",60397),layoutPanelLeft:(0,h.$Qj)("layout-panel-left",60398),layoutPanelCenter:(0,h.$Qj)("layout-panel-center",60399),layoutPanelJustify:(0,h.$Qj)("layout-panel-justify",60400),layoutPanelRight:(0,h.$Qj)("layout-panel-right",60401),layoutPanel:(0,h.$Qj)("layout-panel",60402),layoutSidebarLeft:(0,h.$Qj)("layout-sidebar-left",60403),layoutSidebarRight:(0,h.$Qj)("layout-sidebar-right",60404),layoutStatusbar:(0,h.$Qj)("layout-statusbar",60405),layoutMenubar:(0,h.$Qj)("layout-menubar",60406),layoutCentered:(0,h.$Qj)("layout-centered",60407),target:(0,h.$Qj)("target",60408),indent:(0,h.$Qj)("indent",60409),recordSmall:(0,h.$Qj)("record-small",60410),errorSmall:(0,h.$Qj)("error-small",60411),terminalDecorationError:(0,h.$Qj)("terminal-decoration-error",60411),arrowCircleDown:(0,h.$Qj)("arrow-circle-down",60412),arrowCircleLeft:(0,h.$Qj)("arrow-circle-left",60413),arrowCircleRight:(0,h.$Qj)("arrow-circle-right",60414),arrowCircleUp:(0,h.$Qj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,h.$Qj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,h.$Qj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,h.$Qj)("layout-sidebar-left-off",60418),blank:(0,h.$Qj)("blank",60419),heartFilled:(0,h.$Qj)("heart-filled",60420),map:(0,h.$Qj)("map",60421),mapHorizontal:(0,h.$Qj)("map-horizontal",60421),foldHorizontal:(0,h.$Qj)("fold-horizontal",60421),mapFilled:(0,h.$Qj)("map-filled",60422),mapHorizontalFilled:(0,h.$Qj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,h.$Qj)("fold-horizontal-filled",60422),circleSmall:(0,h.$Qj)("circle-small",60423),bellSlash:(0,h.$Qj)("bell-slash",60424),bellSlashDot:(0,h.$Qj)("bell-slash-dot",60425),commentUnresolved:(0,h.$Qj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,h.$Qj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,h.$Qj)("git-pull-request-new-changes",60428),searchFuzzy:(0,h.$Qj)("search-fuzzy",60429),commentDraft:(0,h.$Qj)("comment-draft",60430),send:(0,h.$Qj)("send",60431),sparkle:(0,h.$Qj)("sparkle",60432),insert:(0,h.$Qj)("insert",60433),mic:(0,h.$Qj)("mic",60434),thumbsdownFilled:(0,h.$Qj)("thumbsdown-filled",60435),thumbsupFilled:(0,h.$Qj)("thumbsup-filled",60436),coffee:(0,h.$Qj)("coffee",60437),snake:(0,h.$Qj)("snake",60438),game:(0,h.$Qj)("game",60439),vr:(0,h.$Qj)("vr",60440),chip:(0,h.$Qj)("chip",60441),piano:(0,h.$Qj)("piano",60442),music:(0,h.$Qj)("music",60443),micFilled:(0,h.$Qj)("mic-filled",60444),repoFetch:(0,h.$Qj)("repo-fetch",60445),copilot:(0,h.$Qj)("copilot",60446),lightbulbSparkle:(0,h.$Qj)("lightbulb-sparkle",60447),robot:(0,h.$Qj)("robot",60448),sparkleFilled:(0,h.$Qj)("sparkle-filled",60449),diffSingle:(0,h.$Qj)("diff-single",60450),diffMultiple:(0,h.$Qj)("diff-multiple",60451),surroundWith:(0,h.$Qj)("surround-with",60452),share:(0,h.$Qj)("share",60453),gitStash:(0,h.$Qj)("git-stash",60454),gitStashApply:(0,h.$Qj)("git-stash-apply",60455),gitStashPop:(0,h.$Qj)("git-stash-pop",60456),vscode:(0,h.$Qj)("vscode",60457),vscodeInsiders:(0,h.$Qj)("vscode-insiders",60458),codeOss:(0,h.$Qj)("code-oss",60459),runCoverage:(0,h.$Qj)("run-coverage",60460),runAllCoverage:(0,h.$Qj)("run-all-coverage",60461),coverage:(0,h.$Qj)("coverage",60462),githubProject:(0,h.$Qj)("github-project",60463),mapVertical:(0,h.$Qj)("map-vertical",60464),foldVertical:(0,h.$Qj)("fold-vertical",60464),mapVerticalFilled:(0,h.$Qj)("map-vertical-filled",60465),foldVerticalFilled:(0,h.$Qj)("fold-vertical-filled",60465),goToSearch:(0,h.$Qj)("go-to-search",60466),percentage:(0,h.$Qj)("percentage",60467),sortPercentage:(0,h.$Qj)("sort-percentage",60467)}}),define(Se[79],De([1,0,99,175]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=void 0,e.$Tj=O;function O(){return Object.values(e.$Vj)}e.$Uj={dialogError:(0,h.$Qj)("dialog-error","error"),dialogWarning:(0,h.$Qj)("dialog-warning","warning"),dialogInfo:(0,h.$Qj)("dialog-info","info"),dialogClose:(0,h.$Qj)("dialog-close","close"),treeItemExpanded:(0,h.$Qj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,h.$Qj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,h.$Qj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,h.$Qj)("tree-filter-clear","close"),treeItemLoading:(0,h.$Qj)("tree-item-loading","loading"),menuSelection:(0,h.$Qj)("menu-selection","check"),menuSubmenu:(0,h.$Qj)("menu-submenu","chevron-right"),menuBarMore:(0,h.$Qj)("menubar-more","more"),scrollbarButtonLeft:(0,h.$Qj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,h.$Qj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,h.$Qj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,h.$Qj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,h.$Qj)("toolbar-more","more"),quickInputBack:(0,h.$Qj)("quick-input-back","arrow-left"),dropDownButton:(0,h.$Qj)("drop-down-button",60084),symbolCustomColor:(0,h.$Qj)("symbol-customcolor",60252),exportIcon:(0,h.$Qj)("export",60332),workspaceUnspecified:(0,h.$Qj)("workspace-unspecified",60355),newLine:(0,h.$Qj)("newline",60394),thumbsDownFilled:(0,h.$Qj)("thumbsdown-filled",60435),thumbsUpFilled:(0,h.$Qj)("thumbsup-filled",60436),gitFetch:(0,h.$Qj)("git-fetch",60445),lightbulbSparkleAutofix:(0,h.$Qj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,h.$Qj)("debug-breakpoint-pending",60377)},e.$Vj={...N.$Sj,...e.$Uj}}),define(Se[24],De([1,0,18]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=N,e.$4n=O,e.$5n=M,e.$6n=$,e.$7n=k,e.$8n=A,e.$9n=I,e.$0n=p,e.$$n=y,e.$_n=v,e.$ao=l,e.$bo=d;function N(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const n=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([i,u])=>{n[i]=u&&typeof u=="object"?N(u):u}),n}function O(o){if(!o||typeof o!="object")return o;const n=[o];for(;n.length>0;){const i=n.shift();Object.freeze(i);for(const u in i)if(R.call(i,u)){const s=i[u];typeof s=="object"&&!Object.isFrozen(s)&&!(0,h.$_f)(s)&&n.push(s)}}return o}const R=Object.prototype.hasOwnProperty;function M(o,n){return b(o,n,new Set)}function b(o,n,i){if((0,h.$fg)(o))return o;const u=n(o);if(typeof u<"u")return u;if(Array.isArray(o)){const s=[];for(const t of o)s.push(b(t,n,i));return s}if((0,h.$$f)(o)){if(i.has(o))throw new Error("Cannot clone recursive data-structure");i.add(o);const s={};for(const t in o)R.call(o,t)&&(s[t]=b(o[t],n,i));return i.delete(o),s}return o}function $(o,n,i=!0){return(0,h.$$f)(o)?((0,h.$$f)(n)&&Object.keys(n).forEach(u=>{u in o?i&&((0,h.$$f)(o[u])&&(0,h.$$f)(n[u])?$(o[u],n[u],i):o[u]=n[u]):o[u]=n[u]}),o):n}function k(o,n){if(o===n)return!0;if(o==null||n===null||n===void 0||typeof o!=typeof n||typeof o!="object"||Array.isArray(o)!==Array.isArray(n))return!1;let i,u;if(Array.isArray(o)){if(o.length!==n.length)return!1;for(i=0;i<o.length;i++)if(!k(o[i],n[i]))return!1}else{const s=[];for(u in o)s.push(u);s.sort();const t=[];for(u in n)t.push(u);if(t.sort(),!k(s,t))return!1;for(i=0;i<s.length;i++)if(!k(o[s[i]],n[s[i]]))return!1}return!0}function A(o){const n=new Set;return JSON.stringify(o,(i,u)=>{if((0,h.$$f)(u)||Array.isArray(u)){if(n.has(u))return"[Circular]";n.add(u)}return typeof u=="bigint"?`[BigInt ${u.toString()}]`:u})}function I(o,n){const i=Object.create(null);return!o||!n||Object.keys(n).forEach(s=>{const t=o[s],c=n[s];k(t,c)||(i[s]=c)}),i}function p(o,n){const i=n.toLowerCase(),u=Object.keys(o).find(s=>s.toLowerCase()===i);return u?o[u]:o[n]}function y(o,n){const i=Object.create(null);for(const[u,s]of Object.entries(o))n(u,s)&&(i[u]=s);return i}function v(o){let n=[];for(;Object.prototype!==o;)n=n.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return n}function l(o){const n=[];for(const i of v(o))typeof o[i]=="function"&&n.push(i);return n}function d(o,n){const i=s=>function(){const t=Array.prototype.slice.call(arguments,0);return n(s,t)},u={};for(const s of o)u[s]=i(s);return u}}),define(Se[50],De([1,0,79]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Wj=O;var N;(function(M){function b($){return $&&typeof $=="object"&&typeof $.id=="string"}M.isThemeColor=b})(N||(e.ThemeColor=N={}));function O(M){return{id:M}}var R;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function $(n){const i=b.exec(n.id);if(!i)return $(h.$Vj.error);const[,u,s]=i,t=["codicon","codicon-"+u];return s&&t.push("codicon-modifier-"+s.substring(1)),t}M.asClassNameArray=$;function k(n){return $(n).join(" ")}M.asClassName=k;function A(n){return"."+$(n).join(".")}M.asCSSSelector=A;function I(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||N.isThemeColor(n.color))}M.isThemeIcon=I;const p=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function y(n){const i=p.exec(n);if(!i)return;const[,u]=i;return{id:u}}M.fromString=y;function v(n){return{id:n}}M.fromId=v;function l(n,i){let u=n.id;const s=u.lastIndexOf("~");return s!==-1&&(u=u.substring(0,s)),i&&(u=`${u}~${i}`),{id:u}}M.modify=l;function d(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}M.getModifier=d;function o(n,i){return n.id===i.id&&n.color?.id===i.color?.id}M.isEqual=o})(R||(e.ThemeIcon=R={}))}),define(Se[176],De([1,0,127,14,50]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=$,e.$Ok=A,e.$Pk=p,e.$Qk=y,e.$Rk=l,e.$Sk=d;const R="$(",M=new RegExp(`\\$\\(${O.ThemeIcon.iconNameExpression}(?:${O.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${M.source}`,"g");function $(o){return o.replace(b,(n,i)=>i?n:`\\${n}`)}const k=new RegExp(`\\\\${M.source}`,"g");function A(o){return o.replace(k,n=>`\\${n}`)}const I=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function p(o){return o.indexOf(R)===-1?o:o.replace(I,(n,i,u,s)=>u?n:i||s||"")}function y(o){return o?o.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const v=new RegExp(`\\$\\(${O.ThemeIcon.iconNameCharacter}+\\)`,"g");function l(o){v.lastIndex=0;let n="";const i=[];let u=0;for(;;){const s=v.lastIndex,t=v.exec(o),c=o.substring(s,t?.index);if(c.length>0){n+=c;for(let r=0;r<c.length;r++)i.push(u)}if(!t)break;u+=t[0].length}return{text:n,iconOffsets:i}}function d(o,n,i=!1){const{text:u,iconOffsets:s}=n;if(!s||s.length===0)return(0,h.$Ek)(o,u,i);const t=(0,N.$ef)(u," "),c=u.length-t.length,r=(0,h.$Ek)(o,t,i);if(r)for(const a of r){const f=s[a.start+c]+c;a.start+=f,a.end+=f}return r}}),define(Se[128],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$5e=N,e.$6e=O;var h;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(h||(e.Constants=h={}));function N(R){return R<0?0:R>255?255:R|0}function O(R){return R<0?0:R>4294967295?4294967295:R|0}}),define(Se[30],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=void 0,e.$Rg=N;const h=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(O){return h.test(O)}e.$Sg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let O;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?O=crypto.getRandomValues.bind(crypto):O=function(b){for(let $=0;$<b.length;$++)b[$]=Math.floor(Math.random()*256);return b};const R=new Uint8Array(16),M=[];for(let b=0;b<256;b++)M.push(b.toString(16).padStart(2,"0"));return function(){O(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let $=0,k="";return k+=M[R[$++]],k+=M[R[$++]],k+=M[R[$++]],k+=M[R[$++]],k+="-",k+=M[R[$++]],k+=M[R[$++]],k+="-",k+=M[R[$++]],k+=M[R[$++]],k+="-",k+=M[R[$++]],k+=M[R[$++]],k+="-",k+=M[R[$++]],k+=M[R[$++]],k+=M[R[$++]],k+=M[R[$++]],k+=M[R[$++]],k+=M[R[$++]],k}}()}),define(Se[177],De([1,0,19,39,30]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=e.$St=void 0,e.$Qt=R,e.$Rt=M,e.$Tt=k;function R(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}function M(I,p,y){const v={id:(0,O.$Sg)(),name:I,uri:p,data:y};return{asString:async()=>"",asFile:()=>v,value:void 0}}class b{constructor(){this.a=new Map}get size(){let p=0;for(const y of this.a)p++;return p}has(p){return this.a.has(this.b(p))}matches(p){const y=[...this.a.keys()];return N.Iterable.some(this,([v,l])=>l.asFile())&&y.push("files"),A($(p),y)}get(p){return this.a.get(this.b(p))?.[0]}append(p,y){const v=this.a.get(p);v?v.push(y):this.a.set(this.b(p),[y])}replace(p,y){this.a.set(this.b(p),[y])}delete(p){this.a.delete(this.b(p))}*[Symbol.iterator](){for(const[p,y]of this.a)for(const v of y)yield[p,v]}b(p){return $(p)}}e.$St=b;function $(I){return I.toLowerCase()}function k(I,p){return A($(I),p.map($))}function A(I,p){if(I==="*/*")return p.length>0;if(p.includes(I))return!0;const y=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[v,l,d]=y;return d==="*"?p.some(o=>o.startsWith(l+"/")):!1}e.$Ut=Object.freeze({create:I=>(0,h.$Mb)(I.map(p=>p.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$Ut.split(I).filter(p=>!p.startsWith("#"))})}),define(Se[178],De([1,0,63]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=void 0,e.$Ug=N,e.$Wg=R;function N(b,$,k,A=1){let I=!1;return new Promise(p=>{const y=setTimeout(()=>{if(!I)return I=!0,p(0)},k);O(b,$,A,v=>{if(!I)return I=!0,clearTimeout(y),p(v)})})}function O(b,$,k,A){if($===0)return A(0);const I=new h.Socket;I.once("connect",()=>(M(I),O(b+k,$-1,k,A))),I.once("data",()=>{}),I.once("error",p=>(M(I),p.code!=="ECONNREFUSED"?O(b+k,$-1,k,A):A(b))),I.connect(b,"127.0.0.1")}e.$Vg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(b,$,k,A="127.0.0.1"){let I=!1,p,y=1;const v=h.createServer({pauseOnConnect:!0});function l(d,o){I||(I=!0,v.removeAllListeners(),v.close(),p&&clearTimeout(p),o(d))}return new Promise(d=>{p=setTimeout(()=>{l(0,d)},k),v.on("listening",()=>{l(b,d)}),v.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&y<$?(b++,y++,v.listen(b,A)):l(0,d)}),v.on("close",()=>{l(0,d)}),v.listen(b,A)})}function M(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch($){console.error($)}}}),define(Se[129],De([1,0,128]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jt=e.$It=void 0;class N{constructor(b){const $=(0,h.$5e)(b);this.c=$,this.a=N.d($),this.b=new Map}static d(b){const $=new Uint8Array(256);return $.fill(b),$}set(b,$){const k=(0,h.$5e)($);b>=0&&b<256?this.a[b]=k:this.b.set(b,k)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$It=N;var O;(function(M){M[M.False=0]="False",M[M.True=1]="True"})(O||(O={}));class R{constructor(){this.a=new N(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$Jt=R}),define(Se[179],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$1t=N;var h;(function(O){O[O.Unknown=0]="Unknown",O[O.Invalid=3]="Invalid",O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(h||(e.StringEOL=h={}));function N(O){let R=0,M=0,b=0,$=0;for(let k=0,A=O.length;k<A;k++){const I=O.charCodeAt(k);I===13?(R===0&&(M=k),R++,k+1<A&&O.charCodeAt(k+1)===10?($|=2,k++):$|=3,b=k+1):I===10&&($|=1,R===0&&(M=k),R++,b=k+1)}return R===0&&(M=O.length),[R,M,O.length-b,$]}}),define(Se[51],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=void 0;class h{constructor(O,R){this.lineNumber=O,this.column=R}with(O=this.lineNumber,R=this.column){return O===this.lineNumber&&R===this.column?this:new h(O,R)}delta(O=0,R=0){return this.with(this.lineNumber+O,this.column+R)}equals(O){return h.equals(this,O)}static equals(O,R){return!O&&!R?!0:!!O&&!!R&&O.lineNumber===R.lineNumber&&O.column===R.column}isBefore(O){return h.isBefore(this,O)}static isBefore(O,R){return O.lineNumber<R.lineNumber?!0:R.lineNumber<O.lineNumber?!1:O.column<R.column}isBeforeOrEqual(O){return h.isBeforeOrEqual(this,O)}static isBeforeOrEqual(O,R){return O.lineNumber<R.lineNumber?!0:R.lineNumber<O.lineNumber?!1:O.column<=R.column}static compare(O,R){const M=O.lineNumber|0,b=R.lineNumber|0;if(M===b){const $=O.column|0,k=R.column|0;return $-k}return M-b}clone(){return new h(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(O){return new h(O.lineNumber,O.column)}static isIPosition(O){return O&&typeof O.lineNumber=="number"&&typeof O.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$tt=h}),define(Se[29],De([1,0,51]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=void 0;class N{constructor(R,M,b,$){R>b||R===b&&M>$?(this.startLineNumber=b,this.startColumn=$,this.endLineNumber=R,this.endColumn=M):(this.startLineNumber=R,this.startColumn=M,this.endLineNumber=b,this.endColumn=$)}isEmpty(){return N.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return N.containsPosition(this,R)}static containsPosition(R,M){return!(M.lineNumber<R.startLineNumber||M.lineNumber>R.endLineNumber||M.lineNumber===R.startLineNumber&&M.column<R.startColumn||M.lineNumber===R.endLineNumber&&M.column>R.endColumn)}static strictContainsPosition(R,M){return!(M.lineNumber<R.startLineNumber||M.lineNumber>R.endLineNumber||M.lineNumber===R.startLineNumber&&M.column<=R.startColumn||M.lineNumber===R.endLineNumber&&M.column>=R.endColumn)}containsRange(R){return N.containsRange(this,R)}static containsRange(R,M){return!(M.startLineNumber<R.startLineNumber||M.endLineNumber<R.startLineNumber||M.startLineNumber>R.endLineNumber||M.endLineNumber>R.endLineNumber||M.startLineNumber===R.startLineNumber&&M.startColumn<R.startColumn||M.endLineNumber===R.endLineNumber&&M.endColumn>R.endColumn)}strictContainsRange(R){return N.strictContainsRange(this,R)}static strictContainsRange(R,M){return!(M.startLineNumber<R.startLineNumber||M.endLineNumber<R.startLineNumber||M.startLineNumber>R.endLineNumber||M.endLineNumber>R.endLineNumber||M.startLineNumber===R.startLineNumber&&M.startColumn<=R.startColumn||M.endLineNumber===R.endLineNumber&&M.endColumn>=R.endColumn)}plusRange(R){return N.plusRange(this,R)}static plusRange(R,M){let b,$,k,A;return M.startLineNumber<R.startLineNumber?(b=M.startLineNumber,$=M.startColumn):M.startLineNumber===R.startLineNumber?(b=M.startLineNumber,$=Math.min(M.startColumn,R.startColumn)):(b=R.startLineNumber,$=R.startColumn),M.endLineNumber>R.endLineNumber?(k=M.endLineNumber,A=M.endColumn):M.endLineNumber===R.endLineNumber?(k=M.endLineNumber,A=Math.max(M.endColumn,R.endColumn)):(k=R.endLineNumber,A=R.endColumn),new N(b,$,k,A)}intersectRanges(R){return N.intersectRanges(this,R)}static intersectRanges(R,M){let b=R.startLineNumber,$=R.startColumn,k=R.endLineNumber,A=R.endColumn;const I=M.startLineNumber,p=M.startColumn,y=M.endLineNumber,v=M.endColumn;return b<I?(b=I,$=p):b===I&&($=Math.max($,p)),k>y?(k=y,A=v):k===y&&(A=Math.min(A,v)),b>k||b===k&&$>A?null:new N(b,$,k,A)}equalsRange(R){return N.equalsRange(this,R)}static equalsRange(R,M){return!R&&!M?!0:!!R&&!!M&&R.startLineNumber===M.startLineNumber&&R.startColumn===M.startColumn&&R.endLineNumber===M.endLineNumber&&R.endColumn===M.endColumn}getEndPosition(){return N.getEndPosition(this)}static getEndPosition(R){return new h.$tt(R.endLineNumber,R.endColumn)}getStartPosition(){return N.getStartPosition(this)}static getStartPosition(R){return new h.$tt(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,M){return new N(this.startLineNumber,this.startColumn,R,M)}setStartPosition(R,M){return new N(R,M,this.endLineNumber,this.endColumn)}collapseToStart(){return N.collapseToStart(this)}static collapseToStart(R){return new N(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return N.collapseToEnd(this)}static collapseToEnd(R){return new N(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new N(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,M=R){return new N(R.lineNumber,R.column,M.lineNumber,M.column)}static lift(R){return R?new N(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,M){return!(R.endLineNumber<M.startLineNumber||R.endLineNumber===M.startLineNumber&&R.endColumn<M.startColumn||M.endLineNumber<R.startLineNumber||M.endLineNumber===R.startLineNumber&&M.endColumn<R.startColumn)}static areIntersecting(R,M){return!(R.endLineNumber<M.startLineNumber||R.endLineNumber===M.startLineNumber&&R.endColumn<=M.startColumn||M.endLineNumber<R.startLineNumber||M.endLineNumber===R.startLineNumber&&M.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,M){if(R&&M){const k=R.startLineNumber|0,A=M.startLineNumber|0;if(k===A){const I=R.startColumn|0,p=M.startColumn|0;if(I===p){const y=R.endLineNumber|0,v=M.endLineNumber|0;if(y===v){const l=R.endColumn|0,d=M.endColumn|0;return l-d}return y-v}return I-p}return k-A}return(R?1:0)-(M?1:0)}static compareRangesUsingEnds(R,M){return R.endLineNumber===M.endLineNumber?R.endColumn===M.endColumn?R.startLineNumber===M.startLineNumber?R.startColumn-M.startColumn:R.startLineNumber-M.startLineNumber:R.endColumn-M.endColumn:R.endLineNumber-M.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$ut=N}),define(Se[180],De([1,0,29]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0;class N{static insert(R,M){return{range:new h.$ut(R.lineNumber,R.column,R.lineNumber,R.column),text:M,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,M){return{range:R,text:M}}static replaceMove(R,M){return{range:R,text:M,forceMoveMarkers:!0}}}e.$vt=N}),define(Se[181],De([1,0,51,29]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.SelectionDirection=void 0;var O;(function(M){M[M.LTR=0]="LTR",M[M.RTL=1]="RTL"})(O||(e.SelectionDirection=O={}));class R extends N.$ut{constructor(b,$,k,A){super(b,$,k,A),this.selectionStartLineNumber=b,this.selectionStartColumn=$,this.positionLineNumber=k,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return R.selectionsEqual(this,b)}static selectionsEqual(b,$){return b.selectionStartLineNumber===$.selectionStartLineNumber&&b.selectionStartColumn===$.selectionStartColumn&&b.positionLineNumber===$.positionLineNumber&&b.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,$){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,b,$):new R(b,$,this.startLineNumber,this.startColumn)}getPosition(){return new h.$tt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new h.$tt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,$){return this.getDirection()===0?new R(b,$,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,b,$)}static fromPositions(b,$=b){return new R(b.lineNumber,b.column,$.lineNumber,$.column)}static fromRange(b,$){return $===0?new R(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new R(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new R(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,$){if(b&&!$||!b&&$)return!1;if(!b&&!$)return!0;if(b.length!==$.length)return!1;for(let k=0,A=b.length;k<A;k++)if(!this.selectionsEqual(b[k],$[k]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,$,k,A,I){return I===0?new R(b,$,k,A):new R(k,A,b,$)}}e.$wt=R}),define(Se[182],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=void 0,e.$4s={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[183],De([1,0,27,129]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kt=e.WordCharacterClass=void 0,e.$Lt=b;var O;(function($){$[$.Regular=0]="Regular",$[$.Whitespace=1]="Whitespace",$[$.WordSeparator=2]="WordSeparator"})(O||(e.WordCharacterClass=O={}));class R extends N.$It{constructor(k,A){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=A,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let I=0,p=k.length;I<p;I++)this.set(k.charCodeAt(I),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(k,A){let I=null;for(const p of this.h(k)){if(p.index>A)break;I=p}return I}findNextIntlWordAtOrAfterOffset(k,A){for(const I of this.h(k))if(!(I.index<A))return I;return null}h(k){return this.e?this.f===k?this.g:(this.f=k,this.g=this.j(this.e.segment(k)),this.g):[]}j(k){const A=[];for(const I of k)this.k(I)&&A.push(I);return A}k(k){return!!k.isWordLike}}e.$Kt=R;const M=new h.$Dc(10);function b($,k){const A=`${$}/${k.join(",")}`;let I=M.get(A);return I||(I=new R($,k),M.set(A,I)),I}}),define(Se[130],De([1,0,39,3,76]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=e.$5s=void 0,e.$7s=M,e.$8s=$,e.$9s=k,e.$5s="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(I=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.$5s)I.indexOf(y)>=0||(p+="\\"+y);return p+="\\s]+)",new RegExp(p,"g")}e.$6s=R();function M(I){let p=e.$6s;if(I&&I instanceof RegExp)if(I.global)p=I;else{let y="g";I.ignoreCase&&(y+="i"),I.multiline&&(y+="m"),I.unicode&&(y+="u"),p=new RegExp(I.source,y)}return p.lastIndex=0,p}const b=new O.$5c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(I){const p=b.unshift(I);return(0,N.$Sc)(p)}function k(I,p,y,v,l){if(p=M(p),l||(l=h.Iterable.first(b)),y.length>l.maxLen){let u=I-l.maxLen/2;return u<0?u=0:v+=u,y=y.substring(u,I+l.maxLen/2),k(I,p,y,v,l)}const d=Date.now(),o=I-1-v;let n=-1,i=null;for(let u=1;!(Date.now()-d>=l.timeBudget);u++){const s=o-l.windowSize*u;p.lastIndex=Math.max(0,s);const t=A(p,y,o,n);if(!t&&i||(i=t,s<=0))break;n=s}if(i){const u={word:i[0],startColumn:v+1+i.index,endColumn:v+1+i.index+i[0].length};return p.lastIndex=0,u}return null}function A(I,p,y,v){let l;for(;l=I.exec(p);){const d=l.index||0;if(d<=y&&I.lastIndex>=y)return l;if(v>0&&d>v)return null}return null}}),define(Se[184],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lu=e.$ku=e.IndentAction=void 0;var h;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(h||(e.IndentAction=h={}));class N{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let $=0,k=b.notIn.length;$<k;$++)switch(b.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,$){if(b.getTokenCount()===0)return!0;const k=b.findTokenIndexAtOffset($-2),A=b.getStandardTokenType(k);return this.isOK(A)}g(b,$){for(let k=b;k<=$;k++){const A=String.fromCharCode(k);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$ku=N;class O{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of b)R(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),R(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),R(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),R(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&R(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$lu=O;function R(M,b,$){M.has(b)?M.get(b).push($):M.set(b,[$])}}),define(Se[185],De([1,0,129]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C2=e.$B2=e.State=void 0,e.$D2=p;var N;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(N||(e.State=N={}));class O{constructor(v,l,d){const o=new Uint8Array(v*l);for(let n=0,i=v*l;n<i;n++)o[n]=d;this.a=o,this.rows=v,this.cols=l}get(v,l){return this.a[v*this.cols+l]}set(v,l,d){this.a[v*this.cols+l]=d}}class R{constructor(v){let l=0,d=0;for(let n=0,i=v.length;n<i;n++){const[u,s,t]=v[n];s>l&&(l=s),u>d&&(d=u),t>d&&(d=t)}l++,d++;const o=new O(d,l,0);for(let n=0,i=v.length;n<i;n++){const[u,s,t]=v[n];o.set(u,s,t)}this.a=o,this.b=l}nextState(v,l){return l<0||l>=this.b?0:this.a.get(v,l)}}e.$B2=R;let M=null;function b(){return M===null&&(M=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),M}var $;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})($||($={}));let k=null;function A(){if(k===null){k=new h.$It(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let l=0;l<y.length;l++)k.set(y.charCodeAt(l),1);const v=".,;:";for(let l=0;l<v.length;l++)k.set(v.charCodeAt(l),2)}return k}class I{static a(v,l,d,o,n){let i=n-1;do{const u=l.charCodeAt(i);if(v.get(u)!==2)break;i--}while(i>o);if(o>0){const u=l.charCodeAt(o-1),s=l.charCodeAt(i);(u===40&&s===41||u===91&&s===93||u===123&&s===125)&&i--}return{range:{startLineNumber:d,startColumn:o+1,endLineNumber:d,endColumn:i+2},url:l.substring(o,i+1)}}static computeLinks(v,l=b()){const d=A(),o=[];for(let n=1,i=v.getLineCount();n<=i;n++){const u=v.getLineContent(n),s=u.length;let t=0,c=0,r=0,a=1,f=!1,g=!1,w=!1,S=!1;for(;t<s;){let m=!1;const E=u.charCodeAt(t);if(a===13){let D;switch(E){case 40:f=!0,D=0;break;case 41:D=f?0:1;break;case 91:w=!0,g=!0,D=0;break;case 93:w=!1,D=g?0:1;break;case 123:S=!0,D=0;break;case 125:D=S?0:1;break;case 39:case 34:case 96:r===E?D=1:r===39||r===34||r===96?D=0:D=1;break;case 42:D=r===42?1:0;break;case 124:D=r===124?1:0;break;case 32:D=w?0:1;break;default:D=d.get(E)}D===1&&(o.push(I.a(d,u,n,c,t)),m=!0)}else if(a===12){let D;E===91?(g=!0,D=0):D=d.get(E),D===1?m=!0:a=13}else a=l.nextState(a,E),a===0&&(m=!0);m&&(a=1,f=!1,g=!1,S=!1,c=t+1,r=E),t++}a===13&&o.push(I.a(d,u,n,c,s))}return o}}e.$C2=I;function p(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:I.computeLinks(y)}}),define(Se[80],De([1,0,24]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jv=e.$Iv=e.$Hv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$Fv=e.$Ev=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$Gv=v,e.$Kv=u;var N;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(N||(e.OverviewRulerLane=N={}));var O;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=3]="Right"})(O||(e.GlyphMarginLane=O={}));var R;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var M;(function(s){s[s.Normal=1]="Normal",s[s.Underlined=2]="Underlined"})(M||(e.MinimapSectionHeaderStyle=M={}));var b;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(b||(e.InjectedTextCursorStops=b={}));var $;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var k;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(k||(e.DefaultEndOfLine=k={}));var A;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(A||(e.EndOfLineSequence=A={}));class I{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,h.$7n)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$Ev=I;class p{constructor(t,c){this._findMatchBrand=void 0,this.range=t,this.matches=c}}e.$Fv=p;var y;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(y||(e.TrackedRangeStickiness=y={}));function v(s){return s&&typeof s.read=="function"}var l;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None",s[s.LeftOfInjectedText=3]="LeftOfInjectedText",s[s.RightOfInjectedText=4]="RightOfInjectedText"})(l||(e.PositionAffinity=l={}));var d;(function(s){s[s.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(d||(e.ModelConstants=d={}));class o{constructor(t,c,r,a,f,g){this.identifier=t,this.range=c,this.text=r,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=f,this._isTracked=g}}e.$Hv=o;class n{constructor(t,c,r){this.regex=t,this.wordSeparators=c,this.simpleSearch=r}}e.$Iv=n;class i{constructor(t,c,r){this.reverseEdits=t,this.changes=c,this.trimAutoWhitespaceLineNumbers=r}}e.$Jv=i;function u(s){return!s.isTooLargeForSyncing()&&!s.isForSimpleWidget}}),define(Se[186],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GC=e.NodeColor=e.$FC=void 0,e.$HC=O,e.$IC=R,e.$JC=k,e.$KC=A,e.$LC=I,e.$MC=p,e.$NC=y,e.$OC=v;class h{constructor(d,o){this.piece=d,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$GC)return O(this.right);let d=this;for(;d.parent!==e.$GC&&d.parent.left!==d;)d=d.parent;return d.parent===e.$GC?e.$GC:d.parent}prev(){if(this.left!==e.$GC)return R(this.left);let d=this;for(;d.parent!==e.$GC&&d.parent.right!==d;)d=d.parent;return d.parent===e.$GC?e.$GC:d.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$FC=h;var N;(function(l){l[l.Black=0]="Black",l[l.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$GC=new h(null,0),e.$GC.parent=e.$GC,e.$GC.left=e.$GC,e.$GC.right=e.$GC,e.$GC.color=0;function O(l){for(;l.left!==e.$GC;)l=l.left;return l}function R(l){for(;l.right!==e.$GC;)l=l.right;return l}function M(l){return l===e.$GC?0:l.size_left+l.piece.length+M(l.right)}function b(l){return l===e.$GC?0:l.lf_left+l.piece.lineFeedCnt+b(l.right)}function $(){e.$GC.parent=e.$GC}function k(l,d){const o=d.right;o.size_left+=d.size_left+(d.piece?d.piece.length:0),o.lf_left+=d.lf_left+(d.piece?d.piece.lineFeedCnt:0),d.right=o.left,o.left!==e.$GC&&(o.left.parent=d),o.parent=d.parent,d.parent===e.$GC?l.root=o:d.parent.left===d?d.parent.left=o:d.parent.right=o,o.left=d,d.parent=o}function A(l,d){const o=d.left;d.left=o.right,o.right!==e.$GC&&(o.right.parent=d),o.parent=d.parent,d.size_left-=o.size_left+(o.piece?o.piece.length:0),d.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),d.parent===e.$GC?l.root=o:d===d.parent.right?d.parent.right=o:d.parent.left=o,o.right=d,d.parent=o}function I(l,d){let o,n;if(d.left===e.$GC?(n=d,o=n.right):d.right===e.$GC?(n=d,o=n.left):(n=O(d.right),o=n.right),n===l.root){l.root=o,o.color=0,d.detach(),$(),l.root.parent=e.$GC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=o:n.parent.right=o,n===d?(o.parent=n.parent,v(l,o)):(n.parent===d?o.parent=n:o.parent=n.parent,v(l,o),n.left=d.left,n.right=d.right,n.parent=d.parent,n.color=d.color,d===l.root?l.root=n:d===d.parent.left?d.parent.left=n:d.parent.right=n,n.left!==e.$GC&&(n.left.parent=n),n.right!==e.$GC&&(n.right.parent=n),n.size_left=d.size_left,n.lf_left=d.lf_left,v(l,n)),d.detach(),o.parent.left===o){const s=M(o),t=b(o);if(s!==o.parent.size_left||t!==o.parent.lf_left){const c=s-o.parent.size_left,r=t-o.parent.lf_left;o.parent.size_left=s,o.parent.lf_left=t,y(l,o.parent,c,r)}}if(v(l,o.parent),i){$();return}let u;for(;o!==l.root&&o.color===0;)o===o.parent.left?(u=o.parent.right,u.color===1&&(u.color=0,o.parent.color=1,k(l,o.parent),u=o.parent.right),u.left.color===0&&u.right.color===0?(u.color=1,o=o.parent):(u.right.color===0&&(u.left.color=0,u.color=1,A(l,u),u=o.parent.right),u.color=o.parent.color,o.parent.color=0,u.right.color=0,k(l,o.parent),o=l.root)):(u=o.parent.left,u.color===1&&(u.color=0,o.parent.color=1,A(l,o.parent),u=o.parent.left),u.left.color===0&&u.right.color===0?(u.color=1,o=o.parent):(u.left.color===0&&(u.right.color=0,u.color=1,k(l,u),u=o.parent.left),u.color=o.parent.color,o.parent.color=0,u.left.color=0,A(l,o.parent),o=l.root));o.color=0,$()}function p(l,d){for(v(l,d);d!==l.root&&d.parent.color===1;)if(d.parent===d.parent.parent.left){const o=d.parent.parent.right;o.color===1?(d.parent.color=0,o.color=0,d.parent.parent.color=1,d=d.parent.parent):(d===d.parent.right&&(d=d.parent,k(l,d)),d.parent.color=0,d.parent.parent.color=1,A(l,d.parent.parent))}else{const o=d.parent.parent.left;o.color===1?(d.parent.color=0,o.color=0,d.parent.parent.color=1,d=d.parent.parent):(d===d.parent.left&&(d=d.parent,A(l,d)),d.parent.color=0,d.parent.parent.color=1,k(l,d.parent.parent))}l.root.color=0}function y(l,d,o,n){for(;d!==l.root&&d!==e.$GC;)d.parent.left===d&&(d.parent.size_left+=o,d.parent.lf_left+=n),d=d.parent}function v(l,d){let o=0,n=0;if(d!==l.root){for(;d!==l.root&&d===d.parent.right;)d=d.parent;if(d!==l.root)for(d=d.parent,o=M(d.left)-d.size_left,n=b(d.left)-d.lf_left,d.size_left+=o,d.lf_left+=n;d!==l.root&&(o!==0||n!==0);)d.parent.left===d&&(d.parent.size_left+=o,d.parent.lf_left+=n),d=d.parent}}}),define(Se[187],De([1,0,19,128]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5v=e.$4v=e.$3v=void 0;class O{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,k){$=(0,N.$6e)($);const A=this.a,I=this.b,p=k.length;return p===0?!1:(this.a=new Uint32Array(A.length+p),this.a.set(A.subarray(0,$),0),this.a.set(A.subarray($),$+p),this.a.set(k,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue($,k){return $=(0,N.$6e)($),k=(0,N.$6e)(k),this.a[$]===k?!1:(this.a[$]=k,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,k){$=(0,N.$6e)($),k=(0,N.$6e)(k);const A=this.a,I=this.b;if($>=A.length)return!1;const p=A.length-$;return k>=p&&(k=p),k===0?!1:(this.a=new Uint32Array(A.length-k),this.a.set(A.subarray(0,$),0),this.a.set(A.subarray($+k),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,N.$6e)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let k=this.c[0]+1;k===0&&(this.b[0]=this.a[0],k++),$>=this.a.length&&($=this.a.length-1);for(let A=k;A<=$;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let k=0,A=this.a.length-1,I=0,p=0,y=0;for(;k<=A;)if(I=k+(A-k)/2|0,p=this.b[I],y=p-this.a[I],$<y)A=I-1;else if($>=p)k=I+1;else break;return new M(I,$-y)}}e.$3v=O;class R{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const k=this.e[$],A=k>0?this.d[k-1]:0;return new M(k,$-A)}removeValues($,k){this.a.splice($,k),this.f($)}insertValues($,k){this.a=(0,h.$Vb)(this.a,$,k),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,k=this.a.length;$<k;$++){const A=this.a[$],I=$>0?this.d[$-1]:0;this.d[$]=I+A;for(let p=0;p<A;p++)this.e[I+p]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,k){this.a[$]!==k&&(this.a[$]=k,this.f($))}}e.$4v=R;class M{constructor($,k){this.index=$,this.remainder=k,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=k}}e.$5v=M}),define(Se[188],De([1,0,14,51,187]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6v=void 0;class R{constructor(b,$,k,A){this.d=b,this.f=$,this.g=k,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const $=b.changes;for(const k of $)this.o(k.range),this.p(new N.$tt(k.range.startLineNumber,k.range.startColumn),k.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,$=this.f.length,k=new Uint32Array($);for(let A=0;A<$;A++)k[A]=this.f[A].length+b;this.j=new O.$3v(k)}}n(b,$){this.f[b]=$,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,$){if($.length===0)return;const k=(0,h.$kf)($);if(k.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+k[0]+this.f[b.lineNumber-1].substring(b.column-1));return}k[k.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+k[0]);const A=new Uint32Array(k.length-1);for(let I=1;I<k.length;I++)this.f.splice(b.lineNumber+I-1,0,k[I]),A[I-1]=k[I].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,A)}}e.$6v=R}),define(Se[100],De([1,0,14,183,51,29,80]),function(he,e,h,N,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UC=e.$SC=e.$PC=void 0,e.$QC=k,e.$RC=A,e.$TC=l;const b=999;class ${constructor(n,i,u,s){this.searchString=n,this.isRegex=i,this.matchCase=u,this.wordSeparators=s}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=k(this.searchString):n=this.searchString.indexOf(`
`)>=0;let i=null;try{i=h.$if(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!i)return null;let u=!this.isRegex&&!n;return u&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(u=this.matchCase),new M.$Iv(i,this.wordSeparators?(0,N.$Lt)(this.wordSeparators,[]):null,u?this.searchString:null)}}e.$PC=$;function k(o){if(!o||o.length===0)return!1;for(let n=0,i=o.length;n<i;n++){const u=o.charCodeAt(n);if(u===10)return!0;if(u===92){if(n++,n>=i)break;const s=o.charCodeAt(n);if(s===110||s===114||s===87)return!0}}return!1}function A(o,n,i){if(!i)return new M.$Fv(o,null);const u=[];for(let s=0,t=n.length;s<t;s++)u[s]=n[s];return new M.$Fv(o,u)}class I{constructor(n){const i=[];let u=0;for(let s=0,t=n.length;s<t;s++)n.charCodeAt(s)===10&&(i[u++]=s);this.a=i}findLineFeedCountBeforeOffset(n){const i=this.a;let u=0,s=i.length-1;if(s===-1||n<=i[0])return 0;for(;u<s;){const t=u+((s-u)/2>>0);i[t]>=n?s=t-1:i[t+1]>=n?(u=t,s=t):u=t+1}return u+1}}class p{static findMatches(n,i,u,s,t){const c=i.parseSearchRequest();return c?c.regex.multiline?this.b(n,u,new d(c.wordSeparators,c.regex),s,t):this.c(n,u,c,s,t):[]}static a(n,i,u,s,t,c){let r,a=0;s?(a=s.findLineFeedCountBeforeOffset(t),r=i+t+a):r=i+t;let f;if(s){const m=s.findLineFeedCountBeforeOffset(t+c.length)-a;f=r+c.length+m}else f=r+c.length;const g=n.getPositionAt(r),w=n.getPositionAt(f);return new R.$ut(g.lineNumber,g.column,w.lineNumber,w.column)}static b(n,i,u,s,t){const c=n.getOffsetAt(i.getStartPosition()),r=n.getValueInRange(i,1),a=n.getEOL()===`\r
`?new I(r):null,f=[];let g=0,w;for(u.reset(0);w=u.next(r);)if(f[g++]=A(this.a(n,c,r,a,w.index,w[0]),w,s),g>=t)return f;return f}static c(n,i,u,s,t){const c=[];let r=0;if(i.startLineNumber===i.endLineNumber){const f=n.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return r=this.d(u,f,i.startLineNumber,i.startColumn-1,r,c,s,t),c}const a=n.getLineContent(i.startLineNumber).substring(i.startColumn-1);r=this.d(u,a,i.startLineNumber,i.startColumn-1,r,c,s,t);for(let f=i.startLineNumber+1;f<i.endLineNumber&&r<t;f++)r=this.d(u,n.getLineContent(f),f,0,r,c,s,t);if(r<t){const f=n.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);r=this.d(u,f,i.endLineNumber,0,r,c,s,t)}return c}static d(n,i,u,s,t,c,r,a){const f=n.wordSeparators;if(!r&&n.simpleSearch){const S=n.simpleSearch,m=S.length,E=i.length;let D=-m;for(;(D=i.indexOf(S,D+m))!==-1;)if((!f||l(f,i,E,D,m))&&(c[t++]=new M.$Fv(new R.$ut(u,D+1+s,u,D+1+m+s),null),t>=a))return t;return t}const g=new d(n.wordSeparators,n.regex);let w;g.reset(0);do if(w=g.next(i),w&&(c[t++]=A(new R.$ut(u,w.index+1+s,u,w.index+1+w[0].length+s),w,r),t>=a))return t;while(w);return t}static findNextMatch(n,i,u,s){const t=i.parseSearchRequest();if(!t)return null;const c=new d(t.wordSeparators,t.regex);return t.regex.multiline?this.e(n,u,c,s):this.f(n,u,c,s)}static e(n,i,u,s){const t=new O.$tt(i.lineNumber,1),c=n.getOffsetAt(t),r=n.getLineCount(),a=n.getValueInRange(new R.$ut(t.lineNumber,t.column,r,n.getLineMaxColumn(r)),1),f=n.getEOL()===`\r
`?new I(a):null;u.reset(i.column-1);const g=u.next(a);return g?A(this.a(n,c,a,f,g.index,g[0]),g,s):i.lineNumber!==1||i.column!==1?this.e(n,new O.$tt(1,1),u,s):null}static f(n,i,u,s){const t=n.getLineCount(),c=i.lineNumber,r=n.getLineContent(c),a=this.g(u,r,c,i.column,s);if(a)return a;for(let f=1;f<=t;f++){const g=(c+f-1)%t,w=n.getLineContent(g+1),S=this.g(u,w,g+1,1,s);if(S)return S}return null}static g(n,i,u,s,t){n.reset(s-1);const c=n.next(i);return c?A(new R.$ut(u,c.index+1,u,c.index+1+c[0].length),c,t):null}static findPreviousMatch(n,i,u,s){const t=i.parseSearchRequest();if(!t)return null;const c=new d(t.wordSeparators,t.regex);return t.regex.multiline?this.h(n,u,c,s):this.j(n,u,c,s)}static h(n,i,u,s){const t=this.b(n,new R.$ut(1,1,i.lineNumber,i.column),u,s,10*b);if(t.length>0)return t[t.length-1];const c=n.getLineCount();return i.lineNumber!==c||i.column!==n.getLineMaxColumn(c)?this.h(n,new O.$tt(c,n.getLineMaxColumn(c)),u,s):null}static j(n,i,u,s){const t=n.getLineCount(),c=i.lineNumber,r=n.getLineContent(c).substring(0,i.column-1),a=this.k(u,r,c,s);if(a)return a;for(let f=1;f<=t;f++){const g=(t+c-f-1)%t,w=n.getLineContent(g+1),S=this.k(u,w,g+1,s);if(S)return S}return null}static k(n,i,u,s){let t=null,c;for(n.reset(0);c=n.next(i);)t=A(new R.$ut(u,c.index+1,u,c.index+1+c[0].length),c,s);return t}}e.$SC=p;function y(o,n,i,u,s){if(u===0)return!0;const t=n.charCodeAt(u-1);if(o.get(t)!==0||t===13||t===10)return!0;if(s>0){const c=n.charCodeAt(u);if(o.get(c)!==0)return!0}return!1}function v(o,n,i,u,s){if(u+s===i)return!0;const t=n.charCodeAt(u+s);if(o.get(t)!==0||t===13||t===10)return!0;if(s>0){const c=n.charCodeAt(u+s-1);if(o.get(c)!==0)return!0}return!1}function l(o,n,i,u,s){return y(o,n,i,u,s)&&v(o,n,i,u,s)}class d{constructor(n,i){this._wordSeparators=n,this.a=i,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const i=n.length;let u;do{if(this.b+this.c===i||(u=this.a.exec(n),!u))return null;const s=u.index,t=u[0].length;if(s===this.b&&t===this.c){if(t===0){h.$Ef(n,i,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=s,this.c=t,!this._wordSeparators||l(this._wordSeparators,n,i,s,t))return u}while(u);return null}}e.$UC=d}),define(Se[131],De([1,0,51,29,80,186,100]),function(he,e,h,N,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZC=e.$YC=e.$XC=void 0,e.$VC=A,e.$WC=I;const b=65535;function $(o){let n;return o[o.length-1]<65536?n=new Uint16Array(o.length):n=new Uint32Array(o.length),n.set(o,0),n}class k{constructor(n,i,u,s,t){this.lineStarts=n,this.cr=i,this.lf=u,this.crlf=s,this.isBasicASCII=t}}function A(o,n=!0){const i=[0];let u=1;for(let s=0,t=o.length;s<t;s++){const c=o.charCodeAt(s);c===13?s+1<t&&o.charCodeAt(s+1)===10?(i[u++]=s+2,s++):i[u++]=s+1:c===10&&(i[u++]=s+1)}return n?$(i):i}function I(o,n){o.length=0,o[0]=0;let i=1,u=0,s=0,t=0,c=!0;for(let a=0,f=n.length;a<f;a++){const g=n.charCodeAt(a);g===13?a+1<f&&n.charCodeAt(a+1)===10?(t++,o[i++]=a+2,a++):(u++,o[i++]=a+1):g===10?(s++,o[i++]=a+1):c&&g!==9&&(g<32||g>126)&&(c=!1)}const r=new k($(o),u,s,t,c);return o.length=0,r}class p{constructor(n,i,u,s,t){this.bufferIndex=n,this.start=i,this.end=u,this.lineFeedCnt=s,this.length=t}}e.$XC=p;class y{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$YC=y;class v{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==R.$GC&&n.iterate(n.root,u=>(u!==R.$GC&&this.a.push(u.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class l{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const u=this.b[i];if(u.nodeStartOffset<=n&&u.nodeStartOffset+u.node.piece.length>=n)return u}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const u=this.b[i];if(u.nodeStartLineNumber&&u.nodeStartLineNumber<n&&u.nodeStartLineNumber+u.node.piece.lineFeedCnt>=n)return u}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const u=this.b;for(let s=0;s<u.length;s++){const t=u[s];if(t.node.parent===null||t.nodeStartOffset>=n){u[s]=null,i=!0;continue}}if(i){const s=[];for(const t of u)t!==null&&s.push(t);this.b=s}}}class d{constructor(n,i,u){this.create(n,i,u)}create(n,i,u){this.a=[new y("",[0])],this.g={line:0,column:0},this.root=R.$GC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=u;let s=null;for(let t=0,c=n.length;t<c;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=A(n[t].buffer));const r=new p(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),s=this.S(s,r)}this.h=new l(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=b,u=i-Math.floor(i/3),s=u*2;let t="",c=0;const r=[];if(this.iterate(this.root,a=>{const f=this.R(a),g=f.length;if(c<=u||c+g<s)return t+=f,c+=g,!0;const w=t.replace(/\r\n|\r|\n/g,n);return r.push(new y(w,A(w))),t=f,c=g,!0}),c>0){const a=t.replace(/\r\n|\r|\n/g,n);r.push(new y(a,A(a)))}this.create(r,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new v(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,s=>{if(s===R.$GC)return!0;const t=this.R(s),c=t.length,r=n.G(i),a=n.G(i+c),f=n.getValueInRange2(r,a);return i+=c,t===f})}getOffsetAt(n,i){let u=0,s=this.root;for(;s!==R.$GC;)if(s.left!==R.$GC&&s.lf_left+1>=n)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt+1>=n){u+=s.size_left;const t=this.B(s,n-s.lf_left-2);return u+=t+i-1}else n-=s.lf_left+s.piece.lineFeedCnt,u+=s.size_left+s.piece.length,s=s.right;return u}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,u=0;const s=n;for(;i!==R.$GC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(u+=i.lf_left+t.index,t.index===0){const c=this.getOffsetAt(u+1,1),r=s-c;return new h.$tt(u+1,r+1)}return new h.$tt(u+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,u+=i.lf_left+i.piece.lineFeedCnt,i.right===R.$GC){const t=this.getOffsetAt(u+1,1),c=s-n-t;return new h.$tt(u+1,c+1)}else i=i.right;return new h.$tt(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const u=this.H(n.startLineNumber,n.startColumn),s=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(u,s);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const r=n.node,a=this.a[r.piece.bufferIndex].buffer,f=this.u(r.piece.bufferIndex,r.piece.start);return a.substring(f+n.remainder,f+i.remainder)}let u=n.node;const s=this.a[u.piece.bufferIndex].buffer,t=this.u(u.piece.bufferIndex,u.piece.start);let c=s.substring(t+n.remainder,t+u.piece.length);for(u=u.next();u!==R.$GC;){const r=this.a[u.piece.bufferIndex].buffer,a=this.u(u.piece.bufferIndex,u.piece.start);if(u===i.node){c+=r.substring(a,a+i.remainder);break}else c+=r.substr(a,u.piece.length);u=u.next()}return c}getLinesContent(){const n=[];let i=0,u="",s=!1;return this.iterate(this.root,t=>{if(t===R.$GC)return!0;const c=t.piece;let r=c.length;if(r===0)return!0;const a=this.a[c.bufferIndex].buffer,f=this.a[c.bufferIndex].lineStarts,g=c.start.line,w=c.end.line;let S=f[g]+c.start.column;if(s&&(a.charCodeAt(S)===10&&(S++,r--),n[i++]=u,u="",s=!1,r===0))return!0;if(g===w)return!this.f&&a.charCodeAt(S+r-1)===13?(s=!0,u+=a.substr(S,r-1)):u+=a.substr(S,r),!0;u+=this.f?a.substring(S,Math.max(S,f[g+1]-this.e)):a.substring(S,f[g+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=u;for(let m=g+1;m<w;m++)u=this.f?a.substring(f[m],f[m+1]-this.e):a.substring(f[m],f[m+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=u;return!this.f&&a.charCodeAt(f[w]+c.end.column-1)===13?(s=!0,c.end.column===0?i--:u=a.substr(f[w],c.end.column-1)):u=a.substr(f[w],c.end.column),!0}),s&&(n[i++]=u,u=""),n[i++]=u,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const u=this.a[i.piece.bufferIndex],s=this.u(i.piece.bufferIndex,i.piece.start);return u.buffer.charCodeAt(s)}else{const i=this.a[n.node.piece.bufferIndex],s=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(s)}}getLineCharCode(n,i){const u=this.H(n,i+1);return this.l(u)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,u,s,t,c,r,a,f,g,w){const S=this.a[n.piece.bufferIndex],m=this.u(n.piece.bufferIndex,n.piece.start),E=this.u(n.piece.bufferIndex,t),D=this.u(n.piece.bufferIndex,c);let C;const P={line:0,column:0};let F,T;i._wordSeparators?(F=S.buffer.substring(E,D),T=z=>z+E,i.reset(0)):(F=S.buffer,T=z=>z,i.reset(E));do if(C=i.next(F),C){if(T(C.index)>=D)return g;this.s(n,T(C.index)-m,P);const z=this.t(n.piece.bufferIndex,t,P),L=P.line===t.line?P.column-t.column+s:P.column+1,j=L+C[0].length;if(w[g++]=(0,M.$RC)(new N.$ut(u+z,L,u+z,j),C,a),T(C.index)+C[0].length>=D||g>=f)return g}while(C);return g}findMatchesLineByLine(n,i,u,s){const t=[];let c=0;const r=new M.$UC(i.wordSeparators,i.regex);let a=this.H(n.startLineNumber,n.startColumn);if(a===null)return[];const f=this.H(n.endLineNumber,n.endColumn);if(f===null)return[];let g=this.s(a.node,a.remainder);const w=this.s(f.node,f.remainder);if(a.node===f.node)return this.findMatchesInNode(a.node,r,n.startLineNumber,n.startColumn,g,w,i,u,s,c,t),t;let S=n.startLineNumber,m=a.node;for(;m!==f.node;){const D=this.t(m.piece.bufferIndex,g,m.piece.end);if(D>=1){const P=this.a[m.piece.bufferIndex].lineStarts,F=this.u(m.piece.bufferIndex,m.piece.start),T=P[g.line+D],z=S===n.startLineNumber?n.startColumn:1;if(c=this.findMatchesInNode(m,r,S,z,g,this.s(m,T-F),i,u,s,c,t),c>=s)return t;S+=D}const C=S===n.startLineNumber?n.startColumn-1:0;if(S===n.endLineNumber){const P=this.getLineContent(S).substring(C,n.endColumn-1);return c=this.n(i,r,P,n.endLineNumber,C,c,t,u,s),t}if(c=this.n(i,r,this.getLineContent(S).substr(C),S,C,c,t,u,s),c>=s)return t;S++,a=this.H(S,1),m=a.node,g=this.s(a.node,a.remainder)}if(S===n.endLineNumber){const D=S===n.startLineNumber?n.startColumn-1:0,C=this.getLineContent(S).substring(D,n.endColumn-1);return c=this.n(i,r,C,n.endLineNumber,D,c,t,u,s),t}const E=S===n.startLineNumber?n.startColumn:1;return c=this.findMatchesInNode(f.node,r,S,E,g,w,i,u,s,c,t),t}n(n,i,u,s,t,c,r,a,f){const g=n.wordSeparators;if(!a&&n.simpleSearch){const S=n.simpleSearch,m=S.length,E=u.length;let D=-m;for(;(D=u.indexOf(S,D+m))!==-1;)if((!g||(0,M.$TC)(g,u,E,D,m))&&(r[c++]=new O.$Fv(new N.$ut(s,D+1+t,s,D+1+m+t),null),c>=f))return c;return c}let w;i.reset(0);do if(w=i.next(u),w&&(r[c++]=(0,M.$RC)(new N.$ut(s,w.index+1+t,s,w.index+1+w[0].length+t),w,a),c>=f))return c;while(w);return c}insert(n,i,u=!1){if(this.f=this.f&&u,this.j.lineNumber=0,this.j.value="",this.root!==R.$GC){const{node:s,remainder:t,nodeStartOffset:c}=this.G(n),r=s.piece,a=r.bufferIndex,f=this.s(s,t);if(s.piece.bufferIndex===0&&r.end.line===this.g.line&&r.end.column===this.g.column&&c+r.length===n&&i.length<b){this.F(s,i),this.y();return}if(c===n)this.o(i,s),this.h.validate(n);else if(c+s.piece.length>n){const g=[];let w=new p(r.bufferIndex,f,r.end,this.t(r.bufferIndex,f,r.end),this.u(a,r.end)-this.u(a,f));if(this.K()&&this.M(i)&&this.I(s,t)===10){const D={line:w.start.line+1,column:0};w=new p(w.bufferIndex,D,w.end,this.t(w.bufferIndex,D,w.end),w.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(s,t-1)===13){const D=this.s(s,t-1);this.C(s,D),i="\r"+i,s.piece.length===0&&g.push(s)}else this.C(s,f);else this.C(s,f);const S=this.w(i);w.length>0&&this.S(s,w);let m=s;for(let E=0;E<S.length;E++)m=this.S(m,S[E]);this.v(g)}else this.q(i,s)}else{const s=this.w(i);let t=this.T(null,s[0]);for(let c=1;c<s.length;c++)t=this.S(t,s[c])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===R.$GC)return;const u=this.G(n),s=this.G(n+i),t=u.node,c=s.node;if(t===c){const S=this.s(t,u.remainder),m=this.s(t,s.remainder);if(u.nodeStartOffset===n){if(i===t.piece.length){const E=t.next();(0,R.$LC)(this,t),this.N(E),this.y();return}this.D(t,m),this.h.validate(n),this.N(t),this.y();return}if(u.nodeStartOffset+t.piece.length===n+i){this.C(t,S),this.O(t),this.y();return}this.E(t,S,m),this.y();return}const r=[],a=this.s(t,u.remainder);this.C(t,a),this.h.validate(n),t.piece.length===0&&r.push(t);const f=this.s(c,s.remainder);this.D(c,f),c.piece.length===0&&r.push(c);const g=t.next();for(let S=g;S!==R.$GC&&S!==c;S=S.next())r.push(S);const w=t.piece.length===0?t.prev():t;this.v(r),this.O(w),this.y()}o(n,i){const u=[];if(this.K()&&this.M(n)&&this.L(i)){const c=i.piece,r={line:c.start.line+1,column:0},a=new p(c.bufferIndex,r,c.end,this.t(c.bufferIndex,r,c.end),c.length-1);i.piece=a,n+=`
`,(0,R.$NC)(this,i,-1,-1),i.piece.length===0&&u.push(i)}const s=this.w(n);let t=this.T(i,s[s.length-1]);for(let c=s.length-2;c>=0;c--)t=this.T(t,s[c]);this.N(t),this.v(u)}q(n,i){this.Q(n,i)&&(n+=`
`);const u=this.w(n),s=this.S(i,u[0]);let t=s;for(let c=1;c<u.length;c++)t=this.S(t,u[c]);this.N(s)}s(n,i,u){const s=n.piece,t=n.piece.bufferIndex,c=this.a[t].lineStarts,a=c[s.start.line]+s.start.column+i;let f=s.start.line,g=s.end.line,w=0,S=0,m=0;for(;f<=g&&(w=f+(g-f)/2|0,m=c[w],w!==g);)if(S=c[w+1],a<m)g=w-1;else if(a>=S)f=w+1;else break;return u?(u.line=w,u.column=a-m,null):{line:w,column:a-m}}t(n,i,u){if(u.column===0)return u.line-i.line;const s=this.a[n].lineStarts;if(u.line===s.length-1)return u.line-i.line;const t=s[u.line+1],c=s[u.line]+u.column;if(t>c+1)return u.line-i.line;const r=c-1;return this.a[n].buffer.charCodeAt(r)===13?u.line-i.line+1:u.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,R.$LC)(this,n[i])}w(n){if(n.length>b){const g=[];for(;n.length>b;){const S=n.charCodeAt(b-1);let m;S===13||S>=55296&&S<=56319?(m=n.substring(0,b-1),n=n.substring(b-1)):(m=n.substring(0,b),n=n.substring(b));const E=A(m);g.push(new p(this.a.length,{line:0,column:0},{line:E.length-1,column:m.length-E[E.length-1]},E.length-1,m.length)),this.a.push(new y(m,E))}const w=A(n);return g.push(new p(this.a.length,{line:0,column:0},{line:w.length-1,column:n.length-w[w.length-1]},w.length-1,n.length)),this.a.push(new y(n,w)),g}let i=this.a[0].buffer.length;const u=A(n,!1);let s=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},s=this.g;for(let g=0;g<u.length;g++)u[g]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(u.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let g=0;g<u.length;g++)u[g]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(u.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,c=this.a[0].lineStarts.length-1,r=t-this.a[0].lineStarts[c],a={line:c,column:r},f=new p(0,s,a,this.t(0,s,a),t-i);return this.g=a,[f]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let u=this.root,s="";const t=this.h.get2(n);if(t){u=t.node;const c=this.B(u,n-t.nodeStartLineNumber-1),r=this.a[u.piece.bufferIndex].buffer,a=this.u(u.piece.bufferIndex,u.piece.start);if(t.nodeStartLineNumber+u.piece.lineFeedCnt===n)s=r.substring(a+c,a+u.piece.length);else{const f=this.B(u,n-t.nodeStartLineNumber);return r.substring(a+c,a+f-i)}}else{let c=0;const r=n;for(;u!==R.$GC;)if(u.left!==R.$GC&&u.lf_left>=n-1)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt>n-1){const a=this.B(u,n-u.lf_left-2),f=this.B(u,n-u.lf_left-1),g=this.a[u.piece.bufferIndex].buffer,w=this.u(u.piece.bufferIndex,u.piece.start);return c+=u.size_left,this.h.set({node:u,nodeStartOffset:c,nodeStartLineNumber:r-(n-1-u.lf_left)}),g.substring(w+a,w+f-i)}else if(u.lf_left+u.piece.lineFeedCnt===n-1){const a=this.B(u,n-u.lf_left-2),f=this.a[u.piece.bufferIndex].buffer,g=this.u(u.piece.bufferIndex,u.piece.start);s=f.substring(g+a,g+u.piece.length);break}else n-=u.lf_left+u.piece.lineFeedCnt,c+=u.size_left+u.piece.length,u=u.right}for(u=u.next();u!==R.$GC;){const c=this.a[u.piece.bufferIndex].buffer;if(u.piece.lineFeedCnt>0){const r=this.B(u,0),a=this.u(u.piece.bufferIndex,u.piece.start);return s+=c.substring(a,a+r-i),s}else{const r=this.u(u.piece.bufferIndex,u.piece.start);s+=c.substr(r,u.piece.length)}u=u.next()}return s}y(){let n=this.root,i=1,u=0;for(;n!==R.$GC;)i+=n.lf_left+n.piece.lineFeedCnt,u+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=u,this.h.validate(this.c)}A(n,i){const u=n.piece,s=this.s(n,i),t=s.line-u.start.line;if(this.u(u.bufferIndex,u.end)-this.u(u.bufferIndex,u.start)===i){const c=this.t(n.piece.bufferIndex,u.start,s);if(c!==t)return{index:c,remainder:0}}return{index:t,remainder:s.column}}B(n,i){if(i<0)return 0;const u=n.piece,s=this.a[u.bufferIndex].lineStarts,t=u.start.line+i+1;return t>u.end.line?s[u.end.line]+u.end.column-s[u.start.line]-u.start.column:s[t]-s[u.start.line]-u.start.column}C(n,i){const u=n.piece,s=u.lineFeedCnt,t=this.u(u.bufferIndex,u.end),c=i,r=this.u(u.bufferIndex,c),a=this.t(u.bufferIndex,u.start,c),f=a-s,g=r-t,w=u.length+g;n.piece=new p(u.bufferIndex,u.start,c,a,w),(0,R.$NC)(this,n,g,f)}D(n,i){const u=n.piece,s=u.lineFeedCnt,t=this.u(u.bufferIndex,u.start),c=i,r=this.t(u.bufferIndex,c,u.end),a=this.u(u.bufferIndex,c),f=r-s,g=t-a,w=u.length+g;n.piece=new p(u.bufferIndex,c,u.end,r,w),(0,R.$NC)(this,n,g,f)}E(n,i,u){const s=n.piece,t=s.start,c=s.end,r=s.length,a=s.lineFeedCnt,f=i,g=this.t(s.bufferIndex,s.start,f),w=this.u(s.bufferIndex,i)-this.u(s.bufferIndex,t);n.piece=new p(s.bufferIndex,s.start,f,g,w),(0,R.$NC)(this,n,w-r,g-a);const S=new p(s.bufferIndex,u,c,this.t(s.bufferIndex,u,c),this.u(s.bufferIndex,c)-this.u(s.bufferIndex,u)),m=this.S(n,S);this.N(m)}F(n,i){this.Q(i,n)&&(i+=`
`);const u=this.K()&&this.L(i)&&this.M(n),s=this.a[0].buffer.length;this.a[0].buffer+=i;const t=A(i,!1);for(let m=0;m<t.length;m++)t[m]+=s;if(u){const m=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:s-m}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const c=this.a[0].lineStarts.length-1,r=this.a[0].buffer.length-this.a[0].lineStarts[c],a={line:c,column:r},f=n.piece.length+i.length,g=n.piece.lineFeedCnt,w=this.t(0,n.piece.start,a),S=w-g;n.piece=new p(n.piece.bufferIndex,n.piece.start,a,w,f),this.g=a,(0,R.$NC)(this,n,i.length,S)}G(n){let i=this.root;const u=this.h.get(n);if(u)return{node:u.node,nodeStartOffset:u.nodeStartOffset,remainder:n-u.nodeStartOffset};let s=0;for(;i!==R.$GC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){s+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:s};return this.h.set(t),t}else n-=i.size_left+i.piece.length,s+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let u=this.root,s=0;for(;u!==R.$GC;)if(u.left!==R.$GC&&u.lf_left>=n-1)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt>n-1){const t=this.B(u,n-u.lf_left-2),c=this.B(u,n-u.lf_left-1);return s+=u.size_left,{node:u,remainder:Math.min(t+i-1,c),nodeStartOffset:s}}else if(u.lf_left+u.piece.lineFeedCnt===n-1){const t=this.B(u,n-u.lf_left-2);if(t+i-1<=u.piece.length)return{node:u,remainder:t+i-1,nodeStartOffset:s};i-=u.piece.length-t;break}else n-=u.lf_left+u.piece.lineFeedCnt,s+=u.size_left+u.piece.length,u=u.right;for(u=u.next();u!==R.$GC;){if(u.piece.lineFeedCnt>0){const t=this.B(u,0),c=this.J(u);return{node:u,remainder:Math.min(i-1,t),nodeStartOffset:c}}else if(u.piece.length>=i-1){const t=this.J(u);return{node:u,remainder:i-1,nodeStartOffset:t}}else i-=u.piece.length;u=u.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const u=this.a[n.piece.bufferIndex],s=this.u(n.piece.bufferIndex,n.piece.start)+i;return u.buffer.charCodeAt(s)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===R.$GC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,u=this.a[i.bufferIndex].lineStarts,s=i.start.line,t=u[s]+i.start.column;return s===u.length-1||u[s+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===R.$GC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const u=[],s=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:s[n.piece.end.line]-s[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const c=n.piece.length-1,r=n.piece.lineFeedCnt-1;n.piece=new p(n.piece.bufferIndex,n.piece.start,t,r,c),(0,R.$NC)(this,n,-1,-1),n.piece.length===0&&u.push(n);const a={line:i.piece.start.line+1,column:0},f=i.piece.length-1,g=this.t(i.piece.bufferIndex,a,i.piece.end);i.piece=new p(i.piece.bufferIndex,a,i.piece.end,g,f),(0,R.$NC)(this,i,-1,-1),i.piece.length===0&&u.push(i);const w=this.w(`\r
`);this.S(n,w[0]);for(let S=0;S<u.length;S++)(0,R.$LC)(this,u[S])}Q(n,i){if(this.K()&&this.M(n)){const u=i.next();if(this.L(u)){if(n+=`
`,u.piece.length===1)(0,R.$LC)(this,u);else{const s=u.piece,t={line:s.start.line+1,column:0},c=s.length-1,r=this.t(s.bufferIndex,t,s.end);u.piece=new p(s.bufferIndex,t,s.end,r,c),(0,R.$NC)(this,u,-1,-1)}return!0}}return!1}iterate(n,i){if(n===R.$GC)return i(R.$GC);const u=this.iterate(n.left,i);return u&&i(n)&&this.iterate(n.right,i)}R(n){if(n===R.$GC)return"";const i=this.a[n.piece.bufferIndex],u=n.piece,s=this.u(u.bufferIndex,u.start),t=this.u(u.bufferIndex,u.end);return i.buffer.substring(s,t)}getPieceContent(n){const i=this.a[n.bufferIndex],u=this.u(n.bufferIndex,n.start),s=this.u(n.bufferIndex,n.end);return i.buffer.substring(u,s)}S(n,i){const u=new R.$FC(i,1);if(u.left=R.$GC,u.right=R.$GC,u.parent=R.$GC,u.size_left=0,u.lf_left=0,this.root===R.$GC)this.root=u,u.color=0;else if(n.right===R.$GC)n.right=u,u.parent=n;else{const t=(0,R.$HC)(n.right);t.left=u,u.parent=t}return(0,R.$MC)(this,u),u}T(n,i){const u=new R.$FC(i,1);if(u.left=R.$GC,u.right=R.$GC,u.parent=R.$GC,u.size_left=0,u.lf_left=0,this.root===R.$GC)this.root=u,u.color=0;else if(n.left===R.$GC)n.left=u,u.parent=n;else{const s=(0,R.$IC)(n.left);s.right=u,u.parent=s}return(0,R.$MC)(this,u),u}U(n){let i="";return this.iterate(n,u=>(i+=this.R(u),!0)),i}}e.$ZC=d}),define(Se[189],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B0=e.$A0=void 0;class h{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const M=this.a.get(R);return this.a.delete(R),M}}addDragOperationTransfer(R,M){this.a.set(R,M)}}e.$A0=h;class N{constructor(R){this.identifier=R}}e.$B0=N}),define(Se[190],De([1,0,4,3]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zt=void 0;class O{constructor(){this.a=new Map,this.b=new Map,this.c=new h.$de,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,$){return this.a.set(b,$),this.handleChange([b]),(0,N.$Sc)(()=>{this.a.get(b)===$&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,$){this.b.get(b)?.dispose();const k=new R(this,b,$);return this.b.set(b,k),(0,N.$Sc)(()=>{const A=this.b.get(b);!A||A!==k||(this.b.delete(b),A.dispose())})}async getOrCreate(b){const $=this.get(b);if($)return $;const k=this.b.get(b);return!k||k.isResolved?null:(await k.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const k=this.b.get(b);return!!(!k||k.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Zt=O;class R extends N.$Uc{get isResolved(){return this.c}constructor(b,$,k){super(),this.f=b,this.g=$,this.h=k,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(Se[191],De([9,10]),function(he,e){return he.create("vs/base/common/actions",e)}),define(Se[192],De([1,0,4,3,191]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=void 0,e.$gj=A;class R extends N.$Uc{constructor(p,y="",v="",l=!0,d){super(),this.h=this.B(new h.$de),this.onDidChange=this.h.event,this.w=!0,this.j=p,this.m=y,this.u=v,this.w=l,this.C=d}get id(){return this.j}get label(){return this.m}set label(p){this.D(p)}D(p){this.m!==p&&(this.m=p,this.h.fire({label:p}))}get tooltip(){return this.n||""}set tooltip(p){this.F(p)}F(p){this.n!==p&&(this.n=p,this.h.fire({tooltip:p}))}get class(){return this.u}set class(p){this.G(p)}G(p){this.u!==p&&(this.u=p,this.h.fire({class:p}))}get enabled(){return this.w}set enabled(p){this.H(p)}H(p){this.w!==p&&(this.w=p,this.h.fire({enabled:p}))}get checked(){return this.z}set checked(p){this.I(p)}I(p){this.z!==p&&(this.z=p,this.h.fire({checked:p}))}async run(p,y){this.C&&await this.C(p)}}e.$bj=R;class M extends N.$Uc{constructor(){super(...arguments),this.f=this.B(new h.$de),this.onWillRun=this.f.event,this.m=this.B(new h.$de),this.onDidRun=this.m.event}async run(p,y){if(!p.enabled)return;this.f.fire({action:p});let v;try{await this.u(p,y)}catch(l){v=l}this.m.fire({action:p,error:v})}async u(p,y){await p.run(y)}}e.$cj=M;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let y=[];for(const v of p)v.length&&(y.length?y=[...y,new b,...v]:y=v);return y}static{this.ID="vs.actions.separator"}async run(){}}e.$dj=b;class ${get actions(){return this.a}constructor(p,y,v,l){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=y,this.class=l,this.a=v}async run(){}}e.$ej=$;class k extends R{static{this.ID="vs.actions.empty"}constructor(){super(k.ID,O.localize(0,null),void 0,!1)}}e.$fj=k;function A(I){return{id:I.id,label:I.label,class:I.class,enabled:I.enabled??!0,checked:I.checked,run:async(...p)=>I.run(...p),tooltip:I.label}}}),define(Se[193],De([9,10]),function(he,e){return he.create("vs/base/common/date",e)}),define(Se[194],De([1,0,193]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=k,e.$3m=A,e.$4m=I;const N=60,O=N*60,R=O*24,M=R*7,b=R*30,$=R*365;function k(p,y,v,l){typeof p!="number"&&(p=p.getTime());const d=Math.round((new Date().getTime()-p)/1e3);if(d<-30)return(0,h.localize)(0,null,k(new Date().getTime()+d*1e3,!1));if(!l&&d<30)return(0,h.localize)(1,null);let o;return d<N?(o=d,y?o===1?v?(0,h.localize)(2,null,o):(0,h.localize)(3,null,o):v?(0,h.localize)(4,null,o):(0,h.localize)(5,null,o):o===1?v?(0,h.localize)(6,null,o):(0,h.localize)(7,null,o):v?(0,h.localize)(8,null,o):(0,h.localize)(9,null,o)):d<O?(o=Math.floor(d/N),y?o===1?v?(0,h.localize)(10,null,o):(0,h.localize)(11,null,o):v?(0,h.localize)(12,null,o):(0,h.localize)(13,null,o):o===1?v?(0,h.localize)(14,null,o):(0,h.localize)(15,null,o):v?(0,h.localize)(16,null,o):(0,h.localize)(17,null,o)):d<R?(o=Math.floor(d/O),y?o===1?v?(0,h.localize)(18,null,o):(0,h.localize)(19,null,o):v?(0,h.localize)(20,null,o):(0,h.localize)(21,null,o):o===1?v?(0,h.localize)(22,null,o):(0,h.localize)(23,null,o):v?(0,h.localize)(24,null,o):(0,h.localize)(25,null,o)):d<M?(o=Math.floor(d/R),y?o===1?(0,h.localize)(26,null,o):(0,h.localize)(27,null,o):o===1?(0,h.localize)(28,null,o):(0,h.localize)(29,null,o)):d<b?(o=Math.floor(d/M),y?o===1?v?(0,h.localize)(30,null,o):(0,h.localize)(31,null,o):v?(0,h.localize)(32,null,o):(0,h.localize)(33,null,o):o===1?v?(0,h.localize)(34,null,o):(0,h.localize)(35,null,o):v?(0,h.localize)(36,null,o):(0,h.localize)(37,null,o)):d<$?(o=Math.floor(d/b),y?o===1?v?(0,h.localize)(38,null,o):(0,h.localize)(39,null,o):v?(0,h.localize)(40,null,o):(0,h.localize)(41,null,o):o===1?v?(0,h.localize)(42,null,o):(0,h.localize)(43,null,o):v?(0,h.localize)(44,null,o):(0,h.localize)(45,null,o)):(o=Math.floor(d/$),y?o===1?v?(0,h.localize)(46,null,o):(0,h.localize)(47,null,o):v?(0,h.localize)(48,null,o):(0,h.localize)(49,null,o):o===1?v?(0,h.localize)(50,null,o):(0,h.localize)(51,null,o):v?(0,h.localize)(52,null,o):(0,h.localize)(53,null,o))}function A(p,y){const v=Math.abs(p/1e3);return v<1?y?(0,h.localize)(54,null,p):(0,h.localize)(55,null,p):v<N?y?(0,h.localize)(56,null,Math.round(p)/1e3):(0,h.localize)(57,null,Math.round(p)/1e3):v<O?y?(0,h.localize)(58,null,Math.round(p/(1e3*N))):(0,h.localize)(59,null,Math.round(p/(1e3*N))):v<R?y?(0,h.localize)(60,null,Math.round(p/(1e3*O))):(0,h.localize)(61,null,Math.round(p/(1e3*O))):(0,h.localize)(62,null,Math.round(p/(1e3*R)))}function I(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Se[195],De([9,10]),function(he,e){return he.create("vs/base/common/errorMessage",e)}),define(Se[47],De([1,0,19,18,195]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=$,e.$ij=k,e.$jj=A;function R(I,p){return p&&(I.stack||I.stacktrace)?O.localize(0,null,b(I),M(I.stack)||M(I.stacktrace)):b(I)}function M(I){return Array.isArray(I)?I.join(`
`):I}function b(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?O.localize(1,null,I.message):I.message||O.localize(2,null)}function $(I=null,p=!1){if(!I)return O.localize(3,null);if(Array.isArray(I)){const y=h.$Hb(I),v=$(y[0],p);return y.length>1?O.localize(4,null,v,y.length):v}if(N.$9f(I))return I;if(I.detail){const y=I.detail;if(y.error)return R(y.error,p);if(y.exception)return R(y.exception,p)}return I.stack?R(I,p):I.message?I.message:O.localize(5,null)}function k(I){const p=I;return p instanceof Error&&Array.isArray(p.actions)}function A(I,p){let y;return typeof I=="string"?y=new Error(I):y=I,y.actions=p,y}}),define(Se[196],De([9,10]),function(he,e){return he.create("vs/base/common/platform",e)}),define(Se[12],De([1,0,196]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=c,e.$D=S,e.$J=m,e.$g="en";let N=!1,O=!1,R=!1,M=!1,b=!1,$=!1,k=!1,A=!1,I=!1,p=!1,y,v=e.$g,l=e.$g,d,o;const n=globalThis;let i;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?i=n.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(i=process);const u=typeof i?.versions?.electron=="string",s=u&&i?.type==="renderer";if(typeof i=="object"){N=i.platform==="win32",O=i.platform==="darwin",R=i.platform==="linux",M=R&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,k=u,I=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.$g,v=e.$g;const E=i.env.VSCODE_NLS_CONFIG;if(E)try{const D=JSON.parse(E),C=D.availableLanguages["*"];y=D.locale,l=D.osLocale,v=C||e.$g,d=D._translationsConfigFile}catch{}b=!0}else typeof navigator=="object"&&!s?(o=navigator.userAgent,N=o.indexOf("Windows")>=0,O=o.indexOf("Macintosh")>=0,A=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=o.indexOf("Linux")>=0,p=o?.indexOf("Mobi")>=0,$=!0,y=h.getConfiguredDefaultLocale(h.localize(0,null))||e.$g,v=y,l=navigator.language):console.error("Unable to resolve platform.");var t;(function(E){E[E.Web=0]="Web",E[E.Mac=1]="Mac",E[E.Linux=2]="Linux",E[E.Windows=3]="Windows"})(t||(e.Platform=t={}));function c(E){switch(E){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let r=0;O?r=1:N?r=3:R&&(r=2),e.$i=N,e.$j=O,e.$k=R,e.$l=M,e.$m=b,e.$n=k,e.$o=$,e.$p=$&&typeof n.importScripts=="function",e.$q=e.$p?n.origin:void 0,e.$r=A,e.$s=p,e.$t=I,e.$u=r,e.$v=o,e.$w=v;var a;(function(E){function D(){return e.$w}E.value=D;function C(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}E.isDefaultVariant=C;function P(){return e.$w==="en"}E.isDefault=P})(a||(e.Language=a={})),e.$x=y,e.$y=l,e.$z=d,e.$A=typeof n.postMessage=="function"&&!n.importScripts,e.$B=(()=>{if(e.$A){const E=[];n.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let P=0,F=E.length;P<F;P++){const T=E[P];if(T.id===C.data.vscodeScheduleAsyncWork){E.splice(P,1),T.callback();return}}});let D=0;return C=>{const P=++D;E.push({id:P,callback:C}),n.postMessage({vscodeScheduleAsyncWork:P},"*")}}return E=>setTimeout(E)})();var f;(function(E){E[E.Windows=1]="Windows",E[E.Macintosh=2]="Macintosh",E[E.Linux=3]="Linux"})(f||(e.OperatingSystem=f={})),e.OS=O||A?2:N?1:3;let g=!0,w=!1;function S(){if(!w){w=!0;const E=new Uint8Array(2);E[0]=1,E[1]=2,g=new Uint16Array(E.buffer)[0]===513}return g}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function m(E){return parseFloat(E)>=20}}),define(Se[52],De([1,0,12]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let N;const O=globalThis.vscode;if(typeof O<"u"&&typeof O.process<"u"){const R=O.process;N={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return h.$i?"win32":h.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$dc=N.platform,e.$ec=N.arch}),define(Se[16],De([1,0,52]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const N=65,O=97,R=90,M=122,b=46,$=47,k=92,A=58,I=63;class p extends Error{constructor(c,r,a){let f;typeof r=="string"&&r.indexOf("not ")===0?(f="must not be",r=r.replace(/^not /,"")):f="must be";const g=c.indexOf(".")!==-1?"property":"argument";let w=`The "${c}" ${g} ${f} of type ${r}`;w+=`. Received type ${typeof a}`,super(w),this.code="ERR_INVALID_ARG_TYPE"}}function y(t,c){if(t===null||typeof t!="object")throw new p(c,"Object",t)}function v(t,c){if(typeof t!="string")throw new p(c,"string",t)}const l=h.$dc==="win32";function d(t){return t===$||t===k}function o(t){return t===$}function n(t){return t>=N&&t<=R||t>=O&&t<=M}function i(t,c,r,a){let f="",g=0,w=-1,S=0,m=0;for(let E=0;E<=t.length;++E){if(E<t.length)m=t.charCodeAt(E);else{if(a(m))break;m=$}if(a(m)){if(!(w===E-1||S===1))if(S===2){if(f.length<2||g!==2||f.charCodeAt(f.length-1)!==b||f.charCodeAt(f.length-2)!==b){if(f.length>2){const D=f.lastIndexOf(r);D===-1?(f="",g=0):(f=f.slice(0,D),g=f.length-1-f.lastIndexOf(r)),w=E,S=0;continue}else if(f.length!==0){f="",g=0,w=E,S=0;continue}}c&&(f+=f.length>0?`${r}..`:"..",g=2)}else f.length>0?f+=`${r}${t.slice(w+1,E)}`:f=t.slice(w+1,E),g=E-w-1;w=E,S=0}else m===b&&S!==-1?++S:S=-1}return f}function u(t,c){y(c,"pathObject");const r=c.dir||c.root,a=c.base||`${c.name||""}${c.ext||""}`;return r?r===c.root?`${r}${a}`:`${r}${t}${a}`:a}e.$fc={resolve(...t){let c="",r="",a=!1;for(let f=t.length-1;f>=-1;f--){let g;if(f>=0){if(g=t[f],v(g,"path"),g.length===0)continue}else c.length===0?g=h.cwd():(g=h.env[`=${c}`]||h.cwd(),(g===void 0||g.slice(0,2).toLowerCase()!==c.toLowerCase()&&g.charCodeAt(2)===k)&&(g=`${c}\\`));const w=g.length;let S=0,m="",E=!1;const D=g.charCodeAt(0);if(w===1)d(D)&&(S=1,E=!0);else if(d(D))if(E=!0,d(g.charCodeAt(1))){let C=2,P=C;for(;C<w&&!d(g.charCodeAt(C));)C++;if(C<w&&C!==P){const F=g.slice(P,C);for(P=C;C<w&&d(g.charCodeAt(C));)C++;if(C<w&&C!==P){for(P=C;C<w&&!d(g.charCodeAt(C));)C++;(C===w||C!==P)&&(m=`\\\\${F}\\${g.slice(P,C)}`,S=C)}}}else S=1;else n(D)&&g.charCodeAt(1)===A&&(m=g.slice(0,2),S=2,w>2&&d(g.charCodeAt(2))&&(E=!0,S=3));if(m.length>0)if(c.length>0){if(m.toLowerCase()!==c.toLowerCase())continue}else c=m;if(a){if(c.length>0)break}else if(r=`${g.slice(S)}\\${r}`,a=E,E&&c.length>0)break}return r=i(r,!a,"\\",d),a?`${c}\\${r}`:`${c}${r}`||"."},normalize(t){v(t,"path");const c=t.length;if(c===0)return".";let r=0,a,f=!1;const g=t.charCodeAt(0);if(c===1)return o(g)?"\\":t;if(d(g))if(f=!0,d(t.charCodeAt(1))){let S=2,m=S;for(;S<c&&!d(t.charCodeAt(S));)S++;if(S<c&&S!==m){const E=t.slice(m,S);for(m=S;S<c&&d(t.charCodeAt(S));)S++;if(S<c&&S!==m){for(m=S;S<c&&!d(t.charCodeAt(S));)S++;if(S===c)return`\\\\${E}\\${t.slice(m)}\\`;S!==m&&(a=`\\\\${E}\\${t.slice(m,S)}`,r=S)}}}else r=1;else n(g)&&t.charCodeAt(1)===A&&(a=t.slice(0,2),r=2,c>2&&d(t.charCodeAt(2))&&(f=!0,r=3));let w=r<c?i(t.slice(r),!f,"\\",d):"";return w.length===0&&!f&&(w="."),w.length>0&&d(t.charCodeAt(c-1))&&(w+="\\"),a===void 0?f?`\\${w}`:w:f?`${a}\\${w}`:`${a}${w}`},isAbsolute(t){v(t,"path");const c=t.length;if(c===0)return!1;const r=t.charCodeAt(0);return d(r)||c>2&&n(r)&&t.charCodeAt(1)===A&&d(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let c,r;for(let g=0;g<t.length;++g){const w=t[g];v(w,"path"),w.length>0&&(c===void 0?c=r=w:c+=`\\${w}`)}if(c===void 0)return".";let a=!0,f=0;if(typeof r=="string"&&d(r.charCodeAt(0))){++f;const g=r.length;g>1&&d(r.charCodeAt(1))&&(++f,g>2&&(d(r.charCodeAt(2))?++f:a=!1))}if(a){for(;f<c.length&&d(c.charCodeAt(f));)f++;f>=2&&(c=`\\${c.slice(f)}`)}return e.$fc.normalize(c)},relative(t,c){if(v(t,"from"),v(c,"to"),t===c)return"";const r=e.$fc.resolve(t),a=e.$fc.resolve(c);if(r===a||(t=r.toLowerCase(),c=a.toLowerCase(),t===c))return"";let f=0;for(;f<t.length&&t.charCodeAt(f)===k;)f++;let g=t.length;for(;g-1>f&&t.charCodeAt(g-1)===k;)g--;const w=g-f;let S=0;for(;S<c.length&&c.charCodeAt(S)===k;)S++;let m=c.length;for(;m-1>S&&c.charCodeAt(m-1)===k;)m--;const E=m-S,D=w<E?w:E;let C=-1,P=0;for(;P<D;P++){const T=t.charCodeAt(f+P);if(T!==c.charCodeAt(S+P))break;T===k&&(C=P)}if(P!==D){if(C===-1)return a}else{if(E>D){if(c.charCodeAt(S+P)===k)return a.slice(S+P+1);if(P===2)return a.slice(S+P)}w>D&&(t.charCodeAt(f+P)===k?C=P:P===2&&(C=3)),C===-1&&(C=0)}let F="";for(P=f+C+1;P<=g;++P)(P===g||t.charCodeAt(P)===k)&&(F+=F.length===0?"..":"\\..");return S+=C,F.length>0?`${F}${a.slice(S,m)}`:(a.charCodeAt(S)===k&&++S,a.slice(S,m))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const c=e.$fc.resolve(t);if(c.length<=2)return t;if(c.charCodeAt(0)===k){if(c.charCodeAt(1)===k){const r=c.charCodeAt(2);if(r!==I&&r!==b)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(n(c.charCodeAt(0))&&c.charCodeAt(1)===A&&c.charCodeAt(2)===k)return`\\\\?\\${c}`;return t},dirname(t){v(t,"path");const c=t.length;if(c===0)return".";let r=-1,a=0;const f=t.charCodeAt(0);if(c===1)return d(f)?t:".";if(d(f)){if(r=a=1,d(t.charCodeAt(1))){let S=2,m=S;for(;S<c&&!d(t.charCodeAt(S));)S++;if(S<c&&S!==m){for(m=S;S<c&&d(t.charCodeAt(S));)S++;if(S<c&&S!==m){for(m=S;S<c&&!d(t.charCodeAt(S));)S++;if(S===c)return t;S!==m&&(r=a=S+1)}}}}else n(f)&&t.charCodeAt(1)===A&&(r=c>2&&d(t.charCodeAt(2))?3:2,a=r);let g=-1,w=!0;for(let S=c-1;S>=a;--S)if(d(t.charCodeAt(S))){if(!w){g=S;break}}else w=!1;if(g===-1){if(r===-1)return".";g=r}return t.slice(0,g)},basename(t,c){c!==void 0&&v(c,"ext"),v(t,"path");let r=0,a=-1,f=!0,g;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(r=2),c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let w=c.length-1,S=-1;for(g=t.length-1;g>=r;--g){const m=t.charCodeAt(g);if(d(m)){if(!f){r=g+1;break}}else S===-1&&(f=!1,S=g+1),w>=0&&(m===c.charCodeAt(w)?--w===-1&&(a=g):(w=-1,a=S))}return r===a?a=S:a===-1&&(a=t.length),t.slice(r,a)}for(g=t.length-1;g>=r;--g)if(d(t.charCodeAt(g))){if(!f){r=g+1;break}}else a===-1&&(f=!1,a=g+1);return a===-1?"":t.slice(r,a)},extname(t){v(t,"path");let c=0,r=-1,a=0,f=-1,g=!0,w=0;t.length>=2&&t.charCodeAt(1)===A&&n(t.charCodeAt(0))&&(c=a=2);for(let S=t.length-1;S>=c;--S){const m=t.charCodeAt(S);if(d(m)){if(!g){a=S+1;break}continue}f===-1&&(g=!1,f=S+1),m===b?r===-1?r=S:w!==1&&(w=1):r!==-1&&(w=-1)}return r===-1||f===-1||w===0||w===1&&r===f-1&&r===a+1?"":t.slice(r,f)},format:u.bind(null,"\\"),parse(t){v(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const r=t.length;let a=0,f=t.charCodeAt(0);if(r===1)return d(f)?(c.root=c.dir=t,c):(c.base=c.name=t,c);if(d(f)){if(a=1,d(t.charCodeAt(1))){let C=2,P=C;for(;C<r&&!d(t.charCodeAt(C));)C++;if(C<r&&C!==P){for(P=C;C<r&&d(t.charCodeAt(C));)C++;if(C<r&&C!==P){for(P=C;C<r&&!d(t.charCodeAt(C));)C++;C===r?a=C:C!==P&&(a=C+1)}}}}else if(n(f)&&t.charCodeAt(1)===A){if(r<=2)return c.root=c.dir=t,c;if(a=2,d(t.charCodeAt(2))){if(r===3)return c.root=c.dir=t,c;a=3}}a>0&&(c.root=t.slice(0,a));let g=-1,w=a,S=-1,m=!0,E=t.length-1,D=0;for(;E>=a;--E){if(f=t.charCodeAt(E),d(f)){if(!m){w=E+1;break}continue}S===-1&&(m=!1,S=E+1),f===b?g===-1?g=E:D!==1&&(D=1):g!==-1&&(D=-1)}return S!==-1&&(g===-1||D===0||D===1&&g===S-1&&g===w+1?c.base=c.name=t.slice(w,S):(c.name=t.slice(w,g),c.base=t.slice(w,S),c.ext=t.slice(g,S))),w>0&&w!==a?c.dir=t.slice(0,w-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(l){const t=/\\/g;return()=>{const c=h.cwd().replace(t,"/");return c.slice(c.indexOf("/"))}}return()=>h.cwd()})();e.$gc={resolve(...t){let c="",r=!1;for(let a=t.length-1;a>=-1&&!r;a--){const f=a>=0?t[a]:s();v(f,"path"),f.length!==0&&(c=`${f}/${c}`,r=f.charCodeAt(0)===$)}return c=i(c,!r,"/",o),r?`/${c}`:c.length>0?c:"."},normalize(t){if(v(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===$,r=t.charCodeAt(t.length-1)===$;return t=i(t,!c,"/",o),t.length===0?c?"/":r?"./":".":(r&&(t+="/"),c?`/${t}`:t)},isAbsolute(t){return v(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let c;for(let r=0;r<t.length;++r){const a=t[r];v(a,"path"),a.length>0&&(c===void 0?c=a:c+=`/${a}`)}return c===void 0?".":e.$gc.normalize(c)},relative(t,c){if(v(t,"from"),v(c,"to"),t===c||(t=e.$gc.resolve(t),c=e.$gc.resolve(c),t===c))return"";const r=1,a=t.length,f=a-r,g=1,w=c.length-g,S=f<w?f:w;let m=-1,E=0;for(;E<S;E++){const C=t.charCodeAt(r+E);if(C!==c.charCodeAt(g+E))break;C===$&&(m=E)}if(E===S)if(w>S){if(c.charCodeAt(g+E)===$)return c.slice(g+E+1);if(E===0)return c.slice(g+E)}else f>S&&(t.charCodeAt(r+E)===$?m=E:E===0&&(m=0));let D="";for(E=r+m+1;E<=a;++E)(E===a||t.charCodeAt(E)===$)&&(D+=D.length===0?"..":"/..");return`${D}${c.slice(g+m)}`},toNamespacedPath(t){return t},dirname(t){if(v(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===$;let r=-1,a=!0;for(let f=t.length-1;f>=1;--f)if(t.charCodeAt(f)===$){if(!a){r=f;break}}else a=!1;return r===-1?c?"/":".":c&&r===1?"//":t.slice(0,r)},basename(t,c){c!==void 0&&v(c,"ext"),v(t,"path");let r=0,a=-1,f=!0,g;if(c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let w=c.length-1,S=-1;for(g=t.length-1;g>=0;--g){const m=t.charCodeAt(g);if(m===$){if(!f){r=g+1;break}}else S===-1&&(f=!1,S=g+1),w>=0&&(m===c.charCodeAt(w)?--w===-1&&(a=g):(w=-1,a=S))}return r===a?a=S:a===-1&&(a=t.length),t.slice(r,a)}for(g=t.length-1;g>=0;--g)if(t.charCodeAt(g)===$){if(!f){r=g+1;break}}else a===-1&&(f=!1,a=g+1);return a===-1?"":t.slice(r,a)},extname(t){v(t,"path");let c=-1,r=0,a=-1,f=!0,g=0;for(let w=t.length-1;w>=0;--w){const S=t.charCodeAt(w);if(S===$){if(!f){r=w+1;break}continue}a===-1&&(f=!1,a=w+1),S===b?c===-1?c=w:g!==1&&(g=1):c!==-1&&(g=-1)}return c===-1||a===-1||g===0||g===1&&c===a-1&&c===r+1?"":t.slice(c,a)},format:u.bind(null,"/"),parse(t){v(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const r=t.charCodeAt(0)===$;let a;r?(c.root="/",a=1):a=0;let f=-1,g=0,w=-1,S=!0,m=t.length-1,E=0;for(;m>=a;--m){const D=t.charCodeAt(m);if(D===$){if(!S){g=m+1;break}continue}w===-1&&(S=!1,w=m+1),D===b?f===-1?f=m:E!==1&&(E=1):f!==-1&&(E=-1)}if(w!==-1){const D=g===0&&r?1:g;f===-1||E===0||E===1&&f===w-1&&f===g+1?c.base=c.name=t.slice(D,w):(c.name=t.slice(D,f),c.base=t.slice(D,w),c.ext=t.slice(f,w))}return g>0?c.dir=t.slice(0,g-1):r&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=l?e.$fc.normalize:e.$gc.normalize,e.$ic=l?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=l?e.$fc.join:e.$gc.join,e.$kc=l?e.$fc.resolve:e.$gc.resolve,e.$lc=l?e.$fc.relative:e.$gc.relative,e.$mc=l?e.$fc.dirname:e.$gc.dirname,e.$nc=l?e.$fc.basename:e.$gc.basename,e.$oc=l?e.$fc.extname:e.$gc.extname,e.$pc=l?e.$fc.format:e.$gc.format,e.$qc=l?e.$fc.parse:e.$gc.parse,e.$rc=l?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=l?e.$fc.sep:e.$gc.sep,e.$tc=l?e.$fc.delimiter:e.$gc.delimiter}),define(Se[132],De([1,0,46,16]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=b,e.$hr=$,e.$ir=k,e.$jr=A,e.$kr=I,e.$lr=p,e.$mr=y,e.$nr=v,e.$or=l,e.$pr=d,e.$qr=f,e.$rr=g,e.$sr=w;const O=new h.$V(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),R=new h.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new h.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(S,m,E=!1){const D=S||"",C=m||"",P=O.value.collator.compare(D,C);return O.value.collatorIsNumeric&&P===0&&D!==C?D<C?-1:1:P}function $(S,m){const E=R.value.collator;return S=S||"",m=m||"",u(E,S,m)}function k(S,m){const E=R.value.collator;return S=S||"",m=m||"",r(S,m)||u(E,S,m)}function A(S,m){const E=R.value.collator;return S=S||"",m=m||"",c(S,m)||u(E,S,m)}function I(S,m){return S=S||"",m=m||"",S===m?0:S<m?-1:1}function p(S,m){const[E,D]=n(S),[C,P]=n(m);let F=O.value.collator.compare(D,P);if(F===0){if(O.value.collatorIsNumeric&&D!==P)return D<P?-1:1;if(F=O.value.collator.compare(E,C),O.value.collatorIsNumeric&&F===0&&E!==C)return E<C?-1:1}return F}function y(S,m){S=S||"",m=m||"";const E=i(S),D=i(m),C=R.value.collator,P=M.value.collator;return u(P,E,D)||u(C,S,m)}function v(S,m){S=S||"",m=m||"";const E=i(S),D=i(m),C=R.value.collator,P=M.value.collator;return u(P,E,D)||r(S,m)||u(C,S,m)}function l(S,m){S=S||"",m=m||"";const E=i(S),D=i(m),C=R.value.collator,P=M.value.collator;return u(P,E,D)||c(S,m)||u(C,S,m)}function d(S,m){S=S||"",m=m||"";const E=i(S).toLowerCase(),D=i(m).toLowerCase();return E!==D?E<D?-1:1:S!==m?S<m?-1:1:0}const o=/^(.*?)(\.([^.]*))?$/;function n(S,m=!1){const E=S?o.exec(S):[];let D=[E&&E[1]||"",E&&E[3]||""];return m&&(!D[0]&&D[1]||D[0]&&D[0].charAt(0)===".")&&(D=[D[0]+"."+D[1],""]),D}function i(S){const m=S?o.exec(S):[];return m&&m[1]&&m[1].charAt(0)!=="."&&m[3]||""}function u(S,m,E){const D=S.compare(m,E);return D!==0?D:m.length!==E.length?m.length<E.length?-1:1:0}function s(S){const m=S.charAt(0);return m.toLocaleUpperCase()!==m}function t(S){const m=S.charAt(0);return m.toLocaleLowerCase()!==m}function c(S,m){return s(S)&&t(m)?-1:t(S)&&s(m)?1:0}function r(S,m){return t(S)&&s(m)?-1:s(S)&&t(m)?1:0}function a(S,m,E=!1){return E||(S=S&&S.toLowerCase(),m=m&&m.toLowerCase()),S===m?0:S<m?-1:1}function f(S,m,E=!1){const D=S.split(N.sep),C=m.split(N.sep),P=D.length-1,F=C.length-1;let T,z;for(let L=0;;L++){if(T=P===L,z=F===L,T&&z)return b(D[L],C[L],E);if(T)return-1;if(z)return 1;const j=a(D[L],C[L],E);if(j!==0)return j}}function g(S,m,E){const D=S.toLowerCase(),C=m.toLowerCase(),P=w(S,m,E);if(P)return P;const F=D.endsWith(E),T=C.endsWith(E);if(F!==T)return F?-1:1;const z=b(D,C);return z!==0?z:D.localeCompare(C)}function w(S,m,E){const D=S.toLowerCase(),C=m.toLowerCase(),P=D.startsWith(E),F=C.startsWith(E);if(P!==F)return P?-1:1;if(P&&F){if(D.length<C.length)return-1;if(D.length>C.length)return 1}return 0}}),define(Se[31],De([1,0,16,12,14,18]),function(he,e,h,N,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=M,e.$pg=b,e.$qg=$,e.$rg=k,e.$sg=A,e.$tg=v,e.$ug=l,e.$vg=d,e.$wg=o,e.$xg=n,e.$yg=i,e.$zg=u,e.$Ag=s,e.$Bg=t,e.$Cg=c,e.$Dg=r,e.$Eg=g;function M(w){return w===47||w===92}function b(w){return w.replace(/[\\/]/g,h.$gc.sep)}function $(w){return w.indexOf("/")===-1&&(w=b(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}function k(w,S=h.$gc.sep){if(!w)return"";const m=w.length,E=w.charCodeAt(0);if(M(E)){if(M(w.charCodeAt(1))&&!M(w.charCodeAt(2))){let C=3;const P=C;for(;C<m&&!M(w.charCodeAt(C));C++);if(P!==C&&!M(w.charCodeAt(C+1))){for(C+=1;C<m;C++)if(M(w.charCodeAt(C)))return w.slice(0,C+1).replace(/[\\/]/g,S)}}return S}else if(o(E)&&w.charCodeAt(1)===58)return M(w.charCodeAt(2))?w.slice(0,2)+S:w.slice(0,2);let D=w.indexOf("://");if(D!==-1){for(D+=3;D<m;D++)if(M(w.charCodeAt(D)))return w.slice(0,D+1)}return""}function A(w){if(!N.$i||!w||w.length<5)return!1;let S=w.charCodeAt(0);if(S!==92||(S=w.charCodeAt(1),S!==92))return!1;let m=2;const E=m;for(;m<w.length&&(S=w.charCodeAt(m),S!==92);m++);return!(E===m||(S=w.charCodeAt(m+1),isNaN(S)||S===92))}const I=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(w,S=N.$i){const m=S?I:p;return!(!w||w.length===0||/^\s+$/.test(w)||(m.lastIndex=0,m.test(w))||S&&y.test(w)||w==="."||w===".."||S&&w[w.length-1]==="."||S&&w.length!==w.trim().length||w.length>255)}function l(w,S,m){const E=w===S;return!m||E?E:!w||!S?!1:(0,O.$xf)(w,S)}function d(w,S,m,E=h.sep){if(w===S)return!0;if(!w||!S||S.length>w.length)return!1;if(m){if(!(0,O.$yf)(w,S))return!1;if(S.length===w.length)return!0;let C=S.length;return S.charAt(S.length-1)===E&&C--,w.charAt(C)===E}return S.charAt(S.length-1)!==E&&(S+=E),w.indexOf(S)===0}function o(w){return w>=65&&w<=90||w>=97&&w<=122}function n(w,S){return N.$i&&w.endsWith(":")&&(w+=h.sep),(0,h.$ic)(w)||(w=(0,h.$jc)(S,w)),w=(0,h.$hc)(w),i(w)}function i(w){return N.$i?(w=(0,O.$ff)(w,h.sep),w.endsWith(":")&&(w+=h.sep)):(w=(0,O.$ff)(w,h.sep),w||(w=h.sep)),w}function u(w){const S=(0,h.$hc)(w);return N.$i?w.length>3?!1:s(S)&&(w.length===2||S.charCodeAt(2)===92):S===h.$gc.sep}function s(w,S=N.$i){return S?o(w.charCodeAt(0))&&w.charCodeAt(1)===58:!1}function t(w,S=N.$i){return s(w,S)?w[0]:void 0}function c(w,S,m){return S.length>w.length?-1:w===S?0:(m&&(w=w.toLowerCase(),S=S.toLowerCase()),w.indexOf(S))}function r(w){const S=w.split(":");let m,E,D;for(const C of S){const P=Number(C);(0,R.$ag)(P)?E===void 0?E=P:D===void 0&&(D=P):m=m?[m,C].join(":"):C}if(!m)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:m,line:E!==void 0?E:void 0,column:D!==void 0?D:E!==void 0?1:void 0}}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",f="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function g(w,S,m=8){let E="";for(let C=0;C<m;C++){let P;C===0&&N.$i&&!S&&(m===3||m===4)?P=f:P=a,E+=P.charAt(Math.floor(Math.random()*P.length))}let D;return S?D=`${S}-${E}`:D=E,w?(0,h.$jc)(w,D):D}}),define(Se[133],De([1,0,132,127,57,16,12,14]),function(he,e,h,N,O,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=A,e.$ur=d,e.$vr=r,e.$wr=E,e.$xr=z,e.$yr=j;const $=0,k=[$,[]];function A(U,X,ie,q){if(!U||!X)return k;const G=U.length,x=X.length;if(G<x)return k;const ne=U.toLowerCase();return I(X,ie,x,U,ne,G,q)}function I(U,X,ie,q,G,x,ne){const be=[],ae=[];for(let _=0;_<ie;_++){const pe=_*x,ue=pe-x,ce=_>0,oe=U[_],le=X[_];for(let K=0;K<x;K++){const se=K>0,$e=pe+K,ve=$e-1,Me=ue+K-1,ge=se?be[ve]:0,Ae=ce&&se?be[Me]:0,Re=ce&&se?ae[Me]:0;let je;!Ae&&ce?je=0:je=p(oe,le,q,G,K,Re),je&&Ae+je>=ge&&(ne||ce||G.startsWith(X,K))?(ae[$e]=Re+1,be[$e]=Ae+je):(ae[$e]=$,be[$e]=ge)}}const Ie=[];let ee=ie-1,B=x-1;for(;ee>=0&&B>=0;){const _=ee*x+B;ae[_]===$||(Ie.push(B),ee--),B--}return[be[ie*x-1],Ie.reverse()]}function p(U,X,ie,q,G,x){let ne=0;if(!y(X,q[G]))return ne;if(ne+=1,x>0&&(ne+=x*5),U===ie[G]&&(ne+=1),G===0)ne+=8;else{const be=v(ie.charCodeAt(G-1));be?ne+=be:(0,N.$Bk)(ie.charCodeAt(G))&&x===0&&(ne+=2)}return ne}function y(U,X){return U===X?!0:U==="/"||U==="\\"?X==="/"||X==="\\":!1}function v(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const l=[void 0,[]];function d(U,X,ie=0,q=0){const G=X;return G.values&&G.values.length>1?o(U,G.values,ie,q):n(U,X,ie,q)}function o(U,X,ie,q){let G=0;const x=[];for(const ne of X){const[be,ae]=n(U,ne,ie,q);if(typeof be!="number")return l;G+=be,x.push(...ae)}return[G,S(x)]}function n(U,X,ie,q){const G=(0,N.$Kk)(X.original,X.originalLowercase,ie,U,U.toLowerCase(),q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return G?[G[0],(0,N.$Hk)(G)]:l}const i=Object.freeze({score:0}),u=1<<18,s=1<<17,t=65536;function c(U,X,ie,q){const G=q.values?q.values:[q];return(0,O.$kj)({[q.normalized]:{values:G.map(ne=>({value:ne.normalized,expectContiguousMatch:ne.expectContiguousMatch})),label:U,description:X,allowNonContiguousMatches:ie}})}function r(U,X,ie,q,G){if(!U||!X.normalized)return i;const x=q.getItemLabel(U);if(!x)return i;const ne=q.getItemDescription(U),be=c(x,ne,ie,X),ae=G[be];if(ae)return ae;const Ie=a(x,ne,q.getItemPath(U),X,ie);return G[be]=Ie,Ie}function a(U,X,ie,q,G){const x=!ie||!q.containsPathSeparator;return ie&&(M.$k?q.pathNormalized===ie:(0,b.$xf)(q.pathNormalized,ie))?{score:u,labelMatch:[{start:0,end:U.length}],descriptionMatch:X?[{start:0,end:X.length}]:void 0}:q.values&&q.values.length>1?f(U,X,ie,q.values,x,G):g(U,X,ie,q,x,G)}function f(U,X,ie,q,G,x){let ne=0;const be=[],ae=[];for(const Ie of q){const{score:ee,labelMatch:B,descriptionMatch:_}=g(U,X,ie,Ie,G,x);if(ee===$)return i;ne+=ee,B&&be.push(...B),_&&ae.push(..._)}return{score:ne,labelMatch:S(be),descriptionMatch:S(ae)}}function g(U,X,ie,q,G,x){if(G||!X){const[ne,be]=A(U,q.normalized,q.normalizedLowercase,x&&!q.expectContiguousMatch);if(ne){const ae=(0,N.$yk)(q.normalized,U);let Ie;if(ae){Ie=s;const ee=Math.round(q.normalized.length/U.length*100);Ie+=ee}else Ie=t;return{score:Ie+ne,labelMatch:ae||w(be)}}}if(X){let ne=X;ie&&(ne=`${X}${R.sep}`);const be=ne.length,ae=`${ne}${U}`,[Ie,ee]=A(ae,q.normalized,q.normalizedLowercase,x&&!q.expectContiguousMatch);if(Ie){const B=w(ee),_=[],pe=[];return B.forEach(ue=>{ue.start<be&&ue.end>be?(_.push({start:0,end:ue.end-be}),pe.push({start:ue.start,end:be})):ue.start>=be?_.push({start:ue.start-be,end:ue.end-be}):pe.push(ue)}),{score:Ie,labelMatch:_,descriptionMatch:pe}}}return i}function w(U){const X=[];if(!U)return X;let ie;for(const q of U)ie&&ie.end===q?ie.end+=1:(ie={start:q,end:q+1},X.push(ie));return X}function S(U){const X=U.sort((G,x)=>G.start-x.start),ie=[];let q;for(const G of X)!q||!m(q,G)?(q=G,ie.push(G)):(q.start=Math.min(q.start,G.start),q.end=Math.max(q.end,G.end));return ie}function m(U,X){return!(U.end<X.start||X.end<U.start)}function E(U,X,ie,q,G,x){const ne=r(U,ie,q,G,x),be=r(X,ie,q,G,x),ae=ne.score,Ie=be.score;if((ae===u||Ie===u)&&ae!==Ie)return ae===u?-1:1;if(ae>t||Ie>t){if(ae!==Ie)return ae>Ie?-1:1;if(ae<s&&Ie<s){const oe=C(ne.labelMatch,be.labelMatch);if(oe!==0)return oe}const ue=G.getItemLabel(U)||"",ce=G.getItemLabel(X)||"";if(ue.length!==ce.length)return ue.length-ce.length}if(ae!==Ie)return ae>Ie?-1:1;const ee=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0,B=Array.isArray(be.labelMatch)&&be.labelMatch.length>0;if(ee&&!B)return-1;if(B&&!ee)return 1;const _=D(U,ne,G),pe=D(X,be,G);return _&&pe&&_!==pe?pe>_?-1:1:P(U,X,ie,G)}function D(U,X,ie){let q=-1,G=-1;if(X.descriptionMatch&&X.descriptionMatch.length?q=X.descriptionMatch[0].start:X.labelMatch&&X.labelMatch.length&&(q=X.labelMatch[0].start),X.labelMatch&&X.labelMatch.length){if(G=X.labelMatch[X.labelMatch.length-1].end,X.descriptionMatch&&X.descriptionMatch.length){const x=ie.getItemDescription(U);x&&(G+=x.length)}}else X.descriptionMatch&&X.descriptionMatch.length&&(G=X.descriptionMatch[X.descriptionMatch.length-1].end);return G-q}function C(U,X){if(!U&&!X||(!U||!U.length)&&(!X||!X.length))return 0;if(!X||!X.length)return-1;if(!U||!U.length)return 1;const ie=U[0].start,G=U[U.length-1].end-ie,x=X[0].start,be=X[X.length-1].end-x;return G===be?0:be<G?1:-1}function P(U,X,ie,q){const G=q.getItemLabel(U)||"",x=q.getItemLabel(X)||"",ne=q.getItemDescription(U),be=q.getItemDescription(X),ae=G.length+(ne?ne.length:0),Ie=x.length+(be?be.length:0);if(ae!==Ie)return ae-Ie;const ee=q.getItemPath(U),B=q.getItemPath(X);return ee&&B&&ee.length!==B.length?ee.length-B.length:G!==x?(0,h.$rr)(G,x,ie.normalized):ne&&be&&ne!==be?(0,h.$rr)(ne,be,ie.normalized):ee&&B&&ee!==B?(0,h.$rr)(ee,B,ie.normalized):0}function F(U){return U.startsWith('"')&&U.endsWith('"')}const T=" ";function z(U){typeof U!="string"&&(U="");const X=U.toLowerCase(),{pathNormalized:ie,normalized:q,normalizedLowercase:G}=L(U),x=ie.indexOf(R.sep)>=0,ne=F(U);let be;const ae=U.split(T);if(ae.length>1)for(const Ie of ae){const ee=F(Ie),{pathNormalized:B,normalized:_,normalizedLowercase:pe}=L(Ie);_&&(be||(be=[]),be.push({original:Ie,originalLowercase:Ie.toLowerCase(),pathNormalized:B,normalized:_,normalizedLowercase:pe,expectContiguousMatch:ee}))}return{original:U,originalLowercase:X,pathNormalized:ie,normalized:q,normalizedLowercase:G,values:be,containsPathSeparator:x,expectContiguousMatch:ne}}function L(U){let X;M.$i?X=U.replace(/\//g,R.sep):X=U.replace(/\\/g,R.sep);const ie=(0,b.$hf)(X).replace(/\s|"/g,"");return{pathNormalized:X,normalized:ie,normalizedLowercase:ie.toLowerCase()}}function j(U){return Array.isArray(U)?z(U.map(X=>X.original).join(T)):z(U.original)}}),define(Se[101],De([1,0,16]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0,e.$Rs=R,e.$Ss=M,e.$Ts=b,e.$Us=k,e.$Qs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},O={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(A){const I=(0,h.$oc)(A),p=N[I.toLowerCase()];return p!==void 0?p:M(A)}function M(A){const I=(0,h.$oc)(A);return O[I.toLowerCase()]}function b(A){for(const I in O)if(O[I]===A)return I}const $=/^(.+)\/(.+?)(;.+)?$/;function k(A,I){const p=$.exec(A);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:I?void 0:A}}),define(Se[102],De([1,0,12]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$mm=R,e.$nm=M;var N;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(N||(e.Source=N={}));var O;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(O||(e.TerminateResponseCode=O={}));function R(b,...$){const k=$.reduce((p,y)=>(p[y]=!0,p),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(p=>!k[p]).forEach(p=>{for(let y=0;y<A.length;y++)if(p.search(A[y])!==-1){delete b[p];break}})}function M(b){b&&(delete b.DEBUG,h.$j&&delete b.DYLD_LIBRARY_PATH,h.$k&&delete b.LD_PRELOAD)}}),define(Se[2],De([1,0,16,12]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=v,e.$wc=u;const O=/^\w[\w\d+.-]*$/,R=/^\//,M=/^\/\//;function b(a,f){if(!a.scheme&&f)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!O.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!R.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(a,f){return!a&&!f?"file":a}function k(a,f){switch(a){case"https":case"http":case"file":f?f[0]!==I&&(f=I+f):f=I;break}return f}const A="",I="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(f){return f instanceof y?!0:f?typeof f.authority=="string"&&typeof f.fragment=="string"&&typeof f.path=="string"&&typeof f.query=="string"&&typeof f.scheme=="string"&&typeof f.fsPath=="string"&&typeof f.with=="function"&&typeof f.toString=="function":!1}constructor(f,g,w,S,m,E=!1){typeof f=="object"?(this.scheme=f.scheme||A,this.authority=f.authority||A,this.path=f.path||A,this.query=f.query||A,this.fragment=f.fragment||A):(this.scheme=$(f,E),this.authority=g||A,this.path=k(this.scheme,w||A),this.query=S||A,this.fragment=m||A,b(this,E))}get fsPath(){return u(this,!1)}with(f){if(!f)return this;let{scheme:g,authority:w,path:S,query:m,fragment:E}=f;return g===void 0?g=this.scheme:g===null&&(g=A),w===void 0?w=this.authority:w===null&&(w=A),S===void 0?S=this.path:S===null&&(S=A),m===void 0?m=this.query:m===null&&(m=A),E===void 0?E=this.fragment:E===null&&(E=A),g===this.scheme&&w===this.authority&&S===this.path&&m===this.query&&E===this.fragment?this:new d(g,w,S,m,E)}static parse(f,g=!1){const w=p.exec(f);return w?new d(w[2]||A,r(w[4]||A),r(w[5]||A),r(w[7]||A),r(w[9]||A),g):new d(A,A,A,A,A)}static file(f){let g=A;if(N.$i&&(f=f.replace(/\\/g,I)),f[0]===I&&f[1]===I){const w=f.indexOf(I,2);w===-1?(g=f.substring(2),f=I):(g=f.substring(2,w),f=f.substring(w)||I)}return new d("file",g,f,A,A)}static from(f,g){return new d(f.scheme,f.authority,f.path,f.query,f.fragment,g)}static joinPath(f,...g){if(!f.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return N.$i&&f.scheme==="file"?w=y.file(h.$fc.join(u(f,!0),...g)).path:w=h.$gc.join(f.path,...g),f.with({path:w})}toString(f=!1){return s(this,f)}toJSON(){return this}static revive(f){if(f){if(f instanceof y)return f;{const g=new d(f);return g._formatted=f.external??null,g._fsPath=f._sep===l?f.fsPath??null:null,g}}else return f}}e.URI=y;function v(a){return!a||typeof a!="object"?!1:typeof a.scheme=="string"&&(typeof a.authority=="string"||typeof a.authority>"u")&&(typeof a.path=="string"||typeof a.path>"u")&&(typeof a.query=="string"||typeof a.query>"u")&&(typeof a.fragment=="string"||typeof a.fragment>"u")}const l=N.$i?1:void 0;class d extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(f=!1){return f?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const f={$mid:1};return this._fsPath&&(f.fsPath=this._fsPath,f._sep=l),this._formatted&&(f.external=this._formatted),this.path&&(f.path=this.path),this.scheme&&(f.scheme=this.scheme),this.authority&&(f.authority=this.authority),this.query&&(f.query=this.query),this.fragment&&(f.fragment=this.fragment),f}}const o={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function n(a,f,g){let w,S=-1;for(let m=0;m<a.length;m++){const E=a.charCodeAt(m);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||f&&E===47||g&&E===91||g&&E===93||g&&E===58)S!==-1&&(w+=encodeURIComponent(a.substring(S,m)),S=-1),w!==void 0&&(w+=a.charAt(m));else{w===void 0&&(w=a.substr(0,m));const D=o[E];D!==void 0?(S!==-1&&(w+=encodeURIComponent(a.substring(S,m)),S=-1),w+=D):S===-1&&(S=m)}}return S!==-1&&(w+=encodeURIComponent(a.substring(S))),w!==void 0?w:a}function i(a){let f;for(let g=0;g<a.length;g++){const w=a.charCodeAt(g);w===35||w===63?(f===void 0&&(f=a.substr(0,g)),f+=o[w]):f!==void 0&&(f+=a[g])}return f!==void 0?f:a}function u(a,f){let g;return a.authority&&a.path.length>1&&a.scheme==="file"?g=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?f?g=a.path.substr(1):g=a.path[1].toLowerCase()+a.path.substr(2):g=a.path,N.$i&&(g=g.replace(/\//g,"\\")),g}function s(a,f){const g=f?i:n;let w="",{scheme:S,authority:m,path:E,query:D,fragment:C}=a;if(S&&(w+=S,w+=":"),(m||S==="file")&&(w+=I,w+=I),m){let P=m.indexOf("@");if(P!==-1){const F=m.substr(0,P);m=m.substr(P+1),P=F.lastIndexOf(":"),P===-1?w+=g(F,!1,!1):(w+=g(F.substr(0,P),!1,!1),w+=":",w+=g(F.substr(P+1),!1,!0)),w+="@"}m=m.toLowerCase(),P=m.lastIndexOf(":"),P===-1?w+=g(m,!1,!0):(w+=g(m.substr(0,P),!1,!0),w+=m.substr(P))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const P=E.charCodeAt(1);P>=65&&P<=90&&(E=`/${String.fromCharCode(P+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const P=E.charCodeAt(0);P>=65&&P<=90&&(E=`${String.fromCharCode(P+32)}:${E.substr(2)}`)}w+=g(E,!0,!1)}return D&&(w+="?",w+=g(D,!1,!1)),C&&(w+="#",w+=f?C:n(C,!1,!1)),w}function t(a){try{return decodeURIComponent(a)}catch{return a.length>3?a.substr(0,3)+t(a.substr(3)):a}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(a){return a.match(c)?a.replace(c,f=>t(f)):a}}),define(Se[197],De([1,0,2]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=N,e.$Wq=O,e.$Xq=R,e.log=b;function N(k){const A=k;return A&&typeof A.type=="string"&&typeof A.severity=="string"}function O(k){const A=[];let I;try{const p=JSON.parse(k.arguments),y=p[p.length-1];y&&y.__$stack&&(p.pop(),I=y.__$stack),A.push(...p)}catch{A.push("Unable to log remote console arguments",k.arguments)}return{args:A,stack:I}}function R(k){if(typeof k!="string")return R(O(k).stack);const A=k;if(A){const I=M(A),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(p&&p.length===4)return{uri:h.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}function M(k){if(!k)return k;const A=k.indexOf(`
`);return A===-1?k:k.substring(0,A)}function b(k,A){const{args:I,stack:p}=O(k),y=typeof I[0]=="string"&&I.length===1;let v=M(p);v&&(v=`(${v.trim()})`);let l=[];if(typeof I[0]=="string"?v&&y?l=[`%c[${A}] %c${I[0]} %c${v}`,$("blue"),$(""),$("grey")]:l=[`%c[${A}] %c${I[0]}`,$("blue"),$(""),...I.slice(1)]:l=[`%c[${A}]%`,$("blue"),...I],v&&!y&&l.push(v),typeof console[k.severity]!="function")throw new Error("Unknown console method");console[k.severity].apply(console,l)}function $(k){return`color: ${k}`}}),define(Se[58],De([1,0,21,2]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=O,e.$5h=R,e.$6h=b;function O($){return JSON.stringify($,M)}function R($){let k=JSON.parse($);return k=b(k),k}function M($,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:k.flags}:k}function b($,k=0){if(!$||k>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return N.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof h.$Fe||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let A=0;A<$.length;++A)$[A]=b($[A],k+1);else for(const A in $)Object.hasOwnProperty.call($,A)&&($[A]=b($[A],k+1))}return $}}),define(Se[15],De([1,0,13,12,14,2,16]),function(he,e,h,N,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Jg=e.$Ig=e.$Hg=e.Schemas=void 0,e.$Fg=$,e.$Gg=k,e.$Kg=I;var b;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatCodeBlock="vscode-chat-code-block",v.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm",v.commentsInput="comment",v.codeSetting="code-setting"})(b||(e.Schemas=b={}));function $(v,l){return R.URI.isUri(v)?(0,O.$xf)(v.scheme,l):(0,O.$yf)(v,l+":")}function k(v,...l){return l.some(d=>$(v,d))}e.$Hg="vscode-tkn",e.$Ig="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(l){this.d=l}setDelegate(l){this.e=l}setServerRootPath(l,d){this.f=I(l,d)}getServerRootPath(){return this.f}get g(){return M.$gc.join(this.f,b.vscodeRemoteResource)}set(l,d,o){this.a[l]=d,this.b[l]=o}setConnectionToken(l,d){this.c[l]=d}getPreferredWebSchema(){return this.d}rewrite(l){if(this.e)try{return this.e(l)}catch(s){return h.$1(s),l}const d=l.authority;let o=this.a[d];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const n=this.b[d],i=this.c[d];let u=`path=${encodeURIComponent(l.path)}`;return typeof i=="string"&&(u+=`&${e.$Ig}=${encodeURIComponent(i)}`),R.URI.from({scheme:N.$o?this.d:b.vscodeRemoteResource,authority:`${o}:${n}`,path:this.g,query:u})}}e.$Jg=new A;function I(v,l){return M.$gc.join(l??"/",`${v.quality??"oss"}-${v.commit??"dev"}`)}e.$Lg="vs/../../extensions",e.$Mg="vs/../../node_modules",e.$Ng="vs/../../node_modules.asar",e.$Og="vs/../../node_modules.asar.unpacked",e.$Pg="vscode-app";class p{static{this.a=e.$Pg}asBrowserUri(l){const d=this.b(l,he);return this.uriToBrowserUri(d)}uriToBrowserUri(l){return l.scheme===b.vscodeRemote?e.$Jg.rewrite(l):l.scheme===b.file&&(N.$m||N.$q===`${b.vscodeFileResource}://${p.a}`)?l.with({scheme:b.vscodeFileResource,authority:l.authority||p.a,query:null,fragment:null}):l}asFileUri(l){const d=this.b(l,he);return this.uriToFileUri(d)}uriToFileUri(l){return l.scheme===b.vscodeFileResource?l.with({scheme:b.file,authority:l.authority!==p.a?l.authority:null,query:null,fragment:null}):l}b(l,d){return R.URI.isUri(l)?l:R.URI.parse(d.toUrl(l))}}e.$Qg=new p;var y;(function(v){const l=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(l.get("3"));const d="vscode-coi";function o(i){let u;typeof i=="string"?u=new URL(i).searchParams:i instanceof URL?u=i.searchParams:R.URI.isUri(i)&&(u=new URL(i.toString(!0)).searchParams);const s=u?.get(d);if(s)return l.get(s)}v.getHeadersFromQuery=o;function n(i,u,s){if(!globalThis.crossOriginIsolated)return;const t=u&&s?"3":s?"2":"1";i instanceof URLSearchParams?i.set(d,t):i[d]=t}v.addSearchParam=n})(y||(e.COI=y={}))}),define(Se[198],De([1,0,163,15,12,2]),function(he,e,h,N,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8D=A;class M{constructor(p,y,v){this.id=p,this.dependencies=y,this.callback=v}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,y,v)=>{typeof p!="string"&&(v=y,y=p,p=null),(typeof y!="object"||!Array.isArray(y))&&(v=y,y=null),this.c.push(new M(p,y,v))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const y=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!y)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(y.dependencies)&&y.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${y.dependencies.join(", ")}`);return typeof y.callback=="function"?y.callback([]):y.callback}h(p){return new Promise((y,v)=>{const l=document.createElement("script");l.setAttribute("async","async"),l.setAttribute("type","text/javascript");const d=()=>{l.removeEventListener("load",o),l.removeEventListener("error",n)},o=i=>{d(),y(this.c.pop())},n=i=>{d(),v(i)};l.addEventListener("load",o),l.addEventListener("error",n),this.f&&(p=this.f.createScriptURL(p)),l.setAttribute("src",p),window.document.getElementsByTagName("head")[0].appendChild(l)})}i(p){return new Promise((y,v)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),y(this.c.pop())}catch(l){v(l)}})}async j(p){try{const y=globalThis._VSCODE_NODE_MODULES.fs,v=globalThis._VSCODE_NODE_MODULES.vm,l=globalThis._VSCODE_NODE_MODULES.module,d=R.URI.parse(p).fsPath,o=y.readFileSync(d).toString(),n=l.wrap(o.replace(/^#!.*/,""));return new v.Script(n).runInThisContext().apply(),this.c.pop()}catch(y){throw y}}}const $=new Map;let k={};typeof globalThis.require=="object"&&(k=globalThis.require.paths??{});async function A(I,p,y){if(h.$T){y===void 0&&(y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),k[I]&&(I=k[I]);const v=`${I}/${p}`;if($.has(v))return $.get(v);let l;if(/^\w[\w\d+.-]*:\/\//.test(v))l=v;else{const i=`${y&&!O.$o?N.$Ng:N.$Mg}/${v}`;l=N.$Qg.asBrowserUri(i).toString(!0)}const d=b.INSTANCE.load(l);return $.set(v,d),d}else return await new Promise((v,l)=>{he([I],v,l)})}}),define(Se[23],De([1,0,31,15,16,12,14,2]),function(he,e,h,N,O,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=void 0,e.$Xg=$,e.$gh=A,e.$hh=p;function $(y){return(0,b.$wc)(y,!0)}class k{constructor(v){this.a=v}compare(v,l,d=!1){return v===l?0:(0,M.$qf)(this.getComparisonKey(v,d),this.getComparisonKey(l,d))}isEqual(v,l,d=!1){return v===l?!0:!v||!l?!1:this.getComparisonKey(v,d)===this.getComparisonKey(l,d)}getComparisonKey(v,l=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,l,d=!1){if(v.scheme===l.scheme){if(v.scheme===N.Schemas.file)return h.$vg($(v),$(l),this.a(v))&&v.query===l.query&&(d||v.fragment===l.fragment);if((0,e.$ch)(v.authority,l.authority))return h.$vg(v.path,l.path,this.a(v),"/")&&v.query===l.query&&(d||v.fragment===l.fragment)}return!1}joinPath(v,...l){return b.URI.joinPath(v,...l)}basenameOrAuthority(v){return(0,e.$7g)(v)||v.authority}basename(v){return O.$gc.basename(v.path)}extname(v){return O.$gc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let l;return v.scheme===N.Schemas.file?l=b.URI.file(O.$mc($(v))).path:(l=O.$gc.dirname(v.path),v.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),l="/")),v.with({path:l})}normalizePath(v){if(!v.path.length)return v;let l;return v.scheme===N.Schemas.file?l=b.URI.file(O.$hc($(v))).path:l=O.$gc.normalize(v.path),v.with({path:l})}relativePath(v,l){if(v.scheme!==l.scheme||!(0,e.$ch)(v.authority,l.authority))return;if(v.scheme===N.Schemas.file){const n=O.$lc($(v),$(l));return R.$i?h.$pg(n):n}let d=v.path||"/";const o=l.path||"/";if(this.a(v)){let n=0;for(const i=Math.min(d.length,o.length);n<i&&!(d.charCodeAt(n)!==o.charCodeAt(n)&&d.charAt(n).toLowerCase()!==o.charAt(n).toLowerCase());n++);d=o.substr(0,n)+d.substr(n)}return O.$gc.relative(d,o)}resolvePath(v,l){if(v.scheme===N.Schemas.file){const d=b.URI.file(O.$kc($(v),l));return v.with({authority:d.authority,path:d.path})}return l=h.$qg(l),v.with({path:O.$gc.resolve(v.path,l)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,l){return v===l||v!==void 0&&l!==void 0&&(0,M.$xf)(v,l)}hasTrailingPathSeparator(v,l=O.sep){if(v.scheme===N.Schemas.file){const d=$(v);return d.length>h.$rg(d).length&&d[d.length-1]===l}else{const d=v.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,l=O.sep){return(0,e.$dh)(v,l)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,l=O.sep){let d=!1;if(v.scheme===N.Schemas.file){const o=$(v);d=o!==void 0&&o.length===h.$rg(o).length&&o[o.length-1]===l}else{l="/";const o=v.path;d=o.length===1&&o.charCodeAt(o.length-1)===47}return!d&&!(0,e.$dh)(v,l)?v.with({path:v.path+"/"}):v}}e.$Yg=k,e.$Zg=new k(()=>!1),e.$1g=new k(y=>y.scheme===N.Schemas.file?!R.$k:!0),e.$2g=new k(y=>!0),e.$3g=e.$Zg.isEqual.bind(e.$Zg),e.$4g=e.$Zg.isEqualOrParent.bind(e.$Zg),e.$5g=e.$Zg.getComparisonKey.bind(e.$Zg),e.$6g=e.$Zg.basenameOrAuthority.bind(e.$Zg),e.$7g=e.$Zg.basename.bind(e.$Zg),e.$8g=e.$Zg.extname.bind(e.$Zg),e.$9g=e.$Zg.dirname.bind(e.$Zg),e.$0g=e.$Zg.joinPath.bind(e.$Zg),e.$$g=e.$Zg.normalizePath.bind(e.$Zg),e.$_g=e.$Zg.relativePath.bind(e.$Zg),e.$ah=e.$Zg.resolvePath.bind(e.$Zg),e.$bh=e.$Zg.isAbsolutePath.bind(e.$Zg),e.$ch=e.$Zg.isEqualAuthority.bind(e.$Zg),e.$dh=e.$Zg.hasTrailingPathSeparator.bind(e.$Zg),e.$eh=e.$Zg.removeTrailingPathSeparator.bind(e.$Zg),e.$fh=e.$Zg.addTrailingPathSeparator.bind(e.$Zg);function A(y,v){const l=[];for(let d=0;d<y.length;d++){const o=v(y[d]);y.some((n,i)=>i===d?!1:(0,e.$4g)(o,v(n)))||l.push(y[d])}return l}var I;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function v(l){const d=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(i=>{const[u,s]=i.split(":");u&&s&&d.set(u,s)});const n=l.path.substring(0,l.path.indexOf(";"));return n&&d.set(y.META_DATA_MIME,n),d}y.parseMetaData=v})(I||(e.DataUri=I={}));function p(y,v,l){if(v){let d=y.path;return d&&d[0]!==O.$gc.sep&&(d=O.$gc.sep+d),y.with({scheme:l,authority:v,path:d})}return y.with({scheme:l})}}),define(Se[7],De([1,0,22,13,4,3,23,12,174,46]),function(he,e,h,N,O,R,M,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.Promises=e.$Th=e.$Sh=e.$Rh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0,e.$ih=A,e.$jh=I,e.$kh=p,e.$lh=y,e.$mh=v,e.$nh=l,e.$oh=d,e.$ph=o,e.$xh=g,e.$yh=w,e.$zh=S,e.$Ah=m,e.$Bh=E,e.$Qh=G,e.$Yh=ce;function A(le){return!!le&&typeof le.then=="function"}function I(le){const K=new h.$oe,se=le(K.token),$e=new Promise((ve,Me)=>{const ge=K.token.onCancellationRequested(()=>{ge.dispose(),Me(new N.$5)});Promise.resolve(se).then(Ae=>{ge.dispose(),K.dispose(),ve(Ae)},Ae=>{ge.dispose(),K.dispose(),Me(Ae)})});return new class{cancel(){K.cancel(),K.dispose()}then(ve,Me){return $e.then(ve,Me)}catch(ve){return this.then(void 0,ve)}finally(ve){return $e.finally(ve)}}}function p(le,K,se){return new Promise(($e,ve)=>{const Me=K.onCancellationRequested(()=>{Me.dispose(),$e(se)});le.then($e,ve).finally(()=>Me.dispose())})}function y(le,K){return new Promise((se,$e)=>{const ve=K.onCancellationRequested(()=>{ve.dispose(),$e(new N.$5)});le.then(se,$e).finally(()=>ve.dispose())})}async function v(le){let K=-1;const se=le.map(($e,ve)=>$e.then(Me=>(K=ve,Me)));try{return await Promise.race(se)}finally{le.forEach(($e,ve)=>{ve!==K&&$e.cancel()})}}function l(le,K,se){let $e;const ve=setTimeout(()=>{$e?.(void 0),se?.()},K);return Promise.race([le.finally(()=>clearTimeout(ve)),new Promise(Me=>$e=Me)])}function d(le){return new Promise((K,se)=>{const $e=le();A($e)?$e.then(K,se):K($e)})}function o(){let le,K;return{promise:new Promise(($e,ve)=>{le=$e,K=ve}),resolve:le,reject:K}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(K){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=K,!this.b){const se=()=>{if(this.b=null,this.f)return;const $e=this.queue(this.d);return this.d=null,$e};this.b=new Promise($e=>{this.a.then(se,se).then($e)})}return new Promise((se,$e)=>{this.b.then(se,$e)})}return this.a=K(),new Promise((se,$e)=>{this.a.then(ve=>{this.a=null,se(ve)},ve=>{this.a=null,$e(ve)})})}dispose(){this.f=!0}}e.$qh=n;class i{constructor(){this.a=Promise.resolve(null)}queue(K){return this.a=this.a.then(()=>K(),()=>K())}}e.$rh=i;class u{constructor(){this.a=new Map}queue(K,se){const ve=(this.a.get(K)??Promise.resolve()).catch(()=>{}).then(se).finally(()=>{this.a.get(K)===ve&&this.a.delete(K)});return this.a.set(K,ve),ve}}e.$sh=u;const s=(le,K)=>{let se=!0;const $e=setTimeout(()=>{se=!1,K()},le);return{isTriggered:()=>se,dispose:()=>{clearTimeout($e),se=!1}}},t=le=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,le())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class c{constructor(K){this.defaultDelay=K,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(K,se=this.defaultDelay){this.g=K,this.h(),this.b||(this.b=new Promise((ve,Me)=>{this.d=ve,this.f=Me}).then(()=>{if(this.b=null,this.d=null,this.g){const ve=this.g;return this.g=null,ve()}}));const $e=()=>{this.a=null,this.d?.(null)};return this.a=se===$.$ae?t($e):s(se,$e),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$th=c;class r{constructor(K){this.a=new c(K),this.b=new n}trigger(K,se){return this.a.trigger(()=>this.b.queue(K),se)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$uh=r;class a{constructor(){this.a=!1,this.b=new Promise((K,se)=>{this.d=K})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$vh=a;class f extends a{constructor(K){super(),this.f=setTimeout(()=>this.open(),K)}open(){clearTimeout(this.f),super.open()}}e.$wh=f;function g(le,K){return K?new Promise((se,$e)=>{const ve=setTimeout(()=>{Me.dispose(),se()},le),Me=K.onCancellationRequested(()=>{clearTimeout(ve),Me.dispose(),$e(new N.$5)})}):I(se=>g(le,se))}function w(le,K=0,se){const $e=setTimeout(()=>{le(),se&&ve.dispose()},K),ve=(0,R.$Sc)(()=>{clearTimeout($e),se?.deleteAndLeak(ve)});return se?.add(ve),ve}function S(le){const K=[];let se=0;const $e=le.length;function ve(){return se<$e?le[se++]():null}function Me(ge){ge!=null&&K.push(ge);const Ae=ve();return Ae?Ae.then(Me):Promise.resolve(K)}return Promise.resolve(null).then(Me)}function m(le,K=$e=>!!$e,se=null){let $e=0;const ve=le.length,Me=()=>{if($e>=ve)return Promise.resolve(se);const ge=le[$e++];return Promise.resolve(ge()).then(Re=>K(Re)?Promise.resolve(Re):Me())};return Me()}function E(le,K=$e=>!!$e,se=null){if(le.length===0)return Promise.resolve(se);let $e=le.length;const ve=()=>{$e=-1;for(const Me of le)Me.cancel?.()};return new Promise((Me,ge)=>{for(const Ae of le)Ae.then(Re=>{--$e>=0&&K(Re)?(ve(),Me(Re)):$e===0&&Me(se)}).catch(Re=>{--$e>=0&&(ve(),ge(Re))})})}class D{constructor(K){this.a=0,this.b=!1,this.f=K,this.g=[],this.d=0,this.h=new O.$de}whenIdle(){return this.size>0?O.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(K){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((se,$e)=>{this.g.push({factory:K,c:se,e:$e}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const K=this.g.shift();this.d++;const se=K.factory();se.then(K.c,K.e),se.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ch=D;class C extends D{constructor(){super(1)}}e.$Dh=C;class P{constructor(){this.a=new x,this.b=0}queue(K){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,K())):this.a.run(this.b++,K())}}e.$Eh=P;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const K=new ae;return this.b.add(K),K.p}g(){for(const[,K]of this.a)if(K.size>0)return!1;return!0}queueSize(K,se=M.$Zg){const $e=se.getComparisonKey(K);return this.a.get($e)?.size??0}queueFor(K,se,$e=M.$Zg){const ve=$e.getComparisonKey(K);let Me=this.a.get(ve);if(!Me){Me=new C;const ge=this.f++,Ae=O.Event.once(Me.onDrained)(()=>{Me?.dispose(),this.a.delete(ve),this.h(),this.d?.deleteAndDispose(ge),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$4c),this.d.set(ge,Ae),this.a.set(ve,Me)}return Me.queue(se)}h(){this.g()&&this.j()}j(){for(const K of this.b)K.complete();this.b.clear()}dispose(){for(const[,K]of this.a)K.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Fh=F;class T{constructor(K,se){this.a=-1,typeof K=="function"&&typeof se=="number"&&this.setIfNotSet(K,se)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(K,se){this.cancel(),this.a=setTimeout(()=>{this.a=-1,K()},se)}setIfNotSet(K,se){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,K()},se))}}e.$Gh=T;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(K,se,$e=globalThis){this.cancel();const ve=$e.setInterval(()=>{K()},se);this.d=(0,R.$Sc)(()=>{$e.clearInterval(ve),this.d=void 0})}dispose(){this.cancel()}}e.$Hh=z;class L{constructor(K,se){this.b=-1,this.a=K,this.d=se,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(K=this.d){this.cancel(),this.b=setTimeout(this.f,K)}get delay(){return this.d}set delay(K){this.d=K}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ih=L;class j{constructor(K,se){se%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.a=K,this.b=se,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(K=this.b){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(K/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Jh=j;class U extends L{constructor(K,se){super(K,se),this.j=[]}work(K){this.j.push(K),this.isScheduled()||this.schedule()}h(){const K=this.j;this.j=[],this.a?.(K)}dispose(){this.j=[],super.dispose()}}e.$Kh=U;class X extends R.$Uc{constructor(K,se){super(),this.g=K,this.h=se,this.a=[],this.b=this.B(new R.$Vc),this.f=!1}get pending(){return this.a.length}work(K){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+K.length>this.g.maxBufferedWork)return!1}else if(this.pending+K.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const se of K)this.a.push(se);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new L(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Lh=X,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Nh=(le,K)=>{(0,b.$B)(()=>{if(se)return;const $e=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$e-Date.now())}}))});let se=!1;return{dispose(){se||(se=!0)}}}:e.$Nh=(le,K,se)=>{const $e=le.requestIdleCallback(K,typeof se=="number"?{timeout:se}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,le.cancelIdleCallback($e))}}},e.$Mh=le=>(0,e.$Nh)(globalThis,le)}();class ie{constructor(K,se){this.g=!1,this.d=()=>{try{this.j=se()}catch($e){this.l=$e}finally{this.g=!0}},this.f=(0,e.$Nh)(K,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Oh=ie;class q extends ie{constructor(K){super(globalThis,K)}}e.$Ph=q;async function G(le,K,se){let $e;for(let ve=0;ve<se;ve++)try{return await le()}catch(Me){$e=Me,await g(K)}throw $e}class x{isRunning(K){return typeof K=="number"?this.a?.taskId===K:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(K,se,$e){return this.a={taskId:K,cancel:()=>$e?.(),promise:se},se.then(()=>this.d(K),()=>this.d(K)),se}d(K){this.a&&K===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const K=this.b;this.b=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this.b)this.b.run=K;else{const{promise:se,resolve:$e,reject:ve}=o();this.b={run:K,promise:se,promiseResolve:$e,promiseReject:ve}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Rh=x;class ne{constructor(K,se=()=>Date.now()){this.d=K,this.f=se,this.a=0,this.b=0}increment(){const K=this.f();return K-this.a>this.d&&(this.a=K,this.b=0),this.b++,this.b}}e.$Sh=ne;var be;(function(le){le[le.Resolved=0]="Resolved",le[le.Rejected=1]="Rejected"})(be||(be={}));class ae{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((K,se)=>{this.a=K,this.b=se})}complete(K){return new Promise(se=>{this.a(K),this.d={outcome:0,value:K},se()})}error(K){return new Promise(se=>{this.b(K),this.d={outcome:1,value:K},se()})}cancel(){return this.error(new N.$5)}}e.$Th=ae;var Ie;(function(le){async function K($e){let ve;const Me=await Promise.all($e.map(ge=>ge.then(Ae=>Ae,Ae=>{ve||(ve=Ae)})));if(typeof ve<"u")throw ve;return Me}le.settled=K;function se($e){return new Promise(async(ve,Me)=>{try{await $e(ve,Me)}catch(ge){Me(ge)}})}le.withAsyncBody=se})(Ie||(e.Promises=Ie={}));class ee{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(K){this.a=void 0,this.b=void 0,this.d=!1,this.promise=K.then(se=>(this.a=se,this.d=!0,se),se=>{throw this.b=se,this.d=!0,se})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Uh=ee;class B{constructor(K){this.b=K,this.a=new k.$V(()=>new ee(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Vh=B;var _;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})(_||(_={}));class pe{static fromArray(K){return new pe(se=>{se.emitMany(K)})}static fromPromise(K){return new pe(async se=>{se.emitMany(await K)})}static fromPromises(K){return new pe(async se=>{await Promise.all(K.map(async $e=>se.emitOne(await $e)))})}static merge(K){return new pe(async se=>{await Promise.all(K.map(async $e=>{for await(const ve of $e)se.emitOne(ve)}))})}static{this.EMPTY=pe.fromArray([])}constructor(K,se){this.a=0,this.b=[],this.d=null,this.f=se,this.g=new O.$de,queueMicrotask(async()=>{const $e={emitOne:ve=>this.h(ve),emitMany:ve=>this.j(ve),reject:ve=>this.l(ve)};try{await Promise.resolve(K($e)),this.k()}catch(ve){this.l(ve)}finally{$e.emitOne=void 0,$e.emitMany=void 0,$e.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(K<this.b.length)return{done:!1,value:this.b[K++]};if(this.a===1)return{done:!0,value:void 0};await O.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(K,se){return new pe(async $e=>{for await(const ve of K)$e.emitOne(se(ve))})}map(K){return pe.map(this,K)}static filter(K,se){return new pe(async $e=>{for await(const ve of K)se(ve)&&$e.emitOne(ve)})}filter(K){return pe.filter(this,K)}static coalesce(K){return pe.filter(K,se=>!!se)}coalesce(){return pe.coalesce(this)}static async toPromise(K){const se=[];for await(const $e of K)se.push($e);return se}toPromise(){return pe.toPromise(this)}h(K){this.a===0&&(this.b.push(K),this.g.fire())}j(K){this.a===0&&(this.b=this.b.concat(K),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(K){this.a===0&&(this.a=2,this.d=K,this.g.fire())}}e.$Wh=pe;class ue extends pe{constructor(K,se){super(se),this.m=K}cancel(){this.m.cancel()}}e.$Xh=ue;function ce(le){const K=new h.$oe,se=le(K.token);return new ue(K,async $e=>{const ve=K.token.onCancellationRequested(()=>{ve.dispose(),K.dispose(),$e.reject(new N.$5)});try{for await(const Me of se){if(K.token.isCancellationRequested)return;$e.emitOne(Me)}ve.dispose(),K.dispose()}catch(Me){ve.dispose(),K.dispose(),$e.reject(Me)}})}class oe{constructor(K){this.a=new ae,this.b=new pe(ve=>{if(se){ve.reject(se);return}return $e&&ve.emitMany($e),this.d=Me=>ve.reject(Me),this.f=Me=>ve.emitOne(Me),this.a.p},K);let se,$e;this.f=ve=>{$e||($e=[]),$e.push(ve)},this.d=ve=>{se||(se=ve)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(K){this.d(K),this.a.complete()}emitOne(K){this.f(K)}}e.$Zh=oe}),define(Se[35],De([1,0,19,7,31,27,16,12,14]),function(he,e,h,N,O,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nk=e.$mk=void 0,e.$lk=k,e.$ok=v,e.$pk=C,e.$qk=P,e.$rk=F,e.$sk=T,e.$tk=z,e.$uk=X;function k(){return Object.create(null)}e.$mk="**",e.$nk="/";const A="[/\\\\]",I="[^/\\\\]",p=/\//g;function y(ie,q){switch(ie){case 0:return"";case 1:return`${I}*?`;default:return`(?:${A}|${I}+${A}${q?`|${A}${I}+`:""})*?`}}function v(ie,q){if(!ie)return[];const G=[];let x=!1,ne=!1,be="";for(const ae of ie){switch(ae){case q:if(!x&&!ne){G.push(be),be="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}be+=ae}return be&&G.push(be),G}function l(ie){if(!ie)return"";let q="";const G=v(ie,e.$nk);if(G.every(x=>x===e.$mk))q=".*";else{let x=!1;G.forEach((ne,be)=>{if(ne===e.$mk){if(x)return;q+=y(2,be===G.length-1)}else{let ae=!1,Ie="",ee=!1,B="";for(const _ of ne){if(_!=="}"&&ae){Ie+=_;continue}if(ee&&(_!=="]"||!B)){let pe;_==="-"?pe=_:(_==="^"||_==="!")&&!B?pe="^":_===e.$nk?pe="":pe=(0,$.$_e)(_),B+=pe;continue}switch(_){case"{":ae=!0;continue;case"[":ee=!0;continue;case"}":{const ue=`(?:${v(Ie,",").map(ce=>l(ce)).join("|")})`;q+=ue,ae=!1,Ie="";break}case"]":{q+="["+B+"]",ee=!1,B="";break}case"?":q+=I;continue;case"*":q+=y(1);continue;default:q+=(0,$.$_e)(_)}}be<G.length-1&&(G[be+1]!==e.$mk||be+2<G.length)&&(q+=A)}x=ne===e.$mk})}return q}const d=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Dc(1e4),c=function(){return!1},r=function(){return null};function a(ie,q){if(!ie)return r;let G;typeof ie!="string"?G=ie.pattern:G=ie,G=G.trim();const x=`${G}_${!!q.trimForExclusions}`;let ne=t.get(x);if(ne)return f(ne,ie);let be;return d.test(G)?ne=w(G.substr(4),G):(be=o.exec(g(G,q)))?ne=S(be[1],G):(q.trimForExclusions?i:n).test(G)?ne=m(G,q):(be=u.exec(g(G,q)))?ne=E(be[1].substr(1),G,!0):(be=s.exec(g(G,q)))?ne=E(be[1],G,!1):ne=D(G),t.set(x,ne),f(ne,ie)}function f(ie,q){if(typeof q=="string")return ie;const G=function(x,ne){return(0,O.$vg)(x,q.base,!b.$k)?ie((0,$.$ef)(x.substr(q.base.length),M.sep),ne):null};return G.allBasenames=ie.allBasenames,G.allPaths=ie.allPaths,G.basenames=ie.basenames,G.patterns=ie.patterns,G}function g(ie,q){return q.trimForExclusions&&ie.endsWith("/**")?ie.substr(0,ie.length-2):ie}function w(ie,q){return function(G,x){return typeof G=="string"&&G.endsWith(ie)?q:null}}function S(ie,q){const G=`/${ie}`,x=`\\${ie}`,ne=function(ae,Ie){return typeof ae!="string"?null:Ie?Ie===ie?q:null:ae===ie||ae.endsWith(G)||ae.endsWith(x)?q:null},be=[ie];return ne.basenames=be,ne.patterns=[q],ne.allBasenames=be,ne}function m(ie,q){const G=U(ie.slice(1,-1).split(",").map(Ie=>a(Ie,q)).filter(Ie=>Ie!==r),ie),x=G.length;if(!x)return r;if(x===1)return G[0];const ne=function(Ie,ee){for(let B=0,_=G.length;B<_;B++)if(G[B](Ie,ee))return ie;return null},be=G.find(Ie=>!!Ie.allBasenames);be&&(ne.allBasenames=be.allBasenames);const ae=G.reduce((Ie,ee)=>ee.allPaths?Ie.concat(ee.allPaths):Ie,[]);return ae.length&&(ne.allPaths=ae),ne}function E(ie,q,G){const x=M.sep===M.$gc.sep,ne=x?ie:ie.replace(p,M.sep),be=M.sep+ne,ae=M.$gc.sep+ie;let Ie;return G?Ie=function(ee,B){return typeof ee=="string"&&(ee===ne||ee.endsWith(be)||!x&&(ee===ie||ee.endsWith(ae)))?q:null}:Ie=function(ee,B){return typeof ee=="string"&&(ee===ne||!x&&ee===ie)?q:null},Ie.allPaths=[(G?"*/":"./")+ie],Ie}function D(ie){try{const q=new RegExp(`^${l(ie)}$`);return function(G){return q.lastIndex=0,typeof G=="string"&&q.test(G)?ie:null}}catch{return r}}function C(ie,q,G){return!ie||typeof q!="string"?!1:P(ie)(q,void 0,G)}function P(ie,q={}){if(!ie)return c;if(typeof ie=="string"||F(ie)){const G=a(ie,q);if(G===r)return c;const x=function(ne,be){return!!G(ne,be)};return G.allBasenames&&(x.allBasenames=G.allBasenames),G.allPaths&&(x.allPaths=G.allPaths),x}return L(ie,q)}function F(ie){const q=ie;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}function T(ie){return ie.allBasenames||[]}function z(ie){return ie.allPaths||[]}function L(ie,q){const G=U(Object.getOwnPropertyNames(ie).map(Ie=>j(Ie,ie[Ie],q)).filter(Ie=>Ie!==r)),x=G.length;if(!x)return r;if(!G.some(Ie=>!!Ie.requiresSiblings)){if(x===1)return G[0];const Ie=function(_,pe){let ue;for(let ce=0,oe=G.length;ce<oe;ce++){const le=G[ce](_,pe);if(typeof le=="string")return le;(0,N.$ih)(le)&&(ue||(ue=[]),ue.push(le))}return ue?(async()=>{for(const ce of ue){const oe=await ce;if(typeof oe=="string")return oe}return null})():null},ee=G.find(_=>!!_.allBasenames);ee&&(Ie.allBasenames=ee.allBasenames);const B=G.reduce((_,pe)=>pe.allPaths?_.concat(pe.allPaths):_,[]);return B.length&&(Ie.allPaths=B),Ie}const ne=function(Ie,ee,B){let _,pe;for(let ue=0,ce=G.length;ue<ce;ue++){const oe=G[ue];oe.requiresSiblings&&B&&(ee||(ee=(0,M.$nc)(Ie)),_||(_=ee.substr(0,ee.length-(0,M.$oc)(Ie).length)));const le=oe(Ie,ee,_,B);if(typeof le=="string")return le;(0,N.$ih)(le)&&(pe||(pe=[]),pe.push(le))}return pe?(async()=>{for(const ue of pe){const ce=await ue;if(typeof ce=="string")return ce}return null})():null},be=G.find(Ie=>!!Ie.allBasenames);be&&(ne.allBasenames=be.allBasenames);const ae=G.reduce((Ie,ee)=>ee.allPaths?Ie.concat(ee.allPaths):Ie,[]);return ae.length&&(ne.allPaths=ae),ne}function j(ie,q,G){if(q===!1)return r;const x=a(ie,G);if(x===r)return r;if(typeof q=="boolean")return x;if(q){const ne=q.when;if(typeof ne=="string"){const be=(ae,Ie,ee,B)=>{if(!B||!x(ae,Ie))return null;const _=ne.replace("$(basename)",()=>ee),pe=B(_);return(0,N.$ih)(pe)?pe.then(ue=>ue?ie:null):pe?ie:null};return be.requiresSiblings=!0,be}}return x}function U(ie,q){const G=ie.filter(Ie=>!!Ie.basenames);if(G.length<2)return ie;const x=G.reduce((Ie,ee)=>{const B=ee.basenames;return B?Ie.concat(B):Ie},[]);let ne;if(q){ne=[];for(let Ie=0,ee=x.length;Ie<ee;Ie++)ne.push(q)}else ne=G.reduce((Ie,ee)=>{const B=ee.patterns;return B?Ie.concat(B):Ie},[]);const be=function(Ie,ee){if(typeof Ie!="string")return null;if(!ee){let _;for(_=Ie.length;_>0;_--){const pe=Ie.charCodeAt(_-1);if(pe===47||pe===92)break}ee=Ie.substr(_)}const B=x.indexOf(ee);return B!==-1?ne[B]:null};be.basenames=x,be.patterns=ne,be.allBasenames=x;const ae=ie.filter(Ie=>!Ie.basenames);return ae.push(be),ae}function X(ie,q){return(0,h.$ub)(ie,q,(G,x)=>typeof G=="string"&&typeof x=="string"?G===x:typeof G!="string"&&typeof x!="string"?G.base===x.base&&G.pattern===x.pattern:!1)}}),define(Se[81],De([1,0,13,176,23,14,2]),function(he,e,h,N,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.MarkdownStringTextNewlineStyle=void 0,e.$Uk=k,e.$Vk=A,e.$Wk=I,e.$Xk=p,e.$Yk=y,e.$Zk=v,e.$1k=l,e.$2k=d;var b;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class ${constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,h.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=p(this.supportThemeIcons?(0,N.$Nk)(n):n).replace(/([ \t]+)/g,(u,s)=>"&nbsp;".repeat(s.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${y(i,n)}
`,this}appendLink(n,i,u){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),u&&(this.value+=` "${this.c(this.c(u,'"'),")")}"`),this.value+=")",this}c(n,i){const u=new RegExp((0,R.$_e)(i),"g");return n.replace(u,(s,t)=>n.charAt(t-1)!=="\\"?`\\${s}`:s)}}e.$Tk=$;function k(o){return A(o)?!o.value:Array.isArray(o)?o.every(k):!0}function A(o){return o instanceof $?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}function I(o,n){return o===n?!0:!o||!n?!1:o.value===n.value&&o.isTrusted===n.isTrusted&&o.supportThemeIcons===n.supportThemeIcons&&o.supportHtml===n.supportHtml&&(o.baseUri===n.baseUri||!!o.baseUri&&!!n.baseUri&&(0,O.$3g)(M.URI.from(o.baseUri),M.URI.from(n.baseUri)))}function p(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function y(o,n){const i=o.match(/^`+/gm)?.reduce((s,t)=>s.length>t.length?s:t).length??0,u=i>=3?i+1:3;return[`${"`".repeat(u)}${n}`,o,`${"`".repeat(u)}`].join(`
`)}function v(o){return o.replace(/"/g,"&quot;")}function l(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function d(o){const n=[],i=o.split("|").map(s=>s.trim());o=i[0];const u=i[1];if(u){const s=/height=(\d+)/.exec(u),t=/width=(\d+)/.exec(u),c=s?s[1]:"",r=t?t[1]:"",a=isFinite(parseInt(r)),f=isFinite(parseInt(c));a&&n.push(`width="${r}"`),f&&n.push(`height="${c}"`)}return{href:o,dimensions:n}}}),define(Se[103],De([1,0,19,31,16,12,23,14]),function(he,e,h,N,O,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dw=$,e.$Ew=A,e.$Fw=p,e.$Gw=y,e.$Hw=o,e.$Iw=i,e.$Jw=u,e.$Kw=s,e.$Lw=t,e.$Mw=c;function $(a,f){const{os:g,tildify:w,relative:S}=f;if(S){const D=k(a,S,g);if(typeof D=="string")return D}let m=a.fsPath;if(g===1&&!R.$i?m=m.replace(/\//g,"\\"):g!==1&&R.$i&&(m=m.replace(/\\/g,"/")),g!==1&&w?.userHome){const D=w.userHome.fsPath;let C;a.scheme!==w.userHome.scheme&&a.path[0]===O.$gc.sep&&a.path[1]!==O.$gc.sep?C=w.userHome.with({path:a.path}).fsPath:C=m,m=p(C,D,g)}return(g===1?O.$fc:O.$gc).normalize(A(m,g===1))}function k(a,f,g){const w=g===1?O.$fc:O.$gc,S=g===3?M.$Zg:M.$2g,m=f.getWorkspace(),E=(0,h.$Ob)(m.folders);if(!E)return;a.scheme!==E.uri.scheme&&a.path[0]===O.$gc.sep&&a.path[1]!==O.$gc.sep&&(a=E.uri.with({path:a.path}));const D=f.getWorkspaceFolder(a);if(!D)return;let C;if(S.isEqual(D.uri,a)?C="":C=S.relativePath(D.uri,a)??"",C&&(C=w.normalize(C)),m.folders.length>1&&!f.noPrefix){const P=D.name?D.name:S.basenameOrAuthority(D.uri);C=C?`${P} \u2022 ${C}`:P}return C}function A(a,f=R.$i){return(0,N.$Ag)(a,f)?a.charAt(0).toUpperCase()+a.slice(1):a}let I=Object.create(null);function p(a,f,g=R.OS){if(g===1||!a||!f)return a;let w=I.original===f?I.normalized:void 0;w||(w=f,R.$i&&(w=(0,N.$pg)(w)),w=`${(0,b.$ff)(w,O.$gc.sep)}${O.$gc.sep}`,I={original:f,normalized:w});let S=a;return R.$i&&(S=(0,N.$pg)(S)),(g===3?S.startsWith(w):(0,b.$yf)(S,w))?`~/${S.substr(w.length)}`:a}function y(a,f){return a.replace(/^~($|\/|\\)/,`${f}$1`)}const v="\u2026",l="\\\\",d="~";function o(a,f=O.sep){const g=new Array(a.length);let w=!1;for(let S=0;S<a.length;S++){const m=a[S];if(m===""){g[S]=`.${f}`;continue}if(!m){g[S]=m;continue}w=!0;let E="",D=m;D.indexOf(l)===0?(E=D.substr(0,D.indexOf(l)+l.length),D=D.substr(D.indexOf(l)+l.length)):D.indexOf(f)===0?(E=D.substr(0,D.indexOf(f)+f.length),D=D.substr(D.indexOf(f)+f.length)):D.indexOf(d)===0&&(E=D.substr(0,D.indexOf(d)+d.length),D=D.substr(D.indexOf(d)+d.length));const C=D.split(f);for(let P=1;w&&P<=C.length;P++)for(let F=C.length-P;w&&F>=0;F--){w=!1;let T=C.slice(F,F+P).join(f);for(let z=0;!w&&z<a.length;z++)if(z!==S&&a[z]&&a[z].indexOf(T)>-1){const L=F+P===C.length,j=F>0&&a[z].indexOf(f)>-1?f+T:T,U=a[z].endsWith(j);w=!L||U}if(!w){let z="";(C[0].endsWith(":")||E!=="")&&(F===1&&(F=0,P++,T=C[0]+f+T),F>0&&(z=C[0]+f),z=E+z),F>0&&(z=z+v+f),z=z+T,F+P<C.length&&(z=z+f+v),g[S]=z}}w&&(g[S]=m)}return g}var n;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(a,f=Object.create(null)){const g=[];let w=!1,S="";for(const m of a)if(m==="$"||w&&m==="{")S&&g.push({value:S,type:n.TEXT}),S="",w=!0;else if(m==="}"&&w){const E=f[S];if(typeof E=="string")E.length&&g.push({value:E,type:n.VARIABLE});else if(E){const D=g[g.length-1];(!D||D.type!==n.SEPARATOR)&&g.push({value:E.label,type:n.SEPARATOR})}S="",w=!1}else S+=m;return S&&!w&&g.push({value:S,type:n.TEXT}),g.filter((m,E)=>{if(m.type===n.SEPARATOR){const D=g[E-1],C=g[E+1];return[D,C].every(P=>P&&(P.type===n.VARIABLE||P.type===n.TEXT)&&P.value.length>0)}return!0}).map(m=>m.value).join("")}function u(a,f){return R.$j||f?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):a.replace(/&&|&/g,g=>g==="&"?"&&":"&")}function s(a,f){return R.$j||f?a.replace(/\(&&\w\)|&&/g,""):R.$i?a.replace(/&&|&/g,g=>g==="&"?"&&":"&"):a.replace(/&&/g,"_")}function t(a){return a.replace(/&/g,"&&")}function c(a){if(a.endsWith("]")){const f=a.lastIndexOf(" [",a.length-2);if(f!==-1){const g=r(a.substring(0,f)),w=a.substring(f);return{name:g.name+w,parentPath:g.parentPath}}}return r(a)}function r(a){const f=a.indexOf("/")!==-1?O.$gc:O.$fc,g=f.basename(a),w=f.dirname(a);return g.length?{name:g,parentPath:w}:{name:w,parentPath:""}}}),define(Se[134],De([1,0,21,2]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$yn=void 0,e.$An=b,e.$Bn=k,e.$Cn=A;function O(I){return I.toJSON()}class R{constructor(p){this.a=p}transformIncoming(p){const y=this.a.transformIncoming(p);return y===p?p:O(N.URI.from(y))}transformOutgoing(p){const y=this.a.transformOutgoing(p);return y===p?p:O(N.URI.from(y))}transformOutgoingURI(p){const y=this.a.transformOutgoing(p);return y===p?p:N.URI.from(y)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$yn=R,e.$zn=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function M(I,p,y){if(!I||y>200)return null;if(typeof I=="object"){if(I instanceof N.URI)return p.transformOutgoing(I);for(const v in I)if(Object.hasOwnProperty.call(I,v)){const l=M(I[v],p,y+1);l!==null&&(I[v]=l)}}return null}function b(I,p){const y=M(I,p,0);return y===null?I:y}function $(I,p,y,v){if(!I||v>200)return null;if(typeof I=="object"){if(I.$mid===1)return y?N.URI.revive(p.transformIncoming(I)):p.transformIncoming(I);if(I instanceof h.$Fe)return null;for(const l in I)if(Object.hasOwnProperty.call(I,l)){const d=$(I[l],p,y,v+1);d!==null&&(I[l]=d)}}return null}function k(I,p){const y=$(I,p,!1,0);return y===null?I:y}function A(I,p){const y=$(I,p,!0,0);return y===null?I:y}}),define(Se[32],De([1,0,53,64,399,7,31,77,16,12,23,2]),function(he,e,h,N,O,R,M,b,$,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=d,e.readdirSync=i,e.whenDeleted=t,e.configureFlushOnWrite=g,e.writeFileSync=S;var p;(function(j){j[j.UNLINK=0]="UNLINK",j[j.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function y(j,U=p.UNLINK,X){if((0,M.$zg)(j))throw new Error("rimraf - will refuse to recursively delete root");return U===p.UNLINK?l(j):v(j,X)}async function v(j,U=(0,M.$Eg)((0,N.tmpdir)())){try{try{await h.promises.rename(j,U)}catch(X){return X.code==="ENOENT"?void 0:l(j)}l(U).catch(X=>{})}catch(X){if(X.code!=="ENOENT")throw X}}async function l(j){return(0,O.promisify)(h.rm)(j,{recursive:!0,force:!0,maxRetries:3})}function d(j){if((0,M.$zg)(j))throw new Error("rimraf - will refuse to recursively delete root");h.rmSync(j,{recursive:!0,force:!0,maxRetries:3})}async function o(j,U){return u(await(U?n(j):(0,O.promisify)(h.readdir)(j)))}async function n(j){try{return await(0,O.promisify)(h.readdir)(j,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const U=[],X=await o(j);for(const ie of X){let q=!1,G=!1,x=!1;try{const ne=await e.Promises.lstat((0,$.$jc)(j,ie));q=ne.isFile(),G=ne.isDirectory(),x=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}U.push({name:ie,isFile:()=>q,isDirectory:()=>G,isSymbolicLink:()=>x})}return U}function i(j){return u(h.readdirSync(j))}function u(j){return j.map(U=>typeof U=="string"?k.$j?(0,b.$bm)(U):U:(U.name=k.$j?(0,b.$bm)(U.name):U.name,U))}async function s(j){const U=await o(j),X=[];for(const ie of U)await c.existsDirectory((0,$.$jc)(j,ie))&&X.push(ie);return X}function t(j,U=1e3){return new Promise(X=>{let ie=!1;const q=setInterval(()=>{ie||(ie=!0,h.access(j,G=>{ie=!1,G&&(clearInterval(q),X(void 0))}))},U)})}var c;(function(j){async function U(q){let G;try{if(G=await e.Promises.lstat(q),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(k.$i&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw ne}throw x}}j.stat=U;async function X(q){try{const{stat:G,symbolicLink:x}=await j.stat(q);return G.isFile()&&x?.dangling!==!0}catch{}return!1}j.existsFile=X;async function ie(q){try{const{stat:G,symbolicLink:x}=await j.stat(q);return G.isDirectory()&&x?.dangling!==!0}catch{}return!1}j.existsDirectory=ie})(c||(e.SymlinkSupport=c={}));const r=new R.$Fh;function a(j,U,X){return r.queueFor(I.URI.file(j),()=>{const ie=m(X);return new Promise((q,G)=>w(j,U,ie,x=>x?G(x):q()))},A.$1g)}let f=!0;function g(j){f=j}function w(j,U,X,ie){if(!f)return h.writeFile(j,U,{mode:X.mode,flag:X.flag},ie);h.open(j,X.flag,X.mode,(q,G)=>{if(q)return ie(q);h.writeFile(G,U,x=>{if(x)return h.close(G,()=>ie(x));h.fdatasync(G,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),g(!1)),h.close(G,be=>ie(be))))})})}function S(j,U,X){const ie=m(X);if(!f)return h.writeFileSync(j,U,{mode:ie.mode,flag:ie.flag});const q=h.openSync(j,ie.flag,ie.mode);try{h.writeFileSync(q,U);try{h.fdatasyncSync(q)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),g(!1)}}finally{h.closeSync(q)}}function m(j){return j?{mode:typeof j.mode=="number"?j.mode:438,flag:typeof j.flag=="string"?j.flag:"w"}:{mode:438,flag:"w"}}async function E(j,U,X=6e4){if(j!==U)try{k.$i&&typeof X=="number"?await D(j,U,Date.now(),X):await(0,O.promisify)(h.rename)(j,U)}catch(ie){if(j.toLowerCase()!==U.toLowerCase()&&ie.code==="EXDEV"||j.endsWith("."))await C(j,U,{preserveSymlinks:!1}),await y(j,p.MOVE);else throw ie}}async function D(j,U,X,ie,q=0){try{return await(0,O.promisify)(h.rename)(j,U)}catch(G){if(G.code!=="EACCES"&&G.code!=="EPERM"&&G.code!=="EBUSY")throw G;if(Date.now()-X>=ie)throw console.error(`[node.js fs] rename failed after ${q} retries with error: ${G}`),G;if(q===0){let x=!1;try{const{stat:ne}=await c.stat(U);ne.isFile()||(x=!0)}catch{}if(x)throw G}return await(0,R.$xh)(Math.min(100,q*10)),D(j,U,X,ie,q+1)}}async function C(j,U,X){return F(j,U,{root:{source:j,target:U},options:X,handledSourcePaths:new Set})}const P=511;async function F(j,U,X){if(X.handledSourcePaths.has(j))return;X.handledSourcePaths.add(j);const{stat:ie,symbolicLink:q}=await c.stat(j);if(q){if(X.options.preserveSymlinks)try{return await L(j,U,X)}catch{}if(q.dangling)return}return ie.isDirectory()?T(j,U,ie.mode&P,X):z(j,U,ie.mode&P)}async function T(j,U,X,ie){await e.Promises.mkdir(U,{recursive:!0,mode:X});const q=await o(j);for(const G of q)await F((0,$.$jc)(j,G),(0,$.$jc)(U,G),ie)}async function z(j,U,X){await e.Promises.copyFile(j,U),await e.Promises.chmod(U,X)}async function L(j,U,X){let ie=await e.Promises.readlink(j);(0,M.$vg)(ie,X.root.source,!k.$k)&&(ie=(0,$.$jc)(X.root.target,ie.substr(X.root.source.length+1))),await e.Promises.symlink(ie,U)}e.Promises=new class{get access(){return(0,O.promisify)(h.access)}get stat(){return(0,O.promisify)(h.stat)}get lstat(){return(0,O.promisify)(h.lstat)}get utimes(){return(0,O.promisify)(h.utimes)}get read(){return(j,U,X,ie,q)=>new Promise((G,x)=>{h.read(j,U,X,ie,q,(ne,be,ae)=>ne?x(ne):G({bytesRead:be,buffer:ae}))})}get readFile(){return(0,O.promisify)(h.readFile)}get write(){return(j,U,X,ie,q)=>new Promise((G,x)=>{h.write(j,U,X,ie,q,(ne,be,ae)=>ne?x(ne):G({bytesWritten:be,buffer:ae}))})}get appendFile(){return(0,O.promisify)(h.appendFile)}get fdatasync(){return(0,O.promisify)(h.fdatasync)}get truncate(){return(0,O.promisify)(h.truncate)}get copyFile(){return(0,O.promisify)(h.copyFile)}get open(){return(0,O.promisify)(h.open)}get close(){return(0,O.promisify)(h.close)}get symlink(){return(0,O.promisify)(h.symlink)}get readlink(){return(0,O.promisify)(h.readlink)}get chmod(){return(0,O.promisify)(h.chmod)}get mkdir(){return(0,O.promisify)(h.mkdir)}get unlink(){return(0,O.promisify)(h.unlink)}get rmdir(){return(0,O.promisify)(h.rmdir)}get realpath(){return(0,O.promisify)(h.realpath)}async exists(j){try{return await e.Promises.access(j),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return s}get writeFile(){return a}get rm(){return y}get rename(){return E}get copy(){return C}}}),define(Se[104],De([1,0,53,16,12,14,32]),function(he,e,h,N,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=b,e.$5q=$,e.$6q=k,e.$7q=A;function b(p){if(O.$k)return p;const y=(0,N.$mc)(p);if(p===y)return p;const v=((0,N.$nc)(p)||p).toLowerCase();try{const d=(0,M.readdirSync)(y).filter(o=>o.toLowerCase()===v);if(d.length===1){const o=b(y);if(o)return(0,N.$jc)(o,d[0])}else if(d.length>1){const o=d.indexOf(v);if(o>=0){const n=b(y);if(n)return(0,N.$jc)(n,d[o])}}}catch{}return null}async function $(p,y){if(O.$k)return p;const v=(0,N.$mc)(p);if(p===v)return p;const l=((0,N.$nc)(p)||p).toLowerCase();try{if(y?.isCancellationRequested)return null;const o=(await M.Promises.readdir(v)).filter(n=>n.toLowerCase()===l);if(o.length===1){const n=await $(v,y);if(n)return(0,N.$jc)(n,o[0])}else if(o.length>1){const n=o.indexOf(l);if(n>=0){const i=await $(v,y);if(i)return(0,N.$jc)(i,o[n])}}}catch{}return null}async function k(p){try{return await M.Promises.realpath(p)}catch{const v=I(p);return await M.Promises.access(v,h.constants.R_OK),v}}function A(p){try{return h.realpathSync(p)}catch{const v=I(p);return h.accessSync(v,h.constants.R_OK),v}}function I(p){return(0,R.$ff)((0,N.$hc)(p),N.sep)}}),define(Se[105],De([1,0,16,12,52,102,18,32]),function(he,e,h,N,O,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$om=$,e.$pm=k,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function $(I=O.env){return I.comspec||"cmd.exe"}function k(I){let p=[],y=!1;const v=function(l){if(y){p.push(l);return}(!I.send(l,o=>{if(o&&console.error(o),y=!1,p.length>0){const n=p.slice(0);p=[],n.forEach(i=>v(i))}})||N.$i)&&(y=!0)};return{send:v}}var A;(function(I){async function p(y,v,l){if(h.$ic(y))return y;if(v===void 0&&(v=O.cwd()),h.$mc(y)!=="."||(l===void 0&&M.$9f(O.env.PATH)&&(l=O.env.PATH.split(h.$tc)),l===void 0||l.length===0))return h.$jc(v,y);async function o(n){if(await b.Promises.exists(n)){let i;try{i=await b.Promises.stat(n)}catch(u){u.message.startsWith("EACCES")&&(i=await b.Promises.lstat(n))}return i?!i.isDirectory():!1}return!1}for(const n of l){let i;if(h.$ic(n)?i=h.$jc(n,y):i=h.$jc(v,n,y),await o(i))return i;let u=i+".com";if(await o(u)||(u=i+".exe",await o(u)))return u}return h.$jc(v,y)}I.findExecutable=p})(A||(e.win32=A={}))});var He=this&&this.__decorate||function(he,e,h,N){var O=arguments.length,R=O<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,h):N,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(he,e,h,N);else for(var b=he.length-1;b>=0;b--)(M=he[b])&&(R=(O<3?M(R):O>3?M(e,h,R):M(e,h))||R);return O>3&&R&&Object.defineProperty(e,h,R),R};define(Se[82],De([1,0,19,7,21,22,56,13,4,3,58,14,18]),function(he,e,h,N,O,R,M,b,$,k,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.ProxyChannel=e.$ei=e.$bi=e.$ai=e.$_h=e.RequestInitiator=e.$$h=e.$8h=e.$7h=void 0,e.$9h=g,e.$0h=w,e.$ci=P,e.$di=F;var y;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(y||(y={}));function v(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var l;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(l||(l={}));function d(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(o||(o={}));function n(q){let G=0;for(let x=0;;x+=7){const ne=q.read(1);if(G|=(ne.buffer[0]&127)<<x,!(ne.buffer[0]&128))return G}}const i=r(0);function u(q,G){if(G===0){q.write(i);return}let x=0;for(let be=G;be!==0;be=be>>>7)x++;const ne=O.$Fe.alloc(x);for(let be=0;G!==0;be++)ne.buffer[be]=G&127,G=G>>>7,G>0&&(ne.buffer[be]|=128);q.write(ne)}class s{constructor(G){this.b=G,this.a=0}read(G){const x=this.b.slice(this.a,this.a+G);return this.a+=x.byteLength,x}}e.$7h=s;class t{constructor(){this.a=[]}get buffer(){return O.$Fe.concat(this.a)}write(G){this.a.push(G)}}e.$8h=t;var c;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(c||(c={}));function r(q){const G=O.$Fe.alloc(1);return G.writeUInt8(q,0),G}const a={Undefined:r(c.Undefined),String:r(c.String),Buffer:r(c.Buffer),VSBuffer:r(c.VSBuffer),Array:r(c.Array),Object:r(c.Object),Uint:r(c.Int)},f=typeof Buffer<"u";function g(q,G){if(typeof G>"u")q.write(a.Undefined);else if(typeof G=="string"){const x=O.$Fe.fromString(G);q.write(a.String),u(q,x.byteLength),q.write(x)}else if(f&&Buffer.isBuffer(G)){const x=O.$Fe.wrap(G);q.write(a.Buffer),u(q,x.byteLength),q.write(x)}else if(G instanceof O.$Fe)q.write(a.VSBuffer),u(q,G.byteLength),q.write(G);else if(Array.isArray(G)){q.write(a.Array),u(q,G.length);for(const x of G)g(q,x)}else if(typeof G=="number"&&(G|0)===G)q.write(a.Uint),u(q,G);else{const x=O.$Fe.fromString(JSON.stringify(G));q.write(a.Object),u(q,x.byteLength),q.write(x)}}function w(q){switch(q.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return q.read(n(q)).toString();case c.Buffer:return q.read(n(q)).buffer;case c.VSBuffer:return q.read(n(q));case c.Array:{const x=n(q),ne=[];for(let be=0;be<x;be++)ne.push(w(q));return ne}case c.Object:return JSON.parse(q.read(n(q)).toString());case c.Int:return n(q)}}class S{constructor(G,x,ne=null,be=1e3){this.h=G,this.j=x,this.k=ne,this.l=be,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(G,x){this.b.set(G,x),setTimeout(()=>this.w(G),0)}m(G){switch(G.type){case 200:{const x=this.o([G.type]);this.k?.logOutgoing(x,0,1,d(G.type));return}case 201:case 202:case 204:case 203:{const x=this.o([G.type,G.id],G.data);this.k?.logOutgoing(x,G.id,1,d(G.type),G.data);return}}}o(G,x=void 0){const ne=new t;return g(ne,G),g(ne,x),this.p(ne.buffer)}p(G){try{return this.h.send(G),G.byteLength}catch{return 0}}q(G){const x=new s(G),ne=w(x),be=w(x),ae=ne[0];switch(ae){case 100:return this.k?.logIncoming(G.byteLength,ne[1],1,`${v(ae)}: ${ne[2]}.${ne[3]}`,be),this.s({type:ae,id:ne[1],channelName:ne[2],name:ne[3],arg:be});case 102:return this.k?.logIncoming(G.byteLength,ne[1],1,`${v(ae)}: ${ne[2]}.${ne[3]}`,be),this.t({type:ae,id:ne[1],channelName:ne[2],name:ne[3],arg:be});case 101:return this.k?.logIncoming(G.byteLength,ne[1],1,`${v(ae)}`),this.u({type:ae,id:ne[1]});case 103:return this.k?.logIncoming(G.byteLength,ne[1],1,`${v(ae)}`),this.u({type:ae,id:ne[1]})}}s(G){const x=this.b.get(G.channelName);if(!x){this.v(G);return}const ne=new R.$oe;let be;try{be=x.call(this.j,G.name,G.arg,ne.token)}catch(ee){be=Promise.reject(ee)}const ae=G.id;be.then(ee=>{this.m({id:ae,data:ee,type:201})},ee=>{ee instanceof Error?this.m({id:ae,data:{message:ee.message,name:ee.name,stack:ee.stack?ee.stack.split?ee.stack.split(`
`):ee.stack:void 0},type:202}):this.m({id:ae,data:ee,type:203})}).finally(()=>{Ie.dispose(),this.d.delete(G.id)});const Ie=(0,k.$Sc)(()=>ne.cancel());this.d.set(G.id,Ie)}t(G){const x=this.b.get(G.channelName);if(!x){this.v(G);return}const ne=G.id,ae=x.listen(this.j,G.name,G.arg)(Ie=>this.m({id:ne,data:Ie,type:204}));this.d.set(G.id,ae)}u(G){const x=this.d.get(G.id);x&&(x.dispose(),this.d.delete(G.id))}v(G){let x=this.g.get(G.channelName);x||(x=[],this.g.set(G.channelName,x));const ne=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===100&&this.m({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);x.push({request:G,timeoutTimer:ne})}w(G){const x=this.g.get(G);if(x){for(const ne of x)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(G)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,k.$Pc)(this.d.values()),this.d.clear()}}e.$$h=S;var m;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(m||(e.RequestInitiator=m={}));class E{constructor(G,x=null){this.l=G,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$de,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=x}getChannel(G){const x=this;return{call(ne,be,ae){return x.a?Promise.reject(new b.$5):x.m(G,ne,be,ae)},listen(ne,be){return x.a?$.Event.None:x.o(G,ne,be)}}}m(G,x,ne,be=R.CancellationToken.None){const ae=this.g++,ee={id:ae,type:100,channelName:G,name:x,arg:ne};if(be.isCancellationRequested)return Promise.reject(new b.$5);let B;return new Promise((pe,ue)=>{if(be.isCancellationRequested)return ue(new b.$5);const ce=()=>{const se=$e=>{switch($e.type){case 201:this.f.delete(ae),pe($e.data);break;case 202:{this.f.delete(ae);const ve=new Error($e.data.message);ve.stack=Array.isArray($e.data.stack)?$e.data.stack.join(`
`):$e.data.stack,ve.name=$e.data.name,ue(ve);break}case 203:this.f.delete(ae),ue($e.data);break}};this.f.set(ae,se),this.p(ee)};let oe=null;this.b===o.Idle?ce():(oe=(0,N.$jh)(se=>this.u()),oe.then(()=>{oe=null,ce()}));const le=()=>{oe?(oe.cancel(),oe=null):this.p({id:ae,type:101}),ue(new b.$5)},K=be.onCancellationRequested(le);B=(0,k.$Rc)((0,k.$Sc)(le),K),this.d.add(B)}).finally(()=>{B.dispose(),this.d.delete(B)})}o(G,x,ne){const be=this.g++,Ie={id:be,type:102,channelName:G,name:x,arg:ne};let ee=null;const B=new $.$de({onWillAddFirstListener:()=>{ee=(0,N.$jh)(pe=>this.u()),ee.then(()=>{ee=null,this.d.add(B),this.p(Ie)})},onDidRemoveLastListener:()=>{ee?(ee.cancel(),ee=null):(this.d.delete(B),this.p({id:be,type:103}))}}),_=pe=>B.fire(pe.data);return this.f.set(be,_),B.event}p(G){switch(G.type){case 100:case 102:{const x=this.q([G.type,G.id,G.channelName,G.name],G.arg);this.j?.logOutgoing(x,G.id,0,`${v(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case 101:case 103:{const x=this.q([G.type,G.id]);this.j?.logOutgoing(x,G.id,0,v(G.type));return}}}q(G,x=void 0){const ne=new t;return g(ne,G),g(ne,x),this.r(ne.buffer)}r(G){try{return this.l.send(G),G.byteLength}catch{return 0}}s(G){const x=new s(G),ne=w(x),be=w(x),ae=ne[0];switch(ae){case 200:return this.j?.logIncoming(G.byteLength,0,0,d(ae)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(G.byteLength,ne[1],0,d(ae),be),this.t({type:ne[0],id:ne[1],data:be})}}t(G){if(G.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(G.id)?.(G)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,k.$Pc)(this.d.values()),this.d.clear()}}e.$_h=E,He([M.$1h],E.prototype,"onDidInitializePromise",null);class D{get connections(){const G=[];return this.f.forEach(x=>G.push(x)),G}constructor(G,x,ne){this.a=new Map,this.f=new Set,this.g=new $.$de,this.onDidAddConnection=this.g.event,this.h=new $.$de,this.onDidRemoveConnection=this.h.event,this.j=new k.$Tc,this.j.add(G(({protocol:be,onDidClientDisconnect:ae})=>{const Ie=$.Event.once(be.onMessage);this.j.add(Ie(ee=>{const B=new s(ee),_=w(B),pe=new S(be,_,x,ne),ue=new E(be,x);this.a.forEach((oe,le)=>pe.registerChannel(le,oe));const ce={channelServer:pe,channelClient:ue,ctx:_};this.f.add(ce),this.g.fire(ce),this.j.add(ae(()=>{pe.dispose(),ue.dispose(),this.f.delete(ce),this.h.fire(ce)}))}))}))}getChannel(G,x){const ne=this;return{call(be,ae,Ie){let ee;if((0,p.$kg)(x)){const _=(0,h.$3b)(ne.connections.filter(x));ee=_?Promise.resolve(_):$.Event.toPromise($.Event.filter(ne.onDidAddConnection,x))}else ee=x.routeCall(ne,be,ae);const B=ee.then(_=>_.channelClient.getChannel(G));return P(B).call(be,ae,Ie)},listen(be,ae){if((0,p.$kg)(x))return ne.k(G,x,be,ae);const Ie=x.routeEvent(ne,be,ae).then(ee=>ee.channelClient.getChannel(G));return P(Ie).listen(be,ae)}}}k(G,x,ne,be){const ae=this;let Ie;const ee=new $.$de({onWillAddFirstListener:()=>{Ie=new k.$Tc;const B=new $.$je,_=new Map,pe=ce=>{const le=ce.channelClient.getChannel(G).listen(ne,be),K=B.add(le);_.set(ce,K)},ue=ce=>{const oe=_.get(ce);oe&&(oe.dispose(),_.delete(ce))};ae.connections.filter(x).forEach(pe),$.Event.filter(ae.onDidAddConnection,x)(pe,void 0,Ie),ae.onDidRemoveConnection(ue,void 0,Ie),B.event(ee.fire,ee,Ie),Ie.add(B)},onDidRemoveLastListener:()=>{Ie?.dispose(),Ie=void 0}});return ee.event}registerChannel(G,x){this.a.set(G,x);for(const ne of this.f)ne.channelServer.registerChannel(G,x)}dispose(){this.j.dispose();for(const G of this.f)G.channelClient.dispose(),G.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ai=D;class C{constructor(G,x,ne=null){const be=new t;g(be,x),G.send(be.buffer),this.a=new E(G,ne),this.d=new S(G,x,ne)}getChannel(G){return this.a.getChannel(G)}registerChannel(G,x){this.d.registerChannel(G,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.$bi=C;function P(q){return{call(G,x,ne){return q.then(be=>be.call(G,x,ne))},listen(G,x){const ne=new $.$me;return q.then(be=>ne.input=be.listen(G,x)),ne.event}}}function F(q){let G=!1;return{call(x,ne,be){return G?q.call(x,ne,be):(0,N.$xh)(0).then(()=>G=!0).then(()=>q.call(x,ne,be))},listen(x,ne){if(G)return q.listen(x,ne);const be=new $.$me;return(0,N.$xh)(0).then(()=>G=!0).then(()=>be.input=q.listen(x,ne)),be.event}}}class T{constructor(G){this.a=G}routeCall(G){return this.b(G)}routeEvent(G){return this.b(G)}async b(G){for(const x of G.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await $.Event.toPromise(G.onDidAddConnection),await this.b(G)}}e.$ei=T;var z;(function(q){function G(ae,Ie,ee){const B=ae,_=ee&&ee.disableMarshalling,pe=new Map;for(const ue in B)ne(ue)&&pe.set(ue,$.Event.buffer(B[ue],!0,void 0,Ie));return new class{listen(ue,ce,oe){const le=pe.get(ce);if(le)return le;const K=B[ce];if(typeof K=="function"){if(be(ce))return K.call(B,oe);if(ne(ce))return pe.set(ce,$.Event.buffer(B[ce],!0,void 0,Ie)),pe.get(ce)}throw new b.$bb(`Event not found: ${ce}`)}call(ue,ce,oe){const le=B[ce];if(typeof le=="function"){if(!_&&Array.isArray(oe))for(let se=0;se<oe.length;se++)oe[se]=(0,A.$6h)(oe[se]);let K=le.apply(B,oe);return K instanceof Promise||(K=Promise.resolve(K)),K}throw new b.$bb(`Method not found: ${ce}`)}}}q.fromService=G;function x(ae,Ie){const ee=Ie&&Ie.disableMarshalling;return new Proxy({},{get(B,_){if(typeof _=="string")return Ie?.properties?.has(_)?Ie.properties.get(_):be(_)?function(pe){return ae.listen(_,pe)}:ne(_)?ae.listen(_):async function(...pe){let ue;Ie&&!(0,p.$fg)(Ie.context)?ue=[Ie.context,...pe]:ue=pe;const ce=await ae.call(_,ue);return ee?ce:(0,A.$6h)(ce)};throw new b.$bb(`Property not found: ${String(_)}`)}})}q.toService=x;function ne(ae){return ae[0]==="o"&&ae[1]==="n"&&I.$wf(ae.charCodeAt(2))}function be(ae){return/^onDynamic/.test(ae)&&I.$wf(ae.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const L=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const G=q.toString();if(G!=="[object Object]")return G}return q}function U(q){return Array.isArray(q)?q.map(j):j(q)}function X(q,G,x,ne,be,ae,Ie){Ie=U(Ie);const ee=L[be],B=ee[ne%ee.length];let _=[`%c[${q}]%c[${String(G).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(ae)?(_=_.concat(Ie),_.push(")")):_.push(Ie),console.log.apply(console,_)}class ie{constructor(G,x){this.d=G,this.f=x,this.a=0,this.b=0}logOutgoing(G,x,ne,be,ae){this.b+=G,X(this.d,this.b,G,x,ne,be,ae)}logIncoming(G,x,ne,be,ae){this.a+=G,X(this.f,this.a,G,x,ne,be,ae)}}e.$fi=ie}),define(Se[83],De([1,0,21,4,3,82]),function(he,e,h,N,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=e.$ii=e.$hi=e.ProtocolConstants=e.$gi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(a){a.Created="created",a.Read="read",a.Write="write",a.Open="open",a.Error="error",a.Close="close",a.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",a.NodeEndReceived="nodeEndReceived",a.NodeEndSent="nodeEndSent",a.NodeDrainBegin="nodeDrainBegin",a.NodeDrainEnd="nodeDrainEnd",a.zlibInflateError="zlibInflateError",a.zlibInflateData="zlibInflateData",a.zlibInflateInitialWrite="zlibInflateInitialWrite",a.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",a.zlibInflateWrite="zlibInflateWrite",a.zlibInflateFlushFired="zlibInflateFlushFired",a.zlibDeflateError="zlibDeflateError",a.zlibDeflateData="zlibDeflateData",a.zlibDeflateWrite="zlibDeflateWrite",a.zlibDeflateFlushFired="zlibDeflateFlushFired",a.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",a.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",a.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",a.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",a.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",a.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",a.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",a.ProtocolHeaderRead="protocolHeaderRead",a.ProtocolMessageRead="protocolMessageRead",a.ProtocolHeaderWrite="protocolHeaderWrite",a.ProtocolMessageWrite="protocolMessageWrite",a.ProtocolWrite="protocolWrite"})(M||(e.SocketDiagnosticsEventType=M={}));var b;(function(a){a.enableDiagnostics=!1,a.records=[];const f=new WeakMap;let g=0;function w(m,E){if(!f.has(m)){const D=String(++g);f.set(m,D)}return f.get(m)}function S(m,E,D,C){if(!a.enableDiagnostics)return;const P=w(m,E);if(C instanceof h.$Fe||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const F=h.$Fe.alloc(C.byteLength);F.set(C),a.records.push({timestamp:Date.now(),id:P,label:E,type:D,buff:F})}else a.records.push({timestamp:Date.now(),id:P,label:E,type:D,data:C})}a.traceSocketEvent=S})(b||(e.SocketDiagnostics=b={}));var $;(function(a){a[a.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",a[a.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let k=null;function A(){return k||(k=h.$Fe.alloc(0)),k}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(f){this.a.push(f),this.b+=f.byteLength}read(f){return this.c(f,!0)}peek(f){return this.c(f,!1)}c(f,g){if(f===0)return A();if(f>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===f){const E=this.a[0];return g&&(this.a.shift(),this.b-=f),E}if(this.a[0].byteLength>f){const E=this.a[0].slice(0,f);return g&&(this.a[0]=this.a[0].slice(f),this.b-=f),E}const w=h.$Fe.alloc(f);let S=0,m=0;for(;f>0;){const E=this.a[m];if(E.byteLength>f){const D=E.slice(0,f);w.set(D,S),S+=f,g&&(this.a[m]=E.slice(f),this.b-=f),f-=f}else w.set(E,S),S+=E.byteLength,g?(this.a.shift(),this.b-=E.byteLength):m++,f-=E.byteLength}return w}}e.$gi=I;var p;(function(a){a[a.None=0]="None",a[a.Regular=1]="Regular",a[a.Control=2]="Control",a[a.Ack=3]="Ack",a[a.Disconnect=5]="Disconnect",a[a.ReplayRequest=6]="ReplayRequest",a[a.Pause=7]="Pause",a[a.Resume=8]="Resume",a[a.KeepAlive=9]="KeepAlive"})(p||(p={}));function y(a){switch(a){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(a){a[a.HeaderLength=13]="HeaderLength",a[a.AcknowledgeTime=2e3]="AcknowledgeTime",a[a.TimeoutTime=2e4]="TimeoutTime",a[a.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",a[a.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",a[a.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class l{constructor(f,g,w,S){this.type=f,this.id=g,this.ack=w,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends O.$Uc{constructor(f){super(),this.f=this.B(new N.$de),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=f,this.b=!1,this.c=new I,this.B(this.a.onData(g=>this.acceptChunk(g))),this.lastReadTime=Date.now()}acceptChunk(f){if(!(!f||f.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(f);this.c.byteLength>=this.g.readLen;){const g=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=g.readUInt32BE(9),this.g.messageType=g.readUInt8(0),this.g.id=g.readUInt32BE(1),this.g.ack=g.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const w=this.g.messageType,S=this.g.id,m=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",g),this.f.fire(new l(w,S,m,g)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(f){this.k=null,this.a=!1,this.b=!1,this.c=f,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(f){if(this.a)return;f.writtenTime=Date.now(),this.lastWriteTime=Date.now();const g=h.$Fe.alloc(13);g.writeUInt8(f.type,0),g.writeUInt32BE(f.id,1),g.writeUInt32BE(f.ack,5),g.writeUInt32BE(f.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(f.type),id:f.id,ack:f.ack,messageSize:f.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",f.data),this.j(g,f.data)}g(f,g){const w=this.f===0;return this.d.push(f,g),this.f+=f.byteLength+g.byteLength,w}h(){const f=h.$Fe.concat(this.d,this.f);return this.d.length=0,this.f=0,f}j(f,g){this.g(f,g)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const f=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:f.byteLength}),this.c.write(f)}}class n extends O.$Uc{constructor(f){super(),this.f=new N.$de,this.onMessage=this.f.event,this.g=new N.$de,this.onDidDispose=this.g.event,this.a=f,this.b=this.B(new o(this.a)),this.c=this.B(new d(this.a)),this.B(this.c.onMessage(g=>{g.type===1&&this.f.fire(g.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(f){this.b.write(new l(1,0,0,f))}}e.$hi=n;class i extends R.$bi{static fromSocket(f,g){return new i(new n(f),g)}get onDidDispose(){return this.b.onDidDispose}constructor(f,g,w=null){super(f,g,w),this.b=f}dispose(){super.dispose();const f=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),f.end()}}e.$ii=i;class u{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$de({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(f){this.b?this.d.length>0?this.d.push(f):this.a.fire(f):this.d.push(f)}flushBuffer(){this.d=[]}}e.$ji=u;class s{constructor(f){this.data=f,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let f=0,g=this.a;for(;g;)g=g.next,f++;return f}peek(){return this.a?this.a.data:null}toArray(){const f=[];let g=0,w=this.a;for(;w;)f[g++]=w.data,w=w.next;return f}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(f){const g=new s(f);if(!this.a){this.a=g,this.b=g;return}this.b.next=g,this.b=g}}class c{static{this.a=10}static{this.b=null}static getInstance(){return c.b||(c.b=new c),c.b}constructor(){this.c=[];const f=Date.now();for(let g=0;g<c.a;g++)this.c[g]=f-1e3*g;setInterval(()=>{for(let g=c.a;g>=1;g--)this.c[g]=this.c[g-1];this.c[0]=Date.now()},1e3)}d(){const f=Date.now(),g=(1+c.a)*1e3;let w=0;for(let S=0;S<c.a;S++)f-this.c[S]<=g&&w++;return 1-w/c.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(f){this.u=new u,this.onControlMessage=this.u.event,this.v=new u,this.onMessage=this.v.event,this.w=new u,this.onDidDispose=this.w.event,this.x=new u,this.onSocketClose=this.x.event,this.y=new u,this.onSocketTimeout=this.y.event,this.s=f.loadEstimator??c.getInstance(),this.t=f.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new O.$Tc,this.o=f.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(g=>this.z(g))),this.r.add(this.o.onClose(g=>this.x.fire(g))),f.initialChunk&&this.q.acceptChunk(f.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const f=new l(5,0,0,A());this.p.write(f),this.p.flush()}sendPause(){const f=new l(7,0,0,A());this.p.write(f)}sendResume(){const f=new l(8,0,0,A());this.p.write(f)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(f,g){this.a=!0,this.r.dispose(),this.r=new O.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=f,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(w=>this.z(w))),this.r.add(this.o.onClose(w=>this.x.fire(w))),this.q.acceptChunk(g)}endAcceptReconnection(){this.a=!1,this.h=this.g;const f=new l(3,0,this.h,A());this.p.write(f);const g=this.b.toArray();for(let w=0,S=g.length;w<S;w++)this.p.write(g[w]);this.B()}acceptDisconnect(){this.w.fire()}z(f){if(f.ack>this.d){this.d=f.ack;do{const g=this.b.peek();if(g&&g.id<=f.ack)this.b.pop();else break}while(!0)}switch(f.type){case 0:break;case 1:{if(f.id>this.g)if(f.id!==this.g+1){const g=Date.now();g-this.m>1e4&&(this.m=g,this.p.write(new l(6,0,0,A())))}else this.g=f.id,this.j=Date.now(),this.A(),this.v.fire(f.data);break}case 2:{this.u.fire(f.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const g=this.b.toArray();for(let w=0,S=g.length;w<S;w++)this.p.write(g[w]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(f){const g=++this.c;this.h=this.g;const w=new l(1,g,this.h,f);this.b.push(w),this.a||(this.p.write(w),this.B())}sendControl(f){const g=new l(2,0,0,f);this.p.write(g)}A(){if(this.g<=this.h||this.k)return;const f=Date.now()-this.j;if(f>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-f+5)}B(){if(this.c<=this.d||this.f||this.a)return;const f=this.b.peek(),g=Date.now()-f.writtenTime,w=Date.now()-this.q.lastReadTime,S=Date.now()-this.n;if(g>=2e4&&w>=2e4&&S>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:g,timeSinceLastReceivedSomeData:w});return}const m=Math.max(2e4-g,2e4-w,2e4-S,500);this.f=setTimeout(()=>{this.f=null,this.B()},m)}C(){if(this.g<=this.h)return;this.h=this.g;const f=new l(3,0,this.h,A());this.p.write(f)}D(){this.h=this.g;const f=new l(9,0,this.h,A());this.p.write(f)}}e.$ki=r}),define(Se[199],De([1,0,54,7,21,22,197,13,4,3,24,105,102,82]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=void 0;class v extends y.$$h{constructor(o){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",n=>O.$Fe.wrap(Buffer.from(n,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$Zq=v;class l{constructor(o,n){this.i=o,this.j=n,this.c=new Set,this.g=new Map,this.h=new $.$de,this.onDidProcessExit=this.h.event;const i=n&&n.timeout?n.timeout:6e4;this.b=new N.$th(i),this.d=null,this.f=null}getChannel(o){const n=this;return{call(i,u,s){return n.k(o,i,u,s)},listen(i,u){return n.l(o,i,u)}}}k(o,n,i,u=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const s=this.n(o),t=(0,N.$jh)(a=>s.call(n,i,a)),c=u.onCancellationRequested(()=>t.cancel()),r=(0,k.$Sc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{c.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,n,i){if(!this.b)return $.Event.None;this.b.cancel();let u;const s=new $.$de({onWillAddFirstListener:()=>{u=this.n(o).listen(n,i)(s.fire,s),this.c.add(u)},onDidRemoveLastListener:()=>{this.c.delete(u),u.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,A.$3n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(g=>!/^--inspect(-brk)?=/.test(g)).filter(g=>!g.startsWith("--vscode-"))),(0,p.$nm)(n.env),this.d=(0,h.fork)(this.i,o,n);const i=new $.$de,s=$.Event.fromNodeEventEmitter(this.d,"message",g=>g)(g=>{if((0,M.$Vq)(g)){(0,M.log)(g,`IPC Library: ${this.j.serverName}`);return}i.fire(O.$Fe.wrap(Buffer.from(g,"base64")))}),t=this.j.useQueue?(0,I.$pm)(this.d):this.d,c=g=>this.d&&this.d.connected&&t.send(g.buffer.toString("base64")),r=i.event,a={send:c,onMessage:r};this.f=new y.$_h(a);const f=()=>this.o();process.once("exit",f),this.d.on("error",g=>console.warn('IPC "'+this.j.serverName+'" errored with '+g)),this.d.on("exit",(g,w)=>{process.removeListener("exit",f),s.dispose(),this.c.forEach(S=>(0,k.$Pc)(S)),this.c.clear(),g!==0&&w!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+g+" and signal "+w),this.b?.cancel(),this.o(),this.h.fire({code:g,signal:w})})}return this.f}n(o){let n=this.g.get(o);return n||(n=this.m.getChannel(o),this.g.set(o,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$1q=l}),define(Se[200],De([1,0,7,4,3,58,18]),function(he,e,h,N,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=e.StorageState=e.StorageHint=void 0,e.$Vp=$;var b;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function $(p){const y=p;return y?.changed instanceof Map||y?.deleted instanceof Set}var k;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(k||(e.StorageState=k={}));class A extends O.$Uc{static{this.a=100}constructor(y,v=Object.create(null)){super(),this.r=y,this.s=v,this.b=this.B(new N.$ge),this.onDidChangeStorage=this.b.event,this.c=k.None,this.f=new Map,this.g=this.B(new h.$uh(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(y=>this.u(y)))}u(y){this.b.pause();try{y.changed?.forEach((v,l)=>this.w(l,v)),y.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(y,v){if(this.c===k.Closed)return;let l=!1;(0,M.$fg)(v)?l=this.f.delete(y):this.f.get(y)!==v&&(this.f.set(y,v),l=!0),l&&this.b.fire({key:y,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===k.None&&(this.c=k.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(y,v){const l=this.f.get(y);return(0,M.$fg)(l)?v:l}getBoolean(y,v){const l=this.get(y);return(0,M.$fg)(l)?v:l==="true"}getNumber(y,v){const l=this.get(y);return(0,M.$fg)(l)?v:parseInt(l,10)}getObject(y,v){const l=this.get(y);return(0,M.$fg)(l)?v:(0,R.$5h)(l)}async set(y,v,l=!1){if(this.c===k.Closed)return;if((0,M.$fg)(v))return this.delete(y,l);const d=(0,M.$$f)(v)||Array.isArray(v)?(0,R.$4h)(v):String(v);if(this.f.get(y)!==d)return this.f.set(y,d),this.j.set(y,d),this.h.delete(y),this.b.fire({key:y,external:l}),this.D()}async delete(y,v=!1){if(!(this.c===k.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire({key:y,external:v}),this.D()}async optimize(){if(this.c!==k.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=k.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(y).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(y){if(!(this.c===k.Closed||this.m))return this.D(y)}async D(y){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),y)}async whenFlushed(){if(this.z)return new Promise(y=>this.n.push(y))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$Wp=A;class I{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((v,l)=>this.a.set(l,v)),y.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$Xp=I}),define(Se[201],De([1,0,14,12,21]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=void 0,e.$Dt=A,e.$Et=I;let R;function M(){return R||(R=new TextDecoder("UTF-16LE")),R}let b;function $(){return b||(b=new TextDecoder("UTF-16BE")),b}let k;function A(){return k||(k=N.$D()?M():$()),k}function I(v,l,d){const o=new Uint16Array(v.buffer,l,d);return d>0&&(o[0]===65279||o[0]===65534)?p(v,l,d):M().decode(o)}function p(v,l,d){const o=[];let n=0;for(let i=0;i<d;i++){const u=O.$He(v,l);l+=2,o[n++]=String.fromCharCode(u)}return o.join("")}class y{constructor(l){this.a=l|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const l=new Uint16Array(this.b.buffer,0,this.d);return A().decode(l)}f(){const l=this.e();this.d=0,this.c===null?this.c=[l]:this.c[this.c.length]=l}appendCharCode(l){const d=this.a-this.d;d<=1&&(d===0||h.$Bf(l))&&this.f(),this.b[this.d++]=l}appendASCIICharCode(l){this.d===this.a&&this.f(),this.b[this.d++]=l}appendString(l){const d=l.length;if(this.d+d>=this.a){this.f(),this.c[this.c.length]=l;return}for(let o=0;o<d;o++)this.b[this.d++]=l.charCodeAt(o)}}e.$Ft=y}),define(Se[202],De([1,0,21,201]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gt=void 0,e.$Ht=M;function O($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(k,A,I,p){this.oldPosition=k,this.oldText=A,this.newPosition=I,this.newText=p}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${O(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${O(this.oldText)}")`:`(replace@${this.oldPosition} "${O(this.oldText)}" with "${O(this.newText)}")`}static a(k){return 4+2*k.length}static c(k,A,I){const p=A.length;h.$Ke(k,p,I),I+=4;for(let y=0;y<p;y++)h.$Ie(k,A.charCodeAt(y),I),I+=2;return I}static d(k,A){const I=h.$Je(k,A);return A+=4,(0,N.$Et)(k,A,I)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(k,A){return h.$Ke(k,this.oldPosition,A),A+=4,h.$Ke(k,this.newPosition,A),A+=4,A=R.c(k,this.oldText,A),A=R.c(k,this.newText,A),A}static read(k,A,I){const p=h.$Je(k,A);A+=4;const y=h.$Je(k,A);A+=4;const v=R.d(k,A);A+=R.a(v);const l=R.d(k,A);return A+=R.a(l),I.push(new R(p,v,y,l)),A}}e.$Gt=R;function M($,k){return $===null||$.length===0?k:new b($,k).compress()}class b{constructor(k,A){this.a=k,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let k=0,A=0,I=this.n(k),p=this.l(A);for(;k<this.f||A<this.h;){if(I===null){this.k(p),p=this.l(++A);continue}if(p===null){this.m(I),I=this.n(++k);continue}if(p.oldEnd<=I.newPosition){this.k(p),p=this.l(++A);continue}if(I.newEnd<=p.oldPosition){this.m(I),I=this.n(++k);continue}if(p.oldPosition<I.newPosition){const[o,n]=b.r(p,I.newPosition-p.oldPosition);this.k(o),p=n;continue}if(I.newPosition<p.oldPosition){const[o,n]=b.q(I,p.oldPosition-I.newPosition);this.m(o),I=n;continue}let l,d;if(p.oldEnd===I.newEnd)l=I,d=p,I=this.n(++k),p=this.l(++A);else if(p.oldEnd<I.newEnd){const[o,n]=b.q(I,p.oldLength);l=o,d=p,I=n,p=this.l(++A)}else{const[o,n]=b.r(p,I.newLength);l=I,d=o,I=this.n(++k),p=n}this.d[this.e++]=new R(l.oldPosition,l.oldText,d.newPosition,d.newText),this.g+=l.newLength-l.oldLength,this.j+=d.newLength-d.oldLength}const y=b.s(this.d);return b.t(y)}k(k){this.d[this.e++]=b.o(this.g,k),this.j+=k.newLength-k.oldLength}l(k){return k<this.h?this.c[k]:null}m(k){this.d[this.e++]=b.p(this.j,k),this.g+=k.newLength-k.oldLength}n(k){return k<this.f?this.a[k]:null}static o(k,A){return new R(A.oldPosition-k,A.oldText,A.newPosition,A.newText)}static p(k,A){return new R(A.oldPosition,A.oldText,A.newPosition+k,A.newText)}static q(k,A){const I=k.newText.substr(0,A),p=k.newText.substr(A);return[new R(k.oldPosition,k.oldText,k.newPosition,I),new R(k.oldEnd,"",k.newPosition+A,p)]}static r(k,A){const I=k.oldText.substr(0,A),p=k.oldText.substr(A);return[new R(k.oldPosition,I,k.newPosition,k.newText),new R(k.oldPosition+A,p,k.newEnd,"")]}static s(k){if(k.length===0)return k;const A=[];let I=0,p=k[0];for(let y=1;y<k.length;y++){const v=k[y];p.oldEnd===v.oldPosition?p=new R(p.oldPosition,p.oldText+v.oldText,p.newPosition,p.newText+v.newText):(A[I++]=p,p=v)}return A[I++]=p,A}static t(k){if(k.length===0)return k;const A=[];let I=0;for(let p=0;p<k.length;p++){const y=k[p];y.oldText!==y.newText&&(A[I++]=y)}return A}}}),define(Se[203],De([1,0,35,16]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xt=O,e.$Yt=R;function O(M,b,$,k,A,I){if(Array.isArray(M)){let p=0;for(const y of M){const v=O(y,b,$,k,A,I);if(v===10)return v;v>p&&(p=v)}return p}else{if(typeof M=="string")return k?M==="*"?5:M===$?10:0:0;if(M){const{language:p,pattern:y,scheme:v,hasAccessToAllModels:l,notebookType:d}=M;if(!k&&!l)return 0;d&&A&&(b=A);let o=0;if(v)if(v===b.scheme)o=10;else if(v==="*")o=5;else return 0;if(p)if(p===$)o=10;else if(p==="*")o=Math.max(o,5);else return 0;if(d)if(d===I)o=10;else if(d==="*"&&I!==void 0)o=Math.max(o,5);else return 0;if(y){let n;if(typeof y=="string"?n=y:n={...y,base:(0,N.$hc)(y.base)},n===b.fsPath||(0,h.$pk)(n,b.fsPath))o=10;else return 0}return o}else return 0}}function R(M){return typeof M=="string"?!1:Array.isArray(M)?M.some(R):!!M.notebookType}}),define(Se[204],De([1,0,4,14,29,80,131,179,202,3]),function(he,e,h,N,O,R,M,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1C=void 0;class A extends k.$Uc{constructor(p,y,v,l,d,o,n){super(),this.m=this.B(new h.$de),this.onDidChangeContent=this.m.event,this.f=y,this.j=!o,this.g=l,this.h=d,this.c=new M.$ZC(p,v,n)}equals(p){return!(p instanceof A)||this.f!==p.f||this.getEOL()!==p.getEOL()?!1:this.c.equal(p.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(p){return this.c.createSnapshot(p?this.f:"")}getOffsetAt(p,y){return this.c.getOffsetAt(p,y)}getPositionAt(p){return this.c.getPositionAt(p)}getRangeAt(p,y){const v=p+y,l=this.getPositionAt(p),d=this.getPositionAt(v);return new O.$ut(l.lineNumber,l.column,d.lineNumber,d.column)}getValueInRange(p,y=0){if(p.isEmpty())return"";const v=this.n(y);return this.c.getValueInRange(p,v)}getValueLengthInRange(p,y=0){if(p.isEmpty())return 0;if(p.startLineNumber===p.endLineNumber)return p.endColumn-p.startColumn;const v=this.getOffsetAt(p.startLineNumber,p.startColumn),l=this.getOffsetAt(p.endLineNumber,p.endColumn);let d=0;const o=this.n(y),n=this.getEOL();if(o.length!==n.length){const i=o.length-n.length,u=p.endLineNumber-p.startLineNumber;d=i*u}return l-v+d}getCharacterCountInRange(p,y=0){if(this.j){let v=0;const l=p.startLineNumber,d=p.endLineNumber;for(let o=l;o<=d;o++){const n=this.getLineContent(o),i=o===l?p.startColumn-1:0,u=o===d?p.endColumn-1:n.length;for(let s=i;s<u;s++)N.$Bf(n.charCodeAt(s))?(v=v+1,s=s+1):v=v+1}return v+=this.n(y).length*(d-l),v}return this.getValueLengthInRange(p,y)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(p){return this.c.getLineContent(p)}getLineCharCode(p,y){return this.c.getLineCharCode(p,y)}getCharCode(p){return this.c.getCharCode(p)}getLineLength(p){return this.c.getLineLength(p)}getLineMinColumn(p){return 1}getLineMaxColumn(p){return this.getLineLength(p)+1}getLineFirstNonWhitespaceColumn(p){const y=N.$mf(this.getLineContent(p));return y===-1?0:y+1}getLineLastNonWhitespaceColumn(p){const y=N.$of(this.getLineContent(p));return y===-1?0:y+2}n(p){switch(p){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(p){this.c.setEOL(p)}applyEdits(p,y,v){let l=this.g,d=this.h,o=this.j,n=!0,i=[];for(let f=0;f<p.length;f++){const g=p[f];n&&g._isTracked&&(n=!1);const w=g.range;if(g.text){let C=!0;o||(C=!N.$Mf(g.text),o=C),!l&&C&&(l=N.$Lf(g.text)),!d&&C&&(d=N.$Of(g.text))}let S="",m=0,E=0,D=0;if(g.text){let C;[m,E,D,C]=(0,b.$1t)(g.text);const P=this.getEOL();C===0||C===(P===`\r
`?2:1)?S=g.text:S=g.text.replace(/\r\n|\r|\n/g,P)}i[f]={sortIndex:f,identifier:g.identifier||null,range:w,rangeOffset:this.getOffsetAt(w.startLineNumber,w.startColumn),rangeLength:this.getValueLengthInRange(w),text:S,eolCount:m,firstLineLength:E,lastLineLength:D,forceMoveMarkers:!!g.forceMoveMarkers,isAutoWhitespaceEdit:g.isAutoWhitespaceEdit||!1}}i.sort(A.u);let u=!1;for(let f=0,g=i.length-1;f<g;f++){const w=i[f].range.getEndPosition(),S=i[f+1].range.getStartPosition();if(S.isBeforeOrEqual(w)){if(S.isBefore(w))throw new Error("Overlapping ranges are not allowed!");u=!0}}n&&(i=this.s(i));const s=v||y?A._getInverseEditRanges(i):[],t=[];if(y)for(let f=0;f<i.length;f++){const g=i[f],w=s[f];if(g.isAutoWhitespaceEdit&&g.range.isEmpty())for(let S=w.startLineNumber;S<=w.endLineNumber;S++){let m="";S===w.startLineNumber&&(m=this.getLineContent(g.range.startLineNumber),N.$mf(m)!==-1)||t.push({lineNumber:S,oldContent:m})}}let c=null;if(v){let f=0;c=[];for(let g=0;g<i.length;g++){const w=i[g],S=s[g],m=this.getValueInRange(w.range),E=w.rangeOffset+f;f+=w.text.length-m.length,c[g]={sortIndex:w.sortIndex,identifier:w.identifier,range:S,text:m,textChange:new $.$Gt(w.rangeOffset,m,E,w.text)}}u||c.sort((g,w)=>g.sortIndex-w.sortIndex)}this.g=l,this.h=d,this.j=o;const r=this.t(i);let a=null;if(y&&t.length>0){t.sort((f,g)=>g.lineNumber-f.lineNumber),a=[];for(let f=0,g=t.length;f<g;f++){const w=t[f].lineNumber;if(f>0&&t[f-1].lineNumber===w)continue;const S=t[f].oldContent,m=this.getLineContent(w);m.length===0||m===S||N.$mf(m)!==-1||a.push(w)}}return this.m.fire(),new R.$Jv(c,r,a)}s(p){return p.length<1e3?p:[this._toSingleEditOperation(p)]}_toSingleEditOperation(p){let y=!1;const v=p[0].range,l=p[p.length-1].range,d=new O.$ut(v.startLineNumber,v.startColumn,l.endLineNumber,l.endColumn);let o=v.startLineNumber,n=v.startColumn;const i=[];for(let r=0,a=p.length;r<a;r++){const f=p[r],g=f.range;y=y||f.forceMoveMarkers,i.push(this.getValueInRange(new O.$ut(o,n,g.startLineNumber,g.startColumn))),f.text.length>0&&i.push(f.text),o=g.endLineNumber,n=g.endColumn}const u=i.join(""),[s,t,c]=(0,b.$1t)(u);return{sortIndex:0,identifier:p[0].identifier,range:d,rangeOffset:this.getOffsetAt(d.startLineNumber,d.startColumn),rangeLength:this.getValueLengthInRange(d,0),text:u,eolCount:s,firstLineLength:t,lastLineLength:c,forceMoveMarkers:y,isAutoWhitespaceEdit:!1}}t(p){p.sort(A.w);const y=[];for(let v=0;v<p.length;v++){const l=p[v],d=l.range.startLineNumber,o=l.range.startColumn,n=l.range.endLineNumber,i=l.range.endColumn;if(d===n&&o===i&&l.text.length===0)continue;l.text?(this.c.delete(l.rangeOffset,l.rangeLength),this.c.insert(l.rangeOffset,l.text,!0)):this.c.delete(l.rangeOffset,l.rangeLength);const u=new O.$ut(d,o,n,i);y.push({range:u,rangeLength:l.rangeLength,text:l.text,rangeOffset:l.rangeOffset,forceMoveMarkers:l.forceMoveMarkers})}return y}findMatchesLineByLine(p,y,v,l){return this.c.findMatchesLineByLine(p,y,v,l)}getPieceTree(){return this.c}static _getInverseEditRange(p,y){const v=p.startLineNumber,l=p.startColumn,[d,o,n]=(0,b.$1t)(y);let i;if(y.length>0){const u=d+1;u===1?i=new O.$ut(v,l,v,l+o):i=new O.$ut(v,l,v+u-1,n+1)}else i=new O.$ut(v,l,v,l);return i}static _getInverseEditRanges(p){const y=[];let v=0,l=0,d=null;for(let o=0,n=p.length;o<n;o++){const i=p[o];let u,s;d?d.range.endLineNumber===i.range.startLineNumber?(u=v,s=l+(i.range.startColumn-d.range.endColumn)):(u=v+(i.range.startLineNumber-d.range.endLineNumber),s=i.range.startColumn):(u=i.range.startLineNumber,s=i.range.startColumn);let t;if(i.text.length>0){const c=i.eolCount+1;c===1?t=new O.$ut(u,s,u,s+i.firstLineLength):t=new O.$ut(u,s,u+c-1,i.lastLineLength+1)}else t=new O.$ut(u,s,u,s);v=t.endLineNumber,l=t.endColumn,y.push(t),d=i}return y}static u(p,y){const v=O.$ut.compareRangesUsingEnds(p.range,y.range);return v===0?p.sortIndex-y.sortIndex:v}static w(p,y){const v=O.$ut.compareRangesUsingEnds(p.range,y.range);return v===0?y.sortIndex-p.sortIndex:-v}}e.$1C=A}),define(Se[205],De([1,0,14,131,204]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2C=void 0;class R{constructor($,k,A,I,p,y,v,l,d){this.a=$,this.b=k,this.c=A,this.d=I,this.e=p,this.f=y,this.g=v,this.h=l,this.j=d}k($){const k=this.c+this.d+this.e,A=this.c+this.e;return k===0?$===1?`
`:`\r
`:A>k/2?`\r
`:`
`}create($){const k=this.k($),A=this.a;if(this.j&&(k===`\r
`&&(this.c>0||this.d>0)||k===`
`&&(this.c>0||this.e>0)))for(let p=0,y=A.length;p<y;p++){const v=A[p].buffer.replace(/\r\n|\r|\n/g,k),l=(0,N.$VC)(v);A[p]=new N.$YC(v,l)}const I=new O.$1C(A,this.b,k,this.f,this.g,this.h,this.j);return{textBuffer:I,disposable:I}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&h.$Wf($)&&(this.b=h.$Vf,$=$.substr(1));const k=$.charCodeAt($.length-1);k===13||k>=55296&&k<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=k):(this.m($,!1),this.c=!1,this.d=k)}m($,k){!k&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const k=(0,N.$WC)(this.e,$);this.a.push(new N.$YC($,k.lineStarts)),this.f+=k.cr,this.g+=k.lf,this.h+=k.crlf,k.isBasicASCII||(this.l=!1,this.j||(this.j=h.$Lf($)),this.k||(this.k=h.$Of($)))}finish($=!0){return this.o(),new R(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const k=(0,N.$VC)($.buffer);$.lineStarts=k,this.d===13&&this.f++}}}e.$2C=M}),define(Se[135],De([1,0,21,12]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hbb=$,e.$ibb=A;var O;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(O||(O={}));function R(I){for(let p=0,y=I.length;p<y;p+=4){const v=I[p+0],l=I[p+1],d=I[p+2],o=I[p+3];I[p+0]=o,I[p+1]=d,I[p+2]=l,I[p+3]=v}}function M(I){const p=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return N.$D()||R(p),h.$Fe.wrap(p)}function b(I){const p=I.buffer;if(N.$D()||R(p),p.byteOffset%4===0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const y=new Uint8Array(p.byteLength);return y.set(p),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function $(I){const p=new Uint32Array(k(I));let y=0;if(p[y++]=I.id,I.type==="full")p[y++]=1,p[y++]=I.data.length,p.set(I.data,y),y+=I.data.length;else{p[y++]=2,p[y++]=I.deltas.length;for(const v of I.deltas)p[y++]=v.start,p[y++]=v.deleteCount,v.data?(p[y++]=v.data.length,p.set(v.data,y),y+=v.data.length):p[y++]=0}return M(p)}function k(I){let p=0;if(p+=2,I.type==="full")p+=1+I.data.length;else{p+=1,p+=3*I.deltas.length;for(const y of I.deltas)y.data&&(p+=y.data.length)}return p}function A(I){const p=b(I);let y=0;const v=p[y++];if(p[y++]===1){const n=p[y++],i=p.subarray(y,y+n);return y+=n,{id:v,type:"full",data:i}}const d=p[y++],o=[];for(let n=0;n<d;n++){const i=p[y++],u=p[y++],s=p[y++];let t;s>0&&(t=p.subarray(y,y+s),y+=s),o[n]={start:i,deleteCount:u,data:t}}return{id:v,type:"delta",deltas:o}}}),define(Se[206],De([9,10]),function(he,e){return he.create("vs/editor/common/config/editorOptions",e)}),define(Se[136],De([1,0,19,24,12,182,130,206]),function(he,e,h,N,O,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=d,e.clampedInt=n,e.clampedFloat=u,e.stringSet=c,e.cursorStyleToString=D,e.filterValidationDecorations=ve;var $;(function(te){te[te.None=0]="None",te[te.Keep=1]="Keep",te[te.Brackets=2]="Brackets",te[te.Advanced=3]="Advanced",te[te.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(re){this.c=re}hasChanged(re){return this.c[re]}}e.ConfigurationChangedEvent=k;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class I{constructor(re,Ce,Pe,Xe){this.id=re,this.name=Ce,this.defaultValue=Pe,this.schema=Xe}applyUpdate(re,Ce){return y(re,Ce)}compute(re,Ce,Pe){return Pe}}class p{constructor(re,Ce){this.newValue=re,this.didChange=Ce}}e.ApplyUpdateResult=p;function y(te,re){if(typeof te!="object"||typeof re!="object"||!te||!re)return new p(re,te!==re);if(Array.isArray(te)||Array.isArray(re)){const Pe=Array.isArray(te)&&Array.isArray(re)&&h.$ub(te,re);return new p(re,!Pe)}let Ce=!1;for(const Pe in re)if(re.hasOwnProperty(Pe)){const Xe=y(te[Pe],re[Pe]);Xe.didChange&&(te[Pe]=Xe.newValue,Ce=!0)}return new p(te,Ce)}class v{constructor(re){this.schema=void 0,this.id=re,this.name="_never_",this.defaultValue=void 0}applyUpdate(re,Ce){return y(re,Ce)}validate(re){return this.defaultValue}}class l{constructor(re,Ce,Pe,Xe){this.id=re,this.name=Ce,this.defaultValue=Pe,this.schema=Xe}applyUpdate(re,Ce){return y(re,Ce)}validate(re){return typeof re>"u"?this.defaultValue:re}compute(re,Ce,Pe){return Pe}}function d(te,re){return typeof te>"u"?re:te==="false"?!1:!!te}class o extends l{constructor(re,Ce,Pe,Xe=void 0){typeof Xe<"u"&&(Xe.type="boolean",Xe.default=Pe),super(re,Ce,Pe,Xe)}validate(re){return d(re,this.defaultValue)}}function n(te,re,Ce,Pe){if(typeof te>"u")return re;let Xe=parseInt(te,10);return isNaN(Xe)?re:(Xe=Math.max(Ce,Xe),Xe=Math.min(Pe,Xe),Xe|0)}class i extends l{static clampedInt(re,Ce,Pe,Xe){return n(re,Ce,Pe,Xe)}constructor(re,Ce,Pe,Xe,st,lt=void 0){typeof lt<"u"&&(lt.type="integer",lt.default=Pe,lt.minimum=Xe,lt.maximum=st),super(re,Ce,Pe,lt),this.minimum=Xe,this.maximum=st}validate(re){return i.clampedInt(re,this.defaultValue,this.minimum,this.maximum)}}function u(te,re,Ce,Pe){if(typeof te>"u")return re;const Xe=s.float(te,re);return s.clamp(Xe,Ce,Pe)}class s extends l{static clamp(re,Ce,Pe){return re<Ce?Ce:re>Pe?Pe:re}static float(re,Ce){if(typeof re=="number")return re;if(typeof re>"u")return Ce;const Pe=parseFloat(re);return isNaN(Pe)?Ce:Pe}constructor(re,Ce,Pe,Xe,st){typeof st<"u"&&(st.type="number",st.default=Pe),super(re,Ce,Pe,st),this.validationFn=Xe}validate(re){return this.validationFn(s.float(re,this.defaultValue))}}class t extends l{static string(re,Ce){return typeof re!="string"?Ce:re}constructor(re,Ce,Pe,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.default=Pe),super(re,Ce,Pe,Xe)}validate(re){return t.string(re,this.defaultValue)}}function c(te,re,Ce,Pe){return typeof te!="string"?re:Pe&&te in Pe?Pe[te]:Ce.indexOf(te)===-1?re:te}class r extends l{constructor(re,Ce,Pe,Xe,st=void 0){typeof st<"u"&&(st.type="string",st.enum=Xe,st.default=Pe),super(re,Ce,Pe,st),this.c=Xe}validate(re){return c(re,this.defaultValue,this.c)}}class a extends I{constructor(re,Ce,Pe,Xe,st,lt,gt=void 0){typeof gt<"u"&&(gt.type="string",gt.enum=st,gt.default=Xe),super(re,Ce,Pe,gt),this.c=st,this.d=lt}validate(re){return typeof re!="string"?this.defaultValue:this.c.indexOf(re)===-1?this.defaultValue:this.d(re)}}function f(te){switch(te){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class g extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(re){switch(re){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(re,Ce,Pe){return Pe===0?re.accessibilitySupport:Pe}}class w extends I{constructor(){const re={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",re,{"editor.comments.insertSpace":{type:"boolean",default:re.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:re.ignoreEmptyLines,description:b.localize(5,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{insertSpace:d(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var S;(function(te){te[te.Hidden=0]="Hidden",te[te.Blink=1]="Blink",te[te.Smooth=2]="Smooth",te[te.Phase=3]="Phase",te[te.Expand=4]="Expand",te[te.Solid=5]="Solid"})(S||(e.TextEditorCursorBlinkingStyle=S={}));function m(te){switch(te){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var E;(function(te){te[te.Line=1]="Line",te[te.Block=2]="Block",te[te.Underline=3]="Underline",te[te.LineThin=4]="LineThin",te[te.BlockOutline=5]="BlockOutline",te[te.UnderlineThin=6]="UnderlineThin"})(E||(e.TextEditorCursorStyle=E={}));function D(te){switch(te){case E.Line:return"line";case E.Block:return"block";case E.Underline:return"underline";case E.LineThin:return"line-thin";case E.BlockOutline:return"block-outline";case E.UnderlineThin:return"underline-thin"}}function C(te){switch(te){case"line":return E.Line;case"block":return E.Block;case"underline":return E.Underline;case"line-thin":return E.LineThin;case"block-outline":return E.BlockOutline;case"underline-thin":return E.UnderlineThin}}class P extends v{constructor(){super(142)}compute(re,Ce,Pe){const Xe=["monaco-editor"];return Ce.get(39)&&Xe.push(Ce.get(39)),re.extraEditorClassName&&Xe.push(re.extraEditorClassName),Ce.get(74)==="default"?Xe.push("mouse-default"):Ce.get(74)==="copy"&&Xe.push("mouse-copy"),Ce.get(111)&&Xe.push("showUnused"),Ce.get(140)&&Xe.push("showDeprecated"),Xe.join(" ")}}class F extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(re,Ce,Pe){return Pe&&re.emptySelectionClipboard}}class T extends I{constructor(){const re={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",re,{"editor.find.cursorMoveOnType":{type:"boolean",default:re.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:re.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:re.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:re.globalFindClipboard,description:b.localize(16,null),included:O.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:re.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:re.loop,description:b.localize(18,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{cursorMoveOnType:d(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof re.seedSearchStringFromSelection=="boolean"?re.seedSearchStringFromSelection?"always":"never":c(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof re.autoFindInSelection=="boolean"?re.autoFindInSelection?"always":"never":c(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(Ce.loop,this.defaultValue.loop)}}}class z extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(re){return typeof re>"u"?this.defaultValue:typeof re=="string"?re==="false"||re.length===0?z.OFF:re==="true"?z.ON:re:re?z.ON:z.OFF}}e.EditorFontLigatures=z;class L extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",L.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(re){return typeof re>"u"?this.defaultValue:typeof re=="string"?re==="false"?L.OFF:re==="true"?L.TRANSLATE:re:re?L.TRANSLATE:L.OFF}compute(re,Ce,Pe){return re.fontInfo.fontVariationSettings}}e.EditorFontVariations=L;class j extends v{constructor(){super(50)}compute(re,Ce,Pe){return re.fontInfo}}class U extends l{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(re){const Ce=s.float(re,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(Ce,6,100)}compute(re,Ce,Pe){return re.fontInfo.fontSize}}class X extends I{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:X.d,maximum:X.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:X.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(re){return re==="normal"||re==="bold"?re:String(i.clampedInt(re,e.EDITOR_FONT_DEFAULTS.fontWeight,X.d,X.e))}}class ie extends I{constructor(){const re={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:re.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Pe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",re,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:re.alternativeDefinitionCommand,enum:Pe,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:re.alternativeTypeDefinitionCommand,enum:Pe,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:re.alternativeDeclarationCommand,enum:Pe,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:re.alternativeImplementationCommand,enum:Pe,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:re.alternativeReferenceCommand,enum:Pe,description:b.localize(41,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{multiple:c(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??c(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??c(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??c(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??c(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??c(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class q extends I{constructor(){const re={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",re,{"editor.hover.enabled":{type:"boolean",default:re.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:re.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:re.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:re.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:re.above,description:b.localize(46,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:d(Ce.enabled,this.defaultValue.enabled),delay:i.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:d(Ce.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:d(Ce.above,this.defaultValue.above)}}}var G;(function(te){te[te.None=0]="None",te[te.Text=1]="Text",te[te.Blocks=2]="Blocks"})(G||(e.RenderMinimap=G={}));class x extends v{constructor(){super(145)}compute(re,Ce,Pe){return x.computeLayout(Ce,{memory:re.memory,outerWidth:re.outerWidth,outerHeight:re.outerHeight,isDominatedByLongLines:re.isDominatedByLongLines,lineHeight:re.fontInfo.lineHeight,viewLineCount:re.viewLineCount,lineNumbersDigitCount:re.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:re.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:re.fontInfo.maxDigitWidth,pixelRatio:re.pixelRatio,glyphMarginDecorationLaneCount:re.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(re){const Ce=re.height/re.lineHeight,Pe=Math.floor(re.paddingTop/re.lineHeight);let Xe=Math.floor(re.paddingBottom/re.lineHeight);re.scrollBeyondLastLine&&(Xe=Math.max(Xe,Ce-1));const st=(Pe+re.viewLineCount+Xe)/(re.pixelRatio*re.height),lt=Math.floor(re.viewLineCount/st);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Pe,extraLinesBeyondLastLine:Xe,desiredRatio:st,minimapLineCount:lt}}static c(re,Ce){const Pe=re.outerWidth,Xe=re.outerHeight,st=re.pixelRatio;if(!re.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*Xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Xe};const lt=Ce.stableMinimapLayoutInput,gt=lt&&re.outerHeight===lt.outerHeight&&re.lineHeight===lt.lineHeight&&re.typicalHalfwidthCharacterWidth===lt.typicalHalfwidthCharacterWidth&&re.pixelRatio===lt.pixelRatio&&re.scrollBeyondLastLine===lt.scrollBeyondLastLine&&re.paddingTop===lt.paddingTop&&re.paddingBottom===lt.paddingBottom&&re.minimap.enabled===lt.minimap.enabled&&re.minimap.side===lt.minimap.side&&re.minimap.size===lt.minimap.size&&re.minimap.showSlider===lt.minimap.showSlider&&re.minimap.renderCharacters===lt.minimap.renderCharacters&&re.minimap.maxColumn===lt.minimap.maxColumn&&re.minimap.scale===lt.minimap.scale&&re.verticalScrollbarWidth===lt.verticalScrollbarWidth&&re.isViewportWrapping===lt.isViewportWrapping,It=re.lineHeight,Pt=re.typicalHalfwidthCharacterWidth,zt=re.scrollBeyondLastLine,Bt=re.minimap.renderCharacters;let Dt=st>=2?Math.round(re.minimap.scale*2):re.minimap.scale;const _t=re.minimap.maxColumn,xe=re.minimap.size,tn=re.minimap.side,nn=re.verticalScrollbarWidth,ft=re.viewLineCount,bt=re.remainingWidth,Ut=re.isViewportWrapping,Kt=Bt?2:3;let Ft=Math.floor(st*Xe);const $t=Ft/st;let Rt=!1,cn=!1,Vt=Kt*Dt,Ze=Dt/st,rn=1;if(xe==="fill"||xe==="fit"){const{typicalViewportLineCount:Qt,extraLinesBeforeFirstLine:Yt,extraLinesBeyondLastLine:Zt,desiredRatio:Wt,minimapLineCount:Mt}=x.computeContainedMinimapLineCount({viewLineCount:ft,scrollBeyondLastLine:zt,paddingTop:re.paddingTop,paddingBottom:re.paddingBottom,height:Xe,lineHeight:It,pixelRatio:st});if(ft/Mt>1)Rt=!0,cn=!0,Dt=1,Vt=1,Ze=Dt/st;else{let Ct=!1,Et=Dt+1;if(xe==="fit"){const wt=Math.ceil((Yt+ft+Zt)*Vt);Ut&&gt&&bt<=Ce.stableFitRemainingWidth?(Ct=!0,Et=Ce.stableFitMaxMinimapScale):Ct=wt>Ft}if(xe==="fill"||Ct){Rt=!0;const wt=Dt;Vt=Math.min(It*st,Math.max(1,Math.floor(1/Wt))),Ut&&gt&&bt<=Ce.stableFitRemainingWidth&&(Et=Ce.stableFitMaxMinimapScale),Dt=Math.min(Et,Math.max(1,Math.floor(Vt/Kt))),Dt>wt&&(rn=Math.min(2,Dt/wt)),Ze=Dt/st/rn,Ft=Math.ceil(Math.max(Qt,Yt+ft+Zt)*Vt),Ut?(Ce.stableMinimapLayoutInput=re,Ce.stableFitRemainingWidth=bt,Ce.stableFitMaxMinimapScale=Dt):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const un=Math.floor(_t*Ze),Jt=Math.min(un,Math.max(0,Math.floor((bt-nn-2)*Ze/(Pt+Ze)))+e.MINIMAP_GUTTER_WIDTH);let mt=Math.floor(st*Jt);const Nt=mt/st;mt=Math.floor(mt*rn);const Lt=Bt?1:2,Tt=tn==="left"?0:Pe-Jt-nn;return{renderMinimap:Lt,minimapLeft:Tt,minimapWidth:Jt,minimapHeightIsEditorHeight:Rt,minimapIsSampling:cn,minimapScale:Dt,minimapLineHeight:Vt,minimapCanvasInnerWidth:mt,minimapCanvasInnerHeight:Ft,minimapCanvasOuterWidth:Nt,minimapCanvasOuterHeight:$t}}static computeLayout(re,Ce){const Pe=Ce.outerWidth|0,Xe=Ce.outerHeight|0,st=Ce.lineHeight|0,lt=Ce.lineNumbersDigitCount|0,gt=Ce.typicalHalfwidthCharacterWidth,It=Ce.maxDigitWidth,Pt=Ce.pixelRatio,zt=Ce.viewLineCount,Bt=re.get(137),Dt=Bt==="inherit"?re.get(136):Bt,_t=Dt==="inherit"?re.get(132):Dt,xe=re.get(135),tn=Ce.isDominatedByLongLines,nn=re.get(57),ft=re.get(68).renderType!==0,bt=re.get(69),Ut=re.get(105),Kt=re.get(84),Ft=re.get(73),$t=re.get(103),Rt=$t.verticalScrollbarSize,cn=$t.verticalHasArrows,Vt=$t.arrowSize,Ze=$t.horizontalScrollbarSize,rn=re.get(43),un=re.get(110)!=="never";let Jt=re.get(66);rn&&un&&(Jt+=16);let mt=0;if(ft){const kt=Math.max(lt,bt);mt=Math.round(kt*It)}let Nt=0;nn&&(Nt=st*Ce.glyphMarginDecorationLaneCount);let Lt=0,Tt=Lt+Nt,Qt=Tt+mt,Yt=Qt+Jt;const Zt=Pe-Nt-mt-Jt;let Wt=!1,Mt=!1,Xt=-1;Dt==="inherit"&&tn?(Wt=!0,Mt=!0):_t==="on"||_t==="bounded"?Mt=!0:_t==="wordWrapColumn"&&(Xt=xe);const Ct=x.c({outerWidth:Pe,outerHeight:Xe,lineHeight:st,typicalHalfwidthCharacterWidth:gt,pixelRatio:Pt,scrollBeyondLastLine:Ut,paddingTop:Kt.top,paddingBottom:Kt.bottom,minimap:Ft,verticalScrollbarWidth:Rt,viewLineCount:zt,remainingWidth:Zt,isViewportWrapping:Mt},Ce.memory||new A);Ct.renderMinimap!==0&&Ct.minimapLeft===0&&(Lt+=Ct.minimapWidth,Tt+=Ct.minimapWidth,Qt+=Ct.minimapWidth,Yt+=Ct.minimapWidth);const Et=Zt-Ct.minimapWidth,wt=Math.max(1,Math.floor((Et-Rt-2)/gt)),xt=cn?Vt:0;return Mt&&(Xt=Math.max(1,wt),_t==="bounded"&&(Xt=Math.min(Xt,xe))),{width:Pe,height:Xe,glyphMarginLeft:Lt,glyphMarginWidth:Nt,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:Tt,lineNumbersWidth:mt,decorationsLeft:Qt,decorationsWidth:Jt,contentLeft:Yt,contentWidth:Et,minimap:Ct,viewportColumn:wt,isWordWrapMinified:Wt,isViewportWrapping:Mt,wrappingColumn:Xt,verticalScrollbarWidth:Rt,horizontalScrollbarHeight:Ze,overviewRuler:{top:xt,width:Rt,height:Xe-2*xt,right:0}}}}e.EditorLayoutInfoComputer=x;class ne extends I{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(re){return c(re,"simple",["simple","advanced"])}compute(re,Ce,Pe){return Ce.get(2)===2?"advanced":Pe}}var be;(function(te){te.Off="off",te.OnCode="onCode",te.On="on"})(be||(e.ShowLightbulbIconMode=be={}));class ae extends I{constructor(){const re={enabled:be.On};super(65,"lightbulb",re,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[be.Off,be.OnCode,be.On],default:re.enabled,enumDescriptions:[b.localize(50,null),b.localize(51,null),b.localize(52,null)],description:b.localize(53,null)}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{enabled:c(re.enabled,this.defaultValue.enabled,[be.Off,be.OnCode,be.On])}}}class Ie extends I{constructor(){const re={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",re,{"editor.stickyScroll.enabled":{type:"boolean",default:re.enabled,description:b.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:re.maxLineCount,minimum:1,maximum:20,description:b.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:re.defaultModel,description:b.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:re.scrollWithEditor,description:b.localize(57,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:d(Ce.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:c(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:d(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ee extends I{constructor(){const re={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",re,{"editor.inlayHints.enabled":{type:"string",default:re.enabled,description:b.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(59,null),b.localize(60,null,O.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(61,null,O.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:re.fontSize,markdownDescription:b.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:re.fontFamily,markdownDescription:b.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:re.padding,description:b.localize(65,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:c(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:d(Ce.padding,this.defaultValue.padding)}}}class B extends I{constructor(){super(66,"lineDecorationsWidth",10)}validate(re){return typeof re=="string"&&/^\d+(\.\d+)?ch$/.test(re)?-parseFloat(re.substring(0,re.length-2)):i.clampedInt(re,this.defaultValue,0,1e3)}compute(re,Ce,Pe){return Pe<0?i.clampedInt(-Pe*re.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Pe}}class _ extends s{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,re=>s.clamp(re,0,150),{markdownDescription:b.localize(66,null)})}compute(re,Ce,Pe){return re.fontInfo.lineHeight}}class pe extends I{constructor(){const re={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",re,{"editor.minimap.enabled":{type:"boolean",default:re.enabled,description:b.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:re.autohide,description:b.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(69,null),b.localize(70,null),b.localize(71,null)],default:re.size,description:b.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:re.side,description:b.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:re.showSlider,description:b.localize(74,null)},"editor.minimap.scale":{type:"number",default:re.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:re.renderCharacters,description:b.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:re.maxColumn,description:b.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:re.showRegionSectionHeaders,description:b.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:re.showMarkSectionHeaders,description:b.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:re.sectionHeaderFontSize,description:b.localize(80,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:d(Ce.enabled,this.defaultValue.enabled),autohide:d(Ce.autohide,this.defaultValue.autohide),size:c(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:c(Ce.side,this.defaultValue.side,["right","left"]),showSlider:c(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Ce.scale,1,1,3),maxColumn:i.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:d(Ce.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:d(Ce.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:s.clamp(Ce.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function ue(te){return te==="ctrlCmd"?O.$j?"metaKey":"ctrlKey":"altKey"}class ce extends I{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(82,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{top:i.clampedInt(Ce.top,0,0,1e3),bottom:i.clampedInt(Ce.bottom,0,0,1e3)}}}class oe extends I{constructor(){const re={enabled:!0,cycle:!0};super(86,"parameterHints",re,{"editor.parameterHints.enabled":{type:"boolean",default:re.enabled,description:b.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:re.cycle,description:b.localize(84,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:d(Ce.enabled,this.defaultValue.enabled),cycle:d(Ce.cycle,this.defaultValue.cycle)}}}class le extends v{constructor(){super(143)}compute(re,Ce,Pe){return re.pixelRatio}}class K extends I{constructor(){const re={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(85,null),b.localize(86,null),b.localize(87,null)]}];super(89,"quickSuggestions",re,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:re.strings,description:b.localize(88,null)},comments:{anyOf:Ce,default:re.comments,description:b.localize(89,null)},other:{anyOf:Ce,default:re.other,description:b.localize(90,null)}},default:re,markdownDescription:b.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=re}validate(re){if(typeof re=="boolean"){const Pt=re?"on":"off";return{comments:Pt,strings:Pt,other:Pt}}if(!re||typeof re!="object")return this.defaultValue;const{other:Ce,comments:Pe,strings:Xe}=re,st=["on","inline","off"];let lt,gt,It;return typeof Ce=="boolean"?lt=Ce?"on":"off":lt=c(Ce,this.defaultValue.other,st),typeof Pe=="boolean"?gt=Pe?"on":"off":gt=c(Pe,this.defaultValue.comments,st),typeof Xe=="boolean"?It=Xe?"on":"off":It=c(Xe,this.defaultValue.strings,st),{other:lt,comments:gt,strings:It}}}var se;(function(te){te[te.Off=0]="Off",te[te.On=1]="On",te[te.Relative=2]="Relative",te[te.Interval=3]="Interval",te[te.Custom=4]="Custom"})(se||(e.RenderLineNumbersType=se={}));class $e extends I{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(92,null),b.localize(93,null),b.localize(94,null),b.localize(95,null)],default:"on",description:b.localize(96,null)})}validate(re){let Ce=this.defaultValue.renderType,Pe=this.defaultValue.renderFn;return typeof re<"u"&&(typeof re=="function"?(Ce=4,Pe=re):re==="interval"?Ce=3:re==="relative"?Ce=2:re==="on"?Ce=1:Ce=0),{renderType:Ce,renderFn:Pe}}}function ve(te){const re=te.get(98);return re==="editable"?te.get(91):re!=="on"}class Me extends I{constructor(){const re=[],Ce={type:"number",description:b.localize(97,null)};super(102,"rulers",re,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:b.localize(98,null),format:"color-hex"}}}]},default:re,description:b.localize(99,null)})}validate(re){if(Array.isArray(re)){const Ce=[];for(const Pe of re)if(typeof Pe=="number")Ce.push({column:i.clampedInt(Pe,0,0,1e4),color:null});else if(Pe&&typeof Pe=="object"){const Xe=Pe;Ce.push({column:i.clampedInt(Xe.column,0,0,1e4),color:Xe.color})}return Ce.sort((Pe,Xe)=>Pe.column-Xe.column),Ce}return this.defaultValue}}class ge extends I{constructor(){super(92,"readOnlyMessage",void 0)}validate(re){return!re||typeof re!="object"?this.defaultValue:re}}function Ae(te,re){if(typeof te!="string")return re;switch(te){case"hidden":return 2;case"visible":return 3;default:return 1}}class Re extends I{constructor(){const re={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",re,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(100,null),b.localize(101,null),b.localize(102,null)],default:"auto",description:b.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(104,null),b.localize(105,null),b.localize(106,null)],default:"auto",description:b.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:re.verticalScrollbarSize,description:b.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:re.horizontalScrollbarSize,description:b.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:re.scrollByPage,description:b.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:re.ignoreHorizontalScrollbarInContentHeight,description:b.localize(111,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re,Pe=i.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Xe=i.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ae(Ce.vertical,this.defaultValue.vertical),horizontal:Ae(Ce.horizontal,this.defaultValue.horizontal),useShadows:d(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Pe,horizontalSliderSize:i.clampedInt(Ce.horizontalSliderSize,Pe,0,1e3),verticalScrollbarSize:Xe,verticalSliderSize:i.clampedInt(Ce.verticalSliderSize,Xe,0,1e3),scrollByPage:d(Ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:d(Ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class je extends I{constructor(){const re={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",re,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.nonBasicASCII,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:re.invisibleCharacters,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:re.ambiguousCharacters,description:b.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.includeComments,description:b.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.includeStrings,description:b.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:re.allowedCharacters,description:b.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:re.allowedLocales,description:b.localize(118,null)}})}applyUpdate(re,Ce){let Pe=!1;Ce.allowedCharacters&&re&&(N.$7n(re.allowedCharacters,Ce.allowedCharacters)||(re={...re,allowedCharacters:Ce.allowedCharacters},Pe=!0)),Ce.allowedLocales&&re&&(N.$7n(re.allowedLocales,Ce.allowedLocales)||(re={...re,allowedLocales:Ce.allowedLocales},Pe=!0));const Xe=super.applyUpdate(re,Ce);return Pe?new p(Xe.newValue,!0):Xe}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{nonBasicASCII:de(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:de(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:de(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(re.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(re.allowedLocales,this.defaultValue.allowedLocales)}}c(re,Ce){if(typeof re!="object"||!re)return Ce;const Pe={};for(const[Xe,st]of Object.entries(re))st===!0&&(Pe[Xe]=!0);return Pe}}class V extends I{constructor(){const re={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",re,{"editor.inlineSuggest.enabled":{type:"boolean",default:re.enabled,description:b.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:re.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(120,null),b.localize(121,null),b.localize(122,null)],description:b.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:re.suppressSuggestions,description:b.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:re.fontFamily,description:b.localize(125,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:d(Ce.enabled,this.defaultValue.enabled),mode:c(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:c(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:d(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:d(Ce.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily)}}}class W extends I{constructor(){const re={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",re,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:re.enabled,description:b.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:re.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(127,null),b.localize(128,null),b.localize(129,null)],description:b.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:re.fontFamily,description:b.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:re.backgroundColoring,description:b.localize(132,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:d(Ce.enabled,this.defaultValue.enabled),showToolbar:c(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),keepOnBlur:d(Ce.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:d(Ce.backgroundColoring,this.defaultValue.backgroundColoring)}}}class J extends I{constructor(){const re={enabled:R.$4s.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$4s.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",re,{"editor.bracketPairColorization.enabled":{type:"boolean",default:re.enabled,markdownDescription:b.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:re.independentColorPoolPerBracketType,description:b.localize(134,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:d(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Z extends I{constructor(){const re={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",re,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(135,null),b.localize(136,null),b.localize(137,null)],default:re.bracketPairs,description:b.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(139,null),b.localize(140,null),b.localize(141,null)],default:re.bracketPairsHorizontal,description:b.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:re.highlightActiveBracketPair,description:b.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:re.indentation,description:b.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(145,null),b.localize(146,null),b.localize(147,null)],default:re.highlightActiveIndentation,description:b.localize(148,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{bracketPairs:de(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:de(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:de(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function de(te,re,Ce){const Pe=Ce.indexOf(te);return Pe===-1?re:Ce[Pe]}class we extends I{constructor(){const re={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",re,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(149,null),b.localize(150,null)],default:re.insertMode,description:b.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:re.filterGraceful,description:b.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:re.localityBonus,description:b.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:re.shareSuggestSelections,markdownDescription:b.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(155,null),b.localize(156,null),b.localize(157,null),b.localize(158,null)],default:re.selectionMode,markdownDescription:b.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:re.snippetsPreventQuickSuggestions,description:b.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:re.showIcons,description:b.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:re.showStatusBar,description:b.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:re.preview,description:b.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:re.showInlineDetails,description:b.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(196,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{insertMode:c(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:c(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:d(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:d(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:d(Ce.preview,this.defaultValue.preview),previewMode:c(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(Ce.showMethods,this.defaultValue.showMethods),showFunctions:d(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:d(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:d(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:d(Ce.showFields,this.defaultValue.showFields),showVariables:d(Ce.showVariables,this.defaultValue.showVariables),showClasses:d(Ce.showClasses,this.defaultValue.showClasses),showStructs:d(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:d(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:d(Ce.showModules,this.defaultValue.showModules),showProperties:d(Ce.showProperties,this.defaultValue.showProperties),showEvents:d(Ce.showEvents,this.defaultValue.showEvents),showOperators:d(Ce.showOperators,this.defaultValue.showOperators),showUnits:d(Ce.showUnits,this.defaultValue.showUnits),showValues:d(Ce.showValues,this.defaultValue.showValues),showConstants:d(Ce.showConstants,this.defaultValue.showConstants),showEnums:d(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:d(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(Ce.showKeywords,this.defaultValue.showKeywords),showWords:d(Ce.showWords,this.defaultValue.showWords),showColors:d(Ce.showColors,this.defaultValue.showColors),showFiles:d(Ce.showFiles,this.defaultValue.showFiles),showReferences:d(Ce.showReferences,this.defaultValue.showReferences),showFolders:d(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:d(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:d(Ce.showUsers,this.defaultValue.showUsers),showIssues:d(Ce.showIssues,this.defaultValue.showIssues)}}}class Fe extends I{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(198,null),default:!0,type:"boolean"}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(re.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:d(re.selectSubwords,this.defaultValue.selectSubwords)}}}class Ve extends I{constructor(){const re=[];super(130,"wordSegmenterLocales",re,{anyOf:[{description:b.localize(199,null),type:"string"},{description:b.localize(200,null),type:"array",items:{type:"string"}}]})}validate(re){if(typeof re=="string"&&(re=[re]),Array.isArray(re)){const Ce=[];for(const Pe of re)if(typeof Pe=="string")try{Intl.Segmenter.supportedLocalesOf(Pe).length>0&&Ce.push(Pe)}catch{}return Ce}return this.defaultValue}}var Ge;(function(te){te[te.None=0]="None",te[te.Same=1]="Same",te[te.Indent=2]="Indent",te[te.DeepIndent=3]="DeepIndent"})(Ge||(e.WrappingIndent=Ge={}));class tt extends I{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(201,null),b.localize(202,null),b.localize(203,null),b.localize(204,null)],description:b.localize(205,null),default:"same"}})}validate(re){switch(re){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(re,Ce,Pe){return Ce.get(2)===2?0:Pe}}class _e extends v{constructor(){super(146)}compute(re,Ce,Pe){const Xe=Ce.get(145);return{isDominatedByLongLines:re.isDominatedByLongLines,isWordWrapMinified:Xe.isWordWrapMinified,isViewportWrapping:Xe.isViewportWrapping,wrappingColumn:Xe.wrappingColumn}}}class nt extends I{constructor(){const re={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",re,{"editor.dropIntoEditor.enabled":{type:"boolean",default:re.enabled,markdownDescription:b.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(208,null),b.localize(209,null)],default:"afterDrop"}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:d(Ce.enabled,this.defaultValue.enabled),showDropSelector:c(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class rt extends I{constructor(){const re={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",re,{"editor.pasteAs.enabled":{type:"boolean",default:re.enabled,markdownDescription:b.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(212,null),b.localize(213,null)],default:"afterPaste"}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:d(Ce.enabled,this.defaultValue.enabled),showPasteSelector:c(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const it="Consolas, 'Courier New', monospace",ct="Menlo, Monaco, 'Courier New', monospace",Oe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:O.$j?ct:O.$k?Oe:it,fontWeight:"normal",fontSize:O.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ee(te){return e.editorOptionsRegistry[te.id]=te,te}var qe;(function(te){te[te.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",te[te.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",te[te.accessibilitySupport=2]="accessibilitySupport",te[te.accessibilityPageSize=3]="accessibilityPageSize",te[te.ariaLabel=4]="ariaLabel",te[te.ariaRequired=5]="ariaRequired",te[te.autoClosingBrackets=6]="autoClosingBrackets",te[te.autoClosingComments=7]="autoClosingComments",te[te.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",te[te.autoClosingDelete=9]="autoClosingDelete",te[te.autoClosingOvertype=10]="autoClosingOvertype",te[te.autoClosingQuotes=11]="autoClosingQuotes",te[te.autoIndent=12]="autoIndent",te[te.automaticLayout=13]="automaticLayout",te[te.autoSurround=14]="autoSurround",te[te.bracketPairColorization=15]="bracketPairColorization",te[te.guides=16]="guides",te[te.codeLens=17]="codeLens",te[te.codeLensFontFamily=18]="codeLensFontFamily",te[te.codeLensFontSize=19]="codeLensFontSize",te[te.colorDecorators=20]="colorDecorators",te[te.colorDecoratorsLimit=21]="colorDecoratorsLimit",te[te.columnSelection=22]="columnSelection",te[te.comments=23]="comments",te[te.contextmenu=24]="contextmenu",te[te.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",te[te.cursorBlinking=26]="cursorBlinking",te[te.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",te[te.cursorStyle=28]="cursorStyle",te[te.cursorSurroundingLines=29]="cursorSurroundingLines",te[te.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",te[te.cursorWidth=31]="cursorWidth",te[te.disableLayerHinting=32]="disableLayerHinting",te[te.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",te[te.domReadOnly=34]="domReadOnly",te[te.dragAndDrop=35]="dragAndDrop",te[te.dropIntoEditor=36]="dropIntoEditor",te[te.emptySelectionClipboard=37]="emptySelectionClipboard",te[te.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",te[te.extraEditorClassName=39]="extraEditorClassName",te[te.fastScrollSensitivity=40]="fastScrollSensitivity",te[te.find=41]="find",te[te.fixedOverflowWidgets=42]="fixedOverflowWidgets",te[te.folding=43]="folding",te[te.foldingStrategy=44]="foldingStrategy",te[te.foldingHighlight=45]="foldingHighlight",te[te.foldingImportsByDefault=46]="foldingImportsByDefault",te[te.foldingMaximumRegions=47]="foldingMaximumRegions",te[te.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",te[te.fontFamily=49]="fontFamily",te[te.fontInfo=50]="fontInfo",te[te.fontLigatures=51]="fontLigatures",te[te.fontSize=52]="fontSize",te[te.fontWeight=53]="fontWeight",te[te.fontVariations=54]="fontVariations",te[te.formatOnPaste=55]="formatOnPaste",te[te.formatOnType=56]="formatOnType",te[te.glyphMargin=57]="glyphMargin",te[te.gotoLocation=58]="gotoLocation",te[te.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",te[te.hover=60]="hover",te[te.inDiffEditor=61]="inDiffEditor",te[te.inlineSuggest=62]="inlineSuggest",te[te.inlineEdit=63]="inlineEdit",te[te.letterSpacing=64]="letterSpacing",te[te.lightbulb=65]="lightbulb",te[te.lineDecorationsWidth=66]="lineDecorationsWidth",te[te.lineHeight=67]="lineHeight",te[te.lineNumbers=68]="lineNumbers",te[te.lineNumbersMinChars=69]="lineNumbersMinChars",te[te.linkedEditing=70]="linkedEditing",te[te.links=71]="links",te[te.matchBrackets=72]="matchBrackets",te[te.minimap=73]="minimap",te[te.mouseStyle=74]="mouseStyle",te[te.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",te[te.mouseWheelZoom=76]="mouseWheelZoom",te[te.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",te[te.multiCursorModifier=78]="multiCursorModifier",te[te.multiCursorPaste=79]="multiCursorPaste",te[te.multiCursorLimit=80]="multiCursorLimit",te[te.occurrencesHighlight=81]="occurrencesHighlight",te[te.overviewRulerBorder=82]="overviewRulerBorder",te[te.overviewRulerLanes=83]="overviewRulerLanes",te[te.padding=84]="padding",te[te.pasteAs=85]="pasteAs",te[te.parameterHints=86]="parameterHints",te[te.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",te[te.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",te[te.quickSuggestions=89]="quickSuggestions",te[te.quickSuggestionsDelay=90]="quickSuggestionsDelay",te[te.readOnly=91]="readOnly",te[te.readOnlyMessage=92]="readOnlyMessage",te[te.renameOnType=93]="renameOnType",te[te.renderControlCharacters=94]="renderControlCharacters",te[te.renderFinalNewline=95]="renderFinalNewline",te[te.renderLineHighlight=96]="renderLineHighlight",te[te.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",te[te.renderValidationDecorations=98]="renderValidationDecorations",te[te.renderWhitespace=99]="renderWhitespace",te[te.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",te[te.roundedSelection=101]="roundedSelection",te[te.rulers=102]="rulers",te[te.scrollbar=103]="scrollbar",te[te.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",te[te.scrollBeyondLastLine=105]="scrollBeyondLastLine",te[te.scrollPredominantAxis=106]="scrollPredominantAxis",te[te.selectionClipboard=107]="selectionClipboard",te[te.selectionHighlight=108]="selectionHighlight",te[te.selectOnLineNumbers=109]="selectOnLineNumbers",te[te.showFoldingControls=110]="showFoldingControls",te[te.showUnused=111]="showUnused",te[te.snippetSuggestions=112]="snippetSuggestions",te[te.smartSelect=113]="smartSelect",te[te.smoothScrolling=114]="smoothScrolling",te[te.stickyScroll=115]="stickyScroll",te[te.stickyTabStops=116]="stickyTabStops",te[te.stopRenderingLineAfter=117]="stopRenderingLineAfter",te[te.suggest=118]="suggest",te[te.suggestFontSize=119]="suggestFontSize",te[te.suggestLineHeight=120]="suggestLineHeight",te[te.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",te[te.suggestSelection=122]="suggestSelection",te[te.tabCompletion=123]="tabCompletion",te[te.tabIndex=124]="tabIndex",te[te.unicodeHighlighting=125]="unicodeHighlighting",te[te.unusualLineTerminators=126]="unusualLineTerminators",te[te.useShadowDOM=127]="useShadowDOM",te[te.useTabStops=128]="useTabStops",te[te.wordBreak=129]="wordBreak",te[te.wordSegmenterLocales=130]="wordSegmenterLocales",te[te.wordSeparators=131]="wordSeparators",te[te.wordWrap=132]="wordWrap",te[te.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",te[te.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",te[te.wordWrapColumn=135]="wordWrapColumn",te[te.wordWrapOverride1=136]="wordWrapOverride1",te[te.wordWrapOverride2=137]="wordWrapOverride2",te[te.wrappingIndent=138]="wrappingIndent",te[te.wrappingStrategy=139]="wrappingStrategy",te[te.showDeprecated=140]="showDeprecated",te[te.inlayHints=141]="inlayHints",te[te.editorClassName=142]="editorClassName",te[te.pixelRatio=143]="pixelRatio",te[te.tabFocusMode=144]="tabFocusMode",te[te.layoutInfo=145]="layoutInfo",te[te.wrappingInfo=146]="wrappingInfo",te[te.defaultColorDecorators=147]="defaultColorDecorators",te[te.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",te[te.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(qe||(e.EditorOption=qe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ee(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(214,null)})),acceptSuggestionOnEnter:Ee(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(215,null),""],markdownDescription:b.localize(216,null)})),accessibilitySupport:Ee(new g),accessibilityPageSize:Ee(new i(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(217,null),tags:["accessibility"]})),ariaLabel:Ee(new t(4,"ariaLabel",b.localize(218,null))),ariaRequired:Ee(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ee(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Ee(new r(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(220,null),b.localize(221,null),""],description:b.localize(222,null)})),autoClosingComments:Ee(new r(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(223,null),b.localize(224,null),""],description:b.localize(225,null)})),autoClosingDelete:Ee(new r(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(226,null),""],description:b.localize(227,null)})),autoClosingOvertype:Ee(new r(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(228,null),""],description:b.localize(229,null)})),autoClosingQuotes:Ee(new r(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(230,null),b.localize(231,null),""],description:b.localize(232,null)})),autoIndent:Ee(new a(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],f,{enumDescriptions:[b.localize(233,null),b.localize(234,null),b.localize(235,null),b.localize(236,null),b.localize(237,null)],description:b.localize(238,null)})),automaticLayout:Ee(new o(13,"automaticLayout",!1)),autoSurround:Ee(new r(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(239,null),b.localize(240,null),b.localize(241,null),""],description:b.localize(242,null)})),bracketPairColorization:Ee(new J),bracketPairGuides:Ee(new Z),stickyTabStops:Ee(new o(116,"stickyTabStops",!1,{description:b.localize(243,null)})),codeLens:Ee(new o(17,"codeLens",!0,{description:b.localize(244,null)})),codeLensFontFamily:Ee(new t(18,"codeLensFontFamily","",{description:b.localize(245,null)})),codeLensFontSize:Ee(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(246,null)})),colorDecorators:Ee(new o(20,"colorDecorators",!0,{description:b.localize(247,null)})),colorDecoratorActivatedOn:Ee(new r(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(248,null),b.localize(249,null),b.localize(250,null)],description:b.localize(251,null)})),colorDecoratorsLimit:Ee(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(252,null)})),columnSelection:Ee(new o(22,"columnSelection",!1,{description:b.localize(253,null)})),comments:Ee(new w),contextmenu:Ee(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ee(new o(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(254,null)})),cursorBlinking:Ee(new a(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:b.localize(255,null)})),cursorSmoothCaretAnimation:Ee(new r(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(256,null),b.localize(257,null),b.localize(258,null)],description:b.localize(259,null)})),cursorStyle:Ee(new a(28,"cursorStyle",E.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:b.localize(260,null)})),cursorSurroundingLines:Ee(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(261,null)})),cursorSurroundingLinesStyle:Ee(new r(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(262,null),b.localize(263,null)],markdownDescription:b.localize(264,null)})),cursorWidth:Ee(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(265,null)})),disableLayerHinting:Ee(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ee(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ee(new o(34,"domReadOnly",!1)),dragAndDrop:Ee(new o(35,"dragAndDrop",!0,{description:b.localize(266,null)})),emptySelectionClipboard:Ee(new F),dropIntoEditor:Ee(new nt),stickyScroll:Ee(new Ie),experimentalWhitespaceRendering:Ee(new r(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(267,null),b.localize(268,null),b.localize(269,null)],description:b.localize(270,null)})),extraEditorClassName:Ee(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ee(new s(40,"fastScrollSensitivity",5,te=>te<=0?5:te,{markdownDescription:b.localize(271,null)})),find:Ee(new T),fixedOverflowWidgets:Ee(new o(42,"fixedOverflowWidgets",!1)),folding:Ee(new o(43,"folding",!0,{description:b.localize(272,null)})),foldingStrategy:Ee(new r(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(273,null),b.localize(274,null)],description:b.localize(275,null)})),foldingHighlight:Ee(new o(45,"foldingHighlight",!0,{description:b.localize(276,null)})),foldingImportsByDefault:Ee(new o(46,"foldingImportsByDefault",!1,{description:b.localize(277,null)})),foldingMaximumRegions:Ee(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(278,null)})),unfoldOnClickAfterEndOfLine:Ee(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(279,null)})),fontFamily:Ee(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(280,null)})),fontInfo:Ee(new j),fontLigatures2:Ee(new z),fontSize:Ee(new U),fontWeight:Ee(new X),fontVariations:Ee(new L),formatOnPaste:Ee(new o(55,"formatOnPaste",!1,{description:b.localize(281,null)})),formatOnType:Ee(new o(56,"formatOnType",!1,{description:b.localize(282,null)})),glyphMargin:Ee(new o(57,"glyphMargin",!0,{description:b.localize(283,null)})),gotoLocation:Ee(new ie),hideCursorInOverviewRuler:Ee(new o(59,"hideCursorInOverviewRuler",!1,{description:b.localize(284,null)})),hover:Ee(new q),inDiffEditor:Ee(new o(61,"inDiffEditor",!1)),letterSpacing:Ee(new s(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,te=>s.clamp(te,-5,20),{description:b.localize(285,null)})),lightbulb:Ee(new ae),lineDecorationsWidth:Ee(new B),lineHeight:Ee(new _),lineNumbers:Ee(new $e),lineNumbersMinChars:Ee(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ee(new o(70,"linkedEditing",!1,{description:b.localize(286,null)})),links:Ee(new o(71,"links",!0,{description:b.localize(287,null)})),matchBrackets:Ee(new r(72,"matchBrackets","always",["always","near","never"],{description:b.localize(288,null)})),minimap:Ee(new pe),mouseStyle:Ee(new r(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ee(new s(75,"mouseWheelScrollSensitivity",1,te=>te===0?1:te,{markdownDescription:b.localize(289,null)})),mouseWheelZoom:Ee(new o(76,"mouseWheelZoom",!1,{markdownDescription:O.$j?b.localize(290,null):b.localize(291,null)})),multiCursorMergeOverlapping:Ee(new o(77,"multiCursorMergeOverlapping",!0,{description:b.localize(292,null)})),multiCursorModifier:Ee(new a(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[b.localize(293,null),b.localize(294,null)],markdownDescription:b.localize(295,null)})),multiCursorPaste:Ee(new r(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(296,null),b.localize(297,null)],markdownDescription:b.localize(298,null)})),multiCursorLimit:Ee(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(299,null)})),occurrencesHighlight:Ee(new r(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(300,null),b.localize(301,null),b.localize(302,null)],markdownDescription:b.localize(303,null)})),overviewRulerBorder:Ee(new o(82,"overviewRulerBorder",!0,{description:b.localize(304,null)})),overviewRulerLanes:Ee(new i(83,"overviewRulerLanes",3,0,3)),padding:Ee(new ce),pasteAs:Ee(new rt),parameterHints:Ee(new oe),peekWidgetDefaultFocus:Ee(new r(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(305,null),b.localize(306,null)],description:b.localize(307,null)})),definitionLinkOpensInPeek:Ee(new o(88,"definitionLinkOpensInPeek",!1,{description:b.localize(308,null)})),quickSuggestions:Ee(new K),quickSuggestionsDelay:Ee(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(309,null)})),readOnly:Ee(new o(91,"readOnly",!1)),readOnlyMessage:Ee(new ge),renameOnType:Ee(new o(93,"renameOnType",!1,{description:b.localize(310,null),markdownDeprecationMessage:b.localize(311,null)})),renderControlCharacters:Ee(new o(94,"renderControlCharacters",!0,{description:b.localize(312,null),restricted:!0})),renderFinalNewline:Ee(new r(95,"renderFinalNewline",O.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(313,null)})),renderLineHighlight:Ee(new r(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(314,null)],description:b.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Ee(new o(97,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(316,null)})),renderValidationDecorations:Ee(new r(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ee(new r(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(317,null),b.localize(318,null),b.localize(319,null),""],description:b.localize(320,null)})),revealHorizontalRightPadding:Ee(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ee(new o(101,"roundedSelection",!0,{description:b.localize(321,null)})),rulers:Ee(new Me),scrollbar:Ee(new Re),scrollBeyondLastColumn:Ee(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(322,null)})),scrollBeyondLastLine:Ee(new o(105,"scrollBeyondLastLine",!0,{description:b.localize(323,null)})),scrollPredominantAxis:Ee(new o(106,"scrollPredominantAxis",!0,{description:b.localize(324,null)})),selectionClipboard:Ee(new o(107,"selectionClipboard",!0,{description:b.localize(325,null),included:O.$k})),selectionHighlight:Ee(new o(108,"selectionHighlight",!0,{description:b.localize(326,null)})),selectOnLineNumbers:Ee(new o(109,"selectOnLineNumbers",!0)),showFoldingControls:Ee(new r(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(327,null),b.localize(328,null),b.localize(329,null)],description:b.localize(330,null)})),showUnused:Ee(new o(111,"showUnused",!0,{description:b.localize(331,null)})),showDeprecated:Ee(new o(140,"showDeprecated",!0,{description:b.localize(332,null)})),inlayHints:Ee(new ee),snippetSuggestions:Ee(new r(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(333,null),b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),smartSelect:Ee(new Fe),smoothScrolling:Ee(new o(114,"smoothScrolling",!1,{description:b.localize(338,null)})),stopRenderingLineAfter:Ee(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ee(new we),inlineSuggest:Ee(new V),inlineEdit:Ee(new W),inlineCompletionsAccessibilityVerbose:Ee(new o(149,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(339,null)})),suggestFontSize:Ee(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ee(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ee(new o(121,"suggestOnTriggerCharacters",!0,{description:b.localize(342,null)})),suggestSelection:Ee(new r(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null),b.localize(345,null)],description:b.localize(346,null)})),tabCompletion:Ee(new r(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(347,null),b.localize(348,null),b.localize(349,null)],description:b.localize(350,null)})),tabIndex:Ee(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ee(new je),unusualLineTerminators:Ee(new r(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(351,null),b.localize(352,null),b.localize(353,null)],description:b.localize(354,null)})),useShadowDOM:Ee(new o(127,"useShadowDOM",!0)),useTabStops:Ee(new o(128,"useTabStops",!0,{description:b.localize(355,null)})),wordBreak:Ee(new r(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(356,null),b.localize(357,null)],description:b.localize(358,null)})),wordSegmenterLocales:Ee(new Ve),wordSeparators:Ee(new t(131,"wordSeparators",M.$5s,{description:b.localize(359,null)})),wordWrap:Ee(new r(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(360,null),b.localize(361,null),b.localize(362,null),b.localize(363,null)],description:b.localize(364,null)})),wordWrapBreakAfterCharacters:Ee(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ee(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ee(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(365,null)})),wordWrapOverride1:Ee(new r(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ee(new r(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ee(new P),defaultColorDecorators:Ee(new o(147,"defaultColorDecorators",!1,{markdownDescription:b.localize(366,null)})),pixelRatio:Ee(new le),tabFocusMode:Ee(new o(144,"tabFocusMode",!1,{markdownDescription:b.localize(367,null)})),layoutInfo:Ee(new x),wrappingInfo:Ee(new _e),wrappingIndent:Ee(new tt),wrappingStrategy:Ee(new ne)}}),define(Se[207],De([9,10]),function(he,e){return he.create("vs/editor/common/languages",e)}),define(Se[84],De([1,0,79,2,180,29,190,207]),function(he,e,h,N,O,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$fu=e.$eu=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$du=e.$cu=e.SymbolKinds=e.SymbolTag=e.$au=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$$t=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$0t=e.$9t=e.$8t=void 0,e.$_t=r,e.$bu=f;class ${constructor(G,x,ne){this.offset=G,this.type=x,this.language=ne,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$8t=$;class k{constructor(G,x){this.tokens=G,this.endState=x,this._tokenizationResultBrand=void 0}}e.$9t=k;class A{constructor(G,x){this.tokens=G,this.endState=x,this._encodedTokenizationResultBrand=void 0}}e.$0t=A;var I;(function(q){q[q.Increase=0]="Increase",q[q.Decrease=1]="Decrease"})(I||(e.HoverVerbosityAction=I={}));var p;(function(q){q[q.Method=0]="Method",q[q.Function=1]="Function",q[q.Constructor=2]="Constructor",q[q.Field=3]="Field",q[q.Variable=4]="Variable",q[q.Class=5]="Class",q[q.Struct=6]="Struct",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Event=10]="Event",q[q.Operator=11]="Operator",q[q.Unit=12]="Unit",q[q.Value=13]="Value",q[q.Constant=14]="Constant",q[q.Enum=15]="Enum",q[q.EnumMember=16]="EnumMember",q[q.Keyword=17]="Keyword",q[q.Text=18]="Text",q[q.Color=19]="Color",q[q.File=20]="File",q[q.Reference=21]="Reference",q[q.Customcolor=22]="Customcolor",q[q.Folder=23]="Folder",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue",q[q.Snippet=27]="Snippet"})(p||(e.CompletionItemKind=p={}));var y;(function(q){const G=new Map;G.set(0,h.$Vj.symbolMethod),G.set(1,h.$Vj.symbolFunction),G.set(2,h.$Vj.symbolConstructor),G.set(3,h.$Vj.symbolField),G.set(4,h.$Vj.symbolVariable),G.set(5,h.$Vj.symbolClass),G.set(6,h.$Vj.symbolStruct),G.set(7,h.$Vj.symbolInterface),G.set(8,h.$Vj.symbolModule),G.set(9,h.$Vj.symbolProperty),G.set(10,h.$Vj.symbolEvent),G.set(11,h.$Vj.symbolOperator),G.set(12,h.$Vj.symbolUnit),G.set(13,h.$Vj.symbolValue),G.set(15,h.$Vj.symbolEnum),G.set(14,h.$Vj.symbolConstant),G.set(15,h.$Vj.symbolEnum),G.set(16,h.$Vj.symbolEnumMember),G.set(17,h.$Vj.symbolKeyword),G.set(27,h.$Vj.symbolSnippet),G.set(18,h.$Vj.symbolText),G.set(19,h.$Vj.symbolColor),G.set(20,h.$Vj.symbolFile),G.set(21,h.$Vj.symbolReference),G.set(22,h.$Vj.symbolCustomColor),G.set(23,h.$Vj.symbolFolder),G.set(24,h.$Vj.symbolTypeParameter),G.set(25,h.$Vj.account),G.set(26,h.$Vj.issues);function x(ae){let Ie=G.get(ae);return Ie||(console.info("No codicon found for CompletionItemKind "+ae),Ie=h.$Vj.symbolProperty),Ie}q.toIcon=x;const ne=new Map;ne.set("method",0),ne.set("function",1),ne.set("constructor",2),ne.set("field",3),ne.set("variable",4),ne.set("class",5),ne.set("struct",6),ne.set("interface",7),ne.set("module",8),ne.set("property",9),ne.set("event",10),ne.set("operator",11),ne.set("unit",12),ne.set("value",13),ne.set("constant",14),ne.set("enum",15),ne.set("enum-member",16),ne.set("enumMember",16),ne.set("keyword",17),ne.set("snippet",27),ne.set("text",18),ne.set("color",19),ne.set("file",20),ne.set("reference",21),ne.set("customcolor",22),ne.set("folder",23),ne.set("type-parameter",24),ne.set("typeParameter",24),ne.set("account",25),ne.set("issue",26);function be(ae,Ie){let ee=ne.get(ae);return typeof ee>"u"&&!Ie&&(ee=9),ee}q.fromString=be})(y||(e.CompletionItemKinds=y={}));var v;(function(q){q[q.Deprecated=1]="Deprecated"})(v||(e.CompletionItemTag=v={}));var l;(function(q){q[q.None=0]="None",q[q.KeepWhitespace=1]="KeepWhitespace",q[q.InsertAsSnippet=4]="InsertAsSnippet"})(l||(e.CompletionItemInsertTextRule=l={}));var d;(function(q){q[q.Word=0]="Word",q[q.Line=1]="Line",q[q.Suggest=2]="Suggest"})(d||(e.PartialAcceptTriggerKind=d={}));var o;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(o||(e.CompletionTriggerKind=o={}));var n;(function(q){q[q.Automatic=0]="Automatic",q[q.Explicit=1]="Explicit"})(n||(e.InlineCompletionTriggerKind=n={}));class i{constructor(G,x,ne,be){this.range=G,this.text=x,this.completionKind=ne,this.isSnippetText=be}equals(G){return R.$ut.lift(this.range).equalsRange(G.range)&&this.text===G.text&&this.completionKind===G.completionKind&&this.isSnippetText===G.isSnippetText}}e.$$t=i;var u;(function(q){q[q.Invoke=1]="Invoke",q[q.Auto=2]="Auto"})(u||(e.CodeActionTriggerType=u={}));var s;(function(q){q[q.Automatic=0]="Automatic",q[q.PasteAs=1]="PasteAs"})(s||(e.DocumentPasteTriggerKind=s={}));var t;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(t||(e.SignatureHelpTriggerKind=t={}));var c;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(c||(e.DocumentHighlightKind=c={}));function r(q){return q&&N.URI.isUri(q.uri)&&R.$ut.isIRange(q.range)&&(R.$ut.isIRange(q.originSelectionRange)||R.$ut.isIRange(q.targetSelectionRange))}var a;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(a||(e.SymbolKind=a={})),e.$au={17:(0,b.localize)(0,null),16:(0,b.localize)(1,null),4:(0,b.localize)(2,null),13:(0,b.localize)(3,null),8:(0,b.localize)(4,null),9:(0,b.localize)(5,null),21:(0,b.localize)(6,null),23:(0,b.localize)(7,null),7:(0,b.localize)(8,null),0:(0,b.localize)(9,null),11:(0,b.localize)(10,null),10:(0,b.localize)(11,null),19:(0,b.localize)(12,null),5:(0,b.localize)(13,null),1:(0,b.localize)(14,null),2:(0,b.localize)(15,null),20:(0,b.localize)(16,null),15:(0,b.localize)(17,null),18:(0,b.localize)(18,null),24:(0,b.localize)(19,null),3:(0,b.localize)(20,null),6:(0,b.localize)(21,null),14:(0,b.localize)(22,null),22:(0,b.localize)(23,null),25:(0,b.localize)(24,null),12:(0,b.localize)(25,null)};function f(q,G){return(0,b.localize)(26,null,q,e.$au[G])}var g;(function(q){q[q.Deprecated=1]="Deprecated"})(g||(e.SymbolTag=g={}));var w;(function(q){const G=new Map;G.set(0,h.$Vj.symbolFile),G.set(1,h.$Vj.symbolModule),G.set(2,h.$Vj.symbolNamespace),G.set(3,h.$Vj.symbolPackage),G.set(4,h.$Vj.symbolClass),G.set(5,h.$Vj.symbolMethod),G.set(6,h.$Vj.symbolProperty),G.set(7,h.$Vj.symbolField),G.set(8,h.$Vj.symbolConstructor),G.set(9,h.$Vj.symbolEnum),G.set(10,h.$Vj.symbolInterface),G.set(11,h.$Vj.symbolFunction),G.set(12,h.$Vj.symbolVariable),G.set(13,h.$Vj.symbolConstant),G.set(14,h.$Vj.symbolString),G.set(15,h.$Vj.symbolNumber),G.set(16,h.$Vj.symbolBoolean),G.set(17,h.$Vj.symbolArray),G.set(18,h.$Vj.symbolObject),G.set(19,h.$Vj.symbolKey),G.set(20,h.$Vj.symbolNull),G.set(21,h.$Vj.symbolEnumMember),G.set(22,h.$Vj.symbolStruct),G.set(23,h.$Vj.symbolEvent),G.set(24,h.$Vj.symbolOperator),G.set(25,h.$Vj.symbolTypeParameter);function x(ne){let be=G.get(ne);return be||(console.info("No codicon found for SymbolKind "+ne),be=h.$Vj.symbolProperty),be}q.toIcon=x})(w||(e.SymbolKinds=w={}));class S{static asEditOperation(G){return O.$vt.replace(R.$ut.lift(G.range),G.text)}}e.$cu=S;class m{static{this.Comment=new m("comment")}static{this.Imports=new m("imports")}static{this.Region=new m("region")}static fromValue(G){switch(G){case"comment":return m.Comment;case"imports":return m.Imports;case"region":return m.Region}return new m(G)}constructor(G){this.value=G}}e.$du=m;var E;(function(q){q[q.AIGenerated=1]="AIGenerated"})(E||(e.NewSymbolNameTag=E={}));var D;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(D||(e.NewSymbolNameTriggerKind=D={}));var C;(function(q){function G(x){return!x||typeof x!="object"?!1:typeof x.id=="string"&&typeof x.title=="string"}q.is=G})(C||(e.Command=C={}));var P;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(P||(e.CommentThreadCollapsibleState=P={}));var F;(function(q){q[q.Unresolved=0]="Unresolved",q[q.Resolved=1]="Resolved"})(F||(e.CommentThreadState=F={}));var T;(function(q){q[q.Current=0]="Current",q[q.Outdated=1]="Outdated"})(T||(e.CommentThreadApplicability=T={}));var z;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(z||(e.CommentMode=z={}));var L;(function(q){q[q.Published=0]="Published",q[q.Draft=1]="Draft"})(L||(e.CommentState=L={}));var j;(function(q){q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(j||(e.InlayHintKind=j={}));class U{constructor(G){this.b=G,this.a=null}dispose(){this.a&&this.a.then(G=>{G&&G.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$eu=U,e.$fu=new M.$Zt;var X;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(X||(e.ExternalUriOpenerPriority=X={}));var ie;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(ie||(e.InlineEditTriggerKind=ie={}))}),define(Se[208],De([9,10]),function(he,e){return he.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[209],De([9,10]),function(he,e){return he.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[210],De([9,10]),function(he,e){return he.create("vs/platform/contextkey/common/scanner",e)}),define(Se[211],De([9,10]),function(he,e){return he.create("vs/platform/dialogs/common/dialogs",e)}),define(Se[212],De([9,10]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[213],De([9,10]),function(he,e){return he.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[214],De([9,10]),function(he,e){return he.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[215],De([9,10]),function(he,e){return he.create("vs/platform/files/common/files",e)}),define(Se[216],De([9,10]),function(he,e){return he.create("vs/platform/files/common/io",e)}),define(Se[217],De([9,10]),function(he,e){return he.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Se[218],De([9,10]),function(he,e){return he.create("vs/platform/log/common/log",e)}),define(Se[219],De([9,10]),function(he,e){return he.create("vs/platform/markers/common/markers",e)}),define(Se[220],De([9,10]),function(he,e){return he.create("vs/platform/request/common/request",e)}),define(Se[221],De([9,10]),function(he,e){return he.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[222],De([9,10]),function(he,e){return he.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[223],De([9,10]),function(he,e){return he.create("vs/platform/workspace/common/workspace",e)}),define(Se[224],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[225],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[226],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[227],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Se[228],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[229],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[230],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[231],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[232],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[233],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[234],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[235],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[236],De([9,10]),function(he,e){return he.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[237],De([9,10]),function(he,e){return he.create("vs/workbench/common/configuration",e)}),define(Se[238],De([9,10]),function(he,e){return he.create("vs/workbench/common/editor",e)}),define(Se[239],De([9,10]),function(he,e){return he.create("vs/workbench/common/views",e)}),define(Se[240],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Se[241],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[242],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[243],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[244],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[245],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[246],De([9,10]),function(he,e){return he.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[247],De([9,10]),function(he,e){return he.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Se[248],De([9,10]),function(he,e){return he.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[249],De([9,10]),function(he,e){return he.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Se[250],De([9,10]),function(he,e){return he.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[251],De([1,0,13,210]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.TokenType=void 0;var O;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(O||(e.TokenType=O={}));function R(...k){switch(k.length){case 1:return(0,N.localize)(0,null,k[0]);case 2:return(0,N.localize)(1,null,k[0],k[1]);case 3:return(0,N.localize)(2,null,k[0],k[1],k[2]);default:return}}const M=(0,N.localize)(3,null),b=(0,N.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,h.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const I=this.d,p=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:p};this.g.push({offset:I,lexeme:p,additionalInfo:A}),this.f.push(y)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const I=this.c.substring(this.d,this.e),p=$.b.get(I);p?this.k(p):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,I=!1,p=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(b);return}const v=this.c.charCodeAt(A);if(I)I=!1;else if(v===47&&!p){A++;break}else v===91?p=!0:v===92?I=!0:v===93&&(p=!1);A++}for(;A<this.c.length&&$.a.has(this.c.charCodeAt(A));)A++;this.e=A;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$rj=$}),define(Se[252],De([1,0,23,41,213,400]),function(he,e,h,N,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=$,e.$Hp=k,e.$Ip=A,e.$Jp=I,e.$Kp=p,e.$Lp=y,e.$Mp=v;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function $(o){return o=o.trim(),o==="*"||M.test(o)}function k(o){if(!$(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=o.match(M);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function A(o){if(!o)return null;const n=o.majorBase,i=o.majorMustEqual,u=o.minorBase;let s=o.minorMustEqual;const t=o.patchBase;let c=o.patchMustEqual;o.hasCaret&&(n===0||(s=!1),c=!1);let r=0;if(o.preRelease){const a=b.exec(o.preRelease);if(a){const[,f,g,w]=a;r=Date.UTC(Number(f),Number(g)-1,Number(w))}}return{majorBase:n,majorMustEqual:i,minorBase:u,minorMustEqual:s,patchBase:t,patchMustEqual:c,isMinimum:o.hasGreaterEquals,notBefore:r}}function I(o,n,i){let u;typeof o=="string"?u=A(k(o)):u=o;let s;n instanceof Date?s=n.getTime():typeof n=="string"&&(s=new Date(n).getTime());let t;if(typeof i=="string"?t=A(k(i)):t=i,!u||!t)return!1;const c=u.majorBase,r=u.minorBase,a=u.patchBase;let f=t.majorBase,g=t.minorBase,w=t.patchBase;const S=t.notBefore;let m=t.majorMustEqual,E=t.minorMustEqual,D=t.patchMustEqual;return t.isMinimum?c>f?!0:c<f?!1:r>g?!0:r<g||s&&s<S?!1:a>=w:(c===1&&f===0&&(!m||!E||!D)&&(f=1,g=0,w=0,m=!0,E=!1,D=!1),c<f?!1:c>f?!m:r<g?!1:r>g?!E:a<w?!1:a>w?!D:!(s&&s<S))}function p(o,n,i,u,s){const t=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return t.push([N.default.Error,O.localize(0,null)]),t;if(typeof u.name!="string")return t.push([N.default.Error,O.localize(1,null,"name")]),t;if(typeof u.version!="string")return t.push([N.default.Error,O.localize(2,null,"version")]),t;if(!u.engines)return t.push([N.default.Error,O.localize(3,null,"engines")]),t;if(typeof u.engines.vscode!="string")return t.push([N.default.Error,O.localize(4,null,"engines.vscode")]),t;if(typeof u.extensionDependencies<"u"&&!d(u.extensionDependencies))return t.push([N.default.Error,O.localize(5,null,"extensionDependencies")]),t;if(typeof u.activationEvents<"u"){if(!d(u.activationEvents))return t.push([N.default.Error,O.localize(6,null,"activationEvents")]),t;if(typeof u.main>"u"&&typeof u.browser>"u")return t.push([N.default.Error,O.localize(7,null,"activationEvents","main","browser")]),t}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&t.push([N.default.Warning,O.localize(8,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return t.push([N.default.Error,O.localize(9,null,"main")]),t;{const a=(0,h.$0g)(i,u.main);(0,h.$4g)(a,i)||t.push([N.default.Warning,O.localize(10,null,a.path,i.path)])}}if(typeof u.browser<"u"){if(typeof u.browser!="string")return t.push([N.default.Error,O.localize(11,null,"browser")]),t;{const a=(0,h.$0g)(i,u.browser);(0,h.$4g)(a,i)||t.push([N.default.Warning,O.localize(12,null,a.path,i.path)])}}if(!R.valid(u.version))return t.push([N.default.Error,O.localize(13,null)]),t;const c=[];if(!y(o,n,u,s,c))for(const a of c)t.push([N.default.Error,a]);return t}function y(o,n,i,u,s){return u||typeof i.main>"u"&&typeof i.browser>"u"?!0:l(o,n,i.engines.vscode,s)}function v(o,n,i){return o==="*"||l(n,i,o)}function l(o,n,i,u=[]){const s=A(k(i));if(!s)return u.push(O.localize(14,null,i)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return u.push(O.localize(15,null,i)),!1}else if(!s.majorMustEqual)return u.push(O.localize(16,null,i)),!1;return I(o,n,s)?!0:(u.push(O.localize(17,null,o,i)),!1)}function d(o){if(!Array.isArray(o))return!1;for(let n=0,i=o.length;n<i;n++)if(typeof o[n]!="string")return!1;return!0}}),define(Se[106],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=void 0;class h{constructor(O,R=[],M=!1){this.ctor=O,this.staticArguments=R,this.supportsDelayedInstantiation=M}}e.$ti=h}),define(Se[85],De([1,0,106]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$xs=R,e.$ys=M;const N=[];var O;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(O||(e.InstantiationType=O={}));function R(b,$,k){$ instanceof h.$ti||($=new h.$ti($,[],!!k)),N.push([b,$])}function M(){return N}}),define(Se[253],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=void 0;class h{constructor(R,M){this.key=R,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$ar=h;class N{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const M of this.a.values())M.outgoing.size===0&&R.push(M);return R}insertEdge(R,M){const b=this.lookupOrInsertNode(R),$=this.lookupOrInsertNode(M);b.outgoing.set($.key,$),$.incoming.set(b.key,b)}removeNode(R){const M=this.b(R);this.a.delete(M);for(const b of this.a.values())b.outgoing.delete(M),b.incoming.delete(M)}lookupOrInsertNode(R){const M=this.b(R);let b=this.a.get(M);return b||(b=new h(M,R),this.a.set(M,b)),b}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[M,b]of this.a)R.push(`${M}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,M]of this.a){const b=new Set([R]),$=this.c(M,b);if($)return $}}c(R,M){for(const[b,$]of R.outgoing){if(M.has(b))return[...M,b].join(" -> ");M.add(b);const k=this.c($,M);if(k)return k;M.delete(b)}}}e.$br=N}),define(Se[5],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e._util=void 0,e.$wi=O,e.$xi=R;var h;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function b($){return $[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=b})(h||(e._util=h={})),e.$vi=O("instantiationService");function N(M,b,$){b[h.DI_TARGET]===b?b[h.DI_DEPENDENCIES].push({id:M,index:$}):(b[h.DI_DEPENDENCIES]=[{id:M,index:$}],b[h.DI_TARGET]=b)}function O(M){if(h.serviceIds.has(M))return h.serviceIds.get(M);const b=function($,k,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(b,$,A)};return b.toString=()=>M,h.serviceIds.set(M,b),b}function R(M){return M}}),define(Se[55],De([1,0,18,2,5]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$3i=void 0,e.$4i=R,e.$5i=M,e.$6i=$,e.$7i=k,e.$8i=A,e.$9i=I,e.$0i=p,e.$$i=v,e.$_i=l,e.$aj=d,e.$3i=(0,O.$wi)("configurationService");function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof N.URI)}function M(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof N.URI)}var b;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function $(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function k(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}function A(o,n){const i=Object.create(null);for(const u in o)I(i,u,o[u],n);return i}function I(o,n,i,u){const s=n.split("."),t=s.pop();let c=o;for(let r=0;r<s.length;r++){const a=s[r];let f=c[a];switch(typeof f){case"undefined":f=c[a]=Object.create(null);break;case"object":if(f===null){u(`Ignoring ${n} as ${s.slice(0,r+1).join(".")} is null`);return}break;default:u(`Ignoring ${n} as ${s.slice(0,r+1).join(".")} is ${JSON.stringify(f)}`);return}c=f}if(typeof c=="object"&&c!==null)try{c[t]=i}catch{u(`Ignoring ${n} as ${s.join(".")} is ${JSON.stringify(c)}`)}else u(`Ignoring ${n} as ${s.join(".")} is ${JSON.stringify(c)}`)}function p(o,n){const i=n.split(".");y(o,i)}function y(o,n){const i=n.shift();if(n.length===0){delete o[i];return}if(Object.keys(o).indexOf(i)!==-1){const u=o[i];typeof u=="object"&&!Array.isArray(u)&&(y(u,n),Object.keys(u).length===0&&delete o[i])}}function v(o,n,i){function u(c,r){let a=c;for(const f of r){if(typeof a!="object"||a===null)return;a=a[f]}return a}const s=n.split("."),t=u(o,s);return typeof t>"u"?i:t}function l(o,n,i){Object.keys(n).forEach(u=>{u!=="__proto__"&&(u in o?h.$$f(o[u])&&h.$$f(n[u])?l(o[u],n[u],i):i&&(o[u]=n[u]):o[u]=n[u])})}function d(o){return o.replace(/[\[\]]/g,"")}}),define(Se[38],De([1,0,12,14,251,5,209,13]),function(he,e,h,N,O,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$uj=e.$tj=e.ContextKeyExprType=void 0,e.$sj=k,e.$vj=c,e.$wj=r,e.$Pj=be;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",h.$j),$.set("isLinux",h.$k),$.set("isWindows",h.$i),$.set("isWeb",h.$o),$.set("isMacNative",h.$j&&!h.$o),$.set("isEdge",h.$H),$.set("isFirefox",h.$F),$.set("isChrome",h.$E),$.set("isSafari",h.$G);function k(ee,B){if($.get(ee)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(ee,B)}const A=Object.prototype.hasOwnProperty;var I;(function(ee){ee[ee.False=0]="False",ee[ee.True=1]="True",ee[ee.Defined=2]="Defined",ee[ee.Not=3]="Not",ee[ee.Equals=4]="Equals",ee[ee.NotEquals=5]="NotEquals",ee[ee.And=6]="And",ee[ee.Regex=7]="Regex",ee[ee.NotRegex=8]="NotRegex",ee[ee.Or=9]="Or",ee[ee.In=10]="In",ee[ee.NotIn=11]="NotIn",ee[ee.Greater=12]="Greater",ee[ee.GreaterEquals=13]="GreaterEquals",ee[ee.Smaller=14]="Smaller",ee[ee.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const p={regexParsingWithErrorRecovery:!0},y=(0,M.localize)(0,null),v=(0,M.localize)(1,null),l=(0,M.localize)(2,null),d=(0,M.localize)(3,null),o=(0,M.localize)(4,null),n=(0,M.localize)(5,null),i=(0,M.localize)(6,null),u=(0,M.localize)(7,null);class s{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=p){this.k=B,this.d=new O.$rj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const _=this.l();if(!this.E()){const pe=this.D(),ue=pe.type===17?n:void 0;throw this.h.push({message:o,offset:pe.offset,lexeme:O.$rj.getLexeme(pe),additionalInfo:ue}),s.c}return _}catch(_){if(_!==s.c)throw _;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const _=this.o();B.push(_)}return B.length===1?B[0]:t.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const _=this.s();B.push(_)}return B.length===1?B[0]:t.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),f.INSTANCE;case 12:return this.z(),g.INSTANCE;case 0:{this.z();const _=this.l();return this.A(1,d),_?.negate()}case 17:return this.z(),C.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const _=this.l();return this.A(1,d),_}case 17:{const _=B.lexeme;if(this.z(),this.y(9)){const ue=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ue.type!==10)throw this.B("REGEX",ue);const ce=ue.lexeme,oe=ce.lastIndexOf("/"),le=oe===ce.length-1?void 0:this.w(ce.substring(oe+1));let K;try{K=new RegExp(ce.substring(1,oe),le)}catch{throw this.B("REGEX",ue)}return j.create(_,K)}switch(ue.type){case 10:case 19:{const ce=[ue.lexeme];this.z();let oe=this.D(),le=0;for(let Me=0;Me<ue.lexeme.length;Me++)ue.lexeme.charCodeAt(Me)===40?le++:ue.lexeme.charCodeAt(Me)===41&&le--;for(;!this.E()&&oe.type!==15&&oe.type!==16;){switch(oe.type){case 0:le++;break;case 1:le--;break;case 10:case 18:for(let Me=0;Me<oe.lexeme.length;Me++)oe.lexeme.charCodeAt(Me)===40?le++:ue.lexeme.charCodeAt(Me)===41&&le--}if(le<0)break;ce.push(O.$rj.getLexeme(oe)),this.z(),oe=this.D()}const K=ce.join(""),se=K.lastIndexOf("/"),$e=se===K.length-1?void 0:this.w(K.substring(se+1));let ve;try{ve=new RegExp(K.substring(1,se),$e)}catch{throw this.B("REGEX",ue)}return t.regex(_,ve)}case 18:{const ce=ue.lexeme;this.z();let oe=null;if(!(0,N.$7e)(ce)){const le=ce.indexOf("/"),K=ce.lastIndexOf("/");if(le!==K&&le>=0){const se=ce.slice(le+1,K),$e=ce[K+1]==="i"?"i":"";try{oe=new RegExp(se,$e)}catch{throw this.B("REGEX",ue)}}}if(oe===null)throw this.B("REGEX",ue);return j.create(_,oe)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,l);const ue=this.u();return t.notIn(_,ue)}switch(this.D().type){case 3:{this.z();const ue=this.u();if(this.x().type===18)return t.equals(_,ue);switch(ue){case"true":return t.has(_);case"false":return t.not(_);default:return t.equals(_,ue)}}case 4:{this.z();const ue=this.u();if(this.x().type===18)return t.notEquals(_,ue);switch(ue){case"true":return t.not(_);case"false":return t.has(_);default:return t.notEquals(_,ue)}}case 5:return this.z(),z.create(_,this.u());case 6:return this.z(),L.create(_,this.u());case 7:return this.z(),F.create(_,this.u());case 8:return this.z(),T.create(_,this.u());case 13:return this.z(),t.in(_,this.u());default:return t.has(_)}}case 20:throw this.h.push({message:i,offset:B.offset,lexeme:"",additionalInfo:u}),s.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,_){if(this.C(B))return this.z();throw this.B(_,this.D())}B(B,_,pe){const ue=(0,M.localize)(8,null,B,O.$rj.getLexeme(_)),ce=_.offset,oe=O.$rj.getLexeme(_);return this.h.push({message:ue,offset:ce,lexeme:oe,additionalInfo:pe}),s.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$tj=s;class t{static false(){return f.INSTANCE}static true(){return g.INSTANCE}static has(B){return w.create(B)}static equals(B,_){return S.create(B,_)}static notEquals(B,_){return D.create(B,_)}static regex(B,_){return j.create(B,_)}static in(B,_){return m.create(B,_)}static notIn(B,_){return E.create(B,_)}static not(B){return C.create(B)}static and(...B){return ie.create(B,null,!0)}static or(...B){return q.create(B,null,!0)}static greater(B,_){return F.create(B,_)}static greaterEquals(B,_){return T.create(B,_)}static smaller(B,_){return z.create(B,_)}static smallerEquals(B,_){return L.create(B,_)}static{this.c=new s({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$uj=t;function c(ee){const B=new s({regexParsingWithErrorRecovery:!1});return ee.map(_=>(B.parse(_),B.lexingErrors.length>0?B.lexingErrors.map(pe=>({errorMessage:pe.additionalInfo?(0,M.localize)(9,null,pe.additionalInfo):(0,M.localize)(10,null),offset:pe.offset,length:pe.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(pe=>({errorMessage:pe.additionalInfo?`${pe.message}. ${pe.additionalInfo}`:pe.message,offset:pe.offset,length:pe.lexeme.length})):[]))}function r(ee,B){const _=ee?ee.substituteConstants():void 0,pe=B?B.substituteConstants():void 0;return!_&&!pe?!0:!_||!pe?!1:_.equals(pe)}function a(ee,B){return ee.cmp(B)}class f{static{this.INSTANCE=new f}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return g.INSTANCE}}e.$xj=f;class g{static{this.INSTANCE=new g}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return f.INSTANCE}}e.$yj=g;class w{static create(B,_=null){const pe=$.get(B);return typeof pe=="boolean"?pe?g.INSTANCE:f.INSTANCE:new w(B,_)}constructor(B,_){this.key=B,this.c=_,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:x(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=$.get(this.key);return typeof B=="boolean"?B?g.INSTANCE:f.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$zj=w;class S{static create(B,_,pe=null){if(typeof _=="boolean")return _?w.create(B,pe):C.create(B,pe);const ue=$.get(B);return typeof ue=="boolean"?_===(ue?"true":"false")?g.INSTANCE:f.INSTANCE:new S(B,_,pe)}constructor(B,_,pe){this.c=B,this.d=_,this.f=pe,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=$.get(this.c);if(typeof B=="boolean"){const _=B?"true":"false";return this.d===_?g.INSTANCE:f.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Aj=S;class m{static create(B,_){return new m(B,_)}constructor(B,_){this.d=B,this.f=_,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const _=B.getValue(this.f),pe=B.getValue(this.d);return Array.isArray(_)?_.includes(pe):typeof pe=="string"&&typeof _=="object"&&_!==null?A.call(_,pe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$Bj=m;class E{static create(B,_){return new E(B,_)}constructor(B,_){this.d=B,this.f=_,this.type=11,this.c=m.create(B,_)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Cj=E;class D{static create(B,_,pe=null){if(typeof _=="boolean")return _?C.create(B,pe):w.create(B,pe);const ue=$.get(B);return typeof ue=="boolean"?_===(ue?"true":"false")?f.INSTANCE:g.INSTANCE:new D(B,_,pe)}constructor(B,_,pe){this.c=B,this.d=_,this.f=pe,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=$.get(this.c);if(typeof B=="boolean"){const _=B?"true":"false";return this.d===_?f.INSTANCE:g.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Dj=D;class C{static create(B,_=null){const pe=$.get(B);return typeof pe=="boolean"?pe?f.INSTANCE:g.INSTANCE:new C(B,_)}constructor(B,_){this.c=B,this.d=_,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:x(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=$.get(this.c);return typeof B=="boolean"?B?f.INSTANCE:g.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=w.create(this.c,this)),this.d}}e.$Ej=C;function P(ee,B){if(typeof ee=="string"){const _=parseFloat(ee);isNaN(_)||(ee=_)}return typeof ee=="string"||typeof ee=="number"?B(ee):f.INSTANCE}class F{static create(B,_,pe=null){return P(_,ue=>new F(B,ue,pe))}constructor(B,_,pe){this.c=B,this.d=_,this.f=pe,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Fj=F;class T{static create(B,_,pe=null){return P(_,ue=>new T(B,ue,pe))}constructor(B,_,pe){this.c=B,this.d=_,this.f=pe,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Gj=T;class z{static create(B,_,pe=null){return P(_,ue=>new z(B,ue,pe))}constructor(B,_,pe){this.c=B,this.d=_,this.f=pe,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Hj=z;class L{static create(B,_,pe=null){return P(_,ue=>new L(B,ue,pe))}constructor(B,_,pe){this.c=B,this.d=_,this.f=pe,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Ij=L;class j{static create(B,_){return new j(B,_)}constructor(B,_){this.d=B,this.f=_,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const _=this.f?this.f.source:"",pe=B.f?B.f.source:"";return _<pe?-1:_>pe?1:0}equals(B){if(B.type===this.type){const _=this.f?this.f.source:"",pe=B.f?B.f.source:"";return this.d===B.d&&_===pe}return!1}substituteConstants(){return this}evaluate(B){const _=B.getValue(this.d);return this.f?this.f.test(_):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=U.create(this)),this.c}}e.$Jj=j;class U{static create(B){return new U(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new U(this.c.map(B))}negate(){return this.c}}e.$Kj=U;function X(ee){let B=null;for(let _=0,pe=ee.length;_<pe;_++){const ue=ee[_].substituteConstants();if(ee[_]!==ue&&B===null){B=[];for(let ce=0;ce<_;ce++)B[ce]=ee[ce]}B!==null&&(B[_]=ue)}return B===null?ee:B}class ie{static create(B,_,pe){return ie.d(B,_,pe)}constructor(B,_){this.expr=B,this.c=_,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let _=0,pe=this.expr.length;_<pe;_++){const ue=a(this.expr[_],B.expr[_]);if(ue!==0)return ue}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let _=0,pe=this.expr.length;_<pe;_++)if(!this.expr[_].equals(B.expr[_]))return!1;return!0}return!1}substituteConstants(){const B=X(this.expr);return B===this.expr?this:ie.create(B,this.c,!1)}evaluate(B){for(let _=0,pe=this.expr.length;_<pe;_++)if(!this.expr[_].evaluate(B))return!1;return!0}static d(B,_,pe){const ue=[];let ce=!1;for(const oe of B)if(oe){if(oe.type===1){ce=!0;continue}if(oe.type===0)return f.INSTANCE;if(oe.type===6){ue.push(...oe.expr);continue}ue.push(oe)}if(ue.length===0&&ce)return g.INSTANCE;if(ue.length!==0){if(ue.length===1)return ue[0];ue.sort(a);for(let oe=1;oe<ue.length;oe++)ue[oe-1].equals(ue[oe])&&(ue.splice(oe,1),oe--);if(ue.length===1)return ue[0];for(;ue.length>1;){const oe=ue[ue.length-1];if(oe.type!==9)break;ue.pop();const le=ue.pop(),K=ue.length===0,se=q.create(oe.expr.map($e=>ie.create([$e,le],null,pe)),null,K);se&&(ue.push(se),ue.sort(a))}if(ue.length===1)return ue[0];if(pe){for(let oe=0;oe<ue.length;oe++)for(let le=oe+1;le<ue.length;le++)if(ue[oe].negate().equals(ue[le]))return f.INSTANCE;if(ue.length===1)return ue[0]}return new ie(ue,_)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const _ of this.expr)B.push(..._.keys());return B}map(B){return new ie(this.expr.map(_=>_.map(B)),null)}negate(){if(!this.c){const B=[];for(const _ of this.expr)B.push(_.negate());this.c=q.create(B,this,!0)}return this.c}}e.$Lj=ie;class q{static create(B,_,pe){return q.d(B,_,pe)}constructor(B,_){this.expr=B,this.c=_,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let _=0,pe=this.expr.length;_<pe;_++){const ue=a(this.expr[_],B.expr[_]);if(ue!==0)return ue}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let _=0,pe=this.expr.length;_<pe;_++)if(!this.expr[_].equals(B.expr[_]))return!1;return!0}return!1}substituteConstants(){const B=X(this.expr);return B===this.expr?this:q.create(B,this.c,!1)}evaluate(B){for(let _=0,pe=this.expr.length;_<pe;_++)if(this.expr[_].evaluate(B))return!0;return!1}static d(B,_,pe){let ue=[],ce=!1;if(B){for(let oe=0,le=B.length;oe<le;oe++){const K=B[oe];if(K){if(K.type===0){ce=!0;continue}if(K.type===1)return g.INSTANCE;if(K.type===9){ue=ue.concat(K.expr);continue}ue.push(K)}}if(ue.length===0&&ce)return f.INSTANCE;ue.sort(a)}if(ue.length!==0){if(ue.length===1)return ue[0];for(let oe=1;oe<ue.length;oe++)ue[oe-1].equals(ue[oe])&&(ue.splice(oe,1),oe--);if(ue.length===1)return ue[0];if(pe){for(let oe=0;oe<ue.length;oe++)for(let le=oe+1;le<ue.length;le++)if(ue[oe].negate().equals(ue[le]))return g.INSTANCE;if(ue.length===1)return ue[0]}return new q(ue,_)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const _ of this.expr)B.push(..._.keys());return B}map(B){return new q(this.expr.map(_=>_.map(B)),null)}negate(){if(!this.c){const B=[];for(const _ of this.expr)B.push(_.negate());for(;B.length>1;){const _=B.shift(),pe=B.shift(),ue=[];for(const ce of Ie(_))for(const oe of Ie(pe))ue.push(ie.create([ce,oe],null,!1));B.unshift(q.create(ue,null,!1))}this.c=q.create(B,this,!0)}return this.c}}e.$Mj=q;class G extends w{static{this.d=[]}static all(){return G.d.values()}constructor(B,_,pe){super(B,null),this.f=_,typeof pe=="object"?G.d.push({...pe,key:B}):pe!==!0&&G.d.push({key:B,description:pe,type:_!=null?typeof _:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return S.create(this.key,B)}notEqualsTo(B){return D.create(this.key,B)}}e.$Nj=G,e.$Oj=(0,R.$wi)("contextKeyService");function x(ee,B){return ee<B?-1:ee>B?1:0}function ne(ee,B,_,pe){return ee<_?-1:ee>_?1:B<pe?-1:B>pe?1:0}function be(ee,B){if(ee.type===0||B.type===1)return!0;if(ee.type===9)return B.type===9?ae(ee.expr,B.expr):!1;if(B.type===9){for(const _ of B.expr)if(be(ee,_))return!0;return!1}if(ee.type===6){if(B.type===6)return ae(B.expr,ee.expr);for(const _ of ee.expr)if(be(_,B))return!0;return!1}return ee.equals(B)}function ae(ee,B){let _=0,pe=0;for(;_<ee.length&&pe<B.length;){const ue=ee[_].cmp(B[pe]);if(ue<0)return!1;ue===0&&_++,pe++}return _===ee.length}function Ie(ee){return ee.type===9?ee.expr:[ee]}}),define(Se[254],De([1,0,23,41,211,5,103,12,24]),function(he,e,h,N,O,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$Pw=e.$Ow=e.$Nw=void 0,e.$Qw=y,e.$Rw=v,e.$Nw=(0,R.$wi)("dialogService");var k;(function(l){l[l.Confirmation=1]="Confirmation",l[l.Prompt=2]="Prompt",l[l.Input=3]="Input"})(k||(k={}));class A{a(d){return this.d(d,k.Confirmation)}b(d){return this.d(d,k.Prompt)}c(d){return this.d(d,k.Input)}d(d,o){const n=[];switch(o){case k.Confirmation:{const i=d;i.primaryButton?n.push(i.primaryButton):n.push((0,O.localize)(0,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,O.localize)(1,null));break}case k.Prompt:{const i=d;Array.isArray(i.buttons)&&i.buttons.length>0&&n.push(...i.buttons.map(u=>u.label)),i.cancelButton&&(i.cancelButton===!0?n.push((0,O.localize)(2,null)):typeof i.cancelButton=="string"?n.push(i.cancelButton):i.cancelButton.label?n.push(i.cancelButton.label):n.push((0,O.localize)(3,null))),n.length===0&&n.push((0,O.localize)(4,null));break}case k.Input:{const i=d;i.primaryButton?n.push(i.primaryButton):n.push((0,O.localize)(5,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,O.localize)(6,null));break}}return n}e(d){if(typeof d=="string")return d;if(typeof d=="number")return d===N.default.Info?"info":d===N.default.Error?"error":d===N.default.Warning?"warning":"none"}f(d,o,n){const i=[...d.buttons??[]];d.cancelButton&&typeof d.cancelButton!="string"&&typeof d.cancelButton!="boolean"&&i.push(d.cancelButton);let u=i[o]?.run({checkboxChecked:n});return u instanceof Promise||(u=Promise.resolve(u)),{result:u,checkboxChecked:n}}}e.$Ow=A,e.$Pw=(0,R.$wi)("fileDialogService");var I;(function(l){l[l.SAVE=0]="SAVE",l[l.DONT_SAVE=1]="DONT_SAVE",l[l.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const p=10;function y(l){const d=[];return d.push(...l.slice(0,p).map(o=>typeof o=="string"?o:(0,h.$7g)(o))),l.length>p&&(l.length-p===1?d.push((0,O.localize)(7,null)):d.push((0,O.localize)(8,null,l.length-p))),d.push(""),d.join(`
`)}function v(l,d){const o=(0,$.$3n)(l);let n=(o.buttons??[]).map(t=>(0,M.$Kw)(t)),i=(l.buttons||[]).map((t,c)=>c),u=0,s=o.cancelId??n.length-1;if(n.length>1){const t=typeof s=="number"?n[s]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&n.length>1&&s!==1){n.splice(s,1),n.splice(1,0,t);const c=i[s];i.splice(s,1),i.splice(1,0,c),s=1}b.$k&&n.length>1&&(n=n.reverse(),i=i.reverse(),u=n.length-1,typeof t=="string"&&(s=u-1))}else if(b.$i&&typeof t=="string"&&n.length>1&&s!==n.length-1){n.splice(s,1),n.push(t);const c=i[s];i.splice(s,1),i.push(c),s=n.length-1}}return o.buttons=n,o.defaultId=u,o.cancelId=s,o.noLink=!0,o.title=o.title||d.nameLong,{options:o,buttonIndeces:i}}}),define(Se[137],De([1,0,5]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=void 0,e.$Di=(0,h.$wi)("environmentService"),e.$Ei=(0,h.$xi)(e.$Di)}),define(Se[138],De([1,0,212,5]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.ExtensionGalleryErrorCode=e.$7o=e.ExtensionManagementErrorCode=e.$6o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=void 0,e.$Zo=O,e.$1o=R,e.$2o=M,e.$3o=b,e.$4o=$,e.$5o=k,e.$To="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Uo=new RegExp(e.$To),e.$Vo="__web_extension",e.$Wo="skipWalkthrough",e.$Xo="extensionsSync",e.$Yo="dependecyOrPackExtensionInstall";function O(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function R(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function M(n,i){switch(n){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function b(n,i){return i==="web"&&!n.includes("web")}function $(n,i,u){return b(i,u)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===u}function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}var A;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var I;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var p;(function(n){n.Install="install",n.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var y;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$6o=(0,N.$wi)("extensionGalleryService");var v;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Cancelled="Cancelled",n.Unknown="Unknown",n.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));class l extends Error{constructor(i,u){super(i),this.code=u,this.name=u}}e.$7o=l;var d;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(d||(e.ExtensionGalleryErrorCode=d={}));class o extends Error{constructor(i,u){super(i),this.code=u,this.name=u}}e.$8o=o,e.$9o=(0,N.$wi)("extensionManagementService"),e.$0o="extensionsIdentifiers/disabled",e.$$o="extensionsIdentifiers/enabled",e.$_o=(0,N.$wi)("IGlobalExtensionEnablementService"),e.$ap=(0,N.$wi)("IExtensionTipsService"),e.$bp=(0,h.localize2)(0,"Extensions"),e.$cp=(0,h.localize2)(1,"Preferences")}),define(Se[255],De([1,0,5]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H7b=e.$G7b=void 0,e.$G7b=(0,h.$wi)("externalTerminal"),e.$H7b="Terminal.app"}),define(Se[256],De([1,0,54,56,15,16,12,102,32,105,214,255]),function(he,e,h,N,O,R,M,b,$,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=e.$Occ=e.$Ncc=void 0;const p=A.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await d.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends y{static{this.b="cmd.exe"}openTerminal(s,t){return this.spawnTerminal(h,s,k.$om(),t)}spawnTerminal(s,t,c,r){const a=t.windowsExec||v.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const f=R.$nc(a,".exe").toLowerCase();if(f==="cmder")return s.spawn(a,r?[r]:void 0),Promise.resolve(void 0);const g=["/c","start","/wait"];return a.indexOf(" ")>=0&&g.push('""'),g.push(a),f==="wt"&&g.push("-d ."),new Promise((w,S)=>{const m=o(process),E=s.spawn(c,g,{cwd:r,env:m,detached:!0});E.on("error",S),E.on("exit",()=>w())})}async runInTerminal(s,t,c,r,a){const f="windowsExec"in a&&a.windowsExec?a.windowsExec:v.getDefaultTerminalWindows(),g=await v.f();return new Promise((w,S)=>{const m=`"${t} - ${p}"`,E=`"${c.join('" "')}" & pause`,D=Object.assign({},o(process),r);Object.keys(D).filter(z=>D[z]===null).forEach(z=>delete D[z]);const C={cwd:t,env:D,windowsVerbatimArguments:!0};let P,F;R.$nc(f,".exe")==="wt"?(P=f,F=["-d",".",v.b,"/c",E]):g?(P=g,F=["-d",".",f,"/c",E]):(P=v.b,F=["/c","start",m,"/wait",f,"/c",`"${E}"`]),h.spawn(P,F,C).on("error",z=>{S(n(z))}),w(void 0)})}static getDefaultTerminalWindows(){if(!v.d){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return v.d}static async f(){try{const s=await k.win32.findExecutable("wt");return await $.Promises.exists(s)?s:void 0}catch{return}}}e.$Ncc=v,He([N.$1h],v,"f",null);class l extends y{static{this.b="/usr/bin/osascript"}openTerminal(s,t){return this.spawnTerminal(h,s,t)}runInTerminal(s,t,c,r,a){const f=a.osxExec||I.$H7b;return new Promise((g,w)=>{if(f===I.$H7b||f==="iTerm.app"){const S=f===I.$H7b?"TerminalHelper":"iTermHelper",E=[O.$Qg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`).fsPath,"-t",s||p,"-w",t];for(const P of c)E.push("-a"),E.push(P);if(r){const P=Object.assign({},o(process),r);for(const F in P){const T=P[F];T===null?(E.push("-u"),E.push(F)):(E.push("-e"),E.push(`${F}=${T}`))}}let D="";const C=h.spawn(l.b,E);C.on("error",P=>{w(n(P))}),C.stderr.on("data",P=>{D+=P.toString()}),C.on("exit",P=>{if(P===0)g(void 0);else if(D){const F=D.split(`
`,1);w(new Error(F[0]))}else w(new Error(A.localize(1,null,S,P)))})}else w(new Error(A.localize(2,null,f)))})}spawnTerminal(s,t,c){const r=t.osxExec||I.$H7b;return new Promise((a,f)=>{const g=["-a",r];c&&g.push(c);const w=o(process),S=s.spawn("/usr/bin/open",g,{cwd:c,env:w});S.on("error",f),S.on("exit",()=>a())})}}e.$Occ=l;class d extends y{static{this.b=A.localize(3,null)}openTerminal(s,t){return this.spawnTerminal(h,s,t)}runInTerminal(s,t,c,r,a){const f=a.linuxExec?Promise.resolve(a.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((g,w)=>{const S=[];f.then(m=>{m.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const E=`${i(c)}; echo; read -p "${d.b}" -n1;`;S.push(`''${E}''`);const D=Object.assign({},o(process),r);Object.keys(D).filter(T=>D[T]===null).forEach(T=>delete D[T]);const C={cwd:t,env:D};let P="";const F=h.spawn(m,S,C);F.on("error",T=>{w(n(T))}),F.stderr.on("data",T=>{P+=T.toString()}),F.on("exit",T=>{if(T===0)g(void 0);else if(P){const z=P.split(`
`,1);w(new Error(z[0]))}else w(new Error(A.localize(4,null,m,T)))})})})}static async getDefaultTerminalLinuxReady(){if(!d.d)if(!M.$k)d.d=Promise.resolve("xterm");else{const s=await $.Promises.exists("/etc/debian_version");d.d=new Promise(t=>{s?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return d.d}spawnTerminal(s,t,c){const r=t.linuxExec?Promise.resolve(t.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((a,f)=>{r.then(g=>{const w=o(process),S=s.spawn(g,[],{cwd:c,env:w});S.on("error",f),S.on("exit",()=>a())})})}}e.$Pcc=d;function o(u){const s={...u.env};return(0,b.$mm)(s),s}function n(u){return"errno"in u&&u.errno==="ENOENT"&&"path"in u&&typeof u.path=="string"?new Error(A.localize(5,null,u.path)):u}function i(u){let s="";for(const t of u)t.indexOf(" ")>=0?s+='"'+t+'"':s+=t,s+=" ";return s}}),define(Se[33],De([1,0,78,16,14,18,2,215,5,12,15,46]),function(he,e,h,N,O,R,M,b,$,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$vl=e.FileKind=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.FileOperationResult=e.$nl=e.$ml=e.$ll=e.$jl=e.FileChangeType=e.$il=e.FileOperation=e.$cl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$3k=void 0,e.$4k=p,e.$5k=d,e.$6k=n,e.$7k=i,e.$8k=u,e.$9k=s,e.$0k=t,e.$$k=c,e.$_k=r,e.$al=a,e.$bl=f,e.$dl=S,e.$el=m,e.$fl=E,e.$gl=D,e.$hl=C,e.$kl=L,e.$wl=G,e.$xl=x,e.$zl=be,e.$3k=(0,$.$wi)("fileService");function p(ae){return ae.create===!0}var y;(function(ae){ae[ae.Unknown=0]="Unknown",ae[ae.File=1]="File",ae[ae.Directory=2]="Directory",ae[ae.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var v;(function(ae){ae[ae.Readonly=1]="Readonly",ae[ae.Locked=2]="Locked"})(v||(e.FilePermission=v={}));var l;(function(ae){ae[ae.UPDATED=2]="UPDATED",ae[ae.ADDED=4]="ADDED",ae[ae.DELETED=8]="DELETED"})(l||(e.FileChangeFilter=l={}));function d(ae){const Ie=ae;return!!Ie&&typeof Ie.onDidChange=="function"}var o;(function(ae){ae[ae.None=0]="None",ae[ae.FileReadWrite=2]="FileReadWrite",ae[ae.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ae[ae.FileReadStream=16]="FileReadStream",ae[ae.FileFolderCopy=8]="FileFolderCopy",ae[ae.PathCaseSensitive=1024]="PathCaseSensitive",ae[ae.Readonly=2048]="Readonly",ae[ae.Trash=4096]="Trash",ae[ae.FileWriteUnlock=8192]="FileWriteUnlock",ae[ae.FileAtomicRead=16384]="FileAtomicRead",ae[ae.FileAtomicWrite=32768]="FileAtomicWrite",ae[ae.FileAtomicDelete=65536]="FileAtomicDelete",ae[ae.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function n(ae){return!!(ae.capabilities&2)}function i(ae){return!!(ae.capabilities&8)}function u(ae){return!!(ae.capabilities&131072)}function s(ae){return!!(ae.capabilities&4)}function t(ae){return!!(ae.capabilities&16)}function c(ae){return n(ae)?!!(ae.capabilities&16384):!1}function r(ae){return n(ae)?!!(ae.capabilities&32768):!1}function a(ae){return!!(ae.capabilities&65536)}function f(ae){return!!(ae.capabilities&2048)}var g;(function(ae){ae.FileExists="EntryExists",ae.FileNotFound="EntryNotFound",ae.FileNotADirectory="EntryNotADirectory",ae.FileIsADirectory="EntryIsADirectory",ae.FileExceedsStorageQuota="EntryExceedsStorageQuota",ae.FileTooLarge="EntryTooLarge",ae.FileWriteLocked="EntryWriteLocked",ae.NoPermissions="NoPermissions",ae.Unavailable="Unavailable",ae.Unknown="Unknown"})(g||(e.FileSystemProviderErrorCode=g={}));class w extends Error{static create(Ie,ee){const B=new w(Ie.toString(),ee);return E(B,ee),B}constructor(Ie,ee){super(Ie),this.code=ee}}e.$cl=w;function S(ae,Ie){return w.create(ae,Ie)}function m(ae){return ae||S((0,b.localize)(0,null),g.Unknown)}function E(ae,Ie){return ae.name=Ie?`${Ie} (FileSystemError)`:"FileSystemError",ae}function D(ae){if(!ae)return g.Unknown;if(ae instanceof w)return ae.code;const Ie=/^(.+) \(FileSystemError\)$/.exec(ae.name);if(!Ie)return g.Unknown;switch(Ie[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}function C(ae){if(ae instanceof j)return ae.fileOperationResult;switch(D(ae)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 9;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileTooLarge:return 7;default:return 10}}var P;(function(ae){ae[ae.CREATE=0]="CREATE",ae[ae.DELETE=1]="DELETE",ae[ae.MOVE=2]="MOVE",ae[ae.COPY=3]="COPY",ae[ae.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class F{constructor(Ie,ee,B){this.resource=Ie,this.operation=ee,this.target=B}isOperation(Ie){return this.operation===Ie}}e.$il=F;var T;(function(ae){ae[ae.UPDATED=0]="UPDATED",ae[ae.ADDED=1]="ADDED",ae[ae.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class z{static{this.a=null}constructor(Ie,ee){this.c=ee,this.b=void 0,this.d=new I.$V(()=>{const B=h.$Ci.forUris(()=>this.c);return B.fill(this.rawAdded.map(_=>[_,!0])),B}),this.f=new I.$V(()=>{const B=h.$Ci.forUris(()=>this.c);return B.fill(this.rawUpdated.map(_=>[_,!0])),B}),this.g=new I.$V(()=>{const B=h.$Ci.forUris(()=>this.c);return B.fill(this.rawDeleted.map(_=>[_,!0])),B}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const B of Ie){switch(B.type){case 1:this.rawAdded.push(B.resource);break;case 0:this.rawUpdated.push(B.resource);break;case 2:this.rawDeleted.push(B.resource);break}this.b!==z.a&&(typeof B.cId=="number"?this.b===void 0?this.b=B.cId:this.b!==B.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(Ie,...ee){return this.h(Ie,{includeChildren:!1},...ee)}affects(Ie,...ee){return this.h(Ie,{includeChildren:!0},...ee)}h(Ie,ee,...B){if(!Ie)return!1;const _=B.length>0;return!!((!_||B.includes(1))&&(this.d.value.get(Ie)||ee.includeChildren&&this.d.value.findSuperstr(Ie))||(!_||B.includes(0))&&(this.f.value.get(Ie)||ee.includeChildren&&this.f.value.findSuperstr(Ie))||(!_||B.includes(2))&&(this.g.value.findSubstr(Ie)||ee.includeChildren&&this.g.value.findSuperstr(Ie)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ie){return this.b===Ie}hasCorrelation(){return typeof this.b=="number"}}e.$jl=z;function L(ae,Ie,ee){return!ae||!Ie||ae===Ie||Ie.length>ae.length?!1:(Ie.charAt(Ie.length-1)!==N.sep&&(Ie+=N.sep),ee?(0,O.$yf)(ae,Ie):ae.indexOf(Ie)===0)}class j extends Error{constructor(Ie,ee,B){super(Ie),this.fileOperationResult=ee,this.options=B}}e.$ll=j;class U extends j{constructor(Ie,ee,B,_){super(Ie,ee,_),this.fileOperationResult=ee,this.size=B}}e.$ml=U;class X extends j{constructor(Ie,ee,B){super(Ie,2,B),this.stat=ee}}e.$nl=X;var ie;(function(ae){ae[ae.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ae[ae.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ae[ae.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ae[ae.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ae[ae.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ae[ae.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ae[ae.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ae[ae.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ae[ae.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ae[ae.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ae[ae.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.$ol={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$pl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ql="files.associations",e.$rl="files.exclude",e.$sl="files.readonlyInclude",e.$tl="files.readonlyExclude",e.$ul="files.readonlyFromPermissions";var q;(function(ae){ae[ae.FILE=0]="FILE",ae[ae.FOLDER=1]="FOLDER",ae[ae.ROOT_FOLDER=2]="ROOT_FOLDER"})(q||(e.FileKind=q={})),e.$vl="";function G(ae){if(!(typeof ae.size!="number"||typeof ae.mtime!="number"))return ae.mtime.toString(29)+ae.size.toString(31)}async function x(ae,Ie){if(!Ie.hasProvider(M.URI.from({scheme:ae.scheme})))return new Promise(ee=>{const B=Ie.onDidChangeFileSystemProviderRegistrations(_=>{_.scheme===ae.scheme&&_.added&&(B.dispose(),ee())})})}class ne{static{this.KB=1024}static{this.MB=ne.KB*ne.KB}static{this.GB=ne.MB*ne.KB}static{this.TB=ne.GB*ne.KB}static formatSize(Ie){return(0,R.$ag)(Ie)||(Ie=0),Ie<ne.KB?(0,b.localize)(1,null,Ie.toFixed(0)):Ie<ne.MB?(0,b.localize)(2,null,(Ie/ne.KB).toFixed(2)):Ie<ne.GB?(0,b.localize)(3,null,(Ie/ne.MB).toFixed(2)):Ie<ne.TB?(0,b.localize)(4,null,(Ie/ne.GB).toFixed(2)):(0,b.localize)(5,null,(Ie/ne.TB).toFixed(2))}}e.$yl=ne;function be(ae){const Ie=typeof ae=="string"||ae?.scheme===A.Schemas.vscodeRemote;return typeof ae!="string"&&ae?.scheme===A.Schemas.file?1024*ne.MB:Ie?10*ne.MB:k.$o?50*ne.MB:1024*ne.MB}}),define(Se[257],De([1,0,21,13,216,33]),function(he,e,h,N,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=M;async function M(A,I,p,y,v,l){let d;try{await b(A,I,p,y,v,l)}catch(o){d=o}finally{d&&v.errorTransformer&&(d=v.errorTransformer(d)),typeof d<"u"&&p.error(d),p.end()}}async function b(A,I,p,y,v,l){$(l);const d=await A.open(I,{create:!1});try{$(l);let o=0,n=0,i=v&&typeof v.length=="number"?v.length:void 0,u=h.$Fe.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),s=v&&typeof v.position=="number"?v.position:0,t=0;do n=await A.read(d,s,u.buffer,t,u.byteLength-t),s+=n,t+=n,o+=n,typeof i=="number"&&(i-=n),t===u.byteLength&&(await p.write(y(u)),u=h.$Fe.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),t=0);while(n>0&&(typeof i!="number"||i>0)&&$(l)&&k(o,v));if(t>0){let c=t;typeof i=="number"&&(c=Math.min(t,i)),p.write(y(u.slice(0,c)))}}catch(o){throw(0,R.$el)(o)}finally{await A.close(d)}}function $(A){if(A.isCancellationRequested)throw(0,N.$6)();return!0}function k(A,I){if(typeof I?.limits?.size=="number"&&A>I.limits.size)throw(0,R.$dl)((0,O.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Se[65],De([1,0,35,3,16,12,2,33]),function(he,e,h,N,O,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Mq=e.$Lq=void 0,e.$Jq=$,e.$Kq=k,e.$Oq=y,e.$Pq=v,e.$Qq=l,e.$Rq=d,e.$Sq=n,e.$Tq=i;function $(u){return typeof u.correlationId=="number"}function k(u){return u.recursive===!0}class A extends N.$Uc{static{this.a=5}constructor(s,t,c,r){super(),this.h=s,this.j=t,this.m=c,this.n=r,this.c=this.B(new N.$Vc),this.f=void 0,this.g=0}s(){const s=new N.$Tc;this.c.value=s,this.b=this.r(s),this.b.setVerboseLogging(this.m),s.add(this.b.onDidChangeFile(t=>this.h(t))),s.add(this.b.onDidLogMessage(t=>this.j(t))),s.add(this.b.onDidError(t=>this.t(t)))}t(s){this.n.restartOnError?this.g<A.a&&this.f?(this.w(`restarting watcher after error: ${s}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${s}`):this.w(s)}u(s){this.g++,this.s(),this.watch(s)}async watch(s){this.f=s,await this.b?.watch(s)}async setVerboseLogging(s){this.m=s,await this.b?.setVerboseLogging(s)}w(s){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${s}`})}y(s){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${s}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Lq=A;class I extends A{constructor(s,t,c){super(s,t,c,{type:"node.js",restartOnError:!1})}}e.$Mq=I;class p extends A{constructor(s,t,c){super(s,t,c,{type:"universal",restartOnError:!0})}}e.$Nq=p;function y(u){return u.map(s=>({type:s.type,resource:M.URI.revive(s.resource),cId:s.cId}))}function v(u){const s=new o;for(const t of u)s.processEvent(t);return s.coalesce()}function l(u,s){return typeof s=="string"&&!s.startsWith(h.$mk)&&!(0,O.$ic)(s)?{base:u,pattern:s}:s}function d(u,s){const t=[];for(const c of s)t.push((0,h.$qk)(l(u,c)));return t}class o{constructor(){this.a=new Set,this.b=new Map}c(s){return R.$k?s.resource.fsPath:s.resource.fsPath.toLowerCase()}processEvent(s){const t=this.b.get(this.c(s));let c=!1;if(t){const r=t.type,a=s.type;t.resource.fsPath!==s.resource.fsPath&&(s.type===2||s.type===1)?c=!0:r===1&&a===2?(this.b.delete(this.c(s)),this.a.delete(t)):r===2&&a===1?t.type=0:r===1&&a===0||(t.type=a)}else c=!0;c&&(this.a.add(s),this.b.set(this.c(s),s))}coalesce(){const s=[],t=[];return Array.from(this.a).filter(c=>c.type!==2?(s.push(c),!1):!0).sort((c,r)=>c.resource.fsPath.length-r.resource.fsPath.length).filter(c=>t.some(r=>(0,b.$kl)(c.resource.fsPath,r,!R.$k))?!1:(t.push(c.resource.fsPath),!0)).concat(s)}}function n(u,s){if(typeof s=="number")switch(u.type){case 1:return(s&4)===0;case 2:return(s&8)===0;case 0:return(s&2)===0}return!1}function i(u){if(typeof u=="number"){const s=[];return u&4&&s.push("Added"),u&8&&s.push("Deleted"),u&2&&s.push("Updated"),s.length===0?"<all>":`[${s.join(", ")}]`}return"<none>"}}),define(Se[258],De([1,0,53,3,65,4,2,7]),function(he,e,h,N,O,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class $ extends N.$Uc{constructor(){super(),this.a=this.B(new R.$de),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$de),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$de),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new N.$4c),this.m=new Set,this.n=5007,this.r=new b.$Th,this.P=!1,this.B(this.f(A=>this.s(A)))}s(A){this.t(A)&&this.w(A)}t(A){return(0,O.$Jq)(A)}async watch(A){this.r.isSettled||this.r.complete(),this.r=new b.$Th;try{this.h.clear(),this.g.clear();for(const I of A)this.t(I)?this.h.set(I.correlationId,I):this.g.add(I);for(const[I]of this.j)this.h.has(I)||(this.j.deleteAndDispose(I),this.m.delete(I));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(A=>!this.j.has(A.correlationId))])}isSuspended(A){return typeof A.correlationId!="number"?!1:this.m.has(A.correlationId)?"polling":this.j.has(A.correlationId)}async w(A){if(this.j.has(A.correlationId))return;const I=new N.$Tc;this.j.set(A.correlationId,I),await this.r.p,!I.isDisposed&&(this.z(A,I),this.u())}y(A){this.j.deleteAndDispose(A.correlationId),this.m.delete(A.correlationId),this.u()}z(A,I){this.C(A,I)?(this.N(`reusing an existing recursive watcher to monitor ${A.path}`),this.m.delete(A.correlationId)):(this.D(A,I),this.m.add(A.correlationId))}C(A,I){const p=this.M?.subscribe(A.path,(y,v)=>{I.isDisposed||(y?this.z(A,I):v?.type===1&&this.F(A))});return p?(I.add(p),!0):!1}D(A,I){let p=!1;const y=(v,l)=>{if(I.isDisposed)return;const d=this.G(v),o=this.G(l),n=p;p=d,!d&&(o||n)&&this.F(A)};this.N(`starting fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,h.watchFile)(A.path,{persistent:!1,interval:this.n},y)}catch(v){this.O(`fs.watchFile() failed with error ${v} on path ${A.path} (correlationId: ${A.correlationId})`)}I.add((0,N.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,h.unwatchFile)(A.path,y)}catch(v){this.O(`fs.unwatchFile() failed with error ${v} on path ${A.path} (correlationId: ${A.correlationId})`)}}))}F(A){this.N(`detected ${A.path} exists again, resuming watcher (correlationId: ${A.correlationId})`);const I={resource:M.URI.file(A.path),type:1,cId:A.correlationId};this.a.fire([I]),this.H(I,A),this.y(A)}G(A){return A.ctimeMs===0&&A.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(A,I){if(this.P){const p=` >> normalized ${A.type===1?"[ADDED]":A.type===2?"[DELETED]":"[CHANGED]"} ${A.resource.fsPath}`;this.I(p,I)}}I(A,I){this.P&&this.N(`${A}${typeof I.correlationId=="number"?` <${I.correlationId}> `:""}`)}J(A){return`${A.path} (excludes: ${A.excludes.length>0?A.excludes:"<none>"}, includes: ${A.includes&&A.includes.length>0?JSON.stringify(A.includes):"<all>"}, filter: ${(0,O.$Tq)(A.filter)}, correlationId: ${typeof A.correlationId=="number"?A.correlationId:"<none>"})`}async setVerboseLogging(A){this.P=A}}e.$3q=$}),define(Se[259],De([1,0,53,7,22,31,3,77,16,12,23,2,104,32,65]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0,e.$9q=d;class l extends M.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(n,i,u,s,t,c){super(),this.s=n,this.t=i,this.u=u,this.w=s,this.y=t,this.z=c,this.c=this.B(new N.$Lh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},r=>this.u(r))),this.f=this.B(new N.$Kh(r=>this.M(r),l.b)),this.g=(0,v.$Rq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,v.$Rq)(this.s.path,this.s.includes):void 0,this.j=(0,v.$Jq)(this.s)?this.s.filter:void 0,this.m=new O.$oe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const n=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const i=await y.Promises.stat(n);if(this.m.token.isCancellationRequested)return;this.B(await this.G(n,i.isDirectory()))}catch(n){n.code!=="ENOENT"?this.O(n):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${n})`),this.D()}}D(){this.r=!0,this.w?.()}async F(n){let i=n.path;try{i=await y.Promises.realpath(n.path),n.path===i&&(i=await(0,p.$5q)(n.path,this.m.token)??n.path),n.path!==i&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${i})`)}catch{}return i}async G(n,i){const u=new M.$Tc;return this.H(n,i,u)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(n,i,u)),u}H(n,i,u){if(i)return!1;const s=I.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(c,r)=>{if(!u.isDisposed)if(c){const a=await this.G(n,i);u.isDisposed?a.dispose():u.add(a)}else r&&(typeof r.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:s,type:r.type,cId:this.s.correlationId},!0)});return t?(u.add(t),!0):!1}async I(n,i,u){if(k.$j&&(0,R.$vg)(n,"/Volumes/",!0)){this.O(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const s=new O.$oe(this.m.token);u.add((0,M.$Sc)(()=>s.dispose(!0)));const t=new M.$Tc;u.add(t);try{const c=I.URI.file(this.s.path),r=(0,$.$nc)(n),a=(0,h.watch)(n);t.add((0,M.$Sc)(()=>{a.removeAllListeners(),a.close()})),this.Q(`Started watching: '${n}'`);const f=new Set;if(i)try{for(const w of await y.Promises.readdir(n))f.add(w)}catch(w){this.O(w)}if(s.token.isCancellationRequested)return;const g=new Map;t.add((0,M.$Sc)(()=>{for(const[,w]of g)w.dispose();g.clear()})),a.on("error",(w,S)=>{s.token.isCancellationRequested||(this.O(`Failed to watch ${n} for changes using fs.watch() (${w}, ${S})`),this.D())}),a.on("change",(w,S)=>{if(s.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${w}"] ${S}`);let m="";if(S&&(m=S.toString(),k.$j&&(m=(0,b.$bm)(m))),!(!m||w!=="change"&&w!=="rename"))if(i)if(w==="rename"){g.get(m)?.dispose();const E=setTimeout(async()=>{if(g.delete(m),m===r&&!await y.Promises.exists(n)){this.J(c);return}if(s.token.isCancellationRequested)return;const D=await this.N((0,$.$jc)(n,m));if(s.token.isCancellationRequested)return;let C;D?f.has(m)?C=0:(C=1,f.add(m)):(f.delete(m),C=2),this.L({resource:(0,A.$0g)(c,m),type:C,cId:this.s.correlationId})},l.a);g.set(m,(0,M.$Sc)(()=>clearTimeout(E)))}else{let E;f.has(m)?E=0:(E=1,f.add(m)),this.L({resource:(0,A.$0g)(c,m),type:E,cId:this.s.correlationId})}else if(w==="rename"||m!==r){const E=setTimeout(async()=>{const D=await y.Promises.exists(n);s.token.isCancellationRequested||(D?(this.L({resource:c,type:0,cId:this.s.correlationId},!0),t.add(await this.G(n,!1))):this.J(c))},l.a);t.clear(),t.add((0,M.$Sc)(()=>clearTimeout(E)))}else this.L({resource:c,type:0,cId:this.s.correlationId},!0)})}catch(c){s.token.isCancellationRequested||this.O(`Failed to watch ${n} for changes using fs.watch() (${c.toString()})`),this.D()}}J(n){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:n,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(n,i=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!i&&this.g.some(u=>u(n.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${n.resource.fsPath}`):!i&&this.h&&this.h.length>0&&!this.h.some(u=>u(n.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}M(n){const i=(0,v.$Pq)(n),u=[];for(const t of i){if((0,v.$Sq)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}u.push(t)}if(u.length===0)return;if(this.z)for(const t of u)this.R(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(u)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(n){if(k.$k)return y.Promises.exists(n);try{const i=(0,$.$nc)(n);return(await y.Promises.readdir((0,$.$mc)(n))).some(s=>s===i)}catch(i){return this.Q(i),!1}}setVerboseLogging(n){this.z=n}O(n){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}P(n){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}Q(n){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}R(n){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${n}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$8q=l;async function d(o,n,i,u,s=512){const t=await y.Promises.open(o,"r"),c=Buffer.allocUnsafe(s),r=new O.$oe(u);let a,f=!1;const g={path:o,excludes:[],recursive:!1},w=new l(g,void 0,S=>{(async()=>{for(const{type:m}of S)if(m===0){if(f)return;f=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:E}=await y.Promises.read(t,c,0,s,null);if(!E||r.token.isCancellationRequested)break;n(c.slice(0,E))}}catch(E){a=new Error(E),r.dispose(!0)}finally{f=!1}}})()});return await w.ready,i(),new Promise((S,m)=>{r.token.onCancellationRequested(async()=>{w.dispose();try{await y.Promises.close(t)}catch(E){a=new Error(E)}a?m(a):S()})})}}),define(Se[260],De([1,0,4,35,258,12,259,31]),function(he,e,h,N,O,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;class $ extends O.$3q{constructor(A){super(),this.M=A,this.onDidError=h.Event.None,this.watchers=new Set}async L(A){A=this.X(A);const I=[],p=new Set(Array.from(this.watchers));for(const y of A){const v=this.S(y);v&&(0,N.$uk)(v.request.excludes,y.excludes)&&(0,N.$uk)(v.request.includes,y.includes)?p.delete(v):I.push(y)}I.length&&this.N(`Request to start watching: ${I.map(y=>this.J(y)).join(",")}`),p.size&&this.N(`Request to stop watching: ${Array.from(p).map(y=>this.J(y.request)).join(",")}`);for(const y of p)this.W(y);for(const y of I)this.U(y)}S(A){for(const I of this.watchers)if(typeof A.correlationId=="number"||typeof I.request.correlationId=="number"){if(I.request.correlationId===A.correlationId)return I}else if((0,b.$ug)(I.request.path,A.path,!R.$k))return I}U(A){const I=new M.$8q(A,this.M,y=>this.a.fire(y),()=>this.c.fire(A),y=>this.b.fire(y),this.P),p={request:A,instance:I};this.watchers.add(p)}async stop(){await super.stop();for(const A of this.watchers)this.W(A)}W(A){this.N("stopping file watcher",A),this.watchers.delete(A),A.instance.dispose()}X(A){const I=new Map;for(const p of A){const y=R.$k?p.path:p.path.toLowerCase();let v=I.get(p.correlationId);v||(v=new Map,I.set(p.correlationId,v)),v.has(y)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(p)}`),v.set(y,p)}return Array.from(I.values()).map(p=>Array.from(p.values())).flat()}async setVerboseLogging(A){super.setVerboseLogging(A);for(const I of this.watchers)I.instance.setVerboseLogging(A)}N(A,I){this.P&&this.b.fire({type:"trace",message:this.$(A,I)})}O(A){this.b.fire({type:"warn",message:this.$(A)})}$(A,I){return I?`[File Watcher (node.js)] ${A} (${this.J(I.request)})`:`[File Watcher (node.js)] ${A}`}}e.$0q=$}),define(Se[261],De([1,0,65,260]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class O extends h.$Mq{constructor(M,b,$){super(M,b,$),this.s()}r(M){return M.add(new N.$0q(void 0))}}e.$$q=O}),define(Se[262],De([1,0,15,82,199,65]),function(he,e,h,N,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;class M extends R.$Nq{constructor($,k,A){super($,k,A),this.s()}r($){const k=$.add(new O.$1q(h.$Qg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(k.onDidProcessExit(({code:A,signal:I})=>this.t(`terminated by itself with code ${A}, signal: ${I} (ETERM)`))),N.ProxyChannel.toService((0,N.$di)(k.getChannel("watcher")))}}e.$2q=M}),define(Se[107],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=void 0;class h{constructor(...O){this.a=new Map;for(const[R,M]of O)this.set(R,M)}set(O,R){const M=this.a.get(O);return this.a.set(O,R),M}has(O){return this.a.has(O)}get(O){return this.a.get(O)}}e.$ui=h}),define(Se[263],De([1,0,7,13,3,106,253,5,107,76]),function(he,e,h,N,O,R,M,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=void 0;const A=!1;class I extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class p{constructor(d=new $.$ui,o=!1,n,i=A){this.i=d,this.j=o,this.k=n,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(b.$vi,this),this._globalGraph=i?n?._globalGraph??new M.$br(u=>u):void 0}dispose(){if(!this.f){this.f=!0,(0,O.$Pc)(this.h),this.h.clear();for(const d of this.g)(0,O.$Oc)(d)&&d.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(d){this.m();const o=new class extends p{dispose(){this.h.delete(o),super.dispose()}}(d,this.j,this,this.l);return this.h.add(o),o}invokeFunction(d,...o){this.m();const n=v.traceInvocation(this.l,d);let i=!1;try{return d({get:s=>{if(i)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(s,n);if(!t)throw new Error(`[invokeFunction] unknown service '${s}'`);return t}},...o)}finally{i=!0,n.stop()}}createInstance(d,...o){this.m();let n,i;return d instanceof R.$ti?(n=v.traceCreation(this.l,d.ctor),i=this.o(d.ctor,d.staticArguments.concat(o),n)):(n=v.traceCreation(this.l,d),i=this.o(d,o,n)),n.stop(),i}o(d,o=[],n){const i=b._util.getServiceDependencies(d).sort((t,c)=>t.index-c.index),u=[];for(const t of i){const c=this.s(t.id,n);c||this.y(`[createInstance] ${d.name} depends on UNKNOWN service ${t.id}.`,!1),u.push(c)}const s=i.length>0?i[0].index:o.length;if(o.length!==s){console.trace(`[createInstance] First service dependency of ${d.name} at position ${s+1} conflicts with ${o.length} static arguments`);const t=s-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,s)}return Reflect.construct(d,o.concat(u))}q(d,o){if(this.i.get(d)instanceof R.$ti)this.i.set(d,o);else if(this.k)this.k.q(d,o);else throw new Error("illegalState - setting UNKNOWN service instance")}r(d){const o=this.i.get(d);return!o&&this.k?this.k.r(d):o}s(d,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const n=this.r(d);return n instanceof R.$ti?this.u(d,n,o.branch(d,!0)):(o.branch(d,!1),n)}u(d,o,n){if(this.t.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.t.add(d);try{return this.v(d,o,n)}finally{this.t.delete(d)}}v(d,o,n){const i=new M.$br(t=>t.id.toString());let u=0;const s=[{id:d,desc:o,_trace:n}];for(;s.length;){const t=s.pop();if(i.lookupOrInsertNode(t),u++>1e3)throw new I(i);for(const c of b._util.getServiceDependencies(t.desc.ctor)){const r=this.r(c.id);if(r||this.y(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(c.id)),r instanceof R.$ti){const a={id:c.id,desc:r,_trace:t._trace.branch(c.id,!0)};i.insertEdge(t,a),s.push(a)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new I(i);break}for(const{data:c}of t){if(this.r(c.id)instanceof R.$ti){const a=this.w(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this.q(c.id,a)}i.removeNode(c)}}return this.r(d)}w(d,o,n=[],i,u){if(this.i.get(d)instanceof R.$ti)return this.x(d,o,n,i,u,this.g);if(this.k)return this.k.w(d,o,n,i,u);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}x(d,o,n=[],i,u,s){if(i){const t=new p(void 0,this.j,this,this.l);t.c=String(d);const c=new Map,r=new h.$Ph(()=>{const a=t.o(o,n,u);for(const[f,g]of c){const w=a[f];if(typeof w=="function")for(const S of g)S.disposable=w.apply(a,S.listener)}return c.clear(),s.add(a),a});return new Proxy(Object.create(null),{get(a,f){if(!r.isInitialized&&typeof f=="string"&&(f.startsWith("onDid")||f.startsWith("onWill"))){let S=c.get(f);return S||(S=new k.$5c,c.set(f,S)),(E,D,C)=>{if(r.isInitialized)return r.value[f](E,D,C);{const P={listener:[E,D,C],disposable:void 0},F=S.push(P);return(0,O.$Sc)(()=>{F(),P.disposable?.dispose()})}}}if(f in a)return a[f];const g=r.value;let w=g[f];return typeof w!="function"||(w=w.bind(g),a[f]=w),w},set(a,f,g){return r.value[f]=g,!0},getPrototypeOf(a){return o.prototype}})}else{const t=this.o(o,n,u);return s.add(t),t}}y(d,o){if(o&&console.warn(d),this.j)throw new Error(d)}}e.$cr=p;var y;(function(l){l[l.None=0]="None",l[l.Creation=1]="Creation",l[l.Invocation=2]="Invocation",l[l.Branch=3]="Branch"})(y||(y={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(d,o){return d?new v(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(d,o){return d?new v(1,o.name):v.c}static{this.f=0}constructor(d,o){this.type=d,this.name=o,this.g=Date.now(),this.h=[]}branch(d,o){const n=new v(3,d.toString());return this.h.push([d,o,n]),n}stop(){const d=Date.now()-this.g;v.f+=d;let o=!1;function n(u,s){const t=[],c=new Array(u+1).join("	");for(const[r,a,f]of s.h)if(a&&f){o=!0,t.push(`${c}CREATES -> ${r}`);const g=n(u+1,f);g&&t.push(g)}else t.push(`${c}uses -> ${r}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(d>2||o)&&v.all.add(i.join(`
`))}}e.$dr=v}),define(Se[11],De([1,0,218,47,4,57,3,27,12,23,18,2,38,5]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$6j=e.LogLevel=e.$4j=e.$3j=void 0,e.$5j=l,e.log=o,e.$ek=w,e.$fk=S,e.$gk=m,e.$hk=E,e.$3j=(0,y.$wi)("logService"),e.$4j=(0,y.$wi)("loggerService");function v(){return new Date().toISOString()}function l(D){return(0,A.$ag)(D)}var d;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(d||(e.LogLevel=d={})),e.$6j=d.Info;function o(D,C,P){switch(C){case d.Trace:D.trace(P);break;case d.Debug:D.debug(P);break;case d.Info:D.info(P);break;case d.Warning:D.warn(P);break;case d.Error:D.error(P);break;case d.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function n(D,C=!1){let P="";for(let F=0;F<D.length;F++){let T=D[F];if(T instanceof Error&&(T=(0,N.$hj)(T,C)),typeof T=="object")try{T=JSON.stringify(T)}catch{}P+=(F>0?" ":"")+T}return P}class i extends M.$Uc{constructor(){super(...arguments),this.b=e.$6j,this.c=this.B(new O.$de),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==d.Off&&this.b<=C}}e.$8j=i;class u extends i{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...P){this.f(d.Trace)&&this.g(d.Trace,n([C,...P],!0))}debug(C,...P){this.f(d.Debug)&&this.g(d.Debug,n([C,...P]))}info(C,...P){this.f(d.Info)&&this.g(d.Info,n([C,...P]))}warn(C,...P){this.f(d.Warning)&&this.g(d.Warning,n([C,...P]))}error(C,...P){if(this.f(d.Error))if(C instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=C.stack,this.g(d.Error,n(F))}else this.g(d.Error,n([C,...P]))}flush(){}}e.$9j=u;class s extends i{constructor(C=e.$6j){super(),this.setLevel(C),this.g=!$.$i}trace(C,...P){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,C,...P):console.log(`[main ${v()}]`,C,...P))}debug(C,...P){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,C,...P):console.log(`[main ${v()}]`,C,...P))}info(C,...P){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,C,...P):console.log(`[main ${v()}]`,C,...P))}warn(C,...P){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,C,...P):console.warn(`[main ${v()}]`,C,...P))}error(C,...P){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,C,...P):console.error(`[main ${v()}]`,C,...P))}flush(){}}e.$0j=s;class t extends i{constructor(C=e.$6j,P=!0){super(),this.g=P,this.setLevel(C)}trace(C,...P){this.f(d.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...P):console.log(C,...P))}debug(C,...P){this.f(d.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...P):console.log(C,...P))}info(C,...P){this.f(d.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...P):console.log(C,...P))}warn(C,...P){this.f(d.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...P):console.log(C,...P))}error(C,...P){this.f(d.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...P):console.error(C,...P))}flush(){}}e.$$j=t;class c extends i{constructor(C,P=e.$6j){super(),this.g=C,this.setLevel(P)}trace(C,...P){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(C),...P])}debug(C,...P){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(C),...P])}info(C,...P){this.f(d.Info)&&this.g.log(d.Info,[this.h(C),...P])}warn(C,...P){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(C),...P])}error(C,...P){this.f(d.Error)&&this.g.log(d.Error,[this.h(C),...P])}h(C){return typeof C=="string"?C:(0,N.$hj)(C,this.f(d.Trace))}flush(){}}e.$_j=c;class r extends i{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const P of this.g)P.setLevel(C);super.setLevel(C)}trace(C,...P){for(const F of this.g)F.trace(C,...P)}debug(C,...P){for(const F of this.g)F.debug(C,...P)}info(C,...P){for(const F of this.g)F.info(C,...P)}warn(C,...P){for(const F of this.g)F.warn(C,...P)}error(C,...P){for(const F of this.g)F.error(C,...P)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$ak=r;class a extends M.$Uc{constructor(C,P,F){if(super(),this.h=C,this.j=P,this.b=new b.$Ac,this.c=this.B(new O.$de),this.onDidChangeLoggers=this.c.event,this.f=this.B(new O.$de),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new O.$de),this.onDidChangeVisibility=this.g.event,F)for(const T of F)this.b.set(T.resource,{logger:void 0,info:T})}m(C){return(0,A.$9f)(C)?[...this.b.values()].find(P=>P.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,P){const F=this.n(C),T=(0,A.$9f)(C)?C:P?.id??(0,R.$kj)(F.toString()).toString(16);let z=this.b.get(F)?.logger;const L=P?.logLevel==="always"?d.Trace:P?.logLevel;z||(z=this.s(F,L??this.getLogLevel(F)??this.h,{...P,id:T}));const j={logger:z,info:{resource:F,id:T,logLevel:L,name:P?.name,hidden:P?.hidden,extensionId:P?.extensionId,when:P?.when}};return this.registerLogger(j.info),this.b.set(F,j),z}n(C){return(0,A.$9f)(C)?(0,k.$0g)(this.j,`${C}.log`):C}setLogLevel(C,P){if(I.URI.isUri(C)){const F=C,T=P,z=this.b.get(F);z&&T!==z.info.logLevel&&(z.info.logLevel=T===this.h?void 0:T,z.logger?.setLevel(T),this.b.set(z.info.resource,z),this.f.fire([F,T]))}else{this.h=C;for(const[F,T]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,P){const F=this.m(C);F&&P!==!F.info.hidden&&(F.info.hidden=!P,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,P]))}getLogLevel(C){let P;return C&&(P=this.b.get(C)?.info.logLevel),P??this.h}registerLogger(C){const P=this.b.get(C.resource);P?P.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const P=this.b.get(C);P&&(P.logger&&P.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[P.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bk=a;class f{constructor(){this.onDidChangeLogLevel=new O.$de().event}setLevel(C){}getLevel(){return d.Info}trace(C,...P){}debug(C,...P){}info(C,...P){}warn(C,...P){}error(C,...P){}critical(C,...P){}dispose(){}flush(){}}e.$ck=f;class g extends f{}e.$dk=g;function w(D){if(D.verbose)return d.Trace;if(typeof D.logLevel=="string"){const C=E(D.logLevel.toLowerCase());if(C!==void 0)return C}return e.$6j}function S(D){switch(D){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}function m(D){switch(D){case d.Trace:return{original:"Trace",value:h.localize(0,null)};case d.Debug:return{original:"Debug",value:h.localize(1,null)};case d.Info:return{original:"Info",value:h.localize(2,null)};case d.Warning:return{original:"Warning",value:h.localize(3,null)};case d.Error:return{original:"Error",value:h.localize(4,null)};case d.Off:return{original:"Off",value:h.localize(5,null)}}}function E(D){switch(D){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.$ik=new p.$Nj("logLevel",S(d.Info))}),define(Se[264],De([1,0,19,7,13,4,31,3,16,65,11]),function(he,e,h,N,O,R,M,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class I extends b.$Uc{constructor(y,v){super(),this.a=y,this.b=v,this.c=this.B(new R.$de),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$de),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$uh(0)),this.w=[],this.y=this.B(new N.$uh(0))}watch(y,v){return v.recursive||this.b?.watcher?.forceUniversal?this.n(y,v):this.z(y,v)}n(y,v){const l={path:this.J(y),excludes:v.excludes,includes:v.includes,recursive:v.recursive,filter:v.filter,correlationId:v.correlationId},d=(0,h.$Tb)(this.j,l);return this.r(),(0,b.$Sc)(()=>{d(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(y=>(0,O.$1)(y))}s(){this.h||(this.h=this.B(this.t(v=>this.c.fire((0,k.$Oq)(v)),v=>this.G(v),this.a.getLevel()===A.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===A.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const v of this.j)(0,k.$Kq)(v)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const v of this.j)(0,k.$Kq)(v)&&y.includes(v.path)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(y,v){const l={path:this.J(y),excludes:v.excludes,includes:v.includes,recursive:!1,filter:v.filter,correlationId:v.correlationId},d=(0,h.$Tb)(this.w,l);return this.C(),(0,b.$Sc)(()=>{d(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(y=>(0,O.$1)(y))}D(){return this.u||(this.u=this.B(this.F(y=>this.c.fire((0,k.$Oq)(y)),y=>this.G(y),this.a.getLevel()===A.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===A.LogLevel.Trace)}))),this.u.watch(this.w)}G(y){y.type==="error"&&this.g.fire(y.message),this.H(y)}H(y){this.a[y.type](y.message)}I(y){return(0,$.$hc)(y.fsPath)}J(y){const v=this.I(y);return(0,M.$yg)(v)}}e.$Uq=I}),define(Se[265],De([1,0,53,401,7,27,21,4,31,3,16,12,23,98,32,217,33,257,264,47,262,261]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d,o,n,i,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0,(()=>{try{(0,N.gracefulify)(h)}catch(c){console.error(`Error enabling graceful-fs: ${(0,i.$hj)(c)}`)}})();class t extends n.$Uq{static{this.L=!1}constructor(r,a){super(r,a),this.onDidChangeCapabilities=b.Event.None,this.P=new R.$Ac(f=>p.$1g.getComparisonKey(f)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,I.$k&&(this.M|=1024)),this.M}async stat(r){try{const{stat:a,symbolicLink:f}=await v.SymlinkSupport.stat(this.I(r));return{type:this.O(a,f),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size,permissions:a.mode&128?void 0:d.FilePermission.Locked}}catch(a){throw this.hb(a)}}async N(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const a=await v.Promises.readdir(this.I(r),{withFileTypes:!0}),f=[];return await Promise.all(a.map(async g=>{try{let w;g.isSymbolicLink()?w=(await this.stat((0,p.$0g)(r,g.name))).type:w=this.O(g),f.push([g.name,w])}catch(w){this.a.trace(w)}})),f}catch(a){throw this.hb(a)}}O(r,a){let f;return a?.dangling?f=d.FileType.Unknown:r.isFile()?f=d.FileType.File:r.isDirectory()?f=d.FileType.Directory:f=d.FileType.Unknown,a&&(f|=d.FileType.SymbolicLink),f}async Q(r){const a=this.I(r);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${a})`);let f;for(;f=this.P.get(r);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${a})`),await f.wait();const g=new O.$vh;return this.P.set(r,g),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${a})`),(0,k.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${a})`),this.P.get(r)===g&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${a})`),this.P.delete(r)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${a})`),g.open()})}async readFile(r,a){let f;try{a?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(r)})`),f=await this.Q(r));const g=this.I(r);return await v.Promises.readFile(g)}catch(g){throw this.hb(g)}finally{f?.dispose()}}R(r){t.L&&this.a.trace(r)}readFileStream(r,a,f){const g=(0,y.$te)(w=>M.$Fe.concat(w.map(S=>M.$Fe.wrap(S))).buffer);return(0,o.$Hq)(this,r,g,w=>w.buffer,{...a,bufferSize:256*1024},f),g}async writeFile(r,a,f){return f?.atomic!==!1&&f?.atomic?.postfix&&await this.S(r)?this.U(r,(0,p.$0g)((0,p.$9g)(r),`${(0,p.$7g)(r)}${f.atomic.postfix}`),a,f):this.W(r,a,f)}async S(r){try{const a=this.I(r),{symbolicLink:f}=await v.SymlinkSupport.stat(a);if(f)return!1}catch{}return!0}async U(r,a,f,g){const w=new k.$Tc;try{w.add(await this.Q(r)),w.add(await this.Q(a)),await this.W(a,f,g,!0);try{await this.rename(a,r,{overwrite:!0})}catch(S){try{await this.delete(a,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{w.dispose()}}async W(r,a,f,g){let w;try{const S=this.I(r);if(!f.create||!f.overwrite){if(await v.Promises.exists(S)){if(!f.overwrite)throw(0,d.$dl)((0,l.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!f.create)throw(0,d.$dl)((0,l.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}w=await this.open(r,{create:!0,unlock:f.unlock},g),await this.write(w,0,a,0,a.byteLength)}catch(S){throw await this.ib(r,S)}finally{typeof w=="number"&&await this.close(w)}}static{this.$=!0}static configureFlushOnWrite(r){t.$=r}async open(r,a,f){const g=this.I(r);let w;(0,d.$4k)(a)&&!f&&(w=await this.Q(r));let S;try{if((0,d.$4k)(a)&&a.unlock)try{const{stat:E}=await v.SymlinkSupport.stat(g);E.mode&128||await v.Promises.chmod(g,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let m;if((0,d.$4k)(a)){if(I.$i)try{await v.Promises.truncate(g,0),m="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}m||(m="w")}else m="r";S=await v.Promises.open(g,m)}catch(m){throw w?.dispose(),(0,d.$4k)(a)?await this.ib(r,m):this.hb(m)}if(this.X.set(S,0),(0,d.$4k)(a)&&this.Z.set(S,r),w){const m=this.Y.get(S);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${g})`),this.Y.set(S,w),m&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${g})`),m.dispose())}return S}async close(r){const a=this.Y.get(r);try{if(this.X.delete(r),this.Z.delete(r)&&t.$)try{await v.Promises.fdatasync(r)}catch(f){t.configureFlushOnWrite(!1),this.a.error(f)}return await v.Promises.close(r)}catch(f){throw this.hb(f)}finally{a&&(this.Y.get(r)===a&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.Y.delete(r)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),a.dispose())}}async read(r,a,f,g,w){const S=this.ab(r,a);let m=null;try{m=(await v.Promises.read(r,f,g,w,S)).bytesRead}catch(E){throw this.hb(E)}finally{this.bb(r,S,m)}return m}ab(r,a){return a===this.X.get(r)?null:a}bb(r,a,f){const g=this.X.get(r);typeof g=="number"&&(typeof a=="number"||(typeof f=="number"?this.X.set(r,g+f):this.X.delete(r)))}async write(r,a,f,g,w){return(0,O.$Qh)(()=>this.cb(r,a,f,g,w),100,3)}async cb(r,a,f,g,w){const S=this.ab(r,a);let m=null;try{m=(await v.Promises.write(r,f,g,w,S)).bytesWritten}catch(E){throw await this.ib(this.Z.get(r),E)}finally{this.bb(r,S,m)}return m}async mkdir(r){try{await v.Promises.mkdir(this.I(r))}catch(a){throw this.hb(a)}}async delete(r,a){try{const f=this.I(r);if(a.recursive){let g;a?.atomic!==!1&&a.atomic.postfix&&(g=(0,A.$jc)((0,A.$mc)(f),`${(0,A.$nc)(f)}${a.atomic.postfix}`)),await v.Promises.rm(f,v.RimRafMode.MOVE,g)}else try{await v.Promises.unlink(f)}catch(g){if(g.code==="EPERM"||g.code==="EISDIR"){let w=!1;try{const{stat:S,symbolicLink:m}=await v.SymlinkSupport.stat(f);w=S.isDirectory()&&!m}catch{}if(w)await v.Promises.rmdir(f);else throw g}else throw g}}catch(f){throw this.hb(f)}}async rename(r,a,f){const g=this.I(r),w=this.I(a);if(g!==w)try{await this.db(r,a,"move",f.overwrite),await v.Promises.rename(g,w)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,l.localize)(2,null,(0,A.$nc)(g),(0,A.$nc)((0,A.$mc)(w)),S.toString()))),this.hb(S)}}async copy(r,a,f){const g=this.I(r),w=this.I(a);if(g!==w)try{await this.db(r,a,"copy",f.overwrite),await v.Promises.copy(g,w,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,l.localize)(3,null,(0,A.$nc)(g),(0,A.$nc)((0,A.$mc)(w)),S.toString()))),this.hb(S)}}async db(r,a,f,g){const w=this.I(r),S=this.I(a);let m=!1;if(!!(this.capabilities&1024)||(m=(0,$.$ug)(w,S,!0)),m){if(f==="copy")throw(0,d.$dl)((0,l.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(f==="move")return}const D=await this.N(r);if(!D)throw(0,d.$dl)((0,l.localize)(5,null),d.FileSystemProviderErrorCode.FileNotFound);const C=await this.N(a);if(C){if(!g)throw(0,d.$dl)((0,l.localize)(6,null),d.FileSystemProviderErrorCode.FileExists);D.type&d.FileType.File&&C.type&d.FileType.File||await this.delete(a,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,a){return this.eb(r,a,!1)}async eb(r,a,f){const g=this.I(r),w=this.I(a),S=!!(this.capabilities&1024);if((0,$.$ug)(g,w,!S))return;const m=new k.$Tc;try{m.add(await this.Q(r)),m.add(await this.Q(a)),f&&await v.Promises.mkdir((0,A.$mc)(w),{recursive:!0}),await v.Promises.copyFile(g,w)}catch(E){if(E.code==="ENOENT"&&!f)return this.eb(r,a,!0);throw this.hb(E)}finally{m.dispose()}}t(r,a,f){return new u.$2q(g=>r(g),g=>a(g),f)}F(r,a,f){return new s.$$q(g=>r(g),g=>a(g),f)}hb(r){if(r instanceof d.$cl)return r;let a=r,f;switch(r.code){case"ENOENT":f=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":f=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":f=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":f=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":f=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":a=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,f=d.FileSystemProviderErrorCode.Unknown;break;default:f=d.FileSystemProviderErrorCode.Unknown}return(0,d.$dl)(a,f)}async ib(r,a){let f=this.hb(a);if(r&&f.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:g}=await v.SymlinkSupport.stat(this.I(r));g.mode&128||(f=(0,d.$dl)(a,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(g){this.a.trace(g)}return f}}e.$_q=t}),define(Se[266],De([1,0,3,11]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5P=void 0;class O extends h.$Uc{constructor(M,b=[]){super(),this.a=new N.$ak([M,...b]),this.B(M.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...b){this.a.trace(M,...b)}debug(M,...b){this.a.debug(M,...b)}info(M,...b){this.a.info(M,...b)}warn(M,...b){this.a.warn(M,...b)}error(M,...b){this.a.error(M,...b)}flush(){this.a.flush()}}e.$5P=O}),define(Se[267],De([1,0,33,11]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TP=void 0;var O;(function(k){k[k.Trace=0]="Trace",k[k.Debug=1]="Debug",k[k.Info=2]="Info",k[k.Warning=3]="Warning",k[k.Error=4]="Error",k[k.Critical=5]="Critical",k[k.Off=6]="Off"})(O||(O={}));async function R(k,A,I,p,y){try{const v=await new Promise((d,o)=>{he(["@vscode/spdlog"],d,o)});v.setFlushOn(O.Trace);const l=await v.createAsyncRotatingLogger(k,A,I,p);return y?l.clearFormatters():l.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),l}catch(v){console.error(v)}return null}function M(k,A,I){switch(A){case N.LogLevel.Trace:k.trace(I);break;case N.LogLevel.Debug:k.debug(I);break;case N.LogLevel.Info:k.info(I);break;case N.LogLevel.Warning:k.warn(I);break;case N.LogLevel.Error:k.error(I);break;case N.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function b(k,A){switch(A){case N.LogLevel.Trace:k.setLevel(O.Trace);break;case N.LogLevel.Debug:k.setLevel(O.Debug);break;case N.LogLevel.Info:k.setLevel(O.Info);break;case N.LogLevel.Warning:k.setLevel(O.Warning);break;case N.LogLevel.Error:k.setLevel(O.Error);break;case N.LogLevel.Off:k.setLevel(O.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class $ extends N.$9j{constructor(A,I,p,y,v){super(),this.m=[],this.setLevel(v),this.n=this.s(A,I,p,y),this.B(this.onDidChangeLogLevel(l=>{this.r&&b(this.r,l)}))}async s(A,I,p,y){const v=p?6:1,l=30/v*h.$yl.MB,d=await R(A,I,l,v,y);if(d){this.r=d,b(this.r,this.getLevel());for(const{level:o,message:n}of this.m)M(this.r,o,n);this.m=[]}}g(A,I){this.r?M(this.r,A,I):this.getLevel()<=A&&this.m.push({level:A,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$TP=$}),define(Se[139],De([1,0,41,219,5]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7t=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var M;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function($){function k(v,l){return l-v}$.compare=k;const A=Object.create(null);A[$.Error]=(0,N.localize)(0,null),A[$.Warning]=(0,N.localize)(1,null),A[$.Info]=(0,N.localize)(2,null);function I(v){return A[v]||""}$.toString=I;function p(v){switch(v){case h.default.Error:return $.Error;case h.default.Warning:return $.Warning;case h.default.Info:return $.Info;case h.default.Ignore:return $.Hint}}$.fromSeverity=p;function y(v){switch(v){case $.Error:return h.default.Error;case $.Warning:return h.default.Warning;case $.Info:return h.default.Info;case $.Hint:return h.default.Ignore}}$.toSeverity=y}(M||(e.MarkerSeverity=M={}));var b;(function($){const k="";function A(p){return I(p,!0)}$.makeKey=A;function I(p,y){const v=[k];return p.source?v.push(p.source.replace("\xA6","\\\xA6")):v.push(k),p.code?typeof p.code=="string"?v.push(p.code.replace("\xA6","\\\xA6")):v.push(p.code.value.replace("\xA6","\\\xA6")):v.push(k),p.severity!==void 0&&p.severity!==null?v.push(M.toString(p.severity)):v.push(k),p.message&&y?v.push(p.message.replace("\xA6","\\\xA6")):v.push(k),p.startLineNumber!==void 0&&p.startLineNumber!==null?v.push(p.startLineNumber.toString()):v.push(k),p.startColumn!==void 0&&p.startColumn!==null?v.push(p.startColumn.toString()):v.push(k),p.endLineNumber!==void 0&&p.endLineNumber!==null?v.push(p.endLineNumber.toString()):v.push(k),p.endColumn!==void 0&&p.endColumn!==null?v.push(p.endColumn.toString()):v.push(k),v.push(k),v.join("\xA6")}$.makeKeyOptionalMessage=I})(b||(e.IMarkerData=b={})),e.$7t=(0,O.$wi)("markerService")}),define(Se[268],De([1,0,4,41,5]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$_v=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$0v=e.Severity=void 0,e.$$v=b,e.Severity=N.default,e.$0v=(0,O.$wi)("notificationService");var R;(function(I){I[I.DEFAULT=0]="DEFAULT",I[I.SILENT=1]="SILENT",I[I.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var M;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));function b(I){if(I){const p=I;return typeof p.id=="string"&&typeof p.label=="string"}return!1}var $;(function(I){I[I.OFF=0]="OFF",I[I.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class k{constructor(){this.progress=new A,this.onDidClose=h.Event.None,this.onDidChangeVisibility=h.Event.None}updateSeverity(p){}updateMessage(p){}updateActions(p){}close(){}}e.$_v=k;class A{infinite(){}done(){}total(p){}worked(p){}}e.$aw=A}),define(Se[269],De([1,0,52]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const O=globalThis.vscode;if(typeof O<"u"&&typeof O.context<"u"){const R=O.context.configuration();if(R)N=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,h.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:R.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(Se[108],De([1,0,5]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=void 0,e.$jk=(0,h.$wi)("productService"),e.$kk="vscode://schemas/vscode-product"});var We=this&&this.__param||function(he,e){return function(h,N){e(h,N,he)}};define(Se[109],De([1,0,7,22,3,5]),function(he,e,h,N,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=e.$gw=e.$fw=e.$ew=e.$dw=e.$cw=e.ProgressLocation=e.$bw=void 0,e.$bw=(0,R.$wi)("progressService");var M;(function(I){I[I.Explorer=1]="Explorer",I[I.Scm=3]="Scm",I[I.Extensions=5]="Extensions",I[I.Window=10]="Window",I[I.Notification=15]="Notification",I[I.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$cw=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(p){this.b=p}report(p){this.a=p,this.b(this.a)}}e.$dw=b;class ${get value(){return this.a}constructor(p){this.e=p}report(p){this.b?this.b.push(p):this.b=[p],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const p=this.b.shift();this.a=p,await this.e(this.a)}}finally{this.c=!1;const p=this.d;this.d=void 0,p?.()}}drain(){return this.c?new Promise(p=>{const y=this.d;this.d=()=>{y?.(),p()}}):Promise.resolve()}}e.$ew=$;let k=class extends O.$Uc{constructor(p,y){super(),this.a=new h.$Th,y.withProgress(p,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,O.$Sc)(()=>this.a.complete()))}report(p){this.b?this.b.report(p):this.c=p}};e.$fw=k,e.$fw=k=He([We(1,e.$bw)],k);class A extends O.$Uc{constructor(p){super(),this.g=p,this.a=0,this.b=this.B(new O.$Tc)}start(p){this.stop();const y=++this.a,v=new N.$oe;return this.f=setTimeout(()=>{y===this.a&&(this.c=this.g.show(!0))},p),this.b.add((0,O.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,O.$Sc)(()=>v.cancel())),this.b.add((0,O.$Sc)(()=>this.c?this.c.done():void 0)),{id:y,token:v.token,stop:()=>this.h(y),isCurrent:()=>this.a===y}}stop(){this.h(this.a)}h(p){this.a===p&&this.b.clear()}}e.$gw=A,e.$hw=(0,R.$wi)("editorProgressService")}),define(Se[36],De([1,0,62,18]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0;class O{constructor(){this.a=new Map}add(M,b){h.ok(N.$9f(M)),h.ok(N.$$f(b)),h.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,b)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$co=new O}),define(Se[110],De([1,0,4,36]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=void 0,e.$do={JSONContribution:"base.contributions.json"};function O(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class R{constructor(){this.b=new h.$de,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,k){this.a[O($)]=k,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const M=new R;N.$co.add(e.$do.JSONContribution,M)}),define(Se[66],De([1,0,19,4,18,208,55,110,36]),function(he,e,h,N,O,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.ConfigurationScope=e.$ho=e.EditPresentationTypes=void 0,e.$so=l,e.$to=d,e.$uo=o,e.$vo=i,e.$wo=u;var k;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(k||(e.EditPresentationTypes=k={})),e.$ho={Configuration:"base.contributions.configuration"};var A;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$io={properties:{},patternProperties:{}},e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo="vscode://schemas/settings/resourceLanguage",e.$po="vscode://schemas/settings/configurationDefaults";const I=$.$co.as(b.$do.JSONContribution);class p{constructor(){this.h=new Set,this.i=new N.$de,this.onDidSchemaChange=this.i.event,this.j=new N.$de,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$oo,this.g),this.v()}registerConfiguration(t,c=!0){this.registerConfigurations([t],c)}registerConfigurations(t,c=!0){const r=new Set;this.n(t,c,r),I.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const c=new Set;this.o(t,c),I.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:c})}updateConfigurations({add:t,remove:c}){const r=new Set;this.o(c,r),this.n(t,!1,r),I.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const c=new Set;this.k(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}k(t,c){const r=[];for(const{overrides:a,source:f}of t)for(const g in a)if(c.add(g),e.$ro.test(g)){const w=this.a.get(g),S=w?.valuesSources??new Map;if(f)for(const C of Object.keys(a[g]))S.set(C,f);const m={...w?.value||{},...a[g]};this.a.set(g,{source:f,value:m,valuesSources:S});const E=(0,M.$aj)(g),D={type:"object",default:m,description:R.localize(1,null,E),$ref:e.$oo,defaultDefaultValue:m,source:O.$9f(f)?void 0:f,defaultValueSource:f};r.push(...l(g)),this.d[g]=D,this.b.properties[g]=D}else{this.a.set(g,{value:a[g],source:f});const w=this.d[g];w&&(this.w(g,w),this.r(g,w))}this.m(r)}deregisterDefaultConfigurations(t){const c=new Set;this.l(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}l(t,c){for(const{overrides:r,source:a}of t)for(const f in r){const g=this.a.get(f),w=O.$9f(a)?a:a?.id,S=O.$9f(g?.source)?g?.source:g?.source?.id;if(w===S)if(c.add(f),this.a.delete(f),e.$ro.test(f))delete this.d[f],delete this.b.properties[f];else{const m=this.d[f];m&&(this.w(f,m),this.r(f,m))}}this.u()}deltaConfiguration(t){let c=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),c=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),c=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:c})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const c of t)this.h.add(c);this.u()}n(t,c,r){t.forEach(a=>{this.p(a,c,a.extensionInfo,a.restrictedProperties,void 0,r),this.c.push(a),this.q(a)})}o(t,c){const r=a=>{if(a.properties)for(const f in a.properties){c.add(f);const g=this.d[f];g?.policy?.name&&this.e.delete(g.policy.name),delete this.d[f],this.s(f,a.properties[f])}a.allOf?.forEach(f=>r(f))};for(const a of t){r(a);const f=this.c.indexOf(a);f!==-1&&this.c.splice(f,1)}}p(t,c=!0,r,a,f=3,g){f=O.$fg(t.scope)?f:t.scope;const w=t.properties;if(w)for(const m in w){const E=w[m];if(c&&i(m,E)){delete w[m];continue}if(E.source=r,E.defaultDefaultValue=w[m].default,this.w(m,E),e.$ro.test(m)?E.scope=void 0:(E.scope=O.$fg(E.scope)?f:E.scope,E.restricted=O.$fg(E.restricted)?!!a?.includes(m):E.restricted),w[m].hasOwnProperty("included")&&!w[m].included){this.f[m]=w[m],delete w[m];continue}else this.d[m]=w[m],w[m].policy?.name&&this.e.set(w[m].policy.name,m);!w[m].deprecationMessage&&w[m].markdownDeprecationMessage&&(w[m].deprecationMessage=w[m].markdownDeprecationMessage),g.add(m)}const S=t.allOf;if(S)for(const m of S)this.p(m,c,r,a,f,g)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const c=r=>{const a=r.properties;if(a)for(const g in a)this.r(g,a[g]);r.allOf?.forEach(c)};c(t)}r(t,c){switch(e.$io.properties[t]=c,c.scope){case 1:e.$jo.properties[t]=c;break;case 2:e.$ko.properties[t]=c;break;case 6:e.$lo.properties[t]=c;break;case 3:e.$mo.properties[t]=c;break;case 4:e.$no.properties[t]=c;break;case 5:e.$no.properties[t]=c,this.g.properties[t]=c;break}}s(t,c){switch(delete e.$io.properties[t],c.scope){case 1:delete e.$jo.properties[t];break;case 2:delete e.$ko.properties[t];break;case 6:delete e.$lo.properties[t];break;case 3:delete e.$mo.properties[t];break;case 4:case 5:delete e.$no.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const c=`[${t}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$oo};this.w(c,r),e.$io.properties[c]=r,e.$jo.properties[c]=r,e.$ko.properties[c]=r,e.$lo.properties[c]=r,e.$mo.properties[c]=r,e.$no.properties[c]=r}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$oo};e.$io.patternProperties[e.$qo]=t,e.$jo.patternProperties[e.$qo]=t,e.$ko.patternProperties[e.$qo]=t,e.$lo.patternProperties[e.$qo]=t,e.$mo.patternProperties[e.$qo]=t,e.$no.patternProperties[e.$qo]=t,this.i.fire()}w(t,c){const r=this.a.get(t);let a=r?.value,f=r?.source;O.$dg(a)&&(a=c.defaultDefaultValue,f=void 0),O.$dg(a)&&(a=o(c.type)),c.default=a,c.defaultValueSource=f}}const y="\\[([^\\]]+)\\]",v=new RegExp(y,"g");e.$qo=`^(${y})+$`,e.$ro=new RegExp(e.$qo);function l(s){const t=[];if(e.$ro.test(s)){let c=v.exec(s);for(;c?.length;){const r=c[1].trim();r&&t.push(r),c=v.exec(s)}}return(0,h.$Mb)(t)}function d(s){return s.reduce((t,c)=>`${t}[${c}]`,"")}function o(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new p;$.$co.add(e.$ho.Configuration,n);function i(s,t){return s.trim()?e.$ro.test(s)?R.localize(7,null,s):n.getConfigurationProperties()[s]!==void 0?R.localize(8,null,s):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,s,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}function u(){const s=[],t=n.getConfigurationProperties();for(const c of Object.keys(t))s.push([c,t[c].scope]);return s.push(["launch",4]),s.push(["task",4]),s}}),define(Se[270],De([1,0,19,4,166,3,27,24,18,2,55,66,36]),function(he,e,h,N,O,R,M,b,$,k,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Ao=e.$zo=e.$yo=e.$xo=void 0,e.$Bo=i;function y(c){return Object.isFrozen(c)?c:b.$4n(c)}class v{static createEmptyModel(r){return new v({},[],[],void 0,r)}constructor(r,a,f,g,w){this.b=r,this.c=a,this.d=f,this.raw=g,this.f=w,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(a=>{if(a instanceof v)return a;const f=new l("",this.f);return f.parseRaw(a),f.configurationModel});this.g=r.reduce((a,f)=>f===a?f:a.merge(f),r[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,A.$$i)(this.contents,r):this.contents}inspect(r,a){const f=this;return{get value(){return y(f.rawConfiguration.getValue(r))},get override(){return a?y(f.rawConfiguration.getOverrideValue(r,a)):void 0},get merged(){return y(a?f.rawConfiguration.override(a).getValue(r):f.rawConfiguration.getValue(r))},get overrides(){const g=[];for(const{contents:w,identifiers:S,keys:m}of f.rawConfiguration.overrides){const E=new v(w,m,[],void 0,f.f).getValue(r);E!==void 0&&g.push({identifiers:S,value:E})}return g.length?y(g):void 0}}}getOverrideValue(r,a){const f=this.j(a);return f?r?(0,A.$$i)(f,r):f:void 0}getKeysForOverrideIdentifier(r){const a=[];for(const f of this.overrides)f.identifiers.includes(r)&&a.push(...f.keys);return h.$Mb(a)}getAllOverrideIdentifiers(){const r=[];for(const a of this.overrides)r.push(...a.identifiers);return h.$Mb(r)}override(r){let a=this.a.get(r);return a||(a=this.h(r),this.a.set(r,a)),a}merge(...r){const a=b.$3n(this.contents),f=b.$3n(this.overrides),g=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const S of r)if(w.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.i(a,S.contents);for(const m of S.overrides){const[E]=f.filter(D=>h.$ub(D.identifiers,m.identifiers));E?(this.i(E.contents,m.contents),E.keys.push(...m.keys),E.keys=h.$Mb(E.keys)):f.push(b.$3n(m))}for(const m of S.keys)g.indexOf(m)===-1&&g.push(m)}return new v(a,g,f,w.every(S=>S instanceof v)?void 0:w,this.f)}h(r){const a=this.j(r);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const f={};for(const g of h.$Mb([...Object.keys(this.contents),...Object.keys(a)])){let w=this.contents[g];const S=a[g];S&&(typeof w=="object"&&typeof S=="object"?(w=b.$3n(w),this.i(w,S)):w=S),f[g]=w}return new v(f,this.keys,this.overrides,void 0,this.f)}i(r,a){for(const f of Object.keys(a)){if(f in r&&$.$$f(r[f])&&$.$$f(a[f])){this.i(r[f],a[f]);continue}r[f]=b.$3n(a[f])}}j(r){let a=null,f=null;const g=w=>{w&&(f?this.i(f,w):f=b.$3n(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===r?a=w.contents:w.identifiers.includes(r)&&g(w.contents);return g(a),f}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,a){this.k(r,a,!0)}setValue(r,a){this.k(r,a,!1)}removeValue(r){const a=this.keys.indexOf(r);a!==-1&&(this.keys.splice(a,1),(0,A.$0i)(this.contents,r),I.$ro.test(r)&&this.overrides.splice(this.overrides.findIndex(f=>h.$ub(f.identifiers,(0,I.$so)(r))),1))}k(r,a,f){(0,A.$9i)(this.contents,r,a,g=>this.f.error(g)),f=f||this.keys.indexOf(r)===-1,f&&this.keys.push(r),I.$ro.test(r)&&this.overrides.push({identifiers:(0,I.$so)(r),keys:Object.keys(this.contents[r]),contents:(0,A.$8i)(this.contents[r],g=>this.f.error(g))})}}e.$xo=v;class l{constructor(r,a){this.f=r,this.g=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||v.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,a){if(!$.$fg(r)){const f=this.h(r);this.parseRaw(f,a)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,a){this.a=r;const{contents:f,keys:g,overrides:w,restricted:S,hasExcludedProperties:m}=this.i(r,a);this.b=new v(f,g,w,m?[r]:void 0,this.g),this.c=S||[]}h(r){let a={},f=null,g=[];const w=[],S=[];function m(D){Array.isArray(g)?g.push(D):f!==null&&(g[f]=D)}const E={onObjectBegin:()=>{const D={};m(D),w.push(g),g=D,f=null},onObjectProperty:D=>{f=D},onObjectEnd:()=>{g=w.pop()},onArrayBegin:()=>{const D=[];m(D),w.push(g),g=D,f=null},onArrayEnd:()=>{g=w.pop()},onLiteralValue:m,onError:(D,C,P)=>{S.push({error:D,offset:C,length:P})}};if(r)try{O.$Qn(r,E),a=g[0]||{}}catch(D){this.g.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return a}i(r,a){const f=p.$co.as(I.$ho.Configuration).getConfigurationProperties(),g=this.j(r,f,!0,a);r=g.raw;const w=(0,A.$8i)(r,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`)),S=Object.keys(r),m=this.l(r,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:w,keys:S,overrides:m,restricted:g.restricted,hasExcludedProperties:g.hasExcludedProperties}}j(r,a,f,g){let w=!1;if(!g?.scopes&&!g?.skipRestricted&&!g?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:w};const S={},m=[];for(const E in r)if(I.$ro.test(E)&&f){const D=this.j(r[E],a,!1,g);S[E]=D.raw,w=w||D.hasExcludedProperties,m.push(...D.restricted)}else{const D=a[E],C=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&m.push(E),!g.exclude?.includes(E)&&(g.include?.includes(E)||(C===void 0||g.scopes===void 0||g.scopes.includes(C))&&!(g.skipRestricted&&D?.restricted))?S[E]=r[E]:w=!0}return{raw:S,restricted:m,hasExcludedProperties:w}}l(r,a){const f=[];for(const g of Object.keys(r))if(I.$ro.test(g)){const w={};for(const S in r[g])w[S]=r[g][S];f.push({identifiers:(0,I.$so)(g),keys:Object.keys(w),contents:(0,A.$8i)(w,a)})}return f}}e.$yo=l;class d extends R.$Uc{constructor(r,a,f,g,w){super(),this.c=r,this.f=a,this.g=g,this.h=w,this.b=this.B(new N.$de),this.onDidChange=this.b.event,this.a=new l(this.c.toString(),w),this.B(this.g.watch(f.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&f.isEqual(S.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return v.createEmptyModel(this.h)}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$zo=d;class o{constructor(r,a,f,g,w,S,m,E,D,C,P,F,T){this.a=r,this.b=a,this.c=f,this.overrideIdentifiers=g,this.d=w,this.f=S,this.g=m,this.h=E,this.i=D,this.j=C,this.k=P,this.l=F,this.m=T}get value(){return y(this.c)}n(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(r,a,f,g,w,S,m,E,D,C){this.j=r,this.l=a,this.m=f,this.n=g,this.p=w,this.q=S,this.r=m,this.s=E,this.t=D,this.u=C,this.h=null,this.i=new M.$Ac,this.v=null}getValue(r,a,f){return this.w(r,a,f).getValue(r)}updateValue(r,a,f={}){let g;f.resource?(g=this.t.get(f.resource),g||(g=v.createEmptyModel(this.u),this.t.set(f.resource,g))):g=this.s,a===void 0?g.removeValue(r):g.setValue(r,a),f.resource||(this.h=null)}inspect(r,a,f){const g=this.w(r,a,f),w=this.A(a.resource,f),S=a.resource?this.t.get(a.resource)||this.s:this.s,m=new Set;for(const E of g.overrides)for(const D of E.identifiers)g.getOverrideValue(r,D)!==void 0&&m.add(D);return new o(r,a,g.getValue(r),m.size?[...m]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,f?this.q:void 0,w||void 0,S)}keys(r){const a=this.A(void 0,r);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:a?a.keys.slice(0):[]}}updateDefaultConfiguration(r){this.j=r,this.h=null,this.i.clear()}updatePolicyConfiguration(r){this.l=r}updateApplicationConfiguration(r){this.m=r,this.h=null,this.i.clear()}updateLocalUserConfiguration(r){this.n=r,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(r){this.p=r,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(r){this.q=r,this.h=null,this.i.clear()}updateFolderConfiguration(r,a){this.r.set(r,a),this.i.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.i.delete(r)}compareAndUpdateDefaultConfiguration(r,a){const f=[];if(!a){const{added:g,updated:w,removed:S}=s(this.j,r);a=[...g,...w,...S]}for(const g of a)for(const w of(0,I.$so)(g)){const S=this.j.getKeysForOverrideIdentifier(w),m=r.getKeysForOverrideIdentifier(w),E=[...m.filter(D=>S.indexOf(D)===-1),...S.filter(D=>m.indexOf(D)===-1),...S.filter(D=>!b.$7n(this.j.override(w).getValue(D),r.override(w).getValue(D)))];f.push([w,E])}return this.updateDefaultConfiguration(r),{keys:a,overrides:f}}compareAndUpdatePolicyConfiguration(r){const{added:a,updated:f,removed:g}=s(this.l,r),w=[...a,...f,...g];return w.length&&this.updatePolicyConfiguration(r),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:a,updated:f,removed:g,overrides:w}=s(this.applicationConfiguration,r),S=[...a,...f,...g];return S.length&&this.updateApplicationConfiguration(r),{keys:S,overrides:w}}compareAndUpdateLocalUserConfiguration(r){const{added:a,updated:f,removed:g,overrides:w}=s(this.localUserConfiguration,r),S=[...a,...f,...g];return S.length&&this.updateLocalUserConfiguration(r),{keys:S,overrides:w}}compareAndUpdateRemoteUserConfiguration(r){const{added:a,updated:f,removed:g,overrides:w}=s(this.remoteUserConfiguration,r),S=[...a,...f,...g];return S.length&&this.updateRemoteUserConfiguration(r),{keys:S,overrides:w}}compareAndUpdateWorkspaceConfiguration(r){const{added:a,updated:f,removed:g,overrides:w}=s(this.workspaceConfiguration,r),S=[...a,...f,...g];return S.length&&this.updateWorkspaceConfiguration(r),{keys:S,overrides:w}}compareAndUpdateFolderConfiguration(r,a){const f=this.folderConfigurations.get(r),{added:g,updated:w,removed:S,overrides:m}=s(f,a),E=[...g,...w,...S];return(E.length||!f)&&this.updateFolderConfiguration(r,a),{keys:E,overrides:m}}compareAndDeleteFolderConfiguration(r){const a=this.folderConfigurations.get(r);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:f,updated:g,removed:w,overrides:S}=s(a,void 0);return{keys:[...f,...g,...w],overrides:S}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(r,a,f){let g=this.x(a,f);return a.overrideIdentifier&&(g=g.override(a.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(r)!==void 0&&(g=g.merge(this.l)),g}x({resource:r},a){let f=this.y();if(a&&r){const g=a.getFolder(r);g&&(f=this.z(g.uri)||f);const w=this.t.get(r);w&&(f=f.merge(w))}return f}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(r){let a=this.i.get(r);if(!a){const f=this.y(),g=this.r.get(r);g?(a=f.merge(g),this.i.set(r,a)):a=f}return a}A(r,a){if(a&&r){const f=a.getFolder(r);if(f)return this.r.get(f.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((r,a)=>{const{contents:f,overrides:g,keys:w}=this.r.get(a);return r.push([a,{contents:f,overrides:g,keys:w}]),r},[])}}allKeys(){const r=new Set;return this.j.keys.forEach(a=>r.add(a)),this.userConfiguration.keys.forEach(a=>r.add(a)),this.q.keys.forEach(a=>r.add(a)),this.r.forEach(a=>a.keys.forEach(f=>r.add(f))),[...r.values()]}B(){const r=new Set;return this.j.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.userConfiguration.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.q.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.r.forEach(a=>a.getAllOverrideIdentifiers().forEach(f=>r.add(f))),[...r.values()]}D(r){const a=new Set;return this.j.getKeysForOverrideIdentifier(r).forEach(f=>a.add(f)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(f=>a.add(f)),this.q.getKeysForOverrideIdentifier(r).forEach(f=>a.add(f)),this.r.forEach(f=>f.getKeysForOverrideIdentifier(r).forEach(g=>a.add(g))),[...a.values()]}static parse(r,a){const f=this.E(r.defaults,a),g=this.E(r.policy,a),w=this.E(r.application,a),S=this.E(r.user,a),m=this.E(r.workspace,a),E=r.folders.reduce((D,C)=>(D.set(k.URI.revive(C[0]),this.E(C[1],a)),D),new M.$Ac);return new n(f,g,w,S,v.createEmptyModel(a),m,E,v.createEmptyModel(a),new M.$Ac,a)}static E(r,a){return new v(r.contents,r.keys,r.overrides,void 0,a)}}e.$Ao=n;function i(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const r=new Set,a=new Map;for(const g of c)g.keys.forEach(w=>r.add(w)),g.overrides.forEach(([w,S])=>{const m=(0,M.$xc)(a,w,new Set);S.forEach(E=>m.add(E))});const f=[];return a.forEach((g,w)=>f.push([w,[...g.values()]])),{keys:[...r.values()],overrides:f}}class u{constructor(r,a,f,g,w){this.change=r,this.f=a,this.g=f,this.h=g,this.i=w,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const S of r.keys)this.affectedKeys.add(S);for(const[,S]of r.overrides)for(const m of S)this.affectedKeys.add(m);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(r,a){const f=this.a+r,g=this.d.indexOf(f);if(g<0)return!1;const w=g+f.length;if(w>=this.d.length)return!1;const S=this.d.charCodeAt(w);if(S!==this.b&&S!==this.c)return!1;if(a){const m=this.previousConfiguration?this.previousConfiguration.getValue(r,a,this.f?.workspace):void 0,E=this.g.getValue(r,a,this.h);return!b.$7n(m,E)}return!0}}e.$Co=u;function s(c,r){const{added:a,removed:f,updated:g}=t(r?.rawConfiguration,c?.rawConfiguration),w=[],S=c?.getAllOverrideIdentifiers()||[],m=r?.getAllOverrideIdentifiers()||[];if(r){const E=m.filter(D=>!S.includes(D));for(const D of E)w.push([D,r.getKeysForOverrideIdentifier(D)])}if(c){const E=S.filter(D=>!m.includes(D));for(const D of E)w.push([D,c.getKeysForOverrideIdentifier(D)])}if(r&&c){for(const E of S)if(m.includes(E)){const D=t({contents:c.getOverrideValue(void 0,E)||{},keys:c.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});w.push([E,[...D.added,...D.removed,...D.updated]])}}return{added:a,removed:f,updated:g,overrides:w}}function t(c,r){const a=c?r?c.keys.filter(w=>r.keys.indexOf(w)===-1):[...c.keys]:[],f=r?c?r.keys.filter(w=>c.keys.indexOf(w)===-1):[...r.keys]:[],g=[];if(c&&r){for(const w of r.keys)if(c.keys.indexOf(w)!==-1){const S=(0,A.$$i)(r.contents,w),m=(0,A.$$i)(c.contents,w);b.$7n(S,m)||g.push(w)}}return{added:a,removed:f,updated:g}}}),define(Se[271],De([1,0,21,4,3,83]),function(he,e,h,N,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xvb=e.$vvb=e.$uvb=void 0,e.$wvb=b;const M=(k,A,I)=>{const p=new Uint8Array(16);for(let l=0;l<16;l++)p[l]=Math.round(Math.random()*256);const y=(0,h.$Ze)(h.$Fe.wrap(p));return[`GET ws://localhost${k}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`].join(`\r
`)+`\r
\r
`};e.$uvb=M,e.$vvb=h.$Fe.fromString(`\r
\r
`);async function b(k,A,I,p,y){k.write(h.$Fe.fromString((0,e.$uvb)(A,I,p)));const v=new O.$Tc;try{return await new Promise((l,d)=>{let o;v.add(k.onData(n=>{o?o=h.$Fe.concat([o,n],o.byteLength+n.byteLength):o=n;const i=o.indexOf(e.$vvb);if(i===-1)return;l(k),k.pauseData();const u=o.slice(i+e.$vvb.byteLength);u.byteLength&&y.onData.fire(u)})),v.add(k.onClose(n=>d(n??new Error("socket closed")))),v.add(k.onEnd(()=>d(new Error("socket ended"))))})}catch(l){throw k.dispose(),l}finally{v.dispose()}}class $ extends O.$Uc{constructor(A,I){super(),this.g=A,this.a=this.B(new N.$ge),this.onData=(...p)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...p)),this.b=this.B(new N.$de),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event(p=>this.a.fire(p))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,I){R.SocketDiagnostics.traceSocketEvent(this,this.g,A,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$xvb=$}),define(Se[67],De([1,0,13,5]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.RemoteAuthorityResolverErrorCode=e.$Jl=e.$Il=e.RemoteConnectionType=e.$Hl=void 0,e.$Ll=k,e.$Hl=(0,N.$wi)("remoteAuthorityResolverService");var O;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(O||(e.RemoteConnectionType=O={}));class R{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$Il=R;class M{constructor(I,p){this.host=I,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Jl=M;var b;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class $ extends h.$bb{static isNotAvailable(I){return I instanceof $&&I._code===b.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof $&&I._code===b.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof $&&I._code===b.NoResolverFound}static isInvalidAuthority(I){return I instanceof $&&I._code===b.InvalidAuthority}static isHandled(I){return I instanceof $&&I.isHandled}constructor(I,p=b.Unknown,y){super(I),this._message=I,this._code=p,this._detail=y,this.isHandled=p===b.NotAvailable&&y===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Kl=$;function k(A){const I=A.indexOf("+");return I===-1?A:A.substring(0,I)}}),define(Se[272],De([1,0,7,21,22,13,4,3,15,59,40,30,83,67]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Ql=S,e.$Rl=m,e.$Sl=D;const v=30*1e3;var l;(function(ee){ee[ee.Management=1]="Management",ee[ee.ExtensionHost=2]="ExtensionHost",ee[ee.Tunnel=3]="Tunnel"})(l||(e.ConnectionType=l={}));function d(ee){switch(ee){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(ee){const B=new O.$oe;return setTimeout(()=>B.cancel(),ee),B.token}function n(ee,B){if(ee.isCancellationRequested||B.isCancellationRequested)return O.CancellationToken.Cancelled;const _=new O.$oe;return ee.onCancellationRequested(()=>_.cancel()),B.onCancellationRequested(()=>_.cancel()),_.token}class i{get didTimeout(){return this.c==="timedout"}constructor(B){this.c="pending",this.d=new b.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,h.$ph)(),B.isCancellationRequested?this.h():this.d.add(B.onCancellationRequested(()=>this.h()))}registerDisposable(B){this.c==="pending"?this.d.add(B):B.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(B))}reject(B){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(B))}}function u(ee,B){const _=new i(B);return _.registerDisposable(ee.onControlMessage(pe=>{const ue=JSON.parse(pe.toString()),ce=G(ue);ce?_.reject(ce):_.resolve(ue)})),_.promise}function s(ee,B,_,pe,ue,ce,oe,le){const K=new i(le),se=A.$_d.create(!1);return ee.info(`Creating a socket (${oe})...`),k.mark(`code/willCreateSocket/${ce}`),B.connect(_,pe,ue,oe).then($e=>{K.didTimeout?(k.mark(`code/didCreateSocketError/${ce}`),ee.info(`Creating a socket (${oe}) finished after ${se.elapsed()} ms, but this is too late and has timed out already.`),$e?.dispose()):(k.mark(`code/didCreateSocketOK/${ce}`),ee.info(`Creating a socket (${oe}) was successful after ${se.elapsed()} ms.`),K.resolve($e))},$e=>{k.mark(`code/didCreateSocketError/${ce}`),ee.info(`Creating a socket (${oe}) returned an error after ${se.elapsed()} ms.`),ee.error($e),K.reject($e)}),K.promise}function t(ee,B){const _=new i(B);return ee.then(pe=>{_.didTimeout||_.resolve(pe)},pe=>{_.didTimeout||_.reject(pe)}),_.promise}async function c(ee,B,_,pe){const ue=ae(ee,B);ee.logService.trace(`${ue} 1/6. invoking socketFactory.connect().`);let ce;try{ce=await s(ee.logService,ee.remoteSocketFactoryService,ee.connectTo,$.$Jg.getServerRootPath(),`reconnectionToken=${ee.reconnectionToken}&reconnection=${ee.reconnectionProtocol?"true":"false"}`,d(B),`renderer-${d(B)}-${ee.reconnectionToken}`,pe)}catch($e){throw ee.logService.error(`${ue} socketFactory.connect() failed or timed out. Error:`),ee.logService.error($e),$e}ee.logService.trace(`${ue} 2/6. socketFactory.connect() was successful.`);let oe,le;ee.reconnectionProtocol?(ee.reconnectionProtocol.beginAcceptReconnection(ce,null),oe=ee.reconnectionProtocol,le=!1):(oe=new p.$ki({socket:ce}),le=!0),ee.logService.trace(`${ue} 3/6. sending AuthRequest control message.`);const K=await t(ee.signService.createNewMessage((0,I.$Sg)()),pe),se={type:"auth",auth:ee.connectionToken||"00000000000000000000",data:K.data};oe.sendControl(N.$Fe.fromString(JSON.stringify(se)));try{const $e=await u(oe,n(pe,o(1e4)));if($e.type!=="sign"||typeof $e.data!="string"){const Ae=new Error("Unexpected handshake message");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}if(ee.logService.trace(`${ue} 4/6. received SignRequest control message.`),!await t(ee.signService.validate(K,$e.signedData),pe)){const Ae=new Error("Refused to connect to unsupported server");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}const Me=await t(ee.signService.sign($e.data),pe),ge={type:"connectionType",commit:ee.commit,signedData:Me,desiredConnectionType:B};return _&&(ge.args=_),ee.logService.trace(`${ue} 5/6. sending ConnectionTypeRequest control message.`),oe.sendControl(N.$Fe.fromString(JSON.stringify(ge))),{protocol:oe,ownsProtocol:le}}catch($e){throw $e&&$e.code==="ETIMEDOUT"&&(ee.logService.error(`${ue} the handshake timed out. Error:`),ee.logService.error($e)),$e&&$e.code==="VSCODE_CONNECTION_ERROR"&&(ee.logService.error(`${ue} received error control message when negotiating connection. Error:`),ee.logService.error($e)),le&&q(oe),$e}}async function r(ee,B,_,pe){const ue=Date.now(),ce=ae(ee,B),{protocol:oe,ownsProtocol:le}=await c(ee,B,_,pe),K=new i(pe);return K.registerDisposable(oe.onControlMessage(se=>{const $e=JSON.parse(se.toString()),ve=G($e);ve?(ee.logService.error(`${ce} received error control message when negotiating connection. Error:`),ee.logService.error(ve),le&&q(oe),K.reject(ve)):(ee.reconnectionProtocol?.endAcceptReconnection(),ee.logService.trace(`${ce} 6/6. handshake finished, connection is up and running after ${Ie(ue)}!`),K.resolve({protocol:oe,firstMessage:$e}))})),K.promise}async function a(ee,B){const{protocol:_}=await r(ee,1,void 0,B);return{protocol:_}}async function f(ee,B,_){const{protocol:pe,firstMessage:ue}=await r(ee,2,B,_),ce=ue&&ue.debugPort;return{protocol:pe,debugPort:ce}}async function g(ee,B,_){const pe=Date.now(),ue=ae(ee,3),{protocol:ce}=await c(ee,3,B,_);return ee.logService.trace(`${ue} 6/6. handshake finished, connection is up and running after ${Ie(pe)}!`),ce}async function w(ee,B,_){const{connectTo:pe,connectionToken:ue}=await ee.addressProvider.getAddress();return{commit:ee.commit,quality:ee.quality,connectTo:pe,connectionToken:ue,reconnectionToken:B,reconnectionProtocol:_,remoteSocketFactoryService:ee.remoteSocketFactoryService,signService:ee.signService,logService:ee.logService}}async function S(ee,B,_){return E(ee,async pe=>{const{protocol:ue}=await a(pe,O.CancellationToken.None);return new X(ee,B,_,pe.reconnectionToken,ue)})}async function m(ee,B){return E(ee,async _=>{const{protocol:pe,debugPort:ue}=await f(_,B,O.CancellationToken.None);return new ie(ee,B,_.reconnectionToken,pe,ue)})}async function E(ee,B){for(let pe=1;;pe++)try{const ue=(0,I.$Sg)(),ce=await w(ee,ue,null);return await B(ce)}catch(ue){if(pe<5)ee.logService.error(`[remote-connection][attempt ${pe}] An error occurred in initial connection! Will retry... Error:`),ee.logService.error(ue);else throw ee.logService.error(`[remote-connection][attempt ${pe}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),ee.logService.error(ue),U.triggerPermanentFailure(0,0,y.$Kl.isHandled(ue)),ue}}async function D(ee,B,_){const pe=await w(ee,(0,I.$Sg)(),null);return await g(pe,{host:B,port:_},O.CancellationToken.None)}function C(ee){return(0,h.$jh)(B=>new Promise((_,pe)=>{const ue=setTimeout(_,ee*1e3);B.onCancellationRequested(()=>{clearTimeout(ue),_()})}))}var P;(function(ee){ee[ee.ConnectionLost=0]="ConnectionLost",ee[ee.ReconnectionWait=1]="ReconnectionWait",ee[ee.ReconnectionRunning=2]="ReconnectionRunning",ee[ee.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",ee[ee.ConnectionGain=4]="ConnectionGain"})(P||(e.PersistentConnectionEventType=P={}));class F{constructor(B,_){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.type=0}}e.$Tl=F;class T{constructor(B,_,pe,ue){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.durationSeconds=pe,this.c=ue,this.type=1}skipWait(){this.c.cancel()}}e.$Ul=T;class z{constructor(B,_,pe){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.attempt=pe,this.type=2}}e.$Vl=z;class L{constructor(B,_,pe){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.attempt=pe,this.type=4}}e.$Wl=L;class j{constructor(B,_,pe,ue){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.attempt=pe,this.handled=ue,this.type=3}}e.$Xl=j;class U extends b.$Uc{static triggerPermanentFailure(B,_,pe){this._permanentFailure=!0,this.f=B,this.g=_,this.h=pe,this.j.forEach(ue=>ue.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(B=>B.y())}static debugPauseSocketWriting(){this.j.forEach(B=>B.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||U._permanentFailure}constructor(B,_,pe,ue,ce){super(),this.t=B,this.u=_,this.reconnectionToken=pe,this.protocol=ue,this.w=ce,this.m=this.B(new M.$de),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new L(this.reconnectionToken,0,0)),this.B(ue.onSocketClose(oe=>{const le=be(this.t,this.reconnectionToken,!0);oe?oe.type===0?(this.u.logService.info(`${le} received socket close event (hadError: ${oe.hadError}).`),oe.error&&this.u.logService.error(oe.error)):(this.u.logService.info(`${le} received socket close event (wasClean: ${oe.wasClean}, code: ${oe.code}, reason: ${oe.reason}).`),oe.event&&this.u.logService.error(oe.event)):this.u.logService.info(`${le} received socket close event.`),this.y()})),this.B(ue.onSocketTimeout(oe=>{const le=be(this.t,this.reconnectionToken,!0);this.u.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${oe.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${oe.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${oe.timeSinceLastReceivedSomeData}).`),this.y()})),U.j.push(this),this.B((0,b.$Sc)(()=>{const oe=U.j.indexOf(this);oe>=0&&U.j.splice(oe,1)})),this.n&&this.D(U.f,U.g,U.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const B=be(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30];let pe=-1;do{pe++;const ue=pe<_.length?_[pe]:_[_.length-1];try{if(ue>0){const oe=C(ue);this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ue,oe)),this.u.logService.info(`${B} waiting for ${ue} seconds before reconnecting...`);try{await oe}catch{}}if(this.n){this.u.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),pe+1)),this.u.logService.info(`${B} resolving connection...`);const ce=await w(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${B} connecting to ${ce.connectTo}...`),await this.G(ce,o(v)),this.u.logService.info(`${B} reconnected!`),this.m.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),pe+1));break}catch(ce){if(ce.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ce),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,!1);break}if(pe>360){this.u.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ce),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,!1);break}if(y.$Kl.isTemporarilyNotAvailable(ce)){this.u.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ce);continue}if((ce.code==="ETIMEDOUT"||ce.code==="ENETUNREACH"||ce.code==="ECONNREFUSED"||ce.code==="ECONNRESET")&&ce.syscall==="connect"){this.u.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ce);continue}if((0,R.$4)(ce)){this.u.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ce);continue}if(ce instanceof y.$Kl){this.u.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ce),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,y.$Kl.isHandled(ce));break}this.u.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ce),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,!1);break}}while(!this.n&&!this.s)}C(B,_,pe){this.w?U.triggerPermanentFailure(B,_,pe):this.D(B,_,pe)}D(B,_,pe){this.m.fire(new j(this.reconnectionToken,B,_,pe)),q(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Yl=U;class X extends U{constructor(B,_,pe,ue,ce){super(1,B,ue,ce,!0),this.client=this.B(new p.$ii(ce,{remoteAuthority:_,clientId:pe},B.ipcLogger))}async G(B,_){await a(B,_)}}e.$Zl=X;class ie extends U{constructor(B,_,pe,ue,ce){super(2,B,pe,ue,!1),this.H=_,this.debugPort=ce}async G(B,_){await f(B,this.H,_)}}e.$1l=ie;function q(ee){try{ee.acceptDisconnect();const B=ee.getSocket();ee.dispose(),B.dispose()}catch(B){(0,R.$1)(B)}}function G(ee){if(ee&&ee.type==="error"){const B=new Error(`Connection error: ${ee.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function x(ee,B){for(;ee.length<B;)ee+=" ";return ee}function ne(ee,B){return`[remote-connection][${x(d(ee),13)}][${B.substr(0,5)}\u2026]`}function be(ee,B,_){return`${ne(ee,B)}[${_?"reconnect":"initial"}]`}function ae(ee,B){return`${be(B,ee.reconnectionToken,!!ee.reconnectionProtocol)}[${ee.connectTo}]`}function Ie(ee){return`${Date.now()-ee} ms`}}),define(Se[86],De([1,0,15]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=N,e.$Im=O,e.$Jm=R,e.$Km=M;function N($){return $.scheme===h.Schemas.vscodeRemote?$.authority:void 0}function O($){if(!$)return;const k=$.indexOf("+");return k<0?$:$.substr(0,k)}function R($){const{host:k,port:A}=b($);if(typeof A>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:k,port:A}}function M($,k){let{host:A,port:I}=b($);return typeof I>"u"&&(I=k),{host:A,port:I}}function b($){const k=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(k)return{host:k[1],port:parseInt(k[2],10)};const A=$.match(/^(\[[0-9a-z:]+\])$/);if(A)return{host:A[1],port:void 0};const I=$.match(/(.*):(\d+)$/);return I?{host:I[1],port:parseInt(I[2],10)}:{host:$,port:void 0}}}),define(Se[25],De([1,0,14,5,86]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Tm=e.$Sm=e.$Rm=e.TargetPlatform=e.ExtensionType=e.$Qm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0,e.$Pm=R,e.$Um=I,e.$Vm=p,e.$Wm=y,e.$Xm=v,e.$Lm="extensions.user.cache",e.$Mm="extensions.builtin.cache",e.$Nm="undefined_publisher",e.$Om=["ui","workspace","web"];function R(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.$Qm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var M;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(M||(e.ExtensionType=M={}));var b;(function(l){l.WIN32_X64="win32-x64",l.WIN32_ARM64="win32-arm64",l.LINUX_X64="linux-x64",l.LINUX_ARM64="linux-arm64",l.LINUX_ARMHF="linux-armhf",l.ALPINE_X64="alpine-x64",l.ALPINE_ARM64="alpine-arm64",l.DARWIN_X64="darwin-x64",l.DARWIN_ARM64="darwin-arm64",l.WEB="web",l.UNIVERSAL="universal",l.UNKNOWN="unknown",l.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class ${constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,o){if(typeof d>"u"||d===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof d=="string"||typeof o=="string"){const n=typeof d=="string"?d:d.value,i=typeof o=="string"?o:o.value;return h.$xf(n,i)}return d._lower===o._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.$Rm=$;class k{get size(){return this.c.size}constructor(d){if(this.c=new Set,d)for(const o of d)this.add(o)}add(d){this.c.add($.toKey(d))}delete(d){return this.c.delete($.toKey(d))}has(d){return this.c.has($.toKey(d))}}e.$Sm=k;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(d){this.c.delete($.toKey(d))}get(d){return this.c.get($.toKey(d))}has(d){return this.c.has($.toKey(d))}set(d,o){this.c.set($.toKey(d),o)}values(){return this.c.values()}forEach(d){this.c.forEach(d)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Tm=A;function I(l){return p(l)}function p(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}function y(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}function v(l,d){if(d){const o=`onResolveRemoteAuthority:${(0,O.$Im)(d)}`;return!!l.activationEvents?.includes(o)}return!1}e.$Ym=(0,N.$wi)("IBuiltinExtensionsScannerService")}),define(Se[140],De([1,0,13,25]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uG=e.$tG=void 0;class O{constructor(){this.a=new Map,this.b=new WeakMap}register(M,b){this.a.set(M,b)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const b=Object.create(null);for(const $ of M){const k=this.readActivationEvents($);k.length>0&&(b[N.$Rm.toKey($.identifier)]=k)}return b}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const b=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let $=0;$<b.length;$++)b[$]==="onUri"&&(b[$]=`onUri:${N.$Rm.toKey(M.identifier)}`);if(!M.contributes)return b;for(const $ in M.contributes){const k=this.a.get($);if(!k)continue;const A=M.contributes[$],I=Array.isArray(A)?A:[A];try{k(I,b)}catch(p){(0,h.$1)(p)}}return b}}e.$tG=O,e.$uG=new O}),define(Se[273],De([1,0,3,5]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=void 0,e.$Ml=(0,N.$wi)("remoteSocketFactoryService");class O{constructor(){this.a={}}register(M,b){return this.a[M]??=[],this.a[M].push(b),(0,h.$Sc)(()=>{const $=this.a[M]?.indexOf(b);typeof $=="number"&&$>=0&&this.a[M]?.splice($,1)})}b(M){return(this.a[M.type]||[]).find($=>$.supports(M))}connect(M,b,$,k){const A=this.b(M);if(!A)throw new Error(`No socket factory found for ${M}`);return A.connect(M,b,$,k)}}e.$Nl=O}),define(Se[274],De([1,0,21,13,3,220,66,5,11,36]),function(he,e,h,N,O,R,M,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=void 0,e.$Pp=p,e.$Qp=y,e.$Rp=v,e.$Sp=l,e.$Tp=d,e.$Up=o,e.$Np=(0,b.$wi)("requestService");class A{constructor(s){this.b=s}toJSON(){if(!this.a){const s=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?s[t]="*****":s[t]=this.b[t];this.a=s}return this.a}}class I extends O.$Uc{constructor(s){super(),this.b=0,this.a=s.createLogger("network",{name:(0,R.localize)(0,null),when:$.$ik.isEqualTo((0,$.$fk)($.LogLevel.Trace)).serialize()})}async c(s,t,c){const r=`${s} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new A(t.headers??{}));try{const a=await c();return this.a.trace(`${r} - end`,t.type,a.res.statusCode,a.res.headers),a}catch(a){throw this.a.error(`${r} - error`,t.type,(0,N.$0)(a)),a}}}e.$Op=I;function p(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}function y(u){return u.res.statusCode===204}async function v(u){return y(u)?null:(await(0,h.$Re)(u.stream)).toString()}async function l(u){if(!p(u))throw new Error("Server returned "+u.res.statusCode);return v(u)}async function d(u){if(!p(u))throw new Error("Server returned "+u.res.statusCode);if(y(u))return null;const t=(await(0,h.$Re)(u.stream)).toString();try{return JSON.parse(t)}catch(c){throw c.message+=`:
`+t,c}}function o(u){i(u)}let n;function i(u){const s=k.$co.as(M.$ho.Configuration),t=n;n={id:"http",order:15,title:(0,R.localize)(1,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(6,null),(0,R.localize)(7,null),(0,R.localize)(8,null),(0,R.localize)(9,null)],default:"override",description:(0,R.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(12,null),restricted:!0}}},s.updateConfigurations({add:[n],remove:t?[t]:[]})}i(1)}),define(Se[275],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7$b=void 0;class h{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(O){try{const R=await this.c();if(R){const M=String(h.a++);return this.b.set(M,R),{id:M,data:R.createNewMessage(O)}}}catch{}return{id:"",data:O}}async validate(O,R){if(!O.id)return!0;const M=this.b.get(O.id);if(!M)return!1;this.b.delete(O.id);try{return M.validate(R)==="ok"}catch{return!1}finally{M.dispose?.()}}async sign(O){try{return await this.d(O)}catch{}return O}}e.$7$b=h}),define(Se[111],De([1,0,5]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=void 0,e.$Ol="signService",e.$Pl=(0,h.$wi)(e.$Ol)}),define(Se[141],De([1,0,275]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=void 0;class N extends h.$7$b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(M=>new M.signer().sign(R))}h(){return new Promise((R,M)=>he(["vsda"],R,M))}}e.$3dc=N}),define(Se[276],De([1,0,12,52,30]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=M,e.$ep=b;function R($){if(h.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function M($,k,A,I,p,y,v,l,d){const o=Object.create(null);o["common.machineId"]=y,o["common.sqmId"]=v,o.sessionID=(0,O.$Sg)()+Date.now(),o.commitHash=I,o.version=p,o["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,h.$h)(h.$u),o["common.nodePlatform"]=N.$dc,o["common.nodeArch"]=A,o["common.product"]=d||"desktop",l&&(o["common.msftInternal"]=l);let n=0;const i=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),h.$l&&(o["common.snap"]="true");const u=R(k);return u&&(o["common.platformDetail"]=u),o}function b($){const k=N.env.USERDNSDOMAIN;if(!k)return!1;const A=k.toLowerCase();return $.some(I=>A===I)}}),define(Se[277],De([1,0,5]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=void 0,e.$2l=(0,h.$wi)("telemetryService"),e.$3l=(0,h.$wi)("customEndpointTelemetryService"),e.$4l="telemetry.currentSessionDate",e.$5l="telemetry.firstSessionDate",e.$6l="telemetry.lastSessionDate",e.$7l="telemetry.machineId",e.$8l="telemetry.sqmId",e.$9l="telemetry",e.$0l="telemetry.telemetryLevel",e.$$l="telemetry.enableCrashReporter",e.$_l="telemetry.enableTelemetry";var N;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var O;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(O||(e.TelemetryConfiguration=O={}))}),define(Se[87],De([1,0,24,18,86,276,277]),function(he,e,h,N,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=void 0,e.$mp=A,e.$np=I,e.$op=p,e.$pp=y,e.$qp=l,e.$rp=o,e.$sp=n,e.$tp=s;class b{constructor(c){this.value=c,this.isTrustedTelemetryValue=!0}}e.$fp=b;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$gp=$,e.$hp=new $;class k{async publicLog(c,r,a){}async publicLogError(c,r,a){}}e.$ip=k,e.$jp="telemetry",e.$kp="extensionTelemetryLog",e.$lp={log:()=>null,flush:()=>Promise.resolve(null)};function A(t,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!t.enableTelemetry)}function I(t,c){return c.extensionTestsLocationURI?!0:!(c.isBuilt||c.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function p(t){const c=t.getValue(M.$0l),r=t.getValue(M.$$l);if(t.getValue(M.$_l)===!1||r===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function y(t){const c={},r={},a={};d(t,a);for(let f in a){f=f.length>150?f.substr(f.length-149):f;const g=a[f];typeof g=="number"?r[f]=g:typeof g=="boolean"?r[f]=g?1:0:typeof g=="string"?(g.length>8192&&console.warn(`Telemetry property: ${f} has been trimmed to 8192, the original length is ${g.length}`),c[f]=g.substring(0,8191)):typeof g<"u"&&g!==null&&(c[f]=g)}return{properties:c,measurements:r}}const v=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function l(t){if(!t)return"none";const c=(0,O.$Im)(t);return v.has(c)?c:"other"}function d(t,c,r=0,a){if(t)for(const f of Object.getOwnPropertyNames(t)){const g=t[f],w=a?a+f:f;Array.isArray(g)?c[w]=(0,h.$8n)(g):g instanceof Date?c[w]=g.toISOString():(0,N.$$f)(g)?r<2?d(g,c,r+1,w+"."):c[w]=(0,h.$8n)(g):c[w]=g}}function o(t,c){const r=t.msftInternalDomains||[],a=c.getValue("telemetry.internalTesting");return(0,R.$ep)(r)||a}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,c){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const a=[];for(const S of c)for(;;){const m=S.exec(t);if(!m)break;a.push([m.index,S.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,g=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(r="";;){const S=g.exec(t);if(!S)break;const m=a.some(([E,D])=>S.index<D&&E<g.lastIndex);!f.test(S[0])&&!m&&(r+=t.substring(w,S.index)+"<REDACTED: user-file-path>",w=g.lastIndex)}return w<t.length&&(r+=t.substr(w)),r}function u(t){if(!t)return t;const c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of c)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function s(t,c){return(0,h.$5n)(t,r=>{if(r instanceof b||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let a=r.replaceAll("%20"," ");a=i(a,c);for(const f of c)a=a.replace(f,"");return a=u(a),a}})}}),define(Se[278],De([1,0,14,138,25,12,2,13,52,87]),function(he,e,h,N,O,R,M,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$vp=void 0,e.$up=A,e.$wp=v,e.$xp=l,e.$yp=d,e.$zp=o,e.$Ap=n,e.$Bp=i,e.$Cp=u,e.$Ep=s,e.$Fp=c;function A(r,a){return r.uuid&&a.uuid?r.uuid===a.uuid:r.id===a.id?!0:(0,h.$sf)(r.id,a.id)===0}const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(a){const f=a.manifest?a.manifest.version:a.version,g=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new p(a.identifier,f,g)}static parse(a){const f=I.exec(a);return f&&f[1]&&f[2]?new p({id:f[1]},f[2],f[4]||void 0):null}constructor(a,f,g="undefined"){this.version=f,this.targetPlatform=g,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof p?A(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.$vp=p;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(r){const a=y.exec(r);return a&&a[1]?[d(a[1]),a[2]]:[d(r),void 0]}function l(r,a){return`${r}.${a}`}function d(r){return r.toLowerCase()}function o(r,a){return d(l(r??O.$Nm,a))}function n(r,a){const f=[],g=w=>{for(const S of f)if(S.some(m=>A(a(m),a(w))))return S;return null};for(const w of r){const S=g(w);S?S.push(w):f.push([w])}return f}function i(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function u(r){return{id:new k.$fp(r.identifier.id),name:new k.$fp(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Dp=new O.$Rm("pprice.better-merge");function s(r,a){const f=[],g=a.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const w=g.shift();if(w&&f.every(S=>!A(S.identifier,{id:w}))){const S=r.filter(m=>A(m.identifier,{id:w}));S.length===1&&(f.push(S[0]),g.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return f}async function t(r,a){if(!R.$k)return!1;let f;try{f=(await r.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{f=(await r.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(w){a.debug("Error while getting the os-release file.",(0,b.$0)(w))}}return!!f&&(f.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function c(r,a){const f=await t(r,a),g=(0,N.$2o)(f?"alpine":R.$u,$.$ec);return a.debug("ComputeTargetPlatform:",g),g}}),define(Se[279],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=h,e.$ms=N,e.$ns=O,e.$os=R,e.$ps=M,e.$qs=b;function h($){return[...$.entries()]}function N($){return $?[...$.entries()]:[]}function O($){return new Map($)}function R($){return new Map($??[])}function M($){return Array.from($.entries()).map(k=>[k[0],h(k[1].map),N(k[1].descriptionMap)])}function b($){return new Map($.map(k=>[k[0],{map:O(k[1]),descriptionMap:R(k[2])}]))}}),define(Se[280],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pvb=void 0;class h{constructor(O){this.b=O,this.a=new Map}dispose(){for(const O of this.a.values())O.dispose()}startBuffering(O,R,M=5){const b=R($=>{const k=typeof $=="string"?$:$.data;let A=this.a.get(O);if(A){A.data.push(k);return}const I=setTimeout(()=>this.flushBuffer(O),M);A={data:[k],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(O),b.dispose()}},this.a.set(O,A)});return b}stopBuffering(O){this.a.get(O)?.dispose()}flushBuffer(O){const R=this.a.get(O);R&&(this.a.delete(O),this.b(O,R.data.join("")))}}e.$Pvb=h}),define(Se[281],De([1,0,7,79,99,50,4,18,2,221,110,36]),function(he,e,h,N,O,R,M,b,$,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mx=e.$lx=e.$kx=e.$jx=e.$ix=e.$hx=e.IconFontDefinition=e.IconContribution=e.$ex=void 0,e.$fx=d,e.$gx=o,e.$ex={IconContribution:"base.contributions.icons"};var p;(function(s){function t(c,r){let a=c.defaults;for(;R.ThemeIcon.isThemeIcon(a);){const f=l.getIcon(a.id);if(!f)return;a=f.defaults}return a}s.getDefinition=t})(p||(e.IconContribution=p={}));var y;(function(s){function t(r){return{weight:r.weight,style:r.style,src:r.src.map(a=>({format:a.format,location:a.location.toString()}))}}s.toJSONObject=t;function c(r){const a=f=>(0,b.$9f)(f)?f:void 0;if(r&&Array.isArray(r.src)&&r.src.every(f=>(0,b.$9f)(f.format)&&(0,b.$9f)(f.location)))return{weight:a(r.weight),style:a(r.style),src:r.src.map(f=>({format:f.format,location:$.URI.parse(f.location)}))}}s.fromJSONObject=c})(y||(e.IconFontDefinition=y={}));class v{constructor(){this.a=new M.$de,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,c,r,a){const f=this.b[t];if(f){if(r&&!f.description){f.description=r,this.d.properties[t].markdownDescription=`${r} $(${t})`;const S=this.e.enum.indexOf(t);S!==-1&&(this.e.enumDescriptions[S]=r),this.a.fire()}return f}const g={id:t,description:r,defaults:c,deprecationMessage:a};this.b[t]=g;const w={$ref:"#/definitions/icons"};return a&&(w.deprecationMessage=a),r&&(w.markdownDescription=`${r}: $(${t})`),this.d.properties[t]=w,this.e.enum.push(t),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const c=this.e.enum.indexOf(t);c!==-1&&(this.e.enum.splice(c,1),this.e.enumDescriptions.splice(c,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,c){const r=this.f[t];return r||(this.f[t]=c,this.a.fire(),c)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(f,g)=>f.id.localeCompare(g.id),c=f=>{for(;R.ThemeIcon.isThemeIcon(f.defaults);)f=this.b[f.defaults.id];return`codicon codicon-${f?f.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.b).map(f=>this.b[f]);for(const f of a.filter(g=>!!g.description).sort(t))r.push(`|<i class="${c(f)}"></i>|${f.id}|${R.ThemeIcon.isThemeIcon(f.defaults)?f.defaults.id:f.id}|${f.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const f of a.filter(g=>!R.ThemeIcon.isThemeIcon(g.defaults)).sort(t))r.push(`|<i class="${c(f)}"></i>|${f.id}|`);return r.join(`
`)}}const l=new v;I.$co.add(e.$ex.IconContribution,l);function d(s,t,c,r){return l.registerIcon(s,t,c,r)}function o(){return l}function n(){const s=(0,O.$Rj)();for(const t in s){const c="\\"+s[t].toString(16);l.registerIcon(t,{fontCharacter:c})}}n(),e.$hx="vscode://schemas/icons";const i=I.$co.as(A.$do.JSONContribution);i.registerSchema(e.$hx,l.getIconSchema());const u=new h.$Ih(()=>i.notifySchemaChanged(e.$hx),200);l.onDidChange(()=>{u.isScheduled()||u.schedule()}),e.$ix=d("widget-close",N.$Vj.close,(0,k.localize)(2,null)),e.$jx=d("goto-previous-location",N.$Vj.arrowUp,(0,k.localize)(3,null)),e.$kx=d("goto-next-location",N.$Vj.arrowDown,(0,k.localize)(4,null)),e.$lx=R.ThemeIcon.modify(N.$Vj.sync,"spin"),e.$mx=R.ThemeIcon.modify(N.$Vj.loading,"spin")}),define(Se[88],De([1,0,4,2,55,5,11]),function(he,e,h,N,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tw=e.$sw=e.$pw=e.$nw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$jw=e.$iw=void 0,e.$kw=k,e.$lw=I,e.$mw=p,e.$ow=y,e.$qw=v,e.$rw=l,e.$iw=(0,R.$wi)("tunnelService"),e.$jw=(0,R.$wi)("sharedTunnelsService");var b;(function(n){n.Http="http",n.Https="https"})(b||(e.TunnelProtocol=b={}));var $;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})($||(e.TunnelPrivacyId=$={}));function k(n){return!!n.forwardPort}var A;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(A||(e.ProvidedOnAutoForward=A={}));function I(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function p(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const u of i){const s=u.split("=")[1];if(/^https?:/.exec(s)){const t=I(N.URI.parse(s));if(t)return t}}}e.$nw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(n){return e.$nw.indexOf(n)>=0}e.$pw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(n){return e.$pw.indexOf(n)>=0}function l(n,i,u,s){if(u===1)return!1;if(u===2&&v(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class d{constructor(i,u,s){this.remoteAddress=i,this.localAddress=u,this.b=s,this.a=new h.$de,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$sw=d;let o=class{constructor(i,u){this.k=i,this.l=u,this.a=new h.$de,this.onTunnelOpened=this.a.event,this.b=new h.$de,this.onTunnelClosed=this.b.event,this.c=new h.$de,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],u=Array.from(this.e.values());for(const s of u){const t=Array.from(s.values());for(const c of t){const r=await c.value;r&&typeof r!="string"&&i.push(r)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:u}of i.values())await u.then(s=>typeof s!="string"?s?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,u,s,t,c){this.q(i,u,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:u,localAddress:s,privacy:t,protocol:c,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,u){(v(i)||y(i))&&(i=e.$nw[0]);const s=this.s(i,u);if(s)return++s.refcount,s.value}openTunnel(i,u,s,t,c,r=!1,a,f){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${s} on local port ${c}.`);const g=this.f??i;if(!g)return;if(u||(u="localhost"),t||(t=this.m),this.f&&this.j.has(s)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const w=this.t(g,u,s,t,c,r,a,f);return w?w.then(S=>{if(S){if(typeof S=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(u,s),S}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(u,s);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const m=this.o(S);return(S.tunnelRemoteHost!==u||S.tunnelRemotePort!==s)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&S.privacy!==a&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(m),m}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),w)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const u=this.e.get(i.tunnelRemoteHost);if(u){const s=u.get(i.tunnelRemotePort);s&&(s.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,s))}}}}async p(i,u,s){if(s.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${u}.`);const t=s.value.then(async c=>{c&&typeof c!="string"&&(await c.dispose(!0),this.b.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(u),t}}async closeTunnel(i,u){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${u} `);const s=this.e.get(i);if(s&&s.has(u)){const t=s.get(u);t.refcount=0,await this.p(i,u,t)}}q(i,u,s){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(u,{refcount:1,value:s})}async r(i,u){const s=this.e.get(i);if(s){const t=s.get(u),c=t?await t.value:void 0;(!c||typeof c=="string")&&s.delete(u),s.size===0&&this.e.delete(i)}}s(i,u){const s=[i];y(i)?(s.push(...e.$nw),s.push(...e.$pw)):v(i)&&s.push(...e.$pw);const t=s.map(c=>this.e.get(c));for(const c of t){const r=c?.get(u);if(r)return r}}canTunnel(i){return!!I(i)}u(i,u,s,t,c,r,a){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${s} on local port ${t}.`);const f=s;this.j.add(f);const g=t===void 0?s:t,w={elevationRequired:c?this.isPortPrivileged(g):!1},S={remoteAddress:{host:u,port:s},localAddressPort:t,privacy:r,public:r?r!==$.Private:void 0,protocol:a},m=i.forwardPort(S,w);return m?(this.q(u,s,m),m.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(f)})):this.j.delete(f),m}};e.$tw=o,e.$tw=o=He([We(0,M.$3j),We(1,O.$3i)],o)}),define(Se[282],De([1,0,5]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=void 0,e.$Al=(0,h.$wi)("IUriIdentityService")}),define(Se[283],De([1,0,5]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$uw=void 0,e.$uw=(0,h.$wi)("editSessionIdentityService");var N;(function(O){O[O.Complete=100]="Complete",O[O.Partial=50]="Partial",O[O.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(Se[284],De([1,0,15]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ML=N,e.$NL=O,e.$OL=R,e.$PL=M,e.$QL=b;function N($){return $.scheme!==h.Schemas.file&&$.scheme!==h.Schemas.vscodeRemote}function O($){if($.folders.length)return $.folders.every(k=>N(k.uri))?$.folders[0].uri:void 0;if($.configuration&&N($.configuration))return $.configuration}function R($){return O($)?.scheme}function M($){return O($)?.authority}function b($){return O($)!==void 0}}),define(Se[42],De([1,0,223,16,78,23,2,5,15]),function(he,e,h,N,O,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Qi=e.$Pi=e.WorkbenchState=e.$Ji=e.$Ii=e.$Fi=void 0,e.$Gi=k,e.$Hi=A,e.$Ki=I,e.$Li=p,e.$Mi=y,e.$Ni=l,e.$Oi=d,e.$Ri=i,e.$Wi=u,e.$Xi=s,e.$Zi=t,e.$1i=c,e.$2i=r,e.$Fi=(0,b.$wi)("contextService");function k(a){const f=a;return typeof f?.id=="string"&&M.URI.isUri(f.uri)}function A(a){return typeof a?.id=="string"&&!k(a)&&!p(a)}e.$Ii={id:"ext-dev"},e.$Ji={id:"empty-window"};function I(a,f){if(typeof a=="string"||typeof a>"u")return typeof a=="string"?{id:(0,N.$nc)(a)}:f?e.$Ii:e.$Ji;const g=a;return g.configuration?{id:g.id,configPath:g.configuration}:g.folders.length===1?{id:g.id,uri:g.folders[0].uri}:{id:g.id}}function p(a){const f=a;return typeof f?.id=="string"&&M.URI.isUri(f.configPath)}function y(a){const f=a;if(f?.uri)return{id:f.id,uri:M.URI.revive(f.uri)};const g=a;if(g?.configPath)return{id:g.id,configPath:M.URI.revive(g.configPath)};if(a?.id)return{id:a.id}}var v;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function l(a){const f=a;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}function d(a){const f=a;return!!(f&&typeof f=="object"&&M.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}class o{constructor(f,g,w,S,m){this.h=f,this.j=w,this.k=S,this.l=m,this.c=O.$Ci.forUris(this.l,()=>!0),this.folders=g}update(f){this.h=f.id,this.k=f.configuration,this.j=f.transient,this.l=f.l,this.folders=f.folders}get folders(){return this.g}set folders(f){this.g=f,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(f){this.k=f}getFolder(f){return f&&this.c.findSubstr(f)||null}n(){this.c=O.$Ci.forUris(this.l,()=>!0);for(const f of this.folders)this.c.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Pi=o;class n{constructor(f,g){this.raw=g,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,R.$0g)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Qi=n;function i(a){return new n({uri:a,index:0,name:(0,R.$6g)(a)},{uri:a.toString()})}e.$Si="code-workspace",e.$Ti=`.${e.$Si}`,e.$Ui=[{name:(0,h.localize)(0,null),extensions:[e.$Si]}],e.$Vi="workspace.json";function u(a,f){return R.$1g.isEqualOrParent(a,f.untitledWorkspacesHome)}function s(a){let f;return M.URI.isUri(a)?f=a:f=a.configuration,f?.scheme===$.Schemas.tmp}e.$Yi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(a){return a.id===e.$Yi}function c(a,f){return!u(a,f)&&!s(a)}function r(a){return(typeof a=="string"?(0,N.$oc)(a):(0,R.$8g)(a))===e.$Ti}}),define(Se[285],De([1,0,57,4,3,23,2,222,137,33,5,11,42,27,282,7,30,14,18]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.$Cl=e.ProfileResourceType=void 0,e.$Bl=u,e.$Dl=s,e.$El=t;var i;(function(a){a.Settings="settings",a.Keybindings="keybindings",a.Snippets="snippets",a.Tasks="tasks",a.Extensions="extensions",a.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function u(a){const f=a;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&typeof f.isDefault=="boolean"&&typeof f.name=="string"&&M.URI.isUri(f.location)&&M.URI.isUri(f.globalStorageHome)&&M.URI.isUri(f.settingsResource)&&M.URI.isUri(f.keybindingsResource)&&M.URI.isUri(f.tasksResource)&&M.URI.isUri(f.snippetsHome)&&M.URI.isUri(f.extensionsResource))}e.$Cl=(0,A.$wi)("IUserDataProfilesService");function s(a,f){return{id:a.id,isDefault:a.isDefault,name:a.name,shortName:a.shortName,icon:a.icon,location:M.URI.revive(a.location).with({scheme:f}),globalStorageHome:M.URI.revive(a.globalStorageHome).with({scheme:f}),settingsResource:M.URI.revive(a.settingsResource).with({scheme:f}),keybindingsResource:M.URI.revive(a.keybindingsResource).with({scheme:f}),tasksResource:M.URI.revive(a.tasksResource).with({scheme:f}),snippetsHome:M.URI.revive(a.snippetsHome).with({scheme:f}),extensionsResource:M.URI.revive(a.extensionsResource).with({scheme:f}),cacheHome:M.URI.revive(a.cacheHome).with({scheme:f}),useDefaultFlags:a.useDefaultFlags,isTransient:a.isTransient}}function t(a,f,g,w,S,m){return{id:a,name:f,location:g,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:m&&S?.useDefaultFlags?.globalState?m.globalStorageHome:(0,R.$0g)(g,"globalStorage"),settingsResource:m&&S?.useDefaultFlags?.settings?m.settingsResource:(0,R.$0g)(g,"settings.json"),keybindingsResource:m&&S?.useDefaultFlags?.keybindings?m.keybindingsResource:(0,R.$0g)(g,"keybindings.json"),tasksResource:m&&S?.useDefaultFlags?.tasks?m.tasksResource:(0,R.$0g)(g,"tasks.json"),snippetsHome:m&&S?.useDefaultFlags?.snippets?m.snippetsHome:(0,R.$0g)(g,"snippets"),extensionsResource:m&&S?.useDefaultFlags?.extensions?m.extensionsResource:(0,R.$0g)(g,"extensions.json"),cacheHome:(0,R.$0g)(w,a),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}let c=class extends O.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(f,g,w,S){super(),this.t=f,this.u=g,this.w=w,this.y=S,this.f=!0,this.h=this.B(new N.$de),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$de),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$de),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$de),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new y.$Ac,emptyWindows:new Map},this.profilesHome=(0,R.$0g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$0g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(f){this.f!==f&&(this.z=void 0,this.f=f)}isEnabled(){return this.f}get C(){if(!this.z){const f=this.D(),g=[f];if(this.f)try{for(const m of this.O()){if(!m.name||!(0,n.$9f)(m.name)||!m.location){this.y.warn("Skipping the invalid stored profile",m.location||m.name);continue}g.push(t((0,R.$7g)(m.location),m.name,m.location,this.g,{shortName:m.shortName,icon:m.icon,useDefaultFlags:m.useDefaultFlags},f))}}catch(m){this.y.error(m)}const w=new y.$Ac,S=new Map;if(g.length)try{const m=this.Q();if(m.workspaces)for(const[E,D]of Object.entries(m.workspaces)){const C=M.URI.parse(E),P=g.find(F=>F.id===D);P&&w.set(C,P)}if(m.emptyWindows)for(const[E,D]of Object.entries(m.emptyWindows)){const C=g.find(P=>P.id===D);C&&S.set(E,C)}}catch(m){this.y.error(m)}this.z={profiles:g,workspaces:w,emptyWindows:S}}return this.z}D(){const f=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...f,extensionsResource:this.S()??f.extensionsResource,isDefault:!0}}async createTransientProfile(f){const g="Temp",w=new RegExp(`${(0,o.$_e)(g)}\\s(\\d+)`);let S=0;for(const E of this.profiles){const D=w.exec(E.name),C=D?parseInt(D[1]):0;S=C>S?C:S}const m=`${g} ${S+1}`;return this.createProfile((0,h.$kj)((0,d.$Sg)()).toString(16),m,{transient:!0},f)}async createNamedProfile(f,g,w){return this.createProfile((0,h.$kj)((0,d.$Sg)()).toString(16),f,g,w)}async createProfile(f,g,w,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=await this.F(f,g,w);return S&&await this.setProfileForWorkspace(S,m),m}async F(f,g,w){if(!(0,n.$9f)(g)||!g)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(g);return S||(S=(async()=>{try{if(this.profiles.find(C=>C.name===g||C.id===f))throw new Error(`Profile with ${g} name already exists`);const E=t(f,g,(0,R.$0g)(this.profilesHome,f),this.g,w,this.defaultProfile);await this.u.createFolder(E.location);const D=[];return this.j.fire({profile:E,join(C){D.push(C)}}),await l.Promises.settled(D),this.I([E],[],[]),E}finally{this.r.delete(g)}})(),this.r.set(g,S)),S}async updateProfile(f,g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let w=this.profiles.find(S=>S.id===f.id);if(!w)throw new Error(`Profile '${f.name}' does not exist`);return w=t(w.id,g.name??w.name,w.location,this.g,{shortName:g.shortName??w.shortName,icon:g.icon===null?void 0:g.icon??w.icon,transient:g.transient??w.isTransient,useDefaultFlags:g.useDefaultFlags??w.useDefaultFlags},this.defaultProfile),this.I([],[],[w]),w}async removeProfile(f){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(f.isDefault)throw new Error("Cannot remove default profile");const g=this.profiles.find(S=>S.id===f.id);if(!g)throw new Error(`Profile '${f.name}' does not exist`);const w=[];this.m.fire({profile:g,join(S){w.push(S)}});try{await Promise.allSettled(w)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])g.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])g.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[g],[]);try{await this.u.del(g.cacheHome,{recursive:!0})}catch(S){(0,k.$hl)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(f,g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=this.profiles.find(S=>S.id===g.id);if(!w)throw new Error(`Profile '${g.name}' does not exist`);this.L(f,w)}unsetWorkspace(f,g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(f,void 0,g)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const f=await this.u.resolve(this.profilesHome);await Promise.all((f.children||[]).filter(g=>g.isDirectory&&this.profiles.every(w=>!this.w.extUri.isEqual(w.location,g.resource))).map(g=>this.u.del(g.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const f=this.s.profiles.filter(g=>!this.H(g));await Promise.allSettled(f.map(g=>this.removeProfile(g)))}getProfileForWorkspace(f){const g=this.G(f);return M.URI.isUri(g)?this.s.workspaces.get(g)??this.C.workspaces.get(g):this.s.emptyWindows.get(g)??this.C.emptyWindows.get(g)}G(f){return(0,p.$Gi)(f)?f.uri:(0,p.$Li)(f)?f.configPath:f.id}H(f){return!!([...this.s.emptyWindows.values()].some(g=>this.w.extUri.isEqual(g.location,f.location))||[...this.s.workspaces.values()].some(g=>this.w.extUri.isEqual(g.location,f.location))||[...this.C.emptyWindows.values()].some(g=>this.w.extUri.isEqual(g.location,f.location))||[...this.C.workspaces.values()].some(g=>this.w.extUri.isEqual(g.location,f.location)))}I(f,g,w){const S=[...this.profiles,...f],m=[];this.s.profiles=[];for(let E of S)E.isDefault||g.some(D=>E.id===D.id)||(E=w.find(D=>E.id===D.id)??E,E.isTransient?this.s.profiles.push(E):m.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(m),this.z=void 0,this.J(f,g,w)}J(f,g,w){this.h.fire({added:f,removed:g,updated:w,all:this.profiles})}L(f,g,w){w=g?.isTransient?!0:w,w||this.L(f,void 0,!0);const S=this.G(f),m=w?this.s:this.C;M.URI.isUri(S)?(m.workspaces.delete(S),g&&m.workspaces.set(S,g)):(m.emptyWindows.delete(S),g&&m.emptyWindows.set(S,g)),w||this.M()}M(){const f={};for(const[w,S]of this.C.workspaces.entries())f[w.toString()]=S.id;const g={};for(const[w,S]of this.C.emptyWindows.entries())g[w.toString()]=S.id;this.R({workspaces:f,emptyWindows:g}),this.z=void 0}N(f){const g={},w=this.D();if(f.workspaces)for(const[m,E]of Object.entries(f.workspaces)){const D=M.URI.parse(E);g[m]=this.w.extUri.isEqual(D,w.location)?w.id:this.w.extUri.basename(D)}const S={};if(f.emptyWindows)for(const[m,E]of Object.entries(f.emptyWindows)){const D=M.URI.parse(E);S[m]=this.w.extUri.isEqual(D,w.location)?w.id:this.w.extUri.basename(D)}return{workspaces:g,emptyWindows:S}}O(){return[]}P(f){throw new Error("not implemented")}Q(){return{}}R(f){throw new Error("not implemented")}S(){}};e.$Fl=c,e.$Fl=c=He([We(0,$.$Di),We(1,k.$3k),We(2,v.$Al),We(3,I.$3j)],c);class r extends c{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(f){this.a=f}Q(){return this.X}R(f){this.X=f}}e.$Gl=r}),define(Se[142],De([1,0,7,4,3,59,18,200,5,285]),function(he,e,h,N,O,R,M,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$3p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$1p=e.$Zp=e.$Yp=void 0,e.$2p=y,e.$4p=l,e.$6p=o,e.$Yp="__$__isNewStorageMarker",e.$Zp="__$__targetStorageMarker",e.$1p=(0,$.$wi)("storageService");var A;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var I;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var p;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function y(n){const i=n.get(e.$Zp);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class v extends O.$Uc{static{this.a=60*1e3}constructor(i={flushInterval:v.a}){super(),this.m=i,this.b=this.B(new N.$ge),this.c=this.B(new N.$ge),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$de),this.onWillSaveState=this.f.event,this.h=this.B(new h.$Ih(()=>this.n(),this.m.flushInterval)),this.j=this.B(new O.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,u,s){return N.Event.filter(this.b.event,t=>t.scope===i&&(u===void 0||t.key===u),s)}n(){this.j.value=(0,h.$Mh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,O.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,u){const{key:s,external:t}=u;if(s===e.$Zp){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:s,target:this.J(i)[s],external:t})}w(i){this.f.fire({reason:i})}get(i,u,s){return this.P(u)?.get(i,s)}getBoolean(i,u,s){return this.P(u)?.getBoolean(i,s)}getNumber(i,u,s){return this.P(u)?.getNumber(i,s)}getObject(i,u,s){return this.P(u)?.getObject(i,s)}storeAll(i,u){this.y(()=>{for(const s of i)this.store(s.key,s.value,s.scope,s.target,u)})}store(i,u,s,t,c=!1){if((0,M.$fg)(u)){this.remove(i,s,c);return}this.y(()=>{this.z(i,s,t),this.P(s)?.set(i,u,c)})}remove(i,u,s=!1){this.y(()=>{this.z(i,u,void 0),this.P(u)?.delete(i,s)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,u){const s=[],t=this.J(i);for(const c of Object.keys(t))t[c]===u&&s.push(c);return s}z(i,u,s,t=!1){const c=this.J(u);typeof s=="number"?c[i]!==s&&(c[i]=s,this.P(u)?.set(e.$Zp,JSON.stringify(c),t)):typeof c[i]=="number"&&(delete c[i],this.P(u)?.set(e.$Zp,JSON.stringify(c),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const u=this.P(i);return u?y(u):Object.create(null)}isNew(i){return this.getBoolean(e.$Yp,i)===!0}async flush(i=A.NONE){this.f.fire({reason:i});const u=this.P(-1),s=this.P(0),t=this.P(1);switch(i){case A.NONE:await h.Promises.settled([u?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await h.Promises.settled([u?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,u=this.P(0)?.items??new Map,s=this.P(1)?.items??new Map;return o(i,u,s,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,u){return this.w(A.NONE),(0,k.$Bl)(i)?this.R(i,u):this.S(i,u)}M(i,u){return!(i.id===u.id||l(u)&&l(i))}N(i,u,s){this.y(()=>{const t=new Set;for(const[c,r]of i)t.add(c),u.get(c)!==r&&this.u(s,{key:c,external:!0});for(const[c]of u.items)t.has(c)||this.u(s,{key:c,external:!0})})}}e.$3p=v;function l(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class d extends v{constructor(){super(),this.U=this.B(new b.$Wp(new b.$Xp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$Wp(new b.$Xp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$Wp(new b.$Xp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$5p=d;async function o(n,i,u,s,t,c){const r=C=>{try{return JSON.parse(C)}catch{return C}},a=new Map,f=new Map;n.forEach((C,P)=>{a.set(P,C),f.set(P,r(C))});const g=new Map,w=new Map;i.forEach((C,P)=>{g.set(P,C),w.set(P,r(C))});const S=new Map,m=new Map;u.forEach((C,P)=>{S.set(P,C),m.set(P,r(C))}),console.group(s!==t?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const E=[];if(a.forEach((C,P)=>{E.push({key:P,value:C})}),console.table(E),console.groupEnd(),console.log(f),s!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];g.forEach((P,F)=>{C.push({key:F,value:P})}),console.table(C),console.groupEnd(),console.log(w)}console.group(`Storage: Workspace (path: ${c})`);const D=[];S.forEach((C,P)=>{D.push({key:P,value:C})}),console.table(D),console.groupEnd(),console.log(m)}}),define(Se[112],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tlc=void 0;class h{static{this.a=!1}constructor(O){this.d=O,this.b=new Map,this.c=1}add(O){const R=this.c++;return this.b.set(R,O),this.e(),R}get(O,R){return this.b.has(O)?this.b.get(O)[R]:void 0}delete(O){this.b.delete(O),this.e()}e(){h.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$tlc=h}),define(Se[60],De([1,0,15,23,5]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=e.$ylc=void 0;class R{constructor(){this.a=new Set(Object.keys(h.Schemas)),this.b=new Map,this.extUri=new N.$Yg(b=>{const $=this.b.get(b.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(b,$){$===null?this.b.delete(b.scheme):this.b.set(b.scheme,$)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$ylc=R,e.$zlc=(0,O.$wi)("IExtHostFileSystemInfo")}),define(Se[28],De([1,0,5]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UO=void 0,e.$UO=(0,h.$wi)("IExtHostInitDataService")}),define(Se[286],De([1,0,228,11,266,28]),function(he,e,h,N,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Enc=void 0;let M=class extends O.$5P{constructor($,k,A){const I=A.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",p=A.remote.isRemote?(0,h.localize)(0,null):$?(0,h.localize)(1,null):(0,h.localize)(2,null);super(k.createLogger(I,{name:p}))}};e.$Enc=M,e.$Enc=M=He([We(1,N.$4j),We(2,R.$UO)],M)}),define(Se[287],De([1,0,7]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fmc=e.$emc=void 0;class N{constructor(M,b,$){this.h=new Map,this.a=M,this.b=b,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new h.$Ih(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of k.values())A.complete()}catch(A){for(const I of k.values())I.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,b){let $=this.f[M];return typeof $>"u"&&($=b),$}update(M,b){this.f[M]=b;const $=this.h.get(M);if($!==void 0)return $.p;const k=new h.$Th;return this.h.set(M,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.$emc=N;class O extends N{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,b){super(M.identifier.value,!0,b),this.j=M}}e.$fmc=O}),define(Se[288],De([1,0,4,2]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5mc=void 0;class O{constructor(M){this.c=M,this.a=new h.$de,this.onDidSaveNotebookDocument=this.a.event,this.b=new h.$de,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,b,$,k){const I=this.c.getNotebookDocument(N.URI.revive(M)).acceptModelChanged(b.value,$,k);this.b.fire(I)}$acceptDirtyStateChanged(M,b){this.c.getNotebookDocument(N.URI.revive(M)).acceptDirty(b)}$acceptModelSaved(M){const b=this.c.getNotebookDocument(N.URI.revive(M));this.a.fire(b.apiNotebook)}}e.$5mc=O}),define(Se[20],De([1,0,5]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FO=e.$EO=void 0,e.$EO=(0,h.$wi)("IExtHostRpcService");class N{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$FO=N}),define(Se[289],De([1,0,25,4]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$omc=void 0;class O{#e;constructor(M,b){this.b=new N.$de,this.onDidChange=this.b.event,this.a=h.$Rm.toKey(M.identifier),this.#e=b,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(M){return this.#e.get(this.a,M)}store(M,b){return this.#e.store(this.a,M,b)}delete(M){return this.#e.delete(this.a,M)}}e.$omc=O}),define(Se[68],De([1,0,5]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Plc=e.$Olc=void 0,e.$Olc=(0,h.$wi)("IURITransformerService");class N{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$Plc=N}),define(Se[290],De([1,0,21]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Orb=O,e.$Prb=M;class N{constructor(){this.buffers=[]}add($){let k=this.buffers.indexOf($);return k<0&&(k=this.buffers.length,this.buffers.push($)),k}}function O(b,$){if($.serializeBuffersForPostMessage){const k=new N,I=JSON.stringify(b,(y,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(v)};if(ArrayBuffer.isView(v)){const l=R(v);if(l)return{$$vscode_array_buffer_reference$$:!0,index:k.add(v.buffer),view:{type:l,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),p=k.buffers.map(y=>{const v=new Uint8Array(y);return h.$Fe.wrap(v)});return{message:I,buffers:p}}else return{message:JSON.stringify(b),buffers:[]}}function R(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(b,$){const k=$.map(p=>{const y=new ArrayBuffer(p.byteLength);return new Uint8Array(y).set(p.buffer),y}),A=$.length?(p,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const v=y,{index:l}=v,d=k[l];if(v.view)switch(v.view.type){case 1:return new Int8Array(d,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return y}:void 0;return{message:JSON.parse(b,A),arrayBuffers:k}}}),define(Se[291],De([1,0,292,402,403,63,2,11,404]),function(he,e,h,N,O,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aoc=A;const k=!1;function A(i,u,s,t,c,r){const a=r.environment.useHostProxy,f=typeof a=="boolean"?a:!r.remote.isRemote,g={resolveProxy:m=>i.resolveProxy(m),lookupProxyAuthorization:d.bind(void 0,t,c,u,{},r.remote.isRemote),getProxyURL:()=>u.getConfiguration("http").get("proxy"),getProxySupport:()=>u.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>p(u),addCertificatesV2:()=>y(u),log:t,getLogLevel:()=>{const m=t.getLevel();switch(m){case b.LogLevel.Trace:return $.LogLevel.Trace;case b.LogLevel.Debug:return $.LogLevel.Debug;case b.LogLevel.Info:return $.LogLevel.Info;case b.LogLevel.Warning:return $.LogLevel.Warning;case b.LogLevel.Error:return $.LogLevel.Error;case b.LogLevel.Off:return $.LogLevel.Off;default:return E(m)}function E(D){return t.error("Unknown log level",D),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:f,loadAdditionalCertificates:async()=>{const m=[];if(r.remote.isRemote&&m.push((0,$.loadSystemCertificates)({log:t})),f){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const E=i.loadCertificates();E.then(D=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",D.length)),m.push(E)}return(await Promise.all(m)).flat()},env:process.env},w=(0,$.createProxyResolver)(g),S=I(g,w);return l(s,S)}function I(i,u){return{http:Object.assign(h,(0,$.createHttpPatch)(i,h,u)),https:Object.assign(N,(0,$.createHttpPatch)(i,N,u)),net:Object.assign(R,(0,$.createNetPatch)(i,R)),tls:Object.assign(O,(0,$.createTlsPatch)(i,O))}}function p(i){const u=i.getConfiguration("http");return!u.get("experimental.systemCertificatesV2",k)&&!!u.get("systemCertificates")}function y(i){const u=i.getConfiguration("http");return!!u.get("experimental.systemCertificatesV2",k)&&!!u.get("systemCertificates")}const v=new Map;function l(i,u){return i.getExtensionPathIndex().then(s=>{const t=globalThis._VSCODE_NODE_MODULES.module,c=t._load;t._load=function(a,f,g){if(a==="net")return u.net;if(a==="tls")return u.tls;if(a!=="http"&&a!=="https")return c.apply(this,arguments);const w=s.findSubstr(M.URI.file(f.filename));let S=v.get(w);if(S||v.set(w,S={}),!S[a]){const m=u[a];S[a]={...m}}return S[a]}})}async function d(i,u,s,t,c,r,a,f){const g=t[r];a&&(t[r]=a),i.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${r}`,`proxyAuthenticate:${a}`,`proxyAuthenticateCache:${g}`);const w=a||g,S=Array.isArray(w)?w:typeof w=="string"?[w]:[];if(n(u,S,c),S.some(m=>/^(Negotiate|Kerberos)( |$)/i.test(m))&&!f.kerberosRequested)try{f.kerberosRequested=!0;const m=await new Promise((F,T)=>{he(["kerberos"],F,T)}),E=new URL(r),D=s.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${E.hostname}`:`HTTP@${E.hostname}`);return i.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${r}`,`spn:${D}`),"Negotiate "+await(await m.initializeClient(D)).step("")}catch(m){i.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",m)}}let o=!1;function n(i,u,s){o||!u.length||(o=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:u.map(t=>t.split(" ")[0]).join(","),extensionHostType:s?"remote":"local"}))}}),define(Se[293],De([1,0,134]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=O;function N(R){return{transformIncoming:M=>M.scheme==="vscode-remote"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="file"?{scheme:"vscode-local",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoing:M=>M.scheme==="file"?{scheme:"vscode-remote",authority:R,path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="vscode-local"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoingScheme:M=>M==="file"?"vscode-remote":M==="vscode-local"?"file":M}}function O(R){return new h.$yn(N(R))}}),define(Se[143],De([1,0,238,18,2,3,5,36,33,15,47,192,41]),function(he,e,h,N,O,R,M,b,$,k,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$RF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$IF=e.EditorInputCapabilities=e.$HF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=void 0,e.$yF=l,e.$zF=d,e.$AF=o,e.$BF=n,e.$CF=i,e.$DF=u,e.$EF=s,e.$FF=t,e.$GF=c,e.$JF=S,e.$KF=E,e.$LF=D,e.$MF=C,e.$NF=P,e.$OF=F,e.$PF=T,e.$QF=ie,e.$SF=x,e.$TF=be,e.$UF=ae,e.$VF=Ie,e.$tF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$uF={id:"default",displayName:(0,h.localize)(0,null),providerDisplayName:(0,h.localize)(1,null)},e.$vF="workbench.editor.sidebysideEditor",e.$wF="workbench.editors.textDiffEditor",e.$xF="workbench.editors.binaryResourceDiffEditor";var y;(function(ee){ee[ee.PROGRAMMATIC=1]="PROGRAMMATIC",ee[ee.USER=2]="USER",ee[ee.EDIT=3]="EDIT",ee[ee.NAVIGATION=4]="NAVIGATION",ee[ee.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var v;(function(ee){ee[ee.IDENTICAL=1]="IDENTICAL",ee[ee.SIMILAR=2]="SIMILAR",ee[ee.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function l(ee){const B=ee;return!!B&&typeof B.getSelection=="function"&&!!B.onDidChangeSelection}function d(ee){const B=ee;return!!B&&typeof B.getScrollPosition=="function"&&typeof B.setScrollPosition=="function"&&!!B.onDidChangeScroll}function o(ee,B,_){for(const pe of _.visibleEditorPanes)if(pe.group.id===B&&ee.matches(pe.input))return pe.getViewState()}function n(ee){if(S(ee))return!1;const B=ee;return O.URI.isUri(B?.resource)}function i(ee){if(S(ee))return!1;const B=ee;return B?.original!==void 0&&B.modified!==void 0}function u(ee){if(S(ee))return!1;const B=ee;return!B||B.resources&&!Array.isArray(B.resources)?!1:!!B.resources||!!B.multiDiffSource}function s(ee){if(S(ee)||i(ee))return!1;const B=ee;return B?.primary!==void 0&&B.secondary!==void 0}function t(ee){if(S(ee))return!1;const B=ee;return B?B.resource===void 0||B.resource.scheme===k.Schemas.untitled||B.forceUntitled===!0:!1}function c(ee){if(S(ee))return!1;const B=ee;return O.URI.isUri(B?.base?.resource)&&O.URI.isUri(B?.input1?.resource)&&O.URI.isUri(B?.input2?.resource)&&O.URI.isUri(B?.result?.resource)}var r;(function(ee){ee[ee.SHORT=0]="SHORT",ee[ee.MEDIUM=1]="MEDIUM",ee[ee.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var a;(function(ee){ee[ee.EXPLICIT=1]="EXPLICIT",ee[ee.AUTO=2]="AUTO",ee[ee.FOCUS_CHANGE=3]="FOCUS_CHANGE",ee[ee.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class f{constructor(){this.a=new Map}registerSource(B,_){let pe=this.a.get(B);return pe||(pe={source:B,label:_},this.a.set(B,pe)),pe.source}getSourceLabel(B){return this.a.get(B)?.label??B}}e.$HF=new f;var g;(function(ee){ee[ee.None=0]="None",ee[ee.Readonly=2]="Readonly",ee[ee.Untitled=4]="Untitled",ee[ee.Singleton=8]="Singleton",ee[ee.RequiresTrust=16]="RequiresTrust",ee[ee.CanSplitInGroup=32]="CanSplitInGroup",ee[ee.ForceDescription=64]="ForceDescription",ee[ee.CanDropIntoEditor=128]="CanDropIntoEditor",ee[ee.MultipleEditors=256]="MultipleEditors",ee[ee.Scratchpad=512]="Scratchpad"})(g||(e.EditorInputCapabilities=g={}));class w extends R.$Uc{}e.$IF=w;function S(ee){return ee instanceof w}function m(ee){const B=ee;return O.URI.isUri(B?.preferredResource)}function E(ee){const B=ee;return S(B?.primary)&&S(B?.secondary)}function D(ee){const B=ee;return S(B?.modified)&&S(B?.original)}function C(ee,B,_,pe,ue){return Ie(pe,[(0,I.$gj)({id:"workbench.action.openLargeFile",label:(0,h.localize)(2,null),run:()=>{const ce={..._,limits:{size:Number.MAX_VALUE}};ee.openEditor(B,ce)}}),(0,I.$gj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,h.localize)(3,null),run:()=>ue.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}function P(ee){return S(ee?.editor)}function F(ee){const B=ee;return P(ee)&&B?.group!==void 0}function T(ee){const B=ee;return typeof B?.groupId=="number"&&S(B.editor)}var z;(function(ee){ee[ee.UNKNOWN=0]="UNKNOWN",ee[ee.REPLACE=1]="REPLACE",ee[ee.MOVE=2]="MOVE",ee[ee.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var L;(function(ee){ee[ee.GROUP_ACTIVE=0]="GROUP_ACTIVE",ee[ee.GROUP_INDEX=1]="GROUP_INDEX",ee[ee.GROUP_LABEL=2]="GROUP_LABEL",ee[ee.GROUP_LOCKED=3]="GROUP_LOCKED",ee[ee.EDITOR_OPEN=4]="EDITOR_OPEN",ee[ee.EDITOR_CLOSE=5]="EDITOR_CLOSE",ee[ee.EDITOR_MOVE=6]="EDITOR_MOVE",ee[ee.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ee[ee.EDITOR_LABEL=8]="EDITOR_LABEL",ee[ee.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ee[ee.EDITOR_PIN=10]="EDITOR_PIN",ee[ee.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ee[ee.EDITOR_STICKY=12]="EDITOR_STICKY",ee[ee.EDITOR_DIRTY=13]="EDITOR_DIRTY",ee[ee.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(L||(e.GroupModelChangeKind=L={}));var j;(function(ee){ee[ee.PRIMARY=1]="PRIMARY",ee[ee.SECONDARY=2]="SECONDARY",ee[ee.BOTH=3]="BOTH",ee[ee.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class U{getOriginalUri(B,_){if(!B)return;if(c(B))return e.$RF.getOriginalUri(B.result,_);if(_?.supportSideBySide){const{primary:ue,secondary:ce}=this.a(B);if(ue&&ce){if(_?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(ue,{filterByScheme:_.filterByScheme}),secondary:this.getOriginalUri(ce,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===j.ANY)return this.getOriginalUri(ue,{filterByScheme:_.filterByScheme})??this.getOriginalUri(ce,{filterByScheme:_.filterByScheme});B=_.supportSideBySide===j.PRIMARY?ue:ce}}if(i(B)||u(B)||s(B)||c(B))return;const pe=m(B)?B.preferredResource:B.resource;return!pe||!_||!_.filterByScheme?pe:this.b(pe,_.filterByScheme)}a(B){return E(B)||s(B)?{primary:B.primary,secondary:B.secondary}:D(B)||i(B)?{primary:B.modified,secondary:B.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(B,_){if(!B)return;if(c(B))return e.$RF.getCanonicalUri(B.result,_);if(_?.supportSideBySide){const{primary:ue,secondary:ce}=this.a(B);if(ue&&ce){if(_?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(ue,{filterByScheme:_.filterByScheme}),secondary:this.getCanonicalUri(ce,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===j.ANY)return this.getCanonicalUri(ue,{filterByScheme:_.filterByScheme})??this.getCanonicalUri(ce,{filterByScheme:_.filterByScheme});B=_.supportSideBySide===j.PRIMARY?ue:ce}}if(i(B)||u(B)||s(B)||c(B))return;const pe=B.resource;return!pe||!_||!_.filterByScheme?pe:this.b(pe,_.filterByScheme)}b(B,_){if(Array.isArray(_)){if(_.some(pe=>B.scheme===pe))return B}else if(_===B.scheme)return B}}var X;(function(ee){ee[ee.UNKNOWN=0]="UNKNOWN",ee[ee.KEYBOARD=1]="KEYBOARD",ee[ee.MOUSE=2]="MOUSE"})(X||(e.EditorCloseMethod=X={}));function ie(ee,B,_,pe){if(!ee.isSticky(B))return!1;switch(pe.preventPinnedEditorClose){case"keyboardAndMouse":return _===X.MOUSE||_===X.KEYBOARD;case"mouse":return _===X.MOUSE;case"keyboard":return _===X.KEYBOARD}return!1}e.$RF=new U;var q;(function(ee){ee[ee.LEFT=0]="LEFT",ee[ee.RIGHT=1]="RIGHT"})(q||(e.CloseDirection=q={}));class G{constructor(){this.c=new Map,this.d=new Map}start(B){const _=this.a=B.get(M.$vi);for(const[pe,ue]of this.c)this.e(pe,ue,_);this.c.clear()}e(B,_,pe){const ue=pe.createInstance(_);this.d.set(B,ue)}registerFileEditorFactory(B){if(this.b)throw new Error("Can only register one file editor factory.");this.b=B}getFileEditorFactory(){return(0,N.$hg)(this.b)}registerEditorSerializer(B,_){if(this.c.has(B)||this.d.has(B))throw new Error(`A editor serializer with type ID '${B}' was already registered.`);return this.a?this.e(B,_,this.a):this.c.set(B,_),(0,R.$Sc)(()=>{this.c.delete(B),this.d.delete(B)})}getEditorSerializer(B){return this.d.get(typeof B=="string"?B:B.typeId)}}b.$co.add(e.$tF.EditorFactory,new G);async function x(ee,B,_){return!ee||!ee.length?[]:await Promise.all(ee.map(async pe=>{const ue=O.URI.revive(pe.fileUri);if(!ue){_.info("Cannot resolve the path because it is not valid.",pe);return}if(!await B.canHandleResource(ue)){_.info("Cannot resolve the path because it cannot be handled",pe);return}let oe=pe.exists,le=pe.type;if(typeof oe!="boolean"||typeof le!="number")try{le=(await B.stat(ue)).isDirectory?$.FileType.Directory:$.FileType.Unknown,oe=!0}catch(se){_.error(se),oe=!1}if(!oe&&pe.openOnlyIfExists){_.info("Cannot resolve the path because it does not exist",pe);return}if(le===$.FileType.Directory){_.info("Cannot resolve the path because it is a directory",pe);return}const K={...pe.options,pinned:!0};return oe?{resource:ue,options:K}:{resource:ue,options:K,forceUntitled:!0}}))}var ne;(function(ee){ee[ee.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ee[ee.SEQUENTIAL=1]="SEQUENTIAL"})(ne||(e.EditorsOrder=ne={}));function be(ee){const B=ee;if(!B)return!1;const _=B;if(_.modified)return be(_.modified);const pe=B;return!!(pe.contributionsState&&pe.viewState&&Array.isArray(pe.cursorState))}function ae(ee){return(0,A.$ij)(ee)}function Ie(ee,B,_){const pe=(0,A.$jj)(ee,B);return pe.forceMessage=_?.forceMessage,pe.forceSeverity=_?.forceSeverity,pe.allowDialog=_?.allowDialog,pe}}),define(Se[294],De([1,0,4,239,5,3,27,36,24,79,281]),function(he,e,h,N,O,R,M,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4F=e.$3F=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$2F=e.ViewContentGroups=e.$ZF=e.ViewContainerLocation=e.Extensions=e.$YF=e.$XF=e.$WF=void 0,e.$1F=y,e.$WF="views",e.$XF=(0,N.localize)(0,null),e.$YF=(0,A.$fx)("default-view-icon",k.$Vj.window,(0,N.localize)(1,null));var I;(function(t){t.ViewContainersRegistry="workbench.registry.view.containers",t.ViewsRegistry="workbench.registry.view"})(I||(e.Extensions=I={}));var p;(function(t){t[t.Sidebar=0]="Sidebar",t[t.Panel=1]="Panel",t[t.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$ZF=[0,1,2];function y(t){switch(t){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class v extends R.$Uc{constructor(){super(...arguments),this.c=this.B(new h.$de),this.onDidRegister=this.c.event,this.f=this.B(new h.$de),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(c,r,a){const f=this.get(c.id);if(f)return f;const g=c;return g.openCommandActionDescriptor=a?.doNotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,M.$xc)(this.g,r,[]).push(g),a?.isDefault&&this.h.push(g),this.c.fire({viewContainer:g,viewContainerLocation:r}),g}deregisterViewContainer(c){for(const r of this.g.keys()){const a=this.g.get(r),f=a?.indexOf(c);if(f!==-1){a?.splice(f,1),a.length===0&&this.g.delete(r),this.f.fire({viewContainer:c,viewContainerLocation:r});return}}}get(c){return this.all.filter(r=>r.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(r=>this.getViewContainers(r).filter(a=>a?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(r=>this.getViewContainerLocation(r)===c)}}b.$co.add(I.ViewContainersRegistry,new v);var l;(function(t){t.Open="2_open",t.Debug="4_debug",t.SCM="5_scm",t.More="9_more"})(l||(e.ViewContentGroups=l={}));function d(t,c){const r=t.group??l.More,a=c.group??l.More;return r!==a?r.localeCompare(a):(t.order??5)-(c.order??5)}class o extends R.$Uc{constructor(){super(...arguments),this.c=this.B(new h.$de),this.onViewsRegistered=this.c.event,this.f=this.B(new h.$de),this.onViewsDeregistered=this.f.event,this.g=this.B(new h.$de),this.onDidChangeContainer=this.g.event,this.h=this.B(new h.$de),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Hc}registerViews(c,r){this.registerViews2([{views:c,viewContainer:r}])}registerViews2(c){c.forEach(({views:r,viewContainer:a})=>this.r(r,a)),this.c.fire(c)}deregisterViews(c,r){const a=this.s(c,r);a.length&&this.f.fire({views:a,viewContainer:r})}moveViews(c,r){for(const a of this.m.keys())if(a!==r){const f=this.s(c,a);f.length&&(this.r(f,r),this.g.fire({views:f,from:a,to:r}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const r of this.j){const a=(this.m.get(r)||[]).filter(f=>f.id===c)[0];if(a)return a}return null}getViewContainer(c){for(const r of this.j)if((this.m.get(r)||[]).filter(f=>f.id===c)[0])return r;return null}registerViewWelcomeContent(c,r){return this.n.add(c,r),this.h.fire(c),(0,R.$Sc)(()=>{this.n.delete(c,r),this.h.fire(c)})}registerViewWelcomeContent2(c,r){const a=new Map;for(const[f,g]of r)this.n.add(c,g),a.set(f,(0,R.$Sc)(()=>{this.n.delete(c,g),this.h.fire(c)}));return this.h.fire(c),a}getViewWelcomeContent(c){const r=[];return this.n.forEach(c,a=>r.push(a)),r.sort(d)}r(c,r){let a=this.m.get(r);a||(a=[],this.m.set(r,a),this.j.push(r));for(const f of c){if(this.getView(f.id)!==null)throw new Error((0,N.localize)(2,null,f.id));a.push(f)}}s(c,r){const a=this.m.get(r);if(!a)return[];const f=[],g=[];for(const w of a)c.includes(w)?f.push(w):g.push(w);return f.length&&(g.length?this.m.set(r,g):(this.m.delete(r),this.j.splice(this.j.indexOf(r),1))),f}}b.$co.add(I.ViewsRegistry,new o),e.$2F=(0,O.$wi)("viewDescriptorService");var n;(function(t){t[t.Default=0]="Default",t[t.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var i;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class u{constructor(c,r){this.c=!1,this.d=!1,(0,$.$6n)(this,c),this.d=!!r,this.resolve=async a=>{if(r&&!this.c){const f=await r(a);f&&(this.tooltip=this.tooltip??f.tooltip,this.command=this.command??f.command)}a.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$3F=u;class s extends Error{constructor(c){super((0,N.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$4F=s}),define(Se[295],De([1,0,240,38]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=void 0,e.$8F=new N.$Nj("chatSessionResponseVote","",{type:"string",description:(0,h.localize)(0,null)}),e.$9F=new N.$Nj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,h.localize)(1,null)}),e.$0F=new N.$Nj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,h.localize)(2,null)}),e.$$F=new N.$Nj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,h.localize)(3,null)}),e.$_F=new N.$Nj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,h.localize)(4,null)}),e.$aG=new N.$Nj("chatResponse",!1,{type:"boolean",description:(0,h.localize)(5,null)}),e.$bG=new N.$Nj("chatRequest",!1,{type:"boolean",description:(0,h.localize)(6,null)}),e.$cG=new N.$Nj("chatEditApplied",!1,{type:"boolean",description:(0,h.localize)(7,null)}),e.$dG=new N.$Nj("chatInputHasText",!1,{type:"boolean",description:(0,h.localize)(8,null)}),e.$eG=new N.$Nj("chatInputHasFocus",!1,{type:"boolean",description:(0,h.localize)(9,null)}),e.$fG=new N.$Nj("inChatInput",!1,{type:"boolean",description:(0,h.localize)(10,null)}),e.$gG=new N.$Nj("inChat",!1,{type:"boolean",description:(0,h.localize)(11,null)}),e.$hG=new N.$Nj("chatIsEnabled",!1,{type:"boolean",description:(0,h.localize)(12,null)}),e.$iG=new N.$Nj("chatCursorAtTop",!1),e.$jG=new N.$Nj("chatInputHasAgent",!1),e.$kG=new N.$Nj("chatLocation",void 0)}),define(Se[296],De([1,0,7,22,4,39,3,171,14,38,5,11,108,274,142,295]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.ChatAgentLocation=void 0;var o;(function(s){s.Panel="panel",s.Terminal="terminal",s.Notebook="notebook",s.Editor="editor"})(o||(e.ChatAgentLocation=o={})),function(s){function t(c){switch(c){case"panel":return s.Panel;case"terminal":return s.Terminal;case"notebook":return s.Notebook;case"editor":return s.Editor}return s.Panel}s.fromRaw=t}(o||(e.ChatAgentLocation=o={})),e.$iH=(0,A.$wi)("chatAgentService");let n=class{static{this.AGENT_LEADER="@"}constructor(t){this.f=t,this.b=[],this.d=new O.$de,this.onDidChangeAgents=this.d.event,this.e=l.$hG.bindTo(this.f)}registerAgent(t,c){if(this.getAgent(t))throw new Error(`Agent already registered: ${JSON.stringify(t)}`);const a=this,f=c.slashCommands;c={...c,get slashCommands(){return f.filter(w=>!w.when||a.f.contextMatchesRules(k.$uj.deserialize(w.when)))}};const g={data:c};return this.b.push(g),(0,M.$Sc)(()=>{this.b=this.b.filter(w=>w!==g),this.d.fire(void 0)})}registerAgentImplementation(t,c){const r=this.g(t);if(!r)throw new Error(`Unknown agent: ${JSON.stringify(t)}`);if(r.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(t)}`);return r.data.isDefault&&this.e.set(!0),r.impl=c,this.d.fire(new i(r.data,c)),(0,M.$Sc)(()=>{r.impl=void 0,this.d.fire(void 0),r.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(t,c){t.isDynamic=!0;const r={data:t,impl:c};return this.b.push(r),this.d.fire(new i(t,c)),(0,M.$Sc)(()=>{this.b=this.b.filter(a=>a!==r),this.d.fire(void 0)})}updateAgent(t,c){const r=this.g(t);if(!r?.impl)throw new Error(`No activated agent with id ${JSON.stringify(t)} registered`);r.data.metadata={...r.data.metadata,...c},this.d.fire(new i(r.data,r.impl))}getDefaultAgent(t){return this.getActivatedAgents().find(c=>!!c.isDefault&&c.locations.includes(t))}getContributedDefaultAgent(t){return this.getAgents().find(c=>!!c.isDefault&&c.locations.includes(t))}getSecondaryAgent(){return R.Iterable.find(this.b.values(),t=>!!t.data.metadata.isSecondary)?.data}g(t){return this.b.find(c=>c.data.id===t)}getAgent(t){return this.g(t)?.data}getAgents(){return this.b.map(t=>t.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(t=>!!t.impl).map(t=>new i(t.data,t.impl))}getAgentsByName(t){return this.getAgents().filter(c=>c.name===t)}async invokeAgent(t,c,r,a,f){const g=this.g(t);if(!g?.impl)throw new Error(`No activated agent with id ${t}`);return await g.impl.invoke(c,r,a,f)}async getFollowups(t,c,r,a,f){const g=this.g(t);if(!g?.impl)throw new Error(`No activated agent with id ${t}`);return g.impl?.provideFollowups?g.impl.provideFollowups(c,r,a,f):[]}};e.$jH=n,e.$jH=n=He([We(0,k.$Oj)],n);class i{constructor(t,c){this.b=t,this.d=c}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(t,c,r,a){return this.d.invoke(t,c,r,a)}async provideFollowups(t,c,r,a){return this.d.provideFollowups?this.d.provideFollowups(t,c,r,a):[]}provideWelcomeMessage(t,c){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(t,c)}provideSampleQuestions(t,c){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(t,c)}}e.$kH=i,e.$lH=(0,A.$wi)("chatAgentNameService");let u=class{static{d=this}static{this.b="chat.participantNameRegistry"}constructor(t,c,r,a){if(this.g=c,this.h=r,this.i=a,this.e=(0,b.$1d)(this,Object.create(null)),this.f=!1,!t.chatParticipantRegistry)return;this.d=t.chatParticipantRegistry;const f=a.get(d.b,-1);try{this.e.set(JSON.parse(f??"{}"),void 0)}catch{a.remove(d.b,-1)}this.j()}j(){this.f||this.k().catch(t=>this.h.warn("Failed to fetch chat participant registry",t)).then(()=>(0,h.$xh)(5*60*1e3)).then(()=>this.j())}async k(){const t=await this.g.request({type:"GET",url:this.d},N.CancellationToken.None);if(t.res.statusCode!==200)throw new Error("Could not get extensions report.");const c=await(0,y.$Tp)(t);if(!c||c.version!==1)throw new Error("Unexpected chat participant registry response.");const r=c.restrictedChatParticipants;this.e.set(r,void 0),this.i.store(d.b,JSON.stringify(r),-1,1)}getAgentNameRestriction(t){return this.e.map(r=>r[t.name.toLowerCase()]).map(r=>r?r.some(a=>(0,$.$xf)(a,a.includes(".")?t.extensionId.value:t.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$mH=u,e.$mH=u=d=He([We(0,p.$jk),We(1,y.$Np),We(2,I.$3j),We(3,v.$1p)],u)}),define(Se[297],De([1,0,2,29,5]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sG=e.$rG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$pG=R,e.$qG=M;function R(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof h.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(N.$ut.isIRange)}function M(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(R)}var b;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var $;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$rG=(0,O.$wi)("IChatService"),e.$sG="accessibility.voice.keywordActivation"}),define(Se[144],De([1,0,4,7,241]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2rb=void 0;class R{constructor(){this.f=new Map,this.m=[],this.n=new h.$de,this.o=new h.$de,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(b){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=b}onEvent(b){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=b}onRequest(b){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.u("response",b)}sendRequest(b,$,k,A){const I={command:b};if($&&Object.keys($).length>0&&(I.arguments=$),this.u("request",I),typeof A=="number"){const p=setTimeout(()=>{clearTimeout(p);const y=this.f.get(I.seq);if(y){this.f.delete(I.seq);const v={type:"response",seq:0,request_seq:I.seq,success:!1,command:b,message:(0,O.localize)(0,null,A,b)};y(v)}},A)}return k&&this.f.set(I.seq,k),I.seq}acceptMessage(b){this.k?this.k(b):(this.m.push(b),this.m.length===1&&this.s())}q(b,$){return b.type!=="event"||$.type!=="event"}async s(){let b;for(;this.m.length;){if((!b||this.q(this.m[0],b))&&await(0,N.$xh)(0),b=this.m.shift(),!b)return;switch(b.type){case"event":this.j?.(b);break;case"request":this.g?.(b);break;case"response":{const $=b,k=this.f.get($.request_seq);k&&(this.f.delete($.request_seq),k($));break}}}}u(b,$){$.type=b,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach(($,k)=>b.set(k,$)),await(0,N.$xh)(500),b.forEach(($,k)=>{$({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$2rb=R}),define(Se[298],De([1,0,2,242,38,5]),function(he,e,h,N,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$CJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$AJ=e.MemoryRangeType=e.State=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=void 0,e.$zJ=$,e.$BJ=A,e.$nI="workbench.view.debug",e.$oI="workbench.debug.variablesView",e.$pI="workbench.debug.watchExpressionsView",e.$qI="workbench.debug.callStackView",e.$rI="workbench.debug.loadedScriptsView",e.$sI="workbench.debug.breakPointsView",e.$tI="workbench.debug.disassemblyView",e.$uI="workbench.panel.repl",e.$vI="workbench.panel.repl.view",e.$wI=new O.$Nj("debugType",void 0,{type:"string",description:N.localize(0,null)}),e.$xI=new O.$Nj("debugConfigurationType",void 0,{type:"string",description:N.localize(1,null)}),e.$yI=new O.$Nj("debugState","inactive",{type:"string",description:N.localize(2,null)}),e.$zI="debugUx",e.$AI=new O.$Nj(e.$zI,"default",{type:"string",description:N.localize(3,null)}),e.$BI=new O.$Nj("hasDebugged",!1,{type:"boolean",description:N.localize(4,null)}),e.$CI=new O.$Nj("inDebugMode",!1,{type:"boolean",description:N.localize(5,null)}),e.$DI=new O.$Nj("inDebugRepl",!1,{type:"boolean",description:N.localize(6,null)}),e.$EI=new O.$Nj("breakpointWidgetVisible",!1,{type:"boolean",description:N.localize(7,null)}),e.$FI=new O.$Nj("inBreakpointWidget",!1,{type:"boolean",description:N.localize(8,null)}),e.$GI=new O.$Nj("breakpointsFocused",!0,{type:"boolean",description:N.localize(9,null)}),e.$HI=new O.$Nj("watchExpressionsFocused",!0,{type:"boolean",description:N.localize(10,null)}),e.$II=new O.$Nj("watchExpressionsExist",!1,{type:"boolean",description:N.localize(11,null)}),e.$JI=new O.$Nj("variablesFocused",!0,{type:"boolean",description:N.localize(12,null)}),e.$KI=new O.$Nj("expressionSelected",!1,{type:"boolean",description:N.localize(13,null)}),e.$LI=new O.$Nj("breakpointInputFocused",!1,{type:"boolean",description:N.localize(14,null)}),e.$MI=new O.$Nj("callStackItemType",void 0,{type:"string",description:N.localize(15,null)}),e.$NI=new O.$Nj("callStackSessionIsAttach",!1,{type:"boolean",description:N.localize(16,null)}),e.$OI=new O.$Nj("callStackItemStopped",!1,{type:"boolean",description:N.localize(17,null)}),e.$PI=new O.$Nj("callStackSessionHasOneThread",!1,{type:"boolean",description:N.localize(18,null)}),e.$QI=new O.$Nj("watchItemType",void 0,{type:"string",description:N.localize(19,null)}),e.$RI=new O.$Nj("canViewMemory",void 0,{type:"boolean",description:N.localize(20,null)}),e.$SI=new O.$Nj("breakpointItemType",void 0,{type:"string",description:N.localize(21,null)}),e.$TI=new O.$Nj("breakpointItemBytes",void 0,{type:"boolean",description:N.localize(22,null)}),e.$UI=new O.$Nj("breakpointHasModes",!1,{type:"boolean",description:N.localize(23,null)}),e.$VI=new O.$Nj("breakpointSupportsCondition",!1,{type:"boolean",description:N.localize(24,null)}),e.$WI=new O.$Nj("loadedScriptsSupported",!1,{type:"boolean",description:N.localize(25,null)}),e.$XI=new O.$Nj("loadedScriptsItemType",void 0,{type:"string",description:N.localize(26,null)}),e.$YI=new O.$Nj("focusedSessionIsAttach",!1,{type:"boolean",description:N.localize(27,null)}),e.$ZI=new O.$Nj("focusedSessionIsNoDebug",!1,{type:"boolean",description:N.localize(28,null)}),e.$1I=new O.$Nj("stepBackSupported",!1,{type:"boolean",description:N.localize(29,null)}),e.$2I=new O.$Nj("restartFrameSupported",!1,{type:"boolean",description:N.localize(30,null)}),e.$3I=new O.$Nj("stackFrameSupportsRestart",!1,{type:"boolean",description:N.localize(31,null)}),e.$4I=new O.$Nj("jumpToCursorSupported",!1,{type:"boolean",description:N.localize(32,null)}),e.$5I=new O.$Nj("stepIntoTargetsSupported",!1,{type:"boolean",description:N.localize(33,null)}),e.$6I=new O.$Nj("breakpointsExist",!1,{type:"boolean",description:N.localize(34,null)}),e.$7I=new O.$Nj("debuggersAvailable",!1,{type:"boolean",description:N.localize(35,null)}),e.$8I=new O.$Nj("debugExtensionAvailable",!0,{type:"boolean",description:N.localize(36,null)}),e.$9I=new O.$Nj("debugProtocolVariableMenuContext",void 0,{type:"string",description:N.localize(37,null)}),e.$0I=new O.$Nj("debugSetVariableSupported",!1,{type:"boolean",description:N.localize(38,null)}),e.$$I=new O.$Nj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:N.localize(39,null)}),e.$_I=new O.$Nj("debugSetExpressionSupported",!1,{type:"boolean",description:N.localize(40,null)}),e.$aJ=new O.$Nj("breakWhenValueChangesSupported",!1,{type:"boolean",description:N.localize(41,null)}),e.$bJ=new O.$Nj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:N.localize(42,null)}),e.$cJ=new O.$Nj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:N.localize(43,null)}),e.$dJ=new O.$Nj("terminateDebuggeeSupported",!1,{type:"boolean",description:N.localize(44,null)}),e.$eJ=new O.$Nj("suspendDebuggeeSupported",!1,{type:"boolean",description:N.localize(45,null)}),e.$fJ=new O.$Nj("variableEvaluateNamePresent",!1,{type:"boolean",description:N.localize(46,null)}),e.$gJ=new O.$Nj("variableIsReadonly",!1,{type:"boolean",description:N.localize(47,null)}),e.$hJ=new O.$Nj("variableValue",!1,{type:"string",description:N.localize(48,null)}),e.$iJ=new O.$Nj("variableType",!1,{type:"string",description:N.localize(49,null)}),e.$jJ=new O.$Nj("variableInterfaces",!1,{type:"array",description:N.localize(50,null)}),e.$kJ=new O.$Nj("variableName",!1,{type:"string",description:N.localize(51,null)}),e.$lJ=new O.$Nj("variableLanguage",!1,{type:"string",description:N.localize(52,null)}),e.$mJ=new O.$Nj("variableExtensionId",!1,{type:"string",description:N.localize(53,null)}),e.$nJ=new O.$Nj("exceptionWidgetVisible",!1,{type:"boolean",description:N.localize(54,null)}),e.$oJ=new O.$Nj("multiSessionRepl",!1,{type:"boolean",description:N.localize(55,null)}),e.$pJ=new O.$Nj("multiSessionDebug",!1,{type:"boolean",description:N.localize(56,null)}),e.$qJ=new O.$Nj("disassembleRequestSupported",!1,{type:"boolean",description:N.localize(57,null)}),e.$rJ=new O.$Nj("disassemblyViewFocus",!1,{type:"boolean",description:N.localize(58,null)}),e.$sJ=new O.$Nj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:N.localize(59,null)}),e.$tJ=new O.$Nj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:N.localize(60,null)});const M=i=>N.localize(61,null,i);e.$uJ=M,e.$vJ="editor.contrib.debug",e.$wJ="editor.contrib.breakpoint",e.$xJ="debug",e.$yJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:N.localize(62,null)};var b;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(b||(e.State=b={}));function $(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var k;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$AJ="vscode-debug-memory";function A(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var I;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(I||(e.DataBreakpointSetType=I={}));var p;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(p||(e.DebugConfigurationProviderTriggerKind=p={}));var y;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(y||(e.DebuggerString=y={})),e.$CJ=(0,R.$wi)("debugService");var v;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(v||(e.BreakpointWidgetContext=v={}));var l;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(l||(e.DebugVisualizationType=l={}));var d;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(d||(e.DebugTreeItemCollapsibleState=d={}));var o;(function(i){i.deserialize=u=>u,i.serialize=u=>u})(o||(e.IDebugVisualizationTreeItem=o={}));var n;(function(i){i.deserialize=u=>({id:u.id,name:u.name,iconPath:u.iconPath&&{light:h.URI.revive(u.iconPath.light),dark:h.URI.revive(u.iconPath.dark)},iconClass:u.iconClass,visualization:u.visualization}),i.serialize=u=>u})(n||(e.IDebugVisualization=n={}))}),define(Se[299],De([1,0,14,2,16,24,15,29,22,19]),function(he,e,h,N,O,R,M,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BH=void 0,e.$pH=I,e.$qH=p,e.$rH=y,e.$sH=v,e.$tH=l,e.$uH=d,e.$vH=o,e.$wH=i,e.$xH=t,e.$yH=c,e.$zH=a,e.$AH=g;const A=/{([^}]+)}/g;function I(S,m,E){return S.replace(A,function(D,C){return m&&C.length>0&&C[0]!=="_"?D:E&&E.hasOwnProperty(C)?E[C]:D})}function p(S){const m={};for(const E of Object.keys(S))E.startsWith("!")||(m[E]=S[E]);return m}function y(S){return S.configuration.request==="attach"&&!v(S)&&(!S.parentSession||y(S.parentSession))}function v(S){let m=S.configuration.type;if(m)return m==="vslsShare"&&(m=S.configuration.adapterProxy.configuration.type),(0,h.$xf)(m,"extensionhost")||(0,h.$xf)(m,"pwa-extensionhost")?S:S.parentSession?v(S.parentSession):void 0}function l(S){return S.type&&(S.label||S.program||S.runtime)}function d(S,m,E){let D,C=0;const P=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let F=null;for(;F=P.exec(S);){const T=F.index+1,z=T+F[0].length;if(T<=m&&z>=E){D=F[0],C=T;break}}if(D){const T=/\w+/g;let z=null;for(;(z=T.exec(D))&&!(z.index+1+C+z[0].length>=E););z&&(D=D.substring(0,T.lastIndex))}return D?{start:C,end:C+D.length-1}:{start:0,end:0}}async function o(S,m,E,D){if(S.evaluatableExpressionProvider.has(m)){const C=S.evaluatableExpressionProvider.ordered(m),P=(0,k.$Hb)(await Promise.all(C.map(async F=>{try{return await F.provideEvaluatableExpression(m,E,D??$.CancellationToken.None)}catch{return}})));if(P.length>0){let F=P[0].expression;const T=P[0].range;return F||(F=m.getLineContent(E.lineNumber).substring(T.startColumn-1,T.endColumn-1)),{range:T,matchingExpression:F}}}else{const C=m.getLineContent(E.lineNumber),{start:P,end:F}=d(C,E.column,E.column),T=C.substring(P-1,F);return{matchingExpression:T,range:new b.$ut(E.lineNumber,P,E.lineNumber,P+T.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(S){return!!(S&&S.match(n))}function u(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(i(S.path))return N.URI.parse(S.path);if((0,O.$ic)(S.path))return N.URI.file(S.path)}return S.path}function s(S){if(typeof S.path=="object"){const m=N.URI.revive(S.path);if(m)return m.scheme===M.Schemas.file?m.fsPath:m.toString()}return S.path}function t(S,m){const E=m?u:s,D=(0,R.$3n)(S);return r(D,(C,P)=>{C&&P&&(P.path=E(P))}),D}function c(S,m){const E=m?u:s,D=(0,R.$3n)(S);return r(D,(C,P)=>{!C&&P&&(P.path=E(P))}),D}function r(S,m){switch(S.type){case"event":{const E=S;switch(E.event){case"output":m(!1,E.body.source);break;case"loadedSource":m(!1,E.body.source);break;case"breakpoint":m(!1,E.body.breakpoint.source);break;default:break}break}case"request":{const E=S;switch(E.command){case"setBreakpoints":m(!0,E.arguments.source);break;case"breakpointLocations":m(!0,E.arguments.source);break;case"source":m(!0,E.arguments.source);break;case"gotoTargets":m(!0,E.arguments.source);break;case"launchVSCode":E.arguments.args.forEach(D=>m(!1,D));break;default:break}break}case"response":{const E=S;if(E.success&&E.body)switch(E.command){case"stackTrace":E.body.stackFrames.forEach(D=>m(!1,D.source));break;case"loadedSources":E.body.sources.forEach(D=>m(!1,D));break;case"scopes":E.body.scopes.forEach(D=>m(!1,D.source));break;case"setFunctionBreakpoints":E.body.breakpoints.forEach(D=>m(!1,D.source));break;case"setBreakpoints":E.body.breakpoints.forEach(D=>m(!1,D.source));break;case"disassemble":E.body?.instructions.forEach(C=>m(!1,C.location));break;default:break}break}}}function a(S){return S.filter(m=>!m.presentation?.hidden).sort((m,E)=>m.presentation?E.presentation?m.presentation.group?E.presentation.group?m.presentation.group!==E.presentation.group?m.presentation.group.localeCompare(E.presentation.group):f(m.presentation.order,E.presentation.order):-1:E.presentation.group?1:f(m.presentation.order,E.presentation.order):-1:E.presentation?1:0)}function f(S,m){return typeof S!="number"?typeof m!="number"?0:1:typeof m!="number"?-1:S-m}async function g(S,m){const E=S.getValue("debug.saveBeforeStart",{overrideIdentifier:m.activeTextEditorLanguageId});if(E!=="none"&&(await m.saveAll(),E==="allEditorsInActiveGroup")){const D=m.activeEditorPane;D&&D.input.resource?.scheme===M.Schemas.untitled&&await m.save({editor:D.input,groupId:D.group.id})}await S.reloadConfiguration()}const w=(S,m)=>!S||!m?S===m:S.name===m.name&&S.path===m.path&&S.sourceReference===m.sourceReference;e.$BH=w}),define(Se[300],De([1,0,54,63,24,16,12,14,32,243,144]),function(he,e,h,N,O,R,M,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Onc=e.$Nnc=e.$Mnc=e.$Lnc=e.$Knc=void 0;class I extends A.$2rb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(o,n){this.l=n,this.p=Buffer.allocUnsafe(0),this.r=-1,o.on("data",i=>this.v(i))}sendMessage(o){if(this.l){const n=JSON.stringify(o);this.l.write(`Content-Length: ${Buffer.byteLength(n,"utf8")}${I.a}${n}`,"utf8")}}v(o){for(this.p=Buffer.concat([this.p,o]);;){if(this.r>=0){if(this.p.length>=this.r){const n=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,n.length>0)try{this.acceptMessage(JSON.parse(n))}catch(i){this.n.fire(new Error((i.message||i)+`
`+n))}continue}}else{const n=this.p.indexOf(I.a);if(n!==-1){const u=this.p.toString("utf8",0,n).split(I.b);for(const s of u){const t=s.split(I.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(n+I.a.length);continue}}break}}}e.$Knc=I;class p extends I{startSession(){return new Promise((o,n)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),o(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):n(new Error("connection closed"))}),this.x.on("error",u=>{i?this.n.fire(u):n(u)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$Lnc=p;class y extends p{constructor(o){super(),this.z=o}y(o){return N.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$Mnc=y;class v extends p{constructor(o){super(),this.z=o}y(o){return N.createConnection(this.z.path,o)}}e.$Nnc=v;class l extends I{constructor(o,n){super(),this.y=o,this.z=n}async startSession(){const o=this.y.command,n=this.y.args,i=this.y.options||{};try{if(o)if(R.$ic(o)){if(!await $.Promises.exists(o))throw new Error(k.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.z));let u=process.env;if(i.env&&Object.keys(i.env).length>0&&(u=O.$6n(O.$3n(process.env),i.env)),o==="node")if(Array.isArray(n)&&n.length>0){const s=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:u,execArgv:s?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(t.cwd=i.cwd);const c=h.fork(n[0],n.slice(1),t);if(!c.pid)throw new Error(k.localize(2,null,n[0]));this.x=c}else throw new Error(k.localize(3,null));else{const s={env:u};i.cwd&&(s.cwd=i.cwd),this.x=h.spawn(o,n,s)}this.x.on("error",s=>{this.n.fire(s)}),this.x.on("exit",(s,t)=>{this.o.fire(s)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",s=>{this.n.fire(s)}),this.x.stdin.on("error",s=>{this.n.fire(s)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(u){this.n.fire(u)}}async stopSession(){return this.x?(await this.w(),M.$i?new Promise((o,n)=>{const i=h.exec(`taskkill /F /T /PID ${this.x.pid}`,function(u,s,t){if(u)return n(u)});i.on("exit",o),i.on("error",n)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,n){if(!o)return;const i=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?i.runtime=R.$jc(n,o.runtime):i.runtime=o.runtime),o.runtimeArgs&&(i.runtimeArgs=o.runtimeArgs),o.program&&(R.$ic(o.program)?i.program=o.program:i.program=R.$jc(n,o.program)),o.args&&(i.args=o.args);const u=o;return u.win&&(i.win=l.A(u.win,n)),u.winx86&&(i.winx86=l.A(u.winx86,n)),u.windows&&(i.windows=l.A(u.windows,n)),u.osx&&(i.osx=l.A(u.osx,n)),u.linux&&(i.linux=l.A(u.linux,n)),i}static platformAdapterExecutable(o,n){let i=Object.create(null);n=n.toLowerCase();for(const a of o)if(a.contributes){const f=a.contributes.debuggers;f&&f.length>0&&f.filter(g=>typeof g.type=="string"&&b.$xf(g.type,n)).forEach(g=>{const w=l.A(g,a.extensionLocation.fsPath);i=O.$6n(i,w,a.isBuiltin)})}let u;M.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?u=i.winx86||i.win||i.windows:M.$i?u=i.win||i.windows:M.$j?u=i.osx:M.$k&&(u=i.linux),u=u||i;const s=u.program||i.program,t=u.args||i.args,c=u.runtime||i.runtime,r=u.runtimeArgs||i.runtimeArgs;if(c)return{type:"executable",command:c,args:(r||[]).concat(typeof s=="string"?[s]:[]).concat(t||[])};if(s)return{type:"executable",command:s,args:t||[]}}}e.$Onc=l}),define(Se[301],De([1,0,54,31,12]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pnc=M,e.$Qnc=$;function R(k,A){return new Promise((I,p)=>{let y="";const v=h.spawn(k,A);v.pid&&v.stdout.on("data",l=>{y+=l.toString()}),v.on("error",l=>{p(l)}),v.on("close",l=>{I(y)})})}async function M(k){if(k)if(O.$i){const A=await new Promise((I,p)=>{he(["@vscode/windows-process-tree"],I,p)});return new Promise(I=>{A.getProcessTree(k,p=>{I(!!p&&p.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(k)]).then(A=>{const I=A.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}var b;(function(k){k[k.cmd=0]="cmd",k[k.powershell=1]="powershell",k[k.bash=2]="bash"})(b||(b={}));function $(k,A,I,p,y){k=k.trim().toLowerCase();let v;k.indexOf("powershell")>=0||k.indexOf("pwsh")>=0?v=1:k.indexOf("cmd.exe")>=0?v=0:k.indexOf("bash")>=0?v=2:O.$i?v=0:v=2;let l,d=" ";switch(v){case 1:if(l=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),p){const o=(0,N.$Bg)(p);o&&(d+=`${o}:; `),d+=`cd ${l(p)}; `}if(y)for(const o in y){const n=y[o];n===null?d+=`Remove-Item env:${o}; `:d+=`\${env:${o}}='${n}'; `}if(A.length>0){const o=A.shift(),n=I?o:l(o);d+=n[0]==="'"?`& ${n} `:`${n} `;for(const i of A)d+=i==="<"||i===">"||I?i:l(i),d+=" "}break;case 0:if(l=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(n=>o.includes(n))||o.length===0?`"${o}"`:o),p){const o=(0,N.$Bg)(p);o&&(d+=`${o}: && `),d+=`cd ${l(p)} && `}if(y){d+='cmd /C "';for(const o in y){let n=y[o];n===null?d+=`set "${o}=" && `:(n=n.replace(/[&^|<>]/g,i=>`^${i}`),d+=`set "${o}=${n}" && `)}}for(const o of A)d+=o==="<"||o===">"||I?o:l(o),d+=" ";y&&(d+='"');break;case 2:{l=n=>(n=n.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),n.length===0?'""':n);const o=n=>/[^\w@%\/+=,.:^-]/.test(n)?`'${n.replace(/'/g,"'\\''")}'`:n;if(p&&(d+=`cd ${l(p)} ; `),y){d+="/usr/bin/env";for(const n in y){const i=y[n];i===null?d+=` -u ${o(n)}`:d+=` ${o(`${n}=${i}`)}`}d+=" "}for(const n of A)d+=n==="<"||n===">"||I?n:l(n),d+=" ";break}}return d}}),define(Se[302],De([1,0,5]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UJ=e.CellExecutionUpdateType=void 0;var N;(function(O){O[O.Output=1]="Output",O[O.OutputItems=2]="OutputItems",O[O.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$UJ=(0,h.$wi)("INotebookExecutionService")}),define(Se[303],De([1,0,5]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cib=e.$Bib=e.ProxyKernelState=e.$Aib=void 0,e.$Aib=100;var N;(function(O){O[O.Disconnected=1]="Disconnected",O[O.Connected=2]="Connected",O[O.Initializing=3]="Initializing"})(N||(e.ProxyKernelState=N={})),e.$Bib=(0,h.$wi)("INotebookKernelService"),e.$Cib=(0,h.$wi)("INotebookKernelHistoryService")}),define(Se[304],De([1,0,3,29,205,100]),function(he,e,h,N,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yXb=void 0;class M extends h.$Uc{constructor($,k,A){super(),this._source=$,this.b=k,this.c=A,this.a=void 0}f($){const k=$.getLineCount();return new N.$ut(1,1,k,this.g($,k))}g($,k){if(k<1||k>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const $=new O.$2C;$.acceptChunk(this._source);const k=$.finish(!0),{textBuffer:A,disposable:I}=k.create(1);this.b=A,this.B(I)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const k=new O.$2C;k.acceptChunk($);const A=k.finish(!0),{textBuffer:I,disposable:p}=A.create(1);return this.B(p),I})),this.a}findInInputs($){const A=new R.$PC($,!1,!1,null).parseSearchRequest();if(!A)return[];const I=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(I,A,!0,5e3)}findInOutputs($){const A=new R.$PC($,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(I=>{const p=I.findMatchesLineByLine(this.f(I),A,!0,5e3);if(p.length!==0)return{textBuffer:I,matches:p}}).filter(I=>!!I):[]}}e.$yXb=M}),define(Se[69],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2K=e.TestPosition=e.TestIdPathParts=void 0;var h;(function(R){R.Delimiter="\0"})(h||(e.TestIdPathParts=h={}));var N;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class O{static fromExtHostTestItem(M,b,$=M.parent){if(M._isRoot)return new O([b]);const k=[M.id];for(let A=$;A&&A.id!==b;A=A.parent)k.push(A.id);return k.push(b),new O(k.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const b=M.indexOf("\0");return b===-1?M:M.slice(0,b)}static fromString(M){return new O(M.split("\0"))}static join(M,b){return new O([...M.path,b])}static joinToString(M,b){return M.toString()+"\0"+b}static parentId(M){const b=M.lastIndexOf("\0");return b===-1?void 0:M.slice(0,b)}static localId(M){const b=M.lastIndexOf("\0");return b===-1?M:M.slice(b+1)}static isChild(M,b){return b.startsWith(M)&&b[M.length]==="\0"}static compare(M,b){return M===b?0:O.isChild(M,b)?2:O.isChild(b,M)?3:1}constructor(M,b=M.length){if(this.path=M,this.d=b,M.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new O(this.path,1)}get parentId(){return this.d>1?new O(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new O(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new O(this.path,M)}compare(M){if(typeof M=="string")return O.compare(this.toString(),M);for(let b=0;b<M.d&&b<this.d;b++)if(M.path[b]!==this.path[b])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$2K=O}),define(Se[89],De([1,0,2,51,29,69]),function(he,e,h,N,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$K=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$0K=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$9K=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$8K=e.$7K=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$6K=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$5K=e.$4K=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$3K=e.TestResultState=void 0;var M;(function(L){L[L.Unset=0]="Unset",L[L.Queued=1]="Queued",L[L.Running=2]="Running",L[L.Passed=3]="Passed",L[L.Failed=4]="Failed",L[L.Skipped=5]="Skipped",L[L.Errored=6]="Errored"})(M||(e.TestResultState=M={})),e.$3K={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var b;(function(L){L[L.Run=1]="Run",L[L.Debug=2]="Debug",L[L.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var $;(function(L){L[L.Run=2]="Run",L[L.Debug=4]="Debug",L[L.Coverage=8]="Coverage",L[L.HasNonDefaultProfile=16]="HasNonDefaultProfile",L[L.HasConfigurable=32]="HasConfigurable",L[L.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$4K=[2,4,8,16,32,64];const k=L=>"runId"in L;e.$5K=k;var A;(function(L){L.serialize=j=>({range:j.range.toJSON(),uri:j.uri.toJSON()}),L.deserialize=(j,U)=>({range:O.$ut.lift(U.range),uri:j.asCanonicalUri(h.URI.revive(U.uri))})})(A||(e.IRichLocation=A={}));var I;(function(L){L[L.Error=0]="Error",L[L.Output=1]="Output"})(I||(e.TestMessageType=I={}));var p;(function(L){L.serialize=j=>({message:j.message,type:0,expected:j.expected,actual:j.actual,contextValue:j.contextValue,location:j.location&&A.serialize(j.location)}),L.deserialize=(j,U)=>({message:U.message,type:0,expected:U.expected,actual:U.actual,contextValue:U.contextValue,location:U.location&&A.deserialize(j,U.location)})})(p||(e.ITestErrorMessage=p={}));const y=(L,j)=>`${j?"s":"e"}${L}`;e.$6K=y;var v;(function(L){L.serialize=j=>({message:j.message,type:1,offset:j.offset,length:j.length,location:j.location&&A.serialize(j.location)}),L.deserialize=(j,U)=>({message:U.message,type:1,offset:U.offset,length:U.length,location:U.location&&A.deserialize(j,U.location)})})(v||(e.ITestOutputMessage=v={}));var l;(function(L){L.serialize=j=>j.type===0?p.serialize(j):v.serialize(j),L.deserialize=(j,U)=>U.type===0?p.deserialize(j,U):v.deserialize(j,U)})(l||(e.ITestMessage=l={}));var d;(function(L){L.serializeWithoutMessages=j=>({state:j.state,duration:j.duration,messages:[]}),L.serialize=j=>({state:j.state,duration:j.duration,messages:j.messages.map(l.serialize)}),L.deserialize=(j,U)=>({state:U.state,duration:U.duration,messages:U.messages.map(X=>l.deserialize(j,X))})})(d||(e.ITestTaskState=d={}));const o="\0",n=(L,j)=>L+o+j;e.$7K=n;const i=L=>{const j=L.indexOf(o);return{ctrlId:L.slice(0,j),tagId:L.slice(j+1)}};e.$8K=i;var u;(function(L){L.serialize=j=>({extId:j.extId,label:j.label,tags:j.tags,busy:j.busy,children:void 0,uri:j.uri?.toJSON(),range:j.range?.toJSON()||null,description:j.description,error:j.error,sortText:j.sortText}),L.deserialize=(j,U)=>({extId:U.extId,label:U.label,tags:U.tags,busy:U.busy,children:void 0,uri:U.uri?j.asCanonicalUri(h.URI.revive(U.uri)):void 0,range:U.range?O.$ut.lift(U.range):null,description:U.description,error:U.error,sortText:U.sortText})})(u||(e.ITestItem=u={}));var s;(function(L){L[L.NotExpandable=0]="NotExpandable",L[L.Expandable=1]="Expandable",L[L.BusyExpanding=2]="BusyExpanding",L[L.Expanded=3]="Expanded"})(s||(e.TestItemExpandState=s={}));var t;(function(L){L.serialize=j=>({expand:j.expand,item:u.serialize(j.item)}),L.deserialize=(j,U)=>({controllerId:R.$2K.root(U.item.extId),expand:U.expand,item:u.deserialize(j,U.item)})})(t||(e.InternalTestItem=t={}));var c;(function(L){L.serialize=j=>{let U;return j.item&&(U={},j.item.label!==void 0&&(U.label=j.item.label),j.item.tags!==void 0&&(U.tags=j.item.tags),j.item.busy!==void 0&&(U.busy=j.item.busy),j.item.uri!==void 0&&(U.uri=j.item.uri?.toJSON()),j.item.range!==void 0&&(U.range=j.item.range?.toJSON()),j.item.description!==void 0&&(U.description=j.item.description),j.item.error!==void 0&&(U.error=j.item.error),j.item.sortText!==void 0&&(U.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:U}},L.deserialize=j=>{let U;return j.item&&(U={},j.item.label!==void 0&&(U.label=j.item.label),j.item.tags!==void 0&&(U.tags=j.item.tags),j.item.busy!==void 0&&(U.busy=j.item.busy),j.item.range!==void 0&&(U.range=j.item.range?O.$ut.lift(j.item.range):null),j.item.description!==void 0&&(U.description=j.item.description),j.item.error!==void 0&&(U.error=j.item.error),j.item.sortText!==void 0&&(U.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:U}}})(c||(e.ITestItemUpdate=c={}));const r=(L,j)=>{j.expand!==void 0&&(L.expand=j.expand),j.item!==void 0&&(L.item=L.item?Object.assign(L.item,j.item):j.item)};e.$9K=r;var a;(function(L){L.serializeWithoutMessages=j=>({...t.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(d.serializeWithoutMessages)}),L.serialize=j=>({...t.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(d.serialize)}),L.deserialize=(j,U)=>({...t.deserialize(j,U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(X=>d.deserialize(j,X)),retired:!0})})(a||(e.TestResultItem=a={}));var f;(function(L){L.empty=()=>({covered:0,total:0}),L.sum=(j,U)=>{j.covered+=U.covered,j.total+=U.total}})(f||(e.ICoverageCount=f={}));var g;(function(L){L.serialize=j=>({id:j.id,statement:j.statement,branch:j.branch,declaration:j.declaration,uri:j.uri.toJSON()}),L.deserialize=(j,U)=>({id:U.id,statement:U.statement,branch:U.branch,declaration:U.declaration,uri:j.asCanonicalUri(h.URI.revive(U.uri))})})(g||(e.IFileCoverage=g={}));function w(L){return{...L,location:L.location?.toJSON()}}function S(L){return L.location=L.location?N.$tt.isIPosition(L.location)?N.$tt.lift(L.location):O.$ut.lift(L.location):void 0,L}e.$0K=3;var m;(function(L){L[L.Declaration=0]="Declaration",L[L.Statement=1]="Statement",L[L.Branch=2]="Branch"})(m||(e.DetailType=m={}));var E;(function(L){L.serialize=j=>j.type===0?C.serialize(j):P.serialize(j),L.deserialize=j=>j.type===0?C.deserialize(j):P.deserialize(j)})(E||(e.CoverageDetails=E={}));var D;(function(L){L.serialize=w,L.deserialize=S})(D||(e.IBranchCoverage=D={}));var C;(function(L){L.serialize=w,L.deserialize=S})(C||(e.IDeclarationCoverage=C={}));var P;(function(L){L.serialize=j=>({...w(j),branches:j.branches?.map(D.serialize)}),L.deserialize=j=>({...S(j),branches:j.branches?.map(D.deserialize)})})(P||(e.IStatementCoverage=P={}));var F;(function(L){L[L.Add=0]="Add",L[L.Update=1]="Update",L[L.DocumentSynced=2]="DocumentSynced",L[L.Remove=3]="Remove",L[L.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",L[L.Retire=5]="Retire",L[L.AddTag=6]="AddTag",L[L.RemoveTag=7]="RemoveTag"})(F||(e.TestDiffOpType=F={}));var T;(function(L){L.deserialize=(j,U)=>U.op===0?{op:U.op,item:t.deserialize(j,U.item)}:U.op===1?{op:U.op,item:c.deserialize(U.item)}:U.op===2?{op:U.op,uri:j.asCanonicalUri(h.URI.revive(U.uri)),docv:U.docv}:U,L.serialize=j=>j.op===0?{op:j.op,item:t.serialize(j.item)}:j.op===1?{op:j.op,item:c.serialize(j.item)}:j})(T||(e.TestsDiffOp=T={}));class z{constructor(j){this.k=j,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(j){const U=this.v();for(const X of j)switch(X.op){case 0:this.l(t.deserialize(this.k,X.item),U);break;case 1:this.o(c.deserialize(X.item),U);break;case 3:this.p(X.itemId,U);break;case 5:this.q(X.itemId);break;case 4:this.updatePendingRoots(X.amount);break;case 6:this.c.set(X.tag.id,X.tag);break;case 7:this.c.delete(X.id);break}U.complete?.()}l(j,U){const X=R.$2K.parentId(j.item.extId)?.toString();let ie;if(!X)ie=this.w(j),this.g.add(ie),this.f.set(j.item.extId,ie);else if(this.f.has(X)){const q=this.f.get(X);q.children.add(j.item.extId),ie=this.w(j,q),this.f.set(j.item.extId,ie)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(j)}`);return}return U.add?.(ie),j.expand===2&&this.h++,ie}o(j,U){const X=this.f.get(j.extId);if(X)return j.expand!==void 0&&(X.expand===2&&this.h--,j.expand===2&&this.h++),(0,e.$9K)(X,j),U.update?.(X),X}p(j,U){const X=this.f.get(j);if(!X)return;const ie=R.$2K.parentId(X.item.extId)?.toString();ie?this.f.get(ie).children.delete(X.item.extId):this.g.delete(X);const q=[[j]];for(;q.length;)for(const G of q.pop()){const x=this.f.get(G);x&&(q.push(x.children),this.f.delete(G),U.remove?.(x,x!==X),x.expand===2&&this.h--)}}q(j){}updatePendingRoots(j){this.j+=j}v(){return{}}}e.$$K=z}),define(Se[113],De([1,0,7,4,3,62,89,69]),function(he,e,h,N,O,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yO=e.$xO=e.$wO=e.$vO=e.$uO=e.TestItemEventOp=void 0;var $;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const k=(n,i)=>n===i,I=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:k,label:k,description:k,error:k,sortText:k,tags:(n,i)=>!(n.length!==i.length||n.some(u=>!i.includes(u)))}),p=(n,i)=>{let u;for(const[s,t]of I)t(n[s],i[s])||(u?u[s]=i[s]:u={[s]:i[s]});return u};class y extends O.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new h.$Ih(()=>this.flushDiff(),200)),this.g=this.B(new N.$de),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const u of this.tree.values())this.J(u)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const u of this.m)if(u.op===2&&u.uri===i.uri){u.docv=i.docv;return}break}case 1:{const u=this.m[this.m.length-1];if(u){if(u.op===1&&u.item.extId===i.item.extId){(0,M.$9K)(u.item,i.item);return}if(u.op===0&&u.item.item.extId===i.item.extId){(0,M.$9K)(u.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,u){const s=this.tree.get(i);if(s){if((s.expandLevels===void 0||u>s.expandLevels)&&(s.expandLevels=u),s.expand===1){const t=this.M(s);return t.isOpen()?this.L(s,u-1):t.wait().then(()=>this.L(s,u-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.L(s,u-1)):this.L(s,u-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,u){switch(u.op){case 3:this.O(b.$2K.joinToString(i.fullId,u.id));break;case 0:this.z(u.item,i);break;case 5:for(const s of u.ops)this.w(i,s);break;case 1:this.C(u.new,u.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:u.update}});break;case 6:this.y(i.actual.uri);break;default:(0,R.$ed)(u)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,u){const s=b.$2K.fromExtHostTestItem(i,this.root.id,u?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==u?.actual&&this.s.getChildren(t.parent).delete(i.id);let c=this.tree.get(s.toString());if(!c){c={fullId:s,actual:i,expandLevels:u?.expandLevels?u.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(c.fullId.toString(),c),this.G(i,u),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:c.expand,item:this.s.toITestItem(i)}}),this.I(i,c,u);return}if(c.actual===i){this.H(i,c,u);return}if(c.actual.uri?.toString()!==i.uri?.toString())return this.O(s.toString()),this.z(i,u);const r=this.s.getChildren(c.actual),a=c.actual,f=p(this.s.toITestItem(a),this.s.toITestItem(i));this.s.getApiFor(a).listener=void 0,c.actual=i,c.resolveBarrier=void 0,c.expand=0,f&&(f.hasOwnProperty("tags")&&(this.C(i.tags,a.tags,s.toString()),delete f.tags),this.w(c,{op:4,update:f})),this.I(i,c,u);for(const[w,S]of r)this.s.getChildren(i).get(S.id)||this.O(b.$2K.joinToString(s,S.id));const g=c.expandLevels;g!==void 0&&queueMicrotask(()=>{c.expand===1&&(c.expandLevels=void 0,this.expand(s.toString(),g))}),this.y(c.actual.uri)}C(i,u,s){const t=new Set(u.map(c=>c.id));for(const c of i)t.delete(c.id)||this.D(c);this.pushDiff({op:1,item:{extId:s,item:{tags:i.map(c=>(0,M.$7K)(this.s.controllerId,c.id))}}}),t.forEach(this.F,this)}D(i){const u=this.j.get(i.id);u?u.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$7K)(this.s.controllerId,i.id)}}))}F(i){const u=this.j.get(i);u&&!--u.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,M.$7K)(this.s.controllerId,i)}))}G(i,u){this.s.getApiFor(i).parent=u&&u.actual!==this.root?u.actual:void 0}H(i,u,s){this.G(i,s);const t=this.s.getApiFor(i);t.parent=s?.actual,t.listener=c=>this.w(u,c),this.J(u)}I(i,u,s){this.H(i,u,s);for(const[t,c]of this.s.getChildren(i))this.z(c,u)}J(i){let u;this.h?i.resolveBarrier?u=i.resolveBarrier.isOpen()?3:2:u=i.actual.canResolveChildren?1:0:u=0,u!==i.expand&&(i.expand=u,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:u}}),u===1&&i.expandLevels!==void 0&&this.M(i))}L(i,u){if(u<0)return;const s=[];for(const[t,c]of this.s.getChildren(i.actual)){const r=this.expand(b.$2K.joinToString(i.fullId,c.id),u);(0,h.$ih)(r)&&s.push(r)}if(s.length)return Promise.all(s).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const c=new h.$vh;return c.open(),c}i.expand=2,this.N(i);const u=i.resolveBarrier=new h.$vh,s=c=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,c)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(c){s(c)}return(0,h.$ih)(t)?t.catch(s).then(()=>{u.open(),this.J(i)}):(u.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const u=this.tree.get(i);if(!u)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const s=[u];for(;s.length;){const t=s.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const c of t.actual.tags)this.F(c.id);this.tree.delete(t.fullId.toString());for(const[c,r]of this.s.getChildren(t.actual))s.push(this.tree.get(b.$2K.joinToString(t.fullId,r.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$uO=y;class v extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$vO=v;class l extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$wO=l;class d extends Error{constructor(i,u,s){super(`TestItem with ID "${i}" is from controller "${u}" and cannot be added as a child of an item from controller "${s}".`)}}e.$xO=d;const o=(n,i,u)=>{let s=new Map;return{get size(){return s.size},forEach(t,c){for(const r of s.values())t.call(c,r,this)},[Symbol.iterator](){return s.entries()},replace(t){const c=new Map,r=new Set(s.keys()),a={op:5,ops:[]};for(const f of t){if(!(f instanceof u))throw new l(f.id);const g=i(f).controllerId;if(g!==n.controllerId)throw new d(f.id,g,n.controllerId);if(c.has(f.id))throw new v(f.id);c.set(f.id,f),r.delete(f.id),a.ops.push({op:0,item:f})}for(const f of r.keys())a.ops.push({op:3,id:f});n.listener?.(a),s=c},add(t){if(!(t instanceof u))throw new l(t.id);s.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){s.delete(t)&&n.listener?.({op:3,id:t})},get(t){return s.get(t)},toJSON(){return Array.from(s.values())}}};e.$yO=o}),define(Se[145],De([1,0,113]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AO=e.$zO=void 0;const N=new WeakMap,O=(M,b)=>{const $={controllerId:b};return N.set(M,$),$};e.$zO=O;const R=M=>{const b=N.get(M);if(!b)throw new h.$wO(M?.id||"<unknown>");return b};e.$AO=R}),define(Se[114],De([1,0,15,2]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UAb=e.$TAb=e.$SAb=void 0,e.$VAb=O,e.$WAb=M,e.$SAb="vscode-cdn.net",e.$TAb=`vscode-resource.${e.$SAb}`,e.$UAb=`'self' https://*.${e.$SAb}`;function O(b,$){return b.scheme===h.Schemas.http||b.scheme===h.Schemas.https?b:($&&$.authority&&$.isRemote&&b.scheme===h.Schemas.file&&(b=N.URI.from({scheme:h.Schemas.vscodeRemote,authority:$.authority,path:b.path})),N.URI.from({scheme:h.Schemas.https,authority:`${b.scheme}+${R(b.authority)}.${e.$TAb}`,path:b.path,fragment:b.fragment,query:b.query}))}function R(b){return b.replace(/./g,$=>{const k=$.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?$:"-"+k.toString(16).padStart(4,"0")})}function M(b){return b.replace(/-([0-9a-f]{4})/g,($,k)=>String.fromCharCode(parseInt(k,16)))}}),define(Se[305],De([1,0,4,3,114]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=void 0;class R{constructor(b,$,k){this.d=b,this.e=$,this.f=k,this.a=0,this.b=new N.$Tc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const A=$.getVisibleTextEditors();for(const I of this.c.values())A.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,$,k,A,I){let p;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===b){p=i;break}if(!p)throw new Error("not a visible editor");const y=this,v=this.a++,l=new h.$de,d=new h.$de,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,O.$VAb)(i,y.f)}get cspSource(){return O.$UAb}set options(i){this.b=i,y.d.$setOptions(v,i)}get options(){return this.b}set html(i){this.a=i,y.d.$setHtml(v,i)}get html(){return this.a}get onDidReceiveMessage(){return l.event}postMessage(i){return y.d.$postMessage(v,i)}},n=new class{constructor(){this.editor=b,this.line=$,this.height=k,this.webview=o,this.onDidDispose=d.event}dispose(){y.c.has(v)&&(y.c.delete(v),y.d.$disposeEditorInset(v),d.fire(),d.dispose(),l.dispose())}};return this.d.$createEditorInset(v,p.id,p.value.document.uri,$+1,k,A||{},I.identifier,I.extensionLocation),this.c.set(v,{editor:b,inset:n,onDidReceiveMessage:l}),n}$onDidDispose(b){const $=this.c.get(b);$&&$.inset.dispose()}$onDidReceiveMessage(b,$){this.c.get(b)?.onDidReceiveMessage.fire($)}}e.$Mlc=R}),define(Se[146],De([1,0,5]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hL=e.$gL=e.$fL=void 0,e.$fL="__",e.$gL=(0,h.$wi)("IAuthenticationService"),e.$hL=(0,h.$wi)("IAuthenticationExtensionsService")}),define(Se[306],De([1,0,5]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tP=e.VariableKind=e.$sP=void 0,e.$sP=(0,h.$wi)("configurationResolverService");var N;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(N||(e.VariableKind=N={}));class O extends Error{constructor(M,b){super(b),this.variable=M}}e.$tP=O}),define(Se[307],De([1,0,16,52,18,24,12,103,246,306,14]),function(he,e,h,N,O,R,M,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IP=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(y,v,l,d){this.h=new Map,this.a=y,this.b=v,this.g=l,d&&(this.c=d.then(o=>this.i(o)))}i(y){if(M.$i){const v=Object.create(null);return Object.keys(y).forEach(l=>{v[l.toLowerCase()]=y[l]}),v}return y}resolveWithEnvironment(y,v,l){return this.l({env:this.i(y),userHome:void 0},v?v.uri:void 0,l)}async resolveAsync(y,v){const l={env:await this.c,userHome:await this.g};return this.l(l,y?y.uri:void 0,v)}async j(y,v,l,d){const o=R.$3n(v);M.$i&&o.windows?Object.keys(o.windows).forEach(i=>o[i]=o.windows[i]):M.$j&&o.osx?Object.keys(o.osx).forEach(i=>o[i]=o.osx[i]):M.$k&&o.linux&&Object.keys(o.linux).forEach(i=>o[i]=o.linux[i]),delete o.windows,delete o.osx,delete o.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,y?y.uri:void 0,o,l,d)}async resolveAnyAsync(y,v,l){return this.j(y,v,l)}async resolveAnyMap(y,v,l){const d=new Map;return{newConfig:await this.j(y,v,l,d),resolvedVariables:d}}resolveWithInteractionReplace(y,v,l,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,v,l,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,v){if(this.h.has(y))throw new Error("Variable "+y+" is contributed twice.");this.h.set(y,v)}async l(y,v,l,d,o){if(O.$9f(l))return this.m(y,v,l,d,o);if(Array.isArray(l))return Promise.all(l.map(n=>this.l(y,v,n,d,o)));if(O.$$f(l)){const n=Object.create(null),i=await Promise.all(Object.keys(l).map(async u=>[await this.m(y,v,u,d,o),await this.l(y,v,l[u],d,o)]));for(const[u,s]of i)n[u]=s;return n}return l}m(y,v,l,d,o){return(0,A.$pf)(l,I.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(I.VARIABLE_LHS))return n;let u=await this.o(y,n,i,v,d);return o?.set(i,u),u!==n&&O.$9f(u)&&u.match(I.VARIABLE_REGEXP)&&(u=await this.m(y,v,u,d,o)),u})}n(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async o(y,v,l,d,o){let n;const i=l.split(":");i.length>1&&(l=i[0],n=i[1]);const u=c=>{const r=this.a.getFilePath();if(r)return(0,b.$Ew)(r);throw new k.$tP(c,(0,$.localize)(0,null,v))},s=c=>{const r=u(c);if(this.a.getWorkspaceFolderPathForFile){const a=this.a.getWorkspaceFolderPathForFile();if(a)return(0,b.$Ew)(a)}throw new k.$tP(c,(0,$.localize)(1,null,v,h.$nc(r)))},t=c=>{if(n){const r=this.a.getFolderUri(n);if(r)return r;throw new k.$tP(c,(0,$.localize)(2,null,v,n))}if(d)return d;throw this.a.getWorkspaceFolderCount()>1?new k.$tP(c,(0,$.localize)(3,null,v)):new k.$tP(c,(0,$.localize)(4,null,v))};switch(l){case"env":if(n){if(y.env){const c=y.env[M.$i?n.toLowerCase():n];if(O.$9f(c))return c}return""}throw new k.$tP(k.VariableKind.Env,(0,$.localize)(5,null,v));case"config":if(n){const c=this.a.getConfigurationValue(d,n);if(O.$fg(c))throw new k.$tP(k.VariableKind.Config,(0,$.localize)(6,null,v,n));if(O.$$f(c))throw new k.$tP(k.VariableKind.Config,(0,$.localize)(7,null,v,n));return c}throw new k.$tP(k.VariableKind.Config,(0,$.localize)(8,null,v));case"command":return this.p(k.VariableKind.Command,v,n,o,"command");case"input":return this.p(k.VariableKind.Input,v,n,o,"input");case"extensionInstallFolder":if(n){const c=await this.a.getExtension(n);if(!c)throw new k.$tP(k.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,v,n));return this.n(c.extensionLocation)}throw new k.$tP(k.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,v));default:switch(l){case"workspaceRoot":case"workspaceFolder":return(0,b.$Ew)(this.n(t(k.VariableKind.WorkspaceFolder)));case"cwd":return d||n?(0,b.$Ew)(this.n(t(k.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$Ew)(h.$nc(this.n(t(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new k.$tP(k.VariableKind.UserHome,(0,$.localize)(11,null,v))}case"lineNumber":{const c=this.a.getLineNumber();if(c)return c;throw new k.$tP(k.VariableKind.LineNumber,(0,$.localize)(12,null,v))}case"selectedText":{const c=this.a.getSelectedText();if(c)return c;throw new k.$tP(k.VariableKind.SelectedText,(0,$.localize)(13,null,v))}case"file":return u(k.VariableKind.File);case"fileWorkspaceFolder":return s(k.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return h.$nc(s(k.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return d||n?h.$lc(this.n(t(k.VariableKind.RelativeFile)),u(k.VariableKind.RelativeFile)):u(k.VariableKind.RelativeFile);case"relativeFileDirname":{const c=h.$mc(u(k.VariableKind.RelativeFileDirname));if(d||n){const r=h.$lc(this.n(t(k.VariableKind.RelativeFileDirname)),c);return r.length===0?".":r}return c}case"fileDirname":return h.$mc(u(k.VariableKind.FileDirname));case"fileExtname":return h.$oc(u(k.VariableKind.FileExtname));case"fileBasename":return h.$nc(u(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const c=h.$nc(u(k.VariableKind.FileBasenameNoExtension));return c.slice(0,c.length-h.$oc(c).length)}case"fileDirnameBasename":return h.$nc(h.$mc(u(k.VariableKind.FileDirnameBasename)));case"execPath":{const c=this.a.getExecPath();return c||v}case"execInstallFolder":{const c=this.a.getAppRoot();return c||v}case"pathSeparator":case"/":return h.sep;default:try{const c=n?`${l}:${n}`:l;return this.p(k.VariableKind.Unknown,v,c,o,void 0)}catch{return v}}}}p(y,v,l,d,o){if(l&&d){const n=o===void 0?d[l]:d[o+":"+l];if(typeof n=="string")return n;throw new k.$tP(y,(0,$.localize)(14,null,v))}return v}}e.$IP=I}),define(Se[147],De([1,0,5,143]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$YD=void 0,e.$ZD=k,e.$1D=p,e.$2D=y,e.$YD=(0,h.$wi)("editorGroupsService");var O;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(O||(e.GroupDirection=O={}));var R;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var M;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var b;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var $;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function k(v){const l=v;return(0,N.$JF)(l?.editor)&&(0,N.$JF)(l?.replacement)}var A;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var I;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function p(v){const l=v;return!!l&&typeof l.id=="number"&&Array.isArray(l.editors)}function y(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Se[308],De([1,0,5,147]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6D=e.$5D=e.$4D=e.$3D=void 0,e.$7D=O,e.$3D=(0,h.$wi)("editorService"),e.$4D=-1,e.$5D=-2,e.$6D=-3;function O(R){const M=R;return typeof R=="number"||(0,N.$1D)(M)}}),define(Se[148],De([1,0,5,137]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AL=void 0,e.$AL=(0,h.$xi)(N.$Di)}),define(Se[149],De([1,0,25,4,16,3,7]),function(he,e,h,N,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0_b=e.$9_b=e.$8_b=e.$7_b=e.$6_b=void 0;class b{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$6_b=b;class ${static isHostExtension(n,i,u){if(i.getExtensionDescription(n))return!1;const s=u.getExtensionDescription(n);return s?!!((s.main||s.browser)&&s.api==="none"):!1}constructor(n,i){this.j=n,this.c=new N.$de,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(l),this.f=new h.$Tm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const u of i)this.h.has(u)||this.h.set(u,[]),this.h.get(u).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=d(this.e,i),this.e=this.e.concat(n);const u=$.l(this.e);return this.e=d(this.e,u.map(s=>s.identifier)),this.k(),this.d++,this.c.fire(void 0),new b(this.d,u)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,a){this.addNode(r),this.addNode(a),this.c.has(r)?this.c.get(r).push(a):this.c.set(r,[a])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,a){const f=i.getArcs(r);for(let g=0;g<f.length;g++)if(!a.has(f[g]))return!1;return!0}getNodes(){return this.e}},u=new h.$Tm;for(const r of n)if(u.set(r.identifier,r),r.extensionDependencies)for(const a of r.extensionDependencies)i.addArc(h.$Rm.toKey(r.identifier),h.$Rm.toKey(a));const s=new Set;i.getNodes().filter(r=>i.getArcs(r).length===0).forEach(r=>s.add(r));const t=i.getNodes().filter(r=>!s.has(r));let c;do{c=!1;for(let r=0;r<t.length;r++){const a=t[r];i.hasOnlyGoodArcs(a,s)&&(t.splice(r,1),r--,s.add(a),c=!0)}}while(c);return t.map(r=>u.get(r))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$7_b=$;class k{constructor(n,i){this.versionId=n,this.extensions=i}}e.$8_b=k;class A{constructor(n){this.d=new y,this.c=new $(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new I(this,i)}deltaExtensions(n,i,u){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,u)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$9_b=A;class I extends R.$Uc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$0_b=I;class p{constructor(n){this.name=n;const i=(0,M.$ph)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class y{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new p(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const u=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),s=()=>{i&&(clearTimeout(u),i=!1,this.d=!1,this.e())};n.resolve((0,R.$Sc)(s))}}var v;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(v||(v={}));function l(o,n){const i=o.isBuiltin?0:o.isUnderDevelopment?2:1,u=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==u)return i-u;const s=O.$gc.basename(o.extensionLocation.path),t=O.$gc.basename(n.extensionLocation.path);return s<t?-1:s>t?1:0}function d(o,n){const i=new h.$Sm(n);return o.filter(u=>!i.has(u.identifier))}}),define(Se[309],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=e.$ln=e.$kn=e.ExtHostConnectionType=void 0,e.$nn=b,e.$on=$;var h;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(h||(e.ExtHostConnectionType=h={}));class N{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[N.ENV_KEY]=this.pipeName}}e.$kn=N;class O{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[O.ENV_KEY]="1"}}e.$ln=O;class R{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[R.ENV_KEY]="1"}}e.$mn=R;function M(A){delete A[N.ENV_KEY],delete A[O.ENV_KEY],delete A[R.ENV_KEY]}function b(A,I){M(I),A.serialize(I)}function $(A){if(A[N.ENV_KEY])return k(A,new N(A[N.ENV_KEY]));if(A[O.ENV_KEY])return k(A,new O);if(A[R.ENV_KEY])return k(A,new R);throw new Error("No connection information defined in environment!")}function k(A,I){return M(A),I}}),define(Se[115],De([1,0,21]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Zm=M,e.$1m=b;var N;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(N||(e.UIKind=N={}));var O;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(O||(e.ExtensionHostExitCode=O={}));var R;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function M(k){const A=h.$Fe.alloc(1);switch(k){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}function b(k,A){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}var $;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Se[90],De([1,0,5,4,11,28,115,86,87,24,2,3,231]),function(he,e,h,N,O,R,M,b,$,k,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YO=e.$WO=e.$VO=void 0,e.$XO=l;let y=class extends I.$Uc{constructor(o,n){super(),this.s=o,this.t=n,this.a=this.B(new N.$de),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$de),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:$.$kp,name:(0,p.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,O.$5j)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===O.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,n,i){const u=this.getTelemetryDetails(),s=new v(n,i,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,s]),s.apiTelemetryLogger}$initializeTelemetryLevel(o,n,i){this.f=o,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const n=Object.create(null);switch(n["common.extname"]=`${o.publisher}.${o.name}`,n["common.extversion"]=o.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=l(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:n["common.uikind"]="web";break;case M.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,b.$Im)((0,$.$qp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const n=this.getTelemetryDetails();this.r.forEach((i,u)=>{const s=i.filter(t=>!t.isDisposed);s.length===0?this.r.delete(u):this.r.set(u,s)}),this.r.forEach(i=>{for(const u of i)u.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,n){const u=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!u)return this.r.delete(o.value),!1;let s=!1;for(const t of u)t.ignoreUnhandledExtHostErrors||(t.logError(n),s=!0);return s}};e.$VO=y,e.$VO=y=He([We(0,R.$UO),We(1,O.$4j)],y);class v{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,n,i,u,s,t,c){this.g=i,this.h=u,this.i=s,this.j=t,this.a=new N.$de,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}}updateTelemetryEnablements(o,n){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let n="properties"in o?o.properties??{}:o;return n=(0,$.$tp)(n,[]),this.c&&(n=(0,k.$6n)(n,this.c)),this.b||(n=(0,k.$6n)(n,this.j)),"properties"in o?o.properties=n:o=n,o}k(o,n){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(o,n),this.h.trace(o,n))}logUsage(o,n){this.d.isUsageEnabled&&this.k(o,n)}logError(o,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,n);else{const i={name:o.name,message:o.message,stack:o.stack,cause:o.cause},u=(0,$.$tp)(i,[]),s=new Error(u.message,{cause:u.cause});s.stack=u.stack,s.name=u.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(s,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const o=this,n={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$WO=v;function l(d){const o=Date.now()-new Date(d).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$YO=(0,h.$wi)("IExtHostTelemetry")}),define(Se[26],De([1,0,4,2,278,140,25,5]),function(he,e,h,N,O,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UG=e.ActivationKind=e.$RG=e.$QG=e.$NG=e.ExtensionHostStartup=e.$MG=e.$LG=e.$KG=e.$JG=void 0,e.$OG=p,e.$PG=y,e.$SG=o,e.$TG=n,e.$JG=Object.freeze({identifier:new M.$Rm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$KG="extensions.webWorker",e.$LG=(0,b.$wi)("extensionService");class ${constructor(s){this.dependency=s}}e.$MG=$;var k;(function(u){u[u.EagerAutoStart=1]="EagerAutoStart",u[u.EagerManualStart=2]="EagerManualStart",u[u.Lazy=3]="Lazy"})(k||(e.ExtensionHostStartup=k={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(s,t,c){this.c=s,this.d=t.slice(0),this.e=c.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$uG.createActivationEventsMap(this.d)}}set(s,t,c){if(this.c>s)throw new Error(`ExtensionHostExtensions: invalid versionId ${s} (current: ${this.c})`);const r=[],a=[],f=[],g=[],w=I(this.d),S=I(t),m=(F,T)=>F.extensionLocation.toString()===T.extensionLocation.toString()||F.isBuiltin===T.isBuiltin||F.isUserBuiltin===T.isUserBuiltin||F.isUnderDevelopment===T.isUnderDevelopment;for(const F of this.d){const T=S.get(F.identifier);if(!T){r.push(F.identifier),w.delete(F.identifier);continue}if(!m(F,T)){r.push(F.identifier),w.delete(F.identifier);continue}}for(const F of t){const T=w.get(F.identifier);if(!T){a.push(F);continue}if(!m(T,F)){r.push(T.identifier),w.delete(T.identifier);continue}}const E=new M.$Sm(this.e),D=new M.$Sm(c);for(const F of this.e)D.has(F)||f.push(F);for(const F of c)E.has(F)||g.push(F);const C=R.$uG.createActivationEventsMap(a),P={versionId:s,toRemove:r,toAdd:a,addActivationEvents:C,myToRemove:f,myToAdd:g};return this.delta(P),P}delta(s){if(this.c>=s.versionId)return null;const{toRemove:t,toAdd:c,myToRemove:r,myToAdd:a}=s,f=new M.$Sm(t),g=new M.$Sm(r);for(let w=0;w<this.d.length;w++)f.has(this.d[w].identifier)&&(this.d.splice(w,1),w--);for(let w=0;w<this.e.length;w++)g.has(this.e[w])&&(this.e.splice(w,1),w--);for(const w of c)this.d.push(w);for(const w of a)this.e.push(w);return this.f=null,s}containsExtension(s){for(const t of this.e)if(M.$Rm.equals(t,s))return!0;return!1}containsActivationEvent(s){return this.f||(this.f=this.g()),this.f.has(s)}g(){const s=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const c=R.$uG.readActivationEvents(t);for(const r of c)s.add(r)}return s}}e.$NG=A;function I(u){const s=new M.$Tm;for(const t of u)s.set(t.identifier,t);return s}function p(u,s){return u.enabledApiProposals?u.enabledApiProposals.includes(s):!1}function y(u,s){if(!p(u,s))throw new Error(`Extension '${u.identifier.value}' CANNOT use API proposal: ${s}.
Its package.json#enabledApiProposals-property declares: ${u.enabledApiProposals?.join(", ")??"[]"} but NOT ${s}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${u.identifier.value}`)}class v{constructor(s,t,c,r){this.codeLoadingTime=s,this.activateCallTime=t,this.activateResolvedTime=c,this.activationReason=r}}e.$QG=v;class l{constructor(s,t){this.description=s,this.value=t}}e.$RG=l;var d;(function(u){u[u.Normal=0]="Normal",u[u.Immediate=1]="Immediate"})(d||(e.ActivationKind=d={}));function o(u){return{type:u.isBuiltin?0:1,isBuiltin:u.isBuiltin||u.isUserBuiltin,identifier:{id:(0,O.$zp)(u.publisher,u.name),uuid:u.uuid},manifest:u,location:u.extensionLocation,targetPlatform:u.targetPlatform,validations:[],isValid:!0}}function n(u,s){return{identifier:new M.$Rm((0,O.$xp)(u.manifest.publisher,u.manifest.name)),isBuiltin:u.type===0,isUserBuiltin:u.type===1&&u.isBuiltin,isUnderDevelopment:!!s,extensionLocation:u.location,...u.manifest,uuid:u.identifier.uuid,targetPlatform:u.targetPlatform,publisherDisplayName:u.publisherDisplayName}}class i{constructor(){this.onDidRegisterExtensions=h.Event.None,this.onDidChangeExtensionsStatus=h.Event.None,this.onDidChangeExtensions=h.Event.None,this.onWillActivateByEvent=h.Event.None,this.onDidChangeResponsiveChange=h.Event.None,this.onWillStop=h.Event.None,this.extensions=[]}activateByEvent(s){return Promise.resolve(void 0)}activateById(s,t){return Promise.resolve(void 0)}activationEventIsDone(s){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(s){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(s,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(s){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$UG=i}),define(Se[310],De([1,0,13,149,25,26,11,7]),function(he,e,h,N,O,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=e.$amc=e.$_lc=e.$$lc=e.$0lc=e.$9lc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(o,n,i,u){this.startup=o,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=u}}e.$9lc=$;class k{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,n){return o===-1||n===-1?-1:n-o}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$0lc=k;class A{constructor(o,n,i,u,s,t){this.activationFailed=o,this.activationFailedError=n,this.activationTimes=i,this.module=u,this.exports=s,this.subscriptions=t}}e.$$lc=A;class I extends A{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$_lc=I;class p extends A{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$amc=p;class y extends A{constructor(o){super(!0,o,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(o,n,i,u){this.g=u,this.a=o,this.b=n,this.c=i,this.d=new O.$Tm,this.f=Object.create(null)}dispose(){for(const[o,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const o=[];for(const[n,i]of this.d)o.push(i.wait());await Promise.all(o)}isActivated(o){const n=this.d.get(o);return!!(n&&n.value)}getActivatedExtension(o){const n=this.d.get(o);if(!n||!n.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return n.value}async activateByEvent(o,n){if(this.f[o])return;const i=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(i.map(u=>({id:u.identifier,reason:{startup:n,extensionId:u.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,n){const i=this.a.getExtensionDescription(o);if(!i)throw new Error(`Extension '${o.value}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(o){const n=o.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const n=this.a.getExtensionDescription(o.id);if(!n){const s=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new y(s));return this.c.onExtensionActivationError(o.id,s,new R.$MG(o.id.value)),t}const i=[],u=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const s of u){if(this.m(s))continue;const t=this.d.get(s);if(t){i.push(t);continue}if(this.l(s)){i.push(this.j({id:this.b.getExtensionDescription(s).identifier,reason:o.reason}));continue}const c=this.a.getExtensionDescription(s);if(c){if(!c.main&&!c.browser)continue;i.push(this.j({id:c.identifier,reason:o.reason}));continue}const r=n.displayName||n.identifier.value,a=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${s}'`),f=this.k(o,n.displayName,[],new y(a));return this.c.onExtensionActivationError(n.identifier,a,new R.$MG(s)),f}return this.k(o,n.displayName,i,null)}k(o,n,i,u){const s=new l(o.id,n,o.reason,i,u,this.c,this.g);return this.d.set(o.id,s),s}l(o){return N.$7_b.isHostExtension(o,this.a,this.b)}m(o){const n=this.b.getExtensionDescription(o);return n?!n.main&&!n.browser:!1}};e.$bmc=v,e.$bmc=v=He([We(3,M.$3j)],v);let l=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,n,i,u,s,t,c){this.c=o,this.d=n,this.f=i,this.g=u,this.h=s,this.j=t,this.k=c,this.a=new b.$vh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const n=this.g[o];if(n.value&&!n.value.activationFailed){this.g.splice(o,1),o--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new y(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const n=new Error;if(o&&o.name&&(n.name=o.name),o&&o.message?n.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(n.stack=o.stack),this.h=new y(n),this.b&&h.$4(o))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};l=He([We(6,M.$3j)],l)}),define(Se[311],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testPreserveFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testPreserveFocus.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[312],De([1,0,248,13,41,138,110,36,25,311,108,140]),function(he,e,h,N,O,R,M,b,$,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=void 0;const p=b.$co.as(M.$do.JSONContribution);class y{constructor(s,t,c){this.a=s,this.b=t,this.c=c}d(s,t){this.a({type:s,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(s){this.d(O.default.Error,s)}warn(s){this.d(O.default.Warning,s)}info(s){this.d(O.default.Info,s)}}e.$DG=y;class v{static a(s){const t=new $.$Sm;for(let c=0,r=s.length;c<r;c++)t.add(s[c].description.identifier);return t}static compute(s,t){if(!s||!s.length)return new v(t,[]);if(!t||!t.length)return new v([],s);const c=this.a(s),r=this.a(t),a=t.filter(g=>!c.has(g.description.identifier)),f=s.filter(g=>!r.has(g.description.identifier));return new v(a,f)}constructor(s,t){this.added=s,this.removed=t}}e.$EG=v;class l{constructor(s,t){this.name=s,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(s){if(this.a!==null)throw new Error("Handler already set!");this.a=s,this.d()}acceptUsers(s){this.c=v.compute(this.b,s),this.b=s,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(s){(0,N.$1)(s)}}}e.$FG=l;const d={type:"string",enum:["ui","workspace"],enumDescriptions:[h.localize(0,null),h.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$GG={properties:{engines:{type:"object",description:h.localize(2,null),properties:{vscode:{type:"string",description:h.localize(3,null),default:"^1.22.0"}}},publisher:{description:h.localize(4,null),type:"string"},displayName:{description:h.localize(5,null),type:"string"},categories:{description:h.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$Qm},{type:"string",const:"Languages",deprecationMessage:h.localize(7,null)}]}},galleryBanner:{type:"object",description:h.localize(8,null),properties:{color:{description:h.localize(9,null),type:"string"},theme:{description:h.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:h.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:h.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:h.localize(13,null)},enabledApiProposals:{markdownDescription:h.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:h.localize(15,null),type:"string",enum:["none"],enumDescriptions:[h.localize(16,null)]},activationEvents:{description:h.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:h.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:h.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:h.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:h.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:h.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:h.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:h.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:h.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:h.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:h.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:h.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:h.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:h.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:h.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:h.localize(32,null)},{label:"onUri",body:"onUri",description:h.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:h.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:h.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:h.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:h.localize(37,null)},{label:"onRenderer",description:h.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:h.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:h.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:h.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:h.localize(42,null)},{label:"*",description:h.localize(43,null),body:"*"}]}},badges:{type:"array",description:h.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:h.localize(45,null)},href:{type:"string",description:h.localize(46,null)},description:{type:"string",description:h.localize(47,null)}}}},markdown:{type:"string",description:h.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:h.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:h.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$To}},extensionPack:{description:h.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$To}},extensionKind:{description:h.localize(52,null),type:"array",items:d,default:["workspace"],defaultSnippets:[{body:["ui"],description:h.localize(53,null)},{body:["workspace"],description:h.localize(54,null)},{body:["ui","workspace"],description:h.localize(55,null)},{body:["workspace","ui"],description:h.localize(56,null)},{body:[],description:h.localize(57,null)}]},capabilities:{description:h.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:h.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:h.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[h.localize(61,null),h.localize(62,null),h.localize(63,null)]},description:{type:"string",markdownDescription:h.localize(64,null)}}},untrustedWorkspaces:{description:h.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:h.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[h.localize(67,null),h.localize(68,null),h.localize(69,null)]},restrictedConfigurations:{description:h.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:h.localize(71,null)}}}}},sponsor:{description:h.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:h.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:h.localize(74,null),type:"string"},"vscode:uninstall":{description:h.localize(75,null),type:"string"}}},icon:{type:"string",description:h.localize(76,null)},l10n:{type:"string",description:h.localize(77,null)},pricing:{type:"string",markdownDescription:h.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(s){if(this.a.has(s.extensionPoint))throw new Error("Duplicate extension point: "+s.extensionPoint);const t=new l(s.extensionPoint,s.defaultExtensionKind);return this.a.set(s.extensionPoint,t),s.activationEventsGenerator&&I.$uG.register(s.extensionPoint,s.activationEventsGenerator),e.$GG.properties.contributes.properties[s.extensionPoint]=s.jsonSchema,p.registerSchema(o,e.$GG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$HG=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};b.$co.add(i.ExtensionsRegistry,new n),e.$IG=b.$co.as(i.ExtensionsRegistry),p.registerSchema(o,e.$GG),p.registerSchema(A.$kk,{properties:{extensionEnabledApiProposals:{description:h.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Se[313],De([1,0,244,18,24,312,38,4]),function(he,e,h,N,O,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cI=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:h.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:h.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:h.localize(2,null),default:""}}};var k;(function(p){function y(v,l,d){if(!v)return;const o=N.$9f(v.type)?v.type:void 0;if(!o||o.length===0){d.error(h.localize(3,null));return}const n=[];if(Array.isArray(v.required))for(const i of v.required)N.$9f(i)&&n.push(i);return{extensionId:l.value,taskType:o,required:n,properties:v.properties?O.$3n(v.properties):{},when:v.when?M.$uj.deserialize(v.when):void 0}}p.from=y})(k||(k={}));const A=R.$IG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(p,y)=>{for(const v of p)v.type&&y.push(`onTaskType:${v.type}`)},jsonSchema:{description:h.localize(4,null),type:"array",items:$}});class I{constructor(){this.d=new b.$de,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,v)=>{A.setHandler((l,d)=>{this.c=void 0;try{for(const o of d.removed){const n=o.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const o of d.added){const n=o.value;for(const i of n){const u=k.from(i,o.description.identifier,o.collector);u&&(this.a[u.taskType]=u)}}(d.removed.length>0||d.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const v of this.all()){const l={type:"object",additionalProperties:!1};v.required.length>0&&(l.required=v.required.slice(0)),v.properties!==void 0?l.properties=O.$3n(v.properties):l.properties=Object.create(null),l.properties.type={type:"string",enum:[v.taskType]},y.push(l)}this.c={oneOf:y}}return this.c}}e.$cI=new I}),define(Se[314],De([1,0,245,18,23,24,38,313]),function(he,e,h,N,O,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$mI=e.JsonSchemaVersion=e.ExecutionEngine=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$gI=e.ShellQuoting=e.$fI=e.$eI=e.$dI=void 0,e.$dI="settings",e.$eI=new M.$Nj("taskRunning",!1,h.localize(0,null)),e.$fI=h.localize2(2,"Tasks");var $;(function(L){L[L.Escape=1]="Escape",L[L.Strong=2]="Strong",L[L.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$gI="$customized",function(L){function j(U){if(!U)return L.Strong;switch(U.toLowerCase()){case"escape":return L.Escape;case"strong":return L.Strong;case"weak":return L.Weak;default:return L.Strong}}L.from=j}($||(e.ShellQuoting=$={}));var k;(function(L){L.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var A;(function(L){L[L.Always=1]="Always",L[L.Silent=2]="Silent",L[L.Never=3]="Never"})(A||(e.RevealKind=A={})),function(L){function j(U){switch(U.toLowerCase()){case"always":return L.Always;case"silent":return L.Silent;case"never":return L.Never;default:return L.Always}}L.fromString=j}(A||(e.RevealKind=A={}));var I;(function(L){L[L.Never=1]="Never",L[L.OnProblem=2]="OnProblem",L[L.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(L){function j(U){switch(U.toLowerCase()){case"always":return L.Always;case"never":return L.Never;case"onproblem":return L.OnProblem;default:return L.OnProblem}}L.fromString=j}(I||(e.RevealProblemKind=I={}));var p;(function(L){L[L.Shared=1]="Shared",L[L.Dedicated=2]="Dedicated",L[L.New=3]="New"})(p||(e.PanelKind=p={})),function(L){function j(U){switch(U.toLowerCase()){case"shared":return L.Shared;case"dedicated":return L.Dedicated;case"new":return L.New;default:return L.Shared}}L.fromString=j}(p||(e.PanelKind=p={}));var y;(function(L){L.defaults={echo:!0,reveal:A.Always,revealProblems:I.Never,focus:!1,panel:p.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var v;(function(L){L[L.Shell=1]="Shell",L[L.Process=2]="Process",L[L.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(L){function j(X){switch(X.toLowerCase()){case"shell":return L.Shell;case"process":return L.Process;case"customExecution":return L.CustomExecution;default:return L.Process}}L.fromString=j;function U(X){switch(X){case L.Shell:return"shell";case L.Process:return"process";case L.CustomExecution:return"customExecution";default:return"process"}}L.toString=U}(v||(e.RuntimeType=v={}));var l;(function(L){function j(U){return N.$9f(U)?U:U.value}L.value=j})(l||(e.CommandString=l={}));var d;(function(L){L.Clean={_id:"clean",isDefault:!1},L.Build={_id:"build",isDefault:!1},L.Rebuild={_id:"rebuild",isDefault:!1},L.Test={_id:"test",isDefault:!1};function j(X){return X===L.Clean._id||X===L.Build._id||X===L.Rebuild._id||X===L.Test._id}L.is=j;function U(X){if(X!==void 0)return N.$9f(X)?j(X)?{_id:X,isDefault:!1}:void 0:X}L.from=U})(d||(e.TaskGroup=d={}));var o;(function(L){L[L.Global=1]="Global",L[L.Workspace=2]="Workspace",L[L.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var n;(function(L){L.Workspace="workspace",L.Extension="extension",L.InMemory="inMemory",L.WorkspaceFile="workspaceFile",L.User="user";function j(U){switch(U){case L.User:return 2;case L.WorkspaceFile:return 5;default:return 6}}L.toConfigurationTarget=j})(n||(e.TaskSourceKind=n={}));var i;(function(L){L.parallel="parallel",L.sequence="sequence"})(i||(e.DependsOrder=i={}));var u;(function(L){L[L.default=1]="default",L[L.folderOpen=2]="folderOpen"})(u||(e.RunOnOptions=u={}));var s;(function(L){L.defaults={reevaluateOnRerun:!0,runOn:u.default,instanceLimit:1}})(s||(e.RunOptions=s={}));class t{constructor(j,U,X,ie,q,G){this._label="",this._id=j,U&&(this._label=U),X&&(this.type=X),this.runOptions=ie,this.configurationProperties=q,this._source=G}getDefinition(j){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const j={folder:this.d(),id:this._id};return JSON.stringify(j)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(j,U=!1){if(j===void 0)return!1;if(N.$9f(j))return j===this._label||j===this.configurationProperties.identifier||U&&j===this._id;const X=this.getDefinition(!0);return X!==void 0&&X._key===j._key}getQualifiedLabel(){const j=this.getWorkspaceFolder();return j?`${this._label} (${j.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(j){this.c===void 0&&(this.c=[]),j&&(this.c=this.c.concat(j))}get taskLoadMessages(){return this.c}}e.$hI=t;class c extends t{constructor(j,U,X,ie,q,G,x,ne){super(j,X,void 0,x,ne,U),this.command={},this._source=U,this.hasDefinedMatchers=G,q&&(this.command=q)}clone(){return new c(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(j=!1){if(j&&this._source.customizes!==void 0)return this._source.customizes;{let U;switch(this.command?this.command.runtime:void 0){case v.Shell:U="shell";break;case v.Process:U="process";break;case v.CustomExecution:U="customExecution";break;case void 0:U="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:U,_key:this._id,id:this._id}}}static is(j){return j instanceof c}getMapKey(){const j=this._source.config.workspaceFolder;return j?`${j.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$dI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const j=this.d();if(!j)return;let U=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(U+=this._source.kind);const X={type:e.$gI,folder:j,id:U};return JSON.stringify(X)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?O.$7g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(j){return new c(j._id,j._source,j._label,j.type,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$iI=c;class r extends t{constructor(j,U,X,ie,q,G,x){super(j,X,ie,G,x,U),this._source=U,this.configures=q}static is(j){return j instanceof r}f(j){return j}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?O.$7g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$dI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const j=this.d();if(!j)return;let U=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(U+=this._source.kind);const X={type:e.$gI,folder:j,id:U};return JSON.stringify(X)}}e.$jI=r;class a extends t{constructor(j,U,X,ie,q,G,x,ne,be){super(j,X,ie,ne,be,U),this.defines=q,this.hasDefinedMatchers=x,this.command=G,this.icon=be.icon,this.hide=be.hide}clone(){return new a(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(j){return j instanceof a}getMapKey(){const j=this._source.workspaceFolder;return j?`${this._source.scope.toString()}|${j.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const j={type:"contributed",scope:this._source.scope,id:this._id};return j.folder=this.d(),JSON.stringify(j)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(j){return new a(j._id,j._source,j._label,j.type,j.defines,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$kI=a;class f extends t{constructor(j,U,X,ie,q,G){super(j,X,ie,q,G,U),this._source=U}clone(){return new f(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(j){return j instanceof f}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(j){return new f(j._id,j._source,j._label,j.type,j.runOptions,j.configurationProperties)}}e.$lI=f;var g;(function(L){L[L.Process=1]="Process",L[L.Terminal=2]="Terminal"})(g||(e.ExecutionEngine=g={})),function(L){L._default=L.Terminal}(g||(e.ExecutionEngine=g={}));var w;(function(L){L[L.V0_1_0=1]="V0_1_0",L[L.V2_0_0=2]="V2_0_0"})(w||(e.JsonSchemaVersion=w={}));class S{constructor(j){this.c=new Map;for(let U=0;U<j.length;U++)this.c.set(j[U].uri.toString(),U)}compare(j,U){const X=j.getWorkspaceFolder(),ie=U.getWorkspaceFolder();if(X&&ie){let q=this.c.get(X.uri.toString());q=q===void 0?0:q+1;let G=this.c.get(ie.uri.toString());return G=G===void 0?0:G+1,q===G?j._label.localeCompare(U._label):q-G}else return!X&&ie?-1:X&&!ie?1:0}}e.$mI=S;var m;(function(L){L.DependsOnStarted="dependsOnStarted",L.AcquiredInput="acquiredInput",L.Start="start",L.ProcessStarted="processStarted",L.Active="active",L.Inactive="inactive",L.Changed="changed",L.Terminated="terminated",L.ProcessEnded="processEnded",L.End="end"})(m||(e.TaskEventKind=m={}));var E;(function(L){L.SingleRun="singleRun",L.Background="background"})(E||(e.TaskRunType=E={}));var D;(function(L){L[L.System=0]="System",L[L.User=1]="User",L[L.FolderOpen=2]="FolderOpen",L[L.ConfigurationChange=3]="ConfigurationChange",L[L.Reconnect=4]="Reconnect"})(D||(e.TaskRunSource=D={}));var C;(function(L){function j(ne){return{taskId:ne._id,taskName:ne.configurationProperties.name,runType:ne.configurationProperties.isBackground?"background":"singleRun",group:ne.configurationProperties.group,__task:ne}}function U(ne,be,ae){return{...j(ne),kind:"start",terminalId:be,resolvedVariables:ae}}L.start=U;function X(ne,be,ae){return{...j(ne),kind:"processStarted",terminalId:be,processId:ae}}L.processStarted=X;function ie(ne,be,ae){return{...j(ne),kind:"processEnded",terminalId:be,exitCode:ae}}L.processEnded=ie;function q(ne,be,ae){return{...j(ne),kind:"terminated",exitReason:ae,terminalId:be}}L.terminated=q;function G(ne,be,ae){return{...j(be),kind:ne,terminalId:ae}}L.general=G;function x(){return{kind:"changed"}}L.changed=x})(C||(e.TaskEvent=C={}));var P;(function(L){function j(X){const ie=Object.keys(X).sort();let q="";for(const G of ie){let x=X[G];x instanceof Object?x=j(x):typeof x=="string"&&(x=x.replace(/,/g,",,")),q+=G+","+x+","}return q}function U(X){const q={_key:j(X),type:X.taskType};return Object.assign(q,X),q}L.create=U})(P||(e.KeyedTaskIdentifier=P={}));var F;(function(L){L.AutoDetect="task.autoDetect",L.SaveBeforeRun="task.saveBeforeRun",L.ShowDecorations="task.showDecorations",L.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",L.SlowProviderWarning="task.slowProviderWarning",L.QuickOpenHistory="task.quickOpen.history",L.QuickOpenDetail="task.quickOpen.detail",L.QuickOpenSkip="task.quickOpen.skip",L.QuickOpenShowAll="task.quickOpen.showAll",L.AllowAutomaticTasks="task.allowAutomaticTasks",L.Reconnection="task.reconnection",L.VerboseLogging="task.verboseLogging"})(F||(e.TaskSettingId=F={}));var T;(function(L){L.Tasks="tasks",L.SuppressTaskName="tasks.suppressTaskName",L.Windows="tasks.windows",L.Osx="tasks.osx",L.Linux="tasks.linux",L.ShowOutput="tasks.showOutput",L.IsShellCommand="tasks.isShellCommand",L.ServiceTestSetting="tasks.service.testSetting"})(T||(e.TasksSchemaProperties=T={}));var z;(function(L){function j(U,X){const ie=b.$cI.get(U.type);if(ie===void 0){const ne=R.$3n(U);return delete ne._key,P.create(ne)}const q=Object.create(null);q.type=ie.taskType;const G=new Set;ie.required.forEach(ne=>G.add(ne));const x=ie.properties;for(const ne of Object.keys(x)){const be=U[ne];if(be!=null)q[ne]=be;else if(G.has(ne)){const ae=x[ne];if(ae.default!==void 0)q[ne]=R.$3n(ae.default);else switch(ae.type){case"boolean":q[ne]=!1;break;case"number":case"integer":q[ne]=0;break;case"string":q[ne]="";break;default:X.error(h.localize(1,null,JSON.stringify(U,void 0,0),ne));return}}}return P.create(q)}L.createTaskIdentifier=j})(z||(e.TaskDefinition=z={}))}),define(Se[315],De([1,0,13]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$__b=e.$$_b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,b)=>{this.b=M,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,h.$1)(M))}then(M,b){return this.j().then(M,b)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$$_b=N;class O extends N{constructor(){super(),this.h=!0,this.i=new h.$5}}e.$__b=O}),define(Se[48],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bw=e.$yw=void 0,e.$zw=O,e.$Aw=R;class h{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++h.count}}e.$yw=h;const N=[];function O(b){const $=new h(b);return N[$.nid]=$,$}function R(b){return N[b].sid}class M{constructor($){this.value=$}}e.$Bw=M}),define(Se[6],De([1,0,48]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eM=e.$dM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$cM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var O;(function(l){l[l.UnknownInput=0]="UnknownInput",l[l.TextInput=1]="TextInput",l[l.TextDiffInput=2]="TextDiffInput",l[l.TextMergeInput=3]="TextMergeInput",l[l.NotebookInput=4]="NotebookInput",l[l.NotebookDiffInput=5]="NotebookDiffInput",l[l.CustomEditorInput=6]="CustomEditorInput",l[l.WebviewEditorInput=7]="WebviewEditorInput",l[l.TerminalEditorInput=8]="TerminalEditorInput",l[l.InteractiveEditorInput=9]="InteractiveEditorInput",l[l.ChatEditorInput=10]="ChatEditorInput",l[l.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(O||(e.TabInputKind=O={}));var R;(function(l){l[l.TAB_OPEN=0]="TAB_OPEN",l[l.TAB_CLOSE=1]="TAB_CLOSE",l[l.TAB_UPDATE=2]="TAB_UPDATE",l[l.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var M;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var b;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var $;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var k;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(k||(e.NotebookEditorRevealType=k={}));var A;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output",l[l.Hybrid=3]="Hybrid"})(A||(e.CandidatePortSource=A={}));class I{static{this.a=0}static mixin(d){return d._id=I.a++,d}}e.$cM=I;var p;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.kindModifier="m",l.commandIdent="n",l.commandId="o",l.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var y;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var v;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$dM={MainThreadAuthentication:(0,h.$zw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,h.$zw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,h.$zw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,h.$zw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,h.$zw)("MainThreadChatVariables"),MainThreadClipboard:(0,h.$zw)("MainThreadClipboard"),MainThreadCommands:(0,h.$zw)("MainThreadCommands"),MainThreadComments:(0,h.$zw)("MainThreadComments"),MainThreadConfiguration:(0,h.$zw)("MainThreadConfiguration"),MainThreadConsole:(0,h.$zw)("MainThreadConsole"),MainThreadDebugService:(0,h.$zw)("MainThreadDebugService"),MainThreadDecorations:(0,h.$zw)("MainThreadDecorations"),MainThreadDiagnostics:(0,h.$zw)("MainThreadDiagnostics"),MainThreadDialogs:(0,h.$zw)("MainThreadDiaglogs"),MainThreadDocuments:(0,h.$zw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,h.$zw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,h.$zw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,h.$zw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,h.$zw)("MainThreadEditorTabs"),MainThreadErrors:(0,h.$zw)("MainThreadErrors"),MainThreadTreeViews:(0,h.$zw)("MainThreadTreeViews"),MainThreadDownloadService:(0,h.$zw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,h.$zw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,h.$zw)("MainThreadLanguages"),MainThreadLogger:(0,h.$zw)("MainThreadLogger"),MainThreadMessageService:(0,h.$zw)("MainThreadMessageService"),MainThreadOutputService:(0,h.$zw)("MainThreadOutputService"),MainThreadProgress:(0,h.$zw)("MainThreadProgress"),MainThreadQuickDiff:(0,h.$zw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,h.$zw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,h.$zw)("MainThreadStatusBar"),MainThreadSecretState:(0,h.$zw)("MainThreadSecretState"),MainThreadStorage:(0,h.$zw)("MainThreadStorage"),MainThreadSpeech:(0,h.$zw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,h.$zw)("MainThreadTelemetry"),MainThreadTerminalService:(0,h.$zw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,h.$zw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,h.$zw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,h.$zw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,h.$zw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,h.$zw)("MainThreadCustomEditors"),MainThreadUrls:(0,h.$zw)("MainThreadUrls"),MainThreadUriOpeners:(0,h.$zw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,h.$zw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,h.$zw)("MainThreadWorkspace"),MainThreadFileSystem:(0,h.$zw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,h.$zw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,h.$zw)("MainThreadExtensionService"),MainThreadSCM:(0,h.$zw)("MainThreadSCM"),MainThreadSearch:(0,h.$zw)("MainThreadSearch"),MainThreadShare:(0,h.$zw)("MainThreadShare"),MainThreadTask:(0,h.$zw)("MainThreadTask"),MainThreadWindow:(0,h.$zw)("MainThreadWindow"),MainThreadLabelService:(0,h.$zw)("MainThreadLabelService"),MainThreadNotebook:(0,h.$zw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,h.$zw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,h.$zw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,h.$zw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,h.$zw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,h.$zw)("MainThreadInteractive"),MainThreadTheming:(0,h.$zw)("MainThreadTheming"),MainThreadTunnelService:(0,h.$zw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,h.$zw)("MainThreadManagedSockets"),MainThreadTimeline:(0,h.$zw)("MainThreadTimeline"),MainThreadTesting:(0,h.$zw)("MainThreadTesting"),MainThreadLocalization:(0,h.$zw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,h.$zw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,h.$zw)("MainThreadAiEmbeddingVector")},e.$eM={ExtHostCommands:(0,h.$zw)("ExtHostCommands"),ExtHostConfiguration:(0,h.$zw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,h.$zw)("ExtHostDiagnostics"),ExtHostDebugService:(0,h.$zw)("ExtHostDebugService"),ExtHostDecorations:(0,h.$zw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,h.$zw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,h.$zw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,h.$zw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,h.$zw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,h.$zw)("ExtHostEditors"),ExtHostTreeViews:(0,h.$zw)("ExtHostTreeViews"),ExtHostFileSystem:(0,h.$zw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,h.$zw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,h.$zw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,h.$zw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,h.$zw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,h.$zw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,h.$zw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,h.$zw)("ExtHostStatusBar"),ExtHostShare:(0,h.$zw)("ExtHostShare"),ExtHostExtensionService:(0,h.$zw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,h.$zw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,h.$zw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,h.$zw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,h.$zw)("ExtHostSCM"),ExtHostSearch:(0,h.$zw)("ExtHostSearch"),ExtHostTask:(0,h.$zw)("ExtHostTask"),ExtHostWorkspace:(0,h.$zw)("ExtHostWorkspace"),ExtHostWindow:(0,h.$zw)("ExtHostWindow"),ExtHostWebviews:(0,h.$zw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,h.$zw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,h.$zw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,h.$zw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,h.$zw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,h.$zw)("ExtHostEditorTabs"),ExtHostProgress:(0,h.$zw)("ExtHostProgress"),ExtHostComments:(0,h.$zw)("ExtHostComments"),ExtHostSecretState:(0,h.$zw)("ExtHostSecretState"),ExtHostStorage:(0,h.$zw)("ExtHostStorage"),ExtHostUrls:(0,h.$zw)("ExtHostUrls"),ExtHostUriOpeners:(0,h.$zw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,h.$zw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,h.$zw)("ExtHostOutputService"),ExtHostLabelService:(0,h.$zw)("ExtHostLabelService"),ExtHostNotebook:(0,h.$zw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,h.$zw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,h.$zw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,h.$zw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,h.$zw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,h.$zw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,h.$zw)("ExtHostInteractive"),ExtHostChatAgents2:(0,h.$zw)("ExtHostChatAgents"),ExtHostChatVariables:(0,h.$zw)("ExtHostChatVariables"),ExtHostChatProvider:(0,h.$zw)("ExtHostChatProvider"),ExtHostSpeech:(0,h.$zw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,h.$zw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,h.$zw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,h.$zw)("ExtHostTheming"),ExtHostTunnelService:(0,h.$zw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,h.$zw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,h.$zw)("ExtHostAuthentication"),ExtHostTimeline:(0,h.$zw)("ExtHostTimeline"),ExtHostTesting:(0,h.$zw)("ExtHostTesting"),ExtHostTelemetry:(0,h.$zw)("ExtHostTelemetry"),ExtHostLocalization:(0,h.$zw)("ExtHostLocalization")}}),define(Se[91],De([1,0,5,11,6,20]),function(he,e,h,N,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=e.$wlc=e.$vlc=void 0,e.$vlc=(0,h.$wi)("IExtHostApiDeprecationService");let M=class{constructor($,k){this.c=k,this.a=new Set,this.b=$.getProxy(O.$dM.MainThreadTelemetry)}report($,k,A){const I=this.d($,k);this.a.has(I)||(this.a.add(I),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:$}))}d($,k){return`${$}-${k.identifier.value}`}};e.$wlc=M,e.$wlc=M=He([We(0,R.$EO),We(1,N.$3j)],M),e.$xlc=Object.freeze(new class{report(b,$,k){}})}),define(Se[316],De([1,0,6]),function(he,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=void 0;class N{constructor(R){const M=R.getProxy(h.$dM.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(b){return M.$writeText(b)}})}}e.$Klc=N}),define(Se[317],De([1,0,24,6,28,20]),function(he,e,h,N,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dnc=void 0;let M=class{constructor(A,I){this.a=A.getProxy(N.$dM.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,I){const p=this,y=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){p.e(A,I,y,arguments)}})}e(A,I,p,y){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:$(y,this.b)}),this.c&&this.f(A,p,y)}};e.$Dnc=M,e.$Dnc=M=He([We(0,R.$EO),We(1,O.$UO)],M);const b=1e5;function $(k,A){const I=[];if(k.length)for(let p=0;p<k.length;p++){let y=k[p];if(typeof y>"u")y="undefined";else if(y instanceof Error){const v=y;v.stack?y=v.stack:y=v.toString()}I.push(y)}if(A){const p=new Error().stack;p&&I.push({__$stack:p.split(`
`).slice(3).join(`
`)})}try{const p=(0,h.$8n)(I);return p.length>b?"Output omitted for a large object that exceeds the limits":p}catch(p){return`Output omitted for an object that cannot be inspected ('${p.toString()}')`}}}),define(Se[318],De([1,0,2,6,26]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=void 0;class R{constructor(b){this.a=b.getProxy(N.$dM.MainThreadDialogs)}showOpenDialog(b,$){return $?.allowUIResources&&(0,O.$PG)(b,"showLocal"),this.a.$showOpenDialog($).then(k=>k?k.map(A=>h.URI.revive(A)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then($=>$?h.URI.revive($):void 0)}}e.$Hmc=R}),define(Se[319],De([1,0,3,6]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1mc=void 0;class O{constructor(M){this.b=0,this.a=M.getProxy(N.$dM.MainThreadLabelService)}$registerResourceLabelFormatter(M){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,M),(0,h.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$1mc=O}),define(Se[116],De([1,0,12,14,2,5,11,6,28,20]),function(he,e,h,N,O,R,M,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qmc=e.$pmc=void 0;let A=class{constructor(p,y,v){this.f=v,this.d=new Map,this.a=y.getProxy(b.$dM.MainThreadLocalization),this.b=p.environment.appLanguage,this.c=this.b===h.$g}getMessage(p,y){const{message:v,args:l,comment:d}=y;if(this.c)return(0,N.$9e)(v,l??{});let o=v;d&&d.length>0&&(o+=`/${Array.isArray(d)?d.join(""):d}`);const n=this.d.get(p)?.contents[o];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,N.$9e)(n??v,l??{})}getBundle(p){return this.d.get(p)?.contents}getBundleUri(p){return this.d.get(p)?.uri}async initializeLocalizedMessages(p){if(this.c||!p.l10n&&!p.isBuiltin||this.d.has(p.identifier.value))return;let y;const v=await this.g(p);if(!v){this.f.error(`No bundle location found for extension ${p.identifier.value}`);return}try{const l=await this.a.$fetchBundleContents(v),d=JSON.parse(l);y=p.isBuiltin?d.contents?.bundle:d}catch(l){this.f.error(`Failed to load translations for ${p.identifier.value} from ${v}: ${l.message}`);return}y&&this.d.set(p.identifier.value,{contents:y,uri:v})}async g(p){if(p.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri(p.identifier.value,this.b);return O.URI.revive(y)}return p.l10n?O.URI.joinPath(p.extensionLocation,p.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$pmc=A,e.$pmc=A=He([We(0,$.$UO),We(1,k.$EO),We(2,M.$3j)],A),e.$qmc=(0,R.$wi)("IExtHostLocalizationService")}),define(Se[150],De([1,0,11,6,28,20,2,58]),function(he,e,h,N,O,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cnc=void 0;let $=class extends h.$bk{constructor(I,p){super(p.logLevel,p.logsLocation,p.loggers.map(y=>(0,b.$6h)(y))),this.r=I.getProxy(N.$dM.MainThreadLogger)}$setLogLevel(I,p){p?this.setLogLevel(M.URI.revive(p),I):this.setLogLevel(I)}setVisibility(I,p){super.setVisibility(I,p),this.r.$setVisibility(I,p)}s(I,p,y){return new k(this.r,I,p,y)}};e.$Cnc=$,e.$Cnc=$=He([We(0,R.$EO),We(1,O.$UO)],$);class k extends h.$9j{constructor(I,p,y,v){super(v?.logLevel==="always"),this.r=I,this.s=p,this.m=!1,this.n=[],this.setLevel(y),this.r.$createLogger(p,v).then(()=>{this.u(this.n),this.m=!0})}g(I,p){const y=[[I,p]];this.m?this.u(y):this.n.push(...y)}u(I){this.r.$log(this.s,I)}flush(){this.r.$flush(this.s)}}}),define(Se[117],De([1,0,6,5,3,20,21]),function(he,e,h,N,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$smc=e.$rmc=void 0,e.$rmc=(0,N.$wi)("IExtHostManagedSockets");let b=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(h.$dM.MainThreadManagedSockets)}setFactory(I,p){for(const y of this.d.values())y.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(I,p),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const p=++this.b,y=await this.c.makeConnection(),v=new O.$Tc;return this.d.set(p,new k(p,y,v)),v.add((0,O.$Sc)(()=>this.d.delete(p))),v.add(y.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(p),v.dispose()})),v.add(y.onDidClose(l=>{this.a.$onDidManagedSocketClose(p,l?.stack??l?.message),v.dispose()})),v.add(y.onDidReceiveMessage(l=>this.a.$onDidManagedSocketHaveData(p,M.$Fe.wrap(l)))),p}$remoteSocketWrite(I,p){this.d.get(I)?.actual.send(p.buffer)}$remoteSocketEnd(I){const p=this.d.get(I);p&&(p.actual.end(),p.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$smc=b,e.$smc=b=He([We(0,R.$EO)],b);class ${constructor(I,p){this.socketFactoryId=I,this.makeConnection=p}}class k extends O.$Uc{constructor(I,p,y){super(),this.socketId=I,this.actual=p,this.B(y)}}}),define(Se[320],De([1,0,6,11,26]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3mc=void 0;function R(b){return b&&b.title}let M=class{constructor($,k){this.b=k,this.a=$.getProxy(h.$dM.MainThreadMessageService)}showMessage($,k,A,I,p){const y={source:{identifier:$.identifier,label:$.displayName||$.name}};let v;typeof I=="string"||R(I)?v=[I,...p]:(y.modal=I?.modal,y.useCustom=I?.useCustom,y.detail=I?.detail,v=p),y.useCustom&&(0,O.$PG)($,"resolvers");const l=[];let d=!1;for(let o=0;o<v.length;o++){const n=v[o];if(typeof n=="string")l.push({title:n,handle:o,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:u}=n;l.push({title:i,isCloseAffordance:!!u,handle:o}),u&&(d?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,n):d=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,n)}return this.a.$showMessage(k,A,y,l).then(o=>{if(typeof o=="number")return v[o]})}};e.$3mc=M,e.$3mc=M=He([We(1,N.$3j)],M)}),define(Se[321],De([1,0,3,18,2,26,6]),function(he,e,h,N,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_mc=void 0;class b{constructor(k){this.b=new Map,this.a=k.getProxy(M.$dM.MainThreadProfileContentHandlers)}registerProfileContentHandler(k,A,I){if((0,R.$PG)(k,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,I),this.a.$registerProfileContentHandler(A,I.name,I.description,k.identifier.value),(0,h.$Sc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(k,A,I,p){const y=this.b.get(k);if(!y)throw new Error(`Unknown handler with id: ${k}`);return y.saveProfile(A,I,p)}async $readProfile(k,A,I){const p=this.b.get(k);if(!p)throw new Error(`Unknown handler with id: ${k}`);return p.readProfile((0,N.$9f)(A)?A:O.URI.revive(A),I)}}e.$_mc=b}),define(Se[118],De([1,0,6,4,5]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nmc=e.$mmc=void 0;class R{constructor(b){this.b=new N.$de,this.onDidChangePassword=this.b.event,this.a=b.getProxy(h.$dM.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,$){return this.a.$getPassword(b,$)}store(b,$,k){return this.a.$setPassword(b,$,k)}delete(b,$){return this.a.$deletePassword(b,$)}}e.$mmc=R,e.$nmc=(0,O.$wi)("IExtHostSecretState")}),define(Se[322],De([1,0,22,3,6]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gnc=void 0;class R{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.f=new Map,this.b=b.getProxy(O.$dM.MainThreadSpeech)}async $createSpeechToTextSession(b,$,k){const A=this.c.get(b);if(!A)return;const I=new N.$Tc,p=new h.$oe;this.d.set($,p);const y=I.add(A.provideSpeechToTextSession(p.token,k?{language:k}:void 0));I.add(y.onDidChange(v=>{p.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,v)})),I.add(p.token.onCancellationRequested(()=>I.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}async $createTextToSpeechSession(b,$){const k=this.c.get(b);if(!k)return;const A=new N.$Tc,I=new h.$oe;this.d.set($,I);const p=A.add(k.provideTextToSpeechSession(I.token));this.f.set($,p),A.add(p.onDidChange(y=>{I.token.isCancellationRequested||this.b.$emitTextToSpeechEvent($,y)})),A.add(I.token.onCancellationRequested(()=>A.dispose()))}async $synthesizeSpeech(b,$){const k=this.f.get(b);k&&k.synthesize($)}async $cancelTextToSpeechSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b),this.f.delete(b)}async $createKeywordRecognitionSession(b,$){const k=this.c.get(b);if(!k)return;const A=new N.$Tc,I=new h.$oe;this.d.set($,I);const p=A.add(k.provideKeywordRecognitionSession(I.token));A.add(p.onDidChange(y=>{I.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,y)})),A.add(I.token.onCancellationRequested(()=>A.dispose()))}async $cancelKeywordRecognitionSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,$,k){const A=R.a++;return this.c.set(A,k),this.b.$registerProvider(A,$,{extension:b,displayName:b.value}),(0,N.$Sc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$gnc=R}),define(Se[119],De([1,0,6,4,5]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=e.$cmc=void 0;class R{constructor(b,$){this.c=$,this.b=new N.$de,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(h.$dM.MainThreadStorage)}registerExtensionStorageKeysToSync(b,$){this.a.$registerExtensionStorageKeysToSync(b,$)}async initializeExtensionStorage(b,$,k){const A=await this.a.$initializeExtensionStorage(b,$);let I;return A&&(I=this.d(b,$,A)),I||k}setValue(b,$,k){return this.a.$setValue(b,$,k)}$acceptValue(b,$,k){const A=this.d(b,$,k);A&&this.b.fire({shared:b,key:$,value:A})}d(b,$,k){try{return JSON.parse(k)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${b}): ${A}`)}}}e.$cmc=R,e.$dmc=(0,O.$wi)("IExtHostStorage")}),define(Se[323],De([1,0,3,15,2,6]),function(he,e,h,N,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wnc=void 0;class M{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(R.$dM.MainThreadUriOpeners)}registerExternalUriOpener($,k,A,I){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const p=I.schemes.find(y=>!M.a.has(y));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this.c.set(k,A),this.b.$registerUriOpener(k,I.schemes,$,I.label),(0,h.$Sc)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri($,k,A){const I=this.c.get($);if(!I)throw new Error(`Unknown opener with id: ${$}`);const p=O.URI.revive(k);return I.canOpenExternalUri(p,A)}async $openUri($,k,A){const I=this.c.get($);if(!I)throw new Error(`Unknown opener id: '${$}'`);return I.openExternalUri(O.URI.revive(k.resolvedUri),{sourceUri:O.URI.revive(k.sourceUri)},A)}}e.$wnc=M}),define(Se[324],De([1,0,6,2,3,13,25]),function(he,e,h,N,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xnc=void 0;class b{static{this.a=0}constructor(k){this.c=new M.$Sm,this.d=new Map,this.b=k.getProxy(h.$dM.MainThreadUrls)}registerUriHandler(k,A){const I=k.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const p=b.a++;return this.c.add(I),this.d.set(p,A),this.b.$registerUriHandler(p,I,k.displayName||k.name),(0,O.$Sc)(()=>{this.c.delete(I),this.d.delete(p),this.b.$unregisterUriHandler(p)})}$handleExternalUri(k,A){const I=this.d.get(k);if(!I)return Promise.resolve(void 0);try{I.handleUri(N.URI.revive(A))}catch(p){(0,R.$1)(p)}return Promise.resolve(void 0)}async createAppUri(k){return N.URI.revive(await this.b.$createAppUri(k))}}e.$xnc=b}),define(Se[92],De([1,0,4,3,15,24,2,252,290,114,6]),function(he,e,h,N,O,R,M,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=e.$Zlc=void 0,e.$1lc=p,e.$3lc=l,e.$4lc=d;class I{#e;#t;#n;#i;#s;#r;#a;#o;#c;#u;#l;#d;constructor(u,s,t,c,r,a,f){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new h.$de,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new h.$de,this._onDidDispose=this.#h.event,this.#e=u,this.#t=s,this.#o=t,this.#i=c,this.#s=r,this.#r=a,this.#l=p(a),this.#d=y(a),this.#n=f}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(u){return this.#u=!0,(0,k.$VAb)(u,this.#i)}get cspSource(){const u=this.#r.extensionLocation;if(u.scheme===O.Schemas.https||u.scheme===O.Schemas.http){let s=u.toString();return s.endsWith("/")||(s+="/"),s+" "+k.$UAb}return k.$UAb}get html(){return this.a(),this.#a}set html(u){this.a(),this.#a!==u&&(this.#a=u,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(u)&&(this.#u=!0,this.#n.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(u)))}get options(){return this.a(),this.#o}set options(u){this.a(),R.$7n(this.#o,u)||this.#t.$setOptions(this.#e,d(this.#r,this.#s,u)),this.#o=u}async postMessage(u){if(this.#c)return!1;const s=(0,$.$Orb)(u,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,s.message,...s.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(u){if(!this.#d)return u;const s=this.#r.extensionLocation?.scheme===O.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===O.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return u.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(c,r,a,f,g,w)=>{const S=M.URI.from({scheme:f||"file",path:decodeURIComponent(g)}),m=(0,k.$VAb)(S,{isRemote:s,authority:t}).toString();return`${r}${m}${w}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(c,r,a,f,g,w)=>{const S=M.URI.from({scheme:f||"file",path:decodeURIComponent(g)}),m=(0,k.$VAb)(S,{isRemote:s,authority:t}).toString();return`${r}${m}${w}`})}}e.$Zlc=I;function p(i){try{const u=(0,b.$Ip)((0,b.$Hp)(i.engines.vscode));return!!u&&u.majorBase>=1&&u.minorBase>=57}catch{return!1}}function y(i){try{const u=(0,b.$Ip)((0,b.$Hp)(i.engines.vscode));return u?u.majorBase<1||u.majorBase===1&&u.minorBase<60:!1}catch{return!1}}class v extends N.$Uc{constructor(u,s,t,c,r){super(),this.c=s,this.f=t,this.g=c,this.h=r,this.b=new Map,this.a=u.getProxy(A.$dM.MainThreadWebviews)}dispose(){super.dispose();for(const u of this.b.values())u.dispose();this.b.clear()}$onMessage(u,s,t){const c=this.j(u);if(c){const{message:r}=(0,$.$Prb)(s,t.value);c._onMessageEmitter.fire(r)}}$onMissingCsp(u,s){this.g.warn(`${s} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(u,s,t){const c=new I(u,this.a,o(s),this.c,this.f,t,this.h);this.b.set(u,c);const r=c._onDidDispose(()=>{r.dispose(),this.deleteWebview(u)});return c}deleteWebview(u){this.b.delete(u)}j(u){return this.b.get(u)}}e.$2lc=v;function l(i){return{id:i.identifier,location:i.extensionLocation}}function d(i,u,s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots||n(i,u)}}function o(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(u=>M.URI.from(u))}}function n(i,u){return[...(u?.getWorkspaceFolders()||[]).map(s=>s.uri),i.extensionLocation]}}),define(Se[151],De([1,0,4,15,14,2,5,20,6]),function(he,e,h,N,O,R,M,b,$){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Anc=e.$znc=void 0;let A=class{static{k=this}static{this.a={focused:!0,active:!0}}getState(){const p=this.d;return{get focused(){return p.focused},get active(){return p.active}}}constructor(p){this.c=new h.$de,this.onDidChangeWindowState=this.c.event,this.d=k.a,this.b=p.getProxy($.$dM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:y,isActive:v})=>{this.onDidChangeWindowProperty("focused",y),this.onDidChangeWindowProperty("active",v)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,y){y!==this.d[p]&&(this.d={...this.d,[p]:y},this.c.fire(this.d))}openUri(p,y){let v;if(typeof p=="string"){v=p;try{p=R.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,O.$7e)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,v,y)}async asExternalUri(p,y){if((0,O.$7e)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const v=await this.b.$asExternalUri(p,y);return R.URI.from(v)}};e.$znc=A,e.$znc=A=k=He([We(0,b.$EO)],A),e.$Anc=(0,M.$wi)("IExtHostWindow")}),define(Se[325],De([1,0,317,28,20]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$coc=void 0;const R=1024*1024;let M=class extends h.$Dnc{constructor($,k){super($,k),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,k,A){const I=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),k.apply(console,A),I.write(`
END_NATIVE_LOG
`),this.g=!1}j($,k){const A=process[$],I=A.write;let p="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(y,v,l)=>{if(!this.g){p+=y.toString(v);const d=p.length>R?p.length:p.lastIndexOf(`
`);d!==-1&&(console[k](p.slice(0,d)),p=p.slice(d+1))}I.call(A,y,v,l)}})}};e.$coc=M,e.$coc=M=He([We(0,O.$EO),We(1,N.$UO)],M)}),define(Se[326],De([1,0,150,15,267,30]),function(he,e,h,N,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ooc=void 0;class M extends h.$Cnc{s($,k,A){return $.scheme===N.Schemas.file?new O.$TP(A?.name||(0,R.$Sg)(),$.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,k):super.s($,k,A)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$ooc=M}),define(Se[327],De([1,0,7,21,22,13,4,3,134,315,48]),function(he,e,h,N,O,R,M,b,$,k,A){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$cac=e.ResponsiveState=e.RequestInitiator=void 0,e.$aac=d,e.$bac=o;function p(D,C){try{return JSON.stringify(D,C)}catch{return"null"}}const y="$$ref$$",v={[y]:-1};class l{constructor(C,P){this.jsonString=C,this.referencedBuffers=P}}function d(D,C=null,P=!1){const F=[];return{jsonString:(P?p:JSON.stringify)(D,(z,L)=>{if(typeof L>"u")return v;if(typeof L=="object"){if(L instanceof N.$Fe){const j=F.push(L)-1;return{[y]:j}}if(C)return C(z,L)}return L}),referencedBuffers:F}}function o(D,C,P){return JSON.parse(D,(F,T)=>{if(T){const z=T[y];if(typeof z=="number")return C[z];if(P&&T.$mid===1)return P.transformIncoming(T)}return T})}function n(D,C){return JSON.stringify(D,C)}function i(D){return D?(C,P)=>P&&P.$mid===1?D.transformOutgoing(P):P:null}var u;(function(D){D[D.LocalSide=0]="LocalSide",D[D.OtherSide=1]="OtherSide"})(u||(e.RequestInitiator=u={}));var s;(function(D){D[D.Responsive=0]="Responsive",D[D.Unresponsive=1]="Unresponsive"})(s||(e.ResponsiveState=s={}));const t=()=>{},c=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class a extends b.$Uc{static{I=c}static{this.a=3*1e3}constructor(C,P=null,F=null){super(),this[I]=!0,this.b=this.B(new M.$de),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=P,this.g=F,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let T=0,z=A.$yw.count;T<z;T++)this.m[T]=null,this.s[T]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new h.$Ih(()=>this.H(),1e3)),this.c.onMessage(T=>this.L(T))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const P=this.w[C];delete this.w[C],P.resolveErr(R.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+a.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+a.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,$.$Bn)(C,this.g):C}getProxy(C){const{nid:P,sid:F}=C;return this.s[P]||(this.s[P]=this.J(P,F)),this.s[P]}J(C,P){const F={get:(T,z)=>(typeof z=="string"&&!T[z]&&z.charCodeAt(0)===36&&(T[z]=(...L)=>this.U(C,z,L)),z===r?P:T[z])};return new Proxy(Object.create(null),F)}set(C,P){return this.m[C.nid]=P,P}assertRegistered(C){for(let P=0,F=C.length;P<F;P++){const T=C[P];if(!this.m[T.nid])throw new Error(`Missing proxy instance ${T.sid}`)}}L(C){if(this.j)return;const P=C.byteLength,F=g.read(C,0),T=F.readUInt8(),z=F.readUInt32();switch(T){case 1:case 2:{let{rpcId:L,method:j,args:U}=S.deserializeRequestJSONArgs(F);this.g&&(U=(0,$.$Bn)(U,this.g)),this.M(P,z,L,j,U,T===2);break}case 3:case 4:{let{rpcId:L,method:j,args:U}=S.deserializeRequestMixedArgs(F);this.g&&(U=(0,$.$Bn)(U,this.g)),this.M(P,z,L,j,U,T===4);break}case 5:{this.f?.logIncoming(P,z,0,"ack"),this.G(z);break}case 6:{this.N(P,z);break}case 7:{this.O(P,z,void 0);break}case 9:{let L=S.deserializeReplyOKJSON(F);this.g&&(L=(0,$.$Bn)(L,this.g)),this.O(P,z,L);break}case 10:{const L=S.deserializeReplyOKJSONWithBuffers(F,this.g);this.O(P,z,L);break}case 8:{const L=S.deserializeReplyOKVSBuffer(F);this.O(P,z,L);break}case 11:{let L=S.deserializeReplyErrError(F);this.g&&(L=(0,$.$Bn)(L,this.g)),this.P(P,z,L);break}case 12:{this.P(P,z,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,P,F,T,z,L){this.f?.logIncoming(C,P,1,`receiveRequest ${(0,A.$Aw)(F)}.${T}(`,z);const j=String(P);let U,X;if(L){const q=new O.$oe;z.push(q.token),U=this.Q(F,T,z),X=()=>q.cancel()}else U=this.Q(F,T,z),X=t;this.u[j]=X;const ie=S.serializeAcknowledged(P);this.f?.logOutgoing(ie.byteLength,P,1,"ack"),this.c.send(ie),U.then(q=>{delete this.u[j];const G=S.serializeReplyOK(P,q,this.h);this.f?.logOutgoing(G.byteLength,P,1,"reply:",q),this.c.send(G)},q=>{delete this.u[j];const G=S.serializeReplyErr(P,q);this.f?.logOutgoing(G.byteLength,P,1,"replyErr:",q),this.c.send(G)})}N(C,P){this.f?.logIncoming(C,P,1,"receiveCancel");const F=String(P);this.u[F]?.()}O(C,P,F){this.f?.logIncoming(C,P,0,"receiveReply:",F);const T=String(P);if(!this.w.hasOwnProperty(T))return;const z=this.w[T];delete this.w[T],z.resolveOk(F)}P(C,P,F){this.f?.logIncoming(C,P,0,"receiveReplyErr:",F);const T=String(P);if(!this.w.hasOwnProperty(T))return;const z=this.w[T];delete this.w[T];let L;F&&(F.$isError?(L=new Error,L.name=F.name,L.message=F.message,L.stack=F.stack):L=F),z.resolveErr(L)}Q(C,P,F){try{return Promise.resolve(this.S(C,P,F))}catch(T){return Promise.reject(T)}}S(C,P,F){const T=this.m[C];if(!T)throw new Error("Unknown actor "+(0,A.$Aw)(C));const z=T[P];if(typeof z!="function")throw new Error("Unknown method "+P+" on actor "+(0,A.$Aw)(C));return z.apply(T,F)}U(C,P,F){if(this.j)return new k.$__b;let T=null;if(F.length>0&&O.CancellationToken.isCancellationToken(F[F.length-1])&&(T=F.pop()),T&&T.isCancellationRequested)return Promise.reject(R.$6());const z=S.serializeRequestArguments(F,this.h),L=++this.t,j=String(L),U=new k.$$_b,X=new b.$Tc;T&&X.add(T.onCancellationRequested(()=>{const q=S.serializeCancel(L);this.f?.logOutgoing(q.byteLength,L,0,"cancel"),this.c.send(S.serializeCancel(L))})),this.w[j]=new f(U,X),this.F(L);const ie=S.serializeRequest(L,C,P,z,!!T);return this.f?.logOutgoing(ie.byteLength,L,0,`request: ${(0,A.$Aw)(C)}.${P}(`,F),this.c.send(ie),U}}e.$cac=a;class f{constructor(C,P){this.a=C,this.b=P}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class g{static alloc(C,P,F){const T=new g(N.$Fe.alloc(F+1+4),0);return T.writeUInt8(C),T.writeUInt32(P),T}static read(C,P){return new g(C,P)}get buffer(){return this.a}constructor(C,P){this.a=C,this.b=P}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const F=this.a.slice(this.b,this.b+C).toString();return this.b+=C,F}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+C).toString();return this.b+=C,F}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const P=this.a.slice(this.b,this.b+C);return this.b+=C,P}static sizeMixedArray(C){let P=0;P+=1;for(let F=0,T=C.length;F<T;F++){const z=C[F];switch(P+=1,z.type){case 1:P+=this.sizeLongString(z.value);break;case 2:P+=this.sizeVSBuffer(z.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(z.value);for(let L=0;L<z.buffers.length;++L)P+=this.sizeVSBuffer(z.buffers[L]);break;case 4:break}}return P}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let P=0,F=C.length;P<F;P++){const T=C[P];switch(T.type){case 1:this.writeUInt8(1),this.writeLongString(T.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(T.value);break;case 3:this.writeUInt8(3),this.writeUInt32(T.buffers.length),this.writeLongString(T.value);for(let z=0;z<T.buffers.length;++z)this.writeBuffer(T.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const P=new Array(C);for(let F=0;F<C;F++)switch(this.readUInt8()){case 1:P[F]=this.readLongString();break;case 2:P[F]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),L=this.readLongString(),j=[];for(let U=0;U<z;++U)j.push(this.readVSBuffer());P[F]=new A.$Bw(o(L,j,null));break}case 4:P[F]=void 0;break}return P}}var w;(function(D){D[D.Simple=0]="Simple",D[D.Mixed=1]="Mixed"})(w||(w={}));class S{static a(C){for(let P=0,F=C.length;P<F;P++)if(C[P]instanceof N.$Fe||C[P]instanceof A.$Bw||typeof C[P]>"u")return!0;return!1}static serializeRequestArguments(C,P){if(this.a(C)){const F=[];for(let T=0,z=C.length;T<z;T++){const L=C[T];if(L instanceof N.$Fe)F[T]={type:2,value:L};else if(typeof L>"u")F[T]={type:4};else if(L instanceof A.$Bw){const{jsonString:j,referencedBuffers:U}=d(L.value,P);F[T]={type:3,value:N.$Fe.fromString(j),buffers:U}}else F[T]={type:1,value:N.$Fe.fromString(n(L,P))}}return{type:1,args:F}}return{type:0,args:n(C,P)}}static serializeRequest(C,P,F,T,z){switch(T.type){case 0:return this.b(C,P,F,T.args,z);case 1:return this.c(C,P,F,T.args,z)}}static b(C,P,F,T,z){const L=N.$Fe.fromString(F),j=N.$Fe.fromString(T);let U=0;U+=g.sizeUInt8(),U+=g.sizeShortString(L),U+=g.sizeLongString(j);const X=g.alloc(z?2:1,C,U);return X.writeUInt8(P),X.writeShortString(L),X.writeLongString(j),X.buffer}static deserializeRequestJSONArgs(C){const P=C.readUInt8(),F=C.readShortString(),T=C.readLongString();return{rpcId:P,method:F,args:JSON.parse(T)}}static c(C,P,F,T,z){const L=N.$Fe.fromString(F);let j=0;j+=g.sizeUInt8(),j+=g.sizeShortString(L),j+=g.sizeMixedArray(T);const U=g.alloc(z?4:3,C,j);return U.writeUInt8(P),U.writeShortString(L),U.writeMixedArray(T),U.buffer}static deserializeRequestMixedArgs(C){const P=C.readUInt8(),F=C.readShortString(),T=C.readMixedArray(),z=new Array(T.length);for(let L=0,j=T.length;L<j;L++){const U=T[L];typeof U=="string"?z[L]=JSON.parse(U):z[L]=U}return{rpcId:P,method:F,args:z}}static serializeAcknowledged(C){return g.alloc(5,C,0).buffer}static serializeCancel(C){return g.alloc(6,C,0).buffer}static serializeReplyOK(C,P,F){if(typeof P>"u")return this.d(C);if(P instanceof N.$Fe)return this.e(C,P);if(P instanceof A.$Bw){const{jsonString:T,referencedBuffers:z}=d(P.value,F,!0);return this.g(C,T,z)}else return this.f(C,p(P,F))}static d(C){return g.alloc(7,C,0).buffer}static e(C,P){let F=0;F+=g.sizeVSBuffer(P);const T=g.alloc(8,C,F);return T.writeVSBuffer(P),T.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,P){const F=N.$Fe.fromString(P);let T=0;T+=g.sizeLongString(F);const z=g.alloc(9,C,T);return z.writeLongString(F),z.buffer}static g(C,P,F){const T=N.$Fe.fromString(P);let z=0;z+=g.sizeUInt32,z+=g.sizeLongString(T);for(const j of F)z+=g.sizeVSBuffer(j);const L=g.alloc(10,C,z);L.writeUInt32(F.length),L.writeLongString(T);for(const j of F)L.writeBuffer(j);return L.buffer}static deserializeReplyOKJSON(C){const P=C.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(C,P){const F=C.readUInt32(),T=C.readLongString(),z=[];for(let L=0;L<F;++L)z.push(C.readVSBuffer());return new A.$Bw(o(T,z,P))}static serializeReplyErr(C,P){const F=P?p(R.$3(P),null):void 0;if(typeof F!="string")return this.h(C);const T=N.$Fe.fromString(F);let z=0;z+=g.sizeLongString(T);const L=g.alloc(11,C,z);return L.writeLongString(T),L.buffer}static deserializeReplyErrError(C){const P=C.readLongString();return JSON.parse(P)}static h(C){return g.alloc(12,C,0).buffer}}var m;(function(D){D[D.RequestJSONArgs=1]="RequestJSONArgs",D[D.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",D[D.RequestMixedArgs=3]="RequestMixedArgs",D[D.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",D[D.Acknowledged=5]="Acknowledged",D[D.Cancel=6]="Cancel",D[D.ReplyOKEmpty=7]="ReplyOKEmpty",D[D.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",D[D.ReplyOKJSON=9]="ReplyOKJSON",D[D.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",D[D.ReplyErrError=11]="ReplyErrError",D[D.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var E;(function(D){D[D.String=1]="String",D[D.VSBuffer=2]="VSBuffer",D[D.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",D[D.Undefined=4]="Undefined"})(E||(E={}))}),define(Se[328],De([1,0,21,27,15,85,5]),function(he,e,h,N,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TJ=e.$QJ=void 0,e.$RJ=A,e.$SJ=I,e.$QJ=(0,M.$wi)("notebookDocumentService");const b=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${b.join("")}]+`),k=7;function A(y){if(y.scheme!==O.Schemas.vscodeNotebookCell)return;const v=y.fragment.indexOf("s");if(v<0)return;const l=parseInt(y.fragment.substring(0,v).replace($,""),k),d=(0,h.$Ye)(y.fragment.substring(v+1)).toString();if(!isNaN(l))return{handle:l,notebook:y.with({scheme:d,fragment:null})}}function I(y,v){const l=v.toString(k),o=`${l.length<b.length?b[l.length-1]:"z"}${l}s${(0,h.$Ze)(h.$Fe.fromString(y.scheme),!0,!0)}`;return y.with({scheme:O.Schemas.vscodeNotebookCell,fragment:o})}class p{constructor(){this.a=new N.$Ac}getNotebook(v){if(v.scheme===O.Schemas.vscodeNotebookCell){const l=A(v);if(l){const d=this.a.get(l.notebook);if(d)return d}}return this.a.get(v)}addNotebookDocument(v){this.a.set(v.uri,v)}removeNotebookDocument(v){this.a.delete(v.uri)}}e.$TJ=p,(0,R.$xs)(e.$QJ,p,1)}),define(Se[120],De([1,0,21,35,39,101,15,16,12,38,328]),function(he,e,h,N,O,R,M,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bK=e.$$J=e.CellStatusbarAlignment=e.$0J=e.NotebookEditorPriority=e.$7J=e.$6J=e.$4J=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$3J=e.$2J=e.$1J=e.$ZJ=e.CellKind=e.$YJ=e.$XJ=e.$WJ=void 0,e.$5J=c,e.$8J=a,e.$9J=f,e.$_J=S,e.$aK=E,e.$WJ="workbench.editor.notebook",e.$XJ="workbench.editor.notebookTextDiffEditor",e.$YJ="workbench.editor.interactive";var I;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(I||(e.CellKind=I={})),e.$ZJ=["application/json","application/javascript","text/html","image/svg+xml",R.$Qs.latex,R.$Qs.markdown,"image/png","image/jpeg",R.$Qs.text],e.$1J=[R.$Qs.latex,R.$Qs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$Qs.text],e.$2J=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$3J="_notAvailable";var p;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})(p||(e.NotebookRunState=p={}));var y;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(y||(e.NotebookCellExecutionState=y={}));var v;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var l;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(l||(e.NotebookRendererMatch=l={}));var d;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(d||(e.RendererMessagingSpec=d={}));var o;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var n;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var u;(function(U){U.scheme=M.Schemas.vscodeNotebookCell;function X(be,ae){return(0,A.$SJ)(be,ae)}U.generate=X;function ie(be){return(0,A.$RJ)(be)}U.parse=ie;function q(be,ae){return be.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${ae??""},${be.scheme!==M.Schemas.file?be.scheme:""}`})}U.generateCellOutputUri=q;function G(be){if(be.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const ae=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(be.fragment);if(!ae)return;const Ie=ae[1]&&ae[1]!==""?ae[1]:void 0,ee=ae[2];return{outputId:Ie,notebook:be.with({scheme:ee||M.Schemas.file,fragment:null})}}U.parseCellOutputUri=G;function x(be,ae,Ie){return U.generate(be,ae).with({scheme:Ie})}U.generateCellPropertyUri=x;function ne(be,ae){if(be.scheme===ae)return U.parse(be.with({scheme:U.scheme}))}U.parseCellPropertyUri=ne})(u||(e.CellUri=u={}));const s=U=>$.$i?U.replace(/\//g,"\\"):U;class t{constructor(X=[],ie=e.$ZJ){this.e=ie,this.d=[...new Set(X)].map(q=>({pattern:q,matches:N.$qk(s(q))}))}sort(X){const ie=new Map(O.Iterable.map(X,G=>[G,s(G)]));let q=[];for(const{matches:G}of this.d)for(const[x,ne]of ie)if(G(ne)){q.push(x),ie.delete(x);break}return ie.size&&(q=q.concat([...ie.keys()].sort((G,x)=>this.e.indexOf(G)-this.e.indexOf(x)))),q}prioritize(X,ie){const q=this.f(X);if(q===-1){this.d.unshift({pattern:X,matches:N.$qk(s(X))});return}const G=new Set(ie.map(ne=>this.f(ne,q)));G.delete(-1);const x=Array.from(G).sort();this.d.splice(q+1,0,...x.map(ne=>this.d[ne]));for(let ne=x.length-1;ne>=0;ne--)this.d.splice(x[ne],1)}toArray(){return this.d.map(X=>X.pattern)}f(X,ie=this.d.length){const q=s(X);for(let G=0;G<ie;G++)if(this.d[G].matches(q))return G;return-1}}e.$4J=t;function c(U,X,ie,q=(G,x)=>G===x){const G=[];function x(ae,Ie,ee){if(Ie===0&&ee.length===0)return;const B=G[G.length-1];B&&B.start+B.deleteCount===ae?(B.deleteCount+=Ie,B.toInsert.push(...ee)):G.push({start:ae,deleteCount:Ie,toInsert:ee})}let ne=0,be=0;for(;;){if(ne===U.length){x(ne,0,X.slice(be));break}if(be===X.length){x(ne,U.length-ne,[]);break}const ae=U[ne],Ie=X[be];if(q(ae,Ie)){ne+=1,be+=1;continue}ie(Ie)?(x(ne,1,[]),ne+=1):(x(ne,0,[Ie]),be+=1)}return G}e.$6J=new k.$Nj("notebookEditorCursorAtBoundary","none"),e.$7J=new k.$Nj("notebookEditorCursorAtLineBoundary","none");var r;(function(U){U.default="default",U.option="option"})(r||(e.NotebookEditorPriority=r={}));function a(U){const X=U;return!!((typeof X.include=="string"||N.$rk(X.include))&&(typeof X.exclude=="string"||N.$rk(X.exclude)))}function f(U,X,ie){if(Array.isArray(U.viewType)&&U.viewType.indexOf(X)>=0||U.viewType===X)return!0;if(U.filenamePattern){const q=a(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,G=a(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(N.$pk(q,(0,b.$nc)(ie.fsPath).toLowerCase()))return!(G&&N.$pk(G,(0,b.$nc)(ie.fsPath).toLowerCase()))}return!1}e.$0J={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var g;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(g||(e.CellStatusbarAlignment=g={}));class w{static{this.d="notebook/"}static create(X){return`${w.d}${X}`}static parse(X){if(X.startsWith(w.d))return X.substring(w.d.length)}}e.$$J=w;function S(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}const m=new TextDecoder;function E(U){const X=[];let ie=!1;for(const ne of U)(X.length===0||ie)&&(X.push(ne),ie=!0);let q=P(X);const G=h.$Fe.concat(X.map(ne=>h.$Fe.wrap(ne))),x=j(G);return q=q||x.byteLength!==G.byteLength,{data:x,didCompression:q}}e.$bK="\x1B[A";const D=e.$bK.split("").map(U=>U.charCodeAt(0)),C=10;function P(U){let X=!1;return U.forEach((ie,q)=>{if(q===0||ie.length<e.$bK.length)return;const G=U[q-1],x=ie.subarray(0,e.$bK.length);if(x[0]===D[0]&&x[1]===D[1]&&x[2]===D[2]){const ne=G.lastIndexOf(C);if(ne===-1)return;X=!0,U[q-1]=G.subarray(0,ne),U[q]=ie.subarray(e.$bK.length)}}),X}function F(U){let X=U;do U=X,X=U.replace(/[^\n]\x08/gm,"");while(X.length<U.length);return U}function T(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const X=U.match(/^(.*)\r+/m)[1];let ie=U.match(/\r+(.*)$/m)[1];ie=ie+X.slice(ie.length,X.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ie)}return U}const z=8,L=13;function j(U){return!U.buffer.includes(z)&&!U.buffer.includes(L)?U:h.$Fe.fromString(T(F(m.decode(U.buffer))))}}),define(Se[8],De([1,0,19,13,81,27,101,14,18,2,30,25,33,67,120]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v){"use strict";var l,d,o,n,i,u,s,t,c,r,a,f,g,w,S,m,E;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$sO=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$rO=e.$qO=e.$pO=e.$oO=e.ChatLocation=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$bO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$1N=e.$ZN=e.$YN=e.$XN=e.$VN=e.$UN=e.$TN=e.$SN=e.TestRunProfileKind=e.TestResultState=e.$RN=e.$QN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$PN=e.NotebookVariablesRequestKind=e.$ON=e.$NN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$MN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$LN=e.$KN=e.$JN=e.$IN=e.$HN=e.ColorThemeKind=e.$GN=e.$FN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$EN=e.$DN=e.DebugConsoleMode=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$xN=e.$wN=e.FileChangeType=e.$vN=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$uN=e.$tN=e.$sN=e.$rN=e.InlineCompletionTriggerKind=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=e.$jN=e.$iN=e.$hN=e.$gN=e.$eN=e.ConfigurationTarget=e.$dN=e.$cN=e.$bN=e.$aN=e.DocumentPasteTriggerKind=e.$_M=e.$$M=e.$0M=e.$9M=e.$8M=e.$7M=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$6M=e.ViewBadge=e.ProgressLocation=e.$5M=e.$4M=e.TaskScope=e.ShellQuoting=e.$3M=e.$2M=e.$1M=e.TaskPanelKind=e.TaskRevealKind=e.$ZM=e.TerminalLocation=e.$YM=e.$XM=e.$WM=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$VM=e.$UM=e.$TM=e.$SM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$QM=e.$PM=e.$OM=e.$NM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$MM=e.$LM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.LanguageStatusSeverity=e.$FM=e.$EM=e.$DM=e.$CM=e.$BM=e.$AM=e.CodeActionTriggerKind=e.$zM=e.$yM=e.SymbolTag=e.SymbolKind=e.$xM=e.$wM=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.DiagnosticSeverity=e.DiagnosticTag=e.$qM=e.$pM=e.FileEditType=e.$oM=e.$nM=e.$mM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$RM=It,e.$fN=Ke,e.$WN=vi;function D(H){return Object.assign(H,{apply:function(...me){if(me.length===0)return Reflect.construct(H,[]);{const Le=me.length===1?[]:me[1];return Reflect.construct(H,Le,me[0].constructor)}},call:function(...me){if(me.length===0)return Reflect.construct(H,[]);{const[Le,...Je]=me;return Reflect.construct(H,Je,Le.constructor)}}})}var C;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var P;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(P||(e.TerminalQuickFixType=P={}));let F=l=class{static from(...Q){let me=Q;return new l(function(){if(me){for(const Le of me)Le&&typeof Le.dispose=="function"&&Le.dispose();me=void 0}})}#e;constructor(Q){this.#e=Q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$fM=F,e.$fM=F=l=He([D],F);let T=d=class{static Min(...Q){if(Q.length===0)throw new TypeError;let me=Q[0];for(let Le=1;Le<Q.length;Le++){const Je=Q[Le];Je.isBefore(me)&&(me=Je)}return me}static Max(...Q){if(Q.length===0)throw new TypeError;let me=Q[0];for(let Le=1;Le<Q.length;Le++){const Je=Q[Le];Je.isAfter(me)&&(me=Je)}return me}static isPosition(Q){if(!Q)return!1;if(Q instanceof d)return!0;const{line:me,character:Le}=Q;return typeof me=="number"&&typeof Le=="number"}static of(Q){if(Q instanceof d)return Q;if(this.isPosition(Q))return new d(Q.line,Q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(Q,me){if(Q<0)throw(0,N.$7)("line must be non-negative");if(me<0)throw(0,N.$7)("character must be non-negative");this.c=Q,this.e=me}isBefore(Q){return this.c<Q.c?!0:Q.c<this.c?!1:this.e<Q.e}isBeforeOrEqual(Q){return this.c<Q.c?!0:Q.c<this.c?!1:this.e<=Q.e}isAfter(Q){return!this.isBeforeOrEqual(Q)}isAfterOrEqual(Q){return!this.isBefore(Q)}isEqual(Q){return this.c===Q.c&&this.e===Q.e}compareTo(Q){return this.c<Q.c?-1:this.c>Q.line?1:this.e<Q.e?-1:this.e>Q.e?1:0}translate(Q,me=0){if(Q===null||me===null)throw(0,N.$7)();let Le;return typeof Q>"u"?Le=0:typeof Q=="number"?Le=Q:(Le=typeof Q.lineDelta=="number"?Q.lineDelta:0,me=typeof Q.characterDelta=="number"?Q.characterDelta:0),Le===0&&me===0?this:new d(this.line+Le,this.character+me)}with(Q,me=this.character){if(Q===null||me===null)throw(0,N.$7)();let Le;return typeof Q>"u"?Le=this.line:typeof Q=="number"?Le=Q:(Le=typeof Q.line=="number"?Q.line:this.line,me=typeof Q.character=="number"?Q.character:this.character),Le===this.line&&me===this.character?this:new d(Le,me)}toJSON(){return{line:this.line,character:this.character}}};e.$gM=T,e.$gM=T=d=He([D],T);let z=o=class{static isRange(Q){return Q instanceof o?!0:Q?T.isPosition(Q.start)&&T.isPosition(Q.end):!1}static of(Q){if(Q instanceof o)return Q;if(this.isRange(Q))return new o(Q.start,Q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(Q,me,Le,Je){let et,dt;if(typeof Q=="number"&&typeof me=="number"&&typeof Le=="number"&&typeof Je=="number"?(et=new T(Q,me),dt=new T(Le,Je)):T.isPosition(Q)&&T.isPosition(me)&&(et=T.of(Q),dt=T.of(me)),!et||!dt)throw new Error("Invalid arguments");et.isBefore(dt)?(this.c=et,this.e=dt):(this.c=dt,this.e=et)}contains(Q){return o.isRange(Q)?this.contains(Q.start)&&this.contains(Q.end):T.isPosition(Q)?!(T.of(Q).isBefore(this.c)||this.e.isBefore(Q)):!1}isEqual(Q){return this.c.isEqual(Q.c)&&this.e.isEqual(Q.e)}intersection(Q){const me=T.Max(Q.start,this.c),Le=T.Min(Q.end,this.e);if(!me.isAfter(Le))return new o(me,Le)}union(Q){if(this.contains(Q))return this;if(Q.contains(this))return Q;const me=T.Min(Q.start,this.c),Le=T.Max(Q.end,this.end);return new o(me,Le)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(Q,me=this.end){if(Q===null||me===null)throw(0,N.$7)();let Le;return Q?T.isPosition(Q)?Le=Q:(Le=Q.start||this.start,me=Q.end||this.end):Le=this.start,Le.isEqual(this.c)&&me.isEqual(this.end)?this:new o(Le,me)}toJSON(){return[this.start,this.end]}};e.$hM=z,e.$hM=z=o=He([D],z);let L=n=class extends z{static isSelection(Q){return Q instanceof n?!0:Q?z.isRange(Q)&&T.isPosition(Q.anchor)&&T.isPosition(Q.active)&&typeof Q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(Q,me,Le,Je){let et,dt;if(typeof Q=="number"&&typeof me=="number"&&typeof Le=="number"&&typeof Je=="number"?(et=new T(Q,me),dt=new T(Le,Je)):T.isPosition(Q)&&T.isPosition(me)&&(et=T.of(Q),dt=T.of(me)),!et||!dt)throw new Error("Invalid arguments");super(et,dt),this.f=et,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$iM=L,e.$iM=L=n=He([D],L);const j=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,N.$7)("connectionToken")};class U{static isResolvedAuthority(Q){return Q&&typeof Q=="object"&&typeof Q.host=="string"&&typeof Q.port=="number"&&(Q.connectionToken===void 0||typeof Q.connectionToken=="string")}constructor(Q,me,Le){if(typeof Q!="string"||Q.length===0)throw(0,N.$7)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,N.$7)("port");typeof Le<"u"&&j(Le),this.host=Q,this.port=Math.round(me),this.connectionToken=Le}}e.$jM=U;class X{static isManagedResolvedAuthority(Q){return Q&&typeof Q=="object"&&typeof Q.makeConnection=="function"&&(Q.connectionToken===void 0||typeof Q.connectionToken=="string")}constructor(Q,me){this.makeConnection=Q,this.connectionToken=me,typeof me<"u"&&j(me)}}e.$kM=X;class ie extends Error{static NotAvailable(Q,me){return new ie(Q,y.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(Q){return new ie(Q,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(Q,me=y.RemoteAuthorityResolverErrorCode.Unknown,Le){super(Q),this._message=Q,this._code=me,this._detail=Le,Object.setPrototypeOf(this,ie.prototype)}}e.$lM=ie;var q;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(q||(e.EndOfLine=q={}));var G;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(G||(e.EnvironmentVariableMutatorType=G={}));let x=i=class{static isTextEdit(Q){return Q instanceof i?!0:Q?z.isRange(Q)&&typeof Q.newText=="string":!1}static replace(Q,me){return new i(Q,me)}static insert(Q,me){return i.replace(new z(Q,Q),me)}static delete(Q){return i.replace(Q,"")}static setEndOfLine(Q){const me=new i(new z(new T(0,0),new T(0,0)),"");return me.newEol=Q,me}get range(){return this.c}set range(Q){if(Q&&!z.isRange(Q))throw(0,N.$7)("range");this.c=Q}get newText(){return this.e||""}set newText(Q){if(Q&&typeof Q!="string")throw(0,N.$7)("newText");this.e=Q}get newEol(){return this.f}set newEol(Q){if(Q&&typeof Q!="number")throw(0,N.$7)("newEol");this.f=Q}constructor(Q,me){this.c=Q,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$mM=x,e.$mM=x=i=He([D],x);let ne=u=class{static isNotebookCellEdit(Q){return Q instanceof u?!0:Q?mn.isNotebookRange(Q)&&Array.isArray(Q.newCells):!1}static replaceCells(Q,me){return new u(Q,me)}static insertCells(Q,me){return new u(new mn(Q,Q),me)}static deleteCells(Q){return new u(Q,[])}static updateCellMetadata(Q,me){const Le=new u(new mn(Q,Q),[]);return Le.newCellMetadata=me,Le}static updateNotebookMetadata(Q){const me=new u(new mn(0,0),[]);return me.newNotebookMetadata=Q,me}constructor(Q,me){this.range=Q,this.newCells=me}};e.$nM=ne,e.$nM=ne=u=He([D],ne);class be{static isSnippetTextEdit(Q){return Q instanceof be?!0:Q?z.isRange(Q.range)&&ee.isSnippetString(Q.snippet):!1}static replace(Q,me){return new be(Q,me)}static insert(Q,me){return be.replace(new z(Q,Q),me)}constructor(Q,me){this.range=Q,this.snippet=me}}e.$oM=be;var ae;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})(ae||(e.FileEditType=ae={}));let Ie=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(Q,me,Le,Je){this.c.push({_type:1,from:Q,to:me,options:Le,metadata:Je})}createFile(Q,me,Le){this.c.push({_type:1,from:void 0,to:Q,options:me,metadata:Le})}deleteFile(Q,me,Le){this.c.push({_type:1,from:Q,to:void 0,options:me,metadata:Le})}e(Q,me,Le){this.c.push({_type:3,metadata:Le,uri:Q,edit:{editType:5,metadata:me},notebookMetadata:me})}f(Q,me,Le,Je){const et=me.start,dt=me.end;(et!==dt||Le.length>0)&&this.c.push({_type:5,uri:Q,index:et,count:dt-et,cells:Le,metadata:Je})}g(Q,me,Le,Je){this.c.push({_type:3,metadata:Je,uri:Q,edit:{editType:3,index:me,metadata:Le}})}replace(Q,me,Le,Je){this.c.push({_type:2,uri:Q,edit:new x(me,Le),metadata:Je})}insert(Q,me,Le,Je){this.replace(Q,new z(me,me),Le,Je)}delete(Q,me,Le){this.replace(Q,me,"",Le)}has(Q){return this.c.some(me=>me._type===2&&me.uri.toString()===Q.toString())}set(Q,me){if(me)for(const Le of me){if(!Le)continue;let Je,et;Array.isArray(Le)?(Je=Le[0],et=Le[1]):Je=Le,ne.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(Q,Je.range.start,Je.newCellMetadata,et):Je.newNotebookMetadata?this.e(Q,Je.newNotebookMetadata,et):this.f(Q,Je.range,Je.newCells,et):be.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:Q,range:Je.range,edit:Je.snippet,metadata:et}):this.c.push({_type:2,uri:Q,edit:Je,metadata:et})}else{for(let Le=0;Le<this.c.length;Le++){const Je=this.c[Le];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===Q.toString()&&(this.c[Le]=void 0);break}}(0,h.$Ib)(this.c)}}get(Q){const me=[];for(const Le of this.c)Le._type===2&&Le.uri.toString()===Q.toString()&&me.push(Le.edit);return me}entries(){const Q=new R.$Ac;for(const me of this.c)if(me._type===2){let Le=Q.get(me.uri);Le||(Le=[me.uri,[]],Q.set(me.uri,Le)),Le[1].push(me.edit)}return[...Q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$pM=Ie,e.$pM=Ie=He([D],Ie);let ee=s=class{static isSnippetString(Q){return Q instanceof s?!0:Q?typeof Q.value=="string":!1}static c(Q){return Q.replace(/\$|}|\\/g,"\\$&")}constructor(Q){this.e=1,this.value=Q||""}appendText(Q){return this.value+=s.c(Q),this}appendTabstop(Q=this.e++){return this.value+="$",this.value+=Q,this}appendPlaceholder(Q,me=this.e++){if(typeof Q=="function"){const Le=new s;Le.e=this.e,Q(Le),this.e=Le.e,Q=Le.value}else Q=s.c(Q);return this.value+="${",this.value+=me,this.value+=":",this.value+=Q,this.value+="}",this}appendChoice(Q,me=this.e++){const Le=Q.map(Je=>Je.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(Q,me){if(typeof me=="function"){const Le=new s;Le.e=this.e,me(Le),this.e=Le.e,me=Le.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=Q,me&&(this.value+=":",this.value+=me),this.value+="}",this}};e.$qM=ee,e.$qM=ee=s=He([D],ee);var B;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(B||(e.DiagnosticTag=B={}));var _;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(_||(e.DiagnosticSeverity=_={}));let pe=t=class{static isLocation(Q){return Q instanceof t?!0:Q?z.isRange(Q.range)&&k.URI.isUri(Q.uri):!1}constructor(Q,me){if(this.uri=Q,me)if(z.isRange(me))this.range=z.of(me);else if(T.isPosition(me))this.range=new z(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$rM=pe,e.$rM=pe=t=He([D],pe);let ue=class{static is(Q){return Q?typeof Q.message=="string"&&Q.location&&z.isRange(Q.location.range)&&k.URI.isUri(Q.location.uri):!1}constructor(Q,me){this.location=Q,this.message=me}static isEqual(Q,me){return Q===me?!0:!Q||!me?!1:Q.message===me.message&&Q.location.range.isEqual(me.location.range)&&Q.location.uri.toString()===me.location.uri.toString()}};e.$sM=ue,e.$sM=ue=He([D],ue);let ce=class{constructor(Q,me,Le=_.Error){if(!z.isRange(Q))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=Q,this.message=me,this.severity=Le}toJSON(){return{severity:_[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(Q,me){return Q===me?!0:!Q||!me?!1:Q.message===me.message&&Q.severity===me.severity&&Q.code===me.code&&Q.severity===me.severity&&Q.source===me.source&&Q.range.isEqual(me.range)&&(0,h.$ub)(Q.tags,me.tags)&&(0,h.$ub)(Q.relatedInformation,me.relatedInformation,ue.isEqual)}};e.$tM=ce,e.$tM=ce=He([D],ce);let oe=class{constructor(Q,me){if(!Q)throw new Error("Illegal argument, contents must be defined");Array.isArray(Q)?this.contents=Q:this.contents=[Q],this.range=me}};e.$uM=oe,e.$uM=oe=He([D],oe);let le=class extends oe{constructor(Q,me,Le,Je){super(Q,me),this.canIncreaseHover=Le,this.canDecreaseHover=Je}};e.$vM=le,e.$vM=le=He([D],le);var K;(function(H){H[H.Increase=0]="Increase",H[H.Decrease=1]="Decrease"})(K||(e.HoverVerbosityAction=K={}));var se;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(se||(e.DocumentHighlightKind=se={}));let $e=class{constructor(Q,me=se.Text){this.range=Q,this.kind=me}toJSON(){return{range:this.range,kind:se[this.kind]}}};e.$wM=$e,e.$wM=$e=He([D],$e);let ve=class{constructor(Q,me){this.uri=Q,this.highlights=me}toJSON(){return{uri:this.uri,highlights:this.highlights.map(Q=>Q.toJSON())}}};e.$xM=ve,e.$xM=ve=He([D],ve);var Me;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(Me||(e.SymbolKind=Me={}));var ge;(function(H){H[H.Deprecated=1]="Deprecated"})(ge||(e.SymbolTag=ge={}));let Ae=c=class{static validate(Q){if(!Q.name)throw new Error("name must not be falsy")}constructor(Q,me,Le,Je,et){this.name=Q,this.kind=me,this.containerName=et,typeof Le=="string"&&(this.containerName=Le),Je instanceof pe?this.location=Je:Le instanceof z&&(this.location=new pe(Je,Le)),c.validate(this)}toJSON(){return{name:this.name,kind:Me[this.kind],location:this.location,containerName:this.containerName}}};e.$yM=Ae,e.$yM=Ae=c=He([D],Ae);let Re=r=class{static validate(Q){if(!Q.name)throw new Error("name must not be falsy");if(!Q.range.contains(Q.selectionRange))throw new Error("selectionRange must be contained in fullRange");Q.children?.forEach(r.validate)}constructor(Q,me,Le,Je,et){this.name=Q,this.detail=me,this.kind=Le,this.range=Je,this.selectionRange=et,this.children=[],r.validate(this)}};e.$zM=Re,e.$zM=Re=r=He([D],Re);var je;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(je||(e.CodeActionTriggerKind=je={}));let V=class{constructor(Q,me){this.title=Q,this.kind=me}};e.$AM=V,e.$AM=V=He([D],V);let W=class{static{a=this}static{this.c="."}constructor(Q){this.value=Q}append(Q){return new a(this.value?this.value+a.c+Q:Q)}intersects(Q){return this.contains(Q)||Q.contains(this)}contains(Q){return this.value===Q.value||Q.value.startsWith(this.value+a.c)}};e.$BM=W,e.$BM=W=a=He([D],W),W.Empty=new W(""),W.QuickFix=W.Empty.append("quickfix"),W.Refactor=W.Empty.append("refactor"),W.RefactorExtract=W.Refactor.append("extract"),W.RefactorInline=W.Refactor.append("inline"),W.RefactorMove=W.Refactor.append("move"),W.RefactorRewrite=W.Refactor.append("rewrite"),W.Source=W.Empty.append("source"),W.SourceOrganizeImports=W.Source.append("organizeImports"),W.SourceFixAll=W.Source.append("fixAll"),W.Notebook=W.Empty.append("notebook");let J=class{constructor(Q,me){if(this.range=Q,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$CM=J,e.$CM=J=He([D],J);class Z{constructor(Q,me,Le,Je,et,dt){this.kind=Q,this.name=me,this.detail=Le,this.uri=Je,this.range=et,this.selectionRange=dt}}e.$DM=Z;class de{constructor(Q,me){this.fromRanges=me,this.from=Q}}e.$EM=de;class we{constructor(Q,me){this.fromRanges=me,this.to=Q}}e.$FM=we;var Fe;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(Fe||(e.LanguageStatusSeverity=Fe={}));let Ve=class{constructor(Q,me){this.range=Q,this.command=me}get isResolved(){return!!this.command}};e.$GM=Ve,e.$GM=Ve=He([D],Ve);let Ge=f=class{#e;static isMarkdownString(Q){return Q instanceof f?!0:Q&&Q.appendCodeblock&&Q.appendMarkdown&&Q.appendText&&Q.value!==void 0}constructor(Q,me=!1){this.#e=new O.$Tk(Q,{supportThemeIcons:me})}get value(){return this.#e.value}set value(Q){this.#e.value=Q}get isTrusted(){return this.#e.isTrusted}set isTrusted(Q){this.#e.isTrusted=Q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(Q){this.#e.supportThemeIcons=Q}get supportHtml(){return this.#e.supportHtml}set supportHtml(Q){this.#e.supportHtml=Q}get baseUri(){return this.#e.baseUri}set baseUri(Q){this.#e.baseUri=Q}appendText(Q){return this.#e.appendText(Q),this}appendMarkdown(Q){return this.#e.appendMarkdown(Q),this}appendCodeblock(Q,me){return this.#e.appendCodeblock(me??"",Q),this}};e.$HM=Ge,e.$HM=Ge=f=He([D],Ge);let tt=class{constructor(Q,me){this.label=Q,this.documentation=me}};e.$IM=tt,e.$IM=tt=He([D],tt);let _e=class{constructor(Q,me){this.label=Q,this.documentation=me,this.parameters=[]}};e.$JM=_e,e.$JM=_e=He([D],_e);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$KM=nt,e.$KM=nt=He([D],nt);var rt;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(rt||(e.SignatureHelpTriggerKind=rt={}));var it;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let ct=class{constructor(Q){this.value=Q}};e.$LM=ct,e.$LM=ct=He([D],ct);let Oe=class{constructor(Q,me,Le){this.position=Q,this.label=me,this.kind=Le}};e.$MM=Oe,e.$MM=Oe=He([D],Oe);var Ee;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ee||(e.CompletionTriggerKind=Ee={}));var qe;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(qe||(e.CompletionItemKind=qe={}));var te;(function(H){H[H.Deprecated=1]="Deprecated"})(te||(e.CompletionItemTag=te={}));let re=class{constructor(Q,me){this.label=Q,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&qe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$NM=re,e.$NM=re=He([D],re);let Ce=class{constructor(Q=[],me=!1){this.items=Q,this.isIncomplete=me}};e.$OM=Ce,e.$OM=Ce=He([D],Ce);let Pe=class{constructor(Q,me,Le){this.insertText=Q,this.range=me,this.command=Le}};e.$PM=Pe,e.$PM=Pe=He([D],Pe);let Xe=class{constructor(Q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=Q}};e.$QM=Xe,e.$QM=Xe=He([D],Xe);var st;(function(H){H[H.Unknown=0]="Unknown",H[H.Word=1]="Word",H[H.Line=2]="Line",H[H.Suggest=3]="Suggest"})(st||(e.PartialAcceptTriggerKind=st={}));var lt;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(lt||(e.ViewColumn=lt={}));var gt;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(gt||(e.StatusBarAlignment=gt={}));function It(H,Q){return`${I.$Rm.toKey(H)}.${Q}`}var Pt;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var zt;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(zt||(e.TextDocumentSaveReason=zt={}));var Bt;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Bt||(e.TextEditorRevealType=Bt={}));var Dt;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(Dt||(e.TextEditorSelectionChangeKind=Dt={}));var _t;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var xe;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(xe||(e.DecorationRangeBehavior=xe={})),function(H){function Q(me){switch(me){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=Q}(Dt||(e.TextEditorSelectionChangeKind=Dt={}));var tn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(tn||(e.SyntaxTokenType=tn={})),function(H){function Q(me){switch(me){case H.Other:return"other";case H.Comment:return"comment";case H.String:return"string";case H.RegEx:return"regex"}return"other"}H.toString=Q}(tn||(e.SyntaxTokenType=tn={}));let nn=class{constructor(Q,me){if(me&&!k.URI.isUri(me))throw(0,N.$7)("target");if(!z.isRange(Q)||Q.isEmpty)throw(0,N.$7)("range");this.range=Q,this.target=me}};e.$SM=nn,e.$SM=nn=He([D],nn);let ft=class{constructor(Q,me,Le,Je){this.red=Q,this.green=me,this.blue=Le,this.alpha=Je}};e.$TM=ft,e.$TM=ft=He([D],ft);let bt=class{constructor(Q,me){if(me&&!(me instanceof ft))throw(0,N.$7)("color");if(!z.isRange(Q)||Q.isEmpty)throw(0,N.$7)("range");this.range=Q,this.color=me}};e.$UM=bt,e.$UM=bt=He([D],bt);let Ut=class{constructor(Q){if(!Q||typeof Q!="string")throw(0,N.$7)("label");this.label=Q}};e.$VM=Ut,e.$VM=Ut=He([D],Ut);var Kt;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(Kt||(e.ColorFormat=Kt={}));var Ft;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(Ft||(e.SourceControlInputBoxValidationType=Ft={}));var $t;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})($t||(e.TerminalExitReason=$t={}));var Rt;(function(H){H[H.Low=0]="Low",H[H.Medium=1]="Medium",H[H.High=2]="High"})(Rt||(e.TerminalShellExecutionCommandLineConfidence=Rt={}));class cn{constructor(Q,me,Le){if(this.startIndex=Q,this.length=me,this.tooltip=Le,typeof Q!="number"||Q<0)throw(0,N.$7)("startIndex");if(typeof me!="number"||me<1)throw(0,N.$7)("length");if(Le!==void 0&&typeof Le!="string")throw(0,N.$7)("tooltip")}}e.$WM=cn;class Vt{constructor(Q){this.uri=Q}}e.$XM=Vt;class Ze{constructor(Q){this.terminalCommand=Q}}e.$YM=Ze;var rn;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(rn||(e.TerminalLocation=rn={}));class un{constructor(Q){if(this.options=Q,typeof Q!="object")throw(0,N.$7)("options")}}e.$ZM=un;var Jt;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(Jt||(e.TaskRevealKind=Jt={}));var mt;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(mt||(e.TaskPanelKind=mt={}));let Nt=class{static{g=this}static{this.Clean=new g("clean","Clean")}static{this.Build=new g("build","Build")}static{this.Rebuild=new g("rebuild","Rebuild")}static{this.Test=new g("test","Test")}static from(Q){switch(Q){case"clean":return g.Clean;case"build":return g.Build;case"rebuild":return g.Rebuild;case"test":return g.Test;default:return}}constructor(Q,me){if(this.label=me,typeof Q!="string"||typeof me!="string")throw(0,N.$7)("name");this.c=Q}get id(){return this.c}};e.$1M=Nt,e.$1M=Nt=g=He([D],Nt);function Lt(H){let Q="";for(let me=0;me<H.length;me++)Q+=H[me].replace(/,/g,",,")+",";return Q}let Tt=class{constructor(Q,me,Le){if(typeof Q!="string")throw(0,N.$7)("process");this.e=[],this.c=Q,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Le):this.f=me)}get process(){return this.c}set process(Q){if(typeof Q!="string")throw(0,N.$7)("process");this.c=Q}get args(){return this.e}set args(Q){Array.isArray(Q)||(Q=[]),this.e=Q}get options(){return this.f}set options(Q){this.f=Q}computeId(){const Q=[];if(Q.push("process"),this.c!==void 0&&Q.push(this.c),this.e&&this.e.length>0)for(const me of this.e)Q.push(me);return Lt(Q)}};e.$2M=Tt,e.$2M=Tt=He([D],Tt);let Qt=class{constructor(Q,me,Le){if(this.f=[],Array.isArray(me)){if(!Q)throw(0,N.$7)("command can't be undefined or null");if(typeof Q!="string"&&typeof Q.value!="string")throw(0,N.$7)("command");this.e=Q,this.f=me,this.g=Le}else{if(typeof Q!="string")throw(0,N.$7)("commandLine");this.c=Q,this.g=me}}get commandLine(){return this.c}set commandLine(Q){if(typeof Q!="string")throw(0,N.$7)("commandLine");this.c=Q}get command(){return this.e?this.e:""}set command(Q){if(typeof Q!="string"&&typeof Q.value!="string")throw(0,N.$7)("command");this.e=Q}get args(){return this.f}set args(Q){this.f=Q||[]}get options(){return this.g}set options(Q){this.g=Q}computeId(){const Q=[];if(Q.push("shell"),this.c!==void 0&&Q.push(this.c),this.e!==void 0&&Q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)Q.push(typeof me=="string"?me:me.value);return Lt(Q)}};e.$3M=Qt,e.$3M=Qt=He([D],Qt);var Yt;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Yt||(e.ShellQuoting=Yt={}));var Zt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(Zt||(e.TaskScope=Zt={}));class Wt{constructor(Q){this.c=Q}computeId(){return"customExecution"+(0,A.$Sg)()}set callback(Q){this.c=Q}get callback(){return this.c}}e.$4M=Wt;let Mt=class{static{w=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(Q,me,Le,Je,et,dt){this.k=!1,this.l=this.definition=Q;let pt;typeof me=="string"?(this.o=this.name=me,this.w=this.source=Le,this.execution=Je,pt=et,this.k=!0):me===Zt.Global||me===Zt.Workspace?(this.target=me,this.o=this.name=Le,this.w=this.source=Je,this.execution=et,pt=dt):(this.target=me,this.o=this.name=Le,this.w=this.source=Je,this.execution=et,pt=dt),typeof pt=="string"?(this.r=[pt],this.t=!0):Array.isArray(pt)?(this.r=pt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(Q){this.j=Q}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Tt?this.l={type:w.e,id:this.q.computeId()}:this.q instanceof Qt?this.l={type:w.f,id:this.q.computeId()}:this.q instanceof Wt?this.l={type:w.c,id:this.q.computeId()}:this.l={type:w.g,id:(0,A.$Sg)()}}get definition(){return this.l}set definition(Q){if(Q==null)throw(0,N.$7)("Kind can't be undefined or null");this.B(),this.l=Q}get scope(){return this.m}set target(Q){this.B(),this.m=Q}get name(){return this.o}set name(Q){if(typeof Q!="string")throw(0,N.$7)("name");this.B(),this.o=Q}get execution(){return this.q}set execution(Q){Q===null&&(Q=void 0),this.B(),this.q=Q;const me=this.l.type;(w.g===me||w.e===me||w.f===me||w.c===me)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(Q){if(Array.isArray(Q))this.B(),this.r=Q,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(Q){Q!==!0&&Q!==!1&&(Q=!1),this.B(),this.u=Q}get source(){return this.w}set source(Q){if(typeof Q!="string"||Q.length===0)throw(0,N.$7)("source must be a string of length > 0");this.B(),this.w=Q}get group(){return this.x}set group(Q){Q===null&&(Q=void 0),this.B(),this.x=Q}get detail(){return this.A}set detail(Q){Q===null&&(Q=void 0),this.A=Q}get presentationOptions(){return this.y}set presentationOptions(Q){Q==null&&(Q=Object.create(null)),this.B(),this.y=Q}get runOptions(){return this.z}set runOptions(Q){Q==null&&(Q=Object.create(null)),this.B(),this.z=Q}};e.$5M=Mt,e.$5M=Mt=w=He([D],Mt);var Xt;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(Xt||(e.ProgressLocation=Xt={}));var Ct;(function(H){function Q(me){const Le=me;return(0,$.$ag)(Le.value)?Le.tooltip&&!(0,$.$9f)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}H.isViewBadge=Q})(Ct||(e.ViewBadge=Ct={}));let Et=S=class{static isTreeItem(Q,me){const Le=Q;if(Le.checkboxState!==void 0){const Je=(0,$.$ag)(Le.checkboxState)?Le.checkboxState:(0,$.$$f)(Le.checkboxState)&&(0,$.$ag)(Le.checkboxState.state)?Le.checkboxState.state:void 0,et=!(0,$.$ag)(Le.checkboxState)&&(0,$.$$f)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(Je===void 0||Je!==xt.Checked&&Je!==xt.Unchecked||et!==void 0&&!(0,$.$9f)(et))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(Q instanceof S)return!0;if(Le.label!==void 0&&!(0,$.$9f)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,$.$9f)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,$.$9f)(Le.iconPath)&&!k.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,$.$9f)(Le.iconPath.id))){const Je=Le.iconPath;if(!Je||!(0,$.$9f)(Je.light)&&!k.URI.isUri(Je.light)&&!(0,$.$9f)(Je.dark)&&!k.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,$.$9f)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!k.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,$.$9f)(Le.tooltip)&&!(Le.tooltip instanceof Ge)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<wt.None&&Le.collapsibleState>wt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,$.$9f)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(Q,me=wt.None){this.collapsibleState=me,k.URI.isUri(Q)?this.resourceUri=Q:this.label=Q}};e.$6M=Et,e.$6M=Et=S=He([D],Et);var wt;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(wt||(e.TreeItemCollapsibleState=wt={}));var xt;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(xt||(e.TreeItemCheckboxState=xt={}));let kt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(Q){this.value=Q}};e.$7M=kt,e.$7M=kt=He([D],kt);class ln extends kt{}e.$8M=ln;class en extends ln{#e;constructor(Q){super(""),this.#e=Q}asFile(){return this.#e}}e.$9M=en;class kn{constructor(Q,me,Le,Je){this.name=Q,this.uri=me,this._itemId=Le,this.c=Je}data(){return this.c()}}e.$0M=kn;let hn=class{#e=new Map;constructor(Q){for(const[me,Le]of Q??[]){const Je=this.#e.get(this.#t(me));Je?Je.push(Le):this.#e.set(this.#t(me),[Le])}}get(Q){return this.#e.get(this.#t(Q))?.[0]}set(Q,me){this.#e.set(this.#t(Q),[me])}forEach(Q,me){for(const[Le,Je]of this.#e)for(const et of Je)Q.call(me,et,Le,this)}*[Symbol.iterator](){for(const[Q,me]of this.#e)for(const Le of me)yield[Q,Le]}#t(Q){return Q.toLowerCase()}};e.$$M=hn,e.$$M=hn=He([D],hn);let gn=class{constructor(Q,me,Le){this.insertText=Q,this.title=me,this.kind=Le}};e.$_M=gn,e.$_M=gn=He([D],gn);var jt;(function(H){H[H.Automatic=0]="Automatic",H[H.PasteAs=1]="PasteAs"})(jt||(e.DocumentPasteTriggerKind=jt={}));class Ne{static{this.c="."}constructor(Q){this.value=Q}append(...Q){return new Ne((this.value?[this.value,...Q]:Q).join(Ne.c))}intersects(Q){return this.contains(Q)||Q.contains(this)}contains(Q){return this.value===Q.value||Q.value.startsWith(this.value+Ne.c)}}e.$aN=Ne,Ne.Empty=new Ne("");class ze{constructor(Q,me,Le){this.title=me,this.insertText=Q,this.kind=Le}}e.$bN=ze;let ye=class{constructor(Q,me){this.id=Q,this.color=me}static isThemeIcon(Q){return typeof Q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",Q.id),!1):!0}};e.$cN=ye,e.$cN=ye=He([D],ye),ye.File=new ye("file"),ye.Folder=new ye("folder");let Y=class{constructor(Q){this.id=Q}};e.$dN=Y,e.$dN=Y=He([D],Y);var Te;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(Te||(e.ConfigurationTarget=Te={}));let Qe=class{get base(){return this.c}set base(Q){this.c=Q,this.e=k.URI.file(Q)}get baseUri(){return this.e}set baseUri(Q){this.e=Q,this.c=Q.fsPath}constructor(Q,me){if(typeof Q!="string"&&(!Q||!k.URI.isUri(Q)&&!k.URI.isUri(Q.uri)))throw(0,N.$7)("base");if(typeof me!="string")throw(0,N.$7)("pattern");typeof Q=="string"?this.baseUri=k.URI.file(Q):k.URI.isUri(Q)?this.baseUri=Q:this.baseUri=Q.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$eN=Qe,e.$eN=Qe=He([D],Qe);const Ye=new WeakMap;function Ke(H,Q){Ye.set(H,Q)}let ot=class{constructor(Q,me,Le,Je,et){this.enabled=typeof Q=="boolean"?Q:!0,typeof me=="string"&&(this.condition=me),typeof Le=="string"&&(this.hitCondition=Le),typeof Je=="string"&&(this.logMessage=Je),typeof et=="string"&&(this.mode=et)}get id(){return this.c||(this.c=Ye.get(this)??(0,A.$Sg)()),this.c}};e.$gN=ot,e.$gN=ot=He([D],ot);let St=class extends ot{constructor(Q,me,Le,Je,et,dt){if(super(me,Le,Je,et,dt),Q===null)throw(0,N.$7)("location");this.location=Q}};e.$hN=St,e.$hN=St=He([D],St);let Ht=class extends ot{constructor(Q,me,Le,Je,et,dt){super(me,Le,Je,et,dt),this.functionName=Q}};e.$iN=Ht,e.$iN=Ht=He([D],Ht);let qt=class extends ot{constructor(Q,me,Le,Je,et,dt,pt,Gt){if(super(Je,et,dt,pt,Gt),!me)throw(0,N.$7)("dataId");this.label=Q,this.dataId=me,this.canPersist=Le}};e.$jN=qt,e.$jN=qt=He([D],qt);let At=class{constructor(Q,me,Le){this.command=Q,this.args=me||[],this.options=Le}};e.$kN=At,e.$kN=At=He([D],At);let ht=class{constructor(Q,me){this.port=Q,this.host=me}};e.$lN=ht,e.$lN=ht=He([D],ht);let An=class{constructor(Q){this.path=Q}};e.$mN=An,e.$mN=An=He([D],An);let dn=class{constructor(Q){this.implementation=Q}};e.$nN=dn,e.$nN=dn=He([D],dn);class yn{constructor(Q,me,Le){this.session=Q,this.threadId=me,this.frameId=Le}}e.$oN=yn;class Kn{constructor(Q,me){this.session=Q,this.threadId=me}}e.$pN=Kn;let Rn=class{constructor(Q,me){this.range=Q,this.expression=me}};e.$qN=Rn,e.$qN=Rn=He([D],Rn);var Jn;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Jn||(e.InlineCompletionTriggerKind=Jn={}));let Mn=class{constructor(Q,me){this.range=Q,this.text=me}};e.$rN=Mn,e.$rN=Mn=He([D],Mn);let Sn=class{constructor(Q,me,Le=!0){this.range=Q,this.variableName=me,this.caseSensitiveLookup=Le}};e.$sN=Sn,e.$sN=Sn=He([D],Sn);let On=class{constructor(Q,me){this.range=Q,this.expression=me}};e.$tN=On,e.$tN=On=He([D],On);let Dn=class{constructor(Q,me){this.frameId=Q,this.stoppedLocation=me}};e.$uN=Dn,e.$uN=Dn=He([D],Dn);var Zn;(function(H){H[H.AIGenerated=1]="AIGenerated"})(Zn||(e.NewSymbolNameTag=Zn={}));var Cn;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Cn||(e.NewSymbolNameTriggerKind=Cn={}));class Nn{constructor(Q,me){this.newSymbolName=Q,this.tags=me}}e.$vN=Nn;var Xn;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Xn||(e.FileChangeType=Xn={}));let Ln=m=class extends Error{static FileExists(Q){return new m(Q,p.FileSystemProviderErrorCode.FileExists,m.FileExists)}static FileNotFound(Q){return new m(Q,p.FileSystemProviderErrorCode.FileNotFound,m.FileNotFound)}static FileNotADirectory(Q){return new m(Q,p.FileSystemProviderErrorCode.FileNotADirectory,m.FileNotADirectory)}static FileIsADirectory(Q){return new m(Q,p.FileSystemProviderErrorCode.FileIsADirectory,m.FileIsADirectory)}static NoPermissions(Q){return new m(Q,p.FileSystemProviderErrorCode.NoPermissions,m.NoPermissions)}static Unavailable(Q){return new m(Q,p.FileSystemProviderErrorCode.Unavailable,m.Unavailable)}constructor(Q,me=p.FileSystemProviderErrorCode.Unknown,Le){super(k.URI.isUri(Q)?Q.toString(!0):Q),this.code=Le?.name??"Unknown",(0,p.$fl)(this,me),Object.setPrototypeOf(this,m.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.$wN=Ln,e.$wN=Ln=m=He([D],Ln);let pn=class{constructor(Q,me,Le){this.start=Q,this.end=me,this.kind=Le}};e.$xN=pn,e.$xN=pn=He([D],pn);var Yn;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Yn||(e.FoldingRangeKind=Yn={}));var xn;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(xn||(e.CommentThreadCollapsibleState=xn={}));var In;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(In||(e.CommentMode=In={}));var _n;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(_n||(e.CommentState=_n={}));var Tn;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(Tn||(e.CommentThreadState=Tn={}));var ei;(function(H){H[H.Current=0]="Current",H[H.Outdated=1]="Outdated"})(ei||(e.CommentThreadApplicability=ei={}));class ti{constructor(Q,me=[]){this.tokenTypes=Q,this.tokenModifiers=me}}e.$yN=ti;function li(H){return typeof H>"u"||(0,$.$0f)(H)}class Fn{constructor(Q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,Q){this.m=!0;for(let me=0,Le=Q.tokenTypes.length;me<Le;me++)this.k.set(Q.tokenTypes[me],me);for(let me=0,Le=Q.tokenModifiers.length;me<Le;me++)this.l.set(Q.tokenModifiers[me],me)}}push(Q,me,Le,Je,et){if(typeof Q=="number"&&typeof me=="number"&&typeof Le=="number"&&typeof Je=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this.q(Q,me,Le,Je,et);if(z.isRange(Q)&&typeof me=="string"&&li(Le))return this.o(Q,me,Le);throw(0,N.$7)()}o(Q,me,Le){if(!this.m)throw new Error("Legend must be provided in constructor");if(Q.start.line!==Q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(me))throw new Error("`tokenType` is not in the provided legend");const Je=Q.start.line,et=Q.start.character,dt=Q.end.character-Q.start.character,pt=this.k.get(me);let Gt=0;if(Le)for(const an of Le){if(!this.l.has(an))throw new Error("`tokenModifier` is not in the provided legend");const fn=this.l.get(an);Gt|=1<<fn>>>0}this.q(Je,et,dt,pt,Gt)}q(Q,me,Le,Je,et){if(this.f&&(Q<this.c||Q===this.c&&me<this.e)){this.f=!1;const Gt=this.g.length/5|0;let an=0,fn=0;for(let $n=0;$n<Gt;$n++){let wn=this.g[5*$n],Hn=this.g[5*$n+1];wn===0?(wn=an,Hn+=fn):wn+=an,this.g[5*$n]=wn,this.g[5*$n+1]=Hn,an=wn,fn=Hn}}let dt=Q,pt=me;this.f&&this.j>0&&(dt-=this.c,dt===0&&(pt-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=pt,this.g[this.j++]=Le,this.g[this.j++]=Je,this.g[this.j++]=et,this.c=Q,this.e=me}static r(Q){const me=[],Le=Q.length/5|0;for(let pt=0;pt<Le;pt++)me[pt]=pt;me.sort((pt,Gt)=>{const an=Q[5*pt],fn=Q[5*Gt];if(an===fn){const $n=Q[5*pt+1],wn=Q[5*Gt+1];return $n-wn}return an-fn});const Je=new Uint32Array(Q.length);let et=0,dt=0;for(let pt=0;pt<Le;pt++){const Gt=5*me[pt],an=Q[Gt+0],fn=Q[Gt+1],$n=Q[Gt+2],wn=Q[Gt+3],Hn=Q[Gt+4],Ti=an-et,gr=Ti===0?fn-dt:fn,Gn=5*pt;Je[Gn+0]=Ti,Je[Gn+1]=gr,Je[Gn+2]=$n,Je[Gn+3]=wn,Je[Gn+4]=Hn,et=an,dt=fn}return Je}build(Q){return this.f?new jn(new Uint32Array(this.g),Q):new jn(Fn.r(this.g),Q)}}e.$zN=Fn;class jn{constructor(Q,me){this.resultId=me,this.data=Q}}e.$AN=jn;class hi{constructor(Q,me,Le){this.start=Q,this.deleteCount=me,this.data=Le}}e.$BN=hi;class zn{constructor(Q,me){this.resultId=me,this.edits=Q}}e.$CN=zn;var Bn;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(Bn||(e.DebugConsoleMode=Bn={}));class Ue{constructor(Q){this.name=Q}}e.$DN=Ue;let sn=class{static{this.Back={iconPath:new ye("arrow-left")}}constructor(){}};e.$EN=sn,e.$EN=sn=He([D],sn);var Un;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(Un||(e.QuickPickItemKind=Un={}));var at;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(at||(e.InputBoxValidationSeverity=at={}));var vt;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(vt||(e.ExtensionKind=vt={}));class di{static validate(Q){if(typeof Q.badge=="string"){let me=(0,b.$Hf)(Q.badge,0);if(me<Q.badge.length&&(me+=(0,b.$Hf)(Q.badge,me)),Q.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(Q.badge&&!ye.isThemeIcon(Q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!Q.color&&!Q.badge&&!Q.tooltip)throw new Error("The decoration is empty");return!0}constructor(Q,me,Le){this.badge=Q,this.tooltip=me,this.color=Le}}e.$FN=di;let Wn=class{constructor(Q){this.kind=Q}};e.$GN=Wn,e.$GN=Wn=He([D],Wn);var Vn;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(Vn||(e.ColorThemeKind=Vn={}));class mn{static isNotebookRange(Q){return Q instanceof mn?!0:Q?typeof Q.start=="number"&&typeof Q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(Q,me){if(Q<0)throw(0,N.$7)("start must be positive");if(me<0)throw(0,N.$7)("end must be positive");Q<=me?(this.c=Q,this.e=me):(this.c=me,this.e=Q)}with(Q){let me=this.c,Le=this.e;return Q.start!==void 0&&(me=Q.start),Q.end!==void 0&&(Le=Q.end),me===this.c&&Le===this.e?this:new mn(me,Le)}}e.$HN=mn;class bn{static validate(Q){if(typeof Q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof Q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof Q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(Q){return Array.isArray(Q)&&Q.every(me=>bn.isNotebookCellData(me))}static isNotebookCellData(Q){return!0}constructor(Q,me,Le,Je,et,dt,pt){this.kind=Q,this.value=me,this.languageId=Le,this.mime=Je,this.outputs=et??[],this.metadata=dt,this.executionSummary=pt,bn.validate(this)}}e.$IN=bn;class fi{constructor(Q){this.cells=Q}}e.$JN=fi;class on{static isNotebookCellOutputItem(Q){return Q instanceof on?!0:Q?typeof Q.mime=="string"&&Q.data instanceof Uint8Array:!1}static error(Q){const me={name:Q.name,message:Q.message,stack:Q.stack};return on.json(me,"application/vnd.code.notebook.error")}static stdout(Q){return on.text(Q,"application/vnd.code.notebook.stdout")}static stderr(Q){return on.text(Q,"application/vnd.code.notebook.stderr")}static bytes(Q,me="application/octet-stream"){return new on(Q,me)}static#e=new TextEncoder;static text(Q,me=M.$Qs.text){const Le=on.#e.encode(String(Q));return new on(Le,me)}static json(Q,me="text/x-json"){const Le=JSON.stringify(Q,void 0,"	");return on.text(Le,me)}constructor(Q,me){this.data=Q,this.mime=me;const Le=(0,M.$Us)(me,!0);if(!Le)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.$KN=on;class Pn{static isNotebookCellOutput(Q){return Q instanceof Pn?!0:!Q||typeof Q!="object"?!1:typeof Q.id=="string"&&Array.isArray(Q.items)}static ensureUniqueMimeTypes(Q,me=!1){const Le=new Set,Je=new Set;for(let et=0;et<Q.length;et++){const dt=Q[et],pt=(0,M.$Us)(dt.mime);if(!Le.has(pt)||(0,v.$_J)(pt)){Le.add(pt);continue}Je.add(et),me&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Je.size===0?Q:Q.filter((et,dt)=>!Je.has(dt))}constructor(Q,me,Le){this.items=Pn.ensureUniqueMimeTypes(Q,!0),typeof me=="string"?(this.id=me,this.metadata=Le):(this.id=(0,A.$Sg)(),this.metadata=me??Le)}}e.$LN=Pn;var qn;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(qn||(e.NotebookCellKind=qn={}));var ni;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(ni||(e.NotebookCellExecutionState=ni={}));var ii;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(ii||(e.NotebookCellStatusBarAlignment=ii={}));var ri;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(ri||(e.NotebookEditorRevealType=ri={}));class gi{constructor(Q,me){this.text=Q,this.alignment=me}}e.$MN=gi;var si;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(si||(e.NotebookControllerAffinity=si={}));var oi;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(oi||(e.NotebookControllerAffinity2=oi={}));class mi{constructor(Q,me=[]){this.uri=Q,this.provides=(0,h.$2b)(me)}}e.$NN=mi;class $i{constructor(Q){this.label=Q}}e.$ON=$i;var ai;(function(H){H[H.Named=1]="Named",H[H.Indexed=2]="Indexed"})(ai||(e.NotebookVariablesRequestKind=ai={}));let Qn=class{constructor(Q,me){this.label=Q,this.timestamp=me}};e.$PN=Qn,e.$PN=Qn=He([D],Qn);var ci;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(ci||(e.ExtensionMode=ci={}));var fe;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(fe||(e.ExtensionRuntime=fe={}));var ke;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(ke||(e.StandardTokenType=ke={}));class Be{constructor(Q,me){this.ranges=Q,this.wordPattern=me}}e.$QN=Be;class ut{constructor(Q){this.c=Q}get autoForwardAction(){return this.c}}e.$RN=ut;var yt;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(yt||(e.TestResultState=yt={}));var Ot;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(Ot||(e.TestRunProfileKind=Ot={}));let En=class{constructor(Q=void 0,me=void 0,Le=void 0,Je=!1,et=!0){this.include=Q,this.exclude=me,this.profile=Le,this.continuous=Je,this.preserveFocus=et}};e.$SN=En,e.$SN=En=He([D],En);let pi=E=class{static diff(Q,me,Le){const Je=new E(Q);return Je.expectedOutput=me,Je.actualOutput=Le,Je}constructor(Q){this.message=Q}};e.$TN=pi,e.$TN=pi=E=He([D],pi);let bi=class{constructor(Q){this.id=Q}};e.$UN=bi,e.$UN=bi=He([D],bi);class ui{constructor(Q,me){this.covered=Q,this.total=me,vi(this)}}e.$VN=ui;function vi(H){if(H){if(H.covered>H.total)throw new Error(`The total number of covered items (${H.covered}) cannot be greater than the total (${H.total})`);if(H.total<0)throw new Error(`The number of covered items (${H.total}) cannot be negative`)}}class wi{static fromDetails(Q,me){const Le=new ui(0,0),Je=new ui(0,0),et=new ui(0,0);for(const pt of me)if("branches"in pt){Le.total+=1,Le.covered+=pt.executed?1:0;for(const Gt of pt.branches)Je.total+=1,Je.covered+=Gt.executed?1:0}else et.total+=1,et.covered+=pt.executed?1:0;const dt=new wi(Q,Le,Je.total>0?Je:void 0,et.total>0?et:void 0);return dt.detailedCoverage=me,dt}constructor(Q,me,Le,Je){this.uri=Q,this.statementCoverage=me,this.branchCoverage=Le,this.declarationCoverage=Je}}e.$XN=wi;class Fi{get executionCount(){return+this.executed}set executionCount(Q){this.executed=Q}constructor(Q,me,Le=[]){this.executed=Q,this.location=me,this.branches=Le}}e.$YN=Fi;class ji{get executionCount(){return+this.executed}set executionCount(Q){this.executed=Q}constructor(Q,me,Le){this.executed=Q,this.location=me,this.label=Le}}e.$ZN=ji;class zi{get executionCount(){return+this.executed}set executionCount(Q){this.executed=Q}constructor(Q,me,Le){this.name=Q,this.executed=me,this.location=Le}}e.$1N=zi;var yi;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(yi||(e.ExternalUriOpenerPriority=yi={}));var Ei;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(Ei||(e.WorkspaceTrustState=Ei={}));var ki;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(ki||(e.PortAutoForwardAction=ki={}));class Bi{constructor(Q,me,Le,Je,et,dt){this.kind=Q,this.name=me,this.detail=Le,this.uri=Je,this.range=et,this.selectionRange=dt}}e.$2N=Bi;class Ui{constructor(Q){this.uri=Q}}e.$3N=Ui;class Wi{constructor(Q,me){this.original=Q,this.modified=me}}e.$4N=Wi;class Vi{constructor(Q,me,Le,Je){this.base=Q,this.input1=me,this.input2=Le,this.result=Je}}e.$5N=Vi;class qi{constructor(Q,me){this.uri=Q,this.viewType=me}}e.$6N=qi;class Qi{constructor(Q){this.viewType=Q}}e.$7N=Qi;class Hi{constructor(Q,me){this.uri=Q,this.notebookType=me}}e.$8N=Hi;class Gi{constructor(Q,me,Le){this.original=Q,this.modified=me,this.notebookType=Le}}e.$9N=Gi;class Ki{constructor(){}}e.$0N=Ki;class Ji{constructor(Q,me){this.uri=Q,this.inputBoxUri=me}}e.$$N=Ji;class Zi{constructor(){}}e.$_N=Zi;class Xi{constructor(Q){this.textDiffs=Q}}e.$aO=Xi;var Si;(function(H){H[H.Down=0]="Down",H[H.Up=1]="Up"})(Si||(e.InteractiveSessionVoteDirection=Si={}));var Di;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(Di||(e.ChatCopyKind=Di={}));var Ci;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(Ci||(e.ChatVariableLevel=Ci={}));class Yi{constructor(Q,me){this.label=Q,this.values=me}}e.$bO=Yi;var Ii;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted",H[H.Bug=4]="Bug"})(Ii||(e.InteractiveEditorResponseFeedbackKind=Ii={}));var Pi;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful"})(Pi||(e.ChatResultFeedbackKind=Pi={}));class xi{constructor(Q){if(typeof Q!="string"&&Q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof Q=="string"?new Ge(Q):Q}}e.$cO=xi;class _i{constructor(Q,me){if(typeof Q!="string"&&Q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof Q=="string"?new Ge(Q):Q,this.vulnerabilities=me}}e.$dO=_i;class er{constructor(Q,me){this.participant=Q,this.command=me}}e.$eO=er;class tr{constructor(Q,me){this.value=Q,this.baseUri=me}}e.$fO=tr;class nr{constructor(Q,me){this.value=Q,this.title=me}}e.$gO=nr;class ir{constructor(Q){this.value=Q}}e.$hO=ir;class rr{constructor(Q){if(typeof Q!="string"&&Q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof Q=="string"?new Ge(Q):Q}}e.$iO=rr;class sr{constructor(Q){this.value=Q}}e.$jO=sr;class or{constructor(Q,me){this.value=Q,this.iconPath=me}}e.$kO=or;class ar{constructor(Q,me){this.uri=Q,this.edits=Array.isArray(me)?me:[me]}}e.$lO=ar;class cr{constructor(Q,me,Le,Je){this.prompt=Q,this.command=me,this.variables=Le,this.participant=Je}}e.$mO=cr;class ur{constructor(Q,me,Le,Je){this.response=Q,this.result=me,this.participant=Le,this.command=Je}}e.$nO=ur;var Ai;(function(H){H[H.Panel=1]="Panel",H[H.Terminal=2]="Terminal",H[H.Notebook=3]="Notebook",H[H.Editor=4]="Editor"})(Ai||(e.ChatLocation=Ai={}));class lr{constructor(Q){this.content=Q}}e.$oO=lr;class hr{constructor(Q,me){this.content=Q,this.name=me}}e.$pO=hr;class dr{constructor(Q,me){this.content=Q,this.name=me}}e.$qO=dr;class vn extends Error{static NotFound(Q){return new vn(Q,vn.NotFound.name)}static NoPermissions(Q){return new vn(Q,vn.NoPermissions.name)}static Blocked(Q){return new vn(Q,vn.Blocked.name)}constructor(Q,me,Le){super(Q,{cause:Le}),this.name="LanguageModelError",this.code=me??""}}e.$rO=vn;var Ri;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(Ri||(e.RelatedInformationType=Ri={}));var Mi;(function(H){H[H.Started=1]="Started",H[H.Recognizing=2]="Recognizing",H[H.Recognized=3]="Recognized",H[H.Stopped=4]="Stopped",H[H.Error=5]="Error"})(Mi||(e.SpeechToTextStatus=Mi={}));var Oi;(function(H){H[H.Started=1]="Started",H[H.Stopped=2]="Stopped",H[H.Error=3]="Error"})(Oi||(e.TextToSpeechStatus=Oi={}));var Ni;(function(H){H[H.Recognized=1]="Recognized",H[H.Stopped=2]="Stopped"})(Ni||(e.KeywordRecognitionStatus=Ni={}));class fr{constructor(Q,me){this.text=Q,this.range=me}}e.$sO=fr;var Li;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Li||(e.InlineEditTriggerKind=Li={}))}),define(Se[329],De([1,0,6,8]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=void 0;class O{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(h.$dM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,b,$){if(this.a.size===0)throw new Error("No related information providers registered");const k=this.a.get(M);if(!k)throw new Error("related information provider not found");return await k.provideRelatedInformation(b,$)??[]}getRelatedInformation(M,b,$){return this.c.$getAiRelatedInformation(b,$)}registerRelatedInformationProvider(M,b,$){const k=this.b;return this.b++,this.a.set(k,$),this.c.$registerAiRelatedInformationProvider(k,b),new N.$fM(()=>{this.c.$unregisterAiRelatedInformationProvider(k),this.a.delete(k)})}}e.$ulc=O}),define(Se[121],De([1,0,4,6,8,25,146,5,20]),function(he,e,h,N,O,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Glc=e.$Flc=void 0,e.$Flc=(0,b.$wi)("IExtHostAuthentication");let k=class{constructor(p){this.b=new Map,this.c=new h.$de,this.onDidChangeSessions=this.c.event,this.d=new A,this.f=new A,this.a=p.getProxy(N.$dM.MainThreadAuthentication)}async getSession(p,y,v,l={}){const d=R.$Rm.toKey(p.identifier),o=[...v].sort().join(" ");return await this.d.getOrCreate(`${d} ${y} ${o}`,async()=>{await this.a.$ensureProvider(y);const n=p.displayName||p.name;return this.a.$getSession(y,v,d,n,l)})}async getSessions(p,y,v){const l=R.$Rm.toKey(p.identifier),d=[...v].sort().join(" ");return await this.f.getOrCreate(`${l} ${d}`,async()=>{await this.a.$ensureProvider(y);const o=p.displayName||p.name;return this.a.$getSessions(y,v,l,o)})}async removeSession(p,y){const v=this.b.get(p);return v?v.provider.removeSession(y):this.a.$removeSession(p,y)}registerAuthenticationProvider(p,y,v,l){if(this.b.get(p))throw new Error(`An authentication provider with id '${p}' is already registered.`);this.b.set(p,{label:y,provider:v,options:l??{supportsMultipleAccounts:!1}});const d=v.onDidChangeSessions(o=>this.a.$sendDidChangeSessions(p,o));return this.a.$registerAuthenticationProvider(p,y,l?.supportsMultipleAccounts??!1),new O.$fM(()=>{d.dispose(),this.b.delete(p),this.a.$unregisterAuthenticationProvider(p)})}async $createSession(p,y,v){const l=this.b.get(p);if(l)return await l.provider.createSession(y,v);throw new Error(`Unable to find authentication provider with handle: ${p}`)}async $removeSession(p,y){const v=this.b.get(p);if(v)return await v.provider.removeSession(y);throw new Error(`Unable to find authentication provider with handle: ${p}`)}async $getSessions(p,y){const v=this.b.get(p);if(v)return await v.provider.getSessions(y);throw new Error(`Unable to find authentication provider with handle: ${p}`)}$onDidChangeAuthenticationSessions(p,y){return p.startsWith(M.$fL)||this.c.fire({provider:{id:p,label:y}}),Promise.resolve()}};e.$Glc=k,e.$Glc=k=He([We(0,$.$EO)],k);class A{constructor(){this.a=new Map}getOrCreate(p,y){const v=this.a.get(p);if(v)return v;const l=y().finally(()=>this.a.delete(p));return this.a.set(p,l),l}}}),define(Se[152],De([1,0,2,6,8,5,20,11,19,14,16,26]),function(he,e,h,N,O,R,M,b,$,k,A,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gmc=e.$Fmc=void 0;let y=class{static{p=this}static{this.c=0}static{this.d=250}constructor(l,d){this.h=d,this.f=new Map,this.g=l.getProxy(N.$dM.MainThreadDecorations)}registerFileDecorationProvider(l,d){const o=p.c++;this.f.set(o,{provider:l,extensionDescription:d}),this.g.$registerDecorationProvider(o,d.identifier.value);const n=l.onDidChangeFileDecorations&&l.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(o,null);return}const u=(0,$.$2b)(i);if(u.length<=p.d){this.g.$onDidChange(o,u);return}this.h.warn("[Decorations] CAPPING events from decorations provider",d.identifier.value,u.length);const s=u.map(r=>({uri:r,rank:(0,k.$af)(r.path,"/")})),t=(0,$.$zb)(s,(r,a)=>r.rank-a.rank||(0,k.$qf)(r.uri.path,a.uri.path)),c=[];e:for(const r of t){let a;for(const f of r){const g=(0,A.$mc)(f.uri.path);if(a!==g&&(a=g,c.push(f.uri)>=p.d))break e}}this.g.$onDidChange(o,c)});return new O.$fM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(l,d,o){if(!this.f.has(l))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:u}=this.f.get(l);return await Promise.all(d.map(async s=>{try{const{uri:t,id:c}=s,r=await Promise.resolve(i.provideFileDecoration(h.URI.revive(t),o));if(!r)return;try{O.$FN.validate(r),r.badge&&typeof r.badge!="string"&&(0,I.$PG)(u,"codiconDecoration"),n[c]=[r.propagate,r.tooltip,r.badge,r.color]}catch(a){this.h.warn(`INVALID decoration from extension '${u.identifier.value}': ${a}`)}}catch(t){this.h.error(t)}})),n}};e.$Fmc=y,e.$Fmc=y=p=He([We(0,M.$EO),We(1,b.$3j)],y),e.$Gmc=(0,R.$wi)("IExtHostDecorations")}),define(Se[330],De([1,0,13,2,8,6,15,22,14]),function(he,e,h,N,O,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=void 0;class k{static{this.a=0}constructor(I,p,y){this.d=p,this.e=y,this.b=new Map,this.c=I.getProxy(R.$dM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,p){if(Object.keys(M.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const y=k.a++;this.b.set(y,p),this.c.$registerTextContentProvider(y,I);let v;if(typeof p.onDidChange=="function"){let l;v=p.onDidChange(async d=>{if(d.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(d))return;l&&await l;const o=this.$provideTextDocumentContent(y,d).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(d);if(!i)return;const u=(0,$.$kf)(n);if(!i.equalLines(u))return this.c.$onVirtualDocumentChange(d,n)}).catch(h.$1).finally(()=>{l===o&&(l=void 0)});l=o})}return new O.$fM(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(I,p){const y=this.b.get(I);return y?Promise.resolve(y.provideTextDocumentContent(N.URI.revive(p),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.$Imc=k}),define(Se[153],De([1,0,62,15,14,188,130,8,19]),function(he,e,h,N,O,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IO=e.$HO=void 0,e.$GO=A;const k=new Map;function A(v,l){l?k.set(v,l):k.delete(v)}function I(v){return k.get(v)}class p extends R.$6v{constructor(l,d,o,n,i,u,s){super(d,o,n,i),this.c=l,this.m=u,this.q=s,this.b=!1}dispose(){(0,h.ok)(!this.b),this.b=!0,this.q=!1}equalLines(l){return(0,$.$ub)(this.f,l)}get document(){if(!this.a){const l=this;this.a={get uri(){return l.d},get fileName(){return l.d.fsPath},get isUntitled(){return l.d.scheme===N.Schemas.untitled},get languageId(){return l.m},get version(){return l.h},get isClosed(){return l.b},get isDirty(){return l.q},save(){return l.r()},getText(d){return d?l.s(d):l.getText()},get eol(){return l.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return l.f.length},lineAt(d){return l.t(d)},offsetAt(d){return l.u(d)},positionAt(d){return l.v(d)},validateRange(d){return l.w(d)},validatePosition(d){return l.x(d)},getWordRangeAtPosition(d,o){return l.y(d,o)}}}return Object.freeze(this.a)}_acceptLanguageId(l){(0,h.ok)(!this.b),this.m=l}_acceptIsDirty(l){(0,h.ok)(!this.b),this.q=l}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(l){const d=this.w(l);if(d.isEmpty)return"";if(d.isSingleLine)return this.f[d.start.line].substring(d.start.character,d.end.character);const o=this.g,n=d.start.line,i=d.end.line,u=[];u.push(this.f[n].substring(d.start.character));for(let s=n+1;s<i;s++)u.push(this.f[s]);return u.push(this.f[i].substring(0,d.end.character)),u.join(o)}t(l){let d;if(l instanceof b.$gM?d=l.line:typeof l=="number"&&(d=l),typeof d!="number"||d<0||d>=this.f.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new y(d,this.f[d],d===this.f.length-1)}u(l){return l=this.x(l),this.l(),this.j.getPrefixSum(l.line-1)+l.character}v(l){l=Math.floor(l),l=Math.max(0,l),this.l();const d=this.j.getIndexOf(l),o=this.f[d.index].length;return new b.$gM(d.index,Math.min(d.remainder,o))}w(l){if(!(l instanceof b.$hM))throw new Error("Invalid argument");const d=this.x(l.start),o=this.x(l.end);return d===l.start&&o===l.end?l:new b.$hM(d.line,d.character,o.line,o.character)}x(l){if(!(l instanceof b.$gM))throw new Error("Invalid argument");if(this.f.length===0)return l.with(0,0);let{line:d,character:o}=l,n=!1;if(d<0)d=0,o=0,n=!0;else if(d>=this.f.length)d=this.f.length-1,o=this.f[d].length,n=!0;else{const i=this.f[d].length;o<0?(o=0,n=!0):o>i&&(o=i,n=!0)}return n?new b.$gM(d,o):l}y(l,d){const o=this.x(l);if(!d)d=I(this.m);else if((0,O.$jf)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const n=(0,M.$9s)(o.character+1,(0,M.$7s)(d),this.f[o.line],0);if(n)return new b.$hM(o.line,n.startColumn-1,o.line,n.endColumn-1)}}e.$HO=p;class y{constructor(l,d,o){this.a=l,this.b=d,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$hM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$hM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$IO=y}),define(Se[331],De([1,0,6,8]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kmc=void 0;class O{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(h.$dM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,b,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const k=this.a.get(M);if(!k)throw new Error("Embedding vector provider not found");const A=await k.provideEmbeddingVector(b,$);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(M,b,$){const k=this.b;return this.b++,this.a.set(k,$),this.c.$registerAiEmbeddingVectorProvider(b,k),new N.$fM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(k),this.a.delete(k)})}}e.$Kmc=O}),define(Se[70],De([1,0,6,33,8,21,5,20,60,3,7,23,15]),function(he,e,h,N,O,R,M,b,$,k,A,I,p){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wlc=e.$Vlc=void 0;let v=y=class{constructor(d,o){this.b=new Map,this.c=new A.$Fh,this.a=d.getProxy(h.$dM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let u;const s=n.b.get(i.scheme);return s?(await n.a.$ensureActivation(i.scheme),u=await s.impl.stat(i)):u=await n.a.$stat(i),{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions===N.FilePermission.Readonly?1:void 0}}catch(u){y.e(u)}},async readDirectory(i){try{const u=n.b.get(i.scheme);return u?(await n.a.$ensureActivation(i.scheme),(await u.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(u){return y.e(u)}},async createDirectory(i){try{const u=n.b.get(i.scheme);return u&&!u.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(u.impl,u.extUri,i)):await n.a.$mkdir(i)}catch(u){return y.e(u)}},async readFile(i){try{const u=n.b.get(i.scheme);return u?(await n.a.$ensureActivation(i.scheme),(await u.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(u){return y.e(u)}},async writeFile(i,u){try{const s=n.b.get(i.scheme);return s&&!s.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(s.impl,s.extUri,s.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(s.impl.writeFile(i,u,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,R.$Fe.wrap(u))}catch(s){return y.e(s)}},async delete(i,u){try{const s=n.b.get(i.scheme);return s&&!s.isReadonly&&!u?.useTrash?(await n.a.$ensureActivation(i.scheme),await s.impl.delete(i,{recursive:!1,...u})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...u})}catch(s){return y.e(s)}},async rename(i,u,s){try{return await n.a.$rename(i,u,{overwrite:!1,...s})}catch(t){return y.e(t)}},async copy(i,u,s){try{return await n.a.$copy(i,u,{overwrite:!1,...s})}catch(t){return y.e(t)}},isWritableFileSystem(i){const u=o.getCapabilities(i);if(typeof u=="number")return!(u&2048)}})}async d(d,o,n){const i=[];for(;!o.isEqual(n,o.dirname(n));)try{if(!((await d.stat(n)).type&N.FileType.Directory))throw O.$wN.FileExists(`Unable to create folder '${n.scheme===p.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(u){if(N.$gl(u)!==N.FileSystemProviderErrorCode.FileNotFound)throw u;i.push(o.basename(n)),n=o.dirname(n)}for(let u=i.length-1;u>=0;u--){n=o.joinPath(n,i[u]);try{await d.createDirectory(n)}catch(s){if(N.$gl(s)!==N.FileSystemProviderErrorCode.FileExists)throw s}}}static e(d){if(d instanceof O.$wN)throw d;if(d instanceof N.$cl)switch(d.code){case N.FileSystemProviderErrorCode.FileExists:throw O.$wN.FileExists(d.message);case N.FileSystemProviderErrorCode.FileNotFound:throw O.$wN.FileNotFound(d.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw O.$wN.FileNotADirectory(d.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw O.$wN.FileIsADirectory(d.message);case N.FileSystemProviderErrorCode.NoPermissions:throw O.$wN.NoPermissions(d.message);case N.FileSystemProviderErrorCode.Unavailable:throw O.$wN.Unavailable(d.message);default:throw new O.$wN(d.message,d.name)}if(!(d instanceof Error))throw new O.$wN(String(d));if(d.name==="ENOPRO"||d.message.includes("ENOPRO"))throw O.$wN.Unavailable(d.message);switch(d.name){case N.FileSystemProviderErrorCode.FileExists:throw O.$wN.FileExists(d.message);case N.FileSystemProviderErrorCode.FileNotFound:throw O.$wN.FileNotFound(d.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw O.$wN.FileNotADirectory(d.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw O.$wN.FileIsADirectory(d.message);case N.FileSystemProviderErrorCode.NoPermissions:throw O.$wN.NoPermissions(d.message);case N.FileSystemProviderErrorCode.Unavailable:throw O.$wN.Unavailable(d.message);default:throw new O.$wN(d.message,d.name)}}addFileSystemProvider(d,o,n){return this.b.set(d,{impl:o,extUri:n?.isCaseSensitive?I.$Zg:I.$2g,isReadonly:!!n?.isReadonly}),(0,k.$Sc)(()=>this.b.delete(d))}getFileSystemProviderExtUri(d){return this.b.get(d)?.extUri??I.$Zg}};e.$Vlc=v,e.$Vlc=v=y=He([We(0,b.$EO),We(1,$.$zlc)],v),e.$Wlc=(0,M.$wi)("IExtHostConsumerFileSystem")}),define(Se[93],De([1,0,5,28,11,70,2]),function(he,e,h,N,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ylc=e.$Xlc=void 0,e.$Xlc=(0,h.$wi)("IExtensionStoragePaths");let b=class{constructor(k,A,I){this.d=A,this.f=I,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(p=>this.c=p)}async g(k){return M.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,A=await this.g(k);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(M.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(k){if(this.c)return M.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return M.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Ylc=b,e.$Ylc=b=He([We(0,N.$UO),We(1,O.$3j),We(2,R.$Wlc)],b)}),define(Se[332],De([1,0,8,20,4]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=void 0;let R=class{constructor(b){this.a=new h.$GN(h.ColorThemeKind.Dark),this.b=new O.$de}get activeColorTheme(){return this.a}$onColorThemeChange(b){let $;switch(b){case"light":$=h.ColorThemeKind.Light;break;case"hcDark":$=h.ColorThemeKind.HighContrast;break;case"hcLight":$=h.ColorThemeKind.HighContrastLight;break;default:$=h.ColorThemeKind.Dark}this.a=new h.$GN($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$snc=R,e.$snc=R=He([We(0,N.$EO)],R)}),define(Se[71],De([1,0,22,4,3,234,5,11,88,6,28,20,8]),function(he,e,h,N,O,R,M,b,$,k,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DDb=e.$CDb=e.TunnelDtoConverter=void 0;class y extends $.$sw{}var v;(function(d){function o(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:i.protocol}}d.fromApiTunnel=o;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==$.TunnelPrivacyId.ConstantPrivate&&i.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}d.fromServiceTunnel=n})(v||(e.TunnelDtoConverter=v={})),e.$CDb=(0,M.$wi)("IExtHostTunnelService");let l=class extends O.$Uc{constructor(o,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$de,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(k.$dM.MainThreadTunnelService)}async openTunnel(o,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,o.displayName);if(i){const u=new y(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(u),u}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,n){o.portRange===void 0&&o.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:o,provider:n}),this.a.$registerPortsAttributesProvider(o,i),new p.$fM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(o,n,i,u,s){const t=[];for(const r of o){const a=this.r.get(r);if(!a)return[];t.push(...await Promise.all(n.map(async f=>{let g;try{g=await a.provider.providePortAttributes({port:f,pid:i,commandLine:u},s)}catch{g=await a.provider.providePortAttributes(f,i,u,s)}return{providedAttributes:g,port:f}})))}const c=t.filter(r=>!!r.providedAttributes);return c.length>0?c.map(r=>({autoForwardAction:r.providedAttributes.autoForwardAction,port:r.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(u,s)=>await o.provideTunnel(u,s,h.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,O.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,n){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const i=o.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let u=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&u.length===0&&(u=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const s=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:u,protocol:!0}:void 0;this.a.$setTunnelProvider(s)}}else this.b=void 0;return(0,O.$Sc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,n){if(this.g.has(o.host)){const i=this.g.get(o.host);i.has(o.port)&&(n&&i.get(o.port).disposeListener.dispose(),await i.get(o.port).tunnel.dispose(),i.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(o,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const u=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),u===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const s=this.B(u.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(u.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:u,disposeListener:s}),v.fromApiTunnel(u)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(o){const n=await Promise.all(o.map(u=>this.f(u.host,u.port,u.detail??""))),i=o.filter((u,s)=>n[s]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(u=>u.port).join(", ")} to ${i.map(u=>u.port).join(", ")}`),i}};e.$DDb=l,e.$DDb=l=He([We(0,I.$EO),We(1,A.$UO),We(2,b.$3j)],l)}),define(Se[17],De([1,0,19,21,177,75,81,27,167,58,101,24,172,23,50,18,2,29,84,139,145,143,296,120,69,89,308,8]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d,o,n,i,u,s,t,c,r,a,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelMessage=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$BO=U,e.$CO=ie,e.$DO=q;var w;(function(Ne){function ze(Y){const{selectionStartLineNumber:Te,selectionStartColumn:Qe,positionLineNumber:Ye,positionColumn:Ke}=Y,ot=new g.$gM(Te-1,Qe-1),St=new g.$gM(Ye-1,Ke-1);return new g.$iM(ot,St)}Ne.to=ze;function ye(Y){const{anchor:Te,active:Qe}=Y;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:Qe.line+1,positionColumn:Qe.character+1}}Ne.from=ye})(w||(e.Selection=w={}));var S;(function(Ne){function ze(Y){if(!Y)return;const{start:Te,end:Qe}=Y;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:Qe.line+1,endColumn:Qe.character+1}}Ne.from=ze;function ye(Y){if(!Y)return;const{startLineNumber:Te,startColumn:Qe,endLineNumber:Ye,endColumn:Ke}=Y;return new g.$hM(Te-1,Qe-1,Ye-1,Ke-1)}Ne.to=ye})(S||(e.Range=S={}));var m;(function(Ne){function ze(Y){return{uri:Y.uri,range:S.from(Y.range)}}Ne.from=ze;function ye(Y){return new g.$rM(d.URI.revive(Y.uri),S.to(Y.range))}Ne.to=ye})(m||(e.Location=m={}));var E;(function(Ne){function ze(ye){switch(ye){case 1:return g.StandardTokenType.Comment;case 0:return g.StandardTokenType.Other;case 3:return g.StandardTokenType.RegEx;case 2:return g.StandardTokenType.String}}Ne.to=ze})(E||(e.TokenType=E={}));var D;(function(Ne){function ze(Y){return new g.$gM(Y.lineNumber-1,Y.column-1)}Ne.to=ze;function ye(Y){return{lineNumber:Y.line+1,column:Y.character+1}}Ne.from=ye})(D||(e.Position=D={}));var C;(function(Ne){function ze(Te,Qe,Ye){return(0,h.$Hb)((0,h.$2b)(Te).map(Ke=>ye(Ke,Qe,Ye)))}Ne.from=ze;function ye(Te,Qe,Ye){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:Ye?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:Y(Te.scheme,Qe),pattern:Ce.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:Ye?.isBuiltin}}function Y(Te,Qe){return Qe&&typeof Te=="string"?Qe.transformOutgoingScheme(Te):Te}})(C||(e.DocumentSelector=C={}));var P;(function(Ne){function ze(Y){switch(Y){case g.DiagnosticTag.Unnecessary:return 1;case g.DiagnosticTag.Deprecated:return 2}}Ne.from=ze;function ye(Y){switch(Y){case 1:return g.DiagnosticTag.Unnecessary;case 2:return g.DiagnosticTag.Deprecated;default:return}}Ne.to=ye})(P||(e.DiagnosticTag=P={}));var F;(function(Ne){function ze(Y){let Te;return Y.code&&((0,l.$9f)(Y.code)||(0,l.$ag)(Y.code)?Te=String(Y.code):Te={value:String(Y.code.value),target:Y.code.target}),{...S.from(Y.range),message:Y.message,source:Y.source,code:Te,severity:z.from(Y.severity),relatedInformation:Y.relatedInformation&&Y.relatedInformation.map(T.from),tags:Array.isArray(Y.tags)?(0,h.$Hb)(Y.tags.map(P.from)):void 0}}Ne.from=ze;function ye(Y){const Te=new g.$tM(S.to(Y),Y.message,z.to(Y.severity));return Te.source=Y.source,Te.code=(0,l.$9f)(Y.code)?Y.code:Y.code?.value,Te.relatedInformation=Y.relatedInformation&&Y.relatedInformation.map(T.to),Te.tags=Y.tags&&(0,h.$Hb)(Y.tags.map(P.to)),Te}Ne.to=ye})(F||(e.Diagnostic=F={}));var T;(function(Ne){function ze(Y){return{...S.from(Y.location.range),message:Y.message,resource:Y.location.uri}}Ne.from=ze;function ye(Y){return new g.$sM(new g.$rM(Y.resource,S.to(Y)),Y.message)}Ne.to=ye})(T||(e.DiagnosticRelatedInformation=T={}));var z;(function(Ne){function ze(Y){switch(Y){case g.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case g.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case g.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case g.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}Ne.from=ze;function ye(Y){switch(Y){case i.MarkerSeverity.Info:return g.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return g.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return g.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return g.DiagnosticSeverity.Hint;default:return g.DiagnosticSeverity.Error}}Ne.to=ye})(z||(e.DiagnosticSeverity=z={}));var L;(function(Ne){function ze(Y){return typeof Y=="number"&&Y>=g.ViewColumn.One?Y-1:Y===g.ViewColumn.Beside?f.$5D:f.$4D}Ne.from=ze;function ye(Y){if(typeof Y=="number"&&Y>=0)return Y+1;throw new Error("invalid 'EditorGroupColumn'")}Ne.to=ye})(L||(e.ViewColumn=L={}));function j(Ne){return typeof Ne.range<"u"}function U(Ne){return Ne.length===0?!0:!!j(Ne[0])}var X;(function(Ne){function ze(Ke){return Ke.map(Ne.from)}Ne.fromMany=ze;function ye(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function Y(Ke){let ot;if(ye(Ke)){const{language:At,value:ht}=Ke;ot={value:"```"+At+`
`+ht+"\n```\n"}}else g.$HM.isMarkdownString(Ke)?ot={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?ot={value:Ke}:ot={value:""};const St=Object.create(null);ot.uris=St;const Ht=At=>{try{let ht=d.URI.parse(At,!0);ht=ht.with({query:Te(ht.query,St)}),St[At]=ht}catch{}return""},qt=new $.marked.Renderer;return qt.link=Ht,qt.image=At=>typeof At=="string"?Ht(M.$2k(At).href):"",(0,$.marked)(ot.value,{renderer:qt}),ot}Ne.from=Y;function Te(Ke,ot){if(!Ke)return Ke;let St;try{St=(0,k.$5h)(Ke)}catch{}if(!St)return Ke;let Ht=!1;return St=(0,I.$5n)(St,qt=>{if(d.URI.isUri(qt)){const At=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[At]=qt,Ht=!0,At}else return}),Ht?JSON.stringify(St):Ke}function Qe(Ke){const ot=new g.$HM(Ke.value,Ke.supportThemeIcons);return ot.isTrusted=Ke.isTrusted,ot.supportHtml=Ke.supportHtml,ot.baseUri=Ke.baseUri?d.URI.from(Ke.baseUri):void 0,ot}Ne.to=Qe;function Ye(Ke){if(Ke)return typeof Ke=="string"?Ke:Ne.from(Ke)}Ne.fromStrict=Ye})(X||(e.MarkdownString=X={}));function ie(Ne){return U(Ne)?Ne.map(ze=>({range:S.from(ze.range),hoverMessage:Array.isArray(ze.hoverMessage)?X.fromMany(ze.hoverMessage):ze.hoverMessage?X.from(ze.hoverMessage):void 0,renderOptions:ze.renderOptions})):Ne.map(ze=>({range:S.from(ze)}))}function q(Ne){return typeof Ne>"u"?Ne:typeof Ne=="string"?d.URI.file(Ne):Ne}var G;(function(Ne){function ze(ye){return typeof ye>"u"?ye:{contentText:ye.contentText,contentIconPath:ye.contentIconPath?q(ye.contentIconPath):void 0,border:ye.border,borderColor:ye.borderColor,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,color:ye.color,backgroundColor:ye.backgroundColor,margin:ye.margin,width:ye.width,height:ye.height}}Ne.from=ze})(G||(e.ThemableDecorationAttachmentRenderOptions=G={}));var x;(function(Ne){function ze(ye){return typeof ye>"u"?ye:{backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?q(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?G.from(ye.before):void 0,after:ye.after?G.from(ye.after):void 0}}Ne.from=ze})(x||(e.ThemableDecorationRenderOptions=x={}));var ne;(function(Ne){function ze(ye){if(typeof ye>"u")return ye;switch(ye){case g.DecorationRangeBehavior.OpenOpen:return 0;case g.DecorationRangeBehavior.ClosedClosed:return 1;case g.DecorationRangeBehavior.OpenClosed:return 2;case g.DecorationRangeBehavior.ClosedOpen:return 3}}Ne.from=ze})(ne||(e.DecorationRangeBehavior=ne={}));var be;(function(Ne){function ze(ye){return{isWholeLine:ye.isWholeLine,rangeBehavior:ye.rangeBehavior?ne.from(ye.rangeBehavior):void 0,overviewRulerLane:ye.overviewRulerLane,light:ye.light?x.from(ye.light):void 0,dark:ye.dark?x.from(ye.dark):void 0,backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?q(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?G.from(ye.before):void 0,after:ye.after?G.from(ye.after):void 0}}Ne.from=ze})(be||(e.DecorationRenderOptions=be={}));var ae;(function(Ne){function ze(Y){return{text:Y.newText,eol:Y.newEol&&Oe.from(Y.newEol),range:S.from(Y.range)}}Ne.from=ze;function ye(Y){const Te=new g.$mM(S.to(Y.range),Y.text);return Te.newEol=typeof Y.eol>"u"?void 0:Oe.to(Y.eol),Te}Ne.to=ye})(ae||(e.TextEdit=ae={}));var Ie;(function(Ne){function ze(Y,Te){const Qe={edits:[]};if(Y instanceof g.$pM){const Ye=new b.$Bc;for(const Ke of Y._allEntries())Ke._type===1&&d.URI.isUri(Ke.to)&&Ke.from===void 0&&Ye.add(Ke.to);for(const Ke of Y._allEntries())if(Ke._type===1){let ot;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?ot={type:"base64",value:(0,N.$Ze)(N.$Fe.wrap(Ke.options.contents))}:ot={type:"dataTransferItem",id:Ke.options.contents._itemId}),Qe.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:ot},metadata:Ke.metadata})}else Ke._type===2?Qe.edits.push({resource:Ke.uri,textEdit:ae.from(Ke.edit),versionId:Ye.has(Ke.uri)?void 0:Te?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?Qe.edits.push({resource:Ke.uri,textEdit:{range:S.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:Ye.has(Ke.uri)?void 0:Te?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?Qe.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&Qe.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(zt.from)}})}return Qe}Ne.from=ze;function ye(Y){const Te=new g.$pM,Qe=new b.$Ac;for(const Ye of Y.edits)if(Ye.textEdit){const Ke=Ye,ot=d.URI.revive(Ke.resource),St=S.to(Ke.textEdit.range),Ht=Ke.textEdit.text,qt=Ke.textEdit.insertAsSnippet;let At;qt?At=g.$oM.replace(St,new g.$qM(Ht)):At=g.$mM.replace(St,Ht);const ht=Qe.get(ot);ht?ht.push(At):Qe.set(ot,[At])}else Te.renameFile(d.URI.revive(Ye.oldResource),d.URI.revive(Ye.newResource),Ye.options);for(const[Ye,Ke]of Qe)Te.set(Ye,Ke);return Te}Ne.to=ye})(Ie||(e.WorkspaceEdit=Ie={}));var ee;(function(Ne){const ze=Object.create(null);ze[g.SymbolKind.File]=0,ze[g.SymbolKind.Module]=1,ze[g.SymbolKind.Namespace]=2,ze[g.SymbolKind.Package]=3,ze[g.SymbolKind.Class]=4,ze[g.SymbolKind.Method]=5,ze[g.SymbolKind.Property]=6,ze[g.SymbolKind.Field]=7,ze[g.SymbolKind.Constructor]=8,ze[g.SymbolKind.Enum]=9,ze[g.SymbolKind.Interface]=10,ze[g.SymbolKind.Function]=11,ze[g.SymbolKind.Variable]=12,ze[g.SymbolKind.Constant]=13,ze[g.SymbolKind.String]=14,ze[g.SymbolKind.Number]=15,ze[g.SymbolKind.Boolean]=16,ze[g.SymbolKind.Array]=17,ze[g.SymbolKind.Object]=18,ze[g.SymbolKind.Key]=19,ze[g.SymbolKind.Null]=20,ze[g.SymbolKind.EnumMember]=21,ze[g.SymbolKind.Struct]=22,ze[g.SymbolKind.Event]=23,ze[g.SymbolKind.Operator]=24,ze[g.SymbolKind.TypeParameter]=25;function ye(Te){return typeof ze[Te]=="number"?ze[Te]:6}Ne.from=ye;function Y(Te){for(const Qe in ze)if(ze[Qe]===Te)return Number(Qe);return g.SymbolKind.Property}Ne.to=Y})(ee||(e.SymbolKind=ee={}));var B;(function(Ne){function ze(Y){switch(Y){case g.SymbolTag.Deprecated:return 1}}Ne.from=ze;function ye(Y){switch(Y){case 1:return g.SymbolTag.Deprecated}}Ne.to=ye})(B||(e.SymbolTag=B={}));var _;(function(Ne){function ze(Y){return{name:Y.name,kind:ee.from(Y.kind),tags:Y.tags&&Y.tags.map(B.from),containerName:Y.containerName,location:le.from(Y.location)}}Ne.from=ze;function ye(Y){const Te=new g.$yM(Y.name,ee.to(Y.kind),Y.containerName,le.to(Y.location));return Te.tags=Y.tags&&Y.tags.map(B.to),Te}Ne.to=ye})(_||(e.WorkspaceSymbol=_={}));var pe;(function(Ne){function ze(Y){const Te={name:Y.name||"!!MISSING: name!!",detail:Y.detail,range:S.from(Y.range),selectionRange:S.from(Y.selectionRange),kind:ee.from(Y.kind),tags:Y.tags?.map(B.from)??[]};return Y.children&&(Te.children=Y.children.map(ze)),Te}Ne.from=ze;function ye(Y){const Te=new g.$zM(Y.name,Y.detail,ee.to(Y.kind),S.to(Y.range),S.to(Y.selectionRange));return(0,h.$Lb)(Y.tags)&&(Te.tags=Y.tags.map(B.to)),Y.children&&(Te.children=Y.children.map(ye)),Te}Ne.to=ye})(pe||(e.DocumentSymbol=pe={}));var ue;(function(Ne){function ze(Y){const Te=new g.$DM(ee.to(Y.kind),Y.name,Y.detail||"",d.URI.revive(Y.uri),S.to(Y.range),S.to(Y.selectionRange));return Te._sessionId=Y._sessionId,Te._itemId=Y._itemId,Te}Ne.to=ze;function ye(Y,Te,Qe){if(Te=Te??Y._sessionId,Qe=Qe??Y._itemId,Te===void 0||Qe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Qe,name:Y.name,detail:Y.detail,kind:ee.from(Y.kind),uri:Y.uri,range:S.from(Y.range),selectionRange:S.from(Y.selectionRange),tags:Y.tags?.map(B.from)}}Ne.from=ye})(ue||(e.CallHierarchyItem=ue={}));var ce;(function(Ne){function ze(ye){return new g.$EM(ue.to(ye.from),ye.fromRanges.map(Y=>S.to(Y)))}Ne.to=ze})(ce||(e.CallHierarchyIncomingCall=ce={}));var oe;(function(Ne){function ze(ye){return new g.$FM(ue.to(ye.to),ye.fromRanges.map(Y=>S.to(Y)))}Ne.to=ze})(oe||(e.CallHierarchyOutgoingCall=oe={}));var le;(function(Ne){function ze(Y){return{range:Y.range&&S.from(Y.range),uri:Y.uri}}Ne.from=ze;function ye(Y){return new g.$rM(d.URI.revive(Y.uri),S.to(Y.range))}Ne.to=ye})(le||(e.location=le={}));var K;(function(Ne){function ze(Y){const Te=Y,Qe=Y;return{originSelectionRange:Te.originSelectionRange?S.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:Qe.uri,range:S.from(Te.targetRange?Te.targetRange:Qe.range),targetSelectionRange:Te.targetSelectionRange?S.from(Te.targetSelectionRange):void 0}}Ne.from=ze;function ye(Y){return{targetUri:d.URI.revive(Y.uri),targetRange:S.to(Y.range),targetSelectionRange:Y.targetSelectionRange?S.to(Y.targetSelectionRange):void 0,originSelectionRange:Y.originSelectionRange?S.to(Y.originSelectionRange):void 0}}Ne.to=ye})(K||(e.DefinitionLink=K={}));var se;(function(Ne){function ze(Y){return{range:S.from(Y.range),contents:X.fromMany(Y.contents),canIncreaseVerbosity:Y.canIncreaseVerbosity,canDecreaseVerbosity:Y.canDecreaseVerbosity}}Ne.from=ze;function ye(Y){const Te=Y.contents.map(X.to),Qe=S.to(Y.range),Ye=Y.canIncreaseVerbosity,Ke=Y.canDecreaseVerbosity;return new g.$vM(Te,Qe,Ye,Ke)}Ne.to=ye})(se||(e.Hover=se={}));var $e;(function(Ne){function ze(Y){return{range:S.from(Y.range),expression:Y.expression}}Ne.from=ze;function ye(Y){return new g.$qN(S.to(Y.range),Y.expression)}Ne.to=ye})($e||(e.EvaluatableExpression=$e={}));var ve;(function(Ne){function ze(Y){if(Y instanceof g.$rN)return{type:"text",range:S.from(Y.range),text:Y.text};if(Y instanceof g.$sN)return{type:"variable",range:S.from(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};if(Y instanceof g.$tN)return{type:"expression",range:S.from(Y.range),expression:Y.expression};throw new Error("Unknown 'InlineValue' type")}Ne.from=ze;function ye(Y){switch(Y.type){case"text":return{range:S.to(Y.range),text:Y.text};case"variable":return{range:S.to(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};case"expression":return{range:S.to(Y.range),expression:Y.expression}}}Ne.to=ye})(ve||(e.InlineValue=ve={}));var Me;(function(Ne){function ze(Y){return{frameId:Y.frameId,stoppedLocation:S.from(Y.stoppedLocation)}}Ne.from=ze;function ye(Y){return new g.$uN(Y.frameId,S.to(Y.stoppedLocation))}Ne.to=ye})(Me||(e.InlineValueContext=Me={}));var ge;(function(Ne){function ze(Y){return{range:S.from(Y.range),kind:Y.kind}}Ne.from=ze;function ye(Y){return new g.$wM(S.to(Y.range),Y.kind)}Ne.to=ye})(ge||(e.DocumentHighlight=ge={}));var Ae;(function(Ne){function ze(Y){return{uri:Y.uri,highlights:Y.highlights.map(ge.from)}}Ne.from=ze;function ye(Y){return new g.$xM(d.URI.revive(Y.uri),Y.highlights.map(ge.to))}Ne.to=ye})(Ae||(e.MultiDocumentHighlight=Ae={}));var Re;(function(Ne){function ze(ye){switch(ye){case 1:return g.CompletionTriggerKind.TriggerCharacter;case 2:return g.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return g.CompletionTriggerKind.Invoke}}Ne.to=ze})(Re||(e.CompletionTriggerKind=Re={}));var je;(function(Ne){function ze(ye){return{triggerKind:Re.to(ye.triggerKind),triggerCharacter:ye.triggerCharacter}}Ne.to=ze})(je||(e.CompletionContext=je={}));var V;(function(Ne){function ze(Y){switch(Y){case g.CompletionItemTag.Deprecated:return 1}}Ne.from=ze;function ye(Y){switch(Y){case 1:return g.CompletionItemTag.Deprecated}}Ne.to=ye})(V||(e.CompletionItemTag=V={}));var W;(function(Ne){const ze=new Map([[g.CompletionItemKind.Method,0],[g.CompletionItemKind.Function,1],[g.CompletionItemKind.Constructor,2],[g.CompletionItemKind.Field,3],[g.CompletionItemKind.Variable,4],[g.CompletionItemKind.Class,5],[g.CompletionItemKind.Interface,7],[g.CompletionItemKind.Struct,6],[g.CompletionItemKind.Module,8],[g.CompletionItemKind.Property,9],[g.CompletionItemKind.Unit,12],[g.CompletionItemKind.Value,13],[g.CompletionItemKind.Constant,14],[g.CompletionItemKind.Enum,15],[g.CompletionItemKind.EnumMember,16],[g.CompletionItemKind.Keyword,17],[g.CompletionItemKind.Snippet,27],[g.CompletionItemKind.Text,18],[g.CompletionItemKind.Color,19],[g.CompletionItemKind.File,20],[g.CompletionItemKind.Reference,21],[g.CompletionItemKind.Folder,23],[g.CompletionItemKind.Event,10],[g.CompletionItemKind.Operator,11],[g.CompletionItemKind.TypeParameter,24],[g.CompletionItemKind.Issue,26],[g.CompletionItemKind.User,25]]);function ye(Qe){return ze.get(Qe)??9}Ne.from=ye;const Y=new Map([[0,g.CompletionItemKind.Method],[1,g.CompletionItemKind.Function],[2,g.CompletionItemKind.Constructor],[3,g.CompletionItemKind.Field],[4,g.CompletionItemKind.Variable],[5,g.CompletionItemKind.Class],[7,g.CompletionItemKind.Interface],[6,g.CompletionItemKind.Struct],[8,g.CompletionItemKind.Module],[9,g.CompletionItemKind.Property],[12,g.CompletionItemKind.Unit],[13,g.CompletionItemKind.Value],[14,g.CompletionItemKind.Constant],[15,g.CompletionItemKind.Enum],[16,g.CompletionItemKind.EnumMember],[17,g.CompletionItemKind.Keyword],[27,g.CompletionItemKind.Snippet],[18,g.CompletionItemKind.Text],[19,g.CompletionItemKind.Color],[20,g.CompletionItemKind.File],[21,g.CompletionItemKind.Reference],[23,g.CompletionItemKind.Folder],[10,g.CompletionItemKind.Event],[11,g.CompletionItemKind.Operator],[24,g.CompletionItemKind.TypeParameter],[25,g.CompletionItemKind.User],[26,g.CompletionItemKind.Issue]]);function Te(Qe){return Y.get(Qe)??g.CompletionItemKind.Property}Ne.to=Te})(W||(e.CompletionItemKind=W={}));var J;(function(Ne){function ze(ye,Y){const Te=new g.$NM(ye.label);return Te.insertText=ye.insertText,Te.kind=W.to(ye.kind),Te.tags=ye.tags?.map(V.to),Te.detail=ye.detail,Te.documentation=M.$Vk(ye.documentation)?X.to(ye.documentation):ye.documentation,Te.sortText=ye.sortText,Te.filterText=ye.filterText,Te.preselect=ye.preselect,Te.commitCharacters=ye.commitCharacters,o.$ut.isIRange(ye.range)?Te.range=S.to(ye.range):typeof ye.range=="object"&&(Te.range={inserting:S.to(ye.range.insert),replacing:S.to(ye.range.replace)}),Te.keepWhitespace=typeof ye.insertTextRules>"u"?!1:!!(ye.insertTextRules&1),typeof ye.insertTextRules<"u"&&ye.insertTextRules&4?Te.insertText=new g.$qM(ye.insertText):(Te.insertText=ye.insertText,Te.textEdit=Te.range instanceof g.$hM?new g.$mM(Te.range,Te.insertText):void 0),ye.additionalTextEdits&&ye.additionalTextEdits.length>0&&(Te.additionalTextEdits=ye.additionalTextEdits.map(Qe=>ae.to(Qe))),Te.command=Y&&ye.command?Y.fromInternal(ye.command):void 0,Te}Ne.to=ze})(J||(e.CompletionItem=J={}));var Z;(function(Ne){function ze(Y){if(typeof Y.label!="string"&&!Array.isArray(Y.label))throw new TypeError("Invalid label");return{label:Y.label,documentation:X.fromStrict(Y.documentation)}}Ne.from=ze;function ye(Y){return{label:Y.label,documentation:M.$Vk(Y.documentation)?X.to(Y.documentation):Y.documentation}}Ne.to=ye})(Z||(e.ParameterInformation=Z={}));var de;(function(Ne){function ze(Y){return{label:Y.label,documentation:X.fromStrict(Y.documentation),parameters:Array.isArray(Y.parameters)?Y.parameters.map(Z.from):[],activeParameter:Y.activeParameter}}Ne.from=ze;function ye(Y){return{label:Y.label,documentation:M.$Vk(Y.documentation)?X.to(Y.documentation):Y.documentation,parameters:Array.isArray(Y.parameters)?Y.parameters.map(Z.to):[],activeParameter:Y.activeParameter}}Ne.to=ye})(de||(e.SignatureInformation=de={}));var we;(function(Ne){function ze(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(de.from):[]}}Ne.from=ze;function ye(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(de.to):[]}}Ne.to=ye})(we||(e.SignatureHelp=we={}));var Fe;(function(Ne){function ze(ye,Y){const Te=new g.$MM(D.to(Y.position),typeof Y.label=="string"?Y.label:Y.label.map(Ve.to.bind(void 0,ye)),Y.kind&&Ge.to(Y.kind));return Te.textEdits=Y.textEdits&&Y.textEdits.map(ae.to),Te.tooltip=M.$Vk(Y.tooltip)?X.to(Y.tooltip):Y.tooltip,Te.paddingLeft=Y.paddingLeft,Te.paddingRight=Y.paddingRight,Te}Ne.to=ze})(Fe||(e.InlayHint=Fe={}));var Ve;(function(Ne){function ze(ye,Y){const Te=new g.$LM(Y.label);return Te.tooltip=M.$Vk(Y.tooltip)?X.to(Y.tooltip):Y.tooltip,n.Command.is(Y.command)&&(Te.command=ye.fromInternal(Y.command)),Y.location&&(Te.location=le.to(Y.location)),Te}Ne.to=ze})(Ve||(e.InlayHintLabelPart=Ve={}));var Ge;(function(Ne){function ze(Y){return Y}Ne.from=ze;function ye(Y){return Y}Ne.to=ye})(Ge||(e.InlayHintKind=Ge={}));var tt;(function(Ne){function ze(Y){return{range:S.from(Y.range),url:Y.target,tooltip:Y.tooltip}}Ne.from=ze;function ye(Y){let Te;if(Y.url)try{Te=typeof Y.url=="string"?d.URI.parse(Y.url,!0):d.URI.revive(Y.url)}catch{}return new g.$SM(S.to(Y.range),Te)}Ne.to=ye})(tt||(e.DocumentLink=tt={}));var _e;(function(Ne){function ze(Y){const Te=new g.$VM(Y.label);return Y.textEdit&&(Te.textEdit=ae.to(Y.textEdit)),Y.additionalTextEdits&&(Te.additionalTextEdits=Y.additionalTextEdits.map(Qe=>ae.to(Qe))),Te}Ne.to=ze;function ye(Y){return{label:Y.label,textEdit:Y.textEdit?ae.from(Y.textEdit):void 0,additionalTextEdits:Y.additionalTextEdits?Y.additionalTextEdits.map(Te=>ae.from(Te)):void 0}}Ne.from=ye})(_e||(e.ColorPresentation=_e={}));var nt;(function(Ne){function ze(Y){return new g.$TM(Y[0],Y[1],Y[2],Y[3])}Ne.to=ze;function ye(Y){return[Y.red,Y.green,Y.blue,Y.alpha]}Ne.from=ye})(nt||(e.Color=nt={}));var rt;(function(Ne){function ze(Y){return{range:S.from(Y.range)}}Ne.from=ze;function ye(Y){return new g.$CM(S.to(Y.range))}Ne.to=ye})(rt||(e.SelectionRange=rt={}));var it;(function(Ne){function ze(ye){switch(ye){case 2:return g.TextDocumentSaveReason.AfterDelay;case 1:return g.TextDocumentSaveReason.Manual;case 3:case 4:return g.TextDocumentSaveReason.FocusOut}}Ne.to=ze})(it||(e.TextDocumentSaveReason=it={}));var ct;(function(Ne){function ze(Y){switch(Y){case g.TextEditorLineNumbersStyle.Off:return 0;case g.TextEditorLineNumbersStyle.Relative:return 2;case g.TextEditorLineNumbersStyle.Interval:return 3;case g.TextEditorLineNumbersStyle.On:default:return 1}}Ne.from=ze;function ye(Y){switch(Y){case 0:return g.TextEditorLineNumbersStyle.Off;case 2:return g.TextEditorLineNumbersStyle.Relative;case 3:return g.TextEditorLineNumbersStyle.Interval;case 1:default:return g.TextEditorLineNumbersStyle.On}}Ne.to=ye})(ct||(e.TextEditorLineNumbersStyle=ct={}));var Oe;(function(Ne){function ze(Y){if(Y===g.EndOfLine.CRLF)return 1;if(Y===g.EndOfLine.LF)return 0}Ne.from=ze;function ye(Y){if(Y===1)return g.EndOfLine.CRLF;if(Y===0)return g.EndOfLine.LF}Ne.to=ye})(Oe||(e.EndOfLine=Oe={}));var Ee;(function(Ne){function ze(ye){if(typeof ye=="object")return ye.viewId;switch(ye){case g.ProgressLocation.SourceControl:return 3;case g.ProgressLocation.Window:return 10;case g.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ne.from=ze})(Ee||(e.ProgressLocation=Ee={}));var qe;(function(Ne){function ze(Y){const Te={start:Y.start+1,end:Y.end+1};return Y.kind&&(Te.kind=te.from(Y.kind)),Te}Ne.from=ze;function ye(Y){const Te={start:Y.start-1,end:Y.end-1};return Y.kind&&(Te.kind=te.to(Y.kind)),Te}Ne.to=ye})(qe||(e.FoldingRange=qe={}));var te;(function(Ne){function ze(Y){if(Y)switch(Y){case g.FoldingRangeKind.Comment:return n.$du.Comment;case g.FoldingRangeKind.Imports:return n.$du.Imports;case g.FoldingRangeKind.Region:return n.$du.Region}}Ne.from=ze;function ye(Y){if(Y)switch(Y.value){case n.$du.Comment.value:return g.FoldingRangeKind.Comment;case n.$du.Imports.value:return g.FoldingRangeKind.Imports;case n.$du.Region.value:return g.FoldingRangeKind.Region}}Ne.to=ye})(te||(e.FoldingRangeKind=te={}));var re;(function(Ne){function ze(ye){if(ye)return{pinned:typeof ye.preview=="boolean"?!ye.preview:void 0,inactive:ye.background,preserveFocus:ye.preserveFocus,selection:typeof ye.selection=="object"?S.from(ye.selection):void 0,override:typeof ye.override=="boolean"?s.$uF.id:void 0}}Ne.from=ze})(re||(e.TextEditorOpenOptions=re={}));var Ce;(function(Ne){function ze(Qe){return Qe instanceof g.$eN?Qe.toJSON():typeof Qe=="string"?Qe:ye(Qe)||Y(Qe)?new g.$eN(Qe.baseUri??Qe.base,Qe.pattern).toJSON():Qe}Ne.from=ze;function ye(Qe){const Ye=Qe;return Ye?d.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function Y(Qe){const Ye=Qe;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Te(Qe){return typeof Qe=="string"?Qe:new g.$eN(d.URI.revive(Qe.baseUri),Qe.pattern)}Ne.to=Te})(Ce||(e.GlobPattern=Ce={}));var Pe;(function(Ne){function ze(ye){if(ye){if(Array.isArray(ye))return ye.map(ze);if(typeof ye=="string")return ye;{const Y=ye;return{language:Y.language,scheme:Y.scheme,pattern:Ce.from(Y.pattern),exclusive:Y.exclusive,notebookType:Y.notebookType}}}else return}Ne.from=ze})(Pe||(e.LanguageSelector=Pe={}));var Xe;(function(Ne){function ze(Y){return!!Y&&typeof Y=="object"&&"documents"in Y&&Array.isArray(Y.documents)&&Y.documents.every(Te=>Array.isArray(Te)&&Te.every(Qe=>Qe&&typeof Qe=="object"&&"uri"in Qe&&d.URI.isUri(Qe.uri)&&"version"in Qe&&typeof Qe.version=="number"&&"ranges"in Qe&&Array.isArray(Qe.ranges)&&Qe.ranges.every(Ye=>Ye instanceof g.$hM)))}Ne.is=ze;function ye(Y){return{documents:Y.documents.map(Te=>Te.map(Qe=>({uri:d.URI.from(Qe.uri),version:Qe.version,ranges:Qe.ranges.map(Ye=>S.from(Ye))})))}}Ne.from=ye})(Xe||(e.MappedEditsContext=Xe={}));var st;(function(Ne){function ze(Y){return{start:Y.start,end:Y.end}}Ne.from=ze;function ye(Y){return new g.$HN(Y.start,Y.end)}Ne.to=ye})(st||(e.NotebookRange=st={}));var lt;(function(Ne){function ze(Y){return{timing:typeof Y.runStartTime=="number"&&typeof Y.runEndTime=="number"?{startTime:Y.runStartTime,endTime:Y.runEndTime}:void 0,executionOrder:Y.executionOrder,success:Y.lastRunSuccess}}Ne.to=ze;function ye(Y){return{lastRunSuccess:Y.success,runStartTime:Y.timing?.startTime,runEndTime:Y.timing?.endTime,executionOrder:Y.executionOrder}}Ne.from=ye})(lt||(e.NotebookCellExecutionSummary=lt={}));var gt;(function(Ne){function ze(ye){if(ye===c.NotebookCellExecutionState.Unconfirmed)return g.NotebookCellExecutionState.Pending;if(ye===c.NotebookCellExecutionState.Pending)return;if(ye===c.NotebookCellExecutionState.Executing)return g.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ye}`)}Ne.to=ze})(gt||(e.NotebookCellExecutionState=gt={}));var It;(function(Ne){function ze(Y){switch(Y){case g.NotebookCellKind.Markup:return c.CellKind.Markup;case g.NotebookCellKind.Code:default:return c.CellKind.Code}}Ne.from=ze;function ye(Y){switch(Y){case c.CellKind.Markup:return g.NotebookCellKind.Markup;case c.CellKind.Code:default:return g.NotebookCellKind.Code}}Ne.to=ye})(It||(e.NotebookCellKind=It={}));var Pt;(function(Ne){function ze(Y){const Te={metadata:Y.metadata??Object.create(null),cells:[]};for(const Qe of Y.cells)g.$IN.validate(Qe),Te.cells.push(zt.from(Qe));return Te}Ne.from=ze;function ye(Y){const Te=new g.$JN(Y.cells.map(zt.to));return(0,l.$jg)(Y.metadata)||(Te.metadata=Y.metadata),Te}Ne.to=ye})(Pt||(e.NotebookData=Pt={}));var zt;(function(Ne){function ze(Y){return{cellKind:It.from(Y.kind),language:Y.languageId,mime:Y.mime,source:Y.value,metadata:Y.metadata,internalMetadata:lt.from(Y.executionSummary??{}),outputs:Y.outputs?Y.outputs.map(Dt.from):[]}}Ne.from=ze;function ye(Y){return new g.$IN(It.to(Y.cellKind),Y.source,Y.language,Y.mime,Y.outputs?Y.outputs.map(Dt.to):void 0,Y.metadata,Y.internalMetadata?lt.to(Y.internalMetadata):void 0)}Ne.to=ye})(zt||(e.NotebookCellData=zt={}));var Bt;(function(Ne){function ze(Y){return{mime:Y.mime,valueBytes:N.$Fe.wrap(Y.data)}}Ne.from=ze;function ye(Y){return new g.$KN(Y.valueBytes.buffer,Y.mime)}Ne.to=ye})(Bt||(e.NotebookCellOutputItem=Bt={}));var Dt;(function(Ne){function ze(Y){return{outputId:Y.id,items:Y.items.map(Bt.from),metadata:Y.metadata}}Ne.from=ze;function ye(Y){const Te=Y.items.map(Bt.to);return new g.$LN(Te,Y.outputId,Y.metadata)}Ne.to=ye})(Dt||(e.NotebookCellOutput=Dt={}));var _t;(function(Ne){function ze(Te){return Y(Te)?{include:Ce.from(Te.include)??void 0,exclude:Ce.from(Te.exclude)??void 0}:Ce.from(Te)??void 0}Ne.from=ze;function ye(Te){return Y(Te)?{include:Ce.to(Te.include),exclude:Ce.to(Te.exclude)}:Ce.to(Te)}Ne.to=ye;function Y(Te){const Qe=Te;return Qe?!(0,l.$fg)(Qe.include)&&!(0,l.$fg)(Qe.exclude):!1}})(_t||(e.NotebookExclusiveDocumentPattern=_t={}));var xe;(function(Ne){function ze(ye,Y,Te){const Qe=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{alignment:ye.alignment===g.NotebookCellStatusBarAlignment.Left?1:2,command:Y.toInternal(Qe,Te),text:ye.text,tooltip:ye.tooltip,accessibilityInformation:ye.accessibilityInformation,priority:ye.priority}}Ne.from=ze})(xe||(e.NotebookStatusBarItem=xe={}));var tn;(function(Ne){function ze(ye,Y,Te){const Qe=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{command:Y.toInternal(Qe,Te),label:ye.label,description:ye.description,detail:ye.detail,documentation:ye.documentation}}Ne.from=ze})(tn||(e.NotebookKernelSourceAction=tn={}));var nn;(function(Ne){function ze(ye){return{transientOutputs:ye?.transientOutputs??!1,transientCellMetadata:ye?.transientCellMetadata??{},transientDocumentMetadata:ye?.transientDocumentMetadata??{},cellContentMetadata:ye?.cellContentMetadata??{}}}Ne.from=ze})(nn||(e.NotebookDocumentContentOptions=nn={}));var ft;(function(Ne){function ze(Y){return{uri:Y.uri,provides:Y.provides}}Ne.from=ze;function ye(Y){return new g.$NN(d.URI.revive(Y.uri),Y.provides)}Ne.to=ye})(ft||(e.NotebookRendererScript=ft={}));var bt;(function(Ne){function ze(Y){return{message:X.fromStrict(Y.message)||"",type:0,expected:Y.expectedOutput,actual:Y.actualOutput,contextValue:Y.contextValue,location:Y.location&&{range:S.from(Y.location.range),uri:Y.location.uri}}}Ne.from=ze;function ye(Y){const Te=new g.$TN(typeof Y.message=="string"?Y.message:X.to(Y.message));return Te.actualOutput=Y.actual,Te.expectedOutput=Y.expected,Te.contextValue=Y.contextValue,Te.location=Y.location?le.to(Y.location):void 0,Te}Ne.to=ye})(bt||(e.TestMessage=bt={}));var Ut;(function(Ne){Ne.namespace=a.$7K,Ne.denamespace=a.$8K})(Ut||(e.TestTag=Ut={}));var Kt;(function(Ne){function ze(Y){const Te=(0,u.$AO)(Y).controllerId;return{extId:r.$2K.fromExtHostTestItem(Y,Te).toString(),label:Y.label,uri:d.URI.revive(Y.uri),busy:Y.busy,tags:Y.tags.map(Qe=>Ut.namespace(Te,Qe.id)),range:o.$ut.lift(S.from(Y.range)),description:Y.description||null,sortText:Y.sortText||null,error:Y.error&&X.fromStrict(Y.error)||null}}Ne.from=ze;function ye(Y){return{parent:void 0,error:void 0,id:r.$2K.fromString(Y.extId).localId,label:Y.label,uri:d.URI.revive(Y.uri),tags:(Y.tags||[]).map(Te=>{const{tagId:Qe}=Ut.denamespace(Te);return new g.$UN(Qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:S.to(Y.range||void 0),canResolveChildren:!1,busy:Y.busy,description:Y.description||void 0,sortText:Y.sortText||void 0}}Ne.toPlain=ye})(Kt||(e.TestItem=Kt={})),function(Ne){function ze(Y){return{id:Y.id}}Ne.from=ze;function ye(Y){return new g.$UN(Y.id)}Ne.to=ye}(Ut||(e.TestTag=Ut={}));var Ft;(function(Ne){const ze=(Y,Te)=>{const Qe=Y.value;if(!Qe)return;const Ye={...Kt.toPlain(Qe.item),parent:Te,taskStates:Qe.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(ot=>ot.type===0).map(bt.to)})),children:[]};if(Y.children)for(const Ke of Y.children.values()){const ot=ze(Ke,Ye);ot&&Ye.children.push(ot)}return Ye};function ye(Y){const Te=new p.$tO;for(const Ke of Y.items)Te.insert(r.$2K.fromString(Ke.item.extId).path,Ke);const Qe=[Te.nodes],Ye=[];for(;Qe.length;)for(const Ke of Qe.pop())Ke.value?Ye.push(Ke):Ke.children&&Qe.push(Ke.children.values());return{completedAt:Y.completedAt,results:Ye.map(Ke=>ze(Ke)).filter(l.$eg)}}Ne.to=ye})(Ft||(e.TestResults=Ft={}));var $t;(function(Ne){function ze(Qe){return{covered:Qe.covered,total:Qe.total}}function ye(Qe){return"line"in Qe?D.from(Qe):S.from(Qe)}function Y(Qe){if(typeof Qe.executed=="number"&&Qe.executed<0)throw new Error(`Invalid coverage count ${Qe.executed}`);return"branches"in Qe?{count:Qe.executed,location:ye(Qe.location),type:1,branches:Qe.branches.length?Qe.branches.map(Ye=>({count:Ye.executed,location:Ye.location&&ye(Ye.location),label:Ye.label})):void 0}:{type:0,name:Qe.name,count:Qe.executed,location:ye(Qe.location)}}Ne.fromDetails=Y;function Te(Qe,Ye){return g.$WN(Ye.statementCoverage),g.$WN(Ye.branchCoverage),g.$WN(Ye.declarationCoverage),{id:Qe,uri:Ye.uri,statement:ze(Ye.statementCoverage),branch:Ye.branchCoverage&&ze(Ye.branchCoverage),declaration:Ye.declarationCoverage&&ze(Ye.declarationCoverage)}}Ne.fromFile=Te})($t||(e.TestCoverage=$t={}));var Rt;(function(Ne){function ze(ye){switch(ye){case 1:return g.CodeActionTriggerKind.Invoke;case 2:return g.CodeActionTriggerKind.Automatic}}Ne.to=ze})(Rt||(e.CodeActionTriggerKind=Rt={}));var cn;(function(Ne){function ze(Y){const Te=new g.$2N(ee.to(Y.kind),Y.name,Y.detail||"",d.URI.revive(Y.uri),S.to(Y.range),S.to(Y.selectionRange));return Te._sessionId=Y._sessionId,Te._itemId=Y._itemId,Te}Ne.to=ze;function ye(Y,Te,Qe){if(Te=Te??Y._sessionId,Qe=Qe??Y._itemId,Te===void 0||Qe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Qe,kind:ee.from(Y.kind),name:Y.name,detail:Y.detail??"",uri:Y.uri,range:S.from(Y.range),selectionRange:S.from(Y.selectionRange),tags:Y.tags?.map(B.from)}}Ne.from=ye})(cn||(e.TypeHierarchyItem=cn={}));var Vt;(function(Ne){function ze(ye){if(ye)return{value:ye.value,tooltip:ye.tooltip}}Ne.from=ze})(Vt||(e.ViewBadge=Vt={}));var Ze;(function(Ne){function ze(Qe,Ye,Ke){const ot=Ye.fileData;return ot?new g.$9M(new g.$0M(ot.name,d.URI.revive(ot.uri),ot.id,(0,R.$db)(()=>Ke(ot.id)))):Qe===A.$Qs.uriList&&Ye.uriListData?new g.$8M(Te(Ye.uriListData)):new g.$8M(Ye.asString)}Ne.to=ze;async function ye(Qe,Ye){const Ke=await Ye.asString();if(Qe===A.$Qs.uriList)return{asString:Ke,fileData:void 0,uriListData:Y(Ke)};const ot=Ye.asFile();return{asString:Ke,fileData:ot?{name:ot.name,uri:ot.uri,id:ot._itemId??ot.id}:void 0}}Ne.from=ye;function Y(Qe){return O.$Ut.split(Qe).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return d.URI.parse(Ye)}catch{}return Ye})}function Te(Qe){return O.$Ut.create(Qe.map(Ye=>typeof Ye=="string"?Ye:d.URI.revive(Ye)))}})(Ze||(e.DataTransferItem=Ze={}));var rn;(function(Ne){function ze(Y,Te){const Qe=Y.items.map(([Ye,Ke])=>[Ye,Ze.to(Ye,Ke,Te)]);return new g.$$M(Qe)}Ne.toDataTransfer=ze;async function ye(Y){const Te={items:[]},Qe=[];for(const[Ye,Ke]of Y)Qe.push((async()=>{Te.items.push([Ye,await Ze.from(Ye,Ke)])})());return await Promise.all(Qe),Te}Ne.from=ye})(rn||(e.DataTransfer=rn={}));var un;(function(Ne){function ze(Y,Te){return{kind:"reply",agentId:Y.participant??Te?.agentId??"",subCommand:Y.command??Te?.command,message:Y.prompt,title:Y.label}}Ne.from=ze;function ye(Y){return{prompt:Y.message,label:Y.title,participant:Y.agentId,command:Y.subCommand}}Ne.to=ye})(un||(e.ChatFollowup=un={}));var Jt;(function(Ne){function ze(Y){switch(Y.role){case 0:return new g.$oO(Y.content);case 1:return new g.$pO(Y.content);case 2:return new g.$qO(Y.content)}}Ne.to=ze;function ye(Y){if(Y instanceof g.$oO)return{role:0,content:Y.content};if(Y instanceof g.$pO)return{role:1,content:Y.content};if(Y instanceof g.$qO)return{role:2,content:Y.content};throw new Error("Invalid LanguageModelMessage")}Ne.from=ye})(Jt||(e.LanguageModelMessage=Jt={}));var mt;(function(Ne){function ze(Y){return{kind:"markdownContent",content:X.from(Y.value)}}Ne.from=ze;function ye(Y){return new g.$cO(X.to(Y.content))}Ne.to=ye})(mt||(e.ChatResponseMarkdownPart=mt={}));var Nt;(function(Ne){function ze(Y){return{kind:"markdownVuln",content:X.from(Y.value),vulnerabilities:Y.vulnerabilities}}Ne.from=ze;function ye(Y){return new g.$dO(X.to(Y.content),Y.vulnerabilities)}Ne.to=ye})(Nt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Nt={}));var Lt;(function(Ne){function ze(Y){return{kind:"agentDetection",agentId:Y.participant,command:Y.command}}Ne.from=ze;function ye(Y){return new g.$eO(Y.agentId,Y.command)}Ne.to=ye})(Lt||(e.ChatResponseDetectedParticipantPart=Lt={}));var Tt;(function(Ne){function ze(Y){const{value:Te,baseUri:Qe}=Y;function Ye(Ke,ot){return Ke.map(St=>{const Ht=d.URI.joinPath(ot,St.name);return{label:St.name,uri:Ht,children:St.children&&Ye(St.children,Ht)}})}return{kind:"treeData",treeData:{label:(0,y.$7g)(Qe),uri:Qe,children:Ye(Te,Qe)}}}Ne.from=ze;function ye(Y){const Te=(0,k.$6h)(Y.treeData);function Qe(ot){return ot.map(St=>({name:St.label,children:St.children&&Qe(St.children)}))}const Ye=Te.uri,Ke=Te.children?Qe(Te.children):[];return new g.$fO(Ke,Ye)}Ne.to=ye})(Tt||(e.ChatResponseFilesPart=Tt={}));var Qt;(function(Ne){function ze(Y){return{kind:"inlineReference",name:Y.title,inlineReference:d.URI.isUri(Y.value)?Y.value:m.from(Y.value)}}Ne.from=ze;function ye(Y){const Te=(0,k.$6h)(Y);return new g.$gO(d.URI.isUri(Te.inlineReference)?Te.inlineReference:m.to(Te.inlineReference),Y.name)}Ne.to=ye})(Qt||(e.ChatResponseAnchorPart=Qt={}));var Yt;(function(Ne){function ze(Y){return{kind:"progressMessage",content:X.from(Y.value)}}Ne.from=ze;function ye(Y){return new g.$hO(Y.content.value)}Ne.to=ye})(Yt||(e.ChatResponseProgressPart=Yt={}));var Zt;(function(Ne){function ze(Y){return{kind:"warning",content:X.from(Y.value)}}Ne.from=ze;function ye(Y){return new g.$iO(Y.content.value)}Ne.to=ye})(Zt||(e.ChatResponseWarningPart=Zt={}));var Wt;(function(Ne){function ze(Y,Te,Qe){return{kind:"command",command:Te.toInternal(Y.value,Qe)??{command:Y.value.command,title:Y.value.title}}}Ne.from=ze;function ye(Y,Te){return new g.$jO(Te.fromInternal(Y.command)??{command:Y.command.id,title:Y.command.title})}Ne.to=ye})(Wt||(e.ChatResponseCommandButtonPart=Wt={}));var Mt;(function(Ne){function ze(Y){return{kind:"textEdit",uri:Y.uri,edits:Y.edits.map(Te=>ae.from(Te))}}Ne.from=ze;function ye(Y){return new g.$lO(d.URI.revive(Y.uri),Y.edits.map(Te=>ae.to(Te)))}Ne.to=ye})(Mt||(e.ChatResponseTextEditPart=Mt={}));var Xt;(function(Ne){function ze(Y){const Te=v.ThemeIcon.isThemeIcon(Y.iconPath)?Y.iconPath:Y.iconPath&&"light"in Y.iconPath&&"dark"in Y.iconPath&&d.URI.isUri(Y.iconPath.light)&&d.URI.isUri(Y.iconPath.dark)?{light:d.URI.revive(Y.iconPath.light),dark:d.URI.revive(Y.iconPath.dark)}:void 0;return"variableName"in Y.value?{kind:"reference",reference:{variableName:Y.value.variableName,value:d.URI.isUri(Y.value.value)||!Y.value.value?Y.value.value:m.from(Y.value.value)},iconPath:Te}:{kind:"reference",reference:d.URI.isUri(Y.value)?Y.value:m.from(Y.value),iconPath:Te}}Ne.from=ze;function ye(Y){const Te=(0,k.$6h)(Y),Qe=Ye=>d.URI.isUri(Ye)?Ye:m.to(Ye);return new g.$kO("variableName"in Te.reference?{variableName:Te.reference.variableName,value:Te.reference.value&&Qe(Te.reference.value)}:Qe(Te.reference))}Ne.to=ye})(Xt||(e.ChatResponseReferencePart=Xt={}));var Ct;(function(Ne){function ze(Te,Qe,Ye){return Te instanceof g.$cO?mt.from(Te):Te instanceof g.$gO?Qt.from(Te):Te instanceof g.$kO?Xt.from(Te):Te instanceof g.$hO?Yt.from(Te):Te instanceof g.$fO?Tt.from(Te):Te instanceof g.$jO?Wt.from(Te,Qe,Ye):Te instanceof g.$lO?Mt.from(Te):Te instanceof g.$dO?Nt.from(Te):Te instanceof g.$eO?Lt.from(Te):Te instanceof g.$iO?Zt.from(Te):{kind:"markdownContent",content:X.from("")}}Ne.from=ze;function ye(Te,Qe){switch(Te.kind){case"reference":return Xt.to(Te);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return Y(Te,Qe)}}Ne.to=ye;function Y(Te,Qe){switch(Te.kind){case"markdownContent":return mt.to(Te);case"inlineReference":return Qt.to(Te);case"progressMessage":return;case"treeData":return Tt.to(Te);case"command":return Wt.to(Te,Qe)}}Ne.toContent=Y})(Ct||(e.ChatResponsePart=Ct={}));var Et;(function(Ne){function ze(ye){return{prompt:ye.message,command:ye.command,attempt:ye.attempt??0,enableCommandDetection:ye.enableCommandDetection??!0,variables:ye.variables.variables.map(xt.to),location:wt.to(ye.location)}}Ne.to=ze})(Et||(e.ChatAgentRequest=Et={}));var wt;(function(Ne){function ze(ye){switch(ye){case t.ChatAgentLocation.Notebook:return g.ChatLocation.Notebook;case t.ChatAgentLocation.Terminal:return g.ChatLocation.Terminal;case t.ChatAgentLocation.Panel:return g.ChatLocation.Panel;case t.ChatAgentLocation.Editor:return g.ChatLocation.Editor}}Ne.to=ze})(wt||(e.ChatLocation=wt={}));var xt;(function(Ne){function ze(ye){const Y=ye.value;if(!Y)throw new Error("Invalid value reference");return{name:ye.name,range:ye.range&&[ye.range.start,ye.range.endExclusive],value:(0,d.$vc)(Y)?d.URI.revive(Y):Y}}Ne.to=ze})(xt||(e.ChatAgentValueReference=xt={}));var kt;(function(Ne){function ze(ye,Y,Te){return{label:ye.label,value:ye.values[0].value,insertText:ye.insertText,detail:ye.detail,documentation:ye.documentation,command:Y.toInternal(ye.command,Te)}}Ne.from=ze})(kt||(e.ChatAgentCompletionItem=kt={}));var ln;(function(Ne){function ze(ye){return{errorDetails:ye.errorDetails,metadata:ye.metadata}}Ne.to=ze})(ln||(e.ChatAgentResult=ln={}));var en;(function(Ne){function ze(ye,Y,Te){if(Y.action.kind==="vote")return;const Qe=ln.to(ye);if(Y.action.kind==="command"){const Ye=Y.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Te.fromInternal(Ye)??{command:Ye.id,title:Ye.title}}},result:Qe}}else return Y.action.kind==="followUp"?{action:{kind:"followUp",followup:un.to(Y.action.followup)},result:Qe}:Y.action.kind==="inlineChat"?{action:{kind:"editor",accepted:Y.action.action==="accepted"},result:Qe}:{action:Y.action,result:Qe}}Ne.to=ze})(en||(e.ChatAgentUserActionEvent=en={}));var kn;(function(Ne){function ze(ye,Y,Te){return"terminalCommand"in ye?{terminalCommand:ye.terminalCommand,shouldExecute:ye.shouldExecute}:"uri"in ye?{uri:ye.uri}:Y.toInternal(ye,Te)}Ne.from=ze})(kn||(e.TerminalQuickFix=kn={}));var hn;(function(Ne){function ze(ye){return{kind:gn.to(ye.kind)}}Ne.to=ze})(hn||(e.PartialAcceptInfo=hn={}));var gn;(function(Ne){function ze(ye){switch(ye){case 0:return g.PartialAcceptTriggerKind.Word;case 1:return g.PartialAcceptTriggerKind.Line;case 2:return g.PartialAcceptTriggerKind.Suggest;default:return g.PartialAcceptTriggerKind.Unknown}}Ne.to=ze})(gn||(e.PartialAcceptTriggerKind=gn={}));var jt;(function(Ne){function ze(ye,Y){return{id:Y,label:ye.label,description:ye.description,canEdit:ye.canEdit,collapsibleState:ye.collapsibleState||0,contextValue:ye.contextValue}}Ne.from=ze})(jt||(e.DebugTreeItem=jt={}))}),define(Se[333],De([1,0,6,20,17,48]),function(he,e,h,N,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hlc=void 0;let M=class{constructor($,k){this.a=$.getProxy(h.$dM.MainThreadBulkEdits),this.b={getTextDocumentVersion:A=>k.getDocument(A)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,k,A){const I=new R.$Bw(O.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(I,void 0,A?.isRefactoring??!1)}};e.$Hlc=M,e.$Hlc=M=He([We(0,N.$EO)],M)}),define(Se[334],De([1,0,19,7,47,4,39,3,40,18,2,25,6,17,8,297,26]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=void 0;class o{constructor(s,t,c,r,a){this.j=s,this.k=t,this.l=c,this.m=r,this.n=a,this.b=$.$_d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(r){if(s.c){const a=new Error("Response stream has been closed");throw Error.captureStackTrace(a,r),a}};const s=this;this.b.reset();const c=r=>{typeof this.d>"u"&&"content"in r&&(this.d=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,r)};this.g={markdown(r){t(this.markdown);const a=new v.$cO(r),f=y.ChatResponseMarkdownPart.from(a);return c(f),this},markdownWithVulnerabilities(r,a){t(this.markdown),a&&(0,d.$PG)(s.j,"chatParticipantAdditions");const f=new v.$dO(r,a),g=y.ChatResponseMarkdownWithVulnerabilitiesPart.from(f);return c(g),this},filetree(r,a){t(this.filetree);const f=new v.$fO(r,a),g=y.ChatResponseFilesPart.from(f);return c(g),this},anchor(r,a){t(this.anchor);const f=new v.$gO(r,a),g=y.ChatResponseAnchorPart.from(f);return c(g),this},button(r){t(this.anchor);const a=new v.$jO(r),f=y.ChatResponseCommandButtonPart.from(a,s.m,s.n);return c(f),this},progress(r){t(this.progress);const a=new v.$hO(r),f=y.ChatResponseProgressPart.from(a);return c(f),this},warning(r){t(this.progress),(0,d.$PG)(s.j,"chatParticipantAdditions");const a=new v.$iO(r),f=y.ChatResponseWarningPart.from(a);return c(f),this},reference(r,a){if(t(this.reference),"variableName"in r&&!r.value){const f=s.k.variables.variables.find(g=>g.name===r.variableName);if(f){let g;if(f.references?.length)g=f.references.map(w=>({kind:"reference",reference:{variableName:r.variableName,value:w.reference}}));else{const w=new v.$kO(r,a);g=[y.ChatResponseReferencePart.from(w)]}return g.forEach(w=>c(w)),this}}else{const f=new v.$kO(r,a),g=y.ChatResponseReferencePart.from(f);c(g)}return this},textEdit(r,a){t(this.textEdit),(0,d.$PG)(s.j,"chatParticipantAdditions");const f=new v.$lO(r,a),g=y.ChatResponseTextEditPart.from(f);return c(g),this},detectedParticipant(r,a){t(this.detectedParticipant),(0,d.$PG)(s.j,"chatParticipantAdditions");const f=new v.$eO(r,a),g=y.ChatResponseDetectedParticipantPart.from(f);return c(g),this},push(r){if(t(this.push),(r instanceof v.$lO||r instanceof v.$dO||r instanceof v.$eO||r instanceof v.$iO)&&(0,d.$PG)(s.j,"chatParticipantAdditions"),r instanceof v.$kO)this.reference(r.value,r.iconPath);else{const a=y.ChatResponsePart.from(r,s.m,s.n);c(a)}return this}}}return this.g}}class n extends b.$Uc{static{this.b=0}constructor(s,t,c){super(),this.n=t,this.s=c,this.c=new Map,this.j=this.B(new b.$4c),this.m=this.B(new b.$4c),this.g=s.getProxy(p.$dM.MainThreadChatAgents2)}transferActiveChat(s){this.g.$transferActiveChatSession(s)}createChatAgent(s,t,c){const r=n.b++,a=new i(s,t,this.g,r,c);return this.c.set(r,a),this.g.$registerAgent(r,s.identifier,t,{},void 0),a.apiAgent}createDynamicChatAgent(s,t,c,r,a,f){const g=n.b++,w=new i(s,t,this.g,g,f);return this.c.set(g,w),this.g.$registerAgent(g,s.identifier,t,{isSticky:!0},{name:c,description:a,publisherDisplayName:r}),w.apiAgent}async $invokeAgent(s,t,c,r){const a=this.c.get(s);if(!a)throw new Error(`[CHAT](${s}) CANNOT invoke agent because the agent is not registered`);let f=this.j.get(t.sessionId);f||(f=new b.$Tc,this.j.set(t.sessionId,f));const g=new o(a.extension,t,this.g,this.s.converter,f);try{const w=await this.t(t.agentId,c),S=a.invoke(y.ChatAgentRequest.to(t),{history:w},g.apiObject,r);return await(0,N.$kh)(Promise.resolve(S).then(m=>{if(m?.metadata)try{JSON.stringify(m.metadata)}catch(E){const D=`result.metadata MUST be JSON.stringify-able. Got error: ${E.message}`;return this.n.error(`[${a.extension.identifier.value}] [@${a.id}] ${D}`,a.extension),{errorDetails:{message:D},timings:g.timings}}return{errorDetails:m?.errorDetails,timings:g.timings,metadata:m?.metadata}}),r)}catch(w){return this.n.error(w,a.extension),{errorDetails:{message:(0,O.$hj)(w),responseIsIncomplete:!0}}}finally{g.close()}}async t(s,t){const c=[];for(const r of t.history){const a=y.ChatAgentResult.to(r.result),f=s===r.request.agentId?a:{...a,metadata:void 0};c.push(new v.$mO(r.request.message,r.request.command,r.request.variables.variables.map(y.ChatAgentValueReference.to),r.request.agentId));const g=(0,h.$Hb)(r.response.map(w=>y.ChatResponsePart.toContent(w,this.s.converter)));c.push(new v.$nO(g,f,r.request.agentId,r.request.command))}return c}$releaseSession(s){this.j.deleteAndDispose(s)}async $provideFollowups(s,t,c,r,a){const f=this.c.get(t);if(!f)return Promise.resolve([]);const g=await this.t(f.id,r),w=y.ChatAgentResult.to(c);return(await f.provideFollowups(w,{history:g},a)).filter(S=>{const m=!S.participant||M.Iterable.some(this.c.values(),E=>E.id===S.participant&&I.$Rm.equals(E.extension.identifier,f.extension.identifier));return m||this.n.warn(`[@${f.id}] ChatFollowup refers to an unknown participant: ${S.participant}`),m}).map(S=>y.ChatFollowup.from(S,s))}$acceptFeedback(s,t,c,r){const a=this.c.get(s);if(!a)return;const f=y.ChatAgentResult.to(t);let g;switch(c){case l.InteractiveSessionVoteDirection.Down:g=v.ChatResultFeedbackKind.Unhelpful;break;case l.InteractiveSessionVoteDirection.Up:g=v.ChatResultFeedbackKind.Helpful;break}a.acceptFeedback(Object.freeze(r?{result:f,kind:g,reportIssue:r}:{result:f,kind:g}))}$acceptAction(s,t,c){const r=this.c.get(s);if(!r||c.action.kind==="vote")return;const a=y.ChatAgentUserActionEvent.to(t,c,this.s.converter);a&&r.acceptAction(Object.freeze(a))}async $invokeCompletionProvider(s,t,c){const r=this.c.get(s);if(!r)return[];let a=this.m.get(s);return a?a.clear():(a=new b.$Tc,this.m.set(s,a)),(await r.invokeCompletionProvider(t,c)).map(g=>y.ChatAgentCompletionItem.from(g,this.s.converter,a))}async $provideWelcomeMessage(s,t,c){const r=this.c.get(s);if(r)return await r.provideWelcomeMessage(y.ChatLocation.to(t),c)}async $provideSampleQuestions(s,t,c){const r=this.c.get(s);if(r)return(await r.provideSampleQuestions(y.ChatLocation.to(t),c)).map(a=>y.ChatFollowup.from(a,void 0))}}e.$Ilc=n;class i{constructor(s,t,c,r,a){this.extension=s,this.id=t,this.u=c,this.w=r,this.x=a,this.n=new R.$de,this.o=new R.$de}acceptFeedback(s){this.n.fire(s)}acceptAction(s){this.o.fire(s)}async invokeCompletionProvider(s,t){return this.q?await this.q.provider.provideCompletionItems(s,t)??[]:[]}async provideFollowups(s,t,c){if(!this.b)return[];const r=await this.b.provideFollowups(s,t,c);return r?r.filter(a=>!(a&&"commandId"in a)).filter(a=>!(a&&"message"in a)):[]}async provideWelcomeMessage(s,t){if(!this.s)return[];const c=await this.s.provideWelcomeMessage(s,t);return c?c.map(r=>typeof r=="string"?r:y.MarkdownString.from(r)):[]}async provideSampleQuestions(s,t){if(!this.s||!this.s.provideSampleQuestions)return[];const c=await this.s.provideSampleQuestions(s,t);return c||[]}get apiAgent(){let s=!1,t=!1;const c=()=>{s||t||(t=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof A.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof v.$cN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:y.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:y.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:y.MarkdownString.from(this.l),supportIssueReporting:this.p,requester:this.t}),t=!1}))},r=this;return{get id(){return r.id},get fullName(){return(0,d.$PG)(r.extension,"defaultChatParticipant"),r.c??r.extension.displayName??r.extension.name},set fullName(a){(0,d.$PG)(r.extension,"defaultChatParticipant"),r.c=a,c()},get iconPath(){return r.d},set iconPath(a){r.d=a,c()},get requestHandler(){return r.x},set requestHandler(a){(0,k.$gg)(typeof a=="function","Invalid request handler"),r.x=a},get followupProvider(){return r.b},set followupProvider(a){r.b=a,c()},get isDefault(){return(0,d.$PG)(r.extension,"defaultChatParticipant"),r.g},set isDefault(a){(0,d.$PG)(r.extension,"defaultChatParticipant"),r.g=a,c()},get helpTextPrefix(){return(0,d.$PG)(r.extension,"defaultChatParticipant"),r.j},set helpTextPrefix(a){(0,d.$PG)(r.extension,"defaultChatParticipant"),r.j=a,c()},get helpTextVariablesPrefix(){return(0,d.$PG)(r.extension,"defaultChatParticipant"),r.k},set helpTextVariablesPrefix(a){(0,d.$PG)(r.extension,"defaultChatParticipant"),r.k=a,c()},get helpTextPostfix(){return(0,d.$PG)(r.extension,"defaultChatParticipant"),r.l},set helpTextPostfix(a){(0,d.$PG)(r.extension,"defaultChatParticipant"),r.l=a,c()},get isSecondary(){return(0,d.$PG)(r.extension,"defaultChatParticipant"),r.m},set isSecondary(a){(0,d.$PG)(r.extension,"defaultChatParticipant"),r.m=a,c()},get supportIssueReporting(){return(0,d.$PG)(r.extension,"chatParticipantAdditions"),r.p},set supportIssueReporting(a){(0,d.$PG)(r.extension,"chatParticipantAdditions"),r.p=a,c()},get onDidReceiveFeedback(){return r.n.event},set participantVariableProvider(a){if((0,d.$PG)(r.extension,"chatParticipantAdditions"),r.q=a,a){if(!a.triggerCharacters.length)throw new Error("triggerCharacters are required");r.u.$registerAgentCompletionsProvider(r.w,a.triggerCharacters)}else r.u.$unregisterAgentCompletionsProvider(r.w)},get participantVariableProvider(){return(0,d.$PG)(r.extension,"chatParticipantAdditions"),r.q},set welcomeMessageProvider(a){(0,d.$PG)(r.extension,"defaultChatParticipant"),r.s=a,c()},get welcomeMessageProvider(){return(0,d.$PG)(r.extension,"defaultChatParticipant"),r.s},onDidPerformAction:(0,d.$OG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(a){r.t=a,c()},get requester(){return r.t},dispose(){s=!0,r.b=void 0,r.n.dispose(),r.u.$unregisterAgent(r.w)}}}invoke(s,t,c,r){return this.x(s,t,c,r)}}}),define(Se[335],De([1,0,13,3,6,17,8,26]),function(he,e,h,N,O,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jlc=void 0;class ${static{this.a=0}constructor(I){this.b=new Map,this.c=I.getProxy(O.$dM.MainThreadChatVariables)}async $resolveVariable(I,p,y,v){const l=this.b.get(I);if(l)try{if(l.resolver.resolve2){(0,b.$PG)(l.extension,"chatParticipantAdditions");const d=new k(p,this.c),o=await l.resolver.resolve2(l.data.name,{prompt:y},d.apiObject,v);if(o&&o[0])return o[0].value}else{const d=await l.resolver.resolve(l.data.name,{prompt:y},v);if(d&&d[0])return d[0].value}}catch(d){(0,h.$2)(d)}}registerVariableResolver(I,p,y,v){const l=$.a++;return this.b.set(l,{extension:I,data:{name:p,description:y},resolver:v}),this.c.$registerVariable(l,{name:p,description:y}),(0,N.$Sc)(()=>{this.b.delete(l),this.c.$unregisterVariable(l)})}}e.$Jlc=$;class k{constructor(I,p){this.c=I,this.d=p,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let p=function(v){if(I.a){const l=new Error("Response stream has been closed");throw Error.captureStackTrace(l,v),l}};const I=this,y=v=>{this.d.$handleProgressChunk(this.c,v)};this.b={progress(v){p(this.progress);const l=new M.$hO(v),d=R.ChatResponseProgressPart.from(l);return y(d),this},reference(v){p(this.reference);const l=new M.$kO(v),d=R.ChatResponseReferencePart.from(l);return y(d),this},push(v){return p(this.push),v instanceof M.$kO?y(R.ChatResponseReferencePart.from(v)):v instanceof M.$hO&&y(R.ChatResponseProgressPart.from(v)),this}}}return this.b}}}),define(Se[336],De([1,0,7,56,4,3,2,84,25,17,8,6,26]),function(he,e,h,N,O,R,M,b,$,k,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlc=y;function y(v,l,d){const o=v.getProxy(I.$dM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$Tm,l.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===6){const S=this.b.get(w.handle);return S?S.value:w}else if(w&&w.$mid===7){const S=w,m=this.b.get(S.commentControlHandle);if(!m)return S;const E=m.getCommentThread(S.commentThreadHandle);return E?E.value:S}else if(w&&(w.$mid===9||w.$mid===8)){const S=this.b.get(w.thread.commentControlHandle);if(!S)return w;const m=S.getCommentThread(w.thread.commentThreadHandle);return m?w.$mid===8?m.value:{thread:m.value,text:w.text}:w}else if(w&&w.$mid===10){const S=this.b.get(w.thread.commentControlHandle);if(!S)return w;const m=S.getCommentThread(w.thread.commentThreadHandle);if(!m)return w;const E=w.commentUniqueId,D=m.getCommentByUniqueId(E);return D||w}else if(w&&w.$mid===11){const S=this.b.get(w.thread.commentControlHandle);if(!S)return w;const m=S.getCommentThread(w.thread.commentThreadHandle);if(!m)return w;const E=w.text,D=w.commentUniqueId,C=m.getCommentByUniqueId(D);return C?(typeof C.body=="string"?C.body=E:C.body=new A.$HM(E),C):w}return w}})}createCommentController(w,S,m){const E=n.a++,D=new u(w,E,S,m);this.b.set(D.handle,D);const C=this.c.get(w.identifier)||[];return C.push(D),this.c.set(w.identifier,C),D.value}async $createCommentThreadTemplate(w,S,m){const E=this.b.get(w);E&&E.$createCommentThreadTemplate(S,m)}async $setActiveComment(w,S){const m=this.b.get(w);m&&m.$setActiveComment(S??void 0)}async $updateCommentThreadTemplate(w,S,m){const E=this.b.get(w);E&&E.$updateCommentThreadTemplate(S,m)}$deleteCommentThread(w,S){this.b.get(w)?.$deleteCommentThread(S)}async $provideCommentingRanges(w,S,m){const E=this.b.get(w);if(!E||!E.commentingRangeProvider)return Promise.resolve(void 0);const D=await d.ensureDocumentData(M.URI.revive(S));return(0,h.$oh)(async()=>{const C=await E.commentingRangeProvider.provideCommentingRanges(D.document,m);let P;return Array.isArray(C)?P={ranges:C,fileComments:!1}:C?P={ranges:C.ranges||[],fileComments:C.fileComments||!1}:P=C??void 0,P}).then(C=>{let P;return C&&(P={ranges:C.ranges.map(F=>k.Range.from(F)),fileComments:C.fileComments}),P})}$toggleReaction(w,S,m,E,D){const C=this.b.get(w);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,h.$oh)(()=>{const P=C.getCommentThread(S);if(P){const F=P.getCommentByUniqueId(E.uniqueIdInThread);if(C!==void 0&&F&&C.reactionHandler)return C.reactionHandler(F,c(D))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(w){this.n=w}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(w){(w===void 0!=(this.p===void 0)||!w||!this.p||!w.isEqual(this.p))&&(this.p=w,this.b.range=w,this.c.fire())}get range(){return this.p}set canReply(w){this.d!==w&&(this.d=w,this.b.canReply=w,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(w){this.e=w,this.b.label=w,this.c.fire()}get contextValue(){return this.f}set contextValue(w){this.f=w,this.b.contextValue=w,this.c.fire()}get comments(){return this.q}set comments(w){this.q=w,this.b.comments=w,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(w){this.g=w,this.b.collapsibleState=w,this.c.fire()}get state(){return this.h}set state(w){this.h=w,typeof w=="object"?((0,p.$PG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=w.resolved,this.b.applicability=w.applicability):this.b.state=w,this.c.fire()}get isDisposed(){return this.j}constructor(w,S,m,E,D,C,P,F){this.m=S,this.n=m,this.o=E,this.p=D,this.q=C,this.extensionDescription=P,this.r=F,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new O.$de,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Vc,this.l.value=new R.$Tc,this.n===void 0&&(this.n=`${w}.${this.handle}`),o.$createCommentThread(S,this.handle,this.n,this.o,k.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{o.$deleteCommentThread(S,this.handle)}});const T=this;this.value={get uri(){return T.uri},get range(){return T.range},set range(z){T.range=z},get comments(){return T.comments},set comments(z){T.comments=z},get collapsibleState(){return T.collapsibleState},set collapsibleState(z){T.collapsibleState=z},get canReply(){return T.canReply},set canReply(z){T.canReply=z},get contextValue(){return T.contextValue},set contextValue(z){T.contextValue=z},get label(){return T.label},set label(z){T.label=z},get state(){return T.state},set state(z){T.state=z},dispose:()=>{T.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Tc);const w=m=>Object.prototype.hasOwnProperty.call(this.b,m),S={};w("range")&&(S.range=k.Range.from(this.p)),w("label")&&(S.label=this.label),w("contextValue")&&(S.contextValue=this.contextValue??null),w("comments")&&(S.comments=this.q.map(m=>s(this,m,this.k,this.extensionDescription))),w("collapsibleState")&&(S.collapseState=r(this.g)),w("canReply")&&(S.canReply=this.canReply),w("state")&&(S.state=a(this.h)),w("applicability")&&(S.applicability=f(this.h)),w("isTemplate")&&(S.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(w){for(const S of this.k){const m=S[0],E=S[1];if(w===E)return m}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(w=>w.dispose())}}He([(0,N.$2h)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class u{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(w){this.b=w,w?.resourceHints&&(0,p.$PG)(this.h,"commentingRangeHint"),o.$updateCommentingRanges(this.handle,w?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(w){this.c=w,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!w})}get options(){return this.d}set options(w){this.d=w,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,p.$PG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,p.$PG)(this.h,"activeComment"),this.f}constructor(w,S,m,E){this.h=w,this.i=S,this.j=m,this.k=E,this.a=new Map,o.$registerCommentController(this.handle,m,E,this.h.identifier.value);const D=this;this.value=Object.freeze({id:D.id,label:D.label,get options(){return D.options},set options(C){D.options=C},get commentingRangeProvider(){return D.commentingRangeProvider},set commentingRangeProvider(C){D.commentingRangeProvider=C},get reactionHandler(){return D.reactionHandler},set reactionHandler(C){D.reactionHandler=C},get activeCommentThread(){return D.activeCommentThread},createCommentThread(C,P,F){return D.createCommentThread(C,P,F).value},dispose:()=>{D.dispose()}}),this.g=[],this.g.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(w,S,m){S===void 0&&(0,p.$PG)(this.h,"fileComments");const E=new i(this.id,this.handle,void 0,w,S,m,this.h,!1);return this.a.set(E.handle,E),E}$setActiveComment(w){if(!w){this.e=void 0,this.f=void 0;return}const S=this.a.get(w.commentThreadHandle);S&&(this.e=w.uniqueIdInThread?S.getCommentByUniqueId(w.uniqueIdInThread):void 0,this.f=S)}$createCommentThreadTemplate(w,S){const m=new i(this.id,this.handle,void 0,M.URI.revive(w),k.Range.to(S),[],this.h,!0);return m.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(m.handle,m),m}$updateCommentThreadTemplate(w,S){const m=this.a.get(w);m&&(m.range=k.Range.to(S))}$deleteCommentThread(w){this.a.get(w)?.dispose(),this.a.delete(w)}getCommentThread(w){return this.a.get(w)}dispose(){this.a.forEach(w=>{w.dispose()}),this.g.forEach(w=>w.dispose())}}function s(g,w,S,m){let E=S.get(w);return E||(E=++g.commentHandle,S.set(w,E)),w.state!==void 0&&(0,p.$PG)(m,"commentsDraftState"),w.reactions?.some(D=>D.reactors!==void 0)&&(0,p.$PG)(m,"commentReactor"),{mode:w.mode,contextValue:w.contextValue,uniqueIdInThread:E,body:typeof w.body=="string"?w.body:k.MarkdownString.from(w.body),userName:w.author.name,userIconPath:w.author.iconPath,label:w.label,commentReactions:w.reactions?w.reactions.map(D=>t(D)):void 0,state:w.state,timestamp:w.timestamp?.toJSON()}}function t(g){return{label:g.label,iconPath:g.iconPath?k.$DO(g.iconPath):void 0,count:g.count,hasReacted:g.authorHasReacted,reactors:g.reactors&&g.reactors.length>0&&typeof g.reactors[0]!="string"?g.reactors.map(w=>w.name):g.reactors}}function c(g){return{label:g.label||"",count:g.count||0,iconPath:g.iconPath?M.URI.revive(g.iconPath):"",authorHasReacted:g.hasReacted||!1,reactors:g.reactors?.map(w=>({name:w}))}}function r(g){if(g!==void 0)switch(g){case A.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function a(g){let w;if(typeof g=="object"?w=g.resolved:w=g,w!==void 0)switch(w){case A.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}function f(g){let w;if(typeof g=="object"&&(w=g.applicability),w!==void 0)switch(w){case A.CommentThreadApplicability.Current:return b.CommentThreadApplicability.Current;case A.CommentThreadApplicability.Outdated:return b.CommentThreadApplicability.Outdated}return b.CommentThreadApplicability.Current}return new n}}),define(Se[337],De([1,0,22,57,3,15,23,2,17,92,112,6,8]),function(he,e,h,N,O,R,M,b,$,k,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6lc=void 0;class y{constructor(c,r){this.document=c,this.b=r,this.a=1,this.c=new A.$tlc("custom documents")}addEdit(c){return this.c.add([c])}async undo(c,r){await this.f(c).undo(),r||this.disposeBackup()}async redo(c,r){await this.f(c).redo(),r||this.disposeBackup()}disposeEdits(c){for(const r of c)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const c=s(this.document.uri)+this.a++;return(0,M.$0g)(this.b,c)}updateBackup(c){this.d?.delete(),this.d=c}disposeBackup(){this.d?.delete(),this.d=void 0}f(c){const r=this.c.get(c,0);if(!r)throw new Error("No edit found");return r}}class v{constructor(){this.a=new Map}get(c,r){return this.a.get(this.b(c,r))}add(c,r,a){const f=this.b(c,r.uri);if(this.a.has(f))throw new Error(`Document already exists for viewType:${c} resource:${r.uri}`);const g=new y(r,a);return this.a.set(f,g),g}delete(c,r){const a=this.b(c,r.uri);this.a.delete(a)}b(c,r){return`${c}@@@${r}`}}var l;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(l||(l={}));class d{constructor(){this.a=new Map}addTextProvider(c,r,a){return this.b(c,{type:0,extension:r,provider:a})}addCustomProvider(c,r,a){return this.b(c,{type:1,extension:r,provider:a})}get(c){return this.a.get(c)}b(c,r){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,r),new p.$fM(()=>this.a.delete(c))}}class o{constructor(c,r,a,f,g){this.d=r,this.f=a,this.g=f,this.h=g,this.b=new d,this.c=new v,this.a=c.getProxy(I.$dM.MainThreadCustomEditors)}registerCustomEditorProvider(c,r,a,f){const g=new O.$Tc;return i(a)?(g.add(this.b.addTextProvider(r,c,a)),this.a.$registerTextEditorProvider((0,k.$3lc)(c),r,f.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,k.$1lc)(c))):(g.add(this.b.addCustomProvider(r,c,a)),n(a)&&g.add(a.onDidChangeCustomDocument(w=>{const S=this.i(r,w.document.uri);if(u(w)){const m=S.addEdit(w);this.a.$onDidEdit(w.document.uri,r,m,w.label)}else this.a.$onContentChange(w.document.uri,r)})),this.a.$registerCustomEditorProvider((0,k.$3lc)(c),r,f.webviewOptions||{},!!f.supportsMultipleEditorsPerDocument,(0,k.$1lc)(c))),p.$fM.from(g,new p.$fM(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(c,r,a,f,g){const w=this.b.get(r);if(!w)throw new Error(`No provider found for '${r}'`);if(w.type!==1)throw new Error(`Invalid provide type for '${r}'`);const S=b.URI.revive(c),m=await w.provider.openCustomDocument(S,{backupId:a,untitledDocumentData:f?.buffer},g);let E;return n(w.provider)&&this.f&&(E=this.f.workspaceValue(w.extension)??this.f.globalValue(w.extension)),this.c.add(r,m,E),{editable:n(w.provider)}}async $disposeCustomDocument(c,r){const a=this.b.get(r);if(!a)throw new Error(`No provider found for '${r}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${r}'`);const f=b.URI.revive(c),{document:g}=this.i(r,f);this.c.delete(r,g),g.dispose()}async $resolveCustomEditor(c,r,a,f,g,w){const S=this.b.get(a);if(!S)throw new Error(`No provider found for '${a}'`);const m=$.ViewColumn.to(g),E=this.g.createNewWebview(r,f.contentOptions,S.extension),D=this.h.createNewWebviewPanel(r,a,f.title,m,f.options,E,f.active),C=b.URI.revive(c);switch(S.type){case 1:{const{document:P}=this.i(a,C);return S.provider.resolveCustomEditor(P,D,w)}case 0:{const P=this.d.getDocument(C);return S.provider.resolveCustomTextEditor(P,D,w)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(c,r,a){this.i(r,c).disposeEdits(a)}async $onMoveCustomEditor(c,r,a){const f=this.b.get(a);if(!f)throw new Error(`No provider found for '${a}'`);if(!f.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const g=this.h.getWebviewPanel(c);if(!g)throw new Error("No webview found");const w=b.URI.revive(r),S=this.d.getDocument(w);await f.provider.moveCustomTextEditor(S,g,h.CancellationToken.None)}async $undo(c,r,a,f){return this.i(r,c).undo(a,f)}async $redo(c,r,a,f){return this.i(r,c).redo(a,f)}async $revert(c,r,a){const f=this.i(r,c);await this.j(r).revertCustomDocument(f.document,a),f.disposeBackup()}async $onSave(c,r,a){const f=this.i(r,c);await this.j(r).saveCustomDocument(f.document,a),f.disposeBackup()}async $onSaveAs(c,r,a,f){const g=this.i(r,c);return this.j(r).saveCustomDocumentAs(g.document,b.URI.revive(a),f)}async $backup(c,r,a){const f=this.i(r,c),w=await this.j(r).backupCustomDocument(f.document,{destination:f.getNewBackupUri()},a);return f.updateBackup(w),w.id}i(c,r){const a=this.c.get(c,b.URI.revive(r));if(!a)throw new Error("No custom document found");return a}j(c){const a=this.b.get(c)?.provider;if(!a||!n(a))throw new Error("Custom document is not editable");return a}}e.$6lc=o;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function u(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function s(t){const c=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,N.$kj)(c)+""}}),define(Se[338],De([1,0,224,139,2,6,8,17,4,11,27,60]),function(he,e,h,N,O,R,M,b,$,k,A,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=e.$Alc=void 0;class y{#e;#t;#n;constructor(d,o,n,i,u,s,t,c){this.d=d,this.e=o,this.f=n,this.g=i,this.h=u,this.c=!1,this.f=Math.max(i,n),this.#n=new A.$Ac(r=>s.getComparisonKey(r)),this.#e=t,this.#t=c}dispose(){this.c||(this.#t.fire([...this.#n.keys()]),this.#e?.$clear(this.e),this.#n.clear(),this.c=!0)}get name(){return this.j(),this.d}set(d,o){if(!d){this.clear();return}this.j();let n=[];if(O.URI.isUri(d)){if(!o){this.delete(d);return}this.#n.set(d,o.slice()),n=[d]}else if(Array.isArray(d)){n=[];let s;d=[...d].sort(y.k);for(const t of d){const[c,r]=t;if((!s||c.toString()!==s.toString())&&(s&&this.#n.get(s).length===0&&this.#n.delete(s),s=c,n.push(c),this.#n.set(c,[])),r)this.#n.get(c)?.push(...r);else{const a=this.#n.get(c);a&&(a.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let u=0;for(const s of n){let t=[];const c=this.#n.get(s);if(c)if(c.length>this.g){t=[];const r=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let a=0;a<4;a++)for(const f of c)if(f.severity===r[a]&&t.push({...b.Diagnostic.from(f),modelVersionId:this.h(s)})===this.g)break e;t.push({severity:N.MarkerSeverity.Info,message:(0,h.localize)(0,null,c.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=c.map(r=>({...b.Diagnostic.from(r),modelVersionId:this.h(s)}));if(i.push([s,t]),u+=t.length,u>this.f)break}this.#e.$changeMany(this.e,i)}delete(d){this.j(),this.#t.fire([d]),this.#n.delete(d),this.#e?.$changeMany(this.e,[[d,void 0]])}clear(){this.j(),this.#t.fire([...this.#n.keys()]),this.#n.clear(),this.#e?.$clear(this.e)}forEach(d,o){this.j();for(const[n,i]of this)d.call(o,n,i,this)}*[Symbol.iterator](){this.j();for(const d of this.#n.keys())yield[d,this.get(d)]}get(d){this.j();const o=this.#n.get(d);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(d){return this.j(),Array.isArray(this.#n.get(d))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(d,o){return d[0].toString()<o[0].toString()?-1:d[0].toString()>o[0].toString()?1:0}}e.$Alc=y;let v=class{static{p=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*p.d}static _mapper(d){const o=new A.$Ac;for(const n of d)o.set(n,n);return{uris:Object.freeze(Array.from(o.values()))}}constructor(d,o,n,i){this.j=o,this.k=n,this.l=i,this.g=new Map,this.h=new $.$he({merge:u=>u.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,p._mapper),this.f=d.getProxy(R.$dM.MainThreadDiagnostics)}createDiagnosticCollection(d,o){const{g:n,f:i,h:u,j:s,k:t,l:c}=this,r=new class{$changeMany(g,w){i.$changeMany(g,w),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",d.value,g,w.length===0?"CLEARING":w)}$clear(g){i.$clear(g),s.trace("[DiagnosticCollection] remove all (extension, owner)",d.value,g)}dispose(){i.dispose()}};let a;if(!o)o="_generated_diagnostic_collection_name_#"+p.c++,a=o;else if(!n.has(o))a=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do a=o+p.c++;while(n.has(a))}return new class extends y{constructor(){super(o,a,p.e,p.d,g=>c.getDocument(g)?.version,t.extUri,r,u),n.set(a,this)}dispose(){super.dispose(),n.delete(a)}}}getDiagnostics(d){if(d)return this.m(d);{const o=new Map,n=[];for(const i of this.g.values())i.forEach((u,s)=>{let t=o.get(u.toString());typeof t>"u"&&(t=n.length,o.set(u.toString(),t),n.push([u,[]])),n[t][1]=n[t][1].concat(...s)});return n}}m(d){let o=[];for(const n of this.g.values())n.has(d)&&(o=o.concat(n.get(d)));return o}$acceptMarkersChange(d){if(!this.n){const o="_generated_mirror",n=new y(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(o,n),this.n=n}for(const[o,n]of d)this.n.set(O.URI.revive(o),n.map(b.Diagnostic.to))}};e.$Blc=v,e.$Blc=v=p=He([We(1,k.$3j),We(2,I.$zlc)],v)}),define(Se[339],De([1,0,2,13,8,17,76,48]),function(he,e,h,N,O,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=void 0;class ${constructor(A,I,p,y={timeout:1500,errors:3}){this.c=A,this.d=I,this.f=p,this.g=y,this.a=new M.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(A){return(I,p,y)=>{const l={dispose:this.a.push([I,p,A])};return Array.isArray(y)&&y.push(l),l}}async $participateInSave(A,I){const p=h.URI.revive(A);let y=!1;const v=setTimeout(()=>y=!0,this.g.timeout),l=[];try{for(const d of[...this.a]){if(y)break;const o=this.d.getDocument(p),n=await this.h(d,{document:o,reason:R.TextDocumentSaveReason.to(I)});l.push(n)}}finally{clearTimeout(v)}return l}h([A,I,p],y){const v=this.b.get(A);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(p,A,I,y).then(()=>!0,l=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${p.identifier.value}' threw ERROR`),this.c.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const d=this.b.get(A);this.b.set(A,d?d+1:1),typeof d=="number"&&d>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${p.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(A,I,p,y){const v=[],l=Date.now(),{document:d,reason:o}=y,{version:n}=d,i=Object.freeze({document:d,reason:o,waitUntil(u){if(Object.isFrozen(v))throw(0,N.$8)("waitUntil can not be called async");v.push(Promise.resolve(u))}});try{I.apply(p,[i])}catch(u){return Promise.reject(u)}return Object.freeze(v),new Promise((u,s)=>{const t=setTimeout(()=>s(new Error("timeout")),this.g.timeout);return Promise.all(v).then(c=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(t),u(c)}).catch(c=>{clearTimeout(t),s(c)})}).then(u=>{const s={edits:[]};for(const t of u)if(Array.isArray(t)&&t.every(c=>c instanceof O.$mM))for(const{newText:c,newEol:r,range:a}of t)s.edits.push({resource:d.uri,versionId:void 0,textEdit:{range:a&&R.Range.from(a),text:c,eol:r&&R.EndOfLine.from(r)}});if(s.edits.length!==0)return n===d.version?this.f.$tryApplyWorkspaceEdit(new b.$Bw(s)):Promise.reject(new Error("concurrent_edits"))})}}e.$Jmc=$}),define(Se[340],De([1,0,4,3,2,6,153,17,18,24,8]),function(he,e,h,N,O,R,M,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Clc=void 0;class I{constructor(y,v){this.a=new h.$de,this.b=new h.$de,this.c=new h.$de,this.d=new h.$de,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Tc,this.h=new Map,this.f=y.getProxy(R.$dM.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(l=>{for(const d of l)this.b.fire(d.document)},void 0,this.e),this.g.onDidAddDocuments(l=>{for(const d of l)this.a.fire(d.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(y){if(!y)return;const v=this.g.getDocument(y);if(v)return v}getDocument(y){const v=this.getDocumentData(y);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${y}'`);return v.document}ensureDocumentData(y){const v=this.g.getDocument(y);if(v)return Promise.resolve(v);let l=this.h.get(y.toString());return l||(l=this.f.$tryOpenDocument(y).then(d=>{this.h.delete(y.toString());const o=O.URI.revive(d);return(0,$.$hg)(this.g.getDocument(o))},d=>(this.h.delete(y.toString()),Promise.reject(d))),this.h.set(y.toString(),l)),l}createDocumentData(y){return this.f.$tryCreateDocument(y).then(v=>O.URI.revive(v))}$acceptModelLanguageChanged(y,v){const l=O.URI.revive(y),d=this.g.getDocument(l);if(!d)throw new Error("unknown document");this.b.fire(d.document),d._acceptLanguageId(v),this.a.fire(d.document)}$acceptModelSaved(y){const v=O.URI.revive(y),l=this.g.getDocument(v);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(y,!1),this.d.fire(l.document)}$acceptDirtyStateChanged(y,v){const l=O.URI.revive(y),d=this.g.getDocument(l);if(!d)throw new Error("unknown document");d._acceptIsDirty(v),this.c.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(y,v,l){const d=O.URI.revive(y),o=this.g.getDocument(d);if(!o)throw new Error("unknown document");o._acceptIsDirty(l),o.onEvents(v);let n;v.isUndoing?n=A.TextDocumentChangeReason.Undo:v.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,k.$4n)({document:o.document,contentChanges:v.changes.map(i=>({range:b.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(y,v){(0,M.$GO)(y,v)}}e.$Clc=I}),define(Se[72],De([1,0,74,4,18,2,5,6,20,17,8]),function(he,e,h,N,O,R,M,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8lc=e.$7lc=void 0,e.$7lc=(0,M.$wi)("IExtHostEditorTabs");class I{constructor(d,o,n){this.e=n,this.d=o,this.acceptDtoUpdate(d)}get apiObject(){if(!this.a){const d=this,o={get isActive(){return d.b.id===d.e()},get label(){return d.b.label},get input(){return d.c},get isDirty(){return d.b.isDirty},get isPinned(){return d.b.isPinned},get isPreview(){return d.b.isPreview},get group(){return d.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(d){this.b=d,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$3N(R.URI.revive(this.b.input.uri));case 2:return new A.$4N(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case 3:return new A.$5N(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case 6:return new A.$6N(R.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$7N(this.b.input.viewType);case 4:return new A.$8N(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$9N(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$0N;case 9:return new A.$$N(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$_N;case 11:return new A.$aO(this.b.input.diffEditors.map(d=>new A.$4N(R.URI.revive(d.original),R.URI.revive(d.modified))));default:return}}}class p{constructor(d,o){this.c=[],this.d="",this.b=d,this.e=o;for(const n of d.tabs)n.isActive&&(this.d=n.id),this.c.push(new I(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const d=this,o={get isActive(){return d.b.groupId===d.e()},get viewColumn(){return k.ViewColumn.to(d.b.viewColumn)},get activeTab(){return d.c.find(n=>n.tabId===d.d)?.apiObject},get tabs(){return Object.freeze(d.c.map(n=>n.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(d){this.b=d}acceptTabOperation(d){if(d.kind===0){const n=new I(d.tabDto,this,()=>this.activeTabId());return this.c.splice(d.index,0,n),d.tabDto.isActive&&(this.d=n.tabId),n}else if(d.kind===1){const n=this.c.splice(d.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(d.kind===3){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(d.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this.c.splice(d.index,0,n),n}const o=this.c.find(n=>n.tabId===d.tabDto.id);if(!o)throw new Error("INVALID tab");return d.tabDto.isActive?this.d=d.tabDto.id:this.d===d.tabDto.id&&!d.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(d.tabDto),o}activeTabId(){return this.d}}let y=class{constructor(d){this.b=new N.$de,this.c=new N.$de,this.e=[],this.a=d.getProxy(b.$dM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const d=this,o={onDidChangeTabGroups:d.c.event,onDidChangeTabs:d.b.event,get all(){return Object.freeze(d.e.map(n=>n.apiObject))},get activeTabGroup(){const n=d.d;return(0,O.$hg)(d.e.find(u=>u.groupId===n)?.apiObject)},close:async(n,i)=>{const u=Array.isArray(n)?n:[n];return u.length?v(u[0])?this.j(u,i):this.i(u,i):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(d){const o=new Set(this.e.map(r=>r.groupId)),n=new Set(d.map(r=>r.groupId)),i=(0,h.$L)(o,n),u=this.e.filter(r=>i.removed.includes(r.groupId)).map(r=>r.apiObject),s=[],t=[];this.e=d.map(r=>{const a=new p(r,()=>this.d);return i.added.includes(a.groupId)?s.push(a.apiObject):t.push(a.apiObject),a});const c=(0,O.$hg)(d.find(r=>r.isActive===!0)?.groupId);c!==void 0&&this.d!==c&&(this.d=c),this.c.fire(Object.freeze({opened:s,closed:u,changed:t}))}$acceptTabGroupUpdate(d){const o=this.e.find(n=>n.groupId===d.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(d),d.isActive&&(this.d=d.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const o=this.e.find(i=>i.groupId===d.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const n=o.acceptTabOperation(d);switch(d.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(d){for(const o of this.e)for(const n of o.tabs)if(n.apiObject===d)return n}h(d){return this.e.find(o=>o.apiObject===d)}async i(d,o){const n=[];for(const i of d){const u=this.g(i);if(!u)throw new Error("Tab close: Invalid tab not found!");n.push(u.tabId)}return this.a.$closeTab(n,o)}async j(d,o){const n=[];for(const i of d){const u=this.h(i);if(!u)throw new Error("Group close: Invalid group not found!");n.push(u.groupId)}return this.a.$closeGroup(n,o)}};e.$8lc=y,e.$8lc=y=He([We(0,$.$EO)],y);function v(l){return l.tabs!==void 0}}),define(Se[341],De([1,0,2,6,3,8,17,185,14,21,26,81]),function(he,e,h,N,O,R,M,b,$,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmc=void 0;class p{constructor(){this.a=[]}add(l){this.b=void 0,this.a.push(l)}delete(l){const d=this.a.indexOf(l);d>=0&&(this.a.splice(d,1),this.b=void 0)}c(){if(!this.b){const l=this.a.sort(),d=[];let o,n,i=14,u=14;for(const s of l){let t=o?(0,$.$zf)(o,s):0;for(t===0?n=1:n=u;t<s.length;t++)t+1===s.length?(i=u,u=9):u+=1,d.push([n,s.toUpperCase().charCodeAt(t),u]),d.push([n,s.toLowerCase().charCodeAt(t),u]),n=u;o=s,u=i}d.push([9,58,10]),d.push([10,47,12]),this.b=new b.$B2(d)}}provideDocumentLinks(l){this.c();const d=[],o=b.$C2.computeLinks({getLineContent(n){return l.lineAt(n-1).text},getLineCount(){return l.lineCount}},this.b);for(const n of o){const i=M.DocumentLink.to(n);i.target&&d.push(i)}return d}}class y{constructor(l,d){this.i=d,this.b=new p,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=l.getProxy(N.$dM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(l,d,o,n={}){if(y.j(o),this.d.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(l,"*",this.b));const i=this.h++;this.b.add(d),this.d.add(d),this.c.set(i,o);let u=2;n.isCaseSensitive&&(u+=1024),n.isReadonly&&(u+=2048),typeof o.copy=="function"&&(u+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,A.$PG)(l,"fsChunks"),u+=4);let s;n.isReadonly&&(0,I.$Vk)(n.isReadonly)&&n.isReadonly.value!==""&&(s={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,d,u,s).catch(c=>{console.error(`FAILED to register filesystem provider of ${l.identifier.value}-extension for the scheme ${d}`),console.error(c)});const t=o.onDidChangeFile(c=>{const r=[];for(const a of c){const{uri:f,type:g}=a;if(f.scheme!==d)continue;let w;switch(g){case R.FileChangeType.Changed:w=0;break;case R.FileChangeType.Created:w=1;break;case R.FileChangeType.Deleted:w=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:f,type:w})}this.a.$onFileSystemChange(i,r)});return(0,O.$Sc)(()=>{t.dispose(),this.b.delete(d),this.d.delete(d),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(l){if(!l)throw new Error("MISSING provider");if(typeof l.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof l.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof l.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof l.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof l.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof l.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof l.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof l.rename!="function")throw new Error("Provider does NOT implement rename")}static k(l){const{type:d,ctime:o,mtime:n,size:i,permissions:u}=l;return{type:d,ctime:o,mtime:n,size:i,permissions:u}}$stat(l,d){return Promise.resolve(this.l(l).stat(h.URI.revive(d))).then(o=>y.k(o))}$readdir(l,d){return Promise.resolve(this.l(l).readDirectory(h.URI.revive(d)))}$readFile(l,d){return Promise.resolve(this.l(l).readFile(h.URI.revive(d))).then(o=>k.$Fe.wrap(o))}$writeFile(l,d,o,n){return Promise.resolve(this.l(l).writeFile(h.URI.revive(d),o.buffer,n))}$delete(l,d,o){return Promise.resolve(this.l(l).delete(h.URI.revive(d),o))}$rename(l,d,o,n){return Promise.resolve(this.l(l).rename(h.URI.revive(d),h.URI.revive(o),n))}$copy(l,d,o,n){const i=this.l(l);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(h.URI.revive(d),h.URI.revive(o),n))}$mkdir(l,d){return Promise.resolve(this.l(l).createDirectory(h.URI.revive(d)))}$watch(l,d,o,n){const i=this.l(l).watch(h.URI.revive(o),n);this.f.set(d,i)}$unwatch(l,d){const o=this.f.get(d);o&&(o.dispose(),this.f.delete(d))}$open(l,d,o){const n=this.l(l);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(h.URI.revive(d),o))}$close(l,d){const o=this.l(l);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(d))}$read(l,d,o,n){const i=this.l(l);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const u=k.$Fe.alloc(n);return Promise.resolve(i.read(d,o,u.buffer,0,n)).then(s=>u.slice(0,s))}$write(l,d,o,n){const i=this.l(l);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(d,o,n.buffer,0,n.byteLength))}l(l){const d=this.c.get(l);if(!d){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return d}}e.$Lmc=y}),define(Se[342],De([1,0,4,35,2,6,17,8,46]),function(he,e,h,N,O,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=void 0;class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(y,v,l,d,o,n){this.a=Math.random(),this.b=new h.$de,this.c=new h.$de,this.d=new h.$de,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,N.$qk)(o),u=typeof o=="string",s=n?.correlate,t=d(c=>{if(!(typeof c.session=="number"&&c.session!==this.a)&&!(s&&typeof c.session>"u")){if(!n?.ignoreCreateEvents)for(const r of c.created){const a=O.URI.revive(r);i(a.fsPath)&&(!u||v.getWorkspaceFolder(a))&&this.b.fire(a)}if(!n?.ignoreChangeEvents)for(const r of c.changed){const a=O.URI.revive(r);i(a.fsPath)&&(!u||v.getWorkspaceFolder(a))&&this.c.fire(a)}if(!n?.ignoreDeleteEvents)for(const r of c.deleted){const a=O.URI.revive(r);i(a.fsPath)&&(!u||v.getWorkspaceFolder(a))&&this.d.fire(a)}}});this.g=b.$fM.from(this.i(y,l,o,n,n?.correlate),this.b,this.c,this.d,t)}i(y,v,l,d,o){const n=b.$fM.from();if(typeof l=="string"||d?.ignoreChangeEvents&&d?.ignoreCreateEvents&&d?.ignoreDeleteEvents)return n;const i=y.getProxy(R.$dM.MainThreadFileSystemEventService);let u=!1;(l.pattern.includes(N.$mk)||l.pattern.includes(N.$nk))&&(u=!0);let s;return o&&(d?.ignoreChangeEvents||d?.ignoreCreateEvents||d?.ignoreDeleteEvents)&&(s=14,d?.ignoreChangeEvents&&(s&=-3),d?.ignoreCreateEvents&&(s&=-5),d?.ignoreDeleteEvents&&(s&=-9)),i.$watch(v.identifier.value,this.a,l.baseUri,{recursive:u,excludes:d?.excludes??[],filter:s},!!o),b.$fM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(y){this.a=y,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(O.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(O.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(O.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class I{constructor(y,v,l){this.j=y,this.k=v,this.l=l,this.a=new h.$de,this.b=new h.$de,this.c=new h.$de,this.d=new h.$de,this.g=new h.$fe,this.h=new h.$fe,this.i=new h.$fe,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(y,v,l,d){return new k(this.j,y,v,this.a.event,M.GlobPattern.from(l),d)}$onFileEvent(y){this.a.fire(new A(y))}$onDidRunFileOperation(y,v){switch(y){case 2:this.b.fire(Object.freeze({files:v.map(l=>({oldUri:O.URI.revive(l.source),newUri:O.URI.revive(l.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(l=>O.URI.revive(l.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(l=>O.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(y){return this.m(y,this.g)}getOnWillCreateFileEvent(y){return this.m(y,this.h)}getOnWillDeleteFileEvent(y){return this.m(y,this.i)}m(y,v){return(l,d,o)=>{const n=function(u){l.call(d,u)};return n.extension=y,v.event(n,void 0,o)}}async $onWillRunFileOperation(y,v,l,d){switch(y){case 2:return await this.n(this.g,{files:v.map(o=>({oldUri:O.URI.revive(o.source),newUri:O.URI.revive(o.target)}))},l,d);case 1:return await this.n(this.i,{files:v.map(o=>O.URI.revive(o.target))},l,d);case 0:case 3:return await this.n(this.h,{files:v.map(o=>O.URI.revive(o.target))},l,d)}}async n(y,v,l,d){const o=new Set,n=[];if(await y.fireAsync(v,d,async(u,s)=>{const t=Date.now(),c=await Promise.resolve(u);c instanceof b.$pM&&(n.push([s.extension,c]),o.add(s.extension.displayName??s.extension.identifier.value)),Date.now()-t>l&&this.k.warn("SLOW file-participant",s.extension.identifier)}),d.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,u]of n){const{edits:s}=M.WorkspaceEdit.from(u,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(s)}return{edit:i,extensionNames:Array.from(o)}}}e.$Mmc=I}),define(Se[343],De([1,0,19,7,22,13,125,3,24,40,14,18,2,29,181,84,135,226,25,17,8,26,112,6]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d,o,n,i,u,s,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=void 0;class r{constructor(V,W){this.d=V,this.e=W}async provideDocumentSymbols(V,W){const J=this.d.getDocument(V),Z=await this.e.provideDocumentSymbols(J,W);if(!(0,h.$Kb)(Z))return Z[0]instanceof u.$zM?Z.map(i.DocumentSymbol.from):r.f(Z)}static f(V){V=V.slice(0).sort((Z,de)=>{let we=Z.location.range.start.compareTo(de.location.range.start);return we===0&&(we=de.location.range.end.compareTo(Z.location.range.end)),we});const W=[],J=[];for(const Z of V){const de={name:Z.name||"!!MISSING: name!!",kind:i.SymbolKind.from(Z.kind),tags:Z.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:Z.containerName,range:i.Range.from(Z.location.range),selectionRange:i.Range.from(Z.location.range),children:[]};for(;;){if(J.length===0){J.push(de),W.push(de);break}const we=J[J.length-1];if(y.$ut.containsRange(we.range,de.range)&&!y.$ut.equalsRange(we.range,de.range)){we.children?.push(de),J.push(de);break}J.pop()}}return W}}class a{constructor(V,W,J,Z,de,we){this.f=V,this.g=W,this.h=J,this.j=Z,this.k=de,this.l=we,this.d=new t.$tlc("CodeLens"),this.e=new Map}async provideCodeLenses(V,W){const J=this.f.getDocument(V),Z=await this.h.provideCodeLenses(J,W);if(!Z||W.isCancellationRequested)return;const de=this.d.add(Z),we=new b.$Tc;this.e.set(de,we);const Fe={cacheId:de,lenses:[]};for(let Ve=0;Ve<Z.length;Ve++)Fe.lenses.push({cacheId:[de,Ve],range:i.Range.from(Z[Ve].range),command:this.g.toInternal(Z[Ve].command,we)});return Fe}async resolveCodeLens(V,W){const J=V.cacheId&&this.d.get(...V.cacheId);if(!J)return;let Z;if(typeof this.h.resolveCodeLens!="function"||J.isResolved?Z=J:Z=await this.h.resolveCodeLens(J,W),Z||(Z=J),W.isCancellationRequested)return;const de=V.cacheId&&this.e.get(V.cacheId[0]);if(de){if(!Z.command){const we=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,we),this.l.error(we);return}return V.command=this.g.toInternal(Z.command,de),V}}releaseCodeLenses(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}}function f(je){return Array.isArray(je)?je.map(i.DefinitionLink.from):je?[i.DefinitionLink.from(je)]:[]}class g{constructor(V,W){this.d=V,this.e=W}async provideDefinition(V,W,J){const Z=this.d.getDocument(V),de=i.Position.to(W),we=await this.e.provideDefinition(Z,de,J);return f(we)}}class w{constructor(V,W){this.d=V,this.e=W}async provideDeclaration(V,W,J){const Z=this.d.getDocument(V),de=i.Position.to(W),we=await this.e.provideDeclaration(Z,de,J);return f(we)}}class S{constructor(V,W){this.d=V,this.e=W}async provideImplementation(V,W,J){const Z=this.d.getDocument(V),de=i.Position.to(W),we=await this.e.provideImplementation(Z,de,J);return f(we)}}class m{constructor(V,W){this.d=V,this.e=W}async provideTypeDefinition(V,W,J){const Z=this.d.getDocument(V),de=i.Position.to(W),we=await this.e.provideTypeDefinition(Z,de,J);return f(we)}}class E{static{this.f=10}constructor(V,W){this.g=V,this.h=W,this.d=0,this.e=new Map}async provideHover(V,W,J,Z){const de=this.g.getDocument(V),we=i.Position.to(W);let Fe;if(J&&J.verbosityRequest){const _e=J.verbosityRequest.previousHover.id,nt=this.e.get(_e);if(!nt)throw new Error(`Hover with id ${_e} not found`);const rt={action:J.verbosityRequest.action,previousHover:nt};Fe=await this.h.provideHover(de,we,Z,rt)}else Fe=await this.h.provideHover(de,we,Z);if(!Fe||(0,h.$Kb)(Fe.contents))return;Fe.range||(Fe.range=de.getWordRangeAtPosition(we)),Fe.range||(Fe.range=new u.$hM(we,we));const Ve=i.Hover.from(Fe),Ge=this.d;if(this.e.size===E.f){const _e=Math.min(...this.e.keys());this.e.delete(_e)}return this.e.set(Ge,Fe),this.d+=1,{...Ve,id:Ge}}releaseHover(V){this.e.delete(V)}}class D{constructor(V,W){this.d=V,this.e=W}async provideEvaluatableExpression(V,W,J){const Z=this.d.getDocument(V),de=i.Position.to(W),we=await this.e.provideEvaluatableExpression(Z,de,J);if(we)return i.EvaluatableExpression.from(we)}}class C{constructor(V,W){this.d=V,this.e=W}async provideInlineValues(V,W,J,Z){const de=this.d.getDocument(V),we=await this.e.provideInlineValues(de,i.Range.to(W),i.InlineValueContext.to(J),Z);if(Array.isArray(we))return we.map(Fe=>i.InlineValue.from(Fe))}}class P{constructor(V,W){this.d=V,this.e=W}async provideDocumentHighlights(V,W,J){const Z=this.d.getDocument(V),de=i.Position.to(W),we=await this.e.provideDocumentHighlights(Z,de,J);if(Array.isArray(we))return we.map(i.DocumentHighlight.from)}}class F{constructor(V,W){this.d=V,this.e=W}async provideMultiDocumentHighlights(V,W,J,Z){const de=this.d.getDocument(V),we=J.map(Ge=>this.d.getDocument(Ge)),Fe=i.Position.to(W),Ve=await this.e.provideMultiDocumentHighlights(de,Fe,we,Z);if(Array.isArray(Ve))return Ve.map(i.MultiDocumentHighlight.from)}}class T{constructor(V,W){this.d=V,this.e=W}async provideLinkedEditingRanges(V,W,J){const Z=this.d.getDocument(V),de=i.Position.to(W),we=await this.e.provideLinkedEditingRanges(Z,de,J);if(we&&Array.isArray(we.ranges))return{ranges:(0,h.$Hb)(we.ranges.map(i.Range.from)),wordPattern:we.wordPattern}}}class z{constructor(V,W){this.d=V,this.e=W}async provideReferences(V,W,J,Z){const de=this.d.getDocument(V),we=i.Position.to(W),Fe=await this.e.provideReferences(de,we,J,Z);if(Array.isArray(Fe))return Fe.map(i.location.from)}}class L{static{this.d=1e3}constructor(V,W,J,Z,de,we,Fe){this.g=V,this.h=W,this.j=J,this.k=Z,this.l=de,this.m=we,this.n=Fe,this.e=new t.$tlc("CodeAction"),this.f=new Map}async provideCodeActions(V,W,J,Z){const de=this.g.getDocument(V),we=v.$wt.isISelection(W)?i.Selection.to(W):i.Range.to(W),Fe=[];for(const rt of this.j.getDiagnostics(V))if(we.intersection(rt.range)&&Fe.push(rt)>L.d)break;const Ve={diagnostics:Fe,only:J.only?new u.$BM(J.only):void 0,triggerKind:i.CodeActionTriggerKind.to(J.trigger)},Ge=await this.k.provideCodeActions(de,we,Ve,Z);if(!(0,h.$Lb)(Ge)||Z.isCancellationRequested)return;const tt=this.e.add(Ge),_e=new b.$Tc;this.f.set(tt,_e);const nt=[];for(let rt=0;rt<Ge.length;rt++){const it=Ge[rt];if(it)if(L.o(it))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:it.title,command:this.h.toInternal(it,_e)});else{Ve.only&&(it.kind?Ve.only.contains(it.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action is of kind '${it.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ct=it.ranges??[];nt.push({cacheId:[tt,rt],title:it.title,command:it.command&&this.h.toInternal(it.command,_e),diagnostics:it.diagnostics&&it.diagnostics.map(i.Diagnostic.from),edit:it.edit&&i.WorkspaceEdit.from(it.edit,void 0),kind:it.kind&&it.kind.value,isPreferred:it.isPreferred,isAI:(0,s.$OG)(this.m,"codeActionAI")?it.isAI:!1,ranges:(0,s.$OG)(this.m,"codeActionRanges")?(0,h.$Hb)(ct.map(i.Range.from)):void 0,disabled:it.disabled?.reason})}}return{cacheId:tt,actions:nt}}async resolveCodeAction(V,W){const[J,Z]=V,de=this.e.get(J,Z);if(!de||L.o(de))return{};if(!this.k.resolveCodeAction)return{};const we=await this.k.resolveCodeAction(de,W)??de;let Fe;we.edit&&(Fe=i.WorkspaceEdit.from(we.edit,void 0));let Ve;if(we.command){const Ge=this.f.get(J);Ge&&(Ve=this.h.toInternal(we.command,Ge))}return{edit:Fe,command:Ve}}releaseCodeActions(V){this.f.get(V)?.dispose(),this.f.delete(V),this.e.delete(V)}static o(V){return typeof V.command=="string"&&typeof V.title=="string"}}class j{constructor(V,W,J,Z,de){this.e=V,this.f=W,this.g=J,this.h=Z,this.j=de,this.d=new t.$tlc("DocumentPasteEdit")}async prepareDocumentPaste(V,W,J,Z){if(!this.g.prepareDocumentPaste)return;const de=this.f.getDocument(V),we=W.map(Ge=>i.Range.to(Ge)),Fe=i.DataTransfer.toDataTransfer(J,()=>{throw new R.$$});if(await this.g.prepareDocumentPaste(de,we,Fe,Z),Z.isCancellationRequested)return;const Ve=Array.from(Fe).filter(([,Ge])=>!(Ge instanceof u.$8M));return i.DataTransfer.from(Ve)}async providePasteEdits(V,W,J,Z,de,we){if(!this.g.provideDocumentPasteEdits)return[];const Fe=this.f.getDocument(W),Ve=J.map(nt=>i.Range.to(nt)),Ge=i.DataTransfer.toDataTransfer(Z,async nt=>(await this.e.$resolvePasteFileData(this.h,V,nt)).buffer),tt=await this.g.provideDocumentPasteEdits(Fe,Ve,Ge,{only:de.only?new u.$aN(de.only):void 0,triggerKind:de.triggerKind},we);if(!tt||we.isCancellationRequested)return[];const _e=this.d.add(tt);return tt.map((nt,rt)=>({_cacheId:[_e,rt],title:nt.title??(0,o.localize)(0,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(it=>it.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(V,W){const[J,Z]=V,de=this.d.get(J,Z);if(!de||!this.g.resolveDocumentPasteEdit)return{};const we=await this.g.resolveDocumentPasteEdit(de,W)??de;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releasePasteEdits(V){this.d.delete(V)}}class U{constructor(V,W){this.d=V,this.e=W}async provideDocumentFormattingEdits(V,W,J){const Z=this.d.getDocument(V),de=await this.e.provideDocumentFormattingEdits(Z,W,J);if(Array.isArray(de))return de.map(i.TextEdit.from)}}class X{constructor(V,W){this.d=V,this.e=W}async provideDocumentRangeFormattingEdits(V,W,J,Z){const de=this.d.getDocument(V),we=i.Range.to(W),Fe=await this.e.provideDocumentRangeFormattingEdits(de,we,J,Z);if(Array.isArray(Fe))return Fe.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(V,W,J,Z){(0,I.$gg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const de=this.d.getDocument(V),we=W.map(i.Range.to),Fe=await this.e.provideDocumentRangesFormattingEdits(de,we,J,Z);if(Array.isArray(Fe))return Fe.map(i.TextEdit.from)}}class ie{constructor(V,W){this.d=V,this.e=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(V,W,J,Z,de){const we=this.d.getDocument(V),Fe=i.Position.to(W),Ve=await this.e.provideOnTypeFormattingEdits(we,Fe,J,Z,de);if(Array.isArray(Ve))return Ve.map(i.TextEdit.from)}}class q{constructor(V,W){this.e=V,this.f=W,this.d=new t.$tlc("WorkspaceSymbols")}async provideWorkspaceSymbols(V,W){const J=await this.e.provideWorkspaceSymbols(V,W);if(!(0,h.$Lb)(J))return{symbols:[]};const Z=this.d.add(J),de={cacheId:Z,symbols:[]};for(let we=0;we<J.length;we++){const Fe=J[we];if(!Fe||!Fe.name){this.f.warn("INVALID SymbolInformation",Fe);continue}de.symbols.push({...i.WorkspaceSymbol.from(Fe),cacheId:[Z,we]})}return de}async resolveWorkspaceSymbol(V,W){if(typeof this.e.resolveWorkspaceSymbol!="function"||!V.cacheId)return V;const J=this.d.get(...V.cacheId);if(J){const Z=await this.e.resolveWorkspaceSymbol(J,W);return Z&&(0,$.$6n)(V,i.WorkspaceSymbol.from(Z),!0)}}releaseWorkspaceSymbols(V){this.d.delete(V)}}class G{static supportsResolving(V){return typeof V.prepareRename=="function"}constructor(V,W,J){this.d=V,this.e=W,this.f=J}async provideRenameEdits(V,W,J,Z){const de=this.d.getDocument(V),we=i.Position.to(W);try{const Fe=await this.e.provideRenameEdits(de,we,J,Z);return Fe?i.WorkspaceEdit.from(Fe):void 0}catch(Fe){const Ve=G.g(Fe);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(Fe)}}async resolveRenameLocation(V,W,J){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Z=this.d.getDocument(V),de=i.Position.to(W);try{const we=await this.e.prepareRename(Z,de,J);let Fe,Ve;if(u.$hM.isRange(we)?(Fe=we,Ve=Z.getText(we)):(0,I.$$f)(we)&&(Fe=we.range,Ve=we.placeholder),!Fe||!Ve)return;if(Fe.start.line>de.line||Fe.end.line<de.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Fe),text:Ve}}catch(we){const Fe=G.g(we);return Fe?{rejectReason:Fe,range:void 0,text:void 0}:Promise.reject(we)}}static g(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class x{static{this.d={[l.NewSymbolNameTriggerKind.Invoke]:u.NewSymbolNameTriggerKind.Invoke,[l.NewSymbolNameTriggerKind.Automatic]:u.NewSymbolNameTriggerKind.Automatic}}constructor(V,W,J){this.e=V,this.f=W,this.g=J}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(V,W,J,Z){const de=this.e.getDocument(V),we=i.Range.to(W);try{const Fe=x.d[J],Ve=await this.f.provideNewSymbolNames(de,we,Fe,Z);return Ve?Ve.map(Ge=>typeof Ge=="string"?{newSymbolName:Ge}:{newSymbolName:Ge.newSymbolName,tags:Ge.tags}):void 0}catch(Fe){this.g.error(x.h(Fe)??JSON.stringify(Fe,null,"	"));return}}static h(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class ne{constructor(V,W){this.resultId=V,this.tokens=W}}class be{constructor(V,W){this.f=V,this.g=W,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(V,W,J){const Z=this.f.getDocument(V),de=W!==0?this.d.get(W):null;let we=typeof de?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Z,de.resultId,J):await this.g.provideDocumentSemanticTokens(Z,J);return de&&this.d.delete(W),we?(we=be.h(we),this.o(be.n(de,we),we)):null}async releaseDocumentSemanticColoring(V){this.d.delete(V)}static h(V){return be.j(V)?be.k(V)?V:new u.$AN(new Uint32Array(V.data),V.resultId):be.l(V)?be.m(V)?V:new u.$CN(V.edits.map(W=>new u.$BN(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),V.resultId):V}static j(V){return V&&!!V.data}static k(V){return V.data instanceof Uint32Array}static l(V){return V&&Array.isArray(V.edits)}static m(V){for(const W of V.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static n(V,W){if(!be.j(W)||!V||!V.tokens)return W;const J=V.tokens,Z=J.length,de=W.data,we=de.length;let Fe=0;const Ve=Math.min(Z,we);for(;Fe<Ve&&J[Fe]===de[Fe];)Fe++;if(Fe===Z&&Fe===we)return new u.$CN([],W.resultId);let Ge=0;const tt=Ve-Fe;for(;Ge<tt&&J[Z-Ge-1]===de[we-Ge-1];)Ge++;return new u.$CN([{start:Fe,deleteCount:Z-Fe-Ge,data:de.subarray(Fe,we-Ge)}],W.resultId)}o(V,W){if(be.j(V)){const J=this.e++;return this.d.set(J,new ne(V.resultId,V.data)),(0,d.$hbb)({id:J,type:"full",data:V.data})}if(be.l(V)){const J=this.e++;return be.j(W)?this.d.set(J,new ne(W.resultId,W.data)):this.d.set(J,new ne(V.resultId)),(0,d.$hbb)({id:J,type:"delta",deltas:(V.edits||[]).map(Z=>({start:Z.start,deleteCount:Z.deleteCount,data:Z.data}))})}return null}}class ae{constructor(V,W){this.d=V,this.e=W}async provideDocumentRangeSemanticTokens(V,W,J){const Z=this.d.getDocument(V),de=await this.e.provideDocumentRangeSemanticTokens(Z,i.Range.to(W),J);return de?this.f(de):null}f(V){return(0,d.$hbb)({id:0,type:"full",data:V.data})}}class Ie{static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}constructor(V,W,J,Z,de){this.f=V,this.g=W,this.h=J,this.j=Z,this.k=de,this.d=new t.$tlc("CompletionItem"),this.e=new Map}async provideCompletionItems(V,W,J,Z){const de=this.f.getDocument(V),we=i.Position.to(W),Fe=de.getWordRangeAtPosition(we)||new u.$hM(we,we),Ve=Fe.with({end:we}),Ge=new k.$_d,tt=await this.h.provideCompletionItems(de,we,Z,i.CompletionContext.to(J));if(!tt||Z.isCancellationRequested)return;const _e=Array.isArray(tt)?new u.$OM(tt):tt,nt=Ie.supportsResolving(this.h)?this.d.add(_e.items):this.d.add([]),rt=new b.$Tc;this.e.set(nt,rt);const it=[],ct={x:nt,b:it,a:{replace:i.Range.from(Fe),insert:i.Range.from(Ve)},c:_e.isIncomplete||void 0,d:Ge.elapsed()};for(let Oe=0;Oe<_e.items.length;Oe++){const Ee=_e.items[Oe],qe=this.l(Ee,[nt,Oe],Ve,Fe);it.push(qe)}return ct}async resolveCompletionItem(V,W){if(typeof this.h.resolveCompletionItem!="function")return;const J=this.d.get(...V);if(!J)return;const Z=this.l(J,V),de=await this.h.resolveCompletionItem(J,W);if(!de)return;const we=this.l(de,V);return(Z.h!==we.h||Z.i!==we.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Z.n!==we.n||Z.o!==we.o||!(0,$.$7n)(Z.p,we.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Z,d:we.d,c:we.c,l:we.l,h:we.h,i:we.i,n:we.n,o:we.o,p:we.p}}releaseCompletionItems(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,W,J,Z){const de=this.e.get(W[0]);if(!de)throw Error("DisposableStore is missing...");const we=this.g.toInternal(V.command,de),Fe={x:W,a:V.label,b:V.kind!==void 0?i.CompletionItemKind.from(V.kind):void 0,m:V.tags&&V.tags.map(i.CompletionItemTag.from),c:V.detail,d:typeof V.documentation>"u"?void 0:i.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters?.join(""),l:V.additionalTextEdits&&V.additionalTextEdits.map(i.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};V.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Fe.h=V.textEdit.newText):typeof V.insertText=="string"?Fe.h=V.insertText:V.insertText instanceof u.$qM&&(Fe.h=V.insertText.value,Fe.i|=4);let Ve;return V.textEdit?Ve=V.textEdit.range:V.range&&(Ve=V.range),u.$hM.isRange(Ve)?Fe.j=i.Range.from(Ve):Ve&&(!J?.isEqual(Ve.inserting)||!Z?.isEqual(Ve.replacing))&&(Fe.j={insert:i.Range.from(Ve.inserting),replace:i.Range.from(Ve.replacing)}),Fe}}class ee{async provideInlineCompletions(V,W,J,Z){}disposeCompletions(V){}handleDidShowCompletionItem(V,W,J){}handlePartialAccept(V,W,J,Z){}}class B extends ee{constructor(V,W,J,Z){super(),this.f=V,this.g=W,this.h=J,this.j=Z,this.d=new pe,this.e=(0,s.$OG)(this.f,"inlineCompletionsAdditions"),this.k={[l.InlineCompletionTriggerKind.Automatic]:u.InlineCompletionTriggerKind.Automatic,[l.InlineCompletionTriggerKind.Explicit]:u.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,s.$OG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(V,W,J,Z){const de=this.g.getDocument(V),we=i.Position.to(W),Fe=await this.h.provideInlineCompletionItems(de,we,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:i.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind]},Z);if(!Fe||Z.isCancellationRequested)return;const Ve=Array.isArray(Fe)?Fe:Fe.items,Ge=this.e?Array.isArray(Fe)?[]:Fe.commands||[]:[],tt=this.e&&!Array.isArray(Fe)?Fe.enableForwardStability:void 0;let _e;return{pid:this.d.createReferenceId({dispose(){_e?.dispose()},items:Ve}),items:Ve.map((rt,it)=>{let ct;rt.command&&(_e||(_e=new b.$Tc),ct=this.j.toInternal(rt.command,_e));const Oe=rt.insertText;return{insertText:typeof Oe=="string"?Oe:{snippet:Oe.value},filterText:rt.filterText,range:rt.range?i.Range.from(rt.range):void 0,command:ct,idx:it,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:Ge.map(rt=>(_e||(_e=new b.$Tc),this.j.toInternal(rt,_e))),suppressSuggestions:!1,enableForwardStability:tt}}disposeCompletions(V){this.d.disposeReferenceId(V)?.dispose()}handleDidShowCompletionItem(V,W,J){const Z=this.d.get(V)?.items[W];Z&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Z,J)}handlePartialAccept(V,W,J,Z){const de=this.d.get(V)?.items[W];de&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(de,J),this.h.handleDidPartiallyAcceptCompletionItem(de,i.PartialAcceptInfo.to(Z)))}}class _{async provideInlineEdits(V,W,J){const Z=this.f.getDocument(V),de=await this.g.provideInlineEdit(Z,{triggerKind:this.e[W.triggerKind]},J);if(!de||J.isCancellationRequested)return;let we;const Fe=this.d.createReferenceId({dispose(){we?.dispose()},item:de});let Ve;de.accepted&&(we||(we=new b.$Tc),Ve=this.h.toInternal(de.accepted,we));let Ge;return de.rejected&&(we||(we=new b.$Tc),Ge=this.h.toInternal(de.rejected,we)),{pid:Fe,text:de.text,range:i.Range.from(de.range),accepted:Ve,rejected:Ge}}disposeEdit(V){this.d.disposeReferenceId(V)?.dispose()}constructor(V,W,J,Z){this.f=W,this.g=J,this.h=Z,this.d=new pe,this.e={[l.InlineEditTriggerKind.Automatic]:u.InlineEditTriggerKind.Automatic,[l.InlineEditTriggerKind.Invoke]:u.InlineEditTriggerKind.Invoke}}}class pe{constructor(){this.d=new Map,this.e=1}createReferenceId(V){const W=this.e++;return this.d.set(W,V),W}disposeReferenceId(V){const W=this.d.get(V);return this.d.delete(V),W}get(V){return this.d.get(V)}}class ue{constructor(V,W){this.e=V,this.f=W,this.d=new t.$tlc("SignatureHelp")}async provideSignatureHelp(V,W,J,Z){const de=this.e.getDocument(V),we=i.Position.to(W),Fe=this.g(J),Ve=await this.f.provideSignatureHelp(de,we,Z,Fe);if(Ve){const Ge=this.d.add([Ve]);return{...i.SignatureHelp.from(Ve),id:Ge}}}g(V){let W;if(V.activeSignatureHelp){const J=i.SignatureHelp.to(V.activeSignatureHelp),Z=this.d.get(V.activeSignatureHelp.id,0);Z?(W=Z,W.activeSignature=J.activeSignature,W.activeParameter=J.activeParameter):W=J}return{...V,activeSignatureHelp:W}}releaseSignatureHelp(V){this.d.delete(V)}}class ce{constructor(V,W,J,Z,de){this.f=V,this.g=W,this.h=J,this.j=Z,this.k=de,this.d=new t.$tlc("InlayHints"),this.e=new Map}async provideInlayHints(V,W,J){const Z=this.f.getDocument(V),de=i.Range.to(W),we=await this.h.provideInlayHints(Z,de,J);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(W)}`);return}if(J.isCancellationRequested)return;const Fe=this.d.add(we);this.e.set(Fe,new b.$Tc);const Ve={hints:[],cacheId:Fe};for(let Ge=0;Ge<we.length;Ge++)this.l(we[Ge],de)&&Ve.hints.push(this.m(we[Ge],[Fe,Ge]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(W)}`),Ve}async resolveInlayHint(V,W){if(typeof this.h.resolveInlayHint!="function")return;const J=this.d.get(...V);if(!J)return;const Z=await this.h.resolveInlayHint(J,W);if(Z&&this.l(Z))return this.m(Z,V)}releaseHints(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,W){return V.label.length===0||Array.isArray(V.label)&&V.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",V),!1):!(W&&!W.contains(V.position))}m(V,W){const J=this.e.get(W[0]);if(!J)throw Error("DisposableStore is missing...");const Z={label:"",cacheId:W,tooltip:i.MarkdownString.fromStrict(V.tooltip),position:i.Position.from(V.position),textEdits:V.textEdits&&V.textEdits.map(i.TextEdit.from),kind:V.kind&&i.InlayHintKind.from(V.kind),paddingLeft:V.paddingLeft,paddingRight:V.paddingRight};if(typeof V.label=="string")Z.label=V.label;else{const de=[];Z.label=de;for(const we of V.label){if(!we.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Fe={label:we.value,tooltip:i.MarkdownString.fromStrict(we.tooltip)};u.$rM.isLocation(we.location)&&(Fe.location=i.location.from(we.location)),we.command&&(Fe.command=this.g.toInternal(we.command,J)),de.push(Fe)}}return Z}}class oe{constructor(V,W){this.e=V,this.f=W,this.d=new t.$tlc("DocumentLink")}async provideLinks(V,W){const J=this.e.getDocument(V),Z=await this.f.provideDocumentLinks(J,W);if(!(!Array.isArray(Z)||Z.length===0)&&!W.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Z.filter(oe.g).map(i.DocumentLink.from)};{const de=this.d.add(Z),we={links:[],cacheId:de};for(let Fe=0;Fe<Z.length;Fe++){if(!oe.g(Z[Fe]))continue;const Ve=i.DocumentLink.from(Z[Fe]);Ve.cacheId=[de,Fe],we.links.push(Ve)}return we}}}static g(V){return V.target&&V.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(V,W){if(typeof this.f.resolveDocumentLink!="function")return;const J=this.d.get(...V);if(!J)return;const Z=await this.f.resolveDocumentLink(J,W);if(!(!Z||!oe.g(Z)))return i.DocumentLink.from(Z)}releaseLinks(V){this.d.delete(V)}}class le{constructor(V,W){this.d=V,this.e=W}async provideColors(V,W){const J=this.d.getDocument(V),Z=await this.e.provideDocumentColors(J,W);return Array.isArray(Z)?Z.map(we=>({color:i.Color.from(we.color),range:i.Range.from(we.range)})):[]}async provideColorPresentations(V,W,J){const Z=this.d.getDocument(V),de=i.Range.to(W.range),we=i.Color.to(W.color),Fe=await this.e.provideColorPresentations(we,{document:Z,range:de},J);if(Array.isArray(Fe))return Fe.map(i.ColorPresentation.from)}}class K{constructor(V,W){this.d=V,this.e=W}async provideFoldingRanges(V,W,J){const Z=this.d.getDocument(V),de=await this.e.provideFoldingRanges(Z,W,J);if(Array.isArray(de))return de.map(i.FoldingRange.from)}}class se{constructor(V,W,J){this.d=V,this.e=W,this.f=J}async provideSelectionRanges(V,W,J){const Z=this.d.getDocument(V),de=W.map(i.Position.to),we=await this.e.provideSelectionRanges(Z,de,J);if(!(0,h.$Lb)(we))return[];if(we.length!==de.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Fe=[];for(let Ve=0;Ve<de.length;Ve++){const Ge=[];Fe.push(Ge);let tt=de[Ve],_e=we[Ve];for(;;){if(!_e.range.contains(tt))throw new Error("INVALID selection range, must contain the previous range");if(Ge.push(i.SelectionRange.from(_e)),!_e.parent)break;tt=_e.range,_e=_e.parent}}return Fe}}class $e{constructor(V,W){this.f=V,this.g=W,this.d=new M.$JO(""),this.e=new Map}async prepareSession(V,W,J){const Z=this.f.getDocument(V),de=i.Position.to(W),we=await this.g.prepareCallHierarchy(Z,de,J);if(!we)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(we)?we.map(Ve=>this.h(Fe,Ve)):[this.h(Fe,we)]}async provideCallsTo(V,W,J){const Z=this.j(V,W);if(!Z)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyIncomingCalls(Z,J);if(de)return de.map(we=>({from:this.h(V,we.from),fromRanges:we.fromRanges.map(Fe=>i.Range.from(Fe))}))}async provideCallsFrom(V,W,J){const Z=this.j(V,W);if(!Z)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyOutgoingCalls(Z,J);if(de)return de.map(we=>({to:this.h(V,we.to),fromRanges:we.fromRanges.map(Fe=>i.Range.from(Fe))}))}releaseSession(V){this.e.delete(V)}h(V,W){const J=this.e.get(V),Z=i.CallHierarchyItem.from(W,V,J.size.toString(36));return J.set(Z._itemId,W),Z}j(V,W){return this.e.get(V)?.get(W)}}class ve{constructor(V,W){this.f=V,this.g=W,this.d=new M.$JO(""),this.e=new Map}async prepareSession(V,W,J){const Z=this.f.getDocument(V),de=i.Position.to(W),we=await this.g.prepareTypeHierarchy(Z,de,J);if(!we)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(we)?we.map(Ve=>this.h(Fe,Ve)):[this.h(Fe,we)]}async provideSupertypes(V,W,J){const Z=this.j(V,W);if(!Z)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySupertypes(Z,J);if(de)return de.map(we=>this.h(V,we))}async provideSubtypes(V,W,J){const Z=this.j(V,W);if(!Z)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySubtypes(Z,J);if(de)return de.map(we=>this.h(V,we))}releaseSession(V){this.e.delete(V)}h(V,W){const J=this.e.get(V),Z=i.TypeHierarchyItem.from(W,V,J.size.toString(36));return J.set(Z._itemId,W),Z}j(V,W){return this.e.get(V)?.get(W)}}class Me{constructor(V,W,J,Z,de){this.e=V,this.f=W,this.g=J,this.h=Z,this.j=de,this.d=new t.$tlc("DocumentDropEdit")}async provideDocumentOnDropEdits(V,W,J,Z,de){const we=this.f.getDocument(W),Fe=i.Position.to(J),Ve=i.DataTransfer.toDataTransfer(Z,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,V,nt)).buffer),Ge=await this.g.provideDocumentDropEdits(we,Fe,Ve,de);if(!Ge)return;const tt=(0,h.$2b)(Ge),_e=this.d.add(tt);return tt.map((nt,rt)=>({_cacheId:[_e,rt],title:nt.title??(0,o.localize)(1,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(it=>it.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(V,W){const[J,Z]=V,de=this.d.get(J,Z);if(!de||!this.g.resolveDocumentDropEdit)return{};const we=await this.g.resolveDocumentDropEdit(de,W)??de;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releaseDropEdits(V){this.d.delete(V)}}class ge{constructor(V,W){this.d=V,this.e=W}async provideMappedEdits(V,W,J,Z){const de=p.URI.revive(V),we=this.d.getDocument(de),Fe=J.documents.map(tt=>tt.map(_e=>({uri:p.URI.revive(_e.uri),version:_e.version,ranges:_e.ranges.map(nt=>i.Range.to(nt))}))),Ve={documents:Fe,selections:Fe[0]?.[0]?.ranges??[]},Ge=await this.e.provideMappedEdits(we,W,Ve,Z);return Ge?i.WorkspaceEdit.from(Ge):null}}class Ae{constructor(V,W){this.adapter=V,this.extension=W}}class Re{static{this.d=0}constructor(V,W,J,Z,de,we,Fe,Ve){this.g=W,this.h=J,this.j=Z,this.k=de,this.l=we,this.m=Fe,this.n=Ve,this.f=new Map,this.e=V.getProxy(c.$dM.MainThreadLanguageFeatures)}o(V,W){return i.DocumentSelector.from(V,this.g,W)}p(V){return new u.$fM(()=>{this.f.delete(V),this.e.$unregister(V)})}q(){return Re.d++}async s(V,W,J,Z,de,we=!1){const Fe=this.f.get(V);if(!Fe||!(Fe.adapter instanceof W))return Z;const Ve=Date.now();we||this.l.trace(`[${Fe.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const Ge=J(Fe.adapter,Fe.extension);return Promise.resolve(Ge).catch(tt=>{(0,R.$4)(tt)||(this.l.error(`[${Fe.extension.identifier.value}] provider FAILED`),this.l.error(tt),this.n.onExtensionError(Fe.extension.identifier,tt))}).finally(()=>{we||this.l.trace(`[${Fe.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),O.CancellationToken.isCancellationToken(de)?(0,N.$lh)(Ge,de):Ge}t(V,W){const J=this.q();return this.f.set(J,new Ae(V,W)),J}static u(V){return V.displayName||V.name}registerDocumentSymbolProvider(V,W,J,Z){const de=this.t(new r(this.h,J),V),we=Z&&Z.label||Re.u(V);return this.e.$registerDocumentSymbolProvider(de,this.o(W,V),we),this.p(de)}$provideDocumentSymbols(V,W,J){return this.s(V,r,Z=>Z.provideDocumentSymbols(p.URI.revive(W),J),void 0,J)}registerCodeLensProvider(V,W,J){const Z=this.q(),de=typeof J.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Z,new Ae(new a(this.h,this.j.converter,J,V,this.n,this.l),V)),this.e.$registerCodeLensSupport(Z,this.o(W,V),de);let we=this.p(Z);if(de!==void 0){const Fe=J.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent(de));we=u.$fM.from(we,Fe)}return we}$provideCodeLenses(V,W,J){return this.s(V,a,Z=>Z.provideCodeLenses(p.URI.revive(W),J),void 0,J)}$resolveCodeLens(V,W,J){return this.s(V,a,Z=>Z.resolveCodeLens(W,J),void 0,void 0)}$releaseCodeLenses(V,W){this.s(V,a,J=>Promise.resolve(J.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(V,W,J){const Z=this.t(new g(this.h,J),V);return this.e.$registerDefinitionSupport(Z,this.o(W,V)),this.p(Z)}$provideDefinition(V,W,J,Z){return this.s(V,g,de=>de.provideDefinition(p.URI.revive(W),J,Z),[],Z)}registerDeclarationProvider(V,W,J){const Z=this.t(new w(this.h,J),V);return this.e.$registerDeclarationSupport(Z,this.o(W,V)),this.p(Z)}$provideDeclaration(V,W,J,Z){return this.s(V,w,de=>de.provideDeclaration(p.URI.revive(W),J,Z),[],Z)}registerImplementationProvider(V,W,J){const Z=this.t(new S(this.h,J),V);return this.e.$registerImplementationSupport(Z,this.o(W,V)),this.p(Z)}$provideImplementation(V,W,J,Z){return this.s(V,S,de=>de.provideImplementation(p.URI.revive(W),J,Z),[],Z)}registerTypeDefinitionProvider(V,W,J){const Z=this.t(new m(this.h,J),V);return this.e.$registerTypeDefinitionSupport(Z,this.o(W,V)),this.p(Z)}$provideTypeDefinition(V,W,J,Z){return this.s(V,m,de=>de.provideTypeDefinition(p.URI.revive(W),J,Z),[],Z)}registerHoverProvider(V,W,J,Z){const de=this.t(new E(this.h,J),V);return this.e.$registerHoverProvider(de,this.o(W,V)),this.p(de)}$provideHover(V,W,J,Z,de){return this.s(V,E,we=>we.provideHover(p.URI.revive(W),J,Z,de),void 0,de)}$releaseHover(V,W){this.s(V,E,J=>Promise.resolve(J.releaseHover(W)),void 0,void 0)}registerEvaluatableExpressionProvider(V,W,J,Z){const de=this.t(new D(this.h,J),V);return this.e.$registerEvaluatableExpressionProvider(de,this.o(W,V)),this.p(de)}$provideEvaluatableExpression(V,W,J,Z){return this.s(V,D,de=>de.provideEvaluatableExpression(p.URI.revive(W),J,Z),void 0,Z)}registerInlineValuesProvider(V,W,J,Z){const de=typeof J.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new C(this.h,J),V);this.e.$registerInlineValuesProvider(we,this.o(W,V),de);let Fe=this.p(we);if(de!==void 0){const Ve=J.onDidChangeInlineValues(Ge=>this.e.$emitInlineValuesEvent(de));Fe=u.$fM.from(Fe,Ve)}return Fe}$provideInlineValues(V,W,J,Z,de){return this.s(V,C,we=>we.provideInlineValues(p.URI.revive(W),J,Z,de),void 0,de)}registerDocumentHighlightProvider(V,W,J){const Z=this.t(new P(this.h,J),V);return this.e.$registerDocumentHighlightProvider(Z,this.o(W,V)),this.p(Z)}registerMultiDocumentHighlightProvider(V,W,J){const Z=this.t(new F(this.h,J),V);return this.e.$registerMultiDocumentHighlightProvider(Z,this.o(W,V)),this.p(Z)}$provideDocumentHighlights(V,W,J,Z){return this.s(V,P,de=>de.provideDocumentHighlights(p.URI.revive(W),J,Z),void 0,Z)}$provideMultiDocumentHighlights(V,W,J,Z,de){return this.s(V,F,we=>we.provideMultiDocumentHighlights(p.URI.revive(W),J,Z.map(Fe=>p.URI.revive(Fe)),de),void 0,de)}registerLinkedEditingRangeProvider(V,W,J){const Z=this.t(new T(this.h,J),V);return this.e.$registerLinkedEditingRangeProvider(Z,this.o(W,V)),this.p(Z)}$provideLinkedEditingRanges(V,W,J,Z){return this.s(V,T,async de=>{const we=await de.provideLinkedEditingRanges(p.URI.revive(W),J,Z);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?Re.w(we.wordPattern):void 0}},void 0,Z)}registerReferenceProvider(V,W,J){const Z=this.t(new z(this.h,J),V);return this.e.$registerReferenceSupport(Z,this.o(W,V)),this.p(Z)}$provideReferences(V,W,J,Z,de){return this.s(V,z,we=>we.provideReferences(p.URI.revive(W),J,Z,de),void 0,de)}registerCodeActionProvider(V,W,J,Z){const de=new b.$Tc,we=this.t(new L(this.h,this.j.converter,this.k,J,this.l,V,this.m),V);return this.e.$registerQuickFixSupport(we,this.o(W,V),{providedKinds:Z?.providedCodeActionKinds?.map(Fe=>Fe.value),documentation:Z?.documentation?.map(Fe=>({kind:Fe.kind.value,command:this.j.converter.toInternal(Fe.command,de)}))},Re.u(V),!!J.resolveCodeAction),de.add(this.p(we)),de}$provideCodeActions(V,W,J,Z,de){return this.s(V,L,we=>we.provideCodeActions(p.URI.revive(W),J,Z,de),void 0,de)}$resolveCodeAction(V,W,J){return this.s(V,L,Z=>Z.resolveCodeAction(W,J),{},void 0)}$releaseCodeActions(V,W){this.s(V,L,J=>Promise.resolve(J.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(V,W,J){const Z=this.t(new U(this.h,J),V);return this.e.$registerDocumentFormattingSupport(Z,this.o(W,V),V.identifier,V.displayName||V.name),this.p(Z)}$provideDocumentFormattingEdits(V,W,J,Z){return this.s(V,U,de=>de.provideDocumentFormattingEdits(p.URI.revive(W),J,Z),void 0,Z)}registerDocumentRangeFormattingEditProvider(V,W,J){const Z=typeof J.provideDocumentRangesFormattingEdits=="function",de=this.t(new X(this.h,J),V);return this.e.$registerRangeFormattingSupport(de,this.o(W,V),V.identifier,V.displayName||V.name,Z),this.p(de)}$provideDocumentRangeFormattingEdits(V,W,J,Z,de){return this.s(V,X,we=>we.provideDocumentRangeFormattingEdits(p.URI.revive(W),J,Z,de),void 0,de)}$provideDocumentRangesFormattingEdits(V,W,J,Z,de){return this.s(V,X,we=>we.provideDocumentRangesFormattingEdits(p.URI.revive(W),J,Z,de),void 0,de)}registerOnTypeFormattingEditProvider(V,W,J,Z){const de=this.t(new ie(this.h,J),V);return this.e.$registerOnTypeFormattingSupport(de,this.o(W,V),Z,V.identifier),this.p(de)}$provideOnTypeFormattingEdits(V,W,J,Z,de,we){return this.s(V,ie,Fe=>Fe.provideOnTypeFormattingEdits(p.URI.revive(W),J,Z,de,we),void 0,we)}registerWorkspaceSymbolProvider(V,W){const J=this.t(new q(W,this.l),V);return this.e.$registerNavigateTypeSupport(J,typeof W.resolveWorkspaceSymbol=="function"),this.p(J)}$provideWorkspaceSymbols(V,W,J){return this.s(V,q,Z=>Z.provideWorkspaceSymbols(W,J),{symbols:[]},J)}$resolveWorkspaceSymbol(V,W,J){return this.s(V,q,Z=>Z.resolveWorkspaceSymbol(W,J),void 0,void 0)}$releaseWorkspaceSymbols(V,W){this.s(V,q,J=>J.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(V,W,J){const Z=this.t(new G(this.h,J,this.l),V);return this.e.$registerRenameSupport(Z,this.o(W,V),G.supportsResolving(J)),this.p(Z)}$provideRenameEdits(V,W,J,Z,de){return this.s(V,G,we=>we.provideRenameEdits(p.URI.revive(W),J,Z,de),void 0,de)}$resolveRenameLocation(V,W,J,Z){return this.s(V,G,de=>de.resolveRenameLocation(p.URI.revive(W),J,Z),void 0,Z)}registerNewSymbolNamesProvider(V,W,J){const Z=this.t(new x(this.h,J,this.l),V);return this.e.$registerNewSymbolNamesProvider(Z,this.o(W,V)),this.p(Z)}$supportsAutomaticNewSymbolNamesTriggerKind(V){return this.s(V,x,W=>W.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(V,W,J,Z,de){return this.s(V,x,we=>we.provideNewSymbolNames(p.URI.revive(W),J,Z,de),void 0,de)}registerDocumentSemanticTokensProvider(V,W,J,Z){const de=this.t(new be(this.h,J),V),we=typeof J.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(de,this.o(W,V),Z,we);let Fe=this.p(de);if(we){const Ve=J.onDidChangeSemanticTokens(Ge=>this.e.$emitDocumentSemanticTokensEvent(we));Fe=u.$fM.from(Fe,Ve)}return Fe}$provideDocumentSemanticTokens(V,W,J,Z){return this.s(V,be,de=>de.provideDocumentSemanticTokens(p.URI.revive(W),J,Z),null,Z)}$releaseDocumentSemanticTokens(V,W){this.s(V,be,J=>J.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(V,W,J,Z){const de=this.t(new ae(this.h,J),V);return this.e.$registerDocumentRangeSemanticTokensProvider(de,this.o(W,V),Z),this.p(de)}$provideDocumentRangeSemanticTokens(V,W,J,Z){return this.s(V,ae,de=>de.provideDocumentRangeSemanticTokens(p.URI.revive(W),J,Z),null,Z)}registerCompletionItemProvider(V,W,J,Z){const de=this.t(new Ie(this.h,this.j.converter,J,this.m,V),V);return this.e.$registerCompletionsProvider(de,this.o(W,V),Z,Ie.supportsResolving(J),V.identifier),this.p(de)}$provideCompletionItems(V,W,J,Z,de){return this.s(V,Ie,we=>we.provideCompletionItems(p.URI.revive(W),J,Z,de),void 0,de)}$resolveCompletionItem(V,W,J){return this.s(V,Ie,Z=>Z.resolveCompletionItem(W,J),void 0,J)}$releaseCompletionItems(V,W){this.s(V,Ie,J=>J.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(V,W,J,Z){const de=new B(V,this.h,J,this.j.converter),we=this.t(de,V);return this.e.$registerInlineCompletionsSupport(we,this.o(W,V),de.supportsHandleEvents,n.$Rm.toKey(V.identifier.value),Z?.yieldTo?.map(Fe=>n.$Rm.toKey(Fe))||[]),this.p(we)}$provideInlineCompletions(V,W,J,Z,de){return this.s(V,ee,we=>we.provideInlineCompletions(p.URI.revive(W),J,Z,de),void 0,de)}$handleInlineCompletionDidShow(V,W,J,Z){this.s(V,ee,async de=>{de.handleDidShowCompletionItem(W,J,Z)},void 0,void 0)}$handleInlineCompletionPartialAccept(V,W,J,Z,de){this.s(V,ee,async we=>{we.handlePartialAccept(W,J,Z,de)},void 0,void 0)}$freeInlineCompletionsList(V,W){this.s(V,ee,async J=>{J.disposeCompletions(W)},void 0,void 0)}registerInlineEditProvider(V,W,J){const Z=new _(V,this.h,J,this.j.converter),de=this.t(Z,V);return this.e.$registerInlineEditProvider(de,this.o(W,V),V.identifier),this.p(de)}$provideInlineEdit(V,W,J,Z){return this.s(V,_,de=>de.provideInlineEdits(p.URI.revive(W),J,Z),void 0,Z)}$freeInlineEdit(V,W){this.s(V,_,async J=>{J.disposeEdit(W)},void 0,void 0)}registerSignatureHelpProvider(V,W,J,Z){const de=Array.isArray(Z)?{triggerCharacters:Z,retriggerCharacters:[]}:Z,we=this.t(new ue(this.h,J),V);return this.e.$registerSignatureHelpProvider(we,this.o(W,V),de),this.p(we)}$provideSignatureHelp(V,W,J,Z,de){return this.s(V,ue,we=>we.provideSignatureHelp(p.URI.revive(W),J,Z,de),void 0,de)}$releaseSignatureHelp(V,W){this.s(V,ue,J=>J.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(V,W,J){const Z=typeof J.onDidChangeInlayHints=="function"?this.q():void 0,de=this.t(new ce(this.h,this.j.converter,J,this.l,V),V);this.e.$registerInlayHintsProvider(de,this.o(W,V),typeof J.resolveInlayHint=="function",Z,Re.u(V));let we=this.p(de);if(Z!==void 0){const Fe=J.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(Z));we=u.$fM.from(we,Fe)}return we}$provideInlayHints(V,W,J,Z){return this.s(V,ce,de=>de.provideInlayHints(p.URI.revive(W),J,Z),void 0,Z)}$resolveInlayHint(V,W,J){return this.s(V,ce,Z=>Z.resolveInlayHint(W,J),void 0,J)}$releaseInlayHints(V,W){this.s(V,ce,J=>J.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(V,W,J){const Z=this.t(new oe(this.h,J),V);return this.e.$registerDocumentLinkProvider(Z,this.o(W,V),typeof J.resolveDocumentLink=="function"),this.p(Z)}$provideDocumentLinks(V,W,J){return this.s(V,oe,Z=>Z.provideLinks(p.URI.revive(W),J),void 0,J,W.scheme==="output")}$resolveDocumentLink(V,W,J){return this.s(V,oe,Z=>Z.resolveLink(W,J),void 0,void 0,!0)}$releaseDocumentLinks(V,W){this.s(V,oe,J=>J.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(V,W,J){const Z=this.t(new le(this.h,J),V);return this.e.$registerDocumentColorProvider(Z,this.o(W,V)),this.p(Z)}$provideDocumentColors(V,W,J){return this.s(V,le,Z=>Z.provideColors(p.URI.revive(W),J),[],J)}$provideColorPresentations(V,W,J,Z){return this.s(V,le,de=>de.provideColorPresentations(p.URI.revive(W),J,Z),void 0,Z)}registerFoldingRangeProvider(V,W,J){const Z=this.q(),de=typeof J.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Z,new Ae(new K(this.h,J),V)),this.e.$registerFoldingRangeProvider(Z,this.o(W,V),V.identifier,de);let we=this.p(Z);if(de!==void 0){const Fe=J.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(de));we=u.$fM.from(we,Fe)}return we}$provideFoldingRanges(V,W,J,Z){return this.s(V,K,de=>de.provideFoldingRanges(p.URI.revive(W),J,Z),void 0,Z)}registerSelectionRangeProvider(V,W,J){const Z=this.t(new se(this.h,J,this.l),V);return this.e.$registerSelectionRangeProvider(Z,this.o(W,V)),this.p(Z)}$provideSelectionRanges(V,W,J,Z){return this.s(V,se,de=>de.provideSelectionRanges(p.URI.revive(W),J,Z),[],Z)}registerCallHierarchyProvider(V,W,J){const Z=this.t(new $e(this.h,J),V);return this.e.$registerCallHierarchyProvider(Z,this.o(W,V)),this.p(Z)}$prepareCallHierarchy(V,W,J,Z){return this.s(V,$e,de=>Promise.resolve(de.prepareSession(p.URI.revive(W),J,Z)),void 0,Z)}$provideCallHierarchyIncomingCalls(V,W,J,Z){return this.s(V,$e,de=>de.provideCallsTo(W,J,Z),void 0,Z)}$provideCallHierarchyOutgoingCalls(V,W,J,Z){return this.s(V,$e,de=>de.provideCallsFrom(W,J,Z),void 0,Z)}$releaseCallHierarchy(V,W){this.s(V,$e,J=>Promise.resolve(J.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(V,W,J){const Z=this.t(new ve(this.h,J),V);return this.e.$registerTypeHierarchyProvider(Z,this.o(W,V)),this.p(Z)}$prepareTypeHierarchy(V,W,J,Z){return this.s(V,ve,de=>Promise.resolve(de.prepareSession(p.URI.revive(W),J,Z)),void 0,Z)}$provideTypeHierarchySupertypes(V,W,J,Z){return this.s(V,ve,de=>de.provideSupertypes(W,J,Z),void 0,Z)}$provideTypeHierarchySubtypes(V,W,J,Z){return this.s(V,ve,de=>de.provideSubtypes(W,J,Z),void 0,Z)}$releaseTypeHierarchy(V,W){this.s(V,ve,J=>Promise.resolve(J.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(V,W,J,Z){const de=this.q();return this.f.set(de,new Ae(new Me(this.e,this.h,J,de,V),V)),this.e.$registerDocumentOnDropEditProvider(de,this.o(W,V),(0,s.$OG)(V,"documentPaste")&&Z?{supportsResolve:!!J.resolveDocumentDropEdit,dropMimeTypes:Z.dropMimeTypes}:void 0),this.p(de)}$provideDocumentOnDropEdits(V,W,J,Z,de,we){return this.s(V,Me,Fe=>Promise.resolve(Fe.provideDocumentOnDropEdits(W,p.URI.revive(J),Z,de,we)),void 0,void 0)}$resolveDropEdit(V,W,J){return this.s(V,Me,Z=>Z.resolveDropEdit(W,J),{},void 0)}$releaseDropEdits(V,W){this.s(V,Me,J=>Promise.resolve(J.releaseDropEdits(W)),void 0,void 0)}registerMappedEditsProvider(V,W,J){const Z=this.t(new ge(this.h,J),V);return this.e.$registerMappedEditsProvider(Z,this.o(W,V)),this.p(Z)}$provideMappedEdits(V,W,J,Z,de){return this.s(V,ge,we=>Promise.resolve(we.provideMappedEdits(W,J,Z,de)),null,de)}registerDocumentPasteEditProvider(V,W,J,Z){const de=this.q();return this.f.set(de,new Ae(new j(this.e,this.h,J,de,V),V)),this.e.$registerPasteEditProvider(de,this.o(W,V),{supportsCopy:!!J.prepareDocumentPaste,supportsPaste:!!J.provideDocumentPasteEdits,supportsResolve:!!J.resolveDocumentPasteEdit,providedPasteEditKinds:Z.providedPasteEditKinds?.map(we=>we.value),copyMimeTypes:Z.copyMimeTypes,pasteMimeTypes:Z.pasteMimeTypes}),this.p(de)}$prepareDocumentPaste(V,W,J,Z,de){return this.s(V,j,we=>we.prepareDocumentPaste(p.URI.revive(W),J,Z,de),void 0,de)}$providePasteEdits(V,W,J,Z,de,we,Fe){return this.s(V,j,Ve=>Ve.providePasteEdits(W,p.URI.revive(J),Z,de,we,Fe),void 0,Fe)}$resolvePasteEdit(V,W,J){return this.s(V,j,Z=>Z.resolvePasteEdit(W,J),{},void 0)}$releasePasteEdits(V,W){this.s(V,j,J=>Promise.resolve(J.releasePasteEdits(W)),void 0,void 0)}static w(V){return{pattern:V.source,flags:V.flags}}static y(V){return{decreaseIndentPattern:Re.w(V.decreaseIndentPattern),increaseIndentPattern:Re.w(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?Re.w(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?Re.w(V.unIndentedLinePattern):void 0}}static z(V){return{beforeText:Re.w(V.beforeText),afterText:V.afterText?Re.w(V.afterText):void 0,previousLineText:V.previousLineText?Re.w(V.previousLineText):void 0,action:V.action}}static B(V){return V.map(Re.z)}static C(V){return{open:V.open,close:V.close,notIn:V.notIn?V.notIn.map(W=>u.SyntaxTokenType.toString(W)):void 0}}static D(V){return V.map(Re.C)}setLanguageConfiguration(V,W,J){const{wordPattern:Z}=J;if(Z&&(0,A.$jf)(Z))throw new Error(`Invalid language configuration: wordPattern '${Z}' is not allowed to match the empty string.`);Z?this.h.setWordDefinitionFor(W,Z):this.h.setWordDefinitionFor(W,void 0),J.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),J.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const de=this.q(),we={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?Re.w(J.wordPattern):void 0,indentationRules:J.indentationRules?Re.y(J.indentationRules):void 0,onEnterRules:J.onEnterRules?Re.B(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport,autoClosingPairs:J.autoClosingPairs?Re.D(J.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(de,W,we),this.p(de)}$setWordDefinitions(V){for(const W of V)this.h.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.$Dlc=Re}),define(Se[122],De([1,0,3,6,17,8,109,25,7,4,227,146,13,5,20,121,11,39]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d,o){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=e.$kmc=void 0,e.$kmc=(0,y.$wi)("IExtHostLanguageModels");class i{constructor(c,r){this.option=c,this.stream=new $.$Zh,this.stream=r??new $.$Zh}}class u{constructor(){this.a=new Map,this.b=new $.$Zh,this.c=!1,this.d=!1;const c=this;this.apiObject={stream:c.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,c]of this.a)yield c.stream;else yield this.b}handleFragment(c){if(this.c)return;this.d=!0;let r=this.a.get(c.index);r||(this.a.size===0?r=new i(c.index,this.b):r=new i(c.index),this.a.set(c.index,r)),r.stream.emitOne(c.part)}get isStreaming(){return this.d}reject(c){this.c=!0;for(const r of this.f())r.reject(c)}resolve(){this.c=!0;for(const c of this.f())c.resolve()}}let s=class{static{n=this}static{this.a=1}constructor(c,r,a){this.j=r,this.k=a,this.c=new k.$de,this.d=new k.$de,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new b.$Tm,this.i=new Map,this.o=new Set,this.b=c.getProxy(N.$dM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(c,r,a,f){const g=n.a++;this.f.set(g,{extension:c.identifier,provider:a,languageModelId:r});let w;f.auth&&(w={providerLabel:c.displayName||c.name,accountLabel:typeof f.auth=="object"?f.auth.label:void 0}),this.b.$registerLanguageModelProvider(g,r,{extension:c.identifier,identifier:r,name:f.name??"",version:f.version,tokens:f.tokens,auth:w});const S=a.onDidReceiveLanguageModelResponse2?.(({extensionId:m,participant:E,tokenCount:D})=>{this.b.$whenLanguageModelChatRequestMade(r,new b.$Rm(m),E,D)});return(0,h.$Sc)(()=>{this.f.delete(g),this.b.$unregisterProvider(g),S?.dispose()})}async $provideLanguageModelResponse(c,r,a,f,g,w){const S=this.f.get(c);if(!S)return;const m=new M.$dw(async E=>{if(w.isCancellationRequested){this.j.warn(`[CHAT](${S.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(r,{index:E.index,part:E.part})});return S.provider.provideLanguageModelResponse2(f.map(O.LanguageModelMessage.to),g,b.$Rm.toKey(a),m,w)}$provideTokenLength(c,r,a){const f=this.f.get(c);return f?Promise.resolve(f.provider.provideTokenCount(r,a)):Promise.resolve(0)}$updateLanguageModels(c){const r=[],a=[];if(c.added)for(const f of c.added)this.g.set(f.identifier,f),r.push(f.identifier);if(c.removed)for(const f of c.removed){this.g.delete(f),a.push(f);for(const[g,w]of this.i)w.languageModelId===f&&(w.res.reject(new p.$5),this.i.delete(g))}this.d.fire(Object.freeze({added:Object.freeze(r),removed:Object.freeze(a)})),c.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(c){const r=new Array;for(const{from:a,to:f,enabled:g}of c){const w=this.h.get(a)??new b.$Sm;if(w.has(f)!==g){g?w.add(f):w.delete(f),this.h.set(a,w);const m={from:a,to:f};r.push(m),this.c.fire(m)}}}async sendChatRequest(c,r,a,f,g){const w=c.identifier,S=await this.b.$prepareChatAccess(w,r,f.justification);if(!S||!this.g.has(r))throw R.$rO.NotFound(`Language model '${r}' is unknown.`);if(this.m(w,S)&&(!await this.l(c,{identifier:S.extension,displayName:S.auth.providerLabel},f.justification,f.silent)||!this.h.get(w)?.has(S.extension)))throw R.$rO.NoPermissions(`Language model '${r}' cannot be used by '${w.value}'.`);const m=Math.random()*1e6|0,E=this.b.$fetchResponse(w,r,m,a.map(O.LanguageModelMessage.from),f.modelOptions??{},g),D=new $.$vh,C=new u;this.i.set(m,{languageModelId:r,res:C});let P;if(E.catch(F=>{D.isOpen()?C.reject(F):P=F}).finally(()=>{this.i.delete(m),C.resolve(),D.open()}),await D.wait(),P)throw P.name===R.$rO.name?P:new R.$rO(`Language model '${r}' errored, check cause for more details`,"Unknown",P);return C.apiObject}async $handleResponseFragment(c,r){const a=this.i.get(c);a&&a.res.handleFragment(r)}async l(c,r,a,f){const g=I.$fL+r.identifier.value;if(await this.k.getSession(c,g,[],{silent:!0}))return this.$updateModelAccesslist([{from:c.identifier,to:r.identifier,enabled:!0}]),!0;if(f)return!1;try{const S=a?(0,A.localize)(0,null,r.displayName,a):(0,A.localize)(1,null,r.displayName);return await this.k.getSession(c,g,[],{forceNewSession:{detail:S}}),this.$updateModelAccesslist([{from:c.identifier,to:r.identifier,enabled:!0}]),!0}catch{return!1}}m(c,r){return!!r.auth&&!b.$Rm.equals(r.extension,c)}async n(c){for(const r of this.o)try{await this.l(r,{identifier:c.extension,displayName:""},void 0,!0)}catch(a){this.j.error("Fake Auth request failed"),this.j.error(a)}}async computeTokenLength(c,r,a){const f=this.g.get(c);if(!f)throw R.$rO.NotFound(`Language model '${c}' is unknown.`);const g=o.Iterable.find(this.f.values(),w=>w.languageModelId===c);return g?g.provider.provideTokenCount(r,a):this.b.$countTokens(f.identifier,typeof r=="string"?r:O.LanguageModelMessage.from(r),a)}getLanguageModelInfo(c){const r=this.g.get(c);if(r)return{id:r.identifier,name:r.name,version:r.version,tokens:r.tokens}}createLanguageModelAccessInformation(c){this.o.add(c);const r=this,a=k.Event.signal(k.Event.filter(this.c.event,g=>b.$Rm.equals(g.from,c.identifier))),f=k.Event.signal(this.d.event);return{get onDidChange(){return k.Event.any(a,f)},canSendRequest(g){const w=r.g.get(g);if(!w)return;if(!r.m(c.identifier,w))return!0;const S=r.h.get(c.identifier);if(S)return S.has(w.extension)}}}};e.$lmc=s,e.$lmc=s=n=He([We(0,v.$EO),We(1,d.$3j),We(2,l.$Flc)],s)}),define(Se[344],De([1,0,6,17,8,41,7,3,26]),function(he,e,h,N,O,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2mc=void 0;class k{constructor(I,p,y,v){this.c=p,this.d=y,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=I.getProxy(h.$dM.MainThreadLanguages)}$acceptLanguageIds(I){this.b=I}async getLanguages(){return this.b.slice(0)}async changeLanguage(I,p){await this.a.$changeLanguage(I,p);const y=this.c.getDocumentData(I);if(!y)throw new Error(`document '${I.toString()}' NOT found`);return y.document}async tokenAtPosition(I,p){const y=I.version,v=N.Position.from(p),l=await this.a.$tokensAtPosition(I.uri,v),d={type:O.StandardTokenType.Other,range:I.getWordRangeAtPosition(p)??new O.$hM(p.line,p.character,p.line,p.character)};if(!l)return d;const o={range:N.Range.to(l.range),type:N.TokenType.to(l.type)};return!o.range.contains(p)||y!==I.version?d:o}createLanguageStatusItem(I,p,y){const v=this.f++,l=this.a,d=this.g,o=`${I.identifier.value}/${p}`;if(d.has(o))throw new Error(`LanguageStatusItem with id '${p}' ALREADY exists`);d.add(o);const n={selector:y,id:p,name:I.displayName??I.name,severity:O.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const u=new b.$Tc,s=()=>{if(i?.dispose(),!d.has(o)){console.warn(`LanguageStatusItem (${p}) from ${I.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,M.$yh)(()=>{u.clear(),this.a.$setLanguageStatus(v,{id:o,name:n.name??I.displayName??I.name,source:I.displayName??I.name,selector:N.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===O.LanguageStatusSeverity.Error?R.default.Error:n.severity===O.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:n.command&&this.d.toInternal(n.command,u),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){u.dispose(),i?.dispose(),l.$removeLanguageStatus(v),d.delete(o)},get id(){return n.id},get name(){return n.name},set name(c){n.name=c,s()},get selector(){return n.selector},set selector(c){n.selector=c,s()},get text(){return n.text},set text(c){n.text=c,s()},set text2(c){(0,$.$PG)(I,"languageStatusText"),n.text=c,s()},get text2(){return(0,$.$PG)(I,"languageStatusText"),n.text},get detail(){return n.detail},set detail(c){n.detail=c,s()},get severity(){return n.severity},set severity(c){n.severity=c,s()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(c){n.accessibilityInformation=c,s()},get command(){return n.command},set command(c){n.command=c,s()},get busy(){return n.busy},set busy(c){n.busy=c,s()}};return s(),t}}e.$2mc=k}),define(Se[345],De([1,0,15,2,17,8,120]),function(he,e,h,N,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Omc=e.$Nmc=void 0;class b{constructor(I,p,y,v){this.start=I,this.deletedCount=p,this.deletedItems=y,this.items=v}asApiEvent(){return{range:new R.$HN(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(I){return{EOL:I.eol,lines:I.source,languageId:I.language,uri:I.uri,isDirty:!1,versionId:1}}constructor(I,p,y){this.notebook=I,this.h=p,this.j=y,this.handle=y.handle,this.uri=N.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(O.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(O.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,p=this.h.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:O.NotebookCellKind.to(this.j.cellKind),document:p.document,get mime(){return I.g},set mime(v){I.g=v},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(y)}return this.f}setOutputs(I){this.a=I.map(O.NotebookCellOutput.to)}setOutputItems(I,p,y){const v=y.map(O.NotebookCellOutputItem.to),l=this.a.find(d=>d.id===I);if(l&&(p||(l.items.length=0),l.items.push(...v),l.items.length>1&&l.items.every(d=>M.$_J(d.mime)))){const d=new Map,o=[];l.items.forEach(n=>{let i;d.has(n.mime)?i=d.get(n.mime):(i=[],d.set(n.mime,i),o.push(n.mime)),i.push(n.data)}),l.items.length=0,o.forEach(n=>{const i=M.$aK(d.get(n));l.items.push({mime:n,data:i.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(O.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$Nmc=$;class k{static{this.a=0}constructor(I,p,y,v,l){this.k=I,this.l=p,this.m=y,this.uri=v,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=l.viewType,this.f=Object.freeze(l.metadata??Object.create(null)),this.r([[0,0,l.cells]],!0,void 0),this.g=l.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,p={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===h.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(y){return y=I.n(y),I.b[y].apiCell},getCells(y){return(y?I.p(y):I.b).map(l=>l.apiCell)},save(){return I.q()}};this.e=Object.freeze(p)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,p,y){this.g=I.versionId,this.h=p,this.acceptDocumentPropertiesChanged({metadata:y});const v={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},l=[];for(const o of I.rawEvents)o.kind===M.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,v.contentChanges):o.kind===M.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,v.contentChanges):o.kind===M.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),l.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===M.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),l.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),l.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===M.NotebookCellsChangeType.ChangeCellContent?l.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),l.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),l.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const d=new Map;for(let o=0;o<l.length;o++){const n=l[o],i=d.get(n.cell);if(i===void 0){const u=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});d.set(n.cell,u-1)}else v.cellChanges[i]={...v.cellChanges[i],...n}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let p=I.start|0,y=I.end|0;return p<0&&(p=0),y>this.b.length&&(y=this.b.length),I.with({start:p,end:y})}p(I){I=this.o(I);const p=[];for(let y=I.start;y<I.end;y++)p.push(this.b[y]);return p}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,p,y){if(this.j)return;const v=[],l=[],d=[];if(I.reverse().forEach(o=>{const i=o[2].map(t=>{const c=new $(this,this.l,t);return p||l.push($.asModelAddData(t)),c}),u=new b(o[0],o[1],[],i),s=this.b.splice(o[0],o[1],...i);for(const t of s)d.push(t.uri),u.deletedItems.push(t.apiCell);v.push(u)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:d}),y)for(const o of v)y.push(o.asApiEvent())}s(I,p,y,v){const l=this.b.splice(I,p);this.b.splice(y,0,...l);const d=[new b(I,p,l.map(o=>o.apiCell),[]),new b(y,0,[],l)];for(const o of d)v.push(o.asApiEvent())}t(I,p){this.b[I].setOutputs(p)}u(I,p,y,v){this.b[I].setOutputItems(p,y,v)}v(I,p){const y=this.b[I];y.apiCell.document.languageId!==p&&this.m.$acceptModelLanguageChanged(y.uri,p)}w(I,p){const y=this.b[I];y.apiCell.mime=p}x(I,p){this.b[I].setMetadata(p)}y(I,p){this.b[I].setInternalMetadata(p)}getCellFromApiCell(I){return this.b.find(p=>p.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find(p=>p.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$Omc=k}),define(Se[346],De([1,0,4,2,17,8,48]),function(he,e,h,N,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4mc=void 0;class b{constructor(k,A,I,p={timeout:1500,errors:3}){this.b=k,this.c=A,this.d=I,this.f=p,this.a=new h.$fe}dispose(){}getOnWillSaveNotebookDocumentEvent(k){return(A,I,p)=>{const y=function(l){A.call(I,l)};return y.extension=k,this.a.event(y,void 0,p)}}async $participateInSave(k,A,I){const p=N.URI.revive(k),y=this.c.getNotebookDocument(p);if(!y)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:y.apiNotebook,reason:O.TextDocumentSaveReason.to(A)},I,async(d,o)=>{const n=Date.now(),i=await await Promise.resolve(d);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!I.isCancellationRequested&&i&&(i instanceof R.$pM?v.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),I.isCancellationRequested)return!1;if(v.length===0)return!0;const l={edits:[]};for(const d of v){const{edits:o}=O.WorkspaceEdit.from(d);l.edits=l.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(new M.$Bw(l))}}e.$4mc=b}),define(Se[154],De([1,0,13,17,8]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pmc=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,$,k,A,I,p){this.id=b,this.f=$,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=A,this.c=p}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection($){this.selections=[$]},get selections(){return b.a},set selections($){if(!Array.isArray($)||!$.every(O.$HN.isNotebookRange))throw(0,h.$7)("selections");b.a=$,b.g($)},get visibleRanges(){return b.b},revealRange($,k){b.f.$tryRevealRange(b.id,N.NotebookRange.from($),k??O.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(N.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$Pmc=R}),define(Se[347],De([1,0,4,11,17]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6mc=void 0;let R=class{constructor(b,$){this.c=b,this.d=$,this.a=new h.$de,this.b=new h.$de,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(b,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,$);const k=this.d.getEditorById(b);$.visibleRanges&&k._acceptVisibleRanges($.visibleRanges.ranges.map(O.NotebookRange.to)),$.selections&&k._acceptSelections($.selections.selections.map(O.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const $ in b)this.d.getEditorById($)._acceptViewColumn(O.ViewColumn.to(b[$]))}};e.$6mc=R,e.$6mc=R=He([We(0,N.$3j)],R)}),define(Se[348],De([1,0,4,6,154]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9mc=void 0;class R{constructor(b,$){this.c=$,this.a=new Map,this.b=b.getProxy(N.$dM.MainThreadNotebookRenderers)}$postRendererMessage(b,$,k){const A=this.c.getEditorById(b);this.a.get($)?.fire({editor:A.apiEditor,message:k})}createRendererMessaging(b,$){if(!b.contributes?.notebookRenderer?.some(A=>A.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(A,I,p)=>this.d($).event(A,I,p),postMessage:(A,I)=>{O.$Pmc.apiEditorsToExtHost.has(A)&&([A,I]=[I,A]);const p=I&&O.$Pmc.apiEditorsToExtHost.get(I);return this.b.$postMessage(p?.id,$,A)}}}d(b){let $=this.a.get(b);return $||($=new h.$de({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(b)}}),this.a.set(b,$),$)}}e.$9mc=R}),define(Se[349],De([1,0,17,109,22,56,13]),function(he,e,h,N,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$anc=void 0;class b{constructor(I){this.b=0,this.c=new Map,this.a=I}async withProgress(I,p,y){const v=this.b++,{title:l,location:d,cancellable:o}=p,n={label:I.displayName||I.name,id:I.identifier.value};return this.a.$startProgress(v,{location:h.ProgressLocation.from(d),title:l,source:n,cancellable:o},I.isUnderDevelopment?void 0:I.identifier.value).catch(M.$2),this.d(v,y,!!o)}d(I,p,y){let v;y&&(v=new O.$oe,this.c.set(I,v));const l=o=>{this.a.$progressEnd(o),this.c.delete(o),v?.dispose()};let d;try{d=p(new k(this.a,I),y&&v?v.token:O.CancellationToken.None)}catch(o){throw l(I),o}return d.then(o=>l(I),o=>l(I)),d}$acceptProgressCanceled(I){const p=this.c.get(I);p&&(p.cancel(),this.c.delete(I))}}e.$anc=b;function $(A,I){return A.message=I.message,typeof I.increment=="number"&&(typeof A.increment=="number"?A.increment+=I.increment:A.increment=I.increment),A}class k extends N.$dw{constructor(I,p){super(y=>this.throttledReport(y)),this.c=I,this.d=p}throttledReport(I){this.c.$progressReport(this.d,I)}}He([(0,R.$3h)(100,(A,I)=>$(A,I),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(Se[350],De([1,0,2,6,7,17]),function(he,e,h,N,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bnc=void 0;class M{static{this.a=0}constructor($,k){this.d=k,this.c=new Map,this.b=$.getProxy(N.$dM.MainThreadQuickDiff)}$provideOriginalResource($,k,A){const I=h.URI.revive(k),p=this.c.get($);return p?(0,O.$oh)(()=>p.provideOriginalResource(I,A)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider($,k,A,I){const p=M.a++;return this.c.set(p,k),this.b.$registerQuickDiffProvider(p,R.DocumentSelector.from($,this.d),A,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider(p),this.c.delete(p)}}}}e.$bnc=M}),define(Se[351],De([1,0,22,4,3,6,2,8,13,19,41,50,26,17]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=v;function v(l,d,o){const n=l.getProxy(R.$dM.MainThreadQuickOpen);class i{constructor(w,S){this.e=new Map,this.f=0,this.a=w,this.b=S}showQuickPick(w,S,m,E=h.CancellationToken.None){this.c=void 0;const D=Promise.resolve(S),C=++this.f,P=n.$show(C,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},E),F={},T=P.then(()=>F);return Promise.race([T,D]).then(z=>{if(z===F)return;const L=(0,p.$OG)(w,"quickPickItemTooltip");return D.then(j=>{const U=[];for(let X=0;X<j.length;X++){const ie=j[X];if(typeof ie=="string")U.push({label:ie,handle:X});else if(ie.kind===b.QuickPickItemKind.Separator)U.push({type:"separator",label:ie.label});else{ie.tooltip&&!L&&console.warn(`Extension '${w.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`);const q=ie.iconPath?r(ie.iconPath):void 0;U.push({label:ie.label,iconPath:q?.iconPath,iconClass:q?.iconClass,description:ie.description,detail:ie.detail,picked:ie.picked,alwaysShow:ie.alwaysShow,tooltip:L?y.MarkdownString.fromStrict(ie.tooltip):void 0,handle:X})}}return m&&typeof m.onDidSelectItem=="function"&&(this.c=X=>{m.onDidSelectItem(j[X])}),n.$setItems(C,U),P.then(X=>{if(typeof X=="number")return j[X];if(Array.isArray(X))return X.map(ie=>j[ie])})})}).then(void 0,z=>{if(!(0,$.$4)(z))return n.$setError(C,z),Promise.reject(z)})}$onItemSelected(w){this.c?.(w)}showInput(w,S=h.CancellationToken.None){return this.d=w?.validateInput,n.$input(w,typeof this.d=="function",S).then(void 0,m=>{if(!(0,$.$4)(m))return Promise.reject(m)})}async $validateInput(w){if(!this.d)return;const S=await this.d(w);if(!S||typeof S=="string")return S;let m;switch(S.severity){case b.InputBoxValidationSeverity.Info:m=A.default.Info;break;case b.InputBoxValidationSeverity.Warning:m=A.default.Warning;break;case b.InputBoxValidationSeverity.Error:m=A.default.Error;break;default:m=S.message?A.default.Error:A.default.Ignore;break}return{content:S.message,severity:m}}async showWorkspaceFolderPick(w,S=h.CancellationToken.None){const m=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[w]);if(!m)return;const E=await this.a.getWorkspaceFolders2();if(E)return E.find(D=>D.uri.toString()===m.uri.toString())}createQuickPick(w){const S=new a(w,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(w){const S=new f(w,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(w,S){this.e.get(w)?._fireDidChangeValue(S)}$onDidAccept(w){this.e.get(w)?._fireDidAccept()}$onDidChangeActive(w,S){const m=this.e.get(w);m instanceof a&&m._fireDidChangeActive(S)}$onDidChangeSelection(w,S){const m=this.e.get(w);m instanceof a&&m._fireDidChangeSelection(S)}$onDidTriggerButton(w,S){this.e.get(w)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(w,S,m){const E=this.e.get(w);E instanceof a&&E._fireDidTriggerItemButton(S,m)}$onDidHide(w){this.e.get(w)?._fireDidHide()}}class u{static{this.a=1}constructor(w,S){this.x=w,this.y=S,this._id=a.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$de,this.q=new N.$de,this.r=new N.$de,this.s=new N.$de,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(w){this.b=w,this.z({title:w})}get step(){return this.c}set step(w){this.c=w,this.z({step:w})}get totalSteps(){return this.d}set totalSteps(w){this.d=w,this.z({totalSteps:w})}get enabled(){return this.g}set enabled(w){this.g=w,this.z({enabled:w})}get busy(){return this.j}set busy(w){this.j=w,this.z({busy:w})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(w){this.k=w,this.z({ignoreFocusOut:w})}get value(){return this.l}set value(w){this.l=w,this.z({value:w})}get placeholder(){return this.m}set placeholder(w){this.m=w,this.z({placeholder:w})}get buttons(){return this.n}set buttons(w){this.n=w.slice(),this.o.clear(),w.forEach((S,m)=>{const E=S===b.$EN.Back?-1:m;this.o.set(E,S)}),this.z({buttons:w.map((S,m)=>({...r(S.iconPath),tooltip:S.tooltip,handle:S===b.$EN.Back?-1:m}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(w){this.l=w,this.q.fire(w)}_fireDidTriggerButton(w){const S=this.o.get(w);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,O.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(w){if(!this.v){for(const S of Object.keys(w)){const m=w[S];this.u[S]=m===void 0?null:m}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function s(g){if(g instanceof b.$cN)return{id:g.id};const w=c(g),S=t(g);return{dark:typeof w=="string"?M.URI.file(w):w,light:typeof S=="string"?M.URI.file(S):S}}function t(g){return typeof g=="object"&&"light"in g?g.light:g}function c(g){return typeof g=="object"&&"dark"in g?g.dark:g}function r(g){const w=s(g);let S,m;return"id"in w?m=I.ThemeIcon.asClassName(w):S=w,{iconPath:S,iconClass:m}}class a extends u{constructor(w,S){super(w.identifier,S),this.O=w,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$de,this.L=[],this.M=new N.$de,this.N=new N.$de,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(w){this.B=w.slice(),this.C.clear(),this.D.clear(),w.forEach((E,D)=>{this.C.set(D,E),this.D.set(E,D)});const S=(0,p.$OG)(this.O,"quickPickItemTooltip"),m=[];for(let E=0;E<w.length;E++){const D=w[E];if(D.kind===b.QuickPickItemKind.Separator)m.push({type:"separator",label:D.label});else{D.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=D.iconPath?r(D.iconPath):void 0;m.push({handle:E,label:D.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:D.description,detail:D.detail,picked:D.picked,alwaysShow:D.alwaysShow,tooltip:S?y.MarkdownString.fromStrict(D.tooltip):void 0,buttons:D.buttons?.map((P,F)=>({...r(P.iconPath),tooltip:P.tooltip,handle:F}))})}}this.z({items:m})}get canSelectMany(){return this.E}set canSelectMany(w){this.E=w,this.z({canSelectMany:w})}get matchOnDescription(){return this.F}set matchOnDescription(w){this.F=w,this.z({matchOnDescription:w})}get matchOnDetail(){return this.G}set matchOnDetail(w){this.G=w,this.z({matchOnDetail:w})}get sortByLabel(){return this.H}set sortByLabel(w){this.H=w,this.z({sortByLabel:w})}get keepScrollPosition(){return this.I}set keepScrollPosition(w){this.I=w,this.z({keepScrollPosition:w})}get activeItems(){return this.J}set activeItems(w){this.J=w.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(w){this.L=w.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(w){const S=(0,k.$Hb)(w.map(m=>this.C.get(m)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(w){const S=(0,k.$Hb)(w.map(m=>this.C.get(m)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(w,S){const m=this.C.get(w);if(!m||!m.buttons||!m.buttons.length)return;const E=m.buttons[S];E&&this.N.fire({button:E,item:m})}}class f extends u{constructor(w,S){super(w.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(w){this.B=w,this.z({password:w})}get prompt(){return this.C}set prompt(w){this.C=w,this.z({prompt:w})}get valueSelection(){return this.D}set valueSelection(w){this.D=w,this.z({valueSelection:w})}get validationMessage(){return this.E}set validationMessage(w){this.E=w,w?typeof w=="string"?this.z({validationMessage:w,severity:A.default.Error}):this.z({validationMessage:w.message,severity:w.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new i(d,o)}}),define(Se[352],De([1,0,2,4,56,3,7,6,19,132,11,25,50,17,26,15,12]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$enc=e.$dnc=void 0;function n(C){return C instanceof h.URI}function i(C,P){return C.scheme===l.Schemas.file&&P.scheme===l.Schemas.file&&d.$k?C.toString()===P.toString():C.toString().toLowerCase()===P.toString().toLowerCase()}function u(C){if(C)return typeof C.iconPath=="string"?h.URI.file(C.iconPath):h.URI.isUri(C.iconPath)||p.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function s(C){if(C.icon){if(h.URI.isUri(C.icon))return C.icon;if(p.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const P=C.icon;return{light:P.light,dark:P.dark}}}else return}function t(C,P){if(!C.iconPath&&!P.iconPath)return 0;if(C.iconPath){if(!P.iconPath)return 1}else return-1;const F=typeof C.iconPath=="string"?C.iconPath:h.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,T=typeof P.iconPath=="string"?P.iconPath:h.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id;return(0,k.$qr)(F,T)}function c(C,P){let F=0;if(C.strikeThrough!==P.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==P.faded)return C.faded?1:-1;if(C.tooltip!==P.tooltip)return(C.tooltip||"").localeCompare(P.tooltip||"");if(F=t(C,P),F!==0)return F;if(C.light&&P.light)F=t(C.light,P.light);else{if(C.light)return 1;if(P.light)return-1}if(F!==0)return F;if(C.dark&&P.dark)F=t(C.dark,P.dark);else{if(C.dark)return 1;if(P.dark)return-1}return F}function r(C,P){if(C.command!==P.command)return C.command<P.command?-1:1;if(C.title!==P.title)return C.title<P.title?-1:1;if(C.tooltip!==P.tooltip){if(C.tooltip!==void 0&&P.tooltip!==void 0)return C.tooltip<P.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(P.tooltip!==void 0)return-1}if(C.arguments===P.arguments)return 0;if(C.arguments)if(P.arguments){if(C.arguments.length!==P.arguments.length)return C.arguments.length-P.arguments.length}else return 1;else return-1;for(let F=0;F<C.arguments.length;F++){const T=C.arguments[F],z=P.arguments[F];if(T!==z&&!(n(T)&&n(z)&&i(T,z)))return T<z?-1:1}return 0}function a(C,P){let F=(0,k.$qr)(C.resourceUri.fsPath,P.resourceUri.fsPath,!0);if(F!==0)return F;if(C.command&&P.command)F=r(C.command,P.command);else{if(C.command)return 1;if(P.command)return-1}if(F!==0)return F;if(C.decorations&&P.decorations)F=c(C.decorations,P.decorations);else{if(C.decorations)return 1;if(P.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&P.multiFileDiffEditorModifiedUri)F=(0,k.$qr)(C.multiFileDiffEditorModifiedUri.fsPath,P.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(P.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&P.multiDiffEditorOriginalUri)F=(0,k.$qr)(C.multiDiffEditorOriginalUri.fsPath,P.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(P.multiDiffEditorOriginalUri)return-1}return F}function f(C,P){for(let F=0;F<C.length;F++)if(C[F]!==P[F])return!1;return!0}function g(C,P){return C.command===P.command&&C.title===P.title&&C.tooltip===P.tooltip&&(C.arguments&&P.arguments?f(C.arguments,P.arguments):C.arguments===P.arguments)}function w(C,P){return(0,$.$ub)(C,P,g)}class S{#e;#t;get value(){return this.d}set value(P){P=P??"",this.#e.$setInputBoxValue(this.l,P),this.n(P)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(P){this.#e.$setInputBoxPlaceholder(this.l,P),this.f=P}get validateInput(){return(0,v.$PG)(this.k,"scmValidation"),this.g}set validateInput(P){if((0,v.$PG)(this.k,"scmValidation"),P&&typeof P!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=P,this.#e.$setValidationProviderIsEnabled(this.l,!!P)}get enabled(){return this.h}set enabled(P){P=!!P,this.h!==P&&(this.h=P,this.#e.$setInputBoxEnablement(this.l,P))}get visible(){return this.j}set visible(P){P=!!P,this.j!==P&&(this.j=P,this.#e.$setInputBoxVisibility(this.l,P))}get document(){return(0,v.$PG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(P,F,T,z,L){this.k=P,this.l=z,this.m=L,this.d="",this.e=new N.$de,this.f="",this.h=!0,this.j=!0,this.#t=F,this.#e=T}showValidationMessage(P,F){(0,v.$PG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,P,F)}$onInputBoxValueChange(P){this.n(P)}n(P){this.d=P,this.e.fire(P)}}e.$dnc=S;class m{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(P){this.v=P,this.q.$updateGroupLabel(this.t,this.handle,P)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(P){this.p=P,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(P){this.f=[...P],this.k.fire()}constructor(P,F,T,z,L,j,U){this.q=P,this.s=F,this.t=T,this.u=z,this.v=L,this.multiDiffEditorEnableViewChanges=j,this.w=U,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$de,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$de,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=m.d++}getResourceState(P){return this.g.get(P)}$executeResourceCommand(P,F){const T=this.h.get(P);return T?(0,M.$oh)(()=>this.s.executeCommand(T.command,...T.arguments||[],F)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const P=[...this.f].sort(a),T=(0,$.$Db)(this.o,P,a).map(j=>{const U=j.toInsert.map(X=>{const ie=this.e++;this.g.set(ie,X);const q=X.resourceUri;let G;if(X.command)if(X.command.command==="vscode.open"||X.command.command==="vscode.diff"||X.command.command==="vscode.changes"){const le=new R.$Tc;G=this.s.converter.toInternal(X.command,le),this.j.set(ie,le)}else this.h.set(ie,X.command);const x=(0,v.$OG)(this.w,"scmMultiDiffEditor"),ne=x?X.multiDiffEditorOriginalUri:void 0,be=x?X.multiFileDiffEditorModifiedUri:void 0,ae=u(X.decorations),Ie=X.decorations&&u(X.decorations.light)||ae,ee=X.decorations&&u(X.decorations.dark)||ae,B=[Ie,ee],_=X.decorations&&X.decorations.tooltip||"",pe=X.decorations&&!!X.decorations.strikeThrough,ue=X.decorations&&!!X.decorations.faded,ce=X.contextValue||"";return{rawResource:[ie,q,B,_,pe,ue,ce,G,ne,be],handle:ie}});return{start:j.start,deleteCount:j.deleteCount,toInsert:U}}),z=T.map(({start:j,deleteCount:U,toInsert:X})=>[j,U,X.map(ie=>ie.rawResource)]),L=T.reverse();for(const{start:j,deleteCount:U,toInsert:X}of L){const ie=X.map(G=>G.handle),q=this.n.splice(j,U,...ie);for(const G of q)this.g.delete(G),this.h.delete(G),this.j.get(G)?.dispose(),this.j.delete(G)}return this.o=P,z}dispose(){this.l=!0,this.m.fire()}}class E{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(P){this.g!==P&&(this.g=P,this.#e.$updateSourceControl(this.w,{count:P}))}get quickDiffProvider(){return this.h}set quickDiffProvider(P){this.h=P;let F;(0,v.$OG)(this.x,"quickDiffProvider")&&(F=P?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!P,quickDiffLabel:F})}get historyProvider(){return(0,v.$PG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(P){(0,v.$PG)(this.x,"scmHistoryProvider"),this.j=P,this.k.value=new R.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!P}),P&&this.k.value.add(P.onDidChangeCurrentHistoryItemGroup(()=>{this.l=P?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(P){P!==this.m&&(this.m=P,this.#e.$updateSourceControl(this.w,{commitTemplate:P}))}get acceptInputCommand(){return this.o}set acceptInputCommand(P){this.n.value=new R.$Tc,this.o=P;const F=this.y.converter.toInternal(P,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:F})}get actionButton(){return(0,v.$PG)(this.x,"scmActionButton"),this.q}set actionButton(P){(0,v.$PG)(this.x,"scmActionButton"),this.p.value=new R.$Tc,this.q=P;const F=P!==void 0?{command:this.y.converter.toInternal(P.command,this.p.value),secondaryCommands:P.secondaryCommands?.map(T=>T.map(z=>this.y.converter.toInternal(z,this.p.value))),description:P.description,enabled:P.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:F??null})}get statusBarCommands(){return this.t}set statusBarCommands(P){if(this.t&&P&&w(this.t,P))return;this.s.value=new R.$Tc,this.t=P;const F=(P||[]).map(T=>this.y.converter.toInternal(T,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:F})}get selected(){return this.u}constructor(P,F,T,z,L,j,U){this.x=P,this.y=z,this.z=L,this.A=j,this.B=U,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Vc,this.m=void 0,this.n=new R.$Vc,this.o=void 0,this.p=new R.$Vc,this.s=new R.$Vc,this.t=void 0,this.u=!1,this.v=new N.$de,this.onDidChangeSelection=this.v.event,this.w=E.d++,this.C=new Map,this.D=new Set,this.#e=T;const X=h.URI.from({scheme:l.Schemas.vscodeSourceControl,path:`${L}/scm${this.w}/input`,query:U?`rootUri=${encodeURIComponent(U.toString())}`:void 0});this.f=new S(P,F,this.#e,this.w,X),this.#e.$registerSourceControl(this.w,L,j,U,X)}createResourceGroup(P,F,T){const z=(0,v.$OG)(this.x,"scmMultiDiffEditor")&&T?.multiDiffEditorEnableViewChanges===!0,L=new m(this.#e,this.y,this.w,P,F,z,this.x),j=N.Event.once(L.onDidDispose)(()=>this.C.delete(L));return this.C.set(L,j),this.eventuallyAddResourceGroups(),L}eventuallyAddResourceGroups(){const P=[],F=[];for(const[T,z]of this.C){z.dispose();const L=T.onDidUpdateResourceStates(()=>{this.D.add(T),this.eventuallyUpdateResourceStates()});N.Event.once(T.onDidDispose)(()=>{this.D.delete(T),L.dispose(),this.e.delete(T.handle),this.#e.$unregisterGroup(this.w,T.handle)}),P.push([T.handle,T.id,T.label,T.features,T.multiDiffEditorEnableViewChanges]);const j=T._takeResourceStateSnapshot();j.length>0&&F.push([T.handle,j]),this.e.set(T.handle,T)}this.#e.$registerGroups(this.w,P,F),this.C.clear()}eventuallyUpdateResourceStates(){const P=[];this.D.forEach(F=>{const T=F._takeResourceStateSnapshot();T.length!==0&&P.push([F.handle,T])}),P.length>0&&this.#e.$spliceResourceStates(this.w,P),this.D.clear()}getResourceGroup(P){return this.e.get(P)}setSelectionState(P){this.u=P,this.v.fire(P)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(P=>P.dispose()),this.#e.$unregisterSourceControl(this.w)}}He([(0,O.$2h)(100)],E.prototype,"eventuallyAddResourceGroups",null),He([(0,O.$2h)(100)],E.prototype,"eventuallyUpdateResourceStates",null);let D=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(P,F,T,z){this.l=F,this.m=T,this.n=z,this.g=new Map,this.h=new I.$Tm,this.j=new N.$de,this.e=P.getProxy(b.$dM.MainThreadSCM),this.f=P.getProxy(b.$dM.MainThreadTelemetry),F.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===3){const j=this.g.get(L.sourceControlHandle);if(!j)return L;const U=j.getResourceGroup(L.groupHandle);return U?U.getResourceState(L.handle):L}else if(L&&L.$mid===4){const j=this.g.get(L.sourceControlHandle);return j?j.getResourceGroup(L.groupHandle):L}else if(L&&L.$mid===5){const j=this.g.get(L.handle);return j||L}return L}})}createSourceControl(P,F,T,z){this.n.trace("ExtHostSCM#createSourceControl",P.identifier.value,F,T,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:P.identifier.value});const L=o.d++,j=new E(P,this.m,this.e,this.l,F,T,z);this.g.set(L,j);const U=this.h.get(P.identifier)||[];return U.push(j),this.h.set(P.identifier,U),j}getLastInputBox(P){this.n.trace("ExtHostSCM#getLastInputBox",P.identifier.value);const F=this.h.get(P.identifier),T=F&&F[F.length-1];return T&&T.inputBox}$provideOriginalResource(P,F,T){const z=h.URI.revive(F);this.n.trace("ExtHostSCM#$provideOriginalResource",P,z.toString());const L=this.g.get(P);return!L||!L.quickDiffProvider||!L.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$oh)(()=>L.quickDiffProvider.provideOriginalResource(z,T)).then(j=>j||null)}$onInputBoxValueChange(P,F){this.n.trace("ExtHostSCM#$onInputBoxValueChange",P);const T=this.g.get(P);return T&&T.inputBox.$onInputBoxValueChange(F),Promise.resolve(void 0)}$executeResourceCommand(P,F,T,z){this.n.trace("ExtHostSCM#$executeResourceCommand",P,F,T);const L=this.g.get(P);if(!L)return Promise.resolve(void 0);const j=L.getResourceGroup(F);return j?j.$executeResourceCommand(T,z):Promise.resolve(void 0)}$validateInput(P,F,T){this.n.trace("ExtHostSCM#$validateInput",P);const z=this.g.get(P);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,M.$oh)(()=>z.inputBox.validateInput(F,T)).then(L=>{if(!L)return Promise.resolve(void 0);const j=y.MarkdownString.fromStrict(L.message);return j?Promise.resolve([j,L.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(P){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",P),P!==void 0&&this.g.get(P)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=P,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(P,F,T,z){return await this.g.get(P)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(F,T,z)??void 0}async $provideHistoryItems(P,F,T,z){return(await this.g.get(P)?.historyProvider?.provideHistoryItems(F,T,z))?.map(U=>({...U,icon:s(U)}))??void 0}async $provideHistoryItemSummary(P,F,T,z){const L=this.g.get(P)?.historyProvider;if(typeof L?.provideHistoryItemSummary!="function")return;const j=await L.provideHistoryItemSummary(F,T,z);return j?{...j,icon:s(j)}:void 0}async $provideHistoryItemChanges(P,F,T,z){return await this.g.get(P)?.historyProvider?.provideHistoryItemChanges(F,T,z)??void 0}};e.$enc=D,e.$enc=D=o=He([We(3,A.$3j)],D)}),define(Se[353],De([1,0,6,17,2]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fnc=void 0;class R{static{this.a=0}constructor(b,$){this.d=$,this.c=new Map,this.b=b.getProxy(h.$dM.MainThreadShare)}async $provideShare(b,$,k){return await this.c.get(b)?.provideShare({selection:N.Range.to($.selection),resourceUri:O.URI.revive($.resourceUri)},k)??void 0}registerShareProvider(b,$){const k=R.a++;return this.c.set(k,$),this.b.$registerShareProvider(k,N.DocumentSelector.from(b,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(k),this.c.delete(k)}}}}e.$fnc=R}),define(Se[354],De([1,0,8,6,230,3,17,18]),function(he,e,h,N,O,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$inc=e.$hnc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new h.$dN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new h.$dN("statusBarItem.warningForeground")]])}#e;#t;constructor(p,y,v,l,d,o=h.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new R.$Tc,this.#e=p,this.#t=y,d&&l){this.c=(0,h.$RM)(l.identifier,d);const i=v.get(this.c);i&&(o=i.alignLeft?h.StatusBarAlignment.Left:h.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String($.a++);this.e=l,this.f=d,this.g=o,this.h=this.u(n)}u(p){if((0,b.$ag)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(p){this.k=p,this.v()}set name(p){this.m=p,this.v()}set tooltip(p){this.l=p,this.v()}set color(p){this.n=p,this.v()}set backgroundColor(p){p&&!$.b.has(p.id)&&(p=void 0),this.o=p,this.v()}set command(p){this.r?.fromApi!==p&&(this.p&&this.q.add(this.p),this.p=new R.$Tc,typeof p=="string"?this.r={fromApi:p,internal:this.#t.toInternal({title:"",command:p},this.p)}:p?this.r={fromApi:p,internal:this.#t.toInternal(p,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(p){this.t=p,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let p;this.e?this.f?p=`${this.e.identifier.value}.${this.f}`:p=this.e.identifier.value:p=this.f;let y;this.m?y=this.m:y=(0,O.localize)(0,null,this.e.displayName||this.e.name);let v=this.n;this.o&&(v=$.b.get(this.o.id));const l=M.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,p,this.e?.identifier.value,y,this.k,l,this.r?.internal,v,this.o,this.g===h.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$hnc=$;class k{constructor(p){this.b=[],this.a=p.createStatusBarEntry(void 0,"status.extensionMessage",h.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,O.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(p){const y={message:p};return this.b.unshift(y),this.c(),new h.$fM(()=>{const v=this.b.indexOf(y);v>=0&&(this.b.splice(v,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(p,y){this.e=new Map,this.a=p.getProxy(N.$dM.MainThreadStatusBar),this.b=y,this.c=new k(this)}$acceptStaticEntries(p){for(const y of p)this.e.set(y.entryId,y)}createStatusBarEntry(p,y,v,l){return new $(this.a,this.b,this.e,p,y,v,l)}setStatusBarMessage(p,y){const v=this.c.setMessage(p);let l;return typeof y=="number"?l=setTimeout(()=>v.dispose(),y):typeof y<"u"&&y.then(()=>v.dispose(),()=>v.dispose()),new h.$fM(()=>{v.dispose(),clearTimeout(l)})}}e.$inc=A}),define(Se[155],De([1,0,29,145,69,113,89,17,2]),function(he,e,h,N,O,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TO=e.$SO=e.$RO=e.$QO=void 0;const k=(i,u,s,t)=>{let c=u;return{enumerable:!0,configurable:!1,get(){return c},set(r){if(!s(c,r)){const a=c;c=r,i.listener?.(t(r,a))}}}},A=(i,u)=>i===u,I={range:(i,u)=>i===u?!0:!i||!u?!1:i.isEqual(u),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(i,u)=>!(i.length!==u.length||i.some(s=>!u.find(t=>s.id===t.id)))},p=i=>u=>({op:4,update:i(u)}),y=(i,u)=>({range:(()=>{let s;const t=p(c=>({range:h.$ut.lift(b.Range.from(c))}));return{enumerable:!0,configurable:!1,get(){return s},set(c){i.listener?.({op:6}),I.range(s,c)||(s=c,i.listener?.(t(c)))}}})(),label:k(i,u,I.label,p(s=>({label:s}))),description:k(i,void 0,I.description,p(s=>({description:s}))),sortText:k(i,void 0,I.sortText,p(s=>({sortText:s}))),canResolveChildren:k(i,!1,I.canResolveChildren,s=>({op:2,state:s})),busy:k(i,!1,I.busy,p(s=>({busy:s}))),error:k(i,void 0,I.error,p(s=>({error:b.MarkdownString.fromStrict(s)||null}))),tags:k(i,[],I.tags,(s,t)=>({op:1,new:s.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),v=i=>{const u=O.$2K.fromString(i.extId),s=new d(u.controllerId,u.localId,i.label,$.URI.revive(i.uri)||void 0);return s.range=b.Range.to(i.range||void 0),s.description=i.description||void 0,s.sortText=i.sortText||void 0,s.tags=i.tags.map(t=>b.TestTag.to({id:(0,M.$8K)(t).tagId})),s},l=i=>{let u;for(const s of i.tests){const t=v(s.item);(0,N.$AO)(t).parent=u,u=t}return u};e.$QO=l;class d{constructor(u,s,t,c){if(s.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(s)} symbol`);const r=(0,N.$zO)(this,u);Object.defineProperties(this,{id:{value:s,enumerable:!0,writable:!1},uri:{value:c,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof o?void 0:r.parent}},children:{value:(0,R.$yO)(r,N.$AO,d),enumerable:!0,writable:!1},...y(r,t)})}}e.$RO=d;class o extends d{constructor(u,s){super(u,u,s,void 0),this._isRoot=!0}}e.$SO=o;class n extends R.$uO{constructor(u,s,t){super({controllerId:u,getDocumentVersion:c=>c&&t.getDocument(c)?.version,getApiFor:N.$AO,getChildren:c=>c.children,root:new o(u,s),toITestItem:b.TestItem.from})}}e.$TO=n}),define(Se[34],De([1,0,18,8,17,24,6,19,11,58,29,51,2,3,5,20,155,21,48,47,40,87,90,30]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d,o,n,i,u,s,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5O=e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=void 0;let r=class{#e;#t;#n;constructor(m,E,D){this.b=new Map,this.c=new Map,this.#e=m.getProxy(M.$dM.MainThreadCommands),this.d=E,this.#n=D,this.#t=m.getProxy(M.$dM.MainThreadTelemetry),this.converter=new a(this,C=>{const P=this.c.get(C);return P?.result===g.Void?P:void 0},E),this.f=[{processArgument(C){return(0,k.$6h)(C)}},{processArgument(C){return(0,R.$5n)(C,function(P){if(A.$ut.isIRange(P))return O.Range.to(P);if(I.$tt.isIPosition(P))return O.Position.to(P);if(A.$ut.isIRange(P.range)&&p.URI.isUri(P.uri))return O.location.to(P);if(P instanceof o.$Fe)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(m){this.f.push(m)}registerApiCommand(m){const E=this.registerCommand(!1,m.id,async(...D)=>{const C=m.args.map((F,T)=>{if(!F.validate(D[T]))throw new Error(`Invalid argument '${F.name}' when running '${m.id}', received: ${typeof D[T]=="object"?JSON.stringify(D[T],null,"	"):D[T]} `);return F.convert(D[T])}),P=await this.executeCommand(m.internalId,...C);return m.result.convert(P,D,this.converter)},void 0,{description:m.description,args:m.args,returns:m.result.description});return this.c.set(m.id,m),new N.$fM(()=>{E.dispose(),this.c.delete(m.id)})}registerCommand(m,E,D,C,P,F){if(this.d.trace("ExtHostCommands#registerCommand",E),!E.trim().length)throw new Error("invalid id");if(this.b.has(E))throw new Error(`command '${E}' already exists`);return this.b.set(E,{callback:D,thisArg:C,metadata:P,extension:F}),m&&this.#e.$registerCommand(E),new N.$fM(()=>{this.b.delete(E)&&m&&this.#e.$unregisterCommand(E)})}executeCommand(m,...E){return this.d.trace("ExtHostCommands#executeCommand",m),this.g(m,E,!0)}async g(m,E,D){if(this.b.has(m))return this.#e.$fireCommandActivationEvent(m),this.h(m,E,!1);{let C=!1;const P=(0,R.$5n)(E,function(F){if(F instanceof N.$gM)return O.Position.from(F);if(F instanceof N.$hM)return O.Range.from(F);if(F instanceof N.$rM)return O.location.from(F);if(N.$HN.isNotebookRange(F))return O.NotebookRange.from(F);if(F instanceof ArrayBuffer)return C=!0,o.$Fe.wrap(new Uint8Array(F));if(F instanceof Uint8Array)return C=!0,o.$Fe.wrap(F);if(F instanceof o.$Fe)return C=!0,F;if(!Array.isArray(F))return F});try{const F=await this.#e.$executeCommand(m,C?new n.$Bw(P):P,D);return(0,k.$6h)(F)}catch(F){if(F instanceof Error&&F.message==="$executeCommand:retry")return this.g(m,E,!1);throw F}}}async h(m,E,D){const C=this.b.get(m);if(!C)throw new Error("Unknown command");const{callback:P,thisArg:F,metadata:T}=C;if(T?.args)for(let L=0;L<T.args.length;L++)try{(0,h.$ng)(E[L],T.args[L].constraint)}catch{throw new Error(`Running the contributed command: '${m}' failed. Illegal argument '${T.args[L].name}' - ${T.args[L].description}`)}const z=u.$_d.create();try{return await P.apply(F,E)}catch(L){if(m===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...E);j&&(m=j.command)}if(this.d.error(L,m,C.extension?.identifier),!D)throw L;if(C.extension?.identifier){const j=this.#n.onExtensionError(C.extension.identifier,L);this.d.trace("forwarded error to extension?",j,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$hj)(L)),this.id=m,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,m,z.elapsed())}}j(m,E,D){m.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:m.extension.identifier.value,id:new s.$fp(E),duration:D})}$executeContributedCommand(m,...E){this.d.trace("ExtHostCommands#$executeContributedCommand",m);const D=this.b.get(m);return D?(E=E.map(C=>this.f.reduce((P,F)=>F.processArgument(P,D.extension?.identifier),C)),this.h(m,E,!0)):Promise.reject(new Error(`Contributed command '${m}' does not exist.`))}getCommands(m=!1){return this.d.trace("ExtHostCommands#getCommands",m),this.#e.$getCommands().then(E=>(m&&(E=E.filter(D=>D[0]!=="_")),E))}$getContributedCommandMetadata(){const m=Object.create(null);for(const[E,D]of this.b){const{metadata:C}=D;C&&(m[E]=C)}return Promise.resolve(m)}};e.$ZO=r,e.$ZO=r=He([We(0,l.$EO),We(1,$.$3j),We(2,t.$YO)],r),e.$1O=(0,v.$wi)("IExtHostCommands");class a{constructor(m,E,D){this.d=m,this.f=E,this.g=D,this.delegatingCommandId=`__vsc${(0,c.$Sg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(m,E){if(!m)return;const D={$ident:void 0,id:m.command,title:m.title,tooltip:m.tooltip};if(!m.command)return D;const C=this.f(m.command);if(C)D.id=C.internalId,D.arguments=C.args.map((P,F)=>P.convert(m.arguments&&m.arguments[F]));else if((0,b.$Lb)(m.arguments)){const P=`${m.command} /${++this.c}`;this.b.set(P,m),E.add((0,y.$Sc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),D.$ident=P,D.id=this.delegatingCommandId,D.arguments=[P],this.g.trace("CommandsConverter#CREATE",m.command,P)}return D}fromInternal(m){return typeof m.$ident=="string"?this.b.get(m.$ident):{command:m.id,title:m.title,arguments:m.arguments}}getActualCommand(...m){return this.b.get(m[0])}h(...m){const E=this.getActualCommand(...m);return this.g.trace("CommandsConverter#EXECUTE",m[0],E?E.command:"MISSING"),E?this.d.executeCommand(E.command,...E.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${m[0]}`)}}e.$2O=a;class f{static{this.Uri=new f("uri","Uri of a text document",m=>p.URI.isUri(m),m=>m)}static{this.Position=new f("position","A position in a text document",m=>N.$gM.isPosition(m),O.Position.from)}static{this.Range=new f("range","A range in a text document",m=>N.$hM.isRange(m),O.Range.from)}static{this.Selection=new f("selection","A selection in a text document",m=>N.$iM.isSelection(m),O.Selection.from)}static{this.Number=new f("number","",m=>typeof m=="number",m=>m)}static{this.String=new f("string","",m=>typeof m=="string",m=>m)}static{this.StringArray=f.Arr(f.String)}static Arr(m){return new f(`${m.name}_array`,`Array of ${m.name}, ${m.description}`,E=>Array.isArray(E)&&E.every(D=>m.validate(D)),E=>E.map(D=>m.convert(D)))}static{this.CallHierarchyItem=new f("item","A call hierarchy item",m=>m instanceof N.$DM,O.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new f("item","A type hierarchy item",m=>m instanceof N.$2N,O.TypeHierarchyItem.from)}static{this.TestItem=new f("testItem","A VS Code TestItem",m=>m instanceof d.$RO,O.TestItem.from)}constructor(m,E,D,C){this.name=m,this.description=E,this.validate=D,this.convert=C}optional(){return new f(this.name,`(optional) ${this.description}`,m=>m==null||this.validate(m),m=>m===void 0?void 0:m===null?null:this.convert(m))}with(m,E){return new f(m??this.name,E??this.description,this.validate,this.convert)}}e.$3O=f;class g{static{this.Void=new g("no result",m=>m)}constructor(m,E){this.description=m,this.convert=E}}e.$4O=g;class w{constructor(m,E,D,C,P){this.id=m,this.internalId=E,this.description=D,this.args=C,this.result=P}}e.$5O=w}),define(Se[355],De([1,0,19,15,2,84,135,38,34,17,8]),function(he,e,h,N,O,R,M,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Elc=void 0;const I=[new $.$5O("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$3O.Uri,$.$3O.Position],new $.$4O("A promise that resolves to an array of DocumentHighlight-instances.",y(k.DocumentHighlight.to))),new $.$5O("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$3O.Uri],new $.$4O("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,d)=>{if((0,h.$Kb)(l))return;class o extends A.$yM{static to(i){const u=new o(i.name,k.SymbolKind.to(i.kind),i.containerName||"",new A.$rM(d[0],k.Range.to(i.range)));return u.detail=i.detail,u.range=u.location.range,u.selectionRange=k.Range.to(i.selectionRange),u.children=i.children?i.children.map(o.to):[],u}}return l.map(o.to)})),new $.$5O("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$3O.Uri,new $.$3O("options","Formatting options",l=>!0,l=>l)],new $.$4O("A promise that resolves to an array of TextEdits.",y(k.TextEdit.to))),new $.$5O("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$3O.Uri,$.$3O.Range,new $.$3O("options","Formatting options",l=>!0,l=>l)],new $.$4O("A promise that resolves to an array of TextEdits.",y(k.TextEdit.to))),new $.$5O("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$3O.Uri,$.$3O.Position,new $.$3O("ch","Trigger character",l=>typeof l=="string",l=>l),new $.$3O("options","Formatting options",l=>!0,l=>l)],new $.$4O("A promise that resolves to an array of TextEdits.",y(k.TextEdit.to))),new $.$5O("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$3O.Uri,$.$3O.Position],new $.$4O("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$5O("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$3O.Uri,$.$3O.Position],new $.$4O("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$5O("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$3O.Uri,$.$3O.Position],new $.$4O("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$5O("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$3O.Uri,$.$3O.Position],new $.$4O("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$5O("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$3O.Uri,$.$3O.Position],new $.$4O("A promise that resolves to an array of Location-instances.",y(k.location.to))),new $.$5O("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$3O.Uri,$.$3O.Position],new $.$4O("A promise that resolves to an array of Hover-instances.",y(k.Hover.to))),new $.$5O("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$3O.Uri,new $.$3O("position","A position in a text document",l=>Array.isArray(l)&&l.every(d=>A.$gM.isPosition(d)),l=>l.map(k.Position.from))],new $.$4O("A promise that resolves to an array of ranges.",l=>l.map(d=>{let o;for(const n of d.reverse())o=new A.$CM(k.Range.to(n),o);return o}))),new $.$5O("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$3O.String.with("query","Search string")],new $.$4O("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(k.WorkspaceSymbol.to))),new $.$5O("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$3O.Uri,$.$3O.Position],new $.$4O("A promise that resolves to an array of CallHierarchyItem-instances",l=>l.map(k.CallHierarchyItem.to))),new $.$5O("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$3O.CallHierarchyItem],new $.$4O("A promise that resolves to an array of CallHierarchyIncomingCall-instances",l=>l.map(k.CallHierarchyIncomingCall.to))),new $.$5O("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$3O.CallHierarchyItem],new $.$4O("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",l=>l.map(k.CallHierarchyOutgoingCall.to))),new $.$5O("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$3O.Uri,$.$3O.Position],new $.$4O("A promise that resolves to a range and placeholder text.",l=>{if(l)return{range:k.Range.to(l.range),placeholder:l.text}})),new $.$5O("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$3O.Uri,$.$3O.Position,$.$3O.String.with("newName","The new symbol name")],new $.$4O("A promise that resolves to a WorkspaceEdit.",l=>{if(l){if(l.rejectReason)throw new Error(l.rejectReason);return k.WorkspaceEdit.to(l)}})),new $.$5O("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$3O.Uri,$.$3O.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$4O("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(k.DocumentLink.to))),new $.$5O("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$3O.Uri],new $.$4O("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new A.$yN(l.tokenTypes,l.tokenModifiers)})),new $.$5O("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$3O.Uri],new $.$4O("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const d=(0,M.$ibb)(l);if(d.type==="full")return new A.$AN(d.data,void 0)})),new $.$5O("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$3O.Uri,$.$3O.Range.optional()],new $.$4O("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new A.$yN(l.tokenTypes,l.tokenModifiers)})),new $.$5O("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$3O.Uri,$.$3O.Range],new $.$4O("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const d=(0,M.$ibb)(l);if(d.type==="full")return new A.$AN(d.data,void 0)})),new $.$5O("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$3O.Uri,$.$3O.Position,$.$3O.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$3O.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$4O("A promise that resolves to a CompletionList-instance.",(l,d,o)=>{if(!l)return new A.$OM([]);const n=l.suggestions.map(i=>k.CompletionItem.to(i,o));return new A.$OM(n,l.incomplete)})),new $.$5O("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$3O.Uri,$.$3O.Position,$.$3O.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$4O("A promise that resolves to SignatureHelp.",l=>{if(l)return k.SignatureHelp.to(l)})),new $.$5O("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$3O.Uri,$.$3O.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$4O("A promise that resolves to an array of CodeLens-instances.",(l,d,o)=>y(n=>new A.$GM(k.Range.to(n.range),n.command&&o.fromInternal(n.command)))(l))),new $.$5O("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$3O.Uri,new $.$3O("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>A.$hM.isRange(l),l=>A.$iM.isSelection(l)?k.Selection.from(l):k.Range.from(l)),$.$3O.String.with("kind","Code action kind to return code actions for").optional(),$.$3O.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$4O("A promise that resolves to an array of Command-instances.",(l,d,o)=>y(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(n.command)}else{const i=new A.$AM(n.title,n.kind?new A.$BM(n.kind):void 0);return n.edit&&(i.edit=k.WorkspaceEdit.to(n.edit)),n.command&&(i.command=o.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(l))),new $.$5O("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$3O.Uri],new $.$4O("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(d=>new A.$UM(k.Range.to(d.range),k.Color.to(d.color))):[])),new $.$5O("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$3O("color","The color to show and insert",l=>l instanceof A.$TM,k.Color.from),new $.$3O("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:k.Range.from(l.range)}))],new $.$4O("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(k.ColorPresentation.to):[])),new $.$5O("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$3O.Uri,$.$3O.Range],new $.$4O("A promise that resolves to an array of Inlay objects",(l,d,o)=>l.map(k.InlayHint.to.bind(void 0,o)))),new $.$5O("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$3O.Uri],new $.$4O("A promise that resolves to an array of FoldingRange objects",(l,d)=>{if(l)return l.map(k.FoldingRange.to)})),new $.$5O("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$4O("A promise that resolves to an array of NotebookContentProvider static info objects.",y(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(d=>k.NotebookExclusiveDocumentPattern.to(d))})))),new $.$5O("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$3O.Uri,$.$3O.Range,new $.$3O("context","An InlineValueContext",l=>l&&typeof l.frameId=="number"&&l.stoppedLocation instanceof A.$hM,l=>k.InlineValueContext.from(l))],new $.$4O("A promise that resolves to an array of InlineValue objects",l=>l.map(k.InlineValue.to))),new $.$5O("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$3O("uriOrString","Uri-instance or string (only http/https)",l=>O.URI.isUri(l)||typeof l=="string"&&(0,N.$Gg)(l,N.Schemas.http,N.Schemas.https),l=>l),new $.$3O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[k.ViewColumn.from(l),void 0]:[k.ViewColumn.from(l.viewColumn),k.TextEditorOpenOptions.from(l)])).optional(),$.$3O.String.with("label","").optional()],$.$4O.Void),new $.$5O("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$3O.Uri.with("resource","Resource to open"),$.$3O.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$3O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[k.ViewColumn.from(l),void 0]:[k.ViewColumn.from(l.viewColumn),k.TextEditorOpenOptions.from(l)])).optional()],$.$4O.Void),new $.$5O("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$3O.Uri.with("left","Left-hand side resource of the diff editor"),$.$3O.Uri.with("right","Right-hand side resource of the diff editor"),$.$3O.String.with("title","Human readable title for the diff editor").optional(),new $.$3O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[k.ViewColumn.from(l.viewColumn),k.TextEditorOpenOptions.from(l)]).optional()],$.$4O.Void),new $.$5O("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$3O.String.with("title","Human readable title for the changes editor"),new $.$3O("resourceList","List of resources to compare",l=>{for(const d of l){if(d.length!==3)return!1;const[o,n,i]=d;if(!O.URI.isUri(o)||!O.URI.isUri(n)&&n!==void 0&&n!==null||!O.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},l=>l)],$.$4O.Void),new $.$5O("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$3O.Uri,$.$3O.Position],new $.$4O("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(k.TypeHierarchyItem.to))),new $.$5O("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$3O.TypeHierarchyItem],new $.$4O("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(k.TypeHierarchyItem.to))),new $.$5O("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$3O.TypeHierarchyItem],new $.$4O("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(k.TypeHierarchyItem.to))),new $.$5O("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$3O.TestItem],$.$4O.Void),new $.$5O("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$3O.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$4O.Void),new $.$5O("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$3O.String.with("name","The context key name"),new $.$3O("value","The context key value",()=>!0,l=>l)],$.$4O.Void),new $.$5O("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$3O.Uri,$.$3O.StringArray,new $.$3O("MappedEditsContext","Mapped Edits Context",l=>k.MappedEditsContext.is(l),l=>k.MappedEditsContext.from(l))],new $.$4O("A promise that resolves to a workspace edit or null",l=>l?k.WorkspaceEdit.to(l):null)),new $.$5O("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$3O("Run arguments","",l=>!0,l=>{if(l)return{initialRange:l.initialRange?k.Range.from(l.initialRange):void 0,initialSelection:A.$iM.isSelection(l.initialSelection)?k.Selection.from(l.initialSelection):void 0,message:l.message,autoSend:l.autoSend,position:l.position?k.Position.from(l.position):void 0}})],$.$4O.Void)];class p{static register(d){I.forEach(d.registerApiCommand,d),this.a(d)}static a(d){d.registerCommand(!1,"_validateWhenClauses",b.$vj)}}e.$Elc=p;function y(l){return d=>{if(Array.isArray(d))return d.map(l)}}function v(l){if(!Array.isArray(l))return;const d=[];for(const o of l)R.$_t(o)?d.push(k.DefinitionLink.to(o)):d.push(k.location.to(o));return d}}),define(Se[356],De([1,0,2,34]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=void 0;class O{constructor(M,b,$,k,A){this.a=b,this.b=$,this.c=k;const I=new N.$5O("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$3O("showOptions","Show Options",p=>!0,p=>p),new N.$3O("resource","Interactive resource Uri",p=>!0,p=>p),new N.$3O("controllerId","Notebook controller Id",p=>!0,p=>p),new N.$3O("title","Interactive editor title",p=>!0,p=>p)],new N.$4O("Notebook and input URI",p=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",p.notebookEditorId),p.notebookEditorId!==void 0){const y=this.a.getEditorById(p.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:h.URI.revive(p.notebookUri),inputUri:h.URI.revive(p.inputUri),notebookEditor:y.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",p.notebookUri,p.inputUri),{notebookUri:h.URI.revive(p.notebookUri),inputUri:h.URI.revive(p.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(M,b,$,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:$,uri:M,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(M,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$Zmc=O}),define(Se[357],De([1,0,19,7,22,4,3,27,2,25,11,6,34,17,8,114,302,26,48,303]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7mc=void 0,e.$8mc=f;let u=class{constructor(w,S,m,E,D){this.m=S,this.n=m,this.o=E,this.q=D,this.b=new b.$Ac,this.c=new b.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$de,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=w.getProxy(I.$dM.MainThreadNotebookKernels);const C=new p.$5O("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.$3O("options","Select kernel options",F=>!0,F=>{if(F&&"notebookEditor"in F&&"id"in F){const T=this.n.getIdByEditor(F.notebookEditor);return{id:F.id,extension:F.extension,notebookEditorId:T}}else if(F&&"notebookEditor"in F){const T=this.n.getIdByEditor(F.notebookEditor);if(T===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${F.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:T}}return F})],p.$4O.Void),P=new p.$5O("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[p.$3O.Uri],new p.$4O("A promise that resolves to an array of variables",(F,T)=>F.map(z=>({variable:{name:z.name,value:z.value,expression:z.expression,type:z.type,language:z.language},hasNamedChildren:z.hasNamedChildren,indexedChildrenCount:z.indexedChildrenCount}))));this.o.registerApiCommand(C),this.o.registerApiCommand(P)}createNotebookController(w,S,m,E,D,C){for(const ae of this.j.values())if(ae.controller.id===S&&k.$Rm.equals(w.identifier,ae.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const P=this.k++,F=this;this.q.trace(`NotebookController[${P}], CREATED by ${w.identifier.value}, ${S}`);const T=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${w.identifier}'`);let z=!1;const L=new R.$de,j=new R.$de,U={id:f(w.identifier,S),notebookType:m,extensionId:w.identifier,extensionLocation:w.extensionLocation,label:E||w.identifier.value,preloads:C?C.map(y.NotebookRendererScript.from):[]};let X=D??T,ie,q;this.a.$addKernel(P,U).catch(ae=>{console.log(ae),z=!0});let G=0;const x=()=>{if(z)return;const ae=++G;Promise.resolve().then(()=>{ae===G&&this.a.$updateKernel(P,U)})},ne=new b.$Ac,be={get id(){return S},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return U.label},set label(ae){U.label=ae??w.displayName??w.name,x()},get detail(){return U.detail??""},set detail(ae){U.detail=ae,x()},get description(){return U.description??""},set description(ae){U.description=ae,x()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(ae){U.supportedLanguages=ae,x()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){U.supportsExecutionOrder=ae,x()},get rendererScripts(){return U.preloads?U.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return X},set executeHandler(ae){X=ae??T},get interruptHandler(){return ie},set interruptHandler(ae){ie=ae,U.supportsInterrupt=!!ae,x()},set variableProvider(ae){(0,o.$PG)(w,"notebookVariableProvider"),q=ae,U.hasVariableProvider=!!ae,ae?.onDidChangeVariables(Ie=>F.a.$variablesUpdated(Ie.uri)),x()},get variableProvider(){return q},createNotebookCellExecution(ae){if(z)throw new Error("notebook controller is DISPOSED");if(!ne.has(ae.notebook.uri))throw F.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(Ie=>Ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return F._createNotebookCellExecution(ae,f(w.identifier,this.id))},createNotebookExecution(ae){if((0,o.$PG)(w,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!ne.has(ae.uri))throw F.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(Ie=>Ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.uri.toString()}`);return F._createNotebookExecution(ae,f(w.identifier,this.id))},dispose:()=>{z||(this.q.trace(`NotebookController[${P}], DISPOSED`),z=!0,this.j.delete(P),L.dispose(),j.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(ae,Ie){Ie===v.NotebookControllerAffinity2.Hidden&&(0,o.$PG)(w,"notebookControllerAffinityHidden"),F.a.$updateNotebookPriority(P,ae.uri,Ie)},onDidReceiveMessage:j.event,postMessage(ae,Ie){return(0,o.$PG)(w,"notebookMessaging"),F.a.$postMessage(P,Ie&&F.n.getIdByEditor(Ie),ae)},asWebviewUri(ae){return(0,o.$PG)(w,"notebookMessaging"),(0,l.$VAb)(ae,F.m.remote)}};return this.j.set(P,{extensionId:w.identifier,controller:be,onDidReceiveMessage:j,onDidChangeSelection:L,associatedNotebooks:ne}),be}getIdByController(w){for(const[S,m]of this.j)if(m.controller===w)return f(m.extensionId,w.id);return null}createNotebookControllerDetectionTask(w,S){const m=this.g++,E=this;this.q.trace(`NotebookControllerDetectionTask[${m}], CREATED by ${w.identifier.value}`),this.a.$addKernelDetectionTask(m,S);const D={dispose:()=>{this.f.delete(m),E.a.$removeKernelDetectionTask(m)}};return this.f.set(m,D),D}registerKernelSourceActionProvider(w,S,m){const E=this.i++,D=typeof m.onDidChangeNotebookKernelSourceActions=="function"?E:void 0,C=this;this.h.set(E,m),this.q.trace(`NotebookKernelSourceActionProvider[${E}], CREATED by ${w.identifier.value}`),this.a.$addKernelSourceActionProvider(E,E,S);let P;return D!==void 0&&(P=m.onDidChangeNotebookKernelSourceActions(F=>this.a.$emitNotebookKernelSourceActionsChangeEvent(D))),{dispose:()=>{this.h.delete(E),C.a.$removeKernelSourceActionProvider(E,E),P?.dispose()}}}async $provideKernelSourceActions(w,S){const m=this.h.get(w);if(m){const E=new M.$Tc;return(await m.provideNotebookKernelSourceActions(S)??[]).map(C=>y.NotebookKernelSourceAction.from(C,this.o.converter,E))}return[]}$acceptNotebookAssociation(w,S,m){const E=this.j.get(w);if(E){const D=this.n.getNotebookDocument($.URI.revive(S));m?E.associatedNotebooks.set(D.uri,!0):E.associatedNotebooks.delete(D.uri),this.q.trace(`NotebookController[${w}] ASSOCIATE notebook`,D.uri.toString(),m),E.onDidChangeSelection.fire({selected:m,notebook:D.apiNotebook})}}async $executeCells(w,S,m){const E=this.j.get(w);if(!E)return;const D=this.n.getNotebookDocument($.URI.revive(S)),C=[];for(const P of m){const F=D.getCell(P);F&&C.push(F.apiCell)}try{this.q.trace(`NotebookController[${w}] EXECUTE cells`,D.uri.toString(),C.length),await E.controller.executeHandler.call(E.controller,C,D.apiNotebook,E.controller)}catch(P){this.q.error(`NotebookController[${w}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(w,S,m){const E=this.j.get(w);if(!E)return;const D=this.n.getNotebookDocument($.URI.revive(S));if(E.controller.interruptHandler)await E.controller.interruptHandler.call(E.controller,D.apiNotebook);else for(const C of m){const P=D.getCell(C);P&&this.b.get(P.uri)?.cancel()}if(E.controller.interruptHandler){const C=this.c.get(D.uri);this.c.delete(D.uri),m.length&&Array.isArray(C)&&C.length&&C.forEach(P=>P.dispose())}}async $provideVariables(w,S,m,E,D,C,P){const F=this.j.get(w);if(!F)return;const T=this.n.getNotebookDocument($.URI.revive(m)),z=F.controller.variableProvider;if(!z)return;let L;if(E!==void 0){if(L=this.s[E],!L)return}else this.s={};const j=D==="named"?v.NotebookVariablesRequestKind.Named:v.NotebookVariablesRequestKind.Indexed,U=z.provideVariables(T.apiNotebook,L,j,C,P);let X=0;for await(const ie of U){if(P.isCancellationRequested)return;const q={id:this.r++,name:ie.variable.name,value:ie.variable.value,type:ie.variable.type,interfaces:ie.variable.interfaces,language:ie.variable.language,expression:ie.variable.expression,hasNamedChildren:ie.hasNamedChildren,indexedChildrenCount:ie.indexedChildrenCount,extensionId:F.extensionId.value};if(this.s[q.id]=ie.variable,this.a.$receiveVariable(S,q),X++>=i.$Aib)return}}$acceptKernelMessageFromRenderer(w,S,m){const E=this.j.get(w);if(!E)return;const D=this.n.getEditorById(S);E.onDidReceiveMessage.fire(Object.freeze({editor:D.apiEditor,message:m}))}$cellExecutionChanged(w,S,m){const D=this.n.getNotebookDocument($.URI.revive(w)).getCell(S);if(D){const C=m?y.NotebookCellExecutionState.to(m):v.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:D.apiCell,state:C})}}_createNotebookCellExecution(w,S){if(w.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const E=this.n.getNotebookDocument(w.notebook.uri).getCellFromApiCell(w);if(!E)throw new Error("invalid cell");if(this.b.has(E.uri))throw new Error(`duplicate execution for ${E.uri}`);const D=new t(S,E,this.a);this.b.set(E.uri,D);const C=D.onDidChangeState(()=>{D.state===s.Resolved&&(D.dispose(),C.dispose(),this.b.delete(E.uri))});return D.asApiObject()}_createNotebookExecution(w,S){const m=this.n.getNotebookDocument(w.uri),E=w.getCells().find(P=>{const F=m.getCellFromApiCell(P);return F&&this.b.has(F.uri)});if(E)throw new Error(`duplicate cell execution for ${E.document.uri}`);if(this.c.has(m.uri))throw new Error(`duplicate notebook execution for ${m.uri}`);const D=new r(S,m,this.a),C=D.onDidChangeState(()=>{D.state===c.Resolved&&(D.dispose(),C.dispose(),this.c.delete(m.uri))});return this.c.set(m.uri,[D,C]),D.asApiObject()}};e.$7mc=u,e.$7mc=u=He([We(4,A.$3j)],u);var s;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(s||(s={}));class t extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(w,S,m){super(),this.m=S,this.n=m,this.b=t.a++,this.c=new R.$de,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new O.$oe),this.h=new a(10,E=>this.s(E)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,w,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(w){await this.h.addItem(w)}async s(w){const S=Array.isArray(w)?w:[w];return this.n.$updateExecution(this.b,new n.$Bw(S))}t(){if(this.f===s.Init)throw new Error("Must call start before modifying cell output");if(this.f===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(w){let S=this.m;if(w&&(S=this.m.notebook.getCellFromApiCell(w)),!S)throw new Error("INVALID cell");return S.handle}y(w){return w.map(S=>{const m=v.$LN.ensureUniqueMimeTypes(S.items,!0);return m===S.items?y.NotebookCellOutput.from(S):y.NotebookCellOutput.from({items:m,id:S.id,metadata:S.metadata})})}async z(w,S,m){const E=this.w(S),D=this.y((0,h.$2b)(w));return this.r({editType:d.CellExecutionUpdateType.Output,cellHandle:E,append:m,outputs:D})}async C(w,S,m){return w=v.$LN.ensureUniqueMimeTypes((0,h.$2b)(w),!0),this.r({editType:d.CellExecutionUpdateType.OutputItems,items:w.map(y.NotebookCellOutputItem.from),outputId:S.id,append:m})}asApiObject(){const w=this;return Object.freeze({get token(){return w.g.token},get cell(){return w.m.apiCell},get executionOrder(){return w.j},set executionOrder(m){w.j=m,w.s([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:w.j}])},start(m){if(w.f===s.Resolved||w.f===s.Started)throw new Error("Cannot call start again");w.f=s.Started,w.c.fire(),w.s({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:m})},end(m,E,D){if(w.f===s.Resolved)throw new Error("Cannot call resolve twice");w.f=s.Resolved,w.c.fire(),w.h.flush();const C=D?{message:D.message,stack:D.stack,location:D?.location?{startLineNumber:D.location.start.line,startColumn:D.location.start.character,endLineNumber:D.location.end.line,endColumn:D.location.end.character}:void 0,uri:D.uri}:void 0;w.n.$completeExecution(w.b,new n.$Bw({runEndTime:E,lastRunSuccess:m,error:C}))},clearOutput(m){return w.t(),w.z([],m,!1)},appendOutput(m,E){return w.t(),w.z(m,E,!0)},replaceOutput(m,E){return w.t(),w.z(m,E,!1)},appendOutputItems(m,E){return w.t(),w.C(m,E,!0)},replaceOutputItems(m,E){return w.t(),w.C(m,E,!1)}})}}var c;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(c||(c={}));class r extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(w,S,m){super(),this.h=S,this.j=m,this.b=r.a++,this.c=new R.$de,this.onDidChangeState=this.c.event,this.f=c.Init,this.g=this.B(new O.$oe),this.j.$createNotebookExecution(this.b,w,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===c.Resolved||this.f===c.Started)throw new Error("Cannot call start again");this.f=c.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===c.Resolved)throw new Error("Cannot call resolve twice");this.f=c.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class a{constructor(w,S){this.f=w,this.g=S,this.a=[],this.b=Date.now()}addItem(w){return this.a.push(w),this.c||(this.c=new N.$Th,this.b=Date.now(),(0,N.$xh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const w=this.c;this.c=void 0;const S=this.a;return this.a=[],this.g(S).finally(()=>w.complete())}}function f(g,w){return`${g.value}/${w}`}}),define(Se[43],De([1,0,4,6,5,2,20,3,8,232,13,279,22,30,280,50,7,17,34]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=e.$imc=e.$hmc=e.$gmc=void 0,e.$gmc=(0,O.$wi)("IExtHostTerminalService");class i extends b.$Uc{constructor(m,E,D,C){super(),this.u=m,this._id=E,this.w=D,this.y=C,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new h.$de),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(F=>this.g=F);const P=this;this.value={get name(){return P.y||""},get processId(){return P.b},get creationOptions(){return P.w},get exitStatus(){return P.j},get state(){return P.m},get selection(){return P.n},get shellIntegration(){return P.shellIntegration},sendText(F,T=!0){P.C(),P.u.$sendText(P._id,F,T)},show(F){P.C(),P.u.$show(P._id,F)},hide(){P.C(),P.u.$hide(P._id)},dispose(){P.a||(P.a=!0,P.u.$dispose(P._id))},get dimensions(){if(!(P.f===void 0||P.h===void 0))return{columns:P.f,rows:P.h}}}}dispose(){this.s.fire(),super.dispose()}async create(m,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:m.name,shellPath:m.shellPath??void 0,shellArgs:m.shellArgs??void 0,cwd:m.cwd??E?.cwd??void 0,env:m.env??void 0,icon:f(m.iconPath)??void 0,color:l.ThemeColor.isThemeColor(m.color)?m.color.id:void 0,initialText:m.message??void 0,strictEnv:m.strictEnv??void 0,hideFromUser:m.hideFromUser??void 0,forceShellIntegration:E?.forceShellIntegration??void 0,isFeatureTerminal:E?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:E?.useShellEnvironment??void 0,location:E?.location||this.z(m.location,E?.resolvedExtHostIdentifier),isTransient:m.isTransient??void 0})}async createExtensionTerminal(m,E,D,C,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:C,color:l.ThemeColor.isThemeColor(P)?P.id:void 0,location:E?.location||this.z(m,D),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(m,E){return typeof m=="object"?"parentTerminal"in m&&m.parentTerminal&&E?{parentTerminal:E}:"viewColumn"in m?{viewColumn:o.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus}:void 0:m}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(m){this.y=m}setExitStatus(m,E){this.j=Object.freeze({code:m,reason:E})}setDimensions(m,E){return m===this.f&&E===this.h||m===0||E===0?!1:(this.f=m,this.h=E,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(m){this.n=m}_setProcessId(m){this.g?(this.g(m),this.g=void 0):this.b.then(E=>{E!==m&&(this.b=Promise.resolve(m))})}}e.$hmc=i;class u{get onProcessReady(){return this.b.event}constructor(m){this.g=m,this.id=0,this.shouldPersist=!1,this.a=new h.$de,this.onProcessData=this.a.event,this.b=new h.$de,this.d=new h.$de,this.onDidChangeProperty=this.d.event,this.f=new h.$de,this.onProcessExit=this.f.event}refreshProperty(m){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${m}`)}updateProperty(m,E){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${m}, value: ${E}`)}async start(){}shutdown(){this.g.close()}input(m){this.g.handleInput?.(m)}resize(m,E){this.g.setDimensions?.({columns:m,rows:E})}clearBuffer(){}async processBinary(m){}acknowledgeDataEvent(m){}async setUnicodeVersion(m){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(m){this.g.onDidWrite(E=>this.a.fire(E)),this.g.onDidClose?.((E=void 0)=>{this.f.fire(E===void 0?void 0:E)}),this.g.onDidOverrideDimensions?.(E=>{E&&this.d.fire({type:"overrideDimensions",value:{cols:E.columns,rows:E.rows}})}),this.g.onDidChangeName?.(E=>{this.d.fire({type:"title",value:E})}),this.g.open(m||void 0),m&&this.g.setDimensions?.(m),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let s=1,t=class extends b.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(m=>m.value)}constructor(m,E,D){super(),this.Q=E,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new h.$de,this.onDidCloseTerminal=this.H.event,this.I=new h.$de,this.onDidOpenTerminal=this.I.event,this.J=new h.$de,this.onDidChangeActiveTerminal=this.J.event,this.L=new h.$de,this.onDidChangeTerminalDimensions=this.L.event,this.M=new h.$de,this.onDidChangeTerminalState=this.M.event,this.N=new h.$de,this.onDidChangeShell=this.N.event,this.O=new h.$de({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new h.$de({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=D.getProxy(N.$dM.MainThreadTerminalService),this.y=new v.$Pvb(this.a.$sendProcessData),this.a.$registerProcessSupport(m),this.Q.registerArgumentProcessor({processArgument:C=>{const P=F=>{const T=F;return this.getTerminalById(T.instanceId)?.value};switch(C?.$mid){case 15:return P(C);default:{if(Array.isArray(C))for(let F=0;F<C.length&&C[F].$mid===15;F++)C[F]=P(C[F]);return C}}}}),this.B({dispose:()=>{for(const[C,P]of this.g)P.shutdown(!0)}})}getDefaultShell(m){return(m?this.u:this.s)?.path||""}getDefaultShellArgs(m){return(m?this.u:this.s)?.args||[]}createExtensionTerminal(m,E){const D=new i(this.a,(0,y.$Sg)(),m,m.name),C=new u(m.pty);return D.createExtensionTerminal(m.location,E,this.R(m,E).resolvedExtHostIdentifier,f(m.iconPath),g(m.color)).then(P=>{const F=this.S(P,C);this.h[P]=F}),this.f.push(D),D.value}R(m,E){if(E=E||{},m.location&&typeof m.location=="object"&&"parentTerminal"in m.location){const D=m.location.parentTerminal;if(D){const C=this.f.find(P=>P.value===D);C&&(E.resolvedExtHostIdentifier=C._id)}}else m.location&&typeof m.location!="object"?E.location=m.location:E.location&&typeof E.location=="object"&&"splitActiveTerminal"in E.location&&(E.location={splitActiveTerminal:!0});return E}attachPtyToTerminal(m,E){if(!this.getTerminalById(m))throw new Error(`Cannot resolve terminal with id ${m} for virtual process`);const C=new u(E),P=this.S(m,C);this.h[m]=P}async $acceptActiveTerminalChanged(m){const E=this.b;if(m===null){this.b=void 0,E!==this.b&&this.J.fire(this.b);return}const D=this.getTerminalById(m);D&&(this.b=D,E!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(m,E){const D=this.getTerminalById(m);D&&this.O.fire({terminal:D.value,data:E})}async $acceptTerminalDimensions(m,E,D){const C=this.getTerminalById(m);C&&C.setDimensions(E,D)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(m,E){const D=this.getTerminalById(m);D&&this.P.fire({terminal:D.value,...E})}async $acceptTerminalMaximumDimensions(m,E,D){this.g.get(m)?.resize(E,D)}async $acceptTerminalTitleChange(m,E){const D=this.getTerminalById(m);D&&(D.name=E)}async $acceptTerminalClosed(m,E,D){const C=this.X(this.f,m);if(C!==null){const P=this.f.splice(C,1)[0];P.setExitStatus(E,D),this.H.fire(P.value)}}$acceptTerminalOpened(m,E,D,C){if(E){const T=this.X(this.f,E);if(T!==null){this.f[T]._id=m,this.I.fire(this.terminals[T]),this.f[T].isOpen=!0;return}}const P={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:R.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},F=new i(this.a,m,P,D);this.f.push(F),this.I.fire(F.value),F.isOpen=!0}async $acceptTerminalProcessId(m,E){this.getTerminalById(m)?._setProcessId(E)}async $startExtensionTerminal(m,E){const D=this.getTerminalById(m);if(!D)return{message:(0,k.localize)(0,null,m)};D.isOpen||await new Promise(P=>{const F=this.onDidOpenTerminal(async T=>{T===D.value&&(F.dispose(),P())})});const C=this.g.get(m);C?C.startSendingEvents(E):this.j[m]={initialDimensions:E}}S(m,E){const D=new b.$Tc;D.add(E.onProcessReady(P=>this.a.$sendProcessReady(m,P.pid,P.cwd,P.windowsPty))),D.add(E.onDidChangeProperty(P=>this.a.$sendProcessProperty(m,P))),this.y.startBuffering(m,E.onProcessData),D.add(E.onProcessExit(P=>this.U(m,P))),this.g.set(m,E);const C=this.j[m];return C&&E instanceof u&&(E.startSendingEvents(C.initialDimensions),delete this.j[m]),D}$acceptProcessAckDataEvent(m,E){this.g.get(m)?.acknowledgeDataEvent(E)}$acceptProcessInput(m,E){this.g.get(m)?.input(E)}$acceptTerminalInteraction(m){const E=this.getTerminalById(m);E?.setInteractedWith()&&this.M.fire(E.value)}$acceptTerminalSelection(m,E){this.getTerminalById(m)?.setSelection(E)}$acceptProcessResize(m,E,D){try{this.g.get(m)?.resize(E,D)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(m,E){this.g.get(m)?.shutdown(E)}$acceptProcessRequestInitialCwd(m){this.g.get(m)?.getInitialCwd().then(E=>this.a.$sendProcessProperty(m,{type:"initialCwd",value:E}))}$acceptProcessRequestCwd(m){this.g.get(m)?.getCwd().then(E=>this.a.$sendProcessProperty(m,{type:"cwd",value:E}))}$acceptProcessRequestLatency(m){return Promise.resolve(m)}registerLinkProvider(m){return this.z.add(m),this.z.size===1&&this.a.$startLinkProvider(),new $.$fM(()=>{this.z.delete(m),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(m,E,D){if(this.C.has(E))throw new Error(`Terminal profile provider "${E}" already registered`);return this.C.set(E,D),this.a.$registerProfileProvider(E,m.identifier.value),new $.$fM(()=>{this.C.delete(E),this.a.$unregisterProfileProvider(E)})}registerTerminalQuickFixProvider(m,E,D){if(this.D.has(m))throw new Error(`Terminal quick fix provider "${m}" is already registered`);return this.D.set(m,D),this.a.$registerQuickFixProvider(m,E),new $.$fM(()=>{this.D.delete(m),this.a.$unregisterQuickFixProvider(m)})}async $provideTerminalQuickFixes(m,E){const D=new p.$oe().token;if(D.isCancellationRequested)return;const C=this.D.get(m);if(!C)return;const P=await C.provideTerminalQuickFixes(E,D);if(P===null||Array.isArray(P)&&P.length===0)return;const F=new b.$Tc;if(this.w.value=F,!Array.isArray(P))return P?o.TerminalQuickFix.from(P,this.Q.converter,F):void 0;const T=[];for(const z of P){const L=o.TerminalQuickFix.from(z,this.Q.converter,F);L&&T.push(L)}return T}async $createContributedProfileTerminal(m,E){const D=new p.$oe().token;let C=await this.C.get(m)?.provideTerminalProfile(D);if(!D.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${m}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,E);return}this.createTerminalFromOptions(C.options,E)}}async $provideLinks(m,E){const D=this.getTerminalById(m);if(!D)return[];this.F.delete(m),this.G.get(m)?.dispose(!0);const P=new p.$oe;this.G.set(m,P);const F=[],T={terminal:D.value,line:E},z=[];for(const U of this.z)z.push(d.Promises.withAsyncBody(async X=>{P.token.onCancellationRequested(()=>X({provider:U,links:[]}));const ie=await U.provideTerminalLinks(T,P.token)||[];P.token.isCancellationRequested||X({provider:U,links:ie})}));const L=await Promise.all(z);if(P.token.isCancellationRequested)return[];const j=new Map;for(const U of L)U&&U.links.length>0&&F.push(...U.links.map(X=>{const ie={id:s++,startIndex:X.startIndex,length:X.length,label:X.tooltip};return j.set(ie.id,{provider:U.provider,link:X}),ie}));return this.F.set(m,j),F}$activateLink(m,E){const D=this.F.get(m)?.get(E);D&&D.provider.handleTerminalLink(D.link)}U(m,E){this.y.stopBuffering(m),this.g.delete(m),delete this.j[m];const D=this.h[m];D&&(D.dispose(),delete this.h[m]),this.a.$sendProcessExit(m,E)}getTerminalById(m){return this.W(this.f,m)}getTerminalIdByApiObject(m){const E=this.f.findIndex(D=>D.value===m);return E>=0?E:null}W(m,E){const D=this.X(m,E);return D!==null?m[D]:null}X(m,E){const D=m.findIndex(C=>C._id===E);return D>=0?D:null}getEnvironmentVariableCollection(m){let E=this.n.get(m.identifier.value);return E||(E=new c,this.Z(m.identifier.value,E)),E.getScopedEnvironmentVariableCollection(void 0)}Y(m,E){const D=(0,I.$ls)(E.map),C=(0,I.$ms)(E.descriptionMap);this.a.$setEnvironmentVariableCollection(m,E.persistent,D.length===0?void 0:D,C)}$initEnvironmentVariableCollections(m){m.forEach(E=>{const D=E[0],C=new c(E[1]);this.Z(D,C)})}$acceptDefaultProfile(m,E){const D=this.s;this.s=m,this.u=E,D?.path!==m.path&&this.N.fire(m.path)}Z(m,E){this.n.set(m,E),E.onDidChangeCollection(()=>{this.Y(m,E)})}};e.$imc=t,e.$imc=t=He([We(1,n.$1O),We(2,M.$EO)],t);class c{get persistent(){return this.b}set persistent(m){this.b=m,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(m){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new h.$de,this.map=new Map(m)}getScopedEnvironmentVariableCollection(m){const E=this.h(m);let D=this.a.get(E);return D||(D=new r(this,m),this.a.set(E,D),D.onDidChangeCollection(()=>this.d.fire())),D}replace(m,E,D,C){this.f(m,{value:E,type:$.EnvironmentVariableMutatorType.Replace,options:D??{applyAtProcessCreation:!0},scope:C})}append(m,E,D,C){this.f(m,{value:E,type:$.EnvironmentVariableMutatorType.Append,options:D??{applyAtProcessCreation:!0},scope:C})}prepend(m,E,D,C){this.f(m,{value:E,type:$.EnvironmentVariableMutatorType.Prepend,options:D??{applyAtProcessCreation:!0},scope:C})}f(m,E){if(E.options&&E.options.applyAtProcessCreation===!1&&!E.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const D=this.g(m,E.scope),C=this.map.get(D),P=E.options?{applyAtProcessCreation:E.options.applyAtProcessCreation??!1,applyAtShellIntegration:E.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==E.value||C.type!==E.type||C.options?.applyAtProcessCreation!==P.applyAtProcessCreation||C.options?.applyAtShellIntegration!==P.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==E.scope?.workspaceFolder?.index){const F=this.g(m,E.scope),T={variable:m,...E,options:P};this.map.set(F,T),this.d.fire()}}get(m,E){const D=this.g(m,E),C=this.map.get(D);return C?w(C):void 0}g(m,E){const D=this.h(E);return D.length?`${m}:::${D}`:m}h(m){return this.j(m?.workspaceFolder)??""}j(m){return m?m.uri.toString():void 0}getVariableMap(m){const E=new Map;for(const[D,C]of this.map)this.h(C.scope)===this.h(m)&&E.set(C.variable,w(C));return E}delete(m,E){const D=this.g(m,E);this.map.delete(D),this.d.fire()}clear(m){if(m?.workspaceFolder){for(const[E,D]of this.map)D.scope?.workspaceFolder?.index===m.workspaceFolder.index&&this.map.delete(E);this.k(m)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(m,E){const D=this.h(E),C=this.descriptionMap.get(D);if(!C||C.description!==m){let P;typeof m=="string"?P=m:P=m?.value.split(`

`)[0];const F={description:P,scope:E};this.descriptionMap.set(D,F),this.d.fire()}}getDescription(m){const E=this.h(m);return this.descriptionMap.get(E)?.description}k(m){const E=this.h(m);this.descriptionMap.delete(E)}}class r{get persistent(){return this.b.persistent}set persistent(m){this.b.persistent=m}get onDidChangeCollection(){return this.a&&this.a.event}constructor(m,E){this.b=m,this.d=E,this.a=new h.$de}getScoped(m){return this.b.getScopedEnvironmentVariableCollection(m)}replace(m,E,D){this.b.replace(m,E,D,this.d)}append(m,E,D){this.b.append(m,E,D,this.d)}prepend(m,E,D){this.b.prepend(m,E,D,this.d)}get(m){return this.b.get(m,this.d)}forEach(m,E){this.b.getVariableMap(this.d).forEach((D,C)=>m.call(E,C,D,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(m){this.b.delete(m,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(m){this.b.setDescription(m,this.d)}get description(){return this.b.getDescription(this.d)}}let a=class extends t{constructor(m,E){super(!1,m,E)}createTerminal(m,E,D){throw new A.$_}createTerminalFromOptions(m,E){throw new A.$_}};e.$jmc=a,e.$jmc=a=He([We(0,n.$1O),We(1,M.$EO)],a);function f(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function g(S){return l.ThemeColor.isThemeColor(S)?S:void 0}function w(S){const m={...S};return delete m.scope,m.options=m.options??void 0,delete m.variable,m}}),define(Se[156],De([1,0,8,3,5,6,20,43,4,2,7]),function(he,e,h,N,O,R,M,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nnc=e.$mnc=void 0,e.$mnc=(0,O.$wi)("IExtHostTerminalShellIntegration");let I=class extends N.$Uc{constructor(d,o){super(),this.h=o,this.b=new Map,this.c=new $.$de,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$de,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$de,this.onDidEndTerminalShellExecution=this.g.event,this.a=d.getProxy(R.$dM.MainThreadTerminalShellIntegration),this.B((0,N.$Sc)(()=>{for(const[n,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(d){const o=this.h.getTerminalById(d);if(!o)return;const n=o.value;let i=this.b.get(d);i||(i=new p(o.value,this.f),this.b.set(d,i),i.store.add(o.onWillDispose(()=>this.b.get(d)?.dispose())),i.store.add(i.onDidRequestShellExecution(u=>this.a.$executeCommand(d,u))),i.store.add(i.onDidRequestEndExecution(u=>this.g.fire(u))),i.store.add(i.onDidRequestChangeShellIntegration(u=>this.c.fire(u))),o.shellIntegration=i.value),this.c.fire({terminal:n,shellIntegration:i.value})}$shellExecutionStart(d,o,n,i,u){this.b.has(d)||this.$shellIntegrationChange(d);const s={value:o,confidence:n,isTrusted:i};this.b.get(d)?.startShellExecution(s,u)}$shellExecutionEnd(d,o,n,i,u){const s={value:o,confidence:n,isTrusted:i};this.b.get(d)?.endShellExecution(s,u)}$shellExecutionData(d,o){this.b.get(d)?.emitData(o)}$cwdChange(d,o){this.b.get(d)?.setCwd((0,k.$vc)(o)?k.URI.revive(o):o)}$closeTerminal(d){this.b.get(d)?.dispose(),this.b.delete(d)}};e.$nnc=I,e.$nnc=I=He([We(0,M.$EO),We(1,b.$gmc)],I);class p extends N.$Uc{get currentExecution(){return this.a}constructor(d,o){super(),this.j=d,this.m=o,this.b=!1,this.store=this.B(new N.$Tc),this.f=this.B(new $.$de),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$de),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$de),this.onDidRequestEndExecution=this.h.event;const n=this;this.value={get cwd(){return n.c},executeCommand(i,u){let s=i;u&&(s+=` "${u.map(r=>`${r.replaceAll('"','\\"')}`).join('" "')}"`),n.g.fire(s);const t={value:s,confidence:h.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},c=n.startShellExecution(t,n.c,!0).value;return n.b=!0,c}}}startShellExecution(d,o,n){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new y(d,o);n?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(d){this.currentExecution?.emitData(d)}endShellExecution(d,o){this.a&&(this.a.endExecution(d),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:o}),this.a=void 0)}setCwd(d){let o=!1;k.URI.isUri(this.c)?o=!k.URI.isUri(d)||this.c.toString()!==d.toString():this.c!==d&&(o=!0),o&&(this.c=d,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class y{constructor(d,o){this.c=d,this.cwd=o,this.b=!1;const n=this;this.value={get commandLine(){return n.c},get cwd(){return n.cwd},read(){return n.d()}}}d(){if(!this.a){if(this.b)return A.$Wh.EMPTY;this.a=new v}return this.a.createIterable()}emitData(d){this.a?.emitData(d)}endExecution(d){d&&(this.c=d),this.a?.endExecution(),this.a=void 0,this.b=!0}}class v extends N.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new A.$vh);const d=this.a;return new A.$Wh(async n=>{this.b.push(n),await d.wait()})}emitData(d){for(const o of this.b)o.emitOne(d)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Se[358],De([1,0,7,21,22,4,75,57,3,18,30,11,6,20,155,17,8,69,113,89]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rnc=e.$qnc=e.$pnc=e.$onc=void 0;let u=class extends $.$Uc{constructor(P,F,T,z){super(),this.w=z,this.f=this.B(new R.$de),this.g=new Map,this.s=this.B(new R.$de),this.onResultsChanged=this.f.event,this.results=[],this.h=P.getProxy(p.$dM.MainThreadTesting),this.m=new S(this.h),this.j=new r(this.h,F),T.registerArgumentProcessor({processArgument:L=>{switch(L?.$mid){case 16:{const j=L,U=j.tests[j.tests.length-1].item.extId;return this.g.get(o.$2K.root(U))?.collection.tree.get(U)?.actual??(0,v.$QO)(L)}case 18:{const{test:j,message:U}=L,X=j.item.extId;return{test:this.g.get(o.$2K.root(X))?.collection.tree.get(X)?.actual??(0,v.$QO)({$mid:16,tests:[j]}),message:l.TestMessage.to(U)}}default:return L}}}),T.registerCommand(!1,"testing.getExplorerSelection",async()=>{const L=await T.executeCommand("_testing.getExplorerSelection"),j=U=>{const X=this.g.get(o.$2K.root(U));if(X)return o.$2K.isRoot(U)?X.controller:X.collection.tree.get(U)?.actual};return{include:L?.include.map(j).filter(k.$eg)||[],exclude:L?.exclude.map(j).filter(k.$eg)||[]}})}createTestController(P,F,T,z){if(this.g.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const L=new $.$Tc,j=L.add(new v.$TO(F,T,this.w));j.root.label=T;const U=new Map,X=new Set,ie=this.h,q={items:j.root.children,get label(){return T},set label(x){T=x,j.root.label=x,ie.$updateController(F,{label:T})},get refreshHandler(){return z},set refreshHandler(x){z=x,ie.$updateController(F,{canRefresh:!!x})},get id(){return F},createRunProfile:(x,ne,be,ae,Ie,ee)=>{let B=(0,b.$kj)(x);for(;U.has(B);)B++;return new E(this.h,U,X,this.s.event,F,B,x,ne,be,ae,Ie,ee)},createTestItem(x,ne,be){return new v.$RO(F,x,ne,be)},createTestRun:(x,ne,be=!0)=>this.j.createTestRun(F,j,x,ne,be),invalidateTestResults:x=>{if(x===void 0)this.h.$markTestRetired(void 0);else{const ne=x instanceof Array?x:[x];this.h.$markTestRetired(ne.map(be=>o.$2K.fromExtHostTestItem(be,F).toString()))}},set resolveHandler(x){j.resolveHandler=x},get resolveHandler(){return j.resolveHandler},dispose:()=>{L.dispose()}};ie.$registerTestController(F,T,!!z),L.add((0,$.$Sc)(()=>ie.$unregisterTestController(F)));const G={controller:q,collection:j,profiles:U,extension:P,activeProfiles:X};return this.g.set(F,G),L.add((0,$.$Sc)(()=>this.g.delete(F))),L.add(j.onDidGenerateDiff(x=>ie.$publishDiff(F,x.map(i.TestsDiffOp.serialize)))),q}createTestObserver(){return this.m.checkout()}async runTests(P,F=O.CancellationToken.None){const T=a(P);if(!T)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.g.get(T.controllerId);if(!z)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:P.preserveFocus??!0,targets:[{testIds:P.include?.map(L=>o.$2K.fromExtHostTestItem(L,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:D[T.kind],profileId:T.profileId,controllerId:T.controllerId}],exclude:P.exclude?.map(L=>L.id)},F)}$syncTests(){for(const{collection:P}of this.g.values())P.flushDiff();return Promise.resolve()}async $getCoverageDetails(P,F){return(await this.j.getCoverageDetails(P,F))?.map(l.TestCoverage.fromDetails)}async $disposeRun(P){this.j.disposeTestRun(P)}$configureRunProfile(P,F){this.g.get(P)?.profiles.get(F)?.configureHandler?.()}$setDefaultRunProfiles(P){const F=new Map;for(const[T,z]of Object.entries(P)){const L=this.g.get(T);if(!L)continue;const j=new Map,U=z.filter(ie=>!L.activeProfiles.has(ie)),X=[...L.activeProfiles].filter(ie=>!z.includes(ie));for(const ie of U)j.set(ie,!0),L.activeProfiles.add(ie);for(const ie of X)j.set(ie,!1),L.activeProfiles.delete(ie);j.size&&F.set(T,j)}this.s.fire(F)}async $refreshTests(P,F){await this.g.get(P)?.controller.refreshHandler?.(F)}$publishTestResults(P){this.results=Object.freeze(P.map(l.TestResults.to).concat(this.results).sort((F,T)=>T.completedAt-F.completedAt).slice(0,32)),this.f.fire()}async $expandTest(P,F){const T=this.g.get(o.$2K.fromString(P).controllerId)?.collection;T&&(await T.expand(P,F<0?1/0:F),T.flushDiff())}$acceptDiff(P){this.m.applyDiff(P.map(F=>i.TestsDiffOp.deserialize({asCanonicalUri:T=>T},F)))}async $runControllerTests(P,F){return Promise.all(P.map(T=>this.y(T,!1,F)))}async $startContinuousRun(P,F){const T=new O.$oe(F),z=await Promise.all(P.map(L=>this.y(L,!0,T.token)));return!F.isCancellationRequested&&!z.some(L=>L.error)&&await new Promise(L=>F.onCancellationRequested(L)),T.dispose(!0),z}async y(P,F,T){const z=this.g.get(P.controllerId);if(!z)return{};const{collection:L,profiles:j}=z,U=j.get(P.profileId);if(!U)return{};const X=P.testIds.map(x=>L.tree.get(x)).filter(k.$eg),ie=P.excludeExtIds.map(x=>z.collection.tree.get(x)).filter(k.$eg).filter(x=>X.some(ne=>ne.fullId.compare(x.fullId)===2));if(!X.length)return{};const q=new d.$SN(X.some(x=>x.actual instanceof v.$SO)?void 0:X.map(x=>x.actual),ie.map(x=>x.actual),U,F),G=(0,i.$5K)(P)&&this.j.prepareForMainThreadTestRun(q,f.fromInternal(P,z.collection),U,T);try{return await U.runHandler(q,T),{}}catch(x){return{error:String(x)}}finally{G&&G.hasRunningTasks&&!T.isCancellationRequested&&await R.Event.toPromise(G.onEnd)}}$cancelExtensionTestRun(P){P===void 0?this.j.cancelAllRuns():this.j.cancelRunById(P)}};e.$onc=u,e.$onc=u=He([We(0,y.$EO),We(1,I.$3j)],u);const s=1e4;var t;(function(C){C[C.Running=0]="Running",C[C.Cancelling=1]="Cancelling",C[C.Ended=2]="Ended"})(t||(t={}));class c extends $.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(P,F,T,z,L){super(),this.y=P,this.z=F,this.C=T,this.D=z,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$de),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new O.$oe(L));const j=this.B(new h.$Ih(()=>this.F(),s));this.B(this.j.token.onCancellationRequested(()=>j.schedule()));const U=new R.$de;this.s=U.event,this.B((0,$.$Sc)(()=>{U.fire(),U.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(P,F){const[,T,z]=o.$2K.fromString(P).path,L=this.w.get(z);if(!L)return[];const j=this.g.get(T);if(!j)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(j.run,L,F)??[]}createRun(P){const F=this.y.id,T=this.y.controllerId,z=(0,A.$Sg)(),L=ie=>(q,...G)=>{if(U){this.C.warn(`Setting the state of test "${q.id}" is a no-op after the run ends.`);return}this.y.isIncluded(q)&&(this.H(q),ie(q,...G))},j=(ie,q)=>{const G=q instanceof Array?q.map(l.TestMessage.from):[l.TestMessage.from(q)];if(ie.uri&&ie.range){const x={range:l.Range.from(ie.range),uri:ie.uri};for(const ne of G)ne.location=ne.location||x}this.z.$appendTestMessagesInRun(F,z,o.$2K.fromExtHostTestItem(ie,T).toString(),G)};let U=!1;const X={isPersisted:this.y.isPersisted,token:this.j.token,name:P,onDidDispose:this.s,addCoverage:ie=>{const q=ie.uri.toString(),G=new o.$2K([F,z,q]).toString();this.w.set(q,ie),this.z.$appendCoverage(F,z,l.TestCoverage.fromFile(G,ie))},enqueued:L(ie=>{this.z.$updateTestStateInRun(F,z,o.$2K.fromExtHostTestItem(ie,T).toString(),1)}),skipped:L(ie=>{this.z.$updateTestStateInRun(F,z,o.$2K.fromExtHostTestItem(ie,T).toString(),5)}),started:L(ie=>{this.z.$updateTestStateInRun(F,z,o.$2K.fromExtHostTestItem(ie,T).toString(),2)}),errored:L((ie,q,G)=>{j(ie,q),this.z.$updateTestStateInRun(F,z,o.$2K.fromExtHostTestItem(ie,T).toString(),6,G)}),failed:L((ie,q,G)=>{j(ie,q),this.z.$updateTestStateInRun(F,z,o.$2K.fromExtHostTestItem(ie,T).toString(),4,G)}),passed:L((ie,q)=>{this.z.$updateTestStateInRun(F,z,o.$2K.fromExtHostTestItem(ie,this.y.controllerId).toString(),3,q)}),appendOutput:(ie,q,G)=>{U||(G&&(this.y.isIncluded(G)?this.H(G):G=void 0),this.z.$appendOutputToRun(F,z,N.$Fe.fromString(ie),q&&l.location.from(q),G&&o.$2K.fromExtHostTestItem(G,T).toString()))},end:()=>{U||(U=!0,this.z.$finishedTestRunTask(F,z),--this.f||this.G())}};return this.f++,this.g.set(z,{run:X}),this.z.$startedTestRunTask(F,{id:z,name:P,running:!0}),X}F(){for(const{run:P}of this.g.values())P.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(P){if(!(P instanceof v.$RO))throw new n.$wO(P.id);if(this.h.has(o.$2K.fromExtHostTestItem(P,this.y.controllerId).toString()))return;const F=[],T=this.y.colllection.root;for(;;){const z=l.TestItem.from(P);if(F.unshift(z),this.h.has(z.extId)||(this.h.add(z.extId),P===T))break;P=P.parent||T}this.z.$addTestsToRun(this.y.controllerId,this.y.id,F)}dispose(){this.G(),super.dispose()}}class r{get trackers(){return this.c.values()}constructor(P,F){this.g=P,this.h=F,this.c=new Map,this.f=new Map}getCoverageDetails(P,F){const T=o.$2K.root(P);return this.f.get(T)?.getCoverageDetails(P,F)||[]}disposeTestRun(P){this.f.get(P)?.dispose(),this.f.delete(P);for(const[F,{id:T}]of this.c)T===P&&this.c.delete(F)}prepareForMainThreadTestRun(P,F,T,z){return this.j(P,F,T,z)}cancelRunById(P){this.f.get(P)?.cancel()}cancelAllRuns(){for(const P of this.c.values())P.cancel()}createTestRun(P,F,T,z,L){const j=this.c.get(T);if(j)return j.createRun(z);const U=f.fromPublic(P,F,T,L),X=a(T);this.g.$startedExtensionTestRun({controllerId:P,continuous:!!T.continuous,profile:X&&{group:D[X.kind],id:X.profileId},exclude:T.exclude?.map(q=>o.$2K.fromExtHostTestItem(q,F.root.id).toString())??[],id:U.id,include:T.include?.map(q=>o.$2K.fromExtHostTestItem(q,F.root.id).toString())??[F.root.id],preserveFocus:T.preserveFocus??!0,persist:L});const ie=this.j(T,U,T.profile);return R.Event.once(ie.onEnd)(()=>{this.g.$finishedExtensionTestRun(U.id)}),ie.createRun(z)}j(P,F,T,z){const L=new c(F,this.g,this.h,T,z);return this.c.set(P,L),this.f.set(L.id,L),L}}e.$pnc=r;const a=C=>{if(C.profile){if(!(C.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return C.profile}};class f{static fromPublic(P,F,T,z){return new f(P,(0,A.$Sg)(),T.include?.map(L=>o.$2K.fromExtHostTestItem(L,P).toString())??[P],T.exclude?.map(L=>o.$2K.fromExtHostTestItem(L,P).toString())??[],z,F)}static fromInternal(P,F){return new f(P.controllerId,P.runId,P.testIds,P.excludeExtIds,!0,F)}constructor(P,F,T,z,L,j){this.controllerId=P,this.id=F,this.isPersisted=L,this.colllection=j,this.c=T.map(U=>U+"\0"),this.f=z.map(U=>U+"\0")}isIncluded(P){const F=o.$2K.fromExtHostTestItem(P,this.controllerId).toString()+"\0";for(const T of this.f)if(F===T||F.startsWith(T))return!1;for(const T of this.c)if(F===T||F.startsWith(T))return!0;return!1}}e.$qnc=f;class g{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(P){this.j=P,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(P){this.c.add(P)}update(P){Object.assign(P.revived,l.TestItem.toPlain(P.item)),this.c.has(P)||this.f.add(P)}remove(P){if(this.c.has(P)){this.c.delete(P);return}this.f.delete(P);const F=o.$2K.parentId(P.item.extId);if(F&&this.h.has(F.toString())){this.h.add(P.item.extId);return}this.g.add(P)}getChangeEvent(){const{c:P,f:F,g:T}=this;return{get added(){return[...P].map(z=>z.revived)},get updated(){return[...F].map(z=>z.revived)},get removed(){return[...T].map(z=>z.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class w extends i.$$K{constructor(){super(...arguments),this.s=new R.$de,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(P){return this.f.get(P)}getMirroredTestDataByReference(P){return this.f.get(P.id)}w(P,F){return{...P,revived:l.TestItem.toPlain(P.item),depth:F?F.depth+1:0,children:new Set}}v(){return new g(this.s)}}class S{constructor(P){this.f=P}checkout(){this.c||(this.c=this.g());const P=this.c;return P.observers++,{onDidChangeTest:P.tests.onDidChangeTests,get tests(){return[...P.tests.rootTests].map(F=>F.revived)},dispose:(0,M.$db)(()=>{--P.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(P){return this.c?.tests.getMirroredTestDataByReference(P)}applyDiff(P){this.c?.tests.apply(P)}g(){const P=new w({asCanonicalUri:F=>F});return this.f.$subscribeToDiffs(),{observers:0,tests:P}}}const m=(C,P,F,T)=>{F?Object.assign(F,T):P.$updateTestRunConfig(C.controllerId,C.profileId,T)};class E{#e;#t;#n;#i;#s;get label(){return this.f}set label(P){P!==this.f&&(this.f=P,m(this,this.#e,this.#i,{label:P}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(P){P!==this.g&&(this.g=P,m(this,this.#e,this.#i,{supportsContinuousRun:P}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(P){P!==this.isDefault&&(P?this.#t.add(this.profileId):this.#t.delete(this.profileId),m(this,this.#e,this.#i,{isDefault:P}))}get tag(){return this._tag}set tag(P){P?.id!==this._tag?.id&&(this._tag=P,m(this,this.#e,this.#i,{tag:P?l.TestTag.namespace(this.controllerId,P.id):null}))}get configureHandler(){return this.c}set configureHandler(P){P!==this.c&&(this.c=P,m(this,this.#e,this.#i,{hasConfigurationHandler:!!P}))}get onDidChangeDefault(){return R.Event.chain(this.#n,P=>P.map(F=>F.get(this.controllerId)?.get(this.profileId)).filter(k.$eg))}constructor(P,F,T,z,L,j,U,X,ie,q=!1,G=void 0,x=!1){this.controllerId=L,this.profileId=j,this.f=U,this.kind=X,this.runHandler=ie,this._tag=G,this.g=x,this.#e=P,this.#s=F,this.#t=T,this.#n=z,F.set(j,this);const ne=D[X];if(typeof ne!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);q&&T.add(j),this.#i={profileId:j,controllerId:L,tag:G?l.TestTag.namespace(this.controllerId,G.id):null,label:U,group:ne,isDefault:q,hasConfigurationHandler:!1,supportsContinuousRun:x},queueMicrotask(()=>{this.#i&&(this.#e.$publishTestRunProfile(this.#i),this.#i=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#i=void 0}}e.$rnc=E;const D={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(Se[157],De([1,0,62,13,125,17,8]),function(he,e,h,N,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NO=e.$MO=e.$LO=void 0;class b{static{this.c=new O.$JO("TextEditorDecorationType")}constructor(p,y,v){const l=b.c.nextId();p.$registerTextEditorDecorationType(y.identifier,l,R.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:l,dispose(){p.$removeTextEditorDecorationType(l)}})}}e.$LO=b;class ${constructor(p,y){this.g=[],this.h=void 0,this.j=!1,this.c=p,this.d=p.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(p,y){this.k();let v=null;if(p instanceof M.$gM)v=new M.$hM(p,p);else if(p instanceof M.$hM)v=p;else throw new Error("Unrecognized location");this.l(v,y,!1)}insert(p,y){this.k(),this.l(new M.$hM(p,p),y,!0)}delete(p){this.k();let y=null;if(p instanceof M.$hM)y=p;else throw new Error("Unrecognized location");this.l(y,null,!0)}l(p,y,v){const l=this.c.validateRange(p);this.g.push({range:l,text:y,forceMoveMarkers:v})}setEndOfLine(p){if(this.k(),p!==M.EndOfLine.LF&&p!==M.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=p}}class k{constructor(p,y,v,l){this.c=p,this.d=y,this._accept(v),this.e=l;const d=this;this.value={get tabSize(){return d.f},set tabSize(o){d.n(o)},get indentSize(){return d.g},set indentSize(o){d.p(o)},get insertSpaces(){return d.j},set insertSpaces(o){d.s(o)},get cursorStyle(){return d.k},set cursorStyle(o){d.t(o)},get lineNumbers(){return d.l},set lineNumbers(o){d.u(o)}}}_accept(p){this.f=p.tabSize,this.g=p.indentSize,this.h=p.originalIndentSize,this.j=p.insertSpaces,this.k=p.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to(p.lineNumbers)}m(p){if(p==="auto")return"auto";if(typeof p=="number"){const y=Math.floor(p);return y>0?y:null}if(typeof p=="string"){const y=parseInt(p,10);return isNaN(y)?null:y>0?y:null}return null}n(p){const y=this.m(p);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}o(p){if(p==="tabSize")return"tabSize";if(typeof p=="number"){const y=Math.floor(p);return y>0?y:null}if(typeof p=="string"){const y=parseInt(p,10);return isNaN(y)?null:y>0?y:null}return null}p(p){const y=this.o(p);if(y!==null){if(typeof y=="number"){if(this.h===y)return;this.g=y,this.h=y}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}q(p){return p==="auto"?"auto":p==="false"?!1:!!p}s(p){const y=this.q(p);if(typeof y=="boolean"){if(this.j===y)return;this.j=y}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}t(p){this.k!==p&&(this.k=p,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:p})))}u(p){this.l!==p&&(this.l=p,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(p)})))}assign(p){const y={};let v=!1;if(typeof p.tabSize<"u"){const l=this.m(p.tabSize);l==="auto"?(v=!0,y.tabSize=l):typeof l=="number"&&this.f!==l&&(this.f=l,v=!0,y.tabSize=l)}if(typeof p.indentSize<"u"){const l=this.o(p.indentSize);l==="tabSize"?(v=!0,y.indentSize=l):typeof l=="number"&&this.h!==l&&(this.g=l,this.h=l,v=!0,y.indentSize=l)}if(typeof p.insertSpaces<"u"){const l=this.q(p.insertSpaces);l==="auto"?(v=!0,y.insertSpaces=l):this.j!==l&&(this.j=l,v=!0,y.insertSpaces=l)}typeof p.cursorStyle<"u"&&this.k!==p.cursorStyle&&(this.k=p.cursorStyle,v=!0,y.cursorStyle=p.cursorStyle),typeof p.lineNumbers<"u"&&this.l!==p.lineNumbers&&(this.l=p.lineNumbers,v=!0,y.lineNumbers=R.TextEditorLineNumbersStyle.from(p.lineNumbers)),v&&this.v("setOptions",this.c.$trySetOptions(this.d,y))}v(p,y){y.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this.e.warn(v)})}}e.$MO=k;class A{constructor(p,y,v,l,d,o,n,i){this.id=p,this.j=y,this.k=v,this.g=!1,this.h=new Set,this.c=d,this.d=new k(this.j,this.id,o,v),this.e=n,this.f=i;const u=this;this.value=Object.freeze({get document(){return l.value},set document(s){throw new N.$9("document")},get selection(){return u.c&&u.c[0]},set selection(s){if(!(s instanceof M.$iM))throw(0,N.$7)("selection");u.c=[s],u.l()},get selections(){return u.c},set selections(s){if(!Array.isArray(s)||s.some(t=>!(t instanceof M.$iM)))throw(0,N.$7)("selections");u.c=s,u.l()},get visibleRanges(){return u.e},set visibleRanges(s){throw new N.$9("visibleRanges")},get options(){return u.d.value},set options(s){u.g||u.d.assign(s)},get viewColumn(){return u.f},set viewColumn(s){throw new N.$9("viewColumn")},edit(s,t={undoStopBefore:!0,undoStopAfter:!0}){if(u.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const c=new $(l.value,t);return s(c),u.m(c)},insertSnippet(s,t,c={undoStopBefore:!0,undoStopAfter:!0}){if(u.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=u.c.map(a=>R.Range.from(a));else if(t instanceof M.$gM){const{lineNumber:a,column:f}=R.Position.from(t);r=[{startLineNumber:a,startColumn:f,endLineNumber:a,endColumn:f}]}else if(t instanceof M.$hM)r=[R.Range.from(t)];else{r=[];for(const a of t)if(a instanceof M.$hM)r.push(R.Range.from(a));else{const{lineNumber:f,column:g}=R.Position.from(a);r.push({startLineNumber:f,startColumn:g,endLineNumber:f,endColumn:g})}}return y.$tryInsertSnippet(p,l.value.version,s.value,r,c)},setDecorations(s,t){const c=t.length===0;c&&!u.h.has(s.key)||(c?u.h.delete(s.key):u.h.add(s.key),u.n(()=>{if(R.$BO(t))return y.$trySetDecorations(p,s.key,R.$CO(t));{const r=new Array(4*t.length);for(let a=0,f=t.length;a<f;a++){const g=t[a];r[4*a]=g.start.line+1,r[4*a+1]=g.start.character+1,r[4*a+2]=g.end.line+1,r[4*a+3]=g.end.character+1}return y.$trySetDecorationsFast(p,s.key,r)}}))},revealRange(s,t){u.n(()=>y.$tryRevealRange(p,R.Range.from(s),t||M.TextEditorRevealType.Default))},show(s){y.$tryShowEditor(p,R.ViewColumn.from(s))},hide(){y.$tryHideEditor(p)}})}dispose(){(0,h.ok)(!this.g),this.g=!0}_acceptOptions(p){(0,h.ok)(!this.g),this.d._accept(p)}_acceptVisibleRanges(p){(0,h.ok)(!this.g),this.e=p}_acceptViewColumn(p){(0,h.ok)(!this.g),this.f=p}_acceptSelections(p){(0,h.ok)(!this.g),this.c=p}async l(){const p=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,p)),this.value}m(p){const y=p.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const v=y.edits.map(d=>d.range);v.sort((d,o)=>d.end.line===o.end.line?d.end.character===o.end.character?d.start.line===o.start.line?d.start.character-o.start.character:d.start.line-o.start.line:d.end.character-o.end.character:d.end.line-o.end.line);for(let d=0,o=v.length-1;d<o;d++){const n=v[d].end;if(v[d+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=y.edits.map(d=>({range:R.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,l,{setEndOfLine:typeof y.setEndOfLine=="number"?R.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n(p){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.$NO=A}),define(Se[73],De([1,0,62,4,3,2,5,6,153,20,157,17,11,27,15,39,46]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PO=e.$OO=void 0;class o{constructor(u){this.value=u,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(u,s){this.h=u,this.i=s,this.a=null,this.b=new Map,this.c=new y.$Ac,this.d=new N.$de,this.e=new N.$de,this.f=new N.$de,this.g=new N.$de,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const s=[],t=[],c=[];if(u.removedDocuments)for(const r of u.removedDocuments){const a=R.URI.revive(r),f=this.c.get(a);f?.unref()&&(this.c.delete(a),s.push(f.value))}if(u.addedDocuments)for(const r of u.addedDocuments){const a=R.URI.revive(r.uri);let f=this.c.get(a);if(f&&a.scheme!==v.Schemas.vscodeNotebookCell&&a.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${a} already exists!'`);f||(f=new o(new $.$HO(this.h.getProxy(b.$dM.MainThreadDocuments),a,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty)),this.c.set(a,f),t.push(f.value)),f.ref()}if(u.removedEditors)for(const r of u.removedEditors){const a=this.b.get(r);this.b.delete(r),a&&c.push(a)}if(u.addedEditors)for(const r of u.addedEditors){const a=R.URI.revive(r.documentUri);h.ok(this.c.has(a),`document '${a}' does not exist`),h.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const f=this.c.get(a).value,g=new A.$NO(r.id,this.h.getProxy(b.$dM.MainThreadTextEditors),this.i,new d.$V(()=>f.document),r.selections.map(I.Selection.to),r.options,r.visibleRanges.map(w=>I.Range.to(w)),typeof r.editorPosition=="number"?I.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,g)}u.newActiveEditor!==void 0&&(h.ok(u.newActiveEditor===null||this.b.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this.a=u.newActiveEditor),(0,O.$Pc)(s),(0,O.$Pc)(c),u.removedDocuments&&this.e.fire(s),u.addedDocuments&&this.d.fire(t),(u.removedEditors||u.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),u.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(u){return this.c.get(u)?.value}allDocuments(){return l.Iterable.map(this.c.values(),u=>u.value)}getEditor(u){return this.b.get(u)}activeEditor(u){if(!this.a)return;const s=this.b.get(this.a);return u?s:s?.value}allEditors(){return[...this.b.values()]}};e.$OO=n,e.$OO=n=He([We(0,k.$EO),We(1,p.$3j)],n),e.$PO=(0,M.$wi)("IExtHostDocumentsAndEditors")}),define(Se[359],De([1,0,19,4,6,157,17,8]),function(he,e,h,N,O,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Llc=void 0;class ${constructor(A,I){this.i=I,this.a=new N.$de,this.b=new N.$de,this.c=new N.$de,this.d=new N.$de,this.f=new N.$de,this.g=new N.$de,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(O.$dM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const I=this.i.allEditors();return A?I:I.map(p=>p.value)}async showTextDocument(A,I,p){let y;typeof I=="number"?y={position:M.ViewColumn.from(I),preserveFocus:p}:typeof I=="object"?y={position:M.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?M.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:y={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(A.uri,y),l=v&&this.i.getEditor(v);if(l)return l.value;throw v?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,I){return new R.$LO(this.h,A,I).value}$acceptEditorPropertiesChanged(A,I){const p=this.i.getEditor(A);if(!p)throw new Error("unknown text editor");if(I.options&&p._acceptOptions(I.options),I.selections){const y=I.selections.selections.map(M.Selection.to);p._acceptSelections(y)}if(I.visibleRanges){const y=h.$Hb(I.visibleRanges.map(M.Range.to));p._acceptVisibleRanges(y)}if(I.options&&this.b.fire({textEditor:p.value,options:{...I.options,lineNumbers:M.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const y=b.TextEditorSelectionChangeKind.fromValue(I.selections.source),v=I.selections.selections.map(M.Selection.to);this.a.fire({textEditor:p.value,selections:v,kind:y})}if(I.visibleRanges){const y=h.$Hb(I.visibleRanges.map(M.Range.to));this.c.fire({textEditor:p.value,visibleRanges:y})}}$acceptEditorPositionData(A){for(const I in A){const p=this.i.getEditor(I);if(!p)throw new Error("Unknown text editor");const y=M.ViewColumn.to(A[I]);p.value.viewColumn!==y&&(p._acceptViewColumn(y),this.d.fire({textEditor:p.value,viewColumn:y}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$Llc=$}),define(Se[360],De([1,0,2,5,6,3,8,17,25,18]),function(he,e,h,N,O,R,M,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=e.$tnc=void 0,e.$tnc=(0,N.$wi)("IExtHostTimeline");class A{constructor(y,v){this.b=new Map,this.c=new Map,this.a=y.getProxy(O.$dM.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(l,d)=>{if(l&&l.$mid===12)if(this.b.get(l.source)&&$.$Rm.equals(d,this.b.get(l.source)?.extension)){const o=l.uri===void 0?void 0:h.URI.revive(l.uri);return this.c.get(l.source)?.get(I(o))?.get(l.handle)}else return;return l}})}async $getTimeline(y,v,l,d){return this.b.get(y)?.provider.provideTimeline(h.URI.revive(v),l,d)}registerTimelineProvider(y,v,l,d){const o=new R.$Tc,n=this.d(v.id,d,o).bind(this);let i;v.onDidChange&&(i=v.onDidChange(s=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...s,id:v.id}),this));const u=this.c;return this.f({...v,scheme:y,onDidChange:void 0,async provideTimeline(s,t,c){t?.resetCache&&(o.clear(),u.get(v.id)?.clear());const r=await v.provideTimeline(s,t,c);if(r==null)return;const a=n(s,t);return{...r,source:v.id,items:r.items.map(a)}},dispose(){for(const s of u.values())s.get(v.id)?.clear();i?.dispose(),o.dispose()}},l)}d(y,v,l){return(d,o)=>{let n;if(o?.cacheResults){let i=this.c.get(y);i===void 0&&(i=new Map,this.c.set(y,i));const u=I(d);n=i.get(u),n===void 0&&(n=new Map,i.set(u,n))}return i=>{const{iconPath:u,...s}=i,t=`${y}|${i.id??i.timestamp}`;n?.set(t,i);let c,r,a;i.iconPath&&(u instanceof M.$cN?a={id:u.id,color:u.color}:h.URI.isUri(u)?(c=u,r=u):{light:c,dark:r}=u);let f;return M.$HM.isMarkdownString(s.tooltip)?f=b.MarkdownString.from(s.tooltip):(0,k.$9f)(s.tooltip)?f=s.tooltip:M.$HM.isMarkdownString(s.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),f=b.MarkdownString.from(s.detail)):(0,k.$9f)(s.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),f=s.detail),{...s,id:s.id??void 0,handle:t,source:y,command:i.command?v.toInternal(i.command,l):void 0,icon:c,iconDark:r,themeIcon:a,tooltip:f,accessibilityInformation:i.accessibilityInformation}}}}f(y,v){if(this.b.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this.a.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this.b.set(y.id,{provider:y,extension:v}),(0,R.$Sc)(()=>{for(const d of this.c.values())d.get(y.id)?.clear();this.b.delete(y.id),this.a.$unregisterTimelineProvider(y.id),y.dispose()})}}e.$unc=A;function I(p){return p?.toString()}}),define(Se[361],De([1,0,233,23,2,4,3,294,7,8,18,19,17,81,22,189,26]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vnc=void 0;function o(u,s){if((0,A.$9f)(u))return{label:u};if(u&&typeof u=="object"&&typeof u.label=="string"){let t;return Array.isArray(u.highlights)&&(t=u.highlights.filter(c=>c.length===2&&typeof c[0]=="number"&&typeof c[1]=="number"),t=t.length?t:void 0),{label:u.label,highlights:t}}}class n extends M.$Uc{constructor(s,t,c){super(),this.f=s,this.g=t,this.h=c,this.a=new Map,this.b=new l.$A0;function r(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:a=>r(a)?this.r(a):Array.isArray(a)&&a.length>0?a.map(f=>r(f)?this.r(f):f):a})}registerTreeDataProvider(s,t,c){const r=this.createTreeView(s,{treeDataProvider:t},c);return{dispose:()=>r.dispose()}}createTreeView(s,t,c){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],a=t.dragAndDropController?.dragMimeTypes??[],f=!!t.dragAndDropController?.handleDrag,g=!!t.dragAndDropController?.handleDrop,w=this.m(s,t,c),S={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:a,hasHandleDrag:f,hasHandleDrop:g,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},m=this.f.$registerTreeViewDataProvider(s,S),E={get onDidCollapseElement(){return w.onDidCollapseElement},get onDidExpandElement(){return w.onDidExpandElement},get selection(){return w.selectedElements},get onDidChangeSelection(){return w.onDidChangeSelection},get activeItem(){return(0,d.$PG)(c,"treeViewActiveItem"),w.focusedElement},get onDidChangeActiveItem(){return(0,d.$PG)(c,"treeViewActiveItem"),w.onDidChangeActiveItem},get visible(){return w.visible},get onDidChangeVisibility(){return w.onDidChangeVisibility},get onDidChangeCheckboxState(){return w.onDidChangeCheckboxState},get message(){return w.message},set message(D){(0,y.$Vk)(D)&&(0,d.$PG)(c,"treeViewMarkdownMessage"),w.message=D},get title(){return w.title},set title(D){w.title=D},get description(){return w.description},set description(D){w.description=D},get badge(){return w.badge},set badge(D){D!==void 0&&k.ViewBadge.isViewBadge(D)?w.badge={value:Math.floor(Math.abs(D.value)),tooltip:D.tooltip}:D===void 0&&(w.badge=void 0)},reveal:(D,C)=>w.reveal(D,C),dispose:async()=>{await m,this.a.delete(s),w.dispose()}};return this.B(E),E}$getChildren(s,t){const c=this.a.get(s);return c?c.getChildren(t):Promise.reject(new b.$4F(s))}async $handleDrop(s,t,c,r,a,f,g,w){const S=this.a.get(s);if(!S)return Promise.reject(new b.$4F(s));const m=p.DataTransfer.toDataTransfer(c,async E=>(await this.f.$resolveDropFileData(s,t,E)).buffer);return g===s&&w&&await this.j(m,S,w,a,f),S.onDrop(m,r,a)}async j(s,t,c,r,a){const f=this.b.removeDragOperationTransfer(a);if(f)(await f)?.forEach((g,w)=>{g&&s.set(w,g)});else if(a&&t.handleDrag){const g=t.handleDrag(c,s,r);this.b.addDragOperationTransfer(a,g),await g}return s}async $handleDrag(s,t,c,r){const a=this.a.get(s);if(!a)return Promise.reject(new b.$4F(s));const f=await this.j(new k.$$M,a,t,r,c);if(!(!f||r.isCancellationRequested))return p.DataTransfer.from(f)}async $hasResolve(s){const t=this.a.get(s);if(!t)throw new b.$4F(s);return t.hasResolve}$resolve(s,t,c){const r=this.a.get(s);if(!r)throw new b.$4F(s);return r.resolveTreeItem(t,c)}$setExpanded(s,t,c){const r=this.a.get(s);if(!r)throw new b.$4F(s);r.setExpanded(t,c)}$setSelectionAndFocus(s,t,c){const r=this.a.get(s);if(!r)throw new b.$4F(s);r.setSelectionAndFocus(t,c)}$setVisible(s,t){const c=this.a.get(s);if(!c){if(!t)return;throw new b.$4F(s)}c.setVisible(t)}$changeCheckboxState(s,t){const c=this.a.get(s);if(!c)throw new b.$4F(s);c.setCheckboxState(t)}m(s,t,c){const r=this.B(new i(s,t,this.f,this.g.converter,this.h,c));return this.a.set(s,r),r}r(s){const t=this.a.get(s.$treeViewId);return t&&"$treeItemHandle"in s?t.getExtensionElement(s.$treeItemHandle):t&&"$focusedTreeItem"in s&&s.$focusedTreeItem?t.focusedElement:null}}e.$vnc=n;class i extends M.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(s=>this.getExtensionElement(s)).filter(s=>!(0,A.$fg)(s))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(s,t,c,r,a,f){if(super(),this.I=s,this.J=c,this.L=r,this.M=a,this.N=f,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$de),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$de),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$de),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$de),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$de),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$de),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$de),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$oe,f.contributes&&f.contributes.views)for(const m in f.contributes.views)for(const E of f.contributes.views[m])E.id===s&&(this.P=E.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(m=>{Array.isArray(m)&&m.length===0||this.F.fire({message:!1,element:m})}));let g,w;const S=R.Event.debounce(this.F.event,(m,E)=>(m||(m={message:!1,elements:[]}),E.element!==!1&&(g||(g=new Promise(D=>w=D),this.G=this.G.then(()=>g)),Array.isArray(E.element)?m.elements.push(...E.element):m.elements.push(E.element)),E.message&&(m.message=!0),m),200,!0);this.B(S(({message:m,elements:E})=>{E.length&&(this.H=this.H.then(()=>{const D=w;return g=null,this.$(E).then(()=>D())})),m&&this.J.$setMessage(this.I,p.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(s){const t=s?this.getExtensionElement(s):void 0;if(s&&!t)return this.M.error(`No tree item with id '${s}' found.`),Promise.resolve([]);let c=this.X(s);return c||(c=await this.Y(t)),c?c.map(r=>r.item):void 0}getExtensionElement(s){return this.j.get(s)}reveal(s,t){t=t||{select:!0,focus:!1};const c=(0,A.$fg)(t.select)?!0:t.select,r=(0,A.$fg)(t.focus)?!1:t.focus,a=(0,A.$fg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):s?this.G.then(()=>this.S(s)).then(f=>this.W(s,f[f.length-1]).then(g=>this.J.$reveal(this.I,{item:g.item,parentChain:f.map(w=>w.item)},{select:c,focus:r,expand:a})),f=>this.M.error(f)):this.J.$reveal(this.I,void 0,{select:c,focus:r,expand:a})}get message(){return this.O}set message(s){this.O=s,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(s){this.P=s,this.J.$setTitle(this.I,s,this.Q)}get description(){return this.Q}set description(s){this.Q=s,this.J.$setTitle(this.I,this.P,s)}get badge(){return this.R}set badge(s){this.R?.value===s?.value&&this.R?.tooltip===s?.tooltip||(this.R=p.ViewBadge.from(s),this.J.$setBadge(this.I,s))}setExpanded(s,t){const c=this.getExtensionElement(s);c&&(t?this.u.fire(Object.freeze({element:c})):this.w.fire(Object.freeze({element:c})))}setSelectionAndFocus(s,t){const c=!(0,I.$ub)(this.s,s);this.s=s;const r=this.t!==t;this.t=t,c&&this.y.fire(Object.freeze({selection:this.selectedElements})),r&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(s){s!==this.r&&(this.r=s,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(s){const t=(await Promise.all(s.map(async c=>{const r=this.getExtensionElement(c.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:c.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(c=>c!==void 0);t.forEach(c=>{c.treeItem.checkboxState=c.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(c=>[c.extensionItem,c.newState])})}async handleDrag(s,t,c){const r=[];for(const a of s){const f=this.getExtensionElement(a);f&&r.push(f)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,t,c),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(s,t,c){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.g?.handleDrop))return(0,$.$oh)(()=>this.g?.handleDrop?this.g.handleDrop(r,s,c):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(s,t){if(!this.f.resolveTreeItem)return;const c=this.j.get(s);if(c){const r=this.m.get(c);if(r){const a=await this.f.resolveTreeItem(r.extensionItem,c,t)??r.extensionItem;return this.hb(a),r.item.tooltip=this.eb(a.tooltip),r.item.command=this.fb(r.disposableStore,a.command),r.item}}}S(s){return this.U(s).then(t=>t?this.S(t).then(c=>this.W(t,c[c.length-1]).then(r=>(c.push(r),c))):Promise.resolve([]))}U(s){const t=this.m.get(s);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$oh)(()=>this.f.getParent(s))}W(s,t){const c=this.m.get(s);return c?Promise.resolve(c):(0,$.$oh)(()=>this.f.getTreeItem(s)).then(r=>this.kb(s,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const a=this.getExtensionElement(r);if(a){const f=this.m.get(a);if(f)return Promise.resolve(f)}throw new Error(`Cannot resolve tree item for element ${r} from extension ${this.N.identifier.value}`)}))}X(s){if(s){let t;if(typeof s=="string"){const c=this.getExtensionElement(s);t=c?this.m.get(c):void 0}else t=s;return t&&t.children||void 0}return this.h}async Y(s){this.rb(s);const t=new v.$oe(this.Z.token);try{const c=s?this.m.get(s):void 0,r=await this.f.getChildren(s);if(t.token.isCancellationRequested)return;const a=(0,I.$Hb)(r||[]),f=await Promise.all((0,I.$Hb)(a).map(w=>this.f.getTreeItem(w)));if(t.token.isCancellationRequested)return;const g=f.map((w,S)=>w?this.db(a[S],w,c):null);return(0,I.$Hb)(g)}finally{t.dispose()}}$(s){if(s.some(c=>!c))return this.Z.dispose(!0),this.Z=new v.$oe,this.tb(),this.J.$refresh(this.I);{const c=this.ab(s);if(c.length)return this.bb(c)}return Promise.resolve(void 0)}ab(s){const t=new Set,c=s.map(a=>this.m.get(a));for(const a of c)if(a&&!t.has(a.item.handle)){let f=a;for(;f&&f.parent&&c.findIndex(g=>f&&f.parent&&g&&g.item.handle===f.parent.item.handle)===-1;){const g=this.j.get(f.parent.item.handle);f=g?this.m.get(g):void 0}f&&!f.parent&&t.add(a.item.handle)}const r=[];return t.forEach(a=>{const f=this.j.get(a);if(f){const g=this.m.get(f);g&&(!g.parent||!t.has(g.parent.item.handle))&&r.push(a)}}),r}bb(s){const t={};return Promise.all(s.map(c=>this.cb(c).then(r=>{r&&(t[c]=r.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(s){const t=this.getExtensionElement(s);if(t){const c=this.m.get(t);if(c)return this.rb(t),(0,$.$oh)(()=>this.f.getTreeItem(t)).then(r=>{if(r){const a=this.ib(t,r,c.parent);return this.pb(t,a,c,c.parent),c.dispose(),a}return null})}return Promise.resolve(null)}db(s,t,c){const r=this.ib(s,t,c);if(t.id&&this.j.has(r.item.handle))throw new Error((0,h.localize)(0,null,t.id));return this.ob(s,r),this.qb(r,c),r}eb(s){return k.$HM.isMarkdownString(s)?p.MarkdownString.from(s):s}fb(s,t){return t?{...this.L.toInternal(t,s),originalId:t.command}:void 0}gb(s){if(s.checkboxState===void 0)return;let t,c,r;return typeof s.checkboxState=="number"?t=s.checkboxState:(t=s.checkboxState.state,c=s.checkboxState.tooltip,r=s.checkboxState.accessibilityInformation),{isChecked:t===k.TreeItemCheckboxState.Checked,tooltip:c,accessibilityInformation:r}}hb(s){if(!k.$6M.isTreeItem(s,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(s,t,c){this.hb(t);const r=this.B(new M.$Tc),a=this.kb(s,t,c),f=this.lb(t);return{item:{handle:a,parentHandle:c?c.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(r,t.command),contextValue:t.contextValue,icon:f,iconDark:this.mb(t)||f,themeIcon:this.jb(t),collapsibleState:(0,A.$fg)(t.collapsibleState)?k.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:c,children:void 0,disposableStore:r,dispose(){r.dispose()}}}jb(s){return s.iconPath instanceof k.$cN?s.iconPath:void 0}kb(s,{id:t,label:c,resourceUri:r},a,f){if(t)return`${i.b}/${t}`;const g=o(c,this.N),w=a?a.item.handle:i.a;let S=g?g.label:r?(0,N.$7g)(r):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const m=this.m.has(s)?this.m.get(s).item.handle:void 0,E=this.X(a)||[];let D,C=0;do{if(D=`${w}/${C}:${S}`,f||!this.j.has(D)||m===D)break;C++}while(C<=E.length);return D}lb(s){if(s.iconPath&&!(s.iconPath instanceof k.$cN))return typeof s.iconPath=="string"||O.URI.isUri(s.iconPath)?this.nb(s.iconPath):this.nb(s.iconPath.light)}mb(s){if(s.iconPath&&!(s.iconPath instanceof k.$cN)&&s.iconPath.dark)return this.nb(s.iconPath.dark)}nb(s){return O.URI.isUri(s)?s:O.URI.file(s)}ob(s,t){this.j.set(t.item.handle,s),this.m.set(s,t)}pb(s,t,c,r){this.j.delete(t.item.handle),this.m.delete(s),t.item.handle!==c.item.handle&&this.j.delete(c.item.handle),this.ob(s,t);const a=this.X(r)||[],f=a.filter(g=>g.item.handle===c.item.handle)[0];f&&a.splice(a.indexOf(f),1,t)}qb(s,t){t?(t.children||(t.children=[]),t.children.push(s)):(this.h||(this.h=[]),this.h.push(s))}rb(s){if(s){const t=this.m.get(s);if(t){if(t.children)for(const c of t.children){const r=this.j.get(c.item.handle);r&&this.sb(r)}t.children=void 0}}else this.tb()}sb(s){const t=this.m.get(s);if(t){if(t.children)for(const c of t.children){const r=this.j.get(c.item.handle);r&&this.sb(r)}this.m.delete(s),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(s=>s.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Se[362],De([1,0,4,3,2,30,17,92,6,8]),function(he,e,h,N,O,R,M,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=void 0;class A extends N.$Uc{#e;#t;#n;#i;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(v,l,d,o){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new h.$de),this.onDidDispose=this.#d.event,this.#h=this.B(new h.$de),this.onDidChangeViewState=this.#h.event,this.#e=v,this.#t=l,this.#i=d,this.#n=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#i.dispose(),super.dispose())}get webview(){return this.c(),this.#i}get viewType(){return this.c(),this.#n}get title(){return this.c(),this.#r}set title(v){this.c(),this.#r!==v&&(this.#r=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.c(),this.#a}set iconPath(v){this.c(),this.#a!==v&&(this.#a=v,this.#t.$setIconPath(this.#e,O.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(v){this.#l||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#u=v.active,this.#c=v.visible,this.#o=v.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(v,l){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:M.ViewColumn.from(v),preserveFocus:!!l})}c(){if(this.#l)throw new Error("Webview is disposed")}}class I extends N.$Uc{static c(){return(0,R.$Sg)()}constructor(v,l,d){super(),this.j=l,this.m=d,this.g=new Map,this.h=new Map,this.f=v.getProxy($.$dM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(v=>v.dispose()),this.g.clear()}createWebviewPanel(v,l,d,o,n={}){const i=typeof o=="object"?o.viewColumn:o,u={viewColumn:M.ViewColumn.from(i),preserveFocus:typeof o=="object"&&!!o.preserveFocus},s=(0,b.$1lc)(v),t=I.c();this.f.$createWebviewPanel((0,b.$3lc)(v),t,l,{title:d,panelOptions:p(n),webviewOptions:(0,b.$4lc)(v,this.m,n),serializeBuffersForPostMessage:s},u);const c=this.j.createNewWebview(t,n,v);return this.createNewWebviewPanel(t,l,d,i,n,c,!0)}$onDidChangeWebviewPanelViewStates(v){const l=Object.keys(v);l.sort((d,o)=>{const n=v[d],i=v[o];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const d of l){const o=this.getWebviewPanel(d);if(!o)continue;const n=v[d];o._updateViewState({active:n.active,visible:n.visible,viewColumn:M.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.g.delete(v),this.j.deleteWebview(v)}registerWebviewPanelSerializer(v,l,d){if(this.h.has(l))throw new Error(`Serializer for '${l}' already registered`);return this.h.set(l,{serializer:d,extension:v}),this.f.$registerSerializer(l,{serializeBuffersForPostMessage:(0,b.$1lc)(v)}),new k.$fM(()=>{this.h.delete(l),this.f.$unregisterSerializer(l)})}async $deserializeWebviewPanel(v,l,d,o){const n=this.h.get(l);if(!n)throw new Error(`No serializer found for '${l}'`);const{serializer:i,extension:u}=n,s=this.j.createNewWebview(v,d.webviewOptions,u),t=this.createNewWebviewPanel(v,l,d.title,o,d.panelOptions,s,d.active);await i.deserializeWebviewPanel(t,d.state)}createNewWebviewPanel(v,l,d,o,n,i,u){const s=new A(v,this.f,i,{viewType:l,title:d,viewColumn:o,panelOptions:n,active:u});return this.g.set(v,s),s}getWebviewPanel(v){return this.g.get(v)}}e.$5lc=I;function p(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}}),define(Se[363],De([1,0,4,3,92,17,6,8]),function(he,e,h,N,O,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ync=void 0;class $ extends N.$Uc{#e;#t;#n;#i;#s;#r;#a;#o;#c;constructor(I,p,y,v,l,d){super(),this.#s=!1,this.#u=this.B(new h.$de),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new h.$de),this.onDidDispose=this.#l.event,this.#n=y,this.#a=v,this.#e=I,this.#t=p,this.#i=l,this.#r=d}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#i.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(I){this.a(),this.#a!==I&&(this.#a=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.a(),this.#o}set description(I){this.a(),this.#o!==I&&(this.#o=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#r}get webview(){return this.#i}get viewType(){return this.#n}_setVisible(I){I===this.#r||this.#s||(this.#r=I,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(I){this.a(),!(I?.value===this.#c?.value&&I?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.a(),this.#t.$show(this.#e,!!I)}a(){if(this.#s)throw new Error("Webview is disposed")}}class k{constructor(I,p){this.d=p,this.b=new Map,this.c=new Map,this.a=I.getProxy(M.$dM.MainThreadWebviewViews)}registerWebviewViewProvider(I,p,y,v){if(this.b.has(p))throw new Error(`View provider for '${p}' already registered`);return this.b.set(p,{provider:y,extension:I}),this.a.$registerWebviewViewProvider((0,O.$3lc)(I),p,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,O.$1lc)(I)}),new b.$fM(()=>{this.b.delete(p),this.a.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(I,p,y,v,l){const d=this.b.get(p);if(!d)throw new Error(`No view provider found for '${p}'`);const{provider:o,extension:n}=d,i=this.d.createNewWebview(I,{},n),u=new $(I,this.a,p,y,i,!0);this.c.set(I,u),await o.resolveWebviewView(u,{state:v},l)}async $onDidChangeWebviewViewVisibility(I,p){this.e(I)._setVisible(p)}async $disposeWebviewView(I){const p=this.e(I);this.c.delete(I),p.dispose(),this.d.deleteWebview(I)}e(I){const p=this.c.get(I);if(!p)throw new Error("No webview found");return p}}e.$ync=k}),define(Se[364],De([1,0,70,15,11,265,33,12]),function(he,e,h,N,O,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$doc=void 0;let $=class{constructor(I,p){I.addFileSystemProvider(N.Schemas.file,new k(p),{isCaseSensitive:b.$k})}};e.$doc=$,e.$doc=$=He([We(0,h.$Wlc),We(1,O.$3j)],$);class k{constructor(I){this.b=I,this.a=new R.$_q(this.b)}async stat(I){const p=await this.a.stat(I);return{type:p.type,ctime:p.ctime,mtime:p.mtime,size:p.size,permissions:p.permissions===M.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,p,y){return this.a.writeFile(I,p,{...y,unlock:!1,atomic:!1})}delete(I,p){return this.a.delete(I,{...p,useTrash:!1,atomic:!1})}rename(I,p,y){return this.a.rename(I,p,y)}copy(I,p,y){return this.a.copy(I,p,y)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,p){throw new Error("Method not implemented.")}}}),define(Se[365],De([1,0,16,64,30,34,3,6,2,20]),function(he,e,h,N,O,R,M,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$boc=void 0;let A=class extends M.$Uc{constructor(p,y){super();const v=p.getProxy(b.$dM.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async l=>{const d=$.URI.file((0,h.$jc)((0,N.tmpdir)(),(0,O.$Sg)()));return await v.$download(l,d),d})}};e.$boc=A,e.$boc=A=He([We(0,k.$EO),We(1,R.$1O)],A)}),define(Se[366],De([1,0,53,16,2,93,3,15,7,32]),function(he,e,h,N,O,R,M,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$noc=void 0;class A extends R.$Ylc{constructor(){super(...arguments),this.i=null}async g(t){const c=await super.g(t);if(c.scheme!==b.Schemas.file)return c;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${c.fsPath}.`),c;const r=c.fsPath;let a=0;do{let f;a===0?f=r:f=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${a}`:`${r}-${a}`,await I(f);const g=N.$jc(f,"vscode.lock"),w=await l(this.d,g,!1);if(w)return this.i=w,process.on("exit",()=>{w.dispose()}),O.URI.file(f);a++}while(a<10);return c}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$noc=A;async function I(s){try{await k.Promises.stat(s);return}catch{}try{await k.Promises.mkdir(s,{recursive:!0})}catch{}}const p=1e3,y=10*60*1e3;class v extends M.$Uc{constructor(t,c){super(),this.b=t,this.c=c,this.a=this.B(new $.$Hh),this.a.cancelAndSet(async()=>{const r=await d(t,c);(!r||r.pid!==process.pid)&&(t.info(`Lock '${c}': The lock was lost unexpectedly.`),this.a.cancel());try{await k.Promises.utimes(c,new Date,new Date)}catch(a){t.error(a),t.info(`Lock '${c}': Could not update mtime.`)}},p)}dispose(){super.dispose();try{h.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const c={pid:process.pid,willReleaseAt:Date.now()+t};await k.Promises.writeFile(this.c,JSON.stringify(c),{flag:"w"})}catch(c){this.b.error(c)}}}async function l(s,t,c){try{const a={pid:process.pid,willReleaseAt:0};await k.Promises.writeFile(t,JSON.stringify(a),{flag:"wx"})}catch(a){s.error(a)}const r=await d(s,t);return!r||r.pid!==process.pid?c?(s.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(s.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),i(s,t)):(s.info(`Lock '${t}': Lock acquired.`),new v(s,t))}async function d(s,t){let c;try{c=await k.Promises.readFile(t)}catch(r){return s.error(r),null}try{return JSON.parse(String(c))}catch(r){return s.error(r),null}}async function o(s,t){let c;try{c=await k.Promises.stat(t)}catch(r){return s.error(r),0}return c.mtime.getTime()}function n(s){try{return process.kill(s,0),!0}catch{return!1}}async function i(s,t){const c=await d(s,t);if(!c)return s.info(`Lock '${t}': Could not read pid of lock holder.`),u(s,t);if(c.willReleaseAt){let w=c.willReleaseAt-Date.now();if(w<5e3){for(w>0?s.info(`Lock '${t}': The lockfile is scheduled to be released in ${w} ms.`):s.info(`Lock '${t}': The lockfile is scheduled to have been released.`);w>0;){if(await(0,$.$xh)(Math.min(100,w)),await o(s,t)===0)return u(s,t);w=c.willReleaseAt-Date.now()}return u(s,t)}}if(!n(c.pid))return s.info(`Lock '${t}': The pid ${c.pid} appears to be gone.`),u(s,t);const r=await o(s,t),a=Date.now()-r;if(a<=y)return s.info(`Lock '${t}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null;s.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$xh)(2e3);const f=await o(s,t),g=Date.now()-f;return g<=y?(s.info(`Lock '${t}': The lock does not look stale, elapsed: ${g} ms, giving up.`),null):(s.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),u(s,t))}async function u(s,t){s.info(`Lock '${t}': Deleting a stale lock.`);try{await k.Promises.unlink(t)}catch{}return l(s,t,!0)}}),define(Se[367],De([1,0,30,20,43,34]),function(he,e,h,N,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Inc=void 0;let M=class extends O.$imc{constructor($,k){super(!0,$,k)}createTerminal($,k,A){return this.createTerminalFromOptions({name:$,shellPath:k,shellArgs:A})}createTerminalFromOptions($,k){const A=new O.$hmc(this.a,(0,h.$Sg)(),$,$.name);return this.f.push(A),A.create($,this.R($,k)),A.value}};e.$Inc=M,e.$Inc=M=He([We(0,R.$1O),We(1,N.$EO)],M)}),define(Se[368],De([1,0,4,36,38,5]),function(he,e,h,N,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zL=e.$yL=e.OutputChannelUpdateMode=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=void 0,e.$lL="text/x-code-output",e.$mL="output",e.$nL="Log",e.$oL="text/x-code-log-output",e.$pL="log",e.$qL="workbench.panel.output",e.$rL=new O.$Nj("inOutput",!1),e.$sL=new O.$Nj("activeLogOutput",!1),e.$tL=new O.$Nj("activeLogOutput.levelSettable",!1),e.$uL=new O.$Nj("activeLogOutput.level",""),e.$vL=new O.$Nj("activeLogOutput.levelIsDefault",!1),e.$wL=new O.$Nj("outputView.scrollLock",!1),e.$xL=(0,R.$wi)("outputService");var M;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$yL={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new h.$de,this.onDidRegisterChannel=this.b.event,this.c=new h.$de,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(A=>k.push(A)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}N.$co.add(e.$yL.OutputChannels,new b),e.$zL=new O.$Nj("activeOutputChannel","")}),define(Se[158],De([1,0,6,5,20,25,11,368,70,28,60,194,21,18,33,4,3]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$mc=e.$0mc=void 0;class o extends M.$9j{get disposed(){return this.n}constructor(s,t,c,r,a){super(),this.id=s,this.name=t,this.r=c,this.s=r,this.extension=a,this.m=0,this.n=!1,this.visible=!1,this.setLevel(c.getLevel()),this.B(c.onDidChangeLogLevel(f=>this.setLevel(f)))}get logLevel(){return this.getLevel()}appendLine(s){this.append(s+`
`)}append(s){this.info(s)}clear(){const s=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,s)}replace(s){const t=this.m;this.info(s),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(s,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof s=="boolean"?s:t))}hide(){this.s.$close(this.id)}g(s,t){this.m+=p.$Fe.fromString(t).byteLength,(0,M.log)(this.r,s,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends o{appendLine(s){this.append(s)}}let i=class{constructor(s,t,c,r,a,f){this.i=t,this.j=c,this.k=r,this.l=a,this.m=f,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=s.getProxy(h.$dM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(s){this.h=s;for(const[t,c]of this.g)c.visible=t===this.h}createOutputChannel(s,t,c){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,a=(0,y.$9f)(t)?t:void 0;if((0,y.$9f)(a)&&!a.trim())throw new Error("illegal argument `languageId`. must not be empty");let f;const g=this.i.environment.extensionLogLevel?.find(([S])=>R.$Rm.equals(c.identifier,S))?.[1];g&&(f=(0,M.$hk)(g));const w=r?this.o(s,f,c):this.n(s,a,c);return w.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),r?this.r(s,f??this.m.getLevel(),w):this.q(s,w)}async n(s,t,c){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,a=this.k.extUri.joinPath(r,`${this.f++}-${s.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),f=this.l.createLogger(a,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),g=await this.a.$register(s,a,t,c.identifier.value);return new o(g,s,f,this.a,c)}async o(s,t,c){const r=await this.p(c),a=s.replace(/[\\/:\*\?"<>\|]/g,""),f=this.k.extUri.joinPath(r,`${a}.log`),g=`${c.identifier.value}.${a}`,w=this.l.createLogger(f,{id:g,name:s,logLevel:t,extensionId:c.identifier.value});return new n(g,s,w,this.a,c)}p(s){let t=this.d.get(s.identifier.value);if(!t){const c=this.k.extUri.joinPath(this.i.logsLocation,s.identifier.value);this.d.set(s.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(c)}catch(r){if((0,v.$gl)(r)!==v.FileSystemProviderErrorCode.FileExists)throw r}return c})())}return t}q(s,t){let c=!1;const r=()=>{if(c)throw new Error("Channel has been closed")};return{get name(){return s},append(a){r(),t.then(f=>f.append(a))},appendLine(a){r(),t.then(f=>f.appendLine(a))},clear(){r(),t.then(a=>a.clear())},replace(a){r(),t.then(f=>f.replace(a))},show(a,f){r(),t.then(g=>g.show(a,f))},hide(){r(),t.then(a=>a.hide())},dispose(){c=!0,t.then(a=>a.dispose())}}}r(s,t,c){const r=new d.$Tc,a=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},f=r.add(new l.$de);function g(w){t=w,f.fire(w)}return c.then(w=>{r.add(w),w.logLevel!==t&&g(w.logLevel),r.add(w.onDidChangeLogLevel(S=>g(S)))}),{...this.q(s,c),get logLevel(){return t},onDidChangeLogLevel:f.event,trace(w,...S){a(),c.then(m=>m.trace(w,...S))},debug(w,...S){a(),c.then(m=>m.debug(w,...S))},info(w,...S){a(),c.then(m=>m.info(w,...S))},warn(w,...S){a(),c.then(m=>m.warn(w,...S))},error(w,...S){a(),c.then(m=>m.error(w,...S))},dispose(){r.dispose()}}}};e.$0mc=i,e.$0mc=i=He([We(0,O.$EO),We(1,k.$UO),We(2,$.$Wlc),We(3,A.$zlc),We(4,M.$4j),We(5,M.$3j)],i),e.$$mc=(0,N.$wi)("IExtHostOutputService")}),define(Se[159],De([1,0,5,7]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=void 0,e.$gn=(0,h.$wi)("remoteAgentService"),e.$hn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(O){let R=1/0;for(let b=0;b<this.maxSampleCount;b++){const $=await O.getRoundTripTime();if($===void 0)return;R=Math.min(R,$/2),await(0,N.$xh)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(R):M=this.initial.reduce((b,$)=>b+$,0)/this.initial.length,this.lastMeasurement={initial:M,current:R,average:this.average.reduce((b,$)=>b+$,0)/this.average.length,high:typeof M>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>M*this.highLatencyMultiple},this.lastMeasurement}}}),define(Se[369],De([1,0,237,66,36,42,55,3,4,159,12,24,7]),function(he,e,h,N,O,R,M,b,$,k,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ygb=e.$xgb=e.$wgb=e.$vgb=e.$ugb=e.$tgb=e.$sgb=void 0,e.$sgb=Object.freeze({id:"application",order:100,title:(0,h.localize)(0,null),type:"object"}),e.$tgb=Object.freeze({id:"workbench",order:7,title:(0,h.localize)(1,null),type:"object"}),e.$ugb=Object.freeze({id:"security",scope:1,title:(0,h.localize)(2,null),type:"object",order:7}),e.$vgb=Object.freeze({id:"problems",title:(0,h.localize)(3,null),type:"object",order:101}),e.$wgb={ConfigurationMigration:"base.contributions.configuration.migration"};class y{constructor(){this.migrations=[],this.a=new $.$de,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const v=new y;O.$co.add(e.$wgb.ConfigurationMigration,v);let l=class extends b.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async u=>{for(const s of u.added)await this.f(s,v.migrations)})),this.c(v.migrations),this.B(v.onDidRegisterConfigurationMigration(u=>this.c(u)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(u=>this.g(u,n?.uri))])}async g(n,i){const u=this.a.inspect(n.key,{resource:i}),s=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,c]of s){const r=u[t];if(!r)continue;const a=[];if(r.value!==void 0){const f=await this.h(n,t,r.value,i,void 0);for(const g of f??[])a.push([g,[]])}for(const{identifiers:f,value:g}of r.overrides??[])if(g!==void 0){const w=await this.h(n,t,g,i,f);for(const S of w??[])a.push([S,f])}a.length&&await Promise.allSettled(a.map(async([[f,g],w])=>this.a.updateValue(f,g.value,{resource:i,overrideIdentifiers:w},c)))}}async h(n,i,u,s,t){const c=a=>{const g=this.a.inspect(a,{resource:s})[i];if(g)return t?g.overrides?.find(({identifiers:w})=>(0,I.$7n)(w,t))?.value:g.value},r=await n.migrateFn(u,c);return Array.isArray(r)?r:[[n.key,r]]}};e.$xgb=l,e.$xgb=l=He([We(0,M.$3i),We(1,R.$Fi)],l);let d=class extends b.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new p.$Th,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!A.$i&&(await this.b.getEnvironment())?.os!==1)return;O.$co.as(N.$ho.Configuration).registerConfiguration({...e.$ugb,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,h.localize)(4,null)},default:[],markdownDescription:(0,h.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,h.localize)(6,null),scope:2}}})}};e.$ygb=d,e.$ygb=d=He([We(0,k.$gn)],d)}),define(Se[370],De([1,0,35,15,16,23,247,369,66,5,36]),function(he,e,h,N,O,R,M,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Agb=e.$zgb=void 0,e.$Bgb=l,e.$Cgb=d,e.$zgb=(0,k.$wi)("editorResolverService"),e.$Agb="workbench.editorAssociations";const I=A.$co.as($.$ho.Configuration),p={...b.$tgb,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};I.registerConfiguration(p);var y;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(y||(e.RegisteredEditorPriority=y={}));var v;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function l(o){switch(o){case y.exclusive:return 5;case y.default:return 4;case y.builtin:return 3;case y.option:default:return 1}}function d(o,n){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(n.scheme))return!1;const s=typeof o=="string"&&o.indexOf(O.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,R.$7g)(n);return h.$pk(typeof o=="string"?o.toLowerCase():o,s.toLowerCase())}}),define(Se[371],De([1,0,31,15,16,12,23,2,5,284,42,148,159]),function(he,e,h,N,O,R,M,b,$,k,A,I,p){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$SL=e.$RL=void 0,e.$RL=(0,$.$wi)("pathService");let v=y=class{constructor(d,o,n,i){this.d=d,this.e=o,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const u=await this.e.getEnvironment();return this.c=u?.userHome??d})()}hasValidBasename(d,o,n){return typeof o=="string"||typeof o>"u"?this.a.then(i=>this.h(d,i,o)):this.h(d,o,n)}h(d,o,n){return d.scheme===N.Schemas.file||d.scheme===N.Schemas.vscodeRemote?(0,h.$tg)(n??(0,M.$7g)(d),o===1):!0}get defaultUriScheme(){return y.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(d,o){if(d.remoteAuthority)return N.Schemas.vscodeRemote;const n=(0,k.$OL)(o.getWorkspace());if(n)return n;const i=o.getWorkspace().folders[0];if(i)return i.uri.scheme;const u=o.getWorkspace().configuration;return u?u.scheme:N.Schemas.file}userHome(d){return d?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(d=>d===1?O.$fc:O.$gc)}async fileURI(d){let o="";if(await this.a===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const i=d.indexOf("/",2);i===-1?(o=d.substring(2),d="/"):(o=d.substring(2,i),d=d.substring(i)||"/")}return b.URI.from({scheme:N.Schemas.file,authority:o,path:d,query:"",fragment:""})}};e.$SL=v,e.$SL=v=y=He([We(1,p.$gn),We(2,I.$AL),We(3,A.$Fi)],v)}),define(Se[372],De([1,0,249,56,4,57,3,2,55,254,11,67,142,88,42,148,26,22,18,24,38]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d,o,n,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LL=e.$KL=e.OnPortForward=e.$FL=e.$EL=e.TunnelSource=e.TunnelCloseReason=e.$CL=e.$BL=void 0,e.$DL=a,e.$GL=w,e.$HL=S,e.$IL=m,e.$JL=D;const s=10*1e3,t="remote.tunnels.toRestore",c="remote.tunnels.toRestoreExpiration",r=1e3*60*60*24*14;e.$BL="onTunnel",e.$CL=new u.$Nj("forwardedPortsViewEnabled",!1,h.localize(0,null));function a(F){const T=F.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(T)return{host:T[1]?.substring(0,T[1].length-1)||"localhost",port:Number(T[2])}}var f;(function(F){F.Other="Other",F.User="User",F.AutoForwardEnd="AutoForwardEnd"})(f||(e.TunnelCloseReason=f={}));var g;(function(F){F[F.User=0]="User",F[F.Auto=1]="Auto",F[F.Extension=2]="Extension"})(g||(e.TunnelSource=g={})),e.$EL={source:g.User,description:h.localize(1,null)},e.$FL={source:g.Auto,description:h.localize(2,null)};function w(F,T,z){const L=F.get(m(T,z));if(L)return L;if((0,y.$ow)(T))for(const j of y.$nw){const U=m(j,z);if(F.has(U))return F.get(U)}else if((0,y.$qw)(T))for(const j of y.$pw){const U=m(j,z);if(F.has(U))return F.get(U)}}function S(F,T,z){const L=w(F,T,z);if(L)return L;const j=(0,y.$qw)(T)?"localhost":(0,y.$ow)(T)?"0.0.0.0":void 0;if(j)return w(F,j,z)}function m(F,T){return F+":"+T}var E;(function(F){F.Notify="notify",F.OpenBrowser="openBrowser",F.OpenBrowserOnce="openBrowserOnce",F.OpenPreview="openPreview",F.Silent="silent",F.Ignore="ignore"})(E||(e.OnPortForward=E={}));function D(F){return F&&"host"in F&&typeof F.host=="string"&&"port"in F&&typeof F.port=="number"&&(!("detail"in F)||typeof F.detail=="string")&&(!("pid"in F)||typeof F.pid=="string")}class C extends M.$Uc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(T){super(),this.r=T,this.j=[],this.n=new O.$de,this.onDidChangeAttributes=this.n.event,this.B(T.onDidChangeConfiguration(z=>{(z.affectsConfiguration(C.c)||z.affectsConfiguration(C.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(T,z,L){let j=this.w(T,z,L,this.j,0);const U={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;j>=0;){const X=this.j[j];X.key===T?(U.onAutoForward=X.onAutoForward??U.onAutoForward,U.elevateIfNeeded=X.elevateIfNeeded!==void 0?X.elevateIfNeeded:U.elevateIfNeeded,U.label=X.label??U.label,U.requireLocalPort=X.requireLocalPort,U.protocol=X.protocol):(U.onAutoForward=U.onAutoForward??X.onAutoForward,U.elevateIfNeeded=U.elevateIfNeeded!==void 0?U.elevateIfNeeded:X.elevateIfNeeded,U.label=U.label??X.label,U.requireLocalPort=U.requireLocalPort!==void 0?U.requireLocalPort:void 0,U.protocol=U.protocol??X.protocol),j=this.w(T,z,L,this.j,j+1)}return U.onAutoForward!==void 0||U.elevateIfNeeded!==void 0||U.label!==void 0||U.requireLocalPort!==void 0||U.protocol!==void 0?U:this.C()}t(T){return T.start!==void 0&&T.end!==void 0}u(T){return T.host!==void 0&&T.port!==void 0&&(0,n.$9f)(T.host)&&(0,n.$ag)(T.port)}w(T,z,L,j,U){if(U>=j.length)return-1;const X=!(0,y.$ow)(z)&&!(0,y.$qw)(z),q=j.slice(U).findIndex(G=>(0,n.$ag)(G.key)?X?!1:G.key===T:this.t(G.key)?X?!1:T>=G.key.start&&T<=G.key.end:this.u(G.key)?T===G.key.port&&z===G.key.host:L?G.key.test(L):!1);return q>=0?q+U:-1}y(){const T=this.r.getValue(C.c);if(!T||!(0,n.$$f)(T))return[];const z=[];for(const j in T){if(j===void 0)continue;const U=T[j];let X;if(Number(j))X=Number(j);else if((0,n.$9f)(j))if(C.g.test(j)){const ie=j.match(C.g);X={start:Number(ie[1]),end:Number(ie[2])}}else if(C.h.test(j)){const ie=j.match(C.h);X={host:ie[1],port:Number(ie[2])}}else{let ie;try{ie=RegExp(j)}catch{}ie&&(X=ie)}X&&z.push({key:X,elevateIfNeeded:U.elevateIfNeeded,onAutoForward:U.onAutoForward,label:U.label,requireLocalPort:U.requireLocalPort,protocol:U.protocol})}const L=this.r.getValue(C.f);return L&&(this.m={elevateIfNeeded:L.elevateIfNeeded,label:L.label,onAutoForward:L.onAutoForward,requireLocalPort:L.requireLocalPort,protocol:L.protocol}),this.z(z)}z(T){function z(L,j){return(0,n.$ag)(L.key)?L.key:j.t(L.key)?L.key.start:j.u(L.key)?L.key.port:Number.MAX_VALUE}return T.sort((L,j)=>z(L,this)-z(j,this))}C(){return this.m}static providedActionToAction(T){switch(T){case y.ProvidedOnAutoForward.Notify:return E.Notify;case y.ProvidedOnAutoForward.OpenBrowser:return E.OpenBrowser;case y.ProvidedOnAutoForward.OpenBrowserOnce:return E.OpenBrowserOnce;case y.ProvidedOnAutoForward.OpenPreview:return E.OpenPreview;case y.ProvidedOnAutoForward.Silent:return E.Silent;case y.ProvidedOnAutoForward.Ignore:return E.Ignore;default:return}}async addAttributes(T,z,L){const U=this.r.inspect(C.c).userRemoteValue;let X;!U||!(0,n.$$f)(U)?X={}:X=(0,i.$3n)(U),X[`${T}`]||(X[`${T}`]={});for(const ie in z)X[`${T}`][ie]=z[ie];return this.r.updateValue(C.c,X,L)}}e.$KL=C;let P=class extends M.$Uc{constructor(T,z,L,j,U,X,ie,q,G,x){super(),this.H=T,this.I=z,this.J=L,this.L=j,this.M=U,this.N=X,this.O=ie,this.P=q,this.Q=G,this.R=x,this.c=new Map,this.g=new O.$de,this.onForwardPort=this.g.event,this.h=new O.$de,this.onClosePort=this.h.event,this.j=new O.$de,this.onPortName=this.j.event,this.n=new O.$de,this.onCandidatesChanged=this.n.event,this.t=new O.$de,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new O.$de,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new C(L),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async ne=>{const be=await this.getAttributes(ne.map(ae=>({port:ae.tunnelRemotePort,host:ae.tunnelRemoteHost})));for(const ae of ne)if(ae.localAddress){const Ie=m(ae.tunnelRemoteHost,ae.tunnelRemotePort),ee=S(this.m??new Map,ae.tunnelRemoteHost,ae.tunnelRemotePort);this.forwarded.set(Ie,{remotePort:ae.tunnelRemotePort,remoteHost:ae.tunnelRemoteHost,localAddress:ae.localAddress,protocol:be?.get(ae.tunnelRemotePort)?.protocol??y.TunnelProtocol.Http,localUri:await this.X(ae.localAddress,be?.get(ae.tunnelRemotePort)),localPort:ae.tunnelLocalPort,runningProcess:ee?.detail,hasRunningProcess:!!ee,pid:ee?.pid,privacy:ae.privacy,source:e.$EL}),this.f.set(Ie,ae)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async ne=>{const be=m(ne.tunnelRemoteHost,ne.tunnelRemotePort);if(!S(this.forwarded,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&!S(this.detected,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&!S(this.c,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&ne.localAddress){const ae=S(this.m??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort),Ie=(await this.getAttributes([{port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost}]))?.get(ne.tunnelRemotePort);this.forwarded.set(be,{remoteHost:ne.tunnelRemoteHost,remotePort:ne.tunnelRemotePort,localAddress:ne.localAddress,protocol:Ie?.protocol??y.TunnelProtocol.Http,localUri:await this.X(ne.localAddress,Ie),localPort:ne.tunnelLocalPort,closeable:!0,runningProcess:ae?.detail,hasRunningProcess:!!ae,pid:ae?.pid,privacy:ne.privacy,source:e.$EL})}await this.cb(),this.f.set(be,ne),this.g.fire(this.forwarded.get(be))})),this.B(this.H.onTunnelClosed(ne=>this.W(ne,f.Other))),this.U()}S(){return this.Q.extensions.find(T=>T.activationEvents?.includes(e.$BL))?(this.R.createKey(e.$CL.key,!0),!0):!1}U(){if(this.S())return;const T=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&T.dispose()}))}async W(T,z){const L=m(T.host,T.port);this.forwarded.has(L)&&(this.forwarded.delete(L),await this.cb(),this.h.fire(T))}X(T,z){if(T.startsWith("http"))return b.URI.parse(T);const L=z?.protocol??"http";return b.URI.parse(`${L}://${T}`)}async Y(T){const z=this.N.getWorkspace(),L=z.configuration?(0,R.$kj)(z.configuration.path):z.folders.length>0?(0,R.$kj)(z.folders[0].uri.path):void 0;if(L===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${T}.${this.L.remoteAuthority}.${L}`}async Z(){return this.Y(t)}async $(){return this.Y(c)}async ab(){const T=this.I.get(t,1);if(T)return this.I.remove(t,1),await this.cb(),T;const z=await this.Z();if(z)return this.I.get(z,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const T=await this.s;if(T&&T!==this.y){const z=JSON.parse(T)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${z.map(L=>L.remotePort).join(", ")}`);for(const L of z){const j=S(this.detected,L.remoteHost,L.remotePort);L.source.source!==g.Extension&&!j||L.source.source===g.Extension&&j?await this.fb({remote:{host:L.remoteHost,port:L.remotePort},local:L.localPort,name:L.name,elevateIfNeeded:!0,source:L.source}):L.source.source===g.Extension&&!j&&this.D.set(m(L.remoteHost,L.remotePort),L)}}}if(this.z=!0,this.C.fire(),!this.w){const T=await this.Z();this.w=this.B(new M.$Tc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async z=>{z.key===T&&(this.s=Promise.resolve(this.I.get(T,0)),await this.restoreForwarded())}))}}bb(){const T=this.I.keys(0,0).filter(z=>z.startsWith(c));for(const z of T){const L=this.I.getNumber(z,0);if(L&&L<Date.now()){this.s=Promise.resolve(void 0);const j=z.replace(c,t);this.I.remove(z,0),this.I.remove(j,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const T=Array.from(this.forwarded.values()),z=T.map(X=>({remoteHost:X.remoteHost,remotePort:X.remotePort,localPort:X.localPort,name:X.name,localAddress:X.localAddress,localUri:X.localUri,protocol:X.protocol,source:X.source}));let L;T.length>0&&(L=JSON.stringify(z));const j=await this.Z(),U=await this.$();!L&&j&&U?(this.I.remove(j,0),this.I.remove(U,0)):L!==this.y&&j&&U&&(this.I.store(j,L,0,0),this.I.store(U,Date.now()+r,0,0)),this.y=L}}async eb(T,z,L){if(!T.tunnelLocalPort||!L?.requireLocalPort||T.tunnelLocalPort===z)return;const j=new Date;if(this.db.getTime()+s>j.getTime())return;this.db=j;const U=h.localize(3,null,z,T.tunnelRemotePort,T.tunnelLocalPort);return this.P.info(U)}async forward(T,z){return!this.z&&this.L.remoteAuthority&&await O.Event.toPromise(this.C.event),this.fb(T,z)}async fb(T,z){await this.Q.activateByEvent(e.$BL);const L=S(this.forwarded,T.remote.host,T.remote.port);z=z??(z!==null?(await this.getAttributes([T.remote]))?.get(T.remote.port):void 0);const j=T.local!==void 0?T.local:T.remote.port;let U;if(L)return this.hb(L,T,z);{const X=this.L.remoteAuthority,ie=X?{getAddress:async()=>(await this.M.resolveAuthority(X)).authority}:void 0,q=m(T.remote.host,T.remote.port);this.c.set(q,!0),T=this.gb(q,T);const G=await this.H.openTunnel(ie,T.remote.host,T.remote.port,void 0,j,T.elevateIfNeeded?T.elevateIfNeeded:z?.elevateIfNeeded,T.privacy,z?.protocol);if(typeof G=="string")U=G;else if(G&&G.localAddress){const x=S(this.m??new Map,T.remote.host,T.remote.port),ne=G.protocol?G.protocol===y.TunnelProtocol.Https?y.TunnelProtocol.Https:y.TunnelProtocol.Http:z?.protocol??y.TunnelProtocol.Http,be={remoteHost:G.tunnelRemoteHost,remotePort:G.tunnelRemotePort,localPort:G.tunnelLocalPort,name:z?.label??T.name,closeable:!0,localAddress:G.localAddress,protocol:ne,localUri:await this.X(G.localAddress,z),runningProcess:x?.detail,hasRunningProcess:!!x,pid:x?.pid,source:T.source??e.$EL,privacy:G.privacy};return this.forwarded.set(q,be),this.f.set(q,G),this.c.delete(q),await this.cb(),await this.eb(G,j,z),this.g.fire(be),G}this.c.delete(q)}return U}gb(T,z){const L=this.D.has(T)?this.D:this.F.has(T)?this.F:void 0;if(L){const j=L.get(T);L.delete(T),j&&(z.name=j.name??z.name,z.local=("local"in j?j.local:"localPort"in j?j.localPort:void 0)??z.local,z.privacy=z.privacy)}return z}async hb(T,z,L){const j=L?.label??z.name;let U;(function(ie){ie[ie.None=0]="None",ie[ie.Fire=1]="Fire",ie[ie.Reopen=2]="Reopen"})(U||(U={}));let X=U.None;switch(j!==T.name&&(T.name=j,X=U.Fire),(L?.protocol||T.protocol!==y.TunnelProtocol.Http)&&L?.protocol!==T.protocol&&(z.source=T.source,X=U.Reopen),z.privacy&&T.privacy!==z.privacy&&(X=U.Reopen),X){case U.Fire:{this.g.fire();break}case U.Reopen:await this.close(T.remoteHost,T.remotePort,f.User),await this.fb(z,L)}return S(this.f,z.remote.host,z.remote.port)}async name(T,z,L){const j=S(this.forwarded,T,z),U=m(T,z);if(j){j.name=L,await this.cb(),this.j.fire({host:T,port:z});return}else this.detected.has(U)&&(this.detected.get(U).name=L,this.j.fire({host:T,port:z}))}async close(T,z,L){const j=m(T,z),U=this.forwarded.get(j);return L===f.AutoForwardEnd&&U&&U.source.source===g.Auto&&this.F.set(j,{local:U.localPort,name:U.name,privacy:U.privacy}),await this.H.closeTunnel(T,z),this.W({host:T,port:z},L)}address(T,z){const L=m(T,z);return(this.forwarded.get(L)||this.detected.get(L))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(T){if(T)for(const z of T){const L=S(this.m??new Map,z.remoteAddress.host,z.remoteAddress.port),j=typeof z.localAddress=="string"?z.localAddress:m(z.localAddress.host,z.localAddress.port);this.detected.set(m(z.remoteAddress.host,z.remoteAddress.port),{remoteHost:z.remoteAddress.host,remotePort:z.remoteAddress.port,localAddress:j,protocol:y.TunnelProtocol.Http,localUri:this.X(j),closeable:!1,runningProcess:L?.detail,hasRunningProcess:!!L,pid:L?.pid,privacy:y.TunnelPrivacyId.ConstantPrivate,source:{source:g.Extension,description:h.localize(4,null)}}),this.H.setEnvironmentTunnel(z.remoteAddress.host,z.remoteAddress.port,j,y.TunnelPrivacyId.ConstantPrivate,y.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(T){this.r=T}async setCandidates(T){let z=T;this.r&&(z=await this.r(T));const L=this.ib(z);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(L.values()).map(j=>j.port).join(", ")}`),this.n.fire(L)}ib(T){const z=this.m??new Map,L=new Map;return this.m=L,T.forEach(j=>{const U=m(j.host,j.port);L.set(U,{host:j.host,port:j.port,detail:j.detail,pid:j.pid}),z.has(U)&&z.delete(U);const X=S(this.forwarded,j.host,j.port);X&&(X.runningProcess=j.detail,X.hasRunningProcess=!0,X.pid=j.pid)}),z.forEach((j,U)=>{const X=a(U);if(!X)return;const ie=S(this.forwarded,X.host,X.port);ie&&(ie.runningProcess=void 0,ie.hasRunningProcess=!1,ie.pid=void 0);const q=S(this.detected,X.host,X.port);q&&(q.runningProcess=void 0,q.hasRunningProcess=!1,q.pid=void 0)}),z}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const T=Array.from(this.forwarded.values()),z=await this.getAttributes(T.map(L=>({port:L.remotePort,host:L.remoteHost})),!1);if(z)for(const L of T){const j=z.get(L.remotePort);(j?.protocol||L.protocol!==y.TunnelProtocol.Http)&&j?.protocol!==L.protocol&&await this.fb({remote:{host:L.remoteHost,port:L.remotePort},local:L.localPort,name:L.name,source:L.source},j),j&&j.label&&j.label!==L.name&&await this.name(L.remoteHost,L.remotePort,j.label)}}async getAttributes(T,z=!0){const L=new Map,j=new Map;T.forEach(G=>{const x=S(this.m??new Map,y.$nw[0],G.port)??G;if(x){L.set(G.port,x);const ne=D(x)?x.pid:void 0;j.has(ne)||j.set(ne,[]),j.get(ne)?.push(G.port)}});const U=new Map;if(T.forEach(G=>{const x=this.configPortsAttributes.getAttributes(G.port,G.host,L.get(G.port)?.detail);x&&U.set(G.port,x)}),this.G.length===0||!z)return U.size>0?U:void 0;const X=await Promise.all(this.G.flatMap(G=>Array.from(j.entries()).map(x=>{const ne=x[1],be=L.get(ne[0]);return G.providePortAttributes(ne,be?.pid,be?.detail,o.CancellationToken.None)}))),ie=new Map;if(X.forEach(G=>G.forEach(x=>{x&&ie.set(x.port,x)})),!U&&!ie)return;const q=new Map;return T.forEach(G=>{const x=U.get(G.port),ne=ie.get(G.port);q.set(G.port,{elevateIfNeeded:x?.elevateIfNeeded,label:x?.label,onAutoForward:x?.onAutoForward??C.providedActionToAction(ne?.autoForwardAction),requireLocalPort:x?.requireLocalPort,protocol:x?.protocol})}),q}addAttributesProvider(T){this.G.push(T)}};e.$LL=P,He([(0,N.$2h)(1e3)],P.prototype,"cb",null),e.$LL=P=He([We(0,y.$iw),We(1,p.$1p),We(2,$.$3i),We(3,l.$AL),We(4,I.$Hl),We(5,v.$Fi),We(6,A.$3j),We(7,k.$Nw),We(8,d.$LG),We(9,u.$Oj)],P)}),define(Se[94],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$kK=e.$jK=void 0;class h{constructor(M,b){this.line=M,this.character=b}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,b){return new h(0,0)}with(M){return new h(0,0)}}e.$jK=h;class N{constructor(M,b,$,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new h(M,b),this.end=new h($,k)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new N(0,0,0,0)}with(M){return new N(0,0,0,0)}}e.$kK=N;var O;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(O||(e.TextSearchCompleteMessageType=O={}))}),define(Se[37],De([1,0,19,35,24,31,14,5,16,13,94,7]),function(he,e,h,N,O,R,M,b,$,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JK=e.$HK=e.$AK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$xK=e.$wK=e.$vK=e.$uK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.TextSearchCompleteMessageType=void 0,e.$rK=o,e.$sK=n,e.$tK=i,e.$yK=w,e.$zK=S,e.$BK=D,e.$CK=C,e.$DK=P,e.$EK=F,e.$FK=T,e.$GK=z,e.$IK=j,e.$KK=ie,e.$LK=q,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$lK="workbench.view.search",e.$mK="workbench.panel.search",e.$nK="workbench.view.search",e.$oK="search-result",e.$pK="search.exclude";const p="\u27EA ",y=" characters skipped \u27EB",v=(p.length+y.length+5)*2;e.$qK=(0,b.$wi)("searchService");var l;(function(x){x[x.file=0]="file",x[x.text=1]="text",x[x.aiText=2]="aiText"})(l||(e.SearchProviderType=l={}));var d;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.aiText=3]="aiText"})(d||(e.QueryType=d={}));function o(x){return!!x.preview}function n(x){return!!x.resource}function i(x){return!!x.message}var u;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(u||(e.SearchCompletionExitCode=u={}));class s{constructor(ne){this.resource=ne,this.results=[]}}e.$uK=s;class t{constructor(ne,be,ae,Ie){this.ranges=be,this.webviewIndex=Ie;const ee=Array.isArray(be)?be:[be];if(ae&&ae.matchLines===1&&c(ee)){ne=(0,M.$2f)(ne,ae.matchLines);let B="",_=0,pe=0;const ue=Math.floor(ae.charsPerLine/5),ce=[];for(const oe of ee){const le=Math.max(oe.startColumn-ue,0),K=oe.startColumn+ae.charsPerLine;if(le>pe+ue+v){const se=p+(le-pe)+y;B+=se+ne.slice(le,K),_+=le-(pe+se.length)}else B+=ne.slice(pe,K);ce.push(new a(0,oe.startColumn-_,oe.endColumn-_)),pe=K}this.preview={text:B,matches:Array.isArray(this.ranges)?ce:ce[0]}}else{const B=Array.isArray(be)?be[0].startLineNumber:be.startLineNumber;this.preview={text:ne,matches:(0,h.$1b)(be,_=>new r(_.startLineNumber-B,_.startColumn,_.endLineNumber-B,_.endColumn))}}}}e.$vK=t;function c(x){const ne=x[0].startLineNumber;for(const be of x)if(be.startLineNumber!==ne||be.endLineNumber!==ne)return!1;return!0}class r{constructor(ne,be,ae,Ie){this.startLineNumber=ne,this.startColumn=be,this.endLineNumber=ae,this.endColumn=Ie}}e.$wK=r;class a extends r{constructor(ne,be,ae){super(ne,be,ne,ae)}}e.$xK=a;var f;(function(x){x.List="list",x.Tree="tree"})(f||(e.ViewMode=f={}));var g;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(g||(e.SearchSortOrder=g={}));function w(x,ne=!0){const be=x&&x.files&&x.files.exclude,ae=ne&&x&&x.search&&x.search.exclude;if(!be&&!ae)return;if(!be||!ae)return be||ae;let Ie=Object.create(null);return Ie=O.$6n(Ie,O.$3n(be)),Ie=O.$6n(Ie,O.$3n(ae),!0),Ie}function S(x,ne){return x.excludePattern&&N.$pk(x.excludePattern,ne)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&N.$pk(x.includePattern,ne)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(be=>{const ae=be.folder.fsPath;if(R.$vg(ne,ae)){const Ie=$.$lc(ae,ne);return!be.includePattern||!!N.$pk(be.includePattern,Ie)}else return!1}):!1:!0}var m;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(m||(e.SearchErrorCode=m={}));class E extends Error{constructor(ne,be){super(ne),this.code=be}}e.$AK=E;function D(x){const ne=x.message;if((0,k.$4)(x))return new E(ne,m.canceled);try{const be=JSON.parse(ne);return new E(be.message,be.code)}catch{return new E(ne,m.other)}}function C(x){const ne={message:x.message,code:x.code};return new Error(JSON.stringify(ne))}function P(x){return x.type==="error"?!0:x.type==="success"}function F(x){return x.type==="success"}function T(x){return!!x.path}function z(x,ne,be=!0){const ae=x.searchPath?x.searchPath:x.relativePath;return be?(0,M.$Yf)(ae,ne):N.$pk(ne,ae)}class L{constructor(ne){this.path=ne,this.results=[]}addMatch(ne){this.results.push(ne)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$HK=L;function j(x,ne){const be={...x||{},...ne||{}};return Object.keys(be).filter(ae=>{const Ie=be[ae];return typeof Ie=="boolean"&&Ie})}class U{constructor(ne,be){this.c=null,this.a={...ne.excludePattern||{},...be.excludePattern||{}},this.b=N.$qk(this.a);let ae=ne.includePattern;be.includePattern&&(ae?ae={...ae,...be.includePattern}:ae=be.includePattern),ae&&(this.c=N.$qk(ae))}matchesExcludesSync(ne,be,ae){return!!(this.b&&this.b(ne,be,ae))}includedInQuerySync(ne,be,ae){return!(this.b&&this.b(ne,be,ae)||this.c&&!this.c(ne,be,ae))}includedInQuery(ne,be,ae){const Ie=this.b(ne,be,ae),ee=()=>this.c?!!this.c(ne,be,ae):!0;return(0,I.$ih)(Ie)?Ie.then(B=>B?!1:ee()):ee()}hasSiblingExcludeClauses(){return X(this.a)}}e.$JK=U;function X(x){for(const ne in x)if(typeof x[ne]!="boolean")return!0;return!1}function ie(x){if(!x)return;let ne;return be=>(ne||(ne=(x()||Promise.resolve([])).then(ae=>ae?G(ae):{})),ne.then(ae=>!!ae[be]))}function q(x){if(!x)return;let ne;return be=>{if(!ne){const ae=x();ne=ae?G(ae):{}}return!!ne[be]}}function G(x){const ne={};for(const be of x)ne[be]=!0;return ne}}),define(Se[44],De([1,0,19,7,22,4,3,78,15,126,23,14,2,235,5,11,268,42,60,28,20,17,8,68,37,6,58]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d,o,n,i,u,s,t,c,r,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rlc=e.$Qlc=void 0;function g(F,T,z){return new A.$Yg(L=>E(L,z)).isEqual(F,T)}function w(F,T,z){return g(F.uri,T.uri,z)?0:(0,I.$qf)(F.uri.toString(),T.uri.toString())}function S(F,T,z){return F.index!==T.index?F.index<T.index?-1:1:g(F.uri,T.uri,z)?(0,I.$qf)(F.name,T.name):(0,I.$qf)(F.uri.toString(),T.uri.toString())}function m(F,T,z,L){const j=F.slice(0).sort((X,ie)=>z(X,ie,L)),U=T.slice(0).sort((X,ie)=>z(X,ie,L));return(0,h.$Eb)(j,U,(X,ie)=>z(X,ie,L))}function E(F,T){const z=T.getCapabilities(F.scheme);return!(z&&z&1024)}class D extends o.$Pi{static toExtHostWorkspace(T,z,L,j){if(!T)return{workspace:null,added:[],removed:[]};const{id:U,name:X,folders:ie,configuration:q,transient:G,isUntitled:x}=T,ne=[],be=z;z?ie.forEach((B,_)=>{const pe=p.URI.revive(B.uri),ue=D.o(L||z,pe,j);ue?(ue.name=B.name,ue.index=B.index,ne.push(ue)):ne.push({uri:pe,name:B.name,index:_})}):ne.push(...ie.map(({uri:B,name:_,index:pe})=>({uri:p.URI.revive(B),name:_,index:pe}))),ne.sort((B,_)=>B.index<_.index?-1:1);const ae=new D(U,X,ne,!!G,q?p.URI.revive(q):null,!!x,B=>E(B,j)),{added:Ie,removed:ee}=m(be?be.workspaceFolders:[],ae.workspaceFolders,w,j);return{workspace:ae,added:Ie,removed:ee}}static o(T,z,L){for(let j=0;j<T.folders.length;j++){const U=T.workspaceFolders[j];if(g(U.uri,z,L))return U}}constructor(T,z,L,j,U,X,ie){super(T,L.map(q=>new o.$Qi(q)),j,U,ie),this.t=z,this.u=X,this.q=[],this.s=b.$Ci.forUris(ie),L.forEach(q=>{this.q.push(q),this.s.set(q.uri,q)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(T,z){return z&&this.s.get(T)&&(T=(0,A.$9g)(T)),this.s.findSubstr(T)}resolveWorkspaceFolder(T){return this.s.get(T)}}let C=class{constructor(T,z,L,j,U){this.c=new R.$de,this.onDidChangeWorkspace=this.c.event,this.g=new R.$de,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$fe,this.C=new Map,this.h=j,this.s=L,this.t=U,this.j=new k.$Dm,this.k=new N.$vh,this.o=T.getProxy(a.$dM.MainThreadWorkspace),this.q=T.getProxy(a.$dM.MainThreadMessageService);const X=z.workspace;this.l=X?new D(X.id,X.name,[],!!X.transient,X.configuration?p.URI.revive(X.configuration):null,!!X.isUntitled,ie=>E(ie,L)):void 0}$initializeWorkspace(T,z){this.v=z,this.$acceptWorkspaceData(T),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?p.URI.from({scheme:$.Schemas.untitled,path:(0,A.$7g)((0,A.$9g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(T,z,L,...j){const U=[];if(Array.isArray(j)&&j.forEach(x=>{p.URI.isUri(x.uri)&&!U.some(ne=>g(ne.uri,x.uri,this.s))&&U.push({uri:x.uri,name:x.name||(0,A.$6g)(x.uri)})}),this.n||[z,L].some(x=>typeof x!="number"||x<0)||L===0&&U.length===0)return!1;const X=this.x?this.x.workspaceFolders:[];if(z+L>X.length)return!1;const ie=X.slice(0);ie.splice(z,L,...U.map(x=>({uri:x.uri,name:x.name||(0,A.$6g)(x.uri),index:void 0})));for(let x=0;x<ie.length;x++){const ne=ie[x];if(ie.some((be,ae)=>ae!==x&&g(ne.uri,be.uri,this.s)))return!1}ie.forEach((x,ne)=>x.index=ne);const{added:q,removed:G}=m(X,ie,S,this.s);if(q.length===0&&G.length===0)return!1;if(this.o){const x=T.displayName||T.name;this.o.$updateWorkspaceFolders(x,z,L,U).then(void 0,ne=>{this.n=void 0;const be={source:{identifier:T.identifier,label:T.displayName||T.name}};this.q.$showMessage(d.Severity.Error,(0,y.localize)(0,null,x,ne.toString()),be,[])})}return this.y(ie),!0}getWorkspaceFolder(T,z){if(this.x)return this.x.getWorkspaceFolder(T,z)}async getWorkspaceFolder2(T,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(T,z)}async resolveWorkspaceFolder(T){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(T)}getPath(){if(!this.x)return;const{folders:T}=this.x;if(T.length!==0)return T[0].uri.fsPath}getRelativePath(T,z){let L,j="";if(typeof T=="string"?(L=p.URI.file(T),j=T):typeof T<"u"&&(L=T,j=T.fsPath),!L)return j;const U=this.getWorkspaceFolder(L,!0);if(!U)return j;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let X=(0,A.$_g)(U.uri,L);return z&&U.name&&(X=`${U.name}/${X}`),X}y(T){this.x&&(this.n=D.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:T,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(T){const{workspace:z,added:L,removed:j}=D.toExtHostWorkspace(T,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:L,removed:j}))}findFiles(T,z,L,j,U=O.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let X="",ie=!0;return z===null?ie=!1:z!==void 0&&(typeof z=="string"?X=z:X=z.pattern),this.z(T,void 0,{exclude:X,maxResults:L,useDefaultExcludes:ie,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},U)}findFiles2(T,z={},L,j=O.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${L.value}, entryPoint: findFiles2`),this.z(void 0,T,z,j)}async z(T,z,L,j=O.CancellationToken.None){if(j&&j.isCancellationRequested)return Promise.resolve([]);const U=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,X={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof L.useParentIgnoreFiles=="boolean"?!L.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof L.useDefaultSearchExcludes=="boolean"?!L.useDefaultSearchExcludes:!1,maxResults:L.maxResults,excludePattern:U,shouldGlobSearch:typeof L.fuzzy=="boolean"?!L.fuzzy:!0,_reason:"startFileSearch"};let ie;if(T){const{includePattern:q,folder:G}=P(s.GlobPattern.from(T));ie=G,X.includePattern=q}else{const{includePattern:q,folder:G}=P(s.GlobPattern.from(z));ie=G,X.filePattern=q}return this.o.$startFileSearch(ie??null,X,j).then(q=>Array.isArray(q)?q.map(G=>p.URI.revive(G)):[])}async findTextInFiles(T,z,L,j,U=O.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const X=this.j.getNext(),ie=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:q,folder:G}=P(s.GlobPattern.from(z.include)),x=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,ne={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:ie,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:q,excludePattern:x},be=!1;if(this.u[X]=ae=>{if(be)return;const Ie=p.URI.revive(ae.resource);ae.results.forEach(ee=>{const B=(0,f.$6h)(ee);(0,r.$rK)(B)?L({uri:Ie,preview:{text:B.preview.text,matches:(0,h.$1b)(B.preview.matches,_=>new t.$hM(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))},ranges:(0,h.$1b)(B.ranges,_=>new t.$hM(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))}):L({uri:Ie,text:B.text,lineNumber:B.lineNumber})})},U.isCancellationRequested)return{};try{const ae=await this.o.$startTextSearch(T,G??null,ne,X,U);return delete this.u[X],ae||{}}catch(ae){throw delete this.u[X],ae}}$handleTextSearchResult(T,z){this.u[z]?.(T)}async save(T){const z=await this.o.$save(T,{saveAs:!1});return p.URI.revive(z)}async saveAs(T){const z=await this.o.$save(T,{saveAs:!0});return p.URI.revive(z)}saveAll(T){return this.o.$saveAll(T)}resolveProxy(T){return this.o.$resolveProxy(T)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(T){return this.o.$requestWorkspaceTrust(T)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(T,z){if(this.w.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.w.set(T,z);const L=this.t.transformOutgoingScheme(T),j=this.A++;return this.o.$registerEditSessionIdentityProvider(j,L),(0,M.$Sc)(()=>{this.w.delete(T),this.o.$unregisterEditSessionIdentityProvider(j)})}async $getEditSessionIdentifier(T,z){this.h.info("Getting edit session identifier for workspaceFolder",T);const L=await this.resolveWorkspaceFolder(p.URI.revive(T));if(!L){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",L);const j=this.w.get(L.uri.scheme);if(this.h.info(`Provider for scheme ${L.uri.scheme} is defined: `,!!j),!j)return;const U=await j.provideEditSessionIdentity(L,z);if(this.h.info("Provider returned edit session identifier: ",U),!!U)return U}async $provideEditSessionIdentityMatch(T,z,L,j){this.h.info("Getting edit session identifier for workspaceFolder",T);const U=await this.resolveWorkspaceFolder(p.URI.revive(T));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const X=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!X),!X)return;const ie=await X.provideEditSessionIdentityMatch?.(z,L,j);if(this.h.info("Provider returned edit session identifier match result: ",ie),!!ie)return ie}getOnWillCreateEditSessionIdentityEvent(T){return(z,L,j)=>{const U=function(ie){z.call(L,ie)};return U.extension=T,this.B.event(U,void 0,j)}}async $onWillCreateEditSessionIdentity(T,z,L){const j=await this.resolveWorkspaceFolder(p.URI.revive(T));if(j===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:j},z,async(U,X)=>{const ie=Date.now();await Promise.resolve(U),Date.now()-ie>L&&this.h.warn("SLOW edit session create-participant",X.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(T,z){if(this.C.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.C.set(T,z);const L=this.t.transformOutgoingScheme(T),j=this.A++;return this.o.$registerCanonicalUriProvider(j,L),(0,M.$Sc)(()=>{this.C.delete(T),this.o.$unregisterCanonicalUriProvider(j)})}async provideCanonicalUri(T,z,L){const j=this.C.get(T.scheme);if(!j)return;const U=await j.provideCanonicalUri?.(p.URI.revive(T),z,L);if(U)return U}async $provideCanonicalUri(T,z,L){return this.provideCanonicalUri(p.URI.revive(T),{targetScheme:z},L)}};e.$Qlc=C,e.$Qlc=C=He([We(0,u.$EO),We(1,i.$UO),We(2,n.$zlc),We(3,l.$3j),We(4,c.$Olc)],C),e.$Rlc=(0,v.$wi)("IExtHostWorkspace");function P(F){let T,z;return F&&(typeof F=="string"?T=F:(T=F.pattern,z=p.URI.revive(F.baseUri))),{includePattern:T,folder:z}}}),define(Se[45],De([1,0,24,4,44,6,8,270,66,18,7,5,20,11,2]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ulc=e.$Tlc=e.$Slc=void 0;function l(c,r){if(r){const a=r.split(".");let f=c;for(let g=0;f&&g<a.length;g++)f=f[a[g]];return f}}function d(c){return c instanceof v.URI}function o(c){return c&&c.uri instanceof v.URI&&c.languageId&&typeof c.languageId=="string"}function n(c){return c&&!c.uri&&c.languageId&&typeof c.languageId=="string"}function i(c){return c&&c.uri instanceof v.URI&&(!c.name||typeof c.name=="string")&&(!c.index||typeof c.index=="number")}function u(c){if(d(c))return{resource:c};if(o(c))return{resource:c.uri,overrideIdentifier:c.languageId};if(n(c))return{overrideIdentifier:c.languageId};if(i(c))return{resource:c.uri};if(c===null)return{resource:null}}let s=class{constructor(r,a,f){this.a=r.getProxy(R.$dM.MainThreadConfiguration),this.c=a,this.b=f,this.d=new A.$vh,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new t(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,a){this.getConfigProvider().then(f=>f.$acceptConfigurationChanged(r,a))}};e.$Slc=s,e.$Slc=s=He([We(0,p.$EO),We(1,O.$Rlc),We(2,y.$3j)],s);class t{constructor(r,a,f,g){this.a=new N.$de,this.b=r,this.f=g,this.c=a,this.e=b.$Ao.parse(f,g),this.d=this.k(f.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,a){const f={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$Ao.parse(r,this.f),this.d=this.k(r.configurationScopes),this.a.fire(this.j(a,f))}getConfiguration(r,a,f){const g=u(a)||{},w=this.g(r?l(this.e.getValue(void 0,g,this.c.workspace),r):this.e.getValue(void 0,g,this.c.workspace));r&&this.h(r,g,f?.identifier);function S(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const m={has(E){return typeof l(w,E)<"u"},get:(E,D)=>{this.h(r?`${r}.${E}`:E,g,f?.identifier);let C=l(w,E);if(typeof C>"u")C=D;else{let P;const F=(T,z)=>{if((0,k.$$f)(T)){let L;const j=()=>{P=P||(0,h.$3n)(w),L=L||l(P,z)};return new Proxy(T,{get:(U,X)=>{if(typeof X=="string"&&X.toLowerCase()==="tojson")return j(),()=>L;if(P)return L=L||l(P,z),L[X];const ie=U[X];return typeof X=="string"?F(ie,`${z}.${X}`):ie},set:(U,X,ie)=>(j(),L&&(L[X]=ie),!0),deleteProperty:(U,X)=>(j(),L&&delete L[X],!0),defineProperty:(U,X,ie)=>(j(),L&&Object.defineProperty(L,X,ie),!0)})}return Array.isArray(T)?(0,h.$3n)(T):T};C=F(C,E)}return C},update:(E,D,C,P)=>{E=r?`${r}.${E}`:E;const F=S(C);return D!==void 0?this.b.$updateConfigurationOption(F,E,D,g,P):this.b.$removeConfigurationOption(F,E,g,P)},inspect:E=>{E=r?`${r}.${E}`:E;const D=this.e.inspect(E,g,this.c.workspace);if(D)return{key:E,defaultValue:(0,h.$3n)(D.policy?.value??D.default?.value),globalValue:(0,h.$3n)(D.user?.value??D.application?.value),workspaceValue:(0,h.$3n)(D.workspace?.value),workspaceFolderValue:(0,h.$3n)(D.workspaceFolder?.value),defaultLanguageValue:(0,h.$3n)(D.default?.override),globalLanguageValue:(0,h.$3n)(D.user?.override??D.application?.override),workspaceLanguageValue:(0,h.$3n)(D.workspace?.override),workspaceFolderLanguageValue:(0,h.$3n)(D.workspaceFolder?.override),languageIds:(0,h.$3n)(D.overrideIdentifiers)}}};return typeof w=="object"&&(0,h.$6n)(m,w,!1),Object.freeze(m)}g(r){const a=f=>(0,k.$$f)(f)?new Proxy(f,{get:(g,w)=>a(g[w]),set:(g,w,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:(g,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:(g,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):f;return a(r)}h(r,a,f){const g=$.$ro.test(r)?4:this.d.get(r),w=f?`[${f.value}] `:"";if(g===4){typeof a?.resource>"u"&&this.f.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){a?.resource&&this.f.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,a){const f=new b.$Co(r,a,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(g,w)=>f.affectsConfiguration(g,u(w))})}k(r){return r.reduce((a,f)=>(a.set(f[0],f[1]),a),new Map)}}e.$Tlc=t,e.$Ulc=(0,I.$wi)("IExtHostConfiguration")}),define(Se[95],De([1,0,2,7,4,6,8,44,73,45,22,43,20,28,5,15,12,11,91,314,13]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d,o,n,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lnc=e.$knc=e.$jnc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var s;(function(F){function T(L){if(L!=null)return L}F.from=T;function z(L){if(L!=null)return L}F.to=z})(s||(s={}));var t;(function(F){function T(L){if(L!=null)return L}F.from=T;function z(L){if(L!=null)return L}F.to=z})(t||(t={}));var c;(function(F){function T(L){if(L!=null)return L}F.from=T;function z(L){if(L!=null)return L}F.to=z})(c||(c={}));var r;(function(F){function T(j){if(j){const U=j;return U&&!!U.process}else return!1}F.is=T;function z(j){if(j==null)return;const U={process:j.process,args:j.args};return j.options&&(U.options=c.from(j.options)),U}F.from=z;function L(j){if(j!=null)return new M.$2M(j.process,j.args,j.options)}F.to=L})(r||(r={}));var a;(function(F){function T(L){if(L!=null)return L}F.from=T;function z(L){if(L!=null)return L}F.to=z})(a||(a={}));var f;(function(F){function T(j){if(j){const U=j;return U&&(!!U.commandLine||!!U.command)}else return!1}F.is=T;function z(j){if(j==null)return;const U={};return j.commandLine!==void 0?U.commandLine=j.commandLine:(U.command=j.command,U.args=j.args),j.options&&(U.options=a.from(j.options)),U}F.from=z;function L(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new M.$3M(j.commandLine,j.options):new M.$3M(j.command,j.args?j.args:[],j.options)}F.to=L})(f||(f={}));var g;(function(F){function T(j){if(j){const U=j;return U&&U.customExecution==="customExecution"}else return!1}F.is=T;function z(j){return{customExecution:"customExecution"}}F.from=z;function L(j,U){return U.get(j)}F.to=L})(g||(e.CustomExecutionDTO=g={}));var w;(function(F){function T(z,L){let j;return z.scope!==void 0&&typeof z.scope!="number"?j=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===M.TaskScope.Workspace&&L&&L.workspaceFile?j=L.workspaceFile:j=i.$dI),{id:z._id,workspaceFolder:j}}F.from=T})(w||(e.TaskHandleDTO=w={}));var S;(function(F){function T(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}F.from=T})(S||(S={}));var m;(function(F){function T(j,U){if(j==null)return[];const X=[];for(const ie of j){const q=z(ie,U);q&&X.push(q)}return X}F.fromMany=T;function z(j,U){if(j==null)return;let X;j.execution instanceof M.$2M?X=r.from(j.execution):j.execution instanceof M.$3M?X=f.from(j.execution):j.execution&&j.execution instanceof M.$4M&&(X=g.from(j.execution));const ie=s.from(j.definition);let q;return j.scope?typeof j.scope=="number"?q=j.scope:q=j.scope.uri:q=M.TaskScope.Workspace,!ie||!q?void 0:{_id:j._id,definition:ie,name:j.name,source:{extensionId:U.identifier.value,label:j.source,scope:q},execution:X,isBackground:j.isBackground,group:S.from(j.group),presentationOptions:t.from(j.presentationOptions),problemMatchers:j.problemMatchers,hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}F.from=z;async function L(j,U,X){if(j==null)return;let ie;r.is(j.execution)?ie=r.to(j.execution):f.is(j.execution)?ie=f.to(j.execution):g.is(j.execution)&&(ie=g.to(j._id,X));const q=s.to(j.definition);let G;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?G=j.source.scope:G=await U.resolveWorkspaceFolder(h.URI.revive(j.source.scope)):G=M.TaskScope.Workspace),!q||!G)return;const x=new M.$5M(q,G,j.name,j.source.label,ie,j.problemMatchers);return j.isBackground!==void 0&&(x.isBackground=j.isBackground),j.group!==void 0&&(x.group=M.$1M.from(j.group._id),x.group&&j.group.isDefault&&(x.group=new M.$1M(x.group.id,x.group.label),j.group.isDefault===!0&&(x.group.isDefault=j.group.isDefault))),j.presentationOptions&&(x.presentationOptions=t.to(j.presentationOptions)),j._id&&(x._id=j._id),j.detail&&(x.detail=j.detail),x}F.to=L})(m||(e.TaskDTO=m={}));var E;(function(F){function T(L){return L}F.from=T;function z(L){if(L)return Object.assign(Object.create(null),L)}F.to=z})(E||(E={}));class D{#e;constructor(T,z,L){this._id=z,this.a=L,this.#e=T}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(T){}fireDidEndProcess(T){}}let C=class{constructor(T,z,L,j,U,X,ie,q){this.q=new O.$de,this.r=new O.$de,this.s=new O.$de,this.u=new O.$de,this.a=T.getProxy(R.$dM.MainThreadTask),this.b=L,this.c=j,this.d=U,this.e=X,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ie,this.g=q,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(T,z,L){if(!L)return new M.$fM(()=>{});const j=this.x();return this.j.set(j,{type:z,provider:L,extension:T}),this.a.$registerTaskProvider(j,z),new M.$fM(()=>{this.j.delete(j),this.a.$unregisterTaskProvider(j)})}registerTaskSystem(T,z){this.a.$registerTaskSystem(T,z)}fetchTasks(T){return this.a.$fetchTasks(E.from(T)).then(async z=>{const L=[];for(const j of z){const U=await m.to(j,this.b,this.m);U&&L.push(U)}return L})}get taskExecutions(){const T=[];return this.k.forEach(z=>T.push(z)),T}terminateTask(T){if(!(T instanceof D))throw new Error("No valid task execution provided");return this.a.$terminateTask(T._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(T,z,L){const j=this.m.get(T.id);j&&(this.o.set(T.id,j),this.e.attachPtyToTerminal(z,await j.callback(L))),this.p=T.id,this.q.fire({execution:await this.z(T)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(T){if(!this.l.has(T.id))return;const z=await this.z(T);this.l.delete(T.id),this.k.delete(T.id),this.B(T),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(T){const z=await this.z(T.id);this.s.fire({execution:z,processId:T.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(T){const z=await this.z(T.id);this.u.fire({execution:z,exitCode:T.exitCode})}$provideTasks(T,z){const L=this.j.get(T);if(!L)return Promise.reject(new Error("no handler found"));const j=[],U=(0,N.$oh)(()=>L.provider.provideTasks(A.CancellationToken.None)).then(X=>this.v(z,j,L,X));return new Promise(X=>{U.then(ie=>{Promise.all(j).then(()=>{X(ie)})})})}async $resolveTask(T,z){const L=this.j.get(T);if(!L)return Promise.reject(new Error("no handler found"));if(z.definition.type!==L.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${L.type}].`);const j=await m.to(z,this.b,this.m);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const U=await L.provider.resolveTask(j,A.CancellationToken.None);if(!U)return;this.A(U,L);const X=m.from(U,L.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(U.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return g.is(X.execution)&&await this.y(X,U,!0),await this.w(X)}x(){return this.h++}async y(T,z,L){const j=await this.a.$createTaskId(T);!L&&!this.m.has(j)&&(this.n.add(j),this.o.set(j,z.execution)),this.m.set(j,z.execution)}async z(T,z){if(typeof T=="string"){const U=this.l.get(T);if(!U)throw new u.$bb("Unexpected: The specified task is missing an execution");return U}const L=this.l.get(T.id);if(L)return L;let j;return z?j=Promise.resolve(new D(this,T.id,z)):j=m.to(T.task,this.b,this.m).then(U=>{if(!U)throw new u.$bb("Unexpected: Task does not exist.");return new D(this,T.id,U)}),this.l.set(T.id,j),j.then(U=>(this.k.set(T.id,U),U))}A(T,z){T._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}B(T){this.o.get(T.id)&&this.o.delete(T.id),this.n.has(T.id)&&this.p!==T.id&&(this.m.delete(T.id),this.n.delete(T.id));const L=this.n.values();let j=L.next();for(;!j.done;)!this.o.has(j.value)&&this.p!==j.value&&(this.m.delete(j.value),this.n.delete(j.value)),j=L.next()}};e.$jnc=C,e.$jnc=C=He([We(0,p.$EO),We(1,y.$UO),We(2,b.$Rlc),We(3,$.$PO),We(4,k.$Ulc),We(5,I.$gmc),We(6,o.$3j),We(7,n.$vlc)],C);let P=class extends C{constructor(T,z,L,j,U,X,ie,q){super(T,z,L,j,U,X,ie,q),this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:d.$h(0)})}async executeTask(T,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const L=m.from(z,T);if(L===void 0)throw new Error("Task is not valid");if(g.is(L.execution))await this.y(L,z,!1);else throw new u.$_;const j=await this.z(await this.a.$getTaskExecution(L),z);return this.a.$executeTask(L).catch(U=>{throw new Error(U)}),j}v(T,z,L,j){const U=[];if(j)for(const X of j){if(this.A(X,L),!X.definition||!T[X.definition.type]){const q=X.source?X.source:"No task source";this.f.warn(`The task [${q}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`)}const ie=m.from(X,L.extension);ie&&g.is(ie.execution)?(U.push(ie),z.push(this.y(ie,X,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:U,extension:L.extension}}async w(T){if(g.is(T.execution))return T;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(T,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(T,z,L){}};e.$knc=P,e.$knc=P=He([We(0,p.$EO),We(1,y.$UO),We(2,b.$Rlc),We(3,$.$PO),We(4,k.$Ulc),We(5,I.$gmc),We(6,o.$3j),We(7,n.$vlc)],P),e.$lnc=(0,v.$wi)("IExtHostTask")}),define(Se[373],De([1,0,37,29]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SK=void 0,e.$RK=O,e.$TK=R;function O(M){return"cellResults"in M}e.$SK="rawCell#";function R(M,b){let $=-1;const k=[];let A=[];return M.forEach(p=>{p.range.startLineNumber!==$&&A.length>0&&(k.push([...A]),A=[]),A.push(p),$=p.range.endLineNumber}),A.length>0&&k.push([...A]),k.map(p=>{const y=[],v=p[0].range.startLineNumber,l=p[p.length-1].range.endLineNumber;for(let d=v;d<=l;d++)y.push(b.getLineContent(d));return new h.$vK(y.join(`
`)+`
`,p.map(d=>new N.$ut(d.range.startLineNumber-1,d.range.startColumn-1,d.range.endLineNumber-1,d.range.endColumn-1)))})}}),define(Se[374],De([1,0,229,21,4,3,27,14,18,2,33,112,6,34,17,8,48,345,154,24,15,304,373,370]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d,o,n,i,u,s,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ymc=void 0;class r{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(f=>f.apiEditor)}constructor(f,g,w,S,m,E){this.q=w,this.r=S,this.s=m,this.t=E,this.f=new Map,this.g=new M.$Ac,this.h=new Map,this.j=new O.$de,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new O.$de,this.onDidOpenNotebookDocument=this.m.event,this.n=new O.$de,this.onDidCloseNotebookDocument=this.n.event,this.o=new O.$de,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$tlc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=f.getProxy(p.$dM.MainThreadNotebook),this.c=f.getProxy(p.$dM.MainThreadNotebookDocuments),this.d=f.getProxy(p.$dM.MainThreadNotebookEditors),this.i=g.converter,g.registerArgumentProcessor({processArgument:D=>{if(D&&D.$mid===13){const C=D.notebookEditor?.notebookUri,P=D.cell.handle,T=this.g.get(C)?.getCell(P);if(T)return T.apiCell}if(D&&D.$mid===14){const C=D.uri,P=this.g.get(C);if(P)return P.apiNotebook}return D}}),r.B(g)}getEditorById(f){const g=this.h.get(f);if(!g)throw new Error(`unknown text editor: ${f}. known editors: ${[...this.h.keys()]} `);return g}getIdByEditor(f){for(const[g,w]of this.h)if(w.apiEditor===f)return g}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(f,g){const w=this.g.get(f);if(!w&&!g)throw new Error(`NO notebook document for '${f}'`);return w}static u(f,g){if(!g)return;const w=g.filenamePattern.map(S=>v.NotebookExclusiveDocumentPattern.from(S)).filter(S=>S!==void 0);if(g.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${g.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:g.displayName,filenamePattern:w,exclusive:g.exclusive||!1}}registerNotebookCellStatusBarItemProvider(f,g,w){const S=r.a++,m=typeof w.onDidChangeCellStatusBarItems=="function"?r.a++:void 0;this.f.set(S,w),this.b.$registerNotebookCellStatusBarItemProvider(S,m,g);let E;return m!==void 0&&(E=w.onDidChangeCellStatusBarItems(D=>this.b.$emitCellStatusBarEvent(m))),new l.$fM(()=>{this.f.delete(S),this.b.$unregisterNotebookCellStatusBarItemProvider(S,m),E?.dispose()})}async createNotebookDocument(f){const g=await this.c.$tryCreateNotebook({viewType:f.viewType,content:f.content&&v.NotebookData.from(f.content)});return k.URI.revive(g)}async openNotebookDocument(f){const g=this.g.get(f);if(g)return g.apiNotebook;const w=await this.c.$tryOpenNotebook(f),S=this.g.get(k.URI.revive(w));return(0,$.$hg)(S?.apiNotebook)}async showNotebookDocument(f,g){k.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let w;typeof g=="object"?w={position:v.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selections:g.selections&&g.selections.map(v.NotebookRange.from),pinned:typeof g.preview=="boolean"?!g.preview:void 0}:w={preserveFocus:!1};const S=await this.d.$tryShowNotebookDocument(f.uri,f.notebookType,w),m=S&&this.h.get(S)?.apiEditor;if(m)return m;throw S?new Error(`Could NOT open editor for "${f.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(f,g,w,S){const m=this.f.get(f),E=k.URI.revive(g),D=this.g.get(E);if(!D||!m)return;const C=D.getCellFromIndex(w);if(!C)return;const P=await m.provideCellStatusBarItems(C.apiCell,S);if(!P)return;const F=new R.$Tc,T=this.p.add([F]),L=(Array.isArray(P)?P:[P]).map(j=>v.NotebookStatusBarItem.from(j,this.i,F));return{cacheId:T,items:L}}$releaseNotebookCellStatusBarItems(f){this.p.delete(f)}registerNotebookSerializer(f,g,w,S,m){if((0,b.$7e)(g))throw new Error("viewType cannot be empty or just whitespace");const E=this.w++;return this.x.set(E,{viewType:g,serializer:w,options:S}),this.b.$registerNotebookSerializer(E,{id:f.identifier,location:f.extensionLocation},g,v.NotebookDocumentContentOptions.from(S),r.u(f,m)),(0,R.$Sc)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook(f,g,w){const S=this.x.get(f);if(!S)throw new Error("NO serializer found");const m=await S.serializer.deserializeNotebook(g.buffer,w);return new d.$Bw(v.NotebookData.from(m))}async $notebookToData(f,g,w){const S=this.x.get(f);if(!S)throw new Error("NO serializer found");const m=await S.serializer.serializeNotebook(v.NotebookData.to(g.value),w);return N.$Fe.wrap(m)}async $saveNotebook(f,g,w,S,m){const E=k.URI.revive(g),D=this.x.get(f);if(!D)throw new Error("NO serializer found");const C=this.g.get(E);if(!C)throw new Error("Document NOT found");if(C.versionId!==w)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new A.$ll((0,h.localize)(0,null,this.z(E)),6);await this.y(E,S);const P={metadata:(0,i.$$n)(C.apiNotebook.metadata,j=>!(D.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of C.apiNotebook.getCells()){const U=new l.$IN(j.kind,j.document.getText(),j.document.languageId,j.mime,D.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);U.metadata=(0,i.$$n)(j.metadata,X=>!(D.options?.transientCellMetadata??{})[X]),P.cells.push(U)}const F=await D.serializer.serializeNotebook(P,m);await this.s.value.writeFile(E,F);const T=this.s.getFileSystemProviderExtUri(E.scheme),z=await this.s.value.stat(E);return{name:T.basename(E),isFile:(z.type&A.FileType.File)!==0,isDirectory:(z.type&A.FileType.Directory)!==0,isSymbolicLink:(z.type&A.FileType.SymbolicLink)!==0,mtime:z.mtime,ctime:z.ctime,size:z.size,readonly:!!((z.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((z.permissions??0)&A.FilePermission.Locked),etag:A.$wl({mtime:z.mtime,size:z.size}),children:void 0}}async $searchInNotebooks(f,g,w,S,m){const E=this.x.get(f)?.serializer;if(!E)return{limitHit:!1,results:[]};const D=new M.$Bc;await(async(z,L,j)=>{await Promise.all(z.map(async U=>await Promise.all(U.filenamePatterns.map(X=>{const ie={_reason:j._reason,folderQueries:j.folderQueries,includePattern:j.includePattern,excludePattern:j.excludePattern,maxResults:j.maxResults,type:1,filePattern:X};return this.t.doInternalFileSearchWithCustomCallback(ie,L,q=>{q.forEach(G=>{D.has(G)||S.some(ne=>U.isFromSettings&&!ne.isFromSettings?!1:ne.filenamePatterns.some(be=>(0,c.$Cgb)(be,G)))||D.add(G)})}).catch(q=>{if(q.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw q})}))))})(w,m,g);const P=new M.$Ac;let F=!1;const T=Array.from(D).map(async z=>{const L=[];try{if(m.isCancellationRequested)return;if(g.maxResults&&[...P.values()].reduce((ie,q)=>ie+q.cellResults.length,0)>g.maxResults){F=!0;return}const j=[],U=this.g.get(z);if(U)U.apiNotebook.getCells().forEach(q=>j.push({input:q.document.getText(),outputs:q.outputs.flatMap(G=>G.items.map(x=>x.data.toString()))}));else{const ie=await this.s.value.readFile(z),q=N.$Fe.fromString(ie.toString()),G=await E.deserializeNotebook(q.buffer,m);if(m.isCancellationRequested)return;v.NotebookData.from(G).cells.forEach(ne=>j.push({input:ne.source,outputs:ne.outputs.flatMap(be=>be.items.map(ae=>ae.valueBytes.toString()))}))}if(m.isCancellationRequested)return;j.forEach((ie,q)=>{const G=g.contentPattern.pattern,x=new s.$yXb(ie.input,void 0,ie.outputs),ne=x.findInInputs(G),be=x.findInOutputs(G),ae=be.flatMap(Ie=>(0,t.$TK)(Ie.matches,Ie.textBuffer)).map((Ie,ee)=>(Ie.webviewIndex=ee,Ie));if(ne.length>0||be.length>0){const Ie={index:q,contentResults:(0,t.$TK)(ne,x.inputTextBuffer),webviewResults:ae};L.push(Ie)}});const X={resource:z,cellResults:L};P.set(z,X);return}catch{return}});return await Promise.all(T),{limitHit:F,results:[...P.values()]}}async y(f,g){const w=await this.s.value.stat(f);if(typeof g?.mtime=="number"&&typeof g.etag=="string"&&g.etag!==A.$vl&&typeof w.mtime=="number"&&typeof w.size=="number"&&g.mtime<w.mtime&&g.etag!==A.$wl({mtime:g.mtime,size:w.size}))throw new A.$ll((0,h.localize)(1,null),3,g)}z(f){return f.scheme===u.Schemas.file?f.fsPath:f.toString()}A(f,g,w){if(this.h.has(g))throw new Error(`editor with id ALREADY EXSIST: ${g}`);const S=new n.$Pmc(g,this.d,f,w.visibleRanges.map(v.NotebookRange.to),w.selections.map(v.NotebookRange.to),typeof w.viewColumn=="number"?v.ViewColumn.to(w.viewColumn):void 0);this.h.set(g,S)}$acceptDocumentAndEditorsDelta(f){if(f.value.removedDocuments)for(const w of f.value.removedDocuments){const S=k.URI.revive(w),m=this.g.get(S);m&&(m.dispose(),this.g.delete(S),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:m.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(m.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===S.toString()&&this.h.delete(E.id)}if(f.value.addedDocuments){const w=[];for(const S of f.value.addedDocuments){const m=k.URI.revive(S.uri);if(this.g.has(m))throw new Error(`adding EXISTING notebook ${m} `);const E=new o.$Omc(this.c,this.q,this.r,m,S);w.push(...S.cells.map(D=>o.$Nmc.asModelAddData(D))),this.g.get(m)?.dispose(),this.g.set(m,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(E.apiNotebook)}}if(f.value.addedEditors)for(const w of f.value.addedEditors){if(this.h.has(w.id))return;const S=k.URI.revive(w.documentUri),m=this.g.get(S);m&&this.A(m,w.id,w)}const g=[];if(f.value.removedEditors)for(const w of f.value.removedEditors){const S=this.h.get(w);S&&(this.h.delete(w),this.k?.id===S.id&&(this.k=void 0),g.push(S))}if(f.value.visibleEditors){this.l=f.value.visibleEditors.map(S=>this.h.get(S)).filter(S=>!!S);const w=new Set;this.l.forEach(S=>w.add(S.id));for(const S of this.h.values()){const m=w.has(S.id);S._acceptVisibility(m)}this.l=[...this.h.values()].map(S=>S).filter(S=>S.visible),this.o.fire(this.visibleNotebookEditors)}f.value.newActiveEditor===null?this.k=void 0:f.value.newActiveEditor&&(this.h.get(f.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${f.value.newActiveEditor}`),this.k=this.h.get(f.value.newActiveEditor)),f.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(f){const g=y.$3O.String.with("notebookType","A notebook type"),w=new y.$5O("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[g,new y.$3O("data","Bytes to convert to data",m=>m instanceof Uint8Array,m=>N.$Fe.wrap(m))],new y.$4O("Notebook Data",m=>v.NotebookData.to(m.value))),S=new y.$5O("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[g,new y.$3O("NotebookData","Notebook data to convert to bytes",m=>!0,m=>new d.$Bw(v.NotebookData.from(m)))],new y.$4O("Bytes",m=>m.buffer));f.registerApiCommand(w),f.registerApiCommand(S)}}e.$Ymc=r}),define(Se[375],De([1,0,16,22,47,35,23,40,37]),function(he,e,h,N,O,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qmc=void 0;class k{constructor(p,y,v){this.k=p,this.l=y,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=p.filePattern,this.b=p.includePattern&&R.$qk(p.includePattern),this.c=p.maxResults||void 0,this.d=p.exists,this.h=new Set,this.j=p.excludePattern&&R.$qk(p.excludePattern)}cancel(){this.g=!0,this.h.forEach(p=>p.cancel()),this.h=new Set}search(p){const y=this.k.folderQueries||[];return new Promise((v,l)=>{const d=o=>{this.f++,p(o)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const n=o.toString(),i=h.$nc(n);this.j&&this.j(n,i)||this.v(d,{base:o,basename:i})}),Promise.all(y.map(o=>this.p(o,d))).then(o=>{v({limitHit:this.e,stats:o[0]||void 0})},o=>{l(new Error((0,O.$hj)(o)))})})}async p(p,y){const v=new N.$oe,l=this.q(p),d=this.r(),o=new $.$JK(this.k,p),n=!o.hasSiblingExcludeClauses();let i;try{this.h.add(v),i=b.$_d.create();const u=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},l,v.token),s=i.elapsed(),t=b.$_d.create();return this.g&&!this.e||(u&&u.forEach(c=>{const r=h.$gc.relative(p.folder.path,c.path);if(n){const a=h.$nc(c.path);this.v(y,{base:p.folder,relativePath:r,basename:a});return}this.s(d,p.folder,r,y)}),this.g&&!this.e)?null:(this.u(d,o,y),{providerTime:s,postProcessTime:t.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(p){const y=(0,$.$IK)(this.k.includePattern,p.includePattern),v=(0,$.$IK)(this.k.excludePattern,p.excludePattern);return{folder:p.folder,excludes:v,includes:y,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}s({pathToEntries:p},y,v,l){if(v===this.a){const o=h.$nc(this.a);this.v(l,{base:y,relativePath:this.a,basename:o})}function d(o){const n=h.$nc(o),i=h.$mc(o);let u=p[i];u||(u=p[i]=[],d(i)),u.push({base:y,relativePath:o,basename:n})}d(v)}u({rootEntries:p,pathToEntries:y},v,l){const d=this,o=this.a;function n(i){const u=(0,$.$LK)(()=>i.map(s=>s.basename));for(let s=0,t=i.length;s<t;s++){const c=i[s],{relativePath:r,basename:a}=c;if(v.matchesExcludesSync(r,a,o!==a?u:void 0))continue;const f=y[r];if(f)n(f);else{if(r===o)continue;d.v(l,c)}if(d.e)break}}n(p)}v(p,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||p(y))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(p,y,v,l){const d=this.c(p.cacheKey),o=new k(p,y,d&&d.token);let n=0;const i=u=>{n+=u.length,v(u.map(s=>this.d(s)))};return this.e(o,A.a,i,l).then(u=>({limitHit:u.limitHit,stats:u.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:u.stats}:void 0,messages:[]}))}clearCache(p){this.c(p)?.cancel()}c(p){if(p)return this.b.has(p)||this.b.set(p,new N.$oe),this.b.get(p)}d(p){return p.relativePath?{resource:M.$0g(p.base,p.relativePath)}:{resource:p.base}}e(p,y,v,l){const d=l.onCancellationRequested(()=>{p.cancel()}),o=i=>{i&&(n.push(i),y>0&&n.length>=y&&(v(n),n=[]))};let n=[];return p.search(o).then(i=>(n.length&&v(n),d.dispose(),i),i=>(n.length&&v(n),d.dispose(),Promise.reject(i)))}}e.$Qmc=A}),define(Se[376],De([1,0,19,74,35,103,27,15,16,23,14,18,2,100,250,55,11,42,147,371,37]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d,o,n,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=void 0,e.$UL=S;let s=class{constructor(E,D,C,P,F){this.a=E,this.b=D,this.c=C,this.d=P,this.e=F}text(E,D,C={}){E=this.f(E,C);const P=this.a.getValue(),F=D&&D.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(D?.map(o.$Ri),C),type:2,contentPattern:E,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:P.search.usePCRE2||F||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(E,D){const C=this.a.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const P={...E,wordSeparators:C.editor.wordSeparators};return this.j(E,D)&&(P.isCaseSensitive=!0),this.k(E)&&(P.isMultiline=!0),D.notebookSearchConfig?.includeMarkupInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownInput=D.notebookSearchConfig.includeMarkupInput),D.notebookSearchConfig?.includeMarkupPreview&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownPreview=D.notebookSearchConfig.includeMarkupPreview),D.notebookSearchConfig?.includeCodeInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellInput=D.notebookSearchConfig.includeCodeInput),D.notebookSearchConfig?.includeOutput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellOutput=D.notebookSearchConfig.includeOutput),P}file(E,D={}){return{...this.h(E,D),type:1,filePattern:D.filePattern?D.filePattern.trim():D.filePattern,exists:D.exists,sortByScore:D.sortByScore,cacheKey:D.cacheKey,shouldGlobMatchFilePattern:D.shouldGlobSearch}}g(E,D){return E?(E=Array.isArray(E)?E.map(f):f(E),D?this.parseSearchPaths(E):{pattern:c(...Array.isArray(E)?E:[E])}):{}}h(E=[],D={}){const C=this.g(D.includePattern,D.expandPatterns),P=this.g(D.excludePattern,D.expandPatterns),F=E.length>1,T=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(j=>this.q(j,D,P)):E.map(j=>this.r(j,D,P,F))).filter(j=>!!j),z={_reason:D._reason,folderQueries:T,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:D.extraFileResources,excludePattern:P.pattern,includePattern:C.pattern,onlyOpenEditors:D.onlyOpenEditors,maxResults:D.maxResults};if(D.onlyOpenEditors){const j=h.$Hb(this.c.groups.flatMap(ie=>ie.editors.map(q=>q.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(j));const U=j.filter(ie=>(0,u.$zK)(z,ie.fsPath)),X=this.i(U);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(X)),{...z,...X}}const L=D.extraFileResources&&D.extraFileResources.filter(j=>(0,u.$zK)(z,j.fsPath));return z.extraFileResources=L&&L.length?L:void 0,z}i(E){const D=[],C=new M.$Ac,P={};let F=!1;return E.forEach(T=>{if(T.scheme===b.Schemas.walkThrough)return;if((0,k.$bh)(T)){const L=this.b.getWorkspaceFolder(T)?.uri??T.with({path:$.$mc(T.fsPath)});let j=C.get(L);j||(F=!0,j={folder:L,includePattern:{}},D.push(j),C.set(L,j));const U=$.$lc(L.fsPath,T.fsPath);(0,I.$hg)(j.includePattern)[U.replace(/\\/g,"/")]=!0}else T.fsPath&&(F=!0,P[T.fsPath]=!0)}),{folderQueries:D,includePattern:P,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}j(E,D){if(D.isSmartCase){if(E.isRegExp){if(A.$Zf(E.pattern,!0))return!0}else if(A.$Zf(E.pattern))return!0}return!!E.isCaseSensitive}k(E){return E.isMultiline||E.isRegExp&&(0,y.$QC)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const D=X=>$.$ic(X)||/^\.\.?([\/\\]|$)/.test(X),P=(Array.isArray(E)?E:r(E)).map(X=>{const ie=this.e.resolvedUserHome;return ie?(0,R.$Gw)(X,ie.scheme===b.Schemas.file?ie.fsPath:ie.path):X}),F=N.$K(P,X=>D(X)?"searchPaths":"exprSegments"),T=(F.exprSegments||[]).map(X=>A.$ff(X,"/")).map(X=>A.$ff(X,"\\")).map(X=>(X[0]==="."&&(X="*"+X),a(X))),z={},L=this.m(F.searchPaths||[]);L&&L.length&&(z.searchPaths=L);const j=T.flat(),U=c(...j);return U&&(z.pattern=U),z}l(E,D){return D.disregardExcludeSettings?void 0:(0,u.$yK)(E,!D.disregardSearchExcludeSettings)}m(E){if(!E||!E.length)return[];const D=E.flatMap(P=>{let{pathPortion:F,globPortion:T}=t(P);return T&&(T=g(T)),this.n(F).flatMap(L=>this.o(L,T))}),C=new Map;return D.forEach(P=>{const F=P.searchPath.toString(),T=C.get(F);T?P.pattern&&(T.pattern=T.pattern||{},T.pattern[P.pattern]=!0):C.set(F,{searchPath:P.searchPath,pattern:P.pattern?c(P.pattern):void 0})}),Array.from(C.values())}n(E){if($.$ic(E)){const D=this.b.getWorkspace().folders;return D[0]&&D[0].uri.scheme!==b.Schemas.file?[{searchPath:D[0].uri.with({path:E})}]:[{searchPath:p.URI.file($.$hc(E))}]}if(this.b.getWorkbenchState()===2){const D=this.b.getWorkspace().folders[0].uri;if(E=f(E),E.startsWith("../")||E===".."){const P=$.$gc.resolve(D.path,E);return[{searchPath:D.with({path:P})}]}const C=g(E);return[{searchPath:D,pattern:C}]}else{if(E==="./"||E===".\\")return[];{const D=E.replace(/^\.[\/\\]/,""),P=this.b.getWorkspace().folders.map(F=>{const T=D.match(new RegExp(`^${A.$_e(F.name)}(?:/(.*)|$)`));return T?{match:T,folder:F}:null}).filter(I.$eg);if(P.length)return P.map(F=>{const T=F.match[1];return{searchPath:F.folder.uri,pattern:T&&g(T)}});{const F=E.match(/\.[\/\\](.+)[\/\\]?/),T=F?F[1]:E,z=v.localize(0,null,T);throw new Error(z)}}}}o(E,D){const C=E.pattern&&D?`${E.pattern}/${D}`:E.pattern||D,P=[{searchPath:E.searchPath,pattern:C}];return C&&!C.endsWith("**")&&P.push({searchPath:E.searchPath,pattern:C+"/**"}),P}q(E,D,C){const P=this.r((0,o.$Ri)(E.searchPath),D,C,!1);return P?{...P,includePattern:E.pattern}:null}r(E,D,C,P){let F;const T=p.URI.isUri(E)?E:E.uri;if(C.searchPaths){const X=C.searchPaths.filter(ie=>(0,k.$3g)(ie.searchPath,T))[0];if(X&&!X.pattern)return null;X&&(F=X.pattern)}const z=this.a.getValue({resource:T}),j={...this.l(z,D)||{},...F||{}},U=p.URI.isUri(E)?(0,k.$7g)(E):E.name;return{folder:T,folderName:P?U:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof D.disregardIgnoreFiles=="boolean"?D.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof D.disregardGlobalIgnoreFiles=="boolean"?D.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof D.disregardParentIgnoreFiles=="boolean"?D.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof D.ignoreSymlinks=="boolean"?D.ignoreSymlinks:!z.search.followSymlinks}}};e.$TL=s,e.$TL=s=He([We(0,l.$3i),We(1,o.$Fi),We(2,n.$YD),We(3,d.$3j),We(4,i.$RL)],s);function t(m){const E=m.match(/[\*\{\}\(\)\[\]\?]/);if(E){const D=E.index,C=m.substr(0,D).match(/[/|\\][^/\\]*$/);if(C){let P=m.substr(0,C.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:m.substr((C.index||0)+1)}}}return{pathPortion:m}}function c(...m){return m.length?m.reduce((E,D)=>(E[D]=!0,E),Object.create(null)):void 0}function r(m){return O.$ok(m,",").map(E=>E.trim()).filter(E=>!!E.length)}function a(m){return[`**/${m}/**`,`**/${m}`].map(D=>D.replace(/\*\*\/\*\*/g,"**"))}function f(m){return m.replace(/\\/g,"/")}function g(m){return f(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function w(m){return m.replace(/([?*[\]])/g,"[$1]")}function S(m,E){m=h.$Mb(m,P=>P.toString());const D=[],C=E.getWorkspace();return m&&m.forEach(P=>{let F;if(E.getWorkbenchState()===2)F=(0,k.$_g)(C.folders[0].uri,P),F&&F!=="."&&(F="./"+F);else{const T=E.getWorkspaceFolder(P);if(T){const z=T.name;if(C.folders.filter(j=>j.name===z).length===1){const j=(0,k.$_g)(T.uri,P);j===""?F=`./${T.name}`:F=`./${T.name}/${j}`}else F=P.fsPath}}F&&D.push(w(F))}),D}}),define(Se[377],De([1,0,23,2,22,13,5,376,37,42,7]),function(he,e,h,N,O,R,M,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vwb=p,e.$wwb=l;const I=7e3;function p(d,o){const n=o.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],u=[];for(const f of n)if(/^workspaceContains:/.test(f)){const g=f.substr(18);g.indexOf("*")>=0||g.indexOf("?")>=0||d.forceUsingSearch?u.push(g):i.push(g)}if(i.length===0&&u.length===0)return Promise.resolve(void 0);const{promise:s,resolve:t}=(0,A.$ph)(),c=f=>t({activationEvent:f}),r=Promise.all(i.map(f=>y(d,f,c))).then(()=>{}),a=v(d,o.identifier,u,c);return Promise.all([r,a]).then(()=>{t(void 0)}),s}async function y(d,o,n){for(const i of d.folders)if(await d.exists(h.$0g(N.URI.revive(i),o))){n(`workspaceContains:${o}`);return}}async function v(d,o,n,i){if(n.length===0)return Promise.resolve(void 0);const u=new O.$oe,s=d.checkExists(d.folders,n,u.token),t=setTimeout(async()=>{u.cancel(),d.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},I);let c=!1;try{c=await s}catch(r){R.$4(r)||R.$1(r)}u.dispose(),clearTimeout(t),c&&i(`workspaceContains:${n.join(",")}`)}function l(d,o,n,i){const u=d.get(M.$vi),s=d.get($.$qK),c=u.createInstance(b.$TL).file(o.map(r=>(0,k.$Ri)(N.URI.revive(r))),{_reason:"checkExists",includePattern:n,exists:!0});return s.fileSearch(c,i).then(r=>!!r.limitHit,r=>R.$4(r)?!1:Promise.reject(r))}}),define(Se[49],De([1,0,225,16,59,23,7,3,78,2,11,6,45,310,119,44,26,149,13,25,21,287,8,67,5,28,93,20,107,71,43,122,4,377,118,289,15,116,40,12,117]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d,o,n,i,u,s,t,c,r,a,f,g,w,S,m,E,D,C,P,F,T,z,L,j,U){"use strict";var X;Object.defineProperty(e,"__esModule",{value:!0}),e.$xmc=e.$wmc=e.$vmc=e.$umc=e.$tmc=void 0,e.$tmc=(0,r.$wi)("IHostUtils");let ie=X=class extends b.$Uc{constructor(B,_,pe,ue,ce,oe,le,K,se,$e,ve,Me,ge){super(),this.Y=Me,this.Z=ge,this.a=this.B(new D.$de),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=_,this.g=pe,this.f=le,this.j=ue,this.m=ce,this.s=oe,this.t=se,this.u=$e,this.w=ve,this.y=this.g.getProxy(I.$dM.MainThreadWorkspace),this.z=this.g.getProxy(I.$dM.MainThreadTelemetry),this.C=this.g.getProxy(I.$dM.MainThreadExtensionService),this.D=new M.$vh,this.F=new M.$vh,this.G=new M.$vh,this.H=new M.$vh,this.I=new Ie(this.f.extensions.activationEvents),this.L=new o.$7_b(this.I,this.f.extensions.allExtensions);const Ae=new i.$Sm(this.f.extensions.myExtensions);this.J=new o.$7_b(this.I,be(this.L,Ae)),j.$t&&(this.s.info(`Creating extension host with the following global extensions: ${x(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${x(this.J)}`)),this.M=new v.$cmc(this.g,this.s),this.N=new P.$mmc(this.g),this.O=K,this.h=B.createChild(new w.$ui([v.$dmc,this.M],[P.$nmc,this.N])),this.P=this.B(new y.$bmc(this.J,this.L,{onExtensionActivationError:(Re,je,V)=>{this.C.$onExtensionActivationError(Re,n.$3(je),V)},actualActivateExtension:async(Re,je)=>{if(o.$7_b.isHostExtension(Re,this.J,this.L))return await this.C.$activateExtension(Re,je),new y.$amc;const V=this.J.getExtensionDescription(Re);return this.fb(V,je)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),O.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(B){n.$1(B)}}async $(){this.O.onWillDeactivateAll();let B=[];try{B=this.J.getAllExtensionDescriptions().map(ce=>ce.identifier).filter(ce=>this.isActivated(ce)).map(ce=>this.eb(ce))}catch{}await Promise.all(B)}terminate(B,_=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${B}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(ue=>{this.s.error(ue)}),this.g.dispose();const pe=this.$();Promise.race([(0,M.$xh)(5e3),pe]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${_}`):this.s.info(`Extension host exiting with code ${_}`),this.s.flush(),this.s.dispose(),this.c.exit(_)})}isActivated(B){return this.G.isOpen()?this.P.isActivated(B):!1}async getExtension(B){const _=await this.C.$getExtension(B);return _&&{..._,identifier:new i.$Rm(_.identifier.value),extensionLocation:k.URI.revive(_.extensionLocation)}}ab(B,_){return this.P.activateByEvent(B,_)}bb(B,_){return this.P.activateById(B,_)}activateByIdWithErrors(B,_){return this.bb(B,_).then(()=>{const pe=this.P.getActivatedExtension(B);if(pe.activationFailed)return Promise.reject(pe.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(B=>this.J)}getExtensionExports(B){if(this.G.isOpen())return this.P.getActivatedExtension(B).exports;try{return this.P.getActivatedExtension(B).exports}catch{return null}}async cb(B){if(B.scheme===T.Schemas.file&&this.c.fsRealpath){const _=B.fsPath;this.R.has(_)||this.R.set(_,this.c.fsRealpath(_));const pe=await this.R.get(_);return k.URI.file(pe)}return B}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(B=>new ae(B))),this.Q}async db(B){const _=$.$Ci.forUris(pe=>R.$1g.ignorePathCasing(pe));return await Promise.all(B.map(async pe=>{if(this.wb(pe)){const ue=await this.cb(pe.extensionLocation);_.set(ue,pe)}})),_}eb(B){let _=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(B))return _;const pe=this.P.getActivatedExtension(B);if(!pe)return _;try{typeof pe.module.deactivate=="function"&&(_=Promise.resolve(pe.module.deactivate()).then(void 0,ue=>(this.s.error(ue),Promise.resolve(void 0))))}catch(ue){this.s.error(`An error occurred when deactivating the extension '${B.value}':`),this.s.error(ue)}try{(0,b.$Pc)(pe.subscriptions)}catch(ue){this.s.error(`An error occurred when deactivating the subscriptions for extension '${B.value}':`),this.s.error(ue)}return _}async fb(B,_){return this.f.remote.isRemote?this.C.$onWillActivateExtension(B.identifier):await this.C.$onWillActivateExtension(B.identifier),this.hb(B,_).then(pe=>{const ue=pe.activationTimes;return this.C.$onDidActivateExtension(B.identifier,ue.codeLoadingTime,ue.activateCallTime,ue.activateResolvedTime,_),this.gb(B,_,"success",ue),pe},pe=>{throw this.gb(B,_,"failure"),pe})}gb(B,_,pe,ue){const ce=G(B,_);this.z.$publicLog2("extensionActivationTimes",{...ce,...ue||{},outcome:pe})}hb(B,_){const pe=G(B,_);this.z.$publicLog2("activatePlugin",pe);const ue=this.wb(B);if(!ue)return Promise.resolve(new y.$_lc(y.$9lc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${B.identifier.value}, startup: ${_.startup}, activationEvent: '${_.activationEvent}'${B.identifier.value!==_.extensionId.value?`, root cause: ${_.extensionId.value}`:""}`),this.s.flush();const ce=new y.$0lc(_.startup);return Promise.all([this.xb(B,(0,R.$0g)(B.extensionLocation,ue),ce),this.ib(B)]).then(oe=>(O.mark(`code/extHost/willActivateExtension/${B.identifier.value}`),X.jb(this.s,B.identifier,oe[0],oe[1],ce))).then(oe=>(O.mark(`code/extHost/didActivateExtension/${B.identifier.value}`),oe))}ib(B){const _=this.Z.createLanguageModelAccessInformation(B),pe=new s.$fmc(B,this.M),ue=new s.$emc(B.identifier.value,!1,this.M),ce=new F.$omc(B,this.N),oe=B.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,le=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${B.identifier.value}`),Promise.all([pe.whenReady,ue.whenReady,this.O.whenReady]).then(()=>{const K=this;let se,$e;const ve=(0,d.$OG)(B,"ipc")?this.f.messagePorts?.get(i.$Rm.toKey(B.identifier)):void 0;return Object.freeze({globalState:pe,workspaceState:ue,secrets:ce,subscriptions:[],get languageModelAccessInformation(){return _},get extensionUri(){return B.extensionLocation},get extensionPath(){return B.extensionLocation.fsPath},asAbsolutePath(Me){return N.$jc(B.extensionLocation.fsPath,Me)},get storagePath(){return K.O.workspaceValue(B)?.fsPath},get globalStoragePath(){return K.O.globalValue(B).fsPath},get logPath(){return N.$jc(K.f.logsLocation.fsPath,B.identifier.value)},get logUri(){return k.URI.joinPath(K.f.logsLocation,B.identifier.value)},get storageUri(){return K.O.workspaceValue(B)},get globalStorageUri(){return K.O.globalValue(B)},get extensionMode(){return oe},get extension(){return se===void 0&&(se=new ne(K,B.identifier,B,le,!1)),se},get extensionRuntime(){return(0,d.$PG)(B,"extensionRuntime"),K.extensionRuntime},get environmentVariableCollection(){return K.u.getEnvironmentVariableCollection(B)},get messagePassingProtocol(){if(!$e){if(!ve)return;const Me=D.Event.buffer(D.Event.fromDOMEventEmitter(ve,"message",ge=>ge.data));ve.start(),$e={onDidReceiveMessage:Me,postMessage:ve.postMessage.bind(ve)}}return $e}})})}static jb(B,_,pe,ue,ce){return pe=pe||{activate:void 0,deactivate:void 0},this.kb(B,_,pe,ue,ce).then(oe=>new y.$$lc(!1,null,ce.build(),pe,oe,ue.subscriptions))}static kb(B,_,pe,ue,ce){if(typeof pe.activate=="function")try{ce.activateCallStart(),B.trace(`ExtensionService#_callActivateOptional ${_.value}`);const oe=typeof global=="object"?global:self,le=pe.activate.apply(oe,[ue]);return ce.activateCallStop(),ce.activateResolveStart(),Promise.resolve(le).then(K=>(ce.activateResolveStop(),K))}catch(oe){return Promise.reject(oe)}else return Promise.resolve(pe)}lb(B,_){this.bb(B.identifier,{startup:!1,extensionId:B.identifier,activationEvent:_}).then(void 0,pe=>{this.s.error(pe)})}mb(B,_=0){const ue=Date.now();(0,j.$B)(()=>{for(let ce=_;ce<B.length;ce+=1){const oe=B[ce];for(const le of oe.activationEvents??[])if(le==="onStartupFinished")if(Date.now()-ue>50){this.mb(B,ce);break}else this.lb(oe,le)}})}nb(){this.C.$setPerformanceMarks(O.getMarks()),this.m.getConfigProvider().then(B=>{const _=B.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),pe=this.J.getAllExtensionDescriptions();if(_)this.mb(pe);else for(const ue of pe)if(ue.activationEvents)for(const ce of ue.activationEvents)ce==="onStartupFinished"&&this.lb(ue,ce)})}ob(){const B=this.ab("*",!0).then(void 0,oe=>{this.s.error(oe)});this.B(this.j.onDidChangeWorkspace(oe=>this.pb(oe.added)));const _=this.j.workspace?this.j.workspace.folders:[],pe=this.pb(_),ue=this.rb(),ce=Promise.all([ue,B,pe]).then(()=>{});return Promise.race([ce,(0,M.$xh)(1e4)]).then(()=>{this.nb()}),ce}pb(B){return B.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(_=>this.qb(B,_))).then(()=>{})}async qb(B,_){if(this.isActivated(_.identifier))return;const pe=!this.f.remote.isRemote&&!!this.f.remote.authority,ue={logService:this.s,folders:B.map(oe=>oe.uri),forceUsingSearch:pe||!this.c.fsExists,exists:oe=>this.c.fsExists(oe.fsPath),checkExists:(oe,le,K)=>this.y.$checkExists(oe,le,K)},ce=await(0,C.$vwb)(ue,_);if(ce)return this.bb(_.identifier,{startup:!0,extensionId:_.identifier,activationEvent:ce.activationEvent}).then(void 0,oe=>this.s.error(oe))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(B){throw console.error(B),B}}async sb(){const{extensionDevelopmentLocationURI:B,extensionTestsLocationURI:_}=this.f.environment;if(!B||!_)throw new Error(h.localize(0,null));const pe=await this.xb(null,_,new y.$0lc(!1));if(!pe||typeof pe.run!="function")throw new Error(h.localize(1,null,_.toString()));return new Promise((ue,ce)=>{const oe=(se,$e)=>{se?(j.$t&&this.s.error("Test runner called back with error",se),ce(se)):(j.$t&&($e?this.s.info(`Test runner called back with ${$e} failures.`):this.s.info("Test runner called back with successful outcome.")),ue(typeof $e=="number"&&$e>0?1:0))},le=(0,R.$Xg)(_),K=pe.run(le,oe);K&&K.then&&K.then(()=>{j.$t&&this.s.info("Test runner finished successfully."),ue(0)}).catch(se=>{j.$t&&this.s.error("Test runner finished with error",se),ce(se instanceof Error&&se.stack?se.stack:String(se))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$xh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(B,_){return this.S[B]=_,(0,b.$Sc)(()=>{delete this.S[B]})}async getRemoteExecServer(B){const{resolver:_}=await this.ub(B);return _?.resolveExecServer?.(B,{resolveAttempt:0})}async ub(B){const _=B.indexOf("+");if(_===-1)throw new t.$lM("Not an authority that can be resolved!",c.RemoteAuthorityResolverErrorCode.InvalidAuthority);const pe=B.substr(0,_);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${pe}`,!1),{authorityPrefix:pe,resolver:this.S[pe]}}async $resolveAuthority(B,_){const pe=L.$_d.create(!1),ue=()=>`[resolveAuthority(${(0,c.$Ll)(B)},${_})][${pe.elapsed()}ms] `,ce=W=>this.s.info(`${ue()}${W}`),oe=W=>this.s.warn(`${ue()}${W}`),le=(W,J=void 0)=>this.s.error(`${ue()}${W}`,J),K=W=>{if(W instanceof t.$lM)return{type:"error",error:{code:W._code,message:W._message,detail:W._detail}};throw W},se=async W=>{ce(`activating resolver for ${W}...`);const{resolver:J,authorityPrefix:Z}=await this.ub(W);if(!J)throw le(`no resolver for ${Z}`),new t.$lM(`No remote extension installed to resolve ${Z}.`,c.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:J,authorityPrefix:Z,remoteAuthority:W}},$e=B.split(/@|%40/g).reverse();ce(`activating remote resolvers ${$e.join(" -> ")}`);let ve;try{ve=await Promise.all($e.map(se)).catch(async W=>{if(!(W instanceof t.$lM)||W._code!==c.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw W;return oe(`resolving nested authorities failed: ${W.message}`),[await se(B)]})}catch(W){return K(W)}const Me=new M.$Hh;Me.cancelAndSet(()=>ce("waiting..."),1e3);let ge,Ae;for(const[W,{authorityPrefix:J,resolver:Z,remoteAuthority:de}]of ve.entries())try{if(W===ve.length-1)ce("invoking final resolve()..."),O.mark(`code/extHost/willResolveAuthority/${J}`),ge=await Z.resolve(de,{resolveAttempt:_,execServer:Ae}),O.mark(`code/extHost/didResolveAuthorityOK/${J}`),ce("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Z,t.$kM.isManagedResolvedAuthority(ge)?ge:void 0));else{if(ce(`invoking resolveExecServer() for ${de}`),O.mark(`code/extHost/willResolveExecServer/${J}`),Ae=await Z.resolveExecServer?.(de,{resolveAttempt:_,execServer:Ae}),!Ae)throw new t.$lM(`Exec server was not available for ${de}`,c.RemoteAuthorityResolverErrorCode.NoResolverFound);O.mark(`code/extHost/didResolveExecServerOK/${J}`)}}catch(we){return O.mark(`code/extHost/didResolveAuthorityError/${J}`),le("returned an error",we),Me.dispose(),K(we)}Me.dispose();const Re={environmentTunnels:ge.environmentTunnels,features:ge.tunnelFeatures?{elevation:ge.tunnelFeatures.elevation,privacyOptions:ge.tunnelFeatures.privacyOptions,protocol:ge.tunnelFeatures.protocol===void 0?!0:ge.tunnelFeatures.protocol}:void 0},je={extensionHostEnv:ge.extensionHostEnv,isTrusted:ge.isTrusted,authenticationSession:ge.authenticationSessionForInitializingExtensions?{id:ge.authenticationSessionForInitializingExtensions.id,providerId:ge.authenticationSessionForInitializingExtensions.providerId}:void 0};ce(`returned ${t.$kM.isManagedResolvedAuthority(ge)?"managed authority":`${ge.host}:${ge.port}`}`);let V;if(t.$kM.isManagedResolvedAuthority(ge)){const W=_;this.Y.setFactory(W,ge.makeConnection),V={authority:B,connectTo:new c.$Il(W),connectionToken:ge.connectionToken}}else V={authority:B,connectTo:new c.$Jl(ge.host,ge.port),connectionToken:ge.connectionToken};return{type:"ok",value:{authority:V,options:je,tunnelInformation:Re}}}async $getCanonicalURI(B,_){this.s.info(`$getCanonicalURI invoked for authority (${(0,c.$Ll)(B)})`);const{resolver:pe}=await this.ub(B);if(!pe)return null;const ue=k.URI.revive(_);if(typeof pe.getCanonicalURI>"u")return ue;const ce=await(0,M.$oh)(()=>pe.getCanonicalURI(ue));return ce||ue}async $startExtensionHost(B){B.toAdd.forEach(oe=>oe.extensionLocation=k.URI.revive(oe.extensionLocation));const{globalRegistry:_,myExtensions:pe}=q(this.I,this.L,this.J,B),ue=await this.db(pe);return(await this.getExtensionPathIndex()).setSearchTree(ue),this.L.set(_.getAllExtensionDescriptions()),this.J.set(pe),j.$t&&(this.s.info(`$startExtensionHost: global extensions: ${x(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${x(this.J)}`)),this.tb()}$activateByEvent(B,_){return _===1?this.D.wait().then(pe=>this.ab(B,!1)):this.G.wait().then(pe=>this.ab(B,!1))}async $activate(B,_){return await this.G.wait(),this.J.getExtensionDescription(B)?(await this.bb(B,_),!0):!1}async $deltaExtensions(B){B.toAdd.forEach(oe=>oe.extensionLocation=k.URI.revive(oe.extensionLocation));const{globalRegistry:_,myExtensions:pe}=q(this.I,this.L,this.J,B),ue=await this.db(pe);return(await this.getExtensionPathIndex()).setSearchTree(ue),this.L.set(_.getAllExtensionDescriptions()),this.J.set(pe),j.$t&&(this.s.info(`$deltaExtensions: global extensions: ${x(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${x(this.J)}`)),Promise.resolve(void 0)}async $test_latency(B){return B}async $test_up(B){return B.byteLength}async $test_down(B){const _=u.$Fe.alloc(B),pe=Math.random()%256;for(let ue=0;ue<B;ue++)_.writeUInt8(pe,ue);return _}async $updateRemoteConnectionData(B){this.X=B,this.a.fire()}};e.$umc=ie,e.$umc=ie=X=He([We(0,r.$vi),We(1,e.$tmc),We(2,g.$EO),We(3,l.$Rlc),We(4,p.$Ulc),We(5,A.$3j),We(6,a.$UO),We(7,f.$Xlc),We(8,S.$CDb),We(9,m.$gmc),We(10,z.$qmc),We(11,U.$rmc),We(12,E.$kmc)],ie);function q(ee,B,_,pe){ee.addActivationEvents(pe.addActivationEvents);const ue=new o.$7_b(ee,B.getAllExtensionDescriptions());ue.deltaExtensions(pe.toAdd,pe.toRemove);const ce=new i.$Sm(_.getAllExtensionDescriptions().map(le=>le.identifier));for(const le of pe.myToRemove)ce.delete(le);for(const le of pe.myToAdd)ce.add(le);const oe=be(ue,ce);return{globalRegistry:ue,myExtensions:oe}}function G(ee,B){return{id:ee.identifier.value,name:ee.name,extensionVersion:ee.version,publisherDisplayName:ee.publisher,activationEvents:ee.activationEvents?ee.activationEvents.join(","):null,isBuiltin:ee.isBuiltin,reason:B.activationEvent,reasonId:B.extensionId.value}}function x(ee){return ee.getAllExtensionDescriptions().map(B=>B.identifier.value).join(",")}e.$vmc=(0,r.$wi)("IExtHostExtensionService");class ne{#e;#t;#n;constructor(B,_,pe,ue,ce){this.#e=B,this.#t=_,this.#n=pe.identifier,this.id=pe.identifier.value,this.extensionUri=pe.extensionLocation,this.extensionPath=N.$hc((0,R.$Xg)(pe.extensionLocation)),this.packageJSON=pe,this.extensionKind=ue,this.isFromDifferentExtensionHost=ce}get isActive(){return this.#e.isActivated(this.#n)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#n)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#n,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$wmc=ne;function be(ee,B){return ee.getAllExtensionDescriptions().filter(_=>B.has(_.identifier))}class ae{constructor(B){this.a=B}setSearchTree(B){this.a=B}findSubstr(B){return this.a.findSubstr(B)}forEach(B){return this.a.forEach(B)}}e.$xmc=ae;class Ie{constructor(B){this.a=new i.$Tm,this.addActivationEvents(B)}readActivationEvents(B){return this.a.get(B.identifier)??[]}addActivationEvents(B){for(const _ of Object.keys(B))this.a.set(_,B[_])}}}),define(Se[378],De([1,0,59,2,6,45,26,25,20,28,5,49,11,14]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fnc=void 0;let l=class{constructor(u,s,t,c,r,a,f){this.c=u,this.d=s,this.e=t,this.f=c,this.g=r,this.h=a,this.i=f,this.a=new Map,this.b=[]}async install(){this.j(),h.mark("code/extHost/willWaitForConfig");const u=await this.f.getConfigProvider();h.mark("code/extHost/didWaitForConfig");const s=await this.g.getExtensionPathIndex();this.register(new o(this.c,s,this.d,u,this.i)),this.register(this.e.createInstance(d)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,s,this.h.environment.appUriScheme))}register(u){if("nodeModuleName"in u)if(Array.isArray(u.nodeModuleName))for(const s of u.nodeModuleName)this.a.set(s,u);else this.a.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this.b.push(s=>u.alternativeModuleName(s))}};e.$Fnc=l,e.$Fnc=l=He([We(2,A.$vi),We(3,R.$Ulc),We(4,I.$vmc),We(5,k.$UO),We(6,p.$3j)],l);let d=class{static{v=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(u){if(u.environment.appRoot&&v.a.size){const s=(0,y.$_e)(this.c(u.environment.appRoot.fsPath)),t="[a-z0-9_.-]",c=`@${t}+\\/${t}+|${t}+`,r="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${s}/${r}\\/)(${c})(.*)$`,"i")}}alternativeModuleName(u){if(!this.b)return;const s=this.b.exec(this.c(u));if(!s)return;const[,t,c,r]=s,a=v.a.get(c);if(a!==void 0)return console.warn(`${c} as been renamed to ${a}, please update your imports`),t+a+r}c(u){return u.replace(/\\/g,"/")}};d=v=He([We(0,k.$UO)],d);class o{constructor(u,s,t,c,r){this.c=u,this.d=s,this.e=t,this.f=c,this.g=r,this.nodeModuleName="vscode",this.a=new b.$Tm}load(u,s){const t=this.d.findSubstr(s);if(t){let c=this.a.get(t.identifier);return c||(c=this.c(t,this.e,this.f),this.a.set(t.identifier,c)),c}if(!this.b){let c="";this.d.forEach((r,a)=>c+=`	${a} -> ${r.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${c}`),this.b=this.c(M.$JG,this.e,this.f)}return this.b}}let n=class{constructor(u,s,t){this.e=u,this.f=s,this.nodeModuleName=["open","opn"],this.d=t.getProxy(O.$dM.MainThreadTelemetry);const c=t.getProxy(O.$dM.MainThreadWindow);this.c=(r,a)=>{const f=N.URI.parse(r);return a?this.g(r,a):f.scheme==="http"||f.scheme==="https"?c.$openUri(f,r,{allowTunneling:!0}):f.scheme==="mailto"||f.scheme===this.f?c.$openUri(f,r,{}):this.g(r,a)}}load(u,s,t){const c=this.e.findSubstr(s);return c&&(this.a=c.identifier.value,this.h()),this.b=t(u),this.c}g(u,s){return this.i(),this.b(u,s)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=He([We(2,$.$EO)],n)}),define(Se[61],De([1,0,46,3,16,52,5,73,72,49,8,44,307,45]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zmc=e.$ymc=void 0,e.$ymc=(0,M.$wi)("IExtHostVariableResolverProvider");class v extends p.$IP{constructor(o,n,i,u,s,t,c){function r(){if(i){const a=i.activeEditor();if(a)return a.document.uri;const f=u.tabGroups.all.find(g=>g.isActive)?.activeTab;if(f!==void 0){if(f.input instanceof A.$4N||f.input instanceof A.$9N)return f.input.modified;if(f.input instanceof A.$3N||f.input instanceof A.$8N||f.input instanceof A.$6N)return f.input.uri}}}super({getFolderUri:a=>{const f=t.folders.filter(g=>g.name===a);if(f&&f.length>0)return f[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(a,f)=>s.getConfiguration(void 0,a).get(f),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const a=r();if(a)return O.$hc(a.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const a=r();if(a){const f=n.getWorkspaceFolder(a);if(f)return O.$hc(f.uri.fsPath)}}},getSelectedText:()=>{if(i){const a=i.activeEditor();if(a&&!a.selection.isEmpty)return a.document.getText(a.selection)}},getLineNumber:()=>{if(i){const a=i.activeEditor();if(a)return String(a.selection.end.line+1)}},getExtension:a=>o.getExtension(a)},void 0,c?Promise.resolve(c):void 0,Promise.resolve(R.env))}}let l=class extends N.$Uc{constructor(o,n,i,u,s){super(),this.b=o,this.c=n,this.g=i,this.h=u,this.j=s,this.a=new h.$V(async()=>{const t=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async a=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,t,r,this.m())})}getResolver(){return this.a.value}m(){}};e.$zmc=l,e.$zmc=l=He([We(0,k.$vmc),We(1,I.$Rlc),We(2,b.$PO),We(3,y.$Ulc),We(4,$.$7lc)],l)}),define(Se[96],De([1,0,7,4,2,25,5,6,72,49,20,8,44,144,299,45,61,3,50,34,17,19]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d,o,n,i,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=e.$Dmc=e.$Cmc=e.$Bmc=e.$Amc=void 0,e.$Amc=(0,M.$wi)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(S,m,E,D,C,P,F){this.N=m,this.O=E,this.P=D,this.Q=C,this.R=P,this.S=F,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new N.$de,this.o=new N.$de,this.q=new N.$de,this.w=new N.$de,this.l=S.getProxy(b.$dM.MainThreadDebugService),this.A=new N.$de,this.C=new N.$de,this.y=new r(this.l),this.z=new Map,this.O.getExtensionRegistry().then(T=>{T.onDidChange(z=>{this.V(T)}),this.V(T)})}async $getVisualizerTreeItem(S,m){const E=this.W(m);if(!E)return;const D=await this.H.get(S)?.getTreeItem?.(E);return D?this.U(S,D):void 0}registerDebugVisualizationTree(S,m,E){const D=R.$Rm.toKey(S.identifier),C=this.jb(D,m);if(this.G.has(C))throw new Error(`A debug visualization provider with id '${m}' is already registered`);return this.H.set(C,E),this.l.$registerDebugVisualizerTree(C,!!E.editItem),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(C),this.H.delete(m)})}async $getVisualizerTreeItemChildren(S,m){const E=this.J.get(m)?.item;return E?(await this.H.get(S)?.getChildren?.(E))?.map(C=>this.U(S,C))||[]:[]}async $editVisualizerTreeItem(S,m){const E=this.J.get(S);if(!E)return;const D=await this.H.get(E.provider)?.editItem?.(E.item,m);return this.U(E.provider,D||E.item)}$disposeVisualizedTree(S){const m=this.J.get(S);if(!m)return;const E=[m.children];for(const D of E)if(D)for(const C of D)E.push(this.J.get(C)?.children),this.J.delete(C)}U(S,m){let E=this.I.get(m);return E||(E=this.F++,this.I.set(m,E),this.J.set(E,{provider:S,item:m})),u.DebugTreeItem.from(m,E)}asDebugSourceUri(S,m){const E=S;if(typeof E.sourceReference=="number"&&E.sourceReference>0){let D=`debug:${encodeURIComponent(E.path||"")}`,C="?";return m&&(D+=`${C}session=${encodeURIComponent(m.id)}`,C="&"),D+=`${C}ref=${E.sourceReference}`,O.URI.parse(D)}else{if(E.path)return O.URI.file(E.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(S){const m=[];for(const E of S.getAllExtensionDescriptions())if(E.contributes){const D=E.contributes.debuggers;if(D&&D.length>0)for(const C of D)(0,v.$tH)(C)&&m.push(C.type)}this.l.$registerDebugTypes(m)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const S=[];return this.z.forEach(m=>S.push(m)),S}async $resolveDebugVisualizer(S,m){const E=this.L.get(S);if(!E)throw new Error(`No debug visualizer found with id '${S}'`);let{v:D,provider:C,extensionId:P}=E;if(D.visualization||(D=await C.resolveDebugVisualization?.(D,m)||D,E.v=D),!D.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${C}'`);return this.kb(P,D.visualization)}async $executeDebugVisualizerCommand(S){const m=this.L.get(S);if(!m)throw new Error(`No debug visualizer found with id '${S}'`);const E=m.v.visualization;E&&"command"in E&&this.S.executeCommand(E.command,...E.arguments||[])}W(S){const m=this.m.get(S.sessionId);return m&&{session:m.api,variable:S.variable,containerId:S.containerId,frameId:S.frameId,threadId:S.threadId}}async $provideDebugVisualizers(S,m,E,D){const C=this.W(E),P=this.jb(S,m),F=this.G.get(P);if(!C||!F)return[];const T=await F.provideDebugVisualization(C,D);return T?T.map(z=>{const L=++this.M;this.L.set(L,{v:z,provider:F,extensionId:S});const j=z.iconPath?this.lb(z.iconPath):void 0;return{id:L,name:z.name,iconClass:j?.iconClass,iconPath:j?.iconPath,visualization:this.kb(S,z.visualization)}}):[]}$disposeDebugVisualizers(S){for(const m of S)this.L.delete(m)}registerDebugVisualizationProvider(S,m,E){if(!S.contributes?.debugVisualizers?.some(P=>P.id===m))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${m})`);const D=R.$Rm.toKey(S.identifier),C=this.jb(D,m);if(this.G.has(C))throw new Error(`A debug visualization provider with id '${m}' is already registered`);return this.G.set(C,E),this.l.$registerDebugVisualizer(D,m),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizer(D,m),this.G.delete(m)})}addBreakpoints(S){const m=S.filter(C=>{const P=C.id;return this.z.has(P)?!1:(this.z.set(P,C),!0)});this.gb(m,[],[]);const E=[],D=new Map;for(const C of m)if(C instanceof I.$hN){let P=D.get(C.location.uri.toString());P||(P={type:"sourceMulti",uri:C.location.uri,lines:[]},D.set(C.location.uri.toString(),P),E.push(P)),P.lines.push({id:C.id,enabled:C.enabled,condition:C.condition,hitCondition:C.hitCondition,logMessage:C.logMessage,line:C.location.range.start.line,character:C.location.range.start.character,mode:C.mode})}else C instanceof I.$iN&&E.push({type:"function",id:C.id,enabled:C.enabled,hitCondition:C.hitCondition,logMessage:C.logMessage,condition:C.condition,functionName:C.functionName,mode:C.mode});return this.l.$registerBreakpoints(E)}removeBreakpoints(S){const m=S.filter(P=>this.z.delete(P.id));this.gb([],m,[]);const E=m.filter(P=>P instanceof I.$hN).map(P=>P.id),D=m.filter(P=>P instanceof I.$iN).map(P=>P.id),C=m.filter(P=>P instanceof I.$jN).map(P=>P.id);return this.l.$unregisterBreakpoints(E,D,C)}startDebugging(S,m,E){return this.l.$startDebugging(S?S.uri:void 0,m,{parentSessionID:E.parentSession?E.parentSession.id:void 0,lifecycleManagedByParent:E.lifecycleManagedByParent,repl:E.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:E.noDebug,compact:E.compact,suppressSaveBeforeStart:E.suppressSaveBeforeStart,suppressDebugStatusbar:E.suppressDebugStatusbar??E.debugUI?.simple,suppressDebugToolbar:E.suppressDebugToolbar??E.debugUI?.simple,suppressDebugView:E.suppressDebugView??E.debugUI?.simple})}stopDebugging(S){return this.l.$stopDebugging(S?S.id:void 0)}registerDebugConfigurationProvider(S,m,E){if(!m)return new I.$fM(()=>{});const D=this.d++;return this.f.push({type:S,handle:D,provider:m}),this.l.$registerDebugConfigurationProvider(S,E,!!m.provideDebugConfigurations,!!m.resolveDebugConfiguration,!!m.resolveDebugConfigurationWithSubstitutedVariables,D),new I.$fM(()=>{this.f=this.f.filter(C=>C.provider!==m),this.l.$unregisterDebugConfigurationProvider(D)})}registerDebugAdapterDescriptorFactory(S,m,E){if(!E)return new I.$fM(()=>{});if(!this.cb(S,m))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${m}' debugger.`);if(this.$(m))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const D=this.g++;return this.h.push({type:m,handle:D,factory:E}),this.l.$registerDebugAdapterDescriptorFactory(m,D),new I.$fM(()=>{this.h=this.h.filter(C=>C.factory!==E),this.l.$unregisterDebugAdapterDescriptorFactory(D)})}registerDebugAdapterTrackerFactory(S,m){if(!m)return new I.$fM(()=>{});const E=this.j++;return this.k.push({type:S,handle:E,factory:m}),new I.$fM(()=>{this.k=this.k.filter(D=>D.factory!==m)})}async $runInTerminal(S,m){return Promise.resolve(void 0)}async $substituteVariables(S,m){let E;const D=await this.ib(S);return D&&(E={uri:D.uri,name:D.name,index:D.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(E,m)}X(S,m){if(S.type==="implementation")return new f(S.implementation)}Y(){}async $startDASession(S,m){const E=this,D=await this.hb(m);return this.eb(this.$(D.type),D).then(C=>{if(!C)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}' (extension might have failed to activate)`);const P=this.Z(C),F=this.X(P,D);if(!F)throw new Error(`Couldn't create a debug adapter for type '${D.type}'.`);const T=F;return this.D.set(S,T),this.db(D).then(z=>(z&&this.E.set(S,z),T.onMessage(async L=>{if(L.type==="request"&&L.command==="handshake"){const j=L,U={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const X=await this.K.sign(j.arguments.value);U.body={signature:X},T.sendResponse(U)}else throw new Error("no signer")}catch(X){U.success=!1,U.message=X.message,T.sendResponse(U)}}else z&&z.onDidSendMessage&&z.onDidSendMessage(L),L=(0,v.$yH)(L,!0),E.l.$acceptDAMessage(S,L)}),T.onError(L=>{z&&z.onError&&z.onError(L),this.l.$acceptDAError(S,L.name,L.message,L.stack)}),T.onExit(L=>{z&&z.onExit&&z.onExit(L??void 0,void 0),this.l.$acceptDAExit(S,L??void 0,void 0)}),z&&z.onWillStartSession&&z.onWillStartSession(),T.startSession()))})}$sendDAMessage(S,m){m=(0,v.$xH)(m,!1);const E=this.E.get(S);E&&E.onWillReceiveMessage&&E.onWillReceiveMessage(m),this.D.get(S)?.sendMessage(m)}$stopDASession(S){const m=this.E.get(S);this.E.delete(S),m&&m.onWillStopSession&&m.onWillStopSession();const E=this.D.get(S);return this.D.delete(S),E?E.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(S){const m=[],E=[],D=[];if(S.added)for(const C of S.added){const P=C.id;if(P&&!this.z.has(P)){let F;if(C.type==="function")F=new I.$iN(C.functionName,C.enabled,C.condition,C.hitCondition,C.logMessage,C.mode);else if(C.type==="data")F=new I.$jN(C.label,C.dataId,C.canPersist,C.enabled,C.hitCondition,C.condition,C.logMessage,C.mode);else{const T=O.URI.revive(C.uri);F=new I.$hN(new I.$rM(T,new I.$gM(C.line,C.character)),C.enabled,C.condition,C.hitCondition,C.logMessage,C.mode)}(0,I.$fN)(F,P),this.z.set(P,F),m.push(F)}}if(S.removed)for(const C of S.removed){const P=this.z.get(C);P&&(this.z.delete(C),E.push(P))}if(S.changed){for(const C of S.changed)if(C.id){const P=this.z.get(C.id);if(P){if(P instanceof I.$iN&&C.type==="function"){const F=P;F.enabled=C.enabled,F.condition=C.condition,F.hitCondition=C.hitCondition,F.logMessage=C.logMessage,F.functionName=C.functionName}else if(P instanceof I.$hN&&C.type==="source"){const F=P;F.enabled=C.enabled,F.condition=C.condition,F.hitCondition=C.hitCondition,F.logMessage=C.logMessage,F.location=new I.$rM(O.URI.revive(C.uri),new I.$gM(C.line,C.character))}D.push(P)}}}this.gb(m,E,D)}async $acceptStackFrameFocus(S){let m;if(S){const E=await this.hb(S.sessionId);S.kind==="thread"?m=new I.$pN(E.api,S.threadId):m=new I.$oN(E.api,S.threadId,S.frameId)}this.B=m,this.C.fire(this.B)}$provideDebugConfigurations(S,m,E){return(0,h.$oh)(async()=>{const D=this.bb(S);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const C=await this.ib(m);return D.provideDebugConfigurations(C,E)}).then(D=>{if(!D)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return D})}$resolveDebugConfiguration(S,m,E,D){return(0,h.$oh)(async()=>{const C=this.bb(S);if(!C)throw new Error("no DebugConfigurationProvider found");if(!C.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(m);return C.resolveDebugConfiguration(P,E,D)})}$resolveDebugConfigurationWithSubstitutedVariables(S,m,E,D){return(0,h.$oh)(async()=>{const C=this.bb(S);if(!C)throw new Error("no DebugConfigurationProvider found");if(!C.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(m);return C.resolveDebugConfigurationWithSubstitutedVariables(P,E,D)})}async $provideDebugAdapter(S,m){const E=this.ab(S);if(!E)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const D=await this.hb(m);return this.eb(E,D).then(C=>{if(!C)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}'`);return this.Z(C)})}async $acceptDebugSessionStarted(S){const m=await this.hb(S);this.n.fire(m.api)}async $acceptDebugSessionTerminated(S){const m=await this.hb(S);m&&(this.o.fire(m.api),this.m.delete(m.id))}async $acceptDebugSessionActiveChanged(S){this.u=S?await this.hb(S):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(S,m){(await this.hb(S))?._acceptNameChanged(m)}async $acceptDebugSessionCustomEvent(S,m){const D={session:(await this.hb(S)).api,event:m.event,body:m.body};this.w.fire(D)}Z(S){if(S instanceof I.$kN)return{type:"executable",command:S.command,args:S.args,options:S.options};if(S instanceof I.$lN)return{type:"server",port:S.port,host:S.host};if(S instanceof I.$mN)return{type:"pipeServer",path:S.path};if(S instanceof I.$nN)return{type:"implementation",implementation:S.implementation};throw new Error("convertToDto unexpected type")}$(S){const m=this.h.filter(E=>E.type===S);if(m.length>0)return m[0].factory}ab(S){const m=this.h.filter(E=>E.handle===S);if(m.length>0)return m[0].factory}bb(S){const m=this.f.filter(E=>E.handle===S);if(m.length>0)return m[0].provider}cb(S,m){if(S.contributes){const E=S.contributes.debuggers;if(E&&E.length>0){for(const D of E)if(D.label&&D.type&&D.type===m)return!0}}return!1}db(S){const E=S.configuration.type,D=this.k.filter(C=>C.type===E||C.type==="*").map(C=>(0,h.$oh)(()=>C.factory.createDebugAdapterTracker(S.api)).then(P=>P,P=>null));return Promise.race([Promise.all(D).then(C=>{const P=(0,s.$Hb)(C);if(P.length>0)return new a(P)}),new Promise(C=>setTimeout(()=>C(void 0),1e3))]).catch(C=>{})}async eb(S,m){const E=m.configuration.debugServer;if(typeof E=="number")return Promise.resolve(new I.$lN(E));if(S){const C=await this.O.getExtensionRegistry();return(0,h.$oh)(()=>S.createDebugAdapterDescriptor(m.api,this.fb(m,C))).then(P=>{if(P)return P})}const D=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(m,D))}fb(S,m){}gb(S,m,E){(S.length>0||m.length>0||E.length>0)&&this.A.fire(Object.freeze({added:S,removed:m,changed:E}))}async hb(S){if(S)if(typeof S=="string"){const m=this.m.get(S);if(m)return m}else{let m=this.m.get(S.id);if(!m){const E=await this.ib(S.folderUri),D=S.parent?this.m.get(S.parent):void 0;m=new c(this.l,S.id,S.type,S.name,E,S.configuration,D?.api),this.m.set(m.id,m),this.l.$sessionCached(m.id)}return m}throw new Error("cannot find session")}ib(S){if(S){const m=O.URI.revive(S);return this.N.resolveWorkspaceFolder(m)}return Promise.resolve(void 0)}jb(S,m){return`${S}\0${m}`}kb(S,m){if(m){if("title"in m&&"command"in m)return{type:0};if("treeId"in m)return{type:1,id:`${S}\0${m.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(S){const m=this.mb(S);let E,D;return"id"in m?D=n.ThemeIcon.asClassName(m):E=m,{iconPath:E,iconClass:D}}mb(S){if(S instanceof I.$cN)return{id:S.id};const m=typeof S=="object"&&"dark"in S?S.dark:S,E=typeof S=="object"&&"light"in S?S.light:S;return{dark:typeof m=="string"?O.URI.file(m):m,light:typeof E=="string"?O.URI.file(E):E}}};e.$Bmc=t,e.$Bmc=t=He([We(0,A.$EO),We(1,p.$Rlc),We(2,k.$vmc),We(3,l.$Ulc),We(4,$.$7lc),We(5,d.$ymc),We(6,i.$1O)],t);class c{constructor(S,m,E,D,C,P,F){this.f=S,this.g=m,this.h=E,this.j=D,this.k=C,this.l=P,this.m=F}get api(){const S=this;return this.d??=Object.freeze({id:S.g,type:S.h,get name(){return S.j},set name(m){S.j=m,S.f.$setDebugSessionName(S.g,m)},parentSession:S.m,workspaceFolder:S.k,configuration:S.l,customRequest(m,E){return S.f.$customDebugAdapterRequest(S.g,m,E)},getDebugProtocolBreakpoint(m){return S.f.$getDebugProtocolBreakpoint(S.g,m.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(S){this.j=S}get configuration(){return this.l}}e.$Cmc=c;class r{constructor(S){this.value=Object.freeze({append(m){S.$appendDebugConsole(m)},appendLine(m){this.append(m+`
`)}})}}e.$Dmc=r;class a{constructor(S){this.d=S}onWillStartSession(){this.d.forEach(S=>S.onWillStartSession?S.onWillStartSession():void 0)}onWillReceiveMessage(S){this.d.forEach(m=>m.onWillReceiveMessage?m.onWillReceiveMessage(S):void 0)}onDidSendMessage(S){this.d.forEach(m=>m.onDidSendMessage?m.onDidSendMessage(S):void 0)}onWillStopSession(){this.d.forEach(S=>S.onWillStopSession?S.onWillStopSession():void 0)}onError(S){this.d.forEach(m=>m.onError?m.onError(S):void 0)}onExit(S,m){this.d.forEach(E=>E.onExit?E.onExit(S,m):void 0)}}class f extends y.$2rb{constructor(S){super(),this.h=S,S.onDidSendMessage(m=>{this.acceptMessage(m)})}startSession(){return Promise.resolve(void 0)}sendMessage(S){this.h.handleMessage(S)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let g=class extends t{constructor(S,m,E,D,C,P,F){super(S,m,E,D,C,P,F)}};e.$Emc=g,e.$Emc=g=He([We(0,A.$EO),We(1,p.$Rlc),We(2,k.$vmc),We(3,l.$Ulc),We(4,$.$7lc),We(5,d.$ymc),We(6,i.$1O)],g)}),define(Se[379],De([1,0,13,59,2,6,327,11,85,107,28,263,20,68,49,90]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hnc=e.$Gnc=void 0;class d{static async installEarlyHandler(i){Error.stackTraceLimit=100;const u=i.get(b.$3j),t=i.get(p.$EO).getProxy(R.$dM.MainThreadErrors);h.setUnexpectedErrorHandler(c=>{u.error(c);const r=h.$3(c);t.$onUnexpectedError(r)})}static async installFullHandler(i){const u=i.get(b.$3j),s=i.get(p.$EO),t=i.get(v.$vmc),c=i.get(l.$YO),r=s.getProxy(R.$dM.MainThreadExtensionService),a=s.getProxy(R.$dM.MainThreadErrors),f=await t.getExtensionPathIndex(),g=new WeakMap;function w(E,D){if(g.has(E))return g.get(E).stack;let C="",P,F;for(const z of D)C+=`
	at ${z.toString()}`,F=z.getFileName(),!P&&F&&(P=f.findSubstr(O.URI.file(F)));const T=`${E.name||"Error"}: ${E.message||""}${C}`;return g.set(E,{extensionIdentifier:P?.identifier,stack:T}),T}const S=Symbol("prepareStackTrace wrapped");let m=w;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return m},set(E){if(E===w||!E||E[S]){m=E||w;return}m=function(D,C){return w(D,C),E.call(Error,D,C)},Object.assign(m,{[S]:!0})}}),h.setUnexpectedErrorHandler(E=>{u.error(E);const D=h.$3(E),C=g.get(E);if(!C?.extensionIdentifier){a.$onUnexpectedError(D);return}r.$onExtensionRuntimeError(C.extensionIdentifier,D);const P=c.onExtensionError(C.extensionIdentifier,E);u.trace("forwarded error to extension?",P,C)})}}e.$Gnc=d;class o{constructor(i,u,s,t,c){this.a=s,this.b=new M.$cac(i,null,t),u=o.e(u,this.b);const r=new k.$ui(...(0,$.$ys)());r.set(A.$UO,{_serviceBrand:void 0,...u,messagePorts:c}),r.set(p.$EO,new p.$FO(this.b)),r.set(y.$Olc,new y.$Plc(t)),r.set(v.$tmc,s);const a=new I.$cr(r,!0);a.invokeFunction(d.installEarlyHandler),this.d=a.invokeFunction(f=>f.get(b.$3j)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",u),this.c=a.invokeFunction(f=>f.get(v.$vmc)),this.c.initialize(),a.invokeFunction(d.installFullHandler)}async asBrowserUri(i){const u=this.b.getProxy(R.$dM.MainThreadExtensionService);return O.URI.revive(await u.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,u){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=O.URI.revive(u.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=O.URI.revive(u.transformIncomingURIs(i.environment.appRoot));const s=i.environment.extensionDevelopmentLocationURI;return s&&(i.environment.extensionDevelopmentLocationURI=s.map(t=>O.URI.revive(u.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=O.URI.revive(u.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=O.URI.revive(u.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=O.URI.revive(u.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=O.URI.revive(u.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=O.URI.revive(u.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=O.URI.revive(u.transformIncomingURIs(i.logsLocation)),i.workspace=u.transformIncomingURIs(i.workspace),i}}e.$Hnc=o}),define(Se[380],De([1,0,7,12,236,256,141,96,72,49,20,43,8,61,44,300,301,45,34]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rnc=void 0;let i=class extends b.$Bmc{constructor(r,a,f,g,w,S,m,E){super(r,a,f,g,S,m,E),this.pb=w,this.nb=new t}X(r,a){switch(r.type){case"server":return new l.$Mnc(r);case"pipeServer":return new l.$Nnc(r);case"executable":return new l.$Onc(r,a.type)}return super.X(r,a)}fb(r,a){const f=l.$Onc.platformAdapterExecutable(a.getAllExtensionDescriptions(),r.type);if(f)return new p.$kN(f.command,f.args,f.options)}Y(){return new M.$3dc}async $runInTerminal(r,a){if(r.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(z=>{this.nb.onTerminalClosed(z)}));const f=await this.P.getConfigProvider(),g=this.pb.getDefaultShell(!0),w=this.pb.getDefaultShellArgs(!0),S=r.title||O.localize(0,null),m=JSON.stringify({shell:g,shellArgs:w});let E=await this.nb.checkout(m,S),D,C=!1;if(E)D=r.cwd;else{const z={shellPath:g,shellArgs:w,cwd:r.cwd,name:S,iconPath:new p.$cN("debug")};C=!0,E=this.pb.createTerminalFromOptions(z,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(E,m)}E.show(!0);const P=await E.processId;C?await new Promise(z=>setTimeout(z,1e3)):(E.state.isInteractedWith&&(E.sendText(""),await(0,h.$xh)(200)),f.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(g.indexOf("powershell")>=0||g.indexOf("pwsh")>=0||g.indexOf("cmd.exe")>=0?E.sendText("cls"):g.indexOf("bash")>=0?E.sendText("clear"):N.$i?E.sendText("cls"):E.sendText("clear")));const F=(0,d.$Qnc)(g,r.args,!!r.argsCanBeInterpretedByShell,D,r.env);E.sendText(F);const T=this.onDidTerminateDebugSession(z=>{z.id===a&&(this.nb.free(E),T.dispose())});return P}else if(r.kind==="external")return s(r,await this.P.getConfigProvider());return super.$runInTerminal(r,a)}};e.$Rnc=i,e.$Rnc=i=He([We(0,A.$EO),We(1,v.$Rlc),We(2,k.$vmc),We(3,o.$Ulc),We(4,I.$gmc),We(5,$.$7lc),We(6,y.$ymc),We(7,n.$1O)],i);let u;function s(c,r){if(!u)if(N.$i)u=new R.$Ncc;else if(N.$j)u=new R.$Occ;else if(N.$k)u=new R.$Pcc;else throw new Error("external terminals not supported on this platform");const a=r.getConfiguration("terminal");return u.runInTerminal(c.title,c.cwd,c.args,c.env||{},a.external||{})}class t{constructor(){this.b=new Map}static{this.a=1e3}async checkout(r,a,f=!1){const w=[...this.b.entries()].map(([S,m])=>(0,h.$jh)(async E=>{if(S.name!==a||m.lastUsedAt!==-1&&await(0,d.$Pnc)(await S.processId))return null;const D=Date.now();return m.lastUsedAt+t.a>D||E.isCancellationRequested?null:m.config!==r?(f&&S.dispose(),null):(m.lastUsedAt=D,S)}));return await(0,h.$Bh)(w,S=>!!S)}insert(r,a){this.b.set(r,{lastUsedAt:Date.now(),config:a})}free(r){const a=this.b.get(r);a&&(a.lastUsedAt=-1)}onTerminalClosed(r){this.b.delete(r)}}}),define(Se[381],De([1,0,16,2,105,44,73,45,42,43,20,28,95,15,11,91,23,64,61]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jnc=void 0;let i=class extends p.$jnc{constructor(s,t,c,r,a,f,g,w,S){super(s,t,c,r,a,f,g,w),this.C=c,this.D=S,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(s,t){const c=t;if(!t.execution&&c._id===void 0)throw new Error("Tasks to execute must include an execution");if(c._id!==void 0){const r=p.TaskHandleDTO.from(c,this.C),a=await this.a.$getTaskExecution(r);if(a.task===void 0)throw new Error("Task from execution DTO is undefined");const f=await this.z(a,t);return this.a.$executeTask(r).catch(()=>{}),f}else{const r=p.TaskDTO.from(t,s);if(r===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(r.execution)&&await this.y(r,t,!1);const a=await this.z(await this.a.$getTaskExecution(r),t);return this.a.$executeTask(r).catch(()=>{}),a}}v(s,t,c,r){const a=[];if(r)for(const f of r){this.A(f,c),(!f.definition||!s[f.definition.type])&&this.f.warn(`The task [${f.source}, ${f.name}] uses an undefined task type. The task will be ignored in the future.`);const g=p.TaskDTO.from(f,c.extension);g&&(a.push(g),p.CustomExecutionDTO.is(g.execution)&&t.push(this.y(g,f,!0)))}return{tasks:a,extension:c.extension}}async w(s){return s}async G(s){let t=s&&s.length>0?s[0]:void 0;if(!t){const c=N.URI.file((0,o.homedir)());t=new $.$Qi({uri:c,name:d.$7g(c),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(s,t){const c=N.URI.revive(s),r={process:void 0,variables:Object.create(null)},a=await this.b.resolveWorkspaceFolder(c),f=await this.b.getWorkspaceFolders2()??[],g=await this.D.getResolver(),w=a?{uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(f);for(const S of t.variables)r.variables[S]=await g.resolveAsync(w,S);if(t.process!==void 0){let S;if(t.process.path!==void 0){S=t.process.path.split(h.$tc);for(let m=0;m<S.length;m++)S[m]=await g.resolveAsync(w,S[m])}r.process=await O.win32.findExecutable(await g.resolveAsync(w,t.process.name),t.process.cwd!==void 0?await g.resolveAsync(w,t.process.cwd):void 0,S)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(s,t,c){return O.win32.findExecutable(s,t,c)}};e.$Jnc=i,e.$Jnc=i=He([We(0,A.$EO),We(1,I.$UO),We(2,R.$Rlc),We(3,M.$PO),We(4,b.$Ulc),We(5,k.$gmc),We(6,v.$3j),We(7,l.$vlc),We(8,n.$ymc)],i)}),define(Se[382],De([1,0,64,61]),function(he,e,h,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$poc=void 0;class O extends N.$zmc{m(){return(0,h.homedir)()}}e.$poc=O}),define(Se[160],De([1,0,19,7,22,47,15,16,23,2,37]),function(he,e,h,N,O,R,M,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Umc=e.$Smc=e.$Rmc=void 0,e.$Tmc=l;class I{constructor(n,i,u){this.d=n,this.e=i,this.f=u,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const u=this.g.folderQueries||[],s=new O.$oe(i);return new Promise((t,c)=>{this.a=new y(n);let r=!1;const a=(f,g)=>{if(!r&&!this.b){const w=this.h(f);l(f)&&typeof this.g.maxResults=="number"&&this.c+w>this.g.maxResults&&(this.b=!0,r=!0,s.cancel(),f=this.j(f,this.g.maxResults-this.c));const S=this.h(f);this.c+=S,(S>0||!l(f))&&this.a.add(f,g)}};Promise.all(u.map((f,g)=>this.k(f,w=>a(w,g),s.token))).then(f=>{s.dispose(),this.a.flush();const g=f.some(w=>!!w&&!!w.limitHit);t({limitHit:this.b||g,messages:f.flatMap(w=>w?.message?Array.isArray(w.message)?w.message:[w.message]:[]),stats:{type:this.f}})},f=>{s.dispose();const g=(0,R.$hj)(f);c(new Error(g))})})}h(n){return l(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const u=Array.isArray(n.ranges)?n.ranges:[n.ranges],s=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:u.slice(0,i),preview:{matches:s.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,u){const s=new A.$JK(this.g,n),t=[],c={report:f=>{if(!this.l(f))return;const g=n.folder.scheme===M.Schemas.file?(0,A.$KK)(()=>this.e.readdir($.$9g(f.uri))):void 0,w=$.$_g(n.folder,f.uri);if(w){const S=s.includedInQuery(w,b.$nc(w),g);(0,N.$ih)(S)?t.push(S.then(m=>{m&&i(f)})):S&&i(f)}}},r=this.n(n);let a;return this.d.query.type===3?a=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,r,c,u):a=await this.d.provider.provideTextSearchResults(p(this.d.query.contentPattern),r,c,u),t.length&&await Promise.all(t),a}l(n){if(l(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,A.$IK)(this.g.includePattern,n.includePattern),u=(0,A.$IK)(this.g.excludePattern,n.excludePattern),s={folder:k.URI.from(n.folder),excludes:u,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??Number.MAX_SAFE_INTEGER,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(s.usePCRE2=this.g.usePCRE2),s}}e.$Rmc=I;function p(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class y{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new d(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!$.$3g(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(v(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$Smc=y;function v(o){return l(o)?{preview:{matches:(0,h.$1b)(o.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:o.preview.text},ranges:(0,h.$1b)(o.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function l(o){return!!o.preview}class d{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<d.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},d.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Umc=d}),define(Se[97],De([1,0,3,6,5,375,20,68,11,2,160]),function(he,e,h,N,O,R,M,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wmc=e.$Vmc=void 0,e.$Xmc=p,e.$Vmc=(0,O.$wi)("IExtHostSearch");let I=class{constructor(l,d,o){this.n=l,this.o=d,this.q=o,this.c=this.n.getProxy(N.$dM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new R.$Qmc}s(l){return this.o.transformOutgoingScheme(l)}registerTextSearchProvider(l,d){if(this.g.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this.g.add(l);const o=this.d++;return this.e.set(o,d),this.c.$registerTextSearchProvider(o,this.s(l)),(0,h.$Sc)(()=>{this.g.delete(l),this.e.delete(o),this.c.$unregisterProvider(o)})}registerAITextSearchProvider(l,d){if(this.i.has(l))throw new Error(`an AI text search provider for the scheme '${l}'is already registered`);this.i.add(l);const o=this.d++;return this.h.set(o,d),this.c.$registerAITextSearchProvider(o,this.s(l)),(0,h.$Sc)(()=>{this.i.delete(l),this.h.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(l,d){if(this.k.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this.k.add(l);const o=this.d++;return this.j.set(o,d),this.c.$registerFileSearchProvider(o,this.s(l)),(0,h.$Sc)(()=>{this.k.delete(l),this.j.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(l,d,o,n){const i=p(o),u=this.j.get(l);if(u)return this.l.fileSearch(i,u,s=>{this.c.$handleFileMatch(l,d,s.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+l)}async doInternalFileSearchWithCustomCallback(l,d,o){return{messages:[]}}$clearCache(l){return this.l.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,d,o,n){const i=this.e.get(l);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${l}`);const u=p(o);return this.t(u,i).search(t=>this.c.$handleTextMatch(l,d,t),n)}$provideAITextSearchResults(l,d,o,n){const i=this.h.get(l);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${l}`);const u=p(o);return this.v(u,i).search(t=>this.c.$handleTextMatch(l,d,t),n)}$enableExtensionHostSearch(){}t(l,d){return new A.$Rmc({query:l,provider:d},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}v(l,d){return new A.$Rmc({query:l,provider:d},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"aiTextSearchProvider")}};e.$Wmc=I,e.$Wmc=I=He([We(0,M.$EO),We(1,b.$Olc),We(2,$.$3j)],I);function p(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(y),extraFileResources:v.extraFileResources&&v.extraFileResources.map(l=>k.URI.revive(l))}}function y(v){return{...v,folder:k.URI.revive(v.folder)}}}),define(Se[383],De([1,0,22,13,4,3,15,41,2,136,203,184,80,25,33,11,86,87,283,6,329,355,91,121,333,334,335,316,305,34,336,45,337,96,152,338,318,330,339,340,73,72,331,49,341,70,342,60,28,356,319,343,122,344,116,117,320,374,346,288,347,357,348,158,321,349,350,351,20,352,97,118,353,322,354,119,93,95,90,43,156,358,359,332,360,361,71,17,8,323,68,324,92,362,363,151,44,298,115,26,94]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d,o,n,i,u,s,t,c,r,a,f,g,w,S,m,E,D,C,P,F,T,z,L,j,U,X,ie,q,G,x,ne,be,ae,Ie,ee,B,_,pe,ue,ce,oe,le,K,se,$e,ve,Me,ge,Ae,Re,je,V,W,J,Z,de,we,Fe,Ve,Ge,tt,_e,nt,rt,it,ct,Oe,Ee,qe,te,re,Ce,Pe,Xe,st,lt,gt,It,Pt,zt,Bt,Dt,_t,xe,tn){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bnc=nn;function nn(ft){const bt=ft.get(ae.$UO),Ut=ft.get(be.$zlc),Kt=ft.get(x.$Wlc),Ft=ft.get(q.$vmc),$t=ft.get(Bt.$Rlc),Rt=ft.get(nt.$YO),cn=ft.get(E.$Ulc),Vt=ft.get(st.$Olc),Ze=ft.get(W.$EO),rn=ft.get(Ge.$dmc),un=ft.get(tt.$Xlc),Jt=ft.get(l.$4j),mt=ft.get(l.$3j),Nt=ft.get(re.$CDb),Lt=ft.get(t.$vlc),Tt=ft.get(zt.$Anc),Qt=ft.get(de.$nmc),Yt=ft.get(X.$7lc),Zt=ft.get(ce.$rmc),Wt=ft.get(c.$Flc),Mt=ft.get(_.$kmc);Ze.set(i.$eM.ExtHostFileSystemInfo,Ut),Ze.set(i.$eM.ExtHostLogLevelServiceShape,Jt),Ze.set(i.$eM.ExtHostWorkspace,$t),Ze.set(i.$eM.ExtHostConfiguration,cn),Ze.set(i.$eM.ExtHostExtensionService,Ft),Ze.set(i.$eM.ExtHostStorage,rn),Ze.set(i.$eM.ExtHostTunnelService,Nt),Ze.set(i.$eM.ExtHostWindow,Tt),Ze.set(i.$eM.ExtHostSecretState,Qt),Ze.set(i.$eM.ExtHostTelemetry,Rt),Ze.set(i.$eM.ExtHostEditorTabs,Yt),Ze.set(i.$eM.ExtHostManagedSockets,Zt),Ze.set(i.$eM.ExtHostAuthentication,Wt),Ze.set(i.$eM.ExtHostChatProvider,Mt);const Xt=Ze.set(i.$eM.ExtHostDecorations,ft.get(P.$Gmc)),Ct=Ze.set(i.$eM.ExtHostDocumentsAndEditors,ft.get(U.$PO)),Et=Ze.set(i.$eM.ExtHostCommands,ft.get(S.$1O)),wt=Ze.set(i.$eM.ExtHostTerminalService,ft.get(rt.$gmc)),xt=Ze.set(i.$eM.ExtHostTerminalShellIntegration,ft.get(it.$mnc)),kt=Ze.set(i.$eM.ExtHostDebugService,ft.get(C.$Amc)),ln=Ze.set(i.$eM.ExtHostSearch,ft.get(Z.$Vmc)),en=Ze.set(i.$eM.ExtHostTask,ft.get(_e.$lnc)),kn=Ze.set(i.$eM.ExtHostOutputService,ft.get(ge.$$mc)),hn=Ze.set(i.$eM.ExtHostLocalization,ft.get(ue.$qmc)),gn=Ze.set(i.$eM.ExtHostUrls,new lt.$xnc(Ze)),jt=Ze.set(i.$eM.ExtHostDocuments,new j.$Clc(Ze,Ct)),Ne=Ze.set(i.$eM.ExtHostDocumentContentProviders,new z.$Imc(Ze,Ct,mt)),ze=Ze.set(i.$eM.ExtHostDocumentSaveParticipant,new L.$Jmc(mt,jt,Ze.getProxy(i.$dM.MainThreadBulkEdits))),ye=Ze.set(i.$eM.ExtHostNotebook,new le.$Ymc(Ze,Et,Ct,jt,Kt,ln)),Y=Ze.set(i.$eM.ExtHostNotebookDocuments,new se.$5mc(ye)),Te=Ze.set(i.$eM.ExtHostNotebookEditors,new $e.$6mc(mt,ye)),Qe=Ze.set(i.$eM.ExtHostNotebookKernels,new ve.$7mc(Ze,bt,ye,Et,mt)),Ye=Ze.set(i.$eM.ExtHostNotebookRenderers,new Me.$9mc(Ze,ye)),Ke=Ze.set(i.$eM.ExtHostNotebookDocumentSaveParticipant,new K.$4mc(mt,ye,Ze.getProxy(i.$dM.MainThreadBulkEdits))),ot=Ze.set(i.$eM.ExtHostEditors,new Oe.$Llc(Ze,Ct)),St=Ze.set(i.$eM.ExtHostTreeViews,new te.$vnc(Ze.getProxy(i.$dM.MainThreadTreeViews),Et,mt)),Ht=Ze.set(i.$eM.ExtHostEditorInsets,new w.$Mlc(Ze.getProxy(i.$dM.MainThreadEditorInsets),ot,bt.remote)),qt=Ze.set(i.$eM.ExtHostDiagnostics,new F.$Blc(Ze,mt,Ut,Ct)),At=Ze.set(i.$eM.ExtHostLanguages,new pe.$2mc(Ze,jt,Et.converter,Vt)),ht=Ze.set(i.$eM.ExtHostLanguageFeatures,new B.$Dlc(Ze,Vt,jt,Et,qt,mt,Lt,Rt)),An=Ze.set(i.$eM.ExtHostFileSystem,new G.$Lmc(Ze,ht)),dn=Ze.set(i.$eM.ExtHostFileSystemEventService,new ne.$Mmc(Ze,mt,Ct)),yn=Ze.set(i.$eM.ExtHostQuickOpen,(0,V.$cnc)(Ze,$t,Et)),Kn=Ze.set(i.$eM.ExtHostSCM,new J.$enc(Ze,Et,jt,mt)),Rn=Ze.set(i.$eM.ExtHostQuickDiff,new je.$bnc(Ze,Vt)),Jn=Ze.set(i.$eM.ExtHostShare,new we.$fnc(Ze,Vt)),Mn=Ze.set(i.$eM.ExtHostComments,(0,m.$Nlc)(Ze,Et,jt)),Sn=Ze.set(i.$eM.ExtHostProgress,new Re.$anc(Ze.getProxy(i.$dM.MainThreadProgress))),On=Ze.set(i.$eM.ExtHostLabelService,new ee.$1mc(Ze)),Dn=Ze.set(i.$eM.ExtHostTheming,new Ee.$snc(Ze)),Zn=Ze.set(i.$eM.ExtHostTimeline,new qe.$unc(Ze,Et)),Cn=Ze.set(i.$eM.ExtHostWebviews,new gt.$2lc(Ze,bt.remote,$t,mt,Lt)),Nn=Ze.set(i.$eM.ExtHostWebviewPanels,new It.$5lc(Ze,Cn,$t)),Xn=Ze.set(i.$eM.ExtHostCustomEditors,new D.$6lc(Ze,jt,un,Cn,Nn)),Ln=Ze.set(i.$eM.ExtHostWebviewViews,new Pt.$ync(Ze,Cn)),pn=Ze.set(i.$eM.ExtHostTesting,new ct.$onc(Ze,mt,Et,Ct)),Yn=Ze.set(i.$eM.ExtHostUriOpeners,new Xe.$wnc(Ze)),xn=Ze.set(i.$eM.ExtHostProfileContentHandlers,new Ae.$_mc(Ze));Ze.set(i.$eM.ExtHostInteractive,new Ie.$Zmc(Ze,ye,Ct,Et,mt));const In=Ze.set(i.$eM.ExtHostChatAgents2,new a.$Ilc(Ze,mt,Et)),_n=Ze.set(i.$eM.ExtHostChatVariables,new f.$Jlc(Ze)),Tn=Ze.set(i.$eM.ExtHostAiRelatedInformation,new u.$ulc(Ze)),ei=Ze.set(i.$eM.ExtHostAiEmbeddingVector,new ie.$Kmc(Ze)),ti=Ze.set(i.$eM.ExtHostStatusBar,new Ve.$inc(Ze,Et.converter)),li=Ze.set(i.$eM.ExtHostSpeech,new Fe.$gnc(Ze)),Fn=Object.values(i.$eM);Ze.assertRegistered(Fn);const jn=new r.$Hlc(Ze,Ct),hi=new g.$Klc(Ze),zn=new oe.$3mc(Ze,mt),Bn=new T.$Hmc(Ze);return s.$Elc.register(Et),function(Ue,sn,Un){function at(fe){return(ke,Be,ut)=>{const yt=fe(Ot=>{try{ke.call(Be,Ot)}catch(En){N.$2(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event: ${En.toString()}`,{cause:En})),Rt.onExtensionError(Ue.identifier,En)}});return ut?.push(yt),yt}}const vt=function(){let fe=!Ue.isUnderDevelopment;function ke(){fe||(mt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),fe=!0)}return function Be(ut){if(Array.isArray(ut))ut.forEach(Be);else if(typeof ut=="string")ke();else{const yt=ut;typeof yt.scheme>"u"&&ke(),typeof yt.exclusive=="boolean"&&(0,xe.$PG)(Ue,"documentFiltersExclusive")}return ut}}(),di={getSession(fe,ke,Be){return typeof Be?.forceNewSession=="object"&&Be.forceNewSession.learnMore&&(0,xe.$PG)(Ue,"authLearnMore"),Wt.getSession(Ue,fe,ke,Be)},getSessions(fe,ke){return(0,xe.$PG)(Ue,"authGetSessions"),Wt.getSessions(Ue,fe,ke)},async hasSession(fe,ke){return(0,xe.$PG)(Ue,"authSession"),!!await Wt.getSession(Ue,fe,ke,{silent:!0})},get onDidChangeSessions(){return at(Wt.onDidChangeSessions)},registerAuthenticationProvider(fe,ke,Be,ut){return Wt.registerAuthenticationProvider(fe,ke,Be,ut)}},Wn={registerCommand(fe,ke,Be){return Et.registerCommand(!0,fe,ke,Be,void 0,Ue)},registerTextEditorCommand(fe,ke,Be){return Et.registerCommand(!0,fe,(...ut)=>{const yt=ot.getActiveTextEditor();if(!yt){mt.warn("Cannot execute "+fe+" because there is no active text editor.");return}return yt.edit(Ot=>{ke.apply(Be,[yt,Ot,...ut])}).then(Ot=>{Ot||mt.warn("Edits from command "+fe+" were not applied.")},Ot=>{mt.warn("An error occurred while running command "+fe,Ot)})},void 0,void 0,Ue)},registerDiffInformationCommand:(fe,ke,Be)=>((0,xe.$PG)(Ue,"diffCommand"),Et.registerCommand(!0,fe,async(...ut)=>{const yt=Ct.activeEditor(!0);if(!yt){mt.warn("Cannot execute "+fe+" because there is no active text editor.");return}const Ot=await ot.getDiffInformation(yt.id);ke.apply(Be,[Ot,...ut])},void 0,void 0,Ue)),executeCommand(fe,...ke){return Et.executeCommand(fe,...ke)},getCommands(fe=!1){return Et.getCommands(fe)}},Vn={get machineId(){return bt.telemetryInfo.machineId},get sessionId(){return bt.telemetryInfo.sessionId},get language(){return bt.environment.appLanguage},get appName(){return bt.environment.appName},get appRoot(){return bt.environment.appRoot?.fsPath??""},get appHost(){return bt.environment.appHost},get uriScheme(){return bt.environment.appUriScheme},get clipboard(){return hi.value},get shell(){return wt.getDefaultShell(!1)},get onDidChangeShell(){return at(wt.onDidChangeShell)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return at(Rt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,xe.$PG)(Ue,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,xe.$PG)(Ue,"telemetry"),at(Rt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,nt.$XO)(bt.telemetryInfo.firstSessionDate)},createTelemetryLogger(fe,ke){return nt.$WO.validateSender(fe),Rt.instantiateLogger(Ue,fe,ke)},openExternal(fe,ke){return Tt.openUri(fe,{allowTunneling:!!bt.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri(fe){if(fe.scheme===bt.environment.appUriScheme)return gn.createAppUri(fe);try{return await Tt.asExternalUri(fe,{allowTunneling:!!bt.remote.authority})}catch(ke){if((0,M.$Fg)(fe,M.Schemas.http)||(0,M.$Fg)(fe,M.Schemas.https))return fe;throw ke}},get remoteName(){return(0,d.$Im)(bt.remote.authority)},get remoteAuthority(){return(0,xe.$PG)(Ue,"resolvers"),bt.remote.authority},get uiKind(){return bt.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return at(mt.onDidChangeLogLevel)},get appQuality(){return(0,xe.$PG)(Ue,"resolvers"),bt.quality},get appCommit(){return(0,xe.$PG)(Ue,"resolvers"),bt.commit}};bt.environment.extensionTestsLocationURI||Object.freeze(Vn);const mn={createTestController(fe,ke,Be){return pn.createTestController(Ue,fe,ke,Be)},createTestObserver(){return(0,xe.$PG)(Ue,"testObserver"),pn.createTestObserver()},runTests(fe){return(0,xe.$PG)(Ue,"testObserver"),pn.runTests(fe)},get onDidChangeTestResults(){return(0,xe.$PG)(Ue,"testObserver"),at(pn.onResultsChanged)},get testResults(){return(0,xe.$PG)(Ue,"testObserver"),pn.results}},bn=bt.remote.isRemote?Pe.ExtensionKind.Workspace:Pe.ExtensionKind.UI,fi={getExtension(fe,ke){(0,xe.$OG)(Ue,"extensionsAny")||(ke=!1);const Be=sn.mine.getExtensionDescription(fe);if(Be)return new q.$wmc(Ft,Ue.identifier,Be,bn,!1);if(ke){const ut=sn.all.getExtensionDescription(fe);if(ut)return new q.$wmc(Ft,Ue.identifier,ut,bn,!0)}},get all(){const fe=[];for(const ke of sn.mine.getAllExtensionDescriptions())fe.push(new q.$wmc(Ft,Ue.identifier,ke,bn,!1));return fe},get allAcrossExtensionHosts(){(0,xe.$PG)(Ue,"extensionsAny");const fe=new y.$Sm(sn.mine.getAllExtensionDescriptions().map(Be=>Be.identifier)),ke=[];for(const Be of sn.all.getAllExtensionDescriptions()){const ut=!fe.has(Be.identifier);ke.push(new q.$wmc(Ft,Ue.identifier,Be,bn,ut))}return ke},get onDidChange(){return(0,xe.$OG)(Ue,"extensionsAny")?at(O.Event.any(sn.mine.onDidChange,sn.all.onDidChange)):at(sn.mine.onDidChange)}},on={createDiagnosticCollection(fe){return qt.createDiagnosticCollection(Ue.identifier,fe)},get onDidChangeDiagnostics(){return at(qt.onDidChangeDiagnostics)},getDiagnostics:fe=>qt.getDiagnostics(fe),getLanguages(){return At.getLanguages()},setTextDocumentLanguage(fe,ke){return At.changeLanguage(fe.uri,ke)},match(fe,ke){const Be=Ce.LanguageSelector.from(fe);let ut;return(0,A.$Yt)(Be)&&(ut=ye.notebookDocuments.find(yt=>yt.apiNotebook.getCells().find(Ot=>Ot.document===ke))?.apiNotebook),(0,A.$Xt)(Be,ke.uri,ke.languageId,!0,ut?.uri,ut?.notebookType)},registerCodeActionsProvider(fe,ke,Be){return ht.registerCodeActionProvider(Ue,vt(fe),ke,Be)},registerDocumentPasteEditProvider(fe,ke,Be){return(0,xe.$PG)(Ue,"documentPaste"),ht.registerDocumentPasteEditProvider(Ue,vt(fe),ke,Be)},registerCodeLensProvider(fe,ke){return ht.registerCodeLensProvider(Ue,vt(fe),ke)},registerDefinitionProvider(fe,ke){return ht.registerDefinitionProvider(Ue,vt(fe),ke)},registerDeclarationProvider(fe,ke){return ht.registerDeclarationProvider(Ue,vt(fe),ke)},registerImplementationProvider(fe,ke){return ht.registerImplementationProvider(Ue,vt(fe),ke)},registerTypeDefinitionProvider(fe,ke){return ht.registerTypeDefinitionProvider(Ue,vt(fe),ke)},registerHoverProvider(fe,ke){return ht.registerHoverProvider(Ue,vt(fe),ke,Ue.identifier)},registerEvaluatableExpressionProvider(fe,ke){return ht.registerEvaluatableExpressionProvider(Ue,vt(fe),ke,Ue.identifier)},registerInlineValuesProvider(fe,ke){return ht.registerInlineValuesProvider(Ue,vt(fe),ke,Ue.identifier)},registerDocumentHighlightProvider(fe,ke){return ht.registerDocumentHighlightProvider(Ue,vt(fe),ke)},registerMultiDocumentHighlightProvider(fe,ke){return ht.registerMultiDocumentHighlightProvider(Ue,vt(fe),ke)},registerLinkedEditingRangeProvider(fe,ke){return ht.registerLinkedEditingRangeProvider(Ue,vt(fe),ke)},registerReferenceProvider(fe,ke){return ht.registerReferenceProvider(Ue,vt(fe),ke)},registerRenameProvider(fe,ke){return ht.registerRenameProvider(Ue,vt(fe),ke)},registerNewSymbolNamesProvider(fe,ke){return(0,xe.$PG)(Ue,"newSymbolNamesProvider"),ht.registerNewSymbolNamesProvider(Ue,vt(fe),ke)},registerDocumentSymbolProvider(fe,ke,Be){return ht.registerDocumentSymbolProvider(Ue,vt(fe),ke,Be)},registerWorkspaceSymbolProvider(fe){return ht.registerWorkspaceSymbolProvider(Ue,fe)},registerDocumentFormattingEditProvider(fe,ke){return ht.registerDocumentFormattingEditProvider(Ue,vt(fe),ke)},registerDocumentRangeFormattingEditProvider(fe,ke){return ht.registerDocumentRangeFormattingEditProvider(Ue,vt(fe),ke)},registerOnTypeFormattingEditProvider(fe,ke,Be,...ut){return ht.registerOnTypeFormattingEditProvider(Ue,vt(fe),ke,[Be].concat(ut))},registerDocumentSemanticTokensProvider(fe,ke,Be){return ht.registerDocumentSemanticTokensProvider(Ue,vt(fe),ke,Be)},registerDocumentRangeSemanticTokensProvider(fe,ke,Be){return ht.registerDocumentRangeSemanticTokensProvider(Ue,vt(fe),ke,Be)},registerSignatureHelpProvider(fe,ke,Be,...ut){return typeof Be=="object"?ht.registerSignatureHelpProvider(Ue,vt(fe),ke,Be):ht.registerSignatureHelpProvider(Ue,vt(fe),ke,typeof Be>"u"?[]:[Be,...ut])},registerCompletionItemProvider(fe,ke,...Be){return ht.registerCompletionItemProvider(Ue,vt(fe),ke,Be)},registerInlineCompletionItemProvider(fe,ke,Be){return ke.handleDidShowCompletionItem&&(0,xe.$PG)(Ue,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,xe.$PG)(Ue,"inlineCompletionsAdditions"),Be&&(0,xe.$PG)(Ue,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(Ue,vt(fe),ke,Be)},registerInlineEditProvider(fe,ke){return(0,xe.$PG)(Ue,"inlineEdit"),ht.registerInlineEditProvider(Ue,vt(fe),ke)},registerDocumentLinkProvider(fe,ke){return ht.registerDocumentLinkProvider(Ue,vt(fe),ke)},registerColorProvider(fe,ke){return ht.registerColorProvider(Ue,vt(fe),ke)},registerFoldingRangeProvider(fe,ke){return ht.registerFoldingRangeProvider(Ue,vt(fe),ke)},registerSelectionRangeProvider(fe,ke){return ht.registerSelectionRangeProvider(Ue,fe,ke)},registerCallHierarchyProvider(fe,ke){return ht.registerCallHierarchyProvider(Ue,fe,ke)},registerTypeHierarchyProvider(fe,ke){return ht.registerTypeHierarchyProvider(Ue,fe,ke)},setLanguageConfiguration:(fe,ke)=>ht.setLanguageConfiguration(Ue,fe,ke),getTokenInformationAtPosition(fe,ke){return(0,xe.$PG)(Ue,"tokenInformation"),At.tokenAtPosition(fe,ke)},registerInlayHintsProvider(fe,ke){return ht.registerInlayHintsProvider(Ue,fe,ke)},createLanguageStatusItem(fe,ke){return At.createLanguageStatusItem(Ue,fe,ke)},registerDocumentDropEditProvider(fe,ke,Be){return ht.registerDocumentOnDropEditProvider(Ue,fe,ke,(0,xe.$OG)(Ue,"documentPaste")?Be:void 0)}},Pn={get activeTextEditor(){return ot.getActiveTextEditor()},get visibleTextEditors(){return ot.getVisibleTextEditors()},get activeTerminal(){return wt.activeTerminal},get terminals(){return wt.terminals},async showTextDocument(fe,ke,Be){$.URI.isUri(fe)&&fe.scheme===M.Schemas.vscodeRemote&&!fe.authority&&Lt.report("workspace.showTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority.");const ut=await($.URI.isUri(fe)?Promise.resolve(qn.openTextDocument(fe)):Promise.resolve(fe));return ot.showTextDocument(ut,ke,Be)},createTextEditorDecorationType(fe){return ot.createTextEditorDecorationType(Ue,fe)},onDidChangeActiveTextEditor(fe,ke,Be){return at(ot.onDidChangeActiveTextEditor)(fe,ke,Be)},onDidChangeVisibleTextEditors(fe,ke,Be){return at(ot.onDidChangeVisibleTextEditors)(fe,ke,Be)},onDidChangeTextEditorSelection(fe,ke,Be){return at(ot.onDidChangeTextEditorSelection)(fe,ke,Be)},onDidChangeTextEditorOptions(fe,ke,Be){return at(ot.onDidChangeTextEditorOptions)(fe,ke,Be)},onDidChangeTextEditorVisibleRanges(fe,ke,Be){return at(ot.onDidChangeTextEditorVisibleRanges)(fe,ke,Be)},onDidChangeTextEditorViewColumn(fe,ke,Be){return at(ot.onDidChangeTextEditorViewColumn)(fe,ke,Be)},onDidCloseTerminal(fe,ke,Be){return at(wt.onDidCloseTerminal)(fe,ke,Be)},onDidOpenTerminal(fe,ke,Be){return at(wt.onDidOpenTerminal)(fe,ke,Be)},onDidChangeActiveTerminal(fe,ke,Be){return at(wt.onDidChangeActiveTerminal)(fe,ke,Be)},onDidChangeTerminalDimensions(fe,ke,Be){return(0,xe.$PG)(Ue,"terminalDimensions"),at(wt.onDidChangeTerminalDimensions)(fe,ke,Be)},onDidChangeTerminalState(fe,ke,Be){return at(wt.onDidChangeTerminalState)(fe,ke,Be)},onDidWriteTerminalData(fe,ke,Be){return(0,xe.$PG)(Ue,"terminalDataWriteEvent"),at(wt.onDidWriteTerminalData)(fe,ke,Be)},onDidExecuteTerminalCommand(fe,ke,Be){return(0,xe.$PG)(Ue,"terminalExecuteCommandEvent"),at(wt.onDidExecuteTerminalCommand)(fe,ke,Be)},onDidChangeTerminalShellIntegration(fe,ke,Be){return(0,xe.$PG)(Ue,"terminalShellIntegration"),at(xt.onDidChangeTerminalShellIntegration)(fe,ke,Be)},onDidStartTerminalShellExecution(fe,ke,Be){return(0,xe.$PG)(Ue,"terminalShellIntegration"),at(xt.onDidStartTerminalShellExecution)(fe,ke,Be)},onDidEndTerminalShellExecution(fe,ke,Be){return(0,xe.$PG)(Ue,"terminalShellIntegration"),at(xt.onDidEndTerminalShellExecution)(fe,ke,Be)},get state(){return Tt.getState()},onDidChangeWindowState(fe,ke,Be){return at(Tt.onDidChangeWindowState)(fe,ke,Be)},showInformationMessage(fe,...ke){return zn.showMessage(Ue,b.default.Info,fe,ke[0],ke.slice(1))},showWarningMessage(fe,...ke){return zn.showMessage(Ue,b.default.Warning,fe,ke[0],ke.slice(1))},showErrorMessage(fe,...ke){return zn.showMessage(Ue,b.default.Error,fe,ke[0],ke.slice(1))},showQuickPick(fe,ke,Be){return yn.showQuickPick(Ue,fe,ke,Be)},showWorkspaceFolderPick(fe){return yn.showWorkspaceFolderPick(fe)},showInputBox(fe,ke){return yn.showInput(fe,ke)},showOpenDialog(fe){return Bn.showOpenDialog(Ue,fe)},showSaveDialog(fe){return Bn.showSaveDialog(fe)},createStatusBarItem(fe,ke,Be){let ut,yt,Ot;return typeof fe=="string"?(ut=fe,yt=ke,Ot=Be):(yt=fe,Ot=ke),ti.createStatusBarEntry(Ue,ut,yt,Ot)},setStatusBarMessage(fe,ke){return ti.setStatusBarMessage(fe,ke)},withScmProgress(fe){return Lt.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Sn.withProgress(Ue,{location:Pe.ProgressLocation.SourceControl},(ke,Be)=>fe({report(ut){}}))},withProgress(fe,ke){return Sn.withProgress(Ue,fe,ke)},createOutputChannel(fe,ke){return kn.createOutputChannel(fe,ke,Ue)},createWebviewPanel(fe,ke,Be,ut){return Nn.createWebviewPanel(Ue,fe,ke,Be,ut)},createWebviewTextEditorInset(fe,ke,Be,ut){return(0,xe.$PG)(Ue,"editorInsets"),Ht.createWebviewEditorInset(fe,ke,Be,ut,Ue)},createTerminal(fe,ke,Be){return typeof fe=="object"?"pty"in fe?wt.createExtensionTerminal(fe):wt.createTerminalFromOptions(fe):wt.createTerminal(fe,ke,Be)},registerTerminalLinkProvider(fe){return wt.registerLinkProvider(fe)},registerTerminalProfileProvider(fe,ke){return wt.registerProfileProvider(Ue,fe,ke)},registerTerminalQuickFixProvider(fe,ke){return(0,xe.$PG)(Ue,"terminalQuickFixProvider"),wt.registerTerminalQuickFixProvider(fe,Ue.identifier.value,ke)},registerTreeDataProvider(fe,ke){return St.registerTreeDataProvider(fe,ke,Ue)},createTreeView(fe,ke){return St.createTreeView(fe,ke,Ue)},registerWebviewPanelSerializer:(fe,ke)=>Nn.registerWebviewPanelSerializer(Ue,fe,ke),registerCustomEditorProvider:(fe,ke,Be={})=>Xn.registerCustomEditorProvider(Ue,fe,ke,Be),registerFileDecorationProvider(fe){return Xt.registerFileDecorationProvider(fe,Ue)},registerUriHandler(fe){return gn.registerUriHandler(Ue,fe)},createQuickPick(){return yn.createQuickPick(Ue)},createInputBox(){return yn.createInputBox(Ue)},get activeColorTheme(){return Dn.activeColorTheme},onDidChangeActiveColorTheme(fe,ke,Be){return at(Dn.onDidChangeActiveColorTheme)(fe,ke,Be)},registerWebviewViewProvider(fe,ke,Be){return Ln.registerWebviewViewProvider(Ue,fe,ke,Be?.webviewOptions)},get activeNotebookEditor(){return ye.activeNotebookEditor},onDidChangeActiveNotebookEditor(fe,ke,Be){return at(ye.onDidChangeActiveNotebookEditor)(fe,ke,Be)},get visibleNotebookEditors(){return ye.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return at(ye.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(fe,ke,Be){return at(Te.onDidChangeNotebookEditorSelection)(fe,ke,Be)},onDidChangeNotebookEditorVisibleRanges(fe,ke,Be){return at(Te.onDidChangeNotebookEditorVisibleRanges)(fe,ke,Be)},showNotebookDocument(fe,ke){return ye.showNotebookDocument(fe,ke)},registerExternalUriOpener(fe,ke,Be){return(0,xe.$PG)(Ue,"externalUriOpener"),Yn.registerExternalUriOpener(Ue.identifier,fe,ke,Be)},registerProfileContentHandler(fe,ke){return(0,xe.$PG)(Ue,"profileContentHandlers"),xn.registerProfileContentHandler(Ue,fe,ke)},registerQuickDiffProvider(fe,ke,Be,ut){return(0,xe.$PG)(Ue,"quickDiffProvider"),Rn.registerQuickDiffProvider(vt(fe),ke,Be,ut)},get tabGroups(){return Yt.tabGroups},registerShareProvider(fe,ke){return(0,xe.$PG)(Ue,"shareProvider"),Jn.registerShareProvider(vt(fe),ke)}},qn={get rootPath(){return Lt.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),$t.getPath()},set rootPath(fe){throw new N.$9("rootPath")},getWorkspaceFolder(fe){return $t.getWorkspaceFolder(fe)},get workspaceFolders(){return $t.getWorkspaceFolders()},get name(){return $t.name},set name(fe){throw new N.$9("name")},get workspaceFile(){return $t.workspaceFile},set workspaceFile(fe){throw new N.$9("workspaceFile")},updateWorkspaceFolders:(fe,ke,...Be)=>$t.updateWorkspaceFolders(Ue,fe,ke||0,...Be),onDidChangeWorkspaceFolders:function(fe,ke,Be){return at($t.onDidChangeWorkspace)(fe,ke,Be)},asRelativePath:(fe,ke)=>$t.getRelativePath(fe,ke),findFiles:(fe,ke,Be,ut)=>$t.findFiles(fe,ke,Be,Ue.identifier,ut),findFiles2:(fe,ke,Be)=>((0,xe.$PG)(Ue,"findFiles2"),$t.findFiles2(fe,ke,Ue.identifier,Be)),findTextInFiles:(fe,ke,Be,ut)=>{(0,xe.$PG)(Ue,"findTextInFiles");let yt,Ot;return typeof ke=="object"?(yt=ke,Ot=Be):(yt={},Ot=ke,ut=Be),$t.findTextInFiles(fe,yt||{},Ot,Ue.identifier,ut)},save:fe=>$t.save(fe),saveAs:fe=>$t.saveAs(fe),saveAll:fe=>$t.saveAll(fe),applyEdit(fe,ke){return jn.applyWorkspaceEdit(fe,Ue,ke)},createFileSystemWatcher:(fe,ke,Be,ut)=>{let yt;return typeof ke=="boolean"?yt={ignoreCreateEvents:!!ke,ignoreChangeEvents:!!Be,ignoreDeleteEvents:!!ut,correlate:!1}:ke&&((0,xe.$PG)(Ue,"createFileSystemWatcher"),yt={...ke,correlate:!0}),dn.createFileSystemWatcher($t,Ue,fe,yt)},get textDocuments(){return jt.getAllDocumentData().map(fe=>fe.document)},set textDocuments(fe){throw new N.$9("textDocuments")},openTextDocument(fe){let ke;const Be=fe;if(typeof fe=="string")ke=Promise.resolve($.URI.file(fe));else if($.URI.isUri(fe))ke=Promise.resolve(fe);else if(!Be||typeof Be=="object")ke=jt.createDocumentData(Be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(ut=>(ut.scheme===M.Schemas.vscodeRemote&&!ut.authority&&Lt.report("workspace.openTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority."),jt.ensureDocumentData(ut).then(yt=>yt.document)))},onDidOpenTextDocument:(fe,ke,Be)=>at(jt.onDidAddDocument)(fe,ke,Be),onDidCloseTextDocument:(fe,ke,Be)=>at(jt.onDidRemoveDocument)(fe,ke,Be),onDidChangeTextDocument:(fe,ke,Be)=>at(jt.onDidChangeDocument)(fe,ke,Be),onDidSaveTextDocument:(fe,ke,Be)=>at(jt.onDidSaveDocument)(fe,ke,Be),onWillSaveTextDocument:(fe,ke,Be)=>at(ze.getOnWillSaveTextDocumentEvent(Ue))(fe,ke,Be),get notebookDocuments(){return ye.notebookDocuments.map(fe=>fe.apiNotebook)},async openNotebookDocument(fe,ke){let Be;if($.URI.isUri(fe))Be=fe,await ye.openNotebookDocument(fe);else if(typeof fe=="string")Be=$.URI.revive(await ye.createNotebookDocument({viewType:fe,content:ke}));else throw new Error("Invalid arguments");return ye.getNotebookDocument(Be).apiNotebook},onDidSaveNotebookDocument(fe,ke,Be){return at(Y.onDidSaveNotebookDocument)(fe,ke,Be)},onDidChangeNotebookDocument(fe,ke,Be){return at(Y.onDidChangeNotebookDocument)(fe,ke,Be)},onWillSaveNotebookDocument(fe,ke,Be){return at(Ke.getOnWillSaveNotebookDocumentEvent(Ue))(fe,ke,Be)},get onDidOpenNotebookDocument(){return at(ye.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return at(ye.onDidCloseNotebookDocument)},registerNotebookSerializer(fe,ke,Be,ut){return ye.registerNotebookSerializer(Ue,fe,ke,Be,(0,xe.$OG)(Ue,"notebookLiveShare")?ut:void 0)},onDidChangeConfiguration:(fe,ke,Be)=>at(Un.onDidChangeConfiguration)(fe,ke,Be),getConfiguration(fe,ke){return ke=arguments.length===1?void 0:ke,Un.getConfiguration(fe,ke,Ue)},registerTextDocumentContentProvider(fe,ke){return Ne.registerTextDocumentContentProvider(fe,ke)},registerTaskProvider:(fe,ke)=>(Lt.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),en.registerTaskProvider(Ue,fe,ke)),registerFileSystemProvider(fe,ke,Be){return(0,R.$Rc)(An.registerFileSystemProvider(Ue,fe,ke,Be),Kt.addFileSystemProvider(fe,ke,Be))},get fs(){return Kt.value},registerFileSearchProvider:(fe,ke)=>((0,xe.$PG)(Ue,"fileSearchProvider"),ln.registerFileSearchProvider(fe,ke)),registerTextSearchProvider:(fe,ke)=>((0,xe.$PG)(Ue,"textSearchProvider"),ln.registerTextSearchProvider(fe,ke)),registerAITextSearchProvider:(fe,ke)=>((0,xe.$PG)(Ue,"aiTextSearchProvider"),(0,xe.$PG)(Ue,"textSearchProvider"),ln.registerAITextSearchProvider(fe,ke)),registerRemoteAuthorityResolver:(fe,ke)=>((0,xe.$PG)(Ue,"resolvers"),Ft.registerRemoteAuthorityResolver(fe,ke)),registerResourceLabelFormatter:fe=>((0,xe.$PG)(Ue,"resolvers"),On.$registerResourceLabelFormatter(fe)),getRemoteExecServer:fe=>((0,xe.$PG)(Ue,"resolvers"),Ft.getRemoteExecServer(fe)),onDidCreateFiles:(fe,ke,Be)=>at(dn.onDidCreateFile)(fe,ke,Be),onDidDeleteFiles:(fe,ke,Be)=>at(dn.onDidDeleteFile)(fe,ke,Be),onDidRenameFiles:(fe,ke,Be)=>at(dn.onDidRenameFile)(fe,ke,Be),onWillCreateFiles:(fe,ke,Be)=>at(dn.getOnWillCreateFileEvent(Ue))(fe,ke,Be),onWillDeleteFiles:(fe,ke,Be)=>at(dn.getOnWillDeleteFileEvent(Ue))(fe,ke,Be),onWillRenameFiles:(fe,ke,Be)=>at(dn.getOnWillRenameFileEvent(Ue))(fe,ke,Be),openTunnel:fe=>((0,xe.$PG)(Ue,"tunnels"),Nt.openTunnel(Ue,fe).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,xe.$PG)(Ue,"tunnels"),Nt.getTunnels()},onDidChangeTunnels:(fe,ke,Be)=>((0,xe.$PG)(Ue,"tunnels"),at(Nt.onDidChangeTunnels)(fe,ke,Be)),registerPortAttributesProvider:(fe,ke)=>((0,xe.$PG)(Ue,"portsAttributes"),Nt.registerPortsAttributesProvider(fe,ke)),registerTunnelProvider:(fe,ke)=>((0,xe.$PG)(Ue,"tunnelFactory"),Nt.registerTunnelProvider(fe,ke)),registerTimelineProvider:(fe,ke)=>((0,xe.$PG)(Ue,"timeline"),Zn.registerTimelineProvider(fe,ke,Ue.identifier,Et.converter)),get isTrusted(){return $t.trusted},requestWorkspaceTrust:fe=>((0,xe.$PG)(Ue,"workspaceTrust"),$t.requestWorkspaceTrust(fe)),onDidGrantWorkspaceTrust:(fe,ke,Be)=>at($t.onDidGrantWorkspaceTrust)(fe,ke,Be),registerEditSessionIdentityProvider:(fe,ke)=>((0,xe.$PG)(Ue,"editSessionIdentityProvider"),$t.registerEditSessionIdentityProvider(fe,ke)),onWillCreateEditSessionIdentity:(fe,ke,Be)=>((0,xe.$PG)(Ue,"editSessionIdentityProvider"),at($t.getOnWillCreateEditSessionIdentityEvent(Ue))(fe,ke,Be)),registerCanonicalUriProvider:(fe,ke)=>((0,xe.$PG)(Ue,"canonicalUriProvider"),$t.registerCanonicalUriProvider(fe,ke)),getCanonicalUri:(fe,ke,Be)=>((0,xe.$PG)(Ue,"canonicalUriProvider"),$t.provideCanonicalUri(fe,ke,Be))},ni={get inputBox(){return Lt.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Kn.getLastInputBox(Ue)},createSourceControl(fe,ke,Be){return Kn.createSourceControl(Ue,fe,ke,Be)}},ii={createCommentController(fe,ke){return Mn.createCommentController(Ue,fe,ke)}},ri={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get activeStackItem(){if((0,xe.$OG)(Ue,"debugFocus"))return kt.activeStackItem},registerDebugVisualizationProvider(fe,ke){return(0,xe.$PG)(Ue,"debugVisualization"),kt.registerDebugVisualizationProvider(Ue,fe,ke)},registerDebugVisualizationTreeProvider(fe,ke){return(0,xe.$PG)(Ue,"debugVisualization"),kt.registerDebugVisualizationTree(Ue,fe,ke)},onDidStartDebugSession(fe,ke,Be){return at(kt.onDidStartDebugSession)(fe,ke,Be)},onDidTerminateDebugSession(fe,ke,Be){return at(kt.onDidTerminateDebugSession)(fe,ke,Be)},onDidChangeActiveDebugSession(fe,ke,Be){return at(kt.onDidChangeActiveDebugSession)(fe,ke,Be)},onDidReceiveDebugSessionCustomEvent(fe,ke,Be){return at(kt.onDidReceiveDebugSessionCustomEvent)(fe,ke,Be)},onDidChangeBreakpoints(fe,ke,Be){return at(kt.onDidChangeBreakpoints)(fe,ke,Be)},onDidChangeActiveStackItem(fe,ke,Be){return(0,xe.$PG)(Ue,"debugFocus"),at(kt.onDidChangeActiveStackItem)(fe,ke,Be)},registerDebugConfigurationProvider(fe,ke,Be){return kt.registerDebugConfigurationProvider(fe,ke,Be||Dt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(fe,ke){return kt.registerDebugAdapterDescriptorFactory(Ue,fe,ke)},registerDebugAdapterTrackerFactory(fe,ke){return kt.registerDebugAdapterTrackerFactory(fe,ke)},startDebugging(fe,ke,Be){return!Be||typeof Be=="object"&&"configuration"in Be?kt.startDebugging(fe,ke,{parentSession:Be}):kt.startDebugging(fe,ke,Be||{})},stopDebugging(fe){return kt.stopDebugging(fe)},addBreakpoints(fe){return kt.addBreakpoints(fe)},removeBreakpoints(fe){return kt.removeBreakpoints(fe)},asDebugSourceUri(fe,ke){return kt.asDebugSourceUri(fe,ke)}},gi={registerTaskProvider:(fe,ke)=>en.registerTaskProvider(Ue,fe,ke),fetchTasks:fe=>en.fetchTasks(fe),executeTask:fe=>en.executeTask(Ue,fe),get taskExecutions(){return en.taskExecutions},onDidStartTask:(fe,ke,Be)=>at(en.onDidStartTask)(fe,ke,Be),onDidEndTask:(fe,ke,Be)=>at(en.onDidEndTask)(fe,ke,Be),onDidStartTaskProcess:(fe,ke,Be)=>at(en.onDidStartTaskProcess)(fe,ke,Be),onDidEndTaskProcess:(fe,ke,Be)=>at(en.onDidEndTaskProcess)(fe,ke,Be)},si={createNotebookController(fe,ke,Be,ut,yt){return Qe.createNotebookController(Ue,fe,ke,Be,ut,(0,xe.$OG)(Ue,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(fe,ke)=>ye.registerNotebookCellStatusBarItemProvider(Ue,fe,ke),createRendererMessaging(fe){return Ye.createRendererMessaging(Ue,fe)},createNotebookControllerDetectionTask(fe){return(0,xe.$PG)(Ue,"notebookKernelSource"),Qe.createNotebookControllerDetectionTask(Ue,fe)},registerKernelSourceActionProvider(fe,ke){return(0,xe.$PG)(Ue,"notebookKernelSource"),Qe.registerKernelSourceActionProvider(Ue,fe,ke)},onDidChangeNotebookCellExecutionState(fe,ke,Be){return(0,xe.$PG)(Ue,"notebookCellExecutionState"),at(Qe.onDidChangeNotebookCellExecutionState)(fe,ke,Be)}},oi={t(...fe){if(typeof fe[0]=="string"){const ke=fe.shift(),Be=!fe||typeof fe[0]!="object"?fe:fe[0];return hn.getMessage(Ue.identifier.value,{message:ke,args:Be})}return hn.getMessage(Ue.identifier.value,fe[0])},get bundle(){return hn.getBundle(Ue.identifier.value)},get uri(){return hn.getBundleUri(Ue.identifier.value)}},mi={_version:1,transferActiveChat(fe){return(0,xe.$PG)(Ue,"interactive"),In.transferActiveChat(fe)}},$i={getRelatedInformation(fe,ke){return(0,xe.$PG)(Ue,"aiRelatedInformation"),Tn.getRelatedInformation(Ue,fe,ke)},registerRelatedInformationProvider(fe,ke){return(0,xe.$PG)(Ue,"aiRelatedInformation"),Tn.registerRelatedInformationProvider(Ue,fe,ke)},registerEmbeddingVectorProvider(fe,ke){return(0,xe.$PG)(Ue,"aiRelatedInformation"),ei.registerEmbeddingVectorProvider(Ue,fe,ke)}},ai={registerChatResponseProvider(fe,ke,Be){return(0,xe.$PG)(Ue,"chatProvider"),Mt.registerLanguageModel(Ue,fe,ke,Be)},registerChatVariableResolver(fe,ke,Be){return(0,xe.$PG)(Ue,"chatVariableResolver"),_n.registerVariableResolver(Ue,fe,ke,Be)},registerMappedEditsProvider(fe,ke){return(0,xe.$PG)(Ue,"mappedEditsProvider"),ht.registerMappedEditsProvider(Ue,fe,ke)},createChatParticipant(fe,ke){return(0,xe.$PG)(Ue,"chatParticipant"),In.createChatAgent(Ue,fe,ke)},createDynamicChatParticipant(fe,ke,Be,ut,yt){return(0,xe.$PG)(Ue,"chatParticipantAdditions"),In.createDynamicChatAgent(Ue,fe,ke,Be,ut,yt)}},Qn={get languageModels(){return(0,xe.$PG)(Ue,"languageModels"),Mt.getLanguageModelIds()},onDidChangeLanguageModels:(fe,ke,Be)=>((0,xe.$PG)(Ue,"languageModels"),Mt.onDidChangeProviders(fe,ke,Be)),sendChatRequest(fe,ke,Be,ut){return(0,xe.$PG)(Ue,"languageModels"),Mt.sendChatRequest(Ue,fe,ke,Be,ut)},computeTokenLength(fe,ke,Be){return(0,xe.$PG)(Ue,"languageModels"),Be??=h.CancellationToken.None,Mt.computeTokenLength(fe,ke,Be)},getLanguageModelInformation(fe){return(0,xe.$PG)(Ue,"languageModels"),Mt.getLanguageModelInfo(fe)}},ci={registerSpeechProvider(fe,ke){return(0,xe.$PG)(Ue,"speech"),li.registerProvider(Ue.identifier,fe,ke)}};return{version:bt.version,ai:$i,authentication:di,commands:Wn,comments:ii,chat:ai,debug:ri,env:Vn,extensions:fi,interactive:mi,l10n:oi,languages:on,lm:Qn,notebooks:si,scm:ni,speech:ci,tasks:gi,tests:mn,window:Pn,workspace:qn,Breakpoint:Pe.$gN,TerminalOutputAnchor:Pe.TerminalOutputAnchor,ChatResultFeedbackKind:Pe.ChatResultFeedbackKind,ChatVariableLevel:Pe.ChatVariableLevel,ChatCompletionItem:Pe.$bO,CallHierarchyIncomingCall:Pe.$EM,CallHierarchyItem:Pe.$DM,CallHierarchyOutgoingCall:Pe.$FM,CancellationError:N.$5,CancellationTokenSource:h.$oe,CandidatePortSource:i.CandidatePortSource,CodeAction:Pe.$AM,CodeActionKind:Pe.$BM,CodeActionTriggerKind:Pe.CodeActionTriggerKind,CodeLens:Pe.$GM,Color:Pe.$TM,ColorInformation:Pe.$UM,ColorPresentation:Pe.$VM,ColorThemeKind:Pe.ColorThemeKind,CommentMode:Pe.CommentMode,CommentState:Pe.CommentState,CommentThreadCollapsibleState:Pe.CommentThreadCollapsibleState,CommentThreadState:Pe.CommentThreadState,CommentThreadApplicability:Pe.CommentThreadApplicability,CompletionItem:Pe.$NM,CompletionItemKind:Pe.CompletionItemKind,CompletionItemTag:Pe.CompletionItemTag,CompletionList:Pe.$OM,CompletionTriggerKind:Pe.CompletionTriggerKind,ConfigurationTarget:Pe.ConfigurationTarget,CustomExecution:Pe.$4M,DebugAdapterExecutable:Pe.$kN,DebugAdapterInlineImplementation:Pe.$nN,DebugAdapterNamedPipeServer:Pe.$mN,DebugAdapterServer:Pe.$lN,DebugConfigurationProviderTriggerKind:Dt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Pe.DebugConsoleMode,DebugVisualization:Pe.$DN,DecorationRangeBehavior:Pe.DecorationRangeBehavior,Diagnostic:Pe.$tM,DiagnosticRelatedInformation:Pe.$sM,DiagnosticSeverity:Pe.DiagnosticSeverity,DiagnosticTag:Pe.DiagnosticTag,Disposable:Pe.$fM,DocumentHighlight:Pe.$wM,DocumentHighlightKind:Pe.DocumentHighlightKind,MultiDocumentHighlight:Pe.$xM,DocumentLink:Pe.$SM,DocumentSymbol:Pe.$zM,EndOfLine:Pe.EndOfLine,EnvironmentVariableMutatorType:Pe.EnvironmentVariableMutatorType,EvaluatableExpression:Pe.$qN,InlineValueText:Pe.$rN,InlineValueVariableLookup:Pe.$sN,InlineValueEvaluatableExpression:Pe.$tN,InlineCompletionTriggerKind:Pe.InlineCompletionTriggerKind,EventEmitter:O.$de,ExtensionKind:Pe.ExtensionKind,ExtensionMode:Pe.ExtensionMode,ExternalUriOpenerPriority:Pe.ExternalUriOpenerPriority,FileChangeType:Pe.FileChangeType,FileDecoration:Pe.$FN,FileDecoration2:Pe.$FN,FileSystemError:Pe.$wN,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:Pe.$xN,FoldingRangeKind:Pe.FoldingRangeKind,FunctionBreakpoint:Pe.$iN,InlineCompletionItem:Pe.$PM,InlineCompletionList:Pe.$QM,Hover:Pe.$uM,VerboseHover:Pe.$vM,HoverVerbosityAction:Pe.HoverVerbosityAction,IndentAction:I.IndentAction,Location:Pe.$rM,MarkdownString:Pe.$HM,OverviewRulerLane:p.OverviewRulerLane,ParameterInformation:Pe.$IM,PortAutoForwardAction:Pe.PortAutoForwardAction,Position:Pe.$gM,ProcessExecution:Pe.$2M,ProgressLocation:Pe.ProgressLocation,QuickInputButtons:Pe.$EN,Range:Pe.$hM,RelativePattern:Pe.$eN,Selection:Pe.$iM,SelectionRange:Pe.$CM,SemanticTokens:Pe.$AN,SemanticTokensBuilder:Pe.$zN,SemanticTokensEdit:Pe.$BN,SemanticTokensEdits:Pe.$CN,SemanticTokensLegend:Pe.$yN,ShellExecution:Pe.$3M,ShellQuoting:Pe.ShellQuoting,SignatureHelp:Pe.$KM,SignatureHelpTriggerKind:Pe.SignatureHelpTriggerKind,SignatureInformation:Pe.$JM,SnippetString:Pe.$qM,SourceBreakpoint:Pe.$hN,StandardTokenType:Pe.StandardTokenType,StatusBarAlignment:Pe.StatusBarAlignment,SymbolInformation:Pe.$yM,SymbolKind:Pe.SymbolKind,SymbolTag:Pe.SymbolTag,Task:Pe.$5M,TaskGroup:Pe.$1M,TaskPanelKind:Pe.TaskPanelKind,TaskRevealKind:Pe.TaskRevealKind,TaskScope:Pe.TaskScope,TerminalLink:Pe.$WM,TerminalQuickFixTerminalCommand:Pe.$YM,TerminalQuickFixOpener:Pe.$XM,TerminalLocation:Pe.TerminalLocation,TerminalProfile:Pe.$ZM,TerminalExitReason:Pe.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Pe.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Pe.TextDocumentSaveReason,TextEdit:Pe.$mM,SnippetTextEdit:Pe.$oM,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:Pe.TextEditorLineNumbersStyle,TextEditorRevealType:Pe.TextEditorRevealType,TextEditorSelectionChangeKind:Pe.TextEditorSelectionChangeKind,SyntaxTokenType:Pe.SyntaxTokenType,TextDocumentChangeReason:Pe.TextDocumentChangeReason,ThemeColor:Pe.$dN,ThemeIcon:Pe.$cN,TreeItem:Pe.$6M,TreeItemCheckboxState:Pe.TreeItemCheckboxState,TreeItemCollapsibleState:Pe.TreeItemCollapsibleState,TypeHierarchyItem:Pe.$2N,UIKind:_t.UIKind,Uri:$.URI,ViewColumn:Pe.ViewColumn,WorkspaceEdit:Pe.$pM,DocumentPasteTriggerKind:Pe.DocumentPasteTriggerKind,DocumentDropEdit:Pe.$_M,DocumentDropOrPasteEditKind:Pe.$aN,DocumentPasteEdit:Pe.$bN,InlayHint:Pe.$MM,InlayHintLabelPart:Pe.$LM,InlayHintKind:Pe.InlayHintKind,RemoteAuthorityResolverError:Pe.$lM,ResolvedAuthority:Pe.$jM,ManagedResolvedAuthority:Pe.$kM,SourceControlInputBoxValidationType:Pe.SourceControlInputBoxValidationType,ExtensionRuntime:Pe.ExtensionRuntime,TimelineItem:Pe.$PN,NotebookRange:Pe.$HN,NotebookCellKind:Pe.NotebookCellKind,NotebookCellExecutionState:Pe.NotebookCellExecutionState,NotebookCellData:Pe.$IN,NotebookData:Pe.$JN,NotebookRendererScript:Pe.$NN,NotebookCellStatusBarAlignment:Pe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Pe.NotebookEditorRevealType,NotebookCellOutput:Pe.$LN,NotebookCellOutputItem:Pe.$KN,NotebookCellStatusBarItem:Pe.$MN,NotebookControllerAffinity:Pe.NotebookControllerAffinity,NotebookControllerAffinity2:Pe.NotebookControllerAffinity2,NotebookEdit:Pe.$nM,NotebookKernelSourceAction:Pe.$ON,NotebookVariablesRequestKind:Pe.NotebookVariablesRequestKind,PortAttributes:Pe.$RN,LinkedEditingRanges:Pe.$QN,TestResultState:Pe.TestResultState,TestRunRequest:Pe.$SN,TestRunRequest2:Pe.$SN,TestMessage:Pe.$TN,TestTag:Pe.$UN,TestRunProfileKind:Pe.TestRunProfileKind,TextSearchCompleteMessageType:tn.TextSearchCompleteMessageType,DataTransfer:Pe.$$M,DataTransferItem:Pe.$7M,TestCoverageCount:Pe.$VN,FileCoverage:Pe.$XN,StatementCoverage:Pe.$YN,BranchCoverage:Pe.$ZN,DeclarationCoverage:Pe.$1N,WorkspaceTrustState:Pe.WorkspaceTrustState,LanguageStatusSeverity:Pe.LanguageStatusSeverity,QuickPickItemKind:Pe.QuickPickItemKind,InputBoxValidationSeverity:Pe.InputBoxValidationSeverity,TabInputText:Pe.$3N,TabInputTextDiff:Pe.$4N,TabInputTextMerge:Pe.$5N,TabInputCustom:Pe.$6N,TabInputNotebook:Pe.$8N,TabInputNotebookDiff:Pe.$9N,TabInputWebview:Pe.$7N,TabInputTerminal:Pe.$0N,TabInputInteractiveWindow:Pe.$$N,TabInputChat:Pe.$_N,TabInputTextMultiDiff:Pe.$aO,TelemetryTrustedValue:o.$fp,LogLevel:l.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Pe.InteractiveSessionVoteDirection,ChatCopyKind:Pe.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Pe.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Pe.$oN,DebugThread:Pe.$pN,RelatedInformationType:Pe.RelatedInformationType,SpeechToTextStatus:Pe.SpeechToTextStatus,TextToSpeechStatus:Pe.TextToSpeechStatus,PartialAcceptTriggerKind:Pe.PartialAcceptTriggerKind,KeywordRecognitionStatus:Pe.KeywordRecognitionStatus,ChatResponseMarkdownPart:Pe.$cO,ChatResponseFileTreePart:Pe.$fO,ChatResponseAnchorPart:Pe.$gO,ChatResponseProgressPart:Pe.$hO,ChatResponseReferencePart:Pe.$kO,ChatResponseWarningPart:Pe.$iO,ChatResponseTextEditPart:Pe.$lO,ChatResponseMarkdownWithVulnerabilitiesPart:Pe.$dO,ChatResponseCommandButtonPart:Pe.$jO,ChatResponseDetectedParticipantPart:Pe.$eO,ChatRequestTurn:Pe.$mO,ChatResponseTurn:Pe.$nO,ChatLocation:Pe.ChatLocation,LanguageModelChatSystemMessage:Pe.$oO,LanguageModelChatUserMessage:Pe.$pO,LanguageModelChatAssistantMessage:Pe.$qO,LanguageModelSystemMessage:Pe.$oO,LanguageModelUserMessage:Pe.$pO,LanguageModelAssistantMessage:Pe.$qO,LanguageModelError:Pe.$rO,NewSymbolName:Pe.$vN,NewSymbolNameTag:Pe.NewSymbolNameTag,NewSymbolNameTriggerKind:Pe.NewSymbolNameTriggerKind,InlineEdit:Pe.$sO,InlineEditTriggerKind:Pe.InlineEditTriggerKind}}}}),define(Se[384],De([1,0,85,158,44,152,45,34,73,43,95,96,97,119,71,91,151,70,60,118,90,72,150,11,61,116,117,121,122,156]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d,o,n,i,u,s,t,c,r,a,f,g,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.$xs)(a.$qmc,a.$pmc,1),(0,h.$xs)(c.$4j,t.$Cnc,1),(0,h.$xs)(l.$vlc,l.$wlc,1),(0,h.$xs)(b.$1O,b.$ZO,0),(0,h.$xs)(g.$Flc,g.$Glc,0),(0,h.$xs)(w.$kmc,w.$lmc,0),(0,h.$xs)(M.$Ulc,M.$Slc,0),(0,h.$xs)(o.$Wlc,o.$Vlc,0),(0,h.$xs)(I.$Amc,I.$Emc,0),(0,h.$xs)(R.$Gmc,R.$Fmc,0),(0,h.$xs)($.$PO,$.$OO,0),(0,h.$xs)(f.$rmc,f.$smc,0),(0,h.$xs)(n.$zlc,n.$ylc,0),(0,h.$xs)(N.$$mc,N.$0mc,1),(0,h.$xs)(p.$Vmc,p.$Wmc,0),(0,h.$xs)(y.$dmc,y.$cmc,0),(0,h.$xs)(A.$lnc,A.$knc,0),(0,h.$xs)(k.$gmc,k.$jmc,0),(0,h.$xs)(S.$mnc,S.$nnc,0),(0,h.$xs)(v.$CDb,v.$DDb,0),(0,h.$xs)(d.$Anc,d.$znc,0),(0,h.$xs)(O.$Rlc,O.$Qlc,0),(0,h.$xs)(i.$nmc,i.$mmc,0),(0,h.$xs)(u.$YO,u.$VO,0),(0,h.$xs)(s.$7lc,s.$8lc,0),(0,h.$xs)(r.$ymc,r.$zmc,0)}),define(Se[123],De([1,0,19,11,37,94]),function(he,e,h,N,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Unc=void 0,e.$Snc=M,e.$Tnc=b;function M(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}function b(I,p,y,v){const l=(0,h.$1b)(y,$),d=new O.$vK(p,l,v),o=d.preview.matches;return{ranges:(0,h.$1b)(l,k),uri:I,preview:{text:d.preview.text,matches:(0,h.$1b)(o,k)}}}function $(I){return new O.$wK(I.start.line,I.start.character,I.end.line,I.end.character)}function k(I){return new R.$kK(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let A=class{constructor(p,y){this.a=p,this.b=y}appendLine(p){this.b.debug(`${this.a}#search`,p)}};e.$Unc=A,e.$Unc=A=He([We(1,N.$3j)],A)}),define(Se[385],De([1,0,54,16,77,31,12,14,123,386]),function(he,e,h,N,O,R,M,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vnc=I,e.$Wnc=d,e.$Xnc=n;const A=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(i,u,s,t){const c=p(i,u,s,t),r=u.folder.fsPath;return{cmd:h.spawn(A,c.args,{cwd:r}),rgDiskPath:A,siblingClauses:c.siblingClauses,rgArgs:c,cwd:r}}function p(i,u,s,t){const c=["--files","--hidden","--case-sensitive","--no-require-git"];v([u],s,!1).forEach(a=>{const f=(0,$.$Snc)(a);if(c.push("-g",f),M.$j){const g=(0,O.$cm)(f);g!==f&&c.push("-g",g)}});const r=y([u],t,void 0,!1);return r.globArgs.forEach(a=>{const f=`!${(0,$.$Snc)(a)}`;if(c.push("-g",f),M.$j){const g=(0,O.$cm)(f);g!==f&&c.push("-g",g)}}),u.disregardIgnoreFiles!==!1?c.push("--no-ignore"):u.disregardParentIgnoreFiles!==!1&&c.push("--no-ignore-parent"),u.ignoreSymlinks||c.push("--follow"),i.exists&&c.push("--quiet"),c.push("--no-config"),u.disregardGlobalIgnoreFiles&&c.push("--no-ignore-global"),{args:c,siblingClauses:r.siblingClauses}}function y(i,u,s,t=!0){const c=[];let r={};return i.forEach(a=>{const f=Object.assign({},a.excludePattern||{},u||{}),g=l(f,t?a.folder.fsPath:void 0,s);c.push(...g.globArgs),g.siblingClauses&&(r=Object.assign(r,g.siblingClauses))}),{globArgs:c,siblingClauses:r}}function v(i,u,s=!0){const t=[];return i.forEach(c=>{const r=Object.assign({},u||{},c.includePattern||{}),a=l(r,s?c.folder.fsPath:void 0);t.push(...a.globArgs)}),t}function l(i,u,s){const t=[],c={};return Object.keys(i).forEach(r=>{if(s&&s.has(r)||!r)return;const a=i[r];r=o(u?d(u,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof a=="boolean"&&a?(r.startsWith("\\\\")&&(r+="**"),t.push(n(r))):a&&a.when&&(c[r]=a)}),{globArgs:t,siblingClauses:c}}function d(i,u){return N.$ic(u)?u:N.$jc(i,u)}function o(i){return i=b.$ff(i,"\\"),b.$ff(i,"/")}function n(i){return R.$rg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(Se[387],De([1,0,54,53,16,388,19,47,35,77,31,12,40,14,18,32,37,385,133]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Znc=e.$Ync=void 0;const i=new Set;process.on("exit",()=>{i.forEach(r=>r())});class u{constructor(a){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=a,this.b=a.filePattern||"",this.d=a.includePattern&&$.$qk(a.includePattern),this.f=a.maxResults||null,this.g=!!a.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=a.shouldGlobMatchFilePattern?null:(0,n.$xr)(this.b).normalizedLowercase),this.u=a.excludePattern&&$.$qk(a.excludePattern),this.t=new Map,a.folderQueries.forEach(f=>{const g=Object.assign({},f.excludePattern||{},this.a.excludePattern||{}),w=f.folder.fsPath;a.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==w).forEach(S=>{(0,A.$vg)(S,w)&&(g[O.$lc(w,S)]=!0)}),this.t.set(w,new t(g,w))})}cancel(){this.l=!0,i.forEach(a=>a())}walk(a,f,g,w,S){if(this.m=p.$_d.create(!1),this.l)return S(null,this.j);f.forEach(m=>{const E=O.$nc(m.fsPath);this.u&&this.u(m.fsPath,E)||this.J(g,{relativePath:m.fsPath,searchPath:void 0})}),this.r=p.$_d.create(!1),this.w(a,(m,E)=>{this.x(this.y,this,m,g,w,D=>{if(D){const C=(0,b.$hj)(D);console.error(C),this.q.push(C),E(D,void 0)}else E(null,void 0)})},(m,E)=>{this.m.stop();const D=m?M.$Hb(m)[0]:null;S(D,this.j)})}w(a,f,g){const w=new Array(a.length),S=new Array(a.length);let m=!1,E=0;if(a.length===0)return g(null,[]);a.forEach((D,C)=>{f(D,(P,F)=>{if(P?(m=!0,w[C]=null,S[C]=P):(w[C]=F,S[C]=null),++E===a.length)return g(m?S:null,w)})})}x(a,f,...g){try{a.apply(f,g)}catch(w){g[g.length-1](w)}}y(a,f,g,w){const S=a.folder.fsPath,m=I.$j,E=()=>T&&T.kill();i.add(E);let D=U=>{i.delete(E),D=()=>{},w(U)},C="";const P=this.D(),F=(0,o.$Vnc)(this.a,a,this.a.includePattern,this.t.get(a.folder.fsPath).expression),T=F.cmd,z=!Object.keys(F.siblingClauses).length,L=F.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let j=`${F.rgDiskPath} ${L}
 - cwd: ${F.cwd}`;F.rgArgs.siblingClauses&&(j+=`
 - Sibling clauses: ${JSON.stringify(F.rgArgs.siblingClauses)}`),g({message:j}),this.s=0,this.z(T,"utf8",g,(U,X,ie)=>{if(U){D(U);return}if(this.j){D();return}const G=(C+(m?k.$bm(X||""):X)).split(`
`);if(ie){const x=G.length;G[x-1]=G[x-1].trim(),G[x-1]||G.pop()}else C=G.pop()||"";if(G.length&&G[0].indexOf(`
`)!==-1){D(new Error("Splitting up files failed"));return}if(this.s+=G.length,z){for(const x of G)if(this.J(f,{base:S,relativePath:x,searchPath:this.N(a,x)}),this.j){E();break}(ie||this.j)&&D();return}this.G(a,P,S,G,f),ie&&(this.H(P,S,f),D())})}spawnFindCmd(a){const f=this.t.get(a.folder.fsPath),g=f.getBasenameTerms(),w=f.getPathTerms(),S=["-L","."];if(g.length||w.length){S.push("-not","(","(");for(const m of g)S.push("-name",m),S.push("-o");for(const m of w)S.push("-path",m),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),h.spawn("find",S,{cwd:a.folder.fsPath})}readStdout(a,f,g){let w="";this.z(a,f,()=>{},(S,m,E)=>{if(S){g(S);return}w+=m,E&&g(null,w)})}z(a,f,g,w){let S=(D,C,P)=>{(D||P)&&(S=()=>{},this.r?.stop()),w(D,C,P)},m=!1;a.stdout?(this.A(a.stdout,f,S),a.stdout.once("data",()=>m=!0)):g({message:"stdout is null"});let E;a.stderr?E=this.B(a.stderr):g({message:"stderr is null"}),a.on("error",D=>{S(D)}),a.on("close",D=>{let C;!m&&(C=this.C(E,f))&&c(C)?S(new Error(`command failed with error code ${D}: ${this.C(E,f)}`)):(this.g&&D===0&&(this.j=!0),S(null,"",!0))})}A(a,f,g){const w=new R.StringDecoder(f);return a.on("data",S=>{g(null,w.write(S))}),w}B(a){const f=[];return a.on("data",g=>{f.push(g)}),f}C(a,f){const g=new R.StringDecoder(f);return a.map(w=>g.write(w)).join("")}D(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}G(a,{pathToEntries:f},g,w,S){w.indexOf(this.b)!==-1&&this.J(S,{base:g,relativePath:this.b,searchPath:this.N(a,this.b)});const m=E=>{const D=O.$nc(E),C=O.$mc(E);let P=f[C];P||(P=f[C]=[],m(C)),P.push({base:g,relativePath:E,basename:D,searchPath:this.N(a,E)})};w.forEach(m)}H({rootEntries:a,pathToEntries:f},g,w){const S=this,m=this.t.get(g),E=this.b;function D(C){S.o++;const P=(0,d.$LK)(()=>C.map(F=>F.basename));for(let F=0,T=C.length;F<T;F++){const z=C[F],{relativePath:L,basename:j}=z;if(m.test(L,j,E!==j?P:void 0))continue;const U=f[L];if(U)D(U);else{if(S.p++,L===E)continue;S.J(w,z)}if(S.j)break}}D(a)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(a,f,g,w,S){const m=a.folder,E=(0,d.$LK)(()=>g);this.w(g,(D,C)=>{if(this.l||this.j)return C(null);const P=f?[f,D].join(O.sep):D;if(this.t.get(a.folder.fsPath).test(P,D,this.a.filePattern!==D?E:void 0))return C(null);const F=[m.fsPath,P].join(O.sep);N.lstat(F,(T,z)=>{if(T||this.l||this.j)return C(null);this.L(F,z,(L,j)=>L||this.l||this.j?C(null):j.isDirectory()?(this.o++,this.M(F,z,(U,X)=>U||this.l||this.j||(X=X||"",this.v[X])?C(null):(this.v[X]=!0,l.Promises.readdir(F).then(ie=>{if(this.l||this.j)return C(null);this.I(a,P,ie,w,q=>C(q||null))},ie=>{C(null)})))):(this.p++,P===this.b||this.h&&v.$ag(j.size)&&j.size>this.h||this.J(w,{base:m.fsPath,relativePath:P,searchPath:this.N(a,P)}),C(null,void 0)))})},D=>{const C=D&&M.$Hb(D);return S(C&&C.length>0?C[0]:void 0)})}J(a,f){this.K(f)&&(!this.d||this.d(f.relativePath,O.$nc(f.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||a(f))}K(a){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,d.$GK)(a,this.c);if(this.b)return(0,d.$GK)(a,this.b,!1)}return!0}L(a,f,g){return f.isSymbolicLink()?N.stat(a,g):g(null,f)}M(a,f,g){return f.isSymbolicLink()?N.realpath(a,(w,S)=>w?g(w):g(null,S)):g(null,a)}N(a,f){return a.folderName?O.$jc(a.folderName,f):f}}e.$Ync=u;class s{constructor(a){this.a=a.folderQueries,this.b=a.extraFileResources||[],this.c=new u(a)}search(a,f,g){this.c.walk(this.a,this.b,a,f,(w,S)=>{g(w,{limitHit:S,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Znc=s;class t{constructor(a,f){this.expression=a,this.c=f,this.d(a)}d(a){let f,g;Object.keys(a).filter(w=>a[w]).forEach(w=>{O.$ic(w)?(f=f||$.$lk(),f[w]=a[w]):(g=g||$.$lk(),g[w]=a[w])}),this.a=f&&$.$qk(f,{trimForExclusions:!0}),this.b=g&&$.$qk(g,{trimForExclusions:!0})}test(a,f,g){return this.b&&this.b(a,f,g)||this.a&&this.a(O.$jc(this.c,a),f,g)}getBasenameTerms(){const a=[];return this.a&&a.push(...$.$sk(this.a)),this.b&&a.push(...$.$sk(this.b)),a}getPathTerms(){const a=[];return this.a&&a.push(...$.$tk(this.a)),this.b&&a.push(...$.$tk(this.b)),a}}function c(r){const a=r.trim().split(`
`),f=a[0].trim();if(f.startsWith("Error parsing regex"))return f;if(f.startsWith("regex parse error"))return y.$1f(a[a.length-1].trim());if(f.startsWith("error parsing glob")||f.startsWith("unsupported encoding"))return f.charAt(0).toUpperCase()+f.substr(1);if(f==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(f.startsWith("Literal "))return f}}),define(Se[389],De([1,0,98,21,198,22]),function(he,e,h,N,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mE=e.$eE=e.DecodeStreamErrorKind=e.$dE=e.$cE=e.$bE=e.$_D=e.$$D=e.$0D=e.$9D=void 0,e.$aE=M,e.$fE=v,e.$gE=l,e.$hE=d,e.$iE=o,e.$jE=n,e.$kE=r,e.$lE=a,e.$9D="utf8",e.$0D="utf8bom",e.$$D="utf16be",e.$_D="utf16le";function M(f){return[e.$9D,e.$0D,e.$$D,e.$_D].some(g=>g===f)}e.$bE=[254,255],e.$cE=[255,254],e.$dE=[239,187,191];const b=512,$=512,k=512*8,A=512*128;var I;(function(f){f[f.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class p extends Error{constructor(g,w){super(g),this.decodeStreamErrorKind=w}}e.$eE=p;class y{static async create(g){let w;if(g!==e.$9D)w=(await(0,O.$8D)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(g));else{const S=new TextDecoder;w={write(m){return S.decode(m,{stream:!0})},end(){return S.decode()}}}return new y(w)}constructor(g){this.a=g}write(g){return this.a.write(g)}end(){return this.a.end()}}function v(f,g){const w=g.minBytesRequiredForDetection??g.guessEncoding?k:$;return new Promise((S,m)=>{const E=(0,h.$te)(z=>z.join("")),D=[];let C=0,P;const F=new R.$oe,T=async()=>{try{const z=await a({buffer:N.$Fe.concat(D),bytesRead:C},g.guessEncoding);if(z.seemsBinary&&g.acceptTextOnly)throw new p("Stream is binary but only text is accepted for decoding",1);z.encoding=await g.overwriteEncoding(z.encoding),P=await y.create(z.encoding);const L=P.write(N.$Fe.concat(D).buffer);E.write(L),D.length=0,C=0,S({stream:E,detected:z})}catch(z){F.cancel(),E.destroy(),m(z)}};(0,h.$xe)(f,{onData:async z=>{P?E.write(P.write(z.buffer)):(D.push(z),C+=z.byteLength,C>=w&&(f.pause(),await T(),setTimeout(()=>f.resume())))},onError:z=>E.error(z),onEnd:async()=>{P||await T(),E.end(P?.end())}},F.token)})}async function l(f,g,w){const m=(await(0,O.$8D)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(g),w);let E=!1,D=!1;return{read(){if(D)return null;const C=f.read();if(typeof C!="string"){if(D=!0,!E&&w?.addBOM)switch(g){case e.$9D:case e.$0D:return N.$Fe.wrap(Uint8Array.from(e.$dE));case e.$$D:return N.$Fe.wrap(Uint8Array.from(e.$bE));case e.$_D:return N.$Fe.wrap(Uint8Array.from(e.$cE))}const P=m.end();return P&&P.length>0?(E=!0,N.$Fe.wrap(P)):null}return E=!0,N.$Fe.wrap(m.write(C))}}}async function d(f){return(await(0,O.$8D)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(f))}function o(f){return f===e.$0D||f===null?e.$9D:f}function n(f,g){if(!f||g<e.$bE.length)return null;const w=f.readUInt8(0),S=f.readUInt8(1);if(w===e.$bE[0]&&S===e.$bE[1])return e.$$D;if(w===e.$cE[0]&&S===e.$cE[1])return e.$_D;if(g<e.$dE.length)return null;const m=f.readUInt8(2);return w===e.$dE[0]&&S===e.$dE[1]&&m===e.$dE[2]?e.$0D:null}const i=["ascii","utf-16","utf-32"];async function u(f){const g=await(0,O.$8D)("jschardet","dist/jschardet.min.js"),w=f.slice(0,A),S=c(w.buffer),m=g.detect(S);if(!m||!m.encoding)return null;const E=m.encoding.toLowerCase();return 0<=i.indexOf(E)?null:t(m.encoding)}const s={ibm866:"cp866",big5:"cp950"};function t(f){const g=f.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return s[g]||g}function c(f){let g="";for(let w=0;w<f.length;w++)g+=String.fromCharCode(f[w]);return g}function r(f){switch(f){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const g=f.match(/windows(\d+)/);return g?"windows-"+g[1]:f}}}function a({buffer:f,bytesRead:g},w){let S=n(f,g),m=!1;if(S!==e.$$D&&S!==e.$_D&&f){let E=!0,D=!0,C=!1;for(let P=0;P<g&&P<b;P++){const F=P%2===1,T=f.readUInt8(P)===0;if(T&&(C=!0),E&&(F&&!T||!F&&T)&&(E=!1),D&&(F&&T||!F&&!T)&&(D=!1),T&&!E&&!D)break}C&&(E?S=e.$_D:D?S=e.$$D:m=!0)}return w&&!m&&!S&&f?u(f.slice(0,g)).then(E=>({seemsBinary:!1,encoding:E})):{seemsBinary:m,encoding:S}}e.$mE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[161],De([1,0,389,32,160]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8nc=void 0;class R extends O.$Rmc{constructor(b,$,k=N,A="searchProcess"){super({query:b,provider:$},{readdir:I=>k.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,h.$kE)(I)},A)}}e.$8nc=R}),define(Se[162],De([1,0,54,405,388,19,74,35,14,2,37,94,406,386,123]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2nc=e.$1nc=void 0,e.$3nc=t,e.$4nc=r,e.$5nc=f,e.$6nc=g,e.$7nc=S;const l=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class d{constructor(E){this.a=E}provideTextSearchResults(E,D,C,P){return this.a.appendLine(`provideTextSearchResults ${E.pattern}, ${JSON.stringify({...D,folder:D.folder.toString()})}`),new Promise((F,T)=>{P.onCancellationRequested(()=>G());const z=t(E,D),L=D.folder.fsPath,j=z.map(Ie=>Ie.match(/^-/)?Ie:`'${Ie}'`).join(" ");this.a.appendLine(`${l} ${j}
 - cwd: ${L}`);let U=h.spawn(l,z,{cwd:L});U.on("error",Ie=>{console.error(Ie),this.a.appendLine("Error: "+(Ie&&Ie.message)),T((0,A.$CK)(new A.$AK(Ie&&Ie.message,A.SearchErrorCode.rgProcessError)))});let X=!1;const ie=new i(D.maxResults,D.folder,D.previewOptions);ie.on("result",Ie=>{X=!0,ne="",C.report(Ie)});let q=!1;const G=()=>{q=!0,U?.kill(),ie?.cancel()};let x=!1;ie.on("hitLimit",()=>{x=!0,G()});let ne="";U.stdout.on("data",Ie=>{ie.handleData(Ie),X||(ne+=Ie)});let be=!1;U.stdout.once("data",()=>be=!0);let ae="";U.stderr.on("data",Ie=>{const ee=Ie.toString();this.a.appendLine(ee),ae.length+ee.length<1e6&&(ae+=ee)}),U.on("close",()=>{if(this.a.appendLine(be?"Got data from stdout":"No data from stdout"),this.a.appendLine(X?"Got result from parser":"No result from parser"),ne&&this.a.appendLine(`Got data without result: ${ne}`),this.a.appendLine(""),q)F({limitHit:x});else{ie.flush(),U=null;let Ie;ae&&!be&&(Ie=o(ae))?T((0,A.$CK)(new A.$AK(Ie.message,Ie.code))):F({limitHit:x})}})})}}e.$1nc=d;function o(m){const E=m.split(`
`),D=E[0].trim();if(E.some(P=>P.startsWith("regex parse error")))return new A.$AK(n(E),A.SearchErrorCode.regexParseError);const C=D.match(/grep config error: unknown encoding: (.*)/);if(C)return new A.$AK(`Unknown encoding: ${C[1]}`,A.SearchErrorCode.unknownEncoding);if(D.startsWith("error parsing glob"))return new A.$AK(D.charAt(0).toUpperCase()+D.substr(1),A.SearchErrorCode.globParseError);if(D.startsWith("the literal"))return new A.$AK(D.charAt(0).toUpperCase()+D.substr(1),A.SearchErrorCode.invalidLiteral);if(D.startsWith("PCRE2: error compiling pattern"))return new A.$AK(D,A.SearchErrorCode.regexParseError)}function n(m){const E=["Regex parse error"],D=m.filter(C=>C.startsWith("PCRE2:"));if(D.length>=1){const C=D[0].replace("PCRE2:","");if(C.indexOf(":")!==-1&&C.split(":").length>=2){const P=C.split(":")[1];E.push(":"+P)}}return E.join("")}class i extends N.EventEmitter{constructor(E,D,C){super(),this.g=E,this.h=D,this.j=C,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new O.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(E,D){return super.on(E,D),this}handleData(E){if(this.b)return;const D=typeof E=="string"?E:this.d.write(E);this.k(D)}k(E){let D=E.indexOf(`
`);const C=this.a+E;if(D>=0)D+=this.a.length;else{this.a=C;return}let P=0;for(;D>=0;)this.m(C.substring(P,D).trim()),P=D+1,D=C.indexOf(`
`,P);this.a=C.substring(P)}m(E){if(this.b||!E)return;let D;try{D=JSON.parse(E)}catch{throw new Error(`malformed line from rg: ${E}`)}if(D.type==="match"){const C=u(D.data.path),P=k.URI.joinPath(this.h,C),F=this.n(D.data,P);this.p(F),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(D.type==="context"){const C=u(D.data.path),P=k.URI.joinPath(this.h,C);this.o(D.data,P).forEach(T=>this.p(T))}}n(E,D){const C=E.line_number-1,P=u(E.lines),F=Buffer.from(P);let T=0,z=0,L=C;E.submatches.length===0&&E.submatches.push(P.length?{start:0,end:1,match:{text:P[0]}}:{start:0,end:0,match:{text:""}});const j=(0,R.$Hb)(E.submatches.map((U,X)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ie=u(U.match),q=F.slice(T,U.start).toString(),G=s(q),x=G.numLines>0?G.lastLineLength:G.lastLineLength+z,ne=s(ie),be=G.numLines+L,ae=ne.numLines+be,Ie=ne.numLines>0?ne.lastLineLength:ne.lastLineLength+x;return T=U.end,z=Ie,L=ae,new I.$kK(be,x,ae,Ie)}));return(0,v.$Tnc)(D,P,j,this.j)}o(E,D){const C=u(E.lines),P=E.line_number;return C.replace(/\r?\n$/,"").split(`
`).map((F,T)=>({text:F,uri:D,lineNumber:P+T}))}p(E){this.emit("result",E)}}e.$2nc=i;function u(m){return m.bytes?Buffer.from(m.bytes,"base64").toString():m.text}function s(m){const E=/\n/g;let D=0,C=-1,P;for(;P=E.exec(m);)D++,C=P.index;const F=C>=0?m.length-C-1:m.length;return{numLines:D,lastLineLength:F}}function t(m,E){const D=["--hidden","--no-require-git"];D.push(m.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:C,otherIncludes:P}=(0,M.$K)(E.includes,T=>T.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(P&&P.length){const T=new Set;P.forEach(z=>{T.add(z)}),D.push("-g","!*"),T.forEach(z=>{c(z).map(v.$Snc).forEach(L=>{D.push("-g",L)})})}C&&C.length&&C.forEach(T=>{D.push("-g",T)}),E.excludes.map(v.$Snc).forEach(T=>D.push("-g",`!${T}`)),E.maxFileSize&&D.push("--max-filesize",E.maxFileSize+""),E.useIgnoreFiles?E.useParentIgnoreFiles||D.push("--no-ignore-parent"):D.push("--no-ignore"),E.followSymlinks&&D.push("--follow"),E.encoding&&E.encoding!=="utf8"&&D.push("--encoding",E.encoding),m.pattern==="--"&&(m.isRegExp=!0,m.pattern="\\-\\-"),m.isMultiline&&!m.isRegExp&&(m.pattern=(0,$.$_e)(m.pattern),m.isRegExp=!0),E.usePCRE2&&D.push("--pcre2"),D.push("--crlf"),m.isRegExp&&(m.pattern=r(m.pattern),D.push("--engine","auto"));let F;if(m.isWordMatch){const z=(0,$.$if)(m.pattern,!!m.isRegExp,{wholeWord:m.isWordMatch}).source.replace(/\\\//g,"/");D.push("--regexp",z)}else if(m.isRegExp){let T=f(m.pattern);T=g(T),D.push("--regexp",T)}else F=m.pattern,D.push("--fixed-strings");return D.push("--no-config"),E.useGlobalIgnoreFiles||D.push("--no-ignore-global"),D.push("--json"),m.isMultiline&&D.push("--multiline"),E.beforeContext&&D.push("--before-context",E.beforeContext+""),E.afterContext&&D.push("--after-context",E.afterContext+""),D.push("--"),F&&D.push(F),D.push("."),D}function c(m){return S(m).flatMap(D=>{const C=(0,b.$ok)(D,"/");return C.map((P,F)=>C.slice(0,F+1).join("/"))})}function r(m){const E=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;m.match(E);)m=m.replace(E,"$1\\x{$2}");const D=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;m.match(D);)m=m.replace(D,"$1\\x{$2}");return m}const a=m=>m.type==="Assertion"&&m.kind==="lookbehind";function f(m){let E;try{E=new p.RegExpParser().parsePattern(m)}catch{return m}let D="",C=0;const P=(z,L,j)=>{D+=m.slice(C,z)+j,C=L},F=[];return new p.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const L=F[0];if(!L)P(z.start,z.end,"\\r?\\n");else if(!F.some(a))if(L.type==="CharacterClass")if(L.negate){const j=m.slice(L.start+2,z.start)+m.slice(z.end,L.end-1);L.parent?.type==="Quantifier"?P(L.start,L.end,j?`[^${j}]`:"."):P(L.start,L.end,"(?!\\r?\\n"+(j?`|[${j}]`:"")+")")}else{const j=m.slice(L.start+1,z.start)+m.slice(z.end,L.end-1);P(L.start,L.end,j===""?"\\r?\\n":`(?:[${j}]|\\r?\\n)`)}else L.type==="Quantifier"&&P(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){F.unshift(z)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(z){F.unshift(z)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(z){F.unshift(z)},onCharacterClassLeave(){F.shift()},onAssertionEnter(z){a(z)&&F.push(z)},onAssertionLeave(z){F[0]===z&&F.shift()}}).visit(E),D+=m.slice(C),D}function g(m){return m.replace(/\n/g,"\\r?\\n")}function w(m){let E=!1,D=!1,C="",P="";for(let F=0;F<m.length;F++){const T=m[F];switch(T){case"\\":D?(E?P+="\\"+T:C+="\\"+T,D=!1):D=!0;break;case"{":if(D)E?P+=T:C+=T,D=!1;else{if(E)return{strInBraces:C+"{"+P+"{"+m.substring(F+1)};E=!0}break;case"}":if(D)E?P+=T:C+=T,D=!1;else{if(E)return{fixedStart:C,strInBraces:P,fixedEnd:m.substring(F+1)};C+=T}break;default:E?P+=(D?"\\":"")+T:C+=(D?"\\":"")+T,D=!1;break}}return{strInBraces:C+(E?"{"+P:"")}}function S(m){const{fixedStart:E,strInBraces:D,fixedEnd:C}=w(m);if(E===void 0||C===void 0)return[D];let P=(0,b.$ok)(D,",");P.length||(P=[""]);const F=S(C);return P.flatMap(T=>{const z=E+T;return F.map(L=>z+L)})}}),define(Se[390],De([1,0,22,162,109,15]),function(he,e,h,N,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$nc=void 0;class M{constructor(k){this.b=k,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(k,A,I,p){const y=new N.$1nc(this.b);if(A.folder.scheme===R.Schemas.vscodeUserData){const v={...A,folder:A.folder.with({scheme:R.Schemas.file})},l=new O.$dw(d=>I.report({...d,uri:d.uri.with({scheme:A.folder.scheme})}));return this.c(p,d=>y.provideTextSearchResults(k,v,l,d))}else return this.c(p,v=>y.provideTextSearchResults(k,A,I,v))}async c(k,A){const I=b(k);this.a.add(I);const p=await A(I.token);return this.a.delete(I),p}d(){this.a.forEach(k=>k.cancel())}}e.$$nc=M;function b($){const k=new h.$oe;return $.onCancellationRequested(()=>k.cancel()),k}}),define(Se[391],De([1,0,32,162,161]),function(he,e,h,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9nc=void 0;class R{constructor($){this.a=$}search($,k,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const I={appendLine(y){A({message:y})}},p=new O.$8nc(this.a,new N.$1nc(I),h);return new Promise((y,v)=>p.search(l=>{k(l.map(M))},$).then(l=>y({limitHit:l.limitHit??!1,type:"success",stats:l.stats,messages:[]}),v))}}e.$9nc=R;function M(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce(($,k)=>{if(k.ranges){const A=k;return $+(Array.isArray(A.ranges)?A.ranges.length:1)}else return $+1},0)}}}),define(Se[392],De([1,0,19,7,13,4,133,16,40,2,33,37,387,391]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0nc=void 0;class v{static{this.a=512}constructor(u="searchProcess"){this.d=u,this.b=Object.create(null)}fileSearch(u){let s;const t=o(u),c=new R.$de({onDidAddFirstListener:()=>{s=(0,N.$jh)(r=>this.doFileSearchWithEngine(p.$Znc,t,a=>c.fire(a),r)),s.then(r=>c.fire(r),r=>c.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return c.event}textSearch(u){let s;const t=o(u),c=new R.$de({onDidAddFirstListener:()=>{s=(0,N.$jh)(r=>this.f(t,a=>c.fire(a),r)),s.then(r=>c.fire(r),r=>c.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return c.event}f(u,s,t){return u.maxFileSize=this.g().maxFileSize,new y.$9nc(u).search(t,s,s)}g(){return{maxFileSize:16*A.$yl.GB}}doFileSearch(u,s,t){return this.doFileSearchWithEngine(p.$Znc,u,s,t)}doFileSearchWithEngine(u,s,t,c,r=v.a){let a=0;const f=w=>{Array.isArray(w)?(a+=w.length,t(w.map(S=>this.h(S)))):w.relativePath?(a++,t(this.h(w))):t(w)};if(s.sortByScore){let w=this.l(s,f,c);if(!w){const S=s.maxResults?Object.assign({},s,{maxResults:null}):s,m=new u(S);w=this.j(m,s,t,f,c)}return new Promise((S,m)=>{w.then(([E,D])=>{const C=D.map(P=>this.h(P));this.o(C,t,r),S(E)},m)})}const g=new u(s);return this.r(g,f,r,c).then(w=>({limitHit:w.limitHit,type:"success",stats:{detailStats:w.stats,type:this.d,fromCache:!1,resultCount:a,sortingTime:void 0},messages:[]}))}h(u){return{path:u.base?(0,b.$jc)(u.base,u.relativePath):u.relativePath}}j(u,s,t,c,r){const a=new R.$de;let f=(0,N.$jh)(w=>{let S=[];const m=E=>{Array.isArray(E)?S=E:(c(E),a.fire(E))};return this.r(u,m,-1,w).then(E=>[E,S])}),g;if(s.cacheKey){g=this.k(s.cacheKey);const w={promise:f,event:a.event,resolved:!1};g.resultsToSearchCache[s.filePattern||""]=w,f.then(()=>{w.resolved=!0},S=>{delete g.resultsToSearchCache[s.filePattern||""]}),f=this.s(f)}return f.then(([w,S])=>{const m=g?g.scorerCache:Object.create(null),E=(typeof s.maxResults!="number"||s.maxResults>0)&&$.$_d.create(!1);return this.n(s,S,m,r).then(D=>{const C=E?E.elapsed():-1;return[{type:"success",stats:{detailStats:w.stats,sortingTime:C,fromCache:!1,type:this.d,resultCount:D.length},messages:w.messages,limitHit:w.limitHit||typeof s.maxResults=="number"&&S.length>s.maxResults},D]})})}k(u){const s=this.b[u];return s||(this.b[u]=new l)}l(u,s,t){const c=u.cacheKey&&this.b[u.cacheKey];if(!c)return;const r=this.q(c,u.filePattern||"",s,t);if(r)return r.then(([a,f,g])=>{const w=$.$_d.create(!1);return this.n(u,f,c.scorerCache,t).then(S=>{const m=w.elapsed(),E={fromCache:!0,detailStats:g,type:this.d,resultCount:f.length,sortingTime:m};return[{type:"success",limitHit:a.limitHit||typeof u.maxResults=="number"&&f.length>u.maxResults,stats:E,messages:[]},S]})})}n(u,s,t,c){const r=(0,M.$xr)(u.filePattern||""),a=(g,w)=>(0,M.$wr)(g,w,r,!0,d,t),f=typeof u.maxResults=="number"?u.maxResults:Number.MAX_VALUE;return h.$Gb(s,a,f,1e4,c)}o(u,s,t){if(t&&t>0)for(let c=0;c<u.length;c+=t)s(u.slice(c,c+t));else s(u)}q(u,s,t,c){const r=$.$_d.create(!1),a=s.indexOf(b.sep)>=0;let f;for(const m in u.resultsToSearchCache)if(s.startsWith(m)){if(a&&m.indexOf(b.sep)<0&&m!=="")continue;const E=u.resultsToSearchCache[m];f={promise:this.s(E.promise),event:E.event,resolved:E.resolved};break}if(!f)return null;const g=r.elapsed(),w=$.$_d.create(!1),S=f.event(t);return c&&c.onCancellationRequested(()=>{S.dispose()}),f.promise.then(([m,E])=>{if(c&&c.isCancellationRequested)throw(0,O.$6)();const D=[],C=(0,M.$xr)(s).normalizedLowercase;for(const P of E)(0,I.$GK)(P,C)&&D.push(P);return[m,D,{cacheWasResolved:f.resolved,cacheLookupTime:g,cacheFilterTime:w.elapsed(),cacheEntryCount:E.length}]})}r(u,s,t,c){return new Promise((r,a)=>{let f=[];c?.onCancellationRequested(()=>u.cancel()),u.search(g=>{g&&(t?(f.push(g),t>0&&f.length>=t&&(s(f),f=[])):s(g))},g=>{s(g)},(g,w)=>{f.length&&s(f),g?(s({message:"Search finished. Error: "+g.message}),a(g)):(s({message:"Search finished. Stats: "+JSON.stringify(w.stats)}),r(w))})})}clearCache(u){return delete this.b[u],Promise.resolve(void 0)}s(u){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(s,t){return u.then(s,t)}catch(s){return this.then(void 0,s)}finally(s){return u.finally(s)}}}}e.$0nc=v;class l{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const d=new class{getItemLabel(i){return(0,b.$nc)(i.relativePath)}getItemDescription(i){return(0,b.$mc)(i.relativePath)}getItemPath(i){return i.relativePath}};function o(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(n),extraFileResources:i.extraFileResources&&i.extraFileResources.map(u=>k.URI.revive(u))}}function n(i){return{...i,folder:k.URI.revive(i.folder)}}}),define(Se[393],De([1,0,3,15,2,32,11,28,20,97,68,37,392,390,123,161]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_nc=void 0;let d=class extends k.$Wmc{constructor(n,i,u,s){super(n,u,s),this.w=R,this.x=-1,this.y=null,this.z=!1,this.A=new h.$Tc;const t=new v.$Unc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(N.Schemas.vscodeUserData,new y.$$nc(t))),i.remote.isRemote&&i.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const n=new v.$Unc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(N.Schemas.file,new y.$$nc(n))),this.A.add(this.C(N.Schemas.file,new p.$0nc("fileSearchProvider")))}C(n,i){const u=this.d++;return this.y=i,this.x=u,this.c.$registerFileSearchProvider(u,this.s(n)),(0,h.$Sc)(()=>{this.y=null,this.c.$unregisterProvider(u)})}$provideFileSearchResults(n,i,u,s){const t=(0,k.$Xmc)(u);if(n===this.x){const c=Date.now();return this.D(n,i,t,s).then(r=>{const a=Date.now()-c;return this.q.debug(`Ext host file search time: ${a}ms`),r})}return super.$provideFileSearchResults(n,i,u,s)}doInternalFileSearchWithCustomCallback(n,i,u){const s=t=>{if((0,I.$FK)(t)&&(t=[t]),Array.isArray(t)){u(t.map(c=>O.URI.file(c.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(n,s,i)}async D(n,i,u,s){return this.doInternalFileSearchWithCustomCallback(u,s,t=>{this.c.$handleFileMatch(n,i,t)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,i){return new l.$8nc(n,i,void 0,"textSearchProvider")}};e.$_nc=d,e.$_nc=d=He([We(0,$.$EO),We(1,b.$UO),We(2,A.$Olc),We(3,M.$3j)],d)}),define(Se[124],De([1,0,407,63,64,408,21,13,4,3,16,12,30,82,83]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$ni=e.$mi=e.$li=void 0,e.$oi=r,e.$pi=a,e.$ri=w,e.$si=S;class l{traceSocketEvent(E,D){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,D)}constructor(E,D=""){this.f=!0,this.debugLabel=D,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,b.$1)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const D=C=>{this.traceSocketEvent("read",C),E(M.$Fe.wrap(C))};return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(E){const D=C=>{E({type:0,hadError:C,error:void 0})};return this.socket.on("close",D),{dispose:()=>this.socket.off("close",D)}}onEnd(E){const D=()=>{E()};return this.socket.on("end",D),{dispose:()=>this.socket.off("end",D)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,b.$1)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,b.$1)(D)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,D)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$li=l;var d;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize",m[m.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var o;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(o||(o={}));class n extends k.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,D){this.socket.traceSocketEvent(E,D)}constructor(E,D,C,P){super(),this.f=this.B(new $.$de),this.g=this.B(new $.$de),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:D,inflateBytesLength:C?.byteLength||0,recordInflateBytes:P}),this.a=this.B(new i(this,D,C,P,this.f,(F,T)=>this.m(F,T))),this.B(this.a.onError(F=>{console.error(F),(0,b.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new v.$gi,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let D=0;for(;D<E.byteLength;)this.a.writeMessage(E.slice(D,Math.min(D+262144,E.byteLength)),{compressed:!0,opcode:2}),D+=262144}m(E,{compressed:D,opcode:C}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let P=2;E.byteLength<126?P+=0:E.byteLength<2**16?P+=2:P+=8;const F=M.$Fe.alloc(P),T=D?64:0,z=C&15;if(F.writeUInt8(128|T|z,0),E.byteLength<126)F.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){F.writeUInt8(126,1);let L=1;F.writeUInt8(E.byteLength>>>8&255,++L),F.writeUInt8(E.byteLength>>>0&255,++L)}else{F.writeUInt8(127,1);let L=1;F.writeUInt8(0,++L),F.writeUInt8(0,++L),F.writeUInt8(0,++L),F.writeUInt8(0,++L),F.writeUInt8(E.byteLength>>>24&255,++L),F.writeUInt8(E.byteLength>>>16&255,++L),F.writeUInt8(E.byteLength>>>8&255,++L),F.writeUInt8(E.byteLength>>>0&255,++L)}this.socket.write(M.$Fe.concat([F,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const D=this.b.peek(this.j.readLen),C=D.readUInt8(0),P=(C&128)>>>7,F=(C&64)>>>6,T=C&15,z=D.readUInt8(1),L=(z&128)>>>7,j=z&127;this.j.state=2,this.j.readLen=2+(L?4:0)+(j===126?2:0)+(j===127?8:0),this.j.fin=P,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!P,this.j.mask=0,this.j.opcode=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const D=this.b.read(this.j.readLen),C=D.readUInt8(1),P=(C&128)>>>7;let F=C&127,T=1;F===126?F=D.readUInt8(++T)*2**8+D.readUInt8(++T):F===127&&(F=D.readUInt8(++T)*0+D.readUInt8(++T)*0+D.readUInt8(++T)*0+D.readUInt8(++T)*0+D.readUInt8(++T)*2**24+D.readUInt8(++T)*2**16+D.readUInt8(++T)*2**8+D.readUInt8(++T));let z=0;P&&(z=D.readUInt8(++T)*2**24+D.readUInt8(++T)*2**16+D.readUInt8(++T)*2**8+D.readUInt8(++T)),this.j.state=3,this.j.readLen=F,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const D=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",D),t(D,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",D),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(D,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(D,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$mi=n;class i extends k.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:M.$Fe.alloc(0)}constructor(E,D,C,P,F,T){super(),this.n=E,this.r=F,this.s=T,this.a=this.B(new $.$de),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$de),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$de),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,D?(this.b=this.B(new u(this.n,P,C,{windowBits:15})),this.f=this.B(new s(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(E,D){this.g.push({data:E,options:D}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:D}=this.g.shift();if(this.f&&D.compressed){const C=await this.w(this.f,E);this.s(C,D)}else this.s(E,{...D,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,D){return new Promise((C,P)=>{E.write(D),E.flush(F=>C(F))})}acceptFrame(E,D,C){this.h.push({data:E,isCompressed:D,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const D=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(D)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,D,C){return new Promise((P,F)=>{E.write(D),C&&E.write(M.$Fe.fromByteArray([0,0,255,255])),E.flush(T=>P(T))})}}class u extends k.$Uc{get recordedInflateBytes(){return this.j?M.$Fe.concat(this.f):M.$Fe.alloc(0)}constructor(E,D,C,P){super(),this.h=E,this.j=D,this.a=this.B(new $.$de),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(P),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(M.$Fe.wrap(F))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent("zlibInflateWrite",E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const D=M.$Fe.concat(this.g);this.g.length=0,E(D)})}}class s extends k.$Uc{constructor(E,D){super(),this.g=E,this.a=this.B(new $.$de),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(M.$Fe.wrap(C))})}write(E){this.g.traceSocketEvent("zlibDeflateWrite",E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let D=M.$Fe.concat(this.f);this.f.length=0,D=D.slice(0,D.byteLength-4),E(D)})}}function t(m,E){if(E===0)return;const D=m.byteLength>>>2;for(let L=0;L<D;L++){const j=m.readUInt32BE(L*4);m.writeUInt32BE(j^E,L*4)}const C=D*4,P=m.byteLength-C,F=E>>>24&255,T=E>>>16&255,z=E>>>8&255;P>=1&&m.writeUInt8(m.readUInt8(C)^F,C),P>=2&&m.writeUInt8(m.readUInt8(C+1)^T,C+1),P>=3&&m.writeUInt8(m.readUInt8(C+2)^z,C+2)}e.$ni=process.env.XDG_RUNTIME_DIR;const c={2:107,1:103};function r(){const m=(0,p.$Sg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;const E=process.platform!=="darwin"&&e.$ni?e.$ni:(0,O.tmpdir)(),D=(0,A.$jc)(E,`vscode-ipc-${m}.sock`);return f(D),D}function a(m,E,D){const P=(0,h.createHash)("sha256").update(m).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${D}-${E}-sock`;const F=D.substr(0,4),T=E.substr(0,6);let z;return process.platform!=="darwin"&&e.$ni&&!process.env.VSCODE_PORTABLE?z=(0,A.$jc)(e.$ni,`vscode-${P}-${F}-${T}.sock`):z=(0,A.$jc)(m,`${F}-${T}.sock`),f(z),z}function f(m){const E=c[I.$u];typeof E=="number"&&m.length>=E&&console.warn(`WARNING: IPC handle "${m}" is longer than ${E} chars, try a shorter --user-data-dir`)}class g extends y.$ai{static b(E){const D=$.Event.fromNodeEventEmitter(E,"connection");return $.Event.map(D,C=>({protocol:new v.$hi(new l(C,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(C,"close"))}))}constructor(E){super(g.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$qi=g;function w(m){return new Promise((E,D)=>{const C=(0,N.createServer)();C.on("error",D),C.listen(m,()=>{C.removeListener("error",D),E(new g(C))})})}function S(m,E){return new Promise((D,C)=>{const P=(0,N.createConnection)(m,()=>{P.removeListener("error",C),D(v.$ii.fromSocket(new l(P,`ipc-client${E}`),E))});P.once("error",C)})}}),define(Se[394],De([1,0,63,64,178,124,7,3,12,55,11,108,272,273,111,88,21]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=e.$Zdc=e.$Ydc=e.$Xdc=void 0;async function o(t,c,r,a,f){let g;for(let w=3;w&&(g?.dispose(),g=await new n(t,c,r,a,f).waitForReady(),!(f&&O.$Vg[f]||!O.$Vg[g.tunnelLocalPort]));w--);return g}class n extends b.$Uc{constructor(c,r,a,f,g){super(),this.m=r,this.n=g,this.privacy=l.TunnelPrivacyId.Private,this.j=new Map,this.a=c,this.b=h.createServer(),this.c=new M.$vh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=w=>this.r(w),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=f,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const c=this.n??this.tunnelRemotePort,r=(0,l.$qw)(this.m)?"0.0.0.0":"127.0.0.1";let a=await(0,O.$Wg)(c,2,1e3,r),f=null;return this.b.listen(a,this.m),await this.c.wait(),f=this.b.address(),f||(a=0,this.b.listen(a,this.m),await this.c.wait(),f=this.b.address()),this.tunnelLocalPort=f.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${f.port}`,this}async r(c){c.pause();const r=(0,l.$ow)(this.tunnelRemoteHost)||(0,l.$qw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,a=await(0,p.$Sl)(this.a,r,this.tunnelRemotePort),f=a.getSocket(),g=a.readEntireBuffer();a.dispose(),g.byteLength>0&&c.write(g.buffer),c.on("end",()=>{c.localAddress&&this.j.delete(c.localAddress),f.end()}),c.on("close",()=>f.end()),c.on("error",()=>{c.localAddress&&this.j.delete(c.localAddress),f instanceof R.$li?f.socket.destroy():f.end()}),f instanceof R.$li?this.t(c,f):this.s(c,f),c.localAddress&&this.j.set(c.localAddress,()=>{c.end(),f.end()})}s(c,r){r.onClose(()=>c.destroy()),r.onEnd(()=>c.end()),r.onData(a=>c.write(a.buffer)),c.on("data",a=>r.write(d.$Fe.wrap(a))),c.resume()}t(c,r){const a=r.socket;a.on("end",()=>c.end()),a.on("close",()=>c.end()),a.on("error",()=>{c.destroy()}),a.pipe(c),c.pipe(a)}}e.$Xdc=n;let i=class extends l.$tw{constructor(c,r,a,f,g){super(r,g),this.v=c,this.w=a,this.y=f}isPortPrivileged(c){return(0,l.$rw)(c,this.m,$.OS,N.release())}t(c,r,a,f,g,w,S,m){const E=this.s(r,a);if(E)return++E.refcount,E.value;if((0,l.$kw)(c))return this.u(c,r,a,g,w,S,m);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${a} on local port ${g}.`);const D={commit:this.y.commit,quality:this.y.quality,addressProvider:c,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},C=o(D,f,r,a,g);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(r,a,C),C}}};e.$Ydc=i,e.$Ydc=i=He([We(0,y.$Ml),We(1,A.$3j),We(2,v.$Pl),We(3,I.$jk),We(4,k.$3i)],i);let u=class extends i{constructor(c,r,a,f,g){super(c,r,a,f,g)}};e.$Zdc=u,e.$Zdc=u=He([We(0,y.$Ml),We(1,A.$3j),We(2,v.$Pl),We(3,I.$jk),We(4,k.$3i)],u);let s=class extends b.$Uc{constructor(c,r,a,f,g){super(),this.b=c,this.c=r,this.f=a,this.g=f,this.h=g,this.a=new Map}async openTunnel(c,r,a,f,g,w,S,m,E){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${a}:${f} on local port ${w}.`),!this.a.has(c)){const D=new u(this.b,this.c,this.g,this.f,this.h);this.B(D),this.a.set(c,D),D.onTunnelClosed(async()=>{(await D.tunnels).length===0&&(D.dispose(),this.a.delete(c))})}return this.a.get(c).openTunnel(r,a,f,g,w,S,m,E)}};e.$1dc=s,e.$1dc=s=He([We(0,y.$Ml),We(1,A.$3j),We(2,I.$jk),We(3,v.$Pl),We(4,k.$3i)],s)}),define(Se[395],De([1,0,124,292,53,34,2,11,42]),function(he,e,h,N,O,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7O=e.$6O=void 0;class k{constructor(p,y,v){this.b=p,this.c=y,this.f=v,this.a=N.createServer((l,d)=>this.h(l,d)),this.g().catch(l=>(y.error(l),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",p=>this.c.error(p))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(p,y){const v=(d,o)=>{y.writeHead(d,{"content-type":"application/json"}),y.end(JSON.stringify(o||null),n=>n&&this.c.error(n))},l=[];p.setEncoding("utf8"),p.on("data",d=>l.push(d)),p.on("end",async()=>{try{const d=JSON.parse(l.join(""));let o;switch(d.type){case"open":o=await this.i(d);break;case"openExternal":o=await this.j(d);break;case"status":o=await this.l(d);break;case"extensionManagement":o=await this.k(d);break;default:v(404,`Unknown message type: ${d.type}`);break}v(200,o)}catch(d){const o=d instanceof Error?d.message:JSON.stringify(d);v(500,o),this.c.error("Error while processing pipe request",d)}})}async i(p){const{fileURIs:y,folderURIs:v,forceNewWindow:l,diffMode:d,mergeMode:o,addMode:n,forceReuseWindow:i,gotoLineMode:u,waitMarkerFilePath:s,remoteAuthority:t}=p,c=[];if(Array.isArray(v))for(const g of v)try{c.push({folderUri:M.URI.parse(g)})}catch{}if(Array.isArray(y))for(const g of y)try{(0,$.$2i)(g)?c.push({workspaceUri:M.URI.parse(g)}):c.push({fileUri:M.URI.parse(g)})}catch{}const r=s?M.URI.file(s):void 0,f={forceNewWindow:l,diffMode:d,mergeMode:o,addMode:n,gotoLineMode:u,forceReuseWindow:i,preferNewWindow:!i&&!r&&!n,waitMarkerFileURI:r,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",c,f)}async j(p){for(const y of p.uris){const v=M.URI.parse(y),l=v.scheme==="file"?v:y;await this.b.executeCommand("_remoteCLI.openExternal",l)}}async k(p){const y=l=>l?.map(d=>/\.vsix$/i.test(d)?M.URI.parse(d):d),v={list:p.list,install:y(p.install),uninstall:y(p.uninstall),force:p.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",v)}async l(p){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&O.existsSync(this.f)&&O.unlinkSync(this.f)}}e.$6O=k;let A=class extends k{constructor(p,y){super(p,y,(0,h.$oi)())}};e.$7O=A,e.$7O=A=He([We(0,R.$1O),We(1,b.$3j)],A)}),define(Se[396],De([1,0,59,383,378,291,49,365,2,15,8,395,104,325,364]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eoc=void 0;class l extends O.$Fnc{j(){const n=this,i=globalThis._VSCODE_NODE_MODULES.module,u=i._load;i._load=function(r,a,f){return r=t(r),n.a.has(r)?n.a.get(r).load(r,$.URI.file((0,p.$7q)(a.filename)),g=>u.apply(this,[g,a,f])):u.apply(this,arguments)};const s=i._resolveLookupPaths;i._resolveLookupPaths=(c,r)=>s.call(this,t(c),r);const t=c=>{for(const r of n.b){const a=r(c);if(a){c=a;break}}return c}}}class d extends M.$umc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async vb(){this.h.createInstance(y.$coc);const n=this.h.invokeFunction(N.$Bnc);if(this.h.createInstance(b.$boc),this.f.remote.isRemote&&this.f.remote.authority){const s=this.h.createInstance(I.$7O);process.env.VSCODE_IPC_HOOK_CLI=s.ipcHandlePath}this.h.createInstance(v.$doc),await this.h.createInstance(l,n,{mine:this.J,all:this.L}).install(),h.mark("code/extHost/didInitAPI");const u=await this.m.getConfigProvider();await(0,R.$aoc)(this.j,u,this,this.s,this.z,this.f),h.mark("code/extHost/didInitProxyResolver")}wb(n){return n.main}async xb(n,i,u){if(i.scheme!==k.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let s=null;u.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const t=n?.identifier.value;n&&await this.w.initializeLocalizedMessages(n);try{t&&h.mark(`code/extHost/willLoadExtensionCode/${t}`),s=he.__$__nodeRequire(i.fsPath)}finally{t&&h.mark(`code/extHost/didLoadExtensionCode/${t}`),u.codeLoadingStop()}return s}async $setRemoteEnvironment(n){if(this.f.remote.isRemote)for(const i in n){const u=n[i];u===null?delete process.env[i]:process.env[i]=u}}}e.$eoc=d}),define(Se[397],De([1,0,54,21,4,3,126,12,23,2,32,11,271,67,111,88,394,28,20,71,372]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d,o,n,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$moc=void 0,e.$foc=s,e.$goc=t,e.$hoc=c,e.$ioc=r,e.$joc=f,e.$koc=g,e.$loc=w;function s(E){const D=E.trim().split(`
`),C=[];return D.forEach(F=>{const T=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(F);T&&T.length>=3&&C.push({pid:parseInt(T[1],10),socket:parseInt(T[2],10)})}),C.reduce((F,T)=>(F[T.socket]=T,F),{})}function t(...E){const D=[].concat(...E.map(r));return[...new Map(D.filter(C=>C.st==="0A").map(C=>{const P=C.local_address.split(":");return{socket:parseInt(C.inode,10),ip:c(P[0]),port:parseInt(P[1],16)}}).map(C=>[C.ip+":"+C.port,C])).values()]}function c(E){let D="";if(E.length===8)for(let C=E.length-2;C>=0;C-=2)D+=parseInt(E.substr(C,2),16),C!==0&&(D+=".");else for(let C=0;C<E.length;C+=8){const P=E.substring(C,C+8);let F="";for(let T=8;T>=2;T-=2)F+=P.substring(T-2,T),(T===6||T===2)&&(F=parseInt(F,16).toString(16),D+=`${F}`,F="",C+T!==E.length-6&&(D+=":"))}return D}function r(E){const D=E.trim().split(`
`),C=D.shift().trim().split(/\s+/).filter(F=>F!=="rx_queue"&&F!=="tm->when");return D.map(F=>F.trim().split(/\s+/).reduce((T,z,L)=>(T[C[L]||L]=z,T),{}))}function a(E){return!!E.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||E.indexOf("out/server-main.js")!==-1||E.indexOf("_productName=VSCode")!==-1}function f(E){const D=E.trim().split(`
`),C=[];return D.forEach(P=>{const F=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(P);F&&F.length>=4&&C.push({pid:parseInt(F[1],10),ppid:parseInt(F[2]),cmd:F[3]})}),C}async function g(E,D,C){const P=C.reduce((T,z)=>(T[z.pid]=z,T),{}),F=[];return E.forEach(({socket:T,ip:z,port:L})=>{const j=D[T]?D[T].pid:void 0,U=j?P[j]?.cmd:void 0;j&&U&&!a(U)&&F.push({host:z,port:L,detail:U,pid:j})}),F}function w(E,D,C){const P=new Map,F=f(D);for(const T of E){const z=C.get(T.port);if(z){P.set(T.port,z);continue}const L=F.find(j=>j.cmd.includes(`${T.port}`));if(L){let j=L,U;do U=F.find(X=>X.ppid===j.pid),U&&(j=U);while(U);P.set(T.port,{host:T.ip,port:T.port,pid:j.pid,detail:j.cmd,ppid:j.ppid})}else P.set(T.port,{host:T.ip,port:T.port,ppid:Number.MAX_VALUE})}return P}let S=class extends i.$DDb{constructor(D,C,P,F){super(D,C,P),this.D=C,this.F=F,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&C.remote.isRemote&&C.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(D){if(D&&this.C)return;this.C=D;let C;this.y&&(C=this.y,await this.a.$onFoundNewCandidates(this.y));const P=new M.$Em;let F=0;for(;this.C;){const T=new Date().getTime(),z=(await this.I()).filter(U=>(0,l.$ow)(U.host)||(0,l.$qw)(U.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(U=>U.port).join(", ")}`);const L=new Date().getTime()-T;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${L} ms.`),F++>3&&P.update(L),(!C||JSON.stringify(C)!==JSON.stringify(z))&&(C=z,await this.a.$onFoundNewCandidates(C));const j=this.G(P.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${j} ms.`),await new Promise(U=>setTimeout(()=>U(),j))}}G(D){return Math.max(D*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(D=>D.port).join(", ")}`)}async I(){let D="",C="";try{D=await A.Promises.readFile("/proc/net/tcp","utf8"),C=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const P=t(D,C),F=await new Promise(q=>{(0,h.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(G,x,ne)=>{q(x)})}),T=s(F),z=await A.Promises.readdir("/proc"),L=[];for(const q of z)try{const G=Number(q),x=$.$0g(k.URI.file("/proc"),q);if((await A.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(G)){const be=await A.Promises.readlink($.$0g(x,"cwd").fsPath),ae=await A.Promises.readFile($.$0g(x,"cmdline").fsPath,"utf8");L.push({pid:G,cwd:be,cmd:ae})}}catch{}const j=[],U=P.filter(q=>{const G=T[q.socket];return G||j.push(q),G}),X=g(U,T,L);let ie;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${j.length}`),j.length>0){const q=await new Promise(G=>{(0,h.exec)("ps -F -A -l | grep root",(x,ne,be)=>{G(ne)})});this.z=w(j,q,this.z),ie=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ie.map(G=>G.port).join(", ")}`)}return X.then(q=>ie?q.concat(ie):q)}w(D){return async C=>{const P=new d.$Xdc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(T,z,L,j){const U=await D.makeConnection();return m.connect(U,z,L,j)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new y.$Il(0),connectionToken:D.connectionToken})}},signService:this.F},"localhost",C.remoteAddress.host||"localhost",C.remoteAddress.port,C.localAddressPort);await P.waitForReady();const F=new O.$de;return{localAddress:(0,u.$DL)(P.localAddress)??P.localAddress,remoteAddress:{port:P.tunnelRemotePort,host:P.tunnelRemoteHost},onDidDispose:F.event,dispose:()=>{P.dispose(),F.fire(),F.dispose()}}}}};e.$moc=S,e.$moc=S=He([We(0,n.$EO),We(1,o.$UO),We(2,I.$3j),We(3,v.$Pl)],S);class m extends p.$xvb{static connect(D,C,P,F){const T=new R.$Tc,z={onClose:T.add(new O.$de),onData:T.add(new O.$de),onEnd:T.add(new O.$de)};T.add(D.onDidReceiveMessage(j=>z.onData.fire(N.$Fe.wrap(j)))),T.add(D.onDidEnd(()=>z.onEnd.fire())),T.add(D.onDidClose(j=>z.onClose.fire({type:0,error:j,hadError:!!j})));const L=new m(D,F,z);return L.B(T),(0,p.$wvb)(L,C,P,F,z)}constructor(D,C,P){super(C,P),this.n=D}write(D){this.n.send(D.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Se[398],De([1,0,85,367,381,380,393,396,397,96,49,97,95,43,71,93,366,326,11,382,61,286,106,111,141]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d,o,n,i,u,s,t,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.$xs)(A.$vmc,b.$eoc,0),(0,h.$xs)(n.$4j,o.$ooc,1),(0,h.$xs)(n.$3j,new t.$ti(s.$Enc,[!1],!0)),(0,h.$xs)(c.$Pl,r.$3dc,1),(0,h.$xs)(l.$Xlc,d.$noc,0),(0,h.$xs)(k.$Amc,R.$Rnc,0),(0,h.$xs)(I.$Vmc,M.$_nc,0),(0,h.$xs)(p.$lnc,O.$Jnc,0),(0,h.$xs)(y.$gmc,N.$Inc,0),(0,h.$xs)(v.$CDb,$.$moc,0),(0,h.$xs)(u.$ymc,i.$poc,0)}),define(Se[409],De([1,0,63,410,59,13,83,124,269,115,379,21,32,104,7,136,293,309,384,398]),function(he,e,h,N,O,R,M,b,$,k,A,I,p,y,v,l,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let w=0;w<process.execArgv.length;w++)process.execArgv[w]==="--inspect-port=0"&&(process.execArgv.splice(w,1),w--)}();const n=N(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const g=globalThis._VSCODE_NODE_MODULES.module,w=g._load;g._load=function(S){if(S==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return w.apply(this,arguments)}})();const i=process.exit.bind(process),u=process.on.bind(process);function s(g){process.exit=function(w){if(g)i(w);else{const S=new Error("An extension called process.exit() and this was prevented.");console.warn(S.stack)}},process.crash=function(){const w=new Error("An extension called process.crash() and this was prevented.");console.warn(w.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(w,S){w==="uncaughtException"&&(S=function(){try{return S.call(void 0,arguments)}catch{}}),u(w,S)}}let t=function(g){i()};function c(){const g=(0,o.$on)(process.env);if(g.type===3)return new Promise((w,S)=>{const m=E=>{const D=E[0],C=new M.$ji;D.on("message",P=>C.fire(I.$Fe.wrap(P.data))),D.on("close",()=>{t("renderer closed the MessagePort")}),D.start(),w({onMessage:C.event,send:P=>D.postMessage(P.buffer)})};process.parentPort.on("message",E=>m(E.ports))});if(g.type===2)return new Promise((w,S)=>{let m=null;const E=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),D=108e5,C=3e5,P=new v.$Jh(()=>t("renderer disconnected for too long (1)"),D),F=new v.$Jh(()=>t("renderer disconnected for too long (2)"),C);process.on("message",(z,L)=>{if(z&&z.type==="VSCODE_EXTHOST_IPC_SOCKET"){L.setNoDelay(!0);const j=I.$Fe.wrap(Buffer.from(z.initialDataChunk,"base64"));let U;if(z.skipWebSocketFrames)U=new b.$li(L,"extHost-socket");else{const X=I.$Fe.wrap(Buffer.from(z.inflateBytes,"base64"));U=new b.$mi(new b.$li(L,"extHost-socket"),z.permessageDeflate,X,!1)}m?(P.cancel(),F.cancel(),m.beginAcceptReconnection(U,j),m.endAcceptReconnection(),m.sendResume()):(clearTimeout(E),m=new M.$ki({socket:U,initialChunk:j}),m.sendResume(),m.onDidDispose(()=>t("renderer disconnected")),w(m),m.onSocketClose(()=>{P.schedule()}))}if(z&&z.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(F.isScheduled())return;P.isScheduled()&&F.schedule()}});const T={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(T)});{const w=g.pipeName;return new Promise((S,m)=>{const E=h.createConnection(w,()=>{E.removeListener("error",m);const D=new M.$ki({socket:new b.$li(E,"extHost-renderer")});D.sendResume(),S(D)});E.once("error",m),E.on("close",()=>{t("renderer closed the socket")})})}}async function r(){const g=await c();return new class{constructor(){this.a=new M.$ji,this.onMessage=this.a.event,this.b=!1,g.onMessage(w=>{(0,k.$1m)(w,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(w)})}send(w){this.b||g.send(w)}async drain(){if(g.drain)return g.drain()}}}function a(g){return new Promise(w=>{const S=g.onMessage(m=>{S.dispose();const E=JSON.parse(m.toString()),D=E.commit,C=$.default.commit;if(D&&C&&D!==C&&i(55),E.parentPid){let P=0;setInterval(function(){try{process.kill(E.parentPid,0),P=0}catch(T){T&&T.code==="EPERM"?(P++,P>=3&&t(`parent process ${E.parentPid} does not exist anymore (3 x EPERM): ${T.message} (code: ${T.code}) (errno: ${T.errno})`)):t(`parent process ${E.parentPid} does not exist anymore: ${T.message} (code: ${T.code}) (errno: ${T.errno})`)}},1e3);let F;try{F=globalThis._VSCODE_NODE_MODULES["native-watchdog"],F.start(E.parentPid)}catch(T){(0,R.$1)(T)}}g.send((0,k.$Zm)(0)),w({protocol:g,initData:E})});g.send((0,k.$Zm)(1))})}async function f(){const g=[];process.on("unhandledRejection",(P,F)=>{g.push(F),setTimeout(()=>{const T=g.indexOf(F);T>=0&&F.catch(z=>{g.splice(T,1),(0,R.$4)(z)||(console.warn(`rejected promise not handled within 1 second: ${z}`),z&&z.stack&&console.warn(`stack trace: ${z.stack}`),P&&(0,R.$1)(P))})},1e3)}),process.on("rejectionHandled",P=>{const F=g.indexOf(P);F>=0&&g.splice(F,1)}),process.on("uncaughtException",function(P){(0,R.$Z)(P)||(0,R.$1)(P)}),O.mark("code/extHost/willConnectToRenderer");const w=await r();O.mark("code/extHost/didConnectToRenderer");const S=await a(w);O.mark("code/extHost/didWaitForInitData");const{initData:m}=S;s(!!m.environment.extensionTestsLocationURI),m.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,m.environment.skipWorkspaceStorageLock=(0,l.boolean)(n.skipWorkspaceStorageLock,!1);const E=new class{constructor(){this.pid=process.pid}exit(F){i(F)}fsExists(F){return p.Promises.exists(F)}fsRealpath(F){return(0,y.$6q)(F)}};let D=null;m.remote.authority&&n.transformURIs&&(D=(0,d.$Bs)(m.remote.authority));const C=new A.$Hnc(S.protocol,m,E,D);t=P=>C.terminate(P)}f().catch(g=>console.log(g))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ccba2fc85c14bedeef5a72b7ebc0bde9b0e91948/core/vs/workbench/api/node/extensionHostProcess.js.map
