/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/registry/common/platform","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/base/common/severity","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/base/common/marshalling","vs/platform/configuration/common/configuration","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ie=function(he){for(var e=[],P=0,O=he.length;P<O;P++)e[P]=Se[he[P]];return e};define(Se[69],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=O,e.$2h=M,e.$3h=N;function P(A){return($,m,E)=>{let T=null,S=null;if(typeof E.value=="function"?(T="value",S=E.value):typeof E.get=="function"&&(T="get",S=E.get),!S)throw new Error("not supported");E[T]=A(S,m)}}function O(A,$,m){let E=null,T=null;if(typeof m.value=="function"?(E="value",T=m.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(E="get",T=m.get),!T)throw new Error("not supported");const S=`$memoize$${$}`;m[E]=function(...l){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,l)}),this[S]}}function M(A,$,m){return P((E,T)=>{const S=`$debounce$${T}`,l=`$debounce$result$${T}`;return function(...b){this[l]||(this[l]=m?m():void 0),clearTimeout(this[S]),$&&(this[l]=$(this[l],...b),b=[this[l]]),this[S]=setTimeout(()=>{E.apply(this,b),this[l]=m?m():void 0},A)}})}function N(A,$,m){return P((E,T)=>{const S=`$throttle$timer$${T}`,l=`$throttle$result$${T}`,b=`$throttle$lastRun$${T}`,g=`$throttle$pending$${T}`;return function(...r){if(this[l]||(this[l]=m?m():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),$&&(this[l]=$(this[l],...r)),this[g])return;const s=this[b]+A;s<=Date.now()?(this[b]=Date.now(),E.apply(this,[this[l]]),this[l]=m?m():void 0):(this[g]=!0,this[S]=setTimeout(()=>{this[g]=!1,this[b]=Date.now(),E.apply(this,[this[l]]),this[l]=m?m():void 0},s-Date.now()))}})}}),define(Se[125],Ie([1,0,18]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=M,e.$8c=N,e.$9c=A,e.$0c=$,e.$$c=m,e.$_c=E;const O=(b,g)=>b===g;e.$6c=O;function M(b=e.$6c){return(g,r)=>P.$ub(g,r,b)}function N(){return(b,g)=>JSON.stringify(b)===JSON.stringify(g)}function A(){return(b,g)=>b.equals(g)}function $(b,g,r){return!b||!g?b===g:r(b,g)}function m(b,g){if(b===g)return!0;if(Array.isArray(b)&&Array.isArray(g)){if(b.length!==g.length)return!1;for(let r=0;r<b.length;r++)if(!m(b[r],g[r]))return!1;return!0}if(b&&typeof b=="object"&&g&&typeof g=="object"&&Object.getPrototypeOf(b)===Object.prototype&&Object.getPrototypeOf(g)===Object.prototype){const r=b,s=g,o=Object.keys(r),n=Object.keys(s),i=new Set(n);if(o.length!==n.length)return!1;for(const c of o)if(!i.has(c)||!m(r[c],s[c]))return!1;return!0}return!1}function E(b){return JSON.stringify(l(b))}let T=0;const S=new WeakMap;function l(b){if(Array.isArray(b))return b.map(l);if(b&&typeof b=="object")if(Object.getPrototypeOf(b)===Object.prototype){const g=b,r=Object.create(null);for(const s of Object.keys(g).sort())r[s]=l(g[s]);return r}else{let g=S.get(b);return g===void 0&&(g=T++,S.set(b,g)),g+"----2b76a038c20c4bcc"}return b}}),define(Se[91],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KO=e.$JO=void 0;class P{constructor(M){this.a=M,this.b=0}nextId(){return this.a+ ++this.b}}e.$JO=P,e.$KO=new P("id#")}),define(Se[126],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Hn=A,e.$In=S,e.$Jn=l,e.$Kn=b,e.$Ln=g,e.$Mn=r,e.$Nn=s,e.$On=o,e.$Pn=n,e.$Qn=i,e.$Rn=c,e.$Sn=u;var P;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var M;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(M||(e.ParseErrorCode=M={}));var N;(function(t){t.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function A(t,d=!1){let a=0;const f=t.length;let w="",p=0,v=16,y=0;function h(q){let R=0,B=0;for(;R<q;){const K=t.charCodeAt(a);if(K>=48&&K<=57)B=B*16+K-48;else if(K>=65&&K<=70)B=B*16+K-65+10;else if(K>=97&&K<=102)B=B*16+K-97+10;else break;a++,R++}return R<q&&(B=-1),B}function D(q){a=q,w="",p=0,v=16,y=0}function k(){const q=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&E(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&E(t.charCodeAt(a)))for(a++;a<t.length&&E(t.charCodeAt(a));)a++;else return y=3,t.substring(q,a);let R=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&E(t.charCodeAt(a))){for(a++;a<t.length&&E(t.charCodeAt(a));)a++;R=a}else y=3;return t.substring(q,R)}function C(){let q="",R=a;for(;;){if(a>=f){q+=t.substring(R,a),y=2;break}const B=t.charCodeAt(a);if(B===34){q+=t.substring(R,a),a++;break}if(B===92){if(q+=t.substring(R,a),a++,a>=f){y=2;break}switch(t.charCodeAt(a++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const ie=h(4);ie>=0?q+=String.fromCharCode(ie):y=4;break}default:y=5}R=a;continue}if(B>=0&&B<=31)if(m(B)){q+=t.substring(R,a),y=2;break}else y=6;a++}return q}function I(){if(w="",y=0,p=a,a>=f)return p=f,v=17;let q=t.charCodeAt(a);if($(q)){do a++,w+=String.fromCharCode(q),q=t.charCodeAt(a);while($(q));return v=15}if(m(q))return a++,w+=String.fromCharCode(q),q===13&&t.charCodeAt(a)===10&&(a++,w+=`
`),v=14;switch(q){case 123:return a++,v=1;case 125:return a++,v=2;case 91:return a++,v=3;case 93:return a++,v=4;case 58:return a++,v=6;case 44:return a++,v=5;case 34:return a++,w=C(),v=10;case 47:{const R=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<f&&!m(t.charCodeAt(a));)a++;return w=t.substring(R,a),v=12}if(t.charCodeAt(a+1)===42){a+=2;const B=f-1;let K=!1;for(;a<B;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,K=!0;break}a++}return K||(a++,y=1),w=t.substring(R,a),v=13}return w+=String.fromCharCode(q),a++,v=16}case 45:if(w+=String.fromCharCode(q),a++,a===f||!E(t.charCodeAt(a)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return w+=k(),v=11;default:for(;a<f&&W(q);)a++,q=t.charCodeAt(a);if(p!==a){switch(w=t.substring(p,a),w){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return w+=String.fromCharCode(q),a++,v=16}}function W(q){if($(q)||m(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let q;do q=I();while(q>=12&&q<=15);return q}return{setPosition:D,getPosition:()=>a,scan:d?V:I,getToken:()=>v,getTokenValue:()=>w,getTokenOffset:()=>p,getTokenLength:()=>a-p,getTokenError:()=>y}}function $(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function m(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function S(t,d){const a=[],f=new Object;let w;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function y(h,D,k,C){p.value=h,p.offset=D,p.length=k,p.type=C,p.colonOffset=void 0,w=p}try{i(t,{onObjectBegin:(h,D)=>{if(d<=h)throw f;w=void 0,v=d>h,a.push("")},onObjectProperty:(h,D,k)=>{if(d<D||(y(h,D,k,"property"),a[a.length-1]=h,d<=D+k))throw f},onObjectEnd:(h,D)=>{if(d<=h)throw f;w=void 0,a.pop()},onArrayBegin:(h,D)=>{if(d<=h)throw f;w=void 0,a.push(0)},onArrayEnd:(h,D)=>{if(d<=h)throw f;w=void 0,a.pop()},onLiteralValue:(h,D,k)=>{if(d<D||(y(h,D,k,u(h)),d<=D+k))throw f},onSeparator:(h,D,k)=>{if(d<=D)throw f;if(h===":"&&w&&w.type==="property")w.colonOffset=D,v=!1,w=void 0;else if(h===","){const C=a[a.length-1];typeof C=="number"?a[a.length-1]=C+1:(v=!0,a[a.length-1]=""),w=void 0}}})}catch(h){if(h!==f)throw h}return{path:a,previousNode:w,isAtPropertyKey:v,matches:h=>{let D=0;for(let k=0;D<h.length&&k<a.length;k++)if(h[D]===a[k]||h[D]==="*")D++;else if(h[D]!=="**")return!1;return D===h.length}}}function l(t,d=[],a=N.DEFAULT){let f=null,w=[];const p=[];function v(h){Array.isArray(w)?w.push(h):f!==null&&(w[f]=h)}return i(t,{onObjectBegin:()=>{const h={};v(h),p.push(w),w=h,f=null},onObjectProperty:h=>{f=h},onObjectEnd:()=>{w=p.pop()},onArrayBegin:()=>{const h=[];v(h),p.push(w),w=h,f=null},onArrayEnd:()=>{w=p.pop()},onLiteralValue:v,onError:(h,D,k)=>{d.push({error:h,offset:D,length:k})}},a),w[0]}function b(t,d=[],a=N.DEFAULT){let f={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(h){f.type==="property"&&(f.length=h-f.offset,f=f.parent)}function p(h){return f.children.push(h),h}i(t,{onObjectBegin:h=>{f=p({type:"object",offset:h,length:-1,parent:f,children:[]})},onObjectProperty:(h,D,k)=>{f=p({type:"property",offset:D,length:-1,parent:f,children:[]}),f.children.push({type:"string",value:h,offset:D,length:k,parent:f})},onObjectEnd:(h,D)=>{f.length=h+D-f.offset,f=f.parent,w(h+D)},onArrayBegin:(h,D)=>{f=p({type:"array",offset:h,length:-1,parent:f,children:[]})},onArrayEnd:(h,D)=>{f.length=h+D-f.offset,f=f.parent,w(h+D)},onLiteralValue:(h,D,k)=>{p({type:u(h),offset:D,length:k,parent:f,value:h}),w(D+k)},onSeparator:(h,D,k)=>{f.type==="property"&&(h===":"?f.colonOffset=D:h===","&&w(D))},onError:(h,D,k)=>{d.push({error:h,offset:D,length:k})}},a);const y=f.children[0];return y&&delete y.parent,y}function g(t,d){if(!t)return;let a=t;for(const f of d)if(typeof f=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let w=!1;for(const p of a.children)if(Array.isArray(p.children)&&p.children[0].value===f){a=p.children[1],w=!0;break}if(!w)return}else{const w=f;if(a.type!=="array"||w<0||!Array.isArray(a.children)||w>=a.children.length)return;a=a.children[w]}return a}function r(t){if(!t.parent||!t.parent.children)return[];const d=r(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;d.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&d.push(a)}return d}function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const d=Object.create(null);for(const a of t.children){const f=a.children[1];f&&(d[a.children[0].value]=s(f))}return d}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function o(t,d,a=!1){return d>=t.offset&&d<t.offset+t.length||a&&d===t.offset+t.length}function n(t,d,a=!1){if(o(t,d,a)){const f=t.children;if(Array.isArray(f))for(let w=0;w<f.length&&f[w].offset<=d;w++){const p=n(f[w],d,a);if(p)return p}return t}}function i(t,d,a=N.DEFAULT){const f=A(t,!1);function w(Ne){return Ne?()=>Ne(f.getTokenOffset(),f.getTokenLength()):()=>!0}function p(Ne){return Ne?ae=>Ne(ae,f.getTokenOffset(),f.getTokenLength()):()=>!0}const v=w(d.onObjectBegin),y=p(d.onObjectProperty),h=w(d.onObjectEnd),D=w(d.onArrayBegin),k=w(d.onArrayEnd),C=p(d.onLiteralValue),I=p(d.onSeparator),W=w(d.onComment),V=p(d.onError),q=a&&a.disallowComments,R=a&&a.allowTrailingComma;function B(){for(;;){const Ne=f.scan();switch(f.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:q||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(Ne){case 12:case 13:q?K(10):W();break;case 16:K(1);break;case 15:case 14:break;default:return Ne}}}function K(Ne,ae=[],Re=[]){if(V(Ne),ae.length+Re.length>0){let ne=f.getToken();for(;ne!==17;){if(ae.indexOf(ne)!==-1){B();break}else if(Re.indexOf(ne)!==-1)break;ne=B()}}}function ie(Ne){const ae=f.getTokenValue();return Ne?C(ae):y(ae),B(),!0}function ce(){switch(f.getToken()){case 11:{let Ne=0;try{Ne=JSON.parse(f.getTokenValue()),typeof Ne!="number"&&(K(2),Ne=0)}catch{K(2)}C(Ne);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return B(),!0}function ve(){return f.getToken()!==10?(K(3,[],[2,5]),!1):(ie(!1),f.getToken()===6?(I(":"),B(),pe()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function ke(){v(),B();let Ne=!1;for(;f.getToken()!==2&&f.getToken()!==17;){if(f.getToken()===5){if(Ne||K(4,[],[]),I(","),B(),f.getToken()===2&&R)break}else Ne&&K(6,[],[]);ve()||K(4,[],[2,5]),Ne=!0}return h(),f.getToken()!==2?K(7,[2],[]):B(),!0}function fe(){D(),B();let Ne=!1;for(;f.getToken()!==4&&f.getToken()!==17;){if(f.getToken()===5){if(Ne||K(4,[],[]),I(","),B(),f.getToken()===4&&R)break}else Ne&&K(6,[],[]);pe()||K(4,[],[4,5]),Ne=!0}return k(),f.getToken()!==4?K(8,[4],[]):B(),!0}function pe(){switch(f.getToken()){case 3:return fe();case 1:return ke();case 10:return ie(!0);default:return ce()}}return B(),f.getToken()===17?a.allowEmptyContent?!0:(K(4,[],[]),!1):pe()?(f.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}function c(t,d){const a=A(t),f=[];let w,p=0,v;do switch(v=a.getPosition(),w=a.scan(),w){case 12:case 13:case 17:p!==v&&f.push(t.substring(p,v)),d!==void 0&&f.push(a.getTokenValue().replace(/[^\r\n]/g,d)),p=a.getPosition();break}while(w!==17);return f.join("")}function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(he,e){typeof define=="function"&&define.amd?define(Se[127],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(he=typeof globalThis<"u"?globalThis:he||self,e(he.marked={}))}(this,function(he){"use strict";function e(De,we){for(var ge=0;ge<we.length;ge++){var Q=we[ge];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(De,Q.key,Q)}}function P(De,we,ge){return we&&e(De.prototype,we),ge&&e(De,ge),Object.defineProperty(De,"prototype",{writable:!1}),De}function O(De,we){if(De){if(typeof De=="string")return M(De,we);var ge=Object.prototype.toString.call(De).slice(8,-1);if(ge==="Object"&&De.constructor&&(ge=De.constructor.name),ge==="Map"||ge==="Set")return Array.from(De);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return M(De,we)}}function M(De,we){(we==null||we>De.length)&&(we=De.length);for(var ge=0,Q=new Array(we);ge<we;ge++)Q[ge]=De[ge];return Q}function N(De,we){var ge=typeof Symbol<"u"&&De[Symbol.iterator]||De["@@iterator"];if(ge)return(ge=ge.call(De)).next.bind(ge);if(Array.isArray(De)||(ge=O(De))||we&&De&&typeof De.length=="number"){ge&&(De=ge);var Q=0;return function(){return Q>=De.length?{done:!0}:{done:!1,value:De[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}he.defaults=A();function $(De){he.defaults=De}var m=/[&<>"']/,E=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(we){return l[we]};function g(De,we){if(we){if(m.test(De))return De.replace(E,b)}else if(T.test(De))return De.replace(S,b);return De}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(De){return De.replace(r,function(we,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var o=/(^|[^\[])\^/g;function n(De,we){De=typeof De=="string"?De:De.source,we=we||"";var ge={replace:function(Y,le){return le=le.source||le,le=le.replace(o,"$1"),De=De.replace(Y,le),ge},getRegex:function(){return new RegExp(De,we)}};return ge}var i=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(De,we,ge){if(De){var Q;try{Q=decodeURIComponent(s(ge)).replace(i,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}we&&!c.test(ge)&&(ge=w(we,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var t={},d=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,f=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(De,we){t[" "+De]||(d.test(De)?t[" "+De]=De+"/":t[" "+De]=h(De,"/",!0)),De=t[" "+De];var ge=De.indexOf(":")===-1;return we.substring(0,2)==="//"?ge?we:De.replace(a,"$1")+we:we.charAt(0)==="/"?ge?we:De.replace(f,"$1")+we:De+we}var p={exec:function(){}};function v(De){for(var we=1,ge,Q;we<arguments.length;we++){ge=arguments[we];for(Q in ge)Object.prototype.hasOwnProperty.call(ge,Q)&&(De[Q]=ge[Q])}return De}function y(De,we){var ge=De.replace(/\|/g,function(le,ue,Oe){for(var de=!1,Ce=ue;--Ce>=0&&Oe[Ce]==="\\";)de=!de;return de?"|":" |"}),Q=ge.split(/ \|/),Y=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>we)Q.splice(we);else for(;Q.length<we;)Q.push("");for(;Y<Q.length;Y++)Q[Y]=Q[Y].trim().replace(/\\\|/g,"|");return Q}function h(De,we,ge){var Q=De.length;if(Q===0)return"";for(var Y=0;Y<Q;){var le=De.charAt(Q-Y-1);if(le===we&&!ge)Y++;else if(le!==we&&ge)Y++;else break}return De.slice(0,Q-Y)}function D(De,we){if(De.indexOf(we[1])===-1)return-1;for(var ge=De.length,Q=0,Y=0;Y<ge;Y++)if(De[Y]==="\\")Y++;else if(De[Y]===we[0])Q++;else if(De[Y]===we[1]&&(Q--,Q<0))return Y;return-1}function k(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(De,we){if(we<1)return"";for(var ge="";we>1;)we&1&&(ge+=De),we>>=1,De+=De;return ge+De}function I(De,we,ge,Q){var Y=we.href,le=we.title?g(we.title):null,ue=De[1].replace(/\\([\[\]])/g,"$1");if(De[0].charAt(0)!=="!"){Q.state.inLink=!0;var Oe={type:"link",raw:ge,href:Y,title:le,text:ue,tokens:Q.inlineTokens(ue)};return Q.state.inLink=!1,Oe}return{type:"image",raw:ge,href:Y,title:le,text:g(ue)}}function W(De,we){var ge=De.match(/^(\s+)(?:```)/);if(ge===null)return we;var Q=ge[1];return we.split(`
`).map(function(Y){var le=Y.match(/^\s+/);if(le===null)return Y;var ue=le[0];return ue.length>=Q.length?Y.slice(Q.length):Y}).join(`
`)}var V=function(){function De(ge){this.options=ge||he.defaults}var we=De.prototype;return we.space=function(Q){var Y=this.rules.block.newline.exec(Q);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},we.code=function(Q){var Y=this.rules.block.code.exec(Q);if(Y){var le=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?le:h(le,`
`)}}},we.fences=function(Q){var Y=this.rules.block.fences.exec(Q);if(Y){var le=Y[0],ue=W(le,Y[3]||"");return{type:"code",raw:le,lang:Y[2]?Y[2].trim():Y[2],text:ue}}},we.heading=function(Q){var Y=this.rules.block.heading.exec(Q);if(Y){var le=Y[2].trim();if(/#$/.test(le)){var ue=h(le,"#");(this.options.pedantic||!ue||/ $/.test(ue))&&(le=ue.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:le,tokens:this.lexer.inline(le)}}},we.hr=function(Q){var Y=this.rules.block.hr.exec(Q);if(Y)return{type:"hr",raw:Y[0]}},we.blockquote=function(Q){var Y=this.rules.block.blockquote.exec(Q);if(Y){var le=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(le,[]),text:le}}},we.list=function(Q){var Y=this.rules.block.list.exec(Q);if(Y){var le,ue,Oe,de,Ce,Me,je,U,F,G,H,ee,re=Y[1].trim(),Ae=re.length>1,Be={type:"list",raw:"",ordered:Ae,start:Ae?+re.slice(0,-1):"",loose:!1,items:[]};re=Ae?"\\d{1,9}\\"+re.slice(-1):"\\"+re,this.options.pedantic&&(re=Ae?re:"[*+-]");for(var qe=new RegExp("^( {0,3}"+re+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(ee=!1,!(!(Y=qe.exec(Q))||this.rules.block.hr.test(Q)));){if(le=Y[0],Q=Q.substring(le.length),U=Y[2].split(`
`,1)[0],F=Q.split(`
`,1)[0],this.options.pedantic?(de=2,H=U.trimLeft()):(de=Y[2].search(/[^ ]/),de=de>4?1:de,H=U.slice(de),de+=Y[1].length),Me=!1,!U&&/^ *$/.test(F)&&(le+=F+`
`,Q=Q.substring(F.length+1),ee=!0),!ee)for(var et=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,de-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),_e=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,de-1)+"}#");Q&&(G=Q.split(`
`,1)[0],U=G,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(_e.test(U)||tt.test(U)||et.test(U)||xe.test(Q)));){if(U.search(/[^ ]/)>=de||!U.trim())H+=`
`+U.slice(de);else if(!Me)H+=`
`+U;else break;!Me&&!U.trim()&&(Me=!0),le+=G+`
`,Q=Q.substring(G.length+1)}Be.loose||(je?Be.loose=!0:/\n *\n *$/.test(le)&&(je=!0)),this.options.gfm&&(ue=/^\[[ xX]\] /.exec(H),ue&&(Oe=ue[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:le,task:!!ue,checked:Oe,loose:!1,text:H}),Be.raw+=le}Be.items[Be.items.length-1].raw=le.trimRight(),Be.items[Be.items.length-1].text=H.trimRight(),Be.raw=Be.raw.trimRight();var rt=Be.items.length;for(Ce=0;Ce<rt;Ce++){this.lexer.state.top=!1,Be.items[Ce].tokens=this.lexer.blockTokens(Be.items[Ce].text,[]);var ct=Be.items[Ce].tokens.filter(function(Ue){return Ue.type==="space"}),ft=ct.every(function(Ue){for(var ot=Ue.raw.split(""),X=0,Z=N(ot),$e;!($e=Z()).done;){var me=$e.value;if(me===`
`&&(X+=1),X>1)return!0}return!1});!Be.loose&&ct.length&&ft&&(Be.loose=!0,Be.items[Ce].loose=!0)}return Be}},we.html=function(Q){var Y=this.rules.block.html.exec(Q);if(Y){var le={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var ue=this.options.sanitizer?this.options.sanitizer(Y[0]):g(Y[0]);le.type="paragraph",le.text=ue,le.tokens=this.lexer.inline(ue)}return le}},we.def=function(Q){var Y=this.rules.block.def.exec(Q);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var le=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:le,raw:Y[0],href:Y[2],title:Y[3]}}},we.table=function(Q){var Y=this.rules.block.table.exec(Q);if(Y){var le={type:"table",header:y(Y[1]).map(function(je){return{text:je}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=Y[0];var ue=le.align.length,Oe,de,Ce,Me;for(Oe=0;Oe<ue;Oe++)/^ *-+: *$/.test(le.align[Oe])?le.align[Oe]="right":/^ *:-+: *$/.test(le.align[Oe])?le.align[Oe]="center":/^ *:-+ *$/.test(le.align[Oe])?le.align[Oe]="left":le.align[Oe]=null;for(ue=le.rows.length,Oe=0;Oe<ue;Oe++)le.rows[Oe]=y(le.rows[Oe],le.header.length).map(function(je){return{text:je}});for(ue=le.header.length,de=0;de<ue;de++)le.header[de].tokens=this.lexer.inline(le.header[de].text);for(ue=le.rows.length,de=0;de<ue;de++)for(Me=le.rows[de],Ce=0;Ce<Me.length;Ce++)Me[Ce].tokens=this.lexer.inline(Me[Ce].text);return le}}},we.lheading=function(Q){var Y=this.rules.block.lheading.exec(Q);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},we.paragraph=function(Q){var Y=this.rules.block.paragraph.exec(Q);if(Y){var le=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:le,tokens:this.lexer.inline(le)}}},we.text=function(Q){var Y=this.rules.block.text.exec(Q);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},we.escape=function(Q){var Y=this.rules.inline.escape.exec(Q);if(Y)return{type:"escape",raw:Y[0],text:g(Y[1])}},we.tag=function(Q){var Y=this.rules.inline.tag.exec(Q);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):g(Y[0]):Y[0]}},we.link=function(Q){var Y=this.rules.inline.link.exec(Q);if(Y){var le=Y[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var ue=h(le.slice(0,-1),"\\");if((le.length-ue.length)%2===0)return}else{var Oe=D(Y[2],"()");if(Oe>-1){var de=Y[0].indexOf("!")===0?5:4,Ce=de+Y[1].length+Oe;Y[2]=Y[2].substring(0,Oe),Y[0]=Y[0].substring(0,Ce).trim(),Y[3]=""}}var Me=Y[2],je="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Me);U&&(Me=U[1],je=U[3])}else je=Y[3]?Y[3].slice(1,-1):"";return Me=Me.trim(),/^</.test(Me)&&(this.options.pedantic&&!/>$/.test(le)?Me=Me.slice(1):Me=Me.slice(1,-1)),I(Y,{href:Me&&Me.replace(this.rules.inline._escapes,"$1"),title:je&&je.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},we.reflink=function(Q,Y){var le;if((le=this.rules.inline.reflink.exec(Q))||(le=this.rules.inline.nolink.exec(Q))){var ue=(le[2]||le[1]).replace(/\s+/g," ");if(ue=Y[ue.toLowerCase()],!ue||!ue.href){var Oe=le[0].charAt(0);return{type:"text",raw:Oe,text:Oe}}return I(le,ue,le[0],this.lexer)}},we.emStrong=function(Q,Y,le){le===void 0&&(le="");var ue=this.rules.inline.emStrong.lDelim.exec(Q);if(ue&&!(ue[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Oe=ue[1]||ue[2]||"";if(!Oe||Oe&&(le===""||this.rules.inline.punctuation.exec(le))){var de=ue[0].length-1,Ce,Me,je=de,U=0,F=ue[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(F.lastIndex=0,Y=Y.slice(-1*Q.length+de);(ue=F.exec(Y))!=null;)if(Ce=ue[1]||ue[2]||ue[3]||ue[4]||ue[5]||ue[6],!!Ce){if(Me=Ce.length,ue[3]||ue[4]){je+=Me;continue}else if((ue[5]||ue[6])&&de%3&&!((de+Me)%3)){U+=Me;continue}if(je-=Me,!(je>0)){if(Me=Math.min(Me,Me+je+U),Math.min(de,Me)%2){var G=Q.slice(1,de+ue.index+Me);return{type:"em",raw:Q.slice(0,de+ue.index+Me+1),text:G,tokens:this.lexer.inlineTokens(G)}}var H=Q.slice(2,de+ue.index+Me-1);return{type:"strong",raw:Q.slice(0,de+ue.index+Me+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},we.codespan=function(Q){var Y=this.rules.inline.code.exec(Q);if(Y){var le=Y[2].replace(/\n/g," "),ue=/[^ ]/.test(le),Oe=/^ /.test(le)&&/ $/.test(le);return ue&&Oe&&(le=le.substring(1,le.length-1)),le=g(le,!0),{type:"codespan",raw:Y[0],text:le}}},we.br=function(Q){var Y=this.rules.inline.br.exec(Q);if(Y)return{type:"br",raw:Y[0]}},we.del=function(Q){var Y=this.rules.inline.del.exec(Q);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},we.autolink=function(Q,Y){var le=this.rules.inline.autolink.exec(Q);if(le){var ue,Oe;return le[2]==="@"?(ue=g(this.options.mangle?Y(le[1]):le[1]),Oe="mailto:"+ue):(ue=g(le[1]),Oe=ue),{type:"link",raw:le[0],text:ue,href:Oe,tokens:[{type:"text",raw:ue,text:ue}]}}},we.url=function(Q,Y){var le;if(le=this.rules.inline.url.exec(Q)){var ue,Oe;if(le[2]==="@")ue=g(this.options.mangle?Y(le[0]):le[0]),Oe="mailto:"+ue;else{var de;do de=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(de!==le[0]);ue=g(le[0]),le[1]==="www."?Oe="http://"+ue:Oe=ue}return{type:"link",raw:le[0],text:ue,href:Oe,tokens:[{type:"text",raw:ue,text:ue}]}}},we.inlineText=function(Q,Y){var le=this.rules.inline.text.exec(Q);if(le){var ue;return this.lexer.state.inRawBlock?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):g(le[0]):le[0]:ue=g(this.options.smartypants?Y(le[0]):le[0]),{type:"text",raw:le[0],text:ue}}},De}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:p,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=n(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=n(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=n(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=n(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=n(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=n(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=v({},q),q.gfm=v({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=n(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=n(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=v({},q.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:p,paragraph:n(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var R={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:p,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:p,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};R._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",R.punctuation=n(R.punctuation).replace(/punctuation/g,R._punctuation).getRegex(),R.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,R.escapedEmSt=/\\\*|\\_/g,R._comment=n(q._comment).replace("(?:-->|$)","-->").getRegex(),R.emStrong.lDelim=n(R.emStrong.lDelim).replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimAst=n(R.emStrong.rDelimAst,"g").replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimUnd=n(R.emStrong.rDelimUnd,"g").replace(/punct/g,R._punctuation).getRegex(),R._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,R._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,R._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,R.autolink=n(R.autolink).replace("scheme",R._scheme).replace("email",R._email).getRegex(),R._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,R.tag=n(R.tag).replace("comment",R._comment).replace("attribute",R._attribute).getRegex(),R._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,R._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,R._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,R.link=n(R.link).replace("label",R._label).replace("href",R._href).replace("title",R._title).getRegex(),R.reflink=n(R.reflink).replace("label",R._label).replace("ref",q._label).getRegex(),R.nolink=n(R.nolink).replace("ref",q._label).getRegex(),R.reflinkSearch=n(R.reflinkSearch,"g").replace("reflink",R.reflink).replace("nolink",R.nolink).getRegex(),R.normal=v({},R),R.pedantic=v({},R.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",R._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",R._label).getRegex()}),R.gfm=v({},R.normal,{escape:n(R.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),R.gfm.url=n(R.gfm.url,"i").replace("email",R.gfm._extended_email).getRegex(),R.breaks=v({},R.gfm,{br:n(R.br).replace("{2,}","*").getRegex(),text:n(R.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function B(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(De){var we="",ge,Q,Y=De.length;for(ge=0;ge<Y;ge++)Q=De.charCodeAt(ge),Math.random()>.5&&(Q="x"+Q.toString(16)),we+="&#"+Q+";";return we}var ie=function(){function De(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||he.defaults,this.options.tokenizer=this.options.tokenizer||new V,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:q.normal,inline:R.normal};this.options.pedantic?(Q.block=q.pedantic,Q.inline=R.pedantic):this.options.gfm&&(Q.block=q.gfm,this.options.breaks?Q.inline=R.breaks:Q.inline=R.gfm),this.tokenizer.rules=Q}De.lex=function(Q,Y){var le=new De(Y);return le.lex(Q)},De.lexInline=function(Q,Y){var le=new De(Y);return le.inlineTokens(Q)};var we=De.prototype;return we.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},we.blockTokens=function(Q,Y){var le=this;Y===void 0&&(Y=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(je,U,F){return U+"    ".repeat(F.length)});for(var ue,Oe,de,Ce;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(je){return(ue=je.call({lexer:le},Q,Y))?(Q=Q.substring(ue.raw.length),Y.push(ue),!0):!1}))){if(ue=this.tokenizer.space(Q)){Q=Q.substring(ue.raw.length),ue.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(ue);continue}if(ue=this.tokenizer.code(Q)){Q=Q.substring(ue.raw.length),Oe=Y[Y.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+ue.raw,Oe.text+=`
`+ue.text,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):Y.push(ue);continue}if(ue=this.tokenizer.fences(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.heading(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.hr(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.blockquote(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.list(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.html(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.def(Q)){Q=Q.substring(ue.raw.length),Oe=Y[Y.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+ue.raw,Oe.text+=`
`+ue.raw,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):this.tokens.links[ue.tag]||(this.tokens.links[ue.tag]={href:ue.href,title:ue.title});continue}if(ue=this.tokenizer.table(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.lheading(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(de=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var je=1/0,U=Q.slice(1),F=void 0;le.options.extensions.startBlock.forEach(function(G){F=G.call({lexer:this},U),typeof F=="number"&&F>=0&&(je=Math.min(je,F))}),je<1/0&&je>=0&&(de=Q.substring(0,je+1))}(),this.state.top&&(ue=this.tokenizer.paragraph(de))){Oe=Y[Y.length-1],Ce&&Oe.type==="paragraph"?(Oe.raw+=`
`+ue.raw,Oe.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):Y.push(ue),Ce=de.length!==Q.length,Q=Q.substring(ue.raw.length);continue}if(ue=this.tokenizer.text(Q)){Q=Q.substring(ue.raw.length),Oe=Y[Y.length-1],Oe&&Oe.type==="text"?(Oe.raw+=`
`+ue.raw,Oe.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):Y.push(ue);continue}if(Q){var Me="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Me);break}else throw new Error(Me)}}return this.state.top=!0,Y},we.inline=function(Q,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:Q,tokens:Y}),Y},we.inlineTokens=function(Q,Y){var le=this;Y===void 0&&(Y=[]);var ue,Oe,de,Ce=Q,Me,je,U;if(this.tokens.links){var F=Object.keys(this.tokens.links);if(F.length>0)for(;(Me=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)F.includes(Me[0].slice(Me[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Me.index)+"["+C("a",Me[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Me=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Me.index)+"["+C("a",Me[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Me=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Me.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(je||(U=""),je=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(ue=H.call({lexer:le},Q,Y))?(Q=Q.substring(ue.raw.length),Y.push(ue),!0):!1}))){if(ue=this.tokenizer.escape(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.tag(Q)){Q=Q.substring(ue.raw.length),Oe=Y[Y.length-1],Oe&&ue.type==="text"&&Oe.type==="text"?(Oe.raw+=ue.raw,Oe.text+=ue.text):Y.push(ue);continue}if(ue=this.tokenizer.link(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(ue.raw.length),Oe=Y[Y.length-1],Oe&&ue.type==="text"&&Oe.type==="text"?(Oe.raw+=ue.raw,Oe.text+=ue.text):Y.push(ue);continue}if(ue=this.tokenizer.emStrong(Q,Ce,U)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.codespan(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.br(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.del(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.autolink(Q,K)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(!this.state.inLink&&(ue=this.tokenizer.url(Q,K))){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(de=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,ee=Q.slice(1),re=void 0;le.options.extensions.startInline.forEach(function(Ae){re=Ae.call({lexer:this},ee),typeof re=="number"&&re>=0&&(H=Math.min(H,re))}),H<1/0&&H>=0&&(de=Q.substring(0,H+1))}(),ue=this.tokenizer.inlineText(de,B)){Q=Q.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(U=ue.raw.slice(-1)),je=!0,Oe=Y[Y.length-1],Oe&&Oe.type==="text"?(Oe.raw+=ue.raw,Oe.text+=ue.text):Y.push(ue);continue}if(Q){var G="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return Y},P(De,null,[{key:"rules",get:function(){return{block:q,inline:R}}}]),De}(),ce=function(){function De(ge){this.options=ge||he.defaults}var we=De.prototype;return we.code=function(Q,Y,le){var ue=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Oe=this.options.highlight(Q,ue);Oe!=null&&Oe!==Q&&(le=!0,Q=Oe)}return Q=Q.replace(/\n$/,"")+`
`,ue?'<pre><code class="'+this.options.langPrefix+g(ue,!0)+'">'+(le?Q:g(Q,!0))+`</code></pre>
`:"<pre><code>"+(le?Q:g(Q,!0))+`</code></pre>
`},we.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},we.html=function(Q){return Q},we.heading=function(Q,Y,le,ue){if(this.options.headerIds){var Oe=this.options.headerPrefix+ue.slug(le);return"<h"+Y+' id="'+Oe+'">'+Q+"</h"+Y+`>
`}return"<h"+Y+">"+Q+"</h"+Y+`>
`},we.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},we.list=function(Q,Y,le){var ue=Y?"ol":"ul",Oe=Y&&le!==1?' start="'+le+'"':"";return"<"+ue+Oe+`>
`+Q+"</"+ue+`>
`},we.listitem=function(Q){return"<li>"+Q+`</li>
`},we.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},we.paragraph=function(Q){return"<p>"+Q+`</p>
`},we.table=function(Q,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+Y+`</table>
`},we.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},we.tablecell=function(Q,Y){var le=Y.header?"th":"td",ue=Y.align?"<"+le+' align="'+Y.align+'">':"<"+le+">";return ue+Q+("</"+le+`>
`)},we.strong=function(Q){return"<strong>"+Q+"</strong>"},we.em=function(Q){return"<em>"+Q+"</em>"},we.codespan=function(Q){return"<code>"+Q+"</code>"},we.br=function(){return this.options.xhtml?"<br/>":"<br>"},we.del=function(Q){return"<del>"+Q+"</del>"},we.link=function(Q,Y,le){if(Q=u(this.options.sanitize,this.options.baseUrl,Q),Q===null)return le;var ue='<a href="'+g(Q)+'"';return Y&&(ue+=' title="'+Y+'"'),ue+=">"+le+"</a>",ue},we.image=function(Q,Y,le){if(Q=u(this.options.sanitize,this.options.baseUrl,Q),Q===null)return le;var ue='<img src="'+Q+'" alt="'+le+'"';return Y&&(ue+=' title="'+Y+'"'),ue+=this.options.xhtml?"/>":">",ue},we.text=function(Q){return Q},De}(),ve=function(){function De(){}var we=De.prototype;return we.strong=function(Q){return Q},we.em=function(Q){return Q},we.codespan=function(Q){return Q},we.del=function(Q){return Q},we.html=function(Q){return Q},we.text=function(Q){return Q},we.link=function(Q,Y,le){return""+le},we.image=function(Q,Y,le){return""+le},we.br=function(){return""},De}(),ke=function(){function De(){this.seen={}}var we=De.prototype;return we.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},we.getNextSafeSlug=function(Q,Y){var le=Q,ue=0;if(this.seen.hasOwnProperty(le)){ue=this.seen[Q];do ue++,le=Q+"-"+ue;while(this.seen.hasOwnProperty(le))}return Y||(this.seen[Q]=ue,this.seen[le]=0),le},we.slug=function(Q,Y){Y===void 0&&(Y={});var le=this.serialize(Q);return this.getNextSafeSlug(le,Y.dryrun)},De}(),fe=function(){function De(ge){this.options=ge||he.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ve,this.slugger=new ke}De.parse=function(Q,Y){var le=new De(Y);return le.parse(Q)},De.parseInline=function(Q,Y){var le=new De(Y);return le.parseInline(Q)};var we=De.prototype;return we.parse=function(Q,Y){Y===void 0&&(Y=!0);var le="",ue,Oe,de,Ce,Me,je,U,F,G,H,ee,re,Ae,Be,qe,et,xe,_e,tt,rt=Q.length;for(ue=0;ue<rt;ue++){if(H=Q[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(tt=this.options.extensions.renderers[H.type].call({parser:this},H),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){le+=tt||"";continue}switch(H.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(H.tokens),H.depth,s(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(F="",U="",Ce=H.header.length,Oe=0;Oe<Ce;Oe++)U+=this.renderer.tablecell(this.parseInline(H.header[Oe].tokens),{header:!0,align:H.align[Oe]});for(F+=this.renderer.tablerow(U),G="",Ce=H.rows.length,Oe=0;Oe<Ce;Oe++){for(je=H.rows[Oe],U="",Me=je.length,de=0;de<Me;de++)U+=this.renderer.tablecell(this.parseInline(je[de].tokens),{header:!1,align:H.align[de]});G+=this.renderer.tablerow(U)}le+=this.renderer.table(F,G);continue}case"blockquote":{G=this.parse(H.tokens),le+=this.renderer.blockquote(G);continue}case"list":{for(ee=H.ordered,re=H.start,Ae=H.loose,Ce=H.items.length,G="",Oe=0;Oe<Ce;Oe++)qe=H.items[Oe],et=qe.checked,xe=qe.task,Be="",qe.task&&(_e=this.renderer.checkbox(et),Ae?qe.tokens.length>0&&qe.tokens[0].type==="paragraph"?(qe.tokens[0].text=_e+" "+qe.tokens[0].text,qe.tokens[0].tokens&&qe.tokens[0].tokens.length>0&&qe.tokens[0].tokens[0].type==="text"&&(qe.tokens[0].tokens[0].text=_e+" "+qe.tokens[0].tokens[0].text)):qe.tokens.unshift({type:"text",text:_e}):Be+=_e),Be+=this.parse(qe.tokens,Ae),G+=this.renderer.listitem(Be,xe,et);le+=this.renderer.list(G,ee,re);continue}case"html":{le+=this.renderer.html(H.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(G=H.tokens?this.parseInline(H.tokens):H.text;ue+1<rt&&Q[ue+1].type==="text";)H=Q[++ue],G+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);le+=Y?this.renderer.paragraph(G):G;continue}default:{var ct='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(ct);return}else throw new Error(ct)}}}return le},we.parseInline=function(Q,Y){Y=Y||this.renderer;var le="",ue,Oe,de,Ce=Q.length;for(ue=0;ue<Ce;ue++){if(Oe=Q[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Oe.type]&&(de=this.options.extensions.renderers[Oe.type].call({parser:this},Oe),de!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Oe.type))){le+=de||"";continue}switch(Oe.type){case"escape":{le+=Y.text(Oe.text);break}case"html":{le+=Y.html(Oe.text);break}case"link":{le+=Y.link(Oe.href,Oe.title,this.parseInline(Oe.tokens,Y));break}case"image":{le+=Y.image(Oe.href,Oe.title,Oe.text);break}case"strong":{le+=Y.strong(this.parseInline(Oe.tokens,Y));break}case"em":{le+=Y.em(this.parseInline(Oe.tokens,Y));break}case"codespan":{le+=Y.codespan(Oe.text);break}case"br":{le+=Y.br();break}case"del":{le+=Y.del(this.parseInline(Oe.tokens,Y));break}case"text":{le+=Y.text(Oe.text);break}default:{var Me='Token with "'+Oe.type+'" type was not found.';if(this.options.silent){console.error(Me);return}else throw new Error(Me)}}}return le},De}();function pe(De,we,ge){if(typeof De>"u"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof we=="function"&&(ge=we,we=null),we=v({},pe.defaults,we||{}),k(we),ge){var Q=we.highlight,Y;try{Y=ie.lex(De,we)}catch(Ce){return ge(Ce)}var le=function(Me){var je;if(!Me)try{we.walkTokens&&pe.walkTokens(Y,we.walkTokens),je=fe.parse(Y,we)}catch(U){Me=U}return we.highlight=Q,Me?ge(Me):ge(null,je)};if(!Q||Q.length<3||(delete we.highlight,!Y.length))return le();var ue=0;pe.walkTokens(Y,function(Ce){Ce.type==="code"&&(ue++,setTimeout(function(){Q(Ce.text,Ce.lang,function(Me,je){if(Me)return le(Me);je!=null&&je!==Ce.text&&(Ce.text=je,Ce.escaped=!0),ue--,ue===0&&le()})},0))}),ue===0&&le();return}function Oe(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+g(Ce.message+"",!0)+"</pre>";throw Ce}try{var de=ie.lex(De,we);if(we.walkTokens){if(we.async)return Promise.all(pe.walkTokens(de,we.walkTokens)).then(function(){return fe.parse(de,we)}).catch(Oe);pe.walkTokens(de,we.walkTokens)}return fe.parse(de,we)}catch(Ce){Oe(Ce)}}pe.options=pe.setOptions=function(De){return v(pe.defaults,De),$(pe.defaults),pe},pe.getDefaults=A,pe.defaults=he.defaults,pe.use=function(){for(var De=arguments.length,we=new Array(De),ge=0;ge<De;ge++)we[ge]=arguments[ge];var Q=v.apply(void 0,[{}].concat(we)),Y=pe.defaults.extensions||{renderers:{},childTokens:{}},le;we.forEach(function(ue){if(ue.extensions&&(le=!0,ue.extensions.forEach(function(de){if(!de.name)throw new Error("extension name required");if(de.renderer){var Ce=Y.renderers?Y.renderers[de.name]:null;Ce?Y.renderers[de.name]=function(){for(var Me=arguments.length,je=new Array(Me),U=0;U<Me;U++)je[U]=arguments[U];var F=de.renderer.apply(this,je);return F===!1&&(F=Ce.apply(this,je)),F}:Y.renderers[de.name]=de.renderer}if(de.tokenizer){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[de.level]?Y[de.level].unshift(de.tokenizer):Y[de.level]=[de.tokenizer],de.start&&(de.level==="block"?Y.startBlock?Y.startBlock.push(de.start):Y.startBlock=[de.start]:de.level==="inline"&&(Y.startInline?Y.startInline.push(de.start):Y.startInline=[de.start]))}de.childTokens&&(Y.childTokens[de.name]=de.childTokens)})),ue.renderer&&function(){var de=pe.defaults.renderer||new ce,Ce=function(U){var F=de[U];de[U]=function(){for(var G=arguments.length,H=new Array(G),ee=0;ee<G;ee++)H[ee]=arguments[ee];var re=ue.renderer[U].apply(de,H);return re===!1&&(re=F.apply(de,H)),re}};for(var Me in ue.renderer)Ce(Me);Q.renderer=de}(),ue.tokenizer&&function(){var de=pe.defaults.tokenizer||new V,Ce=function(U){var F=de[U];de[U]=function(){for(var G=arguments.length,H=new Array(G),ee=0;ee<G;ee++)H[ee]=arguments[ee];var re=ue.tokenizer[U].apply(de,H);return re===!1&&(re=F.apply(de,H)),re}};for(var Me in ue.tokenizer)Ce(Me);Q.tokenizer=de}(),ue.walkTokens){var Oe=pe.defaults.walkTokens;Q.walkTokens=function(de){var Ce=[];return Ce.push(ue.walkTokens.call(this,de)),Oe&&(Ce=Ce.concat(Oe.call(this,de))),Ce}}le&&(Q.extensions=Y),pe.setOptions(Q)})},pe.walkTokens=function(De,we){for(var ge=[],Q=function(){var Oe=le.value;switch(ge=ge.concat(we.call(pe,Oe)),Oe.type){case"table":{for(var de=N(Oe.header),Ce;!(Ce=de()).done;){var Me=Ce.value;ge=ge.concat(pe.walkTokens(Me.tokens,we))}for(var je=N(Oe.rows),U;!(U=je()).done;)for(var F=U.value,G=N(F),H;!(H=G()).done;){var ee=H.value;ge=ge.concat(pe.walkTokens(ee.tokens,we))}break}case"list":{ge=ge.concat(pe.walkTokens(Oe.items,we));break}default:pe.defaults.extensions&&pe.defaults.extensions.childTokens&&pe.defaults.extensions.childTokens[Oe.type]?pe.defaults.extensions.childTokens[Oe.type].forEach(function(re){ge=ge.concat(pe.walkTokens(Oe[re],we))}):Oe.tokens&&(ge=ge.concat(pe.walkTokens(Oe.tokens,we)))}},Y=N(De),le;!(le=Y()).done;)Q();return ge},pe.parseInline=function(De,we){if(typeof De>"u"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");we=v({},pe.defaults,we||{}),k(we);try{var ge=ie.lexInline(De,we);return we.walkTokens&&pe.walkTokens(ge,we.walkTokens),fe.parseInline(ge,we)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+g(Q.message+"",!0)+"</pre>";throw Q}},pe.Parser=fe,pe.parser=fe.parse,pe.Renderer=ce,pe.TextRenderer=ve,pe.Lexer=ie,pe.lexer=ie.lex,pe.Tokenizer=V,pe.Slugger=ke,pe.parse=pe;var Ne=pe.options,ae=pe.setOptions,Re=pe.use,ne=pe.walkTokens,z=pe.parseInline,x=pe,be=fe.parse,Te=ie.lex;he.Lexer=ie,he.Parser=fe,he.Renderer=ce,he.Slugger=ke,he.TextRenderer=ve,he.Tokenizer=V,he.getDefaults=A,he.lexer=Te,he.marked=pe,he.options=Ne,he.parse=x,he.parseInline=z,he.parser=be,he.setOptions=ae,he.use=Re,he.walkTokens=ne,Object.defineProperty(he,"__esModule",{value:!0})}),define(Se[128],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=P;function P(r){const s=N(r);if(s&&s.length>0)return new Uint32Array(s)}let O=0;const M=new Uint32Array(10);function N(r){if(O=0,A(r,S,4352),O>0||(A(r,l,4449),O>0)||(A(r,b,4520),O>0)||(A(r,g,12593),O))return M.subarray(0,O);if(r>=44032&&r<=55203){const s=r-44032,o=s%588,n=Math.floor(s/588),i=Math.floor(o/28),c=o%28-1;if(n<S.length?A(n,S,0):4352+n-12593<g.length&&A(4352+n,g,12593),i<l.length?A(i,l,0):4449+i-12593<g.length&&A(4449+i-12593,g,12593),c>=0&&(c<b.length?A(c,b,0):4520+c-12593<g.length&&A(4520+c-12593,g,12593)),O>0)return M.subarray(0,O)}}function A(r,s,o){r>=o&&r<o+s.length&&$(s[r-o])}function $(r){r!==0&&(M[O++]=r&255,r>>8&&(M[O++]=r>>8&255),r>>16&&(M[O++]=r>>16&255))}var m;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var E;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(E||(E={}));var T;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(T||(T={}));const S=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),b=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),g=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Se[129],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=e.$Dm=void 0,e.$Bm=P,e.rot=O;function P($,m,E){return Math.min(Math.max($,m),E)}function O($,m){return(m+$%m)%m}class M{constructor(){this.a=0}getNext(){return this.a++}}e.$Dm=M;class N{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Em=N;class A{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const E=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Fm=A}),define(Se[130],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=N,e.$cd=l;class P{constructor(g,r,s){this.owner=g,this.debugNameSource=r,this.referenceFn=s}getDebugName(g){return N(g,this)}}e.$ad=P;const O=new Map,M=new WeakMap;function N(b,g){const r=M.get(b);if(r)return r;const s=A(b,g);if(s){let o=O.get(s)??0;o++,O.set(s,o);const n=o===1?s:`${s}#${o}`;return M.set(b,n),n}}function A(b,g){const r=M.get(b);if(r)return r;const s=g.owner?T(g.owner)+".":"";let o;const n=g.debugNameSource;if(n!==void 0)if(typeof n=="function"){if(o=n(),o!==void 0)return s+o}else return s+n;const i=g.referenceFn;if(i!==void 0&&(o=l(i),o!==void 0))return s+o;if(g.owner!==void 0){const c=$(g.owner,b);if(c!==void 0)return s+c}}function $(b,g){for(const r in b)if(b[r]===g)return r}const m=new Map,E=new WeakMap;function T(b){const g=E.get(b);if(g)return g;const r=S(b);let s=m.get(r)??0;s++,m.set(r,s);const o=s===1?r:`${r}#${s}`;return E.set(b,o),o}function S(b){const g=b.constructor;return g?g.name:"Object"}function l(b){const g=b.toString(),s=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(g);return(s?s[1]:void 0)?.trim()}}),define(Se[131],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Hd=O,e.$Id=M;let P;function O(r){P=r}function M(){return P}class N{constructor(){this.a=0,this.d=new WeakMap}b(s){return A([$(b("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[$(" "),E(T(s.oldValue,70),{color:"red",strikeThrough:!0}),$(" "),E(T(s.newValue,60),{color:"green"})]:[$(" (unchanged)")]:[$(" "),E(T(s.newValue,60),{color:"green"}),$(" (initial)")]}handleObservableChanged(s,o){console.log(...this.b([m("observable value changed"),E(s.debugName,{color:"BlueViolet"}),...this.c(o)]))}formatChanges(s){if(s.size!==0)return E(" (changed deps: "+[...s].map(o=>o.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const o=s.handleChange;this.d.set(s,new Set),s.handleChange=(n,i)=>(this.d.get(s).add(n),o.apply(s,[n,i]))}handleDerivedRecomputed(s,o){const n=this.d.get(s);console.log(...this.b([m("derived recomputed"),E(s.debugName,{color:"BlueViolet"}),...this.c(o),this.formatChanges(n),{data:[{fn:s._computeFn}]}])),n.clear()}handleFromEventObservableTriggered(s,o){console.log(...this.b([m("observable from event triggered"),E(s.debugName,{color:"BlueViolet"}),...this.c(o),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const o=s.handleChange;this.d.set(s,new Set),s.handleChange=(n,i)=>(this.d.get(s).add(n),o.apply(s,[n,i]))}handleAutorunTriggered(s){const o=this.d.get(s);console.log(...this.b([m("autorun"),E(s.debugName,{color:"BlueViolet"}),this.formatChanges(o),{data:[{fn:s._runFn}]}])),o.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let o=s.getDebugName();o===void 0&&(o=""),console.log(...this.b([m("transaction"),E(o,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Jd=N;function A(r){const s=new Array,o=[];let n="";function i(u){if("length"in u)for(const t of u)t&&i(t);else"text"in u?(n+=`%c${u.text}`,s.push(u.style),u.data&&o.push(...u.data)):"data"in u&&o.push(...u.data)}i(r);const c=[n,...s];return c.push(...o),c}function $(r){return E(r,{color:"black"})}function m(r){return E(g(`${r}: `,10),{color:"black",bold:!0})}function E(r,s={color:"black"}){function o(i){return Object.entries(i).reduce((c,[u,t])=>`${c}${u}:${t};`,"")}const n={color:s.color};return s.strikeThrough&&(n["text-decoration"]="line-through"),s.bold&&(n["font-weight"]="bold"),{text:r,style:o(n)}}function T(r,s){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=s?`"${r}"`:`"${r.substr(0,s-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?S(r,s):l(r,s);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function S(r,s){let o="[ ",n=!0;for(const i of r){if(n||(o+=", "),o.length-5>s){o+="...";break}n=!1,o+=`${T(i,s-o.length)}`}return o+=" ]",o}function l(r,s){let o="{ ",n=!0;for(const[i,c]of Object.entries(r)){if(n||(o+=", "),o.length-5>s){o+="...";break}n=!1,o+=`${i}: ${T(c,s-o.length)}`}return o+=" }",o}function b(r,s){let o="";for(let n=1;n<=s;n++)o+=r;return o}function g(r,s){for(;r.length<s;)r+=" ";return r}}),define(Se[132],Ie([1,0,125,130,131]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5d=e.$3d=e.$Zd=e.$Ud=e.$Td=void 0,e.$Qd=A,e.$Rd=m,e.$Sd=T,e.$Vd=b,e.$Wd=r,e.$Xd=s,e.$Yd=o,e.$1d=i,e.$2d=c,e.$4d=t;let N;function A(a){N=a}let $;function m(a){$=a}let E;function T(a){E=a}class S{get TChange(){return null}reportChanges(){this.get()}read(f){return f?f.readObservable(this):this.get()}map(f,w){const p=w===void 0?void 0:f,v=w===void 0?f:w;return E({owner:p,debugName:()=>{const y=(0,O.$cd)(v);if(y!==void 0)return y;const D=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(v.toString());if(D)return`${this.debugName}.${D[2]}`;if(!p)return`${this.debugName} (mapped)`},debugReferenceFn:v},y=>v(this.read(y),y))}recomputeInitiallyAndOnChange(f,w){return f.add(N(this,w)),this}keepObserved(f){return f.add($(this)),this}get a(){return this.get()}}e.$Td=S;class l extends S{constructor(){super(...arguments),this.b=new Set}addObserver(f){const w=this.b.size;this.b.add(f),w===0&&this.c()}removeObserver(f){this.b.delete(f)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Ud=l;function b(a,f){const w=new n(a,f);try{a(w)}finally{w.finish()}}let g;function r(a){if(g)a(g);else{const f=new n(a,void 0);g=f;try{a(f)}finally{f.finish(),g=void 0}}}async function s(a,f){const w=new n(a,f);try{await a(w)}finally{w.finish()}}function o(a,f,w){a?f(a):b(f,w)}class n{constructor(f,w){this._fn=f,this.b=w,this.a=[],(0,M.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,O.$cd)(this._fn)}updateObserver(f,w){this.a.push({observer:f,observable:w}),f.beginUpdate(w)}finish(){const f=this.a;for(let w=0;w<f.length;w++){const{observer:p,observable:v}=f[w];p.endUpdate(v)}this.a=null,(0,M.$Id)()?.handleEndTransaction()}}e.$Zd=n;function i(a,f){let w;return typeof a=="string"?w=new O.$ad(void 0,a,void 0):w=new O.$ad(a,void 0,void 0),new u(w,f,P.$6c)}function c(a,f){return new u(new O.$ad(a.owner,a.debugName,void 0),f,a.equalsFn??P.$6c)}class u extends l{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(f,w,p){super(),this.e=f,this.g=p,this.d=w}get(){return this.d}set(f,w,p){if(this.g(this.d,f))return;let v;w||(w=v=new n(()=>{},()=>`Setting ${this.debugName}`));try{const y=this.d;this.h(f),(0,M.$Id)()?.handleObservableChanged(this,{oldValue:y,newValue:f,change:p,didChange:!0,hadValue:!0});for(const h of this.b)w.updateObserver(h,this),h.handleChange(this,p)}finally{v&&v.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(f){this.d=f}}e.$3d=u;function t(a,f){let w;return typeof a=="string"?w=new O.$ad(void 0,a,void 0):w=new O.$ad(a,void 0,void 0),new d(w,f,P.$6c)}class d extends u{h(f){this.d!==f&&(this.d&&this.d.dispose(),this.d=f)}dispose(){this.d?.dispose()}}e.$5d=d}),function(){function he(M){const N=[];typeof M=="number"&&N.push("code/timeOrigin",M);function A(m){N.push(m,Date.now())}function $(){const m=[];for(let E=0;E<N.length;E+=2)m.push({name:N[E],startTime:N[E+1]});return m}return{mark:A,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?he():{mark(M){performance.mark(M)},getMarks(){let M=performance.timeOrigin;typeof M!="number"&&(M=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(M)}];for(const A of performance.getEntriesByType("mark"))N.push({name:A.name,startTime:Math.round(M+A.startTime)});return N}};if(typeof process=="object"){const M=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return he(M)}else return console.trace("perf-util loaded in UNKNOWN environment"),he()}function P(M){return M.MonacoPerformanceMarks||(M.MonacoPerformanceMarks=e()),M.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=P(O))}(),define(Se[133],Ie([1,0,42]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tO=void 0;const O=Symbol("unset");class M{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||P.Iterable.empty()}insert(m,E,T){this.d(m,S=>S._value=E,T)}mutate(m,E){this.d(m,T=>T._value=E(T._value===O?void 0:T._value))}delete(m){const E=this.c(m);if(!E)return;let T=E.length-1;const S=E[T].node._value;if(S!==O){for(this.b--,E[T].node._value=O;T>0;T--){const{node:l,part:b}=E[T];if(l.children?.size||l._value!==O)break;E[T-1].node.children.delete(b)}return S}}*deleteRecursive(m){const E=this.c(m);if(!E)return;const T=E[E.length-1].node;for(let S=E.length-1;S>0;S--){const l=E[S-1];if(l.node.children.delete(E[S].part),l.node.children.size>0||l.node._value!==O)break}for(const S of N(T))S._value!==O&&(this.b--,yield S._value)}find(m){let E=this.a;for(const T of m){const S=E.children?.get(T);if(!S)return;E=S}return E._value===O?void 0:E._value}hasKeyOrParent(m){let E=this.a;for(const T of m){const S=E.children?.get(T);if(!S)return!1;if(S._value!==O)return!0;E=S}return!1}hasKeyOrChildren(m){let E=this.a;for(const T of m){const S=E.children?.get(T);if(!S)return!1;E=S}return!0}hasKey(m){let E=this.a;for(const T of m){const S=E.children?.get(T);if(!S)return!1;E=S}return E._value!==O}c(m){const E=[{part:"",node:this.a}];let T=0;for(const S of m){const l=E[T].node.children?.get(S);if(!l)return;E.push({part:S,node:l}),T++}return E}d(m,E,T){let S=this.a;for(const g of m){if(S.children)if(S.children.has(g))S=S.children.get(g);else{const r=new A;S.children.set(g,r),S=r}else{const r=new A;S.children=new Map([[g,r]]),S=r}T?.(S)}const l=S._value===O?0:1;E(S);const b=S._value===O?0:1;this.b+=b-l}*values(){for(const{_value:m}of N(this.a))m!==O&&(yield m)}}e.$tO=M;function*N($){const m=[$];for(;m.length>0;){const E=m.pop();if(yield E,E.children)for(const T of E.children.values())m.push(T)}}class A{constructor(){this._value=O}get value(){return this._value===O?void 0:this._value}set value(m){this._value=m===void 0?O:m}}}),function(he,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var O in P)(typeof exports=="object"?exports:he)[O]=P[O]}}(typeof self<"u"?self:this,function(){return function(he){var e={};function P(O){if(e[O])return e[O].exports;var M=e[O]={i:O,l:!1,exports:{}};return he[O].call(M.exports,M,M.exports,P),M.l=!0,M.exports}return P.m=he,P.c=e,P.d=function(O,M,N){P.o(O,M)||Object.defineProperty(O,M,{enumerable:!0,get:N})},P.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},P.t=function(O,M){if(1&M&&(O=P(O)),8&M||4&M&&typeof O=="object"&&O&&O.__esModule)return O;var N=Object.create(null);if(P.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:O}),2&M&&typeof O!="string")for(var A in O)P.d(N,A,function($){return O[$]}.bind(null,A));return N},P.n=function(O){var M=O&&O.__esModule?function(){return O.default}:function(){return O};return P.d(M,"a",M),M},P.o=function(O,M){return Object.prototype.hasOwnProperty.call(O,M)},P.p="",P(P.s=0)}([function(he,e,P){(function(O){var M;e=he.exports=Re,M=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var F=Array.prototype.slice.call(arguments,0);F.unshift("SEMVER"),console.log.apply(console,F)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],m=e.src=[],E=0,T=E++;m[T]="0|[1-9]\\d*";var S=E++;m[S]="[0-9]+";var l=E++;m[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=E++;m[b]="("+m[T]+")\\.("+m[T]+")\\.("+m[T]+")";var g=E++;m[g]="("+m[S]+")\\.("+m[S]+")\\.("+m[S]+")";var r=E++;m[r]="(?:"+m[T]+"|"+m[l]+")";var s=E++;m[s]="(?:"+m[S]+"|"+m[l]+")";var o=E++;m[o]="(?:-("+m[r]+"(?:\\."+m[r]+")*))";var n=E++;m[n]="(?:-?("+m[s]+"(?:\\."+m[s]+")*))";var i=E++;m[i]="[0-9A-Za-z-]+";var c=E++;m[c]="(?:\\+("+m[i]+"(?:\\."+m[i]+")*))";var u=E++,t="v?"+m[b]+m[o]+"?"+m[c]+"?";m[u]="^"+t+"$";var d="[v=\\s]*"+m[g]+m[n]+"?"+m[c]+"?",a=E++;m[a]="^"+d+"$";var f=E++;m[f]="((?:<|>)?=?)";var w=E++;m[w]=m[S]+"|x|X|\\*";var p=E++;m[p]=m[T]+"|x|X|\\*";var v=E++;m[v]="[v=\\s]*("+m[p]+")(?:\\.("+m[p]+")(?:\\.("+m[p]+")(?:"+m[o]+")?"+m[c]+"?)?)?";var y=E++;m[y]="[v=\\s]*("+m[w]+")(?:\\.("+m[w]+")(?:\\.("+m[w]+")(?:"+m[n]+")?"+m[c]+"?)?)?";var h=E++;m[h]="^"+m[f]+"\\s*"+m[v]+"$";var D=E++;m[D]="^"+m[f]+"\\s*"+m[y]+"$";var k=E++;m[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=E++;m[C]="(?:~>?)";var I=E++;m[I]="(\\s*)"+m[C]+"\\s+",$[I]=new RegExp(m[I],"g");var W=E++;m[W]="^"+m[C]+m[v]+"$";var V=E++;m[V]="^"+m[C]+m[y]+"$";var q=E++;m[q]="(?:\\^)";var R=E++;m[R]="(\\s*)"+m[q]+"\\s+",$[R]=new RegExp(m[R],"g");var B=E++;m[B]="^"+m[q]+m[v]+"$";var K=E++;m[K]="^"+m[q]+m[y]+"$";var ie=E++;m[ie]="^"+m[f]+"\\s*("+d+")$|^$";var ce=E++;m[ce]="^"+m[f]+"\\s*("+t+")$|^$";var ve=E++;m[ve]="(\\s*)"+m[f]+"\\s*("+d+"|"+m[v]+")",$[ve]=new RegExp(m[ve],"g");var ke=E++;m[ke]="^\\s*("+m[v]+")\\s+-\\s+("+m[v]+")\\s*$";var fe=E++;m[fe]="^\\s*("+m[y]+")\\s+-\\s+("+m[y]+")\\s*$";var pe=E++;m[pe]="(<|>)?=?\\s*\\*";for(var Ne=0;Ne<35;Ne++)M(Ne,m[Ne]),$[Ne]||($[Ne]=new RegExp(m[Ne]));function ae(F,G){if(F instanceof Re)return F;if(typeof F!="string"||F.length>N||!(G?$[a]:$[u]).test(F))return null;try{return new Re(F,G)}catch{return null}}function Re(F,G){if(F instanceof Re){if(F.loose===G)return F;F=F.version}else if(typeof F!="string")throw new TypeError("Invalid Version: "+F);if(F.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof Re))return new Re(F,G);M("SemVer",F,G),this.loose=G;var H=F.trim().match(G?$[a]:$[u]);if(!H)throw new TypeError("Invalid Version: "+F);if(this.raw=F,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var re=+ee;if(re>=0&&re<A)return re}return ee}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=ae,e.valid=function(F,G){var H=ae(F,G);return H?H.version:null},e.clean=function(F,G){var H=ae(F.trim().replace(/^[=v]+/,""),G);return H?H.version:null},e.SemVer=Re,Re.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Re.prototype.toString=function(){return this.version},Re.prototype.compare=function(F){return M("SemVer.compare",this.version,this.loose,F),F instanceof Re||(F=new Re(F,this.loose)),this.compareMain(F)||this.comparePre(F)},Re.prototype.compareMain=function(F){return F instanceof Re||(F=new Re(F,this.loose)),z(this.major,F.major)||z(this.minor,F.minor)||z(this.patch,F.patch)},Re.prototype.comparePre=function(F){if(F instanceof Re||(F=new Re(F,this.loose)),this.prerelease.length&&!F.prerelease.length)return-1;if(!this.prerelease.length&&F.prerelease.length)return 1;if(!this.prerelease.length&&!F.prerelease.length)return 0;var G=0;do{var H=this.prerelease[G],ee=F.prerelease[G];if(M("prerelease compare",G,H,ee),H===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(H===void 0)return-1;if(H!==ee)return z(H,ee)}while(++G)},Re.prototype.inc=function(F,G){switch(F){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+F)}return this.format(),this.raw=this.version,this},e.inc=function(F,G,H,ee){typeof H=="string"&&(ee=H,H=void 0);try{return new Re(F,H).inc(G,ee).version}catch{return null}},e.diff=function(F,G){if(De(F,G))return null;var H=ae(F),ee=ae(G);if(H.prerelease.length||ee.prerelease.length){for(var re in H)if((re==="major"||re==="minor"||re==="patch")&&H[re]!==ee[re])return"pre"+re;return"prerelease"}for(var re in H)if((re==="major"||re==="minor"||re==="patch")&&H[re]!==ee[re])return re},e.compareIdentifiers=z;var ne=/^[0-9]+$/;function z(F,G){var H=ne.test(F),ee=ne.test(G);return H&&ee&&(F=+F,G=+G),H&&!ee?-1:ee&&!H?1:F<G?-1:F>G?1:0}function x(F,G,H){return new Re(F,H).compare(new Re(G,H))}function be(F,G,H){return x(F,G,H)>0}function Te(F,G,H){return x(F,G,H)<0}function De(F,G,H){return x(F,G,H)===0}function we(F,G,H){return x(F,G,H)!==0}function ge(F,G,H){return x(F,G,H)>=0}function Q(F,G,H){return x(F,G,H)<=0}function Y(F,G,H,ee){var re;switch(G){case"===":typeof F=="object"&&(F=F.version),typeof H=="object"&&(H=H.version),re=F===H;break;case"!==":typeof F=="object"&&(F=F.version),typeof H=="object"&&(H=H.version),re=F!==H;break;case"":case"=":case"==":re=De(F,H,ee);break;case"!=":re=we(F,H,ee);break;case">":re=be(F,H,ee);break;case">=":re=ge(F,H,ee);break;case"<":re=Te(F,H,ee);break;case"<=":re=Q(F,H,ee);break;default:throw new TypeError("Invalid operator: "+G)}return re}function le(F,G){if(F instanceof le){if(F.loose===G)return F;F=F.value}if(!(this instanceof le))return new le(F,G);M("comparator",F,G),this.loose=G,this.parse(F),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,M("comp",this)}e.rcompareIdentifiers=function(F,G){return z(G,F)},e.major=function(F,G){return new Re(F,G).major},e.minor=function(F,G){return new Re(F,G).minor},e.patch=function(F,G){return new Re(F,G).patch},e.compare=x,e.compareLoose=function(F,G){return x(F,G,!0)},e.rcompare=function(F,G,H){return x(G,F,H)},e.sort=function(F,G){return F.sort(function(H,ee){return e.compare(H,ee,G)})},e.rsort=function(F,G){return F.sort(function(H,ee){return e.rcompare(H,ee,G)})},e.gt=be,e.lt=Te,e.eq=De,e.neq=we,e.gte=ge,e.lte=Q,e.cmp=Y,e.Comparator=le;var ue={};function Oe(F,G){if(F instanceof Oe)return F.loose===G?F:new Oe(F.raw,G);if(F instanceof le)return new Oe(F.value,G);if(!(this instanceof Oe))return new Oe(F,G);if(this.loose=G,this.raw=F,this.set=F.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+F);this.format()}function de(F){return!F||F.toLowerCase()==="x"||F==="*"}function Ce(F,G,H,ee,re,Ae,Be,qe,et,xe,_e,tt,rt){return((G=de(H)?"":de(ee)?">="+H+".0.0":de(re)?">="+H+"."+ee+".0":">="+G)+" "+(qe=de(et)?"":de(xe)?"<"+(+et+1)+".0.0":de(_e)?"<"+et+"."+(+xe+1)+".0":tt?"<="+et+"."+xe+"."+_e+"-"+tt:"<="+qe)).trim()}function Me(F,G){for(var H=0;H<F.length;H++)if(!F[H].test(G))return!1;if(G.prerelease.length){for(H=0;H<F.length;H++)if(M(F[H].semver),F[H].semver!==ue&&F[H].semver.prerelease.length>0){var ee=F[H].semver;if(ee.major===G.major&&ee.minor===G.minor&&ee.patch===G.patch)return!0}return!1}return!0}function je(F,G,H){try{G=new Oe(G,H)}catch{return!1}return G.test(F)}function U(F,G,H,ee){var re,Ae,Be,qe,et;switch(F=new Re(F,ee),G=new Oe(G,ee),H){case">":re=be,Ae=Q,Be=Te,qe=">",et=">=";break;case"<":re=Te,Ae=ge,Be=be,qe="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(F,G,ee))return!1;for(var xe=0;xe<G.set.length;++xe){var _e=G.set[xe],tt=null,rt=null;if(_e.forEach(function(ct){ct.semver===ue&&(ct=new le(">=0.0.0")),tt=tt||ct,rt=rt||ct,re(ct.semver,tt.semver,ee)?tt=ct:Be(ct.semver,rt.semver,ee)&&(rt=ct)}),tt.operator===qe||tt.operator===et||(!rt.operator||rt.operator===qe)&&Ae(F,rt.semver)||rt.operator===et&&Be(F,rt.semver))return!1}return!0}le.prototype.parse=function(F){var G=this.loose?$[ie]:$[ce],H=F.match(G);if(!H)throw new TypeError("Invalid comparator: "+F);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new Re(H[2],this.loose):this.semver=ue},le.prototype.toString=function(){return this.value},le.prototype.test=function(F){return M("Comparator.test",F,this.loose),this.semver===ue||(typeof F=="string"&&(F=new Re(F,this.loose)),Y(F,this.operator,this.semver,this.loose))},le.prototype.intersects=function(F,G){if(!(F instanceof le))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Oe(F.value,G),je(this.value,H,G);if(F.operator==="")return H=new Oe(this.value,G),je(F.semver,H,G);var ee=!(this.operator!==">="&&this.operator!==">"||F.operator!==">="&&F.operator!==">"),re=!(this.operator!=="<="&&this.operator!=="<"||F.operator!=="<="&&F.operator!=="<"),Ae=this.semver.version===F.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||F.operator!==">="&&F.operator!=="<="),qe=Y(this.semver,"<",F.semver,G)&&(this.operator===">="||this.operator===">")&&(F.operator==="<="||F.operator==="<"),et=Y(this.semver,">",F.semver,G)&&(this.operator==="<="||this.operator==="<")&&(F.operator===">="||F.operator===">");return ee||re||Ae&&Be||qe||et},e.Range=Oe,Oe.prototype.format=function(){return this.range=this.set.map(function(F){return F.join(" ").trim()}).join("||").trim(),this.range},Oe.prototype.toString=function(){return this.range},Oe.prototype.parseRange=function(F){var G=this.loose;F=F.trim(),M("range",F,G);var H=G?$[fe]:$[ke];F=F.replace(H,Ce),M("hyphen replace",F),F=F.replace($[ve],"$1$2$3"),M("comparator trim",F,$[ve]),F=(F=(F=F.replace($[I],"$1~")).replace($[R],"$1^")).split(/\s+/).join(" ");var ee=G?$[ie]:$[ce],re=F.split(" ").map(function(Ae){return function(Be,qe){return M("comp",Be),Be=function(et,xe){return et.trim().split(/\s+/).map(function(_e){return function(tt,rt){M("caret",tt,rt);var ct=rt?$[K]:$[B];return tt.replace(ct,function(ft,Ue,ot,X,Z){var $e;return M("caret",tt,ft,Ue,ot,X,Z),de(Ue)?$e="":de(ot)?$e=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":de(X)?$e=Ue==="0"?">="+Ue+"."+ot+".0 <"+Ue+"."+(+ot+1)+".0":">="+Ue+"."+ot+".0 <"+(+Ue+1)+".0.0":Z?(M("replaceCaret pr",Z),Z.charAt(0)!=="-"&&(Z="-"+Z),$e=Ue==="0"?ot==="0"?">="+Ue+"."+ot+"."+X+Z+" <"+Ue+"."+ot+"."+(+X+1):">="+Ue+"."+ot+"."+X+Z+" <"+Ue+"."+(+ot+1)+".0":">="+Ue+"."+ot+"."+X+Z+" <"+(+Ue+1)+".0.0"):(M("no pr"),$e=Ue==="0"?ot==="0"?">="+Ue+"."+ot+"."+X+" <"+Ue+"."+ot+"."+(+X+1):">="+Ue+"."+ot+"."+X+" <"+Ue+"."+(+ot+1)+".0":">="+Ue+"."+ot+"."+X+" <"+(+Ue+1)+".0.0"),M("caret return",$e),$e})}(_e,xe)}).join(" ")}(Be,qe),M("caret",Be),Be=function(et,xe){return et.trim().split(/\s+/).map(function(_e){return function(tt,rt){var ct=rt?$[V]:$[W];return tt.replace(ct,function(ft,Ue,ot,X,Z){var $e;return M("tilde",tt,ft,Ue,ot,X,Z),de(Ue)?$e="":de(ot)?$e=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":de(X)?$e=">="+Ue+"."+ot+".0 <"+Ue+"."+(+ot+1)+".0":Z?(M("replaceTilde pr",Z),Z.charAt(0)!=="-"&&(Z="-"+Z),$e=">="+Ue+"."+ot+"."+X+Z+" <"+Ue+"."+(+ot+1)+".0"):$e=">="+Ue+"."+ot+"."+X+" <"+Ue+"."+(+ot+1)+".0",M("tilde return",$e),$e})}(_e,xe)}).join(" ")}(Be,qe),M("tildes",Be),Be=function(et,xe){return M("replaceXRanges",et,xe),et.split(/\s+/).map(function(_e){return function(tt,rt){tt=tt.trim();var ct=rt?$[D]:$[h];return tt.replace(ct,function(ft,Ue,ot,X,Z,$e){M("xRange",tt,ft,Ue,ot,X,Z,$e);var me=de(ot),Ze=me||de(X),at=Ze||de(Z);return Ue==="="&&at&&(Ue=""),me?ft=Ue===">"||Ue==="<"?"<0.0.0":"*":Ue&&at?(Ze&&(X=0),at&&(Z=0),Ue===">"?(Ue=">=",Ze?(ot=+ot+1,X=0,Z=0):at&&(X=+X+1,Z=0)):Ue==="<="&&(Ue="<",Ze?ot=+ot+1:X=+X+1),ft=Ue+ot+"."+X+"."+Z):Ze?ft=">="+ot+".0.0 <"+(+ot+1)+".0.0":at&&(ft=">="+ot+"."+X+".0 <"+ot+"."+(+X+1)+".0"),M("xRange return",ft),ft})}(_e,xe)}).join(" ")}(Be,qe),M("xrange",Be),Be=function(et,xe){return M("replaceStars",et,xe),et.trim().replace($[pe],"")}(Be,qe),M("stars",Be),Be}(Ae,G)}).join(" ").split(/\s+/);return this.loose&&(re=re.filter(function(Ae){return!!Ae.match(ee)})),re=re.map(function(Ae){return new le(Ae,G)})},Oe.prototype.intersects=function(F,G){if(!(F instanceof Oe))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ee){return F.set.some(function(re){return re.every(function(Ae){return ee.intersects(Ae,G)})})})})},e.toComparators=function(F,G){return new Oe(F,G).set.map(function(H){return H.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Oe.prototype.test=function(F){if(!F)return!1;typeof F=="string"&&(F=new Re(F,this.loose));for(var G=0;G<this.set.length;G++)if(Me(this.set[G],F))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(F,G,H){var ee=null,re=null;try{var Ae=new Oe(G,H)}catch{return null}return F.forEach(function(Be){Ae.test(Be)&&(ee&&re.compare(Be)!==-1||(re=new Re(ee=Be,H)))}),ee},e.minSatisfying=function(F,G,H){var ee=null,re=null;try{var Ae=new Oe(G,H)}catch{return null}return F.forEach(function(Be){Ae.test(Be)&&(ee&&re.compare(Be)!==1||(re=new Re(ee=Be,H)))}),ee},e.validRange=function(F,G){try{return new Oe(F,G).range||"*"}catch{return null}},e.ltr=function(F,G,H){return U(F,G,"<",H)},e.gtr=function(F,G,H){return U(F,G,">",H)},e.outside=U,e.prerelease=function(F,G){var H=ae(F,G);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(F,G,H){return F=new Oe(F,H),G=new Oe(G,H),F.intersects(G)},e.coerce=function(F){if(F instanceof Re)return F;if(typeof F!="string")return null;var G=F.match($[k]);return G==null?null:ae((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,P(1))},function(he,e){var P,O,M=he.exports={};function N(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function $(s){if(P===setTimeout)return setTimeout(s,0);if((P===N||!P)&&setTimeout)return P=setTimeout,setTimeout(s,0);try{return P(s,0)}catch{try{return P.call(null,s,0)}catch{return P.call(this,s,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:N}catch{P=N}try{O=typeof clearTimeout=="function"?clearTimeout:A}catch{O=A}})();var m,E=[],T=!1,S=-1;function l(){T&&m&&(T=!1,m.length?E=m.concat(E):S=-1,E.length&&b())}function b(){if(!T){var s=$(l);T=!0;for(var o=E.length;o;){for(m=E,E=[];++S<o;)m&&m[S].run();S=-1,o=E.length}m=null,T=!1,function(n){if(O===clearTimeout)return clearTimeout(n);if((O===A||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(n);try{O(n)}catch{try{return O.call(null,n)}catch{return O.call(this,n)}}}(s)}}function g(s,o){this.fun=s,this.array=o}function r(){}M.nextTick=function(s){var o=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)o[n-1]=arguments[n];E.push(new g(s,o)),E.length!==1||T||$(b)},g.prototype.run=function(){this.fun.apply(null,this.array)},M.title="browser",M.browser=!0,M.env={},M.argv=[],M.version="",M.versions={},M.on=r,M.addListener=r,M.once=r,M.off=r,M.removeListener=r,M.removeAllListeners=r,M.emit=r,M.prependListener=r,M.prependOnceListener=r,M.listeners=function(s){return[]},M.binding=function(s){throw new Error("process.binding is not supported")},M.cwd=function(){return"/"},M.chdir=function(s){throw new Error("process.chdir is not supported")},M.umask=function(){return 0}}])}),define(Se[134],Ie([1,0,14,6]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qe=M,e.$re=N,e.$se=A,e.$te=$,e.$ue=E,e.$ve=T,e.$we=S,e.$xe=l,e.$ye=b,e.$ze=g,e.$Ae=r,e.$Be=s,e.$Ce=o,e.$De=n,e.$Ee=i;function M(c){const u=c;return u?typeof u.read=="function":!1}function N(c){const u=c;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}function A(c){const u=c;return u?N(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}function $(c,u){return new m(c,u)}class m{constructor(u,t){this.e=u,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(t=>t(u))}h(u){this.c.error.length===0?(0,P.$1)(u):this.c.error.slice(0).forEach(t=>t(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,t){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(u,t){if(this.a.destroyed)return;let d;switch(u){case"data":d=this.c.data;break;case"end":d=this.c.end;break;case"error":d=this.c.error;break}if(d){const a=d.indexOf(t);a>=0&&d.splice(a,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(d=>d())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(c,u){const t=[];let d;for(;(d=c.read())!==null;)t.push(d);return u(t)}function T(c,u,t){const d=[];let a;for(;(a=c.read())!==null&&d.length<t;)d.push(a);return a===null&&d.length>0?u(d):{read:()=>{if(d.length>0)return d.shift();if(typeof a<"u"){const f=a;return a=void 0,f}return c.read()}}}function S(c,u){return new Promise((t,d)=>{const a=[];l(c,{onData:f=>{u&&a.push(f)},onError:f=>{u?d(f):t(void 0)},onEnd:()=>{t(u?u(a):void 0)}})})}function l(c,u,t){c.on("error",d=>{t?.isCancellationRequested||u.onError(d)}),c.on("end",()=>{t?.isCancellationRequested||u.onEnd()}),c.on("data",d=>{t?.isCancellationRequested||u.onData(d)})}function b(c,u){return new Promise((t,d)=>{const a=new O.$Tc,f=[],w=y=>{if(f.push(y),f.length>u)return a.dispose(),c.pause(),t({stream:c,buffer:f,ended:!1})},p=y=>(a.dispose(),d(y)),v=()=>(a.dispose(),t({stream:c,buffer:f,ended:!0}));a.add((0,O.$Sc)(()=>c.removeListener("error",p))),c.on("error",p),a.add((0,O.$Sc)(()=>c.removeListener("end",v))),c.on("end",v),a.add((0,O.$Sc)(()=>c.removeListener("data",w))),c.on("data",w)})}function g(c,u){const t=$(u);return t.end(c),t}function r(){const c=$(()=>{throw new Error("not supported")});return c.end(),c}function s(c){let u=!1;return{read:()=>u?null:(u=!0,c)}}function o(c,u,t){const d=$(t);return l(c,{onData:a=>d.write(u.data(a)),onError:a=>d.error(u.error?u.error(a):a),onEnd:()=>d.end()}),d}function n(c,u,t){let d=!1;return{read:()=>{const a=u.read();return d?a:(d=!0,a!==null?t([c,a]):c)}}}function i(c,u,t){let d=!1;const a=$(t);return l(u,{onData:f=>d?a.write(f):(d=!0,a.write(t([c,f]))),onError:f=>a.error(f),onEnd:()=>{d||(d=!0,a.write(c)),a.end()}}),a}}),define(Se[21],Ie([1,0,43,134]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fe=void 0,e.$Ge=E,e.$He=T,e.$Ie=S,e.$Je=l,e.$Ke=b,e.$Le=g,e.$Me=r,e.$Ne=s,e.$Oe=o,e.$Pe=n,e.$Qe=i,e.$Re=c,e.$Se=u,e.$Te=t,e.$Ue=d,e.$Ve=a,e.$We=f,e.$Xe=w,e.$Ye=p,e.$Ze=h;const M=typeof Buffer<"u",N=new P.$V(()=>new Uint8Array(256));let A,$;class m{static alloc(k){return M?new m(Buffer.allocUnsafe(k)):new m(new Uint8Array(k))}static wrap(k){return M&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new m(k)}static fromString(k,C){return!(C?.dontUseNodeBuffer||!1)&&M?new m(Buffer.from(k)):(A||(A=new TextEncoder),new m(A.encode(k)))}static fromByteArray(k){const C=m.alloc(k.length);for(let I=0,W=k.length;I<W;I++)C.buffer[I]=k[I];return C}static concat(k,C){if(typeof C>"u"){C=0;for(let V=0,q=k.length;V<q;V++)C+=k[V].byteLength}const I=m.alloc(C);let W=0;for(let V=0,q=k.length;V<q;V++){const R=k[V];I.set(R,W),W+=R.byteLength}return I}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=m.alloc(this.byteLength);return k.set(this),k}toString(){return M?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(k,C){return new m(this.buffer.subarray(k,C))}set(k,C){if(k instanceof m)this.buffer.set(k.buffer,C);else if(k instanceof Uint8Array)this.buffer.set(k,C);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),C);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return l(this.buffer,k)}writeUInt32BE(k,C){b(this.buffer,k,C)}readUInt32LE(k){return g(this.buffer,k)}writeUInt32LE(k,C){r(this.buffer,k,C)}readUInt8(k){return s(this.buffer,k)}writeUInt8(k,C){o(this.buffer,k,C)}indexOf(k,C=0){return E(this.buffer,k instanceof m?k.buffer:k,C)}}e.$Fe=m;function E(D,k,C=0){const I=k.byteLength,W=D.byteLength;if(I===0)return 0;if(I===1)return D.indexOf(k[0]);if(I>W-C)return-1;const V=N.value;V.fill(k.length);for(let K=0;K<k.length;K++)V[k[K]]=k.length-K-1;let q=C+k.length-1,R=q,B=-1;for(;q<W;)if(D[q]===k[R]){if(R===0){B=q;break}q--,R--}else q+=Math.max(k.length-R,V[D[q]]),R=k.length-1;return B}function T(D,k){return D[k+0]<<0>>>0|D[k+1]<<8>>>0}function S(D,k,C){D[C+0]=k&255,k=k>>>8,D[C+1]=k&255}function l(D,k){return D[k]*2**24+D[k+1]*2**16+D[k+2]*2**8+D[k+3]}function b(D,k,C){D[C+3]=k,k=k>>>8,D[C+2]=k,k=k>>>8,D[C+1]=k,k=k>>>8,D[C]=k}function g(D,k){return D[k+0]<<0>>>0|D[k+1]<<8>>>0|D[k+2]<<16>>>0|D[k+3]<<24>>>0}function r(D,k,C){D[C+0]=k&255,k=k>>>8,D[C+1]=k&255,k=k>>>8,D[C+2]=k&255,k=k>>>8,D[C+3]=k&255}function s(D,k){return D[k]}function o(D,k,C){D[C]=k}function n(D){return O.$ue(D,k=>m.concat(k))}function i(D){return O.$Be(D)}function c(D){return O.$we(D,k=>m.concat(k))}async function u(D){return D.ended?m.concat(D.buffer):m.concat([...D.buffer,await c(D.stream)])}function t(D){return O.$ze(D,k=>m.concat(k))}function d(D){return O.$Ce(D,{data:k=>typeof k=="string"?m.fromString(k):m.wrap(k)},k=>m.concat(k))}function a(D){return O.$te(k=>m.concat(k),D)}function f(D,k){return O.$De(D,k,C=>m.concat(C))}function w(D,k){return O.$Ee(D,k,C=>m.concat(C))}function p(D){let k=0,C=0,I=0;const W=new Uint8Array(Math.floor(D.length/4*3)),V=R=>{switch(C){case 3:W[I++]=k|R,C=0;break;case 2:W[I++]=k|R>>>2,k=R<<6,C=3;break;case 1:W[I++]=k|R>>>4,k=R<<4,C=2;break;default:k=R<<2,C=1}};for(let R=0;R<D.length;R++){const B=D.charCodeAt(R);if(B>=65&&B<=90)V(B-65);else if(B>=97&&B<=122)V(B-97+26);else if(B>=48&&B<=57)V(B-48+52);else if(B===43||B===45)V(62);else if(B===47||B===95)V(63);else{if(B===61)break;throw new SyntaxError(`Unexpected base64 character ${D[R]}`)}}const q=I;for(;C>0;)V(0);return m.wrap(W).slice(0,q)}const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:D},k=!0,C=!1){const I=C?y:v;let W="";const V=D.byteLength%3;let q=0;for(;q<D.byteLength-V;q+=3){const R=D[q+0],B=D[q+1],K=D[q+2];W+=I[R>>>2],W+=I[(R<<4|B>>>4)&63],W+=I[(B<<2|K>>>6)&63],W+=I[K&63]}if(V===1){const R=D[q+0];W+=I[R>>>2],W+=I[R<<4&63],k&&(W+="==")}else if(V===2){const R=D[q+0],B=D[q+1];W+=I[R>>>2],W+=I[(R<<4|B>>>4)&63],W+=I[B<<2&63],k&&(W+="=")}return W}}),define(Se[135],Ie([1,0,28,128,13]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=e.FuzzyScore=e.$yk=e.$xk=void 0,e.or=N,e.$zk=$,e.$Ak=m,e.$Bk=S,e.$Ck=p,e.$Dk=v,e.$Ek=I,e.$Fk=W,e.$Gk=V,e.$Hk=q,e.$Ik=x,e.$Kk=we,e.$Lk=Y,e.$Mk=le;function N(...de){return function(Ce,Me){for(let je=0,U=de.length;je<U;je++){const F=de[je](Ce,Me);if(F)return F}return null}}e.$xk=A.bind(void 0,!1),e.$yk=A.bind(void 0,!0);function A(de,Ce,Me){if(!Me||Me.length<Ce.length)return null;let je;return de?je=M.$yf(Me,Ce):je=Me.indexOf(Ce)===0,je?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function $(de,Ce){const Me=Ce.toLowerCase().indexOf(de.toLowerCase());return Me===-1?null:[{start:Me,end:Me+de.length}]}function m(de,Ce){return E(de.toLowerCase(),Ce.toLowerCase(),0,0)}function E(de,Ce,Me,je){if(Me===de.length)return[];if(je===Ce.length)return null;if(de[Me]===Ce[je]){let U=null;return(U=E(de,Ce,Me+1,je+1))?c({start:je,end:je+1},U):null}return E(de,Ce,Me,je+1)}function T(de){return 97<=de&&de<=122}function S(de){return 65<=de&&de<=90}function l(de){return 48<=de&&de<=57}function b(de){return de===32||de===9||de===10||de===13}const g=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(de=>g.add(de.charCodeAt(0)));function r(de){return b(de)||g.has(de)}function s(de,Ce){return de===Ce||r(de)&&r(Ce)}const o=new Map;function n(de){if(o.has(de))return o.get(de);let Ce;const Me=(0,O.$vk)(de);return Me&&(Ce=Me),o.set(de,Ce),Ce}function i(de){return T(de)||S(de)||l(de)}function c(de,Ce){return Ce.length===0?Ce=[de]:de.end===Ce[0].start?Ce[0].start=de.start:Ce.unshift(de),Ce}function u(de,Ce){for(let Me=Ce;Me<de.length;Me++){const je=de.charCodeAt(Me);if(S(je)||l(je)||Me>0&&!i(de.charCodeAt(Me-1)))return Me}return de.length}function t(de,Ce,Me,je){if(Me===de.length)return[];if(je===Ce.length)return null;if(de[Me]!==Ce[je].toLowerCase())return null;{let U=null,F=je+1;for(U=t(de,Ce,Me+1,je+1);!U&&(F=u(Ce,F))<Ce.length;)U=t(de,Ce,Me+1,F),F++;return U===null?null:c({start:je,end:je+1},U)}}function d(de){let Ce=0,Me=0,je=0,U=0,F=0;for(let Ae=0;Ae<de.length;Ae++)F=de.charCodeAt(Ae),S(F)&&Ce++,T(F)&&Me++,i(F)&&je++,l(F)&&U++;const G=Ce/de.length,H=Me/de.length,ee=je/de.length,re=U/de.length;return{upperPercent:G,lowerPercent:H,alphaPercent:ee,numericPercent:re}}function a(de){const{upperPercent:Ce,lowerPercent:Me}=de;return Me===0&&Ce>.6}function f(de){const{upperPercent:Ce,lowerPercent:Me,alphaPercent:je,numericPercent:U}=de;return Me>.2&&Ce<.8&&je>.6&&U<.2}function w(de){let Ce=0,Me=0,je=0,U=0;for(let F=0;F<de.length;F++)je=de.charCodeAt(F),S(je)&&Ce++,T(je)&&Me++,b(je)&&U++;return(Ce===0||Me===0)&&U===0?de.length<=30:Ce<=5}function p(de,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!w(de))return null;Ce.length>60&&(Ce=Ce.substring(0,60));const Me=d(Ce);if(!f(Me)){if(!a(Me))return null;Ce=Ce.toLowerCase()}let je=null,U=0;for(de=de.toLowerCase();U<Ce.length&&(je=t(de,Ce,0,U))===null;)U=u(Ce,U+1);return je}function v(de,Ce,Me=!1){if(!Ce||Ce.length===0)return null;let je=null,U=0;for(de=de.toLowerCase(),Ce=Ce.toLowerCase();U<Ce.length&&(je=y(de,Ce,0,U,Me),je===null);)U=h(Ce,U+1);return je}function y(de,Ce,Me,je,U){let F=0;if(Me===de.length)return[];if(je===Ce.length)return null;if(!s(de.charCodeAt(Me),Ce.charCodeAt(je))){const ee=n(de.charCodeAt(Me));if(!ee)return null;for(let re=0;re<ee.length;re++)if(!s(ee[re],Ce.charCodeAt(je+re)))return null;F+=ee.length-1}let G=null,H=je+F+1;if(G=y(de,Ce,Me+1,H,U),!U)for(;!G&&(H=h(Ce,H))<Ce.length;)G=y(de,Ce,Me+1,H,U),H++;if(!G)return null;if(de.charCodeAt(Me)!==Ce.charCodeAt(je)){const ee=n(de.charCodeAt(Me));if(!ee)return G;for(let re=0;re<ee.length;re++)if(ee[re]!==Ce.charCodeAt(je+re))return G}return c({start:je,end:je+F+1},G)}function h(de,Ce){for(let Me=Ce;Me<de.length;Me++)if(r(de.charCodeAt(Me))||Me>0&&r(de.charCodeAt(Me-1)))return Me;return de.length}const D=N(e.$yk,p,$),k=N(e.$yk,p,m),C=new P.$Dc(1e4);function I(de,Ce,Me=!1){if(typeof de!="string"||typeof Ce!="string")return null;let je=C.get(de);je||(je=new RegExp(M.$gf(de),"i"),C.set(de,je));const U=je.exec(Ce);return U?[{start:U.index,end:U.index+U[0].length}]:Me?k(de,Ce):D(de,Ce)}function W(de,Ce){const Me=we(de,de.toLowerCase(),0,Ce,Ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Me?q(Me):null}function V(de,Ce,Me,je,U,F){const G=Math.min(13,de.length);for(;Me<G;Me++){const H=we(de,Ce,Me,je,U,F,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return H}return[0,F]}function q(de){if(typeof de>"u")return[];const Ce=[],Me=de[1];for(let je=de.length-1;je>1;je--){const U=de[je]+Me,F=Ce[Ce.length-1];F&&F.end===U?F.end=U+1:Ce.push({start:U,end:U+1})}return Ce}const R=128;function B(){const de=[],Ce=[];for(let Me=0;Me<=R;Me++)Ce[Me]=0;for(let Me=0;Me<=R;Me++)de.push(Ce.slice(0));return de}function K(de){const Ce=[];for(let Me=0;Me<=de;Me++)Ce[Me]=0;return Ce}const ie=K(2*R),ce=K(2*R),ve=B(),ke=B(),fe=B(),pe=!1;function Ne(de,Ce,Me,je,U){function F(H,ee,re=" "){for(;H.length<ee;)H=re+H;return H}let G=` |   |${je.split("").map(H=>F(H,3)).join("|")}
`;for(let H=0;H<=Me;H++)H===0?G+=" |":G+=`${Ce[H-1]}|`,G+=de[H].slice(0,U+1).map(ee=>F(ee.toString(),3)).join("|")+`
`;return G}function ae(de,Ce,Me,je){de=de.substr(Ce),Me=Me.substr(je),console.log(Ne(ke,de,de.length,Me,Me.length)),console.log(Ne(fe,de,de.length,Me,Me.length)),console.log(Ne(ve,de,de.length,Me,Me.length))}function Re(de,Ce){if(Ce<0||Ce>=de.length)return!1;const Me=de.codePointAt(Ce);switch(Me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$Qf(Me)}}function ne(de,Ce){if(Ce<0||Ce>=de.length)return!1;switch(de.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function z(de,Ce,Me){return Ce[de]!==Me[de]}function x(de,Ce,Me,je,U,F,G=!1){for(;Ce<Me&&U<F;)de[Ce]===je[U]&&(G&&(ie[Ce]=U),Ce+=1),U+=1;return Ce===Me}var be;(function(de){de[de.Diag=1]="Diag",de[de.Left=2]="Left",de[de.LeftLeft=3]="LeftLeft"})(be||(be={}));var Te;(function(de){de.Default=[-100,0];function Ce(Me){return!Me||Me.length===2&&Me[0]===-100&&Me[1]===0}de.isDefault=Ce})(Te||(e.FuzzyScore=Te={}));class De{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ce,Me){this.firstMatchCanBeWeak=Ce,this.boostFullMatch=Me}}e.$Jk=De;function we(de,Ce,Me,je,U,F,G=De.default){const H=de.length>R?R:de.length,ee=je.length>R?R:je.length;if(Me>=H||F>=ee||H-Me>ee-F||!x(Ce,Me,H,U,F,ee,!0))return;ge(H,ee,Me,F,Ce,U);let re=1,Ae=1,Be=Me,qe=F;const et=[!1];for(re=1,Be=Me;Be<H;re++,Be++){const ct=ie[Be],ft=ce[Be],Ue=Be+1<H?ce[Be+1]:ee;for(Ae=ct-F+1,qe=ct;qe<Ue;Ae++,qe++){let ot=Number.MIN_SAFE_INTEGER,X=!1;qe<=ft&&(ot=Q(de,Ce,Be,Me,je,U,qe,ee,F,ve[re-1][Ae-1]===0,et));let Z=0;ot!==Number.MAX_SAFE_INTEGER&&(X=!0,Z=ot+ke[re-1][Ae-1]);const $e=qe>ct,me=$e?ke[re][Ae-1]+(ve[re][Ae-1]>0?-5:0):0,Ze=qe>ct+1&&ve[re][Ae-1]>0,at=Ze?ke[re][Ae-2]+(ve[re][Ae-2]>0?-5:0):0;if(Ze&&(!$e||at>=me)&&(!X||at>=Z))ke[re][Ae]=at,fe[re][Ae]=3,ve[re][Ae]=0;else if($e&&(!X||me>=Z))ke[re][Ae]=me,fe[re][Ae]=2,ve[re][Ae]=0;else if(X)ke[re][Ae]=Z,fe[re][Ae]=1,ve[re][Ae]=ve[re-1][Ae-1]+1;else throw new Error("not possible")}}if(pe&&ae(de,Me,je,F),!et[0]&&!G.firstMatchCanBeWeak)return;re--,Ae--;const xe=[ke[re][Ae],F];let _e=0,tt=0;for(;re>=1;){let ct=Ae;do{const ft=fe[re][ct];if(ft===3)ct=ct-2;else if(ft===2)ct=ct-1;else break}while(ct>=1);_e>1&&Ce[Me+re-1]===U[F+Ae-1]&&!z(ct+F-1,je,U)&&_e+1>ve[re][ct]&&(ct=Ae),ct===Ae?_e++:_e=1,tt||(tt=ct),re--,Ae=ct-1,xe.push(Ae)}ee-F===H&&G.boostFullMatch&&(xe[0]+=2);const rt=tt-H;return xe[0]-=rt,xe}function ge(de,Ce,Me,je,U,F){let G=de-1,H=Ce-1;for(;G>=Me&&H>=je;)U[G]===F[H]&&(ce[G]=H,G--),H--}function Q(de,Ce,Me,je,U,F,G,H,ee,re,Ae){if(Ce[Me]!==F[G])return Number.MIN_SAFE_INTEGER;let Be=1,qe=!1;return G===Me-je?Be=de[Me]===U[G]?7:5:z(G,U,F)&&(G===0||!z(G-1,U,F))?(Be=de[Me]===U[G]?7:5,qe=!0):Re(F,G)&&(G===0||!Re(F,G-1))?Be=5:(Re(F,G-1)||ne(F,G-1))&&(Be=5,qe=!0),Be>1&&Me===je&&(Ae[0]=!0),qe||(qe=z(G,U,F)||Re(F,G-1)||ne(F,G-1)),Me===je?G>ee&&(Be-=qe?3:5):re?Be+=qe?2:0:Be+=qe?0:1,G+1===H&&(Be-=qe?3:5),Be}function Y(de,Ce,Me,je,U,F,G){return ue(de,Ce,Me,je,U,F,!0,G)}function le(de,Ce,Me,je,U,F,G){return ue(de,Ce,Me,je,U,F,!1,G)}function ue(de,Ce,Me,je,U,F,G,H){let ee=we(de,Ce,Me,je,U,F,H);if(ee&&!G)return ee;if(de.length>=3){const re=Math.min(7,de.length-1);for(let Ae=Me+1;Ae<re;Ae++){const Be=Oe(de,Ae);if(Be){const qe=we(Be,Be.toLowerCase(),Me,je,U,F,H);qe&&(qe[0]-=3,(!ee||qe[0]>ee[0])&&(ee=qe))}}}return ee}function Oe(de,Ce){if(Ce+1>=de.length)return;const Me=de[Ce],je=de[Ce+1];if(Me!==je)return de.slice(0,Ce)+je+Me+de.slice(Ce+2)}}),define(Se[32],Ie([1,0,13]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(M){M[M.Ignore=0]="Ignore",M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})(O||(O={})),function(M){const N="error",A="warning",$="warn",m="info",E="ignore";function T(l){return l?P.$xf(N,l)?M.Error:P.$xf(A,l)||P.$xf($,l)?M.Warning:P.$xf(m,l)?M.Info:M.Ignore:M.Ignore}M.fromValue=T;function S(l){switch(l){case M.Error:return N;case M.Warning:return A;case M.Info:return m;default:return E}}M.toString=S}(O||(O={})),e.default=O}),define(Se[136],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=void 0,e.$ae=Symbol("MicrotaskDelay")}),define(Se[54],Ie([1,0,18,13]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=void 0;class M{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const g=b.charCodeAt(0),r=this.b.charCodeAt(this.c);return g-r}value(){return this.b[this.c]}}e.$yi=M;class N{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,O.$rf)(b,this.b,0,b.length,this.c,this.d):(0,O.$tf)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$zi=N;class A{constructor(b=!0,g=!0){this.f=b,this.g=g}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let g=b.length-1;g>=0;g--,this.c--){const r=this.b.charCodeAt(g);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,O.$rf)(b,this.b,0,b.length,this.d,this.e):(0,O.$tf)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ai=A;var $;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})($||($={}));class m{constructor(b,g){this.f=b,this.g=g,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,O.$sf)(b,this.c.scheme);if(this.d[this.e]===2)return(0,O.$sf)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,O.$qf)(b,this.c.query);if(this.d[this.e]===5)return(0,O.$qf)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Bi=m;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(T||(T={}));class S{static forUris(b=()=>!1,g=()=>!1){return new S(new m(b,g))}static forPaths(b=!1){return new S(new A(void 0,!b))}static forStrings(){return new S(new M)}static forConfigKeys(){return new S(new N)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,g){if(g){const r=g.slice(0);(0,P.$Wb)(r);for(const s of r)this.set(s,b)}else{const r=b.slice(0);(0,P.$Wb)(r);for(const s of r)this.set(s[0],s[1])}}set(b,g){const r=this.b.reset(b);let s;this.c||(this.c=new E,this.c.segment=r.value());const o=[];for(s=this.c;;){const i=r.cmp(s.segment);if(i>0)s.left||(s.left=new E,s.left.segment=r.value()),o.push([-1,s]),s=s.left;else if(i<0)s.right||(s.right=new E,s.right.segment=r.value()),o.push([1,s]),s=s.right;else if(r.hasNext())r.next(),s.mid||(s.mid=new E,s.mid.segment=r.value()),o.push([0,s]),s=s.mid;else break}const n=s.value;s.value=g,s.key=b;for(let i=o.length-1;i>=0;i--){const c=o[i][1];c.updateHeight();const u=c.balanceFactor();if(u<-1||u>1){const t=o[i][0],d=o[i+1][0];if(t===1&&d===1)o[i][1]=c.rotateLeft();else if(t===-1&&d===-1)o[i][1]=c.rotateRight();else if(t===1&&d===-1)c.right=o[i+1][1]=o[i+1][1].rotateRight(),o[i][1]=c.rotateLeft();else if(t===-1&&d===1)c.left=o[i+1][1]=o[i+1][1].rotateLeft(),o[i][1]=c.rotateRight();else throw new Error;if(i>0)switch(o[i-1][0]){case-1:o[i-1][1].left=o[i][1];break;case 1:o[i-1][1].right=o[i][1];break;case 0:o[i-1][1].mid=o[i][1];break}else this.c=o[0][1]}}return n}get(b){return this.d(b)?.value}d(b){const g=this.b.reset(b);let r=this.c;for(;r;){const s=g.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(g.hasNext())g.next(),r=r.mid;else break}return r}has(b){const g=this.d(b);return!(g?.value===void 0&&g?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,g){const r=this.b.reset(b),s=[];let o=this.c;for(;o;){const n=r.cmp(o.segment);if(n>0)s.push([-1,o]),o=o.left;else if(n<0)s.push([1,o]),o=o.right;else if(r.hasNext())r.next(),s.push([0,o]),o=o.mid;else break}if(o){if(g?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const n=this.f(o.right);if(n.key){const{key:i,value:c,segment:u}=n;this.e(n.key,!1),o.key=i,o.value=c,o.segment=u}}else{const n=o.left??o.right;if(s.length>0){const[i,c]=s[s.length-1];switch(i){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=s.length-1;n>=0;n--){const i=s[n][1];i.updateHeight();const c=i.balanceFactor();if(c>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),s[n][1]=i.rotateLeft()):c<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),s[n][1]=i.rotateRight()),n>0)switch(s[n-1][0]){case-1:s[n-1][1].left=s[n][1];break;case 1:s[n-1][1].right=s[n][1];break;case 0:s[n-1][1].mid=s[n][1];break}else this.c=s[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const g=this.b.reset(b);let r=this.c,s;for(;r;){const o=g.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(g.hasNext())g.next(),s=r.value||s,r=r.mid;else break}return r&&r.value||s}findSuperstr(b){return this.g(b,!1)}g(b,g){const r=this.b.reset(b);let s=this.c;for(;s;){const o=r.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(r.hasNext())r.next(),s=s.mid;else return s.mid?this.h(s.mid):g?s.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[g,r]of this)b(r,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const g=[];return this.j(b,g),g[Symbol.iterator]()}j(b,g){b&&(b.left&&this.j(b.left,g),b.value&&g.push([b.key,b.value]),b.mid&&this.j(b.mid,g),b.right&&this.j(b.right,g))}_isBalanced(){const b=g=>{if(!g)return!0;const r=g.balanceFactor();return r<-1||r>1?!1:b(g.left)&&b(g.right)};return b(this.c)}}e.$Ci=S}),define(Se[36],Ie([1,0,92]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Wj=M;var O;(function(A){function $(m){return m&&typeof m=="object"&&typeof m.id=="string"}A.isThemeColor=$})(O||(e.ThemeColor=O={}));function M(A){return{id:A}}var N;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function m(n){const i=$.exec(n.id);if(!i)return m(P.$Vj.error);const[,c,u]=i,t=["codicon","codicon-"+c];return u&&t.push("codicon-modifier-"+u.substring(1)),t}A.asClassNameArray=m;function E(n){return m(n).join(" ")}A.asClassName=E;function T(n){return"."+m(n).join(".")}A.asCSSSelector=T;function S(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||O.isThemeColor(n.color))}A.isThemeIcon=S;const l=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function b(n){const i=l.exec(n);if(!i)return;const[,c]=i;return{id:c}}A.fromString=b;function g(n){return{id:n}}A.fromId=g;function r(n,i){let c=n.id;const u=c.lastIndexOf("~");return u!==-1&&(c=c.substring(0,u)),i&&(c=`${c}~${i}`),{id:c}}A.modify=r;function s(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}A.getModifier=s;function o(n,i){return n.id===i.id&&n.color?.id===i.color?.id}A.isEqual=o})(N||(e.ThemeIcon=N={}))}),define(Se[137],Ie([1,0,135,13,36]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=m,e.$Ok=T,e.$Pk=l,e.$Qk=b,e.$Rk=r,e.$Sk=s;const N="$(",A=new RegExp(`\\$\\(${M.ThemeIcon.iconNameExpression}(?:${M.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${A.source}`,"g");function m(o){return o.replace($,(n,i)=>i?n:`\\${n}`)}const E=new RegExp(`\\\\${A.source}`,"g");function T(o){return o.replace(E,n=>`\\${n}`)}const S=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function l(o){return o.indexOf(N)===-1?o:o.replace(S,(n,i,c,u)=>c?n:i||u||"")}function b(o){return o?o.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const g=new RegExp(`\\$\\(${M.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(o){g.lastIndex=0;let n="";const i=[];let c=0;for(;;){const u=g.lastIndex,t=g.exec(o),d=o.substring(u,t?.index);if(d.length>0){n+=d;for(let a=0;a<d.length;a++)i.push(c)}if(!t)break;c+=t[0].length}return{text:n,iconOffsets:i}}function s(o,n,i=!1){const{text:c,iconOffsets:u}=n;if(!u||u.length===0)return(0,P.$Ek)(o,c,i);const t=(0,O.$ef)(c," "),d=c.length-t.length,a=(0,P.$Ek)(o,t,i);if(a)for(const f of a){const w=u[f.start+d]+d;f.start+=w,f.end+=w}return a}}),define(Se[33],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=void 0,e.$Rg=O;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(M){return P.test(M)}e.$Sg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function($){for(let m=0;m<$.length;m++)$[m]=Math.floor(Math.random()*256);return $};const N=new Uint8Array(16),A=[];for(let $=0;$<256;$++)A.push($.toString(16).padStart(2,"0"));return function(){M(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let m=0,E="";return E+=A[N[m++]],E+=A[N[m++]],E+=A[N[m++]],E+=A[N[m++]],E+="-",E+=A[N[m++]],E+=A[N[m++]],E+="-",E+=A[N[m++]],E+=A[N[m++]],E+="-",E+=A[N[m++]],E+=A[N[m++]],E+="-",E+=A[N[m++]],E+=A[N[m++]],E+=A[N[m++]],E+=A[N[m++]],E+=A[N[m++]],E+=A[N[m++]],E}}()}),define(Se[138],Ie([1,0,18,42,33]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=e.$St=void 0,e.$Qt=N,e.$Rt=A,e.$Tt=E;function N(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}function A(S,l,b){const g={id:(0,M.$Sg)(),name:S,uri:l,data:b};return{asString:async()=>"",asFile:()=>g,value:void 0}}class ${constructor(){this.a=new Map}get size(){let l=0;for(const b of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const b=[...this.a.keys()];return O.Iterable.some(this,([g,r])=>r.asFile())&&b.push("files"),T(m(l),b)}get(l){return this.a.get(this.b(l))?.[0]}append(l,b){const g=this.a.get(l);g?g.push(b):this.a.set(this.b(l),[b])}replace(l,b){this.a.set(this.b(l),[b])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,b]of this.a)for(const g of b)yield[l,g]}b(l){return m(l)}}e.$St=$;function m(S){return S.toLowerCase()}function E(S,l){return T(m(S),l.map(m))}function T(S,l){if(S==="*/*")return l.length>0;if(l.includes(S))return!0;const b=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[g,r,s]=b;return s==="*"?l.some(o=>o.startsWith(r+"/")):!1}e.$Ut=Object.freeze({create:S=>(0,P.$Mb)(S.map(l=>l.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$Ut.split(S).filter(l=>!l.startsWith("#"))})}),define(Se[139],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$1t=O;var P;(function(M){M[M.Unknown=0]="Unknown",M[M.Invalid=3]="Invalid",M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(P||(e.StringEOL=P={}));function O(M){let N=0,A=0,$=0,m=0;for(let E=0,T=M.length;E<T;E++){const S=M.charCodeAt(E);S===13?(N===0&&(A=E),N++,E+1<T&&M.charCodeAt(E+1)===10?(m|=2,E++):m|=3,$=E+1):S===10&&(m|=1,N===0&&(A=E),N++,$=E+1)}return N===0&&(A=M.length),[N,A,M.length-$,m]}}),define(Se[140],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=void 0,e.$4s={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[141],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lu=e.$ku=e.IndentAction=void 0;var P;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(P||(e.IndentAction=P={}));class O{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let m=0,E=$.notIn.length;m<E;m++)switch($.notIn[m]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,m){if($.getTokenCount()===0)return!0;const E=$.findTokenIndexAtOffset(m-2),T=$.getStandardTokenType(E);return this.isOK(T)}g($,m){for(let E=$;E<=m;E++){const T=String.fromCharCode(E);if(!this.open.includes(T)&&!this.close.includes(T))return T}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$ku=O;class M{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const m of $)N(this.autoClosingPairsOpenByStart,m.open.charAt(0),m),N(this.autoClosingPairsOpenByEnd,m.open.charAt(m.open.length-1),m),N(this.autoClosingPairsCloseByStart,m.close.charAt(0),m),N(this.autoClosingPairsCloseByEnd,m.close.charAt(m.close.length-1),m),m.close.length===1&&m.open.length===1&&N(this.autoClosingPairsCloseSingleChar,m.close,m)}}e.$lu=M;function N(A,$,m){A.has($)?A.get($).push(m):A.set($,[m])}}),define(Se[142],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GC=e.NodeColor=e.$FC=void 0,e.$HC=M,e.$IC=N,e.$JC=E,e.$KC=T,e.$LC=S,e.$MC=l,e.$NC=b,e.$OC=g;class P{constructor(s,o){this.piece=s,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$GC)return M(this.right);let s=this;for(;s.parent!==e.$GC&&s.parent.left!==s;)s=s.parent;return s.parent===e.$GC?e.$GC:s.parent}prev(){if(this.left!==e.$GC)return N(this.left);let s=this;for(;s.parent!==e.$GC&&s.parent.right!==s;)s=s.parent;return s.parent===e.$GC?e.$GC:s.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$FC=P;var O;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(O||(e.NodeColor=O={})),e.$GC=new P(null,0),e.$GC.parent=e.$GC,e.$GC.left=e.$GC,e.$GC.right=e.$GC,e.$GC.color=0;function M(r){for(;r.left!==e.$GC;)r=r.left;return r}function N(r){for(;r.right!==e.$GC;)r=r.right;return r}function A(r){return r===e.$GC?0:r.size_left+r.piece.length+A(r.right)}function $(r){return r===e.$GC?0:r.lf_left+r.piece.lineFeedCnt+$(r.right)}function m(){e.$GC.parent=e.$GC}function E(r,s){const o=s.right;o.size_left+=s.size_left+(s.piece?s.piece.length:0),o.lf_left+=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),s.right=o.left,o.left!==e.$GC&&(o.left.parent=s),o.parent=s.parent,s.parent===e.$GC?r.root=o:s.parent.left===s?s.parent.left=o:s.parent.right=o,o.left=s,s.parent=o}function T(r,s){const o=s.left;s.left=o.right,o.right!==e.$GC&&(o.right.parent=s),o.parent=s.parent,s.size_left-=o.size_left+(o.piece?o.piece.length:0),s.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),s.parent===e.$GC?r.root=o:s===s.parent.right?s.parent.right=o:s.parent.left=o,o.right=s,s.parent=o}function S(r,s){let o,n;if(s.left===e.$GC?(n=s,o=n.right):s.right===e.$GC?(n=s,o=n.left):(n=M(s.right),o=n.right),n===r.root){r.root=o,o.color=0,s.detach(),m(),r.root.parent=e.$GC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=o:n.parent.right=o,n===s?(o.parent=n.parent,g(r,o)):(n.parent===s?o.parent=n:o.parent=n.parent,g(r,o),n.left=s.left,n.right=s.right,n.parent=s.parent,n.color=s.color,s===r.root?r.root=n:s===s.parent.left?s.parent.left=n:s.parent.right=n,n.left!==e.$GC&&(n.left.parent=n),n.right!==e.$GC&&(n.right.parent=n),n.size_left=s.size_left,n.lf_left=s.lf_left,g(r,n)),s.detach(),o.parent.left===o){const u=A(o),t=$(o);if(u!==o.parent.size_left||t!==o.parent.lf_left){const d=u-o.parent.size_left,a=t-o.parent.lf_left;o.parent.size_left=u,o.parent.lf_left=t,b(r,o.parent,d,a)}}if(g(r,o.parent),i){m();return}let c;for(;o!==r.root&&o.color===0;)o===o.parent.left?(c=o.parent.right,c.color===1&&(c.color=0,o.parent.color=1,E(r,o.parent),c=o.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,o=o.parent):(c.right.color===0&&(c.left.color=0,c.color=1,T(r,c),c=o.parent.right),c.color=o.parent.color,o.parent.color=0,c.right.color=0,E(r,o.parent),o=r.root)):(c=o.parent.left,c.color===1&&(c.color=0,o.parent.color=1,T(r,o.parent),c=o.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,o=o.parent):(c.left.color===0&&(c.right.color=0,c.color=1,E(r,c),c=o.parent.left),c.color=o.parent.color,o.parent.color=0,c.left.color=0,T(r,o.parent),o=r.root));o.color=0,m()}function l(r,s){for(g(r,s);s!==r.root&&s.parent.color===1;)if(s.parent===s.parent.parent.left){const o=s.parent.parent.right;o.color===1?(s.parent.color=0,o.color=0,s.parent.parent.color=1,s=s.parent.parent):(s===s.parent.right&&(s=s.parent,E(r,s)),s.parent.color=0,s.parent.parent.color=1,T(r,s.parent.parent))}else{const o=s.parent.parent.left;o.color===1?(s.parent.color=0,o.color=0,s.parent.parent.color=1,s=s.parent.parent):(s===s.parent.left&&(s=s.parent,T(r,s)),s.parent.color=0,s.parent.parent.color=1,E(r,s.parent.parent))}r.root.color=0}function b(r,s,o,n){for(;s!==r.root&&s!==e.$GC;)s.parent.left===s&&(s.parent.size_left+=o,s.parent.lf_left+=n),s=s.parent}function g(r,s){let o=0,n=0;if(s!==r.root){for(;s!==r.root&&s===s.parent.right;)s=s.parent;if(s!==r.root)for(s=s.parent,o=A(s.left)-s.size_left,n=$(s.left)-s.lf_left,s.size_left+=o,s.lf_left+=n;s!==r.root&&(o!==0||n!==0);)s.parent.left===s&&(s.parent.size_left+=o,s.parent.lf_left+=n),s=s.parent}}}),define(Se[93],Ie([1,0,94,30,95,142,96]),function(he,e,P,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZC=e.$YC=e.$XC=void 0,e.$VC=T,e.$WC=S;const $=65535;function m(o){let n;return o[o.length-1]<65536?n=new Uint16Array(o.length):n=new Uint32Array(o.length),n.set(o,0),n}class E{constructor(n,i,c,u,t){this.lineStarts=n,this.cr=i,this.lf=c,this.crlf=u,this.isBasicASCII=t}}function T(o,n=!0){const i=[0];let c=1;for(let u=0,t=o.length;u<t;u++){const d=o.charCodeAt(u);d===13?u+1<t&&o.charCodeAt(u+1)===10?(i[c++]=u+2,u++):i[c++]=u+1:d===10&&(i[c++]=u+1)}return n?m(i):i}function S(o,n){o.length=0,o[0]=0;let i=1,c=0,u=0,t=0,d=!0;for(let f=0,w=n.length;f<w;f++){const p=n.charCodeAt(f);p===13?f+1<w&&n.charCodeAt(f+1)===10?(t++,o[i++]=f+2,f++):(c++,o[i++]=f+1):p===10?(u++,o[i++]=f+1):d&&p!==9&&(p<32||p>126)&&(d=!1)}const a=new E(m(o),c,u,t,d);return o.length=0,a}class l{constructor(n,i,c,u,t){this.bufferIndex=n,this.start=i,this.end=c,this.lineFeedCnt=u,this.length=t}}e.$XC=l;class b{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$YC=b;class g{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==N.$GC&&n.iterate(n.root,c=>(c!==N.$GC&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class r{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const c=this.b[i];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const c=this.b[i];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const c=this.b;for(let u=0;u<c.length;u++){const t=c[u];if(t.node.parent===null||t.nodeStartOffset>=n){c[u]=null,i=!0;continue}}if(i){const u=[];for(const t of c)t!==null&&u.push(t);this.b=u}}}class s{constructor(n,i,c){this.create(n,i,c)}create(n,i,c){this.a=[new b("",[0])],this.g={line:0,column:0},this.root=N.$GC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=c;let u=null;for(let t=0,d=n.length;t<d;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=T(n[t].buffer));const a=new l(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),u=this.S(u,a)}this.h=new r(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=$,c=i-Math.floor(i/3),u=c*2;let t="",d=0;const a=[];if(this.iterate(this.root,f=>{const w=this.R(f),p=w.length;if(d<=c||d+p<u)return t+=w,d+=p,!0;const v=t.replace(/\r\n|\r|\n/g,n);return a.push(new b(v,T(v))),t=w,d=p,!0}),d>0){const f=t.replace(/\r\n|\r|\n/g,n);a.push(new b(f,T(f)))}this.create(a,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new g(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,u=>{if(u===N.$GC)return!0;const t=this.R(u),d=t.length,a=n.G(i),f=n.G(i+d),w=n.getValueInRange2(a,f);return i+=d,t===w})}getOffsetAt(n,i){let c=0,u=this.root;for(;u!==N.$GC;)if(u.left!==N.$GC&&u.lf_left+1>=n)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt+1>=n){c+=u.size_left;const t=this.B(u,n-u.lf_left-2);return c+=t+i-1}else n-=u.lf_left+u.piece.lineFeedCnt,c+=u.size_left+u.piece.length,u=u.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,c=0;const u=n;for(;i!==N.$GC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(c+=i.lf_left+t.index,t.index===0){const d=this.getOffsetAt(c+1,1),a=u-d;return new P.$tt(c+1,a+1)}return new P.$tt(c+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,c+=i.lf_left+i.piece.lineFeedCnt,i.right===N.$GC){const t=this.getOffsetAt(c+1,1),d=u-n-t;return new P.$tt(c+1,d+1)}else i=i.right;return new P.$tt(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),u=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(c,u);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const a=n.node,f=this.a[a.piece.bufferIndex].buffer,w=this.u(a.piece.bufferIndex,a.piece.start);return f.substring(w+n.remainder,w+i.remainder)}let c=n.node;const u=this.a[c.piece.bufferIndex].buffer,t=this.u(c.piece.bufferIndex,c.piece.start);let d=u.substring(t+n.remainder,t+c.piece.length);for(c=c.next();c!==N.$GC;){const a=this.a[c.piece.bufferIndex].buffer,f=this.u(c.piece.bufferIndex,c.piece.start);if(c===i.node){d+=a.substring(f,f+i.remainder);break}else d+=a.substr(f,c.piece.length);c=c.next()}return d}getLinesContent(){const n=[];let i=0,c="",u=!1;return this.iterate(this.root,t=>{if(t===N.$GC)return!0;const d=t.piece;let a=d.length;if(a===0)return!0;const f=this.a[d.bufferIndex].buffer,w=this.a[d.bufferIndex].lineStarts,p=d.start.line,v=d.end.line;let y=w[p]+d.start.column;if(u&&(f.charCodeAt(y)===10&&(y++,a--),n[i++]=c,c="",u=!1,a===0))return!0;if(p===v)return!this.f&&f.charCodeAt(y+a-1)===13?(u=!0,c+=f.substr(y,a-1)):c+=f.substr(y,a),!0;c+=this.f?f.substring(y,Math.max(y,w[p+1]-this.e)):f.substring(y,w[p+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=c;for(let h=p+1;h<v;h++)c=this.f?f.substring(w[h],w[h+1]-this.e):f.substring(w[h],w[h+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=c;return!this.f&&f.charCodeAt(w[v]+d.end.column-1)===13?(u=!0,d.end.column===0?i--:c=f.substr(w[v],d.end.column-1)):c=f.substr(w[v],d.end.column),!0}),u&&(n[i++]=c,c=""),n[i++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const c=this.a[i.piece.bufferIndex],u=this.u(i.piece.bufferIndex,i.piece.start);return c.buffer.charCodeAt(u)}else{const i=this.a[n.node.piece.bufferIndex],u=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(u)}}getLineCharCode(n,i){const c=this.H(n,i+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,c,u,t,d,a,f,w,p,v){const y=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start),D=this.u(n.piece.bufferIndex,t),k=this.u(n.piece.bufferIndex,d);let C;const I={line:0,column:0};let W,V;i._wordSeparators?(W=y.buffer.substring(D,k),V=q=>q+D,i.reset(0)):(W=y.buffer,V=q=>q,i.reset(D));do if(C=i.next(W),C){if(V(C.index)>=k)return p;this.s(n,V(C.index)-h,I);const q=this.t(n.piece.bufferIndex,t,I),R=I.line===t.line?I.column-t.column+u:I.column+1,B=R+C[0].length;if(v[p++]=(0,A.$RC)(new O.$ut(c+q,R,c+q,B),C,f),V(C.index)+C[0].length>=k||p>=w)return p}while(C);return p}findMatchesLineByLine(n,i,c,u){const t=[];let d=0;const a=new A.$UC(i.wordSeparators,i.regex);let f=this.H(n.startLineNumber,n.startColumn);if(f===null)return[];const w=this.H(n.endLineNumber,n.endColumn);if(w===null)return[];let p=this.s(f.node,f.remainder);const v=this.s(w.node,w.remainder);if(f.node===w.node)return this.findMatchesInNode(f.node,a,n.startLineNumber,n.startColumn,p,v,i,c,u,d,t),t;let y=n.startLineNumber,h=f.node;for(;h!==w.node;){const k=this.t(h.piece.bufferIndex,p,h.piece.end);if(k>=1){const I=this.a[h.piece.bufferIndex].lineStarts,W=this.u(h.piece.bufferIndex,h.piece.start),V=I[p.line+k],q=y===n.startLineNumber?n.startColumn:1;if(d=this.findMatchesInNode(h,a,y,q,p,this.s(h,V-W),i,c,u,d,t),d>=u)return t;y+=k}const C=y===n.startLineNumber?n.startColumn-1:0;if(y===n.endLineNumber){const I=this.getLineContent(y).substring(C,n.endColumn-1);return d=this.n(i,a,I,n.endLineNumber,C,d,t,c,u),t}if(d=this.n(i,a,this.getLineContent(y).substr(C),y,C,d,t,c,u),d>=u)return t;y++,f=this.H(y,1),h=f.node,p=this.s(f.node,f.remainder)}if(y===n.endLineNumber){const k=y===n.startLineNumber?n.startColumn-1:0,C=this.getLineContent(y).substring(k,n.endColumn-1);return d=this.n(i,a,C,n.endLineNumber,k,d,t,c,u),t}const D=y===n.startLineNumber?n.startColumn:1;return d=this.findMatchesInNode(w.node,a,y,D,p,v,i,c,u,d,t),t}n(n,i,c,u,t,d,a,f,w){const p=n.wordSeparators;if(!f&&n.simpleSearch){const y=n.simpleSearch,h=y.length,D=c.length;let k=-h;for(;(k=c.indexOf(y,k+h))!==-1;)if((!p||(0,A.$TC)(p,c,D,k,h))&&(a[d++]=new M.$Fv(new O.$ut(u,k+1+t,u,k+1+h+t),null),d>=w))return d;return d}let v;i.reset(0);do if(v=i.next(c),v&&(a[d++]=(0,A.$RC)(new O.$ut(u,v.index+1+t,u,v.index+1+v[0].length+t),v,f),d>=w))return d;while(v);return d}insert(n,i,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==N.$GC){const{node:u,remainder:t,nodeStartOffset:d}=this.G(n),a=u.piece,f=a.bufferIndex,w=this.s(u,t);if(u.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&d+a.length===n&&i.length<$){this.F(u,i),this.y();return}if(d===n)this.o(i,u),this.h.validate(n);else if(d+u.piece.length>n){const p=[];let v=new l(a.bufferIndex,w,a.end,this.t(a.bufferIndex,w,a.end),this.u(f,a.end)-this.u(f,w));if(this.K()&&this.M(i)&&this.I(u,t)===10){const k={line:v.start.line+1,column:0};v=new l(v.bufferIndex,k,v.end,this.t(v.bufferIndex,k,v.end),v.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(u,t-1)===13){const k=this.s(u,t-1);this.C(u,k),i="\r"+i,u.piece.length===0&&p.push(u)}else this.C(u,w);else this.C(u,w);const y=this.w(i);v.length>0&&this.S(u,v);let h=u;for(let D=0;D<y.length;D++)h=this.S(h,y[D]);this.v(p)}else this.q(i,u)}else{const u=this.w(i);let t=this.T(null,u[0]);for(let d=1;d<u.length;d++)t=this.S(t,u[d])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===N.$GC)return;const c=this.G(n),u=this.G(n+i),t=c.node,d=u.node;if(t===d){const y=this.s(t,c.remainder),h=this.s(t,u.remainder);if(c.nodeStartOffset===n){if(i===t.piece.length){const D=t.next();(0,N.$LC)(this,t),this.N(D),this.y();return}this.D(t,h),this.h.validate(n),this.N(t),this.y();return}if(c.nodeStartOffset+t.piece.length===n+i){this.C(t,y),this.O(t),this.y();return}this.E(t,y,h),this.y();return}const a=[],f=this.s(t,c.remainder);this.C(t,f),this.h.validate(n),t.piece.length===0&&a.push(t);const w=this.s(d,u.remainder);this.D(d,w),d.piece.length===0&&a.push(d);const p=t.next();for(let y=p;y!==N.$GC&&y!==d;y=y.next())a.push(y);const v=t.piece.length===0?t.prev():t;this.v(a),this.O(v),this.y()}o(n,i){const c=[];if(this.K()&&this.M(n)&&this.L(i)){const d=i.piece,a={line:d.start.line+1,column:0},f=new l(d.bufferIndex,a,d.end,this.t(d.bufferIndex,a,d.end),d.length-1);i.piece=f,n+=`
`,(0,N.$NC)(this,i,-1,-1),i.piece.length===0&&c.push(i)}const u=this.w(n);let t=this.T(i,u[u.length-1]);for(let d=u.length-2;d>=0;d--)t=this.T(t,u[d]);this.N(t),this.v(c)}q(n,i){this.Q(n,i)&&(n+=`
`);const c=this.w(n),u=this.S(i,c[0]);let t=u;for(let d=1;d<c.length;d++)t=this.S(t,c[d]);this.N(u)}s(n,i,c){const u=n.piece,t=n.piece.bufferIndex,d=this.a[t].lineStarts,f=d[u.start.line]+u.start.column+i;let w=u.start.line,p=u.end.line,v=0,y=0,h=0;for(;w<=p&&(v=w+(p-w)/2|0,h=d[v],v!==p);)if(y=d[v+1],f<h)p=v-1;else if(f>=y)w=v+1;else break;return c?(c.line=v,c.column=f-h,null):{line:v,column:f-h}}t(n,i,c){if(c.column===0)return c.line-i.line;const u=this.a[n].lineStarts;if(c.line===u.length-1)return c.line-i.line;const t=u[c.line+1],d=u[c.line]+c.column;if(t>d+1)return c.line-i.line;const a=d-1;return this.a[n].buffer.charCodeAt(a)===13?c.line-i.line+1:c.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,N.$LC)(this,n[i])}w(n){if(n.length>$){const p=[];for(;n.length>$;){const y=n.charCodeAt($-1);let h;y===13||y>=55296&&y<=56319?(h=n.substring(0,$-1),n=n.substring($-1)):(h=n.substring(0,$),n=n.substring($));const D=T(h);p.push(new l(this.a.length,{line:0,column:0},{line:D.length-1,column:h.length-D[D.length-1]},D.length-1,h.length)),this.a.push(new b(h,D))}const v=T(n);return p.push(new l(this.a.length,{line:0,column:0},{line:v.length-1,column:n.length-v[v.length-1]},v.length-1,n.length)),this.a.push(new b(n,v)),p}let i=this.a[0].buffer.length;const c=T(n,!1);let u=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},u=this.g;for(let p=0;p<c.length;p++)c[p]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let p=0;p<c.length;p++)c[p]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,d=this.a[0].lineStarts.length-1,a=t-this.a[0].lineStarts[d],f={line:d,column:a},w=new l(0,u,f,this.t(0,u,f),t-i);return this.g=f,[w]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let c=this.root,u="";const t=this.h.get2(n);if(t){c=t.node;const d=this.B(c,n-t.nodeStartLineNumber-1),a=this.a[c.piece.bufferIndex].buffer,f=this.u(c.piece.bufferIndex,c.piece.start);if(t.nodeStartLineNumber+c.piece.lineFeedCnt===n)u=a.substring(f+d,f+c.piece.length);else{const w=this.B(c,n-t.nodeStartLineNumber);return a.substring(f+d,f+w-i)}}else{let d=0;const a=n;for(;c!==N.$GC;)if(c.left!==N.$GC&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const f=this.B(c,n-c.lf_left-2),w=this.B(c,n-c.lf_left-1),p=this.a[c.piece.bufferIndex].buffer,v=this.u(c.piece.bufferIndex,c.piece.start);return d+=c.size_left,this.h.set({node:c,nodeStartOffset:d,nodeStartLineNumber:a-(n-1-c.lf_left)}),p.substring(v+f,v+w-i)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const f=this.B(c,n-c.lf_left-2),w=this.a[c.piece.bufferIndex].buffer,p=this.u(c.piece.bufferIndex,c.piece.start);u=w.substring(p+f,p+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,d+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==N.$GC;){const d=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const a=this.B(c,0),f=this.u(c.piece.bufferIndex,c.piece.start);return u+=d.substring(f,f+a-i),u}else{const a=this.u(c.piece.bufferIndex,c.piece.start);u+=d.substr(a,c.piece.length)}c=c.next()}return u}y(){let n=this.root,i=1,c=0;for(;n!==N.$GC;)i+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=c,this.h.validate(this.c)}A(n,i){const c=n.piece,u=this.s(n,i),t=u.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===i){const d=this.t(n.piece.bufferIndex,c.start,u);if(d!==t)return{index:d,remainder:0}}return{index:t,remainder:u.column}}B(n,i){if(i<0)return 0;const c=n.piece,u=this.a[c.bufferIndex].lineStarts,t=c.start.line+i+1;return t>c.end.line?u[c.end.line]+c.end.column-u[c.start.line]-c.start.column:u[t]-u[c.start.line]-c.start.column}C(n,i){const c=n.piece,u=c.lineFeedCnt,t=this.u(c.bufferIndex,c.end),d=i,a=this.u(c.bufferIndex,d),f=this.t(c.bufferIndex,c.start,d),w=f-u,p=a-t,v=c.length+p;n.piece=new l(c.bufferIndex,c.start,d,f,v),(0,N.$NC)(this,n,p,w)}D(n,i){const c=n.piece,u=c.lineFeedCnt,t=this.u(c.bufferIndex,c.start),d=i,a=this.t(c.bufferIndex,d,c.end),f=this.u(c.bufferIndex,d),w=a-u,p=t-f,v=c.length+p;n.piece=new l(c.bufferIndex,d,c.end,a,v),(0,N.$NC)(this,n,p,w)}E(n,i,c){const u=n.piece,t=u.start,d=u.end,a=u.length,f=u.lineFeedCnt,w=i,p=this.t(u.bufferIndex,u.start,w),v=this.u(u.bufferIndex,i)-this.u(u.bufferIndex,t);n.piece=new l(u.bufferIndex,u.start,w,p,v),(0,N.$NC)(this,n,v-a,p-f);const y=new l(u.bufferIndex,c,d,this.t(u.bufferIndex,c,d),this.u(u.bufferIndex,d)-this.u(u.bufferIndex,c)),h=this.S(n,y);this.N(h)}F(n,i){this.Q(i,n)&&(i+=`
`);const c=this.K()&&this.L(i)&&this.M(n),u=this.a[0].buffer.length;this.a[0].buffer+=i;const t=T(i,!1);for(let h=0;h<t.length;h++)t[h]+=u;if(c){const h=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:u-h}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const d=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[d],f={line:d,column:a},w=n.piece.length+i.length,p=n.piece.lineFeedCnt,v=this.t(0,n.piece.start,f),y=v-p;n.piece=new l(n.piece.bufferIndex,n.piece.start,f,v,w),this.g=f,(0,N.$NC)(this,n,i.length,y)}G(n){let i=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let u=0;for(;i!==N.$GC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){u+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:u};return this.h.set(t),t}else n-=i.size_left+i.piece.length,u+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let c=this.root,u=0;for(;c!==N.$GC;)if(c.left!==N.$GC&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const t=this.B(c,n-c.lf_left-2),d=this.B(c,n-c.lf_left-1);return u+=c.size_left,{node:c,remainder:Math.min(t+i-1,d),nodeStartOffset:u}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const t=this.B(c,n-c.lf_left-2);if(t+i-1<=c.piece.length)return{node:c,remainder:t+i-1,nodeStartOffset:u};i-=c.piece.length-t;break}else n-=c.lf_left+c.piece.lineFeedCnt,u+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==N.$GC;){if(c.piece.lineFeedCnt>0){const t=this.B(c,0),d=this.J(c);return{node:c,remainder:Math.min(i-1,t),nodeStartOffset:d}}else if(c.piece.length>=i-1){const t=this.J(c);return{node:c,remainder:i-1,nodeStartOffset:t}}else i-=c.piece.length;c=c.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],u=this.u(n.piece.bufferIndex,n.piece.start)+i;return c.buffer.charCodeAt(u)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===N.$GC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,c=this.a[i.bufferIndex].lineStarts,u=i.start.line,t=c[u]+i.start.column;return u===c.length-1||c[u+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===N.$GC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const c=[],u=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:u[n.piece.end.line]-u[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const d=n.piece.length-1,a=n.piece.lineFeedCnt-1;n.piece=new l(n.piece.bufferIndex,n.piece.start,t,a,d),(0,N.$NC)(this,n,-1,-1),n.piece.length===0&&c.push(n);const f={line:i.piece.start.line+1,column:0},w=i.piece.length-1,p=this.t(i.piece.bufferIndex,f,i.piece.end);i.piece=new l(i.piece.bufferIndex,f,i.piece.end,p,w),(0,N.$NC)(this,i,-1,-1),i.piece.length===0&&c.push(i);const v=this.w(`\r
`);this.S(n,v[0]);for(let y=0;y<c.length;y++)(0,N.$LC)(this,c[y])}Q(n,i){if(this.K()&&this.M(n)){const c=i.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,N.$LC)(this,c);else{const u=c.piece,t={line:u.start.line+1,column:0},d=u.length-1,a=this.t(u.bufferIndex,t,u.end);c.piece=new l(u.bufferIndex,t,u.end,a,d),(0,N.$NC)(this,c,-1,-1)}return!0}}return!1}iterate(n,i){if(n===N.$GC)return i(N.$GC);const c=this.iterate(n.left,i);return c&&i(n)&&this.iterate(n.right,i)}R(n){if(n===N.$GC)return"";const i=this.a[n.piece.bufferIndex],c=n.piece,u=this.u(c.bufferIndex,c.start),t=this.u(c.bufferIndex,c.end);return i.buffer.substring(u,t)}getPieceContent(n){const i=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),u=this.u(n.bufferIndex,n.end);return i.buffer.substring(c,u)}S(n,i){const c=new N.$FC(i,1);if(c.left=N.$GC,c.right=N.$GC,c.parent=N.$GC,c.size_left=0,c.lf_left=0,this.root===N.$GC)this.root=c,c.color=0;else if(n.right===N.$GC)n.right=c,c.parent=n;else{const t=(0,N.$HC)(n.right);t.left=c,c.parent=t}return(0,N.$MC)(this,c),c}T(n,i){const c=new N.$FC(i,1);if(c.left=N.$GC,c.right=N.$GC,c.parent=N.$GC,c.size_left=0,c.lf_left=0,this.root===N.$GC)this.root=c,c.color=0;else if(n.left===N.$GC)n.left=c,c.parent=n;else{const u=(0,N.$IC)(n.left);u.right=c,c.parent=u}return(0,N.$MC)(this,c),c}U(n){let i="";return this.iterate(n,c=>(i+=this.R(c),!0)),i}}e.$ZC=s}),define(Se[143],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B0=e.$A0=void 0;class P{constructor(){this.a=new Map}removeDragOperationTransfer(N){if(N&&this.a.has(N)){const A=this.a.get(N);return this.a.delete(N),A}}addDragOperationTransfer(N,A){this.a.set(N,A)}}e.$A0=P;class O{constructor(N){this.identifier=N}}e.$B0=O}),define(Se[144],Ie([9,10]),function(he,e){return he.create("vs/base/common/actions",e)}),define(Se[145],Ie([1,0,5,6,144]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=void 0,e.$gj=T;class N extends O.$Uc{constructor(l,b="",g="",r=!0,s){super(),this.h=this.B(new P.$de),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=b,this.u=g,this.w=r,this.C=s}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,b){this.C&&await this.C(l)}}e.$bj=N;class A extends O.$Uc{constructor(){super(...arguments),this.f=this.B(new P.$de),this.onWillRun=this.f.event,this.m=this.B(new P.$de),this.onDidRun=this.m.event}async run(l,b){if(!l.enabled)return;this.f.fire({action:l});let g;try{await this.u(l,b)}catch(r){g=r}this.m.fire({action:l,error:g})}async u(l,b){await l.run(b)}}e.$cj=A;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let b=[];for(const g of l)g.length&&(b.length?b=[...b,new $,...g]:b=g);return b}static{this.ID="vs.actions.separator"}async run(){}}e.$dj=$;class m{get actions(){return this.a}constructor(l,b,g,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=b,this.class=r,this.a=g}async run(){}}e.$ej=m;class E extends N{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,M.localize(0,null),void 0,!1)}}e.$fj=E;function T(S){return{id:S.id,label:S.label,class:S.class,enabled:S.enabled??!0,checked:S.checked,run:async(...l)=>S.run(...l),tooltip:S.label}}}),define(Se[146],Ie([9,10]),function(he,e){return he.create("vs/base/common/date",e)}),define(Se[147],Ie([1,0,146]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=E,e.$3m=T,e.$4m=S;const O=60,M=O*60,N=M*24,A=N*7,$=N*30,m=N*365;function E(l,b,g,r){typeof l!="number"&&(l=l.getTime());const s=Math.round((new Date().getTime()-l)/1e3);if(s<-30)return(0,P.localize)(0,null,E(new Date().getTime()+s*1e3,!1));if(!r&&s<30)return(0,P.localize)(1,null);let o;return s<O?(o=s,b?o===1?g?(0,P.localize)(2,null,o):(0,P.localize)(3,null,o):g?(0,P.localize)(4,null,o):(0,P.localize)(5,null,o):o===1?g?(0,P.localize)(6,null,o):(0,P.localize)(7,null,o):g?(0,P.localize)(8,null,o):(0,P.localize)(9,null,o)):s<M?(o=Math.floor(s/O),b?o===1?g?(0,P.localize)(10,null,o):(0,P.localize)(11,null,o):g?(0,P.localize)(12,null,o):(0,P.localize)(13,null,o):o===1?g?(0,P.localize)(14,null,o):(0,P.localize)(15,null,o):g?(0,P.localize)(16,null,o):(0,P.localize)(17,null,o)):s<N?(o=Math.floor(s/M),b?o===1?g?(0,P.localize)(18,null,o):(0,P.localize)(19,null,o):g?(0,P.localize)(20,null,o):(0,P.localize)(21,null,o):o===1?g?(0,P.localize)(22,null,o):(0,P.localize)(23,null,o):g?(0,P.localize)(24,null,o):(0,P.localize)(25,null,o)):s<A?(o=Math.floor(s/N),b?o===1?(0,P.localize)(26,null,o):(0,P.localize)(27,null,o):o===1?(0,P.localize)(28,null,o):(0,P.localize)(29,null,o)):s<$?(o=Math.floor(s/A),b?o===1?g?(0,P.localize)(30,null,o):(0,P.localize)(31,null,o):g?(0,P.localize)(32,null,o):(0,P.localize)(33,null,o):o===1?g?(0,P.localize)(34,null,o):(0,P.localize)(35,null,o):g?(0,P.localize)(36,null,o):(0,P.localize)(37,null,o)):s<m?(o=Math.floor(s/$),b?o===1?g?(0,P.localize)(38,null,o):(0,P.localize)(39,null,o):g?(0,P.localize)(40,null,o):(0,P.localize)(41,null,o):o===1?g?(0,P.localize)(42,null,o):(0,P.localize)(43,null,o):g?(0,P.localize)(44,null,o):(0,P.localize)(45,null,o)):(o=Math.floor(s/m),b?o===1?g?(0,P.localize)(46,null,o):(0,P.localize)(47,null,o):g?(0,P.localize)(48,null,o):(0,P.localize)(49,null,o):o===1?g?(0,P.localize)(50,null,o):(0,P.localize)(51,null,o):g?(0,P.localize)(52,null,o):(0,P.localize)(53,null,o))}function T(l,b){const g=Math.abs(l/1e3);return g<1?b?(0,P.localize)(54,null,l):(0,P.localize)(55,null,l):g<O?b?(0,P.localize)(56,null,Math.round(l)/1e3):(0,P.localize)(57,null,Math.round(l)/1e3):g<M?b?(0,P.localize)(58,null,Math.round(l/(1e3*O))):(0,P.localize)(59,null,Math.round(l/(1e3*O))):g<N?b?(0,P.localize)(60,null,Math.round(l/(1e3*M))):(0,P.localize)(61,null,Math.round(l/(1e3*M))):(0,P.localize)(62,null,Math.round(l/(1e3*N)))}function S(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Se[148],Ie([9,10]),function(he,e){return he.create("vs/base/common/errorMessage",e)}),define(Se[44],Ie([1,0,18,15,148]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=m,e.$ij=E,e.$jj=T;function N(S,l){return l&&(S.stack||S.stacktrace)?M.localize(0,null,$(S),A(S.stack)||A(S.stacktrace)):$(S)}function A(S){return Array.isArray(S)?S.join(`
`):S}function $(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?M.localize(1,null,S.message):S.message||M.localize(2,null)}function m(S=null,l=!1){if(!S)return M.localize(3,null);if(Array.isArray(S)){const b=P.$Hb(S),g=m(b[0],l);return b.length>1?M.localize(4,null,g,b.length):g}if(O.$9f(S))return S;if(S.detail){const b=S.detail;if(b.error)return N(b.error,l);if(b.exception)return N(b.exception,l)}return S.stack?N(S,l):S.message?S.message:M.localize(5,null)}function E(S){const l=S;return l instanceof Error&&Array.isArray(l.actions)}function T(S,l){let b;return typeof S=="string"?b=new Error(S):b=S,b.actions=l,b}}),define(Se[149],Ie([1,0,43,19]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=$,e.$hr=m,e.$ir=E,e.$jr=T,e.$kr=S,e.$lr=l,e.$mr=b,e.$nr=g,e.$or=r,e.$pr=s,e.$qr=w,e.$rr=p,e.$sr=v;const M=new P.$V(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),N=new P.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new P.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(y,h,D=!1){const k=y||"",C=h||"",I=M.value.collator.compare(k,C);return M.value.collatorIsNumeric&&I===0&&k!==C?k<C?-1:1:I}function m(y,h){const D=N.value.collator;return y=y||"",h=h||"",c(D,y,h)}function E(y,h){const D=N.value.collator;return y=y||"",h=h||"",a(y,h)||c(D,y,h)}function T(y,h){const D=N.value.collator;return y=y||"",h=h||"",d(y,h)||c(D,y,h)}function S(y,h){return y=y||"",h=h||"",y===h?0:y<h?-1:1}function l(y,h){const[D,k]=n(y),[C,I]=n(h);let W=M.value.collator.compare(k,I);if(W===0){if(M.value.collatorIsNumeric&&k!==I)return k<I?-1:1;if(W=M.value.collator.compare(D,C),M.value.collatorIsNumeric&&W===0&&D!==C)return D<C?-1:1}return W}function b(y,h){y=y||"",h=h||"";const D=i(y),k=i(h),C=N.value.collator,I=A.value.collator;return c(I,D,k)||c(C,y,h)}function g(y,h){y=y||"",h=h||"";const D=i(y),k=i(h),C=N.value.collator,I=A.value.collator;return c(I,D,k)||a(y,h)||c(C,y,h)}function r(y,h){y=y||"",h=h||"";const D=i(y),k=i(h),C=N.value.collator,I=A.value.collator;return c(I,D,k)||d(y,h)||c(C,y,h)}function s(y,h){y=y||"",h=h||"";const D=i(y).toLowerCase(),k=i(h).toLowerCase();return D!==k?D<k?-1:1:y!==h?y<h?-1:1:0}const o=/^(.*?)(\.([^.]*))?$/;function n(y,h=!1){const D=y?o.exec(y):[];let k=[D&&D[1]||"",D&&D[3]||""];return h&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function i(y){const h=y?o.exec(y):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function c(y,h,D){const k=y.compare(h,D);return k!==0?k:h.length!==D.length?h.length<D.length?-1:1:0}function u(y){const h=y.charAt(0);return h.toLocaleUpperCase()!==h}function t(y){const h=y.charAt(0);return h.toLocaleLowerCase()!==h}function d(y,h){return u(y)&&t(h)?-1:t(y)&&u(h)?1:0}function a(y,h){return t(y)&&u(h)?-1:u(y)&&t(h)?1:0}function f(y,h,D=!1){return D||(y=y&&y.toLowerCase(),h=h&&h.toLowerCase()),y===h?0:y<h?-1:1}function w(y,h,D=!1){const k=y.split(O.sep),C=h.split(O.sep),I=k.length-1,W=C.length-1;let V,q;for(let R=0;;R++){if(V=I===R,q=W===R,V&&q)return $(k[R],C[R],D);if(V)return-1;if(q)return 1;const B=f(k[R],C[R],D);if(B!==0)return B}}function p(y,h,D){const k=y.toLowerCase(),C=h.toLowerCase(),I=v(y,h,D);if(I)return I;const W=k.endsWith(D),V=C.endsWith(D);if(W!==V)return W?-1:1;const q=$(k,C);return q!==0?q:k.localeCompare(C)}function v(y,h,D){const k=y.toLowerCase(),C=h.toLowerCase(),I=k.startsWith(D),W=C.startsWith(D);if(I!==W)return I?-1:1;if(I&&W){if(k.length<C.length)return-1;if(k.length>C.length)return 1}return 0}}),define(Se[48],Ie([1,0,19,22,13,15]),function(he,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=A,e.$pg=$,e.$qg=m,e.$rg=E,e.$sg=T,e.$tg=g,e.$ug=r,e.$vg=s,e.$wg=o,e.$xg=n,e.$yg=i,e.$zg=c,e.$Ag=u,e.$Bg=t,e.$Cg=d,e.$Dg=a,e.$Eg=p;function A(v){return v===47||v===92}function $(v){return v.replace(/[\\/]/g,P.$gc.sep)}function m(v){return v.indexOf("/")===-1&&(v=$(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}function E(v,y=P.$gc.sep){if(!v)return"";const h=v.length,D=v.charCodeAt(0);if(A(D)){if(A(v.charCodeAt(1))&&!A(v.charCodeAt(2))){let C=3;const I=C;for(;C<h&&!A(v.charCodeAt(C));C++);if(I!==C&&!A(v.charCodeAt(C+1))){for(C+=1;C<h;C++)if(A(v.charCodeAt(C)))return v.slice(0,C+1).replace(/[\\/]/g,y)}}return y}else if(o(D)&&v.charCodeAt(1)===58)return A(v.charCodeAt(2))?v.slice(0,2)+y:v.slice(0,2);let k=v.indexOf("://");if(k!==-1){for(k+=3;k<h;k++)if(A(v.charCodeAt(k)))return v.slice(0,k+1)}return""}function T(v){if(!O.$i||!v||v.length<5)return!1;let y=v.charCodeAt(0);if(y!==92||(y=v.charCodeAt(1),y!==92))return!1;let h=2;const D=h;for(;h<v.length&&(y=v.charCodeAt(h),y!==92);h++);return!(D===h||(y=v.charCodeAt(h+1),isNaN(y)||y===92))}const S=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(v,y=O.$i){const h=y?S:l;return!(!v||v.length===0||/^\s+$/.test(v)||(h.lastIndex=0,h.test(v))||y&&b.test(v)||v==="."||v===".."||y&&v[v.length-1]==="."||y&&v.length!==v.trim().length||v.length>255)}function r(v,y,h){const D=v===y;return!h||D?D:!v||!y?!1:(0,M.$xf)(v,y)}function s(v,y,h,D=P.sep){if(v===y)return!0;if(!v||!y||y.length>v.length)return!1;if(h){if(!(0,M.$yf)(v,y))return!1;if(y.length===v.length)return!0;let C=y.length;return y.charAt(y.length-1)===D&&C--,v.charAt(C)===D}return y.charAt(y.length-1)!==D&&(y+=D),v.indexOf(y)===0}function o(v){return v>=65&&v<=90||v>=97&&v<=122}function n(v,y){return O.$i&&v.endsWith(":")&&(v+=P.sep),(0,P.$ic)(v)||(v=(0,P.$jc)(y,v)),v=(0,P.$hc)(v),i(v)}function i(v){return O.$i?(v=(0,M.$ff)(v,P.sep),v.endsWith(":")&&(v+=P.sep)):(v=(0,M.$ff)(v,P.sep),v||(v=P.sep)),v}function c(v){const y=(0,P.$hc)(v);return O.$i?v.length>3?!1:u(y)&&(v.length===2||y.charCodeAt(2)===92):y===P.$gc.sep}function u(v,y=O.$i){return y?o(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}function t(v,y=O.$i){return u(v,y)?v[0]:void 0}function d(v,y,h){return y.length>v.length?-1:v===y?0:(h&&(v=v.toLowerCase(),y=y.toLowerCase()),v.indexOf(y))}function a(v){const y=v.split(":");let h,D,k;for(const C of y){const I=Number(C);(0,N.$ag)(I)?D===void 0?D=I:k===void 0&&(k=I):h=h?[h,C].join(":"):C}if(!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:D!==void 0?D:void 0,column:k!==void 0?k:D!==void 0?1:void 0}}const f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",w="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function p(v,y,h=8){let D="";for(let C=0;C<h;C++){let I;C===0&&O.$i&&!y&&(h===3||h===4)?I=w:I=f,D+=I.charAt(Math.floor(Math.random()*I.length))}let k;return y?k=`${y}-${D}`:k=D,v?(0,P.$jc)(v,k):k}}),define(Se[70],Ie([1,0,19]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0,e.$Rs=N,e.$Ss=A,e.$Ts=$,e.$Us=E,e.$Qs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},M={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(T){const S=(0,P.$oc)(T),l=O[S.toLowerCase()];return l!==void 0?l:A(T)}function A(T){const S=(0,P.$oc)(T);return M[S.toLowerCase()]}function $(T){for(const S in M)if(M[S]===T)return S}const m=/^(.+)\/(.+?)(;.+)?$/;function E(T,S){const l=m.exec(T);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:S?void 0:T}}),define(Se[49],Ie([1,0,21,2]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=M,e.$5h=N,e.$6h=$;function M(m){return JSON.stringify(m,A)}function N(m){let E=JSON.parse(m);return E=$(E),E}function A(m,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function $(m,E=0){if(!m||E>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return O.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof P.$Fe||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let T=0;T<m.length;++T)m[T]=$(m[T],E+1);else for(const T in m)Object.hasOwnProperty.call(m,T)&&(m[T]=$(m[T],E+1))}return m}}),define(Se[16],Ie([1,0,14,22,13,2,19]),function(he,e,P,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Jg=e.$Ig=e.$Hg=e.Schemas=void 0,e.$Fg=m,e.$Gg=E,e.$Kg=S;var $;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatCodeBlock="vscode-chat-code-block",g.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm",g.commentsInput="comment",g.codeSetting="code-setting"})($||(e.Schemas=$={}));function m(g,r){return N.URI.isUri(g)?(0,M.$xf)(g.scheme,r):(0,M.$yf)(g,r+":")}function E(g,...r){return r.some(s=>m(g,s))}e.$Hg="vscode-tkn",e.$Ig="tkn";class T{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,s){this.f=S(r,s)}getServerRootPath(){return this.f}get g(){return A.$gc.join(this.f,$.vscodeRemoteResource)}set(r,s,o){this.a[r]=s,this.b[r]=o}setConnectionToken(r,s){this.c[r]=s}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(u){return P.$1(u),r}const s=r.authority;let o=this.a[s];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const n=this.b[s],i=this.c[s];let c=`path=${encodeURIComponent(r.path)}`;return typeof i=="string"&&(c+=`&${e.$Ig}=${encodeURIComponent(i)}`),N.URI.from({scheme:O.$o?this.d:$.vscodeRemoteResource,authority:`${o}:${n}`,path:this.g,query:c})}}e.$Jg=new T;function S(g,r){return A.$gc.join(r??"/",`${g.quality??"oss"}-${g.commit??"dev"}`)}e.$Lg="vs/../../extensions",e.$Mg="vs/../../node_modules",e.$Ng="vs/../../node_modules.asar",e.$Og="vs/../../node_modules.asar.unpacked",e.$Pg="vscode-app";class l{static{this.a=e.$Pg}asBrowserUri(r){const s=this.b(r,he);return this.uriToBrowserUri(s)}uriToBrowserUri(r){return r.scheme===$.vscodeRemote?e.$Jg.rewrite(r):r.scheme===$.file&&(O.$m||O.$q===`${$.vscodeFileResource}://${l.a}`)?r.with({scheme:$.vscodeFileResource,authority:r.authority||l.a,query:null,fragment:null}):r}asFileUri(r){const s=this.b(r,he);return this.uriToFileUri(s)}uriToFileUri(r){return r.scheme===$.vscodeFileResource?r.with({scheme:$.file,authority:r.authority!==l.a?r.authority:null,query:null,fragment:null}):r}b(r,s){return N.URI.isUri(r)?r:N.URI.parse(s.toUrl(r))}}e.$Qg=new l;var b;(function(g){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(r.get("3"));const s="vscode-coi";function o(i){let c;typeof i=="string"?c=new URL(i).searchParams:i instanceof URL?c=i.searchParams:N.URI.isUri(i)&&(c=new URL(i.toString(!0)).searchParams);const u=c?.get(s);if(u)return r.get(u)}g.getHeadersFromQuery=o;function n(i,c,u){if(!globalThis.crossOriginIsolated)return;const t=c&&u?"3":u?"2":"1";i instanceof URLSearchParams?i.set(s,t):i[s]=t}g.addSearchParam=n})(b||(e.COI=b={}))}),define(Se[23],Ie([1,0,48,16,19,22,13,2]),function(he,e,P,O,M,N,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=void 0,e.$Xg=m,e.$gh=T,e.$hh=l;function m(b){return(0,$.$wc)(b,!0)}class E{constructor(g){this.a=g}compare(g,r,s=!1){return g===r?0:(0,A.$qf)(this.getComparisonKey(g,s),this.getComparisonKey(r,s))}isEqual(g,r,s=!1){return g===r?!0:!g||!r?!1:this.getComparisonKey(g,s)===this.getComparisonKey(r,s)}getComparisonKey(g,r=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,r,s=!1){if(g.scheme===r.scheme){if(g.scheme===O.Schemas.file)return P.$vg(m(g),m(r),this.a(g))&&g.query===r.query&&(s||g.fragment===r.fragment);if((0,e.$ch)(g.authority,r.authority))return P.$vg(g.path,r.path,this.a(g),"/")&&g.query===r.query&&(s||g.fragment===r.fragment)}return!1}joinPath(g,...r){return $.URI.joinPath(g,...r)}basenameOrAuthority(g){return(0,e.$7g)(g)||g.authority}basename(g){return M.$gc.basename(g.path)}extname(g){return M.$gc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let r;return g.scheme===O.Schemas.file?r=$.URI.file(M.$mc(m(g))).path:(r=M.$gc.dirname(g.path),g.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),r="/")),g.with({path:r})}normalizePath(g){if(!g.path.length)return g;let r;return g.scheme===O.Schemas.file?r=$.URI.file(M.$hc(m(g))).path:r=M.$gc.normalize(g.path),g.with({path:r})}relativePath(g,r){if(g.scheme!==r.scheme||!(0,e.$ch)(g.authority,r.authority))return;if(g.scheme===O.Schemas.file){const n=M.$lc(m(g),m(r));return N.$i?P.$pg(n):n}let s=g.path||"/";const o=r.path||"/";if(this.a(g)){let n=0;for(const i=Math.min(s.length,o.length);n<i&&!(s.charCodeAt(n)!==o.charCodeAt(n)&&s.charAt(n).toLowerCase()!==o.charAt(n).toLowerCase());n++);s=o.substr(0,n)+s.substr(n)}return M.$gc.relative(s,o)}resolvePath(g,r){if(g.scheme===O.Schemas.file){const s=$.URI.file(M.$kc(m(g),r));return g.with({authority:s.authority,path:s.path})}return r=P.$qg(r),g.with({path:M.$gc.resolve(g.path,r)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,r){return g===r||g!==void 0&&r!==void 0&&(0,A.$xf)(g,r)}hasTrailingPathSeparator(g,r=M.sep){if(g.scheme===O.Schemas.file){const s=m(g);return s.length>P.$rg(s).length&&s[s.length-1]===r}else{const s=g.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,r=M.sep){return(0,e.$dh)(g,r)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,r=M.sep){let s=!1;if(g.scheme===O.Schemas.file){const o=m(g);s=o!==void 0&&o.length===P.$rg(o).length&&o[o.length-1]===r}else{r="/";const o=g.path;s=o.length===1&&o.charCodeAt(o.length-1)===47}return!s&&!(0,e.$dh)(g,r)?g.with({path:g.path+"/"}):g}}e.$Yg=E,e.$Zg=new E(()=>!1),e.$1g=new E(b=>b.scheme===O.Schemas.file?!N.$k:!0),e.$2g=new E(b=>!0),e.$3g=e.$Zg.isEqual.bind(e.$Zg),e.$4g=e.$Zg.isEqualOrParent.bind(e.$Zg),e.$5g=e.$Zg.getComparisonKey.bind(e.$Zg),e.$6g=e.$Zg.basenameOrAuthority.bind(e.$Zg),e.$7g=e.$Zg.basename.bind(e.$Zg),e.$8g=e.$Zg.extname.bind(e.$Zg),e.$9g=e.$Zg.dirname.bind(e.$Zg),e.$0g=e.$Zg.joinPath.bind(e.$Zg),e.$$g=e.$Zg.normalizePath.bind(e.$Zg),e.$_g=e.$Zg.relativePath.bind(e.$Zg),e.$ah=e.$Zg.resolvePath.bind(e.$Zg),e.$bh=e.$Zg.isAbsolutePath.bind(e.$Zg),e.$ch=e.$Zg.isEqualAuthority.bind(e.$Zg),e.$dh=e.$Zg.hasTrailingPathSeparator.bind(e.$Zg),e.$eh=e.$Zg.removeTrailingPathSeparator.bind(e.$Zg),e.$fh=e.$Zg.addTrailingPathSeparator.bind(e.$Zg);function T(b,g){const r=[];for(let s=0;s<b.length;s++){const o=g(b[s]);b.some((n,i)=>i===s?!1:(0,e.$4g)(o,g(n)))||r.push(b[s])}return r}var S;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function g(r){const s=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(i=>{const[c,u]=i.split(":");c&&u&&s.set(c,u)});const n=r.path.substring(0,r.path.indexOf(";"));return n&&s.set(b.META_DATA_MIME,n),s}b.parseMetaData=g})(S||(e.DataUri=S={}));function l(b,g,r){if(g){let s=b.path;return s&&s[0]!==M.$gc.sep&&(s=M.$gc.sep+s),b.with({scheme:r,authority:g,path:s})}return b.with({scheme:r})}}),define(Se[11],Ie([1,0,24,14,5,6,23,22,136,43]),function(he,e,P,O,M,N,A,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.Promises=e.$Th=e.$Sh=e.$Rh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0,e.$ih=T,e.$jh=S,e.$kh=l,e.$lh=b,e.$mh=g,e.$nh=r,e.$oh=s,e.$ph=o,e.$xh=p,e.$yh=v,e.$zh=y,e.$Ah=h,e.$Bh=D,e.$Qh=ke,e.$Yh=De;function T(ge){return!!ge&&typeof ge.then=="function"}function S(ge){const Q=new P.$oe,Y=ge(Q.token),le=new Promise((ue,Oe)=>{const de=Q.token.onCancellationRequested(()=>{de.dispose(),Oe(new O.$5)});Promise.resolve(Y).then(Ce=>{de.dispose(),Q.dispose(),ue(Ce)},Ce=>{de.dispose(),Q.dispose(),Oe(Ce)})});return new class{cancel(){Q.cancel(),Q.dispose()}then(ue,Oe){return le.then(ue,Oe)}catch(ue){return this.then(void 0,ue)}finally(ue){return le.finally(ue)}}}function l(ge,Q,Y){return new Promise((le,ue)=>{const Oe=Q.onCancellationRequested(()=>{Oe.dispose(),le(Y)});ge.then(le,ue).finally(()=>Oe.dispose())})}function b(ge,Q){return new Promise((Y,le)=>{const ue=Q.onCancellationRequested(()=>{ue.dispose(),le(new O.$5)});ge.then(Y,le).finally(()=>ue.dispose())})}async function g(ge){let Q=-1;const Y=ge.map((le,ue)=>le.then(Oe=>(Q=ue,Oe)));try{return await Promise.race(Y)}finally{ge.forEach((le,ue)=>{ue!==Q&&le.cancel()})}}function r(ge,Q,Y){let le;const ue=setTimeout(()=>{le?.(void 0),Y?.()},Q);return Promise.race([ge.finally(()=>clearTimeout(ue)),new Promise(Oe=>le=Oe)])}function s(ge){return new Promise((Q,Y)=>{const le=ge();T(le)?le.then(Q,Y):Q(le)})}function o(){let ge,Q;return{promise:new Promise((le,ue)=>{ge=le,Q=ue}),resolve:ge,reject:Q}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Q,!this.b){const Y=()=>{if(this.b=null,this.f)return;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(Y,Y).then(le)})}return new Promise((Y,le)=>{this.b.then(Y,le)})}return this.a=Q(),new Promise((Y,le)=>{this.a.then(ue=>{this.a=null,Y(ue)},ue=>{this.a=null,le(ue)})})}dispose(){this.f=!0}}e.$qh=n;class i{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.$rh=i;class c{constructor(){this.a=new Map}queue(Q,Y){const ue=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(Q)===ue&&this.a.delete(Q)});return this.a.set(Q,ue),ue}}e.$sh=c;const u=(ge,Q)=>{let Y=!0;const le=setTimeout(()=>{Y=!1,Q()},ge);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(le),Y=!1}}},t=ge=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,ge())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class d{constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,Y=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((ue,Oe)=>{this.d=ue,this.f=Oe}).then(()=>{if(this.b=null,this.d=null,this.g){const ue=this.g;return this.g=null,ue()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=Y===m.$ae?t(le):u(Y,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$th=d;class a{constructor(Q){this.a=new d(Q),this.b=new n}trigger(Q,Y){return this.a.trigger(()=>this.b.queue(Q),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$uh=a;class f{constructor(){this.a=!1,this.b=new Promise((Q,Y)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$vh=f;class w extends f{constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.$wh=w;function p(ge,Q){return Q?new Promise((Y,le)=>{const ue=setTimeout(()=>{Oe.dispose(),Y()},ge),Oe=Q.onCancellationRequested(()=>{clearTimeout(ue),Oe.dispose(),le(new O.$5)})}):S(Y=>p(ge,Y))}function v(ge,Q=0,Y){const le=setTimeout(()=>{ge(),Y&&ue.dispose()},Q),ue=(0,N.$Sc)(()=>{clearTimeout(le),Y?.deleteAndLeak(ue)});return Y?.add(ue),ue}function y(ge){const Q=[];let Y=0;const le=ge.length;function ue(){return Y<le?ge[Y++]():null}function Oe(de){de!=null&&Q.push(de);const Ce=ue();return Ce?Ce.then(Oe):Promise.resolve(Q)}return Promise.resolve(null).then(Oe)}function h(ge,Q=le=>!!le,Y=null){let le=0;const ue=ge.length,Oe=()=>{if(le>=ue)return Promise.resolve(Y);const de=ge[le++];return Promise.resolve(de()).then(Me=>Q(Me)?Promise.resolve(Me):Oe())};return Oe()}function D(ge,Q=le=>!!le,Y=null){if(ge.length===0)return Promise.resolve(Y);let le=ge.length;const ue=()=>{le=-1;for(const Oe of ge)Oe.cancel?.()};return new Promise((Oe,de)=>{for(const Ce of ge)Ce.then(Me=>{--le>=0&&Q(Me)?(ue(),Oe(Me)):le===0&&Oe(Y)}).catch(Me=>{--le>=0&&(ue(),de(Me))})})}class k{constructor(Q){this.a=0,this.b=!1,this.f=Q,this.g=[],this.d=0,this.h=new M.$de}whenIdle(){return this.size>0?M.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,le)=>{this.g.push({factory:Q,c:Y,e:le}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Q=this.g.shift();this.d++;const Y=Q.factory();Y.then(Q.c,Q.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ch=k;class C extends k{constructor(){super(1)}}e.$Dh=C;class I{constructor(){this.a=new fe,this.b=0}queue(Q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Q())):this.a.run(this.b++,Q())}}e.$Eh=I;class W{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Q=new ae;return this.b.add(Q),Q.p}g(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueSize(Q,Y=A.$Zg){const le=Y.getComparisonKey(Q);return this.a.get(le)?.size??0}queueFor(Q,Y,le=A.$Zg){const ue=le.getComparisonKey(Q);let Oe=this.a.get(ue);if(!Oe){Oe=new C;const de=this.f++,Ce=M.Event.once(Oe.onDrained)(()=>{Oe?.dispose(),this.a.delete(ue),this.h(),this.d?.deleteAndDispose(de),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new N.$4c),this.d.set(de,Ce),this.a.set(ue,Oe)}return Oe.queue(Y)}h(){this.g()&&this.j()}j(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Fh=W;class V{constructor(Q,Y){this.a=-1,typeof Q=="function"&&typeof Y=="number"&&this.setIfNotSet(Q,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},Y)}setIfNotSet(Q,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},Y))}}e.$Gh=V;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Q,Y,le=globalThis){this.cancel();const ue=le.setInterval(()=>{Q()},Y);this.d=(0,N.$Sc)(()=>{le.clearInterval(ue),this.d=void 0})}dispose(){this.cancel()}}e.$Hh=q;class R{constructor(Q,Y){this.b=-1,this.a=Q,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ih=R;class B{constructor(Q,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=Q,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Jh=B;class K extends R{constructor(Q,Y){super(Q,Y),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.$Kh=K;class ie extends N.$Uc{constructor(Q,Y){super(),this.g=Q,this.h=Y,this.a=[],this.b=this.B(new N.$Vc),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of Q)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new R(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Lh=ie,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Nh=(ge,Q)=>{(0,$.$B)(()=>{if(Y)return;const le=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$Nh=(ge,Q,Y)=>{const le=ge.requestIdleCallback(Q,typeof Y=="number"?{timeout:Y}:void 0);let ue=!1;return{dispose(){ue||(ue=!0,ge.cancelIdleCallback(le))}}},e.$Mh=ge=>(0,e.$Nh)(globalThis,ge)}();class ce{constructor(Q,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(le){this.l=le}finally{this.g=!0}},this.f=(0,e.$Nh)(Q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Oh=ce;class ve extends ce{constructor(Q){super(globalThis,Q)}}e.$Ph=ve;async function ke(ge,Q,Y){let le;for(let ue=0;ue<Y;ue++)try{return await ge()}catch(Oe){le=Oe,await p(Q)}throw le}class fe{isRunning(Q){return typeof Q=="number"?this.a?.taskId===Q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Q,Y,le){return this.a={taskId:Q,cancel:()=>le?.(),promise:Y},Y.then(()=>this.d(Q),()=>this.d(Q)),Y}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this.b)this.b.run=Q;else{const{promise:Y,resolve:le,reject:ue}=o();this.b={run:Q,promise:Y,promiseResolve:le,promiseReject:ue}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Rh=fe;class pe{constructor(Q,Y=()=>Date.now()){this.d=Q,this.f=Y,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.$Sh=pe;var Ne;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(Ne||(Ne={}));class ae{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Q,Y)=>{this.a=Q,this.b=Y})}complete(Q){return new Promise(Y=>{this.a(Q),this.d={outcome:0,value:Q},Y()})}error(Q){return new Promise(Y=>{this.b(Q),this.d={outcome:1,value:Q},Y()})}cancel(){return this.error(new O.$5)}}e.$Th=ae;var Re;(function(ge){async function Q(le){let ue;const Oe=await Promise.all(le.map(de=>de.then(Ce=>Ce,Ce=>{ue||(ue=Ce)})));if(typeof ue<"u")throw ue;return Oe}ge.settled=Q;function Y(le){return new Promise(async(ue,Oe)=>{try{await le(ue,Oe)}catch(de){Oe(de)}})}ge.withAsyncBody=Y})(Re||(e.Promises=Re={}));class ne{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Q.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new O.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Uh=ne;class z{constructor(Q){this.b=Q,this.a=new E.$V(()=>new ne(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Vh=z;var x;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(x||(x={}));class be{static fromArray(Q){return new be(Y=>{Y.emitMany(Q)})}static fromPromise(Q){return new be(async Y=>{Y.emitMany(await Q)})}static fromPromises(Q){return new be(async Y=>{await Promise.all(Q.map(async le=>Y.emitOne(await le)))})}static merge(Q){return new be(async Y=>{await Promise.all(Q.map(async le=>{for await(const ue of le)Y.emitOne(ue)}))})}static{this.EMPTY=be.fromArray([])}constructor(Q,Y){this.a=0,this.b=[],this.d=null,this.f=Y,this.g=new M.$de,queueMicrotask(async()=>{const le={emitOne:ue=>this.h(ue),emitMany:ue=>this.j(ue),reject:ue=>this.l(ue)};try{await Promise.resolve(Q(le)),this.k()}catch(ue){this.l(ue)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===1)return{done:!0,value:void 0};await M.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Q,Y){return new be(async le=>{for await(const ue of Q)le.emitOne(Y(ue))})}map(Q){return be.map(this,Q)}static filter(Q,Y){return new be(async le=>{for await(const ue of Q)Y(ue)&&le.emitOne(ue)})}filter(Q){return be.filter(this,Q)}static coalesce(Q){return be.filter(Q,Y=>!!Y)}coalesce(){return be.coalesce(this)}static async toPromise(Q){const Y=[];for await(const le of Q)Y.push(le);return Y}toPromise(){return be.toPromise(this)}h(Q){this.a===0&&(this.b.push(Q),this.g.fire())}j(Q){this.a===0&&(this.b=this.b.concat(Q),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(Q){this.a===0&&(this.a=2,this.d=Q,this.g.fire())}}e.$Wh=be;class Te extends be{constructor(Q,Y){super(Y),this.m=Q}cancel(){this.m.cancel()}}e.$Xh=Te;function De(ge){const Q=new P.$oe,Y=ge(Q.token);return new Te(Q,async le=>{const ue=Q.token.onCancellationRequested(()=>{ue.dispose(),Q.dispose(),le.reject(new O.$5)});try{for await(const Oe of Y){if(Q.token.isCancellationRequested)return;le.emitOne(Oe)}ue.dispose(),Q.dispose()}catch(Oe){ue.dispose(),Q.dispose(),le.reject(Oe)}})}class we{constructor(Q){this.a=new ae,this.b=new be(ue=>{if(Y){ue.reject(Y);return}return le&&ue.emitMany(le),this.d=Oe=>ue.reject(Oe),this.f=Oe=>ue.emitOne(Oe),this.a.p},Q);let Y,le;this.f=ue=>{le||(le=[]),le.push(ue)},this.d=ue=>{Y||(Y=ue)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Q){this.d(Q),this.a.complete()}emitOne(Q){this.f(Q)}}e.$Zh=we}),define(Se[37],Ie([1,0,18,11,48,28,19,22,13]),function(he,e,P,O,M,N,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nk=e.$mk=void 0,e.$lk=E,e.$ok=g,e.$pk=C,e.$qk=I,e.$rk=W,e.$sk=V,e.$tk=q,e.$uk=ie;function E(){return Object.create(null)}e.$mk="**",e.$nk="/";const T="[/\\\\]",S="[^/\\\\]",l=/\//g;function b(ce,ve){switch(ce){case 0:return"";case 1:return`${S}*?`;default:return`(?:${T}|${S}+${T}${ve?`|${T}${S}+`:""})*?`}}function g(ce,ve){if(!ce)return[];const ke=[];let fe=!1,pe=!1,Ne="";for(const ae of ce){switch(ae){case ve:if(!fe&&!pe){ke.push(Ne),Ne="";continue}break;case"{":fe=!0;break;case"}":fe=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}Ne+=ae}return Ne&&ke.push(Ne),ke}function r(ce){if(!ce)return"";let ve="";const ke=g(ce,e.$nk);if(ke.every(fe=>fe===e.$mk))ve=".*";else{let fe=!1;ke.forEach((pe,Ne)=>{if(pe===e.$mk){if(fe)return;ve+=b(2,Ne===ke.length-1)}else{let ae=!1,Re="",ne=!1,z="";for(const x of pe){if(x!=="}"&&ae){Re+=x;continue}if(ne&&(x!=="]"||!z)){let be;x==="-"?be=x:(x==="^"||x==="!")&&!z?be="^":x===e.$nk?be="":be=(0,m.$_e)(x),z+=be;continue}switch(x){case"{":ae=!0;continue;case"[":ne=!0;continue;case"}":{const Te=`(?:${g(Re,",").map(De=>r(De)).join("|")})`;ve+=Te,ae=!1,Re="";break}case"]":{ve+="["+z+"]",ne=!1,z="";break}case"?":ve+=S;continue;case"*":ve+=b(1);continue;default:ve+=(0,m.$_e)(x)}}Ne<ke.length-1&&(ke[Ne+1]!==e.$mk||Ne+2<ke.length)&&(ve+=T)}fe=pe===e.$mk})}return ve}const s=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new N.$Dc(1e4),d=function(){return!1},a=function(){return null};function f(ce,ve){if(!ce)return a;let ke;typeof ce!="string"?ke=ce.pattern:ke=ce,ke=ke.trim();const fe=`${ke}_${!!ve.trimForExclusions}`;let pe=t.get(fe);if(pe)return w(pe,ce);let Ne;return s.test(ke)?pe=v(ke.substr(4),ke):(Ne=o.exec(p(ke,ve)))?pe=y(Ne[1],ke):(ve.trimForExclusions?i:n).test(ke)?pe=h(ke,ve):(Ne=c.exec(p(ke,ve)))?pe=D(Ne[1].substr(1),ke,!0):(Ne=u.exec(p(ke,ve)))?pe=D(Ne[1],ke,!1):pe=k(ke),t.set(fe,pe),w(pe,ce)}function w(ce,ve){if(typeof ve=="string")return ce;const ke=function(fe,pe){return(0,M.$vg)(fe,ve.base,!$.$k)?ce((0,m.$ef)(fe.substr(ve.base.length),A.sep),pe):null};return ke.allBasenames=ce.allBasenames,ke.allPaths=ce.allPaths,ke.basenames=ce.basenames,ke.patterns=ce.patterns,ke}function p(ce,ve){return ve.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function v(ce,ve){return function(ke,fe){return typeof ke=="string"&&ke.endsWith(ce)?ve:null}}function y(ce,ve){const ke=`/${ce}`,fe=`\\${ce}`,pe=function(ae,Re){return typeof ae!="string"?null:Re?Re===ce?ve:null:ae===ce||ae.endsWith(ke)||ae.endsWith(fe)?ve:null},Ne=[ce];return pe.basenames=Ne,pe.patterns=[ve],pe.allBasenames=Ne,pe}function h(ce,ve){const ke=K(ce.slice(1,-1).split(",").map(Re=>f(Re,ve)).filter(Re=>Re!==a),ce),fe=ke.length;if(!fe)return a;if(fe===1)return ke[0];const pe=function(Re,ne){for(let z=0,x=ke.length;z<x;z++)if(ke[z](Re,ne))return ce;return null},Ne=ke.find(Re=>!!Re.allBasenames);Ne&&(pe.allBasenames=Ne.allBasenames);const ae=ke.reduce((Re,ne)=>ne.allPaths?Re.concat(ne.allPaths):Re,[]);return ae.length&&(pe.allPaths=ae),pe}function D(ce,ve,ke){const fe=A.sep===A.$gc.sep,pe=fe?ce:ce.replace(l,A.sep),Ne=A.sep+pe,ae=A.$gc.sep+ce;let Re;return ke?Re=function(ne,z){return typeof ne=="string"&&(ne===pe||ne.endsWith(Ne)||!fe&&(ne===ce||ne.endsWith(ae)))?ve:null}:Re=function(ne,z){return typeof ne=="string"&&(ne===pe||!fe&&ne===ce)?ve:null},Re.allPaths=[(ke?"*/":"./")+ce],Re}function k(ce){try{const ve=new RegExp(`^${r(ce)}$`);return function(ke){return ve.lastIndex=0,typeof ke=="string"&&ve.test(ke)?ce:null}}catch{return a}}function C(ce,ve,ke){return!ce||typeof ve!="string"?!1:I(ce)(ve,void 0,ke)}function I(ce,ve={}){if(!ce)return d;if(typeof ce=="string"||W(ce)){const ke=f(ce,ve);if(ke===a)return d;const fe=function(pe,Ne){return!!ke(pe,Ne)};return ke.allBasenames&&(fe.allBasenames=ke.allBasenames),ke.allPaths&&(fe.allPaths=ke.allPaths),fe}return R(ce,ve)}function W(ce){const ve=ce;return ve?typeof ve.base=="string"&&typeof ve.pattern=="string":!1}function V(ce){return ce.allBasenames||[]}function q(ce){return ce.allPaths||[]}function R(ce,ve){const ke=K(Object.getOwnPropertyNames(ce).map(Re=>B(Re,ce[Re],ve)).filter(Re=>Re!==a)),fe=ke.length;if(!fe)return a;if(!ke.some(Re=>!!Re.requiresSiblings)){if(fe===1)return ke[0];const Re=function(x,be){let Te;for(let De=0,we=ke.length;De<we;De++){const ge=ke[De](x,be);if(typeof ge=="string")return ge;(0,O.$ih)(ge)&&(Te||(Te=[]),Te.push(ge))}return Te?(async()=>{for(const De of Te){const we=await De;if(typeof we=="string")return we}return null})():null},ne=ke.find(x=>!!x.allBasenames);ne&&(Re.allBasenames=ne.allBasenames);const z=ke.reduce((x,be)=>be.allPaths?x.concat(be.allPaths):x,[]);return z.length&&(Re.allPaths=z),Re}const pe=function(Re,ne,z){let x,be;for(let Te=0,De=ke.length;Te<De;Te++){const we=ke[Te];we.requiresSiblings&&z&&(ne||(ne=(0,A.$nc)(Re)),x||(x=ne.substr(0,ne.length-(0,A.$oc)(Re).length)));const ge=we(Re,ne,x,z);if(typeof ge=="string")return ge;(0,O.$ih)(ge)&&(be||(be=[]),be.push(ge))}return be?(async()=>{for(const Te of be){const De=await Te;if(typeof De=="string")return De}return null})():null},Ne=ke.find(Re=>!!Re.allBasenames);Ne&&(pe.allBasenames=Ne.allBasenames);const ae=ke.reduce((Re,ne)=>ne.allPaths?Re.concat(ne.allPaths):Re,[]);return ae.length&&(pe.allPaths=ae),pe}function B(ce,ve,ke){if(ve===!1)return a;const fe=f(ce,ke);if(fe===a)return a;if(typeof ve=="boolean")return fe;if(ve){const pe=ve.when;if(typeof pe=="string"){const Ne=(ae,Re,ne,z)=>{if(!z||!fe(ae,Re))return null;const x=pe.replace("$(basename)",()=>ne),be=z(x);return(0,O.$ih)(be)?be.then(Te=>Te?ce:null):be?ce:null};return Ne.requiresSiblings=!0,Ne}}return fe}function K(ce,ve){const ke=ce.filter(Re=>!!Re.basenames);if(ke.length<2)return ce;const fe=ke.reduce((Re,ne)=>{const z=ne.basenames;return z?Re.concat(z):Re},[]);let pe;if(ve){pe=[];for(let Re=0,ne=fe.length;Re<ne;Re++)pe.push(ve)}else pe=ke.reduce((Re,ne)=>{const z=ne.patterns;return z?Re.concat(z):Re},[]);const Ne=function(Re,ne){if(typeof Re!="string")return null;if(!ne){let x;for(x=Re.length;x>0;x--){const be=Re.charCodeAt(x-1);if(be===47||be===92)break}ne=Re.substr(x)}const z=fe.indexOf(ne);return z!==-1?pe[z]:null};Ne.basenames=fe,Ne.patterns=pe,Ne.allBasenames=fe;const ae=ce.filter(Re=>!Re.basenames);return ae.push(Ne),ae}function ie(ce,ve){return(0,P.$ub)(ce,ve,(ke,fe)=>typeof ke=="string"&&typeof fe=="string"?ke===fe:typeof ke!="string"&&typeof fe!="string"?ke.base===fe.base&&ke.pattern===fe.pattern:!1)}}),define(Se[55],Ie([1,0,14,137,23,13,2]),function(he,e,P,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.MarkdownStringTextNewlineStyle=void 0,e.$Uk=E,e.$Vk=T,e.$Wk=S,e.$Xk=l,e.$Yk=b,e.$Zk=g,e.$1k=r,e.$2k=s;var $;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class m{constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,P.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=l(this.supportThemeIcons?(0,O.$Nk)(n):n).replace(/([ \t]+)/g,(c,u)=>"&nbsp;".repeat(u.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${b(i,n)}
`,this}appendLink(n,i,c){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(n,i){const c=new RegExp((0,N.$_e)(i),"g");return n.replace(c,(u,t)=>n.charAt(t-1)!=="\\"?`\\${u}`:u)}}e.$Tk=m;function E(o){return T(o)?!o.value:Array.isArray(o)?o.every(E):!0}function T(o){return o instanceof m?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}function S(o,n){return o===n?!0:!o||!n?!1:o.value===n.value&&o.isTrusted===n.isTrusted&&o.supportThemeIcons===n.supportThemeIcons&&o.supportHtml===n.supportHtml&&(o.baseUri===n.baseUri||!!o.baseUri&&!!n.baseUri&&(0,M.$3g)(A.URI.from(o.baseUri),A.URI.from(n.baseUri)))}function l(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function b(o,n){const i=o.match(/^`+/gm)?.reduce((u,t)=>u.length>t.length?u:t).length??0,c=i>=3?i+1:3;return[`${"`".repeat(c)}${n}`,o,`${"`".repeat(c)}`].join(`
`)}function g(o){return o.replace(/"/g,"&quot;")}function r(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function s(o){const n=[],i=o.split("|").map(u=>u.trim());o=i[0];const c=i[1];if(c){const u=/height=(\d+)/.exec(c),t=/width=(\d+)/.exec(c),d=u?u[1]:"",a=t?t[1]:"",f=isFinite(parseInt(a)),w=isFinite(parseInt(d));f&&n.push(`width="${a}"`),w&&n.push(`height="${d}"`)}return{href:o,dimensions:n}}}),define(Se[97],Ie([1,0,18,48,19,22,23,13]),function(he,e,P,O,M,N,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dw=m,e.$Ew=T,e.$Fw=l,e.$Gw=b,e.$Hw=o,e.$Iw=i,e.$Jw=c,e.$Kw=u,e.$Lw=t,e.$Mw=d;function m(f,w){const{os:p,tildify:v,relative:y}=w;if(y){const k=E(f,y,p);if(typeof k=="string")return k}let h=f.fsPath;if(p===1&&!N.$i?h=h.replace(/\//g,"\\"):p!==1&&N.$i&&(h=h.replace(/\\/g,"/")),p!==1&&v?.userHome){const k=v.userHome.fsPath;let C;f.scheme!==v.userHome.scheme&&f.path[0]===M.$gc.sep&&f.path[1]!==M.$gc.sep?C=v.userHome.with({path:f.path}).fsPath:C=h,h=l(C,k,p)}return(p===1?M.$fc:M.$gc).normalize(T(h,p===1))}function E(f,w,p){const v=p===1?M.$fc:M.$gc,y=p===3?A.$Zg:A.$2g,h=w.getWorkspace(),D=(0,P.$Ob)(h.folders);if(!D)return;f.scheme!==D.uri.scheme&&f.path[0]===M.$gc.sep&&f.path[1]!==M.$gc.sep&&(f=D.uri.with({path:f.path}));const k=w.getWorkspaceFolder(f);if(!k)return;let C;if(y.isEqual(k.uri,f)?C="":C=y.relativePath(k.uri,f)??"",C&&(C=v.normalize(C)),h.folders.length>1&&!w.noPrefix){const I=k.name?k.name:y.basenameOrAuthority(k.uri);C=C?`${I} \u2022 ${C}`:I}return C}function T(f,w=N.$i){return(0,O.$Ag)(f,w)?f.charAt(0).toUpperCase()+f.slice(1):f}let S=Object.create(null);function l(f,w,p=N.OS){if(p===1||!f||!w)return f;let v=S.original===w?S.normalized:void 0;v||(v=w,N.$i&&(v=(0,O.$pg)(v)),v=`${(0,$.$ff)(v,M.$gc.sep)}${M.$gc.sep}`,S={original:w,normalized:v});let y=f;return N.$i&&(y=(0,O.$pg)(y)),(p===3?y.startsWith(v):(0,$.$yf)(y,v))?`~/${y.substr(v.length)}`:f}function b(f,w){return f.replace(/^~($|\/|\\)/,`${w}$1`)}const g="\u2026",r="\\\\",s="~";function o(f,w=M.sep){const p=new Array(f.length);let v=!1;for(let y=0;y<f.length;y++){const h=f[y];if(h===""){p[y]=`.${w}`;continue}if(!h){p[y]=h;continue}v=!0;let D="",k=h;k.indexOf(r)===0?(D=k.substr(0,k.indexOf(r)+r.length),k=k.substr(k.indexOf(r)+r.length)):k.indexOf(w)===0?(D=k.substr(0,k.indexOf(w)+w.length),k=k.substr(k.indexOf(w)+w.length)):k.indexOf(s)===0&&(D=k.substr(0,k.indexOf(s)+s.length),k=k.substr(k.indexOf(s)+s.length));const C=k.split(w);for(let I=1;v&&I<=C.length;I++)for(let W=C.length-I;v&&W>=0;W--){v=!1;let V=C.slice(W,W+I).join(w);for(let q=0;!v&&q<f.length;q++)if(q!==y&&f[q]&&f[q].indexOf(V)>-1){const R=W+I===C.length,B=W>0&&f[q].indexOf(w)>-1?w+V:V,K=f[q].endsWith(B);v=!R||K}if(!v){let q="";(C[0].endsWith(":")||D!=="")&&(W===1&&(W=0,I++,V=C[0]+w+V),W>0&&(q=C[0]+w),q=D+q),W>0&&(q=q+g+w),q=q+V,W+I<C.length&&(q=q+w+g),p[y]=q}}v&&(p[y]=h)}return p}var n;(function(f){f[f.TEXT=0]="TEXT",f[f.VARIABLE=1]="VARIABLE",f[f.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(f,w=Object.create(null)){const p=[];let v=!1,y="";for(const h of f)if(h==="$"||v&&h==="{")y&&p.push({value:y,type:n.TEXT}),y="",v=!0;else if(h==="}"&&v){const D=w[y];if(typeof D=="string")D.length&&p.push({value:D,type:n.VARIABLE});else if(D){const k=p[p.length-1];(!k||k.type!==n.SEPARATOR)&&p.push({value:D.label,type:n.SEPARATOR})}y="",v=!1}else y+=h;return y&&!v&&p.push({value:y,type:n.TEXT}),p.filter((h,D)=>{if(h.type===n.SEPARATOR){const k=p[D-1],C=p[D+1];return[k,C].every(I=>I&&(I.type===n.VARIABLE||I.type===n.TEXT)&&I.value.length>0)}return!0}).map(h=>h.value).join("")}function c(f,w){return N.$j||w?f.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.$j?"&":"&&"):f.replace(/&&|&/g,p=>p==="&"?"&&":"&")}function u(f,w){return N.$j||w?f.replace(/\(&&\w\)|&&/g,""):N.$i?f.replace(/&&|&/g,p=>p==="&"?"&&":"&"):f.replace(/&&/g,"_")}function t(f){return f.replace(/&/g,"&&")}function d(f){if(f.endsWith("]")){const w=f.lastIndexOf(" [",f.length-2);if(w!==-1){const p=a(f.substring(0,w)),v=f.substring(w);return{name:p.name+v,parentPath:p.parentPath}}}return a(f)}function a(f){const w=f.indexOf("/")!==-1?M.$gc:M.$fc,p=w.basename(f),v=w.dirname(f);return p.length?{name:p,parentPath:v}:{name:v,parentPath:""}}}),define(Se[150],Ie([1,0,21,2]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$yn=void 0,e.$An=$,e.$Bn=E,e.$Cn=T;function M(S){return S.toJSON()}class N{constructor(l){this.a=l}transformIncoming(l){const b=this.a.transformIncoming(l);return b===l?l:M(O.URI.from(b))}transformOutgoing(l){const b=this.a.transformOutgoing(l);return b===l?l:M(O.URI.from(b))}transformOutgoingURI(l){const b=this.a.transformOutgoing(l);return b===l?l:O.URI.from(b)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$yn=N,e.$zn=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function A(S,l,b){if(!S||b>200)return null;if(typeof S=="object"){if(S instanceof O.URI)return l.transformOutgoing(S);for(const g in S)if(Object.hasOwnProperty.call(S,g)){const r=A(S[g],l,b+1);r!==null&&(S[g]=r)}}return null}function $(S,l){const b=A(S,l,0);return b===null?S:b}function m(S,l,b,g){if(!S||g>200)return null;if(typeof S=="object"){if(S.$mid===1)return b?O.URI.revive(l.transformIncoming(S)):l.transformIncoming(S);if(S instanceof P.$Fe)return null;for(const r in S)if(Object.hasOwnProperty.call(S,r)){const s=m(S[r],l,b,g+1);s!==null&&(S[r]=s)}}return null}function E(S,l){const b=m(S,l,!1,0);return b===null?S:b}function T(S,l){const b=m(S,l,!0,0);return b===null?S:b}}),define(Se[151],Ie([1,0,11,5,6,49,15]),function(he,e,P,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=e.StorageState=e.StorageHint=void 0,e.$Vp=m;var $;(function(l){l[l.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",l[l.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})($||(e.StorageHint=$={}));function m(l){const b=l;return b?.changed instanceof Map||b?.deleted instanceof Set}var E;(function(l){l[l.None=0]="None",l[l.Initialized=1]="Initialized",l[l.Closed=2]="Closed"})(E||(e.StorageState=E={}));class T extends M.$Uc{static{this.a=100}constructor(b,g=Object.create(null)){super(),this.r=b,this.s=g,this.b=this.B(new O.$ge),this.onDidChangeStorage=this.b.event,this.c=E.None,this.f=new Map,this.g=this.B(new P.$uh(T.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(b=>this.u(b)))}u(b){this.b.pause();try{b.changed?.forEach((g,r)=>this.w(r,g)),b.deleted?.forEach(g=>this.w(g,void 0))}finally{this.b.resume()}}w(b,g){if(this.c===E.Closed)return;let r=!1;(0,A.$fg)(g)?r=this.f.delete(b):this.f.get(b)!==g&&(this.f.set(b,g),r=!0),r&&this.b.fire({key:b,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===E.None&&(this.c=E.Initialized,this.s.hint!==$.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(b,g){const r=this.f.get(b);return(0,A.$fg)(r)?g:r}getBoolean(b,g){const r=this.get(b);return(0,A.$fg)(r)?g:r==="true"}getNumber(b,g){const r=this.get(b);return(0,A.$fg)(r)?g:parseInt(r,10)}getObject(b,g){const r=this.get(b);return(0,A.$fg)(r)?g:(0,N.$5h)(r)}async set(b,g,r=!1){if(this.c===E.Closed)return;if((0,A.$fg)(g))return this.delete(b,r);const s=(0,A.$$f)(g)||Array.isArray(g)?(0,N.$4h)(g):String(g);if(this.f.get(b)!==s)return this.f.set(b,s),this.j.set(b,s),this.h.delete(b),this.b.fire({key:b,external:r}),this.D()}async delete(b,g=!1){if(!(this.c===E.Closed||!this.f.delete(b)))return this.h.has(b)||this.h.add(b),this.j.delete(b),this.b.fire({key:b,external:g}),this.D()}async optimize(){if(this.c!==E.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=E.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const b={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(b).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(b){if(!(this.c===E.Closed||this.m))return this.D(b)}async D(b){return this.s.hint===$.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),b)}async whenFlushed(){if(this.z)return new Promise(b=>this.n.push(b))}isInMemory(){return this.s.hint===$.STORAGE_IN_MEMORY}}e.$Wp=T;class S{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(b){b.insert?.forEach((g,r)=>this.a.set(r,g)),b.delete?.forEach(g=>this.a.delete(g))}async optimize(){}async close(){}}e.$Xp=S}),define(Se[152],Ie([1,0,13,22,21]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=void 0,e.$Dt=T,e.$Et=S;let N;function A(){return N||(N=new TextDecoder("UTF-16LE")),N}let $;function m(){return $||($=new TextDecoder("UTF-16BE")),$}let E;function T(){return E||(E=O.$D()?A():m()),E}function S(g,r,s){const o=new Uint16Array(g.buffer,r,s);return s>0&&(o[0]===65279||o[0]===65534)?l(g,r,s):A().decode(o)}function l(g,r,s){const o=[];let n=0;for(let i=0;i<s;i++){const c=M.$He(g,r);r+=2,o[n++]=String.fromCharCode(c)}return o.join("")}class b{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return T().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const s=this.a-this.d;s<=1&&(s===0||P.$Bf(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const s=r.length;if(this.d+s>=this.a){this.f(),this.c[this.c.length]=r;return}for(let o=0;o<s;o++)this.b[this.d++]=r.charCodeAt(o)}}e.$Ft=b}),define(Se[153],Ie([1,0,21,152]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gt=void 0,e.$Ht=A;function M(m){return m.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class N{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,T,S,l){this.oldPosition=E,this.oldText=T,this.newPosition=S,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${M(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${M(this.oldText)}")`:`(replace@${this.oldPosition} "${M(this.oldText)}" with "${M(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,T,S){const l=T.length;P.$Ke(E,l,S),S+=4;for(let b=0;b<l;b++)P.$Ie(E,T.charCodeAt(b),S),S+=2;return S}static d(E,T){const S=P.$Je(E,T);return T+=4,(0,O.$Et)(E,T,S)}writeSize(){return 8+N.a(this.oldText)+N.a(this.newText)}write(E,T){return P.$Ke(E,this.oldPosition,T),T+=4,P.$Ke(E,this.newPosition,T),T+=4,T=N.c(E,this.oldText,T),T=N.c(E,this.newText,T),T}static read(E,T,S){const l=P.$Je(E,T);T+=4;const b=P.$Je(E,T);T+=4;const g=N.d(E,T);T+=N.a(g);const r=N.d(E,T);return T+=N.a(r),S.push(new N(l,g,b,r)),T}}e.$Gt=N;function A(m,E){return m===null||m.length===0?E:new $(m,E).compress()}class ${constructor(E,T){this.a=E,this.c=T,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,T=0,S=this.n(E),l=this.l(T);for(;E<this.f||T<this.h;){if(S===null){this.k(l),l=this.l(++T);continue}if(l===null){this.m(S),S=this.n(++E);continue}if(l.oldEnd<=S.newPosition){this.k(l),l=this.l(++T);continue}if(S.newEnd<=l.oldPosition){this.m(S),S=this.n(++E);continue}if(l.oldPosition<S.newPosition){const[o,n]=$.r(l,S.newPosition-l.oldPosition);this.k(o),l=n;continue}if(S.newPosition<l.oldPosition){const[o,n]=$.q(S,l.oldPosition-S.newPosition);this.m(o),S=n;continue}let r,s;if(l.oldEnd===S.newEnd)r=S,s=l,S=this.n(++E),l=this.l(++T);else if(l.oldEnd<S.newEnd){const[o,n]=$.q(S,l.oldLength);r=o,s=l,S=n,l=this.l(++T)}else{const[o,n]=$.r(l,S.newLength);r=S,s=o,S=this.n(++E),l=n}this.d[this.e++]=new N(r.oldPosition,r.oldText,s.newPosition,s.newText),this.g+=r.newLength-r.oldLength,this.j+=s.newLength-s.oldLength}const b=$.s(this.d);return $.t(b)}k(E){this.d[this.e++]=$.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=$.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,T){return new N(T.oldPosition-E,T.oldText,T.newPosition,T.newText)}static p(E,T){return new N(T.oldPosition,T.oldText,T.newPosition+E,T.newText)}static q(E,T){const S=E.newText.substr(0,T),l=E.newText.substr(T);return[new N(E.oldPosition,E.oldText,E.newPosition,S),new N(E.oldEnd,"",E.newPosition+T,l)]}static r(E,T){const S=E.oldText.substr(0,T),l=E.oldText.substr(T);return[new N(E.oldPosition,S,E.newPosition,E.newText),new N(E.oldPosition+T,l,E.newEnd,"")]}static s(E){if(E.length===0)return E;const T=[];let S=0,l=E[0];for(let b=1;b<E.length;b++){const g=E[b];l.oldEnd===g.oldPosition?l=new N(l.oldPosition,l.oldText+g.oldText,l.newPosition,l.newText+g.newText):(T[S++]=l,l=g)}return T[S++]=l,T}static t(E){if(E.length===0)return E;const T=[];let S=0;for(let l=0;l<E.length;l++){const b=E[l];b.oldText!==b.newText&&(T[S++]=b)}return T}}}),define(Se[154],Ie([1,0,37,19]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xt=M,e.$Yt=N;function M(A,$,m,E,T,S){if(Array.isArray(A)){let l=0;for(const b of A){const g=M(b,$,m,E,T,S);if(g===10)return g;g>l&&(l=g)}return l}else{if(typeof A=="string")return E?A==="*"?5:A===m?10:0:0;if(A){const{language:l,pattern:b,scheme:g,hasAccessToAllModels:r,notebookType:s}=A;if(!E&&!r)return 0;s&&T&&($=T);let o=0;if(g)if(g===$.scheme)o=10;else if(g==="*")o=5;else return 0;if(l)if(l===m)o=10;else if(l==="*")o=Math.max(o,5);else return 0;if(s)if(s===S)o=10;else if(s==="*"&&S!==void 0)o=Math.max(o,5);else return 0;if(b){let n;if(typeof b=="string"?n=b:n={...b,base:(0,O.$hc)(b.base)},n===$.fsPath||(0,P.$pk)(n,$.fsPath))o=10;else return 0}return o}else return 0}}function N(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(N):!!A.notebookType}}),define(Se[155],Ie([1,0,5,13,30,95,93,139,153,6]),function(he,e,P,O,M,N,A,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1C=void 0;class T extends E.$Uc{constructor(l,b,g,r,s,o,n){super(),this.m=this.B(new P.$de),this.onDidChangeContent=this.m.event,this.f=b,this.j=!o,this.g=r,this.h=s,this.c=new A.$ZC(l,g,n)}equals(l){return!(l instanceof T)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,b){return this.c.getOffsetAt(l,b)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,b){const g=l+b,r=this.getPositionAt(l),s=this.getPositionAt(g);return new M.$ut(r.lineNumber,r.column,s.lineNumber,s.column)}getValueInRange(l,b=0){if(l.isEmpty())return"";const g=this.n(b);return this.c.getValueInRange(l,g)}getValueLengthInRange(l,b=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const g=this.getOffsetAt(l.startLineNumber,l.startColumn),r=this.getOffsetAt(l.endLineNumber,l.endColumn);let s=0;const o=this.n(b),n=this.getEOL();if(o.length!==n.length){const i=o.length-n.length,c=l.endLineNumber-l.startLineNumber;s=i*c}return r-g+s}getCharacterCountInRange(l,b=0){if(this.j){let g=0;const r=l.startLineNumber,s=l.endLineNumber;for(let o=r;o<=s;o++){const n=this.getLineContent(o),i=o===r?l.startColumn-1:0,c=o===s?l.endColumn-1:n.length;for(let u=i;u<c;u++)O.$Bf(n.charCodeAt(u))?(g=g+1,u=u+1):g=g+1}return g+=this.n(b).length*(s-r),g}return this.getValueLengthInRange(l,b)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,b){return this.c.getLineCharCode(l,b)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const b=O.$mf(this.getLineContent(l));return b===-1?0:b+1}getLineLastNonWhitespaceColumn(l){const b=O.$of(this.getLineContent(l));return b===-1?0:b+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,b,g){let r=this.g,s=this.h,o=this.j,n=!0,i=[];for(let w=0;w<l.length;w++){const p=l[w];n&&p._isTracked&&(n=!1);const v=p.range;if(p.text){let C=!0;o||(C=!O.$Mf(p.text),o=C),!r&&C&&(r=O.$Lf(p.text)),!s&&C&&(s=O.$Of(p.text))}let y="",h=0,D=0,k=0;if(p.text){let C;[h,D,k,C]=(0,$.$1t)(p.text);const I=this.getEOL();C===0||C===(I===`\r
`?2:1)?y=p.text:y=p.text.replace(/\r\n|\r|\n/g,I)}i[w]={sortIndex:w,identifier:p.identifier||null,range:v,rangeOffset:this.getOffsetAt(v.startLineNumber,v.startColumn),rangeLength:this.getValueLengthInRange(v),text:y,eolCount:h,firstLineLength:D,lastLineLength:k,forceMoveMarkers:!!p.forceMoveMarkers,isAutoWhitespaceEdit:p.isAutoWhitespaceEdit||!1}}i.sort(T.u);let c=!1;for(let w=0,p=i.length-1;w<p;w++){const v=i[w].range.getEndPosition(),y=i[w+1].range.getStartPosition();if(y.isBeforeOrEqual(v)){if(y.isBefore(v))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(i=this.s(i));const u=g||b?T._getInverseEditRanges(i):[],t=[];if(b)for(let w=0;w<i.length;w++){const p=i[w],v=u[w];if(p.isAutoWhitespaceEdit&&p.range.isEmpty())for(let y=v.startLineNumber;y<=v.endLineNumber;y++){let h="";y===v.startLineNumber&&(h=this.getLineContent(p.range.startLineNumber),O.$mf(h)!==-1)||t.push({lineNumber:y,oldContent:h})}}let d=null;if(g){let w=0;d=[];for(let p=0;p<i.length;p++){const v=i[p],y=u[p],h=this.getValueInRange(v.range),D=v.rangeOffset+w;w+=v.text.length-h.length,d[p]={sortIndex:v.sortIndex,identifier:v.identifier,range:y,text:h,textChange:new m.$Gt(v.rangeOffset,h,D,v.text)}}c||d.sort((p,v)=>p.sortIndex-v.sortIndex)}this.g=r,this.h=s,this.j=o;const a=this.t(i);let f=null;if(b&&t.length>0){t.sort((w,p)=>p.lineNumber-w.lineNumber),f=[];for(let w=0,p=t.length;w<p;w++){const v=t[w].lineNumber;if(w>0&&t[w-1].lineNumber===v)continue;const y=t[w].oldContent,h=this.getLineContent(v);h.length===0||h===y||O.$mf(h)!==-1||f.push(v)}}return this.m.fire(),new N.$Jv(d,a,f)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let b=!1;const g=l[0].range,r=l[l.length-1].range,s=new M.$ut(g.startLineNumber,g.startColumn,r.endLineNumber,r.endColumn);let o=g.startLineNumber,n=g.startColumn;const i=[];for(let a=0,f=l.length;a<f;a++){const w=l[a],p=w.range;b=b||w.forceMoveMarkers,i.push(this.getValueInRange(new M.$ut(o,n,p.startLineNumber,p.startColumn))),w.text.length>0&&i.push(w.text),o=p.endLineNumber,n=p.endColumn}const c=i.join(""),[u,t,d]=(0,$.$1t)(c);return{sortIndex:0,identifier:l[0].identifier,range:s,rangeOffset:this.getOffsetAt(s.startLineNumber,s.startColumn),rangeLength:this.getValueLengthInRange(s,0),text:c,eolCount:u,firstLineLength:t,lastLineLength:d,forceMoveMarkers:b,isAutoWhitespaceEdit:!1}}t(l){l.sort(T.w);const b=[];for(let g=0;g<l.length;g++){const r=l[g],s=r.range.startLineNumber,o=r.range.startColumn,n=r.range.endLineNumber,i=r.range.endColumn;if(s===n&&o===i&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const c=new M.$ut(s,o,n,i);b.push({range:c,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return b}findMatchesLineByLine(l,b,g,r){return this.c.findMatchesLineByLine(l,b,g,r)}getPieceTree(){return this.c}static _getInverseEditRange(l,b){const g=l.startLineNumber,r=l.startColumn,[s,o,n]=(0,$.$1t)(b);let i;if(b.length>0){const c=s+1;c===1?i=new M.$ut(g,r,g,r+o):i=new M.$ut(g,r,g+c-1,n+1)}else i=new M.$ut(g,r,g,r);return i}static _getInverseEditRanges(l){const b=[];let g=0,r=0,s=null;for(let o=0,n=l.length;o<n;o++){const i=l[o];let c,u;s?s.range.endLineNumber===i.range.startLineNumber?(c=g,u=r+(i.range.startColumn-s.range.endColumn)):(c=g+(i.range.startLineNumber-s.range.endLineNumber),u=i.range.startColumn):(c=i.range.startLineNumber,u=i.range.startColumn);let t;if(i.text.length>0){const d=i.eolCount+1;d===1?t=new M.$ut(c,u,c,u+i.firstLineLength):t=new M.$ut(c,u,c+d-1,i.lastLineLength+1)}else t=new M.$ut(c,u,c,u);g=t.endLineNumber,r=t.endColumn,b.push(t),s=i}return b}static u(l,b){const g=M.$ut.compareRangesUsingEnds(l.range,b.range);return g===0?l.sortIndex-b.sortIndex:g}static w(l,b){const g=M.$ut.compareRangesUsingEnds(l.range,b.range);return g===0?b.sortIndex-l.sortIndex:-g}}e.$1C=T}),define(Se[156],Ie([1,0,13,93,155]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2C=void 0;class N{constructor(m,E,T,S,l,b,g,r,s){this.a=m,this.b=E,this.c=T,this.d=S,this.e=l,this.f=b,this.g=g,this.h=r,this.j=s}k(m){const E=this.c+this.d+this.e,T=this.c+this.e;return E===0?m===1?`
`:`\r
`:T>E/2?`\r
`:`
`}create(m){const E=this.k(m),T=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let l=0,b=T.length;l<b;l++){const g=T[l].buffer.replace(/\r\n|\r|\n/g,E),r=(0,O.$VC)(g);T[l]=new O.$YC(g,r)}const S=new M.$1C(T,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(m){return this.a[0].buffer.substr(0,m).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(m){if(m.length===0)return;this.a.length===0&&P.$Wf(m)&&(this.b=P.$Vf,m=m.substr(1));const E=m.charCodeAt(m.length-1);E===13||E>=55296&&E<=56319?(this.m(m.substr(0,m.length-1),!1),this.c=!0,this.d=E):(this.m(m,!1),this.c=!1,this.d=E)}m(m,E){!E&&m.length===0||(this.c?this.n(String.fromCharCode(this.d)+m):this.n(m))}n(m){const E=(0,O.$WC)(this.e,m);this.a.push(new O.$YC(m,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=P.$Lf(m)),this.k||(this.k=P.$Of(m)))}finish(m=!0){return this.o(),new N(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,m)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const m=this.a[this.a.length-1];m.buffer+=String.fromCharCode(this.d);const E=(0,O.$VC)(m.buffer);m.lineStarts=E,this.d===13&&this.f++}}}e.$2C=A}),define(Se[98],Ie([1,0,21,22]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hbb=m,e.$ibb=T;var M;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(M||(M={}));function N(S){for(let l=0,b=S.length;l<b;l+=4){const g=S[l+0],r=S[l+1],s=S[l+2],o=S[l+3];S[l+0]=o,S[l+1]=s,S[l+2]=r,S[l+3]=g}}function A(S){const l=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return O.$D()||N(l),P.$Fe.wrap(l)}function $(S){const l=S.buffer;if(O.$D()||N(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const b=new Uint8Array(l.byteLength);return b.set(l),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function m(S){const l=new Uint32Array(E(S));let b=0;if(l[b++]=S.id,S.type==="full")l[b++]=1,l[b++]=S.data.length,l.set(S.data,b),b+=S.data.length;else{l[b++]=2,l[b++]=S.deltas.length;for(const g of S.deltas)l[b++]=g.start,l[b++]=g.deleteCount,g.data?(l[b++]=g.data.length,l.set(g.data,b),b+=g.data.length):l[b++]=0}return A(l)}function E(S){let l=0;if(l+=2,S.type==="full")l+=1+S.data.length;else{l+=1,l+=3*S.deltas.length;for(const b of S.deltas)b.data&&(l+=b.data.length)}return l}function T(S){const l=$(S);let b=0;const g=l[b++];if(l[b++]===1){const n=l[b++],i=l.subarray(b,b+n);return b+=n,{id:g,type:"full",data:i}}const s=l[b++],o=[];for(let n=0;n<s;n++){const i=l[b++],c=l[b++],u=l[b++];let t;u>0&&(t=l.subarray(b,b+u),b+=u),o[n]={start:i,deleteCount:c,data:t}}return{id:g,type:"delta",deltas:o}}}),define(Se[157],Ie([9,10]),function(he,e){return he.create("vs/editor/common/config/editorOptions",e)}),define(Se[158],Ie([1,0,18,25,22,140,159,157]),function(he,e,P,O,M,N,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=s,e.clampedInt=n,e.clampedFloat=c,e.stringSet=d,e.cursorStyleToString=k,e.filterValidationDecorations=ue;var m;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(m||(e.EditorAutoIndentStrategy=m={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=E;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class S{constructor(Z,$e,me,Ze){this.id=Z,this.name=$e,this.defaultValue=me,this.schema=Ze}applyUpdate(Z,$e){return b(Z,$e)}compute(Z,$e,me){return me}}class l{constructor(Z,$e){this.newValue=Z,this.didChange=$e}}e.ApplyUpdateResult=l;function b(X,Z){if(typeof X!="object"||typeof Z!="object"||!X||!Z)return new l(Z,X!==Z);if(Array.isArray(X)||Array.isArray(Z)){const me=Array.isArray(X)&&Array.isArray(Z)&&P.$ub(X,Z);return new l(Z,!me)}let $e=!1;for(const me in Z)if(Z.hasOwnProperty(me)){const Ze=b(X[me],Z[me]);Ze.didChange&&(X[me]=Ze.newValue,$e=!0)}return new l(X,$e)}class g{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,$e){return b(Z,$e)}validate(Z){return this.defaultValue}}class r{constructor(Z,$e,me,Ze){this.id=Z,this.name=$e,this.defaultValue=me,this.schema=Ze}applyUpdate(Z,$e){return b(Z,$e)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,$e,me){return me}}function s(X,Z){return typeof X>"u"?Z:X==="false"?!1:!!X}class o extends r{constructor(Z,$e,me,Ze=void 0){typeof Ze<"u"&&(Ze.type="boolean",Ze.default=me),super(Z,$e,me,Ze)}validate(Z){return s(Z,this.defaultValue)}}function n(X,Z,$e,me){if(typeof X>"u")return Z;let Ze=parseInt(X,10);return isNaN(Ze)?Z:(Ze=Math.max($e,Ze),Ze=Math.min(me,Ze),Ze|0)}class i extends r{static clampedInt(Z,$e,me,Ze){return n(Z,$e,me,Ze)}constructor(Z,$e,me,Ze,at,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=me,dt.minimum=Ze,dt.maximum=at),super(Z,$e,me,dt),this.minimum=Ze,this.maximum=at}validate(Z){return i.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function c(X,Z,$e,me){if(typeof X>"u")return Z;const Ze=u.float(X,Z);return u.clamp(Ze,$e,me)}class u extends r{static clamp(Z,$e,me){return Z<$e?$e:Z>me?me:Z}static float(Z,$e){if(typeof Z=="number")return Z;if(typeof Z>"u")return $e;const me=parseFloat(Z);return isNaN(me)?$e:me}constructor(Z,$e,me,Ze,at){typeof at<"u"&&(at.type="number",at.default=me),super(Z,$e,me,at),this.validationFn=Ze}validate(Z){return this.validationFn(u.float(Z,this.defaultValue))}}class t extends r{static string(Z,$e){return typeof Z!="string"?$e:Z}constructor(Z,$e,me,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.default=me),super(Z,$e,me,Ze)}validate(Z){return t.string(Z,this.defaultValue)}}function d(X,Z,$e,me){return typeof X!="string"?Z:me&&X in me?me[X]:$e.indexOf(X)===-1?Z:X}class a extends r{constructor(Z,$e,me,Ze,at=void 0){typeof at<"u"&&(at.type="string",at.enum=Ze,at.default=me),super(Z,$e,me,at),this.c=Ze}validate(Z){return d(Z,this.defaultValue,this.c)}}class f extends S{constructor(Z,$e,me,Ze,at,dt,Ct=void 0){typeof Ct<"u"&&(Ct.type="string",Ct.enum=at,Ct.default=Ze),super(Z,$e,me,Ct),this.c=at,this.d=dt}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function w(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,$e,me){return me===0?Z.accessibilitySupport:me}}class v extends S{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:$.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{insertSpace:s($e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:s($e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var y;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(y||(e.TextEditorCursorBlinkingStyle=y={}));function h(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var D;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(D||(e.TextEditorCursorStyle=D={}));function k(X){switch(X){case D.Line:return"line";case D.Block:return"block";case D.Underline:return"underline";case D.LineThin:return"line-thin";case D.BlockOutline:return"block-outline";case D.UnderlineThin:return"underline-thin"}}function C(X){switch(X){case"line":return D.Line;case"block":return D.Block;case"underline":return D.Underline;case"line-thin":return D.LineThin;case"block-outline":return D.BlockOutline;case"underline-thin":return D.UnderlineThin}}class I extends g{constructor(){super(142)}compute(Z,$e,me){const Ze=["monaco-editor"];return $e.get(39)&&Ze.push($e.get(39)),Z.extraEditorClassName&&Ze.push(Z.extraEditorClassName),$e.get(74)==="default"?Ze.push("mouse-default"):$e.get(74)==="copy"&&Ze.push("mouse-copy"),$e.get(111)&&Ze.push("showUnused"),$e.get(140)&&Ze.push("showDeprecated"),Ze.join(" ")}}class W extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(Z,$e,me){return me&&Z.emptySelectionClipboard}}class V extends S{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:$.localize(16,null),included:M.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:$.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{cursorMoveOnType:s($e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":d($e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":d($e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:s($e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:s($e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:s($e.loop,this.defaultValue.loop)}}}class q extends S{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"||Z.length===0?q.OFF:Z==="true"?q.ON:Z:Z?q.ON:q.OFF}}e.EditorFontLigatures=q;class R extends S{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",R.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?R.OFF:Z==="true"?R.TRANSLATE:Z:Z?R.TRANSLATE:R.OFF}compute(Z,$e,me){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=R;class B extends g{constructor(){super(50)}compute(Z,$e,me){return Z.fontInfo}}class K extends r{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(Z){const $e=u.float(Z,this.defaultValue);return $e===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp($e,6,100)}compute(Z,$e,me){return Z.fontInfo.fontSize}}class ie extends S{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ie.d,maximum:ie.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ie.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(i.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,ie.d,ie.e))}}class ce extends S{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},$e={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},me=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...$e},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...$e},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...$e},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...$e},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...$e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:me,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:me,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:me,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:me,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:me,description:$.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{multiple:d($e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:$e.multipleDefinitions??d($e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:$e.multipleTypeDefinitions??d($e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:$e.multipleDeclarations??d($e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:$e.multipleImplementations??d($e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:$e.multipleReferences??d($e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string($e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string($e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string($e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string($e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string($e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ve extends S{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:$.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:s($e.enabled,this.defaultValue.enabled),delay:i.clampedInt($e.delay,this.defaultValue.delay,0,1e4),sticky:s($e.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt($e.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:s($e.above,this.defaultValue.above)}}}var ke;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(ke||(e.RenderMinimap=ke={}));class fe extends g{constructor(){super(145)}compute(Z,$e,me){return fe.computeLayout($e,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const $e=Z.height/Z.lineHeight,me=Math.floor(Z.paddingTop/Z.lineHeight);let Ze=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(Ze=Math.max(Ze,$e-1));const at=(me+Z.viewLineCount+Ze)/(Z.pixelRatio*Z.height),dt=Math.floor(Z.viewLineCount/at);return{typicalViewportLineCount:$e,extraLinesBeforeFirstLine:me,extraLinesBeyondLastLine:Ze,desiredRatio:at,minimapLineCount:dt}}static c(Z,$e){const me=Z.outerWidth,Ze=Z.outerHeight,at=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(at*Ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ze};const dt=$e.stableMinimapLayoutInput,Ct=dt&&Z.outerHeight===dt.outerHeight&&Z.lineHeight===dt.lineHeight&&Z.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&Z.pixelRatio===dt.pixelRatio&&Z.scrollBeyondLastLine===dt.scrollBeyondLastLine&&Z.paddingTop===dt.paddingTop&&Z.paddingBottom===dt.paddingBottom&&Z.minimap.enabled===dt.minimap.enabled&&Z.minimap.side===dt.minimap.side&&Z.minimap.size===dt.minimap.size&&Z.minimap.showSlider===dt.minimap.showSlider&&Z.minimap.renderCharacters===dt.minimap.renderCharacters&&Z.minimap.maxColumn===dt.minimap.maxColumn&&Z.minimap.scale===dt.minimap.scale&&Z.verticalScrollbarWidth===dt.verticalScrollbarWidth&&Z.isViewportWrapping===dt.isViewportWrapping,Bt=Z.lineHeight,Qt=Z.typicalHalfwidthCharacterWidth,xt=Z.scrollBeyondLastLine,Zt=Z.minimap.renderCharacters;let kt=at>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const _t=Z.minimap.maxColumn,Xe=Z.minimap.size,ti=Z.minimap.side,ii=Z.verticalScrollbarWidth,ht=Z.viewLineCount,pt=Z.remainingWidth,Lt=Z.isViewportWrapping,Gt=Zt?2:3;let Tt=Math.floor(at*Ze);const mt=Tt/at;let Pt=!1,ai=!1,Ut=Gt*kt,Je=kt/at,ni=1;if(Xe==="fill"||Xe==="fit"){const{typicalViewportLineCount:Vt,extraLinesBeforeFirstLine:Xt,extraLinesBeyondLastLine:Kt,desiredRatio:zt,minimapLineCount:Mt}=fe.computeContainedMinimapLineCount({viewLineCount:ht,scrollBeyondLastLine:xt,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:Ze,lineHeight:Bt,pixelRatio:at});if(ht/Mt>1)Pt=!0,ai=!0,kt=1,Ut=1,Je=kt/at;else{let St=!1,yt=kt+1;if(Xe==="fit"){const wt=Math.ceil((Xt+ht+Kt)*Ut);Lt&&Ct&&pt<=$e.stableFitRemainingWidth?(St=!0,yt=$e.stableFitMaxMinimapScale):St=wt>Tt}if(Xe==="fill"||St){Pt=!0;const wt=kt;Ut=Math.min(Bt*at,Math.max(1,Math.floor(1/zt))),Lt&&Ct&&pt<=$e.stableFitRemainingWidth&&(yt=$e.stableFitMaxMinimapScale),kt=Math.min(yt,Math.max(1,Math.floor(Ut/Gt))),kt>wt&&(ni=Math.min(2,kt/wt)),Je=kt/at/ni,Tt=Math.ceil(Math.max(Vt,Xt+ht+Kt)*Ut),Lt?($e.stableMinimapLayoutInput=Z,$e.stableFitRemainingWidth=pt,$e.stableFitMaxMinimapScale=kt):($e.stableMinimapLayoutInput=null,$e.stableFitRemainingWidth=0)}}}const ci=Math.floor(_t*Je),Ht=Math.min(ci,Math.max(0,Math.floor((pt-ii-2)*Je/(Qt+Je)))+e.MINIMAP_GUTTER_WIDTH);let gt=Math.floor(at*Ht);const At=gt/at;gt=Math.floor(gt*ni);const Ot=Zt?1:2,Nt=ti==="left"?0:me-Ht-ii;return{renderMinimap:Ot,minimapLeft:Nt,minimapWidth:Ht,minimapHeightIsEditorHeight:Pt,minimapIsSampling:ai,minimapScale:kt,minimapLineHeight:Ut,minimapCanvasInnerWidth:gt,minimapCanvasInnerHeight:Tt,minimapCanvasOuterWidth:At,minimapCanvasOuterHeight:mt}}static computeLayout(Z,$e){const me=$e.outerWidth|0,Ze=$e.outerHeight|0,at=$e.lineHeight|0,dt=$e.lineNumbersDigitCount|0,Ct=$e.typicalHalfwidthCharacterWidth,Bt=$e.maxDigitWidth,Qt=$e.pixelRatio,xt=$e.viewLineCount,Zt=Z.get(137),kt=Zt==="inherit"?Z.get(136):Zt,_t=kt==="inherit"?Z.get(132):kt,Xe=Z.get(135),ti=$e.isDominatedByLongLines,ii=Z.get(57),ht=Z.get(68).renderType!==0,pt=Z.get(69),Lt=Z.get(105),Gt=Z.get(84),Tt=Z.get(73),mt=Z.get(103),Pt=mt.verticalScrollbarSize,ai=mt.verticalHasArrows,Ut=mt.arrowSize,Je=mt.horizontalScrollbarSize,ni=Z.get(43),ci=Z.get(110)!=="never";let Ht=Z.get(66);ni&&ci&&(Ht+=16);let gt=0;if(ht){const Et=Math.max(dt,pt);gt=Math.round(Et*Bt)}let At=0;ii&&(At=at*$e.glyphMarginDecorationLaneCount);let Ot=0,Nt=Ot+At,Vt=Nt+gt,Xt=Vt+Ht;const Kt=me-At-gt-Ht;let zt=!1,Mt=!1,Jt=-1;kt==="inherit"&&ti?(zt=!0,Mt=!0):_t==="on"||_t==="bounded"?Mt=!0:_t==="wordWrapColumn"&&(Jt=Xe);const St=fe.c({outerWidth:me,outerHeight:Ze,lineHeight:at,typicalHalfwidthCharacterWidth:Ct,pixelRatio:Qt,scrollBeyondLastLine:Lt,paddingTop:Gt.top,paddingBottom:Gt.bottom,minimap:Tt,verticalScrollbarWidth:Pt,viewLineCount:xt,remainingWidth:Kt,isViewportWrapping:Mt},$e.memory||new T);St.renderMinimap!==0&&St.minimapLeft===0&&(Ot+=St.minimapWidth,Nt+=St.minimapWidth,Vt+=St.minimapWidth,Xt+=St.minimapWidth);const yt=Kt-St.minimapWidth,wt=Math.max(1,Math.floor((yt-Pt-2)/Ct)),Yt=ai?Ut:0;return Mt&&(Jt=Math.max(1,wt),_t==="bounded"&&(Jt=Math.min(Jt,Xe))),{width:me,height:Ze,glyphMarginLeft:Ot,glyphMarginWidth:At,glyphMarginDecorationLaneCount:$e.glyphMarginDecorationLaneCount,lineNumbersLeft:Nt,lineNumbersWidth:gt,decorationsLeft:Vt,decorationsWidth:Ht,contentLeft:Xt,contentWidth:yt,minimap:St,viewportColumn:wt,isWordWrapMinified:zt,isViewportWrapping:Mt,wrappingColumn:Jt,verticalScrollbarWidth:Pt,horizontalScrollbarHeight:Je,overviewRuler:{top:Yt,width:Pt,height:Ze-2*Yt,right:0}}}}e.EditorLayoutInfoComputer=fe;class pe extends S{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(Z){return d(Z,"simple",["simple","advanced"])}compute(Z,$e,me){return $e.get(2)===2?"advanced":me}}var Ne;(function(X){X.Off="off",X.OnCode="onCode",X.On="on"})(Ne||(e.ShowLightbulbIconMode=Ne={}));class ae extends S{constructor(){const Z={enabled:Ne.On};super(65,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Ne.Off,Ne.OnCode,Ne.On],default:Z.enabled,enumDescriptions:[$.localize(50,null),$.localize(51,null),$.localize(52,null)],description:$.localize(53,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:d(Z.enabled,this.defaultValue.enabled,[Ne.Off,Ne.OnCode,Ne.On])}}}class Re extends S{constructor(){const Z={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:$.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:20,description:$.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:$.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:$.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:s($e.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt($e.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:d($e.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:s($e.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ne extends S{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:$.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(59,null),$.localize(60,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(61,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:$.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:$.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:$.localize(65,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return typeof $e.enabled=="boolean"&&($e.enabled=$e.enabled?"on":"off"),{enabled:d($e.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt($e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string($e.fontFamily,this.defaultValue.fontFamily),padding:s($e.padding,this.defaultValue.padding)}}}class z extends S{constructor(){super(66,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):i.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,$e,me){return me<0?i.clampedInt(-me*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):me}}class x extends u{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>u.clamp(Z,0,150),{markdownDescription:$.localize(66,null)})}compute(Z,$e,me){return Z.fontInfo.lineHeight}}class be extends S{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:$.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:$.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(69,null),$.localize(70,null),$.localize(71,null)],default:Z.size,description:$.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:$.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:$.localize(74,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:$.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:$.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:Z.showRegionSectionHeaders,description:$.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:Z.showMarkSectionHeaders,description:$.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:Z.sectionHeaderFontSize,description:$.localize(80,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:s($e.enabled,this.defaultValue.enabled),autohide:s($e.autohide,this.defaultValue.autohide),size:d($e.size,this.defaultValue.size,["proportional","fill","fit"]),side:d($e.side,this.defaultValue.side,["right","left"]),showSlider:d($e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:s($e.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt($e.scale,1,1,3),maxColumn:i.clampedInt($e.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:s($e.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:s($e.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:u.clamp($e.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Te(X){return X==="ctrlCmd"?M.$j?"metaKey":"ctrlKey":"altKey"}class De extends S{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(82,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{top:i.clampedInt($e.top,0,0,1e3),bottom:i.clampedInt($e.bottom,0,0,1e3)}}}class we extends S{constructor(){const Z={enabled:!0,cycle:!0};super(86,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:$.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:$.localize(84,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:s($e.enabled,this.defaultValue.enabled),cycle:s($e.cycle,this.defaultValue.cycle)}}}class ge extends g{constructor(){super(143)}compute(Z,$e,me){return Z.pixelRatio}}class Q extends S{constructor(){const Z={other:"on",comments:"off",strings:"off"},$e=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(85,null),$.localize(86,null),$.localize(87,null)]}];super(89,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:$e,default:Z.strings,description:$.localize(88,null)},comments:{anyOf:$e,default:Z.comments,description:$.localize(89,null)},other:{anyOf:$e,default:Z.other,description:$.localize(90,null)}},default:Z,markdownDescription:$.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const Qt=Z?"on":"off";return{comments:Qt,strings:Qt,other:Qt}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:$e,comments:me,strings:Ze}=Z,at=["on","inline","off"];let dt,Ct,Bt;return typeof $e=="boolean"?dt=$e?"on":"off":dt=d($e,this.defaultValue.other,at),typeof me=="boolean"?Ct=me?"on":"off":Ct=d(me,this.defaultValue.comments,at),typeof Ze=="boolean"?Bt=Ze?"on":"off":Bt=d(Ze,this.defaultValue.strings,at),{other:dt,comments:Ct,strings:Bt}}}var Y;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class le extends S{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(92,null),$.localize(93,null),$.localize(94,null),$.localize(95,null)],default:"on",description:$.localize(96,null)})}validate(Z){let $e=this.defaultValue.renderType,me=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?($e=4,me=Z):Z==="interval"?$e=3:Z==="relative"?$e=2:Z==="on"?$e=1:$e=0),{renderType:$e,renderFn:me}}}function ue(X){const Z=X.get(98);return Z==="editable"?X.get(91):Z!=="on"}class Oe extends S{constructor(){const Z=[],$e={type:"number",description:$.localize(97,null)};super(102,"rulers",Z,{type:"array",items:{anyOf:[$e,{type:["object"],properties:{column:$e,color:{type:"string",description:$.localize(98,null),format:"color-hex"}}}]},default:Z,description:$.localize(99,null)})}validate(Z){if(Array.isArray(Z)){const $e=[];for(const me of Z)if(typeof me=="number")$e.push({column:i.clampedInt(me,0,0,1e4),color:null});else if(me&&typeof me=="object"){const Ze=me;$e.push({column:i.clampedInt(Ze.column,0,0,1e4),color:Ze.color})}return $e.sort((me,Ze)=>me.column-Ze.column),$e}return this.defaultValue}}class de extends S{constructor(){super(92,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Ce(X,Z){if(typeof X!="string")return Z;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class Me extends S{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(100,null),$.localize(101,null),$.localize(102,null)],default:"auto",description:$.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(104,null),$.localize(105,null),$.localize(106,null)],default:"auto",description:$.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:$.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:$.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:$.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Z.ignoreHorizontalScrollbarInContentHeight,description:$.localize(111,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z,me=i.clampedInt($e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ze=i.clampedInt($e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt($e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce($e.vertical,this.defaultValue.vertical),horizontal:Ce($e.horizontal,this.defaultValue.horizontal),useShadows:s($e.useShadows,this.defaultValue.useShadows),verticalHasArrows:s($e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:s($e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:s($e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:s($e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:me,horizontalSliderSize:i.clampedInt($e.horizontalSliderSize,me,0,1e3),verticalScrollbarSize:Ze,verticalSliderSize:i.clampedInt($e.verticalSliderSize,Ze,0,1e3),scrollByPage:s($e.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:s($e.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class je extends S{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:$.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:$.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:$.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:$.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:$.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:$.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:$.localize(118,null)}})}applyUpdate(Z,$e){let me=!1;$e.allowedCharacters&&Z&&(O.$7n(Z.allowedCharacters,$e.allowedCharacters)||(Z={...Z,allowedCharacters:$e.allowedCharacters},me=!0)),$e.allowedLocales&&Z&&(O.$7n(Z.allowedLocales,$e.allowedLocales)||(Z={...Z,allowedLocales:$e.allowedLocales},me=!0));const Ze=super.applyUpdate(Z,$e);return me?new l(Ze.newValue,!0):Ze}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{nonBasicASCII:ee($e.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:s($e.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:s($e.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee($e.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee($e.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,$e){if(typeof Z!="object"||!Z)return $e;const me={};for(const[Ze,at]of Object.entries(Z))at===!0&&(me[Ze]=!0);return me}}class U extends S{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:$.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[$.localize(120,null),$.localize(121,null),$.localize(122,null)],description:$.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:$.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Z.fontFamily,description:$.localize(125,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:s($e.enabled,this.defaultValue.enabled),mode:d($e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:d($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:s($e.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:s($e.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string($e.fontFamily,this.defaultValue.fontFamily)}}}class F extends S{constructor(){const Z={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",Z,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Z.enabled,description:$.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[$.localize(127,null),$.localize(128,null),$.localize(129,null)],description:$.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Z.fontFamily,description:$.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Z.backgroundColoring,description:$.localize(132,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:s($e.enabled,this.defaultValue.enabled),showToolbar:d($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string($e.fontFamily,this.defaultValue.fontFamily),keepOnBlur:s($e.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:s($e.backgroundColoring,this.defaultValue.backgroundColoring)}}}class G extends S{constructor(){const Z={enabled:N.$4s.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:N.$4s.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:$.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:$.localize(134,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:s($e.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:s($e.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends S{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(135,null),$.localize(136,null),$.localize(137,null)],default:Z.bracketPairs,description:$.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(139,null),$.localize(140,null),$.localize(141,null)],default:Z.bracketPairsHorizontal,description:$.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:$.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:$.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(145,null),$.localize(146,null),$.localize(147,null)],default:Z.highlightActiveIndentation,description:$.localize(148,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{bracketPairs:ee($e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee($e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:s($e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:s($e.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee($e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(X,Z,$e){const me=$e.indexOf(X);return me===-1?Z:$e[me]}class re extends S{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(149,null),$.localize(150,null)],default:Z.insertMode,description:$.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:$.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:$.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:$.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(155,null),$.localize(156,null),$.localize(157,null),$.localize(158,null)],default:Z.selectionMode,markdownDescription:$.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:$.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:$.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:$.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:$.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:$.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(196,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{insertMode:d($e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:s($e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:s($e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:s($e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:s($e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:d($e.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:s($e.showIcons,this.defaultValue.showIcons),showStatusBar:s($e.showStatusBar,this.defaultValue.showStatusBar),preview:s($e.preview,this.defaultValue.preview),previewMode:d($e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:s($e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:s($e.showMethods,this.defaultValue.showMethods),showFunctions:s($e.showFunctions,this.defaultValue.showFunctions),showConstructors:s($e.showConstructors,this.defaultValue.showConstructors),showDeprecated:s($e.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:s($e.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:s($e.showFields,this.defaultValue.showFields),showVariables:s($e.showVariables,this.defaultValue.showVariables),showClasses:s($e.showClasses,this.defaultValue.showClasses),showStructs:s($e.showStructs,this.defaultValue.showStructs),showInterfaces:s($e.showInterfaces,this.defaultValue.showInterfaces),showModules:s($e.showModules,this.defaultValue.showModules),showProperties:s($e.showProperties,this.defaultValue.showProperties),showEvents:s($e.showEvents,this.defaultValue.showEvents),showOperators:s($e.showOperators,this.defaultValue.showOperators),showUnits:s($e.showUnits,this.defaultValue.showUnits),showValues:s($e.showValues,this.defaultValue.showValues),showConstants:s($e.showConstants,this.defaultValue.showConstants),showEnums:s($e.showEnums,this.defaultValue.showEnums),showEnumMembers:s($e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:s($e.showKeywords,this.defaultValue.showKeywords),showWords:s($e.showWords,this.defaultValue.showWords),showColors:s($e.showColors,this.defaultValue.showColors),showFiles:s($e.showFiles,this.defaultValue.showFiles),showReferences:s($e.showReferences,this.defaultValue.showReferences),showFolders:s($e.showFolders,this.defaultValue.showFolders),showTypeParameters:s($e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:s($e.showSnippets,this.defaultValue.showSnippets),showUsers:s($e.showUsers,this.defaultValue.showUsers),showIssues:s($e.showIssues,this.defaultValue.showIssues)}}}class Ae extends S{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(198,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:s(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:s(Z.selectSubwords,this.defaultValue.selectSubwords)}}}class Be extends S{constructor(){const Z=[];super(130,"wordSegmenterLocales",Z,{anyOf:[{description:$.localize(199,null),type:"string"},{description:$.localize(200,null),type:"array",items:{type:"string"}}]})}validate(Z){if(typeof Z=="string"&&(Z=[Z]),Array.isArray(Z)){const $e=[];for(const me of Z)if(typeof me=="string")try{Intl.Segmenter.supportedLocalesOf(me).length>0&&$e.push(me)}catch{}return $e}return this.defaultValue}}var qe;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(qe||(e.WrappingIndent=qe={}));class et extends S{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(201,null),$.localize(202,null),$.localize(203,null),$.localize(204,null)],description:$.localize(205,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,$e,me){return $e.get(2)===2?0:me}}class xe extends g{constructor(){super(146)}compute(Z,$e,me){const Ze=$e.get(145);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:Ze.isWordWrapMinified,isViewportWrapping:Ze.isViewportWrapping,wrappingColumn:Ze.wrappingColumn}}}class _e extends S{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:$.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(208,null),$.localize(209,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:s($e.enabled,this.defaultValue.enabled),showDropSelector:d($e.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class tt extends S{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:$.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(212,null),$.localize(213,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:s($e.enabled,this.defaultValue.enabled),showPasteSelector:d($e.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",ct="Menlo, Monaco, 'Courier New', monospace",ft="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:M.$j?ct:M.$k?ft:rt,fontWeight:"normal",fontSize:M.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(X){return e.editorOptionsRegistry[X.id]=X,X}var ot;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.inlineEdit=63]="inlineEdit",X[X.letterSpacing=64]="letterSpacing",X[X.lightbulb=65]="lightbulb",X[X.lineDecorationsWidth=66]="lineDecorationsWidth",X[X.lineHeight=67]="lineHeight",X[X.lineNumbers=68]="lineNumbers",X[X.lineNumbersMinChars=69]="lineNumbersMinChars",X[X.linkedEditing=70]="linkedEditing",X[X.links=71]="links",X[X.matchBrackets=72]="matchBrackets",X[X.minimap=73]="minimap",X[X.mouseStyle=74]="mouseStyle",X[X.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=76]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",X[X.multiCursorModifier=78]="multiCursorModifier",X[X.multiCursorPaste=79]="multiCursorPaste",X[X.multiCursorLimit=80]="multiCursorLimit",X[X.occurrencesHighlight=81]="occurrencesHighlight",X[X.overviewRulerBorder=82]="overviewRulerBorder",X[X.overviewRulerLanes=83]="overviewRulerLanes",X[X.padding=84]="padding",X[X.pasteAs=85]="pasteAs",X[X.parameterHints=86]="parameterHints",X[X.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",X[X.quickSuggestions=89]="quickSuggestions",X[X.quickSuggestionsDelay=90]="quickSuggestionsDelay",X[X.readOnly=91]="readOnly",X[X.readOnlyMessage=92]="readOnlyMessage",X[X.renameOnType=93]="renameOnType",X[X.renderControlCharacters=94]="renderControlCharacters",X[X.renderFinalNewline=95]="renderFinalNewline",X[X.renderLineHighlight=96]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=98]="renderValidationDecorations",X[X.renderWhitespace=99]="renderWhitespace",X[X.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",X[X.roundedSelection=101]="roundedSelection",X[X.rulers=102]="rulers",X[X.scrollbar=103]="scrollbar",X[X.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=105]="scrollBeyondLastLine",X[X.scrollPredominantAxis=106]="scrollPredominantAxis",X[X.selectionClipboard=107]="selectionClipboard",X[X.selectionHighlight=108]="selectionHighlight",X[X.selectOnLineNumbers=109]="selectOnLineNumbers",X[X.showFoldingControls=110]="showFoldingControls",X[X.showUnused=111]="showUnused",X[X.snippetSuggestions=112]="snippetSuggestions",X[X.smartSelect=113]="smartSelect",X[X.smoothScrolling=114]="smoothScrolling",X[X.stickyScroll=115]="stickyScroll",X[X.stickyTabStops=116]="stickyTabStops",X[X.stopRenderingLineAfter=117]="stopRenderingLineAfter",X[X.suggest=118]="suggest",X[X.suggestFontSize=119]="suggestFontSize",X[X.suggestLineHeight=120]="suggestLineHeight",X[X.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",X[X.suggestSelection=122]="suggestSelection",X[X.tabCompletion=123]="tabCompletion",X[X.tabIndex=124]="tabIndex",X[X.unicodeHighlighting=125]="unicodeHighlighting",X[X.unusualLineTerminators=126]="unusualLineTerminators",X[X.useShadowDOM=127]="useShadowDOM",X[X.useTabStops=128]="useTabStops",X[X.wordBreak=129]="wordBreak",X[X.wordSegmenterLocales=130]="wordSegmenterLocales",X[X.wordSeparators=131]="wordSeparators",X[X.wordWrap=132]="wordWrap",X[X.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=135]="wordWrapColumn",X[X.wordWrapOverride1=136]="wordWrapOverride1",X[X.wordWrapOverride2=137]="wordWrapOverride2",X[X.wrappingIndent=138]="wrappingIndent",X[X.wrappingStrategy=139]="wrappingStrategy",X[X.showDeprecated=140]="showDeprecated",X[X.inlayHints=141]="inlayHints",X[X.editorClassName=142]="editorClassName",X[X.pixelRatio=143]="pixelRatio",X[X.tabFocusMode=144]="tabFocusMode",X[X.layoutInfo=145]="layoutInfo",X[X.wrappingInfo=146]="wrappingInfo",X[X.defaultColorDecorators=147]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(ot||(e.EditorOption=ot={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(214,null)})),acceptSuggestionOnEnter:Ue(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(215,null),""],markdownDescription:$.localize(216,null)})),accessibilitySupport:Ue(new p),accessibilityPageSize:Ue(new i(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(217,null),tags:["accessibility"]})),ariaLabel:Ue(new t(4,"ariaLabel",$.localize(218,null))),ariaRequired:Ue(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(220,null),$.localize(221,null),""],description:$.localize(222,null)})),autoClosingComments:Ue(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(223,null),$.localize(224,null),""],description:$.localize(225,null)})),autoClosingDelete:Ue(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(226,null),""],description:$.localize(227,null)})),autoClosingOvertype:Ue(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(228,null),""],description:$.localize(229,null)})),autoClosingQuotes:Ue(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(230,null),$.localize(231,null),""],description:$.localize(232,null)})),autoIndent:Ue(new f(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[$.localize(233,null),$.localize(234,null),$.localize(235,null),$.localize(236,null),$.localize(237,null)],description:$.localize(238,null)})),automaticLayout:Ue(new o(13,"automaticLayout",!1)),autoSurround:Ue(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(239,null),$.localize(240,null),$.localize(241,null),""],description:$.localize(242,null)})),bracketPairColorization:Ue(new G),bracketPairGuides:Ue(new H),stickyTabStops:Ue(new o(116,"stickyTabStops",!1,{description:$.localize(243,null)})),codeLens:Ue(new o(17,"codeLens",!0,{description:$.localize(244,null)})),codeLensFontFamily:Ue(new t(18,"codeLensFontFamily","",{description:$.localize(245,null)})),codeLensFontSize:Ue(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(246,null)})),colorDecorators:Ue(new o(20,"colorDecorators",!0,{description:$.localize(247,null)})),colorDecoratorActivatedOn:Ue(new a(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(248,null),$.localize(249,null),$.localize(250,null)],description:$.localize(251,null)})),colorDecoratorsLimit:Ue(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(252,null)})),columnSelection:Ue(new o(22,"columnSelection",!1,{description:$.localize(253,null)})),comments:Ue(new v),contextmenu:Ue(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new o(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(254,null)})),cursorBlinking:Ue(new f(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:$.localize(255,null)})),cursorSmoothCaretAnimation:Ue(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(256,null),$.localize(257,null),$.localize(258,null)],description:$.localize(259,null)})),cursorStyle:Ue(new f(28,"cursorStyle",D.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:$.localize(260,null)})),cursorSurroundingLines:Ue(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(261,null)})),cursorSurroundingLinesStyle:Ue(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(262,null),$.localize(263,null)],markdownDescription:$.localize(264,null)})),cursorWidth:Ue(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(265,null)})),disableLayerHinting:Ue(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new o(34,"domReadOnly",!1)),dragAndDrop:Ue(new o(35,"dragAndDrop",!0,{description:$.localize(266,null)})),emptySelectionClipboard:Ue(new W),dropIntoEditor:Ue(new _e),stickyScroll:Ue(new Re),experimentalWhitespaceRendering:Ue(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(267,null),$.localize(268,null),$.localize(269,null)],description:$.localize(270,null)})),extraEditorClassName:Ue(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new u(40,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:$.localize(271,null)})),find:Ue(new V),fixedOverflowWidgets:Ue(new o(42,"fixedOverflowWidgets",!1)),folding:Ue(new o(43,"folding",!0,{description:$.localize(272,null)})),foldingStrategy:Ue(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(273,null),$.localize(274,null)],description:$.localize(275,null)})),foldingHighlight:Ue(new o(45,"foldingHighlight",!0,{description:$.localize(276,null)})),foldingImportsByDefault:Ue(new o(46,"foldingImportsByDefault",!1,{description:$.localize(277,null)})),foldingMaximumRegions:Ue(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(278,null)})),unfoldOnClickAfterEndOfLine:Ue(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(279,null)})),fontFamily:Ue(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(280,null)})),fontInfo:Ue(new B),fontLigatures2:Ue(new q),fontSize:Ue(new K),fontWeight:Ue(new ie),fontVariations:Ue(new R),formatOnPaste:Ue(new o(55,"formatOnPaste",!1,{description:$.localize(281,null)})),formatOnType:Ue(new o(56,"formatOnType",!1,{description:$.localize(282,null)})),glyphMargin:Ue(new o(57,"glyphMargin",!0,{description:$.localize(283,null)})),gotoLocation:Ue(new ce),hideCursorInOverviewRuler:Ue(new o(59,"hideCursorInOverviewRuler",!1,{description:$.localize(284,null)})),hover:Ue(new ve),inDiffEditor:Ue(new o(61,"inDiffEditor",!1)),letterSpacing:Ue(new u(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>u.clamp(X,-5,20),{description:$.localize(285,null)})),lightbulb:Ue(new ae),lineDecorationsWidth:Ue(new z),lineHeight:Ue(new x),lineNumbers:Ue(new le),lineNumbersMinChars:Ue(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new o(70,"linkedEditing",!1,{description:$.localize(286,null)})),links:Ue(new o(71,"links",!0,{description:$.localize(287,null)})),matchBrackets:Ue(new a(72,"matchBrackets","always",["always","near","never"],{description:$.localize(288,null)})),minimap:Ue(new be),mouseStyle:Ue(new a(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new u(75,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:$.localize(289,null)})),mouseWheelZoom:Ue(new o(76,"mouseWheelZoom",!1,{markdownDescription:M.$j?$.localize(290,null):$.localize(291,null)})),multiCursorMergeOverlapping:Ue(new o(77,"multiCursorMergeOverlapping",!0,{description:$.localize(292,null)})),multiCursorModifier:Ue(new f(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Te,{markdownEnumDescriptions:[$.localize(293,null),$.localize(294,null)],markdownDescription:$.localize(295,null)})),multiCursorPaste:Ue(new a(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(296,null),$.localize(297,null)],markdownDescription:$.localize(298,null)})),multiCursorLimit:Ue(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(299,null)})),occurrencesHighlight:Ue(new a(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[$.localize(300,null),$.localize(301,null),$.localize(302,null)],markdownDescription:$.localize(303,null)})),overviewRulerBorder:Ue(new o(82,"overviewRulerBorder",!0,{description:$.localize(304,null)})),overviewRulerLanes:Ue(new i(83,"overviewRulerLanes",3,0,3)),padding:Ue(new De),pasteAs:Ue(new tt),parameterHints:Ue(new we),peekWidgetDefaultFocus:Ue(new a(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(305,null),$.localize(306,null)],description:$.localize(307,null)})),definitionLinkOpensInPeek:Ue(new o(88,"definitionLinkOpensInPeek",!1,{description:$.localize(308,null)})),quickSuggestions:Ue(new Q),quickSuggestionsDelay:Ue(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(309,null)})),readOnly:Ue(new o(91,"readOnly",!1)),readOnlyMessage:Ue(new de),renameOnType:Ue(new o(93,"renameOnType",!1,{description:$.localize(310,null),markdownDeprecationMessage:$.localize(311,null)})),renderControlCharacters:Ue(new o(94,"renderControlCharacters",!0,{description:$.localize(312,null),restricted:!0})),renderFinalNewline:Ue(new a(95,"renderFinalNewline",M.$k?"dimmed":"on",["off","on","dimmed"],{description:$.localize(313,null)})),renderLineHighlight:Ue(new a(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(314,null)],description:$.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Ue(new o(97,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(316,null)})),renderValidationDecorations:Ue(new a(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new a(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(317,null),$.localize(318,null),$.localize(319,null),""],description:$.localize(320,null)})),revealHorizontalRightPadding:Ue(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new o(101,"roundedSelection",!0,{description:$.localize(321,null)})),rulers:Ue(new Oe),scrollbar:Ue(new Me),scrollBeyondLastColumn:Ue(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(322,null)})),scrollBeyondLastLine:Ue(new o(105,"scrollBeyondLastLine",!0,{description:$.localize(323,null)})),scrollPredominantAxis:Ue(new o(106,"scrollPredominantAxis",!0,{description:$.localize(324,null)})),selectionClipboard:Ue(new o(107,"selectionClipboard",!0,{description:$.localize(325,null),included:M.$k})),selectionHighlight:Ue(new o(108,"selectionHighlight",!0,{description:$.localize(326,null)})),selectOnLineNumbers:Ue(new o(109,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new a(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(327,null),$.localize(328,null),$.localize(329,null)],description:$.localize(330,null)})),showUnused:Ue(new o(111,"showUnused",!0,{description:$.localize(331,null)})),showDeprecated:Ue(new o(140,"showDeprecated",!0,{description:$.localize(332,null)})),inlayHints:Ue(new ne),snippetSuggestions:Ue(new a(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(333,null),$.localize(334,null),$.localize(335,null),$.localize(336,null)],description:$.localize(337,null)})),smartSelect:Ue(new Ae),smoothScrolling:Ue(new o(114,"smoothScrolling",!1,{description:$.localize(338,null)})),stopRenderingLineAfter:Ue(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new re),inlineSuggest:Ue(new U),inlineEdit:Ue(new F),inlineCompletionsAccessibilityVerbose:Ue(new o(149,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(339,null)})),suggestFontSize:Ue(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new o(121,"suggestOnTriggerCharacters",!0,{description:$.localize(342,null)})),suggestSelection:Ue(new a(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(343,null),$.localize(344,null),$.localize(345,null)],description:$.localize(346,null)})),tabCompletion:Ue(new a(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(347,null),$.localize(348,null),$.localize(349,null)],description:$.localize(350,null)})),tabIndex:Ue(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new je),unusualLineTerminators:Ue(new a(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(351,null),$.localize(352,null),$.localize(353,null)],description:$.localize(354,null)})),useShadowDOM:Ue(new o(127,"useShadowDOM",!0)),useTabStops:Ue(new o(128,"useTabStops",!0,{description:$.localize(355,null)})),wordBreak:Ue(new a(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(356,null),$.localize(357,null)],description:$.localize(358,null)})),wordSegmenterLocales:Ue(new Be),wordSeparators:Ue(new t(131,"wordSeparators",A.$5s,{description:$.localize(359,null)})),wordWrap:Ue(new a(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(360,null),$.localize(361,null),$.localize(362,null),$.localize(363,null)],description:$.localize(364,null)})),wordWrapBreakAfterCharacters:Ue(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(365,null)})),wordWrapOverride1:Ue(new a(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new a(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new I),defaultColorDecorators:Ue(new o(147,"defaultColorDecorators",!1,{markdownDescription:$.localize(366,null)})),pixelRatio:Ue(new ge),tabFocusMode:Ue(new o(144,"tabFocusMode",!1,{markdownDescription:$.localize(367,null)})),layoutInfo:Ue(new fe),wrappingInfo:Ue(new xe),wrappingIndent:Ue(new et),wrappingStrategy:Ue(new pe)}}),define(Se[160],Ie([9,10]),function(he,e){return he.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[161],Ie([9,10]),function(he,e){return he.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[162],Ie([9,10]),function(he,e){return he.create("vs/platform/contextkey/common/scanner",e)}),define(Se[163],Ie([9,10]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[164],Ie([9,10]),function(he,e){return he.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[165],Ie([9,10]),function(he,e){return he.create("vs/platform/files/common/files",e)}),define(Se[166],Ie([9,10]),function(he,e){return he.create("vs/platform/log/common/log",e)}),define(Se[167],Ie([9,10]),function(he,e){return he.create("vs/platform/markers/common/markers",e)}),define(Se[168],Ie([9,10]),function(he,e){return he.create("vs/platform/request/common/request",e)}),define(Se[169],Ie([9,10]),function(he,e){return he.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[170],Ie([9,10]),function(he,e){return he.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[171],Ie([9,10]),function(he,e){return he.create("vs/platform/workspace/common/workspace",e)}),define(Se[172],Ie([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[173],Ie([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[174],Ie([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[175],Ie([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Se[176],Ie([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[177],Ie([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[178],Ie([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[179],Ie([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[180],Ie([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[181],Ie([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[182],Ie([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[183],Ie([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[184],Ie([9,10]),function(he,e){return he.create("vs/workbench/common/configuration",e)}),define(Se[185],Ie([9,10]),function(he,e){return he.create("vs/workbench/common/editor",e)}),define(Se[186],Ie([9,10]),function(he,e){return he.create("vs/workbench/common/views",e)}),define(Se[187],Ie([9,10]),function(he,e){return he.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Se[188],Ie([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[189],Ie([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[190],Ie([9,10]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[191],Ie([9,10]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[192],Ie([9,10]),function(he,e){return he.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[193],Ie([9,10]),function(he,e){return he.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Se[194],Ie([9,10]),function(he,e){return he.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[195],Ie([9,10]),function(he,e){return he.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[196],Ie([1,0,14,162]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.TokenType=void 0;var M;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(M||(e.TokenType=M={}));function N(...E){switch(E.length){case 1:return(0,O.localize)(0,null,E[0]);case 2:return(0,O.localize)(1,null,E[0],E[1]);case 3:return(0,O.localize)(2,null,E[0],E[1],E[2]);default:return}}const A=(0,O.localize)(3,null),$=(0,O.localize)(4,null);class m{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(T){switch(T.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return T.isTripleEq?"===":"==";case 4:return T.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return T.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return T.lexeme;case 18:return T.lexeme;case 19:return T.lexeme;case 20:return"EOF";default:throw(0,P.$8)(`unhandled token type: ${JSON.stringify(T)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(T=>T.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(T){return this.c=T,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(T){return this.r()||this.c.charCodeAt(this.e)!==T?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(T){this.f.push({type:T,offset:this.d})}l(T){const S=this.d,l=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:l};this.g.push({offset:S,lexeme:l,additionalInfo:T}),this.f.push(b)}n(){this.m.lastIndex=this.d;const T=this.m.exec(this.c);if(T){this.e=this.d+T[0].length;const S=this.c.substring(this.d,this.e),l=m.b.get(S);l?this.k(l):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let T=this.e,S=!1,l=!1;for(;;){if(T>=this.c.length){this.e=T,this.l($);return}const g=this.c.charCodeAt(T);if(S)S=!1;else if(g===47&&!l){T++;break}else g===91?l=!0:g===92?S=!0:g===93&&(l=!1);T++}for(;T<this.c.length&&m.a.has(this.c.charCodeAt(T));)T++;this.e=T;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$rj=m}),define(Se[197],Ie([1,0,23,32,164,310]),function(he,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=m,e.$Hp=E,e.$Ip=T,e.$Jp=S,e.$Kp=l,e.$Lp=b,e.$Mp=g;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function m(o){return o=o.trim(),o==="*"||A.test(o)}function E(o){if(!m(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=o.match(A);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function T(o){if(!o)return null;const n=o.majorBase,i=o.majorMustEqual,c=o.minorBase;let u=o.minorMustEqual;const t=o.patchBase;let d=o.patchMustEqual;o.hasCaret&&(n===0||(u=!1),d=!1);let a=0;if(o.preRelease){const f=$.exec(o.preRelease);if(f){const[,w,p,v]=f;a=Date.UTC(Number(w),Number(p)-1,Number(v))}}return{majorBase:n,majorMustEqual:i,minorBase:c,minorMustEqual:u,patchBase:t,patchMustEqual:d,isMinimum:o.hasGreaterEquals,notBefore:a}}function S(o,n,i){let c;typeof o=="string"?c=T(E(o)):c=o;let u;n instanceof Date?u=n.getTime():typeof n=="string"&&(u=new Date(n).getTime());let t;if(typeof i=="string"?t=T(E(i)):t=i,!c||!t)return!1;const d=c.majorBase,a=c.minorBase,f=c.patchBase;let w=t.majorBase,p=t.minorBase,v=t.patchBase;const y=t.notBefore;let h=t.majorMustEqual,D=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?d>w?!0:d<w?!1:a>p?!0:a<p||u&&u<y?!1:f>=v:(d===1&&w===0&&(!h||!D||!k)&&(w=1,p=0,v=0,h=!0,D=!1,k=!1),d<w?!1:d>w?!h:a<p?!1:a>p?!D:f<v?!1:f>v?!k:!(u&&u<y))}function l(o,n,i,c,u){const t=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return t.push([O.default.Error,M.localize(0,null)]),t;if(typeof c.name!="string")return t.push([O.default.Error,M.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([O.default.Error,M.localize(2,null,"version")]),t;if(!c.engines)return t.push([O.default.Error,M.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([O.default.Error,M.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies<"u"&&!s(c.extensionDependencies))return t.push([O.default.Error,M.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents<"u"){if(!s(c.activationEvents))return t.push([O.default.Error,M.localize(6,null,"activationEvents")]),t;if(typeof c.main>"u"&&typeof c.browser>"u")return t.push([O.default.Error,M.localize(7,null,"activationEvents","main","browser")]),t}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&t.push([O.default.Warning,M.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return t.push([O.default.Error,M.localize(9,null,"main")]),t;{const f=(0,P.$0g)(i,c.main);(0,P.$4g)(f,i)||t.push([O.default.Warning,M.localize(10,null,f.path,i.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return t.push([O.default.Error,M.localize(11,null,"browser")]),t;{const f=(0,P.$0g)(i,c.browser);(0,P.$4g)(f,i)||t.push([O.default.Warning,M.localize(12,null,f.path,i.path)])}}if(!N.valid(c.version))return t.push([O.default.Error,M.localize(13,null)]),t;const d=[];if(!b(o,n,c,u,d))for(const f of d)t.push([O.default.Error,f]);return t}function b(o,n,i,c,u){return c||typeof i.main>"u"&&typeof i.browser>"u"?!0:r(o,n,i.engines.vscode,u)}function g(o,n,i){return o==="*"||r(n,i,o)}function r(o,n,i,c=[]){const u=T(E(i));if(!u)return c.push(M.localize(14,null,i)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return c.push(M.localize(15,null,i)),!1}else if(!u.majorMustEqual)return c.push(M.localize(16,null,i)),!1;return S(o,n,u)?!0:(c.push(M.localize(17,null,o,i)),!1)}function s(o){if(!Array.isArray(o))return!1;for(let n=0,i=o.length;n<i;n++)if(typeof o[n]!="string")return!1;return!0}}),define(Se[71],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=void 0;class P{constructor(M,N=[],A=!1){this.ctor=M,this.staticArguments=N,this.supportsDelayedInstantiation=A}}e.$ti=P}),define(Se[56],Ie([1,0,71]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$xs=N,e.$ys=A;const O=[];var M;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(M||(e.InstantiationType=M={}));function N($,m,E){m instanceof P.$ti||(m=new P.$ti(m,[],!!E)),O.push([$,m])}function A(){return O}}),define(Se[198],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=void 0;class P{constructor(N,A){this.key=N,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$ar=P;class O{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const A of this.a.values())A.outgoing.size===0&&N.push(A);return N}insertEdge(N,A){const $=this.lookupOrInsertNode(N),m=this.lookupOrInsertNode(A);$.outgoing.set(m.key,m),m.incoming.set($.key,$)}removeNode(N){const A=this.b(N);this.a.delete(A);for(const $ of this.a.values())$.outgoing.delete(A),$.incoming.delete(A)}lookupOrInsertNode(N){const A=this.b(N);let $=this.a.get(A);return $||($=new P(A,N),this.a.set(A,$)),$}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[A,$]of this.a)N.push(`${A}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,A]of this.a){const $=new Set([N]),m=this.c(A,$);if(m)return m}}c(N,A){for(const[$,m]of N.outgoing){if(A.has($))return[...A,$].join(" -> ");A.add($);const E=this.c(m,A);if(E)return E;A.delete($)}}}e.$br=O}),define(Se[3],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e._util=void 0,e.$wi=M,e.$xi=N;var P;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function $(m){return m[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=$})(P||(e._util=P={})),e.$vi=M("instantiationService");function O(A,$,m){$[P.DI_TARGET]===$?$[P.DI_DEPENDENCIES].push({id:A,index:m}):($[P.DI_DEPENDENCIES]=[{id:A,index:m}],$[P.DI_TARGET]=$)}function M(A){if(P.serviceIds.has(A))return P.serviceIds.get(A);const $=function(m,E,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O($,m,T)};return $.toString=()=>A,P.serviceIds.set(A,$),$}function N(A){return A}}),define(Se[50],Ie([1,0,15,2,3]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$3i=void 0,e.$4i=N,e.$5i=A,e.$6i=m,e.$7i=E,e.$8i=T,e.$9i=S,e.$0i=l,e.$$i=g,e.$_i=r,e.$aj=s,e.$3i=(0,M.$wi)("configurationService");function N(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof O.URI)}function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof O.URI)}var $;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function m(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function E(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}function T(o,n){const i=Object.create(null);for(const c in o)S(i,c,o[c],n);return i}function S(o,n,i,c){const u=n.split("."),t=u.pop();let d=o;for(let a=0;a<u.length;a++){const f=u[a];let w=d[f];switch(typeof w){case"undefined":w=d[f]=Object.create(null);break;case"object":if(w===null){c(`Ignoring ${n} as ${u.slice(0,a+1).join(".")} is null`);return}break;default:c(`Ignoring ${n} as ${u.slice(0,a+1).join(".")} is ${JSON.stringify(w)}`);return}d=w}if(typeof d=="object"&&d!==null)try{d[t]=i}catch{c(`Ignoring ${n} as ${u.join(".")} is ${JSON.stringify(d)}`)}else c(`Ignoring ${n} as ${u.join(".")} is ${JSON.stringify(d)}`)}function l(o,n){const i=n.split(".");b(o,i)}function b(o,n){const i=n.shift();if(n.length===0){delete o[i];return}if(Object.keys(o).indexOf(i)!==-1){const c=o[i];typeof c=="object"&&!Array.isArray(c)&&(b(c,n),Object.keys(c).length===0&&delete o[i])}}function g(o,n,i){function c(d,a){let f=d;for(const w of a){if(typeof f!="object"||f===null)return;f=f[w]}return f}const u=n.split("."),t=c(o,u);return typeof t>"u"?i:t}function r(o,n,i){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in o?P.$$f(o[c])&&P.$$f(n[c])?r(o[c],n[c],i):i&&(o[c]=n[c]):o[c]=n[c])})}function s(o){return o.replace(/[\[\]]/g,"")}}),define(Se[31],Ie([1,0,22,13,196,3,161,14]),function(he,e,P,O,M,N,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$uj=e.$tj=e.ContextKeyExprType=void 0,e.$sj=E,e.$vj=d,e.$wj=a,e.$Pj=Ne;const m=new Map;m.set("false",!1),m.set("true",!0),m.set("isMac",P.$j),m.set("isLinux",P.$k),m.set("isWindows",P.$i),m.set("isWeb",P.$o),m.set("isMacNative",P.$j&&!P.$o),m.set("isEdge",P.$H),m.set("isFirefox",P.$F),m.set("isChrome",P.$E),m.set("isSafari",P.$G);function E(ne,z){if(m.get(ne)!==void 0)throw(0,$.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");m.set(ne,z)}const T=Object.prototype.hasOwnProperty;var S;(function(ne){ne[ne.False=0]="False",ne[ne.True=1]="True",ne[ne.Defined=2]="Defined",ne[ne.Not=3]="Not",ne[ne.Equals=4]="Equals",ne[ne.NotEquals=5]="NotEquals",ne[ne.And=6]="And",ne[ne.Regex=7]="Regex",ne[ne.NotRegex=8]="NotRegex",ne[ne.Or=9]="Or",ne[ne.In=10]="In",ne[ne.NotIn=11]="NotIn",ne[ne.Greater=12]="Greater",ne[ne.GreaterEquals=13]="GreaterEquals",ne[ne.Smaller=14]="Smaller",ne[ne.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const l={regexParsingWithErrorRecovery:!0},b=(0,A.localize)(0,null),g=(0,A.localize)(1,null),r=(0,A.localize)(2,null),s=(0,A.localize)(3,null),o=(0,A.localize)(4,null),n=(0,A.localize)(5,null),i=(0,A.localize)(6,null),c=(0,A.localize)(7,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(z=l){this.k=z,this.d=new M.$rj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(z){if(z===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(z).scan(),this.g=0,this.h=[];try{const x=this.l();if(!this.E()){const be=this.D(),Te=be.type===17?n:void 0;throw this.h.push({message:o,offset:be.offset,lexeme:M.$rj.getLexeme(be),additionalInfo:Te}),u.c}return x}catch(x){if(x!==u.c)throw x;return}}l(){return this.m()}m(){const z=[this.o()];for(;this.y(16);){const x=this.o();z.push(x)}return z.length===1?z[0]:t.or(...z)}o(){const z=[this.s()];for(;this.y(15);){const x=this.s();z.push(x)}return z.length===1?z[0]:t.and(...z)}s(){if(this.y(2)){const z=this.D();switch(z.type){case 11:return this.z(),w.INSTANCE;case 12:return this.z(),p.INSTANCE;case 0:{this.z();const x=this.l();return this.A(1,s),x?.negate()}case 17:return this.z(),C.create(z.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",z)}}return this.t()}t(){const z=this.D();switch(z.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const x=this.l();return this.A(1,s),x}case 17:{const x=z.lexeme;if(this.z(),this.y(9)){const Te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Te.type!==10)throw this.B("REGEX",Te);const De=Te.lexeme,we=De.lastIndexOf("/"),ge=we===De.length-1?void 0:this.w(De.substring(we+1));let Q;try{Q=new RegExp(De.substring(1,we),ge)}catch{throw this.B("REGEX",Te)}return B.create(x,Q)}switch(Te.type){case 10:case 19:{const De=[Te.lexeme];this.z();let we=this.D(),ge=0;for(let Oe=0;Oe<Te.lexeme.length;Oe++)Te.lexeme.charCodeAt(Oe)===40?ge++:Te.lexeme.charCodeAt(Oe)===41&&ge--;for(;!this.E()&&we.type!==15&&we.type!==16;){switch(we.type){case 0:ge++;break;case 1:ge--;break;case 10:case 18:for(let Oe=0;Oe<we.lexeme.length;Oe++)we.lexeme.charCodeAt(Oe)===40?ge++:Te.lexeme.charCodeAt(Oe)===41&&ge--}if(ge<0)break;De.push(M.$rj.getLexeme(we)),this.z(),we=this.D()}const Q=De.join(""),Y=Q.lastIndexOf("/"),le=Y===Q.length-1?void 0:this.w(Q.substring(Y+1));let ue;try{ue=new RegExp(Q.substring(1,Y),le)}catch{throw this.B("REGEX",Te)}return t.regex(x,ue)}case 18:{const De=Te.lexeme;this.z();let we=null;if(!(0,O.$7e)(De)){const ge=De.indexOf("/"),Q=De.lastIndexOf("/");if(ge!==Q&&ge>=0){const Y=De.slice(ge+1,Q),le=De[Q+1]==="i"?"i":"";try{we=new RegExp(Y,le)}catch{throw this.B("REGEX",Te)}}}if(we===null)throw this.B("REGEX",Te);return B.create(x,we)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,r);const Te=this.u();return t.notIn(x,Te)}switch(this.D().type){case 3:{this.z();const Te=this.u();if(this.x().type===18)return t.equals(x,Te);switch(Te){case"true":return t.has(x);case"false":return t.not(x);default:return t.equals(x,Te)}}case 4:{this.z();const Te=this.u();if(this.x().type===18)return t.notEquals(x,Te);switch(Te){case"true":return t.not(x);case"false":return t.has(x);default:return t.notEquals(x,Te)}}case 5:return this.z(),q.create(x,this.u());case 6:return this.z(),R.create(x,this.u());case 7:return this.z(),W.create(x,this.u());case 8:return this.z(),V.create(x,this.u());case 13:return this.z(),t.in(x,this.u());default:return t.has(x)}}case 20:throw this.h.push({message:i,offset:z.offset,lexeme:"",additionalInfo:c}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const z=this.D();switch(z.type){case 17:case 18:return this.z(),z.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(z){return z.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(z){return this.C(z)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(z,x){if(this.C(z))return this.z();throw this.B(x,this.D())}B(z,x,be){const Te=(0,A.localize)(8,null,z,M.$rj.getLexeme(x)),De=x.offset,we=M.$rj.getLexeme(x);return this.h.push({message:Te,offset:De,lexeme:we,additionalInfo:be}),u.c}C(z){return this.D().type===z}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$tj=u;class t{static false(){return w.INSTANCE}static true(){return p.INSTANCE}static has(z){return v.create(z)}static equals(z,x){return y.create(z,x)}static notEquals(z,x){return k.create(z,x)}static regex(z,x){return B.create(z,x)}static in(z,x){return h.create(z,x)}static notIn(z,x){return D.create(z,x)}static not(z){return C.create(z)}static and(...z){return ce.create(z,null,!0)}static or(...z){return ve.create(z,null,!0)}static greater(z,x){return W.create(z,x)}static greaterEquals(z,x){return V.create(z,x)}static smaller(z,x){return q.create(z,x)}static smallerEquals(z,x){return R.create(z,x)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this.c.parse(z)}}e.$uj=t;function d(ne){const z=new u({regexParsingWithErrorRecovery:!1});return ne.map(x=>(z.parse(x),z.lexingErrors.length>0?z.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,A.localize)(9,null,be.additionalInfo):(0,A.localize)(10,null),offset:be.offset,length:be.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function a(ne,z){const x=ne?ne.substituteConstants():void 0,be=z?z.substituteConstants():void 0;return!x&&!be?!0:!x||!be?!1:x.equals(be)}function f(ne,z){return ne.cmp(z)}class w{static{this.INSTANCE=new w}constructor(){this.type=0}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return p.INSTANCE}}e.$xj=w;class p{static{this.INSTANCE=new p}constructor(){this.type=1}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return w.INSTANCE}}e.$yj=p;class v{static create(z,x=null){const be=m.get(z);return typeof be=="boolean"?be?p.INSTANCE:w.INSTANCE:new v(z,x)}constructor(z,x){this.key=z,this.c=x,this.type=2}cmp(z){return z.type!==this.type?this.type-z.type:fe(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=m.get(this.key);return typeof z=="boolean"?z?p.INSTANCE:w.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$zj=v;class y{static create(z,x,be=null){if(typeof x=="boolean")return x?v.create(z,be):C.create(z,be);const Te=m.get(z);return typeof Te=="boolean"?x===(Te?"true":"false")?p.INSTANCE:w.INSTANCE:new y(z,x,be)}constructor(z,x,be){this.c=z,this.d=x,this.f=be,this.type=4}cmp(z){return z.type!==this.type?this.type-z.type:pe(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=m.get(this.c);if(typeof z=="boolean"){const x=z?"true":"false";return this.d===x?p.INSTANCE:w.INSTANCE}return this}evaluate(z){return z.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(z){return z.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Aj=y;class h{static create(z,x){return new h(z,x)}constructor(z,x){this.d=z,this.f=x,this.type=10,this.c=null}cmp(z){return z.type!==this.type?this.type-z.type:pe(this.d,this.f,z.d,z.f)}equals(z){return z.type===this.type?this.d===z.d&&this.f===z.f:!1}substituteConstants(){return this}evaluate(z){const x=z.getValue(this.f),be=z.getValue(this.d);return Array.isArray(x)?x.includes(be):typeof be=="string"&&typeof x=="object"&&x!==null?T.call(x,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(z){return z.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.$Bj=h;class D{static create(z,x){return new D(z,x)}constructor(z,x){this.d=z,this.f=x,this.type=11,this.c=h.create(z,x)}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(z){return z.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Cj=D;class k{static create(z,x,be=null){if(typeof x=="boolean")return x?C.create(z,be):v.create(z,be);const Te=m.get(z);return typeof Te=="boolean"?x===(Te?"true":"false")?w.INSTANCE:p.INSTANCE:new k(z,x,be)}constructor(z,x,be){this.c=z,this.d=x,this.f=be,this.type=5}cmp(z){return z.type!==this.type?this.type-z.type:pe(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=m.get(this.c);if(typeof z=="boolean"){const x=z?"true":"false";return this.d===x?w.INSTANCE:p.INSTANCE}return this}evaluate(z){return z.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(z){return z.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Dj=k;class C{static create(z,x=null){const be=m.get(z);return typeof be=="boolean"?be?w.INSTANCE:p.INSTANCE:new C(z,x)}constructor(z,x){this.c=z,this.d=x,this.type=3}cmp(z){return z.type!==this.type?this.type-z.type:fe(this.c,z.c)}equals(z){return z.type===this.type?this.c===z.c:!1}substituteConstants(){const z=m.get(this.c);return typeof z=="boolean"?z?w.INSTANCE:p.INSTANCE:this}evaluate(z){return!z.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(z){return z.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.$Ej=C;function I(ne,z){if(typeof ne=="string"){const x=parseFloat(ne);isNaN(x)||(ne=x)}return typeof ne=="string"||typeof ne=="number"?z(ne):w.INSTANCE}class W{static create(z,x,be=null){return I(x,Te=>new W(z,Te,be))}constructor(z,x,be){this.c=z,this.d=x,this.f=be,this.type=12}cmp(z){return z.type!==this.type?this.type-z.type:pe(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Fj=W;class V{static create(z,x,be=null){return I(x,Te=>new V(z,Te,be))}constructor(z,x,be){this.c=z,this.d=x,this.f=be,this.type=13}cmp(z){return z.type!==this.type?this.type-z.type:pe(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Gj=V;class q{static create(z,x,be=null){return I(x,Te=>new q(z,Te,be))}constructor(z,x,be){this.c=z,this.d=x,this.f=be,this.type=14}cmp(z){return z.type!==this.type?this.type-z.type:pe(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Hj=q;class R{static create(z,x,be=null){return I(x,Te=>new R(z,Te,be))}constructor(z,x,be){this.c=z,this.d=x,this.f=be,this.type=15}cmp(z){return z.type!==this.type?this.type-z.type:pe(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Ij=R;class B{static create(z,x){return new B(z,x)}constructor(z,x){this.d=z,this.f=x,this.type=7,this.c=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.d<z.d)return-1;if(this.d>z.d)return 1;const x=this.f?this.f.source:"",be=z.f?z.f.source:"";return x<be?-1:x>be?1:0}equals(z){if(z.type===this.type){const x=this.f?this.f.source:"",be=z.f?z.f.source:"";return this.d===z.d&&x===be}return!1}substituteConstants(){return this}evaluate(z){const x=z.getValue(this.d);return this.f?this.f.test(x):!1}serialize(){const z=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${z}`}keys(){return[this.d]}map(z){return z.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Jj=B;class K{static create(z){return new K(z)}constructor(z){this.c=z,this.type=8}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(z){return new K(this.c.map(z))}negate(){return this.c}}e.$Kj=K;function ie(ne){let z=null;for(let x=0,be=ne.length;x<be;x++){const Te=ne[x].substituteConstants();if(ne[x]!==Te&&z===null){z=[];for(let De=0;De<x;De++)z[De]=ne[De]}z!==null&&(z[x]=Te)}return z===null?ne:z}class ce{static create(z,x,be){return ce.d(z,x,be)}constructor(z,x){this.expr=z,this.c=x,this.type=6}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let x=0,be=this.expr.length;x<be;x++){const Te=f(this.expr[x],z.expr[x]);if(Te!==0)return Te}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let x=0,be=this.expr.length;x<be;x++)if(!this.expr[x].equals(z.expr[x]))return!1;return!0}return!1}substituteConstants(){const z=ie(this.expr);return z===this.expr?this:ce.create(z,this.c,!1)}evaluate(z){for(let x=0,be=this.expr.length;x<be;x++)if(!this.expr[x].evaluate(z))return!1;return!0}static d(z,x,be){const Te=[];let De=!1;for(const we of z)if(we){if(we.type===1){De=!0;continue}if(we.type===0)return w.INSTANCE;if(we.type===6){Te.push(...we.expr);continue}Te.push(we)}if(Te.length===0&&De)return p.INSTANCE;if(Te.length!==0){if(Te.length===1)return Te[0];Te.sort(f);for(let we=1;we<Te.length;we++)Te[we-1].equals(Te[we])&&(Te.splice(we,1),we--);if(Te.length===1)return Te[0];for(;Te.length>1;){const we=Te[Te.length-1];if(we.type!==9)break;Te.pop();const ge=Te.pop(),Q=Te.length===0,Y=ve.create(we.expr.map(le=>ce.create([le,ge],null,be)),null,Q);Y&&(Te.push(Y),Te.sort(f))}if(Te.length===1)return Te[0];if(be){for(let we=0;we<Te.length;we++)for(let ge=we+1;ge<Te.length;ge++)if(Te[we].negate().equals(Te[ge]))return w.INSTANCE;if(Te.length===1)return Te[0]}return new ce(Te,x)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const x of this.expr)z.push(...x.keys());return z}map(z){return new ce(this.expr.map(x=>x.map(z)),null)}negate(){if(!this.c){const z=[];for(const x of this.expr)z.push(x.negate());this.c=ve.create(z,this,!0)}return this.c}}e.$Lj=ce;class ve{static create(z,x,be){return ve.d(z,x,be)}constructor(z,x){this.expr=z,this.c=x,this.type=9}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let x=0,be=this.expr.length;x<be;x++){const Te=f(this.expr[x],z.expr[x]);if(Te!==0)return Te}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let x=0,be=this.expr.length;x<be;x++)if(!this.expr[x].equals(z.expr[x]))return!1;return!0}return!1}substituteConstants(){const z=ie(this.expr);return z===this.expr?this:ve.create(z,this.c,!1)}evaluate(z){for(let x=0,be=this.expr.length;x<be;x++)if(this.expr[x].evaluate(z))return!0;return!1}static d(z,x,be){let Te=[],De=!1;if(z){for(let we=0,ge=z.length;we<ge;we++){const Q=z[we];if(Q){if(Q.type===0){De=!0;continue}if(Q.type===1)return p.INSTANCE;if(Q.type===9){Te=Te.concat(Q.expr);continue}Te.push(Q)}}if(Te.length===0&&De)return w.INSTANCE;Te.sort(f)}if(Te.length!==0){if(Te.length===1)return Te[0];for(let we=1;we<Te.length;we++)Te[we-1].equals(Te[we])&&(Te.splice(we,1),we--);if(Te.length===1)return Te[0];if(be){for(let we=0;we<Te.length;we++)for(let ge=we+1;ge<Te.length;ge++)if(Te[we].negate().equals(Te[ge]))return p.INSTANCE;if(Te.length===1)return Te[0]}return new ve(Te,x)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const x of this.expr)z.push(...x.keys());return z}map(z){return new ve(this.expr.map(x=>x.map(z)),null)}negate(){if(!this.c){const z=[];for(const x of this.expr)z.push(x.negate());for(;z.length>1;){const x=z.shift(),be=z.shift(),Te=[];for(const De of Re(x))for(const we of Re(be))Te.push(ce.create([De,we],null,!1));z.unshift(ve.create(Te,null,!1))}this.c=ve.create(z,this,!0)}return this.c}}e.$Mj=ve;class ke extends v{static{this.d=[]}static all(){return ke.d.values()}constructor(z,x,be){super(z,null),this.f=x,typeof be=="object"?ke.d.push({...be,key:z}):be!==!0&&ke.d.push({key:z,description:be,type:x!=null?typeof x:void 0})}bindTo(z){return z.createKey(this.key,this.f)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return y.create(this.key,z)}notEqualsTo(z){return k.create(this.key,z)}}e.$Nj=ke,e.$Oj=(0,N.$wi)("contextKeyService");function fe(ne,z){return ne<z?-1:ne>z?1:0}function pe(ne,z,x,be){return ne<x?-1:ne>x?1:z<be?-1:z>be?1:0}function Ne(ne,z){if(ne.type===0||z.type===1)return!0;if(ne.type===9)return z.type===9?ae(ne.expr,z.expr):!1;if(z.type===9){for(const x of z.expr)if(Ne(ne,x))return!0;return!1}if(ne.type===6){if(z.type===6)return ae(z.expr,ne.expr);for(const x of ne.expr)if(Ne(x,z))return!0;return!1}return ne.equals(z)}function ae(ne,z){let x=0,be=0;for(;x<ne.length&&be<z.length;){const Te=ne[x].cmp(z[be]);if(Te<0)return!1;Te===0&&x++,be++}return x===ne.length}function Re(ne){return ne.type===9?ne.expr:[ne]}}),define(Se[99],Ie([1,0,3]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=void 0,e.$Di=(0,P.$wi)("environmentService"),e.$Ei=(0,P.$xi)(e.$Di)}),define(Se[100],Ie([1,0,163,3]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.ExtensionGalleryErrorCode=e.$7o=e.ExtensionManagementErrorCode=e.$6o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=void 0,e.$Zo=M,e.$1o=N,e.$2o=A,e.$3o=$,e.$4o=m,e.$5o=E,e.$To="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Uo=new RegExp(e.$To),e.$Vo="__web_extension",e.$Wo="skipWalkthrough",e.$Xo="extensionsSync",e.$Yo="dependecyOrPackExtensionInstall";function M(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function N(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function A(n,i){switch(n){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function $(n,i){return i==="web"&&!n.includes("web")}function m(n,i,c){return $(i,c)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===c}function E(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}var T;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(T||(e.SortBy=T={}));var S;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var l;(function(n){n.Install="install",n.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var b;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$6o=(0,O.$wi)("extensionGalleryService");var g;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Cancelled="Cancelled",n.Unknown="Unknown",n.Internal="Internal"})(g||(e.ExtensionManagementErrorCode=g={}));class r extends Error{constructor(i,c){super(i),this.code=c,this.name=c}}e.$7o=r;var s;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(s||(e.ExtensionGalleryErrorCode=s={}));class o extends Error{constructor(i,c){super(i),this.code=c,this.name=c}}e.$8o=o,e.$9o=(0,O.$wi)("extensionManagementService"),e.$0o="extensionsIdentifiers/disabled",e.$$o="extensionsIdentifiers/enabled",e.$_o=(0,O.$wi)("IGlobalExtensionEnablementService"),e.$ap=(0,O.$wi)("IExtensionTipsService"),e.$bp=(0,P.localize2)(0,"Extensions"),e.$cp=(0,P.localize2)(1,"Preferences")}),define(Se[38],Ie([1,0,54,19,13,15,2,165,3,22,16,43]),function(he,e,P,O,M,N,A,$,m,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$vl=e.FileKind=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.FileOperationResult=e.$nl=e.$ml=e.$ll=e.$jl=e.FileChangeType=e.$il=e.FileOperation=e.$cl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$3k=void 0,e.$4k=l,e.$5k=s,e.$6k=n,e.$7k=i,e.$8k=c,e.$9k=u,e.$0k=t,e.$$k=d,e.$_k=a,e.$al=f,e.$bl=w,e.$dl=y,e.$el=h,e.$fl=D,e.$gl=k,e.$hl=C,e.$kl=R,e.$wl=ke,e.$xl=fe,e.$zl=Ne,e.$3k=(0,m.$wi)("fileService");function l(ae){return ae.create===!0}var b;(function(ae){ae[ae.Unknown=0]="Unknown",ae[ae.File=1]="File",ae[ae.Directory=2]="Directory",ae[ae.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var g;(function(ae){ae[ae.Readonly=1]="Readonly",ae[ae.Locked=2]="Locked"})(g||(e.FilePermission=g={}));var r;(function(ae){ae[ae.UPDATED=2]="UPDATED",ae[ae.ADDED=4]="ADDED",ae[ae.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function s(ae){const Re=ae;return!!Re&&typeof Re.onDidChange=="function"}var o;(function(ae){ae[ae.None=0]="None",ae[ae.FileReadWrite=2]="FileReadWrite",ae[ae.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ae[ae.FileReadStream=16]="FileReadStream",ae[ae.FileFolderCopy=8]="FileFolderCopy",ae[ae.PathCaseSensitive=1024]="PathCaseSensitive",ae[ae.Readonly=2048]="Readonly",ae[ae.Trash=4096]="Trash",ae[ae.FileWriteUnlock=8192]="FileWriteUnlock",ae[ae.FileAtomicRead=16384]="FileAtomicRead",ae[ae.FileAtomicWrite=32768]="FileAtomicWrite",ae[ae.FileAtomicDelete=65536]="FileAtomicDelete",ae[ae.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function n(ae){return!!(ae.capabilities&2)}function i(ae){return!!(ae.capabilities&8)}function c(ae){return!!(ae.capabilities&131072)}function u(ae){return!!(ae.capabilities&4)}function t(ae){return!!(ae.capabilities&16)}function d(ae){return n(ae)?!!(ae.capabilities&16384):!1}function a(ae){return n(ae)?!!(ae.capabilities&32768):!1}function f(ae){return!!(ae.capabilities&65536)}function w(ae){return!!(ae.capabilities&2048)}var p;(function(ae){ae.FileExists="EntryExists",ae.FileNotFound="EntryNotFound",ae.FileNotADirectory="EntryNotADirectory",ae.FileIsADirectory="EntryIsADirectory",ae.FileExceedsStorageQuota="EntryExceedsStorageQuota",ae.FileTooLarge="EntryTooLarge",ae.FileWriteLocked="EntryWriteLocked",ae.NoPermissions="NoPermissions",ae.Unavailable="Unavailable",ae.Unknown="Unknown"})(p||(e.FileSystemProviderErrorCode=p={}));class v extends Error{static create(Re,ne){const z=new v(Re.toString(),ne);return D(z,ne),z}constructor(Re,ne){super(Re),this.code=ne}}e.$cl=v;function y(ae,Re){return v.create(ae,Re)}function h(ae){return ae||y((0,$.localize)(0,null),p.Unknown)}function D(ae,Re){return ae.name=Re?`${Re} (FileSystemError)`:"FileSystemError",ae}function k(ae){if(!ae)return p.Unknown;if(ae instanceof v)return ae.code;const Re=/^(.+) \(FileSystemError\)$/.exec(ae.name);if(!Re)return p.Unknown;switch(Re[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}function C(ae){if(ae instanceof B)return ae.fileOperationResult;switch(k(ae)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 9;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileTooLarge:return 7;default:return 10}}var I;(function(ae){ae[ae.CREATE=0]="CREATE",ae[ae.DELETE=1]="DELETE",ae[ae.MOVE=2]="MOVE",ae[ae.COPY=3]="COPY",ae[ae.WRITE=4]="WRITE"})(I||(e.FileOperation=I={}));class W{constructor(Re,ne,z){this.resource=Re,this.operation=ne,this.target=z}isOperation(Re){return this.operation===Re}}e.$il=W;var V;(function(ae){ae[ae.UPDATED=0]="UPDATED",ae[ae.ADDED=1]="ADDED",ae[ae.DELETED=2]="DELETED"})(V||(e.FileChangeType=V={}));class q{static{this.a=null}constructor(Re,ne){this.c=ne,this.b=void 0,this.d=new S.$V(()=>{const z=P.$Ci.forUris(()=>this.c);return z.fill(this.rawAdded.map(x=>[x,!0])),z}),this.f=new S.$V(()=>{const z=P.$Ci.forUris(()=>this.c);return z.fill(this.rawUpdated.map(x=>[x,!0])),z}),this.g=new S.$V(()=>{const z=P.$Ci.forUris(()=>this.c);return z.fill(this.rawDeleted.map(x=>[x,!0])),z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const z of Re){switch(z.type){case 1:this.rawAdded.push(z.resource);break;case 0:this.rawUpdated.push(z.resource);break;case 2:this.rawDeleted.push(z.resource);break}this.b!==q.a&&(typeof z.cId=="number"?this.b===void 0?this.b=z.cId:this.b!==z.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(Re,...ne){return this.h(Re,{includeChildren:!1},...ne)}affects(Re,...ne){return this.h(Re,{includeChildren:!0},...ne)}h(Re,ne,...z){if(!Re)return!1;const x=z.length>0;return!!((!x||z.includes(1))&&(this.d.value.get(Re)||ne.includeChildren&&this.d.value.findSuperstr(Re))||(!x||z.includes(0))&&(this.f.value.get(Re)||ne.includeChildren&&this.f.value.findSuperstr(Re))||(!x||z.includes(2))&&(this.g.value.findSubstr(Re)||ne.includeChildren&&this.g.value.findSuperstr(Re)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Re){return this.b===Re}hasCorrelation(){return typeof this.b=="number"}}e.$jl=q;function R(ae,Re,ne){return!ae||!Re||ae===Re||Re.length>ae.length?!1:(Re.charAt(Re.length-1)!==O.sep&&(Re+=O.sep),ne?(0,M.$yf)(ae,Re):ae.indexOf(Re)===0)}class B extends Error{constructor(Re,ne,z){super(Re),this.fileOperationResult=ne,this.options=z}}e.$ll=B;class K extends B{constructor(Re,ne,z,x){super(Re,ne,x),this.fileOperationResult=ne,this.size=z}}e.$ml=K;class ie extends B{constructor(Re,ne,z){super(Re,2,z),this.stat=ne}}e.$nl=ie;var ce;(function(ae){ae[ae.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ae[ae.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ae[ae.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ae[ae.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ae[ae.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ae[ae.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ae[ae.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ae[ae.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ae[ae.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ae[ae.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ae[ae.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ce||(e.FileOperationResult=ce={})),e.$ol={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$pl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ql="files.associations",e.$rl="files.exclude",e.$sl="files.readonlyInclude",e.$tl="files.readonlyExclude",e.$ul="files.readonlyFromPermissions";var ve;(function(ae){ae[ae.FILE=0]="FILE",ae[ae.FOLDER=1]="FOLDER",ae[ae.ROOT_FOLDER=2]="ROOT_FOLDER"})(ve||(e.FileKind=ve={})),e.$vl="";function ke(ae){if(!(typeof ae.size!="number"||typeof ae.mtime!="number"))return ae.mtime.toString(29)+ae.size.toString(31)}async function fe(ae,Re){if(!Re.hasProvider(A.URI.from({scheme:ae.scheme})))return new Promise(ne=>{const z=Re.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===ae.scheme&&x.added&&(z.dispose(),ne())})})}class pe{static{this.KB=1024}static{this.MB=pe.KB*pe.KB}static{this.GB=pe.MB*pe.KB}static{this.TB=pe.GB*pe.KB}static formatSize(Re){return(0,N.$ag)(Re)||(Re=0),Re<pe.KB?(0,$.localize)(1,null,Re.toFixed(0)):Re<pe.MB?(0,$.localize)(2,null,(Re/pe.KB).toFixed(2)):Re<pe.GB?(0,$.localize)(3,null,(Re/pe.MB).toFixed(2)):Re<pe.TB?(0,$.localize)(4,null,(Re/pe.GB).toFixed(2)):(0,$.localize)(5,null,(Re/pe.TB).toFixed(2))}}e.$yl=pe;function Ne(ae){const Re=typeof ae=="string"||ae?.scheme===T.Schemas.vscodeRemote;return typeof ae!="string"&&ae?.scheme===T.Schemas.file?1024*pe.MB:Re?10*pe.MB:E.$o?50*pe.MB:1024*pe.MB}}),define(Se[72],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=void 0;class P{constructor(...M){this.a=new Map;for(const[N,A]of M)this.set(N,A)}set(M,N){const A=this.a.get(M);return this.a.set(M,N),A}has(M){return this.a.has(M)}get(M){return this.a.get(M)}}e.$ui=P}),define(Se[199],Ie([1,0,11,14,6,71,198,3,72,200]),function(he,e,P,O,M,N,A,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=void 0;const T=!1;class S extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class l{constructor(s=new m.$ui,o=!1,n,i=T){this.i=s,this.j=o,this.k=n,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set($.$vi,this),this._globalGraph=i?n?._globalGraph??new A.$br(c=>c):void 0}dispose(){if(!this.f){this.f=!0,(0,M.$Pc)(this.h),this.h.clear();for(const s of this.g)(0,M.$Oc)(s)&&s.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(s){this.m();const o=new class extends l{dispose(){this.h.delete(o),super.dispose()}}(s,this.j,this,this.l);return this.h.add(o),o}invokeFunction(s,...o){this.m();const n=g.traceInvocation(this.l,s);let i=!1;try{return s({get:u=>{if(i)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(u,n);if(!t)throw new Error(`[invokeFunction] unknown service '${u}'`);return t}},...o)}finally{i=!0,n.stop()}}createInstance(s,...o){this.m();let n,i;return s instanceof N.$ti?(n=g.traceCreation(this.l,s.ctor),i=this.o(s.ctor,s.staticArguments.concat(o),n)):(n=g.traceCreation(this.l,s),i=this.o(s,o,n)),n.stop(),i}o(s,o=[],n){const i=$._util.getServiceDependencies(s).sort((t,d)=>t.index-d.index),c=[];for(const t of i){const d=this.s(t.id,n);d||this.y(`[createInstance] ${s.name} depends on UNKNOWN service ${t.id}.`,!1),c.push(d)}const u=i.length>0?i[0].index:o.length;if(o.length!==u){console.trace(`[createInstance] First service dependency of ${s.name} at position ${u+1} conflicts with ${o.length} static arguments`);const t=u-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,u)}return Reflect.construct(s,o.concat(c))}q(s,o){if(this.i.get(s)instanceof N.$ti)this.i.set(s,o);else if(this.k)this.k.q(s,o);else throw new Error("illegalState - setting UNKNOWN service instance")}r(s){const o=this.i.get(s);return!o&&this.k?this.k.r(s):o}s(s,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const n=this.r(s);return n instanceof N.$ti?this.u(s,n,o.branch(s,!0)):(o.branch(s,!1),n)}u(s,o,n){if(this.t.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.t.add(s);try{return this.v(s,o,n)}finally{this.t.delete(s)}}v(s,o,n){const i=new A.$br(t=>t.id.toString());let c=0;const u=[{id:s,desc:o,_trace:n}];for(;u.length;){const t=u.pop();if(i.lookupOrInsertNode(t),c++>1e3)throw new S(i);for(const d of $._util.getServiceDependencies(t.desc.ctor)){const a=this.r(d.id);if(a||this.y(`[createInstance] ${s} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(d.id)),a instanceof N.$ti){const f={id:d.id,desc:a,_trace:t._trace.branch(d.id,!0)};i.insertEdge(t,f),u.push(f)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new S(i);break}for(const{data:d}of t){if(this.r(d.id)instanceof N.$ti){const f=this.w(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this.q(d.id,f)}i.removeNode(d)}}return this.r(s)}w(s,o,n=[],i,c){if(this.i.get(s)instanceof N.$ti)return this.x(s,o,n,i,c,this.g);if(this.k)return this.k.w(s,o,n,i,c);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}x(s,o,n=[],i,c,u){if(i){const t=new l(void 0,this.j,this,this.l);t.c=String(s);const d=new Map,a=new P.$Ph(()=>{const f=t.o(o,n,c);for(const[w,p]of d){const v=f[w];if(typeof v=="function")for(const y of p)y.disposable=v.apply(f,y.listener)}return d.clear(),u.add(f),f});return new Proxy(Object.create(null),{get(f,w){if(!a.isInitialized&&typeof w=="string"&&(w.startsWith("onDid")||w.startsWith("onWill"))){let y=d.get(w);return y||(y=new E.$5c,d.set(w,y)),(D,k,C)=>{if(a.isInitialized)return a.value[w](D,k,C);{const I={listener:[D,k,C],disposable:void 0},W=y.push(I);return(0,M.$Sc)(()=>{W(),I.disposable?.dispose()})}}}if(w in f)return f[w];const p=a.value;let v=p[w];return typeof v!="function"||(v=v.bind(p),f[w]=v),v},set(f,w,p){return a.value[w]=p,!0},getPrototypeOf(f){return o.prototype}})}else{const t=this.o(o,n,c);return u.add(t),t}}y(s,o){if(o&&console.warn(s),this.j)throw new Error(s)}}e.$cr=l;var b;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(b||(b={}));class g{static{this.all=new Set}static{this.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(s,o){return s?new g(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(s,o){return s?new g(1,o.name):g.c}static{this.f=0}constructor(s,o){this.type=s,this.name=o,this.g=Date.now(),this.h=[]}branch(s,o){const n=new g(3,s.toString());return this.h.push([s,o,n]),n}stop(){const s=Date.now()-this.g;g.f+=s;let o=!1;function n(c,u){const t=[],d=new Array(c+1).join("	");for(const[a,f,w]of u.h)if(f&&w){o=!0,t.push(`${d}CREATES -> ${a}`);const p=n(c+1,w);p&&t.push(p)}else t.push(`${d}uses -> ${a}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(s>2||o)&&g.all.add(i.join(`
`))}}e.$dr=g}),define(Se[12],Ie([1,0,166,44,5,73,6,28,22,23,15,2,31,3]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$6j=e.LogLevel=e.$4j=e.$3j=void 0,e.$5j=r,e.log=o,e.$ek=v,e.$fk=y,e.$gk=h,e.$hk=D,e.$3j=(0,b.$wi)("logService"),e.$4j=(0,b.$wi)("loggerService");function g(){return new Date().toISOString()}function r(k){return(0,T.$ag)(k)}var s;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(s||(e.LogLevel=s={})),e.$6j=s.Info;function o(k,C,I){switch(C){case s.Trace:k.trace(I);break;case s.Debug:k.debug(I);break;case s.Info:k.info(I);break;case s.Warning:k.warn(I);break;case s.Error:k.error(I);break;case s.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function n(k,C=!1){let I="";for(let W=0;W<k.length;W++){let V=k[W];if(V instanceof Error&&(V=(0,O.$hj)(V,C)),typeof V=="object")try{V=JSON.stringify(V)}catch{}I+=(W>0?" ":"")+V}return I}class i extends A.$Uc{constructor(){super(...arguments),this.b=e.$6j,this.c=this.B(new M.$de),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==s.Off&&this.b<=C}}e.$8j=i;class c extends i{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...I){this.f(s.Trace)&&this.g(s.Trace,n([C,...I],!0))}debug(C,...I){this.f(s.Debug)&&this.g(s.Debug,n([C,...I]))}info(C,...I){this.f(s.Info)&&this.g(s.Info,n([C,...I]))}warn(C,...I){this.f(s.Warning)&&this.g(s.Warning,n([C,...I]))}error(C,...I){if(this.f(s.Error))if(C instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=C.stack,this.g(s.Error,n(W))}else this.g(s.Error,n([C,...I]))}flush(){}}e.$9j=c;class u extends i{constructor(C=e.$6j){super(),this.setLevel(C),this.g=!m.$i}trace(C,...I){this.f(s.Trace)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,C,...I):console.log(`[main ${g()}]`,C,...I))}debug(C,...I){this.f(s.Debug)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,C,...I):console.log(`[main ${g()}]`,C,...I))}info(C,...I){this.f(s.Info)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,C,...I):console.log(`[main ${g()}]`,C,...I))}warn(C,...I){this.f(s.Warning)&&(this.g?console.warn(`\x1B[93m[main ${g()}]\x1B[0m`,C,...I):console.warn(`[main ${g()}]`,C,...I))}error(C,...I){this.f(s.Error)&&(this.g?console.error(`\x1B[91m[main ${g()}]\x1B[0m`,C,...I):console.error(`[main ${g()}]`,C,...I))}flush(){}}e.$0j=u;class t extends i{constructor(C=e.$6j,I=!0){super(),this.g=I,this.setLevel(C)}trace(C,...I){this.f(s.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...I):console.log(C,...I))}debug(C,...I){this.f(s.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...I):console.log(C,...I))}info(C,...I){this.f(s.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...I):console.log(C,...I))}warn(C,...I){this.f(s.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...I):console.log(C,...I))}error(C,...I){this.f(s.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...I):console.error(C,...I))}flush(){}}e.$$j=t;class d extends i{constructor(C,I=e.$6j){super(),this.g=C,this.setLevel(I)}trace(C,...I){this.f(s.Trace)&&this.g.log(s.Trace,[this.h(C),...I])}debug(C,...I){this.f(s.Debug)&&this.g.log(s.Debug,[this.h(C),...I])}info(C,...I){this.f(s.Info)&&this.g.log(s.Info,[this.h(C),...I])}warn(C,...I){this.f(s.Warning)&&this.g.log(s.Warning,[this.h(C),...I])}error(C,...I){this.f(s.Error)&&this.g.log(s.Error,[this.h(C),...I])}h(C){return typeof C=="string"?C:(0,O.$hj)(C,this.f(s.Trace))}flush(){}}e.$_j=d;class a extends i{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const I of this.g)I.setLevel(C);super.setLevel(C)}trace(C,...I){for(const W of this.g)W.trace(C,...I)}debug(C,...I){for(const W of this.g)W.debug(C,...I)}info(C,...I){for(const W of this.g)W.info(C,...I)}warn(C,...I){for(const W of this.g)W.warn(C,...I)}error(C,...I){for(const W of this.g)W.error(C,...I)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$ak=a;class f extends A.$Uc{constructor(C,I,W){if(super(),this.h=C,this.j=I,this.b=new $.$Ac,this.c=this.B(new M.$de),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$de),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$de),this.onDidChangeVisibility=this.g.event,W)for(const V of W)this.b.set(V.resource,{logger:void 0,info:V})}m(C){return(0,T.$9f)(C)?[...this.b.values()].find(I=>I.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,I){const W=this.n(C),V=(0,T.$9f)(C)?C:I?.id??(0,N.$kj)(W.toString()).toString(16);let q=this.b.get(W)?.logger;const R=I?.logLevel==="always"?s.Trace:I?.logLevel;q||(q=this.s(W,R??this.getLogLevel(W)??this.h,{...I,id:V}));const B={logger:q,info:{resource:W,id:V,logLevel:R,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(B.info),this.b.set(W,B),q}n(C){return(0,T.$9f)(C)?(0,E.$0g)(this.j,`${C}.log`):C}setLogLevel(C,I){if(S.URI.isUri(C)){const W=C,V=I,q=this.b.get(W);q&&V!==q.info.logLevel&&(q.info.logLevel=V===this.h?void 0:V,q.logger?.setLevel(V),this.b.set(q.info.resource,q),this.f.fire([W,V]))}else{this.h=C;for(const[W,V]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&V.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,I){const W=this.m(C);W&&I!==!W.info.hidden&&(W.info.hidden=!I,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,I]))}getLogLevel(C){let I;return C&&(I=this.b.get(C)?.info.logLevel),I??this.h}registerLogger(C){const I=this.b.get(C.resource);I?I.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const I=this.b.get(C);I&&(I.logger&&I.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bk=f;class w{constructor(){this.onDidChangeLogLevel=new M.$de().event}setLevel(C){}getLevel(){return s.Info}trace(C,...I){}debug(C,...I){}info(C,...I){}warn(C,...I){}error(C,...I){}critical(C,...I){}dispose(){}flush(){}}e.$ck=w;class p extends w{}e.$dk=p;function v(k){if(k.verbose)return s.Trace;if(typeof k.logLevel=="string"){const C=D(k.logLevel.toLowerCase());if(C!==void 0)return C}return e.$6j}function y(k){switch(k){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}function h(k){switch(k){case s.Trace:return{original:"Trace",value:P.localize(0,null)};case s.Debug:return{original:"Debug",value:P.localize(1,null)};case s.Info:return{original:"Info",value:P.localize(2,null)};case s.Warning:return{original:"Warning",value:P.localize(3,null)};case s.Error:return{original:"Error",value:P.localize(4,null)};case s.Off:return{original:"Off",value:P.localize(5,null)}}}function D(k){switch(k){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.$ik=new l.$Nj("logLevel",y(s.Info))}),define(Se[201],Ie([1,0,6,12]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5P=void 0;class M extends P.$Uc{constructor(A,$=[]){super(),this.a=new O.$ak([A,...$]),this.B(A.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...$){this.a.trace(A,...$)}debug(A,...$){this.a.debug(A,...$)}info(A,...$){this.a.info(A,...$)}warn(A,...$){this.a.warn(A,...$)}error(A,...$){this.a.error(A,...$)}flush(){this.a.flush()}}e.$5P=M}),define(Se[101],Ie([1,0,32,167,3]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7t=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var N;(function(m){m[m.Unnecessary=1]="Unnecessary",m[m.Deprecated=2]="Deprecated"})(N||(e.MarkerTag=N={}));var A;(function(m){m[m.Hint=1]="Hint",m[m.Info=2]="Info",m[m.Warning=4]="Warning",m[m.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(m){function E(g,r){return r-g}m.compare=E;const T=Object.create(null);T[m.Error]=(0,O.localize)(0,null),T[m.Warning]=(0,O.localize)(1,null),T[m.Info]=(0,O.localize)(2,null);function S(g){return T[g]||""}m.toString=S;function l(g){switch(g){case P.default.Error:return m.Error;case P.default.Warning:return m.Warning;case P.default.Info:return m.Info;case P.default.Ignore:return m.Hint}}m.fromSeverity=l;function b(g){switch(g){case m.Error:return P.default.Error;case m.Warning:return P.default.Warning;case m.Info:return P.default.Info;case m.Hint:return P.default.Ignore}}m.toSeverity=b}(A||(e.MarkerSeverity=A={}));var $;(function(m){const E="";function T(l){return S(l,!0)}m.makeKey=T;function S(l,b){const g=[E];return l.source?g.push(l.source.replace("\xA6","\\\xA6")):g.push(E),l.code?typeof l.code=="string"?g.push(l.code.replace("\xA6","\\\xA6")):g.push(l.code.value.replace("\xA6","\\\xA6")):g.push(E),l.severity!==void 0&&l.severity!==null?g.push(A.toString(l.severity)):g.push(E),l.message&&b?g.push(l.message.replace("\xA6","\\\xA6")):g.push(E),l.startLineNumber!==void 0&&l.startLineNumber!==null?g.push(l.startLineNumber.toString()):g.push(E),l.startColumn!==void 0&&l.startColumn!==null?g.push(l.startColumn.toString()):g.push(E),l.endLineNumber!==void 0&&l.endLineNumber!==null?g.push(l.endLineNumber.toString()):g.push(E),l.endColumn!==void 0&&l.endColumn!==null?g.push(l.endColumn.toString()):g.push(E),g.push(E),g.join("\xA6")}m.makeKeyOptionalMessage=S})($||(e.IMarkerData=$={})),e.$7t=(0,M.$wi)("markerService")}),define(Se[202],Ie([1,0,5,32,3]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$_v=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$0v=e.Severity=void 0,e.$$v=$,e.Severity=O.default,e.$0v=(0,M.$wi)("notificationService");var N;(function(S){S[S.DEFAULT=0]="DEFAULT",S[S.SILENT=1]="SILENT",S[S.URGENT=2]="URGENT"})(N||(e.NotificationPriority=N={}));var A;(function(S){S[S.WORKSPACE=0]="WORKSPACE",S[S.PROFILE=1]="PROFILE",S[S.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function $(S){if(S){const l=S;return typeof l.id=="string"&&typeof l.label=="string"}return!1}var m;(function(S){S[S.OFF=0]="OFF",S[S.ERROR=1]="ERROR"})(m||(e.NotificationsFilter=m={}));class E{constructor(){this.progress=new T,this.onDidClose=P.Event.None,this.onDidChangeVisibility=P.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$_v=E;class T{infinite(){}done(){}total(l){}worked(l){}}e.$aw=T}),define(Se[102],Ie([1,0,3]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=void 0,e.$jk=(0,P.$wi)("productService"),e.$kk="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(he,e,P,O){var M=arguments.length,N=M<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,P):O,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(he,e,P,O);else for(var $=he.length-1;$>=0;$--)(A=he[$])&&(N=(M<3?A(N):M>3?A(e,P,N):A(e,P))||N);return M>3&&N&&Object.defineProperty(e,P,N),N},We=this&&this.__param||function(he,e){return function(P,O){e(P,O,he)}};define(Se[103],Ie([1,0,11,24,6,3]),function(he,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=e.$gw=e.$fw=e.$ew=e.$dw=e.$cw=e.ProgressLocation=e.$bw=void 0,e.$bw=(0,N.$wi)("progressService");var A;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$cw=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$dw=$;class m{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const b=this.d;this.d=()=>{b?.(),l()}}):Promise.resolve()}}e.$ew=m;let E=class extends M.$Uc{constructor(l,b){super(),this.a=new P.$Th,b.withProgress(l,g=>(this.b=g,this.c&&g.report(this.c),this.a.p)),this.B((0,M.$Sc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$fw=E,e.$fw=E=Ke([We(1,e.$bw)],E);class T extends M.$Uc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new M.$Tc)}start(l){this.stop();const b=++this.a,g=new O.$oe;return this.f=setTimeout(()=>{b===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,M.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,M.$Sc)(()=>g.cancel())),this.b.add((0,M.$Sc)(()=>this.c?this.c.done():void 0)),{id:b,token:g.token,stop:()=>this.h(b),isCurrent:()=>this.a===b}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$gw=T,e.$hw=(0,N.$wi)("editorProgressService")}),define(Se[29],Ie([1,0,57,15]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0;class M{constructor(){this.a=new Map}add(A,$){P.ok(O.$9f(A)),P.ok(O.$$f($)),P.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,$)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$co=new M}),define(Se[74],Ie([1,0,5,29]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=void 0,e.$do={JSONContribution:"base.contributions.json"};function M($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class N{constructor(){this.b=new P.$de,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,E){this.a[M(m)]=E,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const A=new N;O.$co.add(e.$do.JSONContribution,A)}),define(Se[51],Ie([1,0,18,5,15,160,50,74,29]),function(he,e,P,O,M,N,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.ConfigurationScope=e.$ho=e.EditPresentationTypes=void 0,e.$so=r,e.$to=s,e.$uo=o,e.$vo=i,e.$wo=c;var E;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$ho={Configuration:"base.contributions.configuration"};var T;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T||(e.ConfigurationScope=T={})),e.$io={properties:{},patternProperties:{}},e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo="vscode://schemas/settings/resourceLanguage",e.$po="vscode://schemas/settings/configurationDefaults";const S=m.$co.as($.$do.JSONContribution);class l{constructor(){this.h=new Set,this.i=new O.$de,this.onDidSchemaChange=this.i.event,this.j=new O.$de,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$oo,this.g),this.v()}registerConfiguration(t,d=!0){this.registerConfigurations([t],d)}registerConfigurations(t,d=!0){const a=new Set;this.n(t,d,a),S.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(t){const d=new Set;this.o(t,d),S.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:d})}updateConfigurations({add:t,remove:d}){const a=new Set;this.o(d,a),this.n(t,!1,a),S.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(t){const d=new Set;this.k(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}k(t,d){const a=[];for(const{overrides:f,source:w}of t)for(const p in f)if(d.add(p),e.$ro.test(p)){const v=this.a.get(p),y=v?.valuesSources??new Map;if(w)for(const C of Object.keys(f[p]))y.set(C,w);const h={...v?.value||{},...f[p]};this.a.set(p,{source:w,value:h,valuesSources:y});const D=(0,A.$aj)(p),k={type:"object",default:h,description:N.localize(1,null,D),$ref:e.$oo,defaultDefaultValue:h,source:M.$9f(w)?void 0:w,defaultValueSource:w};a.push(...r(p)),this.d[p]=k,this.b.properties[p]=k}else{this.a.set(p,{value:f[p],source:w});const v=this.d[p];v&&(this.w(p,v),this.r(p,v))}this.m(a)}deregisterDefaultConfigurations(t){const d=new Set;this.l(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}l(t,d){for(const{overrides:a,source:f}of t)for(const w in a){const p=this.a.get(w),v=M.$9f(f)?f:f?.id,y=M.$9f(p?.source)?p?.source:p?.source?.id;if(v===y)if(d.add(w),this.a.delete(w),e.$ro.test(w))delete this.d[w],delete this.b.properties[w];else{const h=this.d[w];h&&(this.w(w,h),this.r(w,h))}}this.u()}deltaConfiguration(t){let d=!1;const a=new Set;t.removedDefaults&&(this.l(t.removedDefaults,a),d=!0),t.addedDefaults&&(this.k(t.addedDefaults,a),d=!0),t.removedConfigurations&&this.o(t.removedConfigurations,a),t.addedConfigurations&&this.n(t.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:d})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const d of t)this.h.add(d);this.u()}n(t,d,a){t.forEach(f=>{this.p(f,d,f.extensionInfo,f.restrictedProperties,void 0,a),this.c.push(f),this.q(f)})}o(t,d){const a=f=>{if(f.properties)for(const w in f.properties){d.add(w);const p=this.d[w];p?.policy?.name&&this.e.delete(p.policy.name),delete this.d[w],this.s(w,f.properties[w])}f.allOf?.forEach(w=>a(w))};for(const f of t){a(f);const w=this.c.indexOf(f);w!==-1&&this.c.splice(w,1)}}p(t,d=!0,a,f,w=3,p){w=M.$fg(t.scope)?w:t.scope;const v=t.properties;if(v)for(const h in v){const D=v[h];if(d&&i(h,D)){delete v[h];continue}if(D.source=a,D.defaultDefaultValue=v[h].default,this.w(h,D),e.$ro.test(h)?D.scope=void 0:(D.scope=M.$fg(D.scope)?w:D.scope,D.restricted=M.$fg(D.restricted)?!!f?.includes(h):D.restricted),v[h].hasOwnProperty("included")&&!v[h].included){this.f[h]=v[h],delete v[h];continue}else this.d[h]=v[h],v[h].policy?.name&&this.e.set(v[h].policy.name,h);!v[h].deprecationMessage&&v[h].markdownDeprecationMessage&&(v[h].deprecationMessage=v[h].markdownDeprecationMessage),p.add(h)}const y=t.allOf;if(y)for(const h of y)this.p(h,d,a,f,w,p)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const d=a=>{const f=a.properties;if(f)for(const p in f)this.r(p,f[p]);a.allOf?.forEach(d)};d(t)}r(t,d){switch(e.$io.properties[t]=d,d.scope){case 1:e.$jo.properties[t]=d;break;case 2:e.$ko.properties[t]=d;break;case 6:e.$lo.properties[t]=d;break;case 3:e.$mo.properties[t]=d;break;case 4:e.$no.properties[t]=d;break;case 5:e.$no.properties[t]=d,this.g.properties[t]=d;break}}s(t,d){switch(delete e.$io.properties[t],d.scope){case 1:delete e.$jo.properties[t];break;case 2:delete e.$ko.properties[t];break;case 6:delete e.$lo.properties[t];break;case 3:delete e.$mo.properties[t];break;case 4:case 5:delete e.$no.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const d=`[${t}]`,a={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$oo};this.w(d,a),e.$io.properties[d]=a,e.$jo.properties[d]=a,e.$ko.properties[d]=a,e.$lo.properties[d]=a,e.$mo.properties[d]=a,e.$no.properties[d]=a}}v(){const t={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$oo};e.$io.patternProperties[e.$qo]=t,e.$jo.patternProperties[e.$qo]=t,e.$ko.patternProperties[e.$qo]=t,e.$lo.patternProperties[e.$qo]=t,e.$mo.patternProperties[e.$qo]=t,e.$no.patternProperties[e.$qo]=t,this.i.fire()}w(t,d){const a=this.a.get(t);let f=a?.value,w=a?.source;M.$dg(f)&&(f=d.defaultDefaultValue,w=void 0),M.$dg(f)&&(f=o(d.type)),d.default=f,d.defaultValueSource=w}}const b="\\[([^\\]]+)\\]",g=new RegExp(b,"g");e.$qo=`^(${b})+$`,e.$ro=new RegExp(e.$qo);function r(u){const t=[];if(e.$ro.test(u)){let d=g.exec(u);for(;d?.length;){const a=d[1].trim();a&&t.push(a),d=g.exec(u)}}return(0,P.$Mb)(t)}function s(u){return u.reduce((t,d)=>`${t}[${d}]`,"")}function o(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new l;m.$co.add(e.$ho.Configuration,n);function i(u,t){return u.trim()?e.$ro.test(u)?N.localize(7,null,u):n.getConfigurationProperties()[u]!==void 0?N.localize(8,null,u):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?N.localize(9,null,u,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:N.localize(6,null)}function c(){const u=[],t=n.getConfigurationProperties();for(const d of Object.keys(t))u.push([d,t[d].scope]);return u.push(["launch",4]),u.push(["task",4]),u}}),define(Se[203],Ie([1,0,18,5,126,6,28,25,15,2,50,51,29]),function(he,e,P,O,M,N,A,$,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Ao=e.$zo=e.$yo=e.$xo=void 0,e.$Bo=i;function b(d){return Object.isFrozen(d)?d:$.$4n(d)}class g{static createEmptyModel(a){return new g({},[],[],void 0,a)}constructor(a,f,w,p,v){this.b=a,this.c=f,this.d=w,this.raw=p,this.f=v,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const a=this.raw.map(f=>{if(f instanceof g)return f;const w=new r("",this.f);return w.parseRaw(f),w.configurationModel});this.g=a.reduce((f,w)=>w===f?w:f.merge(w),a[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,T.$$i)(this.contents,a):this.contents}inspect(a,f){const w=this;return{get value(){return b(w.rawConfiguration.getValue(a))},get override(){return f?b(w.rawConfiguration.getOverrideValue(a,f)):void 0},get merged(){return b(f?w.rawConfiguration.override(f).getValue(a):w.rawConfiguration.getValue(a))},get overrides(){const p=[];for(const{contents:v,identifiers:y,keys:h}of w.rawConfiguration.overrides){const D=new g(v,h,[],void 0,w.f).getValue(a);D!==void 0&&p.push({identifiers:y,value:D})}return p.length?b(p):void 0}}}getOverrideValue(a,f){const w=this.j(f);return w?a?(0,T.$$i)(w,a):w:void 0}getKeysForOverrideIdentifier(a){const f=[];for(const w of this.overrides)w.identifiers.includes(a)&&f.push(...w.keys);return P.$Mb(f)}getAllOverrideIdentifiers(){const a=[];for(const f of this.overrides)a.push(...f.identifiers);return P.$Mb(a)}override(a){let f=this.a.get(a);return f||(f=this.h(a),this.a.set(a,f)),f}merge(...a){const f=$.$3n(this.contents),w=$.$3n(this.overrides),p=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const y of a)if(v.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.i(f,y.contents);for(const h of y.overrides){const[D]=w.filter(k=>P.$ub(k.identifiers,h.identifiers));D?(this.i(D.contents,h.contents),D.keys.push(...h.keys),D.keys=P.$Mb(D.keys)):w.push($.$3n(h))}for(const h of y.keys)p.indexOf(h)===-1&&p.push(h)}return new g(f,p,w,v.every(y=>y instanceof g)?void 0:v,this.f)}h(a){const f=this.j(a);if(!f||typeof f!="object"||!Object.keys(f).length)return this;const w={};for(const p of P.$Mb([...Object.keys(this.contents),...Object.keys(f)])){let v=this.contents[p];const y=f[p];y&&(typeof v=="object"&&typeof y=="object"?(v=$.$3n(v),this.i(v,y)):v=y),w[p]=v}return new g(w,this.keys,this.overrides,void 0,this.f)}i(a,f){for(const w of Object.keys(f)){if(w in a&&m.$$f(a[w])&&m.$$f(f[w])){this.i(a[w],f[w]);continue}a[w]=$.$3n(f[w])}}j(a){let f=null,w=null;const p=v=>{v&&(w?this.i(w,v):w=$.$3n(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===a?f=v.contents:v.identifiers.includes(a)&&p(v.contents);return p(f),w}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,f){this.k(a,f,!0)}setValue(a,f){this.k(a,f,!1)}removeValue(a){const f=this.keys.indexOf(a);f!==-1&&(this.keys.splice(f,1),(0,T.$0i)(this.contents,a),S.$ro.test(a)&&this.overrides.splice(this.overrides.findIndex(w=>P.$ub(w.identifiers,(0,S.$so)(a))),1))}k(a,f,w){(0,T.$9i)(this.contents,a,f,p=>this.f.error(p)),w=w||this.keys.indexOf(a)===-1,w&&this.keys.push(a),S.$ro.test(a)&&this.overrides.push({identifiers:(0,S.$so)(a),keys:Object.keys(this.contents[a]),contents:(0,T.$8i)(this.contents[a],p=>this.f.error(p))})}}e.$xo=g;class r{constructor(a,f){this.f=a,this.g=f,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||g.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,f){if(!m.$fg(a)){const w=this.h(a);this.parseRaw(w,f)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,f){this.a=a;const{contents:w,keys:p,overrides:v,restricted:y,hasExcludedProperties:h}=this.i(a,f);this.b=new g(w,p,v,h?[a]:void 0,this.g),this.c=y||[]}h(a){let f={},w=null,p=[];const v=[],y=[];function h(k){Array.isArray(p)?p.push(k):w!==null&&(p[w]=k)}const D={onObjectBegin:()=>{const k={};h(k),v.push(p),p=k,w=null},onObjectProperty:k=>{w=k},onObjectEnd:()=>{p=v.pop()},onArrayBegin:()=>{const k=[];h(k),v.push(p),p=k,w=null},onArrayEnd:()=>{p=v.pop()},onLiteralValue:h,onError:(k,C,I)=>{y.push({error:k,offset:C,length:I})}};if(a)try{M.$Qn(a,D),f=p[0]||{}}catch(k){this.g.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return f}i(a,f){const w=l.$co.as(S.$ho.Configuration).getConfigurationProperties(),p=this.j(a,w,!0,f);a=p.raw;const v=(0,T.$8i)(a,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`)),y=Object.keys(a),h=this.l(a,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:v,keys:y,overrides:h,restricted:p.restricted,hasExcludedProperties:p.hasExcludedProperties}}j(a,f,w,p){let v=!1;if(!p?.scopes&&!p?.skipRestricted&&!p?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:v};const y={},h=[];for(const D in a)if(S.$ro.test(D)&&w){const k=this.j(a[D],f,!1,p);y[D]=k.raw,v=v||k.hasExcludedProperties,h.push(...k.restricted)}else{const k=f[D],C=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&h.push(D),!p.exclude?.includes(D)&&(p.include?.includes(D)||(C===void 0||p.scopes===void 0||p.scopes.includes(C))&&!(p.skipRestricted&&k?.restricted))?y[D]=a[D]:v=!0}return{raw:y,restricted:h,hasExcludedProperties:v}}l(a,f){const w=[];for(const p of Object.keys(a))if(S.$ro.test(p)){const v={};for(const y in a[p])v[y]=a[p][y];w.push({identifiers:(0,S.$so)(p),keys:Object.keys(v),contents:(0,T.$8i)(v,f)})}return w}}e.$yo=r;class s extends N.$Uc{constructor(a,f,w,p,v){super(),this.c=a,this.f=f,this.g=p,this.h=v,this.b=this.B(new O.$de),this.onDidChange=this.b.event,this.a=new r(this.c.toString(),v),this.B(this.g.watch(w.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,y=>y.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,y=>(y.isOperation(0)||y.isOperation(3)||y.isOperation(1)||y.isOperation(4))&&w.isEqual(y.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return g.createEmptyModel(this.h)}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$zo=s;class o{constructor(a,f,w,p,v,y,h,D,k,C,I,W,V){this.a=a,this.b=f,this.c=w,this.overrideIdentifiers=p,this.d=v,this.f=y,this.g=h,this.h=D,this.i=k,this.j=C,this.k=I,this.l=W,this.m=V}get value(){return b(this.c)}n(a){return a?.value!==void 0||a?.override!==void 0||a?.overrides!==void 0?a:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(a,f,w,p,v,y,h,D,k,C){this.j=a,this.l=f,this.m=w,this.n=p,this.p=v,this.q=y,this.r=h,this.s=D,this.t=k,this.u=C,this.h=null,this.i=new A.$Ac,this.v=null}getValue(a,f,w){return this.w(a,f,w).getValue(a)}updateValue(a,f,w={}){let p;w.resource?(p=this.t.get(w.resource),p||(p=g.createEmptyModel(this.u),this.t.set(w.resource,p))):p=this.s,f===void 0?p.removeValue(a):p.setValue(a,f),w.resource||(this.h=null)}inspect(a,f,w){const p=this.w(a,f,w),v=this.A(f.resource,w),y=f.resource?this.t.get(f.resource)||this.s:this.s,h=new Set;for(const D of p.overrides)for(const k of D.identifiers)p.getOverrideValue(a,k)!==void 0&&h.add(k);return new o(a,f,p.getValue(a),h.size?[...h]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,w?this.q:void 0,v||void 0,y)}keys(a){const f=this.A(void 0,a);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:f?f.keys.slice(0):[]}}updateDefaultConfiguration(a){this.j=a,this.h=null,this.i.clear()}updatePolicyConfiguration(a){this.l=a}updateApplicationConfiguration(a){this.m=a,this.h=null,this.i.clear()}updateLocalUserConfiguration(a){this.n=a,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(a){this.p=a,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(a){this.q=a,this.h=null,this.i.clear()}updateFolderConfiguration(a,f){this.r.set(a,f),this.i.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.i.delete(a)}compareAndUpdateDefaultConfiguration(a,f){const w=[];if(!f){const{added:p,updated:v,removed:y}=u(this.j,a);f=[...p,...v,...y]}for(const p of f)for(const v of(0,S.$so)(p)){const y=this.j.getKeysForOverrideIdentifier(v),h=a.getKeysForOverrideIdentifier(v),D=[...h.filter(k=>y.indexOf(k)===-1),...y.filter(k=>h.indexOf(k)===-1),...y.filter(k=>!$.$7n(this.j.override(v).getValue(k),a.override(v).getValue(k)))];w.push([v,D])}return this.updateDefaultConfiguration(a),{keys:f,overrides:w}}compareAndUpdatePolicyConfiguration(a){const{added:f,updated:w,removed:p}=u(this.l,a),v=[...f,...w,...p];return v.length&&this.updatePolicyConfiguration(a),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:f,updated:w,removed:p,overrides:v}=u(this.applicationConfiguration,a),y=[...f,...w,...p];return y.length&&this.updateApplicationConfiguration(a),{keys:y,overrides:v}}compareAndUpdateLocalUserConfiguration(a){const{added:f,updated:w,removed:p,overrides:v}=u(this.localUserConfiguration,a),y=[...f,...w,...p];return y.length&&this.updateLocalUserConfiguration(a),{keys:y,overrides:v}}compareAndUpdateRemoteUserConfiguration(a){const{added:f,updated:w,removed:p,overrides:v}=u(this.remoteUserConfiguration,a),y=[...f,...w,...p];return y.length&&this.updateRemoteUserConfiguration(a),{keys:y,overrides:v}}compareAndUpdateWorkspaceConfiguration(a){const{added:f,updated:w,removed:p,overrides:v}=u(this.workspaceConfiguration,a),y=[...f,...w,...p];return y.length&&this.updateWorkspaceConfiguration(a),{keys:y,overrides:v}}compareAndUpdateFolderConfiguration(a,f){const w=this.folderConfigurations.get(a),{added:p,updated:v,removed:y,overrides:h}=u(w,f),D=[...p,...v,...y];return(D.length||!w)&&this.updateFolderConfiguration(a,f),{keys:D,overrides:h}}compareAndDeleteFolderConfiguration(a){const f=this.folderConfigurations.get(a);if(!f)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:w,updated:p,removed:v,overrides:y}=u(f,void 0);return{keys:[...w,...p,...v],overrides:y}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(a,f,w){let p=this.x(f,w);return f.overrideIdentifier&&(p=p.override(f.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(a)!==void 0&&(p=p.merge(this.l)),p}x({resource:a},f){let w=this.y();if(f&&a){const p=f.getFolder(a);p&&(w=this.z(p.uri)||w);const v=this.t.get(a);v&&(w=w.merge(v))}return w}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(a){let f=this.i.get(a);if(!f){const w=this.y(),p=this.r.get(a);p?(f=w.merge(p),this.i.set(a,f)):f=w}return f}A(a,f){if(f&&a){const w=f.getFolder(a);if(w)return this.r.get(w.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((a,f)=>{const{contents:w,overrides:p,keys:v}=this.r.get(f);return a.push([f,{contents:w,overrides:p,keys:v}]),a},[])}}allKeys(){const a=new Set;return this.j.keys.forEach(f=>a.add(f)),this.userConfiguration.keys.forEach(f=>a.add(f)),this.q.keys.forEach(f=>a.add(f)),this.r.forEach(f=>f.keys.forEach(w=>a.add(w))),[...a.values()]}B(){const a=new Set;return this.j.getAllOverrideIdentifiers().forEach(f=>a.add(f)),this.userConfiguration.getAllOverrideIdentifiers().forEach(f=>a.add(f)),this.q.getAllOverrideIdentifiers().forEach(f=>a.add(f)),this.r.forEach(f=>f.getAllOverrideIdentifiers().forEach(w=>a.add(w))),[...a.values()]}D(a){const f=new Set;return this.j.getKeysForOverrideIdentifier(a).forEach(w=>f.add(w)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(w=>f.add(w)),this.q.getKeysForOverrideIdentifier(a).forEach(w=>f.add(w)),this.r.forEach(w=>w.getKeysForOverrideIdentifier(a).forEach(p=>f.add(p))),[...f.values()]}static parse(a,f){const w=this.E(a.defaults,f),p=this.E(a.policy,f),v=this.E(a.application,f),y=this.E(a.user,f),h=this.E(a.workspace,f),D=a.folders.reduce((k,C)=>(k.set(E.URI.revive(C[0]),this.E(C[1],f)),k),new A.$Ac);return new n(w,p,v,y,g.createEmptyModel(f),h,D,g.createEmptyModel(f),new A.$Ac,f)}static E(a,f){return new g(a.contents,a.keys,a.overrides,void 0,f)}}e.$Ao=n;function i(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const a=new Set,f=new Map;for(const p of d)p.keys.forEach(v=>a.add(v)),p.overrides.forEach(([v,y])=>{const h=(0,A.$xc)(f,v,new Set);y.forEach(D=>h.add(D))});const w=[];return f.forEach((p,v)=>w.push([v,[...p.values()]])),{keys:[...a.values()],overrides:w}}class c{constructor(a,f,w,p,v){this.change=a,this.f=f,this.g=w,this.h=p,this.i=v,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const y of a.keys)this.affectedKeys.add(y);for(const[,y]of a.overrides)for(const h of y)this.affectedKeys.add(h);this.d=this.a;for(const y of this.affectedKeys)this.d+=y+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(a,f){const w=this.a+a,p=this.d.indexOf(w);if(p<0)return!1;const v=p+w.length;if(v>=this.d.length)return!1;const y=this.d.charCodeAt(v);if(y!==this.b&&y!==this.c)return!1;if(f){const h=this.previousConfiguration?this.previousConfiguration.getValue(a,f,this.f?.workspace):void 0,D=this.g.getValue(a,f,this.h);return!$.$7n(h,D)}return!0}}e.$Co=c;function u(d,a){const{added:f,removed:w,updated:p}=t(a?.rawConfiguration,d?.rawConfiguration),v=[],y=d?.getAllOverrideIdentifiers()||[],h=a?.getAllOverrideIdentifiers()||[];if(a){const D=h.filter(k=>!y.includes(k));for(const k of D)v.push([k,a.getKeysForOverrideIdentifier(k)])}if(d){const D=y.filter(k=>!h.includes(k));for(const k of D)v.push([k,d.getKeysForOverrideIdentifier(k)])}if(a&&d){for(const D of y)if(h.includes(D)){const k=t({contents:d.getOverrideValue(void 0,D)||{},keys:d.getKeysForOverrideIdentifier(D)},{contents:a.getOverrideValue(void 0,D)||{},keys:a.getKeysForOverrideIdentifier(D)});v.push([D,[...k.added,...k.removed,...k.updated]])}}return{added:f,removed:w,updated:p,overrides:v}}function t(d,a){const f=d?a?d.keys.filter(v=>a.keys.indexOf(v)===-1):[...d.keys]:[],w=a?d?a.keys.filter(v=>d.keys.indexOf(v)===-1):[...a.keys]:[],p=[];if(d&&a){for(const v of a.keys)if(d.keys.indexOf(v)!==-1){const y=(0,T.$$i)(a.contents,v),h=(0,T.$$i)(d.contents,v);$.$7n(y,h)||p.push(v)}}return{added:f,removed:w,updated:p}}}),define(Se[104],Ie([1,0,14,3]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.RemoteAuthorityResolverErrorCode=e.$Jl=e.$Il=e.RemoteConnectionType=e.$Hl=void 0,e.$Ll=E,e.$Hl=(0,O.$wi)("remoteAuthorityResolverService");var M;(function(T){T[T.WebSocket=0]="WebSocket",T[T.Managed=1]="Managed"})(M||(e.RemoteConnectionType=M={}));class N{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$Il=N;class A{constructor(S,l){this.host=S,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Jl=A;var $;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound",T.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class m extends P.$bb{static isNotAvailable(S){return S instanceof m&&S._code===$.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof m&&S._code===$.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof m&&S._code===$.NoResolverFound}static isInvalidAuthority(S){return S instanceof m&&S._code===$.InvalidAuthority}static isHandled(S){return S instanceof m&&S.isHandled}constructor(S,l=$.Unknown,b){super(S),this._message=S,this._code=l,this._detail=b,this.isHandled=l===$.NotAvailable&&b===!0,Object.setPrototypeOf(this,m.prototype)}}e.$Kl=m;function E(T){const S=T.indexOf("+");return S===-1?T:T.substring(0,S)}}),define(Se[58],Ie([1,0,16]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=O,e.$Im=M,e.$Jm=N,e.$Km=A;function O(m){return m.scheme===P.Schemas.vscodeRemote?m.authority:void 0}function M(m){if(!m)return;const E=m.indexOf("+");return E<0?m:m.substr(0,E)}function N(m){const{host:E,port:T}=$(m);if(typeof T>"u")throw new Error(`Invalid remote authority: ${m}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:T}}function A(m,E){let{host:T,port:S}=$(m);return typeof S>"u"&&(S=E),{host:T,port:S}}function $(m){const E=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const T=m.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const S=m.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:m,port:void 0}}}),define(Se[20],Ie([1,0,13,3,58]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Tm=e.$Sm=e.$Rm=e.TargetPlatform=e.ExtensionType=e.$Qm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0,e.$Pm=N,e.$Um=S,e.$Vm=l,e.$Wm=b,e.$Xm=g,e.$Lm="extensions.user.cache",e.$Mm="extensions.builtin.cache",e.$Nm="undefined_publisher",e.$Om=["ui","workspace","web"];function N(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$Qm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(A||(e.ExtensionType=A={}));var $;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class m{constructor(s){this.value=s,this._lower=s.toLowerCase()}static equals(s,o){if(typeof s>"u"||s===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof s=="string"||typeof o=="string"){const n=typeof s=="string"?s:s.value,i=typeof o=="string"?o:o.value;return P.$xf(n,i)}return s._lower===o._lower}static toKey(s){return typeof s=="string"?s.toLowerCase():s._lower}}e.$Rm=m;class E{get size(){return this.c.size}constructor(s){if(this.c=new Set,s)for(const o of s)this.add(o)}add(s){this.c.add(m.toKey(s))}delete(s){return this.c.delete(m.toKey(s))}has(s){return this.c.has(m.toKey(s))}}e.$Sm=E;class T{constructor(){this.c=new Map}clear(){this.c.clear()}delete(s){this.c.delete(m.toKey(s))}get(s){return this.c.get(m.toKey(s))}has(s){return this.c.has(m.toKey(s))}set(s,o){this.c.set(m.toKey(s),o)}values(){return this.c.values()}forEach(s){this.c.forEach(s)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Tm=T;function S(r){return l(r)}function l(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}function b(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}function g(r,s){if(s){const o=`onResolveRemoteAuthority:${(0,M.$Im)(s)}`;return!!r.activationEvents?.includes(o)}return!1}e.$Ym=(0,O.$wi)("IBuiltinExtensionsScannerService")}),define(Se[105],Ie([1,0,14,20]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uG=e.$tG=void 0;class M{constructor(){this.a=new Map,this.b=new WeakMap}register(A,$){this.a.set(A,$)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const $=Object.create(null);for(const m of A){const E=this.readActivationEvents(m);E.length>0&&($[O.$Rm.toKey(m.identifier)]=E)}return $}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const $=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let m=0;m<$.length;m++)$[m]==="onUri"&&($[m]=`onUri:${O.$Rm.toKey(A.identifier)}`);if(!A.contributes)return $;for(const m in A.contributes){const E=this.a.get(m);if(!E)continue;const T=A.contributes[m],S=Array.isArray(T)?T:[T];try{E(S,$)}catch(l){(0,P.$1)(l)}}return $}}e.$tG=M,e.$uG=new M}),define(Se[204],Ie([1,0,21,14,6,168,51,3,12,29]),function(he,e,P,O,M,N,A,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=void 0,e.$Pp=l,e.$Qp=b,e.$Rp=g,e.$Sp=r,e.$Tp=s,e.$Up=o,e.$Np=(0,$.$wi)("requestService");class T{constructor(u){this.b=u}toJSON(){if(!this.a){const u=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?u[t]="*****":u[t]=this.b[t];this.a=u}return this.a}}class S extends M.$Uc{constructor(u){super(),this.b=0,this.a=u.createLogger("network",{name:(0,N.localize)(0,null),when:m.$ik.isEqualTo((0,m.$fk)(m.LogLevel.Trace)).serialize()})}async c(u,t,d){const a=`${u} #${++this.b}: ${t.url}`;this.a.trace(`${a} - begin`,t.type,new T(t.headers??{}));try{const f=await d();return this.a.trace(`${a} - end`,t.type,f.res.statusCode,f.res.headers),f}catch(f){throw this.a.error(`${a} - error`,t.type,(0,O.$0)(f)),f}}}e.$Op=S;function l(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}function b(c){return c.res.statusCode===204}async function g(c){return b(c)?null:(await(0,P.$Re)(c.stream)).toString()}async function r(c){if(!l(c))throw new Error("Server returned "+c.res.statusCode);return g(c)}async function s(c){if(!l(c))throw new Error("Server returned "+c.res.statusCode);if(b(c))return null;const t=(await(0,P.$Re)(c.stream)).toString();try{return JSON.parse(t)}catch(d){throw d.message+=`:
`+t,d}}function o(c){i(c)}let n;function i(c){const u=E.$co.as(A.$ho.Configuration),t=n;n={id:"http",order:15,title:(0,N.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,N.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(6,null),(0,N.localize)(7,null),(0,N.localize)(8,null),(0,N.localize)(9,null)],default:"override",description:(0,N.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,N.localize)(12,null),restricted:!0}}},u.updateConfigurations({add:[n],remove:t?[t]:[]})}i(1)}),define(Se[205],Ie([1,0,22,75,33]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=A,e.$ep=$;function N(m){if(P.$u===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}function A(m,E,T,S,l,b,g,r,s){const o=Object.create(null);o["common.machineId"]=b,o["common.sqmId"]=g,o.sessionID=(0,M.$Sg)()+Date.now(),o.commitHash=S,o.version=l,o["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,P.$h)(P.$u),o["common.nodePlatform"]=O.$dc,o["common.nodeArch"]=T,o["common.product"]=s||"desktop",r&&(o["common.msftInternal"]=r);let n=0;const i=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),P.$l&&(o["common.snap"]="true");const c=N(E);return c&&(o["common.platformDetail"]=c),o}function $(m){const E=O.env.USERDNSDOMAIN;if(!E)return!1;const T=E.toLowerCase();return m.some(S=>T===S)}}),define(Se[206],Ie([1,0,3]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=void 0,e.$2l=(0,P.$wi)("telemetryService"),e.$3l=(0,P.$wi)("customEndpointTelemetryService"),e.$4l="telemetry.currentSessionDate",e.$5l="telemetry.firstSessionDate",e.$6l="telemetry.lastSessionDate",e.$7l="telemetry.machineId",e.$8l="telemetry.sqmId",e.$9l="telemetry",e.$0l="telemetry.telemetryLevel",e.$$l="telemetry.enableCrashReporter",e.$_l="telemetry.enableTelemetry";var O;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var M;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(M||(e.TelemetryConfiguration=M={}))}),define(Se[59],Ie([1,0,25,15,58,205,206]),function(he,e,P,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=void 0,e.$mp=T,e.$np=S,e.$op=l,e.$pp=b,e.$qp=r,e.$rp=o,e.$sp=n,e.$tp=u;class ${constructor(d){this.value=d,this.isTrustedTelemetryValue=!0}}e.$fp=$;class m{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$gp=m,e.$hp=new m;class E{async publicLog(d,a,f){}async publicLogError(d,a,f){}}e.$ip=E,e.$jp="telemetry",e.$kp="extensionTelemetryLog",e.$lp={log:()=>null,flush:()=>Promise.resolve(null)};function T(t,d){return!d.isBuilt&&!d.disableTelemetry?!0:!(d.disableTelemetry||!t.enableTelemetry)}function S(t,d){return d.extensionTestsLocationURI?!0:!(d.isBuilt||d.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function l(t){const d=t.getValue(A.$0l),a=t.getValue(A.$$l);if(t.getValue(A.$_l)===!1||a===!1)return 0;switch(d??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function b(t){const d={},a={},f={};s(t,f);for(let w in f){w=w.length>150?w.substr(w.length-149):w;const p=f[w];typeof p=="number"?a[w]=p:typeof p=="boolean"?a[w]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${p.length}`),d[w]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(d[w]=p)}return{properties:d,measurements:a}}const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(t){if(!t)return"none";const d=(0,M.$Im)(t);return g.has(d)?d:"other"}function s(t,d,a=0,f){if(t)for(const w of Object.getOwnPropertyNames(t)){const p=t[w],v=f?f+w:w;Array.isArray(p)?d[v]=(0,P.$8n)(p):p instanceof Date?d[v]=p.toISOString():(0,O.$$f)(p)?a<2?s(p,d,a+1,v+"."):d[v]=(0,P.$8n)(p):d[v]=p}}function o(t,d){const a=t.msftInternalDomains||[],f=d.getValue("telemetry.internalTesting");return(0,N.$ep)(a)||f}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,d){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let a=t;const f=[];for(const y of d)for(;;){const h=y.exec(t);if(!h)break;f.push([h.index,y.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let v=0;for(a="";;){const y=p.exec(t);if(!y)break;const h=f.some(([D,k])=>y.index<k&&D<p.lastIndex);!w.test(y[0])&&!h&&(a+=t.substring(v,y.index)+"<REDACTED: user-file-path>",v=p.lastIndex)}return v<t.length&&(a+=t.substr(v)),a}function c(t){if(!t)return t;const d=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of d)if(a.regex.test(t))return`<REDACTED: ${a.label}>`;return t}function u(t,d){return(0,P.$5n)(t,a=>{if(a instanceof $||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let f=a.replaceAll("%20"," ");f=i(f,d);for(const w of d)f=f.replace(w,"");return f=c(f),f}})}}),define(Se[207],Ie([1,0,13,100,20,22,2,14,75,59]),function(he,e,P,O,M,N,A,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$vp=void 0,e.$up=T,e.$wp=g,e.$xp=r,e.$yp=s,e.$zp=o,e.$Ap=n,e.$Bp=i,e.$Cp=c,e.$Ep=u,e.$Fp=d;function T(a,f){return a.uuid&&f.uuid?a.uuid===f.uuid:a.id===f.id?!0:(0,P.$sf)(a.id,f.id)===0}const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(f){const w=f.manifest?f.manifest.version:f.version,p=f.manifest?f.targetPlatform:f.properties.targetPlatform;return new l(f.identifier,w,p)}static parse(f){const w=S.exec(f);return w&&w[1]&&w[2]?new l({id:w[1]},w[2],w[4]||void 0):null}constructor(f,w,p="undefined"){this.version=w,this.targetPlatform=p,this.id=f.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(f){return f instanceof l?T(this,f)&&this.version===f.version&&this.targetPlatform===f.targetPlatform:!1}}e.$vp=l;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(a){const f=b.exec(a);return f&&f[1]?[s(f[1]),f[2]]:[s(a),void 0]}function r(a,f){return`${a}.${f}`}function s(a){return a.toLowerCase()}function o(a,f){return s(r(a??M.$Nm,f))}function n(a,f){const w=[],p=v=>{for(const y of w)if(y.some(h=>T(f(h),f(v))))return y;return null};for(const v of a){const y=p(v);y?y.push(v):w.push([v])}return w}function i(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function c(a){return{id:new E.$fp(a.identifier.id),name:new E.$fp(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$Dp=new M.$Rm("pprice.better-merge");function u(a,f){const w=[],p=f.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const v=p.shift();if(v&&w.every(y=>!T(y.identifier,{id:v}))){const y=a.filter(h=>T(h.identifier,{id:v}));y.length===1&&(w.push(y[0]),p.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}async function t(a,f){if(!N.$k)return!1;let w;try{w=(await a.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await a.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(v){f.debug("Error while getting the os-release file.",(0,$.$0)(v))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function d(a,f){const w=await t(a,f),p=(0,O.$2o)(w?"alpine":N.$u,m.$ec);return f.debug("ComputeTargetPlatform:",p),p}}),define(Se[208],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=P,e.$ms=O,e.$ns=M,e.$os=N,e.$ps=A,e.$qs=$;function P(m){return[...m.entries()]}function O(m){return m?[...m.entries()]:[]}function M(m){return new Map(m)}function N(m){return new Map(m??[])}function A(m){return Array.from(m.entries()).map(E=>[E[0],P(E[1].map),O(E[1].descriptionMap)])}function $(m){return new Map(m.map(E=>[E[0],{map:M(E[1]),descriptionMap:N(E[2])}]))}}),define(Se[209],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pvb=void 0;class P{constructor(M){this.b=M,this.a=new Map}dispose(){for(const M of this.a.values())M.dispose()}startBuffering(M,N,A=5){const $=N(m=>{const E=typeof m=="string"?m:m.data;let T=this.a.get(M);if(T){T.data.push(E);return}const S=setTimeout(()=>this.flushBuffer(M),A);T={data:[E],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(M),$.dispose()}},this.a.set(M,T)});return $}stopBuffering(M){this.a.get(M)?.dispose()}flushBuffer(M){const N=this.a.get(M);N&&(this.a.delete(M),this.b(M,N.data.join("")))}}e.$Pvb=P}),define(Se[210],Ie([1,0,11,92,311,36,5,15,2,169,74,29]),function(he,e,P,O,M,N,A,$,m,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mx=e.$lx=e.$kx=e.$jx=e.$ix=e.$hx=e.IconFontDefinition=e.IconContribution=e.$ex=void 0,e.$fx=s,e.$gx=o,e.$ex={IconContribution:"base.contributions.icons"};var l;(function(u){function t(d,a){let f=d.defaults;for(;N.ThemeIcon.isThemeIcon(f);){const w=r.getIcon(f.id);if(!w)return;f=w.defaults}return f}u.getDefinition=t})(l||(e.IconContribution=l={}));var b;(function(u){function t(a){return{weight:a.weight,style:a.style,src:a.src.map(f=>({format:f.format,location:f.location.toString()}))}}u.toJSONObject=t;function d(a){const f=w=>(0,$.$9f)(w)?w:void 0;if(a&&Array.isArray(a.src)&&a.src.every(w=>(0,$.$9f)(w.format)&&(0,$.$9f)(w.location)))return{weight:f(a.weight),style:f(a.style),src:a.src.map(w=>({format:w.format,location:m.URI.parse(w.location)}))}}u.fromJSONObject=d})(b||(e.IconFontDefinition=b={}));class g{constructor(){this.a=new A.$de,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${N.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,d,a,f){const w=this.b[t];if(w){if(a&&!w.description){w.description=a,this.d.properties[t].markdownDescription=`${a} $(${t})`;const y=this.e.enum.indexOf(t);y!==-1&&(this.e.enumDescriptions[y]=a),this.a.fire()}return w}const p={id:t,description:a,defaults:d,deprecationMessage:f};this.b[t]=p;const v={$ref:"#/definitions/icons"};return f&&(v.deprecationMessage=f),a&&(v.markdownDescription=`${a}: $(${t})`),this.d.properties[t]=v,this.e.enum.push(t),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const d=this.e.enum.indexOf(t);d!==-1&&(this.e.enum.splice(d,1),this.e.enumDescriptions.splice(d,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,d){const a=this.f[t];return a||(this.f[t]=d,this.a.fire(),d)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(w,p)=>w.id.localeCompare(p.id),d=w=>{for(;N.ThemeIcon.isThemeIcon(w.defaults);)w=this.b[w.defaults.id];return`codicon codicon-${w?w.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const f=Object.keys(this.b).map(w=>this.b[w]);for(const w of f.filter(p=>!!p.description).sort(t))a.push(`|<i class="${d(w)}"></i>|${w.id}|${N.ThemeIcon.isThemeIcon(w.defaults)?w.defaults.id:w.id}|${w.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const w of f.filter(p=>!N.ThemeIcon.isThemeIcon(p.defaults)).sort(t))a.push(`|<i class="${d(w)}"></i>|${w.id}|`);return a.join(`
`)}}const r=new g;S.$co.add(e.$ex.IconContribution,r);function s(u,t,d,a){return r.registerIcon(u,t,d,a)}function o(){return r}function n(){const u=(0,M.$Rj)();for(const t in u){const d="\\"+u[t].toString(16);r.registerIcon(t,{fontCharacter:d})}}n(),e.$hx="vscode://schemas/icons";const i=S.$co.as(T.$do.JSONContribution);i.registerSchema(e.$hx,r.getIconSchema());const c=new P.$Ih(()=>i.notifySchemaChanged(e.$hx),200);r.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$ix=s("widget-close",O.$Vj.close,(0,E.localize)(2,null)),e.$jx=s("goto-previous-location",O.$Vj.arrowUp,(0,E.localize)(3,null)),e.$kx=s("goto-next-location",O.$Vj.arrowDown,(0,E.localize)(4,null)),e.$lx=N.ThemeIcon.modify(O.$Vj.sync,"spin"),e.$mx=N.ThemeIcon.modify(O.$Vj.loading,"spin")}),define(Se[211],Ie([1,0,5,2,50,3,12]),function(he,e,P,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tw=e.$sw=e.$pw=e.$nw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$jw=e.$iw=void 0,e.$kw=E,e.$lw=S,e.$mw=l,e.$ow=b,e.$qw=g,e.$rw=r,e.$iw=(0,N.$wi)("tunnelService"),e.$jw=(0,N.$wi)("sharedTunnelsService");var $;(function(n){n.Http="http",n.Https="https"})($||(e.TunnelProtocol=$={}));var m;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(m||(e.TunnelPrivacyId=m={}));function E(n){return!!n.forwardPort}var T;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(T||(e.ProvidedOnAutoForward=T={}));function S(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function l(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const c of i){const u=c.split("=")[1];if(/^https?:/.exec(u)){const t=S(O.URI.parse(u));if(t)return t}}}e.$nw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(n){return e.$nw.indexOf(n)>=0}e.$pw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(n){return e.$pw.indexOf(n)>=0}function r(n,i,c,u){if(c===1)return!1;if(c===2&&g(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class s{constructor(i,c,u){this.remoteAddress=i,this.localAddress=c,this.b=u,this.a=new P.$de,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$sw=s;let o=class{constructor(i,c){this.k=i,this.l=c,this.a=new P.$de,this.onTunnelOpened=this.a.event,this.b=new P.$de,this.onTunnelClosed=this.b.event,this.c=new P.$de,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],c=Array.from(this.e.values());for(const u of c){const t=Array.from(u.values());for(const d of t){const a=await d.value;a&&typeof a!="string"&&i.push(a)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:c}of i.values())await c.then(u=>typeof u!="string"?u?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,c,u,t,d){this.q(i,c,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:c,localAddress:u,privacy:t,protocol:d,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,c){(g(i)||b(i))&&(i=e.$nw[0]);const u=this.s(i,c);if(u)return++u.refcount,u.value}openTunnel(i,c,u,t,d,a=!1,f,w){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${u} on local port ${d}.`);const p=this.f??i;if(!p)return;if(c||(c="localhost"),t||(t=this.m),this.f&&this.j.has(u)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const v=this.t(p,c,u,t,d,a,f,w);return v?v.then(y=>{if(y){if(typeof y=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,u),y}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,u);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const h=this.o(y);return(y.tunnelRemoteHost!==c||y.tunnelRemotePort!==u)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),f&&y.privacy!==f&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(h),h}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const c=this.e.get(i.tunnelRemoteHost);if(c){const u=c.get(i.tunnelRemotePort);u&&(u.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,u))}}}}async p(i,c,u){if(u.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${c}.`);const t=u.value.then(async d=>{d&&typeof d!="string"&&(await d.dispose(!0),this.b.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(c),t}}async closeTunnel(i,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${c} `);const u=this.e.get(i);if(u&&u.has(c)){const t=u.get(c);t.refcount=0,await this.p(i,c,t)}}q(i,c,u){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(c,{refcount:1,value:u})}async r(i,c){const u=this.e.get(i);if(u){const t=u.get(c),d=t?await t.value:void 0;(!d||typeof d=="string")&&u.delete(c),u.size===0&&this.e.delete(i)}}s(i,c){const u=[i];b(i)?(u.push(...e.$nw),u.push(...e.$pw)):g(i)&&u.push(...e.$pw);const t=u.map(d=>this.e.get(d));for(const d of t){const a=d?.get(c);if(a)return a}}canTunnel(i){return!!S(i)}u(i,c,u,t,d,a,f){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${u} on local port ${t}.`);const w=u;this.j.add(w);const p=t===void 0?u:t,v={elevationRequired:d?this.isPortPrivileged(p):!1},y={remoteAddress:{host:c,port:u},localAddressPort:t,privacy:a,public:a?a!==m.Private:void 0,protocol:f},h=i.forwardPort(y,v);return h?(this.q(c,u,h),h.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(w)})):this.j.delete(w),h}};e.$tw=o,e.$tw=o=Ke([We(0,A.$3j),We(1,M.$3i)],o)}),define(Se[212],Ie([1,0,3]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=void 0,e.$Al=(0,P.$wi)("IUriIdentityService")}),define(Se[213],Ie([1,0,3]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$uw=void 0,e.$uw=(0,P.$wi)("editSessionIdentityService");var O;(function(M){M[M.Complete=100]="Complete",M[M.Partial=50]="Partial",M[M.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(Se[214],Ie([1,0,16]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ML=O,e.$NL=M,e.$OL=N,e.$PL=A,e.$QL=$;function O(m){return m.scheme!==P.Schemas.file&&m.scheme!==P.Schemas.vscodeRemote}function M(m){if(m.folders.length)return m.folders.every(E=>O(E.uri))?m.folders[0].uri:void 0;if(m.configuration&&O(m.configuration))return m.configuration}function N(m){return M(m)?.scheme}function A(m){return M(m)?.authority}function $(m){return M(m)!==void 0}}),define(Se[45],Ie([1,0,171,19,54,23,2,3,16]),function(he,e,P,O,M,N,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Qi=e.$Pi=e.WorkbenchState=e.$Ji=e.$Ii=e.$Fi=void 0,e.$Gi=E,e.$Hi=T,e.$Ki=S,e.$Li=l,e.$Mi=b,e.$Ni=r,e.$Oi=s,e.$Ri=i,e.$Wi=c,e.$Xi=u,e.$Zi=t,e.$1i=d,e.$2i=a,e.$Fi=(0,$.$wi)("contextService");function E(f){const w=f;return typeof w?.id=="string"&&A.URI.isUri(w.uri)}function T(f){return typeof f?.id=="string"&&!E(f)&&!l(f)}e.$Ii={id:"ext-dev"},e.$Ji={id:"empty-window"};function S(f,w){if(typeof f=="string"||typeof f>"u")return typeof f=="string"?{id:(0,O.$nc)(f)}:w?e.$Ii:e.$Ji;const p=f;return p.configuration?{id:p.id,configPath:p.configuration}:p.folders.length===1?{id:p.id,uri:p.folders[0].uri}:{id:p.id}}function l(f){const w=f;return typeof w?.id=="string"&&A.URI.isUri(w.configPath)}function b(f){const w=f;if(w?.uri)return{id:w.id,uri:A.URI.revive(w.uri)};const p=f;if(p?.configPath)return{id:p.id,configPath:A.URI.revive(p.configPath)};if(f?.id)return{id:f.id}}var g;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function r(f){const w=f;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}function s(f){const w=f;return!!(w&&typeof w=="object"&&A.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}class o{constructor(w,p,v,y,h){this.h=w,this.j=v,this.k=y,this.l=h,this.c=M.$Ci.forUris(this.l,()=>!0),this.folders=p}update(w){this.h=w.id,this.k=w.configuration,this.j=w.transient,this.l=w.l,this.folders=w.folders}get folders(){return this.g}set folders(w){this.g=w,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(w){this.k=w}getFolder(w){return w&&this.c.findSubstr(w)||null}n(){this.c=M.$Ci.forUris(this.l,()=>!0);for(const w of this.folders)this.c.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Pi=o;class n{constructor(w,p){this.raw=p,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,N.$0g)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Qi=n;function i(f){return new n({uri:f,index:0,name:(0,N.$6g)(f)},{uri:f.toString()})}e.$Si="code-workspace",e.$Ti=`.${e.$Si}`,e.$Ui=[{name:(0,P.localize)(0,null),extensions:[e.$Si]}],e.$Vi="workspace.json";function c(f,w){return N.$1g.isEqualOrParent(f,w.untitledWorkspacesHome)}function u(f){let w;return A.URI.isUri(f)?w=f:w=f.configuration,w?.scheme===m.Schemas.tmp}e.$Yi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(f){return f.id===e.$Yi}function d(f,w){return!c(f,w)&&!u(f)}function a(f){return(typeof f=="string"?(0,O.$oc)(f):(0,N.$8g)(f))===e.$Ti}}),define(Se[215],Ie([1,0,73,5,6,23,2,170,99,38,3,12,45,28,212,11,33,13,15]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g,r,s,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.$Cl=e.ProfileResourceType=void 0,e.$Bl=c,e.$Dl=u,e.$El=t;var i;(function(f){f.Settings="settings",f.Keybindings="keybindings",f.Snippets="snippets",f.Tasks="tasks",f.Extensions="extensions",f.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function c(f){const w=f;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&typeof w.isDefault=="boolean"&&typeof w.name=="string"&&A.URI.isUri(w.location)&&A.URI.isUri(w.globalStorageHome)&&A.URI.isUri(w.settingsResource)&&A.URI.isUri(w.keybindingsResource)&&A.URI.isUri(w.tasksResource)&&A.URI.isUri(w.snippetsHome)&&A.URI.isUri(w.extensionsResource))}e.$Cl=(0,T.$wi)("IUserDataProfilesService");function u(f,w){return{id:f.id,isDefault:f.isDefault,name:f.name,shortName:f.shortName,icon:f.icon,location:A.URI.revive(f.location).with({scheme:w}),globalStorageHome:A.URI.revive(f.globalStorageHome).with({scheme:w}),settingsResource:A.URI.revive(f.settingsResource).with({scheme:w}),keybindingsResource:A.URI.revive(f.keybindingsResource).with({scheme:w}),tasksResource:A.URI.revive(f.tasksResource).with({scheme:w}),snippetsHome:A.URI.revive(f.snippetsHome).with({scheme:w}),extensionsResource:A.URI.revive(f.extensionsResource).with({scheme:w}),cacheHome:A.URI.revive(f.cacheHome).with({scheme:w}),useDefaultFlags:f.useDefaultFlags,isTransient:f.isTransient}}function t(f,w,p,v,y,h){return{id:f,name:w,location:p,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:h&&y?.useDefaultFlags?.globalState?h.globalStorageHome:(0,N.$0g)(p,"globalStorage"),settingsResource:h&&y?.useDefaultFlags?.settings?h.settingsResource:(0,N.$0g)(p,"settings.json"),keybindingsResource:h&&y?.useDefaultFlags?.keybindings?h.keybindingsResource:(0,N.$0g)(p,"keybindings.json"),tasksResource:h&&y?.useDefaultFlags?.tasks?h.tasksResource:(0,N.$0g)(p,"tasks.json"),snippetsHome:h&&y?.useDefaultFlags?.snippets?h.snippetsHome:(0,N.$0g)(p,"snippets"),extensionsResource:h&&y?.useDefaultFlags?.extensions?h.extensionsResource:(0,N.$0g)(p,"extensions.json"),cacheHome:(0,N.$0g)(v,f),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let d=class extends M.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(w,p,v,y){super(),this.t=w,this.u=p,this.w=v,this.y=y,this.f=!0,this.h=this.B(new O.$de),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$de),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$de),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$de),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new b.$Ac,emptyWindows:new Map},this.profilesHome=(0,N.$0g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,N.$0g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(w){this.f!==w&&(this.z=void 0,this.f=w)}isEnabled(){return this.f}get C(){if(!this.z){const w=this.D(),p=[w];if(this.f)try{for(const h of this.O()){if(!h.name||!(0,n.$9f)(h.name)||!h.location){this.y.warn("Skipping the invalid stored profile",h.location||h.name);continue}p.push(t((0,N.$7g)(h.location),h.name,h.location,this.g,{shortName:h.shortName,icon:h.icon,useDefaultFlags:h.useDefaultFlags},w))}}catch(h){this.y.error(h)}const v=new b.$Ac,y=new Map;if(p.length)try{const h=this.Q();if(h.workspaces)for(const[D,k]of Object.entries(h.workspaces)){const C=A.URI.parse(D),I=p.find(W=>W.id===k);I&&v.set(C,I)}if(h.emptyWindows)for(const[D,k]of Object.entries(h.emptyWindows)){const C=p.find(I=>I.id===k);C&&y.set(D,C)}}catch(h){this.y.error(h)}this.z={profiles:p,workspaces:v,emptyWindows:y}}return this.z}D(){const w=t("__default__profile__",(0,$.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...w,extensionsResource:this.S()??w.extensionsResource,isDefault:!0}}async createTransientProfile(w){const p="Temp",v=new RegExp(`${(0,o.$_e)(p)}\\s(\\d+)`);let y=0;for(const D of this.profiles){const k=v.exec(D.name),C=k?parseInt(k[1]):0;y=C>y?C:y}const h=`${p} ${y+1}`;return this.createProfile((0,P.$kj)((0,s.$Sg)()).toString(16),h,{transient:!0},w)}async createNamedProfile(w,p,v){return this.createProfile((0,P.$kj)((0,s.$Sg)()).toString(16),w,p,v)}async createProfile(w,p,v,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=await this.F(w,p,v);return y&&await this.setProfileForWorkspace(y,h),h}async F(w,p,v){if(!(0,n.$9f)(p)||!p)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(p);return y||(y=(async()=>{try{if(this.profiles.find(C=>C.name===p||C.id===w))throw new Error(`Profile with ${p} name already exists`);const D=t(w,p,(0,N.$0g)(this.profilesHome,w),this.g,v,this.defaultProfile);await this.u.createFolder(D.location);const k=[];return this.j.fire({profile:D,join(C){k.push(C)}}),await r.Promises.settled(k),this.I([D],[],[]),D}finally{this.r.delete(p)}})(),this.r.set(p,y)),y}async updateProfile(w,p){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let v=this.profiles.find(y=>y.id===w.id);if(!v)throw new Error(`Profile '${w.name}' does not exist`);return v=t(v.id,p.name??v.name,v.location,this.g,{shortName:p.shortName??v.shortName,icon:p.icon===null?void 0:p.icon??v.icon,transient:p.transient??v.isTransient,useDefaultFlags:p.useDefaultFlags??v.useDefaultFlags},this.defaultProfile),this.I([],[],[v]),v}async removeProfile(w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(w.isDefault)throw new Error("Cannot remove default profile");const p=this.profiles.find(y=>y.id===w.id);if(!p)throw new Error(`Profile '${w.name}' does not exist`);const v=[];this.m.fire({profile:p,join(y){v.push(y)}});try{await Promise.allSettled(v)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])p.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])p.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[p],[]);try{await this.u.del(p.cacheHome,{recursive:!0})}catch(y){(0,E.$hl)(y)!==1&&this.y.error(y)}}async setProfileForWorkspace(w,p){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=this.profiles.find(y=>y.id===p.id);if(!v)throw new Error(`Profile '${p.name}' does not exist`);this.L(w,v)}unsetWorkspace(w,p){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(w,void 0,p)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const w=await this.u.resolve(this.profilesHome);await Promise.all((w.children||[]).filter(p=>p.isDirectory&&this.profiles.every(v=>!this.w.extUri.isEqual(v.location,p.resource))).map(p=>this.u.del(p.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const w=this.s.profiles.filter(p=>!this.H(p));await Promise.allSettled(w.map(p=>this.removeProfile(p)))}getProfileForWorkspace(w){const p=this.G(w);return A.URI.isUri(p)?this.s.workspaces.get(p)??this.C.workspaces.get(p):this.s.emptyWindows.get(p)??this.C.emptyWindows.get(p)}G(w){return(0,l.$Gi)(w)?w.uri:(0,l.$Li)(w)?w.configPath:w.id}H(w){return!!([...this.s.emptyWindows.values()].some(p=>this.w.extUri.isEqual(p.location,w.location))||[...this.s.workspaces.values()].some(p=>this.w.extUri.isEqual(p.location,w.location))||[...this.C.emptyWindows.values()].some(p=>this.w.extUri.isEqual(p.location,w.location))||[...this.C.workspaces.values()].some(p=>this.w.extUri.isEqual(p.location,w.location)))}I(w,p,v){const y=[...this.profiles,...w],h=[];this.s.profiles=[];for(let D of y)D.isDefault||p.some(k=>D.id===k.id)||(D=v.find(k=>D.id===k.id)??D,D.isTransient?this.s.profiles.push(D):h.push({location:D.location,name:D.name,shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags}));this.P(h),this.z=void 0,this.J(w,p,v)}J(w,p,v){this.h.fire({added:w,removed:p,updated:v,all:this.profiles})}L(w,p,v){v=p?.isTransient?!0:v,v||this.L(w,void 0,!0);const y=this.G(w),h=v?this.s:this.C;A.URI.isUri(y)?(h.workspaces.delete(y),p&&h.workspaces.set(y,p)):(h.emptyWindows.delete(y),p&&h.emptyWindows.set(y,p)),v||this.M()}M(){const w={};for(const[v,y]of this.C.workspaces.entries())w[v.toString()]=y.id;const p={};for(const[v,y]of this.C.emptyWindows.entries())p[v.toString()]=y.id;this.R({workspaces:w,emptyWindows:p}),this.z=void 0}N(w){const p={},v=this.D();if(w.workspaces)for(const[h,D]of Object.entries(w.workspaces)){const k=A.URI.parse(D);p[h]=this.w.extUri.isEqual(k,v.location)?v.id:this.w.extUri.basename(k)}const y={};if(w.emptyWindows)for(const[h,D]of Object.entries(w.emptyWindows)){const k=A.URI.parse(D);y[h]=this.w.extUri.isEqual(k,v.location)?v.id:this.w.extUri.basename(k)}return{workspaces:p,emptyWindows:y}}O(){return[]}P(w){throw new Error("not implemented")}Q(){return{}}R(w){throw new Error("not implemented")}S(){}};e.$Fl=d,e.$Fl=d=Ke([We(0,m.$Di),We(1,E.$3k),We(2,g.$Al),We(3,S.$3j)],d);class a extends d{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(w){this.a=w}Q(){return this.X}R(w){this.X=w}}e.$Gl=a}),define(Se[216],Ie([1,0,11,5,6,60,15,151,3,215]),function(he,e,P,O,M,N,A,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$3p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$1p=e.$Zp=e.$Yp=void 0,e.$2p=b,e.$4p=r,e.$6p=o,e.$Yp="__$__isNewStorageMarker",e.$Zp="__$__targetStorageMarker",e.$1p=(0,m.$wi)("storageService");var T;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(T||(e.WillSaveStateReason=T={}));var S;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var l;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})(l||(e.StorageTarget=l={}));function b(n){const i=n.get(e.$Zp);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class g extends M.$Uc{static{this.a=60*1e3}constructor(i={flushInterval:g.a}){super(),this.m=i,this.b=this.B(new O.$ge),this.c=this.B(new O.$ge),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$de),this.onWillSaveState=this.f.event,this.h=this.B(new P.$Ih(()=>this.n(),this.m.flushInterval)),this.j=this.B(new M.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,c,u){return O.Event.filter(this.b.event,t=>t.scope===i&&(c===void 0||t.key===c),u)}n(){this.j.value=(0,P.$Mh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,M.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.O()}finally{(0,N.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,c){const{key:u,external:t}=c;if(u===e.$Zp){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:u,target:this.J(i)[u],external:t})}w(i){this.f.fire({reason:i})}get(i,c,u){return this.P(c)?.get(i,u)}getBoolean(i,c,u){return this.P(c)?.getBoolean(i,u)}getNumber(i,c,u){return this.P(c)?.getNumber(i,u)}getObject(i,c,u){return this.P(c)?.getObject(i,u)}storeAll(i,c){this.y(()=>{for(const u of i)this.store(u.key,u.value,u.scope,u.target,c)})}store(i,c,u,t,d=!1){if((0,A.$fg)(c)){this.remove(i,u,d);return}this.y(()=>{this.z(i,u,t),this.P(u)?.set(i,c,d)})}remove(i,c,u=!1){this.y(()=>{this.z(i,c,void 0),this.P(c)?.delete(i,u)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,c){const u=[],t=this.J(i);for(const d of Object.keys(t))t[d]===c&&u.push(d);return u}z(i,c,u,t=!1){const d=this.J(c);typeof u=="number"?d[i]!==u&&(d[i]=u,this.P(c)?.set(e.$Zp,JSON.stringify(d),t)):typeof d[i]=="number"&&(delete d[i],this.P(c)?.set(e.$Zp,JSON.stringify(d),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const c=this.P(i);return c?b(c):Object.create(null)}isNew(i){return this.getBoolean(e.$Yp,i)===!0}async flush(i=T.NONE){this.f.fire({reason:i});const c=this.P(-1),u=this.P(0),t=this.P(1);switch(i){case T.NONE:await P.Promises.settled([c?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case T.SHUTDOWN:await P.Promises.settled([c?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,c=this.P(0)?.items??new Map,u=this.P(1)?.items??new Map;return o(i,c,u,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,c){return this.w(T.NONE),(0,E.$Bl)(i)?this.R(i,c):this.S(i,c)}M(i,c){return!(i.id===c.id||r(c)&&r(i))}N(i,c,u){this.y(()=>{const t=new Set;for(const[d,a]of i)t.add(d),c.get(d)!==a&&this.u(u,{key:d,external:!0});for(const[d]of c.items)t.has(d)||this.u(u,{key:d,external:!0})})}}e.$3p=g;function r(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class s extends g{constructor(){super(),this.U=this.B(new $.$Wp(new $.$Xp,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new $.$Wp(new $.$Xp,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new $.$Wp(new $.$Xp,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$5p=s;async function o(n,i,c,u,t,d){const a=C=>{try{return JSON.parse(C)}catch{return C}},f=new Map,w=new Map;n.forEach((C,I)=>{f.set(I,C),w.set(I,a(C))});const p=new Map,v=new Map;i.forEach((C,I)=>{p.set(I,C),v.set(I,a(C))});const y=new Map,h=new Map;c.forEach((C,I)=>{y.set(I,C),h.set(I,a(C))}),console.group(u!==t?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const D=[];if(f.forEach((C,I)=>{D.push({key:I,value:C})}),console.table(D),console.groupEnd(),console.log(w),u!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];p.forEach((I,W)=>{C.push({key:W,value:I})}),console.table(C),console.groupEnd(),console.log(v)}console.group(`Storage: Workspace (path: ${d})`);const k=[];y.forEach((C,I)=>{k.push({key:I,value:C})}),console.table(k),console.groupEnd(),console.log(h)}}),define(Se[76],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tlc=void 0;class P{static{this.a=!1}constructor(M){this.d=M,this.b=new Map,this.c=1}add(M){const N=this.c++;return this.b.set(N,M),this.e(),N}get(M,N){return this.b.has(M)?this.b.get(M)[N]:void 0}delete(M){this.b.delete(M),this.e()}e(){P.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$tlc=P}),define(Se[46],Ie([1,0,16,23,3]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=e.$ylc=void 0;class N{constructor(){this.a=new Set(Object.keys(P.Schemas)),this.b=new Map,this.extUri=new O.$Yg($=>{const m=this.b.get($.scheme);return!(m===void 0||m&1024)})}$acceptProviderInfos($,m){m===null?this.b.delete($.scheme):this.b.set($.scheme,m)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$ylc=N,e.$zlc=(0,M.$wi)("IExtHostFileSystemInfo")}),define(Se[27],Ie([1,0,3]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UO=void 0,e.$UO=(0,P.$wi)("IExtHostInitDataService")}),define(Se[217],Ie([1,0,176,12,201,27]),function(he,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Enc=void 0;let A=class extends M.$5P{constructor(m,E,T){const S=T.remote.isRemote?"remoteexthost":m?"workerexthost":"exthost",l=T.remote.isRemote?(0,P.localize)(0,null):m?(0,P.localize)(1,null):(0,P.localize)(2,null);super(E.createLogger(S,{name:l}))}};e.$Enc=A,e.$Enc=A=Ke([We(1,O.$4j),We(2,N.$UO)],A)}),define(Se[218],Ie([1,0,11]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fmc=e.$emc=void 0;class O{constructor(A,$,m){this.h=new Map,this.a=A,this.b=$,this.c=m,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new P.$Ih(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const T of E.values())T.complete()}catch(T){for(const S of E.values())S.error(T)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,$){let m=this.f[A];return typeof m>"u"&&(m=$),m}update(A,$){this.f[A]=$;const m=this.h.get(A);if(m!==void 0)return m.p;const E=new P.$Th;return this.h.set(A,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$emc=O;class M extends O{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,$){super(A.identifier.value,!0,$),this.j=A}}e.$fmc=M}),define(Se[219],Ie([1,0,5,2]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5mc=void 0;class M{constructor(A){this.c=A,this.a=new P.$de,this.onDidSaveNotebookDocument=this.a.event,this.b=new P.$de,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,$,m,E){const S=this.c.getNotebookDocument(O.URI.revive(A)).acceptModelChanged($.value,m,E);this.b.fire(S)}$acceptDirtyStateChanged(A,$){this.c.getNotebookDocument(O.URI.revive(A)).acceptDirty($)}$acceptModelSaved(A){const $=this.c.getNotebookDocument(O.URI.revive(A));this.a.fire($.apiNotebook)}}e.$5mc=M}),define(Se[17],Ie([1,0,3]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FO=e.$EO=void 0,e.$EO=(0,P.$wi)("IExtHostRpcService");class O{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.$FO=O}),define(Se[220],Ie([1,0,20,5]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$omc=void 0;class M{#e;constructor(A,$){this.b=new O.$de,this.onDidChange=this.b.event,this.a=P.$Rm.toKey(A.identifier),this.#e=$,this.#e.onDidChangePassword(m=>{m.extensionId===this.a&&this.b.fire({key:m.key})})}get(A){return this.#e.get(this.a,A)}store(A,$){return this.#e.store(this.a,A,$)}delete(A){return this.#e.delete(this.a,A)}}e.$omc=M}),define(Se[61],Ie([1,0,3]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Plc=e.$Olc=void 0,e.$Olc=(0,P.$wi)("IURITransformerService");class O{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Plc=O}),define(Se[221],Ie([1,0,21]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Orb=M,e.$Prb=A;class O{constructor(){this.buffers=[]}add(m){let E=this.buffers.indexOf(m);return E<0&&(E=this.buffers.length,this.buffers.push(m)),E}}function M($,m){if(m.serializeBuffersForPostMessage){const E=new O,S=JSON.stringify($,(b,g)=>{if(g instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(g)};if(ArrayBuffer.isView(g)){const r=N(g);if(r)return{$$vscode_array_buffer_reference$$:!0,index:E.add(g.buffer),view:{type:r,byteLength:g.byteLength,byteOffset:g.byteOffset}}}return g}),l=E.buffers.map(b=>{const g=new Uint8Array(b);return P.$Fe.wrap(g)});return{message:S,buffers:l}}else return{message:JSON.stringify($),buffers:[]}}function N($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A($,m){const E=m.map(l=>{const b=new ArrayBuffer(l.byteLength);return new Uint8Array(b).set(l.buffer),b}),T=m.length?(l,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const g=b,{index:r}=g,s=E[r];if(g.view)switch(g.view.type){case 1:return new Int8Array(s,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(s,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(s,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(s,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(s,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(s,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(s,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(s,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(s,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(s,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(s,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return s}return b}:void 0;return{message:JSON.parse($,T),arrayBuffers:E}}}),define(Se[106],Ie([1,0,185,15,2,6,3,29,38,16,44,145,32]),function(he,e,P,O,M,N,A,$,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$RF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$IF=e.EditorInputCapabilities=e.$HF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=void 0,e.$yF=r,e.$zF=s,e.$AF=o,e.$BF=n,e.$CF=i,e.$DF=c,e.$EF=u,e.$FF=t,e.$GF=d,e.$JF=y,e.$KF=D,e.$LF=k,e.$MF=C,e.$NF=I,e.$OF=W,e.$PF=V,e.$QF=ce,e.$SF=fe,e.$TF=Ne,e.$UF=ae,e.$VF=Re,e.$tF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$uF={id:"default",displayName:(0,P.localize)(0,null),providerDisplayName:(0,P.localize)(1,null)},e.$vF="workbench.editor.sidebysideEditor",e.$wF="workbench.editors.textDiffEditor",e.$xF="workbench.editors.binaryResourceDiffEditor";var b;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var g;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(g||(e.EditorPaneSelectionCompareResult=g={}));function r(ne){const z=ne;return!!z&&typeof z.getSelection=="function"&&!!z.onDidChangeSelection}function s(ne){const z=ne;return!!z&&typeof z.getScrollPosition=="function"&&typeof z.setScrollPosition=="function"&&!!z.onDidChangeScroll}function o(ne,z,x){for(const be of x.visibleEditorPanes)if(be.group.id===z&&ne.matches(be.input))return be.getViewState()}function n(ne){if(y(ne))return!1;const z=ne;return M.URI.isUri(z?.resource)}function i(ne){if(y(ne))return!1;const z=ne;return z?.original!==void 0&&z.modified!==void 0}function c(ne){if(y(ne))return!1;const z=ne;return!z||z.resources&&!Array.isArray(z.resources)?!1:!!z.resources||!!z.multiDiffSource}function u(ne){if(y(ne)||i(ne))return!1;const z=ne;return z?.primary!==void 0&&z.secondary!==void 0}function t(ne){if(y(ne))return!1;const z=ne;return z?z.resource===void 0||z.resource.scheme===E.Schemas.untitled||z.forceUntitled===!0:!1}function d(ne){if(y(ne))return!1;const z=ne;return M.URI.isUri(z?.base?.resource)&&M.URI.isUri(z?.input1?.resource)&&M.URI.isUri(z?.input2?.resource)&&M.URI.isUri(z?.result?.resource)}var a;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(a||(e.Verbosity=a={}));var f;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(f||(e.SaveReason=f={}));class w{constructor(){this.a=new Map}registerSource(z,x){let be=this.a.get(z);return be||(be={source:z,label:x},this.a.set(z,be)),be.source}getSourceLabel(z){return this.a.get(z)?.label??z}}e.$HF=new w;var p;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors",ne[ne.Scratchpad=512]="Scratchpad"})(p||(e.EditorInputCapabilities=p={}));class v extends N.$Uc{}e.$IF=v;function y(ne){return ne instanceof v}function h(ne){const z=ne;return M.URI.isUri(z?.preferredResource)}function D(ne){const z=ne;return y(z?.primary)&&y(z?.secondary)}function k(ne){const z=ne;return y(z?.modified)&&y(z?.original)}function C(ne,z,x,be,Te){return Re(be,[(0,S.$gj)({id:"workbench.action.openLargeFile",label:(0,P.localize)(2,null),run:()=>{const De={...x,limits:{size:Number.MAX_VALUE}};ne.openEditor(z,De)}}),(0,S.$gj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,P.localize)(3,null),run:()=>Te.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}function I(ne){return y(ne?.editor)}function W(ne){const z=ne;return I(ne)&&z?.group!==void 0}function V(ne){const z=ne;return typeof z?.groupId=="number"&&y(z.editor)}var q;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var R;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LABEL=2]="GROUP_LABEL",ne[ne.GROUP_LOCKED=3]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=4]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=5]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=6]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=8]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=10]="EDITOR_PIN",ne[ne.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ne[ne.EDITOR_STICKY=12]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=13]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(R||(e.GroupModelChangeKind=R={}));var B;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(B||(e.SideBySideEditor=B={}));class K{getOriginalUri(z,x){if(!z)return;if(d(z))return e.$RF.getOriginalUri(z.result,x);if(x?.supportSideBySide){const{primary:Te,secondary:De}=this.a(z);if(Te&&De){if(x?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(Te,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(De,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===B.ANY)return this.getOriginalUri(Te,{filterByScheme:x.filterByScheme})??this.getOriginalUri(De,{filterByScheme:x.filterByScheme});z=x.supportSideBySide===B.PRIMARY?Te:De}}if(i(z)||c(z)||u(z)||d(z))return;const be=h(z)?z.preferredResource:z.resource;return!be||!x||!x.filterByScheme?be:this.b(be,x.filterByScheme)}a(z){return D(z)||u(z)?{primary:z.primary,secondary:z.secondary}:k(z)||i(z)?{primary:z.modified,secondary:z.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(z,x){if(!z)return;if(d(z))return e.$RF.getCanonicalUri(z.result,x);if(x?.supportSideBySide){const{primary:Te,secondary:De}=this.a(z);if(Te&&De){if(x?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(Te,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(De,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===B.ANY)return this.getCanonicalUri(Te,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(De,{filterByScheme:x.filterByScheme});z=x.supportSideBySide===B.PRIMARY?Te:De}}if(i(z)||c(z)||u(z)||d(z))return;const be=z.resource;return!be||!x||!x.filterByScheme?be:this.b(be,x.filterByScheme)}b(z,x){if(Array.isArray(x)){if(x.some(be=>z.scheme===be))return z}else if(x===z.scheme)return z}}var ie;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.KEYBOARD=1]="KEYBOARD",ne[ne.MOUSE=2]="MOUSE"})(ie||(e.EditorCloseMethod=ie={}));function ce(ne,z,x,be){if(!ne.isSticky(z))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return x===ie.MOUSE||x===ie.KEYBOARD;case"mouse":return x===ie.MOUSE;case"keyboard":return x===ie.KEYBOARD}return!1}e.$RF=new K;var ve;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(ve||(e.CloseDirection=ve={}));class ke{constructor(){this.c=new Map,this.d=new Map}start(z){const x=this.a=z.get(A.$vi);for(const[be,Te]of this.c)this.e(be,Te,x);this.c.clear()}e(z,x,be){const Te=be.createInstance(x);this.d.set(z,Te)}registerFileEditorFactory(z){if(this.b)throw new Error("Can only register one file editor factory.");this.b=z}getFileEditorFactory(){return(0,O.$hg)(this.b)}registerEditorSerializer(z,x){if(this.c.has(z)||this.d.has(z))throw new Error(`A editor serializer with type ID '${z}' was already registered.`);return this.a?this.e(z,x,this.a):this.c.set(z,x),(0,N.$Sc)(()=>{this.c.delete(z),this.d.delete(z)})}getEditorSerializer(z){return this.d.get(typeof z=="string"?z:z.typeId)}}$.$co.add(e.$tF.EditorFactory,new ke);async function fe(ne,z,x){return!ne||!ne.length?[]:await Promise.all(ne.map(async be=>{const Te=M.URI.revive(be.fileUri);if(!Te){x.info("Cannot resolve the path because it is not valid.",be);return}if(!await z.canHandleResource(Te)){x.info("Cannot resolve the path because it cannot be handled",be);return}let we=be.exists,ge=be.type;if(typeof we!="boolean"||typeof ge!="number")try{ge=(await z.stat(Te)).isDirectory?m.FileType.Directory:m.FileType.Unknown,we=!0}catch(Y){x.error(Y),we=!1}if(!we&&be.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",be);return}if(ge===m.FileType.Directory){x.info("Cannot resolve the path because it is a directory",be);return}const Q={...be.options,pinned:!0};return we?{resource:Te,options:Q}:{resource:Te,options:Q,forceUntitled:!0}}))}var pe;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})(pe||(e.EditorsOrder=pe={}));function Ne(ne){const z=ne;if(!z)return!1;const x=z;if(x.modified)return Ne(x.modified);const be=z;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function ae(ne){return(0,T.$ij)(ne)}function Re(ne,z,x){const be=(0,T.$jj)(ne,z);return be.forceMessage=x?.forceMessage,be.forceSeverity=x?.forceSeverity,be.allowDialog=x?.allowDialog,be}}),define(Se[222],Ie([1,0,5,186,3,6,28,29,25,92,210]),function(he,e,P,O,M,N,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4F=e.$3F=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$2F=e.ViewContentGroups=e.$ZF=e.ViewContainerLocation=e.Extensions=e.$YF=e.$XF=e.$WF=void 0,e.$1F=b,e.$WF="views",e.$XF=(0,O.localize)(0,null),e.$YF=(0,T.$fx)("default-view-icon",E.$Vj.window,(0,O.localize)(1,null));var S;(function(t){t.ViewContainersRegistry="workbench.registry.view.containers",t.ViewsRegistry="workbench.registry.view"})(S||(e.Extensions=S={}));var l;(function(t){t[t.Sidebar=0]="Sidebar",t[t.Panel=1]="Panel",t[t.AuxiliaryBar=2]="AuxiliaryBar"})(l||(e.ViewContainerLocation=l={})),e.$ZF=[0,1,2];function b(t){switch(t){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class g extends N.$Uc{constructor(){super(...arguments),this.c=this.B(new P.$de),this.onDidRegister=this.c.event,this.f=this.B(new P.$de),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(d,a,f){const w=this.get(d.id);if(w)return w;const p=d;return p.openCommandActionDescriptor=f?.doNotRegisterOpenCommand?void 0:p.openCommandActionDescriptor??{id:p.id},(0,A.$xc)(this.g,a,[]).push(p),f?.isDefault&&this.h.push(p),this.c.fire({viewContainer:p,viewContainerLocation:a}),p}deregisterViewContainer(d){for(const a of this.g.keys()){const f=this.g.get(a),w=f?.indexOf(d);if(w!==-1){f?.splice(w,1),f.length===0&&this.g.delete(a),this.f.fire({viewContainer:d,viewContainerLocation:a});return}}}get(d){return this.all.filter(a=>a.id===d)[0]}getViewContainers(d){return[...this.g.get(d)||[]]}getViewContainerLocation(d){return[...this.g.keys()].filter(a=>this.getViewContainers(a).filter(f=>f?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.h.find(a=>this.getViewContainerLocation(a)===d)}}$.$co.add(S.ViewContainersRegistry,new g);var r;(function(t){t.Open="2_open",t.Debug="4_debug",t.SCM="5_scm",t.More="9_more"})(r||(e.ViewContentGroups=r={}));function s(t,d){const a=t.group??r.More,f=d.group??r.More;return a!==f?a.localeCompare(f):(t.order??5)-(d.order??5)}class o extends N.$Uc{constructor(){super(...arguments),this.c=this.B(new P.$de),this.onViewsRegistered=this.c.event,this.f=this.B(new P.$de),this.onViewsDeregistered=this.f.event,this.g=this.B(new P.$de),this.onDidChangeContainer=this.g.event,this.h=this.B(new P.$de),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Hc}registerViews(d,a){this.registerViews2([{views:d,viewContainer:a}])}registerViews2(d){d.forEach(({views:a,viewContainer:f})=>this.r(a,f)),this.c.fire(d)}deregisterViews(d,a){const f=this.s(d,a);f.length&&this.f.fire({views:f,viewContainer:a})}moveViews(d,a){for(const f of this.m.keys())if(f!==a){const w=this.s(d,f);w.length&&(this.r(w,a),this.g.fire({views:w,from:f,to:a}))}}getViews(d){return this.m.get(d)||[]}getView(d){for(const a of this.j){const f=(this.m.get(a)||[]).filter(w=>w.id===d)[0];if(f)return f}return null}getViewContainer(d){for(const a of this.j)if((this.m.get(a)||[]).filter(w=>w.id===d)[0])return a;return null}registerViewWelcomeContent(d,a){return this.n.add(d,a),this.h.fire(d),(0,N.$Sc)(()=>{this.n.delete(d,a),this.h.fire(d)})}registerViewWelcomeContent2(d,a){const f=new Map;for(const[w,p]of a)this.n.add(d,p),f.set(w,(0,N.$Sc)(()=>{this.n.delete(d,p),this.h.fire(d)}));return this.h.fire(d),f}getViewWelcomeContent(d){const a=[];return this.n.forEach(d,f=>a.push(f)),a.sort(s)}r(d,a){let f=this.m.get(a);f||(f=[],this.m.set(a,f),this.j.push(a));for(const w of d){if(this.getView(w.id)!==null)throw new Error((0,O.localize)(2,null,w.id));f.push(w)}}s(d,a){const f=this.m.get(a);if(!f)return[];const w=[],p=[];for(const v of f)d.includes(v)?w.push(v):p.push(v);return w.length&&(p.length?this.m.set(a,p):(this.m.delete(a),this.j.splice(this.j.indexOf(a),1))),w}}$.$co.add(S.ViewsRegistry,new o),e.$2F=(0,M.$wi)("viewDescriptorService");var n;(function(t){t[t.Default=0]="Default",t[t.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var i;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class c{constructor(d,a){this.c=!1,this.d=!1,(0,m.$6n)(this,d),this.d=!!a,this.resolve=async f=>{if(a&&!this.c){const w=await a(f);w&&(this.tooltip=this.tooltip??w.tooltip,this.command=this.command??w.command)}f.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$3F=c;class u extends Error{constructor(d){super((0,O.localize)(3,null,d)),this.name="NoTreeViewError"}static is(d){return d.name==="NoTreeViewError"}}e.$4F=u}),define(Se[223],Ie([1,0,187,31]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=void 0,e.$8F=new O.$Nj("chatSessionResponseVote","",{type:"string",description:(0,P.localize)(0,null)}),e.$9F=new O.$Nj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,P.localize)(1,null)}),e.$0F=new O.$Nj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,P.localize)(2,null)}),e.$$F=new O.$Nj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,P.localize)(3,null)}),e.$_F=new O.$Nj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,P.localize)(4,null)}),e.$aG=new O.$Nj("chatResponse",!1,{type:"boolean",description:(0,P.localize)(5,null)}),e.$bG=new O.$Nj("chatRequest",!1,{type:"boolean",description:(0,P.localize)(6,null)}),e.$cG=new O.$Nj("chatEditApplied",!1,{type:"boolean",description:(0,P.localize)(7,null)}),e.$dG=new O.$Nj("chatInputHasText",!1,{type:"boolean",description:(0,P.localize)(8,null)}),e.$eG=new O.$Nj("chatInputHasFocus",!1,{type:"boolean",description:(0,P.localize)(9,null)}),e.$fG=new O.$Nj("inChatInput",!1,{type:"boolean",description:(0,P.localize)(10,null)}),e.$gG=new O.$Nj("inChat",!1,{type:"boolean",description:(0,P.localize)(11,null)}),e.$hG=new O.$Nj("chatIsEnabled",!1,{type:"boolean",description:(0,P.localize)(12,null)}),e.$iG=new O.$Nj("chatCursorAtTop",!1),e.$jG=new O.$Nj("chatInputHasAgent",!1),e.$kG=new O.$Nj("chatLocation",void 0)}),define(Se[224],Ie([1,0,11,24,5,42,6,132,13,31,3,12,102,204,216,223]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g,r){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.ChatAgentLocation=void 0;var o;(function(u){u.Panel="panel",u.Terminal="terminal",u.Notebook="notebook",u.Editor="editor"})(o||(e.ChatAgentLocation=o={})),function(u){function t(d){switch(d){case"panel":return u.Panel;case"terminal":return u.Terminal;case"notebook":return u.Notebook;case"editor":return u.Editor}return u.Panel}u.fromRaw=t}(o||(e.ChatAgentLocation=o={})),e.$iH=(0,T.$wi)("chatAgentService");let n=class{static{this.AGENT_LEADER="@"}constructor(t){this.f=t,this.b=[],this.d=new M.$de,this.onDidChangeAgents=this.d.event,this.e=r.$hG.bindTo(this.f)}registerAgent(t,d){if(this.getAgent(t))throw new Error(`Agent already registered: ${JSON.stringify(t)}`);const f=this,w=d.slashCommands;d={...d,get slashCommands(){return w.filter(v=>!v.when||f.f.contextMatchesRules(E.$uj.deserialize(v.when)))}};const p={data:d};return this.b.push(p),(0,A.$Sc)(()=>{this.b=this.b.filter(v=>v!==p),this.d.fire(void 0)})}registerAgentImplementation(t,d){const a=this.g(t);if(!a)throw new Error(`Unknown agent: ${JSON.stringify(t)}`);if(a.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(t)}`);return a.data.isDefault&&this.e.set(!0),a.impl=d,this.d.fire(new i(a.data,d)),(0,A.$Sc)(()=>{a.impl=void 0,this.d.fire(void 0),a.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(t,d){t.isDynamic=!0;const a={data:t,impl:d};return this.b.push(a),this.d.fire(new i(t,d)),(0,A.$Sc)(()=>{this.b=this.b.filter(f=>f!==a),this.d.fire(void 0)})}updateAgent(t,d){const a=this.g(t);if(!a?.impl)throw new Error(`No activated agent with id ${JSON.stringify(t)} registered`);a.data.metadata={...a.data.metadata,...d},this.d.fire(new i(a.data,a.impl))}getDefaultAgent(t){return this.getActivatedAgents().find(d=>!!d.isDefault&&d.locations.includes(t))}getContributedDefaultAgent(t){return this.getAgents().find(d=>!!d.isDefault&&d.locations.includes(t))}getSecondaryAgent(){return N.Iterable.find(this.b.values(),t=>!!t.data.metadata.isSecondary)?.data}g(t){return this.b.find(d=>d.data.id===t)}getAgent(t){return this.g(t)?.data}getAgents(){return this.b.map(t=>t.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(t=>!!t.impl).map(t=>new i(t.data,t.impl))}getAgentsByName(t){return this.getAgents().filter(d=>d.name===t)}async invokeAgent(t,d,a,f,w){const p=this.g(t);if(!p?.impl)throw new Error(`No activated agent with id ${t}`);return await p.impl.invoke(d,a,f,w)}async getFollowups(t,d,a,f,w){const p=this.g(t);if(!p?.impl)throw new Error(`No activated agent with id ${t}`);return p.impl?.provideFollowups?p.impl.provideFollowups(d,a,f,w):[]}};e.$jH=n,e.$jH=n=Ke([We(0,E.$Oj)],n);class i{constructor(t,d){this.b=t,this.d=d}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(t,d,a,f){return this.d.invoke(t,d,a,f)}async provideFollowups(t,d,a,f){return this.d.provideFollowups?this.d.provideFollowups(t,d,a,f):[]}provideWelcomeMessage(t,d){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(t,d)}provideSampleQuestions(t,d){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(t,d)}}e.$kH=i,e.$lH=(0,T.$wi)("chatAgentNameService");let c=class{static{s=this}static{this.b="chat.participantNameRegistry"}constructor(t,d,a,f){if(this.g=d,this.h=a,this.i=f,this.e=(0,$.$1d)(this,Object.create(null)),this.f=!1,!t.chatParticipantRegistry)return;this.d=t.chatParticipantRegistry;const w=f.get(s.b,-1);try{this.e.set(JSON.parse(w??"{}"),void 0)}catch{f.remove(s.b,-1)}this.j()}j(){this.f||this.k().catch(t=>this.h.warn("Failed to fetch chat participant registry",t)).then(()=>(0,P.$xh)(5*60*1e3)).then(()=>this.j())}async k(){const t=await this.g.request({type:"GET",url:this.d},O.CancellationToken.None);if(t.res.statusCode!==200)throw new Error("Could not get extensions report.");const d=await(0,b.$Tp)(t);if(!d||d.version!==1)throw new Error("Unexpected chat participant registry response.");const a=d.restrictedChatParticipants;this.e.set(a,void 0),this.i.store(s.b,JSON.stringify(a),-1,1)}getAgentNameRestriction(t){return this.e.map(a=>a[t.name.toLowerCase()]).map(a=>a?a.some(f=>(0,m.$xf)(f,f.includes(".")?t.extensionId.value:t.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$mH=c,e.$mH=c=s=Ke([We(0,l.$jk),We(1,b.$Np),We(2,S.$3j),We(3,g.$1p)],c)}),define(Se[225],Ie([1,0,2,30,3]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sG=e.$rG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$pG=N,e.$qG=A;function N(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof P.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(O.$ut.isIRange)}function A(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(N)}var $;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})($||(e.InteractiveSessionVoteDirection=$={}));var m;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(m||(e.ChatCopyKind=m={})),e.$rG=(0,M.$wi)("IChatService"),e.$sG="accessibility.voice.keywordActivation"}),define(Se[226],Ie([1,0,5,11,188]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2rb=void 0;class N{constructor(){this.f=new Map,this.m=[],this.n=new P.$de,this.o=new P.$de,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage($){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=$}onEvent($){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=$}onRequest($){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.u("response",$)}sendRequest($,m,E,T){const S={command:$};if(m&&Object.keys(m).length>0&&(S.arguments=m),this.u("request",S),typeof T=="number"){const l=setTimeout(()=>{clearTimeout(l);const b=this.f.get(S.seq);if(b){this.f.delete(S.seq);const g={type:"response",seq:0,request_seq:S.seq,success:!1,command:$,message:(0,M.localize)(0,null,T,$)};b(g)}},T)}return E&&this.f.set(S.seq,E),S.seq}acceptMessage($){this.k?this.k($):(this.m.push($),this.m.length===1&&this.s())}q($,m){return $.type!=="event"||m.type!=="event"}async s(){let $;for(;this.m.length;){if((!$||this.q(this.m[0],$))&&await(0,O.$xh)(0),$=this.m.shift(),!$)return;switch($.type){case"event":this.j?.($);break;case"request":this.g?.($);break;case"response":{const m=$,E=this.f.get(m.request_seq);E&&(this.f.delete(m.request_seq),E(m));break}}}}u($,m){m.type=$,m.seq=this.d++,this.sendMessage(m)}async w(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((m,E)=>$.set(E,m)),await(0,O.$xh)(500),$.forEach((m,E)=>{m({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$2rb=N}),define(Se[227],Ie([1,0,2,189,31,3]),function(he,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$CJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$AJ=e.MemoryRangeType=e.State=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=void 0,e.$zJ=m,e.$BJ=T,e.$nI="workbench.view.debug",e.$oI="workbench.debug.variablesView",e.$pI="workbench.debug.watchExpressionsView",e.$qI="workbench.debug.callStackView",e.$rI="workbench.debug.loadedScriptsView",e.$sI="workbench.debug.breakPointsView",e.$tI="workbench.debug.disassemblyView",e.$uI="workbench.panel.repl",e.$vI="workbench.panel.repl.view",e.$wI=new M.$Nj("debugType",void 0,{type:"string",description:O.localize(0,null)}),e.$xI=new M.$Nj("debugConfigurationType",void 0,{type:"string",description:O.localize(1,null)}),e.$yI=new M.$Nj("debugState","inactive",{type:"string",description:O.localize(2,null)}),e.$zI="debugUx",e.$AI=new M.$Nj(e.$zI,"default",{type:"string",description:O.localize(3,null)}),e.$BI=new M.$Nj("hasDebugged",!1,{type:"boolean",description:O.localize(4,null)}),e.$CI=new M.$Nj("inDebugMode",!1,{type:"boolean",description:O.localize(5,null)}),e.$DI=new M.$Nj("inDebugRepl",!1,{type:"boolean",description:O.localize(6,null)}),e.$EI=new M.$Nj("breakpointWidgetVisible",!1,{type:"boolean",description:O.localize(7,null)}),e.$FI=new M.$Nj("inBreakpointWidget",!1,{type:"boolean",description:O.localize(8,null)}),e.$GI=new M.$Nj("breakpointsFocused",!0,{type:"boolean",description:O.localize(9,null)}),e.$HI=new M.$Nj("watchExpressionsFocused",!0,{type:"boolean",description:O.localize(10,null)}),e.$II=new M.$Nj("watchExpressionsExist",!1,{type:"boolean",description:O.localize(11,null)}),e.$JI=new M.$Nj("variablesFocused",!0,{type:"boolean",description:O.localize(12,null)}),e.$KI=new M.$Nj("expressionSelected",!1,{type:"boolean",description:O.localize(13,null)}),e.$LI=new M.$Nj("breakpointInputFocused",!1,{type:"boolean",description:O.localize(14,null)}),e.$MI=new M.$Nj("callStackItemType",void 0,{type:"string",description:O.localize(15,null)}),e.$NI=new M.$Nj("callStackSessionIsAttach",!1,{type:"boolean",description:O.localize(16,null)}),e.$OI=new M.$Nj("callStackItemStopped",!1,{type:"boolean",description:O.localize(17,null)}),e.$PI=new M.$Nj("callStackSessionHasOneThread",!1,{type:"boolean",description:O.localize(18,null)}),e.$QI=new M.$Nj("watchItemType",void 0,{type:"string",description:O.localize(19,null)}),e.$RI=new M.$Nj("canViewMemory",void 0,{type:"boolean",description:O.localize(20,null)}),e.$SI=new M.$Nj("breakpointItemType",void 0,{type:"string",description:O.localize(21,null)}),e.$TI=new M.$Nj("breakpointItemBytes",void 0,{type:"boolean",description:O.localize(22,null)}),e.$UI=new M.$Nj("breakpointHasModes",!1,{type:"boolean",description:O.localize(23,null)}),e.$VI=new M.$Nj("breakpointSupportsCondition",!1,{type:"boolean",description:O.localize(24,null)}),e.$WI=new M.$Nj("loadedScriptsSupported",!1,{type:"boolean",description:O.localize(25,null)}),e.$XI=new M.$Nj("loadedScriptsItemType",void 0,{type:"string",description:O.localize(26,null)}),e.$YI=new M.$Nj("focusedSessionIsAttach",!1,{type:"boolean",description:O.localize(27,null)}),e.$ZI=new M.$Nj("focusedSessionIsNoDebug",!1,{type:"boolean",description:O.localize(28,null)}),e.$1I=new M.$Nj("stepBackSupported",!1,{type:"boolean",description:O.localize(29,null)}),e.$2I=new M.$Nj("restartFrameSupported",!1,{type:"boolean",description:O.localize(30,null)}),e.$3I=new M.$Nj("stackFrameSupportsRestart",!1,{type:"boolean",description:O.localize(31,null)}),e.$4I=new M.$Nj("jumpToCursorSupported",!1,{type:"boolean",description:O.localize(32,null)}),e.$5I=new M.$Nj("stepIntoTargetsSupported",!1,{type:"boolean",description:O.localize(33,null)}),e.$6I=new M.$Nj("breakpointsExist",!1,{type:"boolean",description:O.localize(34,null)}),e.$7I=new M.$Nj("debuggersAvailable",!1,{type:"boolean",description:O.localize(35,null)}),e.$8I=new M.$Nj("debugExtensionAvailable",!0,{type:"boolean",description:O.localize(36,null)}),e.$9I=new M.$Nj("debugProtocolVariableMenuContext",void 0,{type:"string",description:O.localize(37,null)}),e.$0I=new M.$Nj("debugSetVariableSupported",!1,{type:"boolean",description:O.localize(38,null)}),e.$$I=new M.$Nj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:O.localize(39,null)}),e.$_I=new M.$Nj("debugSetExpressionSupported",!1,{type:"boolean",description:O.localize(40,null)}),e.$aJ=new M.$Nj("breakWhenValueChangesSupported",!1,{type:"boolean",description:O.localize(41,null)}),e.$bJ=new M.$Nj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:O.localize(42,null)}),e.$cJ=new M.$Nj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:O.localize(43,null)}),e.$dJ=new M.$Nj("terminateDebuggeeSupported",!1,{type:"boolean",description:O.localize(44,null)}),e.$eJ=new M.$Nj("suspendDebuggeeSupported",!1,{type:"boolean",description:O.localize(45,null)}),e.$fJ=new M.$Nj("variableEvaluateNamePresent",!1,{type:"boolean",description:O.localize(46,null)}),e.$gJ=new M.$Nj("variableIsReadonly",!1,{type:"boolean",description:O.localize(47,null)}),e.$hJ=new M.$Nj("variableValue",!1,{type:"string",description:O.localize(48,null)}),e.$iJ=new M.$Nj("variableType",!1,{type:"string",description:O.localize(49,null)}),e.$jJ=new M.$Nj("variableInterfaces",!1,{type:"array",description:O.localize(50,null)}),e.$kJ=new M.$Nj("variableName",!1,{type:"string",description:O.localize(51,null)}),e.$lJ=new M.$Nj("variableLanguage",!1,{type:"string",description:O.localize(52,null)}),e.$mJ=new M.$Nj("variableExtensionId",!1,{type:"string",description:O.localize(53,null)}),e.$nJ=new M.$Nj("exceptionWidgetVisible",!1,{type:"boolean",description:O.localize(54,null)}),e.$oJ=new M.$Nj("multiSessionRepl",!1,{type:"boolean",description:O.localize(55,null)}),e.$pJ=new M.$Nj("multiSessionDebug",!1,{type:"boolean",description:O.localize(56,null)}),e.$qJ=new M.$Nj("disassembleRequestSupported",!1,{type:"boolean",description:O.localize(57,null)}),e.$rJ=new M.$Nj("disassemblyViewFocus",!1,{type:"boolean",description:O.localize(58,null)}),e.$sJ=new M.$Nj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:O.localize(59,null)}),e.$tJ=new M.$Nj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:O.localize(60,null)});const A=i=>O.localize(61,null,i);e.$uJ=A,e.$vJ="editor.contrib.debug",e.$wJ="editor.contrib.breakpoint",e.$xJ="debug",e.$yJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:O.localize(62,null)};var $;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})($||(e.State=$={}));function m(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var E;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$AJ="vscode-debug-memory";function T(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var S;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(S||(e.DataBreakpointSetType=S={}));var l;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(l||(e.DebugConfigurationProviderTriggerKind=l={}));var b;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(b||(e.DebuggerString=b={})),e.$CJ=(0,N.$wi)("debugService");var g;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(g||(e.BreakpointWidgetContext=g={}));var r;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var s;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(s||(e.DebugTreeItemCollapsibleState=s={}));var o;(function(i){i.deserialize=c=>c,i.serialize=c=>c})(o||(e.IDebugVisualizationTreeItem=o={}));var n;(function(i){i.deserialize=c=>({id:c.id,name:c.name,iconPath:c.iconPath&&{light:P.URI.revive(c.iconPath.light),dark:P.URI.revive(c.iconPath.dark)},iconClass:c.iconClass,visualization:c.visualization}),i.serialize=c=>c})(n||(e.IDebugVisualization=n={}))}),define(Se[228],Ie([1,0,13,2,19,25,16,30,24,18]),function(he,e,P,O,M,N,A,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BH=void 0,e.$pH=S,e.$qH=l,e.$rH=b,e.$sH=g,e.$tH=r,e.$uH=s,e.$vH=o,e.$wH=i,e.$xH=t,e.$yH=d,e.$zH=f,e.$AH=p;const T=/{([^}]+)}/g;function S(y,h,D){return y.replace(T,function(k,C){return h&&C.length>0&&C[0]!=="_"?k:D&&D.hasOwnProperty(C)?D[C]:k})}function l(y){const h={};for(const D of Object.keys(y))D.startsWith("!")||(h[D]=y[D]);return h}function b(y){return y.configuration.request==="attach"&&!g(y)&&(!y.parentSession||b(y.parentSession))}function g(y){let h=y.configuration.type;if(h)return h==="vslsShare"&&(h=y.configuration.adapterProxy.configuration.type),(0,P.$xf)(h,"extensionhost")||(0,P.$xf)(h,"pwa-extensionhost")?y:y.parentSession?g(y.parentSession):void 0}function r(y){return y.type&&(y.label||y.program||y.runtime)}function s(y,h,D){let k,C=0;const I=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let W=null;for(;W=I.exec(y);){const V=W.index+1,q=V+W[0].length;if(V<=h&&q>=D){k=W[0],C=V;break}}if(k){const V=/\w+/g;let q=null;for(;(q=V.exec(k))&&!(q.index+1+C+q[0].length>=D););q&&(k=k.substring(0,V.lastIndex))}return k?{start:C,end:C+k.length-1}:{start:0,end:0}}async function o(y,h,D,k){if(y.evaluatableExpressionProvider.has(h)){const C=y.evaluatableExpressionProvider.ordered(h),I=(0,E.$Hb)(await Promise.all(C.map(async W=>{try{return await W.provideEvaluatableExpression(h,D,k??m.CancellationToken.None)}catch{return}})));if(I.length>0){let W=I[0].expression;const V=I[0].range;return W||(W=h.getLineContent(D.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:W}}}else{const C=h.getLineContent(D.lineNumber),{start:I,end:W}=s(C,D.column,D.column),V=C.substring(I-1,W);return{matchingExpression:V,range:new $.$ut(D.lineNumber,I,D.lineNumber,I+V.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(y){return!!(y&&y.match(n))}function c(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(i(y.path))return O.URI.parse(y.path);if((0,M.$ic)(y.path))return O.URI.file(y.path)}return y.path}function u(y){if(typeof y.path=="object"){const h=O.URI.revive(y.path);if(h)return h.scheme===A.Schemas.file?h.fsPath:h.toString()}return y.path}function t(y,h){const D=h?c:u,k=(0,N.$3n)(y);return a(k,(C,I)=>{C&&I&&(I.path=D(I))}),k}function d(y,h){const D=h?c:u,k=(0,N.$3n)(y);return a(k,(C,I)=>{!C&&I&&(I.path=D(I))}),k}function a(y,h){switch(y.type){case"event":{const D=y;switch(D.event){case"output":h(!1,D.body.source);break;case"loadedSource":h(!1,D.body.source);break;case"breakpoint":h(!1,D.body.breakpoint.source);break;default:break}break}case"request":{const D=y;switch(D.command){case"setBreakpoints":h(!0,D.arguments.source);break;case"breakpointLocations":h(!0,D.arguments.source);break;case"source":h(!0,D.arguments.source);break;case"gotoTargets":h(!0,D.arguments.source);break;case"launchVSCode":D.arguments.args.forEach(k=>h(!1,k));break;default:break}break}case"response":{const D=y;if(D.success&&D.body)switch(D.command){case"stackTrace":D.body.stackFrames.forEach(k=>h(!1,k.source));break;case"loadedSources":D.body.sources.forEach(k=>h(!1,k));break;case"scopes":D.body.scopes.forEach(k=>h(!1,k.source));break;case"setFunctionBreakpoints":D.body.breakpoints.forEach(k=>h(!1,k.source));break;case"setBreakpoints":D.body.breakpoints.forEach(k=>h(!1,k.source));break;case"disassemble":D.body?.instructions.forEach(C=>h(!1,C.location));break;default:break}break}}}function f(y){return y.filter(h=>!h.presentation?.hidden).sort((h,D)=>h.presentation?D.presentation?h.presentation.group?D.presentation.group?h.presentation.group!==D.presentation.group?h.presentation.group.localeCompare(D.presentation.group):w(h.presentation.order,D.presentation.order):-1:D.presentation.group?1:w(h.presentation.order,D.presentation.order):-1:D.presentation?1:0)}function w(y,h){return typeof y!="number"?typeof h!="number"?0:1:typeof h!="number"?-1:y-h}async function p(y,h){const D=y.getValue("debug.saveBeforeStart",{overrideIdentifier:h.activeTextEditorLanguageId});if(D!=="none"&&(await h.saveAll(),D==="allEditorsInActiveGroup")){const k=h.activeEditorPane;k&&k.input.resource?.scheme===A.Schemas.untitled&&await h.save({editor:k.input,groupId:k.group.id})}await y.reloadConfiguration()}const v=(y,h)=>!y||!h?y===h:y.name===h.name&&y.path===h.path&&y.sourceReference===h.sourceReference;e.$BH=v}),define(Se[229],Ie([1,0,3]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UJ=e.CellExecutionUpdateType=void 0;var O;(function(M){M[M.Output=1]="Output",M[M.OutputItems=2]="OutputItems",M[M.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.$UJ=(0,P.$wi)("INotebookExecutionService")}),define(Se[230],Ie([1,0,3]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cib=e.$Bib=e.ProxyKernelState=e.$Aib=void 0,e.$Aib=100;var O;(function(M){M[M.Disconnected=1]="Disconnected",M[M.Connected=2]="Connected",M[M.Initializing=3]="Initializing"})(O||(e.ProxyKernelState=O={})),e.$Bib=(0,P.$wi)("INotebookKernelService"),e.$Cib=(0,P.$wi)("INotebookKernelHistoryService")}),define(Se[231],Ie([1,0,6,30,156,96]),function(he,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yXb=void 0;class A extends P.$Uc{constructor(m,E,T){super(),this._source=m,this.b=E,this.c=T,this.a=void 0}f(m){const E=m.getLineCount();return new O.$ut(1,1,E,this.g(m,E))}g(m,E){if(E<1||E>m.getLineCount())throw new Error("Illegal value for lineNumber");return m.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const m=new M.$2C;m.acceptChunk(this._source);const E=m.finish(!0),{textBuffer:T,disposable:S}=E.create(1);this.b=T,this.B(S)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(m=>{const E=new M.$2C;E.acceptChunk(m);const T=E.finish(!0),{textBuffer:S,disposable:l}=T.create(1);return this.B(l),S})),this.a}findInInputs(m){const T=new N.$PC(m,!1,!1,null).parseSearchRequest();if(!T)return[];const S=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(S,T,!0,5e3)}findInOutputs(m){const T=new N.$PC(m,!1,!1,null).parseSearchRequest();return T?this.outputTextBuffers.map(S=>{const l=S.findMatchesLineByLine(this.f(S),T,!0,5e3);if(l.length!==0)return{textBuffer:S,matches:l}}).filter(S=>!!S):[]}}e.$yXb=A}),define(Se[52],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2K=e.TestPosition=e.TestIdPathParts=void 0;var P;(function(N){N.Delimiter="\0"})(P||(e.TestIdPathParts=P={}));var O;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class M{static fromExtHostTestItem(A,$,m=A.parent){if(A._isRoot)return new M([$]);const E=[A.id];for(let T=m;T&&T.id!==$;T=T.parent)E.push(T.id);return E.push($),new M(E.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const $=A.indexOf("\0");return $===-1?A:A.slice(0,$)}static fromString(A){return new M(A.split("\0"))}static join(A,$){return new M([...A.path,$])}static joinToString(A,$){return A.toString()+"\0"+$}static parentId(A){const $=A.lastIndexOf("\0");return $===-1?void 0:A.slice(0,$)}static localId(A){const $=A.lastIndexOf("\0");return $===-1?A:A.slice($+1)}static isChild(A,$){return $.startsWith(A)&&$[A.length]==="\0"}static compare(A,$){return A===$?0:M.isChild(A,$)?2:M.isChild($,A)?3:1}constructor(A,$=A.length){if(this.path=A,this.d=$,A.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new M(this.path,1)}get parentId(){return this.d>1?new M(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new M(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new M(this.path,A)}compare(A){if(typeof A=="string")return M.compare(this.toString(),A);for(let $=0;$<A.d&&$<this.d;$++)if(A.path[$]!==this.path[$])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$2K=M}),define(Se[62],Ie([1,0,2,94,30,52]),function(he,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$K=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$0K=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$9K=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$8K=e.$7K=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$6K=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$5K=e.$4K=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$3K=e.TestResultState=void 0;var A;(function(R){R[R.Unset=0]="Unset",R[R.Queued=1]="Queued",R[R.Running=2]="Running",R[R.Passed=3]="Passed",R[R.Failed=4]="Failed",R[R.Skipped=5]="Skipped",R[R.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$3K={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var $;(function(R){R[R.Run=1]="Run",R[R.Debug=2]="Debug",R[R.Coverage=3]="Coverage"})($||(e.ExtTestRunProfileKind=$={}));var m;(function(R){R[R.Run=2]="Run",R[R.Debug=4]="Debug",R[R.Coverage=8]="Coverage",R[R.HasNonDefaultProfile=16]="HasNonDefaultProfile",R[R.HasConfigurable=32]="HasConfigurable",R[R.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.$4K=[2,4,8,16,32,64];const E=R=>"runId"in R;e.$5K=E;var T;(function(R){R.serialize=B=>({range:B.range.toJSON(),uri:B.uri.toJSON()}),R.deserialize=(B,K)=>({range:M.$ut.lift(K.range),uri:B.asCanonicalUri(P.URI.revive(K.uri))})})(T||(e.IRichLocation=T={}));var S;(function(R){R[R.Error=0]="Error",R[R.Output=1]="Output"})(S||(e.TestMessageType=S={}));var l;(function(R){R.serialize=B=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&T.serialize(B.location)}),R.deserialize=(B,K)=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&T.deserialize(B,K.location)})})(l||(e.ITestErrorMessage=l={}));const b=(R,B)=>`${B?"s":"e"}${R}`;e.$6K=b;var g;(function(R){R.serialize=B=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&T.serialize(B.location)}),R.deserialize=(B,K)=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&T.deserialize(B,K.location)})})(g||(e.ITestOutputMessage=g={}));var r;(function(R){R.serialize=B=>B.type===0?l.serialize(B):g.serialize(B),R.deserialize=(B,K)=>K.type===0?l.deserialize(B,K):g.deserialize(B,K)})(r||(e.ITestMessage=r={}));var s;(function(R){R.serializeWithoutMessages=B=>({state:B.state,duration:B.duration,messages:[]}),R.serialize=B=>({state:B.state,duration:B.duration,messages:B.messages.map(r.serialize)}),R.deserialize=(B,K)=>({state:K.state,duration:K.duration,messages:K.messages.map(ie=>r.deserialize(B,ie))})})(s||(e.ITestTaskState=s={}));const o="\0",n=(R,B)=>R+o+B;e.$7K=n;const i=R=>{const B=R.indexOf(o);return{ctrlId:R.slice(0,B),tagId:R.slice(B+1)}};e.$8K=i;var c;(function(R){R.serialize=B=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?.toJSON(),range:B.range?.toJSON()||null,description:B.description,error:B.error,sortText:B.sortText}),R.deserialize=(B,K)=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?B.asCanonicalUri(P.URI.revive(K.uri)):void 0,range:K.range?M.$ut.lift(K.range):null,description:K.description,error:K.error,sortText:K.sortText})})(c||(e.ITestItem=c={}));var u;(function(R){R[R.NotExpandable=0]="NotExpandable",R[R.Expandable=1]="Expandable",R[R.BusyExpanding=2]="BusyExpanding",R[R.Expanded=3]="Expanded"})(u||(e.TestItemExpandState=u={}));var t;(function(R){R.serialize=B=>({expand:B.expand,item:c.serialize(B.item)}),R.deserialize=(B,K)=>({controllerId:N.$2K.root(K.item.extId),expand:K.expand,item:c.deserialize(B,K.item)})})(t||(e.InternalTestItem=t={}));var d;(function(R){R.serialize=B=>{let K;return B.item&&(K={},B.item.label!==void 0&&(K.label=B.item.label),B.item.tags!==void 0&&(K.tags=B.item.tags),B.item.busy!==void 0&&(K.busy=B.item.busy),B.item.uri!==void 0&&(K.uri=B.item.uri?.toJSON()),B.item.range!==void 0&&(K.range=B.item.range?.toJSON()),B.item.description!==void 0&&(K.description=B.item.description),B.item.error!==void 0&&(K.error=B.item.error),B.item.sortText!==void 0&&(K.sortText=B.item.sortText)),{extId:B.extId,expand:B.expand,item:K}},R.deserialize=B=>{let K;return B.item&&(K={},B.item.label!==void 0&&(K.label=B.item.label),B.item.tags!==void 0&&(K.tags=B.item.tags),B.item.busy!==void 0&&(K.busy=B.item.busy),B.item.range!==void 0&&(K.range=B.item.range?M.$ut.lift(B.item.range):null),B.item.description!==void 0&&(K.description=B.item.description),B.item.error!==void 0&&(K.error=B.item.error),B.item.sortText!==void 0&&(K.sortText=B.item.sortText)),{extId:B.extId,expand:B.expand,item:K}}})(d||(e.ITestItemUpdate=d={}));const a=(R,B)=>{B.expand!==void 0&&(R.expand=B.expand),B.item!==void 0&&(R.item=R.item?Object.assign(R.item,B.item):B.item)};e.$9K=a;var f;(function(R){R.serializeWithoutMessages=B=>({...t.serialize(B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(s.serializeWithoutMessages)}),R.serialize=B=>({...t.serialize(B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(s.serialize)}),R.deserialize=(B,K)=>({...t.deserialize(B,K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(ie=>s.deserialize(B,ie)),retired:!0})})(f||(e.TestResultItem=f={}));var w;(function(R){R.empty=()=>({covered:0,total:0}),R.sum=(B,K)=>{B.covered+=K.covered,B.total+=K.total}})(w||(e.ICoverageCount=w={}));var p;(function(R){R.serialize=B=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,uri:B.uri.toJSON()}),R.deserialize=(B,K)=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,uri:B.asCanonicalUri(P.URI.revive(K.uri))})})(p||(e.IFileCoverage=p={}));function v(R){return{...R,location:R.location?.toJSON()}}function y(R){return R.location=R.location?O.$tt.isIPosition(R.location)?O.$tt.lift(R.location):M.$ut.lift(R.location):void 0,R}e.$0K=3;var h;(function(R){R[R.Declaration=0]="Declaration",R[R.Statement=1]="Statement",R[R.Branch=2]="Branch"})(h||(e.DetailType=h={}));var D;(function(R){R.serialize=B=>B.type===0?C.serialize(B):I.serialize(B),R.deserialize=B=>B.type===0?C.deserialize(B):I.deserialize(B)})(D||(e.CoverageDetails=D={}));var k;(function(R){R.serialize=v,R.deserialize=y})(k||(e.IBranchCoverage=k={}));var C;(function(R){R.serialize=v,R.deserialize=y})(C||(e.IDeclarationCoverage=C={}));var I;(function(R){R.serialize=B=>({...v(B),branches:B.branches?.map(k.serialize)}),R.deserialize=B=>({...y(B),branches:B.branches?.map(k.deserialize)})})(I||(e.IStatementCoverage=I={}));var W;(function(R){R[R.Add=0]="Add",R[R.Update=1]="Update",R[R.DocumentSynced=2]="DocumentSynced",R[R.Remove=3]="Remove",R[R.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",R[R.Retire=5]="Retire",R[R.AddTag=6]="AddTag",R[R.RemoveTag=7]="RemoveTag"})(W||(e.TestDiffOpType=W={}));var V;(function(R){R.deserialize=(B,K)=>K.op===0?{op:K.op,item:t.deserialize(B,K.item)}:K.op===1?{op:K.op,item:d.deserialize(K.item)}:K.op===2?{op:K.op,uri:B.asCanonicalUri(P.URI.revive(K.uri)),docv:K.docv}:K,R.serialize=B=>B.op===0?{op:B.op,item:t.serialize(B.item)}:B.op===1?{op:B.op,item:d.serialize(B.item)}:B})(V||(e.TestsDiffOp=V={}));class q{constructor(B){this.k=B,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(B){const K=this.v();for(const ie of B)switch(ie.op){case 0:this.l(t.deserialize(this.k,ie.item),K);break;case 1:this.o(d.deserialize(ie.item),K);break;case 3:this.p(ie.itemId,K);break;case 5:this.q(ie.itemId);break;case 4:this.updatePendingRoots(ie.amount);break;case 6:this.c.set(ie.tag.id,ie.tag);break;case 7:this.c.delete(ie.id);break}K.complete?.()}l(B,K){const ie=N.$2K.parentId(B.item.extId)?.toString();let ce;if(!ie)ce=this.w(B),this.g.add(ce),this.f.set(B.item.extId,ce);else if(this.f.has(ie)){const ve=this.f.get(ie);ve.children.add(B.item.extId),ce=this.w(B,ve),this.f.set(B.item.extId,ce)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(B)}`);return}return K.add?.(ce),B.expand===2&&this.h++,ce}o(B,K){const ie=this.f.get(B.extId);if(ie)return B.expand!==void 0&&(ie.expand===2&&this.h--,B.expand===2&&this.h++),(0,e.$9K)(ie,B),K.update?.(ie),ie}p(B,K){const ie=this.f.get(B);if(!ie)return;const ce=N.$2K.parentId(ie.item.extId)?.toString();ce?this.f.get(ce).children.delete(ie.item.extId):this.g.delete(ie);const ve=[[B]];for(;ve.length;)for(const ke of ve.pop()){const fe=this.f.get(ke);fe&&(ve.push(fe.children),this.f.delete(ke),K.remove?.(fe,fe!==ie),fe.expand===2&&this.h--)}}q(B){}updatePendingRoots(B){this.j+=B}v(){return{}}}e.$$K=q}),define(Se[77],Ie([1,0,11,5,6,57,62,52]),function(he,e,P,O,M,N,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yO=e.$xO=e.$wO=e.$vO=e.$uO=e.TestItemEventOp=void 0;var m;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(m||(e.TestItemEventOp=m={}));const E=(n,i)=>n===i,S=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:E,label:E,description:E,error:E,sortText:E,tags:(n,i)=>!(n.length!==i.length||n.some(c=>!i.includes(c)))}),l=(n,i)=>{let c;for(const[u,t]of S)t(n[u],i[u])||(c?c[u]=i[u]:c={[u]:i[u]});return c};class b extends M.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new P.$Ih(()=>this.flushDiff(),200)),this.g=this.B(new O.$de),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===i.uri){c.docv=i.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===i.item.extId){(0,A.$9K)(c.item,i.item);return}if(c.op===0&&c.item.item.extId===i.item.extId){(0,A.$9K)(c.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,c){const u=this.tree.get(i);if(u){if((u.expandLevels===void 0||c>u.expandLevels)&&(u.expandLevels=c),u.expand===1){const t=this.M(u);return t.isOpen()?this.L(u,c-1):t.wait().then(()=>this.L(u,c-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.L(u,c-1)):this.L(u,c-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,c){switch(c.op){case 3:this.O($.$2K.joinToString(i.fullId,c.id));break;case 0:this.z(c.item,i);break;case 5:for(const u of c.ops)this.w(i,u);break;case 1:this.C(c.new,c.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:c.update}});break;case 6:this.y(i.actual.uri);break;default:(0,N.$ed)(c)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,c){const u=$.$2K.fromExtHostTestItem(i,this.root.id,c?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==c?.actual&&this.s.getChildren(t.parent).delete(i.id);let d=this.tree.get(u.toString());if(!d){d={fullId:u,actual:i,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(d.fullId.toString(),d),this.G(i,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:d.expand,item:this.s.toITestItem(i)}}),this.I(i,d,c);return}if(d.actual===i){this.H(i,d,c);return}if(d.actual.uri?.toString()!==i.uri?.toString())return this.O(u.toString()),this.z(i,c);const a=this.s.getChildren(d.actual),f=d.actual,w=l(this.s.toITestItem(f),this.s.toITestItem(i));this.s.getApiFor(f).listener=void 0,d.actual=i,d.resolveBarrier=void 0,d.expand=0,w&&(w.hasOwnProperty("tags")&&(this.C(i.tags,f.tags,u.toString()),delete w.tags),this.w(d,{op:4,update:w})),this.I(i,d,c);for(const[v,y]of a)this.s.getChildren(i).get(y.id)||this.O($.$2K.joinToString(u,y.id));const p=d.expandLevels;p!==void 0&&queueMicrotask(()=>{d.expand===1&&(d.expandLevels=void 0,this.expand(u.toString(),p))}),this.y(d.actual.uri)}C(i,c,u){const t=new Set(c.map(d=>d.id));for(const d of i)t.delete(d.id)||this.D(d);this.pushDiff({op:1,item:{extId:u,item:{tags:i.map(d=>(0,A.$7K)(this.s.controllerId,d.id))}}}),t.forEach(this.F,this)}D(i){const c=this.j.get(i.id);c?c.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$7K)(this.s.controllerId,i.id)}}))}F(i){const c=this.j.get(i);c&&!--c.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,A.$7K)(this.s.controllerId,i)}))}G(i,c){this.s.getApiFor(i).parent=c&&c.actual!==this.root?c.actual:void 0}H(i,c,u){this.G(i,u);const t=this.s.getApiFor(i);t.parent=u?.actual,t.listener=d=>this.w(c,d),this.J(c)}I(i,c,u){this.H(i,c,u);for(const[t,d]of this.s.getChildren(i))this.z(d,c)}J(i){let c;this.h?i.resolveBarrier?c=i.resolveBarrier.isOpen()?3:2:c=i.actual.canResolveChildren?1:0:c=0,c!==i.expand&&(i.expand=c,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:c}}),c===1&&i.expandLevels!==void 0&&this.M(i))}L(i,c){if(c<0)return;const u=[];for(const[t,d]of this.s.getChildren(i.actual)){const a=this.expand($.$2K.joinToString(i.fullId,d.id),c);(0,P.$ih)(a)&&u.push(a)}if(u.length)return Promise.all(u).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const d=new P.$vh;return d.open(),d}i.expand=2,this.N(i);const c=i.resolveBarrier=new P.$vh,u=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,d)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(d){u(d)}return(0,P.$ih)(t)?t.catch(u).then(()=>{c.open(),this.J(i)}):(c.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const c=this.tree.get(i);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const u=[c];for(;u.length;){const t=u.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const d of t.actual.tags)this.F(d.id);this.tree.delete(t.fullId.toString());for(const[d,a]of this.s.getChildren(t.actual))u.push(this.tree.get($.$2K.joinToString(t.fullId,a.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$uO=b;class g extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$vO=g;class r extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$wO=r;class s extends Error{constructor(i,c,u){super(`TestItem with ID "${i}" is from controller "${c}" and cannot be added as a child of an item from controller "${u}".`)}}e.$xO=s;const o=(n,i,c)=>{let u=new Map;return{get size(){return u.size},forEach(t,d){for(const a of u.values())t.call(d,a,this)},[Symbol.iterator](){return u.entries()},replace(t){const d=new Map,a=new Set(u.keys()),f={op:5,ops:[]};for(const w of t){if(!(w instanceof c))throw new r(w.id);const p=i(w).controllerId;if(p!==n.controllerId)throw new s(w.id,p,n.controllerId);if(d.has(w.id))throw new g(w.id);d.set(w.id,w),a.delete(w.id),f.ops.push({op:0,item:w})}for(const w of a.keys())f.ops.push({op:3,id:w});n.listener?.(f),u=d},add(t){if(!(t instanceof c))throw new r(t.id);u.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){u.delete(t)&&n.listener?.({op:3,id:t})},get(t){return u.get(t)},toJSON(){return Array.from(u.values())}}};e.$yO=o}),define(Se[107],Ie([1,0,77]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AO=e.$zO=void 0;const O=new WeakMap,M=(A,$)=>{const m={controllerId:$};return O.set(A,m),m};e.$zO=M;const N=A=>{const $=O.get(A);if(!$)throw new P.$wO(A?.id||"<unknown>");return $};e.$AO=N}),define(Se[78],Ie([1,0,16,2]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UAb=e.$TAb=e.$SAb=void 0,e.$VAb=M,e.$WAb=A,e.$SAb="vscode-cdn.net",e.$TAb=`vscode-resource.${e.$SAb}`,e.$UAb=`'self' https://*.${e.$SAb}`;function M($,m){return $.scheme===P.Schemas.http||$.scheme===P.Schemas.https?$:(m&&m.authority&&m.isRemote&&$.scheme===P.Schemas.file&&($=O.URI.from({scheme:P.Schemas.vscodeRemote,authority:m.authority,path:$.path})),O.URI.from({scheme:P.Schemas.https,authority:`${$.scheme}+${N($.authority)}.${e.$TAb}`,path:$.path,fragment:$.fragment,query:$.query}))}function N($){return $.replace(/./g,m=>{const E=m.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?m:"-"+E.toString(16).padStart(4,"0")})}function A($){return $.replace(/-([0-9a-f]{4})/g,(m,E)=>String.fromCharCode(parseInt(E,16)))}}),define(Se[232],Ie([1,0,5,6,78]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=void 0;class N{constructor($,m,E){this.d=$,this.e=m,this.f=E,this.a=0,this.b=new O.$Tc,this.c=new Map,this.b.add(m.onDidChangeVisibleTextEditors(()=>{const T=m.getVisibleTextEditors();for(const S of this.c.values())T.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,m,E,T,S){let l;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===$){l=i;break}if(!l)throw new Error("not a visible editor");const b=this,g=this.a++,r=new P.$de,s=new P.$de,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,M.$VAb)(i,b.f)}get cspSource(){return M.$UAb}set options(i){this.b=i,b.d.$setOptions(g,i)}get options(){return this.b}set html(i){this.a=i,b.d.$setHtml(g,i)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(i){return b.d.$postMessage(g,i)}},n=new class{constructor(){this.editor=$,this.line=m,this.height=E,this.webview=o,this.onDidDispose=s.event}dispose(){b.c.has(g)&&(b.c.delete(g),b.d.$disposeEditorInset(g),s.fire(),s.dispose(),r.dispose())}};return this.d.$createEditorInset(g,l.id,l.value.document.uri,m+1,E,T||{},S.identifier,S.extensionLocation),this.c.set(g,{editor:$,inset:n,onDidReceiveMessage:r}),n}$onDidDispose($){const m=this.c.get($);m&&m.inset.dispose()}$onDidReceiveMessage($,m){this.c.get($)?.onDidReceiveMessage.fire(m)}}e.$Mlc=N}),define(Se[108],Ie([1,0,3]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hL=e.$gL=e.$fL=void 0,e.$fL="__",e.$gL=(0,P.$wi)("IAuthenticationService"),e.$hL=(0,P.$wi)("IAuthenticationExtensionsService")}),define(Se[233],Ie([1,0,3]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tP=e.VariableKind=e.$sP=void 0,e.$sP=(0,P.$wi)("configurationResolverService");var O;(function(N){N.Unknown="unknown",N.Env="env",N.Config="config",N.Command="command",N.Input="input",N.ExtensionInstallFolder="extensionInstallFolder",N.WorkspaceFolder="workspaceFolder",N.Cwd="cwd",N.WorkspaceFolderBasename="workspaceFolderBasename",N.UserHome="userHome",N.LineNumber="lineNumber",N.SelectedText="selectedText",N.File="file",N.FileWorkspaceFolder="fileWorkspaceFolder",N.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",N.RelativeFile="relativeFile",N.RelativeFileDirname="relativeFileDirname",N.FileDirname="fileDirname",N.FileExtname="fileExtname",N.FileBasename="fileBasename",N.FileBasenameNoExtension="fileBasenameNoExtension",N.FileDirnameBasename="fileDirnameBasename",N.ExecPath="execPath",N.ExecInstallFolder="execInstallFolder",N.PathSeparator="pathSeparator",N.PathSeparatorAlias="/"})(O||(e.VariableKind=O={}));class M extends Error{constructor(A,$){super($),this.variable=A}}e.$tP=M}),define(Se[234],Ie([1,0,19,75,15,25,22,97,192,233,13]),function(he,e,P,O,M,N,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IP=void 0;class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(b,g,r,s){this.h=new Map,this.a=b,this.b=g,this.g=r,s&&(this.c=s.then(o=>this.i(o)))}i(b){if(A.$i){const g=Object.create(null);return Object.keys(b).forEach(r=>{g[r.toLowerCase()]=b[r]}),g}return b}resolveWithEnvironment(b,g,r){return this.l({env:this.i(b),userHome:void 0},g?g.uri:void 0,r)}async resolveAsync(b,g){const r={env:await this.c,userHome:await this.g};return this.l(r,b?b.uri:void 0,g)}async j(b,g,r,s){const o=N.$3n(g);A.$i&&o.windows?Object.keys(o.windows).forEach(i=>o[i]=o.windows[i]):A.$j&&o.osx?Object.keys(o.osx).forEach(i=>o[i]=o.osx[i]):A.$k&&o.linux&&Object.keys(o.linux).forEach(i=>o[i]=o.linux[i]),delete o.windows,delete o.osx,delete o.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,b?b.uri:void 0,o,r,s)}async resolveAnyAsync(b,g,r){return this.j(b,g,r)}async resolveAnyMap(b,g,r){const s=new Map;return{newConfig:await this.j(b,g,r,s),resolvedVariables:s}}resolveWithInteractionReplace(b,g,r,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,g,r,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,g){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,g)}async l(b,g,r,s,o){if(M.$9f(r))return this.m(b,g,r,s,o);if(Array.isArray(r))return Promise.all(r.map(n=>this.l(b,g,n,s,o)));if(M.$$f(r)){const n=Object.create(null),i=await Promise.all(Object.keys(r).map(async c=>[await this.m(b,g,c,s,o),await this.l(b,g,r[c],s,o)]));for(const[c,u]of i)n[c]=u;return n}return r}m(b,g,r,s,o){return(0,T.$pf)(r,S.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(S.VARIABLE_LHS))return n;let c=await this.o(b,n,i,g,s);return o?.set(i,c),c!==n&&M.$9f(c)&&c.match(S.VARIABLE_REGEXP)&&(c=await this.m(b,g,c,s,o)),c})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,g,r,s,o){let n;const i=r.split(":");i.length>1&&(r=i[0],n=i[1]);const c=d=>{const a=this.a.getFilePath();if(a)return(0,$.$Ew)(a);throw new E.$tP(d,(0,m.localize)(0,null,g))},u=d=>{const a=c(d);if(this.a.getWorkspaceFolderPathForFile){const f=this.a.getWorkspaceFolderPathForFile();if(f)return(0,$.$Ew)(f)}throw new E.$tP(d,(0,m.localize)(1,null,g,P.$nc(a)))},t=d=>{if(n){const a=this.a.getFolderUri(n);if(a)return a;throw new E.$tP(d,(0,m.localize)(2,null,g,n))}if(s)return s;throw this.a.getWorkspaceFolderCount()>1?new E.$tP(d,(0,m.localize)(3,null,g)):new E.$tP(d,(0,m.localize)(4,null,g))};switch(r){case"env":if(n){if(b.env){const d=b.env[A.$i?n.toLowerCase():n];if(M.$9f(d))return d}return""}throw new E.$tP(E.VariableKind.Env,(0,m.localize)(5,null,g));case"config":if(n){const d=this.a.getConfigurationValue(s,n);if(M.$fg(d))throw new E.$tP(E.VariableKind.Config,(0,m.localize)(6,null,g,n));if(M.$$f(d))throw new E.$tP(E.VariableKind.Config,(0,m.localize)(7,null,g,n));return d}throw new E.$tP(E.VariableKind.Config,(0,m.localize)(8,null,g));case"command":return this.p(E.VariableKind.Command,g,n,o,"command");case"input":return this.p(E.VariableKind.Input,g,n,o,"input");case"extensionInstallFolder":if(n){const d=await this.a.getExtension(n);if(!d)throw new E.$tP(E.VariableKind.ExtensionInstallFolder,(0,m.localize)(9,null,g,n));return this.n(d.extensionLocation)}throw new E.$tP(E.VariableKind.ExtensionInstallFolder,(0,m.localize)(10,null,g));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,$.$Ew)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return s||n?(0,$.$Ew)(this.n(t(E.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$Ew)(P.$nc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new E.$tP(E.VariableKind.UserHome,(0,m.localize)(11,null,g))}case"lineNumber":{const d=this.a.getLineNumber();if(d)return d;throw new E.$tP(E.VariableKind.LineNumber,(0,m.localize)(12,null,g))}case"selectedText":{const d=this.a.getSelectedText();if(d)return d;throw new E.$tP(E.VariableKind.SelectedText,(0,m.localize)(13,null,g))}case"file":return c(E.VariableKind.File);case"fileWorkspaceFolder":return u(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return P.$nc(u(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return s||n?P.$lc(this.n(t(E.VariableKind.RelativeFile)),c(E.VariableKind.RelativeFile)):c(E.VariableKind.RelativeFile);case"relativeFileDirname":{const d=P.$mc(c(E.VariableKind.RelativeFileDirname));if(s||n){const a=P.$lc(this.n(t(E.VariableKind.RelativeFileDirname)),d);return a.length===0?".":a}return d}case"fileDirname":return P.$mc(c(E.VariableKind.FileDirname));case"fileExtname":return P.$oc(c(E.VariableKind.FileExtname));case"fileBasename":return P.$nc(c(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=P.$nc(c(E.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-P.$oc(d).length)}case"fileDirnameBasename":return P.$nc(P.$mc(c(E.VariableKind.FileDirnameBasename)));case"execPath":{const d=this.a.getExecPath();return d||g}case"execInstallFolder":{const d=this.a.getAppRoot();return d||g}case"pathSeparator":case"/":return P.sep;default:try{const d=n?`${r}:${n}`:r;return this.p(E.VariableKind.Unknown,g,d,o,void 0)}catch{return g}}}}p(b,g,r,s,o){if(r&&s){const n=o===void 0?s[r]:s[o+":"+r];if(typeof n=="string")return n;throw new E.$tP(b,(0,m.localize)(14,null,g))}return g}}e.$IP=S}),define(Se[109],Ie([1,0,3,106]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$YD=void 0,e.$ZD=E,e.$1D=l,e.$2D=b,e.$YD=(0,P.$wi)("editorGroupsService");var M;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(M||(e.GroupDirection=M={}));var N;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(N||(e.GroupOrientation=N={}));var A;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var $;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EXPAND=1]="EXPAND",g[g.EVEN=2]="EVEN"})($||(e.GroupsArrangement=$={}));var m;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(m||(e.MergeGroupMode=m={}));function E(g){const r=g;return(0,O.$JF)(r?.editor)&&(0,O.$JF)(r?.replacement)}var T;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T||(e.GroupsOrder=T={}));var S;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function l(g){const r=g;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function b(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Se[235],Ie([1,0,3,109]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6D=e.$5D=e.$4D=e.$3D=void 0,e.$7D=M,e.$3D=(0,P.$wi)("editorService"),e.$4D=-1,e.$5D=-2,e.$6D=-3;function M(N){const A=N;return typeof N=="number"||(0,O.$1D)(A)}}),define(Se[236],Ie([1,0,3,99]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AL=void 0,e.$AL=(0,P.$xi)(O.$Di)}),define(Se[110],Ie([1,0,20,5,19,6,11]),function(he,e,P,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0_b=e.$9_b=e.$8_b=e.$7_b=e.$6_b=void 0;class ${constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$6_b=$;class m{static isHostExtension(n,i,c){if(i.getExtensionDescription(n))return!1;const u=c.getExtensionDescription(n);return u?!!((u.main||u.browser)&&u.api==="none"):!1}constructor(n,i){this.j=n,this.c=new O.$de,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(r),this.f=new P.$Tm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const c of i)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=s(this.e,i),this.e=this.e.concat(n);const c=m.l(this.e);return this.e=s(this.e,c.map(u=>u.identifier)),this.k(),this.d++,this.c.fire(void 0),new $(this.d,c)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(a){this.d.has(a)||(this.d.add(a),this.e.push(a))}addArc(a,f){this.addNode(a),this.addNode(f),this.c.has(a)?this.c.get(a).push(f):this.c.set(a,[f])}getArcs(a){return this.c.has(a)?this.c.get(a):[]}hasOnlyGoodArcs(a,f){const w=i.getArcs(a);for(let p=0;p<w.length;p++)if(!f.has(w[p]))return!1;return!0}getNodes(){return this.e}},c=new P.$Tm;for(const a of n)if(c.set(a.identifier,a),a.extensionDependencies)for(const f of a.extensionDependencies)i.addArc(P.$Rm.toKey(a.identifier),P.$Rm.toKey(f));const u=new Set;i.getNodes().filter(a=>i.getArcs(a).length===0).forEach(a=>u.add(a));const t=i.getNodes().filter(a=>!u.has(a));let d;do{d=!1;for(let a=0;a<t.length;a++){const f=t[a];i.hasOnlyGoodArcs(f,u)&&(t.splice(a,1),a--,u.add(f),d=!0)}}while(d);return t.map(a=>c.get(a))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$7_b=m;class E{constructor(n,i){this.versionId=n,this.extensions=i}}e.$8_b=E;class T{constructor(n){this.d=new b,this.c=new m(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new S(this,i)}deltaExtensions(n,i,c){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,c)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$9_b=T;class S extends N.$Uc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$0_b=S;class l{constructor(n){this.name=n;const i=(0,A.$ph)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class b{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new l(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const c=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),u=()=>{i&&(clearTimeout(c),i=!1,this.d=!1,this.e())};n.resolve((0,N.$Sc)(u))}}var g;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(g||(g={}));function r(o,n){const i=o.isBuiltin?0:o.isUnderDevelopment?2:1,c=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==c)return i-c;const u=M.$gc.basename(o.extensionLocation.path),t=M.$gc.basename(n.extensionLocation.path);return u<t?-1:u>t?1:0}function s(o,n){const i=new P.$Sm(n);return o.filter(c=>!i.has(c.identifier))}}),define(Se[79],Ie([1,0,21]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Zm=A,e.$1m=$;var O;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(O||(e.UIKind=O={}));var M;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(M||(e.ExtensionHostExitCode=M={}));var N;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(N||(e.MessageType=N={}));function A(E){const T=P.$Fe.alloc(1);switch(E){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}function $(E,T){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}var m;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(m||(e.NativeLogMarkers=m={}))}),define(Se[63],Ie([1,0,3,5,12,27,79,58,59,25,2,6,179]),function(he,e,P,O,M,N,A,$,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YO=e.$WO=e.$VO=void 0,e.$XO=r;let b=class extends S.$Uc{constructor(o,n){super(),this.s=o,this.t=n,this.a=this.B(new O.$de),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$de),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=T.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:m.$kp,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,M.$5j)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===M.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,n,i){const c=this.getTelemetryDetails(),u=new g(n,i,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,u]),u.apiTelemetryLogger}$initializeTelemetryLevel(o,n,i){this.f=o,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const n=Object.create(null);switch(n["common.extname"]=`${o.publisher}.${o.name}`,n["common.extversion"]=o.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=r(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:n["common.uikind"]="web";break;case A.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,$.$Im)((0,m.$qp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const n=this.getTelemetryDetails();this.r.forEach((i,c)=>{const u=i.filter(t=>!t.isDisposed);u.length===0?this.r.delete(c):this.r.set(c,u)}),this.r.forEach(i=>{for(const c of i)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,n){const c=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!c)return this.r.delete(o.value),!1;let u=!1;for(const t of c)t.ignoreUnhandledExtHostErrors||(t.logError(n),u=!0);return u}};e.$VO=b,e.$VO=b=Ke([We(0,N.$UO),We(1,M.$4j)],b);class g{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,n,i,c,u,t,d){this.g=i,this.h=c,this.i=u,this.j=t,this.a=new O.$de,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(o,n){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let n="properties"in o?o.properties??{}:o;return n=(0,m.$tp)(n,[]),this.c&&(n=(0,E.$6n)(n,this.c)),this.b||(n=(0,E.$6n)(n,this.j)),"properties"in o?o.properties=n:o=n,o}k(o,n){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(o,n),this.h.trace(o,n))}logUsage(o,n){this.d.isUsageEnabled&&this.k(o,n)}logError(o,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,n);else{const i={name:o.name,message:o.message,stack:o.stack,cause:o.cause},c=(0,m.$tp)(i,[]),u=new Error(c.message,{cause:c.cause});u.stack=c.stack,u.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(u,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const o=this,n={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$WO=g;function r(s){const o=Date.now()-new Date(s).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$YO=(0,P.$wi)("IExtHostTelemetry")}),define(Se[26],Ie([1,0,5,2,207,105,20,3]),function(he,e,P,O,M,N,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UG=e.ActivationKind=e.$RG=e.$QG=e.$NG=e.ExtensionHostStartup=e.$MG=e.$LG=e.$KG=e.$JG=void 0,e.$OG=l,e.$PG=b,e.$SG=o,e.$TG=n,e.$JG=Object.freeze({identifier:new A.$Rm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$KG="extensions.webWorker",e.$LG=(0,$.$wi)("extensionService");class m{constructor(u){this.dependency=u}}e.$MG=m;var E;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class T{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(u,t,d){this.c=u,this.d=t.slice(0),this.e=d.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:N.$uG.createActivationEventsMap(this.d)}}set(u,t,d){if(this.c>u)throw new Error(`ExtensionHostExtensions: invalid versionId ${u} (current: ${this.c})`);const a=[],f=[],w=[],p=[],v=S(this.d),y=S(t),h=(W,V)=>W.extensionLocation.toString()===V.extensionLocation.toString()||W.isBuiltin===V.isBuiltin||W.isUserBuiltin===V.isUserBuiltin||W.isUnderDevelopment===V.isUnderDevelopment;for(const W of this.d){const V=y.get(W.identifier);if(!V){a.push(W.identifier),v.delete(W.identifier);continue}if(!h(W,V)){a.push(W.identifier),v.delete(W.identifier);continue}}for(const W of t){const V=v.get(W.identifier);if(!V){f.push(W);continue}if(!h(V,W)){a.push(V.identifier),v.delete(V.identifier);continue}}const D=new A.$Sm(this.e),k=new A.$Sm(d);for(const W of this.e)k.has(W)||w.push(W);for(const W of d)D.has(W)||p.push(W);const C=N.$uG.createActivationEventsMap(f),I={versionId:u,toRemove:a,toAdd:f,addActivationEvents:C,myToRemove:w,myToAdd:p};return this.delta(I),I}delta(u){if(this.c>=u.versionId)return null;const{toRemove:t,toAdd:d,myToRemove:a,myToAdd:f}=u,w=new A.$Sm(t),p=new A.$Sm(a);for(let v=0;v<this.d.length;v++)w.has(this.d[v].identifier)&&(this.d.splice(v,1),v--);for(let v=0;v<this.e.length;v++)p.has(this.e[v])&&(this.e.splice(v,1),v--);for(const v of d)this.d.push(v);for(const v of f)this.e.push(v);return this.f=null,u}containsExtension(u){for(const t of this.e)if(A.$Rm.equals(t,u))return!0;return!1}containsActivationEvent(u){return this.f||(this.f=this.g()),this.f.has(u)}g(){const u=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const d=N.$uG.readActivationEvents(t);for(const a of d)u.add(a)}return u}}e.$NG=T;function S(c){const u=new A.$Tm;for(const t of c)u.set(t.identifier,t);return u}function l(c,u){return c.enabledApiProposals?c.enabledApiProposals.includes(u):!1}function b(c,u){if(!l(c,u))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}class g{constructor(u,t,d,a){this.codeLoadingTime=u,this.activateCallTime=t,this.activateResolvedTime=d,this.activationReason=a}}e.$QG=g;class r{constructor(u,t){this.description=u,this.value=t}}e.$RG=r;var s;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(s||(e.ActivationKind=s={}));function o(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,M.$zp)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}function n(c,u){return{identifier:new A.$Rm((0,M.$xp)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!u,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,publisherDisplayName:c.publisherDisplayName}}class i{constructor(){this.onDidRegisterExtensions=P.Event.None,this.onDidChangeExtensionsStatus=P.Event.None,this.onDidChangeExtensions=P.Event.None,this.onWillActivateByEvent=P.Event.None,this.onDidChangeResponsiveChange=P.Event.None,this.onWillStop=P.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activateById(u,t){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(u,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$UG=i}),define(Se[237],Ie([1,0,14,110,20,26,12,11]),function(he,e,P,O,M,N,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=e.$amc=e.$_lc=e.$$lc=e.$0lc=e.$9lc=void 0;class m{static{this.NONE=new m(!1,-1,-1,-1)}constructor(o,n,i,c){this.startup=o,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=c}}e.$9lc=m;class E{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,n){return o===-1||n===-1?-1:n-o}build(){return new m(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$0lc=E;class T{constructor(o,n,i,c,u,t){this.activationFailed=o,this.activationFailedError=n,this.activationTimes=i,this.module=c,this.exports=u,this.subscriptions=t}}e.$$lc=T;class S extends T{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$_lc=S;class l extends T{constructor(){super(!1,null,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$amc=l;class b extends T{constructor(o){super(!0,o,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let g=class{constructor(o,n,i,c){this.g=c,this.a=o,this.b=n,this.c=i,this.d=new M.$Tm,this.f=Object.create(null)}dispose(){for(const[o,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const o=[];for(const[n,i]of this.d)o.push(i.wait());await Promise.all(o)}isActivated(o){const n=this.d.get(o);return!!(n&&n.value)}getActivatedExtension(o){const n=this.d.get(o);if(!n||!n.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return n.value}async activateByEvent(o,n){if(this.f[o])return;const i=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(i.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,n){const i=this.a.getExtensionDescription(o);if(!i)throw new Error(`Extension '${o.value}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(o){const n=o.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const n=this.a.getExtensionDescription(o.id);if(!n){const u=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new b(u));return this.c.onExtensionActivationError(o.id,u,new N.$MG(o.id.value)),t}const i=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const u of c){if(this.m(u))continue;const t=this.d.get(u);if(t){i.push(t);continue}if(this.l(u)){i.push(this.j({id:this.b.getExtensionDescription(u).identifier,reason:o.reason}));continue}const d=this.a.getExtensionDescription(u);if(d){if(!d.main&&!d.browser)continue;i.push(this.j({id:d.identifier,reason:o.reason}));continue}const a=n.displayName||n.identifier.value,f=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${u}'`),w=this.k(o,n.displayName,[],new b(f));return this.c.onExtensionActivationError(n.identifier,f,new N.$MG(u)),w}return this.k(o,n.displayName,i,null)}k(o,n,i,c){const u=new r(o.id,n,o.reason,i,c,this.c,this.g);return this.d.set(o.id,u),u}l(o){return O.$7_b.isHostExtension(o,this.a,this.b)}m(o){const n=this.b.getExtensionDescription(o);return n?!n.main&&!n.browser:!1}};e.$bmc=g,e.$bmc=g=Ke([We(3,A.$3j)],g);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,n,i,c,u,t,d){this.c=o,this.d=n,this.f=i,this.g=c,this.h=u,this.j=t,this.k=d,this.a=new $.$vh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const n=this.g[o];if(n.value&&!n.value.activationFailed){this.g.splice(o,1),o--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new b(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const n=new Error;if(o&&o.name&&(n.name=o.name),o&&o.message?n.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(n.stack=o.stack),this.h=new b(n),this.b&&P.$4(o))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};r=Ke([We(6,A.$3j)],r)}),define(Se[238],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testPreserveFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testPreserveFocus.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[239],Ie([1,0,194,14,32,100,74,29,20,238,102,105]),function(he,e,P,O,M,N,A,$,m,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=void 0;const l=$.$co.as(A.$do.JSONContribution);class b{constructor(u,t,d){this.a=u,this.b=t,this.c=d}d(u,t){this.a({type:u,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(u){this.d(M.default.Error,u)}warn(u){this.d(M.default.Warning,u)}info(u){this.d(M.default.Info,u)}}e.$DG=b;class g{static a(u){const t=new m.$Sm;for(let d=0,a=u.length;d<a;d++)t.add(u[d].description.identifier);return t}static compute(u,t){if(!u||!u.length)return new g(t,[]);if(!t||!t.length)return new g([],u);const d=this.a(u),a=this.a(t),f=t.filter(p=>!d.has(p.description.identifier)),w=u.filter(p=>!a.has(p.description.identifier));return new g(f,w)}constructor(u,t){this.added=u,this.removed=t}}e.$EG=g;class r{constructor(u,t){this.name=u,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(u){if(this.a!==null)throw new Error("Handler already set!");this.a=u,this.d()}acceptUsers(u){this.c=g.compute(this.b,u),this.b=u,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(u){(0,O.$1)(u)}}}e.$FG=r;const s={type:"string",enum:["ui","workspace"],enumDescriptions:[P.localize(0,null),P.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$GG={properties:{engines:{type:"object",description:P.localize(2,null),properties:{vscode:{type:"string",description:P.localize(3,null),default:"^1.22.0"}}},publisher:{description:P.localize(4,null),type:"string"},displayName:{description:P.localize(5,null),type:"string"},categories:{description:P.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:m.$Qm},{type:"string",const:"Languages",deprecationMessage:P.localize(7,null)}]}},galleryBanner:{type:"object",description:P.localize(8,null),properties:{color:{description:P.localize(9,null),type:"string"},theme:{description:P.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:P.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:P.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:P.localize(13,null)},enabledApiProposals:{markdownDescription:P.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:P.localize(15,null),type:"string",enum:["none"],enumDescriptions:[P.localize(16,null)]},activationEvents:{description:P.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:P.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:P.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:P.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:P.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:P.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:P.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:P.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:P.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:P.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:P.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:P.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:P.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:P.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:P.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:P.localize(32,null)},{label:"onUri",body:"onUri",description:P.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:P.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:P.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:P.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:P.localize(37,null)},{label:"onRenderer",description:P.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:P.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:P.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:P.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:P.localize(42,null)},{label:"*",description:P.localize(43,null),body:"*"}]}},badges:{type:"array",description:P.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:P.localize(45,null)},href:{type:"string",description:P.localize(46,null)},description:{type:"string",description:P.localize(47,null)}}}},markdown:{type:"string",description:P.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:P.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:P.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$To}},extensionPack:{description:P.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$To}},extensionKind:{description:P.localize(52,null),type:"array",items:s,default:["workspace"],defaultSnippets:[{body:["ui"],description:P.localize(53,null)},{body:["workspace"],description:P.localize(54,null)},{body:["ui","workspace"],description:P.localize(55,null)},{body:["workspace","ui"],description:P.localize(56,null)},{body:[],description:P.localize(57,null)}]},capabilities:{description:P.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:P.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:P.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[P.localize(61,null),P.localize(62,null),P.localize(63,null)]},description:{type:"string",markdownDescription:P.localize(64,null)}}},untrustedWorkspaces:{description:P.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:P.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[P.localize(67,null),P.localize(68,null),P.localize(69,null)]},restrictedConfigurations:{description:P.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:P.localize(71,null)}}}}},sponsor:{description:P.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:P.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:P.localize(74,null),type:"string"},"vscode:uninstall":{description:P.localize(75,null),type:"string"}}},icon:{type:"string",description:P.localize(76,null)},l10n:{type:"string",description:P.localize(77,null)},pricing:{type:"string",markdownDescription:P.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(u){if(this.a.has(u.extensionPoint))throw new Error("Duplicate extension point: "+u.extensionPoint);const t=new r(u.extensionPoint,u.defaultExtensionKind);return this.a.set(u.extensionPoint,t),u.activationEventsGenerator&&S.$uG.register(u.extensionPoint,u.activationEventsGenerator),e.$GG.properties.contributes.properties[u.extensionPoint]=u.jsonSchema,l.registerSchema(o,e.$GG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$HG=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};$.$co.add(i.ExtensionsRegistry,new n),e.$IG=$.$co.as(i.ExtensionsRegistry),l.registerSchema(o,e.$GG),l.registerSchema(T.$kk,{properties:{extensionEnabledApiProposals:{description:P.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(Se[240],Ie([1,0,190,15,25,239,31,5]),function(he,e,P,O,M,N,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cI=void 0;const m={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:P.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:P.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:P.localize(2,null),default:""}}};var E;(function(l){function b(g,r,s){if(!g)return;const o=O.$9f(g.type)?g.type:void 0;if(!o||o.length===0){s.error(P.localize(3,null));return}const n=[];if(Array.isArray(g.required))for(const i of g.required)O.$9f(i)&&n.push(i);return{extensionId:r.value,taskType:o,required:n,properties:g.properties?M.$3n(g.properties):{},when:g.when?A.$uj.deserialize(g.when):void 0}}l.from=b})(E||(E={}));const T=N.$IG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,b)=>{for(const g of l)g.type&&b.push(`onTaskType:${g.type}`)},jsonSchema:{description:P.localize(4,null),type:"array",items:m}});class S{constructor(){this.d=new $.$de,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,g)=>{T.setHandler((r,s)=>{this.c=void 0;try{for(const o of s.removed){const n=o.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const o of s.added){const n=o.value;for(const i of n){const c=E.from(i,o.description.identifier,o.collector);c&&(this.a[c.taskType]=c)}}(s.removed.length>0||s.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const g of this.all()){const r={type:"object",additionalProperties:!1};g.required.length>0&&(r.required=g.required.slice(0)),g.properties!==void 0?r.properties=M.$3n(g.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[g.taskType]},b.push(r)}this.c={oneOf:b}}return this.c}}e.$cI=new S}),define(Se[241],Ie([1,0,191,15,23,25,31,240]),function(he,e,P,O,M,N,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$mI=e.JsonSchemaVersion=e.ExecutionEngine=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$gI=e.ShellQuoting=e.$fI=e.$eI=e.$dI=void 0,e.$dI="settings",e.$eI=new A.$Nj("taskRunning",!1,P.localize(0,null)),e.$fI=P.localize2(2,"Tasks");var m;(function(R){R[R.Escape=1]="Escape",R[R.Strong=2]="Strong",R[R.Weak=3]="Weak"})(m||(e.ShellQuoting=m={})),e.$gI="$customized",function(R){function B(K){if(!K)return R.Strong;switch(K.toLowerCase()){case"escape":return R.Escape;case"strong":return R.Strong;case"weak":return R.Weak;default:return R.Strong}}R.from=B}(m||(e.ShellQuoting=m={}));var E;(function(R){R.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var T;(function(R){R[R.Always=1]="Always",R[R.Silent=2]="Silent",R[R.Never=3]="Never"})(T||(e.RevealKind=T={})),function(R){function B(K){switch(K.toLowerCase()){case"always":return R.Always;case"silent":return R.Silent;case"never":return R.Never;default:return R.Always}}R.fromString=B}(T||(e.RevealKind=T={}));var S;(function(R){R[R.Never=1]="Never",R[R.OnProblem=2]="OnProblem",R[R.Always=3]="Always"})(S||(e.RevealProblemKind=S={})),function(R){function B(K){switch(K.toLowerCase()){case"always":return R.Always;case"never":return R.Never;case"onproblem":return R.OnProblem;default:return R.OnProblem}}R.fromString=B}(S||(e.RevealProblemKind=S={}));var l;(function(R){R[R.Shared=1]="Shared",R[R.Dedicated=2]="Dedicated",R[R.New=3]="New"})(l||(e.PanelKind=l={})),function(R){function B(K){switch(K.toLowerCase()){case"shared":return R.Shared;case"dedicated":return R.Dedicated;case"new":return R.New;default:return R.Shared}}R.fromString=B}(l||(e.PanelKind=l={}));var b;(function(R){R.defaults={echo:!0,reveal:T.Always,revealProblems:S.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var g;(function(R){R[R.Shell=1]="Shell",R[R.Process=2]="Process",R[R.CustomExecution=3]="CustomExecution"})(g||(e.RuntimeType=g={})),function(R){function B(ie){switch(ie.toLowerCase()){case"shell":return R.Shell;case"process":return R.Process;case"customExecution":return R.CustomExecution;default:return R.Process}}R.fromString=B;function K(ie){switch(ie){case R.Shell:return"shell";case R.Process:return"process";case R.CustomExecution:return"customExecution";default:return"process"}}R.toString=K}(g||(e.RuntimeType=g={}));var r;(function(R){function B(K){return O.$9f(K)?K:K.value}R.value=B})(r||(e.CommandString=r={}));var s;(function(R){R.Clean={_id:"clean",isDefault:!1},R.Build={_id:"build",isDefault:!1},R.Rebuild={_id:"rebuild",isDefault:!1},R.Test={_id:"test",isDefault:!1};function B(ie){return ie===R.Clean._id||ie===R.Build._id||ie===R.Rebuild._id||ie===R.Test._id}R.is=B;function K(ie){if(ie!==void 0)return O.$9f(ie)?B(ie)?{_id:ie,isDefault:!1}:void 0:ie}R.from=K})(s||(e.TaskGroup=s={}));var o;(function(R){R[R.Global=1]="Global",R[R.Workspace=2]="Workspace",R[R.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var n;(function(R){R.Workspace="workspace",R.Extension="extension",R.InMemory="inMemory",R.WorkspaceFile="workspaceFile",R.User="user";function B(K){switch(K){case R.User:return 2;case R.WorkspaceFile:return 5;default:return 6}}R.toConfigurationTarget=B})(n||(e.TaskSourceKind=n={}));var i;(function(R){R.parallel="parallel",R.sequence="sequence"})(i||(e.DependsOrder=i={}));var c;(function(R){R[R.default=1]="default",R[R.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var u;(function(R){R.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(u||(e.RunOptions=u={}));class t{constructor(B,K,ie,ce,ve,ke){this._label="",this._id=B,K&&(this._label=K),ie&&(this.type=ie),this.runOptions=ce,this.configurationProperties=ve,this._source=ke}getDefinition(B){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const B={folder:this.d(),id:this._id};return JSON.stringify(B)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,K=!1){if(B===void 0)return!1;if(O.$9f(B))return B===this._label||B===this.configurationProperties.identifier||K&&B===this._id;const ie=this.getDefinition(!0);return ie!==void 0&&ie._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this.c===void 0&&(this.c=[]),B&&(this.c=this.c.concat(B))}get taskLoadMessages(){return this.c}}e.$hI=t;class d extends t{constructor(B,K,ie,ce,ve,ke,fe,pe){super(B,ie,void 0,fe,pe,K),this.command={},this._source=K,this.hasDefinedMatchers=ke,ve&&(this.command=ve)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case g.Shell:K="shell";break;case g.Process:K="process";break;case g.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(B){return B instanceof d}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$dI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const B=this.d();if(!B)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const ie={type:e.$gI,folder:B,id:K};return JSON.stringify(ie)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$7g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(B){return new d(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.$iI=d;class a extends t{constructor(B,K,ie,ce,ve,ke,fe){super(B,ie,ce,ke,fe,K),this._source=K,this.configures=ve}static is(B){return B instanceof a}f(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$7g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$dI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const B=this.d();if(!B)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const ie={type:e.$gI,folder:B,id:K};return JSON.stringify(ie)}}e.$jI=a;class f extends t{constructor(B,K,ie,ce,ve,ke,fe,pe,Ne){super(B,ie,ce,pe,Ne,K),this.defines=ve,this.hasDefinedMatchers=fe,this.command=ke,this.icon=Ne.icon,this.hide=Ne.hide}clone(){return new f(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof f}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.d(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(B){return new f(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.$kI=f;class w extends t{constructor(B,K,ie,ce,ve,ke){super(B,ie,ce,ve,ke,K),this._source=K}clone(){return new w(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof w}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(B){return new w(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.$lI=w;var p;(function(R){R[R.Process=1]="Process",R[R.Terminal=2]="Terminal"})(p||(e.ExecutionEngine=p={})),function(R){R._default=R.Terminal}(p||(e.ExecutionEngine=p={}));var v;(function(R){R[R.V0_1_0=1]="V0_1_0",R[R.V2_0_0=2]="V2_0_0"})(v||(e.JsonSchemaVersion=v={}));class y{constructor(B){this.c=new Map;for(let K=0;K<B.length;K++)this.c.set(B[K].uri.toString(),K)}compare(B,K){const ie=B.getWorkspaceFolder(),ce=K.getWorkspaceFolder();if(ie&&ce){let ve=this.c.get(ie.uri.toString());ve=ve===void 0?0:ve+1;let ke=this.c.get(ce.uri.toString());return ke=ke===void 0?0:ke+1,ve===ke?B._label.localeCompare(K._label):ve-ke}else return!ie&&ce?-1:ie&&!ce?1:0}}e.$mI=y;var h;(function(R){R.DependsOnStarted="dependsOnStarted",R.AcquiredInput="acquiredInput",R.Start="start",R.ProcessStarted="processStarted",R.Active="active",R.Inactive="inactive",R.Changed="changed",R.Terminated="terminated",R.ProcessEnded="processEnded",R.End="end"})(h||(e.TaskEventKind=h={}));var D;(function(R){R.SingleRun="singleRun",R.Background="background"})(D||(e.TaskRunType=D={}));var k;(function(R){R[R.System=0]="System",R[R.User=1]="User",R[R.FolderOpen=2]="FolderOpen",R[R.ConfigurationChange=3]="ConfigurationChange",R[R.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var C;(function(R){function B(pe){return{taskId:pe._id,taskName:pe.configurationProperties.name,runType:pe.configurationProperties.isBackground?"background":"singleRun",group:pe.configurationProperties.group,__task:pe}}function K(pe,Ne,ae){return{...B(pe),kind:"start",terminalId:Ne,resolvedVariables:ae}}R.start=K;function ie(pe,Ne,ae){return{...B(pe),kind:"processStarted",terminalId:Ne,processId:ae}}R.processStarted=ie;function ce(pe,Ne,ae){return{...B(pe),kind:"processEnded",terminalId:Ne,exitCode:ae}}R.processEnded=ce;function ve(pe,Ne,ae){return{...B(pe),kind:"terminated",exitReason:ae,terminalId:Ne}}R.terminated=ve;function ke(pe,Ne,ae){return{...B(Ne),kind:pe,terminalId:ae}}R.general=ke;function fe(){return{kind:"changed"}}R.changed=fe})(C||(e.TaskEvent=C={}));var I;(function(R){function B(ie){const ce=Object.keys(ie).sort();let ve="";for(const ke of ce){let fe=ie[ke];fe instanceof Object?fe=B(fe):typeof fe=="string"&&(fe=fe.replace(/,/g,",,")),ve+=ke+","+fe+","}return ve}function K(ie){const ve={_key:B(ie),type:ie.taskType};return Object.assign(ve,ie),ve}R.create=K})(I||(e.KeyedTaskIdentifier=I={}));var W;(function(R){R.AutoDetect="task.autoDetect",R.SaveBeforeRun="task.saveBeforeRun",R.ShowDecorations="task.showDecorations",R.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",R.SlowProviderWarning="task.slowProviderWarning",R.QuickOpenHistory="task.quickOpen.history",R.QuickOpenDetail="task.quickOpen.detail",R.QuickOpenSkip="task.quickOpen.skip",R.QuickOpenShowAll="task.quickOpen.showAll",R.AllowAutomaticTasks="task.allowAutomaticTasks",R.Reconnection="task.reconnection",R.VerboseLogging="task.verboseLogging"})(W||(e.TaskSettingId=W={}));var V;(function(R){R.Tasks="tasks",R.SuppressTaskName="tasks.suppressTaskName",R.Windows="tasks.windows",R.Osx="tasks.osx",R.Linux="tasks.linux",R.ShowOutput="tasks.showOutput",R.IsShellCommand="tasks.isShellCommand",R.ServiceTestSetting="tasks.service.testSetting"})(V||(e.TasksSchemaProperties=V={}));var q;(function(R){function B(K,ie){const ce=$.$cI.get(K.type);if(ce===void 0){const pe=N.$3n(K);return delete pe._key,I.create(pe)}const ve=Object.create(null);ve.type=ce.taskType;const ke=new Set;ce.required.forEach(pe=>ke.add(pe));const fe=ce.properties;for(const pe of Object.keys(fe)){const Ne=K[pe];if(Ne!=null)ve[pe]=Ne;else if(ke.has(pe)){const ae=fe[pe];if(ae.default!==void 0)ve[pe]=N.$3n(ae.default);else switch(ae.type){case"boolean":ve[pe]=!1;break;case"number":case"integer":ve[pe]=0;break;case"string":ve[pe]="";break;default:ie.error(P.localize(1,null,JSON.stringify(K,void 0,0),pe));return}}}return I.create(ve)}R.createTaskIdentifier=B})(q||(e.TaskDefinition=q={}))}),define(Se[242],Ie([1,0,14]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$__b=e.$$_b=void 0;class O{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,$)=>{this.b=A,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,P.$1)(A))}then(A,$){return this.j().then(A,$)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$$_b=O;class M extends O{constructor(){super(),this.h=!0,this.i=new P.$5}}e.$__b=M}),define(Se[34],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bw=e.$yw=void 0,e.$zw=M,e.$Aw=N;class P{static{this.count=0}constructor(m){this._proxyIdentifierBrand=void 0,this.sid=m,this.nid=++P.count}}e.$yw=P;const O=[];function M($){const m=new P($);return O[m.nid]=m,m}function N($){return O[$].sid}class A{constructor(m){this.value=m}}e.$Bw=A}),define(Se[4],Ie([1,0,34]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eM=e.$dM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$cM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var M;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(M||(e.TabInputKind=M={}));var N;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(N||(e.TabModelOperationKind=N={}));var A;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var $;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var m;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(m||(e.CellOutputKind=m={}));var E;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var T;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(T||(e.CandidatePortSource=T={}));class S{static{this.a=0}static mixin(s){return s._id=S.a++,s}}e.$cM=S;var l;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var b;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var g;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(g||(e.ExtHostTestingResource=g={})),e.$dM={MainThreadAuthentication:(0,P.$zw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,P.$zw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,P.$zw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,P.$zw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,P.$zw)("MainThreadChatVariables"),MainThreadClipboard:(0,P.$zw)("MainThreadClipboard"),MainThreadCommands:(0,P.$zw)("MainThreadCommands"),MainThreadComments:(0,P.$zw)("MainThreadComments"),MainThreadConfiguration:(0,P.$zw)("MainThreadConfiguration"),MainThreadConsole:(0,P.$zw)("MainThreadConsole"),MainThreadDebugService:(0,P.$zw)("MainThreadDebugService"),MainThreadDecorations:(0,P.$zw)("MainThreadDecorations"),MainThreadDiagnostics:(0,P.$zw)("MainThreadDiagnostics"),MainThreadDialogs:(0,P.$zw)("MainThreadDiaglogs"),MainThreadDocuments:(0,P.$zw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,P.$zw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,P.$zw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,P.$zw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,P.$zw)("MainThreadEditorTabs"),MainThreadErrors:(0,P.$zw)("MainThreadErrors"),MainThreadTreeViews:(0,P.$zw)("MainThreadTreeViews"),MainThreadDownloadService:(0,P.$zw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,P.$zw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,P.$zw)("MainThreadLanguages"),MainThreadLogger:(0,P.$zw)("MainThreadLogger"),MainThreadMessageService:(0,P.$zw)("MainThreadMessageService"),MainThreadOutputService:(0,P.$zw)("MainThreadOutputService"),MainThreadProgress:(0,P.$zw)("MainThreadProgress"),MainThreadQuickDiff:(0,P.$zw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,P.$zw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,P.$zw)("MainThreadStatusBar"),MainThreadSecretState:(0,P.$zw)("MainThreadSecretState"),MainThreadStorage:(0,P.$zw)("MainThreadStorage"),MainThreadSpeech:(0,P.$zw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,P.$zw)("MainThreadTelemetry"),MainThreadTerminalService:(0,P.$zw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,P.$zw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,P.$zw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,P.$zw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,P.$zw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,P.$zw)("MainThreadCustomEditors"),MainThreadUrls:(0,P.$zw)("MainThreadUrls"),MainThreadUriOpeners:(0,P.$zw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,P.$zw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,P.$zw)("MainThreadWorkspace"),MainThreadFileSystem:(0,P.$zw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,P.$zw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,P.$zw)("MainThreadExtensionService"),MainThreadSCM:(0,P.$zw)("MainThreadSCM"),MainThreadSearch:(0,P.$zw)("MainThreadSearch"),MainThreadShare:(0,P.$zw)("MainThreadShare"),MainThreadTask:(0,P.$zw)("MainThreadTask"),MainThreadWindow:(0,P.$zw)("MainThreadWindow"),MainThreadLabelService:(0,P.$zw)("MainThreadLabelService"),MainThreadNotebook:(0,P.$zw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,P.$zw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,P.$zw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,P.$zw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,P.$zw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,P.$zw)("MainThreadInteractive"),MainThreadTheming:(0,P.$zw)("MainThreadTheming"),MainThreadTunnelService:(0,P.$zw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,P.$zw)("MainThreadManagedSockets"),MainThreadTimeline:(0,P.$zw)("MainThreadTimeline"),MainThreadTesting:(0,P.$zw)("MainThreadTesting"),MainThreadLocalization:(0,P.$zw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,P.$zw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,P.$zw)("MainThreadAiEmbeddingVector")},e.$eM={ExtHostCommands:(0,P.$zw)("ExtHostCommands"),ExtHostConfiguration:(0,P.$zw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,P.$zw)("ExtHostDiagnostics"),ExtHostDebugService:(0,P.$zw)("ExtHostDebugService"),ExtHostDecorations:(0,P.$zw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,P.$zw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,P.$zw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,P.$zw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,P.$zw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,P.$zw)("ExtHostEditors"),ExtHostTreeViews:(0,P.$zw)("ExtHostTreeViews"),ExtHostFileSystem:(0,P.$zw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,P.$zw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,P.$zw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,P.$zw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,P.$zw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,P.$zw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,P.$zw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,P.$zw)("ExtHostStatusBar"),ExtHostShare:(0,P.$zw)("ExtHostShare"),ExtHostExtensionService:(0,P.$zw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,P.$zw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,P.$zw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,P.$zw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,P.$zw)("ExtHostSCM"),ExtHostSearch:(0,P.$zw)("ExtHostSearch"),ExtHostTask:(0,P.$zw)("ExtHostTask"),ExtHostWorkspace:(0,P.$zw)("ExtHostWorkspace"),ExtHostWindow:(0,P.$zw)("ExtHostWindow"),ExtHostWebviews:(0,P.$zw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,P.$zw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,P.$zw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,P.$zw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,P.$zw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,P.$zw)("ExtHostEditorTabs"),ExtHostProgress:(0,P.$zw)("ExtHostProgress"),ExtHostComments:(0,P.$zw)("ExtHostComments"),ExtHostSecretState:(0,P.$zw)("ExtHostSecretState"),ExtHostStorage:(0,P.$zw)("ExtHostStorage"),ExtHostUrls:(0,P.$zw)("ExtHostUrls"),ExtHostUriOpeners:(0,P.$zw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,P.$zw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,P.$zw)("ExtHostOutputService"),ExtHostLabelService:(0,P.$zw)("ExtHostLabelService"),ExtHostNotebook:(0,P.$zw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,P.$zw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,P.$zw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,P.$zw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,P.$zw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,P.$zw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,P.$zw)("ExtHostInteractive"),ExtHostChatAgents2:(0,P.$zw)("ExtHostChatAgents"),ExtHostChatVariables:(0,P.$zw)("ExtHostChatVariables"),ExtHostChatProvider:(0,P.$zw)("ExtHostChatProvider"),ExtHostSpeech:(0,P.$zw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,P.$zw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,P.$zw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,P.$zw)("ExtHostTheming"),ExtHostTunnelService:(0,P.$zw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,P.$zw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,P.$zw)("ExtHostAuthentication"),ExtHostTimeline:(0,P.$zw)("ExtHostTimeline"),ExtHostTesting:(0,P.$zw)("ExtHostTesting"),ExtHostTelemetry:(0,P.$zw)("ExtHostTelemetry"),ExtHostLocalization:(0,P.$zw)("ExtHostLocalization")}}),define(Se[80],Ie([1,0,3,12,4,17]),function(he,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=e.$wlc=e.$vlc=void 0,e.$vlc=(0,P.$wi)("IExtHostApiDeprecationService");let A=class{constructor(m,E){this.c=E,this.a=new Set,this.b=m.getProxy(M.$dM.MainThreadTelemetry)}report(m,E,T){const S=this.d(m,E);this.a.has(S)||(this.a.add(S),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${m}' is deprecated. ${T}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:m}))}d(m,E){return`${m}-${E.identifier.value}`}};e.$wlc=A,e.$wlc=A=Ke([We(0,N.$EO),We(1,O.$3j)],A),e.$xlc=Object.freeze(new class{report($,m,E){}})}),define(Se[243],Ie([1,0,4]),function(he,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=void 0;class O{constructor(N){const A=N.getProxy(P.$dM.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText($){return A.$writeText($)}})}}e.$Klc=O}),define(Se[244],Ie([1,0,25,4,27,17]),function(he,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dnc=void 0;let A=class{constructor(T,S){this.a=T.getProxy(O.$dM.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(T,S){const l=this,b=console[T];Object.defineProperty(console,T,{set:()=>{},get:()=>function(){l.e(T,S,b,arguments)}})}e(T,S,l,b){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:m(b,this.b)}),this.c&&this.f(T,l,b)}};e.$Dnc=A,e.$Dnc=A=Ke([We(0,N.$EO),We(1,M.$UO)],A);const $=1e5;function m(E,T){const S=[];if(E.length)for(let l=0;l<E.length;l++){let b=E[l];if(typeof b>"u")b="undefined";else if(b instanceof Error){const g=b;g.stack?b=g.stack:b=g.toString()}S.push(b)}if(T){const l=new Error().stack;l&&S.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,P.$8n)(S);return l.length>$?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Se[245],Ie([1,0,2,4,26]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=void 0;class N{constructor($){this.a=$.getProxy(O.$dM.MainThreadDialogs)}showOpenDialog($,m){return m?.allowUIResources&&(0,M.$PG)($,"showLocal"),this.a.$showOpenDialog(m).then(E=>E?E.map(T=>P.URI.revive(T)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(m=>m?P.URI.revive(m):void 0)}}e.$Hmc=N}),define(Se[246],Ie([1,0,6,4]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1mc=void 0;class M{constructor(A){this.b=0,this.a=A.getProxy(O.$dM.MainThreadLabelService)}$registerResourceLabelFormatter(A){const $=this.b++;return this.a.$registerResourceLabelFormatter($,A),(0,P.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$1mc=M}),define(Se[81],Ie([1,0,22,13,2,3,12,4,27,17]),function(he,e,P,O,M,N,A,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qmc=e.$pmc=void 0;let T=class{constructor(l,b,g){this.f=g,this.d=new Map,this.a=b.getProxy($.$dM.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===P.$g}getMessage(l,b){const{message:g,args:r,comment:s}=b;if(this.c)return(0,O.$9e)(g,r??{});let o=g;s&&s.length>0&&(o+=`/${Array.isArray(s)?s.join(""):s}`);const n=this.d.get(l)?.contents[o];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,O.$9e)(n??g,r??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let b;const g=await this.g(l);if(!g){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(g),s=JSON.parse(r);b=l.isBuiltin?s.contents?.bundle:s}catch(r){this.f.error(`Failed to load translations for ${l.identifier.value} from ${g}: ${r.message}`);return}b&&this.d.set(l.identifier.value,{contents:b,uri:g})}async g(l){if(l.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return M.URI.revive(b)}return l.l10n?M.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$pmc=T,e.$pmc=T=Ke([We(0,m.$UO),We(1,E.$EO),We(2,A.$3j)],T),e.$qmc=(0,N.$wi)("IExtHostLocalizationService")}),define(Se[247],Ie([1,0,12,4,27,17,2,49]),function(he,e,P,O,M,N,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cnc=void 0;let m=class extends P.$bk{constructor(S,l){super(l.logLevel,l.logsLocation,l.loggers.map(b=>(0,$.$6h)(b))),this.r=S.getProxy(O.$dM.MainThreadLogger)}$setLogLevel(S,l){l?this.setLogLevel(A.URI.revive(l),S):this.setLogLevel(S)}setVisibility(S,l){super.setVisibility(S,l),this.r.$setVisibility(S,l)}s(S,l,b){return new E(this.r,S,l,b)}};e.$Cnc=m,e.$Cnc=m=Ke([We(0,N.$EO),We(1,M.$UO)],m);class E extends P.$9j{constructor(S,l,b,g){super(g?.logLevel==="always"),this.r=S,this.s=l,this.m=!1,this.n=[],this.setLevel(b),this.r.$createLogger(l,g).then(()=>{this.u(this.n),this.m=!0})}g(S,l){const b=[[S,l]];this.m?this.u(b):this.n.push(...b)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(Se[82],Ie([1,0,4,3,6,17,21]),function(he,e,P,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$smc=e.$rmc=void 0,e.$rmc=(0,O.$wi)("IExtHostManagedSockets");let $=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(P.$dM.MainThreadManagedSockets)}setFactory(S,l){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new m(S,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const l=++this.b,b=await this.c.makeConnection(),g=new M.$Tc;return this.d.set(l,new E(l,b,g)),g.add((0,M.$Sc)(()=>this.d.delete(l))),g.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),g.dispose()})),g.add(b.onDidClose(r=>{this.a.$onDidManagedSocketClose(l,r?.stack??r?.message),g.dispose()})),g.add(b.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(l,A.$Fe.wrap(r)))),l}$remoteSocketWrite(S,l){this.d.get(S)?.actual.send(l.buffer)}$remoteSocketEnd(S){const l=this.d.get(S);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$smc=$,e.$smc=$=Ke([We(0,N.$EO)],$);class m{constructor(S,l){this.socketFactoryId=S,this.makeConnection=l}}class E extends M.$Uc{constructor(S,l,b){super(),this.socketId=S,this.actual=l,this.B(b)}}}),define(Se[248],Ie([1,0,4,12,26]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3mc=void 0;function N($){return $&&$.title}let A=class{constructor(m,E){this.b=E,this.a=m.getProxy(P.$dM.MainThreadMessageService)}showMessage(m,E,T,S,l){const b={source:{identifier:m.identifier,label:m.displayName||m.name}};let g;typeof S=="string"||N(S)?g=[S,...l]:(b.modal=S?.modal,b.useCustom=S?.useCustom,b.detail=S?.detail,g=l),b.useCustom&&(0,M.$PG)(m,"resolvers");const r=[];let s=!1;for(let o=0;o<g.length;o++){const n=g[o];if(typeof n=="string")r.push({title:n,handle:o,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:c}=n;r.push({title:i,isCloseAffordance:!!c,handle:o}),c&&(s?this.b.warn(`[${m.identifier}] Only one message item can have 'isCloseAffordance':`,n):s=!0)}else this.b.warn(`[${m.identifier}] Invalid message item:`,n)}return this.a.$showMessage(E,T,b,r).then(o=>{if(typeof o=="number")return g[o]})}};e.$3mc=A,e.$3mc=A=Ke([We(1,O.$3j)],A)}),define(Se[249],Ie([1,0,6,15,2,26,4]),function(he,e,P,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_mc=void 0;class ${constructor(E){this.b=new Map,this.a=E.getProxy(A.$dM.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,T,S){if((0,N.$PG)(E,"profileContentHandlers"),this.b.has(T))throw new Error(`Handler with id '${T}' already registered`);return this.b.set(T,S),this.a.$registerProfileContentHandler(T,S.name,S.description,E.identifier.value),(0,P.$Sc)(()=>{this.b.delete(T),this.a.$unregisterProfileContentHandler(T)})}async $saveProfile(E,T,S,l){const b=this.b.get(E);if(!b)throw new Error(`Unknown handler with id: ${E}`);return b.saveProfile(T,S,l)}async $readProfile(E,T,S){const l=this.b.get(E);if(!l)throw new Error(`Unknown handler with id: ${E}`);return l.readProfile((0,O.$9f)(T)?T:M.URI.revive(T),S)}}e.$_mc=$}),define(Se[83],Ie([1,0,4,5,3]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nmc=e.$mmc=void 0;class N{constructor($){this.b=new O.$de,this.onDidChangePassword=this.b.event,this.a=$.getProxy(P.$dM.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,m){return this.a.$getPassword($,m)}store($,m,E){return this.a.$setPassword($,m,E)}delete($,m){return this.a.$deletePassword($,m)}}e.$mmc=N,e.$nmc=(0,M.$wi)("IExtHostSecretState")}),define(Se[250],Ie([1,0,24,6,4]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gnc=void 0;class N{static{this.a=1}constructor($){this.c=new Map,this.d=new Map,this.f=new Map,this.b=$.getProxy(M.$dM.MainThreadSpeech)}async $createSpeechToTextSession($,m,E){const T=this.c.get($);if(!T)return;const S=new O.$Tc,l=new P.$oe;this.d.set(m,l);const b=S.add(T.provideSpeechToTextSession(l.token,E?{language:E}:void 0));S.add(b.onDidChange(g=>{l.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(m,g)})),S.add(l.token.onCancellationRequested(()=>S.dispose()))}async $cancelSpeechToTextSession($){this.d.get($)?.dispose(!0),this.d.delete($)}async $createTextToSpeechSession($,m){const E=this.c.get($);if(!E)return;const T=new O.$Tc,S=new P.$oe;this.d.set(m,S);const l=T.add(E.provideTextToSpeechSession(S.token));this.f.set(m,l),T.add(l.onDidChange(b=>{S.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(m,b)})),T.add(S.token.onCancellationRequested(()=>T.dispose()))}async $synthesizeSpeech($,m){const E=this.f.get($);E&&E.synthesize(m)}async $cancelTextToSpeechSession($){this.d.get($)?.dispose(!0),this.d.delete($),this.f.delete($)}async $createKeywordRecognitionSession($,m){const E=this.c.get($);if(!E)return;const T=new O.$Tc,S=new P.$oe;this.d.set(m,S);const l=T.add(E.provideKeywordRecognitionSession(S.token));T.add(l.onDidChange(b=>{S.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(m,b)})),T.add(S.token.onCancellationRequested(()=>T.dispose()))}async $cancelKeywordRecognitionSession($){this.d.get($)?.dispose(!0),this.d.delete($)}registerProvider($,m,E){const T=N.a++;return this.c.set(T,E),this.b.$registerProvider(T,m,{extension:$,displayName:$.value}),(0,O.$Sc)(()=>{this.b.$unregisterProvider(T),this.c.delete(T)})}}e.$gnc=N}),define(Se[84],Ie([1,0,4,5,3]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=e.$cmc=void 0;class N{constructor($,m){this.c=m,this.b=new O.$de,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(P.$dM.MainThreadStorage)}registerExtensionStorageKeysToSync($,m){this.a.$registerExtensionStorageKeysToSync($,m)}async initializeExtensionStorage($,m,E){const T=await this.a.$initializeExtensionStorage($,m);let S;return T&&(S=this.d($,m,T)),S||E}setValue($,m,E){return this.a.$setValue($,m,E)}$acceptValue($,m,E){const T=this.d($,m,E);T&&this.b.fire({shared:$,key:m,value:T})}d($,m,E){try{return JSON.parse(E)}catch(T){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${m}, global: ${$}): ${T}`)}}}e.$cmc=N,e.$dmc=(0,M.$wi)("IExtHostStorage")}),define(Se[251],Ie([1,0,6,16,2,4]),function(he,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wnc=void 0;class A{static{this.a=new Set([O.Schemas.http,O.Schemas.https])}constructor(m){this.c=new Map,this.b=m.getProxy(N.$dM.MainThreadUriOpeners)}registerExternalUriOpener(m,E,T,S){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const l=S.schemes.find(b=>!A.a.has(b));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(E,T),this.b.$registerUriOpener(E,S.schemes,m,S.label),(0,P.$Sc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri(m,E,T){const S=this.c.get(m);if(!S)throw new Error(`Unknown opener with id: ${m}`);const l=M.URI.revive(E);return S.canOpenExternalUri(l,T)}async $openUri(m,E,T){const S=this.c.get(m);if(!S)throw new Error(`Unknown opener id: '${m}'`);return S.openExternalUri(M.URI.revive(E.resolvedUri),{sourceUri:M.URI.revive(E.sourceUri)},T)}}e.$wnc=A}),define(Se[252],Ie([1,0,4,2,6,14,20]),function(he,e,P,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xnc=void 0;class ${static{this.a=0}constructor(E){this.c=new A.$Sm,this.d=new Map,this.b=E.getProxy(P.$dM.MainThreadUrls)}registerUriHandler(E,T){const S=E.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const l=$.a++;return this.c.add(S),this.d.set(l,T),this.b.$registerUriHandler(l,S,E.displayName||E.name),(0,M.$Sc)(()=>{this.c.delete(S),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(E,T){const S=this.d.get(E);if(!S)return Promise.resolve(void 0);try{S.handleUri(O.URI.revive(T))}catch(l){(0,N.$1)(l)}return Promise.resolve(void 0)}async createAppUri(E){return O.URI.revive(await this.b.$createAppUri(E))}}e.$xnc=$}),define(Se[64],Ie([1,0,5,6,16,25,2,197,221,78,4]),function(he,e,P,O,M,N,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=e.$Zlc=void 0,e.$1lc=l,e.$3lc=r,e.$4lc=s;class S{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(c,u,t,d,a,f,w){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new P.$de,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new P.$de,this._onDidDispose=this.#h.event,this.#e=c,this.#t=u,this.#o=t,this.#n=d,this.#s=a,this.#r=f,this.#l=l(f),this.#d=b(f),this.#i=w}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,E.$VAb)(c,this.#n)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===M.Schemas.https||c.scheme===M.Schemas.http){let u=c.toString();return u.endsWith("/")||(u+="/"),u+" "+E.$UAb}return E.$UAb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#o}set options(c){this.a(),N.$7n(this.#o,c)||this.#t.$setOptions(this.#e,s(this.#r,this.#s,c)),this.#o=c}async postMessage(c){if(this.#c)return!1;const u=(0,m.$Orb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,u.message,...u.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const u=this.#r.extensionLocation?.scheme===M.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===M.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(d,a,f,w,p,v)=>{const y=A.URI.from({scheme:w||"file",path:decodeURIComponent(p)}),h=(0,E.$VAb)(y,{isRemote:u,authority:t}).toString();return`${a}${h}${v}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(d,a,f,w,p,v)=>{const y=A.URI.from({scheme:w||"file",path:decodeURIComponent(p)}),h=(0,E.$VAb)(y,{isRemote:u,authority:t}).toString();return`${a}${h}${v}`})}}e.$Zlc=S;function l(i){try{const c=(0,$.$Ip)((0,$.$Hp)(i.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}function b(i){try{const c=(0,$.$Ip)((0,$.$Hp)(i.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class g extends O.$Uc{constructor(c,u,t,d,a){super(),this.c=u,this.f=t,this.g=d,this.h=a,this.b=new Map,this.a=c.getProxy(T.$dM.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,u,t){const d=this.j(c);if(d){const{message:a}=(0,m.$Prb)(u,t.value);d._onMessageEmitter.fire(a)}}$onMissingCsp(c,u){this.g.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,u,t){const d=new S(c,this.a,o(u),this.c,this.f,t,this.h);this.b.set(c,d);const a=d._onDidDispose(()=>{a.dispose(),this.deleteWebview(c)});return d}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$2lc=g;function r(i){return{id:i.identifier,location:i.extensionLocation}}function s(i,c,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||n(i,c)}}function o(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(c=>A.URI.from(c))}}function n(i,c){return[...(c?.getWorkspaceFolders()||[]).map(u=>u.uri),i.extensionLocation]}}),define(Se[111],Ie([1,0,5,16,13,2,3,17,4]),function(he,e,P,O,M,N,A,$,m){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Anc=e.$znc=void 0;let T=class{static{E=this}static{this.a={focused:!0,active:!0}}getState(){const l=this.d;return{get focused(){return l.focused},get active(){return l.active}}}constructor(l){this.c=new P.$de,this.onDidChangeWindowState=this.c.event,this.d=E.a,this.b=l.getProxy(m.$dM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:b,isActive:g})=>{this.onDidChangeWindowProperty("focused",b),this.onDidChangeWindowProperty("active",g)})}$onDidChangeWindowFocus(l){this.onDidChangeWindowProperty("focused",l)}$onDidChangeWindowActive(l){this.onDidChangeWindowProperty("active",l)}onDidChangeWindowProperty(l,b){b!==this.d[l]&&(this.d={...this.d,[l]:b},this.c.fire(this.d))}openUri(l,b){let g;if(typeof l=="string"){g=l;try{l=N.URI.parse(l)}catch{return Promise.reject(`Invalid uri - '${l}'`)}}return(0,M.$7e)(l.scheme)?Promise.reject("Invalid scheme - cannot be empty"):l.scheme===O.Schemas.command?Promise.reject(`Invalid scheme '${l.scheme}'`):this.b.$openUri(l,g,b)}async asExternalUri(l,b){if((0,M.$7e)(l.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this.b.$asExternalUri(l,b);return N.URI.from(g)}};e.$znc=T,e.$znc=T=E=Ke([We(0,$.$EO)],T),e.$Anc=(0,A.$wi)("IExtHostWindow")}),define(Se[253],Ie([1,0,244,27,17]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lpc=void 0;let N=class extends P.$Dnc{constructor($,m){super($,m)}f($,m,E){m.apply(console,E)}};e.$Lpc=N,e.$Lpc=N=Ke([We(0,M.$EO),We(1,O.$UO)],N)}),define(Se[254],Ie([1,0,11,21,24,14,5,6,150,242,34]),function(he,e,P,O,M,N,A,$,m,E,T){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$cac=e.ResponsiveState=e.RequestInitiator=void 0,e.$aac=s,e.$bac=o;function l(k,C){try{return JSON.stringify(k,C)}catch{return"null"}}const b="$$ref$$",g={[b]:-1};class r{constructor(C,I){this.jsonString=C,this.referencedBuffers=I}}function s(k,C=null,I=!1){const W=[];return{jsonString:(I?l:JSON.stringify)(k,(q,R)=>{if(typeof R>"u")return g;if(typeof R=="object"){if(R instanceof O.$Fe){const B=W.push(R)-1;return{[b]:B}}if(C)return C(q,R)}return R}),referencedBuffers:W}}function o(k,C,I){return JSON.parse(k,(W,V)=>{if(V){const q=V[b];if(typeof q=="number")return C[q];if(I&&V.$mid===1)return I.transformIncoming(V)}return V})}function n(k,C){return JSON.stringify(k,C)}function i(k){return k?(C,I)=>I&&I.$mid===1?k.transformOutgoing(I):I:null}var c;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var u;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const t=()=>{},d=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class f extends $.$Uc{static{S=d}static{this.a=3*1e3}constructor(C,I=null,W=null){super(),this[S]=!0,this.b=this.B(new A.$de),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=I,this.g=W,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let V=0,q=T.$yw.count;V<q;V++)this.m[V]=null,this.s[V]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new P.$Ih(()=>this.H(),1e3)),this.c.onMessage(V=>this.L(V))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const I=this.w[C];delete this.w[C],I.resolveErr(N.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+f.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+f.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,m.$Bn)(C,this.g):C}getProxy(C){const{nid:I,sid:W}=C;return this.s[I]||(this.s[I]=this.J(I,W)),this.s[I]}J(C,I){const W={get:(V,q)=>(typeof q=="string"&&!V[q]&&q.charCodeAt(0)===36&&(V[q]=(...R)=>this.U(C,q,R)),q===a?I:V[q])};return new Proxy(Object.create(null),W)}set(C,I){return this.m[C.nid]=I,I}assertRegistered(C){for(let I=0,W=C.length;I<W;I++){const V=C[I];if(!this.m[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}L(C){if(this.j)return;const I=C.byteLength,W=p.read(C,0),V=W.readUInt8(),q=W.readUInt32();switch(V){case 1:case 2:{let{rpcId:R,method:B,args:K}=y.deserializeRequestJSONArgs(W);this.g&&(K=(0,m.$Bn)(K,this.g)),this.M(I,q,R,B,K,V===2);break}case 3:case 4:{let{rpcId:R,method:B,args:K}=y.deserializeRequestMixedArgs(W);this.g&&(K=(0,m.$Bn)(K,this.g)),this.M(I,q,R,B,K,V===4);break}case 5:{this.f?.logIncoming(I,q,0,"ack"),this.G(q);break}case 6:{this.N(I,q);break}case 7:{this.O(I,q,void 0);break}case 9:{let R=y.deserializeReplyOKJSON(W);this.g&&(R=(0,m.$Bn)(R,this.g)),this.O(I,q,R);break}case 10:{const R=y.deserializeReplyOKJSONWithBuffers(W,this.g);this.O(I,q,R);break}case 8:{const R=y.deserializeReplyOKVSBuffer(W);this.O(I,q,R);break}case 11:{let R=y.deserializeReplyErrError(W);this.g&&(R=(0,m.$Bn)(R,this.g)),this.P(I,q,R);break}case 12:{this.P(I,q,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,I,W,V,q,R){this.f?.logIncoming(C,I,1,`receiveRequest ${(0,T.$Aw)(W)}.${V}(`,q);const B=String(I);let K,ie;if(R){const ve=new M.$oe;q.push(ve.token),K=this.Q(W,V,q),ie=()=>ve.cancel()}else K=this.Q(W,V,q),ie=t;this.u[B]=ie;const ce=y.serializeAcknowledged(I);this.f?.logOutgoing(ce.byteLength,I,1,"ack"),this.c.send(ce),K.then(ve=>{delete this.u[B];const ke=y.serializeReplyOK(I,ve,this.h);this.f?.logOutgoing(ke.byteLength,I,1,"reply:",ve),this.c.send(ke)},ve=>{delete this.u[B];const ke=y.serializeReplyErr(I,ve);this.f?.logOutgoing(ke.byteLength,I,1,"replyErr:",ve),this.c.send(ke)})}N(C,I){this.f?.logIncoming(C,I,1,"receiveCancel");const W=String(I);this.u[W]?.()}O(C,I,W){this.f?.logIncoming(C,I,0,"receiveReply:",W);const V=String(I);if(!this.w.hasOwnProperty(V))return;const q=this.w[V];delete this.w[V],q.resolveOk(W)}P(C,I,W){this.f?.logIncoming(C,I,0,"receiveReplyErr:",W);const V=String(I);if(!this.w.hasOwnProperty(V))return;const q=this.w[V];delete this.w[V];let R;W&&(W.$isError?(R=new Error,R.name=W.name,R.message=W.message,R.stack=W.stack):R=W),q.resolveErr(R)}Q(C,I,W){try{return Promise.resolve(this.S(C,I,W))}catch(V){return Promise.reject(V)}}S(C,I,W){const V=this.m[C];if(!V)throw new Error("Unknown actor "+(0,T.$Aw)(C));const q=V[I];if(typeof q!="function")throw new Error("Unknown method "+I+" on actor "+(0,T.$Aw)(C));return q.apply(V,W)}U(C,I,W){if(this.j)return new E.$__b;let V=null;if(W.length>0&&M.CancellationToken.isCancellationToken(W[W.length-1])&&(V=W.pop()),V&&V.isCancellationRequested)return Promise.reject(N.$6());const q=y.serializeRequestArguments(W,this.h),R=++this.t,B=String(R),K=new E.$$_b,ie=new $.$Tc;V&&ie.add(V.onCancellationRequested(()=>{const ve=y.serializeCancel(R);this.f?.logOutgoing(ve.byteLength,R,0,"cancel"),this.c.send(y.serializeCancel(R))})),this.w[B]=new w(K,ie),this.F(R);const ce=y.serializeRequest(R,C,I,q,!!V);return this.f?.logOutgoing(ce.byteLength,R,0,`request: ${(0,T.$Aw)(C)}.${I}(`,W),this.c.send(ce),K}}e.$cac=f;class w{constructor(C,I){this.a=C,this.b=I}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class p{static alloc(C,I,W){const V=new p(O.$Fe.alloc(W+1+4),0);return V.writeUInt8(C),V.writeUInt32(I),V}static read(C,I){return new p(C,I)}get buffer(){return this.a}constructor(C,I){this.a=C,this.b=I}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+C).toString();return this.b+=C,W}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+C).toString();return this.b+=C,W}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const I=this.a.slice(this.b,this.b+C);return this.b+=C,I}static sizeMixedArray(C){let I=0;I+=1;for(let W=0,V=C.length;W<V;W++){const q=C[W];switch(I+=1,q.type){case 1:I+=this.sizeLongString(q.value);break;case 2:I+=this.sizeVSBuffer(q.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString(q.value);for(let R=0;R<q.buffers.length;++R)I+=this.sizeVSBuffer(q.buffers[R]);break;case 4:break}}return I}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let I=0,W=C.length;I<W;I++){const V=C[I];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let q=0;q<V.buffers.length;++q)this.writeBuffer(V.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const I=new Array(C);for(let W=0;W<C;W++)switch(this.readUInt8()){case 1:I[W]=this.readLongString();break;case 2:I[W]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),R=this.readLongString(),B=[];for(let K=0;K<q;++K)B.push(this.readVSBuffer());I[W]=new T.$Bw(o(R,B,null));break}case 4:I[W]=void 0;break}return I}}var v;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(v||(v={}));class y{static a(C){for(let I=0,W=C.length;I<W;I++)if(C[I]instanceof O.$Fe||C[I]instanceof T.$Bw||typeof C[I]>"u")return!0;return!1}static serializeRequestArguments(C,I){if(this.a(C)){const W=[];for(let V=0,q=C.length;V<q;V++){const R=C[V];if(R instanceof O.$Fe)W[V]={type:2,value:R};else if(typeof R>"u")W[V]={type:4};else if(R instanceof T.$Bw){const{jsonString:B,referencedBuffers:K}=s(R.value,I);W[V]={type:3,value:O.$Fe.fromString(B),buffers:K}}else W[V]={type:1,value:O.$Fe.fromString(n(R,I))}}return{type:1,args:W}}return{type:0,args:n(C,I)}}static serializeRequest(C,I,W,V,q){switch(V.type){case 0:return this.b(C,I,W,V.args,q);case 1:return this.c(C,I,W,V.args,q)}}static b(C,I,W,V,q){const R=O.$Fe.fromString(W),B=O.$Fe.fromString(V);let K=0;K+=p.sizeUInt8(),K+=p.sizeShortString(R),K+=p.sizeLongString(B);const ie=p.alloc(q?2:1,C,K);return ie.writeUInt8(I),ie.writeShortString(R),ie.writeLongString(B),ie.buffer}static deserializeRequestJSONArgs(C){const I=C.readUInt8(),W=C.readShortString(),V=C.readLongString();return{rpcId:I,method:W,args:JSON.parse(V)}}static c(C,I,W,V,q){const R=O.$Fe.fromString(W);let B=0;B+=p.sizeUInt8(),B+=p.sizeShortString(R),B+=p.sizeMixedArray(V);const K=p.alloc(q?4:3,C,B);return K.writeUInt8(I),K.writeShortString(R),K.writeMixedArray(V),K.buffer}static deserializeRequestMixedArgs(C){const I=C.readUInt8(),W=C.readShortString(),V=C.readMixedArray(),q=new Array(V.length);for(let R=0,B=V.length;R<B;R++){const K=V[R];typeof K=="string"?q[R]=JSON.parse(K):q[R]=K}return{rpcId:I,method:W,args:q}}static serializeAcknowledged(C){return p.alloc(5,C,0).buffer}static serializeCancel(C){return p.alloc(6,C,0).buffer}static serializeReplyOK(C,I,W){if(typeof I>"u")return this.d(C);if(I instanceof O.$Fe)return this.e(C,I);if(I instanceof T.$Bw){const{jsonString:V,referencedBuffers:q}=s(I.value,W,!0);return this.g(C,V,q)}else return this.f(C,l(I,W))}static d(C){return p.alloc(7,C,0).buffer}static e(C,I){let W=0;W+=p.sizeVSBuffer(I);const V=p.alloc(8,C,W);return V.writeVSBuffer(I),V.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,I){const W=O.$Fe.fromString(I);let V=0;V+=p.sizeLongString(W);const q=p.alloc(9,C,V);return q.writeLongString(W),q.buffer}static g(C,I,W){const V=O.$Fe.fromString(I);let q=0;q+=p.sizeUInt32,q+=p.sizeLongString(V);for(const B of W)q+=p.sizeVSBuffer(B);const R=p.alloc(10,C,q);R.writeUInt32(W.length),R.writeLongString(V);for(const B of W)R.writeBuffer(B);return R.buffer}static deserializeReplyOKJSON(C){const I=C.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(C,I){const W=C.readUInt32(),V=C.readLongString(),q=[];for(let R=0;R<W;++R)q.push(C.readVSBuffer());return new T.$Bw(o(V,q,I))}static serializeReplyErr(C,I){const W=I?l(N.$3(I),null):void 0;if(typeof W!="string")return this.h(C);const V=O.$Fe.fromString(W);let q=0;q+=p.sizeLongString(V);const R=p.alloc(11,C,q);return R.writeLongString(V),R.buffer}static deserializeReplyErrError(C){const I=C.readLongString();return JSON.parse(I)}static h(C){return p.alloc(12,C,0).buffer}}var h;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var D;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(D||(D={}))}),define(Se[255],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Npc=void 0;const P=function(N){const A=$=>{globalThis.removeEventListener("message",A);const m=$.data;Object.defineProperties(globalThis,{postMessage:{value(E,T){m.postMessage(E,T)}},onmessage:{get(){return m.onmessage},set(E){m.onmessage=E}}}),m.addEventListener("message",E=>{globalThis.dispatchEvent(new MessageEvent("message",{data:E.data,ports:E.ports?[...E.ports]:void 0}))}),m.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};globalThis.addEventListener("message",A)}.toString();class O extends EventTarget{constructor(N,A,$){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const m=`((${P})('${A}'))`,E=new Blob([m],{type:"application/javascript"}),T=URL.createObjectURL(E),S=new MessageChannel,l=T,b={type:"_newWorker",id:l,port:S.port2,url:T,options:$};N(b,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{N({type:"_terminateWorker",id:l}),URL.revokeObjectURL(T),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(g){S.port1.onmessage=g}},onmessageerror:{get(){return S.port1.onmessageerror},set(g){S.port1.onmessageerror=g}}}),S.port1.addEventListener("messageerror",g=>{const r=new MessageEvent("messageerror",{data:g.data});this.dispatchEvent(r)}),S.port1.addEventListener("message",g=>{const r=new MessageEvent("message",{data:g.data});this.dispatchEvent(r)}),S.port1.start()}}e.$Npc=O}),define(Se[256],Ie([1,0,21,28,16,56,3]),function(he,e,P,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TJ=e.$QJ=void 0,e.$RJ=T,e.$SJ=S,e.$QJ=(0,A.$wi)("notebookDocumentService");const $=["W","X","Y","Z","a","b","c","d","e","f"],m=new RegExp(`^[${$.join("")}]+`),E=7;function T(b){if(b.scheme!==M.Schemas.vscodeNotebookCell)return;const g=b.fragment.indexOf("s");if(g<0)return;const r=parseInt(b.fragment.substring(0,g).replace(m,""),E),s=(0,P.$Ye)(b.fragment.substring(g+1)).toString();if(!isNaN(r))return{handle:r,notebook:b.with({scheme:s,fragment:null})}}function S(b,g){const r=g.toString(E),o=`${r.length<$.length?$[r.length-1]:"z"}${r}s${(0,P.$Ze)(P.$Fe.fromString(b.scheme),!0,!0)}`;return b.with({scheme:M.Schemas.vscodeNotebookCell,fragment:o})}class l{constructor(){this.a=new O.$Ac}getNotebook(g){if(g.scheme===M.Schemas.vscodeNotebookCell){const r=T(g);if(r){const s=this.a.get(r.notebook);if(s)return s}}return this.a.get(g)}addNotebookDocument(g){this.a.set(g.uri,g)}removeNotebookDocument(g){this.a.delete(g.uri)}}e.$TJ=l,(0,N.$xs)(e.$QJ,l,1)}),define(Se[85],Ie([1,0,21,37,42,70,16,19,22,31,256]),function(he,e,P,O,M,N,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bK=e.$$J=e.CellStatusbarAlignment=e.$0J=e.NotebookEditorPriority=e.$7J=e.$6J=e.$4J=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$3J=e.$2J=e.$1J=e.$ZJ=e.CellKind=e.$YJ=e.$XJ=e.$WJ=void 0,e.$5J=d,e.$8J=f,e.$9J=w,e.$_J=y,e.$aK=D,e.$WJ="workbench.editor.notebook",e.$XJ="workbench.editor.notebookTextDiffEditor",e.$YJ="workbench.editor.interactive";var S;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(S||(e.CellKind=S={})),e.$ZJ=["application/json","application/javascript","text/html","image/svg+xml",N.$Qs.latex,N.$Qs.markdown,"image/png","image/jpeg",N.$Qs.text],e.$1J=[N.$Qs.latex,N.$Qs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",N.$Qs.text],e.$2J=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$3J="_notAvailable";var l;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var b;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(b||(e.NotebookCellExecutionState=b={}));var g;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(g||(e.NotebookExecutionState=g={}));var r;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var s;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(s||(e.RendererMessagingSpec=s={}));var o;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var n;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var c;(function(K){K.scheme=A.Schemas.vscodeNotebookCell;function ie(Ne,ae){return(0,T.$SJ)(Ne,ae)}K.generate=ie;function ce(Ne){return(0,T.$RJ)(Ne)}K.parse=ce;function ve(Ne,ae){return Ne.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${ae??""},${Ne.scheme!==A.Schemas.file?Ne.scheme:""}`})}K.generateCellOutputUri=ve;function ke(Ne){if(Ne.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const ae=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Ne.fragment);if(!ae)return;const Re=ae[1]&&ae[1]!==""?ae[1]:void 0,ne=ae[2];return{outputId:Re,notebook:Ne.with({scheme:ne||A.Schemas.file,fragment:null})}}K.parseCellOutputUri=ke;function fe(Ne,ae,Re){return K.generate(Ne,ae).with({scheme:Re})}K.generateCellPropertyUri=fe;function pe(Ne,ae){if(Ne.scheme===ae)return K.parse(Ne.with({scheme:K.scheme}))}K.parseCellPropertyUri=pe})(c||(e.CellUri=c={}));const u=K=>m.$i?K.replace(/\//g,"\\"):K;class t{constructor(ie=[],ce=e.$ZJ){this.e=ce,this.d=[...new Set(ie)].map(ve=>({pattern:ve,matches:O.$qk(u(ve))}))}sort(ie){const ce=new Map(M.Iterable.map(ie,ke=>[ke,u(ke)]));let ve=[];for(const{matches:ke}of this.d)for(const[fe,pe]of ce)if(ke(pe)){ve.push(fe),ce.delete(fe);break}return ce.size&&(ve=ve.concat([...ce.keys()].sort((ke,fe)=>this.e.indexOf(ke)-this.e.indexOf(fe)))),ve}prioritize(ie,ce){const ve=this.f(ie);if(ve===-1){this.d.unshift({pattern:ie,matches:O.$qk(u(ie))});return}const ke=new Set(ce.map(pe=>this.f(pe,ve)));ke.delete(-1);const fe=Array.from(ke).sort();this.d.splice(ve+1,0,...fe.map(pe=>this.d[pe]));for(let pe=fe.length-1;pe>=0;pe--)this.d.splice(fe[pe],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,ce=this.d.length){const ve=u(ie);for(let ke=0;ke<ce;ke++)if(this.d[ke].matches(ve))return ke;return-1}}e.$4J=t;function d(K,ie,ce,ve=(ke,fe)=>ke===fe){const ke=[];function fe(ae,Re,ne){if(Re===0&&ne.length===0)return;const z=ke[ke.length-1];z&&z.start+z.deleteCount===ae?(z.deleteCount+=Re,z.toInsert.push(...ne)):ke.push({start:ae,deleteCount:Re,toInsert:ne})}let pe=0,Ne=0;for(;;){if(pe===K.length){fe(pe,0,ie.slice(Ne));break}if(Ne===ie.length){fe(pe,K.length-pe,[]);break}const ae=K[pe],Re=ie[Ne];if(ve(ae,Re)){pe+=1,Ne+=1;continue}ce(Re)?(fe(pe,1,[]),pe+=1):(fe(pe,0,[Re]),Ne+=1)}return ke}e.$6J=new E.$Nj("notebookEditorCursorAtBoundary","none"),e.$7J=new E.$Nj("notebookEditorCursorAtLineBoundary","none");var a;(function(K){K.default="default",K.option="option"})(a||(e.NotebookEditorPriority=a={}));function f(K){const ie=K;return!!((typeof ie.include=="string"||O.$rk(ie.include))&&(typeof ie.exclude=="string"||O.$rk(ie.exclude)))}function w(K,ie,ce){if(Array.isArray(K.viewType)&&K.viewType.indexOf(ie)>=0||K.viewType===ie)return!0;if(K.filenamePattern){const ve=f(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,ke=f(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(O.$pk(ve,(0,$.$nc)(ce.fsPath).toLowerCase()))return!(ke&&O.$pk(ke,(0,$.$nc)(ce.fsPath).toLowerCase()))}return!1}e.$0J={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var p;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(p||(e.CellStatusbarAlignment=p={}));class v{static{this.d="notebook/"}static create(ie){return`${v.d}${ie}`}static parse(ie){if(ie.startsWith(v.d))return ie.substring(v.d.length)}}e.$$J=v;function y(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const h=new TextDecoder;function D(K){const ie=[];let ce=!1;for(const pe of K)(ie.length===0||ce)&&(ie.push(pe),ce=!0);let ve=I(ie);const ke=P.$Fe.concat(ie.map(pe=>P.$Fe.wrap(pe))),fe=B(ke);return ve=ve||fe.byteLength!==ke.byteLength,{data:fe,didCompression:ve}}e.$bK="\x1B[A";const k=e.$bK.split("").map(K=>K.charCodeAt(0)),C=10;function I(K){let ie=!1;return K.forEach((ce,ve)=>{if(ve===0||ce.length<e.$bK.length)return;const ke=K[ve-1],fe=ce.subarray(0,e.$bK.length);if(fe[0]===k[0]&&fe[1]===k[1]&&fe[2]===k[2]){const pe=ke.lastIndexOf(C);if(pe===-1)return;ie=!0,K[ve-1]=ke.subarray(0,pe),K[ve]=ce.subarray(e.$bK.length)}}),ie}function W(K){let ie=K;do K=ie,ie=K.replace(/[^\n]\x08/gm,"");while(ie.length<K.length);return K}function V(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const ie=K.match(/^(.*)\r+/m)[1];let ce=K.match(/\r+(.*)$/m)[1];ce=ce+ie.slice(ce.length,ie.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ce)}return K}const q=8,R=13;function B(K){return!K.buffer.includes(q)&&!K.buffer.includes(R)?K:P.$Fe.fromString(V(W(h.decode(K.buffer))))}}),define(Se[7],Ie([1,0,18,14,55,28,70,13,15,2,33,20,38,104,85]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g){"use strict";var r,s,o,n,i,c,u,t,d,a,f,w,p,v,y,h,D;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$sO=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$rO=e.$qO=e.$pO=e.$oO=e.ChatLocation=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$bO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$1N=e.$ZN=e.$YN=e.$XN=e.$VN=e.$UN=e.$TN=e.$SN=e.TestRunProfileKind=e.TestResultState=e.$RN=e.$QN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$PN=e.NotebookVariablesRequestKind=e.$ON=e.$NN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$MN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$LN=e.$KN=e.$JN=e.$IN=e.$HN=e.ColorThemeKind=e.$GN=e.$FN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$EN=e.$DN=e.DebugConsoleMode=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$xN=e.$wN=e.FileChangeType=e.$vN=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$uN=e.$tN=e.$sN=e.$rN=e.InlineCompletionTriggerKind=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=e.$jN=e.$iN=e.$hN=e.$gN=e.$eN=e.ConfigurationTarget=e.$dN=e.$cN=e.$bN=e.$aN=e.DocumentPasteTriggerKind=e.$_M=e.$$M=e.$0M=e.$9M=e.$8M=e.$7M=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$6M=e.ViewBadge=e.ProgressLocation=e.$5M=e.$4M=e.TaskScope=e.ShellQuoting=e.$3M=e.$2M=e.$1M=e.TaskPanelKind=e.TaskRevealKind=e.$ZM=e.TerminalLocation=e.$YM=e.$XM=e.$WM=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$VM=e.$UM=e.$TM=e.$SM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$QM=e.$PM=e.$OM=e.$NM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$MM=e.$LM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.LanguageStatusSeverity=e.$FM=e.$EM=e.$DM=e.$CM=e.$BM=e.$AM=e.CodeActionTriggerKind=e.$zM=e.$yM=e.SymbolTag=e.SymbolKind=e.$xM=e.$wM=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.DiagnosticSeverity=e.DiagnosticTag=e.$qM=e.$pM=e.FileEditType=e.$oM=e.$nM=e.$mM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$RM=Bt,e.$fN=Ge,e.$WN=vn;function k(j){return Object.assign(j,{apply:function(...te){if(te.length===0)return Reflect.construct(j,[]);{const Ee=te.length===1?[]:te[1];return Reflect.construct(j,Ee,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(j,[]);{const[Ee,...He]=te;return Reflect.construct(j,He,Ee.constructor)}}})}var C;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var I;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(I||(e.TerminalQuickFixType=I={}));let W=r=class{static from(...L){let te=L;return new r(function(){if(te){for(const Ee of te)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();te=void 0}})}#e;constructor(L){this.#e=L}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$fM=W,e.$fM=W=r=Ke([k],W);let V=s=class{static Min(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let Ee=1;Ee<L.length;Ee++){const He=L[Ee];He.isBefore(te)&&(te=He)}return te}static Max(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let Ee=1;Ee<L.length;Ee++){const He=L[Ee];He.isAfter(te)&&(te=He)}return te}static isPosition(L){if(!L)return!1;if(L instanceof s)return!0;const{line:te,character:Ee}=L;return typeof te=="number"&&typeof Ee=="number"}static of(L){if(L instanceof s)return L;if(this.isPosition(L))return new s(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(L,te){if(L<0)throw(0,O.$7)("line must be non-negative");if(te<0)throw(0,O.$7)("character must be non-negative");this.c=L,this.e=te}isBefore(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<L.e}isBeforeOrEqual(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<=L.e}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this.c===L.c&&this.e===L.e}compareTo(L){return this.c<L.c?-1:this.c>L.line?1:this.e<L.e?-1:this.e>L.e?1:0}translate(L,te=0){if(L===null||te===null)throw(0,O.$7)();let Ee;return typeof L>"u"?Ee=0:typeof L=="number"?Ee=L:(Ee=typeof L.lineDelta=="number"?L.lineDelta:0,te=typeof L.characterDelta=="number"?L.characterDelta:0),Ee===0&&te===0?this:new s(this.line+Ee,this.character+te)}with(L,te=this.character){if(L===null||te===null)throw(0,O.$7)();let Ee;return typeof L>"u"?Ee=this.line:typeof L=="number"?Ee=L:(Ee=typeof L.line=="number"?L.line:this.line,te=typeof L.character=="number"?L.character:this.character),Ee===this.line&&te===this.character?this:new s(Ee,te)}toJSON(){return{line:this.line,character:this.character}}};e.$gM=V,e.$gM=V=s=Ke([k],V);let q=o=class{static isRange(L){return L instanceof o?!0:L?V.isPosition(L.start)&&V.isPosition(L.end):!1}static of(L){if(L instanceof o)return L;if(this.isRange(L))return new o(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(L,te,Ee,He){let Ye,lt;if(typeof L=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof He=="number"?(Ye=new V(L,te),lt=new V(Ee,He)):V.isPosition(L)&&V.isPosition(te)&&(Ye=V.of(L),lt=V.of(te)),!Ye||!lt)throw new Error("Invalid arguments");Ye.isBefore(lt)?(this.c=Ye,this.e=lt):(this.c=lt,this.e=Ye)}contains(L){return o.isRange(L)?this.contains(L.start)&&this.contains(L.end):V.isPosition(L)?!(V.of(L).isBefore(this.c)||this.e.isBefore(L)):!1}isEqual(L){return this.c.isEqual(L.c)&&this.e.isEqual(L.e)}intersection(L){const te=V.Max(L.start,this.c),Ee=V.Min(L.end,this.e);if(!te.isAfter(Ee))return new o(te,Ee)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const te=V.Min(L.start,this.c),Ee=V.Max(L.end,this.end);return new o(te,Ee)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(L,te=this.end){if(L===null||te===null)throw(0,O.$7)();let Ee;return L?V.isPosition(L)?Ee=L:(Ee=L.start||this.start,te=L.end||this.end):Ee=this.start,Ee.isEqual(this.c)&&te.isEqual(this.end)?this:new o(Ee,te)}toJSON(){return[this.start,this.end]}};e.$hM=q,e.$hM=q=o=Ke([k],q);let R=n=class extends q{static isSelection(L){return L instanceof n?!0:L?q.isRange(L)&&V.isPosition(L.anchor)&&V.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(L,te,Ee,He){let Ye,lt;if(typeof L=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof He=="number"?(Ye=new V(L,te),lt=new V(Ee,He)):V.isPosition(L)&&V.isPosition(te)&&(Ye=V.of(L),lt=V.of(te)),!Ye||!lt)throw new Error("Invalid arguments");super(Ye,lt),this.f=Ye,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$iM=R,e.$iM=R=n=Ke([k],R);const B=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,O.$7)("connectionToken")};class K{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,te,Ee){if(typeof L!="string"||L.length===0)throw(0,O.$7)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,O.$7)("port");typeof Ee<"u"&&B(Ee),this.host=L,this.port=Math.round(te),this.connectionToken=Ee}}e.$jM=K;class ie{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,te){this.makeConnection=L,this.connectionToken=te,typeof te<"u"&&B(te)}}e.$kM=ie;class ce extends Error{static NotAvailable(L,te){return new ce(L,b.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(L){return new ce(L,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,te=b.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(L),this._message=L,this._code=te,this._detail=Ee,Object.setPrototypeOf(this,ce.prototype)}}e.$lM=ce;var ve;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(ve||(e.EndOfLine=ve={}));var ke;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(ke||(e.EnvironmentVariableMutatorType=ke={}));let fe=i=class{static isTextEdit(L){return L instanceof i?!0:L?q.isRange(L)&&typeof L.newText=="string":!1}static replace(L,te){return new i(L,te)}static insert(L,te){return i.replace(new q(L,L),te)}static delete(L){return i.replace(L,"")}static setEndOfLine(L){const te=new i(new q(new V(0,0),new V(0,0)),"");return te.newEol=L,te}get range(){return this.c}set range(L){if(L&&!q.isRange(L))throw(0,O.$7)("range");this.c=L}get newText(){return this.e||""}set newText(L){if(L&&typeof L!="string")throw(0,O.$7)("newText");this.e=L}get newEol(){return this.f}set newEol(L){if(L&&typeof L!="number")throw(0,O.$7)("newEol");this.f=L}constructor(L,te){this.c=L,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$mM=fe,e.$mM=fe=i=Ke([k],fe);let pe=c=class{static isNotebookCellEdit(L){return L instanceof c?!0:L?gi.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,te){return new c(L,te)}static insertCells(L,te){return new c(new gi(L,L),te)}static deleteCells(L){return new c(L,[])}static updateCellMetadata(L,te){const Ee=new c(new gi(L,L),[]);return Ee.newCellMetadata=te,Ee}static updateNotebookMetadata(L){const te=new c(new gi(0,0),[]);return te.newNotebookMetadata=L,te}constructor(L,te){this.range=L,this.newCells=te}};e.$nM=pe,e.$nM=pe=c=Ke([k],pe);class Ne{static isSnippetTextEdit(L){return L instanceof Ne?!0:L?q.isRange(L.range)&&ne.isSnippetString(L.snippet):!1}static replace(L,te){return new Ne(L,te)}static insert(L,te){return Ne.replace(new q(L,L),te)}constructor(L,te){this.range=L,this.snippet=te}}e.$oM=Ne;var ae;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(ae||(e.FileEditType=ae={}));let Re=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(L,te,Ee,He){this.c.push({_type:1,from:L,to:te,options:Ee,metadata:He})}createFile(L,te,Ee){this.c.push({_type:1,from:void 0,to:L,options:te,metadata:Ee})}deleteFile(L,te,Ee){this.c.push({_type:1,from:L,to:void 0,options:te,metadata:Ee})}e(L,te,Ee){this.c.push({_type:3,metadata:Ee,uri:L,edit:{editType:5,metadata:te},notebookMetadata:te})}f(L,te,Ee,He){const Ye=te.start,lt=te.end;(Ye!==lt||Ee.length>0)&&this.c.push({_type:5,uri:L,index:Ye,count:lt-Ye,cells:Ee,metadata:He})}g(L,te,Ee,He){this.c.push({_type:3,metadata:He,uri:L,edit:{editType:3,index:te,metadata:Ee}})}replace(L,te,Ee,He){this.c.push({_type:2,uri:L,edit:new fe(te,Ee),metadata:He})}insert(L,te,Ee,He){this.replace(L,new q(te,te),Ee,He)}delete(L,te,Ee){this.replace(L,te,"",Ee)}has(L){return this.c.some(te=>te._type===2&&te.uri.toString()===L.toString())}set(L,te){if(te)for(const Ee of te){if(!Ee)continue;let He,Ye;Array.isArray(Ee)?(He=Ee[0],Ye=Ee[1]):He=Ee,pe.isNotebookCellEdit(He)?He.newCellMetadata?this.g(L,He.range.start,He.newCellMetadata,Ye):He.newNotebookMetadata?this.e(L,He.newNotebookMetadata,Ye):this.f(L,He.range,He.newCells,Ye):Ne.isSnippetTextEdit(He)?this.c.push({_type:6,uri:L,range:He.range,edit:He.snippet,metadata:Ye}):this.c.push({_type:2,uri:L,edit:He,metadata:Ye})}else{for(let Ee=0;Ee<this.c.length;Ee++){const He=this.c[Ee];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===L.toString()&&(this.c[Ee]=void 0);break}}(0,P.$Ib)(this.c)}}get(L){const te=[];for(const Ee of this.c)Ee._type===2&&Ee.uri.toString()===L.toString()&&te.push(Ee.edit);return te}entries(){const L=new N.$Ac;for(const te of this.c)if(te._type===2){let Ee=L.get(te.uri);Ee||(Ee=[te.uri,[]],L.set(te.uri,Ee)),Ee[1].push(te.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$pM=Re,e.$pM=Re=Ke([k],Re);let ne=u=class{static isSnippetString(L){return L instanceof u?!0:L?typeof L.value=="string":!1}static c(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this.e=1,this.value=L||""}appendText(L){return this.value+=u.c(L),this}appendTabstop(L=this.e++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,te=this.e++){if(typeof L=="function"){const Ee=new u;Ee.e=this.e,L(Ee),this.e=Ee.e,L=Ee.value}else L=u.c(L);return this.value+="${",this.value+=te,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,te=this.e++){const Ee=L.map(He=>He.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(L,te){if(typeof te=="function"){const Ee=new u;Ee.e=this.e,te(Ee),this.e=Ee.e,te=Ee.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$qM=ne,e.$qM=ne=u=Ke([k],ne);var z;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(z||(e.DiagnosticTag=z={}));var x;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(x||(e.DiagnosticSeverity=x={}));let be=t=class{static isLocation(L){return L instanceof t?!0:L?q.isRange(L.range)&&E.URI.isUri(L.uri):!1}constructor(L,te){if(this.uri=L,te)if(q.isRange(te))this.range=q.of(te);else if(V.isPosition(te))this.range=new q(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$rM=be,e.$rM=be=t=Ke([k],be);let Te=class{static is(L){return L?typeof L.message=="string"&&L.location&&q.isRange(L.location.range)&&E.URI.isUri(L.location.uri):!1}constructor(L,te){this.location=L,this.message=te}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.location.range.isEqual(te.location.range)&&L.location.uri.toString()===te.location.uri.toString()}};e.$sM=Te,e.$sM=Te=Ke([k],Te);let De=class{constructor(L,te,Ee=x.Error){if(!q.isRange(L))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=L,this.message=te,this.severity=Ee}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.severity===te.severity&&L.code===te.code&&L.severity===te.severity&&L.source===te.source&&L.range.isEqual(te.range)&&(0,P.$ub)(L.tags,te.tags)&&(0,P.$ub)(L.relatedInformation,te.relatedInformation,Te.isEqual)}};e.$tM=De,e.$tM=De=Ke([k],De);let we=class{constructor(L,te){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=te}};e.$uM=we,e.$uM=we=Ke([k],we);let ge=class extends we{constructor(L,te,Ee,He){super(L,te),this.canIncreaseHover=Ee,this.canDecreaseHover=He}};e.$vM=ge,e.$vM=ge=Ke([k],ge);var Q;(function(j){j[j.Increase=0]="Increase",j[j.Decrease=1]="Decrease"})(Q||(e.HoverVerbosityAction=Q={}));var Y;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(Y||(e.DocumentHighlightKind=Y={}));let le=class{constructor(L,te=Y.Text){this.range=L,this.kind=te}toJSON(){return{range:this.range,kind:Y[this.kind]}}};e.$wM=le,e.$wM=le=Ke([k],le);let ue=class{constructor(L,te){this.uri=L,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(L=>L.toJSON())}}};e.$xM=ue,e.$xM=ue=Ke([k],ue);var Oe;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Oe||(e.SymbolKind=Oe={}));var de;(function(j){j[j.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let Ce=d=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,te,Ee,He,Ye){this.name=L,this.kind=te,this.containerName=Ye,typeof Ee=="string"&&(this.containerName=Ee),He instanceof be?this.location=He:Ee instanceof q&&(this.location=new be(He,Ee)),d.validate(this)}toJSON(){return{name:this.name,kind:Oe[this.kind],location:this.location,containerName:this.containerName}}};e.$yM=Ce,e.$yM=Ce=d=Ke([k],Ce);let Me=a=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(a.validate)}constructor(L,te,Ee,He,Ye){this.name=L,this.detail=te,this.kind=Ee,this.range=He,this.selectionRange=Ye,this.children=[],a.validate(this)}};e.$zM=Me,e.$zM=Me=a=Ke([k],Me);var je;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(je||(e.CodeActionTriggerKind=je={}));let U=class{constructor(L,te){this.title=L,this.kind=te}};e.$AM=U,e.$AM=U=Ke([k],U);let F=class{static{f=this}static{this.c="."}constructor(L){this.value=L}append(L){return new f(this.value?this.value+f.c+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+f.c)}};e.$BM=F,e.$BM=F=f=Ke([k],F),F.Empty=new F(""),F.QuickFix=F.Empty.append("quickfix"),F.Refactor=F.Empty.append("refactor"),F.RefactorExtract=F.Refactor.append("extract"),F.RefactorInline=F.Refactor.append("inline"),F.RefactorMove=F.Refactor.append("move"),F.RefactorRewrite=F.Refactor.append("rewrite"),F.Source=F.Empty.append("source"),F.SourceOrganizeImports=F.Source.append("organizeImports"),F.SourceFixAll=F.Source.append("fixAll"),F.Notebook=F.Empty.append("notebook");let G=class{constructor(L,te){if(this.range=L,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$CM=G,e.$CM=G=Ke([k],G);class H{constructor(L,te,Ee,He,Ye,lt){this.kind=L,this.name=te,this.detail=Ee,this.uri=He,this.range=Ye,this.selectionRange=lt}}e.$DM=H;class ee{constructor(L,te){this.fromRanges=te,this.from=L}}e.$EM=ee;class re{constructor(L,te){this.fromRanges=te,this.to=L}}e.$FM=re;var Ae;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Ae||(e.LanguageStatusSeverity=Ae={}));let Be=class{constructor(L,te){this.range=L,this.command=te}get isResolved(){return!!this.command}};e.$GM=Be,e.$GM=Be=Ke([k],Be);let qe=w=class{#e;static isMarkdownString(L){return L instanceof w?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,te=!1){this.#e=new M.$Tk(L,{supportThemeIcons:te})}get value(){return this.#e.value}set value(L){this.#e.value=L}get isTrusted(){return this.#e.isTrusted}set isTrusted(L){this.#e.isTrusted=L}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(L){this.#e.supportThemeIcons=L}get supportHtml(){return this.#e.supportHtml}set supportHtml(L){this.#e.supportHtml=L}get baseUri(){return this.#e.baseUri}set baseUri(L){this.#e.baseUri=L}appendText(L){return this.#e.appendText(L),this}appendMarkdown(L){return this.#e.appendMarkdown(L),this}appendCodeblock(L,te){return this.#e.appendCodeblock(te??"",L),this}};e.$HM=qe,e.$HM=qe=w=Ke([k],qe);let et=class{constructor(L,te){this.label=L,this.documentation=te}};e.$IM=et,e.$IM=et=Ke([k],et);let xe=class{constructor(L,te){this.label=L,this.documentation=te,this.parameters=[]}};e.$JM=xe,e.$JM=xe=Ke([k],xe);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$KM=_e,e.$KM=_e=Ke([k],_e);var tt;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var rt;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let ct=class{constructor(L){this.value=L}};e.$LM=ct,e.$LM=ct=Ke([k],ct);let ft=class{constructor(L,te,Ee){this.position=L,this.label=te,this.kind=Ee}};e.$MM=ft,e.$MM=ft=Ke([k],ft);var Ue;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ue||(e.CompletionTriggerKind=Ue={}));var ot;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(ot||(e.CompletionItemKind=ot={}));var X;(function(j){j[j.Deprecated=1]="Deprecated"})(X||(e.CompletionItemTag=X={}));let Z=class{constructor(L,te){this.label=L,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&ot[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$NM=Z,e.$NM=Z=Ke([k],Z);let $e=class{constructor(L=[],te=!1){this.items=L,this.isIncomplete=te}};e.$OM=$e,e.$OM=$e=Ke([k],$e);let me=class{constructor(L,te,Ee){this.insertText=L,this.range=te,this.command=Ee}};e.$PM=me,e.$PM=me=Ke([k],me);let Ze=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.$QM=Ze,e.$QM=Ze=Ke([k],Ze);var at;(function(j){j[j.Unknown=0]="Unknown",j[j.Word=1]="Word",j[j.Line=2]="Line",j[j.Suggest=3]="Suggest"})(at||(e.PartialAcceptTriggerKind=at={}));var dt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(dt||(e.ViewColumn=dt={}));var Ct;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ct||(e.StatusBarAlignment=Ct={}));function Bt(j,L){return`${S.$Rm.toKey(j)}.${L}`}var Qt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval"})(Qt||(e.TextEditorLineNumbersStyle=Qt={}));var xt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(xt||(e.TextDocumentSaveReason=xt={}));var Zt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Zt||(e.TextEditorRevealType=Zt={}));var kt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(kt||(e.TextEditorSelectionChangeKind=kt={}));var _t;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var Xe;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Xe||(e.DecorationRangeBehavior=Xe={})),function(j){function L(te){switch(te){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=L}(kt||(e.TextEditorSelectionChangeKind=kt={}));var ti;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(ti||(e.SyntaxTokenType=ti={})),function(j){function L(te){switch(te){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=L}(ti||(e.SyntaxTokenType=ti={}));let ii=class{constructor(L,te){if(te&&!E.URI.isUri(te))throw(0,O.$7)("target");if(!q.isRange(L)||L.isEmpty)throw(0,O.$7)("range");this.range=L,this.target=te}};e.$SM=ii,e.$SM=ii=Ke([k],ii);let ht=class{constructor(L,te,Ee,He){this.red=L,this.green=te,this.blue=Ee,this.alpha=He}};e.$TM=ht,e.$TM=ht=Ke([k],ht);let pt=class{constructor(L,te){if(te&&!(te instanceof ht))throw(0,O.$7)("color");if(!q.isRange(L)||L.isEmpty)throw(0,O.$7)("range");this.range=L,this.color=te}};e.$UM=pt,e.$UM=pt=Ke([k],pt);let Lt=class{constructor(L){if(!L||typeof L!="string")throw(0,O.$7)("label");this.label=L}};e.$VM=Lt,e.$VM=Lt=Ke([k],Lt);var Gt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Gt||(e.ColorFormat=Gt={}));var Tt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Tt||(e.SourceControlInputBoxValidationType=Tt={}));var mt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(mt||(e.TerminalExitReason=mt={}));var Pt;(function(j){j[j.Low=0]="Low",j[j.Medium=1]="Medium",j[j.High=2]="High"})(Pt||(e.TerminalShellExecutionCommandLineConfidence=Pt={}));class ai{constructor(L,te,Ee){if(this.startIndex=L,this.length=te,this.tooltip=Ee,typeof L!="number"||L<0)throw(0,O.$7)("startIndex");if(typeof te!="number"||te<1)throw(0,O.$7)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,O.$7)("tooltip")}}e.$WM=ai;class Ut{constructor(L){this.uri=L}}e.$XM=Ut;class Je{constructor(L){this.terminalCommand=L}}e.$YM=Je;var ni;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(ni||(e.TerminalLocation=ni={}));class ci{constructor(L){if(this.options=L,typeof L!="object")throw(0,O.$7)("options")}}e.$ZM=ci;var Ht;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(Ht||(e.TaskRevealKind=Ht={}));var gt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(gt||(e.TaskPanelKind=gt={}));let At=class{static{p=this}static{this.Clean=new p("clean","Clean")}static{this.Build=new p("build","Build")}static{this.Rebuild=new p("rebuild","Rebuild")}static{this.Test=new p("test","Test")}static from(L){switch(L){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}constructor(L,te){if(this.label=te,typeof L!="string"||typeof te!="string")throw(0,O.$7)("name");this.c=L}get id(){return this.c}};e.$1M=At,e.$1M=At=p=Ke([k],At);function Ot(j){let L="";for(let te=0;te<j.length;te++)L+=j[te].replace(/,/g,",,")+",";return L}let Nt=class{constructor(L,te,Ee){if(typeof L!="string")throw(0,O.$7)("process");this.e=[],this.c=L,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=Ee):this.f=te)}get process(){return this.c}set process(L){if(typeof L!="string")throw(0,O.$7)("process");this.c=L}get args(){return this.e}set args(L){Array.isArray(L)||(L=[]),this.e=L}get options(){return this.f}set options(L){this.f=L}computeId(){const L=[];if(L.push("process"),this.c!==void 0&&L.push(this.c),this.e&&this.e.length>0)for(const te of this.e)L.push(te);return Ot(L)}};e.$2M=Nt,e.$2M=Nt=Ke([k],Nt);let Vt=class{constructor(L,te,Ee){if(this.f=[],Array.isArray(te)){if(!L)throw(0,O.$7)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,O.$7)("command");this.e=L,this.f=te,this.g=Ee}else{if(typeof L!="string")throw(0,O.$7)("commandLine");this.c=L,this.g=te}}get commandLine(){return this.c}set commandLine(L){if(typeof L!="string")throw(0,O.$7)("commandLine");this.c=L}get command(){return this.e?this.e:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,O.$7)("command");this.e=L}get args(){return this.f}set args(L){this.f=L||[]}get options(){return this.g}set options(L){this.g=L}computeId(){const L=[];if(L.push("shell"),this.c!==void 0&&L.push(this.c),this.e!==void 0&&L.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)L.push(typeof te=="string"?te:te.value);return Ot(L)}};e.$3M=Vt,e.$3M=Vt=Ke([k],Vt);var Xt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Xt||(e.ShellQuoting=Xt={}));var Kt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Kt||(e.TaskScope=Kt={}));class zt{constructor(L){this.c=L}computeId(){return"customExecution"+(0,T.$Sg)()}set callback(L){this.c=L}get callback(){return this.c}}e.$4M=zt;let Mt=class{static{v=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(L,te,Ee,He,Ye,lt){this.k=!1,this.l=this.definition=L;let $t;typeof te=="string"?(this.o=this.name=te,this.w=this.source=Ee,this.execution=He,$t=Ye,this.k=!0):te===Kt.Global||te===Kt.Workspace?(this.target=te,this.o=this.name=Ee,this.w=this.source=He,this.execution=Ye,$t=lt):(this.target=te,this.o=this.name=Ee,this.w=this.source=He,this.execution=Ye,$t=lt),typeof $t=="string"?(this.r=[$t],this.t=!0):Array.isArray($t)?(this.r=$t,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(L){this.j=L}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Nt?this.l={type:v.e,id:this.q.computeId()}:this.q instanceof Vt?this.l={type:v.f,id:this.q.computeId()}:this.q instanceof zt?this.l={type:v.c,id:this.q.computeId()}:this.l={type:v.g,id:(0,T.$Sg)()}}get definition(){return this.l}set definition(L){if(L==null)throw(0,O.$7)("Kind can't be undefined or null");this.B(),this.l=L}get scope(){return this.m}set target(L){this.B(),this.m=L}get name(){return this.o}set name(L){if(typeof L!="string")throw(0,O.$7)("name");this.B(),this.o=L}get execution(){return this.q}set execution(L){L===null&&(L=void 0),this.B(),this.q=L;const te=this.l.type;(v.g===te||v.e===te||v.f===te||v.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(L){if(Array.isArray(L))this.B(),this.r=L,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.B(),this.u=L}get source(){return this.w}set source(L){if(typeof L!="string"||L.length===0)throw(0,O.$7)("source must be a string of length > 0");this.B(),this.w=L}get group(){return this.x}set group(L){L===null&&(L=void 0),this.B(),this.x=L}get detail(){return this.A}set detail(L){L===null&&(L=void 0),this.A=L}get presentationOptions(){return this.y}set presentationOptions(L){L==null&&(L=Object.create(null)),this.B(),this.y=L}get runOptions(){return this.z}set runOptions(L){L==null&&(L=Object.create(null)),this.B(),this.z=L}};e.$5M=Mt,e.$5M=Mt=v=Ke([k],Mt);var Jt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(Jt||(e.ProgressLocation=Jt={}));var St;(function(j){function L(te){const Ee=te;return(0,m.$ag)(Ee.value)?Ee.tooltip&&!(0,m.$9f)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}j.isViewBadge=L})(St||(e.ViewBadge=St={}));let yt=y=class{static isTreeItem(L,te){const Ee=L;if(Ee.checkboxState!==void 0){const He=(0,m.$ag)(Ee.checkboxState)?Ee.checkboxState:(0,m.$$f)(Ee.checkboxState)&&(0,m.$ag)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,Ye=!(0,m.$ag)(Ee.checkboxState)&&(0,m.$$f)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(He===void 0||He!==Yt.Checked&&He!==Yt.Unchecked||Ye!==void 0&&!(0,m.$9f)(Ye))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}if(L instanceof y)return!0;if(Ee.label!==void 0&&!(0,m.$9f)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,m.$9f)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,m.$9f)(Ee.iconPath)&&!E.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,m.$9f)(Ee.iconPath.id))){const He=Ee.iconPath;if(!He||!(0,m.$9f)(He.light)&&!E.URI.isUri(He.light)&&!(0,m.$9f)(He.dark)&&!E.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}return Ee.description!==void 0&&!(0,m.$9f)(Ee.description)&&typeof Ee.description!="boolean"?(console.log("INVALID tree item, invalid description",Ee.description),!1):Ee.resourceUri!==void 0&&!E.URI.isUri(Ee.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1):Ee.tooltip!==void 0&&!(0,m.$9f)(Ee.tooltip)&&!(Ee.tooltip instanceof qe)?(console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1):Ee.command!==void 0&&!Ee.command.command?(console.log("INVALID tree item, invalid command",Ee.command),!1):Ee.collapsibleState!==void 0&&Ee.collapsibleState<wt.None&&Ee.collapsibleState>wt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1):Ee.contextValue!==void 0&&!(0,m.$9f)(Ee.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1):Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1):!0}constructor(L,te=wt.None){this.collapsibleState=te,E.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.$6M=yt,e.$6M=yt=y=Ke([k],yt);var wt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(wt||(e.TreeItemCollapsibleState=wt={}));var Yt;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(Yt||(e.TreeItemCheckboxState=Yt={}));let Et=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.$7M=Et,e.$7M=Et=Ke([k],Et);class ui extends Et{}e.$8M=ui;class ei extends ui{#e;constructor(L){super(""),this.#e=L}asFile(){return this.#e}}e.$9M=ei;class Ei{constructor(L,te,Ee,He){this.name=L,this.uri=te,this._itemId=Ee,this.c=He}data(){return this.c()}}e.$0M=Ei;let li=class{#e=new Map;constructor(L){for(const[te,Ee]of L??[]){const He=this.#e.get(this.#t(te));He?He.push(Ee):this.#e.set(this.#t(te),[Ee])}}get(L){return this.#e.get(this.#t(L))?.[0]}set(L,te){this.#e.set(this.#t(L),[te])}forEach(L,te){for(const[Ee,He]of this.#e)for(const Ye of He)L.call(te,Ye,Ee,this)}*[Symbol.iterator](){for(const[L,te]of this.#e)for(const Ee of te)yield[L,Ee]}#t(L){return L.toLowerCase()}};e.$$M=li,e.$$M=li=Ke([k],li);let fi=class{constructor(L,te,Ee){this.insertText=L,this.title=te,this.kind=Ee}};e.$_M=fi,e.$_M=fi=Ke([k],fi);var Ft;(function(j){j[j.Automatic=0]="Automatic",j[j.PasteAs=1]="PasteAs"})(Ft||(e.DocumentPasteTriggerKind=Ft={}));class ye{static{this.c="."}constructor(L){this.value=L}append(...L){return new ye((this.value?[this.value,...L]:L).join(ye.c))}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+ye.c)}}e.$aN=ye,ye.Empty=new ye("");class Fe{constructor(L,te,Ee){this.title=te,this.insertText=L,this.kind=Ee}}e.$bN=Fe;let se=class{constructor(L,te){this.id=L,this.color=te}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.$cN=se,e.$cN=se=Ke([k],se),se.File=new se("file"),se.Folder=new se("folder");let J=class{constructor(L){this.id=L}};e.$dN=J,e.$dN=J=Ke([k],J);var Pe;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Pe||(e.ConfigurationTarget=Pe={}));let Ve=class{get base(){return this.c}set base(L){this.c=L,this.e=E.URI.file(L)}get baseUri(){return this.e}set baseUri(L){this.e=L,this.c=L.fsPath}constructor(L,te){if(typeof L!="string"&&(!L||!E.URI.isUri(L)&&!E.URI.isUri(L.uri)))throw(0,O.$7)("base");if(typeof te!="string")throw(0,O.$7)("pattern");typeof L=="string"?this.baseUri=E.URI.file(L):E.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$eN=Ve,e.$eN=Ve=Ke([k],Ve);const Qe=new WeakMap;function Ge(j,L){Qe.set(j,L)}let it=class{constructor(L,te,Ee,He,Ye){this.enabled=typeof L=="boolean"?L:!0,typeof te=="string"&&(this.condition=te),typeof Ee=="string"&&(this.hitCondition=Ee),typeof He=="string"&&(this.logMessage=He),typeof Ye=="string"&&(this.mode=Ye)}get id(){return this.c||(this.c=Qe.get(this)??(0,T.$Sg)()),this.c}};e.$gN=it,e.$gN=it=Ke([k],it);let Dt=class extends it{constructor(L,te,Ee,He,Ye,lt){if(super(te,Ee,He,Ye,lt),L===null)throw(0,O.$7)("location");this.location=L}};e.$hN=Dt,e.$hN=Dt=Ke([k],Dt);let Wt=class extends it{constructor(L,te,Ee,He,Ye,lt){super(te,Ee,He,Ye,lt),this.functionName=L}};e.$iN=Wt,e.$iN=Wt=Ke([k],Wt);let jt=class extends it{constructor(L,te,Ee,He,Ye,lt,$t,qt){if(super(He,Ye,lt,$t,qt),!te)throw(0,O.$7)("dataId");this.label=L,this.dataId=te,this.canPersist=Ee}};e.$jN=jt,e.$jN=jt=Ke([k],jt);let It=class{constructor(L,te,Ee){this.command=L,this.args=te||[],this.options=Ee}};e.$kN=It,e.$kN=It=Ke([k],It);let ut=class{constructor(L,te){this.port=L,this.host=te}};e.$lN=ut,e.$lN=ut=Ke([k],ut);let Pi=class{constructor(L){this.path=L}};e.$mN=Pi,e.$mN=Pi=Ke([k],Pi);let hi=class{constructor(L){this.implementation=L}};e.$nN=hi,e.$nN=hi=Ke([k],hi);class vi{constructor(L,te,Ee){this.session=L,this.threadId=te,this.frameId=Ee}}e.$oN=vi;class Ki{constructor(L,te){this.session=L,this.threadId=te}}e.$pN=Ki;let Mi=class{constructor(L,te){this.range=L,this.expression=te}};e.$qN=Mi,e.$qN=Mi=Ke([k],Mi);var Ji;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Ji||(e.InlineCompletionTriggerKind=Ji={}));let Ri=class{constructor(L,te){this.range=L,this.text=te}};e.$rN=Ri,e.$rN=Ri=Ke([k],Ri);let Di=class{constructor(L,te,Ee=!0){this.range=L,this.variableName=te,this.caseSensitiveLookup=Ee}};e.$sN=Di,e.$sN=Di=Ke([k],Di);let Ai=class{constructor(L,te){this.range=L,this.expression=te}};e.$tN=Ai,e.$tN=Ai=Ke([k],Ai);let ki=class{constructor(L,te){this.frameId=L,this.stoppedLocation=te}};e.$uN=ki,e.$uN=ki=Ke([k],ki);var Qi;(function(j){j[j.AIGenerated=1]="AIGenerated"})(Qi||(e.NewSymbolNameTag=Qi={}));var Si;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Si||(e.NewSymbolNameTriggerKind=Si={}));class Oi{constructor(L,te){this.newSymbolName=L,this.tags=te}}e.$vN=Oi;var Zi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Zi||(e.FileChangeType=Zi={}));let Ni=h=class extends Error{static FileExists(L){return new h(L,l.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(L){return new h(L,l.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(L){return new h(L,l.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(L){return new h(L,l.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(L){return new h(L,l.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(L){return new h(L,l.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}constructor(L,te=l.FileSystemProviderErrorCode.Unknown,Ee){super(E.URI.isUri(L)?L.toString(!0):L),this.code=Ee?.name??"Unknown",(0,l.$fl)(this,te),Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};e.$wN=Ni,e.$wN=Ni=h=Ke([k],Ni);let $i=class{constructor(L,te,Ee){this.start=L,this.end=te,this.kind=Ee}};e.$xN=$i,e.$xN=$i=Ke([k],$i);var Xi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Yi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Yi||(e.CommentThreadCollapsibleState=Yi={}));var Ii;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Ii||(e.CommentMode=Ii={}));var xi;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(xi||(e.CommentState=xi={}));var Ti;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(Ti||(e.CommentThreadState=Ti={}));var _i;(function(j){j[j.Current=0]="Current",j[j.Outdated=1]="Outdated"})(_i||(e.CommentThreadApplicability=_i={}));class en{constructor(L,te=[]){this.tokenTypes=L,this.tokenModifiers=te}}e.$yN=en;function ln(j){return typeof j>"u"||(0,m.$0f)(j)}class Fi{constructor(L){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,L){this.m=!0;for(let te=0,Ee=L.tokenTypes.length;te<Ee;te++)this.k.set(L.tokenTypes[te],te);for(let te=0,Ee=L.tokenModifiers.length;te<Ee;te++)this.l.set(L.tokenModifiers[te],te)}}push(L,te,Ee,He,Ye){if(typeof L=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof He=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.q(L,te,Ee,He,Ye);if(q.isRange(L)&&typeof te=="string"&&ln(Ee))return this.o(L,te,Ee);throw(0,O.$7)()}o(L,te,Ee){if(!this.m)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const He=L.start.line,Ye=L.start.character,lt=L.end.character-L.start.character,$t=this.k.get(te);let qt=0;if(Ee)for(const oi of Ee){if(!this.l.has(oi))throw new Error("`tokenModifier` is not in the provided legend");const di=this.l.get(oi);qt|=1<<di>>>0}this.q(He,Ye,lt,$t,qt)}q(L,te,Ee,He,Ye){if(this.f&&(L<this.c||L===this.c&&te<this.e)){this.f=!1;const qt=this.g.length/5|0;let oi=0,di=0;for(let mi=0;mi<qt;mi++){let wi=this.g[5*mi],Gi=this.g[5*mi+1];wi===0?(wi=oi,Gi+=di):wi+=oi,this.g[5*mi]=wi,this.g[5*mi+1]=Gi,oi=wi,di=Gi}}let lt=L,$t=te;this.f&&this.j>0&&(lt-=this.c,lt===0&&($t-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=$t,this.g[this.j++]=Ee,this.g[this.j++]=He,this.g[this.j++]=Ye,this.c=L,this.e=te}static r(L){const te=[],Ee=L.length/5|0;for(let $t=0;$t<Ee;$t++)te[$t]=$t;te.sort(($t,qt)=>{const oi=L[5*$t],di=L[5*qt];if(oi===di){const mi=L[5*$t+1],wi=L[5*qt+1];return mi-wi}return oi-di});const He=new Uint32Array(L.length);let Ye=0,lt=0;for(let $t=0;$t<Ee;$t++){const qt=5*te[$t],oi=L[qt+0],di=L[qt+1],mi=L[qt+2],wi=L[qt+3],Gi=L[qt+4],Fn=oi-Ye,gr=Fn===0?di-lt:di,Hi=5*$t;He[Hi+0]=Fn,He[Hi+1]=gr,He[Hi+2]=mi,He[Hi+3]=wi,He[Hi+4]=Gi,Ye=oi,lt=di}return He}build(L){return this.f?new Li(new Uint32Array(this.g),L):new Li(Fi.r(this.g),L)}}e.$zN=Fi;class Li{constructor(L,te){this.resultId=te,this.data=L}}e.$AN=Li;class hn{constructor(L,te,Ee){this.start=L,this.deleteCount=te,this.data=Ee}}e.$BN=hn;class zi{constructor(L,te){this.resultId=te,this.edits=L}}e.$CN=zi;var Ui;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Ui||(e.DebugConsoleMode=Ui={}));class ze{constructor(L){this.name=L}}e.$DN=ze;let ri=class{static{this.Back={iconPath:new se("arrow-left")}}constructor(){}};e.$EN=ri,e.$EN=ri=Ke([k],ri);var ji;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(ji||(e.QuickPickItemKind=ji={}));var nt;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(nt||(e.InputBoxValidationSeverity=nt={}));var bt;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(bt||(e.ExtensionKind=bt={}));class dn{static validate(L){if(typeof L.badge=="string"){let te=(0,$.$Hf)(L.badge,0);if(te<L.badge.length&&(te+=(0,$.$Hf)(L.badge,te)),L.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!se.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,te,Ee){this.badge=L,this.tooltip=te,this.color=Ee}}e.$FN=dn;let Bi=class{constructor(L){this.kind=L}};e.$GN=Bi,e.$GN=Bi=Ke([k],Bi);var Vi;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(Vi||(e.ColorThemeKind=Vi={}));class gi{static isNotebookRange(L){return L instanceof gi?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(L,te){if(L<0)throw(0,O.$7)("start must be positive");if(te<0)throw(0,O.$7)("end must be positive");L<=te?(this.c=L,this.e=te):(this.c=te,this.e=L)}with(L){let te=this.c,Ee=this.e;return L.start!==void 0&&(te=L.start),L.end!==void 0&&(Ee=L.end),te===this.c&&Ee===this.e?this:new gi(te,Ee)}}e.$HN=gi;class pi{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(te=>pi.isNotebookCellData(te))}static isNotebookCellData(L){return!0}constructor(L,te,Ee,He,Ye,lt,$t){this.kind=L,this.value=te,this.languageId=Ee,this.mime=He,this.outputs=Ye??[],this.metadata=lt,this.executionSummary=$t,pi.validate(this)}}e.$IN=pi;class fn{constructor(L){this.cells=L}}e.$JN=fn;class si{static isNotebookCellOutputItem(L){return L instanceof si?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const te={name:L.name,message:L.message,stack:L.stack};return si.json(te,"application/vnd.code.notebook.error")}static stdout(L){return si.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return si.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,te="application/octet-stream"){return new si(L,te)}static#e=new TextEncoder;static text(L,te=A.$Qs.text){const Ee=si.#e.encode(String(L));return new si(Ee,te)}static json(L,te="text/x-json"){const Ee=JSON.stringify(L,void 0,"	");return si.text(Ee,te)}constructor(L,te){this.data=L,this.mime=te;const Ee=(0,A.$Us)(te,!0);if(!Ee)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}e.$KN=si;class Ci{static isNotebookCellOutput(L){return L instanceof Ci?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,te=!1){const Ee=new Set,He=new Set;for(let Ye=0;Ye<L.length;Ye++){const lt=L[Ye],$t=(0,A.$Us)(lt.mime);if(!Ee.has($t)||(0,g.$_J)($t)){Ee.add($t);continue}He.add(Ye),te&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return He.size===0?L:L.filter((Ye,lt)=>!He.has(lt))}constructor(L,te,Ee){this.items=Ci.ensureUniqueMimeTypes(L,!0),typeof te=="string"?(this.id=te,this.metadata=Ee):(this.id=(0,T.$Sg)(),this.metadata=te??Ee)}}e.$LN=Ci;var Wi;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Wi||(e.NotebookCellKind=Wi={}));var tn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(tn||(e.NotebookCellExecutionState=tn={}));var nn;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(nn||(e.NotebookCellStatusBarAlignment=nn={}));var rn;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(rn||(e.NotebookEditorRevealType=rn={}));class gn{constructor(L,te){this.text=L,this.alignment=te}}e.$MN=gn;var sn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(sn||(e.NotebookControllerAffinity=sn={}));var on;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(on||(e.NotebookControllerAffinity2=on={}));class mn{constructor(L,te=[]){this.uri=L,this.provides=(0,P.$2b)(te)}}e.$NN=mn;class $n{constructor(L){this.label=L}}e.$ON=$n;var an;(function(j){j[j.Named=1]="Named",j[j.Indexed=2]="Indexed"})(an||(e.NotebookVariablesRequestKind=an={}));let qi=class{constructor(L,te){this.label=L,this.timestamp=te}};e.$PN=qi,e.$PN=qi=Ke([k],qi);var cn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(cn||(e.ExtensionMode=cn={}));var _;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(_||(e.ExtensionRuntime=_={}));var oe;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(oe||(e.StandardTokenType=oe={}));class Le{constructor(L,te){this.ranges=L,this.wordPattern=te}}e.$QN=Le;class st{constructor(L){this.c=L}get autoForwardAction(){return this.c}}e.$RN=st;var vt;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(vt||(e.TestResultState=vt={}));var Rt;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(Rt||(e.TestRunProfileKind=Rt={}));let yi=class{constructor(L=void 0,te=void 0,Ee=void 0,He=!1,Ye=!0){this.include=L,this.exclude=te,this.profile=Ee,this.continuous=He,this.preserveFocus=Ye}};e.$SN=yi,e.$SN=yi=Ke([k],yi);let pn=D=class{static diff(L,te,Ee){const He=new D(L);return He.expectedOutput=te,He.actualOutput=Ee,He}constructor(L){this.message=L}};e.$TN=pn,e.$TN=pn=D=Ke([k],pn);let wn=class{constructor(L){this.id=L}};e.$UN=wn,e.$UN=wn=Ke([k],wn);class un{constructor(L,te){this.covered=L,this.total=te,vn(this)}}e.$VN=un;function vn(j){if(j){if(j.covered>j.total)throw new Error(`The total number of covered items (${j.covered}) cannot be greater than the total (${j.total})`);if(j.total<0)throw new Error(`The number of covered items (${j.total}) cannot be negative`)}}class bn{static fromDetails(L,te){const Ee=new un(0,0),He=new un(0,0),Ye=new un(0,0);for(const $t of te)if("branches"in $t){Ee.total+=1,Ee.covered+=$t.executed?1:0;for(const qt of $t.branches)He.total+=1,He.covered+=qt.executed?1:0}else Ye.total+=1,Ye.covered+=$t.executed?1:0;const lt=new bn(L,Ee,He.total>0?He:void 0,Ye.total>0?Ye:void 0);return lt.detailedCoverage=te,lt}constructor(L,te,Ee,He){this.uri=L,this.statementCoverage=te,this.branchCoverage=Ee,this.declarationCoverage=He}}e.$XN=bn;class Ln{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,te,Ee=[]){this.executed=L,this.location=te,this.branches=Ee}}e.$YN=Ln;class zn{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,te,Ee){this.executed=L,this.location=te,this.label=Ee}}e.$ZN=zn;class Un{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,te,Ee){this.name=L,this.executed=te,this.location=Ee}}e.$1N=Un;var yn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(yn||(e.ExternalUriOpenerPriority=yn={}));var En;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(En||(e.WorkspaceTrustState=En={}));var Dn;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(Dn||(e.PortAutoForwardAction=Dn={}));class jn{constructor(L,te,Ee,He,Ye,lt){this.kind=L,this.name=te,this.detail=Ee,this.uri=He,this.range=Ye,this.selectionRange=lt}}e.$2N=jn;class Bn{constructor(L){this.uri=L}}e.$3N=Bn;class Vn{constructor(L,te){this.original=L,this.modified=te}}e.$4N=Vn;class Wn{constructor(L,te,Ee,He){this.base=L,this.input1=te,this.input2=Ee,this.result=He}}e.$5N=Wn;class qn{constructor(L,te){this.uri=L,this.viewType=te}}e.$6N=qn;class Gn{constructor(L){this.viewType=L}}e.$7N=Gn;class Hn{constructor(L,te){this.uri=L,this.notebookType=te}}e.$8N=Hn;class Kn{constructor(L,te,Ee){this.original=L,this.modified=te,this.notebookType=Ee}}e.$9N=Kn;class Jn{constructor(){}}e.$0N=Jn;class Qn{constructor(L,te){this.uri=L,this.inputBoxUri=te}}e.$$N=Qn;class Zn{constructor(){}}e.$_N=Zn;class Xn{constructor(L){this.textDiffs=L}}e.$aO=Xn;var kn;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(kn||(e.InteractiveSessionVoteDirection=kn={}));var Sn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(Sn||(e.ChatCopyKind=Sn={}));var In;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(In||(e.ChatVariableLevel=In={}));class Yn{constructor(L,te){this.label=L,this.values=te}}e.$bO=Yn;var Cn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted",j[j.Bug=4]="Bug"})(Cn||(e.InteractiveEditorResponseFeedbackKind=Cn={}));var Pn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(Pn||(e.ChatResultFeedbackKind=Pn={}));class xn{constructor(L){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new qe(L):L}}e.$cO=xn;class _n{constructor(L,te){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new qe(L):L,this.vulnerabilities=te}}e.$dO=_n;class er{constructor(L,te){this.participant=L,this.command=te}}e.$eO=er;class tr{constructor(L,te){this.value=L,this.baseUri=te}}e.$fO=tr;class ir{constructor(L,te){this.value=L,this.title=te}}e.$gO=ir;class nr{constructor(L){this.value=L}}e.$hO=nr;class rr{constructor(L){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new qe(L):L}}e.$iO=rr;class sr{constructor(L){this.value=L}}e.$jO=sr;class or{constructor(L,te){this.value=L,this.iconPath=te}}e.$kO=or;class ar{constructor(L,te){this.uri=L,this.edits=Array.isArray(te)?te:[te]}}e.$lO=ar;class cr{constructor(L,te,Ee,He){this.prompt=L,this.command=te,this.variables=Ee,this.participant=He}}e.$mO=cr;class ur{constructor(L,te,Ee,He){this.response=L,this.result=te,this.participant=Ee,this.command=He}}e.$nO=ur;var Mn;(function(j){j[j.Panel=1]="Panel",j[j.Terminal=2]="Terminal",j[j.Notebook=3]="Notebook",j[j.Editor=4]="Editor"})(Mn||(e.ChatLocation=Mn={}));class lr{constructor(L){this.content=L}}e.$oO=lr;class hr{constructor(L,te){this.content=L,this.name=te}}e.$pO=hr;class dr{constructor(L,te){this.content=L,this.name=te}}e.$qO=dr;class bi extends Error{static NotFound(L){return new bi(L,bi.NotFound.name)}static NoPermissions(L){return new bi(L,bi.NoPermissions.name)}static Blocked(L){return new bi(L,bi.Blocked.name)}constructor(L,te,Ee){super(L,{cause:Ee}),this.name="LanguageModelError",this.code=te??""}}e.$rO=bi;var Rn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(Rn||(e.RelatedInformationType=Rn={}));var An;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped",j[j.Error=5]="Error"})(An||(e.SpeechToTextStatus=An={}));var On;(function(j){j[j.Started=1]="Started",j[j.Stopped=2]="Stopped",j[j.Error=3]="Error"})(On||(e.TextToSpeechStatus=On={}));var Nn;(function(j){j[j.Recognized=1]="Recognized",j[j.Stopped=2]="Stopped"})(Nn||(e.KeywordRecognitionStatus=Nn={}));class fr{constructor(L,te){this.text=L,this.range=te}}e.$sO=fr;var Tn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Tn||(e.InlineEditTriggerKind=Tn={}))}),define(Se[257],Ie([1,0,4,7]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=void 0;class M{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(P.$dM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,$,m){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(A);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation($,m)??[]}getRelatedInformation(A,$,m){return this.c.$getAiRelatedInformation($,m)}registerRelatedInformationProvider(A,$,m){const E=this.b;return this.b++,this.a.set(E,m),this.c.$registerAiRelatedInformationProvider(E,$),new O.$fM(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$ulc=M}),define(Se[86],Ie([1,0,5,4,7,20,108,3,17]),function(he,e,P,O,M,N,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Glc=e.$Flc=void 0,e.$Flc=(0,$.$wi)("IExtHostAuthentication");let E=class{constructor(l){this.b=new Map,this.c=new P.$de,this.onDidChangeSessions=this.c.event,this.d=new T,this.f=new T,this.a=l.getProxy(O.$dM.MainThreadAuthentication)}async getSession(l,b,g,r={}){const s=N.$Rm.toKey(l.identifier),o=[...g].sort().join(" ");return await this.d.getOrCreate(`${s} ${b} ${o}`,async()=>{await this.a.$ensureProvider(b);const n=l.displayName||l.name;return this.a.$getSession(b,g,s,n,r)})}async getSessions(l,b,g){const r=N.$Rm.toKey(l.identifier),s=[...g].sort().join(" ");return await this.f.getOrCreate(`${r} ${s}`,async()=>{await this.a.$ensureProvider(b);const o=l.displayName||l.name;return this.a.$getSessions(b,g,r,o)})}async removeSession(l,b){const g=this.b.get(l);return g?g.provider.removeSession(b):this.a.$removeSession(l,b)}registerAuthenticationProvider(l,b,g,r){if(this.b.get(l))throw new Error(`An authentication provider with id '${l}' is already registered.`);this.b.set(l,{label:b,provider:g,options:r??{supportsMultipleAccounts:!1}});const s=g.onDidChangeSessions(o=>this.a.$sendDidChangeSessions(l,o));return this.a.$registerAuthenticationProvider(l,b,r?.supportsMultipleAccounts??!1),new M.$fM(()=>{s.dispose(),this.b.delete(l),this.a.$unregisterAuthenticationProvider(l)})}async $createSession(l,b,g){const r=this.b.get(l);if(r)return await r.provider.createSession(b,g);throw new Error(`Unable to find authentication provider with handle: ${l}`)}async $removeSession(l,b){const g=this.b.get(l);if(g)return await g.provider.removeSession(b);throw new Error(`Unable to find authentication provider with handle: ${l}`)}async $getSessions(l,b){const g=this.b.get(l);if(g)return await g.provider.getSessions(b);throw new Error(`Unable to find authentication provider with handle: ${l}`)}$onDidChangeAuthenticationSessions(l,b){return l.startsWith(A.$fL)||this.c.fire({provider:{id:l,label:b}}),Promise.resolve()}};e.$Glc=E,e.$Glc=E=Ke([We(0,m.$EO)],E);class T{constructor(){this.a=new Map}getOrCreate(l,b){const g=this.a.get(l);if(g)return g;const r=b().finally(()=>this.a.delete(l));return this.a.set(l,r),r}}}),define(Se[112],Ie([1,0,2,4,7,3,17,12,18,13,19,26]),function(he,e,P,O,M,N,A,$,m,E,T,S){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gmc=e.$Fmc=void 0;let b=class{static{l=this}static{this.c=0}static{this.d=250}constructor(r,s){this.h=s,this.f=new Map,this.g=r.getProxy(O.$dM.MainThreadDecorations)}registerFileDecorationProvider(r,s){const o=l.c++;this.f.set(o,{provider:r,extensionDescription:s}),this.g.$registerDecorationProvider(o,s.identifier.value);const n=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(o,null);return}const c=(0,m.$2b)(i);if(c.length<=l.d){this.g.$onDidChange(o,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",s.identifier.value,c.length);const u=c.map(a=>({uri:a,rank:(0,E.$af)(a.path,"/")})),t=(0,m.$zb)(u,(a,f)=>a.rank-f.rank||(0,E.$qf)(a.uri.path,f.uri.path)),d=[];e:for(const a of t){let f;for(const w of a){const p=(0,T.$mc)(w.uri.path);if(f!==p&&(f=p,d.push(w.uri)>=l.d))break e}}this.g.$onDidChange(o,d)});return new M.$fM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(r,s,o){if(!this.f.has(r))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:c}=this.f.get(r);return await Promise.all(s.map(async u=>{try{const{uri:t,id:d}=u,a=await Promise.resolve(i.provideFileDecoration(P.URI.revive(t),o));if(!a)return;try{M.$FN.validate(a),a.badge&&typeof a.badge!="string"&&(0,S.$PG)(c,"codiconDecoration"),n[d]=[a.propagate,a.tooltip,a.badge,a.color]}catch(f){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${f}`)}}catch(t){this.h.error(t)}})),n}};e.$Fmc=b,e.$Fmc=b=l=Ke([We(0,A.$EO),We(1,$.$3j)],b),e.$Gmc=(0,N.$wi)("IExtHostDecorations")}),define(Se[258],Ie([1,0,14,2,7,4,16,24,13]),function(he,e,P,O,M,N,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=void 0;class E{static{this.a=0}constructor(S,l,b){this.d=l,this.e=b,this.b=new Map,this.c=S.getProxy(N.$dM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,l){if(Object.keys(A.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const b=E.a++;this.b.set(b,l),this.c.$registerTextContentProvider(b,S);let g;if(typeof l.onDidChange=="function"){let r;g=l.onDidChange(async s=>{if(s.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(s))return;r&&await r;const o=this.$provideTextDocumentContent(b,s).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(s);if(!i)return;const c=(0,m.$kf)(n);if(!i.equalLines(c))return this.c.$onVirtualDocumentChange(s,n)}).catch(P.$1).finally(()=>{r===o&&(r=void 0)});r=o})}return new M.$fM(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(S,l){const b=this.b.get(S);return b?Promise.resolve(b.provideTextDocumentContent(O.URI.revive(l),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$Imc=E}),define(Se[113],Ie([1,0,57,16,13,312,159,7,18]),function(he,e,P,O,M,N,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IO=e.$HO=void 0,e.$GO=T;const E=new Map;function T(g,r){r?E.set(g,r):E.delete(g)}function S(g){return E.get(g)}class l extends N.$6v{constructor(r,s,o,n,i,c,u){super(s,o,n,i),this.c=r,this.m=c,this.q=u,this.b=!1}dispose(){(0,P.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,m.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===O.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(s){return s?r.s(s):r.getText()},get eol(){return r.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(s){return r.t(s)},offsetAt(s){return r.u(s)},positionAt(s){return r.v(s)},validateRange(s){return r.w(s)},validatePosition(s){return r.x(s)},getWordRangeAtPosition(s,o){return r.y(s,o)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,P.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,P.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const s=this.w(r);if(s.isEmpty)return"";if(s.isSingleLine)return this.f[s.start.line].substring(s.start.character,s.end.character);const o=this.g,n=s.start.line,i=s.end.line,c=[];c.push(this.f[n].substring(s.start.character));for(let u=n+1;u<i;u++)c.push(this.f[u]);return c.push(this.f[i].substring(0,s.end.character)),c.join(o)}t(r){let s;if(r instanceof $.$gM?s=r.line:typeof r=="number"&&(s=r),typeof s!="number"||s<0||s>=this.f.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new b(s,this.f[s],s===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const s=this.j.getIndexOf(r),o=this.f[s.index].length;return new $.$gM(s.index,Math.min(s.remainder,o))}w(r){if(!(r instanceof $.$hM))throw new Error("Invalid argument");const s=this.x(r.start),o=this.x(r.end);return s===r.start&&o===r.end?r:new $.$hM(s.line,s.character,o.line,o.character)}x(r){if(!(r instanceof $.$gM))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:s,character:o}=r,n=!1;if(s<0)s=0,o=0,n=!0;else if(s>=this.f.length)s=this.f.length-1,o=this.f[s].length,n=!0;else{const i=this.f[s].length;o<0?(o=0,n=!0):o>i&&(o=i,n=!0)}return n?new $.$gM(s,o):r}y(r,s){const o=this.x(r);if(!s)s=S(this.m);else if((0,M.$jf)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const n=(0,A.$9s)(o.character+1,(0,A.$7s)(s),this.f[o.line],0);if(n)return new $.$hM(o.line,n.startColumn-1,o.line,n.endColumn-1)}}e.$HO=l;class b{constructor(r,s,o){this.a=r,this.b=s,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$hM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$hM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$IO=b}),define(Se[259],Ie([1,0,4,7]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kmc=void 0;class M{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(P.$dM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,$,m){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(A);if(!E)throw new Error("Embedding vector provider not found");const T=await E.provideEmbeddingVector($,m);if(!T)throw new Error("Embedding vector provider returned undefined");return T}registerEmbeddingVectorProvider(A,$,m){const E=this.b;return this.b++,this.a.set(E,m),this.c.$registerAiEmbeddingVectorProvider($,E),new O.$fM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$Kmc=M}),define(Se[65],Ie([1,0,4,38,7,21,3,17,46,6,11,23,16]),function(he,e,P,O,M,N,A,$,m,E,T,S,l){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wlc=e.$Vlc=void 0;let g=b=class{constructor(s,o){this.b=new Map,this.c=new T.$Fh,this.a=s.getProxy(P.$dM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let c;const u=n.b.get(i.scheme);return u?(await n.a.$ensureActivation(i.scheme),c=await u.impl.stat(i)):c=await n.a.$stat(i),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===O.FilePermission.Readonly?1:void 0}}catch(c){b.e(c)}},async readDirectory(i){try{const c=n.b.get(i.scheme);return c?(await n.a.$ensureActivation(i.scheme),(await c.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(c){return b.e(c)}},async createDirectory(i){try{const c=n.b.get(i.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(c.impl,c.extUri,i)):await n.a.$mkdir(i)}catch(c){return b.e(c)}},async readFile(i){try{const c=n.b.get(i.scheme);return c?(await n.a.$ensureActivation(i.scheme),(await c.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(c){return b.e(c)}},async writeFile(i,c){try{const u=n.b.get(i.scheme);return u&&!u.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(u.impl,u.extUri,u.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(u.impl.writeFile(i,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,N.$Fe.wrap(c))}catch(u){return b.e(u)}},async delete(i,c){try{const u=n.b.get(i.scheme);return u&&!u.isReadonly&&!c?.useTrash?(await n.a.$ensureActivation(i.scheme),await u.impl.delete(i,{recursive:!1,...c})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(u){return b.e(u)}},async rename(i,c,u){try{return await n.a.$rename(i,c,{overwrite:!1,...u})}catch(t){return b.e(t)}},async copy(i,c,u){try{return await n.a.$copy(i,c,{overwrite:!1,...u})}catch(t){return b.e(t)}},isWritableFileSystem(i){const c=o.getCapabilities(i);if(typeof c=="number")return!(c&2048)}})}async d(s,o,n){const i=[];for(;!o.isEqual(n,o.dirname(n));)try{if(!((await s.stat(n)).type&O.FileType.Directory))throw M.$wN.FileExists(`Unable to create folder '${n.scheme===l.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(O.$gl(c)!==O.FileSystemProviderErrorCode.FileNotFound)throw c;i.push(o.basename(n)),n=o.dirname(n)}for(let c=i.length-1;c>=0;c--){n=o.joinPath(n,i[c]);try{await s.createDirectory(n)}catch(u){if(O.$gl(u)!==O.FileSystemProviderErrorCode.FileExists)throw u}}}static e(s){if(s instanceof M.$wN)throw s;if(s instanceof O.$cl)switch(s.code){case O.FileSystemProviderErrorCode.FileExists:throw M.$wN.FileExists(s.message);case O.FileSystemProviderErrorCode.FileNotFound:throw M.$wN.FileNotFound(s.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw M.$wN.FileNotADirectory(s.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw M.$wN.FileIsADirectory(s.message);case O.FileSystemProviderErrorCode.NoPermissions:throw M.$wN.NoPermissions(s.message);case O.FileSystemProviderErrorCode.Unavailable:throw M.$wN.Unavailable(s.message);default:throw new M.$wN(s.message,s.name)}if(!(s instanceof Error))throw new M.$wN(String(s));if(s.name==="ENOPRO"||s.message.includes("ENOPRO"))throw M.$wN.Unavailable(s.message);switch(s.name){case O.FileSystemProviderErrorCode.FileExists:throw M.$wN.FileExists(s.message);case O.FileSystemProviderErrorCode.FileNotFound:throw M.$wN.FileNotFound(s.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw M.$wN.FileNotADirectory(s.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw M.$wN.FileIsADirectory(s.message);case O.FileSystemProviderErrorCode.NoPermissions:throw M.$wN.NoPermissions(s.message);case O.FileSystemProviderErrorCode.Unavailable:throw M.$wN.Unavailable(s.message);default:throw new M.$wN(s.message,s.name)}}addFileSystemProvider(s,o,n){return this.b.set(s,{impl:o,extUri:n?.isCaseSensitive?S.$Zg:S.$2g,isReadonly:!!n?.isReadonly}),(0,E.$Sc)(()=>this.b.delete(s))}getFileSystemProviderExtUri(s){return this.b.get(s)?.extUri??S.$Zg}};e.$Vlc=g,e.$Vlc=g=b=Ke([We(0,$.$EO),We(1,m.$zlc)],g),e.$Wlc=(0,A.$wi)("IExtHostConsumerFileSystem")}),define(Se[87],Ie([1,0,3,27,12,65,2]),function(he,e,P,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ylc=e.$Xlc=void 0,e.$Xlc=(0,P.$wi)("IExtensionStoragePaths");let $=class{constructor(E,T,S){this.d=T,this.f=S,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(E){return A.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,T=await this.g(E);try{return await this.f.value.stat(T),this.d.trace("[ExtHostStorage] storage dir already exists",T),T}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",T),await this.f.value.createDirectory(T),await this.f.value.writeFile(A.URI.joinPath(T,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),T}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(E){if(this.c)return A.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return A.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Ylc=$,e.$Ylc=$=Ke([We(0,O.$UO),We(1,M.$3j),We(2,N.$Wlc)],$)}),define(Se[260],Ie([1,0,7,17,5]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=void 0;let N=class{constructor($){this.a=new P.$GN(P.ColorThemeKind.Dark),this.b=new M.$de}get activeColorTheme(){return this.a}$onColorThemeChange($){let m;switch($){case"light":m=P.ColorThemeKind.Light;break;case"hcDark":m=P.ColorThemeKind.HighContrast;break;case"hcLight":m=P.ColorThemeKind.HighContrastLight;break;default:m=P.ColorThemeKind.Dark}this.a=new P.$GN(m),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$snc=N,e.$snc=N=Ke([We(0,O.$EO)],N)}),define(Se[88],Ie([1,0,24,5,6,182,3,12,211,4,27,17,7]),function(he,e,P,O,M,N,A,$,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DDb=e.$CDb=e.TunnelDtoConverter=void 0;class b extends m.$sw{}var g;(function(s){function o(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?m.TunnelPrivacyId.Public:m.TunnelPrivacyId.Private),protocol:i.protocol}}s.fromApiTunnel=o;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==m.TunnelPrivacyId.ConstantPrivate&&i.privacy!==m.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}s.fromServiceTunnel=n})(g||(e.TunnelDtoConverter=g={})),e.$CDb=(0,A.$wi)("IExtHostTunnelService");let r=class extends M.$Uc{constructor(o,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new O.$de,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(E.$dM.MainThreadTunnelService)}async openTunnel(o,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,o.displayName);if(i){const c=new b(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,n){o.portRange===void 0&&o.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:o,provider:n}),this.a.$registerPortsAttributesProvider(o,i),new l.$fM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(o,n,i,c,u){const t=[];for(const a of o){const f=this.r.get(a);if(!f)return[];t.push(...await Promise.all(n.map(async w=>{let p;try{p=await f.provider.providePortAttributes({port:w,pid:i,commandLine:c},u)}catch{p=await f.provider.providePortAttributes(w,i,c,u)}return{providedAttributes:p,port:w}})))}const d=t.filter(a=>!!a.providedAttributes);return d.length>0?d.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,u)=>await o.provideTunnel(c,u,P.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,M.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,n){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const i=o.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let c=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:N.localize(0,null),themeIcon:"lock"},{id:"public",label:N.localize(1,null),themeIcon:"eye"}]);const u=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(u)}}else this.b=void 0;return(0,M.$Sc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,n){if(this.g.has(o.host)){const i=this.g.get(o.host);i.has(o.port)&&(n&&i.get(o.port).disposeListener.dispose(),await i.get(o.port).tunnel.dispose(),i.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(o,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const c=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const u=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:c,disposeListener:u}),g.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(o){const n=await Promise.all(o.map(c=>this.f(c.host,c.port,c.detail??""))),i=o.filter((c,u)=>n[u]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(c=>c.port).join(", ")} to ${i.map(c=>c.port).join(", ")}`),i}};e.$DDb=r,e.$DDb=r=Ke([We(0,S.$EO),We(1,T.$UO),We(2,$.$3j)],r)}),define(Se[8],Ie([1,0,18,21,138,261,55,28,127,49,70,25,133,23,36,15,2,30,89,101,107,106,224,85,52,62,235,7]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g,r,s,o,n,i,c,u,t,d,a,f,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelMessage=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$BO=K,e.$CO=ce,e.$DO=ve;var v;(function(ye){function Fe(J){const{selectionStartLineNumber:Pe,selectionStartColumn:Ve,positionLineNumber:Qe,positionColumn:Ge}=J,it=new p.$gM(Pe-1,Ve-1),Dt=new p.$gM(Qe-1,Ge-1);return new p.$iM(it,Dt)}ye.to=Fe;function se(J){const{anchor:Pe,active:Ve}=J;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}ye.from=se})(v||(e.Selection=v={}));var y;(function(ye){function Fe(J){if(!J)return;const{start:Pe,end:Ve}=J;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}ye.from=Fe;function se(J){if(!J)return;const{startLineNumber:Pe,startColumn:Ve,endLineNumber:Qe,endColumn:Ge}=J;return new p.$hM(Pe-1,Ve-1,Qe-1,Ge-1)}ye.to=se})(y||(e.Range=y={}));var h;(function(ye){function Fe(J){return{uri:J.uri,range:y.from(J.range)}}ye.from=Fe;function se(J){return new p.$rM(s.URI.revive(J.uri),y.to(J.range))}ye.to=se})(h||(e.Location=h={}));var D;(function(ye){function Fe(se){switch(se){case 1:return p.StandardTokenType.Comment;case 0:return p.StandardTokenType.Other;case 3:return p.StandardTokenType.RegEx;case 2:return p.StandardTokenType.String}}ye.to=Fe})(D||(e.TokenType=D={}));var k;(function(ye){function Fe(J){return new p.$gM(J.lineNumber-1,J.column-1)}ye.to=Fe;function se(J){return{lineNumber:J.line+1,column:J.character+1}}ye.from=se})(k||(e.Position=k={}));var C;(function(ye){function Fe(Pe,Ve,Qe){return(0,P.$Hb)((0,P.$2b)(Pe).map(Ge=>se(Ge,Ve,Qe)))}ye.from=Fe;function se(Pe,Ve,Qe){if(typeof Pe=="string")return{$serialized:!0,language:Pe,isBuiltin:Qe?.isBuiltin};if(Pe)return{$serialized:!0,language:Pe.language,scheme:J(Pe.scheme,Ve),pattern:$e.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType,isBuiltin:Qe?.isBuiltin}}function J(Pe,Ve){return Ve&&typeof Pe=="string"?Ve.transformOutgoingScheme(Pe):Pe}})(C||(e.DocumentSelector=C={}));var I;(function(ye){function Fe(J){switch(J){case p.DiagnosticTag.Unnecessary:return 1;case p.DiagnosticTag.Deprecated:return 2}}ye.from=Fe;function se(J){switch(J){case 1:return p.DiagnosticTag.Unnecessary;case 2:return p.DiagnosticTag.Deprecated;default:return}}ye.to=se})(I||(e.DiagnosticTag=I={}));var W;(function(ye){function Fe(J){let Pe;return J.code&&((0,r.$9f)(J.code)||(0,r.$ag)(J.code)?Pe=String(J.code):Pe={value:String(J.code.value),target:J.code.target}),{...y.from(J.range),message:J.message,source:J.source,code:Pe,severity:q.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(V.from),tags:Array.isArray(J.tags)?(0,P.$Hb)(J.tags.map(I.from)):void 0}}ye.from=Fe;function se(J){const Pe=new p.$tM(y.to(J),J.message,q.to(J.severity));return Pe.source=J.source,Pe.code=(0,r.$9f)(J.code)?J.code:J.code?.value,Pe.relatedInformation=J.relatedInformation&&J.relatedInformation.map(V.to),Pe.tags=J.tags&&(0,P.$Hb)(J.tags.map(I.to)),Pe}ye.to=se})(W||(e.Diagnostic=W={}));var V;(function(ye){function Fe(J){return{...y.from(J.location.range),message:J.message,resource:J.location.uri}}ye.from=Fe;function se(J){return new p.$sM(new p.$rM(J.resource,y.to(J)),J.message)}ye.to=se})(V||(e.DiagnosticRelatedInformation=V={}));var q;(function(ye){function Fe(J){switch(J){case p.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case p.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case p.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case p.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}ye.from=Fe;function se(J){switch(J){case i.MarkerSeverity.Info:return p.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return p.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return p.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return p.DiagnosticSeverity.Hint;default:return p.DiagnosticSeverity.Error}}ye.to=se})(q||(e.DiagnosticSeverity=q={}));var R;(function(ye){function Fe(J){return typeof J=="number"&&J>=p.ViewColumn.One?J-1:J===p.ViewColumn.Beside?w.$5D:w.$4D}ye.from=Fe;function se(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=se})(R||(e.ViewColumn=R={}));function B(ye){return typeof ye.range<"u"}function K(ye){return ye.length===0?!0:!!B(ye[0])}var ie;(function(ye){function Fe(Ge){return Ge.map(ye.from)}ye.fromMany=Fe;function se(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function J(Ge){let it;if(se(Ge)){const{language:It,value:ut}=Ge;it={value:"```"+It+`
`+ut+"\n```\n"}}else p.$HM.isMarkdownString(Ge)?it={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?it={value:Ge}:it={value:""};const Dt=Object.create(null);it.uris=Dt;const Wt=It=>{try{let ut=s.URI.parse(It,!0);ut=ut.with({query:Pe(ut.query,Dt)}),Dt[It]=ut}catch{}return""},jt=new m.marked.Renderer;return jt.link=Wt,jt.image=It=>typeof It=="string"?Wt(A.$2k(It).href):"",(0,m.marked)(it.value,{renderer:jt}),it}ye.from=J;function Pe(Ge,it){if(!Ge)return Ge;let Dt;try{Dt=(0,E.$5h)(Ge)}catch{}if(!Dt)return Ge;let Wt=!1;return Dt=(0,S.$5n)(Dt,jt=>{if(s.URI.isUri(jt)){const It=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[It]=jt,Wt=!0,It}else return}),Wt?JSON.stringify(Dt):Ge}function Ve(Ge){const it=new p.$HM(Ge.value,Ge.supportThemeIcons);return it.isTrusted=Ge.isTrusted,it.supportHtml=Ge.supportHtml,it.baseUri=Ge.baseUri?s.URI.from(Ge.baseUri):void 0,it}ye.to=Ve;function Qe(Ge){if(Ge)return typeof Ge=="string"?Ge:ye.from(Ge)}ye.fromStrict=Qe})(ie||(e.MarkdownString=ie={}));function ce(ye){return K(ye)?ye.map(Fe=>({range:y.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?ie.fromMany(Fe.hoverMessage):Fe.hoverMessage?ie.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):ye.map(Fe=>({range:y.from(Fe)}))}function ve(ye){return typeof ye>"u"?ye:typeof ye=="string"?s.URI.file(ye):ye}var ke;(function(ye){function Fe(se){return typeof se>"u"?se:{contentText:se.contentText,contentIconPath:se.contentIconPath?ve(se.contentIconPath):void 0,border:se.border,borderColor:se.borderColor,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,color:se.color,backgroundColor:se.backgroundColor,margin:se.margin,width:se.width,height:se.height}}ye.from=Fe})(ke||(e.ThemableDecorationAttachmentRenderOptions=ke={}));var fe;(function(ye){function Fe(se){return typeof se>"u"?se:{backgroundColor:se.backgroundColor,outline:se.outline,outlineColor:se.outlineColor,outlineStyle:se.outlineStyle,outlineWidth:se.outlineWidth,border:se.border,borderColor:se.borderColor,borderRadius:se.borderRadius,borderSpacing:se.borderSpacing,borderStyle:se.borderStyle,borderWidth:se.borderWidth,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,cursor:se.cursor,color:se.color,opacity:se.opacity,letterSpacing:se.letterSpacing,gutterIconPath:se.gutterIconPath?ve(se.gutterIconPath):void 0,gutterIconSize:se.gutterIconSize,overviewRulerColor:se.overviewRulerColor,before:se.before?ke.from(se.before):void 0,after:se.after?ke.from(se.after):void 0}}ye.from=Fe})(fe||(e.ThemableDecorationRenderOptions=fe={}));var pe;(function(ye){function Fe(se){if(typeof se>"u")return se;switch(se){case p.DecorationRangeBehavior.OpenOpen:return 0;case p.DecorationRangeBehavior.ClosedClosed:return 1;case p.DecorationRangeBehavior.OpenClosed:return 2;case p.DecorationRangeBehavior.ClosedOpen:return 3}}ye.from=Fe})(pe||(e.DecorationRangeBehavior=pe={}));var Ne;(function(ye){function Fe(se){return{isWholeLine:se.isWholeLine,rangeBehavior:se.rangeBehavior?pe.from(se.rangeBehavior):void 0,overviewRulerLane:se.overviewRulerLane,light:se.light?fe.from(se.light):void 0,dark:se.dark?fe.from(se.dark):void 0,backgroundColor:se.backgroundColor,outline:se.outline,outlineColor:se.outlineColor,outlineStyle:se.outlineStyle,outlineWidth:se.outlineWidth,border:se.border,borderColor:se.borderColor,borderRadius:se.borderRadius,borderSpacing:se.borderSpacing,borderStyle:se.borderStyle,borderWidth:se.borderWidth,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,cursor:se.cursor,color:se.color,opacity:se.opacity,letterSpacing:se.letterSpacing,gutterIconPath:se.gutterIconPath?ve(se.gutterIconPath):void 0,gutterIconSize:se.gutterIconSize,overviewRulerColor:se.overviewRulerColor,before:se.before?ke.from(se.before):void 0,after:se.after?ke.from(se.after):void 0}}ye.from=Fe})(Ne||(e.DecorationRenderOptions=Ne={}));var ae;(function(ye){function Fe(J){return{text:J.newText,eol:J.newEol&&ft.from(J.newEol),range:y.from(J.range)}}ye.from=Fe;function se(J){const Pe=new p.$mM(y.to(J.range),J.text);return Pe.newEol=typeof J.eol>"u"?void 0:ft.to(J.eol),Pe}ye.to=se})(ae||(e.TextEdit=ae={}));var Re;(function(ye){function Fe(J,Pe){const Ve={edits:[]};if(J instanceof p.$pM){const Qe=new $.$Bc;for(const Ge of J._allEntries())Ge._type===1&&s.URI.isUri(Ge.to)&&Ge.from===void 0&&Qe.add(Ge.to);for(const Ge of J._allEntries())if(Ge._type===1){let it;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?it={type:"base64",value:(0,O.$Ze)(O.$Fe.wrap(Ge.options.contents))}:it={type:"dataTransferItem",id:Ge.options.contents._itemId}),Ve.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:it},metadata:Ge.metadata})}else Ge._type===2?Ve.edits.push({resource:Ge.uri,textEdit:ae.from(Ge.edit),versionId:Qe.has(Ge.uri)?void 0:Pe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?Ve.edits.push({resource:Ge.uri,textEdit:{range:y.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Qe.has(Ge.uri)?void 0:Pe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?Ve.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&Ve.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(xt.from)}})}return Ve}ye.from=Fe;function se(J){const Pe=new p.$pM,Ve=new $.$Ac;for(const Qe of J.edits)if(Qe.textEdit){const Ge=Qe,it=s.URI.revive(Ge.resource),Dt=y.to(Ge.textEdit.range),Wt=Ge.textEdit.text,jt=Ge.textEdit.insertAsSnippet;let It;jt?It=p.$oM.replace(Dt,new p.$qM(Wt)):It=p.$mM.replace(Dt,Wt);const ut=Ve.get(it);ut?ut.push(It):Ve.set(it,[It])}else Pe.renameFile(s.URI.revive(Qe.oldResource),s.URI.revive(Qe.newResource),Qe.options);for(const[Qe,Ge]of Ve)Pe.set(Qe,Ge);return Pe}ye.to=se})(Re||(e.WorkspaceEdit=Re={}));var ne;(function(ye){const Fe=Object.create(null);Fe[p.SymbolKind.File]=0,Fe[p.SymbolKind.Module]=1,Fe[p.SymbolKind.Namespace]=2,Fe[p.SymbolKind.Package]=3,Fe[p.SymbolKind.Class]=4,Fe[p.SymbolKind.Method]=5,Fe[p.SymbolKind.Property]=6,Fe[p.SymbolKind.Field]=7,Fe[p.SymbolKind.Constructor]=8,Fe[p.SymbolKind.Enum]=9,Fe[p.SymbolKind.Interface]=10,Fe[p.SymbolKind.Function]=11,Fe[p.SymbolKind.Variable]=12,Fe[p.SymbolKind.Constant]=13,Fe[p.SymbolKind.String]=14,Fe[p.SymbolKind.Number]=15,Fe[p.SymbolKind.Boolean]=16,Fe[p.SymbolKind.Array]=17,Fe[p.SymbolKind.Object]=18,Fe[p.SymbolKind.Key]=19,Fe[p.SymbolKind.Null]=20,Fe[p.SymbolKind.EnumMember]=21,Fe[p.SymbolKind.Struct]=22,Fe[p.SymbolKind.Event]=23,Fe[p.SymbolKind.Operator]=24,Fe[p.SymbolKind.TypeParameter]=25;function se(Pe){return typeof Fe[Pe]=="number"?Fe[Pe]:6}ye.from=se;function J(Pe){for(const Ve in Fe)if(Fe[Ve]===Pe)return Number(Ve);return p.SymbolKind.Property}ye.to=J})(ne||(e.SymbolKind=ne={}));var z;(function(ye){function Fe(J){switch(J){case p.SymbolTag.Deprecated:return 1}}ye.from=Fe;function se(J){switch(J){case 1:return p.SymbolTag.Deprecated}}ye.to=se})(z||(e.SymbolTag=z={}));var x;(function(ye){function Fe(J){return{name:J.name,kind:ne.from(J.kind),tags:J.tags&&J.tags.map(z.from),containerName:J.containerName,location:ge.from(J.location)}}ye.from=Fe;function se(J){const Pe=new p.$yM(J.name,ne.to(J.kind),J.containerName,ge.to(J.location));return Pe.tags=J.tags&&J.tags.map(z.to),Pe}ye.to=se})(x||(e.WorkspaceSymbol=x={}));var be;(function(ye){function Fe(J){const Pe={name:J.name||"!!MISSING: name!!",detail:J.detail,range:y.from(J.range),selectionRange:y.from(J.selectionRange),kind:ne.from(J.kind),tags:J.tags?.map(z.from)??[]};return J.children&&(Pe.children=J.children.map(Fe)),Pe}ye.from=Fe;function se(J){const Pe=new p.$zM(J.name,J.detail,ne.to(J.kind),y.to(J.range),y.to(J.selectionRange));return(0,P.$Lb)(J.tags)&&(Pe.tags=J.tags.map(z.to)),J.children&&(Pe.children=J.children.map(se)),Pe}ye.to=se})(be||(e.DocumentSymbol=be={}));var Te;(function(ye){function Fe(J){const Pe=new p.$DM(ne.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),y.to(J.range),y.to(J.selectionRange));return Pe._sessionId=J._sessionId,Pe._itemId=J._itemId,Pe}ye.to=Fe;function se(J,Pe,Ve){if(Pe=Pe??J._sessionId,Ve=Ve??J._itemId,Pe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Ve,name:J.name,detail:J.detail,kind:ne.from(J.kind),uri:J.uri,range:y.from(J.range),selectionRange:y.from(J.selectionRange),tags:J.tags?.map(z.from)}}ye.from=se})(Te||(e.CallHierarchyItem=Te={}));var De;(function(ye){function Fe(se){return new p.$EM(Te.to(se.from),se.fromRanges.map(J=>y.to(J)))}ye.to=Fe})(De||(e.CallHierarchyIncomingCall=De={}));var we;(function(ye){function Fe(se){return new p.$FM(Te.to(se.to),se.fromRanges.map(J=>y.to(J)))}ye.to=Fe})(we||(e.CallHierarchyOutgoingCall=we={}));var ge;(function(ye){function Fe(J){return{range:J.range&&y.from(J.range),uri:J.uri}}ye.from=Fe;function se(J){return new p.$rM(s.URI.revive(J.uri),y.to(J.range))}ye.to=se})(ge||(e.location=ge={}));var Q;(function(ye){function Fe(J){const Pe=J,Ve=J;return{originSelectionRange:Pe.originSelectionRange?y.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Ve.uri,range:y.from(Pe.targetRange?Pe.targetRange:Ve.range),targetSelectionRange:Pe.targetSelectionRange?y.from(Pe.targetSelectionRange):void 0}}ye.from=Fe;function se(J){return{targetUri:s.URI.revive(J.uri),targetRange:y.to(J.range),targetSelectionRange:J.targetSelectionRange?y.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?y.to(J.originSelectionRange):void 0}}ye.to=se})(Q||(e.DefinitionLink=Q={}));var Y;(function(ye){function Fe(J){return{range:y.from(J.range),contents:ie.fromMany(J.contents),canIncreaseVerbosity:J.canIncreaseVerbosity,canDecreaseVerbosity:J.canDecreaseVerbosity}}ye.from=Fe;function se(J){const Pe=J.contents.map(ie.to),Ve=y.to(J.range),Qe=J.canIncreaseVerbosity,Ge=J.canDecreaseVerbosity;return new p.$vM(Pe,Ve,Qe,Ge)}ye.to=se})(Y||(e.Hover=Y={}));var le;(function(ye){function Fe(J){return{range:y.from(J.range),expression:J.expression}}ye.from=Fe;function se(J){return new p.$qN(y.to(J.range),J.expression)}ye.to=se})(le||(e.EvaluatableExpression=le={}));var ue;(function(ye){function Fe(J){if(J instanceof p.$rN)return{type:"text",range:y.from(J.range),text:J.text};if(J instanceof p.$sN)return{type:"variable",range:y.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof p.$tN)return{type:"expression",range:y.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Fe;function se(J){switch(J.type){case"text":return{range:y.to(J.range),text:J.text};case"variable":return{range:y.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:y.to(J.range),expression:J.expression}}}ye.to=se})(ue||(e.InlineValue=ue={}));var Oe;(function(ye){function Fe(J){return{frameId:J.frameId,stoppedLocation:y.from(J.stoppedLocation)}}ye.from=Fe;function se(J){return new p.$uN(J.frameId,y.to(J.stoppedLocation))}ye.to=se})(Oe||(e.InlineValueContext=Oe={}));var de;(function(ye){function Fe(J){return{range:y.from(J.range),kind:J.kind}}ye.from=Fe;function se(J){return new p.$wM(y.to(J.range),J.kind)}ye.to=se})(de||(e.DocumentHighlight=de={}));var Ce;(function(ye){function Fe(J){return{uri:J.uri,highlights:J.highlights.map(de.from)}}ye.from=Fe;function se(J){return new p.$xM(s.URI.revive(J.uri),J.highlights.map(de.to))}ye.to=se})(Ce||(e.MultiDocumentHighlight=Ce={}));var Me;(function(ye){function Fe(se){switch(se){case 1:return p.CompletionTriggerKind.TriggerCharacter;case 2:return p.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return p.CompletionTriggerKind.Invoke}}ye.to=Fe})(Me||(e.CompletionTriggerKind=Me={}));var je;(function(ye){function Fe(se){return{triggerKind:Me.to(se.triggerKind),triggerCharacter:se.triggerCharacter}}ye.to=Fe})(je||(e.CompletionContext=je={}));var U;(function(ye){function Fe(J){switch(J){case p.CompletionItemTag.Deprecated:return 1}}ye.from=Fe;function se(J){switch(J){case 1:return p.CompletionItemTag.Deprecated}}ye.to=se})(U||(e.CompletionItemTag=U={}));var F;(function(ye){const Fe=new Map([[p.CompletionItemKind.Method,0],[p.CompletionItemKind.Function,1],[p.CompletionItemKind.Constructor,2],[p.CompletionItemKind.Field,3],[p.CompletionItemKind.Variable,4],[p.CompletionItemKind.Class,5],[p.CompletionItemKind.Interface,7],[p.CompletionItemKind.Struct,6],[p.CompletionItemKind.Module,8],[p.CompletionItemKind.Property,9],[p.CompletionItemKind.Unit,12],[p.CompletionItemKind.Value,13],[p.CompletionItemKind.Constant,14],[p.CompletionItemKind.Enum,15],[p.CompletionItemKind.EnumMember,16],[p.CompletionItemKind.Keyword,17],[p.CompletionItemKind.Snippet,27],[p.CompletionItemKind.Text,18],[p.CompletionItemKind.Color,19],[p.CompletionItemKind.File,20],[p.CompletionItemKind.Reference,21],[p.CompletionItemKind.Folder,23],[p.CompletionItemKind.Event,10],[p.CompletionItemKind.Operator,11],[p.CompletionItemKind.TypeParameter,24],[p.CompletionItemKind.Issue,26],[p.CompletionItemKind.User,25]]);function se(Ve){return Fe.get(Ve)??9}ye.from=se;const J=new Map([[0,p.CompletionItemKind.Method],[1,p.CompletionItemKind.Function],[2,p.CompletionItemKind.Constructor],[3,p.CompletionItemKind.Field],[4,p.CompletionItemKind.Variable],[5,p.CompletionItemKind.Class],[7,p.CompletionItemKind.Interface],[6,p.CompletionItemKind.Struct],[8,p.CompletionItemKind.Module],[9,p.CompletionItemKind.Property],[12,p.CompletionItemKind.Unit],[13,p.CompletionItemKind.Value],[14,p.CompletionItemKind.Constant],[15,p.CompletionItemKind.Enum],[16,p.CompletionItemKind.EnumMember],[17,p.CompletionItemKind.Keyword],[27,p.CompletionItemKind.Snippet],[18,p.CompletionItemKind.Text],[19,p.CompletionItemKind.Color],[20,p.CompletionItemKind.File],[21,p.CompletionItemKind.Reference],[23,p.CompletionItemKind.Folder],[10,p.CompletionItemKind.Event],[11,p.CompletionItemKind.Operator],[24,p.CompletionItemKind.TypeParameter],[25,p.CompletionItemKind.User],[26,p.CompletionItemKind.Issue]]);function Pe(Ve){return J.get(Ve)??p.CompletionItemKind.Property}ye.to=Pe})(F||(e.CompletionItemKind=F={}));var G;(function(ye){function Fe(se,J){const Pe=new p.$NM(se.label);return Pe.insertText=se.insertText,Pe.kind=F.to(se.kind),Pe.tags=se.tags?.map(U.to),Pe.detail=se.detail,Pe.documentation=A.$Vk(se.documentation)?ie.to(se.documentation):se.documentation,Pe.sortText=se.sortText,Pe.filterText=se.filterText,Pe.preselect=se.preselect,Pe.commitCharacters=se.commitCharacters,o.$ut.isIRange(se.range)?Pe.range=y.to(se.range):typeof se.range=="object"&&(Pe.range={inserting:y.to(se.range.insert),replacing:y.to(se.range.replace)}),Pe.keepWhitespace=typeof se.insertTextRules>"u"?!1:!!(se.insertTextRules&1),typeof se.insertTextRules<"u"&&se.insertTextRules&4?Pe.insertText=new p.$qM(se.insertText):(Pe.insertText=se.insertText,Pe.textEdit=Pe.range instanceof p.$hM?new p.$mM(Pe.range,Pe.insertText):void 0),se.additionalTextEdits&&se.additionalTextEdits.length>0&&(Pe.additionalTextEdits=se.additionalTextEdits.map(Ve=>ae.to(Ve))),Pe.command=J&&se.command?J.fromInternal(se.command):void 0,Pe}ye.to=Fe})(G||(e.CompletionItem=G={}));var H;(function(ye){function Fe(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:ie.fromStrict(J.documentation)}}ye.from=Fe;function se(J){return{label:J.label,documentation:A.$Vk(J.documentation)?ie.to(J.documentation):J.documentation}}ye.to=se})(H||(e.ParameterInformation=H={}));var ee;(function(ye){function Fe(J){return{label:J.label,documentation:ie.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(H.from):[],activeParameter:J.activeParameter}}ye.from=Fe;function se(J){return{label:J.label,documentation:A.$Vk(J.documentation)?ie.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(H.to):[],activeParameter:J.activeParameter}}ye.to=se})(ee||(e.SignatureInformation=ee={}));var re;(function(ye){function Fe(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(ee.from):[]}}ye.from=Fe;function se(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(ee.to):[]}}ye.to=se})(re||(e.SignatureHelp=re={}));var Ae;(function(ye){function Fe(se,J){const Pe=new p.$MM(k.to(J.position),typeof J.label=="string"?J.label:J.label.map(Be.to.bind(void 0,se)),J.kind&&qe.to(J.kind));return Pe.textEdits=J.textEdits&&J.textEdits.map(ae.to),Pe.tooltip=A.$Vk(J.tooltip)?ie.to(J.tooltip):J.tooltip,Pe.paddingLeft=J.paddingLeft,Pe.paddingRight=J.paddingRight,Pe}ye.to=Fe})(Ae||(e.InlayHint=Ae={}));var Be;(function(ye){function Fe(se,J){const Pe=new p.$LM(J.label);return Pe.tooltip=A.$Vk(J.tooltip)?ie.to(J.tooltip):J.tooltip,n.Command.is(J.command)&&(Pe.command=se.fromInternal(J.command)),J.location&&(Pe.location=ge.to(J.location)),Pe}ye.to=Fe})(Be||(e.InlayHintLabelPart=Be={}));var qe;(function(ye){function Fe(J){return J}ye.from=Fe;function se(J){return J}ye.to=se})(qe||(e.InlayHintKind=qe={}));var et;(function(ye){function Fe(J){return{range:y.from(J.range),url:J.target,tooltip:J.tooltip}}ye.from=Fe;function se(J){let Pe;if(J.url)try{Pe=typeof J.url=="string"?s.URI.parse(J.url,!0):s.URI.revive(J.url)}catch{}return new p.$SM(y.to(J.range),Pe)}ye.to=se})(et||(e.DocumentLink=et={}));var xe;(function(ye){function Fe(J){const Pe=new p.$VM(J.label);return J.textEdit&&(Pe.textEdit=ae.to(J.textEdit)),J.additionalTextEdits&&(Pe.additionalTextEdits=J.additionalTextEdits.map(Ve=>ae.to(Ve))),Pe}ye.to=Fe;function se(J){return{label:J.label,textEdit:J.textEdit?ae.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Pe=>ae.from(Pe)):void 0}}ye.from=se})(xe||(e.ColorPresentation=xe={}));var _e;(function(ye){function Fe(J){return new p.$TM(J[0],J[1],J[2],J[3])}ye.to=Fe;function se(J){return[J.red,J.green,J.blue,J.alpha]}ye.from=se})(_e||(e.Color=_e={}));var tt;(function(ye){function Fe(J){return{range:y.from(J.range)}}ye.from=Fe;function se(J){return new p.$CM(y.to(J.range))}ye.to=se})(tt||(e.SelectionRange=tt={}));var rt;(function(ye){function Fe(se){switch(se){case 2:return p.TextDocumentSaveReason.AfterDelay;case 1:return p.TextDocumentSaveReason.Manual;case 3:case 4:return p.TextDocumentSaveReason.FocusOut}}ye.to=Fe})(rt||(e.TextDocumentSaveReason=rt={}));var ct;(function(ye){function Fe(J){switch(J){case p.TextEditorLineNumbersStyle.Off:return 0;case p.TextEditorLineNumbersStyle.Relative:return 2;case p.TextEditorLineNumbersStyle.Interval:return 3;case p.TextEditorLineNumbersStyle.On:default:return 1}}ye.from=Fe;function se(J){switch(J){case 0:return p.TextEditorLineNumbersStyle.Off;case 2:return p.TextEditorLineNumbersStyle.Relative;case 3:return p.TextEditorLineNumbersStyle.Interval;case 1:default:return p.TextEditorLineNumbersStyle.On}}ye.to=se})(ct||(e.TextEditorLineNumbersStyle=ct={}));var ft;(function(ye){function Fe(J){if(J===p.EndOfLine.CRLF)return 1;if(J===p.EndOfLine.LF)return 0}ye.from=Fe;function se(J){if(J===1)return p.EndOfLine.CRLF;if(J===0)return p.EndOfLine.LF}ye.to=se})(ft||(e.EndOfLine=ft={}));var Ue;(function(ye){function Fe(se){if(typeof se=="object")return se.viewId;switch(se){case p.ProgressLocation.SourceControl:return 3;case p.ProgressLocation.Window:return 10;case p.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ye.from=Fe})(Ue||(e.ProgressLocation=Ue={}));var ot;(function(ye){function Fe(J){const Pe={start:J.start+1,end:J.end+1};return J.kind&&(Pe.kind=X.from(J.kind)),Pe}ye.from=Fe;function se(J){const Pe={start:J.start-1,end:J.end-1};return J.kind&&(Pe.kind=X.to(J.kind)),Pe}ye.to=se})(ot||(e.FoldingRange=ot={}));var X;(function(ye){function Fe(J){if(J)switch(J){case p.FoldingRangeKind.Comment:return n.$du.Comment;case p.FoldingRangeKind.Imports:return n.$du.Imports;case p.FoldingRangeKind.Region:return n.$du.Region}}ye.from=Fe;function se(J){if(J)switch(J.value){case n.$du.Comment.value:return p.FoldingRangeKind.Comment;case n.$du.Imports.value:return p.FoldingRangeKind.Imports;case n.$du.Region.value:return p.FoldingRangeKind.Region}}ye.to=se})(X||(e.FoldingRangeKind=X={}));var Z;(function(ye){function Fe(se){if(se)return{pinned:typeof se.preview=="boolean"?!se.preview:void 0,inactive:se.background,preserveFocus:se.preserveFocus,selection:typeof se.selection=="object"?y.from(se.selection):void 0,override:typeof se.override=="boolean"?u.$uF.id:void 0}}ye.from=Fe})(Z||(e.TextEditorOpenOptions=Z={}));var $e;(function(ye){function Fe(Ve){return Ve instanceof p.$eN?Ve.toJSON():typeof Ve=="string"?Ve:se(Ve)||J(Ve)?new p.$eN(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}ye.from=Fe;function se(Ve){const Qe=Ve;return Qe?s.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function J(Ve){const Qe=Ve;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Pe(Ve){return typeof Ve=="string"?Ve:new p.$eN(s.URI.revive(Ve.baseUri),Ve.pattern)}ye.to=Pe})($e||(e.GlobPattern=$e={}));var me;(function(ye){function Fe(se){if(se){if(Array.isArray(se))return se.map(Fe);if(typeof se=="string")return se;{const J=se;return{language:J.language,scheme:J.scheme,pattern:$e.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}ye.from=Fe})(me||(e.LanguageSelector=me={}));var Ze;(function(ye){function Fe(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(Pe=>Array.isArray(Pe)&&Pe.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&s.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(Qe=>Qe instanceof p.$hM)))}ye.is=Fe;function se(J){return{documents:J.documents.map(Pe=>Pe.map(Ve=>({uri:s.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(Qe=>y.from(Qe))})))}}ye.from=se})(Ze||(e.MappedEditsContext=Ze={}));var at;(function(ye){function Fe(J){return{start:J.start,end:J.end}}ye.from=Fe;function se(J){return new p.$HN(J.start,J.end)}ye.to=se})(at||(e.NotebookRange=at={}));var dt;(function(ye){function Fe(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}ye.to=Fe;function se(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}ye.from=se})(dt||(e.NotebookCellExecutionSummary=dt={}));var Ct;(function(ye){function Fe(se){if(se===d.NotebookCellExecutionState.Unconfirmed)return p.NotebookCellExecutionState.Pending;if(se===d.NotebookCellExecutionState.Pending)return;if(se===d.NotebookCellExecutionState.Executing)return p.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${se}`)}ye.to=Fe})(Ct||(e.NotebookCellExecutionState=Ct={}));var Bt;(function(ye){function Fe(J){switch(J){case p.NotebookCellKind.Markup:return d.CellKind.Markup;case p.NotebookCellKind.Code:default:return d.CellKind.Code}}ye.from=Fe;function se(J){switch(J){case d.CellKind.Markup:return p.NotebookCellKind.Markup;case d.CellKind.Code:default:return p.NotebookCellKind.Code}}ye.to=se})(Bt||(e.NotebookCellKind=Bt={}));var Qt;(function(ye){function Fe(J){const Pe={metadata:J.metadata??Object.create(null),cells:[]};for(const Ve of J.cells)p.$IN.validate(Ve),Pe.cells.push(xt.from(Ve));return Pe}ye.from=Fe;function se(J){const Pe=new p.$JN(J.cells.map(xt.to));return(0,r.$jg)(J.metadata)||(Pe.metadata=J.metadata),Pe}ye.to=se})(Qt||(e.NotebookData=Qt={}));var xt;(function(ye){function Fe(J){return{cellKind:Bt.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:dt.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(kt.from):[]}}ye.from=Fe;function se(J){return new p.$IN(Bt.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(kt.to):void 0,J.metadata,J.internalMetadata?dt.to(J.internalMetadata):void 0)}ye.to=se})(xt||(e.NotebookCellData=xt={}));var Zt;(function(ye){function Fe(J){return{mime:J.mime,valueBytes:O.$Fe.wrap(J.data)}}ye.from=Fe;function se(J){return new p.$KN(J.valueBytes.buffer,J.mime)}ye.to=se})(Zt||(e.NotebookCellOutputItem=Zt={}));var kt;(function(ye){function Fe(J){return{outputId:J.id,items:J.items.map(Zt.from),metadata:J.metadata}}ye.from=Fe;function se(J){const Pe=J.items.map(Zt.to);return new p.$LN(Pe,J.outputId,J.metadata)}ye.to=se})(kt||(e.NotebookCellOutput=kt={}));var _t;(function(ye){function Fe(Pe){return J(Pe)?{include:$e.from(Pe.include)??void 0,exclude:$e.from(Pe.exclude)??void 0}:$e.from(Pe)??void 0}ye.from=Fe;function se(Pe){return J(Pe)?{include:$e.to(Pe.include),exclude:$e.to(Pe.exclude)}:$e.to(Pe)}ye.to=se;function J(Pe){const Ve=Pe;return Ve?!(0,r.$fg)(Ve.include)&&!(0,r.$fg)(Ve.exclude):!1}})(_t||(e.NotebookExclusiveDocumentPattern=_t={}));var Xe;(function(ye){function Fe(se,J,Pe){const Ve=typeof se.command=="string"?{title:"",command:se.command}:se.command;return{alignment:se.alignment===p.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Ve,Pe),text:se.text,tooltip:se.tooltip,accessibilityInformation:se.accessibilityInformation,priority:se.priority}}ye.from=Fe})(Xe||(e.NotebookStatusBarItem=Xe={}));var ti;(function(ye){function Fe(se,J,Pe){const Ve=typeof se.command=="string"?{title:"",command:se.command}:se.command;return{command:J.toInternal(Ve,Pe),label:se.label,description:se.description,detail:se.detail,documentation:se.documentation}}ye.from=Fe})(ti||(e.NotebookKernelSourceAction=ti={}));var ii;(function(ye){function Fe(se){return{transientOutputs:se?.transientOutputs??!1,transientCellMetadata:se?.transientCellMetadata??{},transientDocumentMetadata:se?.transientDocumentMetadata??{},cellContentMetadata:se?.cellContentMetadata??{}}}ye.from=Fe})(ii||(e.NotebookDocumentContentOptions=ii={}));var ht;(function(ye){function Fe(J){return{uri:J.uri,provides:J.provides}}ye.from=Fe;function se(J){return new p.$NN(s.URI.revive(J.uri),J.provides)}ye.to=se})(ht||(e.NotebookRendererScript=ht={}));var pt;(function(ye){function Fe(J){return{message:ie.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:y.from(J.location.range),uri:J.location.uri}}}ye.from=Fe;function se(J){const Pe=new p.$TN(typeof J.message=="string"?J.message:ie.to(J.message));return Pe.actualOutput=J.actual,Pe.expectedOutput=J.expected,Pe.contextValue=J.contextValue,Pe.location=J.location?ge.to(J.location):void 0,Pe}ye.to=se})(pt||(e.TestMessage=pt={}));var Lt;(function(ye){ye.namespace=f.$7K,ye.denamespace=f.$8K})(Lt||(e.TestTag=Lt={}));var Gt;(function(ye){function Fe(J){const Pe=(0,c.$AO)(J).controllerId;return{extId:a.$2K.fromExtHostTestItem(J,Pe).toString(),label:J.label,uri:s.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Ve=>Lt.namespace(Pe,Ve.id)),range:o.$ut.lift(y.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&ie.fromStrict(J.error)||null}}ye.from=Fe;function se(J){return{parent:void 0,error:void 0,id:a.$2K.fromString(J.extId).localId,label:J.label,uri:s.URI.revive(J.uri),tags:(J.tags||[]).map(Pe=>{const{tagId:Ve}=Lt.denamespace(Pe);return new p.$UN(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:y.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}ye.toPlain=se})(Gt||(e.TestItem=Gt={})),function(ye){function Fe(J){return{id:J.id}}ye.from=Fe;function se(J){return new p.$UN(J.id)}ye.to=se}(Lt||(e.TestTag=Lt={}));var Tt;(function(ye){const Fe=(J,Pe)=>{const Ve=J.value;if(!Ve)return;const Qe={...Gt.toPlain(Ve.item),parent:Pe,taskStates:Ve.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(it=>it.type===0).map(pt.to)})),children:[]};if(J.children)for(const Ge of J.children.values()){const it=Fe(Ge,Qe);it&&Qe.children.push(it)}return Qe};function se(J){const Pe=new l.$tO;for(const Ge of J.items)Pe.insert(a.$2K.fromString(Ge.item.extId).path,Ge);const Ve=[Pe.nodes],Qe=[];for(;Ve.length;)for(const Ge of Ve.pop())Ge.value?Qe.push(Ge):Ge.children&&Ve.push(Ge.children.values());return{completedAt:J.completedAt,results:Qe.map(Ge=>Fe(Ge)).filter(r.$eg)}}ye.to=se})(Tt||(e.TestResults=Tt={}));var mt;(function(ye){function Fe(Ve){return{covered:Ve.covered,total:Ve.total}}function se(Ve){return"line"in Ve?k.from(Ve):y.from(Ve)}function J(Ve){if(typeof Ve.executed=="number"&&Ve.executed<0)throw new Error(`Invalid coverage count ${Ve.executed}`);return"branches"in Ve?{count:Ve.executed,location:se(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(Qe=>({count:Qe.executed,location:Qe.location&&se(Qe.location),label:Qe.label})):void 0}:{type:0,name:Ve.name,count:Ve.executed,location:se(Ve.location)}}ye.fromDetails=J;function Pe(Ve,Qe){return p.$WN(Qe.statementCoverage),p.$WN(Qe.branchCoverage),p.$WN(Qe.declarationCoverage),{id:Ve,uri:Qe.uri,statement:Fe(Qe.statementCoverage),branch:Qe.branchCoverage&&Fe(Qe.branchCoverage),declaration:Qe.declarationCoverage&&Fe(Qe.declarationCoverage)}}ye.fromFile=Pe})(mt||(e.TestCoverage=mt={}));var Pt;(function(ye){function Fe(se){switch(se){case 1:return p.CodeActionTriggerKind.Invoke;case 2:return p.CodeActionTriggerKind.Automatic}}ye.to=Fe})(Pt||(e.CodeActionTriggerKind=Pt={}));var ai;(function(ye){function Fe(J){const Pe=new p.$2N(ne.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),y.to(J.range),y.to(J.selectionRange));return Pe._sessionId=J._sessionId,Pe._itemId=J._itemId,Pe}ye.to=Fe;function se(J,Pe,Ve){if(Pe=Pe??J._sessionId,Ve=Ve??J._itemId,Pe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Ve,kind:ne.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:y.from(J.range),selectionRange:y.from(J.selectionRange),tags:J.tags?.map(z.from)}}ye.from=se})(ai||(e.TypeHierarchyItem=ai={}));var Ut;(function(ye){function Fe(se){if(se)return{value:se.value,tooltip:se.tooltip}}ye.from=Fe})(Ut||(e.ViewBadge=Ut={}));var Je;(function(ye){function Fe(Ve,Qe,Ge){const it=Qe.fileData;return it?new p.$9M(new p.$0M(it.name,s.URI.revive(it.uri),it.id,(0,N.$db)(()=>Ge(it.id)))):Ve===T.$Qs.uriList&&Qe.uriListData?new p.$8M(Pe(Qe.uriListData)):new p.$8M(Qe.asString)}ye.to=Fe;async function se(Ve,Qe){const Ge=await Qe.asString();if(Ve===T.$Qs.uriList)return{asString:Ge,fileData:void 0,uriListData:J(Ge)};const it=Qe.asFile();return{asString:Ge,fileData:it?{name:it.name,uri:it.uri,id:it._itemId??it.id}:void 0}}ye.from=se;function J(Ve){return M.$Ut.split(Ve).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return s.URI.parse(Qe)}catch{}return Qe})}function Pe(Ve){return M.$Ut.create(Ve.map(Qe=>typeof Qe=="string"?Qe:s.URI.revive(Qe)))}})(Je||(e.DataTransferItem=Je={}));var ni;(function(ye){function Fe(J,Pe){const Ve=J.items.map(([Qe,Ge])=>[Qe,Je.to(Qe,Ge,Pe)]);return new p.$$M(Ve)}ye.toDataTransfer=Fe;async function se(J){const Pe={items:[]},Ve=[];for(const[Qe,Ge]of J)Ve.push((async()=>{Pe.items.push([Qe,await Je.from(Qe,Ge)])})());return await Promise.all(Ve),Pe}ye.from=se})(ni||(e.DataTransfer=ni={}));var ci;(function(ye){function Fe(J,Pe){return{kind:"reply",agentId:J.participant??Pe?.agentId??"",subCommand:J.command??Pe?.command,message:J.prompt,title:J.label}}ye.from=Fe;function se(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}ye.to=se})(ci||(e.ChatFollowup=ci={}));var Ht;(function(ye){function Fe(J){switch(J.role){case 0:return new p.$oO(J.content);case 1:return new p.$pO(J.content);case 2:return new p.$qO(J.content)}}ye.to=Fe;function se(J){if(J instanceof p.$oO)return{role:0,content:J.content};if(J instanceof p.$pO)return{role:1,content:J.content};if(J instanceof p.$qO)return{role:2,content:J.content};throw new Error("Invalid LanguageModelMessage")}ye.from=se})(Ht||(e.LanguageModelMessage=Ht={}));var gt;(function(ye){function Fe(J){return{kind:"markdownContent",content:ie.from(J.value)}}ye.from=Fe;function se(J){return new p.$cO(ie.to(J.content))}ye.to=se})(gt||(e.ChatResponseMarkdownPart=gt={}));var At;(function(ye){function Fe(J){return{kind:"markdownVuln",content:ie.from(J.value),vulnerabilities:J.vulnerabilities}}ye.from=Fe;function se(J){return new p.$dO(ie.to(J.content),J.vulnerabilities)}ye.to=se})(At||(e.ChatResponseMarkdownWithVulnerabilitiesPart=At={}));var Ot;(function(ye){function Fe(J){return{kind:"agentDetection",agentId:J.participant,command:J.command}}ye.from=Fe;function se(J){return new p.$eO(J.agentId,J.command)}ye.to=se})(Ot||(e.ChatResponseDetectedParticipantPart=Ot={}));var Nt;(function(ye){function Fe(J){const{value:Pe,baseUri:Ve}=J;function Qe(Ge,it){return Ge.map(Dt=>{const Wt=s.URI.joinPath(it,Dt.name);return{label:Dt.name,uri:Wt,children:Dt.children&&Qe(Dt.children,Wt)}})}return{kind:"treeData",treeData:{label:(0,b.$7g)(Ve),uri:Ve,children:Qe(Pe,Ve)}}}ye.from=Fe;function se(J){const Pe=(0,E.$6h)(J.treeData);function Ve(it){return it.map(Dt=>({name:Dt.label,children:Dt.children&&Ve(Dt.children)}))}const Qe=Pe.uri,Ge=Pe.children?Ve(Pe.children):[];return new p.$fO(Ge,Qe)}ye.to=se})(Nt||(e.ChatResponseFilesPart=Nt={}));var Vt;(function(ye){function Fe(J){return{kind:"inlineReference",name:J.title,inlineReference:s.URI.isUri(J.value)?J.value:h.from(J.value)}}ye.from=Fe;function se(J){const Pe=(0,E.$6h)(J);return new p.$gO(s.URI.isUri(Pe.inlineReference)?Pe.inlineReference:h.to(Pe.inlineReference),J.name)}ye.to=se})(Vt||(e.ChatResponseAnchorPart=Vt={}));var Xt;(function(ye){function Fe(J){return{kind:"progressMessage",content:ie.from(J.value)}}ye.from=Fe;function se(J){return new p.$hO(J.content.value)}ye.to=se})(Xt||(e.ChatResponseProgressPart=Xt={}));var Kt;(function(ye){function Fe(J){return{kind:"warning",content:ie.from(J.value)}}ye.from=Fe;function se(J){return new p.$iO(J.content.value)}ye.to=se})(Kt||(e.ChatResponseWarningPart=Kt={}));var zt;(function(ye){function Fe(J,Pe,Ve){return{kind:"command",command:Pe.toInternal(J.value,Ve)??{command:J.value.command,title:J.value.title}}}ye.from=Fe;function se(J,Pe){return new p.$jO(Pe.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}ye.to=se})(zt||(e.ChatResponseCommandButtonPart=zt={}));var Mt;(function(ye){function Fe(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(Pe=>ae.from(Pe))}}ye.from=Fe;function se(J){return new p.$lO(s.URI.revive(J.uri),J.edits.map(Pe=>ae.to(Pe)))}ye.to=se})(Mt||(e.ChatResponseTextEditPart=Mt={}));var Jt;(function(ye){function Fe(J){const Pe=g.ThemeIcon.isThemeIcon(J.iconPath)?J.iconPath:J.iconPath&&"light"in J.iconPath&&"dark"in J.iconPath&&s.URI.isUri(J.iconPath.light)&&s.URI.isUri(J.iconPath.dark)?{light:s.URI.revive(J.iconPath.light),dark:s.URI.revive(J.iconPath.dark)}:void 0;return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:s.URI.isUri(J.value.value)||!J.value.value?J.value.value:h.from(J.value.value)},iconPath:Pe}:{kind:"reference",reference:s.URI.isUri(J.value)?J.value:h.from(J.value),iconPath:Pe}}ye.from=Fe;function se(J){const Pe=(0,E.$6h)(J),Ve=Qe=>s.URI.isUri(Qe)?Qe:h.to(Qe);return new p.$kO("variableName"in Pe.reference?{variableName:Pe.reference.variableName,value:Pe.reference.value&&Ve(Pe.reference.value)}:Ve(Pe.reference))}ye.to=se})(Jt||(e.ChatResponseReferencePart=Jt={}));var St;(function(ye){function Fe(Pe,Ve,Qe){return Pe instanceof p.$cO?gt.from(Pe):Pe instanceof p.$gO?Vt.from(Pe):Pe instanceof p.$kO?Jt.from(Pe):Pe instanceof p.$hO?Xt.from(Pe):Pe instanceof p.$fO?Nt.from(Pe):Pe instanceof p.$jO?zt.from(Pe,Ve,Qe):Pe instanceof p.$lO?Mt.from(Pe):Pe instanceof p.$dO?At.from(Pe):Pe instanceof p.$eO?Ot.from(Pe):Pe instanceof p.$iO?Kt.from(Pe):{kind:"markdownContent",content:ie.from("")}}ye.from=Fe;function se(Pe,Ve){switch(Pe.kind){case"reference":return Jt.to(Pe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(Pe,Ve)}}ye.to=se;function J(Pe,Ve){switch(Pe.kind){case"markdownContent":return gt.to(Pe);case"inlineReference":return Vt.to(Pe);case"progressMessage":return;case"treeData":return Nt.to(Pe);case"command":return zt.to(Pe,Ve)}}ye.toContent=J})(St||(e.ChatResponsePart=St={}));var yt;(function(ye){function Fe(se){return{prompt:se.message,command:se.command,attempt:se.attempt??0,enableCommandDetection:se.enableCommandDetection??!0,variables:se.variables.variables.map(Yt.to),location:wt.to(se.location)}}ye.to=Fe})(yt||(e.ChatAgentRequest=yt={}));var wt;(function(ye){function Fe(se){switch(se){case t.ChatAgentLocation.Notebook:return p.ChatLocation.Notebook;case t.ChatAgentLocation.Terminal:return p.ChatLocation.Terminal;case t.ChatAgentLocation.Panel:return p.ChatLocation.Panel;case t.ChatAgentLocation.Editor:return p.ChatLocation.Editor}}ye.to=Fe})(wt||(e.ChatLocation=wt={}));var Yt;(function(ye){function Fe(se){const J=se.value;if(!J)throw new Error("Invalid value reference");return{name:se.name,range:se.range&&[se.range.start,se.range.endExclusive],value:(0,s.$vc)(J)?s.URI.revive(J):J}}ye.to=Fe})(Yt||(e.ChatAgentValueReference=Yt={}));var Et;(function(ye){function Fe(se,J,Pe){return{label:se.label,value:se.values[0].value,insertText:se.insertText,detail:se.detail,documentation:se.documentation,command:J.toInternal(se.command,Pe)}}ye.from=Fe})(Et||(e.ChatAgentCompletionItem=Et={}));var ui;(function(ye){function Fe(se){return{errorDetails:se.errorDetails,metadata:se.metadata}}ye.to=Fe})(ui||(e.ChatAgentResult=ui={}));var ei;(function(ye){function Fe(se,J,Pe){if(J.action.kind==="vote")return;const Ve=ui.to(se);if(J.action.kind==="command"){const Qe=J.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Pe.fromInternal(Qe)??{command:Qe.id,title:Qe.title}}},result:Ve}}else return J.action.kind==="followUp"?{action:{kind:"followUp",followup:ci.to(J.action.followup)},result:Ve}:J.action.kind==="inlineChat"?{action:{kind:"editor",accepted:J.action.action==="accepted"},result:Ve}:{action:J.action,result:Ve}}ye.to=Fe})(ei||(e.ChatAgentUserActionEvent=ei={}));var Ei;(function(ye){function Fe(se,J,Pe){return"terminalCommand"in se?{terminalCommand:se.terminalCommand,shouldExecute:se.shouldExecute}:"uri"in se?{uri:se.uri}:J.toInternal(se,Pe)}ye.from=Fe})(Ei||(e.TerminalQuickFix=Ei={}));var li;(function(ye){function Fe(se){return{kind:fi.to(se.kind)}}ye.to=Fe})(li||(e.PartialAcceptInfo=li={}));var fi;(function(ye){function Fe(se){switch(se){case 0:return p.PartialAcceptTriggerKind.Word;case 1:return p.PartialAcceptTriggerKind.Line;case 2:return p.PartialAcceptTriggerKind.Suggest;default:return p.PartialAcceptTriggerKind.Unknown}}ye.to=Fe})(fi||(e.PartialAcceptTriggerKind=fi={}));var Ft;(function(ye){function Fe(se,J){return{id:J,label:se.label,description:se.description,canEdit:se.canEdit,collapsibleState:se.collapsibleState||0,contextValue:se.contextValue}}ye.from=Fe})(Ft||(e.DebugTreeItem=Ft={}))}),define(Se[262],Ie([1,0,4,17,8,34]),function(he,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hlc=void 0;let A=class{constructor(m,E){this.a=m.getProxy(P.$dM.MainThreadBulkEdits),this.b={getTextDocumentVersion:T=>E.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,E,T){const S=new N.$Bw(M.WorkspaceEdit.from(m,this.b));return this.a.$tryApplyWorkspaceEdit(S,void 0,T?.isRefactoring??!1)}};e.$Hlc=A,e.$Hlc=A=Ke([We(0,O.$EO)],A)}),define(Se[263],Ie([1,0,18,11,44,5,42,6,66,15,2,20,4,8,7,225,26]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=void 0;class o{constructor(u,t,d,a,f){this.j=u,this.k=t,this.l=d,this.m=a,this.n=f,this.b=m.$_d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(a){if(u.c){const f=new Error("Response stream has been closed");throw Error.captureStackTrace(f,a),f}};const u=this;this.b.reset();const d=a=>{typeof this.d>"u"&&"content"in a&&(this.d=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,a)};this.g={markdown(a){t(this.markdown);const f=new g.$cO(a),w=b.ChatResponseMarkdownPart.from(f);return d(w),this},markdownWithVulnerabilities(a,f){t(this.markdown),f&&(0,s.$PG)(u.j,"chatParticipantAdditions");const w=new g.$dO(a,f),p=b.ChatResponseMarkdownWithVulnerabilitiesPart.from(w);return d(p),this},filetree(a,f){t(this.filetree);const w=new g.$fO(a,f),p=b.ChatResponseFilesPart.from(w);return d(p),this},anchor(a,f){t(this.anchor);const w=new g.$gO(a,f),p=b.ChatResponseAnchorPart.from(w);return d(p),this},button(a){t(this.anchor);const f=new g.$jO(a),w=b.ChatResponseCommandButtonPart.from(f,u.m,u.n);return d(w),this},progress(a){t(this.progress);const f=new g.$hO(a),w=b.ChatResponseProgressPart.from(f);return d(w),this},warning(a){t(this.progress),(0,s.$PG)(u.j,"chatParticipantAdditions");const f=new g.$iO(a),w=b.ChatResponseWarningPart.from(f);return d(w),this},reference(a,f){if(t(this.reference),"variableName"in a&&!a.value){const w=u.k.variables.variables.find(p=>p.name===a.variableName);if(w){let p;if(w.references?.length)p=w.references.map(v=>({kind:"reference",reference:{variableName:a.variableName,value:v.reference}}));else{const v=new g.$kO(a,f);p=[b.ChatResponseReferencePart.from(v)]}return p.forEach(v=>d(v)),this}}else{const w=new g.$kO(a,f),p=b.ChatResponseReferencePart.from(w);d(p)}return this},textEdit(a,f){t(this.textEdit),(0,s.$PG)(u.j,"chatParticipantAdditions");const w=new g.$lO(a,f),p=b.ChatResponseTextEditPart.from(w);return d(p),this},detectedParticipant(a,f){t(this.detectedParticipant),(0,s.$PG)(u.j,"chatParticipantAdditions");const w=new g.$eO(a,f),p=b.ChatResponseDetectedParticipantPart.from(w);return d(p),this},push(a){if(t(this.push),(a instanceof g.$lO||a instanceof g.$dO||a instanceof g.$eO||a instanceof g.$iO)&&(0,s.$PG)(u.j,"chatParticipantAdditions"),a instanceof g.$kO)this.reference(a.value,a.iconPath);else{const f=b.ChatResponsePart.from(a,u.m,u.n);d(f)}return this}}}return this.g}}class n extends $.$Uc{static{this.b=0}constructor(u,t,d){super(),this.n=t,this.s=d,this.c=new Map,this.j=this.B(new $.$4c),this.m=this.B(new $.$4c),this.g=u.getProxy(l.$dM.MainThreadChatAgents2)}transferActiveChat(u){this.g.$transferActiveChatSession(u)}createChatAgent(u,t,d){const a=n.b++,f=new i(u,t,this.g,a,d);return this.c.set(a,f),this.g.$registerAgent(a,u.identifier,t,{},void 0),f.apiAgent}createDynamicChatAgent(u,t,d,a,f,w){const p=n.b++,v=new i(u,t,this.g,p,w);return this.c.set(p,v),this.g.$registerAgent(p,u.identifier,t,{isSticky:!0},{name:d,description:f,publisherDisplayName:a}),v.apiAgent}async $invokeAgent(u,t,d,a){const f=this.c.get(u);if(!f)throw new Error(`[CHAT](${u}) CANNOT invoke agent because the agent is not registered`);let w=this.j.get(t.sessionId);w||(w=new $.$Tc,this.j.set(t.sessionId,w));const p=new o(f.extension,t,this.g,this.s.converter,w);try{const v=await this.t(t.agentId,d),y=f.invoke(b.ChatAgentRequest.to(t),{history:v},p.apiObject,a);return await(0,O.$kh)(Promise.resolve(y).then(h=>{if(h?.metadata)try{JSON.stringify(h.metadata)}catch(D){const k=`result.metadata MUST be JSON.stringify-able. Got error: ${D.message}`;return this.n.error(`[${f.extension.identifier.value}] [@${f.id}] ${k}`,f.extension),{errorDetails:{message:k},timings:p.timings}}return{errorDetails:h?.errorDetails,timings:p.timings,metadata:h?.metadata}}),a)}catch(v){return this.n.error(v,f.extension),{errorDetails:{message:(0,M.$hj)(v),responseIsIncomplete:!0}}}finally{p.close()}}async t(u,t){const d=[];for(const a of t.history){const f=b.ChatAgentResult.to(a.result),w=u===a.request.agentId?f:{...f,metadata:void 0};d.push(new g.$mO(a.request.message,a.request.command,a.request.variables.variables.map(b.ChatAgentValueReference.to),a.request.agentId));const p=(0,P.$Hb)(a.response.map(v=>b.ChatResponsePart.toContent(v,this.s.converter)));d.push(new g.$nO(p,w,a.request.agentId,a.request.command))}return d}$releaseSession(u){this.j.deleteAndDispose(u)}async $provideFollowups(u,t,d,a,f){const w=this.c.get(t);if(!w)return Promise.resolve([]);const p=await this.t(w.id,a),v=b.ChatAgentResult.to(d);return(await w.provideFollowups(v,{history:p},f)).filter(y=>{const h=!y.participant||A.Iterable.some(this.c.values(),D=>D.id===y.participant&&S.$Rm.equals(D.extension.identifier,w.extension.identifier));return h||this.n.warn(`[@${w.id}] ChatFollowup refers to an unknown participant: ${y.participant}`),h}).map(y=>b.ChatFollowup.from(y,u))}$acceptFeedback(u,t,d,a){const f=this.c.get(u);if(!f)return;const w=b.ChatAgentResult.to(t);let p;switch(d){case r.InteractiveSessionVoteDirection.Down:p=g.ChatResultFeedbackKind.Unhelpful;break;case r.InteractiveSessionVoteDirection.Up:p=g.ChatResultFeedbackKind.Helpful;break}f.acceptFeedback(Object.freeze(a?{result:w,kind:p,reportIssue:a}:{result:w,kind:p}))}$acceptAction(u,t,d){const a=this.c.get(u);if(!a||d.action.kind==="vote")return;const f=b.ChatAgentUserActionEvent.to(t,d,this.s.converter);f&&a.acceptAction(Object.freeze(f))}async $invokeCompletionProvider(u,t,d){const a=this.c.get(u);if(!a)return[];let f=this.m.get(u);return f?f.clear():(f=new $.$Tc,this.m.set(u,f)),(await a.invokeCompletionProvider(t,d)).map(p=>b.ChatAgentCompletionItem.from(p,this.s.converter,f))}async $provideWelcomeMessage(u,t,d){const a=this.c.get(u);if(a)return await a.provideWelcomeMessage(b.ChatLocation.to(t),d)}async $provideSampleQuestions(u,t,d){const a=this.c.get(u);if(a)return(await a.provideSampleQuestions(b.ChatLocation.to(t),d)).map(f=>b.ChatFollowup.from(f,void 0))}}e.$Ilc=n;class i{constructor(u,t,d,a,f){this.extension=u,this.id=t,this.u=d,this.w=a,this.x=f,this.n=new N.$de,this.o=new N.$de}acceptFeedback(u){this.n.fire(u)}acceptAction(u){this.o.fire(u)}async invokeCompletionProvider(u,t){return this.q?await this.q.provider.provideCompletionItems(u,t)??[]:[]}async provideFollowups(u,t,d){if(!this.b)return[];const a=await this.b.provideFollowups(u,t,d);return a?a.filter(f=>!(f&&"commandId"in f)).filter(f=>!(f&&"message"in f)):[]}async provideWelcomeMessage(u,t){if(!this.s)return[];const d=await this.s.provideWelcomeMessage(u,t);return d?d.map(a=>typeof a=="string"?a:b.MarkdownString.from(a)):[]}async provideSampleQuestions(u,t){if(!this.s||!this.s.provideSampleQuestions)return[];const d=await this.s.provideSampleQuestions(u,t);return d||[]}get apiAgent(){let u=!1,t=!1;const d=()=>{u||t||(t=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof T.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof g.$cN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:b.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:b.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:b.MarkdownString.from(this.l),supportIssueReporting:this.p,requester:this.t}),t=!1}))},a=this;return{get id(){return a.id},get fullName(){return(0,s.$PG)(a.extension,"defaultChatParticipant"),a.c??a.extension.displayName??a.extension.name},set fullName(f){(0,s.$PG)(a.extension,"defaultChatParticipant"),a.c=f,d()},get iconPath(){return a.d},set iconPath(f){a.d=f,d()},get requestHandler(){return a.x},set requestHandler(f){(0,E.$gg)(typeof f=="function","Invalid request handler"),a.x=f},get followupProvider(){return a.b},set followupProvider(f){a.b=f,d()},get isDefault(){return(0,s.$PG)(a.extension,"defaultChatParticipant"),a.g},set isDefault(f){(0,s.$PG)(a.extension,"defaultChatParticipant"),a.g=f,d()},get helpTextPrefix(){return(0,s.$PG)(a.extension,"defaultChatParticipant"),a.j},set helpTextPrefix(f){(0,s.$PG)(a.extension,"defaultChatParticipant"),a.j=f,d()},get helpTextVariablesPrefix(){return(0,s.$PG)(a.extension,"defaultChatParticipant"),a.k},set helpTextVariablesPrefix(f){(0,s.$PG)(a.extension,"defaultChatParticipant"),a.k=f,d()},get helpTextPostfix(){return(0,s.$PG)(a.extension,"defaultChatParticipant"),a.l},set helpTextPostfix(f){(0,s.$PG)(a.extension,"defaultChatParticipant"),a.l=f,d()},get isSecondary(){return(0,s.$PG)(a.extension,"defaultChatParticipant"),a.m},set isSecondary(f){(0,s.$PG)(a.extension,"defaultChatParticipant"),a.m=f,d()},get supportIssueReporting(){return(0,s.$PG)(a.extension,"chatParticipantAdditions"),a.p},set supportIssueReporting(f){(0,s.$PG)(a.extension,"chatParticipantAdditions"),a.p=f,d()},get onDidReceiveFeedback(){return a.n.event},set participantVariableProvider(f){if((0,s.$PG)(a.extension,"chatParticipantAdditions"),a.q=f,f){if(!f.triggerCharacters.length)throw new Error("triggerCharacters are required");a.u.$registerAgentCompletionsProvider(a.w,f.triggerCharacters)}else a.u.$unregisterAgentCompletionsProvider(a.w)},get participantVariableProvider(){return(0,s.$PG)(a.extension,"chatParticipantAdditions"),a.q},set welcomeMessageProvider(f){(0,s.$PG)(a.extension,"defaultChatParticipant"),a.s=f,d()},get welcomeMessageProvider(){return(0,s.$PG)(a.extension,"defaultChatParticipant"),a.s},onDidPerformAction:(0,s.$OG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(f){a.t=f,d()},get requester(){return a.t},dispose(){u=!0,a.b=void 0,a.n.dispose(),a.u.$unregisterAgent(a.w)}}}invoke(u,t,d,a){return this.x(u,t,d,a)}}}),define(Se[264],Ie([1,0,14,6,4,8,7,26]),function(he,e,P,O,M,N,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jlc=void 0;class m{static{this.a=0}constructor(S){this.b=new Map,this.c=S.getProxy(M.$dM.MainThreadChatVariables)}async $resolveVariable(S,l,b,g){const r=this.b.get(S);if(r)try{if(r.resolver.resolve2){(0,$.$PG)(r.extension,"chatParticipantAdditions");const s=new E(l,this.c),o=await r.resolver.resolve2(r.data.name,{prompt:b},s.apiObject,g);if(o&&o[0])return o[0].value}else{const s=await r.resolver.resolve(r.data.name,{prompt:b},g);if(s&&s[0])return s[0].value}}catch(s){(0,P.$2)(s)}}registerVariableResolver(S,l,b,g){const r=m.a++;return this.b.set(r,{extension:S,data:{name:l,description:b},resolver:g}),this.c.$registerVariable(r,{name:l,description:b}),(0,O.$Sc)(()=>{this.b.delete(r),this.c.$unregisterVariable(r)})}}e.$Jlc=m;class E{constructor(S,l){this.c=S,this.d=l,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let l=function(g){if(S.a){const r=new Error("Response stream has been closed");throw Error.captureStackTrace(r,g),r}};const S=this,b=g=>{this.d.$handleProgressChunk(this.c,g)};this.b={progress(g){l(this.progress);const r=new A.$hO(g),s=N.ChatResponseProgressPart.from(r);return b(s),this},reference(g){l(this.reference);const r=new A.$kO(g),s=N.ChatResponseReferencePart.from(r);return b(s),this},push(g){return l(this.push),g instanceof A.$kO?b(N.ChatResponseReferencePart.from(g)):g instanceof A.$hO&&b(N.ChatResponseProgressPart.from(g)),this}}}return this.b}}}),define(Se[265],Ie([1,0,11,69,5,6,2,89,20,8,7,4,26]),function(he,e,P,O,M,N,A,$,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlc=b;function b(g,r,s){const o=g.getProxy(S.$dM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new m.$Tm,r.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===6){const y=this.b.get(v.handle);return y?y.value:v}else if(v&&v.$mid===7){const y=v,h=this.b.get(y.commentControlHandle);if(!h)return y;const D=h.getCommentThread(y.commentThreadHandle);return D?D.value:y}else if(v&&(v.$mid===9||v.$mid===8)){const y=this.b.get(v.thread.commentControlHandle);if(!y)return v;const h=y.getCommentThread(v.thread.commentThreadHandle);return h?v.$mid===8?h.value:{thread:h.value,text:v.text}:v}else if(v&&v.$mid===10){const y=this.b.get(v.thread.commentControlHandle);if(!y)return v;const h=y.getCommentThread(v.thread.commentThreadHandle);if(!h)return v;const D=v.commentUniqueId,k=h.getCommentByUniqueId(D);return k||v}else if(v&&v.$mid===11){const y=this.b.get(v.thread.commentControlHandle);if(!y)return v;const h=y.getCommentThread(v.thread.commentThreadHandle);if(!h)return v;const D=v.text,k=v.commentUniqueId,C=h.getCommentByUniqueId(k);return C?(typeof C.body=="string"?C.body=D:C.body=new T.$HM(D),C):v}return v}})}createCommentController(v,y,h){const D=n.a++,k=new c(v,D,y,h);this.b.set(k.handle,k);const C=this.c.get(v.identifier)||[];return C.push(k),this.c.set(v.identifier,C),k.value}async $createCommentThreadTemplate(v,y,h){const D=this.b.get(v);D&&D.$createCommentThreadTemplate(y,h)}async $setActiveComment(v,y){const h=this.b.get(v);h&&h.$setActiveComment(y??void 0)}async $updateCommentThreadTemplate(v,y,h){const D=this.b.get(v);D&&D.$updateCommentThreadTemplate(y,h)}$deleteCommentThread(v,y){this.b.get(v)?.$deleteCommentThread(y)}async $provideCommentingRanges(v,y,h){const D=this.b.get(v);if(!D||!D.commentingRangeProvider)return Promise.resolve(void 0);const k=await s.ensureDocumentData(A.URI.revive(y));return(0,P.$oh)(async()=>{const C=await D.commentingRangeProvider.provideCommentingRanges(k.document,h);let I;return Array.isArray(C)?I={ranges:C,fileComments:!1}:C?I={ranges:C.ranges||[],fileComments:C.fileComments||!1}:I=C??void 0,I}).then(C=>{let I;return C&&(I={ranges:C.ranges.map(W=>E.Range.from(W)),fileComments:C.fileComments}),I})}$toggleReaction(v,y,h,D,k){const C=this.b.get(v);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,P.$oh)(()=>{const I=C.getCommentThread(y);if(I){const W=I.getCommentByUniqueId(D.uniqueIdInThread);if(C!==void 0&&W&&C.reactionHandler)return C.reactionHandler(W,d(k))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(v){this.n=v}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(v){(v===void 0!=(this.p===void 0)||!v||!this.p||!v.isEqual(this.p))&&(this.p=v,this.b.range=v,this.c.fire())}get range(){return this.p}set canReply(v){this.d!==v&&(this.d=v,this.b.canReply=v,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(v){this.e=v,this.b.label=v,this.c.fire()}get contextValue(){return this.f}set contextValue(v){this.f=v,this.b.contextValue=v,this.c.fire()}get comments(){return this.q}set comments(v){this.q=v,this.b.comments=v,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(v){this.g=v,this.b.collapsibleState=v,this.c.fire()}get state(){return this.h}set state(v){this.h=v,typeof v=="object"?((0,l.$PG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=v.resolved,this.b.applicability=v.applicability):this.b.state=v,this.c.fire()}get isDisposed(){return this.j}constructor(v,y,h,D,k,C,I,W){this.m=y,this.n=h,this.o=D,this.p=k,this.q=C,this.extensionDescription=I,this.r=W,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new M.$de,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new N.$Vc,this.l.value=new N.$Tc,this.n===void 0&&(this.n=`${v}.${this.handle}`),o.$createCommentThread(y,this.handle,this.n,this.o,E.Range.from(this.p),I.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{o.$deleteCommentThread(y,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(q){V.range=q},get comments(){return V.comments},set comments(q){V.comments=q},get collapsibleState(){return V.collapsibleState},set collapsibleState(q){V.collapsibleState=q},get canReply(){return V.canReply},set canReply(q){V.canReply=q},get contextValue(){return V.contextValue},set contextValue(q){V.contextValue=q},get label(){return V.label},set label(q){V.label=q},get state(){return V.state},set state(q){V.state=q},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new N.$Tc);const v=h=>Object.prototype.hasOwnProperty.call(this.b,h),y={};v("range")&&(y.range=E.Range.from(this.p)),v("label")&&(y.label=this.label),v("contextValue")&&(y.contextValue=this.contextValue??null),v("comments")&&(y.comments=this.q.map(h=>u(this,h,this.k,this.extensionDescription))),v("collapsibleState")&&(y.collapseState=a(this.g)),v("canReply")&&(y.canReply=this.canReply),v("state")&&(y.state=f(this.h)),v("applicability")&&(y.applicability=w(this.h)),v("isTemplate")&&(y.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,y)}getCommentByUniqueId(v){for(const y of this.k){const h=y[0],D=y[1];if(v===D)return h}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(v=>v.dispose())}}Ke([(0,O.$2h)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(v){this.b=v,v?.resourceHints&&(0,l.$PG)(this.h,"commentingRangeHint"),o.$updateCommentingRanges(this.handle,v?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(v){this.c=v,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!v})}get options(){return this.d}set options(v){this.d=v,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,l.$PG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,l.$PG)(this.h,"activeComment"),this.f}constructor(v,y,h,D){this.h=v,this.i=y,this.j=h,this.k=D,this.a=new Map,o.$registerCommentController(this.handle,h,D,this.h.identifier.value);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(C){k.options=C},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(C){k.commentingRangeProvider=C},get reactionHandler(){return k.reactionHandler},set reactionHandler(C){k.reactionHandler=C},get activeCommentThread(){return k.activeCommentThread},createCommentThread(C,I,W){return k.createCommentThread(C,I,W).value},dispose:()=>{k.dispose()}}),this.g=[],this.g.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(v,y,h){y===void 0&&(0,l.$PG)(this.h,"fileComments");const D=new i(this.id,this.handle,void 0,v,y,h,this.h,!1);return this.a.set(D.handle,D),D}$setActiveComment(v){if(!v){this.e=void 0,this.f=void 0;return}const y=this.a.get(v.commentThreadHandle);y&&(this.e=v.uniqueIdInThread?y.getCommentByUniqueId(v.uniqueIdInThread):void 0,this.f=y)}$createCommentThreadTemplate(v,y){const h=new i(this.id,this.handle,void 0,A.URI.revive(v),E.Range.to(y),[],this.h,!0);return h.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(h.handle,h),h}$updateCommentThreadTemplate(v,y){const h=this.a.get(v);h&&(h.range=E.Range.to(y))}$deleteCommentThread(v){this.a.get(v)?.dispose(),this.a.delete(v)}getCommentThread(v){return this.a.get(v)}dispose(){this.a.forEach(v=>{v.dispose()}),this.g.forEach(v=>v.dispose())}}function u(p,v,y,h){let D=y.get(v);return D||(D=++p.commentHandle,y.set(v,D)),v.state!==void 0&&(0,l.$PG)(h,"commentsDraftState"),v.reactions?.some(k=>k.reactors!==void 0)&&(0,l.$PG)(h,"commentReactor"),{mode:v.mode,contextValue:v.contextValue,uniqueIdInThread:D,body:typeof v.body=="string"?v.body:E.MarkdownString.from(v.body),userName:v.author.name,userIconPath:v.author.iconPath,label:v.label,commentReactions:v.reactions?v.reactions.map(k=>t(k)):void 0,state:v.state,timestamp:v.timestamp?.toJSON()}}function t(p){return{label:p.label,iconPath:p.iconPath?E.$DO(p.iconPath):void 0,count:p.count,hasReacted:p.authorHasReacted,reactors:p.reactors&&p.reactors.length>0&&typeof p.reactors[0]!="string"?p.reactors.map(v=>v.name):p.reactors}}function d(p){return{label:p.label||"",count:p.count||0,iconPath:p.iconPath?A.URI.revive(p.iconPath):"",authorHasReacted:p.hasReacted||!1,reactors:p.reactors?.map(v=>({name:v}))}}function a(p){if(p!==void 0)switch(p){case T.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function f(p){let v;if(typeof p=="object"?v=p.resolved:v=p,v!==void 0)switch(v){case T.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case T.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}function w(p){let v;if(typeof p=="object"&&(v=p.applicability),v!==void 0)switch(v){case T.CommentThreadApplicability.Current:return $.CommentThreadApplicability.Current;case T.CommentThreadApplicability.Outdated:return $.CommentThreadApplicability.Outdated}return $.CommentThreadApplicability.Current}return new n}}),define(Se[266],Ie([1,0,24,73,6,16,23,2,8,64,76,4,7]),function(he,e,P,O,M,N,A,$,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6lc=void 0;class b{constructor(d,a){this.document=d,this.b=a,this.a=1,this.c=new T.$tlc("custom documents")}addEdit(d){return this.c.add([d])}async undo(d,a){await this.f(d).undo(),a||this.disposeBackup()}async redo(d,a){await this.f(d).redo(),a||this.disposeBackup()}disposeEdits(d){for(const a of d)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const d=u(this.document.uri)+this.a++;return(0,A.$0g)(this.b,d)}updateBackup(d){this.d?.delete(),this.d=d}disposeBackup(){this.d?.delete(),this.d=void 0}f(d){const a=this.c.get(d,0);if(!a)throw new Error("No edit found");return a}}class g{constructor(){this.a=new Map}get(d,a){return this.a.get(this.b(d,a))}add(d,a,f){const w=this.b(d,a.uri);if(this.a.has(w))throw new Error(`Document already exists for viewType:${d} resource:${a.uri}`);const p=new b(a,f);return this.a.set(w,p),p}delete(d,a){const f=this.b(d,a.uri);this.a.delete(f)}b(d,a){return`${d}@@@${a}`}}var r;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(r||(r={}));class s{constructor(){this.a=new Map}addTextProvider(d,a,f){return this.b(d,{type:0,extension:a,provider:f})}addCustomProvider(d,a,f){return this.b(d,{type:1,extension:a,provider:f})}get(d){return this.a.get(d)}b(d,a){if(this.a.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this.a.set(d,a),new l.$fM(()=>this.a.delete(d))}}class o{constructor(d,a,f,w,p){this.d=a,this.f=f,this.g=w,this.h=p,this.b=new s,this.c=new g,this.a=d.getProxy(S.$dM.MainThreadCustomEditors)}registerCustomEditorProvider(d,a,f,w){const p=new M.$Tc;return i(f)?(p.add(this.b.addTextProvider(a,d,f)),this.a.$registerTextEditorProvider((0,E.$3lc)(d),a,w.webviewOptions||{},{supportsMove:!!f.moveCustomTextEditor},(0,E.$1lc)(d))):(p.add(this.b.addCustomProvider(a,d,f)),n(f)&&p.add(f.onDidChangeCustomDocument(v=>{const y=this.i(a,v.document.uri);if(c(v)){const h=y.addEdit(v);this.a.$onDidEdit(v.document.uri,a,h,v.label)}else this.a.$onContentChange(v.document.uri,a)})),this.a.$registerCustomEditorProvider((0,E.$3lc)(d),a,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,E.$1lc)(d))),l.$fM.from(p,new l.$fM(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(d,a,f,w,p){const v=this.b.get(a);if(!v)throw new Error(`No provider found for '${a}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${a}'`);const y=$.URI.revive(d),h=await v.provider.openCustomDocument(y,{backupId:f,untitledDocumentData:w?.buffer},p);let D;return n(v.provider)&&this.f&&(D=this.f.workspaceValue(v.extension)??this.f.globalValue(v.extension)),this.c.add(a,h,D),{editable:n(v.provider)}}async $disposeCustomDocument(d,a){const f=this.b.get(a);if(!f)throw new Error(`No provider found for '${a}'`);if(f.type!==1)throw new Error(`Invalid provider type for '${a}'`);const w=$.URI.revive(d),{document:p}=this.i(a,w);this.c.delete(a,p),p.dispose()}async $resolveCustomEditor(d,a,f,w,p,v){const y=this.b.get(f);if(!y)throw new Error(`No provider found for '${f}'`);const h=m.ViewColumn.to(p),D=this.g.createNewWebview(a,w.contentOptions,y.extension),k=this.h.createNewWebviewPanel(a,f,w.title,h,w.options,D,w.active),C=$.URI.revive(d);switch(y.type){case 1:{const{document:I}=this.i(f,C);return y.provider.resolveCustomEditor(I,k,v)}case 0:{const I=this.d.getDocument(C);return y.provider.resolveCustomTextEditor(I,k,v)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(d,a,f){this.i(a,d).disposeEdits(f)}async $onMoveCustomEditor(d,a,f){const w=this.b.get(f);if(!w)throw new Error(`No provider found for '${f}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${f}'`);const p=this.h.getWebviewPanel(d);if(!p)throw new Error("No webview found");const v=$.URI.revive(a),y=this.d.getDocument(v);await w.provider.moveCustomTextEditor(y,p,P.CancellationToken.None)}async $undo(d,a,f,w){return this.i(a,d).undo(f,w)}async $redo(d,a,f,w){return this.i(a,d).redo(f,w)}async $revert(d,a,f){const w=this.i(a,d);await this.j(a).revertCustomDocument(w.document,f),w.disposeBackup()}async $onSave(d,a,f){const w=this.i(a,d);await this.j(a).saveCustomDocument(w.document,f),w.disposeBackup()}async $onSaveAs(d,a,f,w){const p=this.i(a,d);return this.j(a).saveCustomDocumentAs(p.document,$.URI.revive(f),w)}async $backup(d,a,f){const w=this.i(a,d),v=await this.j(a).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},f);return w.updateBackup(v),v.id}i(d,a){const f=this.c.get(d,$.URI.revive(a));if(!f)throw new Error("No custom document found");return f}j(d){const f=this.b.get(d)?.provider;if(!f||!n(f))throw new Error("Custom document is not editable");return f}}e.$6lc=o;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function c(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function u(t){const d=t.scheme===N.Schemas.file||t.scheme===N.Schemas.untitled?t.fsPath:t.toString();return(0,O.$kj)(d)+""}}),define(Se[267],Ie([1,0,172,101,2,4,7,8,5,12,28,46]),function(he,e,P,O,M,N,A,$,m,E,T,S){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=e.$Alc=void 0;class b{#e;#t;#i;constructor(s,o,n,i,c,u,t,d){this.d=s,this.e=o,this.f=n,this.g=i,this.h=c,this.c=!1,this.f=Math.max(i,n),this.#i=new T.$Ac(a=>u.getComparisonKey(a)),this.#e=t,this.#t=d}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(s,o){if(!s){this.clear();return}this.j();let n=[];if(M.URI.isUri(s)){if(!o){this.delete(s);return}this.#i.set(s,o.slice()),n=[s]}else if(Array.isArray(s)){n=[];let u;s=[...s].sort(b.k);for(const t of s){const[d,a]=t;if((!u||d.toString()!==u.toString())&&(u&&this.#i.get(u).length===0&&this.#i.delete(u),u=d,n.push(d),this.#i.set(d,[])),a)this.#i.get(d)?.push(...a);else{const f=this.#i.get(d);f&&(f.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let c=0;for(const u of n){let t=[];const d=this.#i.get(u);if(d)if(d.length>this.g){t=[];const a=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let f=0;f<4;f++)for(const w of d)if(w.severity===a[f]&&t.push({...$.Diagnostic.from(w),modelVersionId:this.h(u)})===this.g)break e;t.push({severity:O.MarkerSeverity.Info,message:(0,P.localize)(0,null,d.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=d.map(a=>({...$.Diagnostic.from(a),modelVersionId:this.h(u)}));if(i.push([u,t]),c+=t.length,c>this.f)break}this.#e.$changeMany(this.e,i)}delete(s){this.j(),this.#t.fire([s]),this.#i.delete(s),this.#e?.$changeMany(this.e,[[s,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(s,o){this.j();for(const[n,i]of this)s.call(o,n,i,this)}*[Symbol.iterator](){this.j();for(const s of this.#i.keys())yield[s,this.get(s)]}get(s){this.j();const o=this.#i.get(s);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(s){return this.j(),Array.isArray(this.#i.get(s))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(s,o){return s[0].toString()<o[0].toString()?-1:s[0].toString()>o[0].toString()?1:0}}e.$Alc=b;let g=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(s){const o=new T.$Ac;for(const n of s)o.set(n,n);return{uris:Object.freeze(Array.from(o.values()))}}constructor(s,o,n,i){this.j=o,this.k=n,this.l=i,this.g=new Map,this.h=new m.$he({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=m.Event.map(this.h.event,l._mapper),this.f=s.getProxy(N.$dM.MainThreadDiagnostics)}createDiagnosticCollection(s,o){const{g:n,f:i,h:c,j:u,k:t,l:d}=this,a=new class{$changeMany(p,v){i.$changeMany(p,v),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,p,v.length===0?"CLEARING":v)}$clear(p){i.$clear(p),u.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,p)}dispose(){i.dispose()}};let f;if(!o)o="_generated_diagnostic_collection_name_#"+l.c++,f=o;else if(!n.has(o))f=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do f=o+l.c++;while(n.has(f))}return new class extends b{constructor(){super(o,f,l.e,l.d,p=>d.getDocument(p)?.version,t.extUri,a,c),n.set(f,this)}dispose(){super.dispose(),n.delete(f)}}}getDiagnostics(s){if(s)return this.m(s);{const o=new Map,n=[];for(const i of this.g.values())i.forEach((c,u)=>{let t=o.get(c.toString());typeof t>"u"&&(t=n.length,o.set(c.toString(),t),n.push([c,[]])),n[t][1]=n[t][1].concat(...u)});return n}}m(s){let o=[];for(const n of this.g.values())n.has(s)&&(o=o.concat(n.get(s)));return o}$acceptMarkersChange(s){if(!this.n){const o="_generated_mirror",n=new b(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(o,n),this.n=n}for(const[o,n]of s)this.n.set(M.URI.revive(o),n.map($.Diagnostic.to))}};e.$Blc=g,e.$Blc=g=l=Ke([We(1,E.$3j),We(2,S.$zlc)],g)}),define(Se[268],Ie([1,0,2,14,7,8,200,34]),function(he,e,P,O,M,N,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=void 0;class m{constructor(T,S,l,b={timeout:1500,errors:3}){this.c=T,this.d=S,this.f=l,this.g=b,this.a=new A.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(T){return(S,l,b)=>{const r={dispose:this.a.push([S,l,T])};return Array.isArray(b)&&b.push(r),r}}async $participateInSave(T,S){const l=P.URI.revive(T);let b=!1;const g=setTimeout(()=>b=!0,this.g.timeout),r=[];try{for(const s of[...this.a]){if(b)break;const o=this.d.getDocument(l),n=await this.h(s,{document:o,reason:N.TextDocumentSaveReason.to(S)});r.push(n)}}finally{clearTimeout(g)}return r}h([T,S,l],b){const g=this.b.get(T);return typeof g=="number"&&g>this.g.errors?Promise.resolve(!1):this.i(l,T,S,b).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const s=this.b.get(T);this.b.set(T,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(T,S,l,b){const g=[],r=Date.now(),{document:s,reason:o}=b,{version:n}=s,i=Object.freeze({document:s,reason:o,waitUntil(c){if(Object.isFrozen(g))throw(0,O.$8)("waitUntil can not be called async");g.push(Promise.resolve(c))}});try{S.apply(l,[i])}catch(c){return Promise.reject(c)}return Object.freeze(g),new Promise((c,u)=>{const t=setTimeout(()=>u(new Error("timeout")),this.g.timeout);return Promise.all(g).then(d=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(t),c(d)}).catch(d=>{clearTimeout(t),u(d)})}).then(c=>{const u={edits:[]};for(const t of c)if(Array.isArray(t)&&t.every(d=>d instanceof M.$mM))for(const{newText:d,newEol:a,range:f}of t)u.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:f&&N.Range.from(f),text:d,eol:a&&N.EndOfLine.from(a)}});if(u.edits.length!==0)return n===s.version?this.f.$tryApplyWorkspaceEdit(new $.$Bw(u)):Promise.reject(new Error("concurrent_edits"))})}}e.$Jmc=m}),define(Se[269],Ie([1,0,5,6,2,4,113,8,15,25,7]),function(he,e,P,O,M,N,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Clc=void 0;class S{constructor(b,g){this.a=new P.$de,this.b=new P.$de,this.c=new P.$de,this.d=new P.$de,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new O.$Tc,this.h=new Map,this.f=b.getProxy(N.$dM.MainThreadDocuments),this.g=g,this.g.onDidRemoveDocuments(r=>{for(const s of r)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const s of r)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const g=this.g.getDocument(b);if(g)return g}getDocument(b){const g=this.getDocumentData(b);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return g.document}ensureDocumentData(b){const g=this.g.getDocument(b);if(g)return Promise.resolve(g);let r=this.h.get(b.toString());return r||(r=this.f.$tryOpenDocument(b).then(s=>{this.h.delete(b.toString());const o=M.URI.revive(s);return(0,m.$hg)(this.g.getDocument(o))},s=>(this.h.delete(b.toString()),Promise.reject(s))),this.h.set(b.toString(),r)),r}createDocumentData(b){return this.f.$tryCreateDocument(b).then(g=>M.URI.revive(g))}$acceptModelLanguageChanged(b,g){const r=M.URI.revive(b),s=this.g.getDocument(r);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(g),this.a.fire(s.document)}$acceptModelSaved(b){const g=M.URI.revive(b),r=this.g.getDocument(g);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(b,g){const r=M.URI.revive(b),s=this.g.getDocument(r);if(!s)throw new Error("unknown document");s._acceptIsDirty(g),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,g,r){const s=M.URI.revive(b),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");o._acceptIsDirty(r),o.onEvents(g);let n;g.isUndoing?n=T.TextDocumentChangeReason.Undo:g.isRedoing&&(n=T.TextDocumentChangeReason.Redo),this.c.fire((0,E.$4n)({document:o.document,contentChanges:g.changes.map(i=>({range:$.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(b,g){(0,A.$GO)(b,g)}}e.$Clc=S}),define(Se[67],Ie([1,0,270,5,15,2,3,4,17,8,7]),function(he,e,P,O,M,N,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8lc=e.$7lc=void 0,e.$7lc=(0,A.$wi)("IExtHostEditorTabs");class S{constructor(s,o,n){this.e=n,this.d=o,this.acceptDtoUpdate(s)}get apiObject(){if(!this.a){const s=this,o={get isActive(){return s.b.id===s.e()},get label(){return s.b.label},get input(){return s.c},get isDirty(){return s.b.isDirty},get isPinned(){return s.b.isPinned},get isPreview(){return s.b.isPreview},get group(){return s.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(s){this.b=s,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new T.$3N(N.URI.revive(this.b.input.uri));case 2:return new T.$4N(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified));case 3:return new T.$5N(N.URI.revive(this.b.input.base),N.URI.revive(this.b.input.input1),N.URI.revive(this.b.input.input2),N.URI.revive(this.b.input.result));case 6:return new T.$6N(N.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new T.$7N(this.b.input.viewType);case 4:return new T.$8N(N.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new T.$9N(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new T.$0N;case 9:return new T.$$N(N.URI.revive(this.b.input.uri),N.URI.revive(this.b.input.inputBoxUri));case 10:return new T.$_N;case 11:return new T.$aO(this.b.input.diffEditors.map(s=>new T.$4N(N.URI.revive(s.original),N.URI.revive(s.modified))));default:return}}}class l{constructor(s,o){this.c=[],this.d="",this.b=s,this.e=o;for(const n of s.tabs)n.isActive&&(this.d=n.id),this.c.push(new S(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const s=this,o={get isActive(){return s.b.groupId===s.e()},get viewColumn(){return E.ViewColumn.to(s.b.viewColumn)},get activeTab(){return s.c.find(n=>n.tabId===s.d)?.apiObject},get tabs(){return Object.freeze(s.c.map(n=>n.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(s){this.b=s}acceptTabOperation(s){if(s.kind===0){const n=new S(s.tabDto,this,()=>this.activeTabId());return this.c.splice(s.index,0,n),s.tabDto.isActive&&(this.d=n.tabId),n}else if(s.kind===1){const n=this.c.splice(s.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(s.kind===3){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(s.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this.c.splice(s.index,0,n),n}const o=this.c.find(n=>n.tabId===s.tabDto.id);if(!o)throw new Error("INVALID tab");return s.tabDto.isActive?this.d=s.tabDto.id:this.d===s.tabDto.id&&!s.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(s.tabDto),o}activeTabId(){return this.d}}let b=class{constructor(s){this.b=new O.$de,this.c=new O.$de,this.e=[],this.a=s.getProxy($.$dM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const s=this,o={onDidChangeTabGroups:s.c.event,onDidChangeTabs:s.b.event,get all(){return Object.freeze(s.e.map(n=>n.apiObject))},get activeTabGroup(){const n=s.d;return(0,M.$hg)(s.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,i)=>{const c=Array.isArray(n)?n:[n];return c.length?g(c[0])?this.j(c,i):this.i(c,i):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(s){const o=new Set(this.e.map(a=>a.groupId)),n=new Set(s.map(a=>a.groupId)),i=(0,P.$L)(o,n),c=this.e.filter(a=>i.removed.includes(a.groupId)).map(a=>a.apiObject),u=[],t=[];this.e=s.map(a=>{const f=new l(a,()=>this.d);return i.added.includes(f.groupId)?u.push(f.apiObject):t.push(f.apiObject),f});const d=(0,M.$hg)(s.find(a=>a.isActive===!0)?.groupId);d!==void 0&&this.d!==d&&(this.d=d),this.c.fire(Object.freeze({opened:u,closed:c,changed:t}))}$acceptTabGroupUpdate(s){const o=this.e.find(n=>n.groupId===s.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(s),s.isActive&&(this.d=s.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const o=this.e.find(i=>i.groupId===s.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const n=o.acceptTabOperation(s);switch(s.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(s){for(const o of this.e)for(const n of o.tabs)if(n.apiObject===s)return n}h(s){return this.e.find(o=>o.apiObject===s)}async i(s,o){const n=[];for(const i of s){const c=this.g(i);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,o)}async j(s,o){const n=[];for(const i of s){const c=this.h(i);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,o)}};e.$8lc=b,e.$8lc=b=Ke([We(0,m.$EO)],b);function g(r){return r.tabs!==void 0}}),define(Se[271],Ie([1,0,2,4,6,7,8,313,13,21,26,55]),function(he,e,P,O,M,N,A,$,m,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmc=void 0;class l{constructor(){this.a=[]}add(r){this.b=void 0,this.a.push(r)}delete(r){const s=this.a.indexOf(r);s>=0&&(this.a.splice(s,1),this.b=void 0)}c(){if(!this.b){const r=this.a.sort(),s=[];let o,n,i=14,c=14;for(const u of r){let t=o?(0,m.$zf)(o,u):0;for(t===0?n=1:n=c;t<u.length;t++)t+1===u.length?(i=c,c=9):c+=1,s.push([n,u.toUpperCase().charCodeAt(t),c]),s.push([n,u.toLowerCase().charCodeAt(t),c]),n=c;o=u,c=i}s.push([9,58,10]),s.push([10,47,12]),this.b=new $.$B2(s)}}provideDocumentLinks(r){this.c();const s=[],o=$.$C2.computeLinks({getLineContent(n){return r.lineAt(n-1).text},getLineCount(){return r.lineCount}},this.b);for(const n of o){const i=A.DocumentLink.to(n);i.target&&s.push(i)}return s}}class b{constructor(r,s){this.i=s,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=r.getProxy(O.$dM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(r,s,o,n={}){if(b.j(o),this.d.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(r,"*",this.b));const i=this.h++;this.b.add(s),this.d.add(s),this.c.set(i,o);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof o.copy=="function"&&(c+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,T.$PG)(r,"fsChunks"),c+=4);let u;n.isReadonly&&(0,S.$Vk)(n.isReadonly)&&n.isReadonly.value!==""&&(u={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,s,c,u).catch(d=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${s}`),console.error(d)});const t=o.onDidChangeFile(d=>{const a=[];for(const f of d){const{uri:w,type:p}=f;if(w.scheme!==s)continue;let v;switch(p){case N.FileChangeType.Changed:v=0;break;case N.FileChangeType.Created:v=1;break;case N.FileChangeType.Deleted:v=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:w,type:v})}this.a.$onFileSystemChange(i,a)});return(0,M.$Sc)(()=>{t.dispose(),this.b.delete(s),this.d.delete(s),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(r){if(!r)throw new Error("MISSING provider");if(typeof r.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof r.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof r.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof r.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof r.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof r.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof r.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof r.rename!="function")throw new Error("Provider does NOT implement rename")}static k(r){const{type:s,ctime:o,mtime:n,size:i,permissions:c}=r;return{type:s,ctime:o,mtime:n,size:i,permissions:c}}$stat(r,s){return Promise.resolve(this.l(r).stat(P.URI.revive(s))).then(o=>b.k(o))}$readdir(r,s){return Promise.resolve(this.l(r).readDirectory(P.URI.revive(s)))}$readFile(r,s){return Promise.resolve(this.l(r).readFile(P.URI.revive(s))).then(o=>E.$Fe.wrap(o))}$writeFile(r,s,o,n){return Promise.resolve(this.l(r).writeFile(P.URI.revive(s),o.buffer,n))}$delete(r,s,o){return Promise.resolve(this.l(r).delete(P.URI.revive(s),o))}$rename(r,s,o,n){return Promise.resolve(this.l(r).rename(P.URI.revive(s),P.URI.revive(o),n))}$copy(r,s,o,n){const i=this.l(r);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(P.URI.revive(s),P.URI.revive(o),n))}$mkdir(r,s){return Promise.resolve(this.l(r).createDirectory(P.URI.revive(s)))}$watch(r,s,o,n){const i=this.l(r).watch(P.URI.revive(o),n);this.f.set(s,i)}$unwatch(r,s){const o=this.f.get(s);o&&(o.dispose(),this.f.delete(s))}$open(r,s,o){const n=this.l(r);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(P.URI.revive(s),o))}$close(r,s){const o=this.l(r);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(s))}$read(r,s,o,n){const i=this.l(r);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const c=E.$Fe.alloc(n);return Promise.resolve(i.read(s,o,c.buffer,0,n)).then(u=>c.slice(0,u))}$write(r,s,o,n){const i=this.l(r);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(s,o,n.buffer,0,n.byteLength))}l(r){const s=this.c.get(r);if(!s){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return s}}e.$Lmc=b}),define(Se[272],Ie([1,0,5,37,2,4,8,7,43]),function(he,e,P,O,M,N,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(b,g,r,s,o,n){this.a=Math.random(),this.b=new P.$de,this.c=new P.$de,this.d=new P.$de,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,O.$qk)(o),c=typeof o=="string",u=n?.correlate,t=s(d=>{if(!(typeof d.session=="number"&&d.session!==this.a)&&!(u&&typeof d.session>"u")){if(!n?.ignoreCreateEvents)for(const a of d.created){const f=M.URI.revive(a);i(f.fsPath)&&(!c||g.getWorkspaceFolder(f))&&this.b.fire(f)}if(!n?.ignoreChangeEvents)for(const a of d.changed){const f=M.URI.revive(a);i(f.fsPath)&&(!c||g.getWorkspaceFolder(f))&&this.c.fire(f)}if(!n?.ignoreDeleteEvents)for(const a of d.deleted){const f=M.URI.revive(a);i(f.fsPath)&&(!c||g.getWorkspaceFolder(f))&&this.d.fire(f)}}});this.g=$.$fM.from(this.i(b,r,o,n,n?.correlate),this.b,this.c,this.d,t)}i(b,g,r,s,o){const n=$.$fM.from();if(typeof r=="string"||s?.ignoreChangeEvents&&s?.ignoreCreateEvents&&s?.ignoreDeleteEvents)return n;const i=b.getProxy(N.$dM.MainThreadFileSystemEventService);let c=!1;(r.pattern.includes(O.$mk)||r.pattern.includes(O.$nk))&&(c=!0);let u;return o&&(s?.ignoreChangeEvents||s?.ignoreCreateEvents||s?.ignoreDeleteEvents)&&(u=14,s?.ignoreChangeEvents&&(u&=-3),s?.ignoreCreateEvents&&(u&=-5),s?.ignoreDeleteEvents&&(u&=-9)),i.$watch(g.identifier.value,this.a,r.baseUri,{recursive:c,excludes:s?.excludes??[],filter:u},!!o),$.$fM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class T{constructor(b){this.a=b,this.session=this.a.session,this.b=new m.$V(()=>this.a.created.map(M.URI.revive)),this.c=new m.$V(()=>this.a.changed.map(M.URI.revive)),this.d=new m.$V(()=>this.a.deleted.map(M.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class S{constructor(b,g,r){this.j=b,this.k=g,this.l=r,this.a=new P.$de,this.b=new P.$de,this.c=new P.$de,this.d=new P.$de,this.g=new P.$fe,this.h=new P.$fe,this.i=new P.$fe,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,g,r,s){return new E(this.j,b,g,this.a.event,A.GlobPattern.from(r),s)}$onFileEvent(b){this.a.fire(new T(b))}$onDidRunFileOperation(b,g){switch(b){case 2:this.b.fire(Object.freeze({files:g.map(r=>({oldUri:M.URI.revive(r.source),newUri:M.URI.revive(r.target)}))}));break;case 1:this.d.fire(Object.freeze({files:g.map(r=>M.URI.revive(r.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:g.map(r=>M.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,g){return(r,s,o)=>{const n=function(c){r.call(s,c)};return n.extension=b,g.event(n,void 0,o)}}async $onWillRunFileOperation(b,g,r,s){switch(b){case 2:return await this.n(this.g,{files:g.map(o=>({oldUri:M.URI.revive(o.source),newUri:M.URI.revive(o.target)}))},r,s);case 1:return await this.n(this.i,{files:g.map(o=>M.URI.revive(o.target))},r,s);case 0:case 3:return await this.n(this.h,{files:g.map(o=>M.URI.revive(o.target))},r,s)}}async n(b,g,r,s){const o=new Set,n=[];if(await b.fireAsync(g,s,async(c,u)=>{const t=Date.now(),d=await Promise.resolve(c);d instanceof $.$pM&&(n.push([u.extension,d]),o.add(u.extension.displayName??u.extension.identifier.value)),Date.now()-t>r&&this.k.warn("SLOW file-participant",u.extension.identifier)}),s.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,c]of n){const{edits:u}=A.WorkspaceEdit.from(c,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(u)}return{edit:i,extensionNames:Array.from(o)}}}e.$Mmc=S}),define(Se[273],Ie([1,0,18,11,24,14,91,6,25,66,13,15,2,30,314,89,98,174,20,8,7,26,76,4]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g,r,s,o,n,i,c,u,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=void 0;class a{constructor(U,F){this.d=U,this.e=F}async provideDocumentSymbols(U,F){const G=this.d.getDocument(U),H=await this.e.provideDocumentSymbols(G,F);if(!(0,P.$Kb)(H))return H[0]instanceof c.$zM?H.map(i.DocumentSymbol.from):a.f(H)}static f(U){U=U.slice(0).sort((H,ee)=>{let re=H.location.range.start.compareTo(ee.location.range.start);return re===0&&(re=ee.location.range.end.compareTo(H.location.range.end)),re});const F=[],G=[];for(const H of U){const ee={name:H.name||"!!MISSING: name!!",kind:i.SymbolKind.from(H.kind),tags:H.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:i.Range.from(H.location.range),selectionRange:i.Range.from(H.location.range),children:[]};for(;;){if(G.length===0){G.push(ee),F.push(ee);break}const re=G[G.length-1];if(b.$ut.containsRange(re.range,ee.range)&&!b.$ut.equalsRange(re.range,ee.range)){re.children?.push(ee),G.push(ee);break}G.pop()}}return F}}class f{constructor(U,F,G,H,ee,re){this.f=U,this.g=F,this.h=G,this.j=H,this.k=ee,this.l=re,this.d=new t.$tlc("CodeLens"),this.e=new Map}async provideCodeLenses(U,F){const G=this.f.getDocument(U),H=await this.h.provideCodeLenses(G,F);if(!H||F.isCancellationRequested)return;const ee=this.d.add(H),re=new $.$Tc;this.e.set(ee,re);const Ae={cacheId:ee,lenses:[]};for(let Be=0;Be<H.length;Be++)Ae.lenses.push({cacheId:[ee,Be],range:i.Range.from(H[Be].range),command:this.g.toInternal(H[Be].command,re)});return Ae}async resolveCodeLens(U,F){const G=U.cacheId&&this.d.get(...U.cacheId);if(!G)return;let H;if(typeof this.h.resolveCodeLens!="function"||G.isResolved?H=G:H=await this.h.resolveCodeLens(G,F),H||(H=G),F.isCancellationRequested)return;const ee=U.cacheId&&this.e.get(U.cacheId[0]);if(ee){if(!H.command){const re=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,re),this.l.error(re);return}return U.command=this.g.toInternal(H.command,ee),U}}releaseCodeLenses(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}}function w(je){return Array.isArray(je)?je.map(i.DefinitionLink.from):je?[i.DefinitionLink.from(je)]:[]}class p{constructor(U,F){this.d=U,this.e=F}async provideDefinition(U,F,G){const H=this.d.getDocument(U),ee=i.Position.to(F),re=await this.e.provideDefinition(H,ee,G);return w(re)}}class v{constructor(U,F){this.d=U,this.e=F}async provideDeclaration(U,F,G){const H=this.d.getDocument(U),ee=i.Position.to(F),re=await this.e.provideDeclaration(H,ee,G);return w(re)}}class y{constructor(U,F){this.d=U,this.e=F}async provideImplementation(U,F,G){const H=this.d.getDocument(U),ee=i.Position.to(F),re=await this.e.provideImplementation(H,ee,G);return w(re)}}class h{constructor(U,F){this.d=U,this.e=F}async provideTypeDefinition(U,F,G){const H=this.d.getDocument(U),ee=i.Position.to(F),re=await this.e.provideTypeDefinition(H,ee,G);return w(re)}}class D{static{this.f=10}constructor(U,F){this.g=U,this.h=F,this.d=0,this.e=new Map}async provideHover(U,F,G,H){const ee=this.g.getDocument(U),re=i.Position.to(F);let Ae;if(G&&G.verbosityRequest){const xe=G.verbosityRequest.previousHover.id,_e=this.e.get(xe);if(!_e)throw new Error(`Hover with id ${xe} not found`);const tt={action:G.verbosityRequest.action,previousHover:_e};Ae=await this.h.provideHover(ee,re,H,tt)}else Ae=await this.h.provideHover(ee,re,H);if(!Ae||(0,P.$Kb)(Ae.contents))return;Ae.range||(Ae.range=ee.getWordRangeAtPosition(re)),Ae.range||(Ae.range=new c.$hM(re,re));const Be=i.Hover.from(Ae),qe=this.d;if(this.e.size===D.f){const xe=Math.min(...this.e.keys());this.e.delete(xe)}return this.e.set(qe,Ae),this.d+=1,{...Be,id:qe}}releaseHover(U){this.e.delete(U)}}class k{constructor(U,F){this.d=U,this.e=F}async provideEvaluatableExpression(U,F,G){const H=this.d.getDocument(U),ee=i.Position.to(F),re=await this.e.provideEvaluatableExpression(H,ee,G);if(re)return i.EvaluatableExpression.from(re)}}class C{constructor(U,F){this.d=U,this.e=F}async provideInlineValues(U,F,G,H){const ee=this.d.getDocument(U),re=await this.e.provideInlineValues(ee,i.Range.to(F),i.InlineValueContext.to(G),H);if(Array.isArray(re))return re.map(Ae=>i.InlineValue.from(Ae))}}class I{constructor(U,F){this.d=U,this.e=F}async provideDocumentHighlights(U,F,G){const H=this.d.getDocument(U),ee=i.Position.to(F),re=await this.e.provideDocumentHighlights(H,ee,G);if(Array.isArray(re))return re.map(i.DocumentHighlight.from)}}class W{constructor(U,F){this.d=U,this.e=F}async provideMultiDocumentHighlights(U,F,G,H){const ee=this.d.getDocument(U),re=G.map(qe=>this.d.getDocument(qe)),Ae=i.Position.to(F),Be=await this.e.provideMultiDocumentHighlights(ee,Ae,re,H);if(Array.isArray(Be))return Be.map(i.MultiDocumentHighlight.from)}}class V{constructor(U,F){this.d=U,this.e=F}async provideLinkedEditingRanges(U,F,G){const H=this.d.getDocument(U),ee=i.Position.to(F),re=await this.e.provideLinkedEditingRanges(H,ee,G);if(re&&Array.isArray(re.ranges))return{ranges:(0,P.$Hb)(re.ranges.map(i.Range.from)),wordPattern:re.wordPattern}}}class q{constructor(U,F){this.d=U,this.e=F}async provideReferences(U,F,G,H){const ee=this.d.getDocument(U),re=i.Position.to(F),Ae=await this.e.provideReferences(ee,re,G,H);if(Array.isArray(Ae))return Ae.map(i.location.from)}}class R{static{this.d=1e3}constructor(U,F,G,H,ee,re,Ae){this.g=U,this.h=F,this.j=G,this.k=H,this.l=ee,this.m=re,this.n=Ae,this.e=new t.$tlc("CodeAction"),this.f=new Map}async provideCodeActions(U,F,G,H){const ee=this.g.getDocument(U),re=g.$wt.isISelection(F)?i.Selection.to(F):i.Range.to(F),Ae=[];for(const tt of this.j.getDiagnostics(U))if(re.intersection(tt.range)&&Ae.push(tt)>R.d)break;const Be={diagnostics:Ae,only:G.only?new c.$BM(G.only):void 0,triggerKind:i.CodeActionTriggerKind.to(G.trigger)},qe=await this.k.provideCodeActions(ee,re,Be,H);if(!(0,P.$Lb)(qe)||H.isCancellationRequested)return;const et=this.e.add(qe),xe=new $.$Tc;this.f.set(et,xe);const _e=[];for(let tt=0;tt<qe.length;tt++){const rt=qe[tt];if(rt)if(R.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),_e.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,xe)});else{Be.only&&(rt.kind?Be.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ct=rt.ranges??[];_e.push({cacheId:[et,tt],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,xe),diagnostics:rt.diagnostics&&rt.diagnostics.map(i.Diagnostic.from),edit:rt.edit&&i.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,u.$OG)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,u.$OG)(this.m,"codeActionRanges")?(0,P.$Hb)(ct.map(i.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:et,actions:_e}}async resolveCodeAction(U,F){const[G,H]=U,ee=this.e.get(G,H);if(!ee||R.o(ee))return{};if(!this.k.resolveCodeAction)return{};const re=await this.k.resolveCodeAction(ee,F)??ee;let Ae;re.edit&&(Ae=i.WorkspaceEdit.from(re.edit,void 0));let Be;if(re.command){const qe=this.f.get(G);qe&&(Be=this.h.toInternal(re.command,qe))}return{edit:Ae,command:Be}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static o(U){return typeof U.command=="string"&&typeof U.title=="string"}}class B{constructor(U,F,G,H,ee){this.e=U,this.f=F,this.g=G,this.h=H,this.j=ee,this.d=new t.$tlc("DocumentPasteEdit")}async prepareDocumentPaste(U,F,G,H){if(!this.g.prepareDocumentPaste)return;const ee=this.f.getDocument(U),re=F.map(qe=>i.Range.to(qe)),Ae=i.DataTransfer.toDataTransfer(G,()=>{throw new N.$$});if(await this.g.prepareDocumentPaste(ee,re,Ae,H),H.isCancellationRequested)return;const Be=Array.from(Ae).filter(([,qe])=>!(qe instanceof c.$8M));return i.DataTransfer.from(Be)}async providePasteEdits(U,F,G,H,ee,re){if(!this.g.provideDocumentPasteEdits)return[];const Ae=this.f.getDocument(F),Be=G.map(_e=>i.Range.to(_e)),qe=i.DataTransfer.toDataTransfer(H,async _e=>(await this.e.$resolvePasteFileData(this.h,U,_e)).buffer),et=await this.g.provideDocumentPasteEdits(Ae,Be,qe,{only:ee.only?new c.$aN(ee.only):void 0,triggerKind:ee.triggerKind},re);if(!et||re.isCancellationRequested)return[];const xe=this.d.add(et);return et.map((_e,tt)=>({_cacheId:[xe,tt],title:_e.title??(0,o.localize)(0,null,this.j.displayName||this.j.name),kind:_e.kind,yieldTo:_e.yieldTo?.map(rt=>rt.value),insertText:typeof _e.insertText=="string"?_e.insertText:{snippet:_e.insertText.value},additionalEdit:_e.additionalEdit?i.WorkspaceEdit.from(_e.additionalEdit,void 0):void 0}))}async resolvePasteEdit(U,F){const[G,H]=U,ee=this.d.get(G,H);if(!ee||!this.g.resolveDocumentPasteEdit)return{};const re=await this.g.resolveDocumentPasteEdit(ee,F)??ee;return{additionalEdit:re.additionalEdit?i.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releasePasteEdits(U){this.d.delete(U)}}class K{constructor(U,F){this.d=U,this.e=F}async provideDocumentFormattingEdits(U,F,G){const H=this.d.getDocument(U),ee=await this.e.provideDocumentFormattingEdits(H,F,G);if(Array.isArray(ee))return ee.map(i.TextEdit.from)}}class ie{constructor(U,F){this.d=U,this.e=F}async provideDocumentRangeFormattingEdits(U,F,G,H){const ee=this.d.getDocument(U),re=i.Range.to(F),Ae=await this.e.provideDocumentRangeFormattingEdits(ee,re,G,H);if(Array.isArray(Ae))return Ae.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,F,G,H){(0,S.$gg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(U),re=F.map(i.Range.to),Ae=await this.e.provideDocumentRangesFormattingEdits(ee,re,G,H);if(Array.isArray(Ae))return Ae.map(i.TextEdit.from)}}class ce{constructor(U,F){this.d=U,this.e=F,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,F,G,H,ee){const re=this.d.getDocument(U),Ae=i.Position.to(F),Be=await this.e.provideOnTypeFormattingEdits(re,Ae,G,H,ee);if(Array.isArray(Be))return Be.map(i.TextEdit.from)}}class ve{constructor(U,F){this.e=U,this.f=F,this.d=new t.$tlc("WorkspaceSymbols")}async provideWorkspaceSymbols(U,F){const G=await this.e.provideWorkspaceSymbols(U,F);if(!(0,P.$Lb)(G))return{symbols:[]};const H=this.d.add(G),ee={cacheId:H,symbols:[]};for(let re=0;re<G.length;re++){const Ae=G[re];if(!Ae||!Ae.name){this.f.warn("INVALID SymbolInformation",Ae);continue}ee.symbols.push({...i.WorkspaceSymbol.from(Ae),cacheId:[H,re]})}return ee}async resolveWorkspaceSymbol(U,F){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const G=this.d.get(...U.cacheId);if(G){const H=await this.e.resolveWorkspaceSymbol(G,F);return H&&(0,m.$6n)(U,i.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class ke{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,F,G){this.d=U,this.e=F,this.f=G}async provideRenameEdits(U,F,G,H){const ee=this.d.getDocument(U),re=i.Position.to(F);try{const Ae=await this.e.provideRenameEdits(ee,re,G,H);return Ae?i.WorkspaceEdit.from(Ae):void 0}catch(Ae){const Be=ke.g(Ae);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(U,F,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(U),ee=i.Position.to(F);try{const re=await this.e.prepareRename(H,ee,G);let Ae,Be;if(c.$hM.isRange(re)?(Ae=re,Be=H.getText(re)):(0,S.$$f)(re)&&(Ae=re.range,Be=re.placeholder),!Ae||!Be)return;if(Ae.start.line>ee.line||Ae.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Ae),text:Be}}catch(re){const Ae=ke.g(re);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(re)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class fe{static{this.d={[r.NewSymbolNameTriggerKind.Invoke]:c.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:c.NewSymbolNameTriggerKind.Automatic}}constructor(U,F,G){this.e=U,this.f=F,this.g=G}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(U,F,G,H){const ee=this.e.getDocument(U),re=i.Range.to(F);try{const Ae=fe.d[G],Be=await this.f.provideNewSymbolNames(ee,re,Ae,H);return Be?Be.map(qe=>typeof qe=="string"?{newSymbolName:qe}:{newSymbolName:qe.newSymbolName,tags:qe.tags}):void 0}catch(Ae){this.g.error(fe.h(Ae)??JSON.stringify(Ae,null,"	"));return}}static h(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class pe{constructor(U,F){this.resultId=U,this.tokens=F}}class Ne{constructor(U,F){this.f=U,this.g=F,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,F,G){const H=this.f.getDocument(U),ee=F!==0?this.d.get(F):null;let re=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,ee.resultId,G):await this.g.provideDocumentSemanticTokens(H,G);return ee&&this.d.delete(F),re?(re=Ne.h(re),this.o(Ne.n(ee,re),re)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return Ne.j(U)?Ne.k(U)?U:new c.$AN(new Uint32Array(U.data),U.resultId):Ne.l(U)?Ne.m(U)?U:new c.$CN(U.edits.map(F=>new c.$BN(F.start,F.deleteCount,F.data?new Uint32Array(F.data):F.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const F of U.edits)if(!(F.data instanceof Uint32Array))return!1;return!0}static n(U,F){if(!Ne.j(F)||!U||!U.tokens)return F;const G=U.tokens,H=G.length,ee=F.data,re=ee.length;let Ae=0;const Be=Math.min(H,re);for(;Ae<Be&&G[Ae]===ee[Ae];)Ae++;if(Ae===H&&Ae===re)return new c.$CN([],F.resultId);let qe=0;const et=Be-Ae;for(;qe<et&&G[H-qe-1]===ee[re-qe-1];)qe++;return new c.$CN([{start:Ae,deleteCount:H-Ae-qe,data:ee.subarray(Ae,re-qe)}],F.resultId)}o(U,F){if(Ne.j(U)){const G=this.e++;return this.d.set(G,new pe(U.resultId,U.data)),(0,s.$hbb)({id:G,type:"full",data:U.data})}if(Ne.l(U)){const G=this.e++;return Ne.j(F)?this.d.set(G,new pe(F.resultId,F.data)):this.d.set(G,new pe(U.resultId)),(0,s.$hbb)({id:G,type:"delta",deltas:(U.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class ae{constructor(U,F){this.d=U,this.e=F}async provideDocumentRangeSemanticTokens(U,F,G){const H=this.d.getDocument(U),ee=await this.e.provideDocumentRangeSemanticTokens(H,i.Range.to(F),G);return ee?this.f(ee):null}f(U){return(0,s.$hbb)({id:0,type:"full",data:U.data})}}class Re{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,F,G,H,ee){this.f=U,this.g=F,this.h=G,this.j=H,this.k=ee,this.d=new t.$tlc("CompletionItem"),this.e=new Map}async provideCompletionItems(U,F,G,H){const ee=this.f.getDocument(U),re=i.Position.to(F),Ae=ee.getWordRangeAtPosition(re)||new c.$hM(re,re),Be=Ae.with({end:re}),qe=new E.$_d,et=await this.h.provideCompletionItems(ee,re,H,i.CompletionContext.to(G));if(!et||H.isCancellationRequested)return;const xe=Array.isArray(et)?new c.$OM(et):et,_e=Re.supportsResolving(this.h)?this.d.add(xe.items):this.d.add([]),tt=new $.$Tc;this.e.set(_e,tt);const rt=[],ct={x:_e,b:rt,a:{replace:i.Range.from(Ae),insert:i.Range.from(Be)},c:xe.isIncomplete||void 0,d:qe.elapsed()};for(let ft=0;ft<xe.items.length;ft++){const Ue=xe.items[ft],ot=this.l(Ue,[_e,ft],Be,Ae);rt.push(ot)}return ct}async resolveCompletionItem(U,F){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...U);if(!G)return;const H=this.l(G,U),ee=await this.h.resolveCompletionItem(G,F);if(!ee)return;const re=this.l(ee,U);return(H.h!==re.h||H.i!==re.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==re.n||H.o!==re.o||!(0,m.$7n)(H.p,re.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:re.d,c:re.c,l:re.l,h:re.h,i:re.i,n:re.n,o:re.o,p:re.p}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,F,G,H){const ee=this.e.get(F[0]);if(!ee)throw Error("DisposableStore is missing...");const re=this.g.toInternal(U.command,ee),Ae={x:F,a:U.label,b:U.kind!==void 0?i.CompletionItemKind.from(U.kind):void 0,m:U.tags&&U.tags.map(i.CompletionItemTag.from),c:U.detail,d:typeof U.documentation>"u"?void 0:i.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters?.join(""),l:U.additionalTextEdits&&U.additionalTextEdits.map(i.TextEdit.from),n:re?.$ident,o:re?.id,p:re?.$ident?void 0:re?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae.h=U.textEdit.newText):typeof U.insertText=="string"?Ae.h=U.insertText:U.insertText instanceof c.$qM&&(Ae.h=U.insertText.value,Ae.i|=4);let Be;return U.textEdit?Be=U.textEdit.range:U.range&&(Be=U.range),c.$hM.isRange(Be)?Ae.j=i.Range.from(Be):Be&&(!G?.isEqual(Be.inserting)||!H?.isEqual(Be.replacing))&&(Ae.j={insert:i.Range.from(Be.inserting),replace:i.Range.from(Be.replacing)}),Ae}}class ne{async provideInlineCompletions(U,F,G,H){}disposeCompletions(U){}handleDidShowCompletionItem(U,F,G){}handlePartialAccept(U,F,G,H){}}class z extends ne{constructor(U,F,G,H){super(),this.f=U,this.g=F,this.h=G,this.j=H,this.d=new be,this.e=(0,u.$OG)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:c.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:c.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,u.$OG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,F,G,H){const ee=this.g.getDocument(U),re=i.Position.to(F),Ae=await this.h.provideInlineCompletionItems(ee,re,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:i.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},H);if(!Ae||H.isCancellationRequested)return;const Be=Array.isArray(Ae)?Ae:Ae.items,qe=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[],et=this.e&&!Array.isArray(Ae)?Ae.enableForwardStability:void 0;let xe;return{pid:this.d.createReferenceId({dispose(){xe?.dispose()},items:Be}),items:Be.map((tt,rt)=>{let ct;tt.command&&(xe||(xe=new $.$Tc),ct=this.j.toInternal(tt.command,xe));const ft=tt.insertText;return{insertText:typeof ft=="string"?ft:{snippet:ft.value},filterText:tt.filterText,range:tt.range?i.Range.from(tt.range):void 0,command:ct,idx:rt,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:qe.map(tt=>(xe||(xe=new $.$Tc),this.j.toInternal(tt,xe))),suppressSuggestions:!1,enableForwardStability:et}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,F,G){const H=this.d.get(U)?.items[F];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,G)}handlePartialAccept(U,F,G,H){const ee=this.d.get(U)?.items[F];ee&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ee,G),this.h.handleDidPartiallyAcceptCompletionItem(ee,i.PartialAcceptInfo.to(H)))}}class x{async provideInlineEdits(U,F,G){const H=this.f.getDocument(U),ee=await this.g.provideInlineEdit(H,{triggerKind:this.e[F.triggerKind]},G);if(!ee||G.isCancellationRequested)return;let re;const Ae=this.d.createReferenceId({dispose(){re?.dispose()},item:ee});let Be;ee.accepted&&(re||(re=new $.$Tc),Be=this.h.toInternal(ee.accepted,re));let qe;return ee.rejected&&(re||(re=new $.$Tc),qe=this.h.toInternal(ee.rejected,re)),{pid:Ae,text:ee.text,range:i.Range.from(ee.range),accepted:Be,rejected:qe}}disposeEdit(U){this.d.disposeReferenceId(U)?.dispose()}constructor(U,F,G,H){this.f=F,this.g=G,this.h=H,this.d=new be,this.e={[r.InlineEditTriggerKind.Automatic]:c.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:c.InlineEditTriggerKind.Invoke}}}class be{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const F=this.e++;return this.d.set(F,U),F}disposeReferenceId(U){const F=this.d.get(U);return this.d.delete(U),F}get(U){return this.d.get(U)}}class Te{constructor(U,F){this.e=U,this.f=F,this.d=new t.$tlc("SignatureHelp")}async provideSignatureHelp(U,F,G,H){const ee=this.e.getDocument(U),re=i.Position.to(F),Ae=this.g(G),Be=await this.f.provideSignatureHelp(ee,re,H,Ae);if(Be){const qe=this.d.add([Be]);return{...i.SignatureHelp.from(Be),id:qe}}}g(U){let F;if(U.activeSignatureHelp){const G=i.SignatureHelp.to(U.activeSignatureHelp),H=this.d.get(U.activeSignatureHelp.id,0);H?(F=H,F.activeSignature=G.activeSignature,F.activeParameter=G.activeParameter):F=G}return{...U,activeSignatureHelp:F}}releaseSignatureHelp(U){this.d.delete(U)}}class De{constructor(U,F,G,H,ee){this.f=U,this.g=F,this.h=G,this.j=H,this.k=ee,this.d=new t.$tlc("InlayHints"),this.e=new Map}async provideInlayHints(U,F,G){const H=this.f.getDocument(U),ee=i.Range.to(F),re=await this.h.provideInlayHints(H,ee,G);if(!Array.isArray(re)||re.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(F)}`);return}if(G.isCancellationRequested)return;const Ae=this.d.add(re);this.e.set(Ae,new $.$Tc);const Be={hints:[],cacheId:Ae};for(let qe=0;qe<re.length;qe++)this.l(re[qe],ee)&&Be.hints.push(this.m(re[qe],[Ae,qe]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(F)}`),Be}async resolveInlayHint(U,F){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...U);if(!G)return;const H=await this.h.resolveInlayHint(G,F);if(H&&this.l(H))return this.m(H,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,F){return U.label.length===0||Array.isArray(U.label)&&U.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(F&&!F.contains(U.position))}m(U,F){const G=this.e.get(F[0]);if(!G)throw Error("DisposableStore is missing...");const H={label:"",cacheId:F,tooltip:i.MarkdownString.fromStrict(U.tooltip),position:i.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(i.TextEdit.from),kind:U.kind&&i.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};if(typeof U.label=="string")H.label=U.label;else{const ee=[];H.label=ee;for(const re of U.label){if(!re.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ae={label:re.value,tooltip:i.MarkdownString.fromStrict(re.tooltip)};c.$rM.isLocation(re.location)&&(Ae.location=i.location.from(re.location)),re.command&&(Ae.command=this.g.toInternal(re.command,G)),ee.push(Ae)}}return H}}class we{constructor(U,F){this.e=U,this.f=F,this.d=new t.$tlc("DocumentLink")}async provideLinks(U,F){const G=this.e.getDocument(U),H=await this.f.provideDocumentLinks(G,F);if(!(!Array.isArray(H)||H.length===0)&&!F.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(we.g).map(i.DocumentLink.from)};{const ee=this.d.add(H),re={links:[],cacheId:ee};for(let Ae=0;Ae<H.length;Ae++){if(!we.g(H[Ae]))continue;const Be=i.DocumentLink.from(H[Ae]);Be.cacheId=[ee,Ae],re.links.push(Be)}return re}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,F){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...U);if(!G)return;const H=await this.f.resolveDocumentLink(G,F);if(!(!H||!we.g(H)))return i.DocumentLink.from(H)}releaseLinks(U){this.d.delete(U)}}class ge{constructor(U,F){this.d=U,this.e=F}async provideColors(U,F){const G=this.d.getDocument(U),H=await this.e.provideDocumentColors(G,F);return Array.isArray(H)?H.map(re=>({color:i.Color.from(re.color),range:i.Range.from(re.range)})):[]}async provideColorPresentations(U,F,G){const H=this.d.getDocument(U),ee=i.Range.to(F.range),re=i.Color.to(F.color),Ae=await this.e.provideColorPresentations(re,{document:H,range:ee},G);if(Array.isArray(Ae))return Ae.map(i.ColorPresentation.from)}}class Q{constructor(U,F){this.d=U,this.e=F}async provideFoldingRanges(U,F,G){const H=this.d.getDocument(U),ee=await this.e.provideFoldingRanges(H,F,G);if(Array.isArray(ee))return ee.map(i.FoldingRange.from)}}class Y{constructor(U,F,G){this.d=U,this.e=F,this.f=G}async provideSelectionRanges(U,F,G){const H=this.d.getDocument(U),ee=F.map(i.Position.to),re=await this.e.provideSelectionRanges(H,ee,G);if(!(0,P.$Lb)(re))return[];if(re.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let Be=0;Be<ee.length;Be++){const qe=[];Ae.push(qe);let et=ee[Be],xe=re[Be];for(;;){if(!xe.range.contains(et))throw new Error("INVALID selection range, must contain the previous range");if(qe.push(i.SelectionRange.from(xe)),!xe.parent)break;et=xe.range,xe=xe.parent}}return Ae}}class le{constructor(U,F){this.f=U,this.g=F,this.d=new A.$JO(""),this.e=new Map}async prepareSession(U,F,G){const H=this.f.getDocument(U),ee=i.Position.to(F),re=await this.g.prepareCallHierarchy(H,ee,G);if(!re)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(re)?re.map(Be=>this.h(Ae,Be)):[this.h(Ae,re)]}async provideCallsTo(U,F,G){const H=this.j(U,F);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(H,G);if(ee)return ee.map(re=>({from:this.h(U,re.from),fromRanges:re.fromRanges.map(Ae=>i.Range.from(Ae))}))}async provideCallsFrom(U,F,G){const H=this.j(U,F);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(H,G);if(ee)return ee.map(re=>({to:this.h(U,re.to),fromRanges:re.fromRanges.map(Ae=>i.Range.from(Ae))}))}releaseSession(U){this.e.delete(U)}h(U,F){const G=this.e.get(U),H=i.CallHierarchyItem.from(F,U,G.size.toString(36));return G.set(H._itemId,F),H}j(U,F){return this.e.get(U)?.get(F)}}class ue{constructor(U,F){this.f=U,this.g=F,this.d=new A.$JO(""),this.e=new Map}async prepareSession(U,F,G){const H=this.f.getDocument(U),ee=i.Position.to(F),re=await this.g.prepareTypeHierarchy(H,ee,G);if(!re)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(re)?re.map(Be=>this.h(Ae,Be)):[this.h(Ae,re)]}async provideSupertypes(U,F,G){const H=this.j(U,F);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(H,G);if(ee)return ee.map(re=>this.h(U,re))}async provideSubtypes(U,F,G){const H=this.j(U,F);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(H,G);if(ee)return ee.map(re=>this.h(U,re))}releaseSession(U){this.e.delete(U)}h(U,F){const G=this.e.get(U),H=i.TypeHierarchyItem.from(F,U,G.size.toString(36));return G.set(H._itemId,F),H}j(U,F){return this.e.get(U)?.get(F)}}class Oe{constructor(U,F,G,H,ee){this.e=U,this.f=F,this.g=G,this.h=H,this.j=ee,this.d=new t.$tlc("DocumentDropEdit")}async provideDocumentOnDropEdits(U,F,G,H,ee){const re=this.f.getDocument(F),Ae=i.Position.to(G),Be=i.DataTransfer.toDataTransfer(H,async _e=>(await this.e.$resolveDocumentOnDropFileData(this.h,U,_e)).buffer),qe=await this.g.provideDocumentDropEdits(re,Ae,Be,ee);if(!qe)return;const et=(0,P.$2b)(qe),xe=this.d.add(et);return et.map((_e,tt)=>({_cacheId:[xe,tt],title:_e.title??(0,o.localize)(1,null,this.j.displayName||this.j.name),kind:_e.kind?.value,yieldTo:_e.yieldTo?.map(rt=>rt.value),insertText:typeof _e.insertText=="string"?_e.insertText:{snippet:_e.insertText.value},additionalEdit:_e.additionalEdit?i.WorkspaceEdit.from(_e.additionalEdit,void 0):void 0}))}async resolveDropEdit(U,F){const[G,H]=U,ee=this.d.get(G,H);if(!ee||!this.g.resolveDocumentDropEdit)return{};const re=await this.g.resolveDocumentDropEdit(ee,F)??ee;return{additionalEdit:re.additionalEdit?i.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releaseDropEdits(U){this.d.delete(U)}}class de{constructor(U,F){this.d=U,this.e=F}async provideMappedEdits(U,F,G,H){const ee=l.URI.revive(U),re=this.d.getDocument(ee),Ae=G.documents.map(et=>et.map(xe=>({uri:l.URI.revive(xe.uri),version:xe.version,ranges:xe.ranges.map(_e=>i.Range.to(_e))}))),Be={documents:Ae,selections:Ae[0]?.[0]?.ranges??[]},qe=await this.e.provideMappedEdits(re,F,Be,H);return qe?i.WorkspaceEdit.from(qe):null}}class Ce{constructor(U,F){this.adapter=U,this.extension=F}}class Me{static{this.d=0}constructor(U,F,G,H,ee,re,Ae,Be){this.g=F,this.h=G,this.j=H,this.k=ee,this.l=re,this.m=Ae,this.n=Be,this.f=new Map,this.e=U.getProxy(d.$dM.MainThreadLanguageFeatures)}o(U,F){return i.DocumentSelector.from(U,this.g,F)}p(U){return new c.$fM(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return Me.d++}async s(U,F,G,H,ee,re=!1){const Ae=this.f.get(U);if(!Ae||!(Ae.adapter instanceof F))return H;const Be=Date.now();re||this.l.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const qe=G(Ae.adapter,Ae.extension);return Promise.resolve(qe).catch(et=>{(0,N.$4)(et)||(this.l.error(`[${Ae.extension.identifier.value}] provider FAILED`),this.l.error(et),this.n.onExtensionError(Ae.extension.identifier,et))}).finally(()=>{re||this.l.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),M.CancellationToken.isCancellationToken(ee)?(0,O.$lh)(qe,ee):qe}t(U,F){const G=this.q();return this.f.set(G,new Ce(U,F)),G}static u(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,F,G,H){const ee=this.t(new a(this.h,G),U),re=H&&H.label||Me.u(U);return this.e.$registerDocumentSymbolProvider(ee,this.o(F,U),re),this.p(ee)}$provideDocumentSymbols(U,F,G){return this.s(U,a,H=>H.provideDocumentSymbols(l.URI.revive(F),G),void 0,G)}registerCodeLensProvider(U,F,G){const H=this.q(),ee=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Ce(new f(this.h,this.j.converter,G,U,this.n,this.l),U)),this.e.$registerCodeLensSupport(H,this.o(F,U),ee);let re=this.p(H);if(ee!==void 0){const Ae=G.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(ee));re=c.$fM.from(re,Ae)}return re}$provideCodeLenses(U,F,G){return this.s(U,f,H=>H.provideCodeLenses(l.URI.revive(F),G),void 0,G)}$resolveCodeLens(U,F,G){return this.s(U,f,H=>H.resolveCodeLens(F,G),void 0,void 0)}$releaseCodeLenses(U,F){this.s(U,f,G=>Promise.resolve(G.releaseCodeLenses(F)),void 0,void 0)}registerDefinitionProvider(U,F,G){const H=this.t(new p(this.h,G),U);return this.e.$registerDefinitionSupport(H,this.o(F,U)),this.p(H)}$provideDefinition(U,F,G,H){return this.s(U,p,ee=>ee.provideDefinition(l.URI.revive(F),G,H),[],H)}registerDeclarationProvider(U,F,G){const H=this.t(new v(this.h,G),U);return this.e.$registerDeclarationSupport(H,this.o(F,U)),this.p(H)}$provideDeclaration(U,F,G,H){return this.s(U,v,ee=>ee.provideDeclaration(l.URI.revive(F),G,H),[],H)}registerImplementationProvider(U,F,G){const H=this.t(new y(this.h,G),U);return this.e.$registerImplementationSupport(H,this.o(F,U)),this.p(H)}$provideImplementation(U,F,G,H){return this.s(U,y,ee=>ee.provideImplementation(l.URI.revive(F),G,H),[],H)}registerTypeDefinitionProvider(U,F,G){const H=this.t(new h(this.h,G),U);return this.e.$registerTypeDefinitionSupport(H,this.o(F,U)),this.p(H)}$provideTypeDefinition(U,F,G,H){return this.s(U,h,ee=>ee.provideTypeDefinition(l.URI.revive(F),G,H),[],H)}registerHoverProvider(U,F,G,H){const ee=this.t(new D(this.h,G),U);return this.e.$registerHoverProvider(ee,this.o(F,U)),this.p(ee)}$provideHover(U,F,G,H,ee){return this.s(U,D,re=>re.provideHover(l.URI.revive(F),G,H,ee),void 0,ee)}$releaseHover(U,F){this.s(U,D,G=>Promise.resolve(G.releaseHover(F)),void 0,void 0)}registerEvaluatableExpressionProvider(U,F,G,H){const ee=this.t(new k(this.h,G),U);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(F,U)),this.p(ee)}$provideEvaluatableExpression(U,F,G,H){return this.s(U,k,ee=>ee.provideEvaluatableExpression(l.URI.revive(F),G,H),void 0,H)}registerInlineValuesProvider(U,F,G,H){const ee=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,re=this.t(new C(this.h,G),U);this.e.$registerInlineValuesProvider(re,this.o(F,U),ee);let Ae=this.p(re);if(ee!==void 0){const Be=G.onDidChangeInlineValues(qe=>this.e.$emitInlineValuesEvent(ee));Ae=c.$fM.from(Ae,Be)}return Ae}$provideInlineValues(U,F,G,H,ee){return this.s(U,C,re=>re.provideInlineValues(l.URI.revive(F),G,H,ee),void 0,ee)}registerDocumentHighlightProvider(U,F,G){const H=this.t(new I(this.h,G),U);return this.e.$registerDocumentHighlightProvider(H,this.o(F,U)),this.p(H)}registerMultiDocumentHighlightProvider(U,F,G){const H=this.t(new W(this.h,G),U);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(F,U)),this.p(H)}$provideDocumentHighlights(U,F,G,H){return this.s(U,I,ee=>ee.provideDocumentHighlights(l.URI.revive(F),G,H),void 0,H)}$provideMultiDocumentHighlights(U,F,G,H,ee){return this.s(U,W,re=>re.provideMultiDocumentHighlights(l.URI.revive(F),G,H.map(Ae=>l.URI.revive(Ae)),ee),void 0,ee)}registerLinkedEditingRangeProvider(U,F,G){const H=this.t(new V(this.h,G),U);return this.e.$registerLinkedEditingRangeProvider(H,this.o(F,U)),this.p(H)}$provideLinkedEditingRanges(U,F,G,H){return this.s(U,V,async ee=>{const re=await ee.provideLinkedEditingRanges(l.URI.revive(F),G,H);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?Me.w(re.wordPattern):void 0}},void 0,H)}registerReferenceProvider(U,F,G){const H=this.t(new q(this.h,G),U);return this.e.$registerReferenceSupport(H,this.o(F,U)),this.p(H)}$provideReferences(U,F,G,H,ee){return this.s(U,q,re=>re.provideReferences(l.URI.revive(F),G,H,ee),void 0,ee)}registerCodeActionProvider(U,F,G,H){const ee=new $.$Tc,re=this.t(new R(this.h,this.j.converter,this.k,G,this.l,U,this.m),U);return this.e.$registerQuickFixSupport(re,this.o(F,U),{providedKinds:H?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:H?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this.j.converter.toInternal(Ae.command,ee)}))},Me.u(U),!!G.resolveCodeAction),ee.add(this.p(re)),ee}$provideCodeActions(U,F,G,H,ee){return this.s(U,R,re=>re.provideCodeActions(l.URI.revive(F),G,H,ee),void 0,ee)}$resolveCodeAction(U,F,G){return this.s(U,R,H=>H.resolveCodeAction(F,G),{},void 0)}$releaseCodeActions(U,F){this.s(U,R,G=>Promise.resolve(G.releaseCodeActions(F)),void 0,void 0)}registerDocumentFormattingEditProvider(U,F,G){const H=this.t(new K(this.h,G),U);return this.e.$registerDocumentFormattingSupport(H,this.o(F,U),U.identifier,U.displayName||U.name),this.p(H)}$provideDocumentFormattingEdits(U,F,G,H){return this.s(U,K,ee=>ee.provideDocumentFormattingEdits(l.URI.revive(F),G,H),void 0,H)}registerDocumentRangeFormattingEditProvider(U,F,G){const H=typeof G.provideDocumentRangesFormattingEdits=="function",ee=this.t(new ie(this.h,G),U);return this.e.$registerRangeFormattingSupport(ee,this.o(F,U),U.identifier,U.displayName||U.name,H),this.p(ee)}$provideDocumentRangeFormattingEdits(U,F,G,H,ee){return this.s(U,ie,re=>re.provideDocumentRangeFormattingEdits(l.URI.revive(F),G,H,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(U,F,G,H,ee){return this.s(U,ie,re=>re.provideDocumentRangesFormattingEdits(l.URI.revive(F),G,H,ee),void 0,ee)}registerOnTypeFormattingEditProvider(U,F,G,H){const ee=this.t(new ce(this.h,G),U);return this.e.$registerOnTypeFormattingSupport(ee,this.o(F,U),H,U.identifier),this.p(ee)}$provideOnTypeFormattingEdits(U,F,G,H,ee,re){return this.s(U,ce,Ae=>Ae.provideOnTypeFormattingEdits(l.URI.revive(F),G,H,ee,re),void 0,re)}registerWorkspaceSymbolProvider(U,F){const G=this.t(new ve(F,this.l),U);return this.e.$registerNavigateTypeSupport(G,typeof F.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(U,F,G){return this.s(U,ve,H=>H.provideWorkspaceSymbols(F,G),{symbols:[]},G)}$resolveWorkspaceSymbol(U,F,G){return this.s(U,ve,H=>H.resolveWorkspaceSymbol(F,G),void 0,void 0)}$releaseWorkspaceSymbols(U,F){this.s(U,ve,G=>G.releaseWorkspaceSymbols(F),void 0,void 0)}registerRenameProvider(U,F,G){const H=this.t(new ke(this.h,G,this.l),U);return this.e.$registerRenameSupport(H,this.o(F,U),ke.supportsResolving(G)),this.p(H)}$provideRenameEdits(U,F,G,H,ee){return this.s(U,ke,re=>re.provideRenameEdits(l.URI.revive(F),G,H,ee),void 0,ee)}$resolveRenameLocation(U,F,G,H){return this.s(U,ke,ee=>ee.resolveRenameLocation(l.URI.revive(F),G,H),void 0,H)}registerNewSymbolNamesProvider(U,F,G){const H=this.t(new fe(this.h,G,this.l),U);return this.e.$registerNewSymbolNamesProvider(H,this.o(F,U)),this.p(H)}$supportsAutomaticNewSymbolNamesTriggerKind(U){return this.s(U,fe,F=>F.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(U,F,G,H,ee){return this.s(U,fe,re=>re.provideNewSymbolNames(l.URI.revive(F),G,H,ee),void 0,ee)}registerDocumentSemanticTokensProvider(U,F,G,H){const ee=this.t(new Ne(this.h,G),U),re=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(F,U),H,re);let Ae=this.p(ee);if(re){const Be=G.onDidChangeSemanticTokens(qe=>this.e.$emitDocumentSemanticTokensEvent(re));Ae=c.$fM.from(Ae,Be)}return Ae}$provideDocumentSemanticTokens(U,F,G,H){return this.s(U,Ne,ee=>ee.provideDocumentSemanticTokens(l.URI.revive(F),G,H),null,H)}$releaseDocumentSemanticTokens(U,F){this.s(U,Ne,G=>G.releaseDocumentSemanticColoring(F),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,F,G,H){const ee=this.t(new ae(this.h,G),U);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(F,U),H),this.p(ee)}$provideDocumentRangeSemanticTokens(U,F,G,H){return this.s(U,ae,ee=>ee.provideDocumentRangeSemanticTokens(l.URI.revive(F),G,H),null,H)}registerCompletionItemProvider(U,F,G,H){const ee=this.t(new Re(this.h,this.j.converter,G,this.m,U),U);return this.e.$registerCompletionsProvider(ee,this.o(F,U),H,Re.supportsResolving(G),U.identifier),this.p(ee)}$provideCompletionItems(U,F,G,H,ee){return this.s(U,Re,re=>re.provideCompletionItems(l.URI.revive(F),G,H,ee),void 0,ee)}$resolveCompletionItem(U,F,G){return this.s(U,Re,H=>H.resolveCompletionItem(F,G),void 0,G)}$releaseCompletionItems(U,F){this.s(U,Re,G=>G.releaseCompletionItems(F),void 0,void 0)}registerInlineCompletionsProvider(U,F,G,H){const ee=new z(U,this.h,G,this.j.converter),re=this.t(ee,U);return this.e.$registerInlineCompletionsSupport(re,this.o(F,U),ee.supportsHandleEvents,n.$Rm.toKey(U.identifier.value),H?.yieldTo?.map(Ae=>n.$Rm.toKey(Ae))||[]),this.p(re)}$provideInlineCompletions(U,F,G,H,ee){return this.s(U,ne,re=>re.provideInlineCompletions(l.URI.revive(F),G,H,ee),void 0,ee)}$handleInlineCompletionDidShow(U,F,G,H){this.s(U,ne,async ee=>{ee.handleDidShowCompletionItem(F,G,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,F,G,H,ee){this.s(U,ne,async re=>{re.handlePartialAccept(F,G,H,ee)},void 0,void 0)}$freeInlineCompletionsList(U,F){this.s(U,ne,async G=>{G.disposeCompletions(F)},void 0,void 0)}registerInlineEditProvider(U,F,G){const H=new x(U,this.h,G,this.j.converter),ee=this.t(H,U);return this.e.$registerInlineEditProvider(ee,this.o(F,U),U.identifier),this.p(ee)}$provideInlineEdit(U,F,G,H){return this.s(U,x,ee=>ee.provideInlineEdits(l.URI.revive(F),G,H),void 0,H)}$freeInlineEdit(U,F){this.s(U,x,async G=>{G.disposeEdit(F)},void 0,void 0)}registerSignatureHelpProvider(U,F,G,H){const ee=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,re=this.t(new Te(this.h,G),U);return this.e.$registerSignatureHelpProvider(re,this.o(F,U),ee),this.p(re)}$provideSignatureHelp(U,F,G,H,ee){return this.s(U,Te,re=>re.provideSignatureHelp(l.URI.revive(F),G,H,ee),void 0,ee)}$releaseSignatureHelp(U,F){this.s(U,Te,G=>G.releaseSignatureHelp(F),void 0,void 0)}registerInlayHintsProvider(U,F,G){const H=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new De(this.h,this.j.converter,G,this.l,U),U);this.e.$registerInlayHintsProvider(ee,this.o(F,U),typeof G.resolveInlayHint=="function",H,Me.u(U));let re=this.p(ee);if(H!==void 0){const Ae=G.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(H));re=c.$fM.from(re,Ae)}return re}$provideInlayHints(U,F,G,H){return this.s(U,De,ee=>ee.provideInlayHints(l.URI.revive(F),G,H),void 0,H)}$resolveInlayHint(U,F,G){return this.s(U,De,H=>H.resolveInlayHint(F,G),void 0,G)}$releaseInlayHints(U,F){this.s(U,De,G=>G.releaseHints(F),void 0,void 0)}registerDocumentLinkProvider(U,F,G){const H=this.t(new we(this.h,G),U);return this.e.$registerDocumentLinkProvider(H,this.o(F,U),typeof G.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(U,F,G){return this.s(U,we,H=>H.provideLinks(l.URI.revive(F),G),void 0,G,F.scheme==="output")}$resolveDocumentLink(U,F,G){return this.s(U,we,H=>H.resolveLink(F,G),void 0,void 0,!0)}$releaseDocumentLinks(U,F){this.s(U,we,G=>G.releaseLinks(F),void 0,void 0,!0)}registerColorProvider(U,F,G){const H=this.t(new ge(this.h,G),U);return this.e.$registerDocumentColorProvider(H,this.o(F,U)),this.p(H)}$provideDocumentColors(U,F,G){return this.s(U,ge,H=>H.provideColors(l.URI.revive(F),G),[],G)}$provideColorPresentations(U,F,G,H){return this.s(U,ge,ee=>ee.provideColorPresentations(l.URI.revive(F),G,H),void 0,H)}registerFoldingRangeProvider(U,F,G){const H=this.q(),ee=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Ce(new Q(this.h,G),U)),this.e.$registerFoldingRangeProvider(H,this.o(F,U),U.identifier,ee);let re=this.p(H);if(ee!==void 0){const Ae=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));re=c.$fM.from(re,Ae)}return re}$provideFoldingRanges(U,F,G,H){return this.s(U,Q,ee=>ee.provideFoldingRanges(l.URI.revive(F),G,H),void 0,H)}registerSelectionRangeProvider(U,F,G){const H=this.t(new Y(this.h,G,this.l),U);return this.e.$registerSelectionRangeProvider(H,this.o(F,U)),this.p(H)}$provideSelectionRanges(U,F,G,H){return this.s(U,Y,ee=>ee.provideSelectionRanges(l.URI.revive(F),G,H),[],H)}registerCallHierarchyProvider(U,F,G){const H=this.t(new le(this.h,G),U);return this.e.$registerCallHierarchyProvider(H,this.o(F,U)),this.p(H)}$prepareCallHierarchy(U,F,G,H){return this.s(U,le,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(F),G,H)),void 0,H)}$provideCallHierarchyIncomingCalls(U,F,G,H){return this.s(U,le,ee=>ee.provideCallsTo(F,G,H),void 0,H)}$provideCallHierarchyOutgoingCalls(U,F,G,H){return this.s(U,le,ee=>ee.provideCallsFrom(F,G,H),void 0,H)}$releaseCallHierarchy(U,F){this.s(U,le,G=>Promise.resolve(G.releaseSession(F)),void 0,void 0)}registerTypeHierarchyProvider(U,F,G){const H=this.t(new ue(this.h,G),U);return this.e.$registerTypeHierarchyProvider(H,this.o(F,U)),this.p(H)}$prepareTypeHierarchy(U,F,G,H){return this.s(U,ue,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(F),G,H)),void 0,H)}$provideTypeHierarchySupertypes(U,F,G,H){return this.s(U,ue,ee=>ee.provideSupertypes(F,G,H),void 0,H)}$provideTypeHierarchySubtypes(U,F,G,H){return this.s(U,ue,ee=>ee.provideSubtypes(F,G,H),void 0,H)}$releaseTypeHierarchy(U,F){this.s(U,ue,G=>Promise.resolve(G.releaseSession(F)),void 0,void 0)}registerDocumentOnDropEditProvider(U,F,G,H){const ee=this.q();return this.f.set(ee,new Ce(new Oe(this.e,this.h,G,ee,U),U)),this.e.$registerDocumentOnDropEditProvider(ee,this.o(F,U),(0,u.$OG)(U,"documentPaste")&&H?{supportsResolve:!!G.resolveDocumentDropEdit,dropMimeTypes:H.dropMimeTypes}:void 0),this.p(ee)}$provideDocumentOnDropEdits(U,F,G,H,ee,re){return this.s(U,Oe,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(F,l.URI.revive(G),H,ee,re)),void 0,void 0)}$resolveDropEdit(U,F,G){return this.s(U,Oe,H=>H.resolveDropEdit(F,G),{},void 0)}$releaseDropEdits(U,F){this.s(U,Oe,G=>Promise.resolve(G.releaseDropEdits(F)),void 0,void 0)}registerMappedEditsProvider(U,F,G){const H=this.t(new de(this.h,G),U);return this.e.$registerMappedEditsProvider(H,this.o(F,U)),this.p(H)}$provideMappedEdits(U,F,G,H,ee){return this.s(U,de,re=>Promise.resolve(re.provideMappedEdits(F,G,H,ee)),null,ee)}registerDocumentPasteEditProvider(U,F,G,H){const ee=this.q();return this.f.set(ee,new Ce(new B(this.e,this.h,G,ee,U),U)),this.e.$registerPasteEditProvider(ee,this.o(F,U),{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,supportsResolve:!!G.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(re=>re.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(U,F,G,H,ee){return this.s(U,B,re=>re.prepareDocumentPaste(l.URI.revive(F),G,H,ee),void 0,ee)}$providePasteEdits(U,F,G,H,ee,re,Ae){return this.s(U,B,Be=>Be.providePasteEdits(F,l.URI.revive(G),H,ee,re,Ae),void 0,Ae)}$resolvePasteEdit(U,F,G){return this.s(U,B,H=>H.resolvePasteEdit(F,G),{},void 0)}$releasePasteEdits(U,F){this.s(U,B,G=>Promise.resolve(G.releasePasteEdits(F)),void 0,void 0)}static w(U){return{pattern:U.source,flags:U.flags}}static y(U){return{decreaseIndentPattern:Me.w(U.decreaseIndentPattern),increaseIndentPattern:Me.w(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Me.w(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Me.w(U.unIndentedLinePattern):void 0}}static z(U){return{beforeText:Me.w(U.beforeText),afterText:U.afterText?Me.w(U.afterText):void 0,previousLineText:U.previousLineText?Me.w(U.previousLineText):void 0,action:U.action}}static B(U){return U.map(Me.z)}static C(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map(F=>c.SyntaxTokenType.toString(F)):void 0}}static D(U){return U.map(Me.C)}setLanguageConfiguration(U,F,G){const{wordPattern:H}=G;if(H&&(0,T.$jf)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(F,H):this.h.setWordDefinitionFor(F,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const ee=this.q(),re={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?Me.w(G.wordPattern):void 0,indentationRules:G.indentationRules?Me.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?Me.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?Me.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,F,re),this.p(ee)}$setWordDefinitions(U){for(const F of U)this.h.setWordDefinitionFor(F.languageId,new RegExp(F.regexSource,F.regexFlags))}}e.$Dlc=Me}),define(Se[90],Ie([1,0,6,4,8,7,103,20,11,5,175,108,14,3,17,86,12,42]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g,r,s,o){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=e.$kmc=void 0,e.$kmc=(0,b.$wi)("IExtHostLanguageModels");class i{constructor(d,a){this.option=d,this.stream=new m.$Zh,this.stream=a??new m.$Zh}}class c{constructor(){this.a=new Map,this.b=new m.$Zh,this.c=!1,this.d=!1;const d=this;this.apiObject={stream:d.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,d]of this.a)yield d.stream;else yield this.b}handleFragment(d){if(this.c)return;this.d=!0;let a=this.a.get(d.index);a||(this.a.size===0?a=new i(d.index,this.b):a=new i(d.index),this.a.set(d.index,a)),a.stream.emitOne(d.part)}get isStreaming(){return this.d}reject(d){this.c=!0;for(const a of this.f())a.reject(d)}resolve(){this.c=!0;for(const d of this.f())d.resolve()}}let u=class{static{n=this}static{this.a=1}constructor(d,a,f){this.j=a,this.k=f,this.c=new E.$de,this.d=new E.$de,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new $.$Tm,this.i=new Map,this.o=new Set,this.b=d.getProxy(O.$dM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(d,a,f,w){const p=n.a++;this.f.set(p,{extension:d.identifier,provider:f,languageModelId:a});let v;w.auth&&(v={providerLabel:d.displayName||d.name,accountLabel:typeof w.auth=="object"?w.auth.label:void 0}),this.b.$registerLanguageModelProvider(p,a,{extension:d.identifier,identifier:a,name:w.name??"",version:w.version,tokens:w.tokens,auth:v});const y=f.onDidReceiveLanguageModelResponse2?.(({extensionId:h,participant:D,tokenCount:k})=>{this.b.$whenLanguageModelChatRequestMade(a,new $.$Rm(h),D,k)});return(0,P.$Sc)(()=>{this.f.delete(p),this.b.$unregisterProvider(p),y?.dispose()})}async $provideLanguageModelResponse(d,a,f,w,p,v){const y=this.f.get(d);if(!y)return;const h=new A.$dw(async D=>{if(v.isCancellationRequested){this.j.warn(`[CHAT](${y.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(a,{index:D.index,part:D.part})});return y.provider.provideLanguageModelResponse2(w.map(M.LanguageModelMessage.to),p,$.$Rm.toKey(f),h,v)}$provideTokenLength(d,a,f){const w=this.f.get(d);return w?Promise.resolve(w.provider.provideTokenCount(a,f)):Promise.resolve(0)}$updateLanguageModels(d){const a=[],f=[];if(d.added)for(const w of d.added)this.g.set(w.identifier,w),a.push(w.identifier);if(d.removed)for(const w of d.removed){this.g.delete(w),f.push(w);for(const[p,v]of this.i)v.languageModelId===w&&(v.res.reject(new l.$5),this.i.delete(p))}this.d.fire(Object.freeze({added:Object.freeze(a),removed:Object.freeze(f)})),d.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(d){const a=new Array;for(const{from:f,to:w,enabled:p}of d){const v=this.h.get(f)??new $.$Sm;if(v.has(w)!==p){p?v.add(w):v.delete(w),this.h.set(f,v);const h={from:f,to:w};a.push(h),this.c.fire(h)}}}async sendChatRequest(d,a,f,w,p){const v=d.identifier,y=await this.b.$prepareChatAccess(v,a,w.justification);if(!y||!this.g.has(a))throw N.$rO.NotFound(`Language model '${a}' is unknown.`);if(this.m(v,y)&&(!await this.l(d,{identifier:y.extension,displayName:y.auth.providerLabel},w.justification,w.silent)||!this.h.get(v)?.has(y.extension)))throw N.$rO.NoPermissions(`Language model '${a}' cannot be used by '${v.value}'.`);const h=Math.random()*1e6|0,D=this.b.$fetchResponse(v,a,h,f.map(M.LanguageModelMessage.from),w.modelOptions??{},p),k=new m.$vh,C=new c;this.i.set(h,{languageModelId:a,res:C});let I;if(D.catch(W=>{k.isOpen()?C.reject(W):I=W}).finally(()=>{this.i.delete(h),C.resolve(),k.open()}),await k.wait(),I)throw I.name===N.$rO.name?I:new N.$rO(`Language model '${a}' errored, check cause for more details`,"Unknown",I);return C.apiObject}async $handleResponseFragment(d,a){const f=this.i.get(d);f&&f.res.handleFragment(a)}async l(d,a,f,w){const p=S.$fL+a.identifier.value;if(await this.k.getSession(d,p,[],{silent:!0}))return this.$updateModelAccesslist([{from:d.identifier,to:a.identifier,enabled:!0}]),!0;if(w)return!1;try{const y=f?(0,T.localize)(0,null,a.displayName,f):(0,T.localize)(1,null,a.displayName);return await this.k.getSession(d,p,[],{forceNewSession:{detail:y}}),this.$updateModelAccesslist([{from:d.identifier,to:a.identifier,enabled:!0}]),!0}catch{return!1}}m(d,a){return!!a.auth&&!$.$Rm.equals(a.extension,d)}async n(d){for(const a of this.o)try{await this.l(a,{identifier:d.extension,displayName:""},void 0,!0)}catch(f){this.j.error("Fake Auth request failed"),this.j.error(f)}}async computeTokenLength(d,a,f){const w=this.g.get(d);if(!w)throw N.$rO.NotFound(`Language model '${d}' is unknown.`);const p=o.Iterable.find(this.f.values(),v=>v.languageModelId===d);return p?p.provider.provideTokenCount(a,f):this.b.$countTokens(w.identifier,typeof a=="string"?a:M.LanguageModelMessage.from(a),f)}getLanguageModelInfo(d){const a=this.g.get(d);if(a)return{id:a.identifier,name:a.name,version:a.version,tokens:a.tokens}}createLanguageModelAccessInformation(d){this.o.add(d);const a=this,f=E.Event.signal(E.Event.filter(this.c.event,p=>$.$Rm.equals(p.from,d.identifier))),w=E.Event.signal(this.d.event);return{get onDidChange(){return E.Event.any(f,w)},canSendRequest(p){const v=a.g.get(p);if(!v)return;if(!a.m(d.identifier,v))return!0;const y=a.h.get(d.identifier);if(y)return y.has(v.extension)}}}};e.$lmc=u,e.$lmc=u=n=Ke([We(0,g.$EO),We(1,s.$3j),We(2,r.$Flc)],u)}),define(Se[274],Ie([1,0,4,8,7,32,11,6,26]),function(he,e,P,O,M,N,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2mc=void 0;class E{constructor(S,l,b,g){this.c=l,this.d=b,this.e=g,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(P.$dM.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,l){await this.a.$changeLanguage(S,l);const b=this.c.getDocumentData(S);if(!b)throw new Error(`document '${S.toString()}' NOT found`);return b.document}async tokenAtPosition(S,l){const b=S.version,g=O.Position.from(l),r=await this.a.$tokensAtPosition(S.uri,g),s={type:M.StandardTokenType.Other,range:S.getWordRangeAtPosition(l)??new M.$hM(l.line,l.character,l.line,l.character)};if(!r)return s;const o={range:O.Range.to(r.range),type:O.TokenType.to(r.type)};return!o.range.contains(l)||b!==S.version?s:o}createLanguageStatusItem(S,l,b){const g=this.f++,r=this.a,s=this.g,o=`${S.identifier.value}/${l}`;if(s.has(o))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);s.add(o);const n={selector:b,id:l,name:S.displayName??S.name,severity:M.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const c=new $.$Tc,u=()=>{if(i?.dispose(),!s.has(o)){console.warn(`LanguageStatusItem (${l}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,A.$yh)(()=>{c.clear(),this.a.$setLanguageStatus(g,{id:o,name:n.name??S.displayName??S.name,source:S.displayName??S.name,selector:O.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===M.LanguageStatusSeverity.Error?N.default.Error:n.severity===M.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){c.dispose(),i?.dispose(),r.$removeLanguageStatus(g),s.delete(o)},get id(){return n.id},get name(){return n.name},set name(d){n.name=d,u()},get selector(){return n.selector},set selector(d){n.selector=d,u()},get text(){return n.text},set text(d){n.text=d,u()},set text2(d){(0,m.$PG)(S,"languageStatusText"),n.text=d,u()},get text2(){return(0,m.$PG)(S,"languageStatusText"),n.text},get detail(){return n.detail},set detail(d){n.detail=d,u()},get severity(){return n.severity},set severity(d){n.severity=d,u()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(d){n.accessibilityInformation=d,u()},get command(){return n.command},set command(d){n.command=d,u()},get busy(){return n.busy},set busy(d){n.busy=d,u()}};return u(),t}}e.$2mc=E}),define(Se[275],Ie([1,0,16,2,8,7,85]),function(he,e,P,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Omc=e.$Nmc=void 0;class ${constructor(S,l,b,g){this.start=S,this.deletedCount=l,this.deletedItems=b,this.items=g}asApiEvent(){return{range:new N.$HN(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class m{static asModelAddData(S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1}}constructor(S,l,b){this.notebook=S,this.h=l,this.j=b,this.handle=b.handle,this.uri=O.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(M.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(M.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:M.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return S.g},set mime(g){S.g=g},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(b)}return this.f}setOutputs(S){this.a=S.map(M.NotebookCellOutput.to)}setOutputItems(S,l,b){const g=b.map(M.NotebookCellOutputItem.to),r=this.a.find(s=>s.id===S);if(r&&(l||(r.items.length=0),r.items.push(...g),r.items.length>1&&r.items.every(s=>A.$_J(s.mime)))){const s=new Map,o=[];r.items.forEach(n=>{let i;s.has(n.mime)?i=s.get(n.mime):(i=[],s.set(n.mime,i),o.push(n.mime)),i.push(n.data)}),r.items.length=0,o.forEach(n=>{const i=A.$aK(s.get(n));r.items.push({mime:n,data:i.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(M.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$Nmc=m;class E{static{this.a=0}constructor(S,l,b,g,r){this.k=S,this.l=l,this.m=b,this.uri=g,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,l={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===P.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(b){return b=S.n(b),S.b[b].apiCell},getCells(b){return(b?S.p(b):S.b).map(r=>r.apiCell)},save(){return S.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,l,b){this.g=S.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:b});const g={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},r=[];for(const o of S.rawEvents)o.kind===A.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,g.contentChanges):o.kind===A.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,g.contentChanges):o.kind===A.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),r.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),r.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),r.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===A.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),r.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),r.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const s=new Map;for(let o=0;o<r.length;o++){const n=r[o],i=s.get(n.cell);if(i===void 0){const c=g.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});s.set(n.cell,c-1)}else g.cellChanges[i]={...g.cellChanges[i],...n}}return Object.freeze(g),Object.freeze(g.cellChanges),Object.freeze(g.contentChanges),g}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let l=S.start|0,b=S.end|0;return l<0&&(l=0),b>this.b.length&&(b=this.b.length),S.with({start:l,end:b})}p(S){S=this.o(S);const l=[];for(let b=S.start;b<S.end;b++)l.push(this.b[b]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,l,b){if(this.j)return;const g=[],r=[],s=[];if(S.reverse().forEach(o=>{const i=o[2].map(t=>{const d=new m(this,this.l,t);return l||r.push(m.asModelAddData(t)),d}),c=new $(o[0],o[1],[],i),u=this.b.splice(o[0],o[1],...i);for(const t of u)s.push(t.uri),c.deletedItems.push(t.apiCell);g.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:s}),b)for(const o of g)b.push(o.asApiEvent())}s(S,l,b,g){const r=this.b.splice(S,l);this.b.splice(b,0,...r);const s=[new $(S,l,r.map(o=>o.apiCell),[]),new $(b,0,[],r)];for(const o of s)g.push(o.asApiEvent())}t(S,l){this.b[S].setOutputs(l)}u(S,l,b,g){this.b[S].setOutputItems(l,b,g)}v(S,l){const b=this.b[S];b.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(b.uri,l)}w(S,l){const b=this.b[S];b.apiCell.mime=l}x(S,l){this.b[S].setMetadata(l)}y(S,l){this.b[S].setInternalMetadata(l)}getCellFromApiCell(S){return this.b.find(l=>l.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(l=>l.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$Omc=E}),define(Se[276],Ie([1,0,5,2,8,7,34]),function(he,e,P,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4mc=void 0;class ${constructor(E,T,S,l={timeout:1500,errors:3}){this.b=E,this.c=T,this.d=S,this.f=l,this.a=new P.$fe}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(T,S,l)=>{const b=function(r){T.call(S,r)};return b.extension=E,this.a.event(b,void 0,l)}}async $participateInSave(E,T,S){const l=O.URI.revive(E),b=this.c.getNotebookDocument(l);if(!b)throw new Error("Unable to resolve notebook document");const g=[];if(await this.a.fireAsync({notebook:b.apiNotebook,reason:M.TextDocumentSaveReason.to(T)},S,async(s,o)=>{const n=Date.now(),i=await await Promise.resolve(s);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!S.isCancellationRequested&&i&&(i instanceof N.$pM?g.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),S.isCancellationRequested)return!1;if(g.length===0)return!0;const r={edits:[]};for(const s of g){const{edits:o}=M.WorkspaceEdit.from(s);r.edits=r.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(new A.$Bw(r))}}e.$4mc=$}),define(Se[114],Ie([1,0,14,8,7]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pmc=void 0;class N{static{this.apiEditorsToExtHost=new WeakMap}constructor($,m,E,T,S,l){this.id=$,this.f=m,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=T,this.c=l}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(m){this.selections=[m]},get selections(){return $.a},set selections(m){if(!Array.isArray(m)||!m.every(M.$HN.isNotebookRange))throw(0,P.$7)("selections");$.a=m,$.g(m)},get visibleRanges(){return $.b},revealRange(m,E){$.f.$tryRevealRange($.id,O.NotebookRange.from(m),E??M.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},N.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(O.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$Pmc=N}),define(Se[277],Ie([1,0,5,12,8]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6mc=void 0;let N=class{constructor($,m){this.c=$,this.d=m,this.a=new P.$de,this.b=new P.$de,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged($,m){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",$,m);const E=this.d.getEditorById($);m.visibleRanges&&E._acceptVisibleRanges(m.visibleRanges.ranges.map(M.NotebookRange.to)),m.selections&&E._acceptSelections(m.selections.selections.map(M.NotebookRange.to)),m.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),m.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns($){for(const m in $)this.d.getEditorById(m)._acceptViewColumn(M.ViewColumn.to($[m]))}};e.$6mc=N,e.$6mc=N=Ke([We(0,O.$3j)],N)}),define(Se[278],Ie([1,0,5,4,114]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9mc=void 0;class N{constructor($,m){this.c=m,this.a=new Map,this.b=$.getProxy(O.$dM.MainThreadNotebookRenderers)}$postRendererMessage($,m,E){const T=this.c.getEditorById($);this.a.get(m)?.fire({editor:T.apiEditor,message:E})}createRendererMessaging($,m){if(!$.contributes?.notebookRenderer?.some(T=>T.id===m))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${m})`);return{onDidReceiveMessage:(T,S,l)=>this.d(m).event(T,S,l),postMessage:(T,S)=>{M.$Pmc.apiEditorsToExtHost.has(T)&&([T,S]=[S,T]);const l=S&&M.$Pmc.apiEditorsToExtHost.get(S);return this.b.$postMessage(l?.id,m,T)}}}d($){let m=this.a.get($);return m||(m=new P.$de({onDidRemoveLastListener:()=>{m?.dispose(),this.a.delete($)}}),this.a.set($,m),m)}}e.$9mc=N}),define(Se[279],Ie([1,0,8,103,24,69,14]),function(he,e,P,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$anc=void 0;class ${constructor(S){this.b=0,this.c=new Map,this.a=S}async withProgress(S,l,b){const g=this.b++,{title:r,location:s,cancellable:o}=l,n={label:S.displayName||S.name,id:S.identifier.value};return this.a.$startProgress(g,{location:P.ProgressLocation.from(s),title:r,source:n,cancellable:o},S.isUnderDevelopment?void 0:S.identifier.value).catch(A.$2),this.d(g,b,!!o)}d(S,l,b){let g;b&&(g=new M.$oe,this.c.set(S,g));const r=o=>{this.a.$progressEnd(o),this.c.delete(o),g?.dispose()};let s;try{s=l(new E(this.a,S),b&&g?g.token:M.CancellationToken.None)}catch(o){throw r(S),o}return s.then(o=>r(S),o=>r(S)),s}$acceptProgressCanceled(S){const l=this.c.get(S);l&&(l.cancel(),this.c.delete(S))}}e.$anc=$;function m(T,S){return T.message=S.message,typeof S.increment=="number"&&(typeof T.increment=="number"?T.increment+=S.increment:T.increment=S.increment),T}class E extends O.$dw{constructor(S,l){super(b=>this.throttledReport(b)),this.c=S,this.d=l}throttledReport(S){this.c.$progressReport(this.d,S)}}Ke([(0,N.$3h)(100,(T,S)=>m(T,S),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(Se[280],Ie([1,0,2,4,11,8]),function(he,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bnc=void 0;class A{static{this.a=0}constructor(m,E){this.d=E,this.c=new Map,this.b=m.getProxy(O.$dM.MainThreadQuickDiff)}$provideOriginalResource(m,E,T){const S=P.URI.revive(E),l=this.c.get(m);return l?(0,M.$oh)(()=>l.provideOriginalResource(S,T)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(m,E,T,S){const l=A.a++;return this.c.set(l,E),this.b.$registerQuickDiffProvider(l,N.DocumentSelector.from(m,this.d),T,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$bnc=A}),define(Se[281],Ie([1,0,24,5,6,4,2,7,14,18,32,36,26,8]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=g;function g(r,s,o){const n=r.getProxy(N.$dM.MainThreadQuickOpen);class i{constructor(v,y){this.e=new Map,this.f=0,this.a=v,this.b=y}showQuickPick(v,y,h,D=P.CancellationToken.None){this.c=void 0;const k=Promise.resolve(y),C=++this.f,I=n.$show(C,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},D),W={},V=I.then(()=>W);return Promise.race([V,k]).then(q=>{if(q===W)return;const R=(0,l.$OG)(v,"quickPickItemTooltip");return k.then(B=>{const K=[];for(let ie=0;ie<B.length;ie++){const ce=B[ie];if(typeof ce=="string")K.push({label:ce,handle:ie});else if(ce.kind===$.QuickPickItemKind.Separator)K.push({type:"separator",label:ce.label});else{ce.tooltip&&!R&&console.warn(`Extension '${v.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`);const ve=ce.iconPath?a(ce.iconPath):void 0;K.push({label:ce.label,iconPath:ve?.iconPath,iconClass:ve?.iconClass,description:ce.description,detail:ce.detail,picked:ce.picked,alwaysShow:ce.alwaysShow,tooltip:R?b.MarkdownString.fromStrict(ce.tooltip):void 0,handle:ie})}}return h&&typeof h.onDidSelectItem=="function"&&(this.c=ie=>{h.onDidSelectItem(B[ie])}),n.$setItems(C,K),I.then(ie=>{if(typeof ie=="number")return B[ie];if(Array.isArray(ie))return ie.map(ce=>B[ce])})})}).then(void 0,q=>{if(!(0,m.$4)(q))return n.$setError(C,q),Promise.reject(q)})}$onItemSelected(v){this.c?.(v)}showInput(v,y=P.CancellationToken.None){return this.d=v?.validateInput,n.$input(v,typeof this.d=="function",y).then(void 0,h=>{if(!(0,m.$4)(h))return Promise.reject(h)})}async $validateInput(v){if(!this.d)return;const y=await this.d(v);if(!y||typeof y=="string")return y;let h;switch(y.severity){case $.InputBoxValidationSeverity.Info:h=T.default.Info;break;case $.InputBoxValidationSeverity.Warning:h=T.default.Warning;break;case $.InputBoxValidationSeverity.Error:h=T.default.Error;break;default:h=y.message?T.default.Error:T.default.Ignore;break}return{content:y.message,severity:h}}async showWorkspaceFolderPick(v,y=P.CancellationToken.None){const h=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[v]);if(!h)return;const D=await this.a.getWorkspaceFolders2();if(D)return D.find(k=>k.uri.toString()===h.uri.toString())}createQuickPick(v){const y=new f(v,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(v){const y=new w(v,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(v,y){this.e.get(v)?._fireDidChangeValue(y)}$onDidAccept(v){this.e.get(v)?._fireDidAccept()}$onDidChangeActive(v,y){const h=this.e.get(v);h instanceof f&&h._fireDidChangeActive(y)}$onDidChangeSelection(v,y){const h=this.e.get(v);h instanceof f&&h._fireDidChangeSelection(y)}$onDidTriggerButton(v,y){this.e.get(v)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(v,y,h){const D=this.e.get(v);D instanceof f&&D._fireDidTriggerItemButton(y,h)}$onDidHide(v){this.e.get(v)?._fireDidHide()}}class c{static{this.a=1}constructor(v,y){this.x=v,this.y=y,this._id=f.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new O.$de,this.q=new O.$de,this.r=new O.$de,this.s=new O.$de,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(v){this.b=v,this.z({title:v})}get step(){return this.c}set step(v){this.c=v,this.z({step:v})}get totalSteps(){return this.d}set totalSteps(v){this.d=v,this.z({totalSteps:v})}get enabled(){return this.g}set enabled(v){this.g=v,this.z({enabled:v})}get busy(){return this.j}set busy(v){this.j=v,this.z({busy:v})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(v){this.k=v,this.z({ignoreFocusOut:v})}get value(){return this.l}set value(v){this.l=v,this.z({value:v})}get placeholder(){return this.m}set placeholder(v){this.m=v,this.z({placeholder:v})}get buttons(){return this.n}set buttons(v){this.n=v.slice(),this.o.clear(),v.forEach((y,h)=>{const D=y===$.$EN.Back?-1:h;this.o.set(D,y)}),this.z({buttons:v.map((y,h)=>({...a(y.iconPath),tooltip:y.tooltip,handle:y===$.$EN.Back?-1:h}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(v){this.l=v,this.q.fire(v)}_fireDidTriggerButton(v){const y=this.o.get(v);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,M.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(v){if(!this.v){for(const y of Object.keys(v)){const h=v[y];this.u[y]=h===void 0?null:h}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function u(p){if(p instanceof $.$cN)return{id:p.id};const v=d(p),y=t(p);return{dark:typeof v=="string"?A.URI.file(v):v,light:typeof y=="string"?A.URI.file(y):y}}function t(p){return typeof p=="object"&&"light"in p?p.light:p}function d(p){return typeof p=="object"&&"dark"in p?p.dark:p}function a(p){const v=u(p);let y,h;return"id"in v?h=S.ThemeIcon.asClassName(v):y=v,{iconPath:y,iconClass:h}}class f extends c{constructor(v,y){super(v.identifier,y),this.O=v,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new O.$de,this.L=[],this.M=new O.$de,this.N=new O.$de,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(v){this.B=v.slice(),this.C.clear(),this.D.clear(),v.forEach((D,k)=>{this.C.set(k,D),this.D.set(D,k)});const y=(0,l.$OG)(this.O,"quickPickItemTooltip"),h=[];for(let D=0;D<v.length;D++){const k=v[D];if(k.kind===$.QuickPickItemKind.Separator)h.push({type:"separator",label:k.label});else{k.tooltip&&!y&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=k.iconPath?a(k.iconPath):void 0;h.push({handle:D,label:k.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:y?b.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((I,W)=>({...a(I.iconPath),tooltip:I.tooltip,handle:W}))})}}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(v){this.E=v,this.z({canSelectMany:v})}get matchOnDescription(){return this.F}set matchOnDescription(v){this.F=v,this.z({matchOnDescription:v})}get matchOnDetail(){return this.G}set matchOnDetail(v){this.G=v,this.z({matchOnDetail:v})}get sortByLabel(){return this.H}set sortByLabel(v){this.H=v,this.z({sortByLabel:v})}get keepScrollPosition(){return this.I}set keepScrollPosition(v){this.I=v,this.z({keepScrollPosition:v})}get activeItems(){return this.J}set activeItems(v){this.J=v.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(v){this.L=v.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(v){const y=(0,E.$Hb)(v.map(h=>this.C.get(h)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(v){const y=(0,E.$Hb)(v.map(h=>this.C.get(h)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(v,y){const h=this.C.get(v);if(!h||!h.buttons||!h.buttons.length)return;const D=h.buttons[y];D&&this.N.fire({button:D,item:h})}}class w extends c{constructor(v,y){super(v.identifier,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(v){this.B=v,this.z({password:v})}get prompt(){return this.C}set prompt(v){this.C=v,this.z({prompt:v})}get valueSelection(){return this.D}set valueSelection(v){this.D=v,this.z({valueSelection:v})}get validationMessage(){return this.E}set validationMessage(v){this.E=v,v?typeof v=="string"?this.z({validationMessage:v,severity:T.default.Error}):this.z({validationMessage:v.message,severity:v.severity??T.default.Error}):this.z({validationMessage:void 0,severity:T.default.Ignore})}}return new i(s,o)}}),define(Se[282],Ie([1,0,2,5,69,6,11,4,18,149,12,20,36,8,26,16,22]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g,r,s){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$enc=e.$dnc=void 0;function n(C){return C instanceof P.URI}function i(C,I){return C.scheme===r.Schemas.file&&I.scheme===r.Schemas.file&&s.$k?C.toString()===I.toString():C.toString().toLowerCase()===I.toString().toLowerCase()}function c(C){if(C)return typeof C.iconPath=="string"?P.URI.file(C.iconPath):P.URI.isUri(C.iconPath)||l.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function u(C){if(C.icon){if(P.URI.isUri(C.icon))return C.icon;if(l.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const I=C.icon;return{light:I.light,dark:I.dark}}}else return}function t(C,I){if(!C.iconPath&&!I.iconPath)return 0;if(C.iconPath){if(!I.iconPath)return 1}else return-1;const W=typeof C.iconPath=="string"?C.iconPath:P.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,V=typeof I.iconPath=="string"?I.iconPath:P.URI.isUri(I.iconPath)?I.iconPath.fsPath:I.iconPath.id;return(0,E.$qr)(W,V)}function d(C,I){let W=0;if(C.strikeThrough!==I.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==I.faded)return C.faded?1:-1;if(C.tooltip!==I.tooltip)return(C.tooltip||"").localeCompare(I.tooltip||"");if(W=t(C,I),W!==0)return W;if(C.light&&I.light)W=t(C.light,I.light);else{if(C.light)return 1;if(I.light)return-1}if(W!==0)return W;if(C.dark&&I.dark)W=t(C.dark,I.dark);else{if(C.dark)return 1;if(I.dark)return-1}return W}function a(C,I){if(C.command!==I.command)return C.command<I.command?-1:1;if(C.title!==I.title)return C.title<I.title?-1:1;if(C.tooltip!==I.tooltip){if(C.tooltip!==void 0&&I.tooltip!==void 0)return C.tooltip<I.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(I.tooltip!==void 0)return-1}if(C.arguments===I.arguments)return 0;if(C.arguments)if(I.arguments){if(C.arguments.length!==I.arguments.length)return C.arguments.length-I.arguments.length}else return 1;else return-1;for(let W=0;W<C.arguments.length;W++){const V=C.arguments[W],q=I.arguments[W];if(V!==q&&!(n(V)&&n(q)&&i(V,q)))return V<q?-1:1}return 0}function f(C,I){let W=(0,E.$qr)(C.resourceUri.fsPath,I.resourceUri.fsPath,!0);if(W!==0)return W;if(C.command&&I.command)W=a(C.command,I.command);else{if(C.command)return 1;if(I.command)return-1}if(W!==0)return W;if(C.decorations&&I.decorations)W=d(C.decorations,I.decorations);else{if(C.decorations)return 1;if(I.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&I.multiFileDiffEditorModifiedUri)W=(0,E.$qr)(C.multiFileDiffEditorModifiedUri.fsPath,I.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(I.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&I.multiDiffEditorOriginalUri)W=(0,E.$qr)(C.multiDiffEditorOriginalUri.fsPath,I.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(I.multiDiffEditorOriginalUri)return-1}return W}function w(C,I){for(let W=0;W<C.length;W++)if(C[W]!==I[W])return!1;return!0}function p(C,I){return C.command===I.command&&C.title===I.title&&C.tooltip===I.tooltip&&(C.arguments&&I.arguments?w(C.arguments,I.arguments):C.arguments===I.arguments)}function v(C,I){return(0,m.$ub)(C,I,p)}class y{#e;#t;get value(){return this.d}set value(I){I=I??"",this.#e.$setInputBoxValue(this.l,I),this.n(I)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(I){this.#e.$setInputBoxPlaceholder(this.l,I),this.f=I}get validateInput(){return(0,g.$PG)(this.k,"scmValidation"),this.g}set validateInput(I){if((0,g.$PG)(this.k,"scmValidation"),I&&typeof I!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=I,this.#e.$setValidationProviderIsEnabled(this.l,!!I)}get enabled(){return this.h}set enabled(I){I=!!I,this.h!==I&&(this.h=I,this.#e.$setInputBoxEnablement(this.l,I))}get visible(){return this.j}set visible(I){I=!!I,this.j!==I&&(this.j=I,this.#e.$setInputBoxVisibility(this.l,I))}get document(){return(0,g.$PG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(I,W,V,q,R){this.k=I,this.l=q,this.m=R,this.d="",this.e=new O.$de,this.f="",this.h=!0,this.j=!0,this.#t=W,this.#e=V}showValidationMessage(I,W){(0,g.$PG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,I,W)}$onInputBoxValueChange(I){this.n(I)}n(I){this.d=I,this.e.fire(I)}}e.$dnc=y;class h{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(I){this.v=I,this.q.$updateGroupLabel(this.t,this.handle,I)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(I){this.p=I,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(I){this.f=[...I],this.k.fire()}constructor(I,W,V,q,R,B,K){this.q=I,this.s=W,this.t=V,this.u=q,this.v=R,this.multiDiffEditorEnableViewChanges=B,this.w=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new O.$de,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new O.$de,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=h.d++}getResourceState(I){return this.g.get(I)}$executeResourceCommand(I,W){const V=this.h.get(I);return V?(0,A.$oh)(()=>this.s.executeCommand(V.command,...V.arguments||[],W)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const I=[...this.f].sort(f),V=(0,m.$Db)(this.o,I,f).map(B=>{const K=B.toInsert.map(ie=>{const ce=this.e++;this.g.set(ce,ie);const ve=ie.resourceUri;let ke;if(ie.command)if(ie.command.command==="vscode.open"||ie.command.command==="vscode.diff"||ie.command.command==="vscode.changes"){const ge=new N.$Tc;ke=this.s.converter.toInternal(ie.command,ge),this.j.set(ce,ge)}else this.h.set(ce,ie.command);const fe=(0,g.$OG)(this.w,"scmMultiDiffEditor"),pe=fe?ie.multiDiffEditorOriginalUri:void 0,Ne=fe?ie.multiFileDiffEditorModifiedUri:void 0,ae=c(ie.decorations),Re=ie.decorations&&c(ie.decorations.light)||ae,ne=ie.decorations&&c(ie.decorations.dark)||ae,z=[Re,ne],x=ie.decorations&&ie.decorations.tooltip||"",be=ie.decorations&&!!ie.decorations.strikeThrough,Te=ie.decorations&&!!ie.decorations.faded,De=ie.contextValue||"";return{rawResource:[ce,ve,z,x,be,Te,De,ke,pe,Ne],handle:ce}});return{start:B.start,deleteCount:B.deleteCount,toInsert:K}}),q=V.map(({start:B,deleteCount:K,toInsert:ie})=>[B,K,ie.map(ce=>ce.rawResource)]),R=V.reverse();for(const{start:B,deleteCount:K,toInsert:ie}of R){const ce=ie.map(ke=>ke.handle),ve=this.n.splice(B,K,...ce);for(const ke of ve)this.g.delete(ke),this.h.delete(ke),this.j.get(ke)?.dispose(),this.j.delete(ke)}return this.o=I,q}dispose(){this.l=!0,this.m.fire()}}class D{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(I){this.g!==I&&(this.g=I,this.#e.$updateSourceControl(this.w,{count:I}))}get quickDiffProvider(){return this.h}set quickDiffProvider(I){this.h=I;let W;(0,g.$OG)(this.x,"quickDiffProvider")&&(W=I?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!I,quickDiffLabel:W})}get historyProvider(){return(0,g.$PG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(I){(0,g.$PG)(this.x,"scmHistoryProvider"),this.j=I,this.k.value=new N.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!I}),I&&this.k.value.add(I.onDidChangeCurrentHistoryItemGroup(()=>{this.l=I?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(I){I!==this.m&&(this.m=I,this.#e.$updateSourceControl(this.w,{commitTemplate:I}))}get acceptInputCommand(){return this.o}set acceptInputCommand(I){this.n.value=new N.$Tc,this.o=I;const W=this.y.converter.toInternal(I,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:W})}get actionButton(){return(0,g.$PG)(this.x,"scmActionButton"),this.q}set actionButton(I){(0,g.$PG)(this.x,"scmActionButton"),this.p.value=new N.$Tc,this.q=I;const W=I!==void 0?{command:this.y.converter.toInternal(I.command,this.p.value),secondaryCommands:I.secondaryCommands?.map(V=>V.map(q=>this.y.converter.toInternal(q,this.p.value))),description:I.description,enabled:I.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:W??null})}get statusBarCommands(){return this.t}set statusBarCommands(I){if(this.t&&I&&v(this.t,I))return;this.s.value=new N.$Tc,this.t=I;const W=(I||[]).map(V=>this.y.converter.toInternal(V,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:W})}get selected(){return this.u}constructor(I,W,V,q,R,B,K){this.x=I,this.y=q,this.z=R,this.A=B,this.B=K,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new N.$Vc,this.m=void 0,this.n=new N.$Vc,this.o=void 0,this.p=new N.$Vc,this.s=new N.$Vc,this.t=void 0,this.u=!1,this.v=new O.$de,this.onDidChangeSelection=this.v.event,this.w=D.d++,this.C=new Map,this.D=new Set,this.#e=V;const ie=P.URI.from({scheme:r.Schemas.vscodeSourceControl,path:`${R}/scm${this.w}/input`,query:K?`rootUri=${encodeURIComponent(K.toString())}`:void 0});this.f=new y(I,W,this.#e,this.w,ie),this.#e.$registerSourceControl(this.w,R,B,K,ie)}createResourceGroup(I,W,V){const q=(0,g.$OG)(this.x,"scmMultiDiffEditor")&&V?.multiDiffEditorEnableViewChanges===!0,R=new h(this.#e,this.y,this.w,I,W,q,this.x),B=O.Event.once(R.onDidDispose)(()=>this.C.delete(R));return this.C.set(R,B),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const I=[],W=[];for(const[V,q]of this.C){q.dispose();const R=V.onDidUpdateResourceStates(()=>{this.D.add(V),this.eventuallyUpdateResourceStates()});O.Event.once(V.onDidDispose)(()=>{this.D.delete(V),R.dispose(),this.e.delete(V.handle),this.#e.$unregisterGroup(this.w,V.handle)}),I.push([V.handle,V.id,V.label,V.features,V.multiDiffEditorEnableViewChanges]);const B=V._takeResourceStateSnapshot();B.length>0&&W.push([V.handle,B]),this.e.set(V.handle,V)}this.#e.$registerGroups(this.w,I,W),this.C.clear()}eventuallyUpdateResourceStates(){const I=[];this.D.forEach(W=>{const V=W._takeResourceStateSnapshot();V.length!==0&&I.push([W.handle,V])}),I.length>0&&this.#e.$spliceResourceStates(this.w,I),this.D.clear()}getResourceGroup(I){return this.e.get(I)}setSelectionState(I){this.u=I,this.v.fire(I)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(I=>I.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ke([(0,M.$2h)(100)],D.prototype,"eventuallyAddResourceGroups",null),Ke([(0,M.$2h)(100)],D.prototype,"eventuallyUpdateResourceStates",null);let k=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(I,W,V,q){this.l=W,this.m=V,this.n=q,this.g=new Map,this.h=new S.$Tm,this.j=new O.$de,this.e=I.getProxy($.$dM.MainThreadSCM),this.f=I.getProxy($.$dM.MainThreadTelemetry),W.registerArgumentProcessor({processArgument:R=>{if(R&&R.$mid===3){const B=this.g.get(R.sourceControlHandle);if(!B)return R;const K=B.getResourceGroup(R.groupHandle);return K?K.getResourceState(R.handle):R}else if(R&&R.$mid===4){const B=this.g.get(R.sourceControlHandle);return B?B.getResourceGroup(R.groupHandle):R}else if(R&&R.$mid===5){const B=this.g.get(R.handle);return B||R}return R}})}createSourceControl(I,W,V,q){this.n.trace("ExtHostSCM#createSourceControl",I.identifier.value,W,V,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:I.identifier.value});const R=o.d++,B=new D(I,this.m,this.e,this.l,W,V,q);this.g.set(R,B);const K=this.h.get(I.identifier)||[];return K.push(B),this.h.set(I.identifier,K),B}getLastInputBox(I){this.n.trace("ExtHostSCM#getLastInputBox",I.identifier.value);const W=this.h.get(I.identifier),V=W&&W[W.length-1];return V&&V.inputBox}$provideOriginalResource(I,W,V){const q=P.URI.revive(W);this.n.trace("ExtHostSCM#$provideOriginalResource",I,q.toString());const R=this.g.get(I);return!R||!R.quickDiffProvider||!R.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$oh)(()=>R.quickDiffProvider.provideOriginalResource(q,V)).then(B=>B||null)}$onInputBoxValueChange(I,W){this.n.trace("ExtHostSCM#$onInputBoxValueChange",I);const V=this.g.get(I);return V&&V.inputBox.$onInputBoxValueChange(W),Promise.resolve(void 0)}$executeResourceCommand(I,W,V,q){this.n.trace("ExtHostSCM#$executeResourceCommand",I,W,V);const R=this.g.get(I);if(!R)return Promise.resolve(void 0);const B=R.getResourceGroup(W);return B?B.$executeResourceCommand(V,q):Promise.resolve(void 0)}$validateInput(I,W,V){this.n.trace("ExtHostSCM#$validateInput",I);const q=this.g.get(I);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,A.$oh)(()=>q.inputBox.validateInput(W,V)).then(R=>{if(!R)return Promise.resolve(void 0);const B=b.MarkdownString.fromStrict(R.message);return B?Promise.resolve([B,R.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(I){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",I),I!==void 0&&this.g.get(I)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=I,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(I,W,V,q){return await this.g.get(I)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(W,V,q)??void 0}async $provideHistoryItems(I,W,V,q){return(await this.g.get(I)?.historyProvider?.provideHistoryItems(W,V,q))?.map(K=>({...K,icon:u(K)}))??void 0}async $provideHistoryItemSummary(I,W,V,q){const R=this.g.get(I)?.historyProvider;if(typeof R?.provideHistoryItemSummary!="function")return;const B=await R.provideHistoryItemSummary(W,V,q);return B?{...B,icon:u(B)}:void 0}async $provideHistoryItemChanges(I,W,V,q){return await this.g.get(I)?.historyProvider?.provideHistoryItemChanges(W,V,q)??void 0}};e.$enc=k,e.$enc=k=o=Ke([We(3,T.$3j)],k)}),define(Se[283],Ie([1,0,4,8,2]),function(he,e,P,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fnc=void 0;class N{static{this.a=0}constructor($,m){this.d=m,this.c=new Map,this.b=$.getProxy(P.$dM.MainThreadShare)}async $provideShare($,m,E){return await this.c.get($)?.provideShare({selection:O.Range.to(m.selection),resourceUri:M.URI.revive(m.resourceUri)},E)??void 0}registerShareProvider($,m){const E=N.a++;return this.c.set(E,m),this.b.$registerShareProvider(E,O.DocumentSelector.from($,this.d),m.id,m.label,m.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$fnc=N}),define(Se[284],Ie([1,0,7,4,178,6,8,15]),function(he,e,P,O,M,N,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$inc=e.$hnc=void 0;class m{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new P.$dN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new P.$dN("statusBarItem.warningForeground")]])}#e;#t;constructor(l,b,g,r,s,o=P.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new N.$Tc,this.#e=l,this.#t=b,s&&r){this.c=(0,P.$RM)(r.identifier,s);const i=g.get(this.c);i&&(o=i.alignLeft?P.StatusBarAlignment.Left:P.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(m.a++);this.e=r,this.f=s,this.g=o,this.h=this.u(n)}u(l){if((0,$.$ag)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!m.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new N.$Tc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let b;this.m?b=this.m:b=(0,M.localize)(0,null,this.e.displayName||this.e.name);let g=this.n;this.o&&(g=m.b.get(this.o.id));const r=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,b,this.k,r,this.r?.internal,g,this.o,this.g===P.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$hnc=m;class E{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",P.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,M.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const b={message:l};return this.b.unshift(b),this.c(),new P.$fM(()=>{const g=this.b.indexOf(b);g>=0&&(this.b.splice(g,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class T{constructor(l,b){this.e=new Map,this.a=l.getProxy(O.$dM.MainThreadStatusBar),this.b=b,this.c=new E(this)}$acceptStaticEntries(l){for(const b of l)this.e.set(b.entryId,b)}createStatusBarEntry(l,b,g,r){return new m(this.a,this.b,this.e,l,b,g,r)}setStatusBarMessage(l,b){const g=this.c.setMessage(l);let r;return typeof b=="number"?r=setTimeout(()=>g.dispose(),b):typeof b<"u"&&b.then(()=>g.dispose(),()=>g.dispose()),new P.$fM(()=>{g.dispose(),clearTimeout(r)})}}e.$inc=T}),define(Se[115],Ie([1,0,30,107,52,77,62,8,2]),function(he,e,P,O,M,N,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TO=e.$SO=e.$RO=e.$QO=void 0;const E=(i,c,u,t)=>{let d=c;return{enumerable:!0,configurable:!1,get(){return d},set(a){if(!u(d,a)){const f=d;d=a,i.listener?.(t(a,f))}}}},T=(i,c)=>i===c,S={range:(i,c)=>i===c?!0:!i||!c?!1:i.isEqual(c),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(i,c)=>!(i.length!==c.length||i.some(u=>!c.find(t=>u.id===t.id)))},l=i=>c=>({op:4,update:i(c)}),b=(i,c)=>({range:(()=>{let u;const t=l(d=>({range:P.$ut.lift($.Range.from(d))}));return{enumerable:!0,configurable:!1,get(){return u},set(d){i.listener?.({op:6}),S.range(u,d)||(u=d,i.listener?.(t(d)))}}})(),label:E(i,c,S.label,l(u=>({label:u}))),description:E(i,void 0,S.description,l(u=>({description:u}))),sortText:E(i,void 0,S.sortText,l(u=>({sortText:u}))),canResolveChildren:E(i,!1,S.canResolveChildren,u=>({op:2,state:u})),busy:E(i,!1,S.busy,l(u=>({busy:u}))),error:E(i,void 0,S.error,l(u=>({error:$.MarkdownString.fromStrict(u)||null}))),tags:E(i,[],S.tags,(u,t)=>({op:1,new:u.map($.TestTag.from),old:t.map($.TestTag.from)}))}),g=i=>{const c=M.$2K.fromString(i.extId),u=new s(c.controllerId,c.localId,i.label,m.URI.revive(i.uri)||void 0);return u.range=$.Range.to(i.range||void 0),u.description=i.description||void 0,u.sortText=i.sortText||void 0,u.tags=i.tags.map(t=>$.TestTag.to({id:(0,A.$8K)(t).tagId})),u},r=i=>{let c;for(const u of i.tests){const t=g(u.item);(0,O.$AO)(t).parent=c,c=t}return c};e.$QO=r;class s{constructor(c,u,t,d){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const a=(0,O.$zO)(this,c);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof o?void 0:a.parent}},children:{value:(0,N.$yO)(a,O.$AO,s),enumerable:!0,writable:!1},...b(a,t)})}}e.$RO=s;class o extends s{constructor(c,u){super(c,c,u,void 0),this._isRoot=!0}}e.$SO=o;class n extends N.$uO{constructor(c,u,t){super({controllerId:c,getDocumentVersion:d=>d&&t.getDocument(d)?.version,getApiFor:O.$AO,getChildren:d=>d.children,root:new o(c,u),toITestItem:$.TestItem.from})}}e.$TO=n}),define(Se[35],Ie([1,0,15,7,8,25,4,18,12,49,30,94,2,6,3,17,115,21,34,44,66,59,63,33]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g,r,s,o,n,i,c,u,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5O=e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=void 0;let a=class{#e;#t;#i;constructor(h,D,k){this.b=new Map,this.c=new Map,this.#e=h.getProxy(A.$dM.MainThreadCommands),this.d=D,this.#i=k,this.#t=h.getProxy(A.$dM.MainThreadTelemetry),this.converter=new f(this,C=>{const I=this.c.get(C);return I?.result===p.Void?I:void 0},D),this.f=[{processArgument(C){return(0,E.$6h)(C)}},{processArgument(C){return(0,N.$5n)(C,function(I){if(T.$ut.isIRange(I))return M.Range.to(I);if(S.$tt.isIPosition(I))return M.Position.to(I);if(T.$ut.isIRange(I.range)&&l.URI.isUri(I.uri))return M.location.to(I);if(I instanceof o.$Fe)return I.buffer.buffer;if(!Array.isArray(I))return I})}}]}registerArgumentProcessor(h){this.f.push(h)}registerApiCommand(h){const D=this.registerCommand(!1,h.id,async(...k)=>{const C=h.args.map((W,V)=>{if(!W.validate(k[V]))throw new Error(`Invalid argument '${W.name}' when running '${h.id}', received: ${typeof k[V]=="object"?JSON.stringify(k[V],null,"	"):k[V]} `);return W.convert(k[V])}),I=await this.executeCommand(h.internalId,...C);return h.result.convert(I,k,this.converter)},void 0,{description:h.description,args:h.args,returns:h.result.description});return this.c.set(h.id,h),new O.$fM(()=>{D.dispose(),this.c.delete(h.id)})}registerCommand(h,D,k,C,I,W){if(this.d.trace("ExtHostCommands#registerCommand",D),!D.trim().length)throw new Error("invalid id");if(this.b.has(D))throw new Error(`command '${D}' already exists`);return this.b.set(D,{callback:k,thisArg:C,metadata:I,extension:W}),h&&this.#e.$registerCommand(D),new O.$fM(()=>{this.b.delete(D)&&h&&this.#e.$unregisterCommand(D)})}executeCommand(h,...D){return this.d.trace("ExtHostCommands#executeCommand",h),this.g(h,D,!0)}async g(h,D,k){if(this.b.has(h))return this.#e.$fireCommandActivationEvent(h),this.h(h,D,!1);{let C=!1;const I=(0,N.$5n)(D,function(W){if(W instanceof O.$gM)return M.Position.from(W);if(W instanceof O.$hM)return M.Range.from(W);if(W instanceof O.$rM)return M.location.from(W);if(O.$HN.isNotebookRange(W))return M.NotebookRange.from(W);if(W instanceof ArrayBuffer)return C=!0,o.$Fe.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return C=!0,o.$Fe.wrap(W);if(W instanceof o.$Fe)return C=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(h,C?new n.$Bw(I):I,k);return(0,E.$6h)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(h,D,!1);throw W}}}async h(h,D,k){const C=this.b.get(h);if(!C)throw new Error("Unknown command");const{callback:I,thisArg:W,metadata:V}=C;if(V?.args)for(let R=0;R<V.args.length;R++)try{(0,P.$ng)(D[R],V.args[R].constraint)}catch{throw new Error(`Running the contributed command: '${h}' failed. Illegal argument '${V.args[R].name}' - ${V.args[R].description}`)}const q=c.$_d.create();try{return await I.apply(W,D)}catch(R){if(h===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...D);B&&(h=B.command)}if(this.d.error(R,h,C.extension?.identifier),!k)throw R;if(C.extension?.identifier){const B=this.#i.onExtensionError(C.extension.identifier,R);this.d.trace("forwarded error to extension?",B,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$hj)(R)),this.id=h,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,h,q.elapsed())}}j(h,D,k){h.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:h.extension.identifier.value,id:new u.$fp(D),duration:k})}$executeContributedCommand(h,...D){this.d.trace("ExtHostCommands#$executeContributedCommand",h);const k=this.b.get(h);return k?(D=D.map(C=>this.f.reduce((I,W)=>W.processArgument(I,k.extension?.identifier),C)),this.h(h,D,!0)):Promise.reject(new Error(`Contributed command '${h}' does not exist.`))}getCommands(h=!1){return this.d.trace("ExtHostCommands#getCommands",h),this.#e.$getCommands().then(D=>(h&&(D=D.filter(k=>k[0]!=="_")),D))}$getContributedCommandMetadata(){const h=Object.create(null);for(const[D,k]of this.b){const{metadata:C}=k;C&&(h[D]=C)}return Promise.resolve(h)}};e.$ZO=a,e.$ZO=a=Ke([We(0,r.$EO),We(1,m.$3j),We(2,t.$YO)],a),e.$1O=(0,g.$wi)("IExtHostCommands");class f{constructor(h,D,k){this.d=h,this.f=D,this.g=k,this.delegatingCommandId=`__vsc${(0,d.$Sg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(h,D){if(!h)return;const k={$ident:void 0,id:h.command,title:h.title,tooltip:h.tooltip};if(!h.command)return k;const C=this.f(h.command);if(C)k.id=C.internalId,k.arguments=C.args.map((I,W)=>I.convert(h.arguments&&h.arguments[W]));else if((0,$.$Lb)(h.arguments)){const I=`${h.command} /${++this.c}`;this.b.set(I,h),D.add((0,b.$Sc)(()=>{this.b.delete(I),this.g.trace("CommandsConverter#DISPOSE",I)})),k.$ident=I,k.id=this.delegatingCommandId,k.arguments=[I],this.g.trace("CommandsConverter#CREATE",h.command,I)}return k}fromInternal(h){return typeof h.$ident=="string"?this.b.get(h.$ident):{command:h.id,title:h.title,arguments:h.arguments}}getActualCommand(...h){return this.b.get(h[0])}h(...h){const D=this.getActualCommand(...h);return this.g.trace("CommandsConverter#EXECUTE",h[0],D?D.command:"MISSING"),D?this.d.executeCommand(D.command,...D.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${h[0]}`)}}e.$2O=f;class w{static{this.Uri=new w("uri","Uri of a text document",h=>l.URI.isUri(h),h=>h)}static{this.Position=new w("position","A position in a text document",h=>O.$gM.isPosition(h),M.Position.from)}static{this.Range=new w("range","A range in a text document",h=>O.$hM.isRange(h),M.Range.from)}static{this.Selection=new w("selection","A selection in a text document",h=>O.$iM.isSelection(h),M.Selection.from)}static{this.Number=new w("number","",h=>typeof h=="number",h=>h)}static{this.String=new w("string","",h=>typeof h=="string",h=>h)}static{this.StringArray=w.Arr(w.String)}static Arr(h){return new w(`${h.name}_array`,`Array of ${h.name}, ${h.description}`,D=>Array.isArray(D)&&D.every(k=>h.validate(k)),D=>D.map(k=>h.convert(k)))}static{this.CallHierarchyItem=new w("item","A call hierarchy item",h=>h instanceof O.$DM,M.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new w("item","A type hierarchy item",h=>h instanceof O.$2N,M.TypeHierarchyItem.from)}static{this.TestItem=new w("testItem","A VS Code TestItem",h=>h instanceof s.$RO,M.TestItem.from)}constructor(h,D,k,C){this.name=h,this.description=D,this.validate=k,this.convert=C}optional(){return new w(this.name,`(optional) ${this.description}`,h=>h==null||this.validate(h),h=>h===void 0?void 0:h===null?null:this.convert(h))}with(h,D){return new w(h??this.name,D??this.description,this.validate,this.convert)}}e.$3O=w;class p{static{this.Void=new p("no result",h=>h)}constructor(h,D){this.description=h,this.convert=D}}e.$4O=p;class v{constructor(h,D,k,C,I){this.id=h,this.internalId=D,this.description=k,this.args=C,this.result=I}}e.$5O=v}),define(Se[285],Ie([1,0,18,16,2,89,98,31,35,8,7]),function(he,e,P,O,M,N,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Elc=void 0;const S=[new m.$5O("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.$3O.Uri,m.$3O.Position],new m.$4O("A promise that resolves to an array of DocumentHighlight-instances.",b(E.DocumentHighlight.to))),new m.$5O("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.$3O.Uri],new m.$4O("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,s)=>{if((0,P.$Kb)(r))return;class o extends T.$yM{static to(i){const c=new o(i.name,E.SymbolKind.to(i.kind),i.containerName||"",new T.$rM(s[0],E.Range.to(i.range)));return c.detail=i.detail,c.range=c.location.range,c.selectionRange=E.Range.to(i.selectionRange),c.children=i.children?i.children.map(o.to):[],c}}return r.map(o.to)})),new m.$5O("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.$3O.Uri,new m.$3O("options","Formatting options",r=>!0,r=>r)],new m.$4O("A promise that resolves to an array of TextEdits.",b(E.TextEdit.to))),new m.$5O("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.$3O.Uri,m.$3O.Range,new m.$3O("options","Formatting options",r=>!0,r=>r)],new m.$4O("A promise that resolves to an array of TextEdits.",b(E.TextEdit.to))),new m.$5O("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.$3O.Uri,m.$3O.Position,new m.$3O("ch","Trigger character",r=>typeof r=="string",r=>r),new m.$3O("options","Formatting options",r=>!0,r=>r)],new m.$4O("A promise that resolves to an array of TextEdits.",b(E.TextEdit.to))),new m.$5O("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.$3O.Uri,m.$3O.Position],new m.$4O("A promise that resolves to an array of Location or LocationLink instances.",g)),new m.$5O("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.$3O.Uri,m.$3O.Position],new m.$4O("A promise that resolves to an array of Location or LocationLink instances.",g)),new m.$5O("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.$3O.Uri,m.$3O.Position],new m.$4O("A promise that resolves to an array of Location or LocationLink instances.",g)),new m.$5O("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.$3O.Uri,m.$3O.Position],new m.$4O("A promise that resolves to an array of Location or LocationLink instances.",g)),new m.$5O("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.$3O.Uri,m.$3O.Position],new m.$4O("A promise that resolves to an array of Location-instances.",b(E.location.to))),new m.$5O("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.$3O.Uri,m.$3O.Position],new m.$4O("A promise that resolves to an array of Hover-instances.",b(E.Hover.to))),new m.$5O("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.$3O.Uri,new m.$3O("position","A position in a text document",r=>Array.isArray(r)&&r.every(s=>T.$gM.isPosition(s)),r=>r.map(E.Position.from))],new m.$4O("A promise that resolves to an array of ranges.",r=>r.map(s=>{let o;for(const n of s.reverse())o=new T.$CM(E.Range.to(n),o);return o}))),new m.$5O("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.$3O.String.with("query","Search string")],new m.$4O("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(E.WorkspaceSymbol.to))),new m.$5O("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.$3O.Uri,m.$3O.Position],new m.$4O("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(E.CallHierarchyItem.to))),new m.$5O("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.$3O.CallHierarchyItem],new m.$4O("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(E.CallHierarchyIncomingCall.to))),new m.$5O("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.$3O.CallHierarchyItem],new m.$4O("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(E.CallHierarchyOutgoingCall.to))),new m.$5O("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.$3O.Uri,m.$3O.Position],new m.$4O("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:E.Range.to(r.range),placeholder:r.text}})),new m.$5O("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.$3O.Uri,m.$3O.Position,m.$3O.String.with("newName","The new symbol name")],new m.$4O("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return E.WorkspaceEdit.to(r)}})),new m.$5O("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.$3O.Uri,m.$3O.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.$4O("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(E.DocumentLink.to))),new m.$5O("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.$3O.Uri],new m.$4O("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new T.$yN(r.tokenTypes,r.tokenModifiers)})),new m.$5O("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.$3O.Uri],new m.$4O("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const s=(0,A.$ibb)(r);if(s.type==="full")return new T.$AN(s.data,void 0)})),new m.$5O("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.$3O.Uri,m.$3O.Range.optional()],new m.$4O("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new T.$yN(r.tokenTypes,r.tokenModifiers)})),new m.$5O("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.$3O.Uri,m.$3O.Range],new m.$4O("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const s=(0,A.$ibb)(r);if(s.type==="full")return new T.$AN(s.data,void 0)})),new m.$5O("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.$3O.Uri,m.$3O.Position,m.$3O.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.$3O.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.$4O("A promise that resolves to a CompletionList-instance.",(r,s,o)=>{if(!r)return new T.$OM([]);const n=r.suggestions.map(i=>E.CompletionItem.to(i,o));return new T.$OM(n,r.incomplete)})),new m.$5O("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.$3O.Uri,m.$3O.Position,m.$3O.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.$4O("A promise that resolves to SignatureHelp.",r=>{if(r)return E.SignatureHelp.to(r)})),new m.$5O("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.$3O.Uri,m.$3O.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.$4O("A promise that resolves to an array of CodeLens-instances.",(r,s,o)=>b(n=>new T.$GM(E.Range.to(n.range),n.command&&o.fromInternal(n.command)))(r))),new m.$5O("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.$3O.Uri,new m.$3O("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>T.$hM.isRange(r),r=>T.$iM.isSelection(r)?E.Selection.from(r):E.Range.from(r)),m.$3O.String.with("kind","Code action kind to return code actions for").optional(),m.$3O.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.$4O("A promise that resolves to an array of Command-instances.",(r,s,o)=>b(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(n.command)}else{const i=new T.$AM(n.title,n.kind?new T.$BM(n.kind):void 0);return n.edit&&(i.edit=E.WorkspaceEdit.to(n.edit)),n.command&&(i.command=o.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(r))),new m.$5O("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.$3O.Uri],new m.$4O("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(s=>new T.$UM(E.Range.to(s.range),E.Color.to(s.color))):[])),new m.$5O("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.$3O("color","The color to show and insert",r=>r instanceof T.$TM,E.Color.from),new m.$3O("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:E.Range.from(r.range)}))],new m.$4O("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(E.ColorPresentation.to):[])),new m.$5O("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.$3O.Uri,m.$3O.Range],new m.$4O("A promise that resolves to an array of Inlay objects",(r,s,o)=>r.map(E.InlayHint.to.bind(void 0,o)))),new m.$5O("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.$3O.Uri],new m.$4O("A promise that resolves to an array of FoldingRange objects",(r,s)=>{if(r)return r.map(E.FoldingRange.to)})),new m.$5O("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.$4O("A promise that resolves to an array of NotebookContentProvider static info objects.",b(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(s=>E.NotebookExclusiveDocumentPattern.to(s))})))),new m.$5O("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.$3O.Uri,m.$3O.Range,new m.$3O("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof T.$hM,r=>E.InlineValueContext.from(r))],new m.$4O("A promise that resolves to an array of InlineValue objects",r=>r.map(E.InlineValue.to))),new m.$5O("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.$3O("uriOrString","Uri-instance or string (only http/https)",r=>M.URI.isUri(r)||typeof r=="string"&&(0,O.$Gg)(r,O.Schemas.http,O.Schemas.https),r=>r),new m.$3O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[E.ViewColumn.from(r),void 0]:[E.ViewColumn.from(r.viewColumn),E.TextEditorOpenOptions.from(r)])).optional(),m.$3O.String.with("label","").optional()],m.$4O.Void),new m.$5O("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.$3O.Uri.with("resource","Resource to open"),m.$3O.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new m.$3O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[E.ViewColumn.from(r),void 0]:[E.ViewColumn.from(r.viewColumn),E.TextEditorOpenOptions.from(r)])).optional()],m.$4O.Void),new m.$5O("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.$3O.Uri.with("left","Left-hand side resource of the diff editor"),m.$3O.Uri.with("right","Right-hand side resource of the diff editor"),m.$3O.String.with("title","Human readable title for the diff editor").optional(),new m.$3O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[E.ViewColumn.from(r.viewColumn),E.TextEditorOpenOptions.from(r)]).optional()],m.$4O.Void),new m.$5O("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[m.$3O.String.with("title","Human readable title for the changes editor"),new m.$3O("resourceList","List of resources to compare",r=>{for(const s of r){if(s.length!==3)return!1;const[o,n,i]=s;if(!M.URI.isUri(o)||!M.URI.isUri(n)&&n!==void 0&&n!==null||!M.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},r=>r)],m.$4O.Void),new m.$5O("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.$3O.Uri,m.$3O.Position],new m.$4O("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(E.TypeHierarchyItem.to))),new m.$5O("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.$3O.TypeHierarchyItem],new m.$4O("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(E.TypeHierarchyItem.to))),new m.$5O("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.$3O.TypeHierarchyItem],new m.$4O("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(E.TypeHierarchyItem.to))),new m.$5O("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.$3O.TestItem],m.$4O.Void),new m.$5O("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.$3O.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.$4O.Void),new m.$5O("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.$3O.String.with("name","The context key name"),new m.$3O("value","The context key value",()=>!0,r=>r)],m.$4O.Void),new m.$5O("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.$3O.Uri,m.$3O.StringArray,new m.$3O("MappedEditsContext","Mapped Edits Context",r=>E.MappedEditsContext.is(r),r=>E.MappedEditsContext.from(r))],new m.$4O("A promise that resolves to a workspace edit or null",r=>r?E.WorkspaceEdit.to(r):null)),new m.$5O("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$3O("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?E.Range.from(r.initialRange):void 0,initialSelection:T.$iM.isSelection(r.initialSelection)?E.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?E.Position.from(r.position):void 0}})],m.$4O.Void)];class l{static register(s){S.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",$.$vj)}}e.$Elc=l;function b(r){return s=>{if(Array.isArray(s))return s.map(r)}}function g(r){if(!Array.isArray(r))return;const s=[];for(const o of r)N.$_t(o)?s.push(E.DefinitionLink.to(o)):s.push(E.location.to(o));return s}}),define(Se[286],Ie([1,0,2,35]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=void 0;class M{constructor(A,$,m,E,T){this.a=$,this.b=m,this.c=E;const S=new O.$5O("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.$3O("showOptions","Show Options",l=>!0,l=>l),new O.$3O("resource","Interactive resource Uri",l=>!0,l=>l),new O.$3O("controllerId","Notebook controller Id",l=>!0,l=>l),new O.$3O("title","Interactive editor title",l=>!0,l=>l)],new O.$4O("Notebook and input URI",l=>{if(T.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const b=this.a.getEditorById(l.notebookEditorId);return T.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:P.URI.revive(l.notebookUri),inputUri:P.URI.revive(l.inputUri),notebookEditor:b.apiEditor}}return T.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:P.URI.revive(l.notebookUri),inputUri:P.URI.revive(l.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(A,$,m,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:m,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Zmc=M}),define(Se[287],Ie([1,0,18,11,24,5,6,28,2,20,12,4,35,8,7,78,229,26,34,230]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g,r,s,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7mc=void 0,e.$8mc=w;let c=class{constructor(v,y,h,D,k){this.m=y,this.n=h,this.o=D,this.q=k,this.b=new $.$Ac,this.c=new $.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new N.$de,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=v.getProxy(S.$dM.MainThreadNotebookKernels);const C=new l.$5O("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$3O("options","Select kernel options",W=>!0,W=>{if(W&&"notebookEditor"in W&&"id"in W){const V=this.n.getIdByEditor(W.notebookEditor);return{id:W.id,extension:W.extension,notebookEditorId:V}}else if(W&&"notebookEditor"in W){const V=this.n.getIdByEditor(W.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${W.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return W})],l.$4O.Void),I=new l.$5O("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[l.$3O.Uri],new l.$4O("A promise that resolves to an array of variables",(W,V)=>W.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(C),this.o.registerApiCommand(I)}createNotebookController(v,y,h,D,k,C){for(const ae of this.j.values())if(ae.controller.id===y&&E.$Rm.equals(v.identifier,ae.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const I=this.k++,W=this;this.q.trace(`NotebookController[${I}], CREATED by ${v.identifier.value}, ${y}`);const V=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${v.identifier}'`);let q=!1;const R=new N.$de,B=new N.$de,K={id:w(v.identifier,y),notebookType:h,extensionId:v.identifier,extensionLocation:v.extensionLocation,label:D||v.identifier.value,preloads:C?C.map(b.NotebookRendererScript.from):[]};let ie=k??V,ce,ve;this.a.$addKernel(I,K).catch(ae=>{console.log(ae),q=!0});let ke=0;const fe=()=>{if(q)return;const ae=++ke;Promise.resolve().then(()=>{ae===ke&&this.a.$updateKernel(I,K)})},pe=new $.$Ac,Ne={get id(){return y},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:R.event,get label(){return K.label},set label(ae){K.label=ae??v.displayName??v.name,fe()},get detail(){return K.detail??""},set detail(ae){K.detail=ae,fe()},get description(){return K.description??""},set description(ae){K.description=ae,fe()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(ae){K.supportedLanguages=ae,fe()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){K.supportsExecutionOrder=ae,fe()},get rendererScripts(){return K.preloads?K.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return ie},set executeHandler(ae){ie=ae??V},get interruptHandler(){return ce},set interruptHandler(ae){ce=ae,K.supportsInterrupt=!!ae,fe()},set variableProvider(ae){(0,o.$PG)(v,"notebookVariableProvider"),ve=ae,K.hasVariableProvider=!!ae,ae?.onDidChangeVariables(Re=>W.a.$variablesUpdated(Re.uri)),fe()},get variableProvider(){return ve},createNotebookCellExecution(ae){if(q)throw new Error("notebook controller is DISPOSED");if(!pe.has(ae.notebook.uri))throw W.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(Re=>Re.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return W._createNotebookCellExecution(ae,w(v.identifier,this.id))},createNotebookExecution(ae){if((0,o.$PG)(v,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!pe.has(ae.uri))throw W.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(Re=>Re.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.uri.toString()}`);return W._createNotebookExecution(ae,w(v.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${I}], DISPOSED`),q=!0,this.j.delete(I),R.dispose(),B.dispose(),this.a.$removeKernel(I))},updateNotebookAffinity(ae,Re){Re===g.NotebookControllerAffinity2.Hidden&&(0,o.$PG)(v,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(I,ae.uri,Re)},onDidReceiveMessage:B.event,postMessage(ae,Re){return(0,o.$PG)(v,"notebookMessaging"),W.a.$postMessage(I,Re&&W.n.getIdByEditor(Re),ae)},asWebviewUri(ae){return(0,o.$PG)(v,"notebookMessaging"),(0,r.$VAb)(ae,W.m.remote)}};return this.j.set(I,{extensionId:v.identifier,controller:Ne,onDidReceiveMessage:B,onDidChangeSelection:R,associatedNotebooks:pe}),Ne}getIdByController(v){for(const[y,h]of this.j)if(h.controller===v)return w(h.extensionId,v.id);return null}createNotebookControllerDetectionTask(v,y){const h=this.g++,D=this;this.q.trace(`NotebookControllerDetectionTask[${h}], CREATED by ${v.identifier.value}`),this.a.$addKernelDetectionTask(h,y);const k={dispose:()=>{this.f.delete(h),D.a.$removeKernelDetectionTask(h)}};return this.f.set(h,k),k}registerKernelSourceActionProvider(v,y,h){const D=this.i++,k=typeof h.onDidChangeNotebookKernelSourceActions=="function"?D:void 0,C=this;this.h.set(D,h),this.q.trace(`NotebookKernelSourceActionProvider[${D}], CREATED by ${v.identifier.value}`),this.a.$addKernelSourceActionProvider(D,D,y);let I;return k!==void 0&&(I=h.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(k))),{dispose:()=>{this.h.delete(D),C.a.$removeKernelSourceActionProvider(D,D),I?.dispose()}}}async $provideKernelSourceActions(v,y){const h=this.h.get(v);if(h){const D=new A.$Tc;return(await h.provideNotebookKernelSourceActions(y)??[]).map(C=>b.NotebookKernelSourceAction.from(C,this.o.converter,D))}return[]}$acceptNotebookAssociation(v,y,h){const D=this.j.get(v);if(D){const k=this.n.getNotebookDocument(m.URI.revive(y));h?D.associatedNotebooks.set(k.uri,!0):D.associatedNotebooks.delete(k.uri),this.q.trace(`NotebookController[${v}] ASSOCIATE notebook`,k.uri.toString(),h),D.onDidChangeSelection.fire({selected:h,notebook:k.apiNotebook})}}async $executeCells(v,y,h){const D=this.j.get(v);if(!D)return;const k=this.n.getNotebookDocument(m.URI.revive(y)),C=[];for(const I of h){const W=k.getCell(I);W&&C.push(W.apiCell)}try{this.q.trace(`NotebookController[${v}] EXECUTE cells`,k.uri.toString(),C.length),await D.controller.executeHandler.call(D.controller,C,k.apiNotebook,D.controller)}catch(I){this.q.error(`NotebookController[${v}] execute cells FAILED`,I),console.error(I)}}async $cancelCells(v,y,h){const D=this.j.get(v);if(!D)return;const k=this.n.getNotebookDocument(m.URI.revive(y));if(D.controller.interruptHandler)await D.controller.interruptHandler.call(D.controller,k.apiNotebook);else for(const C of h){const I=k.getCell(C);I&&this.b.get(I.uri)?.cancel()}if(D.controller.interruptHandler){const C=this.c.get(k.uri);this.c.delete(k.uri),h.length&&Array.isArray(C)&&C.length&&C.forEach(I=>I.dispose())}}async $provideVariables(v,y,h,D,k,C,I){const W=this.j.get(v);if(!W)return;const V=this.n.getNotebookDocument(m.URI.revive(h)),q=W.controller.variableProvider;if(!q)return;let R;if(D!==void 0){if(R=this.s[D],!R)return}else this.s={};const B=k==="named"?g.NotebookVariablesRequestKind.Named:g.NotebookVariablesRequestKind.Indexed,K=q.provideVariables(V.apiNotebook,R,B,C,I);let ie=0;for await(const ce of K){if(I.isCancellationRequested)return;const ve={id:this.r++,name:ce.variable.name,value:ce.variable.value,type:ce.variable.type,interfaces:ce.variable.interfaces,language:ce.variable.language,expression:ce.variable.expression,hasNamedChildren:ce.hasNamedChildren,indexedChildrenCount:ce.indexedChildrenCount,extensionId:W.extensionId.value};if(this.s[ve.id]=ce.variable,this.a.$receiveVariable(y,ve),ie++>=i.$Aib)return}}$acceptKernelMessageFromRenderer(v,y,h){const D=this.j.get(v);if(!D)return;const k=this.n.getEditorById(y);D.onDidReceiveMessage.fire(Object.freeze({editor:k.apiEditor,message:h}))}$cellExecutionChanged(v,y,h){const k=this.n.getNotebookDocument(m.URI.revive(v)).getCell(y);if(k){const C=h?b.NotebookCellExecutionState.to(h):g.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:k.apiCell,state:C})}}_createNotebookCellExecution(v,y){if(v.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const D=this.n.getNotebookDocument(v.notebook.uri).getCellFromApiCell(v);if(!D)throw new Error("invalid cell");if(this.b.has(D.uri))throw new Error(`duplicate execution for ${D.uri}`);const k=new t(y,D,this.a);this.b.set(D.uri,k);const C=k.onDidChangeState(()=>{k.state===u.Resolved&&(k.dispose(),C.dispose(),this.b.delete(D.uri))});return k.asApiObject()}_createNotebookExecution(v,y){const h=this.n.getNotebookDocument(v.uri),D=v.getCells().find(I=>{const W=h.getCellFromApiCell(I);return W&&this.b.has(W.uri)});if(D)throw new Error(`duplicate cell execution for ${D.document.uri}`);if(this.c.has(h.uri))throw new Error(`duplicate notebook execution for ${h.uri}`);const k=new a(y,h,this.a),C=k.onDidChangeState(()=>{k.state===d.Resolved&&(k.dispose(),C.dispose(),this.c.delete(h.uri))});return this.c.set(h.uri,[k,C]),k.asApiObject()}};e.$7mc=c,e.$7mc=c=Ke([We(4,T.$3j)],c);var u;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(u||(u={}));class t extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(v,y,h){super(),this.m=y,this.n=h,this.b=t.a++,this.c=new N.$de,this.onDidChangeState=this.c.event,this.f=u.Init,this.g=this.B(new M.$oe),this.h=new f(10,D=>this.s(D)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,v,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(v){await this.h.addItem(v)}async s(v){const y=Array.isArray(v)?v:[v];return this.n.$updateExecution(this.b,new n.$Bw(y))}t(){if(this.f===u.Init)throw new Error("Must call start before modifying cell output");if(this.f===u.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(v){let y=this.m;if(v&&(y=this.m.notebook.getCellFromApiCell(v)),!y)throw new Error("INVALID cell");return y.handle}y(v){return v.map(y=>{const h=g.$LN.ensureUniqueMimeTypes(y.items,!0);return h===y.items?b.NotebookCellOutput.from(y):b.NotebookCellOutput.from({items:h,id:y.id,metadata:y.metadata})})}async z(v,y,h){const D=this.w(y),k=this.y((0,P.$2b)(v));return this.r({editType:s.CellExecutionUpdateType.Output,cellHandle:D,append:h,outputs:k})}async C(v,y,h){return v=g.$LN.ensureUniqueMimeTypes((0,P.$2b)(v),!0),this.r({editType:s.CellExecutionUpdateType.OutputItems,items:v.map(b.NotebookCellOutputItem.from),outputId:y.id,append:h})}asApiObject(){const v=this;return Object.freeze({get token(){return v.g.token},get cell(){return v.m.apiCell},get executionOrder(){return v.j},set executionOrder(h){v.j=h,v.s([{editType:s.CellExecutionUpdateType.ExecutionState,executionOrder:v.j}])},start(h){if(v.f===u.Resolved||v.f===u.Started)throw new Error("Cannot call start again");v.f=u.Started,v.c.fire(),v.s({editType:s.CellExecutionUpdateType.ExecutionState,runStartTime:h})},end(h,D,k){if(v.f===u.Resolved)throw new Error("Cannot call resolve twice");v.f=u.Resolved,v.c.fire(),v.h.flush();const C=k?{message:k.message,stack:k.stack,location:k?.location?{startLineNumber:k.location.start.line,startColumn:k.location.start.character,endLineNumber:k.location.end.line,endColumn:k.location.end.character}:void 0,uri:k.uri}:void 0;v.n.$completeExecution(v.b,new n.$Bw({runEndTime:D,lastRunSuccess:h,error:C}))},clearOutput(h){return v.t(),v.z([],h,!1)},appendOutput(h,D){return v.t(),v.z(h,D,!0)},replaceOutput(h,D){return v.t(),v.z(h,D,!1)},appendOutputItems(h,D){return v.t(),v.C(h,D,!0)},replaceOutputItems(h,D){return v.t(),v.C(h,D,!1)}})}}var d;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(d||(d={}));class a extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(v,y,h){super(),this.h=y,this.j=h,this.b=a.a++,this.c=new N.$de,this.onDidChangeState=this.c.event,this.f=d.Init,this.g=this.B(new M.$oe),this.j.$createNotebookExecution(this.b,v,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===d.Resolved||this.f===d.Started)throw new Error("Cannot call start again");this.f=d.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===d.Resolved)throw new Error("Cannot call resolve twice");this.f=d.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class f{constructor(v,y){this.f=v,this.g=y,this.a=[],this.b=Date.now()}addItem(v){return this.a.push(v),this.c||(this.c=new O.$Th,this.b=Date.now(),(0,O.$xh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const v=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>v.complete())}}function w(p,v){return`${p.value}/${v}`}}),define(Se[53],Ie([1,0,5,4,3,2,17,6,7,180,14,208,24,33,209,36,11,8,35]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g,r,s,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=e.$imc=e.$hmc=e.$gmc=void 0,e.$gmc=(0,M.$wi)("IExtHostTerminalService");class i extends $.$Uc{constructor(h,D,k,C){super(),this.u=h,this._id=D,this.w=k,this.y=C,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new P.$de),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(W=>this.g=W);const I=this;this.value={get name(){return I.y||""},get processId(){return I.b},get creationOptions(){return I.w},get exitStatus(){return I.j},get state(){return I.m},get selection(){return I.n},get shellIntegration(){return I.shellIntegration},sendText(W,V=!0){I.C(),I.u.$sendText(I._id,W,V)},show(W){I.C(),I.u.$show(I._id,W)},hide(){I.C(),I.u.$hide(I._id)},dispose(){I.a||(I.a=!0,I.u.$dispose(I._id))},get dimensions(){if(!(I.f===void 0||I.h===void 0))return{columns:I.f,rows:I.h}}}}dispose(){this.s.fire(),super.dispose()}async create(h,D){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:h.name,shellPath:h.shellPath??void 0,shellArgs:h.shellArgs??void 0,cwd:h.cwd??D?.cwd??void 0,env:h.env??void 0,icon:w(h.iconPath)??void 0,color:r.ThemeColor.isThemeColor(h.color)?h.color.id:void 0,initialText:h.message??void 0,strictEnv:h.strictEnv??void 0,hideFromUser:h.hideFromUser??void 0,forceShellIntegration:D?.forceShellIntegration??void 0,isFeatureTerminal:D?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:D?.useShellEnvironment??void 0,location:D?.location||this.z(h.location,D?.resolvedExtHostIdentifier),isTransient:h.isTransient??void 0})}async createExtensionTerminal(h,D,k,C,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:C,color:r.ThemeColor.isThemeColor(I)?I.id:void 0,location:D?.location||this.z(h,k),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(h,D){return typeof h=="object"?"parentTerminal"in h&&h.parentTerminal&&D?{parentTerminal:D}:"viewColumn"in h?{viewColumn:o.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus}:void 0:h}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(h){this.y=h}setExitStatus(h,D){this.j=Object.freeze({code:h,reason:D})}setDimensions(h,D){return h===this.f&&D===this.h||h===0||D===0?!1:(this.f=h,this.h=D,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(h){this.n=h}_setProcessId(h){this.g?(this.g(h),this.g=void 0):this.b.then(D=>{D!==h&&(this.b=Promise.resolve(h))})}}e.$hmc=i;class c{get onProcessReady(){return this.b.event}constructor(h){this.g=h,this.id=0,this.shouldPersist=!1,this.a=new P.$de,this.onProcessData=this.a.event,this.b=new P.$de,this.d=new P.$de,this.onDidChangeProperty=this.d.event,this.f=new P.$de,this.onProcessExit=this.f.event}refreshProperty(h){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${h}`)}updateProperty(h,D){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${h}, value: ${D}`)}async start(){}shutdown(){this.g.close()}input(h){this.g.handleInput?.(h)}resize(h,D){this.g.setDimensions?.({columns:h,rows:D})}clearBuffer(){}async processBinary(h){}acknowledgeDataEvent(h){}async setUnicodeVersion(h){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(h){this.g.onDidWrite(D=>this.a.fire(D)),this.g.onDidClose?.((D=void 0)=>{this.f.fire(D===void 0?void 0:D)}),this.g.onDidOverrideDimensions?.(D=>{D&&this.d.fire({type:"overrideDimensions",value:{cols:D.columns,rows:D.rows}})}),this.g.onDidChangeName?.(D=>{this.d.fire({type:"title",value:D})}),this.g.open(h||void 0),h&&this.g.setDimensions?.(h),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,t=class extends $.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(h=>h.value)}constructor(h,D,k){super(),this.Q=D,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new P.$de,this.onDidCloseTerminal=this.H.event,this.I=new P.$de,this.onDidOpenTerminal=this.I.event,this.J=new P.$de,this.onDidChangeActiveTerminal=this.J.event,this.L=new P.$de,this.onDidChangeTerminalDimensions=this.L.event,this.M=new P.$de,this.onDidChangeTerminalState=this.M.event,this.N=new P.$de,this.onDidChangeShell=this.N.event,this.O=new P.$de({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new P.$de({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(O.$dM.MainThreadTerminalService),this.y=new g.$Pvb(this.a.$sendProcessData),this.a.$registerProcessSupport(h),this.Q.registerArgumentProcessor({processArgument:C=>{const I=W=>{const V=W;return this.getTerminalById(V.instanceId)?.value};switch(C?.$mid){case 15:return I(C);default:{if(Array.isArray(C))for(let W=0;W<C.length&&C[W].$mid===15;W++)C[W]=I(C[W]);return C}}}}),this.B({dispose:()=>{for(const[C,I]of this.g)I.shutdown(!0)}})}getDefaultShell(h){return(h?this.u:this.s)?.path||""}getDefaultShellArgs(h){return(h?this.u:this.s)?.args||[]}createExtensionTerminal(h,D){const k=new i(this.a,(0,b.$Sg)(),h,h.name),C=new c(h.pty);return k.createExtensionTerminal(h.location,D,this.R(h,D).resolvedExtHostIdentifier,w(h.iconPath),p(h.color)).then(I=>{const W=this.S(I,C);this.h[I]=W}),this.f.push(k),k.value}R(h,D){if(D=D||{},h.location&&typeof h.location=="object"&&"parentTerminal"in h.location){const k=h.location.parentTerminal;if(k){const C=this.f.find(I=>I.value===k);C&&(D.resolvedExtHostIdentifier=C._id)}}else h.location&&typeof h.location!="object"?D.location=h.location:D.location&&typeof D.location=="object"&&"splitActiveTerminal"in D.location&&(D.location={splitActiveTerminal:!0});return D}attachPtyToTerminal(h,D){if(!this.getTerminalById(h))throw new Error(`Cannot resolve terminal with id ${h} for virtual process`);const C=new c(D),I=this.S(h,C);this.h[h]=I}async $acceptActiveTerminalChanged(h){const D=this.b;if(h===null){this.b=void 0,D!==this.b&&this.J.fire(this.b);return}const k=this.getTerminalById(h);k&&(this.b=k,D!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(h,D){const k=this.getTerminalById(h);k&&this.O.fire({terminal:k.value,data:D})}async $acceptTerminalDimensions(h,D,k){const C=this.getTerminalById(h);C&&C.setDimensions(D,k)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(h,D){const k=this.getTerminalById(h);k&&this.P.fire({terminal:k.value,...D})}async $acceptTerminalMaximumDimensions(h,D,k){this.g.get(h)?.resize(D,k)}async $acceptTerminalTitleChange(h,D){const k=this.getTerminalById(h);k&&(k.name=D)}async $acceptTerminalClosed(h,D,k){const C=this.X(this.f,h);if(C!==null){const I=this.f.splice(C,1)[0];I.setExitStatus(D,k),this.H.fire(I.value)}}$acceptTerminalOpened(h,D,k,C){if(D){const V=this.X(this.f,D);if(V!==null){this.f[V]._id=h,this.I.fire(this.terminals[V]),this.f[V].isOpen=!0;return}}const I={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:N.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},W=new i(this.a,h,I,k);this.f.push(W),this.I.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(h,D){this.getTerminalById(h)?._setProcessId(D)}async $startExtensionTerminal(h,D){const k=this.getTerminalById(h);if(!k)return{message:(0,E.localize)(0,null,h)};k.isOpen||await new Promise(I=>{const W=this.onDidOpenTerminal(async V=>{V===k.value&&(W.dispose(),I())})});const C=this.g.get(h);C?C.startSendingEvents(D):this.j[h]={initialDimensions:D}}S(h,D){const k=new $.$Tc;k.add(D.onProcessReady(I=>this.a.$sendProcessReady(h,I.pid,I.cwd,I.windowsPty))),k.add(D.onDidChangeProperty(I=>this.a.$sendProcessProperty(h,I))),this.y.startBuffering(h,D.onProcessData),k.add(D.onProcessExit(I=>this.U(h,I))),this.g.set(h,D);const C=this.j[h];return C&&D instanceof c&&(D.startSendingEvents(C.initialDimensions),delete this.j[h]),k}$acceptProcessAckDataEvent(h,D){this.g.get(h)?.acknowledgeDataEvent(D)}$acceptProcessInput(h,D){this.g.get(h)?.input(D)}$acceptTerminalInteraction(h){const D=this.getTerminalById(h);D?.setInteractedWith()&&this.M.fire(D.value)}$acceptTerminalSelection(h,D){this.getTerminalById(h)?.setSelection(D)}$acceptProcessResize(h,D,k){try{this.g.get(h)?.resize(D,k)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(h,D){this.g.get(h)?.shutdown(D)}$acceptProcessRequestInitialCwd(h){this.g.get(h)?.getInitialCwd().then(D=>this.a.$sendProcessProperty(h,{type:"initialCwd",value:D}))}$acceptProcessRequestCwd(h){this.g.get(h)?.getCwd().then(D=>this.a.$sendProcessProperty(h,{type:"cwd",value:D}))}$acceptProcessRequestLatency(h){return Promise.resolve(h)}registerLinkProvider(h){return this.z.add(h),this.z.size===1&&this.a.$startLinkProvider(),new m.$fM(()=>{this.z.delete(h),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(h,D,k){if(this.C.has(D))throw new Error(`Terminal profile provider "${D}" already registered`);return this.C.set(D,k),this.a.$registerProfileProvider(D,h.identifier.value),new m.$fM(()=>{this.C.delete(D),this.a.$unregisterProfileProvider(D)})}registerTerminalQuickFixProvider(h,D,k){if(this.D.has(h))throw new Error(`Terminal quick fix provider "${h}" is already registered`);return this.D.set(h,k),this.a.$registerQuickFixProvider(h,D),new m.$fM(()=>{this.D.delete(h),this.a.$unregisterQuickFixProvider(h)})}async $provideTerminalQuickFixes(h,D){const k=new l.$oe().token;if(k.isCancellationRequested)return;const C=this.D.get(h);if(!C)return;const I=await C.provideTerminalQuickFixes(D,k);if(I===null||Array.isArray(I)&&I.length===0)return;const W=new $.$Tc;if(this.w.value=W,!Array.isArray(I))return I?o.TerminalQuickFix.from(I,this.Q.converter,W):void 0;const V=[];for(const q of I){const R=o.TerminalQuickFix.from(q,this.Q.converter,W);R&&V.push(R)}return V}async $createContributedProfileTerminal(h,D){const k=new l.$oe().token;let C=await this.C.get(h)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${h}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,D);return}this.createTerminalFromOptions(C.options,D)}}async $provideLinks(h,D){const k=this.getTerminalById(h);if(!k)return[];this.F.delete(h),this.G.get(h)?.dispose(!0);const I=new l.$oe;this.G.set(h,I);const W=[],V={terminal:k.value,line:D},q=[];for(const K of this.z)q.push(s.Promises.withAsyncBody(async ie=>{I.token.onCancellationRequested(()=>ie({provider:K,links:[]}));const ce=await K.provideTerminalLinks(V,I.token)||[];I.token.isCancellationRequested||ie({provider:K,links:ce})}));const R=await Promise.all(q);if(I.token.isCancellationRequested)return[];const B=new Map;for(const K of R)K&&K.links.length>0&&W.push(...K.links.map(ie=>{const ce={id:u++,startIndex:ie.startIndex,length:ie.length,label:ie.tooltip};return B.set(ce.id,{provider:K.provider,link:ie}),ce}));return this.F.set(h,B),W}$activateLink(h,D){const k=this.F.get(h)?.get(D);k&&k.provider.handleTerminalLink(k.link)}U(h,D){this.y.stopBuffering(h),this.g.delete(h),delete this.j[h];const k=this.h[h];k&&(k.dispose(),delete this.h[h]),this.a.$sendProcessExit(h,D)}getTerminalById(h){return this.W(this.f,h)}getTerminalIdByApiObject(h){const D=this.f.findIndex(k=>k.value===h);return D>=0?D:null}W(h,D){const k=this.X(h,D);return k!==null?h[k]:null}X(h,D){const k=h.findIndex(C=>C._id===D);return k>=0?k:null}getEnvironmentVariableCollection(h){let D=this.n.get(h.identifier.value);return D||(D=new d,this.Z(h.identifier.value,D)),D.getScopedEnvironmentVariableCollection(void 0)}Y(h,D){const k=(0,S.$ls)(D.map),C=(0,S.$ms)(D.descriptionMap);this.a.$setEnvironmentVariableCollection(h,D.persistent,k.length===0?void 0:k,C)}$initEnvironmentVariableCollections(h){h.forEach(D=>{const k=D[0],C=new d(D[1]);this.Z(k,C)})}$acceptDefaultProfile(h,D){const k=this.s;this.s=h,this.u=D,k?.path!==h.path&&this.N.fire(h.path)}Z(h,D){this.n.set(h,D),D.onDidChangeCollection(()=>{this.Y(h,D)})}};e.$imc=t,e.$imc=t=Ke([We(1,n.$1O),We(2,A.$EO)],t);class d{get persistent(){return this.b}set persistent(h){this.b=h,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(h){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new P.$de,this.map=new Map(h)}getScopedEnvironmentVariableCollection(h){const D=this.h(h);let k=this.a.get(D);return k||(k=new a(this,h),this.a.set(D,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(h,D,k,C){this.f(h,{value:D,type:m.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:C})}append(h,D,k,C){this.f(h,{value:D,type:m.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:C})}prepend(h,D,k,C){this.f(h,{value:D,type:m.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:C})}f(h,D){if(D.options&&D.options.applyAtProcessCreation===!1&&!D.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(h,D.scope),C=this.map.get(k),I=D.options?{applyAtProcessCreation:D.options.applyAtProcessCreation??!1,applyAtShellIntegration:D.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==D.value||C.type!==D.type||C.options?.applyAtProcessCreation!==I.applyAtProcessCreation||C.options?.applyAtShellIntegration!==I.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==D.scope?.workspaceFolder?.index){const W=this.g(h,D.scope),V={variable:h,...D,options:I};this.map.set(W,V),this.d.fire()}}get(h,D){const k=this.g(h,D),C=this.map.get(k);return C?v(C):void 0}g(h,D){const k=this.h(D);return k.length?`${h}:::${k}`:h}h(h){return this.j(h?.workspaceFolder)??""}j(h){return h?h.uri.toString():void 0}getVariableMap(h){const D=new Map;for(const[k,C]of this.map)this.h(C.scope)===this.h(h)&&D.set(C.variable,v(C));return D}delete(h,D){const k=this.g(h,D);this.map.delete(k),this.d.fire()}clear(h){if(h?.workspaceFolder){for(const[D,k]of this.map)k.scope?.workspaceFolder?.index===h.workspaceFolder.index&&this.map.delete(D);this.k(h)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(h,D){const k=this.h(D),C=this.descriptionMap.get(k);if(!C||C.description!==h){let I;typeof h=="string"?I=h:I=h?.value.split(`

`)[0];const W={description:I,scope:D};this.descriptionMap.set(k,W),this.d.fire()}}getDescription(h){const D=this.h(h);return this.descriptionMap.get(D)?.description}k(h){const D=this.h(h);this.descriptionMap.delete(D)}}class a{get persistent(){return this.b.persistent}set persistent(h){this.b.persistent=h}get onDidChangeCollection(){return this.a&&this.a.event}constructor(h,D){this.b=h,this.d=D,this.a=new P.$de}getScoped(h){return this.b.getScopedEnvironmentVariableCollection(h)}replace(h,D,k){this.b.replace(h,D,k,this.d)}append(h,D,k){this.b.append(h,D,k,this.d)}prepend(h,D,k){this.b.prepend(h,D,k,this.d)}get(h){return this.b.get(h,this.d)}forEach(h,D){this.b.getVariableMap(this.d).forEach((k,C)=>h.call(D,C,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(h){this.b.delete(h,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(h){this.b.setDescription(h,this.d)}get description(){return this.b.getDescription(this.d)}}let f=class extends t{constructor(h,D){super(!1,h,D)}createTerminal(h,D,k){throw new T.$_}createTerminalFromOptions(h,D){throw new T.$_}};e.$jmc=f,e.$jmc=f=Ke([We(0,n.$1O),We(1,A.$EO)],f);function w(y){if(!(!y||typeof y=="string"))return"id"in y?{id:y.id,color:y.color}:y}function p(y){return r.ThemeColor.isThemeColor(y)?y:void 0}function v(y){const h={...y};return delete h.scope,h.options=h.options??void 0,delete h.variable,h}}),define(Se[116],Ie([1,0,7,6,3,4,17,53,5,2,11]),function(he,e,P,O,M,N,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nnc=e.$mnc=void 0,e.$mnc=(0,M.$wi)("IExtHostTerminalShellIntegration");let S=class extends O.$Uc{constructor(s,o){super(),this.h=o,this.b=new Map,this.c=new m.$de,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new m.$de,this.onDidStartTerminalShellExecution=this.f.event,this.g=new m.$de,this.onDidEndTerminalShellExecution=this.g.event,this.a=s.getProxy(N.$dM.MainThreadTerminalShellIntegration),this.B((0,O.$Sc)(()=>{for(const[n,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(s){const o=this.h.getTerminalById(s);if(!o)return;const n=o.value;let i=this.b.get(s);i||(i=new l(o.value,this.f),this.b.set(s,i),i.store.add(o.onWillDispose(()=>this.b.get(s)?.dispose())),i.store.add(i.onDidRequestShellExecution(c=>this.a.$executeCommand(s,c))),i.store.add(i.onDidRequestEndExecution(c=>this.g.fire(c))),i.store.add(i.onDidRequestChangeShellIntegration(c=>this.c.fire(c))),o.shellIntegration=i.value),this.c.fire({terminal:n,shellIntegration:i.value})}$shellExecutionStart(s,o,n,i,c){this.b.has(s)||this.$shellIntegrationChange(s);const u={value:o,confidence:n,isTrusted:i};this.b.get(s)?.startShellExecution(u,c)}$shellExecutionEnd(s,o,n,i,c){const u={value:o,confidence:n,isTrusted:i};this.b.get(s)?.endShellExecution(u,c)}$shellExecutionData(s,o){this.b.get(s)?.emitData(o)}$cwdChange(s,o){this.b.get(s)?.setCwd((0,E.$vc)(o)?E.URI.revive(o):o)}$closeTerminal(s){this.b.get(s)?.dispose(),this.b.delete(s)}};e.$nnc=S,e.$nnc=S=Ke([We(0,A.$EO),We(1,$.$gmc)],S);class l extends O.$Uc{get currentExecution(){return this.a}constructor(s,o){super(),this.j=s,this.m=o,this.b=!1,this.store=this.B(new O.$Tc),this.f=this.B(new m.$de),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new m.$de),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new m.$de),this.onDidRequestEndExecution=this.h.event;const n=this;this.value={get cwd(){return n.c},executeCommand(i,c){let u=i;c&&(u+=` "${c.map(a=>`${a.replaceAll('"','\\"')}`).join('" "')}"`),n.g.fire(u);const t={value:u,confidence:P.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},d=n.startShellExecution(t,n.c,!0).value;return n.b=!0,d}}}startShellExecution(s,o,n){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new b(s,o);n?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(s){this.currentExecution?.emitData(s)}endShellExecution(s,o){this.a&&(this.a.endExecution(s),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:o}),this.a=void 0)}setCwd(s){let o=!1;E.URI.isUri(this.c)?o=!E.URI.isUri(s)||this.c.toString()!==s.toString():this.c!==s&&(o=!0),o&&(this.c=s,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class b{constructor(s,o){this.c=s,this.cwd=o,this.b=!1;const n=this;this.value={get commandLine(){return n.c},get cwd(){return n.cwd},read(){return n.d()}}}d(){if(!this.a){if(this.b)return T.$Wh.EMPTY;this.a=new g}return this.a.createIterable()}emitData(s){this.a?.emitData(s)}endExecution(s){s&&(this.c=s),this.a?.endExecution(),this.a=void 0,this.b=!0}}class g extends O.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new T.$vh);const s=this.a;return new T.$Wh(async n=>{this.b.push(n),await s.wait()})}emitData(s){for(const o of this.b)o.emitOne(s)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Se[288],Ie([1,0,11,21,24,5,261,73,6,15,33,12,4,17,115,8,7,52,77,62]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g,r,s,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rnc=e.$qnc=e.$pnc=e.$onc=void 0;let c=class extends m.$Uc{constructor(I,W,V,q){super(),this.w=q,this.f=this.B(new N.$de),this.g=new Map,this.s=this.B(new N.$de),this.onResultsChanged=this.f.event,this.results=[],this.h=I.getProxy(l.$dM.MainThreadTesting),this.m=new y(this.h),this.j=new a(this.h,W),V.registerArgumentProcessor({processArgument:R=>{switch(R?.$mid){case 16:{const B=R,K=B.tests[B.tests.length-1].item.extId;return this.g.get(o.$2K.root(K))?.collection.tree.get(K)?.actual??(0,g.$QO)(R)}case 18:{const{test:B,message:K}=R,ie=B.item.extId;return{test:this.g.get(o.$2K.root(ie))?.collection.tree.get(ie)?.actual??(0,g.$QO)({$mid:16,tests:[B]}),message:r.TestMessage.to(K)}}default:return R}}}),V.registerCommand(!1,"testing.getExplorerSelection",async()=>{const R=await V.executeCommand("_testing.getExplorerSelection"),B=K=>{const ie=this.g.get(o.$2K.root(K));if(ie)return o.$2K.isRoot(K)?ie.controller:ie.collection.tree.get(K)?.actual};return{include:R?.include.map(B).filter(E.$eg)||[],exclude:R?.exclude.map(B).filter(E.$eg)||[]}})}createTestController(I,W,V,q){if(this.g.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const R=new m.$Tc,B=R.add(new g.$TO(W,V,this.w));B.root.label=V;const K=new Map,ie=new Set,ce=this.h,ve={items:B.root.children,get label(){return V},set label(fe){V=fe,B.root.label=fe,ce.$updateController(W,{label:V})},get refreshHandler(){return q},set refreshHandler(fe){q=fe,ce.$updateController(W,{canRefresh:!!fe})},get id(){return W},createRunProfile:(fe,pe,Ne,ae,Re,ne)=>{let z=(0,$.$kj)(fe);for(;K.has(z);)z++;return new D(this.h,K,ie,this.s.event,W,z,fe,pe,Ne,ae,Re,ne)},createTestItem(fe,pe,Ne){return new g.$RO(W,fe,pe,Ne)},createTestRun:(fe,pe,Ne=!0)=>this.j.createTestRun(W,B,fe,pe,Ne),invalidateTestResults:fe=>{if(fe===void 0)this.h.$markTestRetired(void 0);else{const pe=fe instanceof Array?fe:[fe];this.h.$markTestRetired(pe.map(Ne=>o.$2K.fromExtHostTestItem(Ne,W).toString()))}},set resolveHandler(fe){B.resolveHandler=fe},get resolveHandler(){return B.resolveHandler},dispose:()=>{R.dispose()}};ce.$registerTestController(W,V,!!q),R.add((0,m.$Sc)(()=>ce.$unregisterTestController(W)));const ke={controller:ve,collection:B,profiles:K,extension:I,activeProfiles:ie};return this.g.set(W,ke),R.add((0,m.$Sc)(()=>this.g.delete(W))),R.add(B.onDidGenerateDiff(fe=>ce.$publishDiff(W,fe.map(i.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(I,W=M.CancellationToken.None){const V=f(I);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.g.get(V.controllerId);if(!q)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:I.preserveFocus??!0,targets:[{testIds:I.include?.map(R=>o.$2K.fromExtHostTestItem(R,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:k[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:I.exclude?.map(R=>R.id)},W)}$syncTests(){for(const{collection:I}of this.g.values())I.flushDiff();return Promise.resolve()}async $getCoverageDetails(I,W){return(await this.j.getCoverageDetails(I,W))?.map(r.TestCoverage.fromDetails)}async $disposeRun(I){this.j.disposeTestRun(I)}$configureRunProfile(I,W){this.g.get(I)?.profiles.get(W)?.configureHandler?.()}$setDefaultRunProfiles(I){const W=new Map;for(const[V,q]of Object.entries(I)){const R=this.g.get(V);if(!R)continue;const B=new Map,K=q.filter(ce=>!R.activeProfiles.has(ce)),ie=[...R.activeProfiles].filter(ce=>!q.includes(ce));for(const ce of K)B.set(ce,!0),R.activeProfiles.add(ce);for(const ce of ie)B.set(ce,!1),R.activeProfiles.delete(ce);B.size&&W.set(V,B)}this.s.fire(W)}async $refreshTests(I,W){await this.g.get(I)?.controller.refreshHandler?.(W)}$publishTestResults(I){this.results=Object.freeze(I.map(r.TestResults.to).concat(this.results).sort((W,V)=>V.completedAt-W.completedAt).slice(0,32)),this.f.fire()}async $expandTest(I,W){const V=this.g.get(o.$2K.fromString(I).controllerId)?.collection;V&&(await V.expand(I,W<0?1/0:W),V.flushDiff())}$acceptDiff(I){this.m.applyDiff(I.map(W=>i.TestsDiffOp.deserialize({asCanonicalUri:V=>V},W)))}async $runControllerTests(I,W){return Promise.all(I.map(V=>this.y(V,!1,W)))}async $startContinuousRun(I,W){const V=new M.$oe(W),q=await Promise.all(I.map(R=>this.y(R,!0,V.token)));return!W.isCancellationRequested&&!q.some(R=>R.error)&&await new Promise(R=>W.onCancellationRequested(R)),V.dispose(!0),q}async y(I,W,V){const q=this.g.get(I.controllerId);if(!q)return{};const{collection:R,profiles:B}=q,K=B.get(I.profileId);if(!K)return{};const ie=I.testIds.map(fe=>R.tree.get(fe)).filter(E.$eg),ce=I.excludeExtIds.map(fe=>q.collection.tree.get(fe)).filter(E.$eg).filter(fe=>ie.some(pe=>pe.fullId.compare(fe.fullId)===2));if(!ie.length)return{};const ve=new s.$SN(ie.some(fe=>fe.actual instanceof g.$SO)?void 0:ie.map(fe=>fe.actual),ce.map(fe=>fe.actual),K,W),ke=(0,i.$5K)(I)&&this.j.prepareForMainThreadTestRun(ve,w.fromInternal(I,q.collection),K,V);try{return await K.runHandler(ve,V),{}}catch(fe){return{error:String(fe)}}finally{ke&&ke.hasRunningTasks&&!V.isCancellationRequested&&await N.Event.toPromise(ke.onEnd)}}$cancelExtensionTestRun(I){I===void 0?this.j.cancelAllRuns():this.j.cancelRunById(I)}};e.$onc=c,e.$onc=c=Ke([We(0,b.$EO),We(1,S.$3j)],c);const u=1e4;var t;(function(C){C[C.Running=0]="Running",C[C.Cancelling=1]="Cancelling",C[C.Ended=2]="Ended"})(t||(t={}));class d extends m.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(I,W,V,q,R){super(),this.y=I,this.z=W,this.C=V,this.D=q,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new N.$de),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new M.$oe(R));const B=this.B(new P.$Ih(()=>this.F(),u));this.B(this.j.token.onCancellationRequested(()=>B.schedule()));const K=new N.$de;this.s=K.event,this.B((0,m.$Sc)(()=>{K.fire(),K.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(I,W){const[,V,q]=o.$2K.fromString(I).path,R=this.w.get(q);if(!R)return[];const B=this.g.get(V);if(!B)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(B.run,R,W)??[]}createRun(I){const W=this.y.id,V=this.y.controllerId,q=(0,T.$Sg)(),R=ce=>(ve,...ke)=>{if(K){this.C.warn(`Setting the state of test "${ve.id}" is a no-op after the run ends.`);return}this.y.isIncluded(ve)&&(this.H(ve),ce(ve,...ke))},B=(ce,ve)=>{const ke=ve instanceof Array?ve.map(r.TestMessage.from):[r.TestMessage.from(ve)];if(ce.uri&&ce.range){const fe={range:r.Range.from(ce.range),uri:ce.uri};for(const pe of ke)pe.location=pe.location||fe}this.z.$appendTestMessagesInRun(W,q,o.$2K.fromExtHostTestItem(ce,V).toString(),ke)};let K=!1;const ie={isPersisted:this.y.isPersisted,token:this.j.token,name:I,onDidDispose:this.s,addCoverage:ce=>{const ve=ce.uri.toString(),ke=new o.$2K([W,q,ve]).toString();this.w.set(ve,ce),this.z.$appendCoverage(W,q,r.TestCoverage.fromFile(ke,ce))},enqueued:R(ce=>{this.z.$updateTestStateInRun(W,q,o.$2K.fromExtHostTestItem(ce,V).toString(),1)}),skipped:R(ce=>{this.z.$updateTestStateInRun(W,q,o.$2K.fromExtHostTestItem(ce,V).toString(),5)}),started:R(ce=>{this.z.$updateTestStateInRun(W,q,o.$2K.fromExtHostTestItem(ce,V).toString(),2)}),errored:R((ce,ve,ke)=>{B(ce,ve),this.z.$updateTestStateInRun(W,q,o.$2K.fromExtHostTestItem(ce,V).toString(),6,ke)}),failed:R((ce,ve,ke)=>{B(ce,ve),this.z.$updateTestStateInRun(W,q,o.$2K.fromExtHostTestItem(ce,V).toString(),4,ke)}),passed:R((ce,ve)=>{this.z.$updateTestStateInRun(W,q,o.$2K.fromExtHostTestItem(ce,this.y.controllerId).toString(),3,ve)}),appendOutput:(ce,ve,ke)=>{K||(ke&&(this.y.isIncluded(ke)?this.H(ke):ke=void 0),this.z.$appendOutputToRun(W,q,O.$Fe.fromString(ce),ve&&r.location.from(ve),ke&&o.$2K.fromExtHostTestItem(ke,V).toString()))},end:()=>{K||(K=!0,this.z.$finishedTestRunTask(W,q),--this.f||this.G())}};return this.f++,this.g.set(q,{run:ie}),this.z.$startedTestRunTask(W,{id:q,name:I,running:!0}),ie}F(){for(const{run:I}of this.g.values())I.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(I){if(!(I instanceof g.$RO))throw new n.$wO(I.id);if(this.h.has(o.$2K.fromExtHostTestItem(I,this.y.controllerId).toString()))return;const W=[],V=this.y.colllection.root;for(;;){const q=r.TestItem.from(I);if(W.unshift(q),this.h.has(q.extId)||(this.h.add(q.extId),I===V))break;I=I.parent||V}this.z.$addTestsToRun(this.y.controllerId,this.y.id,W)}dispose(){this.G(),super.dispose()}}class a{get trackers(){return this.c.values()}constructor(I,W){this.g=I,this.h=W,this.c=new Map,this.f=new Map}getCoverageDetails(I,W){const V=o.$2K.root(I);return this.f.get(V)?.getCoverageDetails(I,W)||[]}disposeTestRun(I){this.f.get(I)?.dispose(),this.f.delete(I);for(const[W,{id:V}]of this.c)V===I&&this.c.delete(W)}prepareForMainThreadTestRun(I,W,V,q){return this.j(I,W,V,q)}cancelRunById(I){this.f.get(I)?.cancel()}cancelAllRuns(){for(const I of this.c.values())I.cancel()}createTestRun(I,W,V,q,R){const B=this.c.get(V);if(B)return B.createRun(q);const K=w.fromPublic(I,W,V,R),ie=f(V);this.g.$startedExtensionTestRun({controllerId:I,continuous:!!V.continuous,profile:ie&&{group:k[ie.kind],id:ie.profileId},exclude:V.exclude?.map(ve=>o.$2K.fromExtHostTestItem(ve,W.root.id).toString())??[],id:K.id,include:V.include?.map(ve=>o.$2K.fromExtHostTestItem(ve,W.root.id).toString())??[W.root.id],preserveFocus:V.preserveFocus??!0,persist:R});const ce=this.j(V,K,V.profile);return N.Event.once(ce.onEnd)(()=>{this.g.$finishedExtensionTestRun(K.id)}),ce.createRun(q)}j(I,W,V,q){const R=new d(W,this.g,this.h,V,q);return this.c.set(I,R),this.f.set(R.id,R),R}}e.$pnc=a;const f=C=>{if(C.profile){if(!(C.profile instanceof D))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return C.profile}};class w{static fromPublic(I,W,V,q){return new w(I,(0,T.$Sg)(),V.include?.map(R=>o.$2K.fromExtHostTestItem(R,I).toString())??[I],V.exclude?.map(R=>o.$2K.fromExtHostTestItem(R,I).toString())??[],q,W)}static fromInternal(I,W){return new w(I.controllerId,I.runId,I.testIds,I.excludeExtIds,!0,W)}constructor(I,W,V,q,R,B){this.controllerId=I,this.id=W,this.isPersisted=R,this.colllection=B,this.c=V.map(K=>K+"\0"),this.f=q.map(K=>K+"\0")}isIncluded(I){const W=o.$2K.fromExtHostTestItem(I,this.controllerId).toString()+"\0";for(const V of this.f)if(W===V||W.startsWith(V))return!1;for(const V of this.c)if(W===V||W.startsWith(V))return!0;return!1}}e.$qnc=w;class p{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(I){this.j=I,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(I){this.c.add(I)}update(I){Object.assign(I.revived,r.TestItem.toPlain(I.item)),this.c.has(I)||this.f.add(I)}remove(I){if(this.c.has(I)){this.c.delete(I);return}this.f.delete(I);const W=o.$2K.parentId(I.item.extId);if(W&&this.h.has(W.toString())){this.h.add(I.item.extId);return}this.g.add(I)}getChangeEvent(){const{c:I,f:W,g:V}=this;return{get added(){return[...I].map(q=>q.revived)},get updated(){return[...W].map(q=>q.revived)},get removed(){return[...V].map(q=>q.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class v extends i.$$K{constructor(){super(...arguments),this.s=new N.$de,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(I){return this.f.get(I)}getMirroredTestDataByReference(I){return this.f.get(I.id)}w(I,W){return{...I,revived:r.TestItem.toPlain(I.item),depth:W?W.depth+1:0,children:new Set}}v(){return new p(this.s)}}class y{constructor(I){this.f=I}checkout(){this.c||(this.c=this.g());const I=this.c;return I.observers++,{onDidChangeTest:I.tests.onDidChangeTests,get tests(){return[...I.tests.rootTests].map(W=>W.revived)},dispose:(0,A.$db)(()=>{--I.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(I){return this.c?.tests.getMirroredTestDataByReference(I)}applyDiff(I){this.c?.tests.apply(I)}g(){const I=new v({asCanonicalUri:W=>W});return this.f.$subscribeToDiffs(),{observers:0,tests:I}}}const h=(C,I,W,V)=>{W?Object.assign(W,V):I.$updateTestRunConfig(C.controllerId,C.profileId,V)};class D{#e;#t;#i;#n;#s;get label(){return this.f}set label(I){I!==this.f&&(this.f=I,h(this,this.#e,this.#n,{label:I}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(I){I!==this.g&&(this.g=I,h(this,this.#e,this.#n,{supportsContinuousRun:I}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(I){I!==this.isDefault&&(I?this.#t.add(this.profileId):this.#t.delete(this.profileId),h(this,this.#e,this.#n,{isDefault:I}))}get tag(){return this._tag}set tag(I){I?.id!==this._tag?.id&&(this._tag=I,h(this,this.#e,this.#n,{tag:I?r.TestTag.namespace(this.controllerId,I.id):null}))}get configureHandler(){return this.c}set configureHandler(I){I!==this.c&&(this.c=I,h(this,this.#e,this.#n,{hasConfigurationHandler:!!I}))}get onDidChangeDefault(){return N.Event.chain(this.#i,I=>I.map(W=>W.get(this.controllerId)?.get(this.profileId)).filter(E.$eg))}constructor(I,W,V,q,R,B,K,ie,ce,ve=!1,ke=void 0,fe=!1){this.controllerId=R,this.profileId=B,this.f=K,this.kind=ie,this.runHandler=ce,this._tag=ke,this.g=fe,this.#e=I,this.#s=W,this.#t=V,this.#i=q,W.set(B,this);const pe=k[ie];if(typeof pe!="number")throw new Error(`Unknown TestRunProfile.group ${ie}`);ve&&V.add(B),this.#n={profileId:B,controllerId:R,tag:ke?r.TestTag.namespace(this.controllerId,ke.id):null,label:K,group:pe,isDefault:ve,hasConfigurationHandler:!1,supportsContinuousRun:fe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$rnc=D;const k={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(Se[117],Ie([1,0,57,14,91,8,7]),function(he,e,P,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NO=e.$MO=e.$LO=void 0;class ${static{this.c=new M.$JO("TextEditorDecorationType")}constructor(l,b,g){const r=$.c.nextId();l.$registerTextEditorDecorationType(b.identifier,r,N.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:r,dispose(){l.$removeTextEditorDecorationType(r)}})}}e.$LO=$;class m{constructor(l,b){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,b){this.k();let g=null;if(l instanceof A.$gM)g=new A.$hM(l,l);else if(l instanceof A.$hM)g=l;else throw new Error("Unrecognized location");this.l(g,b,!1)}insert(l,b){this.k(),this.l(new A.$hM(l,l),b,!0)}delete(l){this.k();let b=null;if(l instanceof A.$hM)b=l;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(l,b,g){const r=this.c.validateRange(l);this.g.push({range:r,text:b,forceMoveMarkers:g})}setEndOfLine(l){if(this.k(),l!==A.EndOfLine.LF&&l!==A.EndOfLine.CRLF)throw(0,O.$7)("endOfLine");this.h=l}}class E{constructor(l,b,g,r){this.c=l,this.d=b,this._accept(g),this.e=r;const s=this;this.value={get tabSize(){return s.f},set tabSize(o){s.n(o)},get indentSize(){return s.g},set indentSize(o){s.p(o)},get insertSpaces(){return s.j},set insertSpaces(o){s.s(o)},get cursorStyle(){return s.k},set cursorStyle(o){s.t(o)},get lineNumbers(){return s.l},set lineNumbers(o){s.u(o)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=N.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const b=Math.floor(l);return b>0?b:null}if(typeof l=="string"){const b=parseInt(l,10);return isNaN(b)?null:b>0?b:null}return null}n(l){const b=this.m(l);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const b=Math.floor(l);return b>0?b:null}if(typeof l=="string"){const b=parseInt(l,10);return isNaN(b)?null:b>0?b:null}return null}p(l){const b=this.o(l);if(b!==null){if(typeof b=="number"){if(this.h===b)return;this.g=b,this.h=b}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const b=this.q(l);if(typeof b=="boolean"){if(this.j===b)return;this.j=b}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:N.TextEditorLineNumbersStyle.from(l)})))}assign(l){const b={};let g=!1;if(typeof l.tabSize<"u"){const r=this.m(l.tabSize);r==="auto"?(g=!0,b.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,g=!0,b.tabSize=r)}if(typeof l.indentSize<"u"){const r=this.o(l.indentSize);r==="tabSize"?(g=!0,b.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,g=!0,b.indentSize=r)}if(typeof l.insertSpaces<"u"){const r=this.q(l.insertSpaces);r==="auto"?(g=!0,b.insertSpaces=r):this.j!==r&&(this.j=r,g=!0,b.insertSpaces=r)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,g=!0,b.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,g=!0,b.lineNumbers=N.TextEditorLineNumbersStyle.from(l.lineNumbers)),g&&this.v("setOptions",this.c.$trySetOptions(this.d,b))}v(l,b){b.catch(g=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(g)})}}e.$MO=E;class T{constructor(l,b,g,r,s,o,n,i){this.id=l,this.j=b,this.k=g,this.g=!1,this.h=new Set,this.c=s,this.d=new E(this.j,this.id,o,g),this.e=n,this.f=i;const c=this;this.value=Object.freeze({get document(){return r.value},set document(u){throw new O.$9("document")},get selection(){return c.c&&c.c[0]},set selection(u){if(!(u instanceof A.$iM))throw(0,O.$7)("selection");c.c=[u],c.l()},get selections(){return c.c},set selections(u){if(!Array.isArray(u)||u.some(t=>!(t instanceof A.$iM)))throw(0,O.$7)("selections");c.c=u,c.l()},get visibleRanges(){return c.e},set visibleRanges(u){throw new O.$9("visibleRanges")},get options(){return c.d.value},set options(u){c.g||c.d.assign(u)},get viewColumn(){return c.f},set viewColumn(u){throw new O.$9("viewColumn")},edit(u,t={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new m(r.value,t);return u(d),c.m(d)},insertSnippet(u,t,d={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=c.c.map(f=>N.Range.from(f));else if(t instanceof A.$gM){const{lineNumber:f,column:w}=N.Position.from(t);a=[{startLineNumber:f,startColumn:w,endLineNumber:f,endColumn:w}]}else if(t instanceof A.$hM)a=[N.Range.from(t)];else{a=[];for(const f of t)if(f instanceof A.$hM)a.push(N.Range.from(f));else{const{lineNumber:w,column:p}=N.Position.from(f);a.push({startLineNumber:w,startColumn:p,endLineNumber:w,endColumn:p})}}return b.$tryInsertSnippet(l,r.value.version,u.value,a,d)},setDecorations(u,t){const d=t.length===0;d&&!c.h.has(u.key)||(d?c.h.delete(u.key):c.h.add(u.key),c.n(()=>{if(N.$BO(t))return b.$trySetDecorations(l,u.key,N.$CO(t));{const a=new Array(4*t.length);for(let f=0,w=t.length;f<w;f++){const p=t[f];a[4*f]=p.start.line+1,a[4*f+1]=p.start.character+1,a[4*f+2]=p.end.line+1,a[4*f+3]=p.end.character+1}return b.$trySetDecorationsFast(l,u.key,a)}}))},revealRange(u,t){c.n(()=>b.$tryRevealRange(l,N.Range.from(u),t||A.TextEditorRevealType.Default))},show(u){b.$tryShowEditor(l,N.ViewColumn.from(u))},hide(){b.$tryHideEditor(l)}})}dispose(){(0,P.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,P.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,P.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,P.ok)(!this.g),this.f=l}_acceptSelections(l){(0,P.ok)(!this.g),this.c=l}async l(){const l=this.c.map(N.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const b=l.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const g=b.edits.map(s=>s.range);g.sort((s,o)=>s.end.line===o.end.line?s.end.character===o.end.character?s.start.line===o.start.line?s.start.character-o.start.character:s.start.line-o.start.line:s.end.character-o.end.character:s.end.line-o.end.line);for(let s=0,o=g.length-1;s<o;s++){const n=g[s].end;if(g[s+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=b.edits.map(s=>({range:N.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,r,{setEndOfLine:typeof b.setEndOfLine=="number"?N.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$NO=T}),define(Se[68],Ie([1,0,57,5,6,2,3,4,113,17,117,8,12,28,16,42,43]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PO=e.$OO=void 0;class o{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,u){this.h=c,this.i=u,this.a=null,this.b=new Map,this.c=new b.$Ac,this.d=new O.$de,this.e=new O.$de,this.f=new O.$de,this.g=new O.$de,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const u=[],t=[],d=[];if(c.removedDocuments)for(const a of c.removedDocuments){const f=N.URI.revive(a),w=this.c.get(f);w?.unref()&&(this.c.delete(f),u.push(w.value))}if(c.addedDocuments)for(const a of c.addedDocuments){const f=N.URI.revive(a.uri);let w=this.c.get(f);if(w&&f.scheme!==g.Schemas.vscodeNotebookCell&&f.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${f} already exists!'`);w||(w=new o(new m.$HO(this.h.getProxy($.$dM.MainThreadDocuments),f,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty)),this.c.set(f,w),t.push(w.value)),w.ref()}if(c.removedEditors)for(const a of c.removedEditors){const f=this.b.get(a);this.b.delete(a),f&&d.push(f)}if(c.addedEditors)for(const a of c.addedEditors){const f=N.URI.revive(a.documentUri);P.ok(this.c.has(f),`document '${f}' does not exist`),P.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const w=this.c.get(f).value,p=new T.$NO(a.id,this.h.getProxy($.$dM.MainThreadTextEditors),this.i,new s.$V(()=>w.document),a.selections.map(S.Selection.to),a.options,a.visibleRanges.map(v=>S.Range.to(v)),typeof a.editorPosition=="number"?S.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,p)}c.newActiveEditor!==void 0&&(P.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,M.$Pc)(u),(0,M.$Pc)(d),c.removedDocuments&&this.e.fire(u),c.addedDocuments&&this.d.fire(t),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return r.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const u=this.b.get(this.a);return c?u:u?.value}allEditors(){return[...this.b.values()]}};e.$OO=n,e.$OO=n=Ke([We(0,E.$EO),We(1,l.$3j)],n),e.$PO=(0,A.$wi)("IExtHostDocumentsAndEditors")}),define(Se[289],Ie([1,0,18,5,4,117,8,7]),function(he,e,P,O,M,N,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Llc=void 0;class m{constructor(T,S){this.i=S,this.a=new O.$de,this.b=new O.$de,this.c=new O.$de,this.d=new O.$de,this.f=new O.$de,this.g=new O.$de,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=T.getProxy(M.$dM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(T){const S=this.i.allEditors();return T?S:S.map(l=>l.value)}async showTextDocument(T,S,l){let b;typeof S=="number"?b={position:A.ViewColumn.from(S),preserveFocus:l}:typeof S=="object"?b={position:A.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?A.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:b={preserveFocus:!1};const g=await this.h.$tryShowTextDocument(T.uri,b),r=g&&this.i.getEditor(g);if(r)return r.value;throw g?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T,S){return new N.$LO(this.h,T,S).value}$acceptEditorPropertiesChanged(T,S){const l=this.i.getEditor(T);if(!l)throw new Error("unknown text editor");if(S.options&&l._acceptOptions(S.options),S.selections){const b=S.selections.selections.map(A.Selection.to);l._acceptSelections(b)}if(S.visibleRanges){const b=P.$Hb(S.visibleRanges.map(A.Range.to));l._acceptVisibleRanges(b)}if(S.options&&this.b.fire({textEditor:l.value,options:{...S.options,lineNumbers:A.TextEditorLineNumbersStyle.to(S.options.lineNumbers)}}),S.selections){const b=$.TextEditorSelectionChangeKind.fromValue(S.selections.source),g=S.selections.selections.map(A.Selection.to);this.a.fire({textEditor:l.value,selections:g,kind:b})}if(S.visibleRanges){const b=P.$Hb(S.visibleRanges.map(A.Range.to));this.c.fire({textEditor:l.value,visibleRanges:b})}}$acceptEditorPositionData(T){for(const S in T){const l=this.i.getEditor(S);if(!l)throw new Error("Unknown text editor");const b=A.ViewColumn.to(T[S]);l.value.viewColumn!==b&&(l._acceptViewColumn(b),this.d.fire({textEditor:l.value,viewColumn:b}))}}getDiffInformation(T){return Promise.resolve(this.h.$getDiffInformation(T))}}e.$Llc=m}),define(Se[290],Ie([1,0,2,3,4,6,7,8,20,15]),function(he,e,P,O,M,N,A,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=e.$tnc=void 0,e.$tnc=(0,O.$wi)("IExtHostTimeline");class T{constructor(b,g){this.b=new Map,this.c=new Map,this.a=b.getProxy(M.$dM.MainThreadTimeline),g.registerArgumentProcessor({processArgument:(r,s)=>{if(r&&r.$mid===12)if(this.b.get(r.source)&&m.$Rm.equals(s,this.b.get(r.source)?.extension)){const o=r.uri===void 0?void 0:P.URI.revive(r.uri);return this.c.get(r.source)?.get(S(o))?.get(r.handle)}else return;return r}})}async $getTimeline(b,g,r,s){return this.b.get(b)?.provider.provideTimeline(P.URI.revive(g),r,s)}registerTimelineProvider(b,g,r,s){const o=new N.$Tc,n=this.d(g.id,s,o).bind(this);let i;g.onDidChange&&(i=g.onDidChange(u=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...u,id:g.id}),this));const c=this.c;return this.f({...g,scheme:b,onDidChange:void 0,async provideTimeline(u,t,d){t?.resetCache&&(o.clear(),c.get(g.id)?.clear());const a=await g.provideTimeline(u,t,d);if(a==null)return;const f=n(u,t);return{...a,source:g.id,items:a.items.map(f)}},dispose(){for(const u of c.values())u.get(g.id)?.clear();i?.dispose(),o.dispose()}},r)}d(b,g,r){return(s,o)=>{let n;if(o?.cacheResults){let i=this.c.get(b);i===void 0&&(i=new Map,this.c.set(b,i));const c=S(s);n=i.get(c),n===void 0&&(n=new Map,i.set(c,n))}return i=>{const{iconPath:c,...u}=i,t=`${b}|${i.id??i.timestamp}`;n?.set(t,i);let d,a,f;i.iconPath&&(c instanceof A.$cN?f={id:c.id,color:c.color}:P.URI.isUri(c)?(d=c,a=c):{light:d,dark:a}=c);let w;return A.$HM.isMarkdownString(u.tooltip)?w=$.MarkdownString.from(u.tooltip):(0,E.$9f)(u.tooltip)?w=u.tooltip:A.$HM.isMarkdownString(u.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=$.MarkdownString.from(u.detail)):(0,E.$9f)(u.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=u.detail),{...u,id:u.id??void 0,handle:t,source:b,command:i.command?g.toInternal(i.command,r):void 0,icon:d,iconDark:a,themeIcon:f,tooltip:w,accessibilityInformation:i.accessibilityInformation}}}}f(b,g){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:g}),(0,N.$Sc)(()=>{for(const s of this.c.values())s.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$unc=T;function S(l){return l?.toString()}}),define(Se[291],Ie([1,0,181,23,2,5,6,222,11,7,15,18,8,55,24,143,26]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vnc=void 0;function o(c,u){if((0,T.$9f)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let t;return Array.isArray(c.highlights)&&(t=c.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),t=t.length?t:void 0),{label:c.label,highlights:t}}}class n extends A.$Uc{constructor(u,t,d){super(),this.f=u,this.g=t,this.h=d,this.a=new Map,this.b=new r.$A0;function a(f){return f&&f.$treeViewId&&(f.$treeItemHandle||f.$selectedTreeItems||f.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:f=>a(f)?this.r(f):Array.isArray(f)&&f.length>0?f.map(w=>a(w)?this.r(w):w):f})}registerTreeDataProvider(u,t,d){const a=this.createTreeView(u,{treeDataProvider:t},d);return{dispose:()=>a.dispose()}}createTreeView(u,t,d){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=t.dragAndDropController?.dropMimeTypes??[],f=t.dragAndDropController?.dragMimeTypes??[],w=!!t.dragAndDropController?.handleDrag,p=!!t.dragAndDropController?.handleDrop,v=this.m(u,t,d),y={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:a,dragMimeTypes:f,hasHandleDrag:w,hasHandleDrop:p,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},h=this.f.$registerTreeViewDataProvider(u,y),D={get onDidCollapseElement(){return v.onDidCollapseElement},get onDidExpandElement(){return v.onDidExpandElement},get selection(){return v.selectedElements},get onDidChangeSelection(){return v.onDidChangeSelection},get activeItem(){return(0,s.$PG)(d,"treeViewActiveItem"),v.focusedElement},get onDidChangeActiveItem(){return(0,s.$PG)(d,"treeViewActiveItem"),v.onDidChangeActiveItem},get visible(){return v.visible},get onDidChangeVisibility(){return v.onDidChangeVisibility},get onDidChangeCheckboxState(){return v.onDidChangeCheckboxState},get message(){return v.message},set message(k){(0,b.$Vk)(k)&&(0,s.$PG)(d,"treeViewMarkdownMessage"),v.message=k},get title(){return v.title},set title(k){v.title=k},get description(){return v.description},set description(k){v.description=k},get badge(){return v.badge},set badge(k){k!==void 0&&E.ViewBadge.isViewBadge(k)?v.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(v.badge=void 0)},reveal:(k,C)=>v.reveal(k,C),dispose:async()=>{await h,this.a.delete(u),v.dispose()}};return this.B(D),D}$getChildren(u,t){const d=this.a.get(u);return d?d.getChildren(t):Promise.reject(new $.$4F(u))}async $handleDrop(u,t,d,a,f,w,p,v){const y=this.a.get(u);if(!y)return Promise.reject(new $.$4F(u));const h=l.DataTransfer.toDataTransfer(d,async D=>(await this.f.$resolveDropFileData(u,t,D)).buffer);return p===u&&v&&await this.j(h,y,v,f,w),y.onDrop(h,a,f)}async j(u,t,d,a,f){const w=this.b.removeDragOperationTransfer(f);if(w)(await w)?.forEach((p,v)=>{p&&u.set(v,p)});else if(f&&t.handleDrag){const p=t.handleDrag(d,u,a);this.b.addDragOperationTransfer(f,p),await p}return u}async $handleDrag(u,t,d,a){const f=this.a.get(u);if(!f)return Promise.reject(new $.$4F(u));const w=await this.j(new E.$$M,f,t,a,d);if(!(!w||a.isCancellationRequested))return l.DataTransfer.from(w)}async $hasResolve(u){const t=this.a.get(u);if(!t)throw new $.$4F(u);return t.hasResolve}$resolve(u,t,d){const a=this.a.get(u);if(!a)throw new $.$4F(u);return a.resolveTreeItem(t,d)}$setExpanded(u,t,d){const a=this.a.get(u);if(!a)throw new $.$4F(u);a.setExpanded(t,d)}$setSelectionAndFocus(u,t,d){const a=this.a.get(u);if(!a)throw new $.$4F(u);a.setSelectionAndFocus(t,d)}$setVisible(u,t){const d=this.a.get(u);if(!d){if(!t)return;throw new $.$4F(u)}d.setVisible(t)}$changeCheckboxState(u,t){const d=this.a.get(u);if(!d)throw new $.$4F(u);d.setCheckboxState(t)}m(u,t,d){const a=this.B(new i(u,t,this.f,this.g.converter,this.h,d));return this.a.set(u,a),a}r(u){const t=this.a.get(u.$treeViewId);return t&&"$treeItemHandle"in u?t.getExtensionElement(u.$treeItemHandle):t&&"$focusedTreeItem"in u&&u.$focusedTreeItem?t.focusedElement:null}}e.$vnc=n;class i extends A.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(u=>this.getExtensionElement(u)).filter(u=>!(0,T.$fg)(u))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(u,t,d,a,f,w){if(super(),this.I=u,this.J=d,this.L=a,this.M=f,this.N=w,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new N.$de),this.onDidExpandElement=this.u.event,this.w=this.B(new N.$de),this.onDidCollapseElement=this.w.event,this.y=this.B(new N.$de),this.onDidChangeSelection=this.y.event,this.z=this.B(new N.$de),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new N.$de),this.onDidChangeVisibility=this.C.event,this.D=this.B(new N.$de),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new N.$de),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new g.$oe,w.contributes&&w.contributes.views)for(const h in w.contributes.views)for(const D of w.contributes.views[h])D.id===u&&(this.P=D.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(h=>{Array.isArray(h)&&h.length===0||this.F.fire({message:!1,element:h})}));let p,v;const y=N.Event.debounce(this.F.event,(h,D)=>(h||(h={message:!1,elements:[]}),D.element!==!1&&(p||(p=new Promise(k=>v=k),this.G=this.G.then(()=>p)),Array.isArray(D.element)?h.elements.push(...D.element):h.elements.push(D.element)),D.message&&(h.message=!0),h),200,!0);this.B(y(({message:h,elements:D})=>{D.length&&(this.H=this.H.then(()=>{const k=v;return p=null,this.$(D).then(()=>k())})),h&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(u){const t=u?this.getExtensionElement(u):void 0;if(u&&!t)return this.M.error(`No tree item with id '${u}' found.`),Promise.resolve([]);let d=this.X(u);return d||(d=await this.Y(t)),d?d.map(a=>a.item):void 0}getExtensionElement(u){return this.j.get(u)}reveal(u,t){t=t||{select:!0,focus:!1};const d=(0,T.$fg)(t.select)?!0:t.select,a=(0,T.$fg)(t.focus)?!1:t.focus,f=(0,T.$fg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):u?this.G.then(()=>this.S(u)).then(w=>this.W(u,w[w.length-1]).then(p=>this.J.$reveal(this.I,{item:p.item,parentChain:w.map(v=>v.item)},{select:d,focus:a,expand:f})),w=>this.M.error(w)):this.J.$reveal(this.I,void 0,{select:d,focus:a,expand:f})}get message(){return this.O}set message(u){this.O=u,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(u){this.P=u,this.J.$setTitle(this.I,u,this.Q)}get description(){return this.Q}set description(u){this.Q=u,this.J.$setTitle(this.I,this.P,u)}get badge(){return this.R}set badge(u){this.R?.value===u?.value&&this.R?.tooltip===u?.tooltip||(this.R=l.ViewBadge.from(u),this.J.$setBadge(this.I,u))}setExpanded(u,t){const d=this.getExtensionElement(u);d&&(t?this.u.fire(Object.freeze({element:d})):this.w.fire(Object.freeze({element:d})))}setSelectionAndFocus(u,t){const d=!(0,S.$ub)(this.s,u);this.s=u;const a=this.t!==t;this.t=t,d&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(u){u!==this.r&&(this.r=u,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(u){const t=(await Promise.all(u.map(async d=>{const a=this.getExtensionElement(d.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:d.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(d=>d!==void 0);t.forEach(d=>{d.treeItem.checkboxState=d.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(d=>[d.extensionItem,d.newState])})}async handleDrag(u,t,d){const a=[];for(const f of u){const w=this.getExtensionElement(f);w&&a.push(w)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,t,d),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(u,t,d){const a=t?this.getExtensionElement(t):void 0;if(!(!a&&t||!this.g?.handleDrop))return(0,m.$oh)(()=>this.g?.handleDrop?this.g.handleDrop(a,u,d):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(u,t){if(!this.f.resolveTreeItem)return;const d=this.j.get(u);if(d){const a=this.m.get(d);if(a){const f=await this.f.resolveTreeItem(a.extensionItem,d,t)??a.extensionItem;return this.hb(f),a.item.tooltip=this.eb(f.tooltip),a.item.command=this.fb(a.disposableStore,f.command),a.item}}}S(u){return this.U(u).then(t=>t?this.S(t).then(d=>this.W(t,d[d.length-1]).then(a=>(d.push(a),d))):Promise.resolve([]))}U(u){const t=this.m.get(u);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,m.$oh)(()=>this.f.getParent(u))}W(u,t){const d=this.m.get(u);return d?Promise.resolve(d):(0,m.$oh)(()=>this.f.getTreeItem(u)).then(a=>this.kb(u,a,t,!0)).then(a=>this.getChildren(t?t.item.handle:void 0).then(()=>{const f=this.getExtensionElement(a);if(f){const w=this.m.get(f);if(w)return Promise.resolve(w)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(u){if(u){let t;if(typeof u=="string"){const d=this.getExtensionElement(u);t=d?this.m.get(d):void 0}else t=u;return t&&t.children||void 0}return this.h}async Y(u){this.rb(u);const t=new g.$oe(this.Z.token);try{const d=u?this.m.get(u):void 0,a=await this.f.getChildren(u);if(t.token.isCancellationRequested)return;const f=(0,S.$Hb)(a||[]),w=await Promise.all((0,S.$Hb)(f).map(v=>this.f.getTreeItem(v)));if(t.token.isCancellationRequested)return;const p=w.map((v,y)=>v?this.db(f[y],v,d):null);return(0,S.$Hb)(p)}finally{t.dispose()}}$(u){if(u.some(d=>!d))return this.Z.dispose(!0),this.Z=new g.$oe,this.tb(),this.J.$refresh(this.I);{const d=this.ab(u);if(d.length)return this.bb(d)}return Promise.resolve(void 0)}ab(u){const t=new Set,d=u.map(f=>this.m.get(f));for(const f of d)if(f&&!t.has(f.item.handle)){let w=f;for(;w&&w.parent&&d.findIndex(p=>w&&w.parent&&p&&p.item.handle===w.parent.item.handle)===-1;){const p=this.j.get(w.parent.item.handle);w=p?this.m.get(p):void 0}w&&!w.parent&&t.add(f.item.handle)}const a=[];return t.forEach(f=>{const w=this.j.get(f);if(w){const p=this.m.get(w);p&&(!p.parent||!t.has(p.parent.item.handle))&&a.push(f)}}),a}bb(u){const t={};return Promise.all(u.map(d=>this.cb(d).then(a=>{a&&(t[d]=a.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(u){const t=this.getExtensionElement(u);if(t){const d=this.m.get(t);if(d)return this.rb(t),(0,m.$oh)(()=>this.f.getTreeItem(t)).then(a=>{if(a){const f=this.ib(t,a,d.parent);return this.pb(t,f,d,d.parent),d.dispose(),f}return null})}return Promise.resolve(null)}db(u,t,d){const a=this.ib(u,t,d);if(t.id&&this.j.has(a.item.handle))throw new Error((0,P.localize)(0,null,t.id));return this.ob(u,a),this.qb(a,d),a}eb(u){return E.$HM.isMarkdownString(u)?l.MarkdownString.from(u):u}fb(u,t){return t?{...this.L.toInternal(t,u),originalId:t.command}:void 0}gb(u){if(u.checkboxState===void 0)return;let t,d,a;return typeof u.checkboxState=="number"?t=u.checkboxState:(t=u.checkboxState.state,d=u.checkboxState.tooltip,a=u.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:d,accessibilityInformation:a}}hb(u){if(!E.$6M.isTreeItem(u,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(u,t,d){this.hb(t);const a=this.B(new A.$Tc),f=this.kb(u,t,d),w=this.lb(t);return{item:{handle:f,parentHandle:d?d.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(a,t.command),contextValue:t.contextValue,icon:w,iconDark:this.mb(t)||w,themeIcon:this.jb(t),collapsibleState:(0,T.$fg)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:d,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(u){return u.iconPath instanceof E.$cN?u.iconPath:void 0}kb(u,{id:t,label:d,resourceUri:a},f,w){if(t)return`${i.b}/${t}`;const p=o(d,this.N),v=f?f.item.handle:i.a;let y=p?p.label:a?(0,O.$7g)(a):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const h=this.m.has(u)?this.m.get(u).item.handle:void 0,D=this.X(f)||[];let k,C=0;do{if(k=`${v}/${C}:${y}`,w||!this.j.has(k)||h===k)break;C++}while(C<=D.length);return k}lb(u){if(u.iconPath&&!(u.iconPath instanceof E.$cN))return typeof u.iconPath=="string"||M.URI.isUri(u.iconPath)?this.nb(u.iconPath):this.nb(u.iconPath.light)}mb(u){if(u.iconPath&&!(u.iconPath instanceof E.$cN)&&u.iconPath.dark)return this.nb(u.iconPath.dark)}nb(u){return M.URI.isUri(u)?u:M.URI.file(u)}ob(u,t){this.j.set(t.item.handle,u),this.m.set(u,t)}pb(u,t,d,a){this.j.delete(t.item.handle),this.m.delete(u),t.item.handle!==d.item.handle&&this.j.delete(d.item.handle),this.ob(u,t);const f=this.X(a)||[],w=f.filter(p=>p.item.handle===d.item.handle)[0];w&&f.splice(f.indexOf(w),1,t)}qb(u,t){t?(t.children||(t.children=[]),t.children.push(u)):(this.h||(this.h=[]),this.h.push(u))}rb(u){if(u){const t=this.m.get(u);if(t){if(t.children)for(const d of t.children){const a=this.j.get(d.item.handle);a&&this.sb(a)}t.children=void 0}}else this.tb()}sb(u){const t=this.m.get(u);if(t){if(t.children)for(const d of t.children){const a=this.j.get(d.item.handle);a&&this.sb(a)}this.m.delete(u),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(u=>u.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Se[292],Ie([1,0,5,6,2,33,8,64,4,7]),function(he,e,P,O,M,N,A,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=void 0;class T extends O.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(g,r,s,o){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new P.$de),this.onDidDispose=this.#d.event,this.#h=this.B(new P.$de),this.onDidChangeViewState=this.#h.event,this.#e=g,this.#t=r,this.#n=s,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(g){this.c(),this.#r!==g&&(this.#r=g,this.#t.$setTitle(this.#e,g))}get iconPath(){return this.c(),this.#a}set iconPath(g){this.c(),this.#a!==g&&(this.#a=g,this.#t.$setIconPath(this.#e,M.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(g){this.#l||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(this.#u=g.active,this.#c=g.visible,this.#o=g.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(g,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof g>"u"?void 0:A.ViewColumn.from(g),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class S extends O.$Uc{static c(){return(0,N.$Sg)()}constructor(g,r,s){super(),this.j=r,this.m=s,this.g=new Map,this.h=new Map,this.f=g.getProxy(m.$dM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(g=>g.dispose()),this.g.clear()}createWebviewPanel(g,r,s,o,n={}){const i=typeof o=="object"?o.viewColumn:o,c={viewColumn:A.ViewColumn.from(i),preserveFocus:typeof o=="object"&&!!o.preserveFocus},u=(0,$.$1lc)(g),t=S.c();this.f.$createWebviewPanel((0,$.$3lc)(g),t,r,{title:s,panelOptions:l(n),webviewOptions:(0,$.$4lc)(g,this.m,n),serializeBuffersForPostMessage:u},c);const d=this.j.createNewWebview(t,n,g);return this.createNewWebviewPanel(t,r,s,i,n,d,!0)}$onDidChangeWebviewPanelViewStates(g){const r=Object.keys(g);r.sort((s,o)=>{const n=g[s],i=g[o];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const s of r){const o=this.getWebviewPanel(s);if(!o)continue;const n=g[s];o._updateViewState({active:n.active,visible:n.visible,viewColumn:A.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(g){this.getWebviewPanel(g)?.dispose(),this.g.delete(g),this.j.deleteWebview(g)}registerWebviewPanelSerializer(g,r,s){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:s,extension:g}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,$.$1lc)(g)}),new E.$fM(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(g,r,s,o){const n=this.h.get(r);if(!n)throw new Error(`No serializer found for '${r}'`);const{serializer:i,extension:c}=n,u=this.j.createNewWebview(g,s.webviewOptions,c),t=this.createNewWebviewPanel(g,r,s.title,o,s.panelOptions,u,s.active);await i.deserializeWebviewPanel(t,s.state)}createNewWebviewPanel(g,r,s,o,n,i,c){const u=new T(g,this.f,i,{viewType:r,title:s,viewColumn:o,panelOptions:n,active:c});return this.g.set(g,u),u}getWebviewPanel(g){return this.g.get(g)}}e.$5lc=S;function l(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}}),define(Se[293],Ie([1,0,5,6,64,8,4,7]),function(he,e,P,O,M,N,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ync=void 0;class m extends O.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(S,l,b,g,r,s){super(),this.#s=!1,this.#u=this.B(new P.$de),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new P.$de),this.onDidDispose=this.#l.event,this.#i=b,this.#a=g,this.#e=S,this.#t=l,this.#n=r,this.#r=s}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(S){this.a(),this.#a!==S&&(this.#a=S,this.#t.$setWebviewViewTitle(this.#e,S))}get description(){return this.a(),this.#o}set description(S){this.a(),this.#o!==S&&(this.#o=S,this.#t.$setWebviewViewDescription(this.#e,S))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(S){S===this.#r||this.#s||(this.#r=S,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(S){this.a(),!(S?.value===this.#c?.value&&S?.tooltip===this.#c?.tooltip)&&(this.#c=N.ViewBadge.from(S),this.#t.$setWebviewViewBadge(this.#e,S))}show(S){this.a(),this.#t.$show(this.#e,!!S)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(S,l){this.d=l,this.b=new Map,this.c=new Map,this.a=S.getProxy(A.$dM.MainThreadWebviewViews)}registerWebviewViewProvider(S,l,b,g){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:b,extension:S}),this.a.$registerWebviewViewProvider((0,M.$3lc)(S),l,{retainContextWhenHidden:g?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,M.$1lc)(S)}),new $.$fM(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(S,l,b,g,r){const s=this.b.get(l);if(!s)throw new Error(`No view provider found for '${l}'`);const{provider:o,extension:n}=s,i=this.d.createNewWebview(S,{},n),c=new m(S,this.a,l,b,i,!0);this.c.set(S,c),await o.resolveWebviewView(c,{state:g},r)}async $onDidChangeWebviewViewVisibility(S,l){this.e(S)._setVisible(l)}async $disposeWebviewView(S){const l=this.e(S);this.c.delete(S),l.dispose(),this.d.deleteWebview(S)}e(S){const l=this.c.get(S);if(!l)throw new Error("No webview found");return l}}e.$ync=E}),define(Se[294],Ie([1,0,5,29,31,3]),function(he,e,P,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zL=e.$yL=e.OutputChannelUpdateMode=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=void 0,e.$lL="text/x-code-output",e.$mL="output",e.$nL="Log",e.$oL="text/x-code-log-output",e.$pL="log",e.$qL="workbench.panel.output",e.$rL=new M.$Nj("inOutput",!1),e.$sL=new M.$Nj("activeLogOutput",!1),e.$tL=new M.$Nj("activeLogOutput.levelSettable",!1),e.$uL=new M.$Nj("activeLogOutput.level",""),e.$vL=new M.$Nj("activeLogOutput.levelIsDefault",!1),e.$wL=new M.$Nj("outputView.scrollLock",!1),e.$xL=(0,N.$wi)("outputService");var A;(function(m){m[m.Append=1]="Append",m[m.Replace=2]="Replace",m[m.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$yL={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new P.$de,this.onDidRegisterChannel=this.b.event,this.c=new P.$de,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(T=>E.push(T)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}O.$co.add(e.$yL.OutputChannels,new $),e.$zL=new M.$Nj("activeOutputChannel","")}),define(Se[118],Ie([1,0,4,3,17,20,12,294,65,27,46,147,21,15,38,5,6]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$mc=e.$0mc=void 0;class o extends A.$9j{get disposed(){return this.n}constructor(u,t,d,a,f){super(),this.id=u,this.name=t,this.r=d,this.s=a,this.extension=f,this.m=0,this.n=!1,this.visible=!1,this.setLevel(d.getLevel()),this.B(d.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(u){this.append(u+`
`)}append(u){this.info(u)}clear(){const u=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,u)}replace(u){const t=this.m;this.info(u),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(u,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof u=="boolean"?u:t))}hide(){this.s.$close(this.id)}g(u,t){this.m+=l.$Fe.fromString(t).byteLength,(0,A.log)(this.r,u,t),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends o{appendLine(u){this.append(u)}}let i=class{constructor(u,t,d,a,f,w){this.i=t,this.j=d,this.k=a,this.l=f,this.m=w,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=u.getProxy(P.$dM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,S.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(u){this.h=u;for(const[t,d]of this.g)d.visible=t===this.h}createOutputChannel(u,t,d){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");const a=typeof t=="object"&&t.log,f=(0,b.$9f)(t)?t:void 0;if((0,b.$9f)(f)&&!f.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const p=this.i.environment.extensionLogLevel?.find(([y])=>N.$Rm.equals(d.identifier,y))?.[1];p&&(w=(0,A.$hk)(p));const v=a?this.o(u,w,d):this.n(u,f,d);return v.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),a?this.r(u,w??this.m.getLevel(),v):this.q(u,v)}async n(u,t,d){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,f=this.k.extUri.joinPath(a,`${this.f++}-${u.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.l.createLogger(f,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),p=await this.a.$register(u,f,t,d.identifier.value);return new o(p,u,w,this.a,d)}async o(u,t,d){const a=await this.p(d),f=u.replace(/[\\/:\*\?"<>\|]/g,""),w=this.k.extUri.joinPath(a,`${f}.log`),p=`${d.identifier.value}.${f}`,v=this.l.createLogger(w,{id:p,name:u,logLevel:t,extensionId:d.identifier.value});return new n(p,u,v,this.a,d)}p(u){let t=this.d.get(u.identifier.value);if(!t){const d=this.k.extUri.joinPath(this.i.logsLocation,u.identifier.value);this.d.set(u.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(d)}catch(a){if((0,g.$gl)(a)!==g.FileSystemProviderErrorCode.FileExists)throw a}return d})())}return t}q(u,t){let d=!1;const a=()=>{if(d)throw new Error("Channel has been closed")};return{get name(){return u},append(f){a(),t.then(w=>w.append(f))},appendLine(f){a(),t.then(w=>w.appendLine(f))},clear(){a(),t.then(f=>f.clear())},replace(f){a(),t.then(w=>w.replace(f))},show(f,w){a(),t.then(p=>p.show(f,w))},hide(){a(),t.then(f=>f.hide())},dispose(){d=!0,t.then(f=>f.dispose())}}}r(u,t,d){const a=new s.$Tc,f=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},w=a.add(new r.$de);function p(v){t=v,w.fire(v)}return d.then(v=>{a.add(v),v.logLevel!==t&&p(v.logLevel),a.add(v.onDidChangeLogLevel(y=>p(y)))}),{...this.q(u,d),get logLevel(){return t},onDidChangeLogLevel:w.event,trace(v,...y){f(),d.then(h=>h.trace(v,...y))},debug(v,...y){f(),d.then(h=>h.debug(v,...y))},info(v,...y){f(),d.then(h=>h.info(v,...y))},warn(v,...y){f(),d.then(h=>h.warn(v,...y))},error(v,...y){f(),d.then(h=>h.error(v,...y))},dispose(){a.dispose()}}}};e.$0mc=i,e.$0mc=i=Ke([We(0,M.$EO),We(1,E.$UO),We(2,m.$Wlc),We(3,T.$zlc),We(4,A.$4j),We(5,A.$3j)],i),e.$$mc=(0,O.$wi)("IExtHostOutputService")}),define(Se[119],Ie([1,0,3,11]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=void 0,e.$gn=(0,P.$wi)("remoteAgentService"),e.$hn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(M){let N=1/0;for(let $=0;$<this.maxSampleCount;$++){const m=await M.getRoundTripTime();if(m===void 0)return;N=Math.min(N,m/2),await(0,O.$xh)(this.sampleDelay)}this.average.push(N),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(N):A=this.initial.reduce(($,m)=>$+m,0)/this.initial.length,this.lastMeasurement={initial:A,current:N,average:this.average.reduce(($,m)=>$+m,0)/this.average.length,high:typeof A>"u"?!1:N>this.highLatencyMaxThreshold||N>this.highLatencyMinThreshold&&N>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Se[295],Ie([1,0,184,51,29,45,50,6,5,119,22,25,11]),function(he,e,P,O,M,N,A,$,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ygb=e.$xgb=e.$wgb=e.$vgb=e.$ugb=e.$tgb=e.$sgb=void 0,e.$sgb=Object.freeze({id:"application",order:100,title:(0,P.localize)(0,null),type:"object"}),e.$tgb=Object.freeze({id:"workbench",order:7,title:(0,P.localize)(1,null),type:"object"}),e.$ugb=Object.freeze({id:"security",scope:1,title:(0,P.localize)(2,null),type:"object",order:7}),e.$vgb=Object.freeze({id:"problems",title:(0,P.localize)(3,null),type:"object",order:101}),e.$wgb={ConfigurationMigration:"base.contributions.configuration.migration"};class b{constructor(){this.migrations=[],this.a=new m.$de,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const g=new b;M.$co.add(e.$wgb.ConfigurationMigration,g);let r=class extends $.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const u of c.added)await this.f(u,g.migrations)})),this.c(g.migrations),this.B(g.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(c=>this.g(c,n?.uri))])}async g(n,i){const c=this.a.inspect(n.key,{resource:i}),u=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,d]of u){const a=c[t];if(!a)continue;const f=[];if(a.value!==void 0){const w=await this.h(n,t,a.value,i,void 0);for(const p of w??[])f.push([p,[]])}for(const{identifiers:w,value:p}of a.overrides??[])if(p!==void 0){const v=await this.h(n,t,p,i,w);for(const y of v??[])f.push([y,w])}f.length&&await Promise.allSettled(f.map(async([[w,p],v])=>this.a.updateValue(w,p.value,{resource:i,overrideIdentifiers:v},d)))}}async h(n,i,c,u,t){const d=f=>{const p=this.a.inspect(f,{resource:u})[i];if(p)return t?p.overrides?.find(({identifiers:v})=>(0,S.$7n)(v,t))?.value:p.value},a=await n.migrateFn(c,d);return Array.isArray(a)?a:[[n.key,a]]}};e.$xgb=r,e.$xgb=r=Ke([We(0,A.$3i),We(1,N.$Fi)],r);let s=class extends $.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new l.$Th,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!T.$i&&(await this.b.getEnvironment())?.os!==1)return;M.$co.as(O.$ho.Configuration).registerConfiguration({...e.$ugb,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,P.localize)(4,null)},default:[],markdownDescription:(0,P.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,P.localize)(6,null),scope:2}}})}};e.$ygb=s,e.$ygb=s=Ke([We(0,E.$gn)],s)}),define(Se[296],Ie([1,0,37,16,19,23,193,295,51,3,29]),function(he,e,P,O,M,N,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Agb=e.$zgb=void 0,e.$Bgb=r,e.$Cgb=s,e.$zgb=(0,E.$wi)("editorResolverService"),e.$Agb="workbench.editorAssociations";const S=T.$co.as(m.$ho.Configuration),l={...$.$tgb,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};S.registerConfiguration(l);var b;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(b||(e.RegisteredEditorPriority=b={}));var g;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(g||(e.ResolvedStatus=g={}));function r(o){switch(o){case b.exclusive:return 5;case b.default:return 4;case b.builtin:return 3;case b.option:default:return 1}}function s(o,n){if(new Set([O.Schemas.extension,O.Schemas.webviewPanel,O.Schemas.vscodeWorkspaceTrust,O.Schemas.vscodeSettings]).has(n.scheme))return!1;const u=typeof o=="string"&&o.indexOf(M.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,N.$7g)(n);return P.$pk(typeof o=="string"?o.toLowerCase():o,u.toLowerCase())}}),define(Se[297],Ie([1,0,48,16,19,22,23,2,3,214,45,236,119]),function(he,e,P,O,M,N,A,$,m,E,T,S,l){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$SL=e.$RL=void 0,e.$RL=(0,m.$wi)("pathService");let g=b=class{constructor(s,o,n,i){this.d=s,this.e=o,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||N.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??s})()}hasValidBasename(s,o,n){return typeof o=="string"||typeof o>"u"?this.a.then(i=>this.h(s,i,o)):this.h(s,o,n)}h(s,o,n){return s.scheme===O.Schemas.file||s.scheme===O.Schemas.vscodeRemote?(0,P.$tg)(n??(0,A.$7g)(s),o===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(s,o){if(s.remoteAuthority)return O.Schemas.vscodeRemote;const n=(0,E.$OL)(o.getWorkspace());if(n)return n;const i=o.getWorkspace().folders[0];if(i)return i.uri.scheme;const c=o.getWorkspace().configuration;return c?c.scheme:O.Schemas.file}userHome(s){return s?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(s=>s===1?M.$fc:M.$gc)}async fileURI(s){let o="";if(await this.a===1&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const i=s.indexOf("/",2);i===-1?(o=s.substring(2),s="/"):(o=s.substring(2,i),s=s.substring(i)||"/")}return $.URI.from({scheme:O.Schemas.file,authority:o,path:s,query:"",fragment:""})}};e.$SL=g,e.$SL=g=b=Ke([We(1,l.$gn),We(2,S.$AL),We(3,T.$Fi)],g)}),define(Se[120],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$kK=e.$jK=void 0;class P{constructor(A,$){this.line=A,this.character=$}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,$){return new P(0,0)}with(A){return new P(0,0)}}e.$jK=P;class O{constructor(A,$,m,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new P(A,$),this.end=new P(m,E)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new O(0,0,0,0)}with(A){return new O(0,0,0,0)}}e.$kK=O;var M;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(M||(e.TextSearchCompleteMessageType=M={}))}),define(Se[47],Ie([1,0,18,37,25,48,13,3,19,14,120,11]),function(he,e,P,O,M,N,A,$,m,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JK=e.$HK=e.$AK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$xK=e.$wK=e.$vK=e.$uK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.TextSearchCompleteMessageType=void 0,e.$rK=o,e.$sK=n,e.$tK=i,e.$yK=v,e.$zK=y,e.$BK=k,e.$CK=C,e.$DK=I,e.$EK=W,e.$FK=V,e.$GK=q,e.$IK=B,e.$KK=ce,e.$LK=ve,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return T.TextSearchCompleteMessageType}}),e.$lK="workbench.view.search",e.$mK="workbench.panel.search",e.$nK="workbench.view.search",e.$oK="search-result",e.$pK="search.exclude";const l="\u27EA ",b=" characters skipped \u27EB",g=(l.length+b.length+5)*2;e.$qK=(0,$.$wi)("searchService");var r;(function(fe){fe[fe.file=0]="file",fe[fe.text=1]="text",fe[fe.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var s;(function(fe){fe[fe.File=1]="File",fe[fe.Text=2]="Text",fe[fe.aiText=3]="aiText"})(s||(e.QueryType=s={}));function o(fe){return!!fe.preview}function n(fe){return!!fe.resource}function i(fe){return!!fe.message}var c;(function(fe){fe[fe.Normal=0]="Normal",fe[fe.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class u{constructor(pe){this.resource=pe,this.results=[]}}e.$uK=u;class t{constructor(pe,Ne,ae,Re){this.ranges=Ne,this.webviewIndex=Re;const ne=Array.isArray(Ne)?Ne:[Ne];if(ae&&ae.matchLines===1&&d(ne)){pe=(0,A.$2f)(pe,ae.matchLines);let z="",x=0,be=0;const Te=Math.floor(ae.charsPerLine/5),De=[];for(const we of ne){const ge=Math.max(we.startColumn-Te,0),Q=we.startColumn+ae.charsPerLine;if(ge>be+Te+g){const Y=l+(ge-be)+b;z+=Y+pe.slice(ge,Q),x+=ge-(be+Y.length)}else z+=pe.slice(be,Q);De.push(new f(0,we.startColumn-x,we.endColumn-x)),be=Q}this.preview={text:z,matches:Array.isArray(this.ranges)?De:De[0]}}else{const z=Array.isArray(Ne)?Ne[0].startLineNumber:Ne.startLineNumber;this.preview={text:pe,matches:(0,P.$1b)(Ne,x=>new a(x.startLineNumber-z,x.startColumn,x.endLineNumber-z,x.endColumn))}}}}e.$vK=t;function d(fe){const pe=fe[0].startLineNumber;for(const Ne of fe)if(Ne.startLineNumber!==pe||Ne.endLineNumber!==pe)return!1;return!0}class a{constructor(pe,Ne,ae,Re){this.startLineNumber=pe,this.startColumn=Ne,this.endLineNumber=ae,this.endColumn=Re}}e.$wK=a;class f extends a{constructor(pe,Ne,ae){super(pe,Ne,pe,ae)}}e.$xK=f;var w;(function(fe){fe.List="list",fe.Tree="tree"})(w||(e.ViewMode=w={}));var p;(function(fe){fe.Default="default",fe.FileNames="fileNames",fe.Type="type",fe.Modified="modified",fe.CountDescending="countDescending",fe.CountAscending="countAscending"})(p||(e.SearchSortOrder=p={}));function v(fe,pe=!0){const Ne=fe&&fe.files&&fe.files.exclude,ae=pe&&fe&&fe.search&&fe.search.exclude;if(!Ne&&!ae)return;if(!Ne||!ae)return Ne||ae;let Re=Object.create(null);return Re=M.$6n(Re,M.$3n(Ne)),Re=M.$6n(Re,M.$3n(ae),!0),Re}function y(fe,pe){return fe.excludePattern&&O.$pk(fe.excludePattern,pe)?!1:fe.includePattern||fe.usingSearchPaths?fe.includePattern&&O.$pk(fe.includePattern,pe)?!0:fe.usingSearchPaths?!!fe.folderQueries&&fe.folderQueries.some(Ne=>{const ae=Ne.folder.fsPath;if(N.$vg(pe,ae)){const Re=m.$lc(ae,pe);return!Ne.includePattern||!!O.$pk(Ne.includePattern,Re)}else return!1}):!1:!0}var h;(function(fe){fe[fe.unknownEncoding=1]="unknownEncoding",fe[fe.regexParseError=2]="regexParseError",fe[fe.globParseError=3]="globParseError",fe[fe.invalidLiteral=4]="invalidLiteral",fe[fe.rgProcessError=5]="rgProcessError",fe[fe.other=6]="other",fe[fe.canceled=7]="canceled"})(h||(e.SearchErrorCode=h={}));class D extends Error{constructor(pe,Ne){super(pe),this.code=Ne}}e.$AK=D;function k(fe){const pe=fe.message;if((0,E.$4)(fe))return new D(pe,h.canceled);try{const Ne=JSON.parse(pe);return new D(Ne.message,Ne.code)}catch{return new D(pe,h.other)}}function C(fe){const pe={message:fe.message,code:fe.code};return new Error(JSON.stringify(pe))}function I(fe){return fe.type==="error"?!0:fe.type==="success"}function W(fe){return fe.type==="success"}function V(fe){return!!fe.path}function q(fe,pe,Ne=!0){const ae=fe.searchPath?fe.searchPath:fe.relativePath;return Ne?(0,A.$Yf)(ae,pe):O.$pk(pe,ae)}class R{constructor(pe){this.path=pe,this.results=[]}addMatch(pe){this.results.push(pe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$HK=R;function B(fe,pe){const Ne={...fe||{},...pe||{}};return Object.keys(Ne).filter(ae=>{const Re=Ne[ae];return typeof Re=="boolean"&&Re})}class K{constructor(pe,Ne){this.c=null,this.a={...pe.excludePattern||{},...Ne.excludePattern||{}},this.b=O.$qk(this.a);let ae=pe.includePattern;Ne.includePattern&&(ae?ae={...ae,...Ne.includePattern}:ae=Ne.includePattern),ae&&(this.c=O.$qk(ae))}matchesExcludesSync(pe,Ne,ae){return!!(this.b&&this.b(pe,Ne,ae))}includedInQuerySync(pe,Ne,ae){return!(this.b&&this.b(pe,Ne,ae)||this.c&&!this.c(pe,Ne,ae))}includedInQuery(pe,Ne,ae){const Re=this.b(pe,Ne,ae),ne=()=>this.c?!!this.c(pe,Ne,ae):!0;return(0,S.$ih)(Re)?Re.then(z=>z?!1:ne()):ne()}hasSiblingExcludeClauses(){return ie(this.a)}}e.$JK=K;function ie(fe){for(const pe in fe)if(typeof fe[pe]!="boolean")return!0;return!1}function ce(fe){if(!fe)return;let pe;return Ne=>(pe||(pe=(fe()||Promise.resolve([])).then(ae=>ae?ke(ae):{})),pe.then(ae=>!!ae[Ne]))}function ve(fe){if(!fe)return;let pe;return Ne=>{if(!pe){const ae=fe();pe=ae?ke(ae):{}}return!!pe[Ne]}}function ke(fe){const pe={};for(const Ne of fe)pe[Ne]=!0;return pe}}),define(Se[39],Ie([1,0,18,11,24,5,6,54,16,129,23,13,2,183,3,12,202,45,46,27,17,8,7,61,47,4,49]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g,r,s,o,n,i,c,u,t,d,a,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rlc=e.$Qlc=void 0;function p(W,V,q){return new T.$Yg(R=>D(R,q)).isEqual(W,V)}function v(W,V,q){return p(W.uri,V.uri,q)?0:(0,S.$qf)(W.uri.toString(),V.uri.toString())}function y(W,V,q){return W.index!==V.index?W.index<V.index?-1:1:p(W.uri,V.uri,q)?(0,S.$qf)(W.name,V.name):(0,S.$qf)(W.uri.toString(),V.uri.toString())}function h(W,V,q,R){const B=W.slice(0).sort((ie,ce)=>q(ie,ce,R)),K=V.slice(0).sort((ie,ce)=>q(ie,ce,R));return(0,P.$Eb)(B,K,(ie,ce)=>q(ie,ce,R))}function D(W,V){const q=V.getCapabilities(W.scheme);return!(q&&q&1024)}class k extends o.$Pi{static toExtHostWorkspace(V,q,R,B){if(!V)return{workspace:null,added:[],removed:[]};const{id:K,name:ie,folders:ce,configuration:ve,transient:ke,isUntitled:fe}=V,pe=[],Ne=q;q?ce.forEach((z,x)=>{const be=l.URI.revive(z.uri),Te=k.o(R||q,be,B);Te?(Te.name=z.name,Te.index=z.index,pe.push(Te)):pe.push({uri:be,name:z.name,index:x})}):pe.push(...ce.map(({uri:z,name:x,index:be})=>({uri:l.URI.revive(z),name:x,index:be}))),pe.sort((z,x)=>z.index<x.index?-1:1);const ae=new k(K,ie,pe,!!ke,ve?l.URI.revive(ve):null,!!fe,z=>D(z,B)),{added:Re,removed:ne}=h(Ne?Ne.workspaceFolders:[],ae.workspaceFolders,v,B);return{workspace:ae,added:Re,removed:ne}}static o(V,q,R){for(let B=0;B<V.folders.length;B++){const K=V.workspaceFolders[B];if(p(K.uri,q,R))return K}}constructor(V,q,R,B,K,ie,ce){super(V,R.map(ve=>new o.$Qi(ve)),B,K,ce),this.t=q,this.u=ie,this.q=[],this.s=$.$Ci.forUris(ce),R.forEach(ve=>{this.q.push(ve),this.s.set(ve.uri,ve)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,q){return q&&this.s.get(V)&&(V=(0,T.$9g)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let C=class{constructor(V,q,R,B,K){this.c=new N.$de,this.onDidChangeWorkspace=this.c.event,this.g=new N.$de,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new N.$fe,this.C=new Map,this.h=B,this.s=R,this.t=K,this.j=new E.$Dm,this.k=new O.$vh,this.o=V.getProxy(f.$dM.MainThreadWorkspace),this.q=V.getProxy(f.$dM.MainThreadMessageService);const ie=q.workspace;this.l=ie?new k(ie.id,ie.name,[],!!ie.transient,ie.configuration?l.URI.revive(ie.configuration):null,!!ie.isUntitled,ce=>D(ce,R)):void 0}$initializeWorkspace(V,q){this.v=q,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:m.Schemas.untitled,path:(0,T.$7g)((0,T.$9g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,q,R,...B){const K=[];if(Array.isArray(B)&&B.forEach(fe=>{l.URI.isUri(fe.uri)&&!K.some(pe=>p(pe.uri,fe.uri,this.s))&&K.push({uri:fe.uri,name:fe.name||(0,T.$6g)(fe.uri)})}),this.n||[q,R].some(fe=>typeof fe!="number"||fe<0)||R===0&&K.length===0)return!1;const ie=this.x?this.x.workspaceFolders:[];if(q+R>ie.length)return!1;const ce=ie.slice(0);ce.splice(q,R,...K.map(fe=>({uri:fe.uri,name:fe.name||(0,T.$6g)(fe.uri),index:void 0})));for(let fe=0;fe<ce.length;fe++){const pe=ce[fe];if(ce.some((Ne,ae)=>ae!==fe&&p(pe.uri,Ne.uri,this.s)))return!1}ce.forEach((fe,pe)=>fe.index=pe);const{added:ve,removed:ke}=h(ie,ce,y,this.s);if(ve.length===0&&ke.length===0)return!1;if(this.o){const fe=V.displayName||V.name;this.o.$updateWorkspaceFolders(fe,q,R,K).then(void 0,pe=>{this.n=void 0;const Ne={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(s.Severity.Error,(0,b.localize)(0,null,fe,pe.toString()),Ne,[])})}return this.y(ce),!0}getWorkspaceFolder(V,q){if(this.x)return this.x.getWorkspaceFolder(V,q)}async getWorkspaceFolder2(V,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,q)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,q){let R,B="";if(typeof V=="string"?(R=l.URI.file(V),B=V):typeof V<"u"&&(R=V,B=V.fsPath),!R)return B;const K=this.getWorkspaceFolder(R,!0);if(!K)return B;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let ie=(0,T.$_g)(K.uri,R);return q&&K.name&&(ie=`${K.name}/${ie}`),ie}y(V){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:q,added:R,removed:B}=k.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:R,removed:B}))}findFiles(V,q,R,B,K=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let ie="",ce=!0;return q===null?ce=!1:q!==void 0&&(typeof q=="string"?ie=q:ie=q.pattern),this.z(V,void 0,{exclude:ie,maxResults:R,useDefaultExcludes:ce,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},K)}findFiles2(V,q={},R,B=M.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${R.value}, entryPoint: findFiles2`),this.z(void 0,V,q,B)}async z(V,q,R,B=M.CancellationToken.None){if(B&&B.isCancellationRequested)return Promise.resolve([]);const K=typeof R.exclude=="string"?R.exclude:R.exclude?R.exclude.pattern:void 0,ie={ignoreSymlinks:typeof R.followSymlinks=="boolean"?!R.followSymlinks:void 0,disregardIgnoreFiles:typeof R.useIgnoreFiles=="boolean"?!R.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof R.useGlobalIgnoreFiles=="boolean"?!R.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof R.useParentIgnoreFiles=="boolean"?!R.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof R.useDefaultExcludes=="boolean"?!R.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof R.useDefaultSearchExcludes=="boolean"?!R.useDefaultSearchExcludes:!1,maxResults:R.maxResults,excludePattern:K,shouldGlobSearch:typeof R.fuzzy=="boolean"?!R.fuzzy:!0,_reason:"startFileSearch"};let ce;if(V){const{includePattern:ve,folder:ke}=I(u.GlobPattern.from(V));ce=ke,ie.includePattern=ve}else{const{includePattern:ve,folder:ke}=I(u.GlobPattern.from(q));ce=ke,ie.filePattern=ve}return this.o.$startFileSearch(ce??null,ie,B).then(ve=>Array.isArray(ve)?ve.map(ke=>l.URI.revive(ke)):[])}async findTextInFiles(V,q,R,B,K=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const ie=this.j.getNext(),ce=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:ve,folder:ke}=I(u.GlobPattern.from(q.include)),fe=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,pe={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:ce,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:ve,excludePattern:fe},Ne=!1;if(this.u[ie]=ae=>{if(Ne)return;const Re=l.URI.revive(ae.resource);ae.results.forEach(ne=>{const z=(0,w.$6h)(ne);(0,a.$rK)(z)?R({uri:Re,preview:{text:z.preview.text,matches:(0,P.$1b)(z.preview.matches,x=>new t.$hM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))},ranges:(0,P.$1b)(z.ranges,x=>new t.$hM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))}):R({uri:Re,text:z.text,lineNumber:z.lineNumber})})},K.isCancellationRequested)return{};try{const ae=await this.o.$startTextSearch(V,ke??null,pe,ie,K);return delete this.u[ie],ae||{}}catch(ae){throw delete this.u[ie],ae}}$handleTextSearchResult(V,q){this.u[q]?.(V)}async save(V){const q=await this.o.$save(V,{saveAs:!1});return l.URI.revive(q)}async saveAs(V){const q=await this.o.$save(V,{saveAs:!0});return l.URI.revive(q)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,q){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,q);const R=this.t.transformOutgoingScheme(V),B=this.A++;return this.o.$registerEditSessionIdentityProvider(B,R),(0,A.$Sc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(V,q){this.h.info("Getting edit session identifier for workspaceFolder",V);const R=await this.resolveWorkspaceFolder(l.URI.revive(V));if(!R){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",R);const B=this.w.get(R.uri.scheme);if(this.h.info(`Provider for scheme ${R.uri.scheme} is defined: `,!!B),!B)return;const K=await B.provideEditSessionIdentity(R,q);if(this.h.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(V,q,R,B){this.h.info("Getting edit session identifier for workspaceFolder",V);const K=await this.resolveWorkspaceFolder(l.URI.revive(V));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const ie=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!ie),!ie)return;const ce=await ie.provideEditSessionIdentityMatch?.(q,R,B);if(this.h.info("Provider returned edit session identifier match result: ",ce),!!ce)return ce}getOnWillCreateEditSessionIdentityEvent(V){return(q,R,B)=>{const K=function(ce){q.call(R,ce)};return K.extension=V,this.B.event(K,void 0,B)}}async $onWillCreateEditSessionIdentity(V,q,R){const B=await this.resolveWorkspaceFolder(l.URI.revive(V));if(B===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:B},q,async(K,ie)=>{const ce=Date.now();await Promise.resolve(K),Date.now()-ce>R&&this.h.warn("SLOW edit session create-participant",ie.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(V,q){if(this.C.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.C.set(V,q);const R=this.t.transformOutgoingScheme(V),B=this.A++;return this.o.$registerCanonicalUriProvider(B,R),(0,A.$Sc)(()=>{this.C.delete(V),this.o.$unregisterCanonicalUriProvider(B)})}async provideCanonicalUri(V,q,R){const B=this.C.get(V.scheme);if(!B)return;const K=await B.provideCanonicalUri?.(l.URI.revive(V),q,R);if(K)return K}async $provideCanonicalUri(V,q,R){return this.provideCanonicalUri(l.URI.revive(V),{targetScheme:q},R)}};e.$Qlc=C,e.$Qlc=C=Ke([We(0,c.$EO),We(1,i.$UO),We(2,n.$zlc),We(3,r.$3j),We(4,d.$Olc)],C),e.$Rlc=(0,g.$wi)("IExtHostWorkspace");function I(W){let V,q;return W&&(typeof W=="string"?V=W:(V=W.pattern,q=l.URI.revive(W.baseUri))),{includePattern:V,folder:q}}}),define(Se[40],Ie([1,0,25,5,39,4,7,203,51,15,11,3,17,12,2]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ulc=e.$Tlc=e.$Slc=void 0;function r(d,a){if(a){const f=a.split(".");let w=d;for(let p=0;w&&p<f.length;p++)w=w[f[p]];return w}}function s(d){return d instanceof g.URI}function o(d){return d&&d.uri instanceof g.URI&&d.languageId&&typeof d.languageId=="string"}function n(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function i(d){return d&&d.uri instanceof g.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function c(d){if(s(d))return{resource:d};if(o(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(n(d))return{overrideIdentifier:d.languageId};if(i(d))return{resource:d.uri};if(d===null)return{resource:null}}let u=class{constructor(a,f,w){this.a=a.getProxy(N.$dM.MainThreadConfiguration),this.c=f,this.b=w,this.d=new T.$vh,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new t(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,f){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(a,f))}};e.$Slc=u,e.$Slc=u=Ke([We(0,l.$EO),We(1,M.$Rlc),We(2,b.$3j)],u);class t{constructor(a,f,w,p){this.a=new O.$de,this.b=a,this.f=p,this.c=f,this.e=$.$Ao.parse(w,p),this.d=this.k(w.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,f){const w={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Ao.parse(a,this.f),this.d=this.k(a.configurationScopes),this.a.fire(this.j(f,w))}getConfiguration(a,f,w){const p=c(f)||{},v=this.g(a?r(this.e.getValue(void 0,p,this.c.workspace),a):this.e.getValue(void 0,p,this.c.workspace));a&&this.h(a,p,w?.identifier);function y(D){if(D==null)return null;if(typeof D=="boolean")return D?2:5;switch(D){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(D){return typeof r(v,D)<"u"},get:(D,k)=>{this.h(a?`${a}.${D}`:D,p,w?.identifier);let C=r(v,D);if(typeof C>"u")C=k;else{let I;const W=(V,q)=>{if((0,E.$$f)(V)){let R;const B=()=>{I=I||(0,P.$3n)(v),R=R||r(I,q)};return new Proxy(V,{get:(K,ie)=>{if(typeof ie=="string"&&ie.toLowerCase()==="tojson")return B(),()=>R;if(I)return R=R||r(I,q),R[ie];const ce=K[ie];return typeof ie=="string"?W(ce,`${q}.${ie}`):ce},set:(K,ie,ce)=>(B(),R&&(R[ie]=ce),!0),deleteProperty:(K,ie)=>(B(),R&&delete R[ie],!0),defineProperty:(K,ie,ce)=>(B(),R&&Object.defineProperty(R,ie,ce),!0)})}return Array.isArray(V)?(0,P.$3n)(V):V};C=W(C,D)}return C},update:(D,k,C,I)=>{D=a?`${a}.${D}`:D;const W=y(C);return k!==void 0?this.b.$updateConfigurationOption(W,D,k,p,I):this.b.$removeConfigurationOption(W,D,p,I)},inspect:D=>{D=a?`${a}.${D}`:D;const k=this.e.inspect(D,p,this.c.workspace);if(k)return{key:D,defaultValue:(0,P.$3n)(k.policy?.value??k.default?.value),globalValue:(0,P.$3n)(k.user?.value??k.application?.value),workspaceValue:(0,P.$3n)(k.workspace?.value),workspaceFolderValue:(0,P.$3n)(k.workspaceFolder?.value),defaultLanguageValue:(0,P.$3n)(k.default?.override),globalLanguageValue:(0,P.$3n)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,P.$3n)(k.workspace?.override),workspaceFolderLanguageValue:(0,P.$3n)(k.workspaceFolder?.override),languageIds:(0,P.$3n)(k.overrideIdentifiers)}}};return typeof v=="object"&&(0,P.$6n)(h,v,!1),Object.freeze(h)}g(a){const f=w=>(0,E.$$f)(w)?new Proxy(w,{get:(p,v)=>f(p[v]),set:(p,v,y)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(p,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(p,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return f(a)}h(a,f,w){const p=m.$ro.test(a)?4:this.d.get(a),v=w?`[${w.value}] `:"";if(p===4){typeof f?.resource>"u"&&this.f.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){f?.resource&&this.f.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,f){const w=new $.$Co(a,f,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(p,v)=>w.affectsConfiguration(p,c(v))})}k(a){return a.reduce((f,w)=>(f.set(w[0],w[1]),f),new Map)}}e.$Tlc=t,e.$Ulc=(0,S.$wi)("IExtHostConfiguration")}),define(Se[121],Ie([1,0,2,11,5,4,7,39,68,40,24,53,17,27,3,16,22,12,80,241,14]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g,r,s,o,n,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lnc=e.$knc=e.$jnc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var u;(function(W){function V(R){if(R!=null)return R}W.from=V;function q(R){if(R!=null)return R}W.to=q})(u||(u={}));var t;(function(W){function V(R){if(R!=null)return R}W.from=V;function q(R){if(R!=null)return R}W.to=q})(t||(t={}));var d;(function(W){function V(R){if(R!=null)return R}W.from=V;function q(R){if(R!=null)return R}W.to=q})(d||(d={}));var a;(function(W){function V(B){if(B){const K=B;return K&&!!K.process}else return!1}W.is=V;function q(B){if(B==null)return;const K={process:B.process,args:B.args};return B.options&&(K.options=d.from(B.options)),K}W.from=q;function R(B){if(B!=null)return new A.$2M(B.process,B.args,B.options)}W.to=R})(a||(a={}));var f;(function(W){function V(R){if(R!=null)return R}W.from=V;function q(R){if(R!=null)return R}W.to=q})(f||(f={}));var w;(function(W){function V(B){if(B){const K=B;return K&&(!!K.commandLine||!!K.command)}else return!1}W.is=V;function q(B){if(B==null)return;const K={};return B.commandLine!==void 0?K.commandLine=B.commandLine:(K.command=B.command,K.args=B.args),B.options&&(K.options=f.from(B.options)),K}W.from=q;function R(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new A.$3M(B.commandLine,B.options):new A.$3M(B.command,B.args?B.args:[],B.options)}W.to=R})(w||(w={}));var p;(function(W){function V(B){if(B){const K=B;return K&&K.customExecution==="customExecution"}else return!1}W.is=V;function q(B){return{customExecution:"customExecution"}}W.from=q;function R(B,K){return K.get(B)}W.to=R})(p||(e.CustomExecutionDTO=p={}));var v;(function(W){function V(q,R){let B;return q.scope!==void 0&&typeof q.scope!="number"?B=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===A.TaskScope.Workspace&&R&&R.workspaceFile?B=R.workspaceFile:B=i.$dI),{id:q._id,workspaceFolder:B}}W.from=V})(v||(e.TaskHandleDTO=v={}));var y;(function(W){function V(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}W.from=V})(y||(y={}));var h;(function(W){function V(B,K){if(B==null)return[];const ie=[];for(const ce of B){const ve=q(ce,K);ve&&ie.push(ve)}return ie}W.fromMany=V;function q(B,K){if(B==null)return;let ie;B.execution instanceof A.$2M?ie=a.from(B.execution):B.execution instanceof A.$3M?ie=w.from(B.execution):B.execution&&B.execution instanceof A.$4M&&(ie=p.from(B.execution));const ce=u.from(B.definition);let ve;return B.scope?typeof B.scope=="number"?ve=B.scope:ve=B.scope.uri:ve=A.TaskScope.Workspace,!ce||!ve?void 0:{_id:B._id,definition:ce,name:B.name,source:{extensionId:K.identifier.value,label:B.source,scope:ve},execution:ie,isBackground:B.isBackground,group:y.from(B.group),presentationOptions:t.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}W.from=q;async function R(B,K,ie){if(B==null)return;let ce;a.is(B.execution)?ce=a.to(B.execution):w.is(B.execution)?ce=w.to(B.execution):p.is(B.execution)&&(ce=p.to(B._id,ie));const ve=u.to(B.definition);let ke;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?ke=B.source.scope:ke=await K.resolveWorkspaceFolder(P.URI.revive(B.source.scope)):ke=A.TaskScope.Workspace),!ve||!ke)return;const fe=new A.$5M(ve,ke,B.name,B.source.label,ce,B.problemMatchers);return B.isBackground!==void 0&&(fe.isBackground=B.isBackground),B.group!==void 0&&(fe.group=A.$1M.from(B.group._id),fe.group&&B.group.isDefault&&(fe.group=new A.$1M(fe.group.id,fe.group.label),B.group.isDefault===!0&&(fe.group.isDefault=B.group.isDefault))),B.presentationOptions&&(fe.presentationOptions=t.to(B.presentationOptions)),B._id&&(fe._id=B._id),B.detail&&(fe.detail=B.detail),fe}W.to=R})(h||(e.TaskDTO=h={}));var D;(function(W){function V(R){return R}W.from=V;function q(R){if(R)return Object.assign(Object.create(null),R)}W.to=q})(D||(D={}));class k{#e;constructor(V,q,R){this._id=q,this.a=R,this.#e=V}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}let C=class{constructor(V,q,R,B,K,ie,ce,ve){this.q=new M.$de,this.r=new M.$de,this.s=new M.$de,this.u=new M.$de,this.a=V.getProxy(N.$dM.MainThreadTask),this.b=R,this.c=B,this.d=K,this.e=ie,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ce,this.g=ve,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(V,q,R){if(!R)return new A.$fM(()=>{});const B=this.x();return this.j.set(B,{type:q,provider:R,extension:V}),this.a.$registerTaskProvider(B,q),new A.$fM(()=>{this.j.delete(B),this.a.$unregisterTaskProvider(B)})}registerTaskSystem(V,q){this.a.$registerTaskSystem(V,q)}fetchTasks(V){return this.a.$fetchTasks(D.from(V)).then(async q=>{const R=[];for(const B of q){const K=await h.to(B,this.b,this.m);K&&R.push(K)}return R})}get taskExecutions(){const V=[];return this.k.forEach(q=>V.push(q)),V}terminateTask(V){if(!(V instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(V._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(V,q,R){const B=this.m.get(V.id);B&&(this.o.set(V.id,B),this.e.attachPtyToTerminal(q,await B.callback(R))),this.p=V.id,this.q.fire({execution:await this.z(V)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(V){if(!this.l.has(V.id))return;const q=await this.z(V);this.l.delete(V.id),this.k.delete(V.id),this.B(V),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(V){const q=await this.z(V.id);this.s.fire({execution:q,processId:V.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(V){const q=await this.z(V.id);this.u.fire({execution:q,exitCode:V.exitCode})}$provideTasks(V,q){const R=this.j.get(V);if(!R)return Promise.reject(new Error("no handler found"));const B=[],K=(0,O.$oh)(()=>R.provider.provideTasks(T.CancellationToken.None)).then(ie=>this.v(q,B,R,ie));return new Promise(ie=>{K.then(ce=>{Promise.all(B).then(()=>{ie(ce)})})})}async $resolveTask(V,q){const R=this.j.get(V);if(!R)return Promise.reject(new Error("no handler found"));if(q.definition.type!==R.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${R.type}].`);const B=await h.to(q,this.b,this.m);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const K=await R.provider.resolveTask(B,T.CancellationToken.None);if(!K)return;this.A(K,R);const ie=h.from(K,R.extension);if(!ie)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(ie.execution)&&await this.y(ie,K,!0),await this.w(ie)}x(){return this.h++}async y(V,q,R){const B=await this.a.$createTaskId(V);!R&&!this.m.has(B)&&(this.n.add(B),this.o.set(B,q.execution)),this.m.set(B,q.execution)}async z(V,q){if(typeof V=="string"){const K=this.l.get(V);if(!K)throw new c.$bb("Unexpected: The specified task is missing an execution");return K}const R=this.l.get(V.id);if(R)return R;let B;return q?B=Promise.resolve(new k(this,V.id,q)):B=h.to(V.task,this.b,this.m).then(K=>{if(!K)throw new c.$bb("Unexpected: Task does not exist.");return new k(this,V.id,K)}),this.l.set(V.id,B),B.then(K=>(this.k.set(V.id,K),K))}A(V,q){V._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(V){this.o.get(V.id)&&this.o.delete(V.id),this.n.has(V.id)&&this.p!==V.id&&(this.m.delete(V.id),this.n.delete(V.id));const R=this.n.values();let B=R.next();for(;!B.done;)!this.o.has(B.value)&&this.p!==B.value&&(this.m.delete(B.value),this.n.delete(B.value)),B=R.next()}};e.$jnc=C,e.$jnc=C=Ke([We(0,l.$EO),We(1,b.$UO),We(2,$.$Rlc),We(3,m.$PO),We(4,E.$Ulc),We(5,S.$gmc),We(6,o.$3j),We(7,n.$vlc)],C);let I=class extends C{constructor(V,q,R,B,K,ie,ce,ve){super(V,q,R,B,K,ie,ce,ve),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:s.$h(0)})}async executeTask(V,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const R=h.from(q,V);if(R===void 0)throw new Error("Task is not valid");if(p.is(R.execution))await this.y(R,q,!1);else throw new c.$_;const B=await this.z(await this.a.$getTaskExecution(R),q);return this.a.$executeTask(R).catch(K=>{throw new Error(K)}),B}v(V,q,R,B){const K=[];if(B)for(const ie of B){if(this.A(ie,R),!ie.definition||!V[ie.definition.type]){const ve=ie.source?ie.source:"No task source";this.f.warn(`The task [${ve}, ${ie.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=h.from(ie,R.extension);ce&&p.is(ce.execution)?(K.push(ce),q.push(this.y(ce,ie,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:R.extension}}async w(V){if(p.is(V.execution))return V;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(V,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,q,R){}};e.$knc=I,e.$knc=I=Ke([We(0,l.$EO),We(1,b.$UO),We(2,$.$Rlc),We(3,m.$PO),We(4,E.$Ulc),We(5,S.$gmc),We(6,o.$3j),We(7,n.$vlc)],I),e.$lnc=(0,g.$wi)("IExtHostTask")}),define(Se[298],Ie([1,0,47,30]),function(he,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SK=void 0,e.$RK=M,e.$TK=N;function M(A){return"cellResults"in A}e.$SK="rawCell#";function N(A,$){let m=-1;const E=[];let T=[];return A.forEach(l=>{l.range.startLineNumber!==m&&T.length>0&&(E.push([...T]),T=[]),T.push(l),m=l.range.endLineNumber}),T.length>0&&E.push([...T]),E.map(l=>{const b=[],g=l[0].range.startLineNumber,r=l[l.length-1].range.endLineNumber;for(let s=g;s<=r;s++)b.push($.getLineContent(s));return new P.$vK(b.join(`
`)+`
`,l.map(s=>new O.$ut(s.range.startLineNumber-1,s.range.startColumn-1,s.range.endLineNumber-1,s.range.endColumn-1)))})}}),define(Se[299],Ie([1,0,177,21,5,6,28,13,15,2,38,76,4,35,8,7,34,275,114,25,16,231,298,296]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g,r,s,o,n,i,c,u,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ymc=void 0;class a{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(w=>w.apiEditor)}constructor(w,p,v,y,h,D){this.q=v,this.r=y,this.s=h,this.t=D,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new M.$de,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new M.$de,this.onDidOpenNotebookDocument=this.m.event,this.n=new M.$de,this.onDidCloseNotebookDocument=this.n.event,this.o=new M.$de,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new S.$tlc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=w.getProxy(l.$dM.MainThreadNotebook),this.c=w.getProxy(l.$dM.MainThreadNotebookDocuments),this.d=w.getProxy(l.$dM.MainThreadNotebookEditors),this.i=p.converter,p.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const C=k.notebookEditor?.notebookUri,I=k.cell.handle,V=this.g.get(C)?.getCell(I);if(V)return V.apiCell}if(k&&k.$mid===14){const C=k.uri,I=this.g.get(C);if(I)return I.apiNotebook}return k}}),a.B(p)}getEditorById(w){const p=this.h.get(w);if(!p)throw new Error(`unknown text editor: ${w}. known editors: ${[...this.h.keys()]} `);return p}getIdByEditor(w){for(const[p,v]of this.h)if(v.apiEditor===w)return p}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(w,p){const v=this.g.get(w);if(!v&&!p)throw new Error(`NO notebook document for '${w}'`);return v}static u(w,p){if(!p)return;const v=p.filenamePattern.map(y=>g.NotebookExclusiveDocumentPattern.from(y)).filter(y=>y!==void 0);if(p.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:w.identifier,providerDisplayName:w.displayName||w.name,displayName:p.displayName,filenamePattern:v,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(w,p,v){const y=a.a++,h=typeof v.onDidChangeCellStatusBarItems=="function"?a.a++:void 0;this.f.set(y,v),this.b.$registerNotebookCellStatusBarItemProvider(y,h,p);let D;return h!==void 0&&(D=v.onDidChangeCellStatusBarItems(k=>this.b.$emitCellStatusBarEvent(h))),new r.$fM(()=>{this.f.delete(y),this.b.$unregisterNotebookCellStatusBarItemProvider(y,h),D?.dispose()})}async createNotebookDocument(w){const p=await this.c.$tryCreateNotebook({viewType:w.viewType,content:w.content&&g.NotebookData.from(w.content)});return E.URI.revive(p)}async openNotebookDocument(w){const p=this.g.get(w);if(p)return p.apiNotebook;const v=await this.c.$tryOpenNotebook(w),y=this.g.get(E.URI.revive(v));return(0,m.$hg)(y?.apiNotebook)}async showNotebookDocument(w,p){E.URI.isUri(w)&&(w=await this.openNotebookDocument(w));let v;typeof p=="object"?v={position:g.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(g.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:v={preserveFocus:!1};const y=await this.d.$tryShowNotebookDocument(w.uri,w.notebookType,v),h=y&&this.h.get(y)?.apiEditor;if(h)return h;throw y?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(w,p,v,y){const h=this.f.get(w),D=E.URI.revive(p),k=this.g.get(D);if(!k||!h)return;const C=k.getCellFromIndex(v);if(!C)return;const I=await h.provideCellStatusBarItems(C.apiCell,y);if(!I)return;const W=new N.$Tc,V=this.p.add([W]),R=(Array.isArray(I)?I:[I]).map(B=>g.NotebookStatusBarItem.from(B,this.i,W));return{cacheId:V,items:R}}$releaseNotebookCellStatusBarItems(w){this.p.delete(w)}registerNotebookSerializer(w,p,v,y,h){if((0,$.$7e)(p))throw new Error("viewType cannot be empty or just whitespace");const D=this.w++;return this.x.set(D,{viewType:p,serializer:v,options:y}),this.b.$registerNotebookSerializer(D,{id:w.identifier,location:w.extensionLocation},p,g.NotebookDocumentContentOptions.from(y),a.u(w,h)),(0,N.$Sc)(()=>{this.b.$unregisterNotebookSerializer(D)})}async $dataToNotebook(w,p,v){const y=this.x.get(w);if(!y)throw new Error("NO serializer found");const h=await y.serializer.deserializeNotebook(p.buffer,v);return new s.$Bw(g.NotebookData.from(h))}async $notebookToData(w,p,v){const y=this.x.get(w);if(!y)throw new Error("NO serializer found");const h=await y.serializer.serializeNotebook(g.NotebookData.to(p.value),v);return O.$Fe.wrap(h)}async $saveNotebook(w,p,v,y,h){const D=E.URI.revive(p),k=this.x.get(w);if(!k)throw new Error("NO serializer found");const C=this.g.get(D);if(!C)throw new Error("Document NOT found");if(C.versionId!==v)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(D.scheme))throw new T.$ll((0,P.localize)(0,null,this.z(D)),6);await this.y(D,y);const I={metadata:(0,i.$$n)(C.apiNotebook.metadata,B=>!(k.options?.transientDocumentMetadata??{})[B]),cells:[]};for(const B of C.apiNotebook.getCells()){const K=new r.$IN(B.kind,B.document.getText(),B.document.languageId,B.mime,k.options?.transientOutputs?[]:[...B.outputs],B.metadata,B.executionSummary);K.metadata=(0,i.$$n)(B.metadata,ie=>!(k.options?.transientCellMetadata??{})[ie]),I.cells.push(K)}const W=await k.serializer.serializeNotebook(I,h);await this.s.value.writeFile(D,W);const V=this.s.getFileSystemProviderExtUri(D.scheme),q=await this.s.value.stat(D);return{name:V.basename(D),isFile:(q.type&T.FileType.File)!==0,isDirectory:(q.type&T.FileType.Directory)!==0,isSymbolicLink:(q.type&T.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&T.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(D.scheme),locked:!!((q.permissions??0)&T.FilePermission.Locked),etag:T.$wl({mtime:q.mtime,size:q.size}),children:void 0}}async $searchInNotebooks(w,p,v,y,h){const D=this.x.get(w)?.serializer;if(!D)return{limitHit:!1,results:[]};const k=new A.$Bc;await(async(q,R,B)=>{await Promise.all(q.map(async K=>await Promise.all(K.filenamePatterns.map(ie=>{const ce={_reason:B._reason,folderQueries:B.folderQueries,includePattern:B.includePattern,excludePattern:B.excludePattern,maxResults:B.maxResults,type:1,filePattern:ie};return this.t.doInternalFileSearchWithCustomCallback(ce,R,ve=>{ve.forEach(ke=>{k.has(ke)||y.some(pe=>K.isFromSettings&&!pe.isFromSettings?!1:pe.filenamePatterns.some(Ne=>(0,d.$Cgb)(Ne,ke)))||k.add(ke)})}).catch(ve=>{if(ve.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ve})}))))})(v,h,p);const I=new A.$Ac;let W=!1;const V=Array.from(k).map(async q=>{const R=[];try{if(h.isCancellationRequested)return;if(p.maxResults&&[...I.values()].reduce((ce,ve)=>ce+ve.cellResults.length,0)>p.maxResults){W=!0;return}const B=[],K=this.g.get(q);if(K)K.apiNotebook.getCells().forEach(ve=>B.push({input:ve.document.getText(),outputs:ve.outputs.flatMap(ke=>ke.items.map(fe=>fe.data.toString()))}));else{const ce=await this.s.value.readFile(q),ve=O.$Fe.fromString(ce.toString()),ke=await D.deserializeNotebook(ve.buffer,h);if(h.isCancellationRequested)return;g.NotebookData.from(ke).cells.forEach(pe=>B.push({input:pe.source,outputs:pe.outputs.flatMap(Ne=>Ne.items.map(ae=>ae.valueBytes.toString()))}))}if(h.isCancellationRequested)return;B.forEach((ce,ve)=>{const ke=p.contentPattern.pattern,fe=new u.$yXb(ce.input,void 0,ce.outputs),pe=fe.findInInputs(ke),Ne=fe.findInOutputs(ke),ae=Ne.flatMap(Re=>(0,t.$TK)(Re.matches,Re.textBuffer)).map((Re,ne)=>(Re.webviewIndex=ne,Re));if(pe.length>0||Ne.length>0){const Re={index:ve,contentResults:(0,t.$TK)(pe,fe.inputTextBuffer),webviewResults:ae};R.push(Re)}});const ie={resource:q,cellResults:R};I.set(q,ie);return}catch{return}});return await Promise.all(V),{limitHit:W,results:[...I.values()]}}async y(w,p){const v=await this.s.value.stat(w);if(typeof p?.mtime=="number"&&typeof p.etag=="string"&&p.etag!==T.$vl&&typeof v.mtime=="number"&&typeof v.size=="number"&&p.mtime<v.mtime&&p.etag!==T.$wl({mtime:p.mtime,size:v.size}))throw new T.$ll((0,P.localize)(1,null),3,p)}z(w){return w.scheme===c.Schemas.file?w.fsPath:w.toString()}A(w,p,v){if(this.h.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const y=new n.$Pmc(p,this.d,w,v.visibleRanges.map(g.NotebookRange.to),v.selections.map(g.NotebookRange.to),typeof v.viewColumn=="number"?g.ViewColumn.to(v.viewColumn):void 0);this.h.set(p,y)}$acceptDocumentAndEditorsDelta(w){if(w.value.removedDocuments)for(const v of w.value.removedDocuments){const y=E.URI.revive(v),h=this.g.get(y);h&&(h.dispose(),this.g.delete(y),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:h.apiNotebook.getCells().map(D=>D.document.uri)}),this.n.fire(h.apiNotebook));for(const D of this.h.values())D.notebookData.uri.toString()===y.toString()&&this.h.delete(D.id)}if(w.value.addedDocuments){const v=[];for(const y of w.value.addedDocuments){const h=E.URI.revive(y.uri);if(this.g.has(h))throw new Error(`adding EXISTING notebook ${h} `);const D=new o.$Omc(this.c,this.q,this.r,h,y);v.push(...y.cells.map(k=>o.$Nmc.asModelAddData(k))),this.g.get(h)?.dispose(),this.g.set(h,D),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this.m.fire(D.apiNotebook)}}if(w.value.addedEditors)for(const v of w.value.addedEditors){if(this.h.has(v.id))return;const y=E.URI.revive(v.documentUri),h=this.g.get(y);h&&this.A(h,v.id,v)}const p=[];if(w.value.removedEditors)for(const v of w.value.removedEditors){const y=this.h.get(v);y&&(this.h.delete(v),this.k?.id===y.id&&(this.k=void 0),p.push(y))}if(w.value.visibleEditors){this.l=w.value.visibleEditors.map(y=>this.h.get(y)).filter(y=>!!y);const v=new Set;this.l.forEach(y=>v.add(y.id));for(const y of this.h.values()){const h=v.has(y.id);y._acceptVisibility(h)}this.l=[...this.h.values()].map(y=>y).filter(y=>y.visible),this.o.fire(this.visibleNotebookEditors)}w.value.newActiveEditor===null?this.k=void 0:w.value.newActiveEditor&&(this.h.get(w.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${w.value.newActiveEditor}`),this.k=this.h.get(w.value.newActiveEditor)),w.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(w){const p=b.$3O.String.with("notebookType","A notebook type"),v=new b.$5O("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new b.$3O("data","Bytes to convert to data",h=>h instanceof Uint8Array,h=>O.$Fe.wrap(h))],new b.$4O("Notebook Data",h=>g.NotebookData.to(h.value))),y=new b.$5O("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new b.$3O("NotebookData","Notebook data to convert to bytes",h=>!0,h=>new s.$Bw(g.NotebookData.from(h)))],new b.$4O("Bytes",h=>h.buffer));w.registerApiCommand(v),w.registerApiCommand(y)}}e.$Ymc=a}),define(Se[300],Ie([1,0,19,24,44,37,23,66,47]),function(he,e,P,O,M,N,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qmc=void 0;class E{constructor(l,b,g){this.k=l,this.l=b,this.o=g,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&N.$qk(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&N.$qk(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const b=this.k.folderQueries||[];return new Promise((g,r)=>{const s=o=>{this.f++,l(o)};if(this.g)return g({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const n=o.toString(),i=P.$nc(n);this.j&&this.j(n,i)||this.v(s,{base:o,basename:i})}),Promise.all(b.map(o=>this.p(o,s))).then(o=>{g({limitHit:this.e,stats:o[0]||void 0})},o=>{r(new Error((0,M.$hj)(o)))})})}async p(l,b){const g=new O.$oe,r=this.q(l),s=this.r(),o=new m.$JK(this.k,l),n=!o.hasSiblingExcludeClauses();let i;try{this.h.add(g),i=$.$_d.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,g.token),u=i.elapsed(),t=$.$_d.create();return this.g&&!this.e||(c&&c.forEach(d=>{const a=P.$gc.relative(l.folder.path,d.path);if(n){const f=P.$nc(d.path);this.v(b,{base:l.folder,relativePath:a,basename:f});return}this.s(s,l.folder,a,b)}),this.g&&!this.e)?null:(this.u(s,o,b),{providerTime:u,postProcessTime:t.elapsed()})}finally{g.dispose(),this.h.delete(g)}}q(l){const b=(0,m.$IK)(this.k.includePattern,l.includePattern),g=(0,m.$IK)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:g,includes:b,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},b,g,r){if(g===this.a){const o=P.$nc(this.a);this.v(r,{base:b,relativePath:this.a,basename:o})}function s(o){const n=P.$nc(o),i=P.$mc(o);let c=l[i];c||(c=l[i]=[],s(i)),c.push({base:b,relativePath:o,basename:n})}s(g)}u({rootEntries:l,pathToEntries:b},g,r){const s=this,o=this.a;function n(i){const c=(0,m.$LK)(()=>i.map(u=>u.basename));for(let u=0,t=i.length;u<t;u++){const d=i[u],{relativePath:a,basename:f}=d;if(g.matchesExcludesSync(a,f,o!==f?c:void 0))continue;const w=b[a];if(w)n(w);else{if(a===o)continue;s.v(r,d)}if(s.e)break}}n(l)}v(l,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(b))}}class T{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,b,g,r){const s=this.c(l.cacheKey),o=new E(l,b,s&&s.token);let n=0;const i=c=>{n+=c.length,g(c.map(u=>this.d(u)))};return this.e(o,T.a,i,r).then(c=>({limitHit:c.limitHit,stats:c.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}:void 0,messages:[]}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new O.$oe),this.b.get(l)}d(l){return l.relativePath?{resource:A.$0g(l.base,l.relativePath)}:{resource:l.base}}e(l,b,g,r){const s=r.onCancellationRequested(()=>{l.cancel()}),o=i=>{i&&(n.push(i),b>0&&n.length>=b&&(g(n),n=[]))};let n=[];return l.search(o).then(i=>(n.length&&g(n),s.dispose(),i),i=>(n.length&&g(n),s.dispose(),Promise.reject(i)))}}e.$Qmc=T}),define(Se[301],Ie([1,0,18,270,37,97,28,16,19,23,13,15,2,96,195,50,12,45,109,297,47]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g,r,s,o,n,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=void 0,e.$UL=y;let u=class{constructor(D,k,C,I,W){this.a=D,this.b=k,this.c=C,this.d=I,this.e=W}text(D,k,C={}){D=this.f(D,C);const I=this.a.getValue(),W=k&&k.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(k?.map(o.$Ri),C),type:2,contentPattern:D,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:I.search.usePCRE2||W||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(D,k){const C=this.a.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const I={...D,wordSeparators:C.editor.wordSeparators};return this.j(D,k)&&(I.isCaseSensitive=!0),this.k(D)&&(I.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),I}file(D,k={}){return{...this.h(D,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey,shouldGlobMatchFilePattern:k.shouldGlobSearch}}g(D,k){return D?(D=Array.isArray(D)?D.map(w):w(D),k?this.parseSearchPaths(D):{pattern:d(...Array.isArray(D)?D:[D])}):{}}h(D=[],k={}){const C=this.g(k.includePattern,k.expandPatterns),I=this.g(k.excludePattern,k.expandPatterns),W=D.length>1,V=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(B=>this.q(B,k,I)):D.map(B=>this.r(B,k,I,W))).filter(B=>!!B),q={_reason:k._reason,folderQueries:V,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:I.pattern,includePattern:C.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const B=P.$Hb(this.c.groups.flatMap(ce=>ce.editors.map(ve=>ve.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(B));const K=B.filter(ce=>(0,c.$zK)(q,ce.fsPath)),ie=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ie)),{...q,...ie}}const R=k.extraFileResources&&k.extraFileResources.filter(B=>(0,c.$zK)(q,B.fsPath));return q.extraFileResources=R&&R.length?R:void 0,q}i(D){const k=[],C=new A.$Ac,I={};let W=!1;return D.forEach(V=>{if(V.scheme===$.Schemas.walkThrough)return;if((0,E.$bh)(V)){const R=this.b.getWorkspaceFolder(V)?.uri??V.with({path:m.$mc(V.fsPath)});let B=C.get(R);B||(W=!0,B={folder:R,includePattern:{}},k.push(B),C.set(R,B));const K=m.$lc(R.fsPath,V.fsPath);(0,S.$hg)(B.includePattern)[K.replace(/\\/g,"/")]=!0}else V.fsPath&&(W=!0,I[V.fsPath]=!0)}),{folderQueries:k,includePattern:I,usingSearchPaths:!0,excludePattern:W?void 0:{"**/*":!0}}}j(D,k){if(k.isSmartCase){if(D.isRegExp){if(T.$Zf(D.pattern,!0))return!0}else if(T.$Zf(D.pattern))return!0}return!!D.isCaseSensitive}k(D){return D.isMultiline||D.isRegExp&&(0,b.$QC)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const k=ie=>m.$ic(ie)||/^\.\.?([\/\\]|$)/.test(ie),I=(Array.isArray(D)?D:a(D)).map(ie=>{const ce=this.e.resolvedUserHome;return ce?(0,N.$Gw)(ie,ce.scheme===$.Schemas.file?ce.fsPath:ce.path):ie}),W=O.$K(I,ie=>k(ie)?"searchPaths":"exprSegments"),V=(W.exprSegments||[]).map(ie=>T.$ff(ie,"/")).map(ie=>T.$ff(ie,"\\")).map(ie=>(ie[0]==="."&&(ie="*"+ie),f(ie))),q={},R=this.m(W.searchPaths||[]);R&&R.length&&(q.searchPaths=R);const B=V.flat(),K=d(...B);return K&&(q.pattern=K),q}l(D,k){return k.disregardExcludeSettings?void 0:(0,c.$yK)(D,!k.disregardSearchExcludeSettings)}m(D){if(!D||!D.length)return[];const k=D.flatMap(I=>{let{pathPortion:W,globPortion:V}=t(I);return V&&(V=p(V)),this.n(W).flatMap(R=>this.o(R,V))}),C=new Map;return k.forEach(I=>{const W=I.searchPath.toString(),V=C.get(W);V?I.pattern&&(V.pattern=V.pattern||{},V.pattern[I.pattern]=!0):C.set(W,{searchPath:I.searchPath,pattern:I.pattern?d(I.pattern):void 0})}),Array.from(C.values())}n(D){if(m.$ic(D)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==$.Schemas.file?[{searchPath:k[0].uri.with({path:D})}]:[{searchPath:l.URI.file(m.$hc(D))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(D=w(D),D.startsWith("../")||D===".."){const I=m.$gc.resolve(k.path,D);return[{searchPath:k.with({path:I})}]}const C=p(D);return[{searchPath:k,pattern:C}]}else{if(D==="./"||D===".\\")return[];{const k=D.replace(/^\.[\/\\]/,""),I=this.b.getWorkspace().folders.map(W=>{const V=k.match(new RegExp(`^${T.$_e(W.name)}(?:/(.*)|$)`));return V?{match:V,folder:W}:null}).filter(S.$eg);if(I.length)return I.map(W=>{const V=W.match[1];return{searchPath:W.folder.uri,pattern:V&&p(V)}});{const W=D.match(/\.[\/\\](.+)[\/\\]?/),V=W?W[1]:D,q=g.localize(0,null,V);throw new Error(q)}}}}o(D,k){const C=D.pattern&&k?`${D.pattern}/${k}`:D.pattern||k,I=[{searchPath:D.searchPath,pattern:C}];return C&&!C.endsWith("**")&&I.push({searchPath:D.searchPath,pattern:C+"/**"}),I}q(D,k,C){const I=this.r((0,o.$Ri)(D.searchPath),k,C,!1);return I?{...I,includePattern:D.pattern}:null}r(D,k,C,I){let W;const V=l.URI.isUri(D)?D:D.uri;if(C.searchPaths){const ie=C.searchPaths.filter(ce=>(0,E.$3g)(ce.searchPath,V))[0];if(ie&&!ie.pattern)return null;ie&&(W=ie.pattern)}const q=this.a.getValue({resource:V}),B={...this.l(q,k)||{},...W||{}},K=l.URI.isUri(D)?(0,E.$7g)(D):D.name;return{folder:V,folderName:I?K:void 0,excludePattern:Object.keys(B).length>0?B:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!q.search.followSymlinks}}};e.$TL=u,e.$TL=u=Ke([We(0,r.$3i),We(1,o.$Fi),We(2,n.$YD),We(3,s.$3j),We(4,i.$RL)],u);function t(h){const D=h.match(/[\*\{\}\(\)\[\]\?]/);if(D){const k=D.index,C=h.substr(0,k).match(/[/|\\][^/\\]*$/);if(C){let I=h.substr(0,C.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:h.substr((C.index||0)+1)}}}return{pathPortion:h}}function d(...h){return h.length?h.reduce((D,k)=>(D[k]=!0,D),Object.create(null)):void 0}function a(h){return M.$ok(h,",").map(D=>D.trim()).filter(D=>!!D.length)}function f(h){return[`**/${h}/**`,`**/${h}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function w(h){return h.replace(/\\/g,"/")}function p(h){return w(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function v(h){return h.replace(/([?*[\]])/g,"[$1]")}function y(h,D){h=P.$Mb(h,I=>I.toString());const k=[],C=D.getWorkspace();return h&&h.forEach(I=>{let W;if(D.getWorkbenchState()===2)W=(0,E.$_g)(C.folders[0].uri,I),W&&W!=="."&&(W="./"+W);else{const V=D.getWorkspaceFolder(I);if(V){const q=V.name;if(C.folders.filter(B=>B.name===q).length===1){const B=(0,E.$_g)(V.uri,I);B===""?W=`./${V.name}`:W=`./${V.name}/${B}`}else W=I.fsPath}}W&&k.push(v(W))}),k}}),define(Se[302],Ie([1,0,23,2,24,14,3,301,47,45,11]),function(he,e,P,O,M,N,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vwb=l,e.$wwb=r;const S=7e3;function l(s,o){const n=o.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],c=[];for(const w of n)if(/^workspaceContains:/.test(w)){const p=w.substr(18);p.indexOf("*")>=0||p.indexOf("?")>=0||s.forceUsingSearch?c.push(p):i.push(p)}if(i.length===0&&c.length===0)return Promise.resolve(void 0);const{promise:u,resolve:t}=(0,T.$ph)(),d=w=>t({activationEvent:w}),a=Promise.all(i.map(w=>b(s,w,d))).then(()=>{}),f=g(s,o.identifier,c,d);return Promise.all([a,f]).then(()=>{t(void 0)}),u}async function b(s,o,n){for(const i of s.folders)if(await s.exists(P.$0g(O.URI.revive(i),o))){n(`workspaceContains:${o}`);return}}async function g(s,o,n,i){if(n.length===0)return Promise.resolve(void 0);const c=new M.$oe,u=s.checkExists(s.folders,n,c.token),t=setTimeout(async()=>{c.cancel(),s.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},S);let d=!1;try{d=await u}catch(a){N.$4(a)||N.$1(a)}c.dispose(),clearTimeout(t),d&&i(`workspaceContains:${n.join(",")}`)}function r(s,o,n,i){const c=s.get(A.$vi),u=s.get(m.$qK),d=c.createInstance($.$TL).file(o.map(a=>(0,E.$Ri)(O.URI.revive(a))),{_reason:"checkExists",includePattern:n,exists:!0});return u.fileSearch(d,i).then(a=>!!a.limitHit,a=>N.$4(a)?!1:Promise.reject(a))}}),define(Se[41],Ie([1,0,173,19,60,23,11,6,54,2,12,4,40,237,84,39,26,110,14,20,21,218,7,104,3,27,87,17,72,88,53,90,5,302,83,220,16,81,66,22,82]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g,r,s,o,n,i,c,u,t,d,a,f,w,p,v,y,h,D,k,C,I,W,V,q,R,B,K){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.$xmc=e.$wmc=e.$vmc=e.$umc=e.$tmc=void 0,e.$tmc=(0,a.$wi)("IHostUtils");let ce=ie=class extends $.$Uc{constructor(z,x,be,Te,De,we,ge,Q,Y,le,ue,Oe,de){super(),this.Y=Oe,this.Z=de,this.a=this.B(new k.$de),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=x,this.g=be,this.f=ge,this.j=Te,this.m=De,this.s=we,this.t=Y,this.u=le,this.w=ue,this.y=this.g.getProxy(S.$dM.MainThreadWorkspace),this.z=this.g.getProxy(S.$dM.MainThreadTelemetry),this.C=this.g.getProxy(S.$dM.MainThreadExtensionService),this.D=new A.$vh,this.F=new A.$vh,this.G=new A.$vh,this.H=new A.$vh,this.I=new Re(this.f.extensions.activationEvents),this.L=new o.$7_b(this.I,this.f.extensions.allExtensions);const Ce=new i.$Sm(this.f.extensions.myExtensions);this.J=new o.$7_b(this.I,Ne(this.L,Ce)),B.$t&&(this.s.info(`Creating extension host with the following global extensions: ${fe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${fe(this.J)}`)),this.M=new g.$cmc(this.g,this.s),this.N=new I.$mmc(this.g),this.O=Q,this.h=z.createChild(new v.$ui([g.$dmc,this.M],[I.$nmc,this.N])),this.P=this.B(new b.$bmc(this.J,this.L,{onExtensionActivationError:(Me,je,U)=>{this.C.$onExtensionActivationError(Me,n.$3(je),U)},actualActivateExtension:async(Me,je)=>{if(o.$7_b.isHostExtension(Me,this.J,this.L))return await this.C.$activateExtension(Me,je),new b.$amc;const U=this.J.getExtensionDescription(Me);return this.fb(U,je)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),M.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(z){n.$1(z)}}async $(){this.O.onWillDeactivateAll();let z=[];try{z=this.J.getAllExtensionDescriptions().map(De=>De.identifier).filter(De=>this.isActivated(De)).map(De=>this.eb(De))}catch{}await Promise.all(z)}terminate(z,x=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${z}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Te=>{this.s.error(Te)}),this.g.dispose();const be=this.$();Promise.race([(0,A.$xh)(5e3),be]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${x}`):this.s.info(`Extension host exiting with code ${x}`),this.s.flush(),this.s.dispose(),this.c.exit(x)})}isActivated(z){return this.G.isOpen()?this.P.isActivated(z):!1}async getExtension(z){const x=await this.C.$getExtension(z);return x&&{...x,identifier:new i.$Rm(x.identifier.value),extensionLocation:E.URI.revive(x.extensionLocation)}}ab(z,x){return this.P.activateByEvent(z,x)}bb(z,x){return this.P.activateById(z,x)}activateByIdWithErrors(z,x){return this.bb(z,x).then(()=>{const be=this.P.getActivatedExtension(z);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(z=>this.J)}getExtensionExports(z){if(this.G.isOpen())return this.P.getActivatedExtension(z).exports;try{return this.P.getActivatedExtension(z).exports}catch{return null}}async cb(z){if(z.scheme===V.Schemas.file&&this.c.fsRealpath){const x=z.fsPath;this.R.has(x)||this.R.set(x,this.c.fsRealpath(x));const be=await this.R.get(x);return E.URI.file(be)}return z}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(z=>new ae(z))),this.Q}async db(z){const x=m.$Ci.forUris(be=>N.$1g.ignorePathCasing(be));return await Promise.all(z.map(async be=>{if(this.wb(be)){const Te=await this.cb(be.extensionLocation);x.set(Te,be)}})),x}eb(z){let x=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(z))return x;const be=this.P.getActivatedExtension(z);if(!be)return x;try{typeof be.module.deactivate=="function"&&(x=Promise.resolve(be.module.deactivate()).then(void 0,Te=>(this.s.error(Te),Promise.resolve(void 0))))}catch(Te){this.s.error(`An error occurred when deactivating the extension '${z.value}':`),this.s.error(Te)}try{(0,$.$Pc)(be.subscriptions)}catch(Te){this.s.error(`An error occurred when deactivating the subscriptions for extension '${z.value}':`),this.s.error(Te)}return x}async fb(z,x){return this.f.remote.isRemote?this.C.$onWillActivateExtension(z.identifier):await this.C.$onWillActivateExtension(z.identifier),this.hb(z,x).then(be=>{const Te=be.activationTimes;return this.C.$onDidActivateExtension(z.identifier,Te.codeLoadingTime,Te.activateCallTime,Te.activateResolvedTime,x),this.gb(z,x,"success",Te),be},be=>{throw this.gb(z,x,"failure"),be})}gb(z,x,be,Te){const De=ke(z,x);this.z.$publicLog2("extensionActivationTimes",{...De,...Te||{},outcome:be})}hb(z,x){const be=ke(z,x);this.z.$publicLog2("activatePlugin",be);const Te=this.wb(z);if(!Te)return Promise.resolve(new b.$_lc(b.$9lc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${z.identifier.value}, startup: ${x.startup}, activationEvent: '${x.activationEvent}'${z.identifier.value!==x.extensionId.value?`, root cause: ${x.extensionId.value}`:""}`),this.s.flush();const De=new b.$0lc(x.startup);return Promise.all([this.xb(z,(0,N.$0g)(z.extensionLocation,Te),De),this.ib(z)]).then(we=>(M.mark(`code/extHost/willActivateExtension/${z.identifier.value}`),ie.jb(this.s,z.identifier,we[0],we[1],De))).then(we=>(M.mark(`code/extHost/didActivateExtension/${z.identifier.value}`),we))}ib(z){const x=this.Z.createLanguageModelAccessInformation(z),be=new u.$fmc(z,this.M),Te=new u.$emc(z.identifier.value,!1,this.M),De=new W.$omc(z,this.N),we=z.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${z.identifier.value}`),Promise.all([be.whenReady,Te.whenReady,this.O.whenReady]).then(()=>{const Q=this;let Y,le;const ue=(0,s.$OG)(z,"ipc")?this.f.messagePorts?.get(i.$Rm.toKey(z.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:Te,secrets:De,subscriptions:[],get languageModelAccessInformation(){return x},get extensionUri(){return z.extensionLocation},get extensionPath(){return z.extensionLocation.fsPath},asAbsolutePath(Oe){return O.$jc(z.extensionLocation.fsPath,Oe)},get storagePath(){return Q.O.workspaceValue(z)?.fsPath},get globalStoragePath(){return Q.O.globalValue(z).fsPath},get logPath(){return O.$jc(Q.f.logsLocation.fsPath,z.identifier.value)},get logUri(){return E.URI.joinPath(Q.f.logsLocation,z.identifier.value)},get storageUri(){return Q.O.workspaceValue(z)},get globalStorageUri(){return Q.O.globalValue(z)},get extensionMode(){return we},get extension(){return Y===void 0&&(Y=new pe(Q,z.identifier,z,ge,!1)),Y},get extensionRuntime(){return(0,s.$PG)(z,"extensionRuntime"),Q.extensionRuntime},get environmentVariableCollection(){return Q.u.getEnvironmentVariableCollection(z)},get messagePassingProtocol(){if(!le){if(!ue)return;const Oe=k.Event.buffer(k.Event.fromDOMEventEmitter(ue,"message",de=>de.data));ue.start(),le={onDidReceiveMessage:Oe,postMessage:ue.postMessage.bind(ue)}}return le}})})}static jb(z,x,be,Te,De){return be=be||{activate:void 0,deactivate:void 0},this.kb(z,x,be,Te,De).then(we=>new b.$$lc(!1,null,De.build(),be,we,Te.subscriptions))}static kb(z,x,be,Te,De){if(typeof be.activate=="function")try{De.activateCallStart(),z.trace(`ExtensionService#_callActivateOptional ${x.value}`);const we=typeof global=="object"?global:self,ge=be.activate.apply(we,[Te]);return De.activateCallStop(),De.activateResolveStart(),Promise.resolve(ge).then(Q=>(De.activateResolveStop(),Q))}catch(we){return Promise.reject(we)}else return Promise.resolve(be)}lb(z,x){this.bb(z.identifier,{startup:!1,extensionId:z.identifier,activationEvent:x}).then(void 0,be=>{this.s.error(be)})}mb(z,x=0){const Te=Date.now();(0,B.$B)(()=>{for(let De=x;De<z.length;De+=1){const we=z[De];for(const ge of we.activationEvents??[])if(ge==="onStartupFinished")if(Date.now()-Te>50){this.mb(z,De);break}else this.lb(we,ge)}})}nb(){this.C.$setPerformanceMarks(M.getMarks()),this.m.getConfigProvider().then(z=>{const x=z.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),be=this.J.getAllExtensionDescriptions();if(x)this.mb(be);else for(const Te of be)if(Te.activationEvents)for(const De of Te.activationEvents)De==="onStartupFinished"&&this.lb(Te,De)})}ob(){const z=this.ab("*",!0).then(void 0,we=>{this.s.error(we)});this.B(this.j.onDidChangeWorkspace(we=>this.pb(we.added)));const x=this.j.workspace?this.j.workspace.folders:[],be=this.pb(x),Te=this.rb(),De=Promise.all([Te,z,be]).then(()=>{});return Promise.race([De,(0,A.$xh)(1e4)]).then(()=>{this.nb()}),De}pb(z){return z.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(x=>this.qb(z,x))).then(()=>{})}async qb(z,x){if(this.isActivated(x.identifier))return;const be=!this.f.remote.isRemote&&!!this.f.remote.authority,Te={logService:this.s,folders:z.map(we=>we.uri),forceUsingSearch:be||!this.c.fsExists,exists:we=>this.c.fsExists(we.fsPath),checkExists:(we,ge,Q)=>this.y.$checkExists(we,ge,Q)},De=await(0,C.$vwb)(Te,x);if(De)return this.bb(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:De.activationEvent}).then(void 0,we=>this.s.error(we))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(z){throw console.error(z),z}}async sb(){const{extensionDevelopmentLocationURI:z,extensionTestsLocationURI:x}=this.f.environment;if(!z||!x)throw new Error(P.localize(0,null));const be=await this.xb(null,x,new b.$0lc(!1));if(!be||typeof be.run!="function")throw new Error(P.localize(1,null,x.toString()));return new Promise((Te,De)=>{const we=(Y,le)=>{Y?(B.$t&&this.s.error("Test runner called back with error",Y),De(Y)):(B.$t&&(le?this.s.info(`Test runner called back with ${le} failures.`):this.s.info("Test runner called back with successful outcome.")),Te(typeof le=="number"&&le>0?1:0))},ge=(0,N.$Xg)(x),Q=be.run(ge,we);Q&&Q.then&&Q.then(()=>{B.$t&&this.s.info("Test runner finished successfully."),Te(0)}).catch(Y=>{B.$t&&this.s.error("Test runner finished with error",Y),De(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$xh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(z,x){return this.S[z]=x,(0,$.$Sc)(()=>{delete this.S[z]})}async getRemoteExecServer(z){const{resolver:x}=await this.ub(z);return x?.resolveExecServer?.(z,{resolveAttempt:0})}async ub(z){const x=z.indexOf("+");if(x===-1)throw new t.$lM("Not an authority that can be resolved!",d.RemoteAuthorityResolverErrorCode.InvalidAuthority);const be=z.substr(0,x);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this.S[be]}}async $resolveAuthority(z,x){const be=R.$_d.create(!1),Te=()=>`[resolveAuthority(${(0,d.$Ll)(z)},${x})][${be.elapsed()}ms] `,De=F=>this.s.info(`${Te()}${F}`),we=F=>this.s.warn(`${Te()}${F}`),ge=(F,G=void 0)=>this.s.error(`${Te()}${F}`,G),Q=F=>{if(F instanceof t.$lM)return{type:"error",error:{code:F._code,message:F._message,detail:F._detail}};throw F},Y=async F=>{De(`activating resolver for ${F}...`);const{resolver:G,authorityPrefix:H}=await this.ub(F);if(!G)throw ge(`no resolver for ${H}`),new t.$lM(`No remote extension installed to resolve ${H}.`,d.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:G,authorityPrefix:H,remoteAuthority:F}},le=z.split(/@|%40/g).reverse();De(`activating remote resolvers ${le.join(" -> ")}`);let ue;try{ue=await Promise.all(le.map(Y)).catch(async F=>{if(!(F instanceof t.$lM)||F._code!==d.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw F;return we(`resolving nested authorities failed: ${F.message}`),[await Y(z)]})}catch(F){return Q(F)}const Oe=new A.$Hh;Oe.cancelAndSet(()=>De("waiting..."),1e3);let de,Ce;for(const[F,{authorityPrefix:G,resolver:H,remoteAuthority:ee}]of ue.entries())try{if(F===ue.length-1)De("invoking final resolve()..."),M.mark(`code/extHost/willResolveAuthority/${G}`),de=await H.resolve(ee,{resolveAttempt:x,execServer:Ce}),M.mark(`code/extHost/didResolveAuthorityOK/${G}`),De("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,t.$kM.isManagedResolvedAuthority(de)?de:void 0));else{if(De(`invoking resolveExecServer() for ${ee}`),M.mark(`code/extHost/willResolveExecServer/${G}`),Ce=await H.resolveExecServer?.(ee,{resolveAttempt:x,execServer:Ce}),!Ce)throw new t.$lM(`Exec server was not available for ${ee}`,d.RemoteAuthorityResolverErrorCode.NoResolverFound);M.mark(`code/extHost/didResolveExecServerOK/${G}`)}}catch(re){return M.mark(`code/extHost/didResolveAuthorityError/${G}`),ge("returned an error",re),Oe.dispose(),Q(re)}Oe.dispose();const Me={environmentTunnels:de.environmentTunnels,features:de.tunnelFeatures?{elevation:de.tunnelFeatures.elevation,privacyOptions:de.tunnelFeatures.privacyOptions,protocol:de.tunnelFeatures.protocol===void 0?!0:de.tunnelFeatures.protocol}:void 0},je={extensionHostEnv:de.extensionHostEnv,isTrusted:de.isTrusted,authenticationSession:de.authenticationSessionForInitializingExtensions?{id:de.authenticationSessionForInitializingExtensions.id,providerId:de.authenticationSessionForInitializingExtensions.providerId}:void 0};De(`returned ${t.$kM.isManagedResolvedAuthority(de)?"managed authority":`${de.host}:${de.port}`}`);let U;if(t.$kM.isManagedResolvedAuthority(de)){const F=x;this.Y.setFactory(F,de.makeConnection),U={authority:z,connectTo:new d.$Il(F),connectionToken:de.connectionToken}}else U={authority:z,connectTo:new d.$Jl(de.host,de.port),connectionToken:de.connectionToken};return{type:"ok",value:{authority:U,options:je,tunnelInformation:Me}}}async $getCanonicalURI(z,x){this.s.info(`$getCanonicalURI invoked for authority (${(0,d.$Ll)(z)})`);const{resolver:be}=await this.ub(z);if(!be)return null;const Te=E.URI.revive(x);if(typeof be.getCanonicalURI>"u")return Te;const De=await(0,A.$oh)(()=>be.getCanonicalURI(Te));return De||Te}async $startExtensionHost(z){z.toAdd.forEach(we=>we.extensionLocation=E.URI.revive(we.extensionLocation));const{globalRegistry:x,myExtensions:be}=ve(this.I,this.L,this.J,z),Te=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(Te),this.L.set(x.getAllExtensionDescriptions()),this.J.set(be),B.$t&&(this.s.info(`$startExtensionHost: global extensions: ${fe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${fe(this.J)}`)),this.tb()}$activateByEvent(z,x){return x===1?this.D.wait().then(be=>this.ab(z,!1)):this.G.wait().then(be=>this.ab(z,!1))}async $activate(z,x){return await this.G.wait(),this.J.getExtensionDescription(z)?(await this.bb(z,x),!0):!1}async $deltaExtensions(z){z.toAdd.forEach(we=>we.extensionLocation=E.URI.revive(we.extensionLocation));const{globalRegistry:x,myExtensions:be}=ve(this.I,this.L,this.J,z),Te=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(Te),this.L.set(x.getAllExtensionDescriptions()),this.J.set(be),B.$t&&(this.s.info(`$deltaExtensions: global extensions: ${fe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${fe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(z){return z}async $test_up(z){return z.byteLength}async $test_down(z){const x=c.$Fe.alloc(z),be=Math.random()%256;for(let Te=0;Te<z;Te++)x.writeUInt8(be,Te);return x}async $updateRemoteConnectionData(z){this.X=z,this.a.fire()}};e.$umc=ce,e.$umc=ce=ie=Ke([We(0,a.$vi),We(1,e.$tmc),We(2,p.$EO),We(3,r.$Rlc),We(4,l.$Ulc),We(5,T.$3j),We(6,f.$UO),We(7,w.$Xlc),We(8,y.$CDb),We(9,h.$gmc),We(10,q.$qmc),We(11,K.$rmc),We(12,D.$kmc)],ce);function ve(ne,z,x,be){ne.addActivationEvents(be.addActivationEvents);const Te=new o.$7_b(ne,z.getAllExtensionDescriptions());Te.deltaExtensions(be.toAdd,be.toRemove);const De=new i.$Sm(x.getAllExtensionDescriptions().map(ge=>ge.identifier));for(const ge of be.myToRemove)De.delete(ge);for(const ge of be.myToAdd)De.add(ge);const we=Ne(Te,De);return{globalRegistry:Te,myExtensions:we}}function ke(ne,z){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:z.activationEvent,reasonId:z.extensionId.value}}function fe(ne){return ne.getAllExtensionDescriptions().map(z=>z.identifier.value).join(",")}e.$vmc=(0,a.$wi)("IExtHostExtensionService");class pe{#e;#t;#i;constructor(z,x,be,Te,De){this.#e=z,this.#t=x,this.#i=be.identifier,this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=O.$hc((0,N.$Xg)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=Te,this.isFromDifferentExtensionHost=De}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$wmc=pe;function Ne(ne,z){return ne.getAllExtensionDescriptions().filter(x=>z.has(x.identifier))}class ae{constructor(z){this.a=z}setSearchTree(z){this.a=z}findSubstr(z){return this.a.findSubstr(z)}forEach(z){return this.a.forEach(z)}}e.$xmc=ae;class Re{constructor(z){this.a=new i.$Tm,this.addActivationEvents(z)}readActivationEvents(z){return this.a.get(z.identifier)??[]}addActivationEvents(z){for(const x of Object.keys(z))this.a.set(x,z[x])}}}),define(Se[303],Ie([1,0,60,2,4,40,26,20,17,27,3,41,12,13]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fnc=void 0;let r=class{constructor(c,u,t,d,a,f,w){this.c=c,this.d=u,this.e=t,this.f=d,this.g=a,this.h=f,this.i=w,this.a=new Map,this.b=[]}async install(){this.j(),P.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();P.mark("code/extHost/didWaitForConfig");const u=await this.g.getExtensionPathIndex();this.register(new o(this.c,u,this.d,c,this.i)),this.register(this.e.createInstance(s)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,u,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const u of c.nodeModuleName)this.a.set(u,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(u=>c.alternativeModuleName(u))}};e.$Fnc=r,e.$Fnc=r=Ke([We(2,T.$vi),We(3,N.$Ulc),We(4,S.$vmc),We(5,E.$UO),We(6,l.$3j)],r);let s=class{static{g=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&g.a.size){const u=(0,b.$_e)(this.c(c.environment.appRoot.fsPath)),t="[a-z0-9_.-]",d=`@${t}+\\/${t}+|${t}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${u}/${a}\\/)(${d})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const u=this.b.exec(this.c(c));if(!u)return;const[,t,d,a]=u,f=g.a.get(d);if(f!==void 0)return console.warn(`${d} as been renamed to ${f}, please update your imports`),t+f+a}c(c){return c.replace(/\\/g,"/")}};s=g=Ke([We(0,E.$UO)],s);class o{constructor(c,u,t,d,a){this.c=c,this.d=u,this.e=t,this.f=d,this.g=a,this.nodeModuleName="vscode",this.a=new $.$Tm}load(c,u){const t=this.d.findSubstr(u);if(t){let d=this.a.get(t.identifier);return d||(d=this.c(t,this.e,this.f),this.a.set(t.identifier,d)),d}if(!this.b){let d="";this.d.forEach((a,f)=>d+=`	${f} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${u}. These are the extension path mappings: 
${d}`),this.b=this.c(A.$JG,this.e,this.f)}return this.b}}let n=class{constructor(c,u,t){this.e=c,this.f=u,this.nodeModuleName=["open","opn"],this.d=t.getProxy(M.$dM.MainThreadTelemetry);const d=t.getProxy(M.$dM.MainThreadWindow);this.c=(a,f)=>{const w=O.URI.parse(a);return f?this.g(a,f):w.scheme==="http"||w.scheme==="https"?d.$openUri(w,a,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?d.$openUri(w,a,{}):this.g(a,f)}}load(c,u,t){const d=this.e.findSubstr(u);return d&&(this.a=d.identifier.value,this.h()),this.b=t(c),this.c}g(c,u){return this.i(),this.b(c,u)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Ke([We(2,m.$EO)],n)}),define(Se[122],Ie([1,0,43,6,19,75,3,68,67,41,7,39,234,40]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zmc=e.$ymc=void 0,e.$ymc=(0,A.$wi)("IExtHostVariableResolverProvider");class g extends l.$IP{constructor(o,n,i,c,u,t,d){function a(){if(i){const f=i.activeEditor();if(f)return f.document.uri;const w=c.tabGroups.all.find(p=>p.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof T.$4N||w.input instanceof T.$9N)return w.input.modified;if(w.input instanceof T.$3N||w.input instanceof T.$8N||w.input instanceof T.$6N)return w.input.uri}}}super({getFolderUri:f=>{const w=t.folders.filter(p=>p.name===f);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(f,w)=>u.getConfiguration(void 0,f).get(w),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const f=a();if(f)return M.$hc(f.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const f=a();if(f){const w=n.getWorkspaceFolder(f);if(w)return M.$hc(w.uri.fsPath)}}},getSelectedText:()=>{if(i){const f=i.activeEditor();if(f&&!f.selection.isEmpty)return f.document.getText(f.selection)}},getLineNumber:()=>{if(i){const f=i.activeEditor();if(f)return String(f.selection.end.line+1)}},getExtension:f=>o.getExtension(f)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(N.env))}}let r=class extends O.$Uc{constructor(o,n,i,c,u){super(),this.b=o,this.c=n,this.g=i,this.h=c,this.j=u,this.a=new P.$V(async()=>{const t=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async f=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new g(this.b,this.c,this.g,this.j,t,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$zmc=r,e.$zmc=r=Ke([We(0,E.$vmc),We(1,S.$Rlc),We(2,$.$PO),We(3,b.$Ulc),We(4,m.$7lc)],r)}),define(Se[123],Ie([1,0,11,5,2,20,3,4,67,41,17,7,39,226,228,40,122,6,36,35,8,18]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g,r,s,o,n,i,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=e.$Dmc=e.$Cmc=e.$Bmc=e.$Amc=void 0,e.$Amc=(0,A.$wi)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(y,h,D,k,C,I,W){this.N=h,this.O=D,this.P=k,this.Q=C,this.R=I,this.S=W,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new O.$de,this.o=new O.$de,this.q=new O.$de,this.w=new O.$de,this.l=y.getProxy($.$dM.MainThreadDebugService),this.A=new O.$de,this.C=new O.$de,this.y=new a(this.l),this.z=new Map,this.O.getExtensionRegistry().then(V=>{V.onDidChange(q=>{this.V(V)}),this.V(V)})}async $getVisualizerTreeItem(y,h){const D=this.W(h);if(!D)return;const k=await this.H.get(y)?.getTreeItem?.(D);return k?this.U(y,k):void 0}registerDebugVisualizationTree(y,h,D){const k=N.$Rm.toKey(y.identifier),C=this.jb(k,h);if(this.G.has(C))throw new Error(`A debug visualization provider with id '${h}' is already registered`);return this.H.set(C,D),this.l.$registerDebugVisualizerTree(C,!!D.editItem),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(C),this.H.delete(h)})}async $getVisualizerTreeItemChildren(y,h){const D=this.J.get(h)?.item;return D?(await this.H.get(y)?.getChildren?.(D))?.map(C=>this.U(y,C))||[]:[]}async $editVisualizerTreeItem(y,h){const D=this.J.get(y);if(!D)return;const k=await this.H.get(D.provider)?.editItem?.(D.item,h);return this.U(D.provider,k||D.item)}$disposeVisualizedTree(y){const h=this.J.get(y);if(!h)return;const D=[h.children];for(const k of D)if(k)for(const C of k)D.push(this.J.get(C)?.children),this.J.delete(C)}U(y,h){let D=this.I.get(h);return D||(D=this.F++,this.I.set(h,D),this.J.set(D,{provider:y,item:h})),c.DebugTreeItem.from(h,D)}asDebugSourceUri(y,h){const D=y;if(typeof D.sourceReference=="number"&&D.sourceReference>0){let k=`debug:${encodeURIComponent(D.path||"")}`,C="?";return h&&(k+=`${C}session=${encodeURIComponent(h.id)}`,C="&"),k+=`${C}ref=${D.sourceReference}`,M.URI.parse(k)}else{if(D.path)return M.URI.file(D.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(y){const h=[];for(const D of y.getAllExtensionDescriptions())if(D.contributes){const k=D.contributes.debuggers;if(k&&k.length>0)for(const C of k)(0,g.$tH)(C)&&h.push(C.type)}this.l.$registerDebugTypes(h)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const y=[];return this.z.forEach(h=>y.push(h)),y}async $resolveDebugVisualizer(y,h){const D=this.L.get(y);if(!D)throw new Error(`No debug visualizer found with id '${y}'`);let{v:k,provider:C,extensionId:I}=D;if(k.visualization||(k=await C.resolveDebugVisualization?.(k,h)||k,D.v=k),!k.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${C}'`);return this.kb(I,k.visualization)}async $executeDebugVisualizerCommand(y){const h=this.L.get(y);if(!h)throw new Error(`No debug visualizer found with id '${y}'`);const D=h.v.visualization;D&&"command"in D&&this.S.executeCommand(D.command,...D.arguments||[])}W(y){const h=this.m.get(y.sessionId);return h&&{session:h.api,variable:y.variable,containerId:y.containerId,frameId:y.frameId,threadId:y.threadId}}async $provideDebugVisualizers(y,h,D,k){const C=this.W(D),I=this.jb(y,h),W=this.G.get(I);if(!C||!W)return[];const V=await W.provideDebugVisualization(C,k);return V?V.map(q=>{const R=++this.M;this.L.set(R,{v:q,provider:W,extensionId:y});const B=q.iconPath?this.lb(q.iconPath):void 0;return{id:R,name:q.name,iconClass:B?.iconClass,iconPath:B?.iconPath,visualization:this.kb(y,q.visualization)}}):[]}$disposeDebugVisualizers(y){for(const h of y)this.L.delete(h)}registerDebugVisualizationProvider(y,h,D){if(!y.contributes?.debugVisualizers?.some(I=>I.id===h))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${h})`);const k=N.$Rm.toKey(y.identifier),C=this.jb(k,h);if(this.G.has(C))throw new Error(`A debug visualization provider with id '${h}' is already registered`);return this.G.set(C,D),this.l.$registerDebugVisualizer(k,h),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizer(k,h),this.G.delete(h)})}addBreakpoints(y){const h=y.filter(C=>{const I=C.id;return this.z.has(I)?!1:(this.z.set(I,C),!0)});this.gb(h,[],[]);const D=[],k=new Map;for(const C of h)if(C instanceof S.$hN){let I=k.get(C.location.uri.toString());I||(I={type:"sourceMulti",uri:C.location.uri,lines:[]},k.set(C.location.uri.toString(),I),D.push(I)),I.lines.push({id:C.id,enabled:C.enabled,condition:C.condition,hitCondition:C.hitCondition,logMessage:C.logMessage,line:C.location.range.start.line,character:C.location.range.start.character,mode:C.mode})}else C instanceof S.$iN&&D.push({type:"function",id:C.id,enabled:C.enabled,hitCondition:C.hitCondition,logMessage:C.logMessage,condition:C.condition,functionName:C.functionName,mode:C.mode});return this.l.$registerBreakpoints(D)}removeBreakpoints(y){const h=y.filter(I=>this.z.delete(I.id));this.gb([],h,[]);const D=h.filter(I=>I instanceof S.$hN).map(I=>I.id),k=h.filter(I=>I instanceof S.$iN).map(I=>I.id),C=h.filter(I=>I instanceof S.$jN).map(I=>I.id);return this.l.$unregisterBreakpoints(D,k,C)}startDebugging(y,h,D){return this.l.$startDebugging(y?y.uri:void 0,h,{parentSessionID:D.parentSession?D.parentSession.id:void 0,lifecycleManagedByParent:D.lifecycleManagedByParent,repl:D.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:D.noDebug,compact:D.compact,suppressSaveBeforeStart:D.suppressSaveBeforeStart,suppressDebugStatusbar:D.suppressDebugStatusbar??D.debugUI?.simple,suppressDebugToolbar:D.suppressDebugToolbar??D.debugUI?.simple,suppressDebugView:D.suppressDebugView??D.debugUI?.simple})}stopDebugging(y){return this.l.$stopDebugging(y?y.id:void 0)}registerDebugConfigurationProvider(y,h,D){if(!h)return new S.$fM(()=>{});const k=this.d++;return this.f.push({type:y,handle:k,provider:h}),this.l.$registerDebugConfigurationProvider(y,D,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,k),new S.$fM(()=>{this.f=this.f.filter(C=>C.provider!==h),this.l.$unregisterDebugConfigurationProvider(k)})}registerDebugAdapterDescriptorFactory(y,h,D){if(!D)return new S.$fM(()=>{});if(!this.cb(y,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.$(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const k=this.g++;return this.h.push({type:h,handle:k,factory:D}),this.l.$registerDebugAdapterDescriptorFactory(h,k),new S.$fM(()=>{this.h=this.h.filter(C=>C.factory!==D),this.l.$unregisterDebugAdapterDescriptorFactory(k)})}registerDebugAdapterTrackerFactory(y,h){if(!h)return new S.$fM(()=>{});const D=this.j++;return this.k.push({type:y,handle:D,factory:h}),new S.$fM(()=>{this.k=this.k.filter(k=>k.factory!==h)})}async $runInTerminal(y,h){return Promise.resolve(void 0)}async $substituteVariables(y,h){let D;const k=await this.ib(y);return k&&(D={uri:k.uri,name:k.name,index:k.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(D,h)}X(y,h){if(y.type==="implementation")return new w(y.implementation)}Y(){}async $startDASession(y,h){const D=this,k=await this.hb(h);return this.eb(this.$(k.type),k).then(C=>{if(!C)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}' (extension might have failed to activate)`);const I=this.Z(C),W=this.X(I,k);if(!W)throw new Error(`Couldn't create a debug adapter for type '${k.type}'.`);const V=W;return this.D.set(y,V),this.db(k).then(q=>(q&&this.E.set(y,q),V.onMessage(async R=>{if(R.type==="request"&&R.command==="handshake"){const B=R,K={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const ie=await this.K.sign(B.arguments.value);K.body={signature:ie},V.sendResponse(K)}else throw new Error("no signer")}catch(ie){K.success=!1,K.message=ie.message,V.sendResponse(K)}}else q&&q.onDidSendMessage&&q.onDidSendMessage(R),R=(0,g.$yH)(R,!0),D.l.$acceptDAMessage(y,R)}),V.onError(R=>{q&&q.onError&&q.onError(R),this.l.$acceptDAError(y,R.name,R.message,R.stack)}),V.onExit(R=>{q&&q.onExit&&q.onExit(R??void 0,void 0),this.l.$acceptDAExit(y,R??void 0,void 0)}),q&&q.onWillStartSession&&q.onWillStartSession(),V.startSession()))})}$sendDAMessage(y,h){h=(0,g.$xH)(h,!1);const D=this.E.get(y);D&&D.onWillReceiveMessage&&D.onWillReceiveMessage(h),this.D.get(y)?.sendMessage(h)}$stopDASession(y){const h=this.E.get(y);this.E.delete(y),h&&h.onWillStopSession&&h.onWillStopSession();const D=this.D.get(y);return this.D.delete(y),D?D.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(y){const h=[],D=[],k=[];if(y.added)for(const C of y.added){const I=C.id;if(I&&!this.z.has(I)){let W;if(C.type==="function")W=new S.$iN(C.functionName,C.enabled,C.condition,C.hitCondition,C.logMessage,C.mode);else if(C.type==="data")W=new S.$jN(C.label,C.dataId,C.canPersist,C.enabled,C.hitCondition,C.condition,C.logMessage,C.mode);else{const V=M.URI.revive(C.uri);W=new S.$hN(new S.$rM(V,new S.$gM(C.line,C.character)),C.enabled,C.condition,C.hitCondition,C.logMessage,C.mode)}(0,S.$fN)(W,I),this.z.set(I,W),h.push(W)}}if(y.removed)for(const C of y.removed){const I=this.z.get(C);I&&(this.z.delete(C),D.push(I))}if(y.changed){for(const C of y.changed)if(C.id){const I=this.z.get(C.id);if(I){if(I instanceof S.$iN&&C.type==="function"){const W=I;W.enabled=C.enabled,W.condition=C.condition,W.hitCondition=C.hitCondition,W.logMessage=C.logMessage,W.functionName=C.functionName}else if(I instanceof S.$hN&&C.type==="source"){const W=I;W.enabled=C.enabled,W.condition=C.condition,W.hitCondition=C.hitCondition,W.logMessage=C.logMessage,W.location=new S.$rM(M.URI.revive(C.uri),new S.$gM(C.line,C.character))}k.push(I)}}}this.gb(h,D,k)}async $acceptStackFrameFocus(y){let h;if(y){const D=await this.hb(y.sessionId);y.kind==="thread"?h=new S.$pN(D.api,y.threadId):h=new S.$oN(D.api,y.threadId,y.frameId)}this.B=h,this.C.fire(this.B)}$provideDebugConfigurations(y,h,D){return(0,P.$oh)(async()=>{const k=this.bb(y);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const C=await this.ib(h);return k.provideDebugConfigurations(C,D)}).then(k=>{if(!k)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return k})}$resolveDebugConfiguration(y,h,D,k){return(0,P.$oh)(async()=>{const C=this.bb(y);if(!C)throw new Error("no DebugConfigurationProvider found");if(!C.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.ib(h);return C.resolveDebugConfiguration(I,D,k)})}$resolveDebugConfigurationWithSubstitutedVariables(y,h,D,k){return(0,P.$oh)(async()=>{const C=this.bb(y);if(!C)throw new Error("no DebugConfigurationProvider found");if(!C.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.ib(h);return C.resolveDebugConfigurationWithSubstitutedVariables(I,D,k)})}async $provideDebugAdapter(y,h){const D=this.ab(y);if(!D)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const k=await this.hb(h);return this.eb(D,k).then(C=>{if(!C)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}'`);return this.Z(C)})}async $acceptDebugSessionStarted(y){const h=await this.hb(y);this.n.fire(h.api)}async $acceptDebugSessionTerminated(y){const h=await this.hb(y);h&&(this.o.fire(h.api),this.m.delete(h.id))}async $acceptDebugSessionActiveChanged(y){this.u=y?await this.hb(y):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(y,h){(await this.hb(y))?._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(y,h){const k={session:(await this.hb(y)).api,event:h.event,body:h.body};this.w.fire(k)}Z(y){if(y instanceof S.$kN)return{type:"executable",command:y.command,args:y.args,options:y.options};if(y instanceof S.$lN)return{type:"server",port:y.port,host:y.host};if(y instanceof S.$mN)return{type:"pipeServer",path:y.path};if(y instanceof S.$nN)return{type:"implementation",implementation:y.implementation};throw new Error("convertToDto unexpected type")}$(y){const h=this.h.filter(D=>D.type===y);if(h.length>0)return h[0].factory}ab(y){const h=this.h.filter(D=>D.handle===y);if(h.length>0)return h[0].factory}bb(y){const h=this.f.filter(D=>D.handle===y);if(h.length>0)return h[0].provider}cb(y,h){if(y.contributes){const D=y.contributes.debuggers;if(D&&D.length>0){for(const k of D)if(k.label&&k.type&&k.type===h)return!0}}return!1}db(y){const D=y.configuration.type,k=this.k.filter(C=>C.type===D||C.type==="*").map(C=>(0,P.$oh)(()=>C.factory.createDebugAdapterTracker(y.api)).then(I=>I,I=>null));return Promise.race([Promise.all(k).then(C=>{const I=(0,u.$Hb)(C);if(I.length>0)return new f(I)}),new Promise(C=>setTimeout(()=>C(void 0),1e3))]).catch(C=>{})}async eb(y,h){const D=h.configuration.debugServer;if(typeof D=="number")return Promise.resolve(new S.$lN(D));if(y){const C=await this.O.getExtensionRegistry();return(0,P.$oh)(()=>y.createDebugAdapterDescriptor(h.api,this.fb(h,C))).then(I=>{if(I)return I})}const k=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(h,k))}fb(y,h){}gb(y,h,D){(y.length>0||h.length>0||D.length>0)&&this.A.fire(Object.freeze({added:y,removed:h,changed:D}))}async hb(y){if(y)if(typeof y=="string"){const h=this.m.get(y);if(h)return h}else{let h=this.m.get(y.id);if(!h){const D=await this.ib(y.folderUri),k=y.parent?this.m.get(y.parent):void 0;h=new d(this.l,y.id,y.type,y.name,D,y.configuration,k?.api),this.m.set(h.id,h),this.l.$sessionCached(h.id)}return h}throw new Error("cannot find session")}ib(y){if(y){const h=M.URI.revive(y);return this.N.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}jb(y,h){return`${y}\0${h}`}kb(y,h){if(h){if("title"in h&&"command"in h)return{type:0};if("treeId"in h)return{type:1,id:`${y}\0${h.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(y){const h=this.mb(y);let D,k;return"id"in h?k=n.ThemeIcon.asClassName(h):D=h,{iconPath:D,iconClass:k}}mb(y){if(y instanceof S.$cN)return{id:y.id};const h=typeof y=="object"&&"dark"in y?y.dark:y,D=typeof y=="object"&&"light"in y?y.light:y;return{dark:typeof h=="string"?M.URI.file(h):h,light:typeof D=="string"?M.URI.file(D):D}}};e.$Bmc=t,e.$Bmc=t=Ke([We(0,T.$EO),We(1,l.$Rlc),We(2,E.$vmc),We(3,r.$Ulc),We(4,m.$7lc),We(5,s.$ymc),We(6,i.$1O)],t);class d{constructor(y,h,D,k,C,I,W){this.f=y,this.g=h,this.h=D,this.j=k,this.k=C,this.l=I,this.m=W}get api(){const y=this;return this.d??=Object.freeze({id:y.g,type:y.h,get name(){return y.j},set name(h){y.j=h,y.f.$setDebugSessionName(y.g,h)},parentSession:y.m,workspaceFolder:y.k,configuration:y.l,customRequest(h,D){return y.f.$customDebugAdapterRequest(y.g,h,D)},getDebugProtocolBreakpoint(h){return y.f.$getDebugProtocolBreakpoint(y.g,h.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(y){this.j=y}get configuration(){return this.l}}e.$Cmc=d;class a{constructor(y){this.value=Object.freeze({append(h){y.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.$Dmc=a;class f{constructor(y){this.d=y}onWillStartSession(){this.d.forEach(y=>y.onWillStartSession?y.onWillStartSession():void 0)}onWillReceiveMessage(y){this.d.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(y):void 0)}onDidSendMessage(y){this.d.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(y):void 0)}onWillStopSession(){this.d.forEach(y=>y.onWillStopSession?y.onWillStopSession():void 0)}onError(y){this.d.forEach(h=>h.onError?h.onError(y):void 0)}onExit(y,h){this.d.forEach(D=>D.onExit?D.onExit(y,h):void 0)}}class w extends b.$2rb{constructor(y){super(),this.h=y,y.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(y){this.h.handleMessage(y)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let p=class extends t{constructor(y,h,D,k,C,I,W){super(y,h,D,k,C,I,W)}};e.$Emc=p,e.$Emc=p=Ke([We(0,T.$EO),We(1,l.$Rlc),We(2,E.$vmc),We(3,r.$Ulc),We(4,m.$7lc),We(5,s.$ymc),We(6,i.$1O)],p)}),define(Se[304],Ie([1,0,14,60,2,4,254,12,56,72,27,199,17,61,41,63]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hnc=e.$Gnc=void 0;class s{static async installEarlyHandler(i){Error.stackTraceLimit=100;const c=i.get($.$3j),t=i.get(l.$EO).getProxy(N.$dM.MainThreadErrors);P.setUnexpectedErrorHandler(d=>{c.error(d);const a=P.$3(d);t.$onUnexpectedError(a)})}static async installFullHandler(i){const c=i.get($.$3j),u=i.get(l.$EO),t=i.get(g.$vmc),d=i.get(r.$YO),a=u.getProxy(N.$dM.MainThreadExtensionService),f=u.getProxy(N.$dM.MainThreadErrors),w=await t.getExtensionPathIndex(),p=new WeakMap;function v(D,k){if(p.has(D))return p.get(D).stack;let C="",I,W;for(const q of k)C+=`
	at ${q.toString()}`,W=q.getFileName(),!I&&W&&(I=w.findSubstr(M.URI.file(W)));const V=`${D.name||"Error"}: ${D.message||""}${C}`;return p.set(D,{extensionIdentifier:I?.identifier,stack:V}),V}const y=Symbol("prepareStackTrace wrapped");let h=v;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return h},set(D){if(D===v||!D||D[y]){h=D||v;return}h=function(k,C){return v(k,C),D.call(Error,k,C)},Object.assign(h,{[y]:!0})}}),P.setUnexpectedErrorHandler(D=>{c.error(D);const k=P.$3(D),C=p.get(D);if(!C?.extensionIdentifier){f.$onUnexpectedError(k);return}a.$onExtensionRuntimeError(C.extensionIdentifier,k);const I=d.onExtensionError(C.extensionIdentifier,D);c.trace("forwarded error to extension?",I,C)})}}e.$Gnc=s;class o{constructor(i,c,u,t,d){this.a=u,this.b=new A.$cac(i,null,t),c=o.e(c,this.b);const a=new E.$ui(...(0,m.$ys)());a.set(T.$UO,{_serviceBrand:void 0,...c,messagePorts:d}),a.set(l.$EO,new l.$FO(this.b)),a.set(b.$Olc,new b.$Plc(t)),a.set(g.$tmc,u);const f=new S.$cr(a,!0);f.invokeFunction(s.installEarlyHandler),this.d=f.invokeFunction(w=>w.get($.$3j)),O.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=f.invokeFunction(w=>w.get(g.$vmc)),this.c.initialize(),f.invokeFunction(s.installFullHandler)}async asBrowserUri(i){const c=this.b.getProxy(N.$dM.MainThreadExtensionService);return M.URI.revive(await c.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,c){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=M.URI.revive(c.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=M.URI.revive(c.transformIncomingURIs(i.environment.appRoot));const u=i.environment.extensionDevelopmentLocationURI;return u&&(i.environment.extensionDevelopmentLocationURI=u.map(t=>M.URI.revive(c.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=M.URI.revive(c.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=M.URI.revive(c.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=M.URI.revive(c.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=M.URI.revive(c.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=M.URI.revive(c.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=M.URI.revive(c.transformIncomingURIs(i.logsLocation)),i.workspace=c.transformIncomingURIs(i.workspace),i}}e.$Hnc=o}),define(Se[305],Ie([1,0,18,11,24,44,16,19,23,2,47]),function(he,e,P,O,M,N,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Umc=e.$Smc=e.$Rmc=void 0,e.$Tmc=r;class S{constructor(n,i,c){this.d=n,this.e=i,this.f=c,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const c=this.g.folderQueries||[],u=new M.$oe(i);return new Promise((t,d)=>{this.a=new b(n);let a=!1;const f=(w,p)=>{if(!a&&!this.b){const v=this.h(w);r(w)&&typeof this.g.maxResults=="number"&&this.c+v>this.g.maxResults&&(this.b=!0,a=!0,u.cancel(),w=this.j(w,this.g.maxResults-this.c));const y=this.h(w);this.c+=y,(y>0||!r(w))&&this.a.add(w,p)}};Promise.all(c.map((w,p)=>this.k(w,v=>f(v,p),u.token))).then(w=>{u.dispose(),this.a.flush();const p=w.some(v=>!!v&&!!v.limitHit);t({limitHit:this.b||p,messages:w.flatMap(v=>v?.message?Array.isArray(v.message)?v.message:[v.message]:[]),stats:{type:this.f}})},w=>{u.dispose();const p=(0,N.$hj)(w);d(new Error(p))})})}h(n){return r(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],u=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,i),preview:{matches:u.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,c){const u=new T.$JK(this.g,n),t=[],d={report:w=>{if(!this.l(w))return;const p=n.folder.scheme===A.Schemas.file?(0,T.$KK)(()=>this.e.readdir(m.$9g(w.uri))):void 0,v=m.$_g(n.folder,w.uri);if(v){const y=u.includedInQuery(v,$.$nc(v),p);(0,O.$ih)(y)?t.push(y.then(h=>{h&&i(w)})):y&&i(w)}}},a=this.n(n);let f;return this.d.query.type===3?f=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,a,d,c):f=await this.d.provider.provideTextSearchResults(l(this.d.query.contentPattern),a,d,c),t.length&&await Promise.all(t),f}l(n){if(r(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,T.$IK)(this.g.includePattern,n.includePattern),c=(0,T.$IK)(this.g.excludePattern,n.excludePattern),u={folder:E.URI.from(n.folder),excludes:c,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??Number.MAX_SAFE_INTEGER,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(u.usePCRE2=this.g.usePCRE2),u}}e.$Rmc=S;function l(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class b{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new s(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!m.$3g(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(g(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$Smc=b;function g(o){return r(o)?{preview:{matches:(0,P.$1b)(o.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:o.preview.text},ranges:(0,P.$1b)(o.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function r(o){return!!o.preview}class s{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<s.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},s.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Umc=s}),define(Se[124],Ie([1,0,6,4,3,300,17,61,12,2,305]),function(he,e,P,O,M,N,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wmc=e.$Vmc=void 0,e.$Xmc=l,e.$Vmc=(0,M.$wi)("IExtHostSearch");let S=class{constructor(r,s,o){this.n=r,this.o=s,this.q=o,this.c=this.n.getProxy(O.$dM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new N.$Qmc}s(r){return this.o.transformOutgoingScheme(r)}registerTextSearchProvider(r,s){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const o=this.d++;return this.e.set(o,s),this.c.$registerTextSearchProvider(o,this.s(r)),(0,P.$Sc)(()=>{this.g.delete(r),this.e.delete(o),this.c.$unregisterProvider(o)})}registerAITextSearchProvider(r,s){if(this.i.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this.i.add(r);const o=this.d++;return this.h.set(o,s),this.c.$registerAITextSearchProvider(o,this.s(r)),(0,P.$Sc)(()=>{this.i.delete(r),this.h.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(r,s){if(this.k.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.k.add(r);const o=this.d++;return this.j.set(o,s),this.c.$registerFileSearchProvider(o,this.s(r)),(0,P.$Sc)(()=>{this.k.delete(r),this.j.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(r,s,o,n){const i=l(o),c=this.j.get(r);if(c)return this.l.fileSearch(i,c,u=>{this.c.$handleFileMatch(r,s,u.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,s,o){return{messages:[]}}$clearCache(r){return this.l.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,s,o,n){const i=this.e.get(r);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${r}`);const c=l(o);return this.t(c,i).search(t=>this.c.$handleTextMatch(r,s,t),n)}$provideAITextSearchResults(r,s,o,n){const i=this.h.get(r);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${r}`);const c=l(o);return this.v(c,i).search(t=>this.c.$handleTextMatch(r,s,t),n)}$enableExtensionHostSearch(){}t(r,s){return new T.$Rmc({query:r,provider:s},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}v(r,s){return new T.$Rmc({query:r,provider:s},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"aiTextSearchProvider")}};e.$Wmc=S,e.$Wmc=S=Ke([We(0,A.$EO),We(1,$.$Olc),We(2,m.$3j)],S);function l(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(b),extraFileResources:g.extraFileResources&&g.extraFileResources.map(r=>E.URI.revive(r))}}function b(g){return{...g,folder:E.URI.revive(g.folder)}}}),define(Se[306],Ie([1,0,24,14,5,6,16,32,2,158,154,141,95,20,38,12,58,59,213,4,257,285,80,86,262,263,264,243,232,35,265,40,266,123,112,267,245,258,268,269,68,67,259,41,271,65,272,46,27,286,246,273,90,274,81,82,248,299,276,219,277,287,278,118,249,279,280,281,17,282,124,83,283,250,284,84,87,121,63,53,116,288,289,260,290,291,88,8,7,251,61,252,64,292,293,111,39,227,79,26,120]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g,r,s,o,n,i,c,u,t,d,a,f,w,p,v,y,h,D,k,C,I,W,V,q,R,B,K,ie,ce,ve,ke,fe,pe,Ne,ae,Re,ne,z,x,be,Te,De,we,ge,Q,Y,le,ue,Oe,de,Ce,Me,je,U,F,G,H,ee,re,Ae,Be,qe,et,xe,_e,tt,rt,ct,ft,Ue,ot,X,Z,$e,me,Ze,at,dt,Ct,Bt,Qt,xt,Zt,kt,_t,Xe,ti){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bnc=ii;function ii(ht){const pt=ht.get(ae.$UO),Lt=ht.get(Ne.$zlc),Gt=ht.get(fe.$Wlc),Tt=ht.get(ve.$vmc),mt=ht.get(Zt.$Rlc),Pt=ht.get(_e.$YO),ai=ht.get(D.$Ulc),Ut=ht.get(at.$Olc),Je=ht.get(F.$EO),ni=ht.get(qe.$dmc),ci=ht.get(et.$Xlc),Ht=ht.get(r.$4j),gt=ht.get(r.$3j),At=ht.get(Z.$CDb),Ot=ht.get(t.$vlc),Nt=ht.get(xt.$Anc),Vt=ht.get(ee.$nmc),Xt=ht.get(ie.$7lc),Kt=ht.get(De.$rmc),zt=ht.get(d.$Flc),Mt=ht.get(x.$kmc);Je.set(i.$eM.ExtHostFileSystemInfo,Lt),Je.set(i.$eM.ExtHostLogLevelServiceShape,Ht),Je.set(i.$eM.ExtHostWorkspace,mt),Je.set(i.$eM.ExtHostConfiguration,ai),Je.set(i.$eM.ExtHostExtensionService,Tt),Je.set(i.$eM.ExtHostStorage,ni),Je.set(i.$eM.ExtHostTunnelService,At),Je.set(i.$eM.ExtHostWindow,Nt),Je.set(i.$eM.ExtHostSecretState,Vt),Je.set(i.$eM.ExtHostTelemetry,Pt),Je.set(i.$eM.ExtHostEditorTabs,Xt),Je.set(i.$eM.ExtHostManagedSockets,Kt),Je.set(i.$eM.ExtHostAuthentication,zt),Je.set(i.$eM.ExtHostChatProvider,Mt);const Jt=Je.set(i.$eM.ExtHostDecorations,ht.get(I.$Gmc)),St=Je.set(i.$eM.ExtHostDocumentsAndEditors,ht.get(K.$PO)),yt=Je.set(i.$eM.ExtHostCommands,ht.get(y.$1O)),wt=Je.set(i.$eM.ExtHostTerminalService,ht.get(tt.$gmc)),Yt=Je.set(i.$eM.ExtHostTerminalShellIntegration,ht.get(rt.$mnc)),Et=Je.set(i.$eM.ExtHostDebugService,ht.get(C.$Amc)),ui=Je.set(i.$eM.ExtHostSearch,ht.get(H.$Vmc)),ei=Je.set(i.$eM.ExtHostTask,ht.get(xe.$lnc)),Ei=Je.set(i.$eM.ExtHostOutputService,ht.get(de.$$mc)),li=Je.set(i.$eM.ExtHostLocalization,ht.get(Te.$qmc)),fi=Je.set(i.$eM.ExtHostUrls,new dt.$xnc(Je)),Ft=Je.set(i.$eM.ExtHostDocuments,new B.$Clc(Je,St)),ye=Je.set(i.$eM.ExtHostDocumentContentProviders,new q.$Imc(Je,St,gt)),Fe=Je.set(i.$eM.ExtHostDocumentSaveParticipant,new R.$Jmc(gt,Ft,Je.getProxy(i.$dM.MainThreadBulkEdits))),se=Je.set(i.$eM.ExtHostNotebook,new ge.$Ymc(Je,yt,St,Ft,Gt,ui)),J=Je.set(i.$eM.ExtHostNotebookDocuments,new Y.$5mc(se)),Pe=Je.set(i.$eM.ExtHostNotebookEditors,new le.$6mc(gt,se)),Ve=Je.set(i.$eM.ExtHostNotebookKernels,new ue.$7mc(Je,pt,se,yt,gt)),Qe=Je.set(i.$eM.ExtHostNotebookRenderers,new Oe.$9mc(Je,se)),Ge=Je.set(i.$eM.ExtHostNotebookDocumentSaveParticipant,new Q.$4mc(gt,se,Je.getProxy(i.$dM.MainThreadBulkEdits))),it=Je.set(i.$eM.ExtHostEditors,new ft.$Llc(Je,St)),Dt=Je.set(i.$eM.ExtHostTreeViews,new X.$vnc(Je.getProxy(i.$dM.MainThreadTreeViews),yt,gt)),Wt=Je.set(i.$eM.ExtHostEditorInsets,new v.$Mlc(Je.getProxy(i.$dM.MainThreadEditorInsets),it,pt.remote)),jt=Je.set(i.$eM.ExtHostDiagnostics,new W.$Blc(Je,gt,Lt,St)),It=Je.set(i.$eM.ExtHostLanguages,new be.$2mc(Je,Ft,yt.converter,Ut)),ut=Je.set(i.$eM.ExtHostLanguageFeatures,new z.$Dlc(Je,Ut,Ft,yt,jt,gt,Ot,Pt)),Pi=Je.set(i.$eM.ExtHostFileSystem,new ke.$Lmc(Je,ut)),hi=Je.set(i.$eM.ExtHostFileSystemEventService,new pe.$Mmc(Je,gt,St)),vi=Je.set(i.$eM.ExtHostQuickOpen,(0,U.$cnc)(Je,mt,yt)),Ki=Je.set(i.$eM.ExtHostSCM,new G.$enc(Je,yt,Ft,gt)),Mi=Je.set(i.$eM.ExtHostQuickDiff,new je.$bnc(Je,Ut)),Ji=Je.set(i.$eM.ExtHostShare,new re.$fnc(Je,Ut)),Ri=Je.set(i.$eM.ExtHostComments,(0,h.$Nlc)(Je,yt,Ft)),Di=Je.set(i.$eM.ExtHostProgress,new Me.$anc(Je.getProxy(i.$dM.MainThreadProgress))),Ai=Je.set(i.$eM.ExtHostLabelService,new ne.$1mc(Je)),ki=Je.set(i.$eM.ExtHostTheming,new Ue.$snc(Je)),Qi=Je.set(i.$eM.ExtHostTimeline,new ot.$unc(Je,yt)),Si=Je.set(i.$eM.ExtHostWebviews,new Ct.$2lc(Je,pt.remote,mt,gt,Ot)),Oi=Je.set(i.$eM.ExtHostWebviewPanels,new Bt.$5lc(Je,Si,mt)),Zi=Je.set(i.$eM.ExtHostCustomEditors,new k.$6lc(Je,Ft,ci,Si,Oi)),Ni=Je.set(i.$eM.ExtHostWebviewViews,new Qt.$ync(Je,Si)),$i=Je.set(i.$eM.ExtHostTesting,new ct.$onc(Je,gt,yt,St)),Xi=Je.set(i.$eM.ExtHostUriOpeners,new Ze.$wnc(Je)),Yi=Je.set(i.$eM.ExtHostProfileContentHandlers,new Ce.$_mc(Je));Je.set(i.$eM.ExtHostInteractive,new Re.$Zmc(Je,se,St,yt,gt));const Ii=Je.set(i.$eM.ExtHostChatAgents2,new f.$Ilc(Je,gt,yt)),xi=Je.set(i.$eM.ExtHostChatVariables,new w.$Jlc(Je)),Ti=Je.set(i.$eM.ExtHostAiRelatedInformation,new c.$ulc(Je)),_i=Je.set(i.$eM.ExtHostAiEmbeddingVector,new ce.$Kmc(Je)),en=Je.set(i.$eM.ExtHostStatusBar,new Be.$inc(Je,yt.converter)),ln=Je.set(i.$eM.ExtHostSpeech,new Ae.$gnc(Je)),Fi=Object.values(i.$eM);Je.assertRegistered(Fi);const Li=new a.$Hlc(Je,St),hn=new p.$Klc(Je),zi=new we.$3mc(Je,gt),Ui=new V.$Hmc(Je);return u.$Elc.register(yt),function(ze,ri,ji){function nt(_){return(oe,Le,st)=>{const vt=_(Rt=>{try{oe.call(Le,Rt)}catch(yi){O.$2(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event: ${yi.toString()}`,{cause:yi})),Pt.onExtensionError(ze.identifier,yi)}});return st?.push(vt),vt}}const bt=function(){let _=!ze.isUnderDevelopment;function oe(){_||(gt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),_=!0)}return function Le(st){if(Array.isArray(st))st.forEach(Le);else if(typeof st=="string")oe();else{const vt=st;typeof vt.scheme>"u"&&oe(),typeof vt.exclusive=="boolean"&&(0,Xe.$PG)(ze,"documentFiltersExclusive")}return st}}(),dn={getSession(_,oe,Le){return typeof Le?.forceNewSession=="object"&&Le.forceNewSession.learnMore&&(0,Xe.$PG)(ze,"authLearnMore"),zt.getSession(ze,_,oe,Le)},getSessions(_,oe){return(0,Xe.$PG)(ze,"authGetSessions"),zt.getSessions(ze,_,oe)},async hasSession(_,oe){return(0,Xe.$PG)(ze,"authSession"),!!await zt.getSession(ze,_,oe,{silent:!0})},get onDidChangeSessions(){return nt(zt.onDidChangeSessions)},registerAuthenticationProvider(_,oe,Le,st){return zt.registerAuthenticationProvider(_,oe,Le,st)}},Bi={registerCommand(_,oe,Le){return yt.registerCommand(!0,_,oe,Le,void 0,ze)},registerTextEditorCommand(_,oe,Le){return yt.registerCommand(!0,_,(...st)=>{const vt=it.getActiveTextEditor();if(!vt){gt.warn("Cannot execute "+_+" because there is no active text editor.");return}return vt.edit(Rt=>{oe.apply(Le,[vt,Rt,...st])}).then(Rt=>{Rt||gt.warn("Edits from command "+_+" were not applied.")},Rt=>{gt.warn("An error occurred while running command "+_,Rt)})},void 0,void 0,ze)},registerDiffInformationCommand:(_,oe,Le)=>((0,Xe.$PG)(ze,"diffCommand"),yt.registerCommand(!0,_,async(...st)=>{const vt=St.activeEditor(!0);if(!vt){gt.warn("Cannot execute "+_+" because there is no active text editor.");return}const Rt=await it.getDiffInformation(vt.id);oe.apply(Le,[Rt,...st])},void 0,void 0,ze)),executeCommand(_,...oe){return yt.executeCommand(_,...oe)},getCommands(_=!1){return yt.getCommands(_)}},Vi={get machineId(){return pt.telemetryInfo.machineId},get sessionId(){return pt.telemetryInfo.sessionId},get language(){return pt.environment.appLanguage},get appName(){return pt.environment.appName},get appRoot(){return pt.environment.appRoot?.fsPath??""},get appHost(){return pt.environment.appHost},get uriScheme(){return pt.environment.appUriScheme},get clipboard(){return hn.value},get shell(){return wt.getDefaultShell(!1)},get onDidChangeShell(){return nt(wt.onDidChangeShell)},get isTelemetryEnabled(){return Pt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return nt(Pt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.$PG)(ze,"telemetry"),Pt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$PG)(ze,"telemetry"),nt(Pt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,_e.$XO)(pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(_,oe){return _e.$WO.validateSender(_),Pt.instantiateLogger(ze,_,oe)},openExternal(_,oe){return Nt.openUri(_,{allowTunneling:!!pt.remote.authority,allowContributedOpeners:oe?.allowContributedOpeners})},async asExternalUri(_){if(_.scheme===pt.environment.appUriScheme)return fi.createAppUri(_);try{return await Nt.asExternalUri(_,{allowTunneling:!!pt.remote.authority})}catch(oe){if((0,A.$Fg)(_,A.Schemas.http)||(0,A.$Fg)(_,A.Schemas.https))return _;throw oe}},get remoteName(){return(0,s.$Im)(pt.remote.authority)},get remoteAuthority(){return(0,Xe.$PG)(ze,"resolvers"),pt.remote.authority},get uiKind(){return pt.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return nt(gt.onDidChangeLogLevel)},get appQuality(){return(0,Xe.$PG)(ze,"resolvers"),pt.quality},get appCommit(){return(0,Xe.$PG)(ze,"resolvers"),pt.commit}};pt.environment.extensionTestsLocationURI||Object.freeze(Vi);const gi={createTestController(_,oe,Le){return $i.createTestController(ze,_,oe,Le)},createTestObserver(){return(0,Xe.$PG)(ze,"testObserver"),$i.createTestObserver()},runTests(_){return(0,Xe.$PG)(ze,"testObserver"),$i.runTests(_)},get onDidChangeTestResults(){return(0,Xe.$PG)(ze,"testObserver"),nt($i.onResultsChanged)},get testResults(){return(0,Xe.$PG)(ze,"testObserver"),$i.results}},pi=pt.remote.isRemote?me.ExtensionKind.Workspace:me.ExtensionKind.UI,fn={getExtension(_,oe){(0,Xe.$OG)(ze,"extensionsAny")||(oe=!1);const Le=ri.mine.getExtensionDescription(_);if(Le)return new ve.$wmc(Tt,ze.identifier,Le,pi,!1);if(oe){const st=ri.all.getExtensionDescription(_);if(st)return new ve.$wmc(Tt,ze.identifier,st,pi,!0)}},get all(){const _=[];for(const oe of ri.mine.getAllExtensionDescriptions())_.push(new ve.$wmc(Tt,ze.identifier,oe,pi,!1));return _},get allAcrossExtensionHosts(){(0,Xe.$PG)(ze,"extensionsAny");const _=new b.$Sm(ri.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),oe=[];for(const Le of ri.all.getAllExtensionDescriptions()){const st=!_.has(Le.identifier);oe.push(new ve.$wmc(Tt,ze.identifier,Le,pi,st))}return oe},get onDidChange(){return(0,Xe.$OG)(ze,"extensionsAny")?nt(M.Event.any(ri.mine.onDidChange,ri.all.onDidChange)):nt(ri.mine.onDidChange)}},si={createDiagnosticCollection(_){return jt.createDiagnosticCollection(ze.identifier,_)},get onDidChangeDiagnostics(){return nt(jt.onDidChangeDiagnostics)},getDiagnostics:_=>jt.getDiagnostics(_),getLanguages(){return It.getLanguages()},setTextDocumentLanguage(_,oe){return It.changeLanguage(_.uri,oe)},match(_,oe){const Le=$e.LanguageSelector.from(_);let st;return(0,T.$Yt)(Le)&&(st=se.notebookDocuments.find(vt=>vt.apiNotebook.getCells().find(Rt=>Rt.document===oe))?.apiNotebook),(0,T.$Xt)(Le,oe.uri,oe.languageId,!0,st?.uri,st?.notebookType)},registerCodeActionsProvider(_,oe,Le){return ut.registerCodeActionProvider(ze,bt(_),oe,Le)},registerDocumentPasteEditProvider(_,oe,Le){return(0,Xe.$PG)(ze,"documentPaste"),ut.registerDocumentPasteEditProvider(ze,bt(_),oe,Le)},registerCodeLensProvider(_,oe){return ut.registerCodeLensProvider(ze,bt(_),oe)},registerDefinitionProvider(_,oe){return ut.registerDefinitionProvider(ze,bt(_),oe)},registerDeclarationProvider(_,oe){return ut.registerDeclarationProvider(ze,bt(_),oe)},registerImplementationProvider(_,oe){return ut.registerImplementationProvider(ze,bt(_),oe)},registerTypeDefinitionProvider(_,oe){return ut.registerTypeDefinitionProvider(ze,bt(_),oe)},registerHoverProvider(_,oe){return ut.registerHoverProvider(ze,bt(_),oe,ze.identifier)},registerEvaluatableExpressionProvider(_,oe){return ut.registerEvaluatableExpressionProvider(ze,bt(_),oe,ze.identifier)},registerInlineValuesProvider(_,oe){return ut.registerInlineValuesProvider(ze,bt(_),oe,ze.identifier)},registerDocumentHighlightProvider(_,oe){return ut.registerDocumentHighlightProvider(ze,bt(_),oe)},registerMultiDocumentHighlightProvider(_,oe){return ut.registerMultiDocumentHighlightProvider(ze,bt(_),oe)},registerLinkedEditingRangeProvider(_,oe){return ut.registerLinkedEditingRangeProvider(ze,bt(_),oe)},registerReferenceProvider(_,oe){return ut.registerReferenceProvider(ze,bt(_),oe)},registerRenameProvider(_,oe){return ut.registerRenameProvider(ze,bt(_),oe)},registerNewSymbolNamesProvider(_,oe){return(0,Xe.$PG)(ze,"newSymbolNamesProvider"),ut.registerNewSymbolNamesProvider(ze,bt(_),oe)},registerDocumentSymbolProvider(_,oe,Le){return ut.registerDocumentSymbolProvider(ze,bt(_),oe,Le)},registerWorkspaceSymbolProvider(_){return ut.registerWorkspaceSymbolProvider(ze,_)},registerDocumentFormattingEditProvider(_,oe){return ut.registerDocumentFormattingEditProvider(ze,bt(_),oe)},registerDocumentRangeFormattingEditProvider(_,oe){return ut.registerDocumentRangeFormattingEditProvider(ze,bt(_),oe)},registerOnTypeFormattingEditProvider(_,oe,Le,...st){return ut.registerOnTypeFormattingEditProvider(ze,bt(_),oe,[Le].concat(st))},registerDocumentSemanticTokensProvider(_,oe,Le){return ut.registerDocumentSemanticTokensProvider(ze,bt(_),oe,Le)},registerDocumentRangeSemanticTokensProvider(_,oe,Le){return ut.registerDocumentRangeSemanticTokensProvider(ze,bt(_),oe,Le)},registerSignatureHelpProvider(_,oe,Le,...st){return typeof Le=="object"?ut.registerSignatureHelpProvider(ze,bt(_),oe,Le):ut.registerSignatureHelpProvider(ze,bt(_),oe,typeof Le>"u"?[]:[Le,...st])},registerCompletionItemProvider(_,oe,...Le){return ut.registerCompletionItemProvider(ze,bt(_),oe,Le)},registerInlineCompletionItemProvider(_,oe,Le){return oe.handleDidShowCompletionItem&&(0,Xe.$PG)(ze,"inlineCompletionsAdditions"),oe.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$PG)(ze,"inlineCompletionsAdditions"),Le&&(0,Xe.$PG)(ze,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(ze,bt(_),oe,Le)},registerInlineEditProvider(_,oe){return(0,Xe.$PG)(ze,"inlineEdit"),ut.registerInlineEditProvider(ze,bt(_),oe)},registerDocumentLinkProvider(_,oe){return ut.registerDocumentLinkProvider(ze,bt(_),oe)},registerColorProvider(_,oe){return ut.registerColorProvider(ze,bt(_),oe)},registerFoldingRangeProvider(_,oe){return ut.registerFoldingRangeProvider(ze,bt(_),oe)},registerSelectionRangeProvider(_,oe){return ut.registerSelectionRangeProvider(ze,_,oe)},registerCallHierarchyProvider(_,oe){return ut.registerCallHierarchyProvider(ze,_,oe)},registerTypeHierarchyProvider(_,oe){return ut.registerTypeHierarchyProvider(ze,_,oe)},setLanguageConfiguration:(_,oe)=>ut.setLanguageConfiguration(ze,_,oe),getTokenInformationAtPosition(_,oe){return(0,Xe.$PG)(ze,"tokenInformation"),It.tokenAtPosition(_,oe)},registerInlayHintsProvider(_,oe){return ut.registerInlayHintsProvider(ze,_,oe)},createLanguageStatusItem(_,oe){return It.createLanguageStatusItem(ze,_,oe)},registerDocumentDropEditProvider(_,oe,Le){return ut.registerDocumentOnDropEditProvider(ze,_,oe,(0,Xe.$OG)(ze,"documentPaste")?Le:void 0)}},Ci={get activeTextEditor(){return it.getActiveTextEditor()},get visibleTextEditors(){return it.getVisibleTextEditors()},get activeTerminal(){return wt.activeTerminal},get terminals(){return wt.terminals},async showTextDocument(_,oe,Le){m.URI.isUri(_)&&_.scheme===A.Schemas.vscodeRemote&&!_.authority&&Ot.report("workspace.showTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority.");const st=await(m.URI.isUri(_)?Promise.resolve(Wi.openTextDocument(_)):Promise.resolve(_));return it.showTextDocument(st,oe,Le)},createTextEditorDecorationType(_){return it.createTextEditorDecorationType(ze,_)},onDidChangeActiveTextEditor(_,oe,Le){return nt(it.onDidChangeActiveTextEditor)(_,oe,Le)},onDidChangeVisibleTextEditors(_,oe,Le){return nt(it.onDidChangeVisibleTextEditors)(_,oe,Le)},onDidChangeTextEditorSelection(_,oe,Le){return nt(it.onDidChangeTextEditorSelection)(_,oe,Le)},onDidChangeTextEditorOptions(_,oe,Le){return nt(it.onDidChangeTextEditorOptions)(_,oe,Le)},onDidChangeTextEditorVisibleRanges(_,oe,Le){return nt(it.onDidChangeTextEditorVisibleRanges)(_,oe,Le)},onDidChangeTextEditorViewColumn(_,oe,Le){return nt(it.onDidChangeTextEditorViewColumn)(_,oe,Le)},onDidCloseTerminal(_,oe,Le){return nt(wt.onDidCloseTerminal)(_,oe,Le)},onDidOpenTerminal(_,oe,Le){return nt(wt.onDidOpenTerminal)(_,oe,Le)},onDidChangeActiveTerminal(_,oe,Le){return nt(wt.onDidChangeActiveTerminal)(_,oe,Le)},onDidChangeTerminalDimensions(_,oe,Le){return(0,Xe.$PG)(ze,"terminalDimensions"),nt(wt.onDidChangeTerminalDimensions)(_,oe,Le)},onDidChangeTerminalState(_,oe,Le){return nt(wt.onDidChangeTerminalState)(_,oe,Le)},onDidWriteTerminalData(_,oe,Le){return(0,Xe.$PG)(ze,"terminalDataWriteEvent"),nt(wt.onDidWriteTerminalData)(_,oe,Le)},onDidExecuteTerminalCommand(_,oe,Le){return(0,Xe.$PG)(ze,"terminalExecuteCommandEvent"),nt(wt.onDidExecuteTerminalCommand)(_,oe,Le)},onDidChangeTerminalShellIntegration(_,oe,Le){return(0,Xe.$PG)(ze,"terminalShellIntegration"),nt(Yt.onDidChangeTerminalShellIntegration)(_,oe,Le)},onDidStartTerminalShellExecution(_,oe,Le){return(0,Xe.$PG)(ze,"terminalShellIntegration"),nt(Yt.onDidStartTerminalShellExecution)(_,oe,Le)},onDidEndTerminalShellExecution(_,oe,Le){return(0,Xe.$PG)(ze,"terminalShellIntegration"),nt(Yt.onDidEndTerminalShellExecution)(_,oe,Le)},get state(){return Nt.getState()},onDidChangeWindowState(_,oe,Le){return nt(Nt.onDidChangeWindowState)(_,oe,Le)},showInformationMessage(_,...oe){return zi.showMessage(ze,$.default.Info,_,oe[0],oe.slice(1))},showWarningMessage(_,...oe){return zi.showMessage(ze,$.default.Warning,_,oe[0],oe.slice(1))},showErrorMessage(_,...oe){return zi.showMessage(ze,$.default.Error,_,oe[0],oe.slice(1))},showQuickPick(_,oe,Le){return vi.showQuickPick(ze,_,oe,Le)},showWorkspaceFolderPick(_){return vi.showWorkspaceFolderPick(_)},showInputBox(_,oe){return vi.showInput(_,oe)},showOpenDialog(_){return Ui.showOpenDialog(ze,_)},showSaveDialog(_){return Ui.showSaveDialog(_)},createStatusBarItem(_,oe,Le){let st,vt,Rt;return typeof _=="string"?(st=_,vt=oe,Rt=Le):(vt=_,Rt=oe),en.createStatusBarEntry(ze,st,vt,Rt)},setStatusBarMessage(_,oe){return en.setStatusBarMessage(_,oe)},withScmProgress(_){return Ot.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Di.withProgress(ze,{location:me.ProgressLocation.SourceControl},(oe,Le)=>_({report(st){}}))},withProgress(_,oe){return Di.withProgress(ze,_,oe)},createOutputChannel(_,oe){return Ei.createOutputChannel(_,oe,ze)},createWebviewPanel(_,oe,Le,st){return Oi.createWebviewPanel(ze,_,oe,Le,st)},createWebviewTextEditorInset(_,oe,Le,st){return(0,Xe.$PG)(ze,"editorInsets"),Wt.createWebviewEditorInset(_,oe,Le,st,ze)},createTerminal(_,oe,Le){return typeof _=="object"?"pty"in _?wt.createExtensionTerminal(_):wt.createTerminalFromOptions(_):wt.createTerminal(_,oe,Le)},registerTerminalLinkProvider(_){return wt.registerLinkProvider(_)},registerTerminalProfileProvider(_,oe){return wt.registerProfileProvider(ze,_,oe)},registerTerminalQuickFixProvider(_,oe){return(0,Xe.$PG)(ze,"terminalQuickFixProvider"),wt.registerTerminalQuickFixProvider(_,ze.identifier.value,oe)},registerTreeDataProvider(_,oe){return Dt.registerTreeDataProvider(_,oe,ze)},createTreeView(_,oe){return Dt.createTreeView(_,oe,ze)},registerWebviewPanelSerializer:(_,oe)=>Oi.registerWebviewPanelSerializer(ze,_,oe),registerCustomEditorProvider:(_,oe,Le={})=>Zi.registerCustomEditorProvider(ze,_,oe,Le),registerFileDecorationProvider(_){return Jt.registerFileDecorationProvider(_,ze)},registerUriHandler(_){return fi.registerUriHandler(ze,_)},createQuickPick(){return vi.createQuickPick(ze)},createInputBox(){return vi.createInputBox(ze)},get activeColorTheme(){return ki.activeColorTheme},onDidChangeActiveColorTheme(_,oe,Le){return nt(ki.onDidChangeActiveColorTheme)(_,oe,Le)},registerWebviewViewProvider(_,oe,Le){return Ni.registerWebviewViewProvider(ze,_,oe,Le?.webviewOptions)},get activeNotebookEditor(){return se.activeNotebookEditor},onDidChangeActiveNotebookEditor(_,oe,Le){return nt(se.onDidChangeActiveNotebookEditor)(_,oe,Le)},get visibleNotebookEditors(){return se.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return nt(se.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(_,oe,Le){return nt(Pe.onDidChangeNotebookEditorSelection)(_,oe,Le)},onDidChangeNotebookEditorVisibleRanges(_,oe,Le){return nt(Pe.onDidChangeNotebookEditorVisibleRanges)(_,oe,Le)},showNotebookDocument(_,oe){return se.showNotebookDocument(_,oe)},registerExternalUriOpener(_,oe,Le){return(0,Xe.$PG)(ze,"externalUriOpener"),Xi.registerExternalUriOpener(ze.identifier,_,oe,Le)},registerProfileContentHandler(_,oe){return(0,Xe.$PG)(ze,"profileContentHandlers"),Yi.registerProfileContentHandler(ze,_,oe)},registerQuickDiffProvider(_,oe,Le,st){return(0,Xe.$PG)(ze,"quickDiffProvider"),Mi.registerQuickDiffProvider(bt(_),oe,Le,st)},get tabGroups(){return Xt.tabGroups},registerShareProvider(_,oe){return(0,Xe.$PG)(ze,"shareProvider"),Ji.registerShareProvider(bt(_),oe)}},Wi={get rootPath(){return Ot.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(_){throw new O.$9("rootPath")},getWorkspaceFolder(_){return mt.getWorkspaceFolder(_)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(_){throw new O.$9("name")},get workspaceFile(){return mt.workspaceFile},set workspaceFile(_){throw new O.$9("workspaceFile")},updateWorkspaceFolders:(_,oe,...Le)=>mt.updateWorkspaceFolders(ze,_,oe||0,...Le),onDidChangeWorkspaceFolders:function(_,oe,Le){return nt(mt.onDidChangeWorkspace)(_,oe,Le)},asRelativePath:(_,oe)=>mt.getRelativePath(_,oe),findFiles:(_,oe,Le,st)=>mt.findFiles(_,oe,Le,ze.identifier,st),findFiles2:(_,oe,Le)=>((0,Xe.$PG)(ze,"findFiles2"),mt.findFiles2(_,oe,ze.identifier,Le)),findTextInFiles:(_,oe,Le,st)=>{(0,Xe.$PG)(ze,"findTextInFiles");let vt,Rt;return typeof oe=="object"?(vt=oe,Rt=Le):(vt={},Rt=oe,st=Le),mt.findTextInFiles(_,vt||{},Rt,ze.identifier,st)},save:_=>mt.save(_),saveAs:_=>mt.saveAs(_),saveAll:_=>mt.saveAll(_),applyEdit(_,oe){return Li.applyWorkspaceEdit(_,ze,oe)},createFileSystemWatcher:(_,oe,Le,st)=>{let vt;return typeof oe=="boolean"?vt={ignoreCreateEvents:!!oe,ignoreChangeEvents:!!Le,ignoreDeleteEvents:!!st,correlate:!1}:oe&&((0,Xe.$PG)(ze,"createFileSystemWatcher"),vt={...oe,correlate:!0}),hi.createFileSystemWatcher(mt,ze,_,vt)},get textDocuments(){return Ft.getAllDocumentData().map(_=>_.document)},set textDocuments(_){throw new O.$9("textDocuments")},openTextDocument(_){let oe;const Le=_;if(typeof _=="string")oe=Promise.resolve(m.URI.file(_));else if(m.URI.isUri(_))oe=Promise.resolve(_);else if(!Le||typeof Le=="object")oe=Ft.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return oe.then(st=>(st.scheme===A.Schemas.vscodeRemote&&!st.authority&&Ot.report("workspace.openTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority."),Ft.ensureDocumentData(st).then(vt=>vt.document)))},onDidOpenTextDocument:(_,oe,Le)=>nt(Ft.onDidAddDocument)(_,oe,Le),onDidCloseTextDocument:(_,oe,Le)=>nt(Ft.onDidRemoveDocument)(_,oe,Le),onDidChangeTextDocument:(_,oe,Le)=>nt(Ft.onDidChangeDocument)(_,oe,Le),onDidSaveTextDocument:(_,oe,Le)=>nt(Ft.onDidSaveDocument)(_,oe,Le),onWillSaveTextDocument:(_,oe,Le)=>nt(Fe.getOnWillSaveTextDocumentEvent(ze))(_,oe,Le),get notebookDocuments(){return se.notebookDocuments.map(_=>_.apiNotebook)},async openNotebookDocument(_,oe){let Le;if(m.URI.isUri(_))Le=_,await se.openNotebookDocument(_);else if(typeof _=="string")Le=m.URI.revive(await se.createNotebookDocument({viewType:_,content:oe}));else throw new Error("Invalid arguments");return se.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(_,oe,Le){return nt(J.onDidSaveNotebookDocument)(_,oe,Le)},onDidChangeNotebookDocument(_,oe,Le){return nt(J.onDidChangeNotebookDocument)(_,oe,Le)},onWillSaveNotebookDocument(_,oe,Le){return nt(Ge.getOnWillSaveNotebookDocumentEvent(ze))(_,oe,Le)},get onDidOpenNotebookDocument(){return nt(se.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return nt(se.onDidCloseNotebookDocument)},registerNotebookSerializer(_,oe,Le,st){return se.registerNotebookSerializer(ze,_,oe,Le,(0,Xe.$OG)(ze,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(_,oe,Le)=>nt(ji.onDidChangeConfiguration)(_,oe,Le),getConfiguration(_,oe){return oe=arguments.length===1?void 0:oe,ji.getConfiguration(_,oe,ze)},registerTextDocumentContentProvider(_,oe){return ye.registerTextDocumentContentProvider(_,oe)},registerTaskProvider:(_,oe)=>(Ot.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),ei.registerTaskProvider(ze,_,oe)),registerFileSystemProvider(_,oe,Le){return(0,N.$Rc)(Pi.registerFileSystemProvider(ze,_,oe,Le),Gt.addFileSystemProvider(_,oe,Le))},get fs(){return Gt.value},registerFileSearchProvider:(_,oe)=>((0,Xe.$PG)(ze,"fileSearchProvider"),ui.registerFileSearchProvider(_,oe)),registerTextSearchProvider:(_,oe)=>((0,Xe.$PG)(ze,"textSearchProvider"),ui.registerTextSearchProvider(_,oe)),registerAITextSearchProvider:(_,oe)=>((0,Xe.$PG)(ze,"aiTextSearchProvider"),(0,Xe.$PG)(ze,"textSearchProvider"),ui.registerAITextSearchProvider(_,oe)),registerRemoteAuthorityResolver:(_,oe)=>((0,Xe.$PG)(ze,"resolvers"),Tt.registerRemoteAuthorityResolver(_,oe)),registerResourceLabelFormatter:_=>((0,Xe.$PG)(ze,"resolvers"),Ai.$registerResourceLabelFormatter(_)),getRemoteExecServer:_=>((0,Xe.$PG)(ze,"resolvers"),Tt.getRemoteExecServer(_)),onDidCreateFiles:(_,oe,Le)=>nt(hi.onDidCreateFile)(_,oe,Le),onDidDeleteFiles:(_,oe,Le)=>nt(hi.onDidDeleteFile)(_,oe,Le),onDidRenameFiles:(_,oe,Le)=>nt(hi.onDidRenameFile)(_,oe,Le),onWillCreateFiles:(_,oe,Le)=>nt(hi.getOnWillCreateFileEvent(ze))(_,oe,Le),onWillDeleteFiles:(_,oe,Le)=>nt(hi.getOnWillDeleteFileEvent(ze))(_,oe,Le),onWillRenameFiles:(_,oe,Le)=>nt(hi.getOnWillRenameFileEvent(ze))(_,oe,Le),openTunnel:_=>((0,Xe.$PG)(ze,"tunnels"),At.openTunnel(ze,_).then(oe=>{if(!oe)throw new Error("cannot open tunnel");return oe})),get tunnels(){return(0,Xe.$PG)(ze,"tunnels"),At.getTunnels()},onDidChangeTunnels:(_,oe,Le)=>((0,Xe.$PG)(ze,"tunnels"),nt(At.onDidChangeTunnels)(_,oe,Le)),registerPortAttributesProvider:(_,oe)=>((0,Xe.$PG)(ze,"portsAttributes"),At.registerPortsAttributesProvider(_,oe)),registerTunnelProvider:(_,oe)=>((0,Xe.$PG)(ze,"tunnelFactory"),At.registerTunnelProvider(_,oe)),registerTimelineProvider:(_,oe)=>((0,Xe.$PG)(ze,"timeline"),Qi.registerTimelineProvider(_,oe,ze.identifier,yt.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:_=>((0,Xe.$PG)(ze,"workspaceTrust"),mt.requestWorkspaceTrust(_)),onDidGrantWorkspaceTrust:(_,oe,Le)=>nt(mt.onDidGrantWorkspaceTrust)(_,oe,Le),registerEditSessionIdentityProvider:(_,oe)=>((0,Xe.$PG)(ze,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(_,oe)),onWillCreateEditSessionIdentity:(_,oe,Le)=>((0,Xe.$PG)(ze,"editSessionIdentityProvider"),nt(mt.getOnWillCreateEditSessionIdentityEvent(ze))(_,oe,Le)),registerCanonicalUriProvider:(_,oe)=>((0,Xe.$PG)(ze,"canonicalUriProvider"),mt.registerCanonicalUriProvider(_,oe)),getCanonicalUri:(_,oe,Le)=>((0,Xe.$PG)(ze,"canonicalUriProvider"),mt.provideCanonicalUri(_,oe,Le))},tn={get inputBox(){return Ot.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),Ki.getLastInputBox(ze)},createSourceControl(_,oe,Le){return Ki.createSourceControl(ze,_,oe,Le)}},nn={createCommentController(_,oe){return Ri.createCommentController(ze,_,oe)}},rn={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},get activeStackItem(){if((0,Xe.$OG)(ze,"debugFocus"))return Et.activeStackItem},registerDebugVisualizationProvider(_,oe){return(0,Xe.$PG)(ze,"debugVisualization"),Et.registerDebugVisualizationProvider(ze,_,oe)},registerDebugVisualizationTreeProvider(_,oe){return(0,Xe.$PG)(ze,"debugVisualization"),Et.registerDebugVisualizationTree(ze,_,oe)},onDidStartDebugSession(_,oe,Le){return nt(Et.onDidStartDebugSession)(_,oe,Le)},onDidTerminateDebugSession(_,oe,Le){return nt(Et.onDidTerminateDebugSession)(_,oe,Le)},onDidChangeActiveDebugSession(_,oe,Le){return nt(Et.onDidChangeActiveDebugSession)(_,oe,Le)},onDidReceiveDebugSessionCustomEvent(_,oe,Le){return nt(Et.onDidReceiveDebugSessionCustomEvent)(_,oe,Le)},onDidChangeBreakpoints(_,oe,Le){return nt(Et.onDidChangeBreakpoints)(_,oe,Le)},onDidChangeActiveStackItem(_,oe,Le){return(0,Xe.$PG)(ze,"debugFocus"),nt(Et.onDidChangeActiveStackItem)(_,oe,Le)},registerDebugConfigurationProvider(_,oe,Le){return Et.registerDebugConfigurationProvider(_,oe,Le||kt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(_,oe){return Et.registerDebugAdapterDescriptorFactory(ze,_,oe)},registerDebugAdapterTrackerFactory(_,oe){return Et.registerDebugAdapterTrackerFactory(_,oe)},startDebugging(_,oe,Le){return!Le||typeof Le=="object"&&"configuration"in Le?Et.startDebugging(_,oe,{parentSession:Le}):Et.startDebugging(_,oe,Le||{})},stopDebugging(_){return Et.stopDebugging(_)},addBreakpoints(_){return Et.addBreakpoints(_)},removeBreakpoints(_){return Et.removeBreakpoints(_)},asDebugSourceUri(_,oe){return Et.asDebugSourceUri(_,oe)}},gn={registerTaskProvider:(_,oe)=>ei.registerTaskProvider(ze,_,oe),fetchTasks:_=>ei.fetchTasks(_),executeTask:_=>ei.executeTask(ze,_),get taskExecutions(){return ei.taskExecutions},onDidStartTask:(_,oe,Le)=>nt(ei.onDidStartTask)(_,oe,Le),onDidEndTask:(_,oe,Le)=>nt(ei.onDidEndTask)(_,oe,Le),onDidStartTaskProcess:(_,oe,Le)=>nt(ei.onDidStartTaskProcess)(_,oe,Le),onDidEndTaskProcess:(_,oe,Le)=>nt(ei.onDidEndTaskProcess)(_,oe,Le)},sn={createNotebookController(_,oe,Le,st,vt){return Ve.createNotebookController(ze,_,oe,Le,st,(0,Xe.$OG)(ze,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(_,oe)=>se.registerNotebookCellStatusBarItemProvider(ze,_,oe),createRendererMessaging(_){return Qe.createRendererMessaging(ze,_)},createNotebookControllerDetectionTask(_){return(0,Xe.$PG)(ze,"notebookKernelSource"),Ve.createNotebookControllerDetectionTask(ze,_)},registerKernelSourceActionProvider(_,oe){return(0,Xe.$PG)(ze,"notebookKernelSource"),Ve.registerKernelSourceActionProvider(ze,_,oe)},onDidChangeNotebookCellExecutionState(_,oe,Le){return(0,Xe.$PG)(ze,"notebookCellExecutionState"),nt(Ve.onDidChangeNotebookCellExecutionState)(_,oe,Le)}},on={t(..._){if(typeof _[0]=="string"){const oe=_.shift(),Le=!_||typeof _[0]!="object"?_:_[0];return li.getMessage(ze.identifier.value,{message:oe,args:Le})}return li.getMessage(ze.identifier.value,_[0])},get bundle(){return li.getBundle(ze.identifier.value)},get uri(){return li.getBundleUri(ze.identifier.value)}},mn={_version:1,transferActiveChat(_){return(0,Xe.$PG)(ze,"interactive"),Ii.transferActiveChat(_)}},$n={getRelatedInformation(_,oe){return(0,Xe.$PG)(ze,"aiRelatedInformation"),Ti.getRelatedInformation(ze,_,oe)},registerRelatedInformationProvider(_,oe){return(0,Xe.$PG)(ze,"aiRelatedInformation"),Ti.registerRelatedInformationProvider(ze,_,oe)},registerEmbeddingVectorProvider(_,oe){return(0,Xe.$PG)(ze,"aiRelatedInformation"),_i.registerEmbeddingVectorProvider(ze,_,oe)}},an={registerChatResponseProvider(_,oe,Le){return(0,Xe.$PG)(ze,"chatProvider"),Mt.registerLanguageModel(ze,_,oe,Le)},registerChatVariableResolver(_,oe,Le){return(0,Xe.$PG)(ze,"chatVariableResolver"),xi.registerVariableResolver(ze,_,oe,Le)},registerMappedEditsProvider(_,oe){return(0,Xe.$PG)(ze,"mappedEditsProvider"),ut.registerMappedEditsProvider(ze,_,oe)},createChatParticipant(_,oe){return(0,Xe.$PG)(ze,"chatParticipant"),Ii.createChatAgent(ze,_,oe)},createDynamicChatParticipant(_,oe,Le,st,vt){return(0,Xe.$PG)(ze,"chatParticipantAdditions"),Ii.createDynamicChatAgent(ze,_,oe,Le,st,vt)}},qi={get languageModels(){return(0,Xe.$PG)(ze,"languageModels"),Mt.getLanguageModelIds()},onDidChangeLanguageModels:(_,oe,Le)=>((0,Xe.$PG)(ze,"languageModels"),Mt.onDidChangeProviders(_,oe,Le)),sendChatRequest(_,oe,Le,st){return(0,Xe.$PG)(ze,"languageModels"),Mt.sendChatRequest(ze,_,oe,Le,st)},computeTokenLength(_,oe,Le){return(0,Xe.$PG)(ze,"languageModels"),Le??=P.CancellationToken.None,Mt.computeTokenLength(_,oe,Le)},getLanguageModelInformation(_){return(0,Xe.$PG)(ze,"languageModels"),Mt.getLanguageModelInfo(_)}},cn={registerSpeechProvider(_,oe){return(0,Xe.$PG)(ze,"speech"),ln.registerProvider(ze.identifier,_,oe)}};return{version:pt.version,ai:$n,authentication:dn,commands:Bi,comments:nn,chat:an,debug:rn,env:Vi,extensions:fn,interactive:mn,l10n:on,languages:si,lm:qi,notebooks:sn,scm:tn,speech:cn,tasks:gn,tests:gi,window:Ci,workspace:Wi,Breakpoint:me.$gN,TerminalOutputAnchor:me.TerminalOutputAnchor,ChatResultFeedbackKind:me.ChatResultFeedbackKind,ChatVariableLevel:me.ChatVariableLevel,ChatCompletionItem:me.$bO,CallHierarchyIncomingCall:me.$EM,CallHierarchyItem:me.$DM,CallHierarchyOutgoingCall:me.$FM,CancellationError:O.$5,CancellationTokenSource:P.$oe,CandidatePortSource:i.CandidatePortSource,CodeAction:me.$AM,CodeActionKind:me.$BM,CodeActionTriggerKind:me.CodeActionTriggerKind,CodeLens:me.$GM,Color:me.$TM,ColorInformation:me.$UM,ColorPresentation:me.$VM,ColorThemeKind:me.ColorThemeKind,CommentMode:me.CommentMode,CommentState:me.CommentState,CommentThreadCollapsibleState:me.CommentThreadCollapsibleState,CommentThreadState:me.CommentThreadState,CommentThreadApplicability:me.CommentThreadApplicability,CompletionItem:me.$NM,CompletionItemKind:me.CompletionItemKind,CompletionItemTag:me.CompletionItemTag,CompletionList:me.$OM,CompletionTriggerKind:me.CompletionTriggerKind,ConfigurationTarget:me.ConfigurationTarget,CustomExecution:me.$4M,DebugAdapterExecutable:me.$kN,DebugAdapterInlineImplementation:me.$nN,DebugAdapterNamedPipeServer:me.$mN,DebugAdapterServer:me.$lN,DebugConfigurationProviderTriggerKind:kt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:me.DebugConsoleMode,DebugVisualization:me.$DN,DecorationRangeBehavior:me.DecorationRangeBehavior,Diagnostic:me.$tM,DiagnosticRelatedInformation:me.$sM,DiagnosticSeverity:me.DiagnosticSeverity,DiagnosticTag:me.DiagnosticTag,Disposable:me.$fM,DocumentHighlight:me.$wM,DocumentHighlightKind:me.DocumentHighlightKind,MultiDocumentHighlight:me.$xM,DocumentLink:me.$SM,DocumentSymbol:me.$zM,EndOfLine:me.EndOfLine,EnvironmentVariableMutatorType:me.EnvironmentVariableMutatorType,EvaluatableExpression:me.$qN,InlineValueText:me.$rN,InlineValueVariableLookup:me.$sN,InlineValueEvaluatableExpression:me.$tN,InlineCompletionTriggerKind:me.InlineCompletionTriggerKind,EventEmitter:M.$de,ExtensionKind:me.ExtensionKind,ExtensionMode:me.ExtensionMode,ExternalUriOpenerPriority:me.ExternalUriOpenerPriority,FileChangeType:me.FileChangeType,FileDecoration:me.$FN,FileDecoration2:me.$FN,FileSystemError:me.$wN,FileType:g.FileType,FilePermission:g.FilePermission,FoldingRange:me.$xN,FoldingRangeKind:me.FoldingRangeKind,FunctionBreakpoint:me.$iN,InlineCompletionItem:me.$PM,InlineCompletionList:me.$QM,Hover:me.$uM,VerboseHover:me.$vM,HoverVerbosityAction:me.HoverVerbosityAction,IndentAction:S.IndentAction,Location:me.$rM,MarkdownString:me.$HM,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:me.$IM,PortAutoForwardAction:me.PortAutoForwardAction,Position:me.$gM,ProcessExecution:me.$2M,ProgressLocation:me.ProgressLocation,QuickInputButtons:me.$EN,Range:me.$hM,RelativePattern:me.$eN,Selection:me.$iM,SelectionRange:me.$CM,SemanticTokens:me.$AN,SemanticTokensBuilder:me.$zN,SemanticTokensEdit:me.$BN,SemanticTokensEdits:me.$CN,SemanticTokensLegend:me.$yN,ShellExecution:me.$3M,ShellQuoting:me.ShellQuoting,SignatureHelp:me.$KM,SignatureHelpTriggerKind:me.SignatureHelpTriggerKind,SignatureInformation:me.$JM,SnippetString:me.$qM,SourceBreakpoint:me.$hN,StandardTokenType:me.StandardTokenType,StatusBarAlignment:me.StatusBarAlignment,SymbolInformation:me.$yM,SymbolKind:me.SymbolKind,SymbolTag:me.SymbolTag,Task:me.$5M,TaskGroup:me.$1M,TaskPanelKind:me.TaskPanelKind,TaskRevealKind:me.TaskRevealKind,TaskScope:me.TaskScope,TerminalLink:me.$WM,TerminalQuickFixTerminalCommand:me.$YM,TerminalQuickFixOpener:me.$XM,TerminalLocation:me.TerminalLocation,TerminalProfile:me.$ZM,TerminalExitReason:me.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:me.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:me.TextDocumentSaveReason,TextEdit:me.$mM,SnippetTextEdit:me.$oM,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:me.TextEditorLineNumbersStyle,TextEditorRevealType:me.TextEditorRevealType,TextEditorSelectionChangeKind:me.TextEditorSelectionChangeKind,SyntaxTokenType:me.SyntaxTokenType,TextDocumentChangeReason:me.TextDocumentChangeReason,ThemeColor:me.$dN,ThemeIcon:me.$cN,TreeItem:me.$6M,TreeItemCheckboxState:me.TreeItemCheckboxState,TreeItemCollapsibleState:me.TreeItemCollapsibleState,TypeHierarchyItem:me.$2N,UIKind:_t.UIKind,Uri:m.URI,ViewColumn:me.ViewColumn,WorkspaceEdit:me.$pM,DocumentPasteTriggerKind:me.DocumentPasteTriggerKind,DocumentDropEdit:me.$_M,DocumentDropOrPasteEditKind:me.$aN,DocumentPasteEdit:me.$bN,InlayHint:me.$MM,InlayHintLabelPart:me.$LM,InlayHintKind:me.InlayHintKind,RemoteAuthorityResolverError:me.$lM,ResolvedAuthority:me.$jM,ManagedResolvedAuthority:me.$kM,SourceControlInputBoxValidationType:me.SourceControlInputBoxValidationType,ExtensionRuntime:me.ExtensionRuntime,TimelineItem:me.$PN,NotebookRange:me.$HN,NotebookCellKind:me.NotebookCellKind,NotebookCellExecutionState:me.NotebookCellExecutionState,NotebookCellData:me.$IN,NotebookData:me.$JN,NotebookRendererScript:me.$NN,NotebookCellStatusBarAlignment:me.NotebookCellStatusBarAlignment,NotebookEditorRevealType:me.NotebookEditorRevealType,NotebookCellOutput:me.$LN,NotebookCellOutputItem:me.$KN,NotebookCellStatusBarItem:me.$MN,NotebookControllerAffinity:me.NotebookControllerAffinity,NotebookControllerAffinity2:me.NotebookControllerAffinity2,NotebookEdit:me.$nM,NotebookKernelSourceAction:me.$ON,NotebookVariablesRequestKind:me.NotebookVariablesRequestKind,PortAttributes:me.$RN,LinkedEditingRanges:me.$QN,TestResultState:me.TestResultState,TestRunRequest:me.$SN,TestRunRequest2:me.$SN,TestMessage:me.$TN,TestTag:me.$UN,TestRunProfileKind:me.TestRunProfileKind,TextSearchCompleteMessageType:ti.TextSearchCompleteMessageType,DataTransfer:me.$$M,DataTransferItem:me.$7M,TestCoverageCount:me.$VN,FileCoverage:me.$XN,StatementCoverage:me.$YN,BranchCoverage:me.$ZN,DeclarationCoverage:me.$1N,WorkspaceTrustState:me.WorkspaceTrustState,LanguageStatusSeverity:me.LanguageStatusSeverity,QuickPickItemKind:me.QuickPickItemKind,InputBoxValidationSeverity:me.InputBoxValidationSeverity,TabInputText:me.$3N,TabInputTextDiff:me.$4N,TabInputTextMerge:me.$5N,TabInputCustom:me.$6N,TabInputNotebook:me.$8N,TabInputNotebookDiff:me.$9N,TabInputWebview:me.$7N,TabInputTerminal:me.$0N,TabInputInteractiveWindow:me.$$N,TabInputChat:me.$_N,TabInputTextMultiDiff:me.$aO,TelemetryTrustedValue:o.$fp,LogLevel:r.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:me.InteractiveSessionVoteDirection,ChatCopyKind:me.ChatCopyKind,InteractiveEditorResponseFeedbackKind:me.InteractiveEditorResponseFeedbackKind,DebugStackFrame:me.$oN,DebugThread:me.$pN,RelatedInformationType:me.RelatedInformationType,SpeechToTextStatus:me.SpeechToTextStatus,TextToSpeechStatus:me.TextToSpeechStatus,PartialAcceptTriggerKind:me.PartialAcceptTriggerKind,KeywordRecognitionStatus:me.KeywordRecognitionStatus,ChatResponseMarkdownPart:me.$cO,ChatResponseFileTreePart:me.$fO,ChatResponseAnchorPart:me.$gO,ChatResponseProgressPart:me.$hO,ChatResponseReferencePart:me.$kO,ChatResponseWarningPart:me.$iO,ChatResponseTextEditPart:me.$lO,ChatResponseMarkdownWithVulnerabilitiesPart:me.$dO,ChatResponseCommandButtonPart:me.$jO,ChatResponseDetectedParticipantPart:me.$eO,ChatRequestTurn:me.$mO,ChatResponseTurn:me.$nO,ChatLocation:me.ChatLocation,LanguageModelChatSystemMessage:me.$oO,LanguageModelChatUserMessage:me.$pO,LanguageModelChatAssistantMessage:me.$qO,LanguageModelSystemMessage:me.$oO,LanguageModelUserMessage:me.$pO,LanguageModelAssistantMessage:me.$qO,LanguageModelError:me.$rO,NewSymbolName:me.$vN,NewSymbolNameTag:me.NewSymbolNameTag,NewSymbolNameTriggerKind:me.NewSymbolNameTriggerKind,InlineEdit:me.$sO,InlineEditTriggerKind:me.InlineEditTriggerKind}}}}),define(Se[307],Ie([1,0,56,118,39,112,40,35,68,53,121,123,124,84,88,80,111,65,46,83,63,67,247,12,122,81,82,86,90,116]),function(he,e,P,O,M,N,A,$,m,E,T,S,l,b,g,r,s,o,n,i,c,u,t,d,a,f,w,p,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,P.$xs)(f.$qmc,f.$pmc,1),(0,P.$xs)(d.$4j,t.$Cnc,1),(0,P.$xs)(r.$vlc,r.$wlc,1),(0,P.$xs)($.$1O,$.$ZO,0),(0,P.$xs)(p.$Flc,p.$Glc,0),(0,P.$xs)(v.$kmc,v.$lmc,0),(0,P.$xs)(A.$Ulc,A.$Slc,0),(0,P.$xs)(o.$Wlc,o.$Vlc,0),(0,P.$xs)(S.$Amc,S.$Emc,0),(0,P.$xs)(N.$Gmc,N.$Fmc,0),(0,P.$xs)(m.$PO,m.$OO,0),(0,P.$xs)(w.$rmc,w.$smc,0),(0,P.$xs)(n.$zlc,n.$ylc,0),(0,P.$xs)(O.$$mc,O.$0mc,1),(0,P.$xs)(l.$Vmc,l.$Wmc,0),(0,P.$xs)(b.$dmc,b.$cmc,0),(0,P.$xs)(T.$lnc,T.$knc,0),(0,P.$xs)(E.$gmc,E.$jmc,0),(0,P.$xs)(y.$mnc,y.$nnc,0),(0,P.$xs)(g.$CDb,g.$DDb,0),(0,P.$xs)(s.$Anc,s.$znc,0),(0,P.$xs)(M.$Rlc,M.$Qlc,0),(0,P.$xs)(i.$nmc,i.$mmc,0),(0,P.$xs)(c.$YO,c.$VO,0),(0,P.$xs)(u.$7lc,u.$8lc,0),(0,P.$xs)(a.$ymc,a.$zmc,0)}),define(Se[308],Ie([1,0,306,41,2,303,7,11,253]),function(he,e,P,O,M,N,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mpc=void 0;class E extends N.$Fnc{j(){}getModule(b,g){for(const r of this.b){const s=r(b);if(s){b=s;break}}if(this.a.has(b))return this.a.get(b).load(b,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class T extends O.$umc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(m.$Lpc);const b=this.h.invokeFunction(P.$Bnc);this.r=this.h.createInstance(E,b,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(b){return b.browser}async xb(b,g,r){g=g.with({path:S(g.path,".js")});const s=b?.identifier.value;s&&performance.mark(`code/extHost/willFetchExtensionCode/${s}`);const o=M.URI.revive(await this.C.$asBrowserUri(g)),n=await fetch(o.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s}`),n.status!==200)throw new Error(n.statusText);const i=await n.text(),c=`${g.toString(!0)}#vscode-extension`,u=`${i}
//# sourceURL=${c}`;let t;try{t=new Function("module","exports","require",u)}catch(w){throw console.error(s?`Loading code for extension ${s} failed: ${w.message}`:`Loading code failed: ${w.message}`),console.error(`${g.toString(!0)}${typeof w.line=="number"?` line ${w.line}`:""}${typeof w.column=="number"?` column ${w.column}`:""}`),console.error(w),w}b&&await this.w.initializeLocalizedMessages(b);const d={},a={exports:d},f=w=>{const p=this.r.getModule(w,g);if(p===void 0)throw new Error(`Cannot load module '${w}'`);return p};try{return r.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s}`),t(a,d,f),a.exports!==d?a.exports:d}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s}`),r.codeLoadingStop()}}async $setRemoteEnvironment(b){}async Bb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+b;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,$.$xh)(10)}}e.$Mpc=T;function S(l,b){return l.endsWith(b)?l:l+b}}),define(Se[309],Ie([1,0,71,56,12,41,217,87,308]),function(he,e,P,O,M,N,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,O.$xs)(M.$3j,new P.$ti(A.$Enc,[!0],!0)),(0,O.$xs)(N.$vmc,m.$Mpc,0),(0,O.$xs)($.$Xlc,$.$Ylc,0)}),define(Se[315],Ie([1,0,21,5,79,304,255,19,60,16,2,307,309]),function(he,e,P,O,M,N,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=u;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(t){return/^(file|vscode-remote):/i.test(t)}const g=fetch.bind(self);function r(t){self.fetch=async function(d,a){return d instanceof Request||b(String(d))&&(d=(await t(T.URI.parse(String(d)))).toString(!0)),g(d,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(d,a,f,w,p){(async()=>(b(a.toString())&&(a=(await t(T.URI.parse(a.toString()))).toString(!0)),super.open(d,a,f??!0,w,p)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(d,a){if(/^file:/i.test(d.toString()))d=E.$Qg.uriToBrowserUri(T.URI.parse(d.toString())).toString(!0);else if(/^vscode-remote:/i.test(d.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const w=`(${function(h){function D(I){return typeof I=="string"||I instanceof URL?String(I).replace(/^file:\/\//i,"vscode-file://vscode-app"):I}const k=fetch.bind(self);self.fetch=function(I,W){return I instanceof Request?k(I,W):k(D(I),W)},self.XMLHttpRequest=class extends XMLHttpRequest{open(I,W,V,q,R){return super.open(I,D(W),V??!0,q,R)}};const C=importScripts.bind(self);self.importScripts=(...I)=>{C(...I.map(D))},C(h)}.toString()}('${d}'))`;a=a||{},a.name=`${name} -> ${a.name||$.$nc(d.toString())}`;const p=new Blob([w],{type:"application/javascript"}),v=URL.createObjectURL(p);return new t(v,a)}}else self.Worker=class extends A.$Npc{constructor(t,d){super(l,t,{name:$.$nc(t.toString()),...d})}};const s=new class{constructor(){this.pid=void 0}exit(t){S()}};class o{constructor(){const d=new MessageChannel,a=new O.$de;let f=!1;l(d.port2,[d.port2]),d.port1.onmessage=w=>{const{data:p}=w;if(!(p instanceof ArrayBuffer)){console.warn("UNKNOWN data received",p);return}const v=P.$Fe.wrap(new Uint8Array(p,0,p.byteLength));if((0,M.$1m)(v,2)){f=!0,i("received terminate message from renderer");return}a.fire(v)},this.protocol={onMessage:a.event,send:w=>{if(!f){const p=w.buffer.buffer.slice(w.buffer.byteOffset,w.buffer.byteOffset+w.buffer.byteLength);d.port1.postMessage(p,[p])}}}}}function n(t){return new Promise(d=>{const a=t.onMessage(f=>{a.dispose();const w=JSON.parse(f.toString());t.send((0,M.$Zm)(0)),d({protocol:t,initData:w})});t.send((0,M.$Zm)(1))})}let i=t=>S();function c(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function u(){m.mark("code/extHost/willConnectToRenderer");const t=new o;return{onmessage(d){c(d)&&n(t.protocol).then(a=>{m.mark("code/extHost/didWaitForInitData");const f=new N.$Hnc(a.protocol,a.initData,s,null,d.data);r(w=>f.asBrowserUri(w)),i=w=>f.terminate(w)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ccba2fc85c14bedeef5a72b7ebc0bde9b0e91948/core/vs/workbench/api/worker/extensionHostWorker.js.map
